unit AmCharts;

interface

//AmCharts

type
  JAmPieChart = class external 'AmPieChart'
    alphaField: String;
    angle: Float;
    balloonText: String;
    chartData: array of Variant;
    colorField: String;
    colors: array of Variant;
    depth3D: Float;
    descriptionField: String;
    gradientRatio: array of Float;
    groupedAlpha: Float;
    groupedColor: String;
    groupedDescription: String;
    groupedPulled: Boolean;
    groupedTitle: String;
    groupPercent: Float;
    hideLabelsPercent: Float;
    hoverAlpha: Float;
    innerRadius: Variant;
    labelRadius: Float;
    labelRadiusField: String;
    labelsEnabled: Boolean;
    labelText: String;
    labelTickAlpha: Float;
    labelTickColor: String;
    marginBottom: Float;
    marginLeft: Float;
    marginRight: Float;
    marginTop: Float;
    minRadius: Float;
    outlineAlpha: Float;
    outlineColor: String;
    outlineThickness: Float;
    pieAlpha: Float;
    pieBaseColor: String;
    pieBrightnessStep: Float;
    pieX: Variant;
    pieY: Variant;
    pulledField: String;
    pullOutDuration: Float;
    pullOutEffect: String;
    pullOutOnlyOne: Boolean;
    pullOutRadius: Variant;
    radius: Variant;
    sequencedAnimation: Boolean;
    startAlpha: Float;
    startAngle: Float;
    startDuration: Float;
    startEffect: String;
    startRadius: Variant;
    titleField: String;
    urlField: String;
    urlTarget: String;
    valueField: String;
    visibleInLegendField: String;
    procedure animateAgain;
    procedure clickSlice(index: Float);
    procedure hideSlice(index: Float);
    procedure rollOutSlice(index: Float);
    procedure rollOverSlice(index: Float);
    procedure showSlice(index: Float);
    procedure addListener(&type: String; handler: (e:       &type: String;
      dataItem: JSlice;
    end;));
  end;

  JAmRadarChart = class external 'AmRadarChart'(JAmCoordinateChart)
    marginBottom: Float;
    marginLeft: Float;
    marginRight: Float;
    marginTop: Float;
    radius: Variant;
  end;

  JAmXYChart = class external 'AmXYChart'(JAmRectangularChart)
    hideXScrollbar: Boolean;
    hideYScrollbar: Boolean;
    maxZoomFactor: Float;
    procedure zoomOut;
  end;

  JGuide = class external 'Guide'
    above: Boolean;
    angle: Float;
    balloonColor: String;
    balloonText: String;
    boldLabel: Boolean;
    category: String;
    dashLength: Float;
    date: JDate;
    expand: Boolean;
    fillAlpha: Float;
    fillColor: String;
    fontSize: String;
    id: String;
    inside: Boolean;
    &label: String;
    labelRotation: Float;
    lineAlpha: Float;
    lineColor: String;
    lineThickness: Float;
    position: String;
    tickLength: Float;
    toAngle: Float;
    toCategory: String;
    toDate: JDate;
    toValue: Float;
    value: Float;
    valueAxis: JValueAxis;
  end;

  JImagesSettings = class external 'ImagesSettings'
    alpha: Float;
    balloonText: String;
    centered: Boolean;
    color: String;
    descriptionWindowHeight: Float;
    descriptionWindowWidth: Float;
    descriptionWindowX: Float;
    descriptionWindowY: Float;
    labelColor: String;
    labelfontSize: String;
    labelPosition: String;
    labelRollOverColor: String;
    outlineAlpha: Float;
    outlineColor: String;
    outlineThickness: Float;
    rollOverColor: String;
    rollOverScale: Float;
    selectedScale: Float;
  end;

  JAreasSettings = class external 'AreasSettings'
    alpha: Float;
    autoZoom: Boolean;
    balloonText: String;
    color: String;
    colorSolid: String;
    descriptionWindowHeight: Float;
    descriptionWindowWidth: Float;
    descriptionWindowX: Float;
    descriptionWindowY: Float;
    outlineAlpha: Float;
    outlineColor: String;
    outlineThickness: Float;
    rollOverColor: String;
    rollOverOutlineColor: String;
    selectedColor: String;
    unlistedAreasAlpha: Float;
    unlistedAreasColor: String;
    unlistedAreasOutlineAlpha: Float;
    unlistedAreasOutlineColor: String;
  end;

  JSlice = class external 'Slice'
    alpha: Float;
    color: String;
    dataContext: JObject;
    description: String;
    hidden: Boolean;
    percents: Float;
    pulled: Boolean;
    title: String;
    url: String;
    value: Float;
    visibleInLegend: Boolean;
  end;

  JAmStockChart = class external 'AmStockChart'
    animationPlayed: Boolean;
    balloon: JAmBalloon;
    categoryAxesSettings: JCategoryAxesSettings;
    chartCreated: Boolean;
    chartCursorSettings: JChartCursorSettings;
    chartScrollbarSettings: JChartScrollbarSettings;
    colors: array of Variant;
    comparedDataSets: array of Variant;
    dataSets: array of Variant;
    dataSetSelector: JDataSetSelector;
    endDate: JDate;
    firstDayOfWeek: Float;
    glueToTheEnd: Boolean;
    legendSettings: JLegendSettings;
    mainDataSet: JDataSet;
    panels: array of Variant;
    panelsSettings: JPanelsSettings;
    periodSelector: JPeriodSelector;
    scrollbarChart: JAmSerialChart;
    startDate: JDate;
    stockEventsSettings: Variant;
    valueAxesSettings: JValueAxesSettings;
    version: String;
    zoomOutOnDataSetChange: Boolean;
    procedure addPanel(panel: JStockPanel);
    procedure addPanelAt(panel: JStockPanel; index: Float);
    procedure clear;
    procedure hideStockEvents;
    procedure removeListener(obj: Variant; &type: String; handler: Variant);
    procedure removePanel(panel: JStockPanel);
    procedure showStockEvents;
    procedure validateData;
    procedure validateNow;
    procedure zoom(startDate: JDate; endDate: JDate);
    procedure zoomOut;
    procedure addListener(&type: String; handler: (e:       &type: String;
      chart: JAmStockChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      eventObject: Variant;
      graph: JAmGraph;
      date: JDate;
      chart: JAmStockChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      startDate: JDate;
      endDate: JDate;
      period: String;
      chart: JAmStockChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      panel: JStockPanel;
      chart: JAmStockChart;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JValueAxesSettings = class external 'ValueAxesSettings'
    autoGridCount: Boolean;
    axisAlpha: Float;
    axisColor: String;
    axisThickness: Float;
    color: String;
    dashLength: Float;
    fillAlpha: Float;
    fillColor: String;
    gridAlpha: Float;
    gridColor: String;
    gridCount: Float;
    gridThickness: Float;
    includeGuidesInMinMax: Boolean;
    includeHidden: Boolean;
    inside: Boolean;
    integersOnly: Boolean;
    labelFrequency: Float;
    labelsEnabled: Boolean;
    logarithmic: Boolean;
    offset: Float;
    position: String;
    reversed: Boolean;
    showFirstLabel: Boolean;
    showLastLabel: Boolean;
    stackType: String;
    tickLength: Float;
    unit: String;
    unitPosition: String;
  end;

  JAmLegend = class external 'AmLegend'
    align: String;
    autoMargins: Boolean;
    backgroundAlpha: Float;
    backgroundColor: String;
    borderAlpha: Float;
    borderColor: String;
    bottom: Float;
    color: String;
    data: array of Variant;
    equalWidths: Boolean;
    fontSize: String;
    horizontalGap: Float;
    labelText: String;
    left: Float;
    marginBottom: Float;
    marginLeft: Float;
    marginRight: Float;
    marginTop: Float;
    markerBorderAlpha: Float;
    markerBorderColor: String;
    markerBorderThickness: Float;
    markerDisabledColor: String;
    markerLabelGap: Float;
    markerSize: Float;
    markerType: String;
    maxColumns: Float;
    position: String;
    reversedOrder: Boolean;
    right: Float;
    rollOverColor: String;
    rollOverGraphAlpha: Float;
    showEntries: Boolean;
    spacing: Float;
    switchable: Boolean;
    switchColor: String;
    switchType: String;
    textClickEnabled: Boolean;
    top: Float;
    useMarkerColorForLabels: Boolean;
    valueAlign: String;
    valueText: String;
    valueWidth: Float;
    verticalGap: Float;
    procedure addListener(&type: String; handler: (e:       &type: String;
      dataItem: JObject;
      chart: JAmChart;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JStockLegend = class external 'StockLegend'(JAmLegend)
    valueTextComparing: String;
    valueTextRegular: String;
  end;

  JStockPanel = class external 'StockPanel'(JAmSerialChart)
    allowTurningOff: Boolean;
    drawingIconsEnabled: Boolean;
    drawOnAxis: JValueAxis;
    eraseAll: Boolean;
    iconSize: Float;
    percentHeight: Float;
    recalculateToPercents: String;
    showCategoryAxis: Boolean;
    stockGraphs: array of JStockGraph;
    stockLegend: JStockLegend;
    title: String;
    trendLineAlpha: Float;
    trendLineColor: String;
    trendLineDashLength: Float;
    trendLineThickness: Float;
    procedure addStockGraph(graph: JStockGraph);
    procedure removeStockGraph(graph: JStockGraph);
  end;

  JAmChart = class external 'AmChart'
    constructor Create(theme: Variant);
    addClassNames: Boolean;
    allLabels: array of JLabel;
    autoResize: Boolean;
    backgroundAlpha: Float;
    backgroundColor: String;
    balloon: JAmBalloon;
    borderAlpha: Float;
    borderColor: String;
    classNamePrefix: String;
    color: String;
    creditsPosition: String;
    dataProvider: array of Variant;
    decimalSeparator: String;
    defs: Variant;
    &export: JExportSettings;
    fontFamily: String;
    fontSize: String;
    handDrawn: Boolean;
    handDrawScatter: Float;
    handDrawThickness: Float;
    hideBalloonTime: Float;
    legend: JAmLegend;
    legendDiv: JHTMLElement;
    listerns: array of JObject;
    panEventsEnabled: Boolean;
    path: String;
    pathToImages: String;
    percentPrecision: Float;
    precision: Float;
    prefixesOfBigNumbers: array of Variant;
    prefixesOfSmallNumbers: array of Variant;
    theme: String;
    thousandsSeparator: String;
    titles: array of JTitle;
    &type: String;
    usePrefixes: Boolean;
    version: String;
    procedure addLabel(x: Float; y: Float; text: String; align: String; size: Float; color: String; rotation: Float; alpha: Float; bold: Boolean; url: String);
    procedure addLegend(legend: JAmLegend); overload;
    procedure addLegend(legend: JAmLegend; legendDivId: String); overload;
    procedure addLegend(legend: JAmLegend; legendDiv: JHTMLElement);
    procedure addTitle(text: String; size: Float; color: String; alpha: Float; bold: Boolean);
    procedure clear;
    procedure clearLabels;
    procedure invalidateSize;
    procedure removeLegend;
    procedure validateData;
    procedure validateNow;
    procedure write(container: JHTMLElement);
    procedure write(container: String);
    procedure addListener(&type: String; handler: (e:       &type: String;
      chart: JAmChart;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JAmCoordinateChart = class external 'AmCoordinateChart'(JAmChart)
    chartData: array of JObject;
    colors: array of String;
    graphs: array of JAmGraph;
    gridAboveGraphs: Boolean;
    guides: array of JGuide;
    sequencedAnimation: Boolean;
    startAlpha: Float;
    startDuration: Float;
    startEffect: String;
    urlTarget: Variant;
    valueAxes: array of Variant;
    procedure addGraph(graph: JAmGraph);
    procedure addValueAxis(axis: JValueAxis);
    procedure animateAgain;
    function getGraphById(graphId: String): JAmGraph;
    function getValueAxisById(axisId: String): JValueAxis;
    procedure hideGraph(graph: JAmGraph);
    procedure hideGraphsBalloon(graph: JAmGraph);
    procedure highlightGraph(graph: JAmGraph);
    procedure removeGraph(graph: JAmGraph);
    procedure removeValueAxis(axis: JValueAxis);
    procedure showGraph(graph: JAmGraph);
    procedure showGraphsBalloon(graph: JAmGraph);
    procedure unhighlightGraph(graph: JAmGraph);
    procedure addListener(&type: String; handler: (e:       &type: String;
      graph: JAmGraph;
      item: JGraphDataItem;
      index: Float;
      chart: JAmChart;
    end;));
  end;

  JGraphDataItem = class external 'GraphDataItem'
    alpha: Float;
    bullet: String;
    bulletSize: Float;
    category: String;
    color: String;
    customBullet: String;
    dataContext: JObject;
    description: String;
    fillColors: array of Variant;
    percents: JObject;
    serialDataItem: JSerialDataItem;
    url: String;
    values: JObject;
    x: Float;
    y: Float;
  end;

  JSerialDataItem = class external 'SerialDataItem'
    axes: JObject;
    category: Variant;
    time: Float;
    x: Float;
  end;

  JCategoryAxis = class external 'CategoryAxis'(JAxisBase)
    boldPeriodBeginning: Boolean;
    dateFormats: array of Variant;
    equalSpacing: Boolean;
    forceShowField: String;
    gridPosition: String;
    minPeriod: String;
    parseDates: Boolean;
    startOnAxis: Boolean;
    procedure categoryToCoordinate(category: String);
    procedure coordinateToDate(coordinate: Float);
    procedure dateToCoordinate(date: JDate);
    procedure xToIndex(x: Float);
  end;

  JChartScrollbar = class external 'ChartScrollbar'
    autoGridCount: Boolean;
    backgroundAlpha: Float;
    backgroundColor: String;
    categoryAxis: JCategoryAxis;
    color: String;
    graph: JAmGraph;
    graphFillAlpha: Float;
    graphFillColor: String;
    graphLineAlpha: Float;
    graphLineColor: String;
    graphType: String;
    gridAlpha: Float;
    gridColor: String;
    gridCount: Float;
    hideResizeGrips: Boolean;
    resizeEnabled: Boolean;
    scrollbarHeight: Float;
    scrollDuration: Float;
    selectedBackgroundAlpha: Float;
    selectedBackgroundColor: String;
    selectedGraphFillAlpha: Float;
    selectedGraphFillColor: String;
    selectedGraphLineAlpha: Float;
    selectedGraphLineColor: String;
    updateOnReleaseOnly: Boolean;
  end;

  JAmRectangularChart = class external 'AmRectangularChart'(JAmCoordinateChart)
    angle: Float;
    autoMarginOffset: Float;
    autoMargins: Boolean;
    chartCursor: JChartCursor;
    chartScrollbar: JChartScrollbar;
    depth3D: Float;
    marginBottom: Float;
    marginLeft: Float;
    marginRight: Float;
    marginsUpdated: Boolean;
    marginTop: Float;
    plotAreaBorderAlpha: Float;
    plotAreaBorderColor: String;
    plotAreaFillAlphas: Float;
    plotAreaFillColors: Variant;
    plotAreaGradientAngle: Float;
    trendLines: array of JTrendLine;
    zoomOutButtonAlpha: Float;
    zoomOutButtonColor: String;
    zoomOutButtonImage: String;
    zoomOutButtonImageSize: Float;
    zoomOutButtonPadding: Float;
    zoomOutButtonRollOverAlpha: Float;
    zoomOutText: String;
    procedure addChartCursor(cursor: JChartCursor);
    procedure addChartScrollbar(scrollbar: JChartScrollbar);
    procedure addTrendLine(trendLine: JTrendLine);
    procedure removeChartCursor;
    procedure removeChartScrollbar;
    procedure removeTrendLine(trendLine: JTrendLine);
  end;

  JTrendLine = class external 'TrendLine'
  end;

  JChartCursor = class external 'ChartCursor'
    bulletsEnabled: Boolean;
    bulletSize: Float;
    categoryBalloonAlpha: Float;
    categoryBalloonColor: String;
    categoryBalloonDateFormat: String;
    categoryBalloonEnabled: Boolean;
    color: String;
    cursorAlpha: Float;
    cursorColor: String;
    cursorPosition: String;
    enabled: Boolean;
    oneBalloonOnly: Boolean;
    pan: Boolean;
    selectionAlpha: Float;
    selectWithoutZooming: Boolean;
    valueBalloonsEnabled: Boolean;
    zoomable: Boolean;
    zooming: Boolean;
    procedure hideCursor;
    procedure showCursorAt(category: String);
    procedure addListener(&type: String; handler: (e:       &type: String;
      index: Float;
      zooming: Boolean;
      mostCloseGraph: JAmGraph;
      chart: JAmChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      chart: JAmChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      index: Float;
      zooming: Boolean;
      chart: JAmChart;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JAmSerialChart = class external 'AmSerialChart'(JAmRectangularChart)
    balloonDateFormat: String;
    categoryAxis: JCategoryAxis;
    categoryField: String;
    columnSpacing: Float;
    columnSpacing3D: Float;
    columnWidth: Float;
    endDate: JDate;
    endIndex: Float;
    maxSelectedSeries: Float;
    maxSelectedTime: Float;
    minSelectedTime: Float;
    mouseWheelScrollEnabled: Boolean;
    mouseWheelZoomEnabled: Boolean;
    rotate: Boolean;
    startDate: JDate;
    startIndex: Float;
    zoomOutOnDataUpdate: Boolean;
    procedure getCategoryIndexByValue(value: Float);
    procedure zoomOut;
    procedure zoomToCategoryValues(start: JDate; &end: JDate);
    procedure zoomToDates(start: JDate; &end: JDate);
    procedure zoomToIndexes(start: JDate; &end: JDate);
  end;

  JPeriodSelector = class external 'PeriodSelector'
    dateFormat: String;
    fromText: String;
    hideOutOfScopePeriods: Boolean;
    inputFieldsEnabled: Boolean;
    inputFieldWidth: Float;
    periods: array of Variant;
    periodsText: String;
    position: String;
    selectFromStart: Boolean;
    toText: String;
    width: Float;
    procedure addListener(&type: String; handler: (e:       &type: String;
      startDate: JDate;
      endDate: JDate;
      predefinedPeriod: String;
      count: Float;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JPanelsSettings = class external 'PanelsSettings'
    angle: Float;
    backgroundAlpha: Float;
    backgroundColor: String;
    columnSpacing: Float;
    columnWidth: Float;
    depth3D: Float;
    fontFamily: String;
    fontSize: String;
    marginBottom: Float;
    marginLeft: Float;
    marginRight: Float;
    marginTop: Float;
    panelSpacing: Float;
    panEventsEnabled: Boolean;
    plotAreaBorderAlpha: Float;
    plotAreaBorderColor: String;
    plotAreaFillAlphas: Float;
    plotAreaFillColors: Variant;
    prefixesOfBigNumbers: array of Variant;
    prefixesOfSmallNumbers: array of Variant;
    sequencedAnimation: Boolean;
    startAlpha: Float;
    startDuration: Float;
    startEffect: String;
    usePrefixes: Boolean;
  end;

  JDataSet = class external 'DataSet'
    categoryField: String;
    color: String;
    compared: Boolean;
    dataProvider: array of Variant;
    fieldMappings: array of Variant;
    showInCompare: Boolean;
    showInSelect: Boolean;
    stockEvents: array of JStockEvent;
    title: String;
  end;

  JStockGraph = class external 'StockGraph'(JAmGraph)
    comparable: Boolean;
    compareField: String;
    compareGraphBalloonColor: String;
    compareGraphBalloonText: String;
    compareGraphBullet: String;
    compareGraphBulletSize: Float;
    compareGraphCornerRadiusTop: Float;
    compareGraphDashLength: Float;
    compareGraphFillAlphas: Float;
    compareGraphFillColors: String;
    compareGraphLineAlpha: Float;
    compareGraphLineThickness: Float;
    compareGraphType: String;
    compareGraphVisibleInLegend: Boolean;
    periodValue: String;
    useDataSetColors: Boolean;
  end;

  JStockEvent = class external 'StockEvent'
    backgroundAlpha: Float;
    backgroundColor: String;
    borderAlpha: Float;
    borderColor: String;
    color: String;
    date: JDate;
    graph: JStockGraph;
    rollOverColor: String;
    showOnAxis: Boolean;
    text: String;
    &type: String;
    url: String;
    urlTarget: String;
  end;

  JLabel = class external 'Label'
    align: String;
    alpha: Float;
    bold: Boolean;
    color: String;
    id: String;
    rotation: Float;
    size: Float;
    text: String;
    url: String;
    x: Variant {Float or String};
    y: Variant {Float or String};
  end;

  JLegendSettings = class external 'LegendSettings'
    align: String;
    equalWidths: Boolean;
    horizontalGap: Float;
    labelText: String;
    marginBottom: Float;
    marginTop: Float;
    markerBorderAlpha: Float;
    markerBorderColor: String;
    markerBorderThickness: Float;
    markerDisabledColor: String;
    markerLabelGap: Float;
    markerSize: Float;
    markerType: String;
    reversedOrder: Boolean;
    rollOverColor: String;
    rollOverGraphAlpha: Float;
    switchable: Boolean;
    switchColor: String;
    switchType: String;
    textClickEnabled: Boolean;
    useMarkerColorForLabels: Boolean;
    valueTextComparing: String;
    valueTextRegular: String;
    valueWidth: Float;
    verticalGap: Float;
  end;

  JDataSetSelector = class external 'DataSetSelector'
    comboBoxSelectText: String;
    compareText: String;
    listHeight: Float;
    position: String;
    selectText: String;
    width: Float;
  end;

  JAmBalloon = class external 'AmBalloon'
    adjustBorderColor: Boolean;
    borderAlpha: Float;
    borderColor: String;
    borderThickness: Float;
    color: String;
    cornerRadius: Float;
    fillAlpha: Float;
    fillColor: String;
    fontSize: String;
    horizontalPadding: Float;
    pointerWidth: Float;
    showBullet: Boolean;
    textAlign: String;
    textShadowColor: String;
    verticalPadding: Float;
    procedure hide;
    procedure setBounds(left: Float; top: Float; right: Float; bottom: Float);
    procedure setPosition(x: Float; y: Float);
    procedure show(value: String);
  end;

  JCategoryAxesSettings = class external 'CategoryAxesSettings'
    autoGridCount: Boolean;
    axisAlpha: Float;
    axisColor: String;
    axisHeight: Float;
    axisThickness: Float;
    color: String;
    dashLength: Float;
    dateFormats: array of Variant;
    equalSpacing: Boolean;
    fillAlpha: Float;
    fillColor: String;
    fontSize: String;
    gridAlpha: Float;
    gridColor: String;
    gridCount: Float;
    gridThickness: Float;
    groupToPeriods: array of Variant;
    inside: Boolean;
    labelRotation: Float;
    maxSeries: Float;
    minPeriod: String;
    position: String;
    startOnAxis: Boolean;
    tickLength: Float;
  end;

  JChartCursorSettings = class external 'ChartCursorSettings'
    bulletsEnabled: Boolean;
    bulletSize: Float;
    categoryBalloonAlpha: Float;
    categoryBalloonColor: String;
    categoryBalloonDateFormats: array of Variant;
    categoryBalloonEnabled: Boolean;
    cursorAlpha: Float;
    cursorColor: String;
    cursorPosition: String;
    enabled: Boolean;
    pan: Boolean;
    valueBalloonsEnabled: Boolean;
    zoomable: Boolean;
  end;

  JChartScrollbarSettings = class external 'ChartScrollbarSettings'
    autoGridCount: Boolean;
    backgroundAlpha: Float;
    backgroundColor: String;
    color: String;
    enabled: Boolean;
    fontSize: String;
    graph: JAmGraph;
    graphFillAlpha: Float;
    graphFillColor: String;
    graphLineAlpha: Float;
    graphLineColor: String;
    graphType: String;
    gridAlpha: Float;
    gridColor: String;
    gridCount: Float;
    height: Float;
    hideResizeGrips: Boolean;
    scrollDuration: Float;
    selectedBackgroundAlpha: Float;
    selectedBackgroundColor: String;
    selectedGraphFillAlpha: Float;
    selectedGraphFillColor: String;
    selectedGraphLineAlpha: Float;
    selectedGraphLineColor: String;
    updateOnReleaseOnly: Boolean;
  end;

  JAmGraph = class external 'AmGraph'
    alphaField: String;
    balloonColor: String;
    function balloonFunction(graphDataItem: JGraphDataItem; amGraph: JAmGraph): String;
    balloonText: String;
    behindColumns: Boolean;
    bullet: String;
    bulletAlpha: Float;
    bulletBorderAlpha: Float;
    bulletBorderColor: String;
    bulletBorderThickness: Float;
    bulletColor: String;
    bulletField: String;
    bulletOffset: Float;
    bulletSize: Float;
    bulletSizeField: String;
    closeField: String;
    color: String;
    colorField: String;
    connect: Boolean;
    cornerRadiusTop: Float;
    cursorBulletAlpha: Float;
    customBullet: String;
    customBulletField: String;
    dashLength: Float;
    descriptionField: String;
    fillAlphas: Float;
    fillColors: Variant;
    fillColorsField: String;
    fillToGraph: JAmGraph;
    fontSize: String;
    gradientOrientation: String;
    hidden: Boolean;
    hideBulletsCount: Float;
    highField: String;
    includeInMinMax: Boolean;
    labelColorField: String;
    labelPosition: String;
    labelText: String;
    legendAlpha: Float;
    legendColor: String;
    legendValueText: String;
    lineAlpha: Float;
    lineColor: String;
    lineColorField: String;
    lineThickness: Float;
    lowField: String;
    markerType: String;
    maxBulletSize: Float;
    minBulletSize: Float;
    negativeBase: Float;
    negativeFillAlphas: Float;
    negativeFillColors: Variant;
    negativeLineColor: String;
    numberFormatter: JObject;
    openField: String;
    pointPosition: String;
    showAllValueLabels: Boolean;
    showBalloon: Boolean;
    showBalloonAt: String;
    stackable: Boolean;
    title: String;
    &type: String;
    urlField: String;
    urlTarget: String;
    valueAxis: JValueAxis;
    valueField: String;
    visibleInLegend: Boolean;
    xAxis: JValueAxis;
    xField: String;
    yAxis: JValueAxis;
    yField: String;
  end;

  JAxisBase = class external 'AxisBase'
    autoGridCount: Boolean;
    axisAlpha: Float;
    axisColor: String;
    axisThickness: Float;
    color: String;
    dashLength: Float;
    fillAlpha: Float;
    fillColor: String;
    fontSize: String;
    gridAlpha: Float;
    gridColor: String;
    gridCount: Float;
    gridThickness: Float;
    guides: array of Variant;
    ignoreAxisWidth: Boolean;
    inside: Boolean;
    labelFrequency: Float;
    labelRotation: Float;
    labelsEnabled: Boolean;
    offset: Float;
    position: String;
    showFirstLabel: Boolean;
    showLastLabel: Boolean;
    tickLength: Float;
    title: String;
    titleBold: Boolean;
    titleColor: String;
    titlefontSize: String;
    procedure addGuide(guide: JGuide);
    procedure removeGuide(guide: JGuide);
  end;

  JValueAxis = class external 'ValueAxis'(JAxisBase)
    axisTitleOffset: Float;
    baseCoord: Float;
    baseValue: Float;
    duration: String;
    durationUnits: JObject;
    gridType: String;
    id: String;
    includeGuidesInMinMax: Boolean;
    includeHidden: Boolean;
    integersOnly: Boolean;
    function labelFunction(value: Float; valueText: String; valueAxis: JValueAxis): String;
    function labelFunction(valueText: String; data: JDate; valueAxis: JValueAxis): String;
    logarithmic: Boolean;
    max: Float;
    maximum: Float;
    maximumData: JDate;
    min: Float;
    minimum: Float;
    minimumDate: JDate;
    minMaxMultiplier: Float;
    pointPosition: String;
    position: String;
    precision: Float;
    radarCategoriesEnabled: Boolean;
    recalculateToPercents: Boolean;
    reversed: Boolean;
    stackType: String;
    step: Float;
    strictMinMax: Boolean;
    synchronizationMultiplier: Float;
    synchronizeWith: JValueAxis;
    totalText: String;
    totalTextColor: String;
    totalTextOffset: Float;
    treatZeroAs: Float;
    &type: String;
    unit: String;
    unitPosition: String;
    usePrefixes: Boolean;
    useScientificNotation: Boolean;
    procedure addGuide(guide: JGuide);
    procedure addListener(&type: String; handler: Variant);
    procedure coordinateToValue(coordinate: Float);
    procedure getCoordinate(value: Float);
    procedure removeGuide(guide: JGuide);
    procedure removeListener(obj: Variant; &type: String; handler: Variant);
    procedure synchronizeWithAxis(axis: JValueAxis);
    procedure zoomToValues(startValue: Float; endValue: Float);
    procedure addListener(&type: String; handler: (e:       &type: String;
      startValue: JDate;
      endValue: JDate;
      chart: JAmChart;
    end;));
    procedure addListener(&type: String; handler: (e:       &type: String;
      chart: JAmChart;
    end;));
    procedure removeListener(chart: JAmChart; &type: String; handler: Variant);
  end;

  JTitle = class external 'Title'
    alpha: Float;
    bold: Boolean;
    color: String;
    id: String;
    size: Float;
    text: String;
  end;

  JExportSettings = class external 'ExportSettings'
    enabled: Boolean;
    libs: JObject;
    menu: JObject;
  end;

procedure clear;

var
  baseHref: Boolean;
  dayNames: array of String;
  monthNames: array of String;
  shortDayNames: array of String;
  shortMonthNames: array of String;
  useUTC: Boolean;

