unit Amplifyjs;

interface

type
  JamplifyRequestSettings = class external
    resourceId: String;
    data: Variant; // nullable
    success: (args: array of Variant); // nullable
    error: (args: array of Variant); // nullable
  end;

  JamplifyDecoder = class external
(data: Variant; status: String; xhr: JJQueryXHR; success: (args: array of Variant); error: (args: array of Variant))  end;

  JamplifyDecoders = class external
    // property Item[decoderName: String]: JamplifyDecoder;
    jsSend: JamplifyDecoder;
  end;

  JamplifyAjaxSettings = class external(JJQueryAjaxSettings)
    cache: Variant; // nullable
    dataMap: Variant {    end; or (data: Variant):     end;}; // nullable
    decoder: Variant; // nullable
  end;

  JamplifyRequest = class external
(resourceId: String; hash: Variant; callback: JFunction)(settings: JamplifyRequestSettings): Variant    procedure define(resourceId: String; requestType: String); overload;
    procedure define(resourceId: String; requestType: String; settings: JamplifyAjaxSettings); overload;
    procedure define(resourceId: String; resource: (settings: JamplifyRequestSettings));
    decoders: JamplifyDecoders;
    cache: Variant;
  end;

  JamplifySubscribe = class external
(topic: String; callback: JFunction)(topic: String; context: Variant; callback: JFunction; priority: Float)(topic: String; callback: JFunction; priority: Float)  end;

  JamplifyStorageTypeStore = class external
(key: String; value: Variant; options: Variant)(key: String): Variant: Variant  end;

  JamplifyStore = class external(JamplifyStorageTypeStore)
    localStorage: JamplifyStorageTypeStore;
    sessionStorage: JamplifyStorageTypeStore;
    globalStorage: JamplifyStorageTypeStore;
    userData: JamplifyStorageTypeStore;
    memory: JamplifyStorageTypeStore;
  end;

  JamplifyStatic = class external
    subscribe: JamplifySubscribe;
    procedure unsubscribe(topic: String; callback: JFunction);
    function publish(topic: String; args: array of Variant): Boolean;
    store: JamplifyStore;
    request: JamplifyRequest;
  end;

amplify: JamplifyStatic;
