unit Easeljs;

interface

type
  JNativeMouseEvent = class external(JMouseEvent)
  end;

//createjs

type
  JAlphaMapFilter = class external 'AlphaMapFilter'(JFilter)
    constructor Create(alphaMap: Variant {JHTMLImageElement or JHTMLCanvasElement});
    alphaMap: Variant {JHTMLImageElement or JHTMLCanvasElement};
    function clone: JAlphaMapFilter;
  end;

  JAlphaMaskFilter = class external 'AlphaMaskFilter'(JFilter)
    constructor Create(mask: Variant {JHTMLImageElement or JHTMLCanvasElement});
    mask: Variant {JHTMLImageElement or JHTMLCanvasElement};
    function clone: JAlphaMaskFilter;
  end;

  JBitmap = class external 'Bitmap'(JDisplayObject)
    constructor Create(imageOrUrl: Variant {JHTMLImageElement or JHTMLCanvasElement or JHTMLVideoElement or String});
    image: Variant {JHTMLImageElement or JHTMLCanvasElement or JHTMLVideoElement};
    sourceRect: JRectangle;
    function clone: JBitmap;
  end;

  JBitmapText = class external 'BitmapText'(JDisplayObject)
    constructor Create(text: String; spriteSheet: JSpriteSheet);
    maxPoolSize: Float;
    letterSpacing: Float;
    lineHeight: Float;
    spaceWidth: Float;
    spriteSheet: JSpriteSheet;
    text: String;
  end;

  JBlurFilter = class external 'BlurFilter'(JFilter)
    constructor Create(blurX: Float; blurY: Float; quality: Float);
    blurX: Float;
    blurY: Float;
    quality: Float;
    function clone: JBlurFilter;
  end;

  JButtonHelper = class external 'ButtonHelper'
    constructor Create(target: JSprite; outLabel: String; overLabel: String; downLabel: String; play: Boolean; hitArea: JDisplayObject; hitLabel: String);
    constructor Create(target: JMovieClip; outLabel: String; overLabel: String; downLabel: String; play: Boolean; hitArea: JDisplayObject; hitLabel: String);
    downLabel: Variant {String or Float};
    outLabel: Variant {String or Float};
    overLabel: Variant {String or Float};
    play: Boolean;
    target: Variant {JMovieClip or JSprite};
    enabled: Boolean;
    procedure setEnabled(value: Boolean);
    function getEnabled: Boolean;
    function toString: String;
  end;

  JColorFilter = class external 'ColorFilter'(JFilter)
    constructor Create(redMultiplier: Float; greenMultiplier: Float; blueMultiplier: Float; alphaMultiplier: Float; redOffset: Float; greenOffset: Float; blueOffset: Float; alphaOffset: Float);
    alphaMultiplier: Float;
    alphaOffset: Float;
    blueMultiplier: Float;
    blueOffset: Float;
    greenMultiplier: Float;
    greenOffset: Float;
    redMultiplier: Float;
    redOffset: Float;
    function clone: JColorFilter;
  end;

  JColorMatrix = class external 'ColorMatrix'
    constructor Create(brightness: Float; contrast: Float; saturation: Float; hue: Float);
    function adjustBrightness(value: Float): JColorMatrix;
    function adjustColor(brightness: Float; contrast: Float; saturation: Float; hue: Float): JColorMatrix;
    function adjustContrast(value: Float): JColorMatrix;
    function adjustHue(value: Float): JColorMatrix;
    function adjustSaturation(value: Float): JColorMatrix;
    function clone: JColorMatrix;
    function concat(matrix: array of Float): JColorMatrix;
    function concat(matrix: JColorMatrix): JColorMatrix;
    function copy(matrix: array of Float): JColorMatrix;
    function copy(matrix: JColorMatrix): JColorMatrix;
    function reset: JColorMatrix;
    function setColor(brightness: Float; contrast: Float; saturation: Float; hue: Float): JColorMatrix;
    function toArray: array of Float;
    function toString: String;
  end;

  JColorMatrixFilter = class external 'ColorMatrixFilter'(JFilter)
    constructor Create(matrix: Variant {array of Float or JColorMatrix});
    matrix: Variant {array of Float or JColorMatrix};
    function clone: JColorMatrixFilter;
  end;

  JContainer = class external 'Container'(JDisplayObject)
    constructor Create;
    children: array of JDisplayObject;
    mouseChildren: Boolean;
    numChildren: Float;
    tickChildren: Boolean;
    function addChild(child: array of JDisplayObject): JDisplayObject;
    function addChildAt(child: JDisplayObject; index: Float): JDisplayObject;
    function addChildAt(childOrIndex: array of Variant): JDisplayObject;
    function clone: JContainer; overload;
    function clone(recursive: Boolean): JContainer; overload;
    function contains(child: JDisplayObject): Boolean;
    function getChildAt(index: Float): JDisplayObject;
    function getChildByName(name: String): JDisplayObject;
    function getChildIndex(child: JDisplayObject): Float;
    function getNumChildren: Float;
    function getObjectsUnderPoint(x: Float; y: Float; mode: Float): array of JDisplayObject;
    function getObjectUnderPoint(x: Float; y: Float; mode: Float): JDisplayObject;
    procedure removeAllChildren;
    function removeChild(child: array of JDisplayObject): Boolean;
    function removeChildAt(index: array of Float): Boolean;
    procedure setChildIndex(child: JDisplayObject; index: Float);
    procedure sortChildren(sortFunction: (a: JDisplayObject; b: JDisplayObject): Float);
    procedure swapChildren(child1: JDisplayObject; child2: JDisplayObject);
    procedure swapChildrenAt(index1: Float; index2: Float);
  end;

  JDisplayObject = class external 'DisplayObject'(JEventDispatcher)
    constructor Create;
    alpha: Float;
    cacheCanvas: Variant {JHTMLCanvasElement or JObject};
    cacheID: Float;
    compositeOperation: String;
    cursor: String;
    filters: array of JFilter;
    hitArea: JDisplayObject;
    id: Float;
    mask: JShape;
    mouseEnabled: Boolean;
    name: String;
    parent: JContainer;
    regX: Float;
    regY: Float;
    rotation: Float;
    scaleX: Float;
    scaleY: Float;
    shadow: JShadow;
    skewX: Float;
    skewY: Float;
    snapToPixel: Boolean;
    stage: JStage;
    suppressCrossDomainErrors: Boolean;
    tickEnabled: Boolean;
    transformMatrix: JMatrix2D;
    visible: Boolean;
    x: Float;
    y: Float;
    procedure cache(x: Float; y: Float; width: Float; height: Float); overload;
    procedure cache(x: Float; y: Float; width: Float; height: Float; scale: Float); overload;
    function clone: JDisplayObject;
    function draw(ctx: JCanvasRenderingContext2D): Boolean; overload;
    function draw(ctx: JCanvasRenderingContext2D; ignoreCache: Boolean): Boolean; overload;
    function getBounds: JRectangle;
    function getCacheDataURL: String;
    function getConcatenatedDisplayProps: JDisplayProps; overload;
    function getConcatenatedDisplayProps(props: JDisplayProps): JDisplayProps; overload;
    function getConcatenatedMatrix: JMatrix2D; overload;
    function getConcatenatedMatrix(mtx: JMatrix2D): JMatrix2D; overload;
    function getMatrix: JMatrix2D; overload;
    function getMatrix(matrix: JMatrix2D): JMatrix2D; overload;
    function getStage: JStage;
    function getTransformedBounds: JRectangle;
    function globalToLocal(x: Float; y: Float): JPoint; overload;
    function globalToLocal(x: Float; y: Float; pt: Variant {JPoint or JObject}): JPoint; overload;
    function hitTest(x: Float; y: Float): Boolean;
    function isVisible: Boolean;
    function localToGlobal(x: Float; y: Float): JPoint; overload;
    function localToGlobal(x: Float; y: Float; pt: Variant {JPoint or JObject}): JPoint; overload;
    function localToLocal(x: Float; y: Float; target: JDisplayObject): JPoint; overload;
    function localToLocal(x: Float; y: Float; target: JDisplayObject; pt: Variant {JPoint or JObject}): JPoint; overload;
    function set(props: JObject): JDisplayObject;
    procedure setBounds(x: Float; y: Float; width: Float; height: Float);
    function setTransform: JDisplayObject; overload;
    function setTransform(x: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JDisplayObject; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JDisplayObject; overload;
    procedure uncache;
    procedure updateCache; overload;
    procedure updateCache(compositeOperation: String); overload;
    procedure updateContext(ctx: JCanvasRenderingContext2D);
  end;

  JDisplayProps = class external 'DisplayProps'
    constructor Create(visible: Float; alpha: Float; shadow: Float; compositeOperation: Float; matrix: Float);
    alpha: Float;
    compositeOperation: String;
    matrix: JMatrix2D;
    shadow: JShadow;
    visible: Boolean;
    function append(visible: Boolean; alpha: Float; shadow: JShadow; compositeOperation: String): JDisplayProps; overload;
    function append(visible: Boolean; alpha: Float; shadow: JShadow; compositeOperation: String; matrix: JMatrix2D): JDisplayProps; overload;
    function clone: JDisplayProps;
    function identity: JDisplayProps;
    function prepend(visible: Boolean; alpha: Float; shadow: JShadow; compositeOperation: String): JDisplayProps; overload;
    function prepend(visible: Boolean; alpha: Float; shadow: JShadow; compositeOperation: String; matrix: JMatrix2D): JDisplayProps; overload;
    function setValues: JDisplayProps; overload;
    function setValues(visible: Boolean): JDisplayProps; overload;
    function setValues(visible: Boolean; alpha: Float): JDisplayProps; overload;
    function setValues(visible: Boolean; alpha: Float; shadow: Float): JDisplayProps; overload;
    function setValues(visible: Boolean; alpha: Float; shadow: Float; compositeOperation: Float): JDisplayProps; overload;
    function setValues(visible: Boolean; alpha: Float; shadow: Float; compositeOperation: Float; matrix: Float): JDisplayProps; overload;
  end;

  JDOMElement = class external 'DOMElement'(JDisplayObject)
    constructor Create(htmlElement: JHTMLElement);
    htmlElement: JHTMLElement;
    function clone: JDisplayObject;
    function set(props: JObject): JDOMElement;
    function setTransform: JDOMElement; overload;
    function setTransform(x: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JDOMElement; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JDOMElement; overload;
  end;

  JEaselJS = class external 'EaselJS'
    buildDate: String;
    version: String;
  end;

  JFilter = class external 'Filter'
    constructor Create;
    function applyFilter(ctx: JCanvasRenderingContext2D; x: Float; y: Float; width: Float; height: Float): Boolean; overload;
    function applyFilter(ctx: JCanvasRenderingContext2D; x: Float; y: Float; width: Float; height: Float; targetCtx: JCanvasRenderingContext2D): Boolean; overload;
    function applyFilter(ctx: JCanvasRenderingContext2D; x: Float; y: Float; width: Float; height: Float; targetCtx: JCanvasRenderingContext2D; targetX: Float): Boolean; overload;
    function applyFilter(ctx: JCanvasRenderingContext2D; x: Float; y: Float; width: Float; height: Float; targetCtx: JCanvasRenderingContext2D; targetX: Float; targetY: Float): Boolean; overload;
    function clone: JFilter;
    function getBounds: JRectangle;
    function toString: String;
  end;

  JGraphics = class external 'Graphics'
    constructor Create;
    BASE_64: JObject;
    beginCmd: JGraphics.BeginPath;
    command: JObject;
    instructions: array of JObject;
    STROKE_CAPS_MAP: array of String;
    STROKE_JOINTS_MAP: array of String;
    function append(command: JObject): JGraphics; overload;
    function append(command: JObject; clean: Boolean): JGraphics; overload;
    function arc(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float; anticlockwise: Boolean): JGraphics;
    function arcTo(x1: Float; y1: Float; x2: Float; y2: Float; radius: Float): JGraphics;
    function beginBitmapFill(image: JObject): JGraphics; overload;
    function beginBitmapFill(image: JObject; repetition: String): JGraphics; overload;
    function beginBitmapFill(image: JObject; repetition: String; matrix: JMatrix2D): JGraphics; overload;
    function beginBitmapStroke(image: JObject): JGraphics; overload;
    function beginBitmapStroke(image: JObject; repetition: String): JGraphics; overload;
    function beginFill(color: String): JGraphics;
    function beginLinearGradientFill(colors: array of String; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JGraphics;
    function beginLinearGradientStroke(colors: array of String; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JGraphics;
    function beginRadialGradientFill(colors: array of String; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JGraphics;
    function beginRadialGradientStroke(colors: array of String; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JGraphics;
    function beginStroke(color: String): JGraphics;
    function bezierCurveTo(cp1x: Float; cp1y: Float; cp2x: Float; cp2y: Float; x: Float; y: Float): JGraphics;
    function clear: JGraphics;
    function clone: JGraphics;
    function closePath: JGraphics;
    function curveTo(cpx: Float; cpy: Float; x: Float; y: Float): JGraphics;
    function decodePath(str: String): JGraphics;
    procedure draw(ctx: JCanvasRenderingContext2D);
    procedure drawAsPath(ctx: JCanvasRenderingContext2D);
    function drawCircle(x: Float; y: Float; radius: Float): JGraphics;
    function drawEllipse(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function drawPolyStar(x: Float; y: Float; radius: Float; sides: Float; pointSize: Float; angle: Float): JGraphics;
    function drawRect(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function drawRoundRect(x: Float; y: Float; w: Float; h: Float; radius: Float): JGraphics;
    function drawRoundRectComplex(x: Float; y: Float; w: Float; h: Float; radiusTL: Float; radiusTR: Float; radiusBR: Float; radisBL: Float): JGraphics;
    function endFill: JGraphics;
    function endStroke: JGraphics;
    function getHSL(hue: Float; saturation: Float; lightness: Float): String; overload;
    function getHSL(hue: Float; saturation: Float; lightness: Float; alpha: Float): String; overload;
    function getInstructions: array of JObject;
    function getRGB(r: Float; g: Float; b: Float): String; overload;
    function getRGB(r: Float; g: Float; b: Float; alpha: Float): String; overload;
    function inject(callback: (data: Variant): Variant; data: Variant): JGraphics;
    function isEmpty: Boolean;
    function lineTo(x: Float; y: Float): JGraphics;
    function moveTo(x: Float; y: Float): JGraphics;
    function quadraticCurveTo(cpx: Float; cpy: Float; x: Float; y: Float): JGraphics;
    function rect(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function setStrokeStyle(thickness: Float): JGraphics; overload;
    function setStrokeStyle(thickness: Float; caps: Variant {String or Float}): JGraphics; overload;
    function setStrokeStyle(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}): JGraphics; overload;
    function setStrokeStyle(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}; miterLimit: Float): JGraphics; overload;
    function setStrokeStyle(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}; miterLimit: Float; ignoreScale: Boolean): JGraphics; overload;
    function setStrokeDash: JGraphics; overload;
    function setStrokeDash(segments: array of Float): JGraphics; overload;
    function setStrokeDash(segments: array of Float; offset: Float): JGraphics; overload;
    function store: JGraphics;
    function toString: String;
    function unstore: JGraphics;
    function a(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float; anticlockwise: Boolean): JGraphics;
    function at(x1: Float; y1: Float; x2: Float; y2: Float; radius: Float): JGraphics;
    function bf(image: JObject): JGraphics; overload;
    function bf(image: JObject; repetition: String): JGraphics; overload;
    function bf(image: JObject; repetition: String; matrix: JMatrix2D): JGraphics; overload;
    function bs(image: JObject): JGraphics; overload;
    function bs(image: JObject; repetition: String): JGraphics; overload;
    function f(color: String): JGraphics;
    function lf(colors: array of String; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JGraphics;
    function ls(colors: array of String; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JGraphics;
    function rf(colors: array of String; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JGraphics;
    function rs(colors: array of String; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JGraphics;
    function s(color: String): JGraphics;
    function bt(cp1x: Float; cp1y: Float; cp2x: Float; cp2y: Float; x: Float; y: Float): JGraphics;
    function c: JGraphics;
    function cp: JGraphics;
    function p(str: String): JGraphics;
    function dc(x: Float; y: Float; radius: Float): JGraphics;
    function de(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function dp(x: Float; y: Float; radius: Float; sides: Float; pointSize: Float; angle: Float): JGraphics;
    function dr(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function rr(x: Float; y: Float; w: Float; h: Float; radius: Float): JGraphics;
    function rc(x: Float; y: Float; w: Float; h: Float; radiusTL: Float; radiusTR: Float; radiusBR: Float; radisBL: Float): JGraphics;
    function ef: JGraphics;
    function es: JGraphics;
    function lt(x: Float; y: Float): JGraphics;
    function mt(x: Float; y: Float): JGraphics;
    function qt(cpx: Float; cpy: Float; x: Float; y: Float): JGraphics;
    function r(x: Float; y: Float; w: Float; h: Float): JGraphics;
    function ss(thickness: Float): JGraphics; overload;
    function ss(thickness: Float; caps: Variant {String or Float}): JGraphics; overload;
    function ss(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}): JGraphics; overload;
    function ss(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}; miterLimit: Float): JGraphics; overload;
    function ss(thickness: Float; caps: Variant {String or Float}; joints: Variant {String or Float}; miterLimit: Float; ignoreScale: Boolean): JGraphics; overload;
    function sd: JGraphics; overload;
    function sd(segments: array of Float): JGraphics; overload;
    function sd(segments: array of Float; offset: Float): JGraphics; overload;
  end;

  JMatrix2D = class external 'Matrix2D'
    constructor Create(a: Float; b: Float; c: Float; d: Float; tx: Float; ty: Float);
    a: Float;
    b: Float;
    c: Float;
    d: Float;
    DEG_TO_RAD: Float;
    identity: JMatrix2D;
    tx: Float;
    ty: Float;
    function append(a: Float; b: Float; c: Float; d: Float; tx: Float; ty: Float): JMatrix2D;
    function appendMatrix(matrix: JMatrix2D): JMatrix2D;
    function appendTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JMatrix2D; overload;
    function appendTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JMatrix2D; overload;
    function appendTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JMatrix2D; overload;
    function clone: JMatrix2D;
    function copy(matrix: JMatrix2D): JMatrix2D;
    function decompose:       x: Float;
      y: Float;
      scaleX: Float;
      scaleY: Float;
      rotation: Float;
      skewX: Float;
      skewY: Float;
    end;;
    function decompose(target: JObject): JMatrix2D;
    function equals(matrix: JMatrix2D): Boolean;
    function identity: JMatrix2D;
    function invert: JMatrix2D;
    function isIdentity: Boolean;
    function prepend(a: Float; b: Float; c: Float; d: Float; tx: Float; ty: Float): JMatrix2D;
    function prependMatrix(matrix: JMatrix2D): JMatrix2D;
    function prependTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JMatrix2D; overload;
    function prependTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JMatrix2D; overload;
    function prependTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JMatrix2D; overload;
    function rotate(angle: Float): JMatrix2D;
    function scale(x: Float; y: Float): JMatrix2D;
    function setValues: JMatrix2D; overload;
    function setValues(a: Float): JMatrix2D; overload;
    function setValues(a: Float; b: Float): JMatrix2D; overload;
    function setValues(a: Float; b: Float; c: Float): JMatrix2D; overload;
    function setValues(a: Float; b: Float; c: Float; d: Float): JMatrix2D; overload;
    function setValues(a: Float; b: Float; c: Float; d: Float; tx: Float): JMatrix2D; overload;
    function setValues(a: Float; b: Float; c: Float; d: Float; tx: Float; ty: Float): JMatrix2D; overload;
    function skew(skewX: Float; skewY: Float): JMatrix2D;
    function toString: String;
    function transformPoint(x: Float; y: Float): JPoint; overload;
    function transformPoint(x: Float; y: Float; pt: Variant {JPoint or JObject}): JPoint; overload;
    function translate(x: Float; y: Float): JMatrix2D;
  end;

  JMouseEvent = class external 'MouseEvent'(JEvent)
    constructor Create(&type: String; bubbles: Boolean; cancelable: Boolean; stageX: Float; stageY: Float; nativeEvent: JNativeMouseEvent; pointerID: Float; primary: Boolean; rawX: Float; rawY: Float);
    isTouch: Boolean;
    localX: Float;
    localY: Float;
    nativeEvent: JNativeMouseEvent;
    pointerID: Float;
    primary: Boolean;
    rawX: Float;
    rawY: Float;
    stageX: Float;
    stageY: Float;
    function clone: JMouseEvent;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean): JObject; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}): Boolean; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}; target: JObject): Boolean; overload;
    function hasEventListener(&type: String): Boolean;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject)); overload;
    procedure off(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener: JFunction); overload;
    procedure off(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    procedure removeAllEventListeners; overload;
    procedure removeAllEventListeners(&type: String); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject)); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function toString: String;
    function willTrigger(&type: String): Boolean;
  end;

  JMovieClip = class external 'MovieClip'(JContainer)
    constructor Create(mode: String; startPosition: Float; loop: Boolean; labels: JObject);
    actionsEnabled: Boolean;
    autoReset: Boolean;
    buildDate: String;
    currentFrame: Float;
    currentLabel: String;
    frameBounds: array of JRectangle;
    framerate: Float;
    INDEPENDENT: String;
    labels: array of JObject;
    loop: Boolean;
    mode: String;
    paused: Boolean;
    SINGLE_FRAME: String;
    startPosition: Float;
    SYNCHED: String;
    timeline: JTimeline;
    version: String;
    procedure advance; overload;
    procedure advance(time: Float); overload;
    function clone: JMovieClip;
    function getCurrentLabel: String;
    function getLabels: array of JObject;
    procedure gotoAndPlay(positionOrLabel: Variant {String or Float});
    procedure gotoAndStop(positionOrLabel: Variant {String or Float});
    procedure play;
    procedure stop;
  end;

  JMovieClipPlugin = class external 'MovieClipPlugin'
    procedure tween(tween: JTween; prop: String; value: Variant {String or Float or Boolean}; startValues: array of Variant; endValues: array of Variant; ratio: Float; wait: JObject; &end: JObject);
  end;

  JPoint = class external 'Point'
    constructor Create(x: Float; y: Float);
    x: Float;
    y: Float;
    function clone: JPoint;
    function copy(point: JPoint): JPoint;
    function setValues: JPoint; overload;
    function setValues(x: Float): JPoint; overload;
    function setValues(x: Float; y: Float): JPoint; overload;
    function toString: String;
  end;

  JRectangle = class external 'Rectangle'
    constructor Create(x: Float; y: Float; width: Float; height: Float);
    height: Float;
    width: Float;
    x: Float;
    y: Float;
    function clone: JRectangle;
    function contains(x: Float; y: Float): Boolean; overload;
    function contains(x: Float; y: Float; width: Float): Boolean; overload;
    function contains(x: Float; y: Float; width: Float; height: Float): Boolean; overload;
    function copy(rectangle: JRectangle): JRectangle;
    function extend(x: Float; y: Float): JRectangle; overload;
    function extend(x: Float; y: Float; width: Float): JRectangle; overload;
    function extend(x: Float; y: Float; width: Float; height: Float): JRectangle; overload;
    function intersection(rect: JRectangle): JRectangle;
    function intersects(rect: JRectangle): Boolean;
    function isEmpty: Boolean;
    function setValues: JRectangle; overload;
    function setValues(x: Float): JRectangle; overload;
    function setValues(x: Float; y: Float): JRectangle; overload;
    function setValues(x: Float; y: Float; width: Float): JRectangle; overload;
    function setValues(x: Float; y: Float; width: Float; height: Float): JRectangle; overload;
    function toString: String;
    function union(rect: JRectangle): JRectangle;
  end;

  JShadow = class external 'Shadow'
    constructor Create(color: String; offsetX: Float; offsetY: Float; blur: Float);
    blur: Float;
    color: String;
    identity: JShadow;
    offsetX: Float;
    offsetY: Float;
    function clone: JShadow;
    function toString: String;
  end;

  JShape = class external 'Shape'(JDisplayObject)
    constructor Create(graphics: JGraphics);
    graphics: JGraphics;
    function clone: JShape; overload;
    function clone(recursive: Boolean): JShape; overload;
    function set(props: JObject): JShape;
    function setTransform: JShape; overload;
    function setTransform(x: Float): JShape; overload;
    function setTransform(x: Float; y: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JShape; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JShape; overload;
  end;

  JSprite = class external 'Sprite'(JDisplayObject)
    constructor Create(spriteSheet: JSpriteSheet; frameOrAnimation: Variant {String or Float});
    currentAnimation: String;
    currentAnimationFrame: Float;
    currentFrame: Float;
    framerate: Float;
    offset: Float;
    paused: Boolean;
    spriteSheet: JSpriteSheet;
    procedure advance; overload;
    procedure advance(time: Float); overload;
    function clone: JSprite;
    function getBounds: JRectangle;
    procedure gotoAndPlay(frameOrAnimation: Variant {String or Float});
    procedure gotoAndStop(frameOrAnimation: Variant {String or Float});
    procedure play;
    function set(props: JObject): JSprite;
    function setTransform: JSprite; overload;
    function setTransform(x: Float): JSprite; overload;
    function setTransform(x: Float; y: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JSprite; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JSprite; overload;
    procedure stop;
  end;

  JSpriteContainer = class external 'SpriteContainer'(JContainer)
    constructor Create(spriteSheet: JSpriteSheet);
    spriteSheet: JSpriteSheet;
  end;

  JSpriteSheet = class external 'SpriteSheet'(JEventDispatcher)
    constructor Create(data: JObject);
    animations: array of String;
    complete: Boolean;
    framerate: Float;
    function clone: JSpriteSheet;
    function getAnimation(name: String): JSpriteSheetAnimation;
    function getAnimations: array of String;
    function getFrame(frameIndex: Float): JSpriteSheetFrame;
    function getFrameBounds(frameIndex: Float): JRectangle; overload;
    function getFrameBounds(frameIndex: Float; rectangle: JRectangle): JRectangle; overload;
    function getNumFrames(animation: String): Float;
  end;

  JSpriteSheetBuilder = class external 'SpriteSheetBuilder'(JEventDispatcher)
    constructor Create;
    maxHeight: Float;
    maxWidth: Float;
    padding: Float;
    progress: Float;
    scale: Float;
    spriteSheet: JSpriteSheet;
    timeSlice: Float;
    procedure addAnimation(name: String; frames: array of Float); overload;
    procedure addAnimation(name: String; frames: array of Float; next: Variant {String or Boolean}); overload;
    procedure addAnimation(name: String; frames: array of Float; next: Variant {String or Boolean}; frequency: Float); overload;
    function addFrame(source: JDisplayObject): Float; overload;
    function addFrame(source: JDisplayObject; sourceRect: JRectangle): Float; overload;
    function addFrame(source: JDisplayObject; sourceRect: JRectangle; scale: Float): Float; overload;
    function addFrame(source: JDisplayObject; sourceRect: JRectangle; scale: Float; setupFunction: : Variant): Float; overload;
    function addFrame(source: JDisplayObject; sourceRect: JRectangle; scale: Float; setupFunction: : Variant; setupData: JObject): Float; overload;
    procedure addMovieClip(source: JMovieClip); overload;
    procedure addMovieClip(source: JMovieClip; sourceRect: JRectangle); overload;
    procedure addMovieClip(source: JMovieClip; sourceRect: JRectangle; scale: Float); overload;
    procedure addMovieClip(source: JMovieClip; sourceRect: JRectangle; scale: Float; setupFunction: : Variant); overload;
    procedure addMovieClip(source: JMovieClip; sourceRect: JRectangle; scale: Float; setupFunction: : Variant; setupData: JObject); overload;
    procedure addMovieClip(source: JMovieClip; sourceRect: JRectangle; scale: Float; setupFunction: : Variant; setupData: JObject; labelFunction: : Variant); overload;
    function build: JSpriteSheet;
    procedure buildAsync; overload;
    procedure buildAsync(timeSlice: Float); overload;
    procedure clone;
    procedure stopAsync;
  end;

  JSpriteSheetUtils = class external 'SpriteSheetUtils'
    procedure addFlippedFrames(spriteSheet: JSpriteSheet); overload;
    procedure addFlippedFrames(spriteSheet: JSpriteSheet; horizontal: Boolean); overload;
    procedure addFlippedFrames(spriteSheet: JSpriteSheet; horizontal: Boolean; vertical: Boolean); overload;
    procedure addFlippedFrames(spriteSheet: JSpriteSheet; horizontal: Boolean; vertical: Boolean; both: Boolean); overload;
    function extractFrame(spriteSheet: JSpriteSheet; frameOrAnimation: Variant {Float or String}): JHTMLImageElement;
    function mergeAlpha(rgbImage: JHTMLImageElement; alphaImage: JHTMLImageElement): JHTMLCanvasElement; overload;
    function mergeAlpha(rgbImage: JHTMLImageElement; alphaImage: JHTMLImageElement; canvas: JHTMLCanvasElement): JHTMLCanvasElement; overload;
  end;

  JSpriteStage = class external 'SpriteStage'(JStage)
    constructor Create(canvas: Variant {JHTMLCanvasElement or String}; preserveDrawingBuffer: Boolean; antialias: Boolean);
    INDICES_PER_BOX: Float;
    isWebGL: Boolean;
    MAX_BOXES_POINTS_INCREMENT: Float;
    MAX_INDEX_SIZE: Float;
    NUM_VERTEX_PROPERTIES: Float;
    NUM_VERTEX_PROPERTIES_PER_BOX: Float;
    POINTS_PER_BOX: Float;
    procedure clearImageTexture(image: JObject);
    procedure updateViewport(width: Float; height: Float);
  end;

  JStage = class external 'Stage'(JContainer)
    constructor Create(canvas: Variant {JHTMLCanvasElement or String or JObject});
    autoClear: Boolean;
    canvas: Variant {JHTMLCanvasElement or JObject};
    drawRect: JRectangle;
    handleEvent: JFunction;
    mouseInBounds: Boolean;
    mouseMoveOutside: Boolean;
    mouseX: Float;
    mouseY: Float;
    nextStage: JStage;
    preventSelection: Boolean;
    snapToPixelEnabled: Boolean;
    tickOnUpdate: Boolean;
    procedure clear;
    function clone: JStage;
    procedure enableDOMEvents; overload;
    procedure enableDOMEvents(enable: Boolean); overload;
    procedure enableMouseOver; overload;
    procedure enableMouseOver(frequency: Float); overload;
    procedure tick; overload;
    procedure tick(props: JObject); overload;
    function toDataURL(backgroundColor: String; mimeType: String): String;
    procedure update(arg: array of Variant);
  end;

  JText = class external 'Text'(JDisplayObject)
    constructor Create(text: String; font: String; color: String);
    color: String;
    font: String;
    lineHeight: Float;
    lineWidth: Float;
    maxWidth: Float;
    outline: Float;
    text: String;
    textAlign: String;
    textBaseline: String;
    function clone: JText;
    function getMeasuredHeight: Float;
    function getMeasuredLineHeight: Float;
    function getMeasuredWidth: Float;
    function getMetrics: JObject;
    function set(props: JObject): JText;
    function setTransform: JText; overload;
    function setTransform(x: Float): JText; overload;
    function setTransform(x: Float; y: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float): JText; overload;
    function setTransform(x: Float; y: Float; scaleX: Float; scaleY: Float; rotation: Float; skewX: Float; skewY: Float; regX: Float; regY: Float): JText; overload;
  end;

  JTicker = class external 'Ticker'
    framerate: Float;
    interval: Float;
    maxDelta: Float;
    paused: Boolean;
    RAF: String;
    RAF_SYNCHED: String;
    TIMEOUT: String;
    timingMode: String;
    useRAF: Boolean;
    function getEventTime: Float; overload;
    function getEventTime(runTime: Boolean): Float; overload;
    function getFPS: Float;
    function getInterval: Float;
    function getMeasuredFPS: Float; overload;
    function getMeasuredFPS(ticks: Float): Float; overload;
    function getMeasuredTickTime: Float; overload;
    function getMeasuredTickTime(ticks: Float): Float; overload;
    function getPaused: Boolean;
    function getTicks: Float; overload;
    function getTicks(pauseable: Boolean): Float; overload;
    function getTime: Float; overload;
    function getTime(runTime: Boolean): Float; overload;
    procedure init;
    procedure reset;
    procedure setFPS(value: Float);
    procedure setInterval(interval: Float);
    procedure setPaused(value: Boolean);
    function addEventListener(&type: String; listener: JStage): JStage; overload;
    function addEventListener(&type: String; listener: JStage; useCapture: Boolean): JStage; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean): JObject; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}): Boolean; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}; target: JObject): Boolean; overload;
    function hasEventListener(&type: String): Boolean;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject)); overload;
    procedure off(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener: JFunction); overload;
    procedure off(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    procedure removeAllEventListeners; overload;
    procedure removeAllEventListeners(&type: String); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject)); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function toString: String;
    function willTrigger(&type: String): Boolean;
  end;

  JTickerEvent = class external 'TickerEvent'
    target: JObject;
    &type: String;
    paused: Boolean;
    delta: Float;
    time: Float;
    runTime: Float;
  end;

  JTouch = class external 'Touch'
    procedure disable(stage: JStage);
    function enable(stage: JStage): Boolean; overload;
    function enable(stage: JStage; singleTouch: Boolean): Boolean; overload;
    function enable(stage: JStage; singleTouch: Boolean; allowDefault: Boolean): Boolean; overload;
    function isSupported: Boolean;
  end;

  JUID = class external 'UID'
    function get: Float;
  end;

  JSpriteSheetAnimation = class external
    frames: array of Float;
    speed: Float;
    name: String;
    next: String;
  end;

  JSpriteSheetFrame = class external
    image: JHTMLImageElement;
    rect: JRectangle;
  end;

//Graphics

type
  JArc = class external 'Arc'
    constructor Create(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float; anticlockwise: Float);
    anticlockwise: Float;
    endAngle: Float;
    radius: Float;
    startAngle: Float;
    x: Float;
    y: Float;
  end;

  JArcTo = class external 'ArcTo'
    constructor Create(x1: Float; y1: Float; x2: Float; y2: Float; radius: Float);
    x1: Float;
    y1: Float;
    x2: Float;
    y2: Float;
    radius: Float;
  end;

  JBeginPath = class external 'BeginPath'
  end;

  JBezierCurveTo = class external 'BezierCurveTo'
    constructor Create(cp1x: Float; cp1y: Float; cp2x: Float; cp2y: Float; x: Float; y: Float);
    cp1x: Float;
    cp1y: Float;
    cp2x: Float;
    cp2y: Float;
    x: Float;
    y: Float;
  end;

  JCircle = class external 'Circle'
    constructor Create(x: Float; y: Float; radius: Float);
    x: Float;
    y: Float;
    radius: Float;
  end;

  JClosePath = class external 'ClosePath'
  end;

  JFill = class external 'Fill'
    constructor Create(style: JObject; matrix: JMatrix2D);
    style: JObject;
    matrix: JMatrix2D;
    function bitmap(image: JHTMLImageElement): JFill; overload;
    function bitmap(image: JHTMLImageElement; repetition: String): JFill; overload;
    function linearGradient(colors: array of Float; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JFill;
    function radialGradient(colors: array of Float; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JFill;
  end;

  JLineTo = class external 'LineTo'
    constructor Create(x: Float; y: Float);
    x: Float;
    y: Float;
  end;

  JMoveTo = class external 'MoveTo'
    constructor Create(x: Float; y: Float);
    x: Float;
    y: Float;
  end;

  JPolyStar = class external 'PolyStar'
    constructor Create(x: Float; y: Float; radius: Float; sides: Float; pointSize: Float; angle: Float);
    angle: Float;
    pointSize: Float;
    radius: Float;
    sides: Float;
    x: Float;
    y: Float;
  end;

  JQuadraticCurveTo = class external 'QuadraticCurveTo'
    constructor Create(cpx: Float; cpy: Float; x: Float; y: Float);
    cpx: Float;
    cpy: Float;
    x: Float;
    y: Float;
  end;

  JRect = class external 'Rect'
    constructor Create(x: Float; y: Float; w: Float; h: Float);
    x: Float;
    y: Float;
    w: Float;
    h: Float;
  end;

  JRoundRect = class external 'RoundRect'
    constructor Create(x: Float; y: Float; w: Float; h: Float; radiusTL: Float; radiusTR: Float; radiusBR: Float; radiusBL: Float);
    x: Float;
    y: Float;
    w: Float;
    h: Float;
    radiusTL: Float;
    radiusTR: Float;
    radiusBR: Float;
    radiusBL: Float;
  end;

  JStroke = class external 'Stroke'
    constructor Create(style: JObject; ignoreScale: Boolean);
    style: JObject;
    ignoreScale: Boolean;
    function bitmap(image: JHTMLImageElement): JStroke; overload;
    function bitmap(image: JHTMLImageElement; repetition: String): JStroke; overload;
    function linearGradient(colors: array of Float; ratios: array of Float; x0: Float; y0: Float; x1: Float; y1: Float): JStroke;
    function radialGradient(colors: array of Float; ratios: array of Float; x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JStroke;
  end;

  JStrokeStyle = class external 'StrokeStyle'
    constructor Create(width: Float; caps: String; joints: Float; miterLimit: Float);
    caps: String;
    joints: String;
    miterLimit: Float;
    width: Float;
  end;

