unit Ember;

interface

type
  JFunction = class external
    function observes(args: array of String): JFunction;
    function observesBefore(args: array of String): JFunction;
    function on(args: array of String): JFunction;
    function property(args: array of String): JFunction;
  end;

  JString = class external
    function camelize: String;
    function capitalize: String;
    function classify: String;
    function dasherize: String;
    function decamelize: String;
    function fmt(args: array of String): String;
    function htmlSafe: Jtype of;
    function loc(args: array of String): String;
    function underscore: String;
    function w: array of String;
  end;

  JArray{<T>} = class external
    procedure constructor(arr: array of Variant);
    procedure activate;
    function addArrayObserver(target: Variant): array of Variant; overload;
    function addArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant; overload;
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function arrayContentDidChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function arrayContentWillChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: Variant): Boolean; overload;
    function clear: array of Variant;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEmber.Enumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEmber.Enumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEmber.Enumerable; adding: JEmber.Enumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEmber.Enumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEmber.Enumerable): Variant;
    function enumerableContentDidChange(removing: JEmber.Enumerable; adding: JEmber.Enumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): array of Variant;
    function enumerableContentWillChange(removing: JEmber.Enumerable; adding: Float): array of Variant;
    function enumerableContentWillChange(removing: Float; adding: JEmber.Enumerable): array of Variant;
    function enumerableContentWillChange(removing: JEmber.Enumerable; adding: JEmber.Enumerable): array of Variant;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: Variant): Boolean; overload;
    function filter(callback: JFunction): array of Variant; overload;
    function filter(callback: JFunction; target: Variant): array of Variant; overload;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction): Variant; overload;
    function find(callback: JFunction; target: Variant): Variant; overload;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function indexOf(&object: Variant): Float; overload;
    function indexOf(&object: Variant; startAt: Float): Float; overload;
    function insertAt(idx: Float; &object: Variant): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    function lastIndexOf(&object: Variant): Float; overload;
    function lastIndexOf(&object: Variant; startAt: Float): Float; overload;
    function map(callback: JFunction): array of Variant; overload;
    function map(callback: JFunction; target: Variant): array of Variant; overload;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function objectAt(idx: Float): Variant;
    function objectsAt(args: array of Float): array of Variant;
    function popObject: Variant;
    function pushObject(obj: Variant): Variant;
    function pushObjects(args: array of Variant): array of Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function removeAt(start: Float; len: Float): Variant;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    procedure replace(idx: Float; amt: Float; objects: array of Variant);
    function reverseObjects: array of Variant;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function setObjects(objects: array of Variant): array of Variant;
    function shiftObject: Variant;
    function slice: array of Variant; overload;
    function slice(beginIndex: Float): array of Variant; overload;
    function slice(beginIndex: Float; endIndex: Float): array of Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: array of Variant;
    function unshiftObject(&object: Variant): Variant;
    function unshiftObjects(objects: array of Variant): array of Variant;
    function without(value: Variant): array of Variant;
    '[]': array of Variant;
    '@each': JEmber.EachProxy;
    Boolean: Boolean;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEmber.Enumerable): array of Variant;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEmber.Enumerable): array of Variant;
    addObserver: JModifyObserver;
    function beginPropertyChanges: array of Variant;
    function cacheFor(keyName: String): Variant;
    function decrementProperty(keyName: String): Float; overload;
    function decrementProperty(keyName: String; decrement: Float): Float; overload;
    function endPropertyChanges: array of Variant;
    function get(keyName: String): Variant;
    function getProperties(args: array of String):     end;;
    function getProperties(keys: array of String):     end;;
    function getWithDefault(keyName: String; defaultValue: Variant): Variant;
    function hasObserverFor(key: String): Boolean;
    function incrementProperty(keyName: String): Float; overload;
    function incrementProperty(keyName: String; increment: Float): Float; overload;
    function notifyPropertyChange(keyName: String): array of Variant;
    function propertyDidChange(keyName: String): array of Variant;
    function propertyWillChange(keyName: String): array of Variant;
    function removeObserver(key: String; target: Variant; method: String): JEmber.Observable;
    function removeObserver(key: String; target: Variant; method: JFunction): JEmber.Observable;
    function set(keyName: String; value: Variant): array of Variant;
    function setProperties(hash:     end;): array of Variant;
    function toggleProperty(keyName: String): Variant;
    function copy(deep: Boolean): array of Variant;
    function frozenCopy: array of Variant;
    function isAny(key: String): Boolean; overload;
    function isAny(key: String; value: String): Boolean; overload;
    function isEvery(key: String): Boolean; overload;
    function isEvery(key: String; value: String): Boolean; overload;
  end;

  JApplicationCreateArguments = class external
    customEvents:     end;; // nullable
    rootElement: String; // nullable
    LOG_TRANSITIONS: Boolean; // nullable
    LOG_TRANSITIONS_INTERNAL: Boolean; // nullable
  end;

  JApplicationInitializerArguments = class external
    name: String; // nullable
    initialize: JApplicationInitializerFunction; // nullable
  end;

  JApplicationInitializerFunction = class external
(container: JEmber.Container; application: JEmber.Application)  end;

  JCoreObjectArguments = class external
    init: JFunction; // nullable
    willDestroy: JFunction; // nullable
    // property Item[propName: String]: Variant;
  end;

  JEnumerableConfigurationOptions = class external
    willChange: Boolean; // nullable
    didChange: Boolean; // nullable
  end;

  JItemIndexEnumerableCallbackTarget = class external
(callback: JItemIndexEnumerableCallback; target: Variant): array of Variant  end;

  JItemIndexEnumerableCallback = class external
(item: Variant; index: Float; enumerable: JEmber.Enumerable)  end;

  JReduceCallback = class external
(previousValue: Variant; item: Variant; index: Float; enumerable: JEmber.Enumerable)  end;

  JTransitionsHash = class external
    contexts: array of Variant;
    exitStates: array of JEmber.State;
    enterStates: array of JEmber.State;
    resolveState: JEmber.State;
  end;

  JActionsHash = class external
    willTransition: JFunction; // nullable
    error: JFunction; // nullable
  end;

  JDisconnectOutletOptions = class external
    outlet: String; // nullable
    parentView: String; // nullable
  end;

  JRenderOptions = class external
    into: String; // nullable
    controller: String; // nullable
    model: Variant; // nullable
    outlet: String; // nullable
    view: String; // nullable
  end;

  JModifyObserver = class external
(obj: Variant; path: String; target: Variant; method: JFunction)(obj: Variant; path: String; target: Variant; method: String)(obj: Variant; path: String; func: JFunction; method: JFunction)(obj: Variant; path: String; func: JFunction; method: String)  end;

Handlebars: JHandlebarsStatic;
//EmberStates

type
  JTransition = class external
    targetName: String;
    urlMethod: String;
    intent: Variant;
    params: Variant {    end; or Variant};
    pivotHandler: Variant;
    resolveIndex: Float;
    handlerInfos: Variant;
    resolvedModels: Variant {    end; or Variant};
    isActive: Boolean;
    state: Variant;
    queryParams: Variant {    end; or Variant};
    queryParamsOnly: Boolean;
    isTransition: Boolean;
    promise: JEmber.RSVP.Promise;
    data: Variant;
    function then(onFulfilled: JFunction): JEmber.RSVP.Promise; overload;
    function then(onFulfilled: JFunction; onRejected: JFunction): JEmber.RSVP.Promise; overload;
    function then(onFulfilled: JFunction; onRejected: JFunction; &label: String): JEmber.RSVP.Promise; overload;
    function catch(onRejection: JFunction): JEmber.RSVP.Promise; overload;
    function catch(onRejection: JFunction; &label: String): JEmber.RSVP.Promise; overload;
    function finally(callback: JFunction): JEmber.RSVP.Promise; overload;
    function finally(callback: JFunction; &label: String): JEmber.RSVP.Promise; overload;
    function abort: JEmberStates.Transition;
    procedure normalize(manager: JEmber.StateManager; contexts: array of Variant);
    function retry: JEmberStates.Transition;
    function method(method: String): JEmberStates.Transition;
    procedure trigger(ignoreFailure: Boolean; eventName: String);
    procedure trigger(eventName: String);
    function followRedirects: JEmber.RSVP.Promise;
  end;

//EmberTesting

//Test

type
  JAdapter = class external 'Adapter'
    procedure asyncEnd;
    procedure asyncStart;
    procedure exception(error: String);
  end;

  JQUnitAdapter = class external 'QUnitAdapter'(JAdapter)
  end;

//Ember

type
  JActionHandlerMixin = class external 'ActionHandlerMixin'
    procedure send(name: String; args: array of Variant);
    actions: JActionsHash;
  end;

  JApplication = class external 'Application'(JNamespace)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure initializer; overload;
    procedure initializer(args: JApplicationInitializerArguments); overload;
    procedure advanceReadiness;
    procedure deferReadiness;
    procedure inject(factoryNameOrType: String; &property: String; injectionName: String);
    procedure injectTestHelpers;
    procedure register(fullName: String; factory: JFunction); overload;
    procedure register(fullName: String; factory: JFunction; options:     end;); overload;
    procedure removeTestHelpers;
    procedure reset;
    procedure setupForTesting;
    customEvents:     end;;
    eventDispatcher: JEventDispatcher;
    resolver: JDefaultResolver;
    rootElement: JHTMLElement;
    ready: JFunction;
    Router: JRouter;
  end;

  JArray = class external 'Array'
    function addArrayObserver(target: Variant): array of Variant; overload;
    function addArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant; overload;
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function arrayContentDidChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function arrayContentWillChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction): Variant; overload;
    function find(callback: JFunction; target: Variant): Variant; overload;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function indexOf(&object: Variant; startAt: Float): Float;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    function lastIndexOf(&object: Variant; startAt: Float): Float;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function objectAt(idx: Float): Variant;
    function objectsAt(args: array of Float): array of Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function slice: array of Variant; overload;
    function slice(beginIndex: Float): array of Variant; overload;
    function slice(beginIndex: Float; endIndex: Float): array of Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function without(value: Variant): JEnumerable;
    '@each': JEachProxy;
    Boolean: Boolean;
    '[]': array of Variant;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    _length: Float;
  end;

  JArrayController = class external 'ArrayController'(JArrayProxy)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function lookupItemController(&object: Variant): String;
    arrangedContent: Variant;
    itemController: String;
    sortAscending: Boolean;
    sortFunction: JComparable;
    sortProperties: array of Variant;
    procedure replaceRoute(name: String; args: array of Variant);
    procedure transitionToRoute(name: String; args: array of Variant);
    controllers:     end;;
    needs: array of String;
    target: Variant;
    model: Variant;
    queryParams: Variant;
    procedure send(name: String; args: array of Variant);
    actions:     end;;
  end;

  JArrayProxy = class external 'ArrayProxy'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function addArrayObserver(target: Variant): array of Variant; overload;
    function addArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant; overload;
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function arrayContentDidChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function arrayContentWillChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function clear: array of Variant;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function indexOf(&object: Variant; startAt: Float): Float;
    function insertAt(idx: Float; &object: Variant): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    function lastIndexOf(&object: Variant; startAt: Float): Float;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function objectAt(idx: Float): Variant;
    function objectAtContent(idx: Float): Variant;
    function objectsAt(args: array of Float): array of Variant;
    function popObject: Variant;
    function pushObject(obj: Variant): Variant;
    function pushObjects(args: array of Variant): array of Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function removeAt(start: Float; len: Float): Variant;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function replace(idx: Float; amt: Float; objects: array of Variant): Variant;
    procedure replaceContent(idx: Float; amt: Float; objects: array of Variant);
    function reverseObjects: array of Variant;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function setObjects(objects: array of Variant): array of Variant;
    function shiftObject: Variant;
    function slice: array of Variant; overload;
    function slice(beginIndex: Float): array of Variant; overload;
    function slice(beginIndex: Float; endIndex: Float): array of Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function unshiftObject(&object: Variant): Variant;
    function unshiftObjects(objects: array of Variant): array of Variant;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    '@each': JEachProxy;
    Boolean: Boolean;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    _length: Float;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JMutableEnumberable;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JMutableEnumberable;
  end;

  JBinding = class external 'Binding'
    constructor Create(toPath: String; fromPath: String);
    function connect(obj: Variant): JBinding;
    function copy: JBinding;
    function disconnect(obj: Variant): JBinding;
    function from(path: String): JBinding;
    function oneWay(from: String): JBinding; overload;
    function oneWay(from: String; flag: Boolean): JBinding; overload;
    function to(path: String): JBinding;
    function to(pathTuple: array of Variant): JBinding;
    function toString: String;
  end;

  JButton = class external 'Button'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function triggerAction(opts:     end;): Boolean;
  end;

  JCheckbox = class external 'Checkbox'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JCollectionView = class external 'CollectionView'(JContainerView)
    procedure arrayDidChange(content: array of Variant; start: Float; removed: Float; added: Float);
    procedure arrayWillChange(content: array of Variant; start: Float; removed: Float);
    function createChildView(viewClass:     end;): JCollectionView; overload;
    function createChildView(viewClass:     end;; attrs:     end;): JCollectionView; overload;
    function destroy: JCollectionView;
    procedure init;
    CONTAINER_MAP:     end;;
    content: array of Variant;
    emptyView: JView;
    itemViewClass: JView;
  end;

  JComparable = class external 'Comparable'
    function compare(a: Variant; b: Variant): Float;
  end;

  JComponent = class external 'Component'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure sendAction(action: String; context: Variant);
    targetObject: JController;
  end;

  JComputedProperty = class external 'ComputedProperty'
    function cacheable: JComputedProperty; overload;
    function cacheable(aFlag: Boolean): JComputedProperty; overload;
    function get(keyName: String): Variant;
    function meta(meta:     end;): JComputedProperty;
    function property(args: array of String): JComputedProperty;
    function readOnly: JComputedProperty;
    function set(keyName: String; newValue: Variant; oldValue: String): Variant;
    function volatile: JComputedProperty;
  end;

  JContainer = class external 'Container'
    constructor Create(parent: JContainer);
    parent: JContainer;
    children: array of Variant;
    resolver: JFunction;
    registry:     end;;
    cache:     end;;
    typeInjections:     end;;
    injections:     end;;
    function child: JContainer;
    procedure set(&object:     end;; key: String; value: Variant);
    procedure register(fullName: String; factory: JFunction); overload;
    procedure register(fullName: String; factory: JFunction; options:     end;); overload;
    procedure unregister(fullName: String);
    function resolve(fullName: String): JFunction;
    function describe(fullName: String): String;
    function normalize(fullName: String): String;
    function makeToString(factory: Variant; fullName: String): JFunction;
    function lookup(fullName: String): Variant; overload;
    function lookup(fullName: String; options:     end;): Variant; overload;
    function lookupFactory(fullName: String): Variant;
    function has(fullName: String): Boolean;
    procedure optionsForType(&type: String; options:     end;);
    procedure options(&type: String; options:     end;);
    procedure injection(factoryName: String; &property: String; injectionName: String);
    procedure factoryInjection(factoryName: String; &property: String; injectionName: String);
    procedure destroy;
    procedure reset;
  end;

  JContainerView = class external 'ContainerView'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JController = class external 'Controller'(JObject)
    procedure replaceRoute(name: String; args: array of Variant);
    procedure transitionToRoute(name: String; args: array of Variant);
    controllers:     end;;
    model: Variant;
    needs: array of String;
    queryParams: Variant;
    target: Variant;
    procedure send(name: String; args: array of Variant);
    actions: JActionsHash;
  end;

  JControllerMixin = class external 'ControllerMixin'(JActionHandlerMixin)
    procedure replaceRoute(name: String; args: array of Variant);
    procedure transitionToRoute(name: String; args: array of Variant);
    controllers:     end;;
    model: Variant;
    needs: array of String;
    queryParams: Variant;
    target: Variant;
  end;

  JCopyable = class external 'Copyable'
    function copy(deep: Boolean): JCopyable;
    function frozenCopy: JCopyable;
  end;

  JCoreObject = class external 'CoreObject'
    procedure init;
    concatenatedProperties: array of Variant;
    isDestroyed: Boolean;
    isDestroying: Boolean;
    function destroy: JCoreObject;
    procedure willDestroy;
    function toString: String;
    isClass: Boolean;
    isMethod: Boolean;
    function extend: JT; overload;
    function extend(args: JCoreObjectArguments): JT; overload;
    function extend: JT; overload;
    function extend(mixins: JMixin): JT; overload;
    function extend(mixins: JMixin; args: JCoreObjectArguments): JT; overload;
    function extend: JT; overload;
    function extend(args: JCoreObjectArguments): JT; overload;
    function extend: JT; overload;
    function extend(mixins: JMixin): JT; overload;
    function extend(mixins: JMixin; args: JCoreObjectArguments): JT; overload;
    function createWithMixins: JT; overload;
    function createWithMixins(args:     end;): JT; overload;
    function create: JT; overload;
    function create(args:     end;): JT; overload;
    function reopen: JT; overload;
    function reopen(args:     end;): JT; overload;
    function reopenClass: JT; overload;
    function reopenClass(args:     end;): JT; overload;
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    function metaForProperty(key: String):     end;;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
  end;

  JCoreView = class external 'CoreView'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure send(name: String; args: array of Variant);
    actions: JActionsHash;
    parentView: JCoreView;
  end;

  JDAG = class external 'DAG'
    function add(name: String): Variant;
    procedure map(name: String; value: Variant);
    procedure addEdge(fromName: String; toName: String);
    procedure topsort(fn: JFunction);
    procedure addEdges(name: String; value: Variant; before: Variant; after: Variant);
    names: array of Variant;
    vertices:     end;;
  end;

  JDefaultResolver = class external 'DefaultResolver'
    function resolve(fullName: String):     end;;
    namespace: JApplication;
  end;

  JDeferred = class external 'Deferred'
    procedure reject(value: Variant);
    procedure resolve(value: Variant);
    procedure then(resolve: JFunction; reject: JFunction);
  end;

  JDeferredMixin = class external 'DeferredMixin'(JMixin)
    procedure reject(value: Variant);
    procedure resolve(value: Variant);
    procedure then(resolve: JFunction; reject: JFunction);
  end;

  JDescriptor = class external 'Descriptor'
  end;

  JEachProxy = class external 'EachProxy'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function unknownProperty(keyName: String; value: Variant): array of Variant;
  end;

  JEnumerable = class external 'Enumerable'
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
  end;

  JEventDispatcher = class external 'EventDispatcher'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    events:     end;;
  end;

  JEvented = class external 'Evented'
    function has(name: String): Boolean;
    function off(name: String; target: Variant; method: JFunction): JEvented;
    function on(name: String; target: Variant; method: JFunction): JEvented;
    function one(name: String; target: Variant; method: JFunction): JEvented;
    procedure trigger(name: String; args: array of String);
  end;

  JFreezable = class external 'Freezable'
    function freeze: JFreezable;
    isFrozen: Boolean;
  end;

  JHashLocation = class external 'HashLocation'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JHistoryLocation = class external 'HistoryLocation'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    rootURL: String;
  end;

  JInstrumentation = class external 'Instrumentation'
    function getProperties(obj: Variant; list: array of Variant):     end;;
    function getProperties(obj: Variant; args: array of String):     end;;
    procedure instrument(name: String; payload: Variant; callback: JFunction; binding: Variant);
    procedure reset;
    procedure subscribe(pattern: String; &object: Variant);
    procedure unsubscribe(subscriber: Variant);
  end;

  JLinkView = class external 'LinkView'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure init;
    active: Variant;
    activeClass: String;
    attributeBindings: Variant;
    classNameBindings: array of String;
    disabled: Variant;
    disabledClass: String;
    eventName: String;
    href: Variant;
    loading: Variant;
    loadingClass: String;
    loadingHref: String;
    rel: Variant;
    replace: Boolean;
    title: Variant;
    click: JFunction;
  end;

  JLocation = class external 'Location'
    function create: Variant; overload;
    function create(options:     end;): Variant; overload;
    procedure registerImplementation(name: String; implementation: Variant);
  end;

  JMap = class external 'Map'
    function copy: JMap;
    function create: JMap;
    procedure forEach(callback: JFunction; self: Variant);
    function get(key: Variant): Variant;
    function has(key: Variant): Boolean;
    function remove(key: Variant): Boolean;
    procedure set(key: Variant; value: Variant);
    _length: Float;
  end;

  JMapWithDefault = class external 'MapWithDefault'(JMap)
    function copy: JMapWithDefault;
    function create: JMapWithDefault;
  end;

  JMixin = class external 'Mixin'
    function apply(obj: Variant): Variant;
    function create(args: array of JCoreObjectArguments): JT;
    function detect(obj: Variant): Boolean;
    function reopen: JT; overload;
    function reopen(args:     end;): JT; overload;
  end;

  JMutableArray = class external 'MutableArray'
    function addArrayObserver(target: Variant): array of Variant; overload;
    function addArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant; overload;
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function arrayContentDidChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function arrayContentWillChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function clear: array of Variant;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function indexOf(&object: Variant; startAt: Float): Float;
    function insertAt(idx: Float; &object: Variant): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    function lastIndexOf(&object: Variant; startAt: Float): Float;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function objectAt(idx: Float): Variant;
    function objectsAt(args: array of Float): array of Variant;
    function popObject: Variant;
    function pushObject(obj: Variant): Variant;
    function pushObjects(args: array of Variant): array of Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function removeAt(start: Float; len: Float): Variant;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function replace(idx: Float; amt: Float; objects: array of Variant): Variant;
    function reverseObjects: array of Variant;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function setObjects(objects: array of Variant): array of Variant;
    function shiftObject: Variant;
    function slice: array of Variant; overload;
    function slice(beginIndex: Float): array of Variant; overload;
    function slice(beginIndex: Float; endIndex: Float): array of Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function unshiftObject(&object: Variant): Variant;
    function unshiftObjects(objects: array of Variant): array of Variant;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    '@each': JEachProxy;
    Boolean: Boolean;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    _length: Float;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JMutableEnumberable;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JMutableEnumberable;
  end;

  JMutableEnumberable = class external 'MutableEnumberable'
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JMutableEnumberable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JMutableEnumberable;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
  end;

  JNamespace = class external 'Namespace'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JNativeArray = class external 'NativeArray'
    constructor Create(arr: array of Variant);
    procedure activate;
    function addArrayObserver(target: Variant): array of Variant; overload;
    function addArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant; overload;
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function arrayContentDidChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function arrayContentWillChange(startIdx: Float; removeAmt: Float; addAmt: Float): array of Variant;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: Variant): Boolean; overload;
    function clear: array of Variant;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: Variant): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function indexOf(&object: Variant; startAt: Float): Float;
    function insertAt(idx: Float; &object: Variant): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    function lastIndexOf(&object: Variant; startAt: Float): Float;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function objectAt(idx: Float): Variant;
    function objectsAt(args: array of Float): array of Variant;
    function popObject: Variant;
    function pushObject(obj: Variant): Variant;
    function pushObjects(args: array of Variant): array of Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeArrayObserver(target: Variant; opts: JEnumerableConfigurationOptions): array of Variant;
    function removeAt(start: Float; len: Float): Variant;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function replace(idx: Float; amt: Float; objects: array of Variant): Variant;
    function reverseObjects: array of Variant;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function setObjects(objects: array of Variant): array of Variant;
    function shiftObject: Variant;
    function slice: array of Variant; overload;
    function slice(beginIndex: Float): array of Variant; overload;
    function slice(beginIndex: Float; endIndex: Float): array of Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function unshiftObject(&object: Variant): Variant;
    function unshiftObjects(objects: array of Variant): array of Variant;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    '@each': JEachProxy;
    Boolean: Boolean;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    _length: Float;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JMutableEnumberable;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JMutableEnumberable;
    addObserver: JModifyObserver;
    function beginPropertyChanges: JObservable;
    function cacheFor(keyName: String): Variant;
    function decrementProperty(keyName: String): Float; overload;
    function decrementProperty(keyName: String; decrement: Float): Float; overload;
    function endPropertyChanges: JObservable;
    function get(keyName: String): Variant;
    function getProperties(args: array of String):     end;;
    function getProperties(keys: array of String):     end;;
    function getWithDefault(keyName: String; defaultValue: Variant): Variant;
    function hasObserverFor(key: String): Boolean;
    function incrementProperty(keyName: String): Float; overload;
    function incrementProperty(keyName: String; increment: Float): Float; overload;
    function notifyPropertyChange(keyName: String): JObservable;
    function propertyDidChange(keyName: String): JObservable;
    function propertyWillChange(keyName: String): JObservable;
    procedure removeObserver(key: String; target: Variant; method: String);
    procedure removeObserver(key: String; target: Variant; method: JFunction);
    function set(keyName: String; value: Variant): JObservable;
    function setProperties(hash:     end;): JObservable;
    function toggleProperty(keyName: String): Variant;
    function copy(deep: Boolean): JCopyable;
    function frozenCopy: JCopyable;
  end;

  JNoneLocation = class external 'NoneLocation'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JObject = class external 'Object'(JCoreObject)
    addObserver: JModifyObserver;
    function beginPropertyChanges: JObservable;
    function cacheFor(keyName: String): Variant;
    function decrementProperty(keyName: String): Float; overload;
    function decrementProperty(keyName: String; decrement: Float): Float; overload;
    function endPropertyChanges: JObservable;
    function get(keyName: String): Variant;
    function get(keyName: String): JT;
    function getProperties(args: array of String):     end;;
    function getProperties(keys: array of String):     end;;
    function getWithDefault(keyName: String; defaultValue: Variant): Variant;
    function hasObserverFor(key: String): Boolean;
    function incrementProperty(keyName: String): Float; overload;
    function incrementProperty(keyName: String; increment: Float): Float; overload;
    function notifyPropertyChange(keyName: String): JObservable;
    function propertyDidChange(keyName: String): JObservable;
    function propertyWillChange(keyName: String): JObservable;
    function removeObserver(key: String; target: Variant; method: String): JObservable;
    function removeObserver(key: String; target: Variant; method: JFunction): JObservable;
    function set(keyName: String; value: Variant): JObservable;
    function setProperties(hash:     end;): JObservable;
    function toggleProperty(keyName: String): Variant;
  end;

  JObjectController = class external 'ObjectController'(JObjectProxy)
    procedure replaceRoute(name: String; args: array of Variant);
    procedure transitionToRoute(name: String; args: array of Variant);
    controllers: JObject;
    needs: array of String;
    target: Variant;
    model: Variant;
    queryParams: Variant;
    procedure send(name: String; args: array of Variant);
    actions:     end;;
  end;

  JObjectProxy = class external 'ObjectProxy'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    content: JObject;
  end;

  JObservable = class external 'Observable'
    addObserver: JModifyObserver;
    function beginPropertyChanges: JObservable;
    function cacheFor(keyName: String): Variant;
    function decrementProperty(keyName: String): Float; overload;
    function decrementProperty(keyName: String; decrement: Float): Float; overload;
    function endPropertyChanges: JObservable;
    function get(keyName: String): Variant;
    function getProperties(args: array of String):     end;;
    function getProperties(keys: array of String):     end;;
    function getWithDefault(keyName: String; defaultValue: Variant): Variant;
    function hasObserverFor(key: String): Boolean;
    function incrementProperty(keyName: String): Float; overload;
    function incrementProperty(keyName: String; increment: Float): Float; overload;
    function notifyPropertyChange(keyName: String): JObservable;
    function propertyDidChange(keyName: String): JObservable;
    function propertyWillChange(keyName: String): JObservable;
    procedure removeObserver(key: String; target:     end;; method: String);
    procedure removeObserver(key: String; target:     end;; method: JFunction);
    function set(keyName: String; value: Variant): JObservable;
    function setProperties(hash:     end;): JObservable;
    function toggleProperty(keyName: String): Boolean;
  end;

  JOrderedSet = class external 'OrderedSet'
    procedure add(obj: Variant);
    procedure clear;
    function copy: JOrderedSet;
    function create: JOrderedSet;
    procedure forEach(fn: JFunction; self: Variant);
    function has(obj: Variant): Boolean;
    function isEmpty: Boolean;
    procedure remove(obj: Variant);
    function toArray: array of Variant;
  end;

  JRenderBuffer = class external 'RenderBuffer'
    function addClass(className: String): JRenderBuffer;
    function attr(name: String; value: Variant): Variant;
    function element: JHTMLElement;
    function id(id: String): JRenderBuffer;
    function prop(name: String; value: String): Variant;
    function push(&string: String): JRenderBuffer;
    function removeAttr(name: String): JRenderBuffer;
    function removeProp(name: String): JRenderBuffer;
    function string: String;
    function style(name: String; value: String): JRenderBuffer;
    classes: array of Variant;
    elementAttributes:     end;;
    elementId: String;
    elementProperties:     end;;
    elementStyle:     end;;
    elementTag: String;
    parentBuffer: JRenderBuffer;
  end;

  JRoute = class external 'Route'(JObject)
    isClass: Boolean;
    isMethod: Boolean;
    activate: JFunction;
    function afterModel(resolvedModel: Variant; transition: JEmberStates.Transition): JRSVP.Promise;
    function beforeModel(transition: JEmberStates.Transition): JRSVP.Promise;
    controller: JController;
    function controllerFor(name: String): JController;
    controllerName: String;
    deactivate: JFunction;
    function deserializeQueryParam(value: Variant; urlKey: String; defaultValueType: String): Variant;
    procedure disconnectOutlet(options: Variant {JDisconnectOutletOptions or String});
    function findModel(&type: String; value: Variant): Variant;
    function generateController(name: String; model:     end;): JController;
    procedure intermediateTransitionTo(name: String; models: array of Variant);
    function model(params:     end;; transition: JEmberStates.Transition): Variant {Variant or JRSVP.Promise};
    function modelFor(name: String):     end;;
    function paramsFor(name: String): Variant;
    queryParams:     end;;
    function redirect: JEmberStates.Transition;
    function refresh: JEmberStates.Transition;
    procedure render(name: String); overload;
    procedure render(name: String; options: JRenderOptions); overload;
    procedure renderTemplate(controller: JController; model:     end;);
    procedure replaceWith(name: String; models: array of Variant);
    procedure resetController(controller: JEmber.Controller; isExiting: Boolean; transition: Variant);
    function serialize(model:     end;; params: array of String): String;
    function serializeQueryParam(value: Variant; urlKey: String; defaultValueType: String): String;
    function serializeQueryParamKey(controllerPropertyName: String): String;
    procedure setupController(controller: JController; model:     end;);
    function store(store: Variant): Variant;
    templateName: String;
    function transitionTo(name: String; &object: array of Variant): JEmberStates.Transition;
    viewName: String;
    procedure send(name: String; args: array of Variant);
    actions: JActionsHash;
    function on(name: String; target: Variant; method: JFunction): JEvented;
    function one(name: String; target: Variant; method: JFunction): JEvented;
    procedure trigger(name: String; args: array of String);
    function off(name: String; target: Variant; method: JFunction): JEvented;
    function has(name: String): Boolean;
  end;

  JRouter = class external 'Router'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function map(callback: JFunction): JRouter;
  end;

  JRouterDSL = class external 'RouterDSL'
    procedure resource(name: String); overload;
    procedure resource(name: String; options:     end;); overload;
    procedure resource(name: String; options:     end;; callback: JFunction); overload;
    procedure resource(name: String; callback: JFunction);
    procedure route(name: String); overload;
    procedure route(name: String; options:     end;); overload;
  end;

  JSelect = class external 'Select'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    content: array of Variant;
    groupView: JView;
    multiple: Boolean;
    optionGroupPath: String;
    optionLabelPath: String;
    optionValuePath: String;
    optionView: JView;
    prompt: String;
    selection: Variant;
    value: String;
  end;

  JSelectOption = class external 'SelectOption'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
  end;

  JSet = class external 'Set'(JCoreObject)
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JSet;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JSet;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JSet;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JSet;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JSet;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JSet;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JSet;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JSet;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JSet;
    function without(value: Variant): JSet;
    '[]': array of Variant;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    function copy(deep: Boolean): JSet;
    function frozenCopy: JSet;
    function freeze: JSet;
    isFrozen: Boolean;
    function add(obj: Variant): JSet;
    function addEach(args: array of Variant): JSet;
    function clear: JSet;
    function isEqual(obj: JSet): Boolean;
    function pop: Variant;
    function push(obj: Variant): JSet;
    function remove(obj: Variant): JSet;
    function removeEach(args: array of Variant): JSet;
    function shift: Variant;
    function unshift(obj: Variant): JSet;
    _length: Float;
  end;

  JSortableMixin = class external 'SortableMixin'
    function addEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function addObject(&object: Variant): Variant;
    function addObjects(objects: JEnumerable): JMutableEnumberable;
    function any(callback: JFunction): Boolean; overload;
    function any(callback: JFunction; target: Variant): Boolean; overload;
    function anyBy(key: String): Boolean; overload;
    function anyBy(key: String; value: String): Boolean; overload;
    function someProperty(key: String): Boolean; overload;
    function someProperty(key: String; value: String): Boolean; overload;
    function compact: array of Variant;
    function contains(obj: Variant): Boolean;
    function enumerableContentDidChange(start: Float; removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(start: Float; removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(start: Float; removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: Float; adding: Float): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: Float): Variant;
    function enumerableContentDidChange(removing: Float; adding: JEnumerable): Variant;
    function enumerableContentDidChange(removing: JEnumerable; adding: JEnumerable): Variant;
    function enumerableContentWillChange(removing: Float; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: Float): JEnumerable;
    function enumerableContentWillChange(removing: Float; adding: JEnumerable): JEnumerable;
    function enumerableContentWillChange(removing: JEnumerable; adding: JEnumerable): JEnumerable;
    function every(callback: JFunction): Boolean; overload;
    function every(callback: JFunction; target: Variant): Boolean; overload;
    function everyBy(key: String): Boolean; overload;
    function everyBy(key: String; value: String): Boolean; overload;
    function everyProperty(key: String): Boolean; overload;
    function everyProperty(key: String; value: String): Boolean; overload;
    function filter(callback: JFunction; target: Variant): array of Variant;
    function filterBy(key: String): array of Variant; overload;
    function filterBy(key: String; value: String): array of Variant; overload;
    function find(callback: JFunction; target: Variant): Variant;
    function findBy(key: String): Variant; overload;
    function findBy(key: String; value: String): Variant; overload;
    function forEach(callback: JFunction): Variant; overload;
    function forEach(callback: JFunction; target: Variant): Variant; overload;
    function getEach(key: String): array of Variant;
    function invoke(methodName: String; args: array of Variant): array of Variant;
    map: JItemIndexEnumerableCallbackTarget;
    function mapBy(key: String): array of Variant;
    function nextObject(index: Float; previousObject: Variant; context: Variant): Variant;
    function reduce(callback: JReduceCallback; initialValue: Variant; reducerProperty: String): Variant;
    reject: JItemIndexEnumerableCallbackTarget;
    function rejectBy(key: String): array of Variant; overload;
    function rejectBy(key: String; value: String): array of Variant; overload;
    function removeEnumerableObserver(target: Variant; opts: JEnumerableConfigurationOptions): JEnumerable;
    function removeObject(&object: Variant): Variant;
    function removeObjects(objects: JEnumerable): JMutableEnumberable;
    function setEach(key: String): Variant; overload;
    function setEach(key: String; value: Variant): Variant; overload;
    function some(callback: JFunction): Boolean; overload;
    function some(callback: JFunction; target: Variant): Boolean; overload;
    function toArray: array of Variant;
    function uniq: JEnumerable;
    function without(value: Variant): JEnumerable;
    '[]': array of Variant;
    arrangedContent: Variant;
    firstObject: Variant;
    hasEnumerableObservers: Boolean;
    lastObject: Variant;
    sortAscending: Boolean;
    sortFunction: JComparable;
    sortProperties: array of Variant;
  end;

  JState = class external 'State'(JObject)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function has(name: String): Boolean;
    function off(name: String; target: Variant; method: JFunction): JState;
    function on(name: String; target: Variant; method: JFunction): JState;
    function one(name: String; target: Variant; method: JFunction): JState;
    procedure trigger(name: String; args: array of String);
    function getPathsCache(stateManager:     end;; path: String):     end;;
    procedure init;
    procedure setPathsCache(stateManager:     end;; path: String; transitions: Variant);
    procedure transitionTo(target: String);
    hasContext: Boolean;
    isLeaf: Boolean;
    name: String;
    parentState: JState;
    path: String;
    enter: JFunction;
    exit: JFunction;
    setup: JFunction;
  end;

  JStateManager = class external 'StateManager'(JState)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function contextFreeTransition(currentState: JState; path: String): JTransitionsHash;
    procedure enterState(transition: JTransitionsHash);
    function getState(name: String): JState;
    function getStateByPath(root: JState; path: String): JState;
    function getStateMeta(state: JState; key: String): Variant;
    function getStatesInPath(root: JState; path: String): array of JState;
    procedure goToState(path: String; context: Variant);
    procedure send(event: String);
    function setStateMeta(state: JState; key: String; value: Variant): Variant;
    function stateMetaFor(state: JState):     end;;
    procedure transitionTo(path: String; context: Variant);
    procedure triggerSetupContext(transitions: JTransitionsHash);
    function unhandledEvent(manager: JStateManager; event: String): Variant;
    currentPath: String;
    currentState: JState;
    errorOnUnhandledEvents: Boolean;
    transitionEvent: String;
  end;

  JTargetActionSupport = class external 'TargetActionSupport'
    function triggerAction(opts:     end;): Boolean;
  end;

  JTest = class external 'Test'
    function click(selector: String): JRSVP.Promise;
    function fillin(selector: String; text: String): JRSVP.Promise;
    function find(selector: String): JJQuery;
    function findWithAssert(selector: String): JJQuery;
    procedure injectTestHelpers;
    function keyEvent(selector: String; &type: String; keyCode: Float): JRSVP.Promise;
    procedure oninjectHelpers(callback: JFunction);
    function promise(resolver: JFunction): JRSVP.Promise;
    procedure registerHelper(name: String; helperMethod: JFunction);
    procedure removeTestHelpers;
    procedure setupForTesting;
    procedure unregisterHelper(name: String);
    function visit(url: String): JRSVP.Promise;
    function wait(value: Variant): JRSVP.Promise;
    adapter: JObject;
    testHelpers:     end;;
  end;

  JTextArea = class external 'TextArea'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure cancel(event: JFunction);
    procedure focusIn(event: JFunction);
    procedure focusOut(event: JFunction);
    procedure insertNewLine(event: JFunction);
    procedure keyPress(event: JFunction);
    action: String;
    bubbles: Boolean;
    onEvent: String;
  end;

  JTextField = class external 'TextField'(JView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    procedure cancel(event: JFunction);
    procedure focusIn(event: JFunction);
    procedure focusOut(event: JFunction);
    procedure insertNewLine(event: JFunction);
    procedure keyPress(event: JFunction);
    action: String;
    bubbles: Boolean;
    onEvent: String;
    pattern: String;
    size: String;
    &type: String;
    value: String;
  end;

  JTextSupport = class external 'TextSupport'
    procedure cancel(event: JFunction);
    procedure focusIn(event: JFunction);
    procedure focusOut(event: JFunction);
    procedure insertNewLine(event: JFunction);
    procedure keyPress(event: JFunction);
    action: String;
    bubbles: Boolean;
    onEvent: String;
  end;

  JView = class external 'View'(JCoreView)
    function detect(obj: Variant): Boolean;
    function detectInstance(obj: Variant): Boolean;
    procedure eachComputedProperty(callback: JFunction; binding:     end;);
    function metaForProperty(key: String):     end;;
    isClass: Boolean;
    isMethod: Boolean;
    function $: JJQuery;
    function append: JView;
    function appendTo(A: String): JView;
    function appendTo(A: JHTMLElement): JView;
    function appendTo(A: JJQuery): JView;
    function createChildView(viewClass:     end;): JView; overload;
    function createChildView(viewClass:     end;; attrs:     end;): JView; overload;
    function createChildView(viewClass: String): JView; overload;
    function createChildView(viewClass: String; attrs:     end;): JView; overload;
    function createElement: JView;
    function destroy: JView;
    function destroyElement: JView;
    function findElementInParentElement(parentElement: JHTMLElement): JHTMLElement;
    function remove: JView;
    function removeAllChildren: JView;
    function removeChild(view: JView): JView;
    function removeFromParent: JView;
    procedure render(buffer: JRenderBuffer);
    function replaceIn(A: String): JView;
    function replaceIn(A: JHTMLElement): JView;
    function replaceIn(A: JJQuery): JView;
    procedure rerender;
    ariaRole: String;
    attributeBindings: Variant;
    classNameBindings: array of String;
    classNames: array of String;
    context: Variant;
    controller: Variant;
    element: JHTMLElement;
    isView: Boolean;
    isVisible: Boolean;
    layout: JFunction;
    layoutName: String;
    nearestChildOf: JView;
    nearestOfType: JView;
    nearestWithProperty: JView;
    tagName: String;
    template: JFunction;
    templateName: String;
    templates:     end;;
    views:     end;;
    didInsertElement: JFunction;
    parentViewDidChange: JFunction;
    willClearRender: JFunction;
    willDestroyElement: JFunction;
    willInsertElement: JFunction;
  end;

  JViewTargetActionSupport = class external 'ViewTargetActionSupport'(JMixin)
    target: Variant;
    actionContext: Variant;
  end;

//Handlebars

type
  Jhelpers = class external 'helpers'
    procedure action(actionName: String; context: Variant); overload;
    procedure action(actionName: String; context: Variant; options:     end;); overload;
    function bindAttr: String; overload;
    function bindAttr(options:     end;): String; overload;
    procedure connectOutlet(outletName: String; view:     end;);
    function control(path: String; modelPath: String): String; overload;
    function control(path: String; modelPath: String; options:     end;): String; overload;
    procedure debugger(&property: String);
    procedure disconnectOutlet(outletName: String);
    procedure each(name: String; path: String); overload;
    procedure each(name: String; path: String; options:     end;); overload;
    function if(context: JFunction): String; overload;
    function if(context: JFunction; options:     end;): String; overload;
    procedure init;
    procedure input; overload;
    procedure input(options:     end;); overload;
    function linkTo(routeName: String; context: Variant): String; overload;
    function linkTo(routeName: String; context: Variant; options:     end;): String; overload;
    procedure loc(str: String);
    procedure log(&property: String);
    function outlet(&property: String): String;
    procedure partial(partialName: String);
    function render(name: String): String; overload;
    function render(name: String; context: String): String; overload;
    function render(name: String; context: String; options:     end;): String; overload;
    procedure textarea; overload;
    procedure textarea(options:     end;); overload;
    function unbound(&property: String): String;
    function unless(context: JFunction): String; overload;
    function unless(context: JFunction; options:     end;): String; overload;
    function view(path: String): String; overload;
    function view(path: String; options:     end;): String; overload;
    function with(context: JFunction): String; overload;
    function with(context: JFunction; options:     end;): String; overload;
    function yield: String; overload;
    function yield(options:     end;): String; overload;
  end;

  JCompiler = class external 'Compiler'
  end;

  JJavaScriptCompiler = class external 'JavaScriptCompiler'
  end;

  JSafeString = class external 'SafeString'
    constructor Create(str: String);
    function toString: String;
  end;

function compile(&string: String): JFunction;
function get(root: Variant; path: String): Variant; overload;
function get(root: Variant; path: String; options: end;): Variant; overload;
procedure helper(name: String; func: JFunction); overload;
procedure helper(name: String; func: JFunction; dependentKeys: String); overload;
procedure helper(name: String; view: JView); overload;
procedure helper(name: String; view: JView; dependentKeys: String); overload;
procedure precompile(&string: String);
procedure registerBoundHelper(name: String; func: JFunction); overload;
procedure registerBoundHelper(name: String; func: JFunction; dependentKeys: String); overload;
procedure registerHelper(name: String; fn: JFunction); overload;
procedure registerHelper(name: String; fn: JFunction; inverse: Boolean); overload;
procedure registerPartial(name: String; str: Variant);
function K: Variant;
function createFrame(objec: Variant): Variant;
procedure Exception(message: String);
function parse(&string: String): Variant;
procedure print(ast: Variant);
procedure log(level: String; str: String);
function compile(environment: Variant): Variant; overload;
function compile(environment: Variant; options: Variant): Variant; overload;
function compile(environment: Variant; options: Variant; context: Variant): Variant; overload;
function compile(environment: Variant; options: Variant; context: Variant; asObject: Variant): Variant; overload;

var
  logger: Jtype of;

//RSVP

type
  JPromise = class external 'Promise'
    constructor Create(resolver: JPromiseResolverFunction; &label: String);
    function then: JPromise; overload;
    function then(onFulfilled: JFunction): JPromise; overload;
    function then(onFulfilled: JFunction; onRejected: JFunction): JPromise; overload;
    function catch(onRejection: JFunction): JPromise; overload;
    function catch(onRejection: JFunction; &label: String): JPromise; overload;
    function finally(callback: JFunction): JPromise; overload;
    function finally(callback: JFunction; &label: String): JPromise; overload;
  end;

  JPromiseResolve = class external
(value: Variant)  end;

  JPromiseReject = class external
(reason: Variant)  end;

  JPromiseResolverFunction = class external
(resolve: JPromiseResolve; reject: JPromiseReject)  end;

//String

function camelize(str: String): String;
function capitalize(str: String): String;
function classify(str: String): String;
function dasherize(str: String): String;
function decamelize(str: String): String;
function fmt(args: array of String): String;
procedure htmlSafe(str: String);
function loc(args: array of String): String;
function underscore(str: String): String;
function w(str: String): array of String;

function A: JNativeArray; overload;
function A(arr: array of Variant): JNativeArray; overload;
function DEFAULT_GETTER_FUNCTION(name: String): JFunction;
procedure MANDATORY_SETTER_FUNCTION(value: String);
function addBeforeObserver(obj: Variant; path: String; target: Variant; method: JFunction): Variant;
procedure addListener(obj: Variant; eventName: String; target: Variant; method: JFunction); overload;
procedure addListener(obj: Variant; eventName: String; target: Variant; method: JFunction; once: Boolean); overload;
procedure addListener(obj: Variant; eventName: String; target: Variant; method: String); overload;
procedure addListener(obj: Variant; eventName: String; target: Variant; method: String; once: Boolean); overload;
procedure addListener(obj: Variant; eventName: String; func: JFunction; method: JFunction); overload;
procedure addListener(obj: Variant; eventName: String; func: JFunction; method: JFunction; once: Boolean); overload;
procedure addListener(obj: Variant; eventName: String; func: JFunction; method: String); overload;
procedure addListener(obj: Variant; eventName: String; func: JFunction; method: String; once: Boolean); overload;
function aliasMethod(methodName: String): JDescriptor;
procedure assert(desc: String; test: Boolean);
function beforeObserver(func: JFunction; propertyName: String): JFunction;
function beforeObserversFor(obj: Variant; path: String): array of String;
procedure beginPropertyChanges;
function bind(obj: Variant; to: String; from: String): JBinding;
function cacheFor(obj: Variant; key: String): Variant;
function canInvoke(obj: Variant; methodName: String): Boolean;
procedure changeProperties(callback: JFunction); overload;
procedure changeProperties(callback: JFunction; binding: Variant); overload;
function compare(v: Variant; w: Variant): Float;
function controllerFor(container: JContainer; controllerName: String): JController; overload;
function controllerFor(container: JContainer; controllerName: String; lookupOptions: end;): JController; overload;
function copy(obj: Variant; deep: Boolean): Variant;
function create: JCoreObject; overload;
function create(arguments: end;): JCoreObject; overload;
procedure debug(message: String);
procedure defineProperty(obj: Variant; keyName: String; desc: end;);
procedure deprecate(message: String); overload;
procedure deprecate(message: String; test: Boolean); overload;
function deprecateFunc(message: String; func: JFunction): JFunction;
procedure destroy(obj: Variant);
procedure endPropertyChanges;
procedure finishChains(obj: Variant);
procedure flushPendingChains;
function generateController(container: JContainer; controllerName: String; context: Variant): JController;
function generateGuid(obj: Variant): String; overload;
function generateGuid(obj: Variant; prefix: String): String; overload;
function get(obj: Variant; keyName: String): Variant;
function getMeta(obj: Variant; &property: String): Variant;
function getWithDefault(root: String; key: String; defaultValue: Variant): Variant;
function guidFor(obj: Variant): String;
function handleErrors(func: JFunction; context: Variant): Variant;
function hasListeners(context: Variant; name: String): Boolean;
function hasOwnProperty(prop: String): Boolean;
function immediateObserver(func: JFunction; propertyNames: array of Variant): JFunction;
function inspect(obj: Variant): String;
procedure instrument(name: String; payload: Variant; callback: JFunction; binding: Variant);
function isArray(obj: Variant): Boolean;
function isEmpty(obj: Variant): Boolean;
function isEqual(a: Variant; b: Variant): Boolean;
function isGlobalPath(path: String): Boolean;
function isNone(obj: Variant): Boolean;
function isPrototypeOf(obj: end;): Boolean;
function isWatching(obj: Variant; key: String): Boolean;
function keys(obj: Variant): array of Variant;
function listenersDiff(obj: Variant; eventName: String; otherActions: array of Variant): array of Variant;
function listenersFor(obj: Variant; eventName: String): array of Variant;
procedure listenersUnion(obj: Variant; eventName: String; otherActions: array of Variant);
function makeArray(obj: Variant): array of Variant;
function merge(original: Variant; updates: Variant): Variant;
function meta(obj: Variant): end;; overload;
function meta(obj: Variant; writable: Boolean): end;; overload;
function metaPath(obj: Variant; path: String): Variant; overload;
function metaPath(obj: Variant; path: String; writable: Boolean): Variant; overload;
function mixin(obj: Variant; args: array of Variant): Variant;
function normalizeTuple(target: Variant; path: String): array of Variant;
function observer(args: array of Variant): JFunction;
function observersFor(obj: Variant; path: String): array of Variant;
procedure onLoad(name: String; callback: JFunction);
function oneWay(obj: Variant; to: String; from: String): JBinding;
function overrideChains(obj: Variant; keyName: String; m: Variant): Boolean;
procedure propertyDidChange(obj: Variant; keyName: String);
function propertyIsEnumerable(prop: String): Boolean;
procedure propertyWillChange(obj: Variant; keyName: String);
function removeBeforeObserver(obj: Variant; path: String; target: Variant; method: JFunction): Variant;
procedure removeChainWatcher(obj: Variant; keyName: String; node: Variant);
procedure removeListener(obj: Variant; eventName: String; target: Variant; method: JFunction);
procedure removeListener(obj: Variant; eventName: String; target: Variant; method: String);
procedure removeListener(obj: Variant; eventName: String; func: JFunction; method: JFunction);
procedure removeListener(obj: Variant; eventName: String; func: JFunction; method: String);
function removeObserver(obj: Variant; path: String; target: Variant; method: JFunction): Variant;
function required: JDescriptor;
procedure rewatch(obj: Variant);
procedure runLoadHooks(name: String; &object: Variant);
function sendEvent(obj: Variant; eventName: String): Boolean; overload;
function sendEvent(obj: Variant; eventName: String; params: array of Variant): Boolean; overload;
function sendEvent(obj: Variant; eventName: String; params: array of Variant; actions: array of Variant): Boolean; overload;
function set(obj: Variant; keyName: String; value: Variant): Variant;
procedure setMeta(obj: Variant; &property: String; value: Variant);
function setProperties(self: Variant; hash: end;): Variant;
procedure subscribe(pattern: String; &object: Variant);
function toLocaleString: String;
function toString: String;
function tryCatchFinally(tryable: JFunction; catchable: JFunction; finalizer: JFunction): Variant; overload;
function tryCatchFinally(tryable: JFunction; catchable: JFunction; finalizer: JFunction; binding: Variant): Variant; overload;
function tryFinally(tryable: JFunction; finalizer: JFunction): Variant; overload;
function tryFinally(tryable: JFunction; finalizer: JFunction; binding: Variant): Variant; overload;
function tryInvoke(obj: Variant; methodName: String): Variant; overload;
function tryInvoke(obj: Variant; methodName: String; args: array of Variant): Variant; overload;
procedure trySet(obj: Variant; path: String; value: Variant);
function typeOf(item: Variant): String;
procedure unwatch(obj: Variant; keyPath: String);
procedure unwatchKey(obj: Variant; keyName: String);
procedure unwatchPath(obj: Variant; keyPath: String);
function valueOf: end;;
procedure warn(message: String); overload;
procedure warn(message: String; test: Boolean); overload;
procedure watch(obj: Variant; keyPath: String);
procedure watchKey(obj: Variant; keyName: String);
procedure watchPath(obj: Variant; keyPath: String);
function watchedEvents(obj: end;): array of Variant;
function wrap(func: JFunction; superFunc: JFunction): JFunction;

var
  $: JJQueryStatic;
  ArrayPolyfills:     map: Jtype of;
    forEach: Jtype of;
    indexOf: Jtype of;
  end;;
  BOOTED: Boolean;
  EMPTY_META:   end;;
  ENV:   end;;
  EXTEND_PROTOTYPES: Boolean;
  EnumerableUtils:   end;;
  Error: Variant;
  FROZEN_ERROR: String;
  GUID_KEY: String;
  IS_BINDING: JRegExp;
  K: JFunction;
  LOG_BINDINGS: Boolean;
  LOG_STACKTRACE_ON_DEPRECATION: Boolean;
  LOG_VERSION: Boolean;
  Logger:     procedure assert(param: Variant);
    procedure debug(args: array of Variant);
    procedure error(args: array of Variant);
    procedure info(args: array of Variant);
    procedure log(args: array of Variant);
    procedure warn(args: array of Variant);
  end;;
  META_KEY: String;
  NAME_KEY: String;
  ORDER_DEFINITION: array of String;
  SHIM_ES5: Boolean;
  STRINGS: Boolean;
  TEMPLATES:   end;;
  VERSION: String;
  ViewUtils:   end;;
  addObserver: JModifyObserver;
  alias: Jtype of;
  anyUnprocessedMixins: Boolean;
  computed: (args: array of Variant): JComputedProperty    function alias(dependentKey: String): JComputedProperty;
    function and(args: array of String): JComputedProperty;
    function any(args: array of String): JComputedProperty;
    function bool(dependentKey: String): JComputedProperty;
    function defaultTo(defaultPath: String): JComputedProperty;
    function empty(dependentKey: String): JComputedProperty;
    function equal(dependentKey: String; value: Variant): JComputedProperty;
    function gt(dependentKey: String; value: Float): JComputedProperty;
    function gte(dependentKey: String; value: Float): JComputedProperty;
    function lt(dependentKey: String; value: Float): JComputedProperty;
    function lte(dependentKey: String; value: Float): JComputedProperty;
    function map(args: array of String): JComputedProperty;
    function match(dependentKey: String; regexp: JRegExp): JComputedProperty;
    function none(dependentKey: String): JComputedProperty;
    function not(dependentKey: String): JComputedProperty;
    function notEmpty(dependentKey: String): JComputedProperty;
    function oneWay(dependentKey: String): JComputedProperty;
    function or(args: array of String): JComputedProperty;
  end;;
  config:   end;;
  empty: Jtype of;
  exports:   end;;
  getPath: Jtype of;
  imports:   end;;
  isNamespace: Boolean;
  lookup:   end;;
  none: Jtype of;
  onError: JError;
  platform:     addBeforeObserver: JModifyObserver;
    addObserver: JModifyObserver;
    procedure defineProperty(obj: Variant; keyName: String; desc:     end;);
    removeBeforeObserver: JModifyObserver;
    removeObserver: JModifyObserver;
    hasPropertyAccessors: Boolean;
  end;;
  run: (target: Variant; method: JFunction)    procedure begin;
    procedure cancel(timer: Variant);
    procedure debounce(target: Variant; method: JFunction; args: array of Variant);
    procedure debounce(target: Variant; method: String; args: array of Variant);
    procedure end;
    function join(target: Variant; method: JFunction; args: array of Variant): Variant;
    function join(target: Variant; method: String; args: array of Variant): Variant;
    function later(target: Variant; method: JFunction; args: array of Variant): String;
    function later(target: Variant; method: String; args: array of Variant): String;
    function next(target: Variant; method: JFunction; args: array of Variant): Float;
    function next(target: Variant; method: String; args: array of Variant): Float;
    function once(target: Variant; method: JFunction; args: array of Variant): Float;
    function once(target: Variant; method: String; args: array of Variant): Float;
    procedure schedule(queue: String; target: Variant; method: JFunction; args: array of Variant);
    procedure schedule(queue: String; target: Variant; method: String; args: array of Variant);
    procedure scheduleOnce(queue: String; target: Variant; method: JFunction; args: array of Variant);
    procedure scheduleOnce(queue: String; target: Variant; method: String; args: array of Variant);
    procedure sync;
    procedure throttle(target: Variant; method: JFunction; args: array of Variant);
    procedure throttle(target: Variant; method: String; args: array of Variant);
    queues: array of Variant;
  end;;
  setPath: Jtype of;
  trySetPath: Jtype of;
  uuid: Float;

//Em

type
  JActionHandlerMixin = class external 'ActionHandlerMixin'(JEmber.ActionHandlerMixin)
  end;

  JApplication = class external 'Application'(JEmber.Application)
  end;

  JArray = class external 'Array'(JEmber.Array)
  end;

  JArrayController = class external 'ArrayController'(JEmber.ArrayController)
  end;

  JArrayProxy = class external 'ArrayProxy'(JEmber.ArrayProxy)
  end;

  JBinding = class external 'Binding'(JEmber.Binding)
  end;

  JButton = class external 'Button'(JEmber.Button)
  end;

  JCheckbox = class external 'Checkbox'(JEmber.Checkbox)
  end;

  JCollectionView = class external 'CollectionView'(JEmber.CollectionView)
  end;

  JComparable = class external 'Comparable'(JEmber.Comparable)
  end;

  JComponent = class external 'Component'(JEmber.Component)
  end;

  JComputedProperty = class external 'ComputedProperty'(JEmber.ComputedProperty)
  end;

  JContainer = class external 'Container'(JEmber.Container)
  end;

  JContainerView = class external 'ContainerView'(JEmber.ContainerView)
  end;

  JController = class external 'Controller'(JEmber.Controller)
  end;

  JControllerMixin = class external 'ControllerMixin'(JEmber.ControllerMixin)
  end;

  JCopyable = class external 'Copyable'(JEmber.Copyable)
  end;

  JCoreObject = class external 'CoreObject'(JEmber.CoreObject)
  end;

  JCoreView = class external 'CoreView'(JEmber.CoreView)
  end;

  JDAG = class external 'DAG'(JEmber.DAG)
  end;

  JDefaultResolver = class external 'DefaultResolver'(JEmber.DefaultResolver)
  end;

  JDeffered = class external 'Deffered'(JEmber.Deferred)
  end;

  JDeferredMixin = class external 'DeferredMixin'(JEmber.DeferredMixin)
  end;

  JDescriptor = class external 'Descriptor'(JEmber.Descriptor)
  end;

  JEachProxy = class external 'EachProxy'(JEmber.EachProxy)
  end;

  JEnumerable = class external 'Enumerable'(JEmber.Enumerable)
  end;

  JEventDispatcher = class external 'EventDispatcher'(JEmber.EventDispatcher)
  end;

  JEvented = class external 'Evented'(JEmber.Evented)
  end;

  JFreezable = class external 'Freezable'(JEmber.Freezable)
  end;

  JHashLocation = class external 'HashLocation'(JEmber.HashLocation)
  end;

  JHistoryLocation = class external 'HistoryLocation'(JEmber.HistoryLocation)
  end;

  JInstrumentation = class external 'Instrumentation'(JEmber.Instrumentation)
  end;

  JLinkView = class external 'LinkView'(JEmber.LinkView)
  end;

  JLocation = class external 'Location'(JEmber.Location)
  end;

  JMap = class external 'Map'(JEmber.Map)
  end;

  JMapWithDefault = class external 'MapWithDefault'(JEmber.MapWithDefault)
  end;

  JMixin = class external 'Mixin'(JEmber.Mixin)
  end;

  JMutableArray = class external 'MutableArray'(JEmber.MutableArray)
  end;

  JMutableEnumerable = class external 'MutableEnumerable'(JEmber.MutableEnumberable)
  end;

  JNamespace = class external 'Namespace'(JEmber.Namespace)
  end;

  JNativeArray = class external 'NativeArray'(JEmber.NativeArray)
  end;

  JNoneLocation = class external 'NoneLocation'(JEmber.NoneLocation)
  end;

  JObject = class external 'Object'(JEmber.Object)
  end;

  JObjectController = class external 'ObjectController'(JEmber.ObjectController)
  end;

  JObjectProxy = class external 'ObjectProxy'(JEmber.ObjectProxy)
  end;

  JObservable = class external 'Observable'(JEmber.Observable)
  end;

  JOrderedSet = class external 'OrderedSet'(JEmber.OrderedSet)
  end;

  JRenderBuffer = class external 'RenderBuffer'(JEmber.RenderBuffer)
  end;

  JRoute = class external 'Route'(JEmber.Route)
  end;

  JRouter = class external 'Router'(JEmber.Router)
  end;

  JRouterDSL = class external 'RouterDSL'(JEmber.RouterDSL)
  end;

  JSelect = class external 'Select'(JEmber.Select)
  end;

  JSelectOption = class external 'SelectOption'(JEmber.SelectOption)
  end;

  JSet = class external 'Set'(JEmber.Set)
  end;

  JSortableMixin = class external 'SortableMixin'(JEmber.SortableMixin)
  end;

  JState = class external 'State'(JEmber.State)
  end;

  JStateManager = class external 'StateManager'(JEmber.StateManager)
  end;

  JTargetActionSupport = class external 'TargetActionSupport'(JEmber.TargetActionSupport)
  end;

  JTest = class external 'Test'(JEmber.Test)
  end;

  JTextArea = class external 'TextArea'(JEmber.TextArea)
  end;

  JTextField = class external 'TextField'(JEmber.TextField)
  end;

  JTextSupport = class external 'TextSupport'(JEmber.TextSupport)
  end;

  JView = class external 'View'(JEmber.View)
  end;

  JViewTargetActionSupport = class external 'ViewTargetActionSupport'(JEmber.ViewTargetActionSupport)
  end;

//Handlebars

type
  Jhelpers = class external 'helpers'(JEmber.Handlebars.helpers)
  end;

  JCompiler = class external 'Compiler'(JEmber.Handlebars.Compiler)
  end;

  JJavaScriptCompiler = class external 'JavaScriptCompiler'(JEmber.Handlebars.JavaScriptCompiler)
  end;

  JSafeString = class external 'SafeString'(JEmber.Handlebars.SafeString)
  end;

var
  compile: Jtype of;
  get: Jtype of;
  helper: Jtype of;
  precompile: Jtype of;
  registerBoundHelper: Jtype of;
  registerHelper: Jtype of;
  registerPartial: Jtype of;
  K: Jtype of;
  createFrame: Jtype of;
  Exception: Jtype of;
  parse: Jtype of;
  print: Jtype of;
  logger: Jtype of;
  log: Jtype of;

//RSVP

type
  JPromise = class external 'Promise'(JEmber.RSVP.Promise)
  end;

  JPromiseResolve = class external(JEmber.RSVP.PromiseResolve)
  end;

  JPromiseReject = class external(JEmber.RSVP.PromiseReject)
  end;

  JPromiseResolverFunction = class external(JEmber.RSVP.PromiseResolverFunction)
  end;

//String

var
  camelize: Jtype of;
  capitalize: Jtype of;
  classify: Jtype of;
  dasherize: Jtype of;
  decamelize: Jtype of;
  fmt: Jtype of;
  htmlSafe: Jtype of;
  loc: Jtype of;
  underscore: Jtype of;
  w: Jtype of;

var
  $: Jtype of;
  A: Jtype of;
  ArrayPolyfills: Jtype of;
  BOOTED: Jtype of;
  DEFAULT_GETTER_FUNCTION: Jtype of;
  EMPTY_META: Jtype of;
  ENV: Jtype of;
  EXTEND_PROTOTYPES: Jtype of;
  EnumerableUtils: Jtype of;
  Error: Jtype of;
  FROZEN_ERROR: Jtype of;
  GUID_KEY: Jtype of;
  IS_BINDING: Jtype of;
  K: Jtype of;
  LOG_BINDINGS: Jtype of;
  LOG_STACKTRACE_ON_DEPRECATION: Jtype of;
  LOG_VERSION: Jtype of;
  Logger: Jtype of;
  MANDATORY_SETTER_FUNCTION: Jtype of;
  META_KEY: Jtype of;
  NAME_KEY: Jtype of;
  ORDER_DEFINITION: Jtype of;
  SHIM_ES5: Jtype of;
  STRINGS: Jtype of;
  TEMPLATES: Jtype of;
  VERSION: Jtype of;
  ViewUtils: Jtype of;
  addBeforeObserver: Jtype of;
  addListener: Jtype of;
  addObserver: Jtype of;
  alias: Jtype of;
  aliasMethod: Jtype of;
  anyUnprocessedMixins: Jtype of;
  assert: Jtype of;
  beforeObserver: Jtype of;
  beforeObserversFor: Jtype of;
  beginPropertyChanges: Jtype of;
  bind: Jtype of;
  cacheFor: Jtype of;
  canInvoke: Jtype of;
  changeProperties: Jtype of;
  compare: Jtype of;
  computed: Jtype of;
  config: Jtype of;
  controllerFor: Jtype of;
  copy: Jtype of;
  create: Jtype of;
  debug: Jtype of;
  defineProperty: Jtype of;
  deprecate: Jtype of;
  deprecateFunc: Jtype of;
  destroy: Jtype of;
  empty: Jtype of;
  endPropertyChanges: Jtype of;
  exports: Jtype of;
  finishChains: Jtype of;
  flushPendingChains: Jtype of;
  generateController: Jtype of;
  generateGuid: Jtype of;
  get: Jtype of;
  getMeta: Jtype of;
  getPath: Jtype of;
  getWithDefault: Jtype of;
  guidFor: Jtype of;
  handleErrors: Jtype of;
  hasListeners: Jtype of;
  hasOwnProperty: Jtype of;
  immediateObserver: Jtype of;
  imports: Jtype of;
  inspect: Jtype of;
  instrument: Jtype of;
  isArray: Jtype of;
  isEmpty: Jtype of;
  isEqual: Jtype of;
  isGlobalPath: Jtype of;
  isNamespace: Jtype of;
  isNone: Jtype of;
  isPrototypeOf: Jtype of;
  isWatching: Jtype of;
  keys: Jtype of;
  listenersDiff: Jtype of;
  listenersFor: Jtype of;
  listenersUnion: Jtype of;
  lookup: Jtype of;
  makeArray: Jtype of;
  merge: Jtype of;
  meta: Jtype of;
  metaPath: Jtype of;
  mixin: Jtype of;
  none: Jtype of;
  normalizeTuple: Jtype of;
  observer: Jtype of;
  observersFor: Jtype of;
  onLoad: Jtype of;
  oneWay: Jtype of;
  onError: Jtype of;
  overrideChains: Jtype of;
  platform: Jtype of;
  propertyDidChange: Jtype of;
  propertyIsEnumerable: Jtype of;
  propertyWillChange: Jtype of;
  removeBeforeObserver: Jtype of;
  removeChainWatcher: Jtype of;
  removeListener: Jtype of;
  removeObserver: Jtype of;
  required: Jtype of;
  rewatch: Jtype of;
  run: Jtype of;
  runLoadHooks: Jtype of;
  sendEvent: Jtype of;
  set: Jtype of;
  setMeta: Jtype of;
  setPath: Jtype of;
  setProperties: Jtype of;
  subscribe: Jtype of;
  toLocaleString: Jtype of;
  toString: Jtype of;
  tryCatchFinally: Jtype of;
  tryFinally: Jtype of;
  tryInvoke: Jtype of;
  trySet: Jtype of;
  trySetPath: Jtype of;
  typeOf: Jtype of;
  unwatch: Jtype of;
  unwatchKey: Jtype of;
  unwatchPath: Jtype of;
  uuid: Jtype of;
  valueOf: Jtype of;
  warn: Jtype of;
  watch: Jtype of;
  watchKey: Jtype of;
  watchPath: Jtype of;
  watchedEvents: Jtype of;
  wrap: Jtype of;

//"Ember"

type
  JActionHandlerMixin = class external 'ActionHandlerMixin'(JEmber.ActionHandlerMixin)
  end;

  JApplication = class external 'Application'(JEmber.Application)
  end;

  JArray = class external 'Array'(JEmber.Array)
  end;

  JArrayController = class external 'ArrayController'(JEmber.ArrayController)
  end;

  JArrayProxy = class external 'ArrayProxy'(JEmber.ArrayProxy)
  end;

  JBinding = class external 'Binding'(JEmber.Binding)
  end;

  JButton = class external 'Button'(JEmber.Button)
  end;

  JCheckbox = class external 'Checkbox'(JEmber.Checkbox)
  end;

  JCollectionView = class external 'CollectionView'(JEmber.CollectionView)
  end;

  JComparable = class external 'Comparable'(JEmber.Comparable)
  end;

  JComponent = class external 'Component'(JEmber.Component)
  end;

  JComputedProperty = class external 'ComputedProperty'(JEmber.ComputedProperty)
  end;

  JContainer = class external 'Container'(JEmber.Container)
  end;

  JContainerView = class external 'ContainerView'(JEmber.ContainerView)
  end;

  JController = class external 'Controller'(JEmber.Controller)
  end;

  JControllerMixin = class external 'ControllerMixin'(JEmber.ControllerMixin)
  end;

  JCopyable = class external 'Copyable'(JEmber.Copyable)
  end;

  JCoreObject = class external 'CoreObject'(JEmber.CoreObject)
  end;

  JCoreView = class external 'CoreView'(JEmber.CoreView)
  end;

  JDAG = class external 'DAG'(JEmber.DAG)
  end;

  JDefaultResolver = class external 'DefaultResolver'(JEmber.DefaultResolver)
  end;

  JDeffered = class external 'Deffered'(JEmber.Deferred)
  end;

  JDeferredMixin = class external 'DeferredMixin'(JEmber.DeferredMixin)
  end;

  JDescriptor = class external 'Descriptor'(JEmber.Descriptor)
  end;

  JEachProxy = class external 'EachProxy'(JEmber.EachProxy)
  end;

  JEnumerable = class external 'Enumerable'(JEmber.Enumerable)
  end;

  JEventDispatcher = class external 'EventDispatcher'(JEmber.EventDispatcher)
  end;

  JEvented = class external 'Evented'(JEmber.Evented)
  end;

  JFreezable = class external 'Freezable'(JEmber.Freezable)
  end;

  JHashLocation = class external 'HashLocation'(JEmber.HashLocation)
  end;

  JHistoryLocation = class external 'HistoryLocation'(JEmber.HistoryLocation)
  end;

  JInstrumentation = class external 'Instrumentation'(JEmber.Instrumentation)
  end;

  JLinkView = class external 'LinkView'(JEmber.LinkView)
  end;

  JLocation = class external 'Location'(JEmber.Location)
  end;

  JMap = class external 'Map'(JEmber.Map)
  end;

  JMapWithDefault = class external 'MapWithDefault'(JEmber.MapWithDefault)
  end;

  JMixin = class external 'Mixin'(JEmber.Mixin)
  end;

  JMutableArray = class external 'MutableArray'(JEmber.MutableArray)
  end;

  JMutableEnumerable = class external 'MutableEnumerable'(JEmber.MutableEnumberable)
  end;

  JNamespace = class external 'Namespace'(JEmber.Namespace)
  end;

  JNativeArray = class external 'NativeArray'(JEmber.NativeArray)
  end;

  JNoneLocation = class external 'NoneLocation'(JEmber.NoneLocation)
  end;

  JObject = class external 'Object'(JEmber.Object)
  end;

  JObjectController = class external 'ObjectController'(JEmber.ObjectController)
  end;

  JObjectProxy = class external 'ObjectProxy'(JEmber.ObjectProxy)
  end;

  JObservable = class external 'Observable'(JEmber.Observable)
  end;

  JOrderedSet = class external 'OrderedSet'(JEmber.OrderedSet)
  end;

  JRenderBuffer = class external 'RenderBuffer'(JEmber.RenderBuffer)
  end;

  JRoute = class external 'Route'(JEmber.Route)
  end;

  JRouter = class external 'Router'(JEmber.Router)
  end;

  JRouterDSL = class external 'RouterDSL'(JEmber.RouterDSL)
  end;

  JSelect = class external 'Select'(JEmber.Select)
  end;

  JSelectOption = class external 'SelectOption'(JEmber.SelectOption)
  end;

  JSet = class external 'Set'(JEmber.Set)
  end;

  JSortableMixin = class external 'SortableMixin'(JEmber.SortableMixin)
  end;

  JState = class external 'State'(JEmber.State)
  end;

  JStateManager = class external 'StateManager'(JEmber.StateManager)
  end;

  JTargetActionSupport = class external 'TargetActionSupport'(JEmber.TargetActionSupport)
  end;

  JTest = class external 'Test'(JEmber.Test)
  end;

  JTextArea = class external 'TextArea'(JEmber.TextArea)
  end;

  JTextField = class external 'TextField'(JEmber.TextField)
  end;

  JTextSupport = class external 'TextSupport'(JEmber.TextSupport)
  end;

  JView = class external 'View'(JEmber.View)
  end;

  JViewTargetActionSupport = class external 'ViewTargetActionSupport'(JEmber.ViewTargetActionSupport)
  end;

//Handlebars

type
  Jhelpers = class external 'helpers'(JEmber.Handlebars.helpers)
  end;

  JCompiler = class external 'Compiler'(JEmber.Handlebars.Compiler)
  end;

  JJavaScriptCompiler = class external 'JavaScriptCompiler'(JEmber.Handlebars.JavaScriptCompiler)
  end;

  JSafeString = class external 'SafeString'(JEmber.Handlebars.SafeString)
  end;

var
  compile: Jtype of;
  get: Jtype of;
  helper: Jtype of;
  precompile: Jtype of;
  registerBoundHelper: Jtype of;
  registerHelper: Jtype of;
  registerPartial: Jtype of;
  K: Jtype of;
  createFrame: Jtype of;
  Exception: Jtype of;
  parse: Jtype of;
  print: Jtype of;
  logger: Jtype of;
  log: Jtype of;

//RSVP

type
  JPromise = class external 'Promise'(JEmber.RSVP.Promise)
  end;

  JPromiseResolve = class external(JEmber.RSVP.PromiseResolve)
  end;

  JPromiseReject = class external(JEmber.RSVP.PromiseReject)
  end;

  JPromiseResolverFunction = class external(JEmber.RSVP.PromiseResolverFunction)
  end;

//String

var
  camelize: Jtype of;
  capitalize: Jtype of;
  classify: Jtype of;
  dasherize: Jtype of;
  decamelize: Jtype of;
  fmt: Jtype of;
  htmlSafe: Jtype of;
  loc: Jtype of;
  underscore: Jtype of;
  w: Jtype of;

var
  $: Jtype of;
  A: Jtype of;
  ArrayPolyfills: Jtype of;
  BOOTED: Jtype of;
  DEFAULT_GETTER_FUNCTION: Jtype of;
  EMPTY_META: Jtype of;
  ENV: Jtype of;
  EXTEND_PROTOTYPES: Jtype of;
  EnumerableUtils: Jtype of;
  Error: Jtype of;
  FROZEN_ERROR: Jtype of;
  GUID_KEY: Jtype of;
  IS_BINDING: Jtype of;
  K: Jtype of;
  LOG_BINDINGS: Jtype of;
  LOG_STACKTRACE_ON_DEPRECATION: Jtype of;
  LOG_VERSION: Jtype of;
  Logger: Jtype of;
  MANDATORY_SETTER_FUNCTION: Jtype of;
  META_KEY: Jtype of;
  NAME_KEY: Jtype of;
  ORDER_DEFINITION: Jtype of;
  SHIM_ES5: Jtype of;
  STRINGS: Jtype of;
  TEMPLATES: Jtype of;
  VERSION: Jtype of;
  ViewUtils: Jtype of;
  addBeforeObserver: Jtype of;
  addListener: Jtype of;
  addObserver: Jtype of;
  alias: Jtype of;
  aliasMethod: Jtype of;
  anyUnprocessedMixins: Jtype of;
  assert: Jtype of;
  beforeObserver: Jtype of;
  beforeObserversFor: Jtype of;
  beginPropertyChanges: Jtype of;
  bind: Jtype of;
  cacheFor: Jtype of;
  canInvoke: Jtype of;
  changeProperties: Jtype of;
  compare: Jtype of;
  computed: Jtype of;
  config: Jtype of;
  controllerFor: Jtype of;
  copy: Jtype of;
  create: Jtype of;
  debug: Jtype of;
  defineProperty: Jtype of;
  deprecate: Jtype of;
  deprecateFunc: Jtype of;
  destroy: Jtype of;
  empty: Jtype of;
  endPropertyChanges: Jtype of;
  exports: Jtype of;
  finishChains: Jtype of;
  flushPendingChains: Jtype of;
  generateController: Jtype of;
  generateGuid: Jtype of;
  get: Jtype of;
  getMeta: Jtype of;
  getPath: Jtype of;
  getWithDefault: Jtype of;
  guidFor: Jtype of;
  handleErrors: Jtype of;
  hasListeners: Jtype of;
  hasOwnProperty: Jtype of;
  immediateObserver: Jtype of;
  imports: Jtype of;
  inspect: Jtype of;
  instrument: Jtype of;
  isArray: Jtype of;
  isEmpty: Jtype of;
  isEqual: Jtype of;
  isGlobalPath: Jtype of;
  isNamespace: Jtype of;
  isNone: Jtype of;
  isPrototypeOf: Jtype of;
  isWatching: Jtype of;
  keys: Jtype of;
  listenersDiff: Jtype of;
  listenersFor: Jtype of;
  listenersUnion: Jtype of;
  lookup: Jtype of;
  makeArray: Jtype of;
  merge: Jtype of;
  meta: Jtype of;
  metaPath: Jtype of;
  mixin: Jtype of;
  none: Jtype of;
  normalizeTuple: Jtype of;
  observer: Jtype of;
  observersFor: Jtype of;
  onLoad: Jtype of;
  oneWay: Jtype of;
  onError: Jtype of;
  overrideChains: Jtype of;
  platform: Jtype of;
  propertyDidChange: Jtype of;
  propertyIsEnumerable: Jtype of;
  propertyWillChange: Jtype of;
  removeBeforeObserver: Jtype of;
  removeChainWatcher: Jtype of;
  removeListener: Jtype of;
  removeObserver: Jtype of;
  required: Jtype of;
  rewatch: Jtype of;
  run: Jtype of;
  runLoadHooks: Jtype of;
  sendEvent: Jtype of;
  set: Jtype of;
  setMeta: Jtype of;
  setPath: Jtype of;
  setProperties: Jtype of;
  subscribe: Jtype of;
  toLocaleString: Jtype of;
  toString: Jtype of;
  tryCatchFinally: Jtype of;
  tryFinally: Jtype of;
  tryInvoke: Jtype of;
  trySet: Jtype of;
  trySetPath: Jtype of;
  typeOf: Jtype of;
  unwatch: Jtype of;
  unwatchKey: Jtype of;
  unwatchPath: Jtype of;
  uuid: Jtype of;
  valueOf: Jtype of;
  warn: Jtype of;
  watch: Jtype of;
  watchKey: Jtype of;
  watchPath: Jtype of;
  watchedEvents: Jtype of;
  wrap: Jtype of;

