unit Fabricjs;

interface

//"fabric"

//fabric

type
  JIDataURLOptions = class external
    format: String; // nullable
    quality: Float; // nullable
    multiplier: Float; // nullable
    left: Float; // nullable
    top: Float; // nullable
    width: Float; // nullable
    height: Float; // nullable
  end;

  JIEvent = class external
    e: JEvent;
    target: JIObject; // nullable
  end;

  JIFillOptions = class external
    source: Variant {String or JHTMLImageElement};
    repeat: String; // nullable
    offsetX: Float; // nullable
    offsetY: Float; // nullable
  end;

  JIToSVGOptions = class external
    suppressPreamble: Boolean;
    viewBox: JIViewBox;
    encoding: String;
  end;

  JIViewBox = class external
    x: Float;
    y: Float;
    width: Float;
    height: Float;
  end;

  JICollection{<T>} = class external
    function add(&object: array of JIObject): JT;
    function insertAt(&object: JIObject; index: Float; nonSplicing: Boolean): JT;
    function remove(&object: array of JIObject): JT;
    function forEachObject(callback: (element: JIObject; index: Float; array: array of JIObject): Variant): JT; overload;
    function forEachObject(callback: (element: JIObject; index: Float; array: array of JIObject): Variant; context: Variant): JT; overload;
    function getObjects: array of JIObject; overload;
    function getObjects(&type: String): array of JIObject; overload;
    function item(index: Float): JT;
    function isEmpty: Boolean;
    function size: Float;
    function contains(&object: JIObject): Boolean;
    function complexity: Float;
  end;

  JIObservable{<T>} = class external
    function on(eventName: String; handler: (e: JIEvent): Variant): JT;
    function on(eventName:       // property Item[key: String]: JFunction;
    end;): JT;
    function trigger(eventName: String): JT; overload;
    function trigger(eventName: String; options: Variant): JT; overload;
    function off: JT; overload;
    function off(eventName: Variant {String or Variant}): JT; overload;
    function off(eventName: Variant {String or Variant}; handler: (e: JIEvent): Variant): JT; overload;
  end;

  JICanvasAnimation{<T>} = class external
    FX_DURATION: Float;
    function fxCenterObjectH(&object: JIObject): JT; overload;
    function fxCenterObjectH(&object: JIObject; callbacks:       onComplete: JFunction;
      onChange: JFunction;
    end;): JT; overload;
    function fxCenterObjectV(&object: JIObject): JT; overload;
    function fxCenterObjectV(&object: JIObject; callbacks:       onComplete: JFunction;
      onChange: JFunction;
    end;): JT; overload;
    function fxRemove(&object: JIObject): JT; overload;
    function fxRemove(&object: JIObject; callbacks:       onComplete: JFunction;
      onChange: JFunction;
    end;): JT; overload;
  end;

  JIObjectAnimation{<T>} = class external
    function animate(&property: String; value: Variant {Float or String}): JIObject; overload;
    function animate(&property: String; value: Variant {Float or String}; options: JIAnimationOptions): JIObject; overload;
    function animate(properties: Variant): JIObject; overload;
    function animate(properties: Variant; options: JIAnimationOptions): JIObject; overload;
  end;

  JIAnimationOptions = class external
    from: Variant {String or Float}; // nullable
    duration: Float; // nullable
    onChange: JFunction; // nullable
    onComplete: JFunction; // nullable
    easing: JFunction; // nullable
    by: Float; // nullable
  end;

  JIColor = class external
    function getSource: array of Float;
    procedure setSource(source: array of Float);
    function toRgb: String;
    function toRgba: String;
    function toHsl: String;
    function toHsla: String;
    function toHex: String;
    function getAlpha: Float;
    procedure setAlpha(alpha: Float);
    function toGrayscale: JIColor;
    function toBlackWhite(threshold: Float): JIColor;
    function overlayWith(otherColor: Variant {String or JIColor}): JIColor;
  end;

  JIColorStatic = class external
    constructor CreateJIColor;
    function fromRgb(color: String): JIColor;
    function fromRgba(color: String): JIColor;
    function sourceFromRgb(color: String): array of Float;
    function fromHsl(color: String): JIColor;
    function fromHsla(color: String): JIColor;
    function sourceFromHsl(color: String): array of Float;
    function fromHex(color: String): JIColor;
    function sourceFromHex(color: String): array of Float;
    function fromSource(source: array of Float): JIColor;
    prototype: Variant;
  end;

  JIGradientOptions = class external
    &type: String; // nullable
    x1: Float; // nullable
    y1: Float; // nullable
    x2: Float; // nullable
    y2: Float; // nullable
    r1: Float; // nullable
    r2: Float; // nullable
    colorStops: Variant; // nullable
  end;

  JIGradient = class external(JIGradientOptions)
    function addColorStop(colorStop: Variant): JIGradient;
    function toObject: Variant;
    function toSVG(&object: JIObject): String; overload;
    function toSVG(&object: JIObject; normalize: Boolean): String; overload;
    function toLive(ctx: JCanvasRenderingContext2D): JCanvasGradient; overload;
    function toLive(ctx: JCanvasRenderingContext2D; &object: JIPathGroup): JCanvasGradient; overload;
  end;

  JIGrandientStatic = class external
    constructor CreateJIGradient;
    function fromElement(el: JSVGGradientElement; instance: JIObject): JIGradient;
    function fromObject(obj: Variant; options: array of Variant): JIGradient;
  end;

  JIIntersection = class external
    procedure appendPoint(point: JIPoint);
    procedure appendPoints(points: array of JIPoint);
  end;

  JIIntersectionStatic = class external
    constructor Create;
    function intersectPolygonPolygon(points1: array of JIPoint; points2: array of JIPoint): JIIntersection;
    function intersectLinePolygon(a1: JIPoint; a2: JIPoint; points: array of JIPoint): JIIntersection;
    function intersectLineLine(a1: JIPoint; a2: JIPoint; b1: JIPoint; b2: JIPoint): JIIntersection;
    function intersectPolygonRectangle(points: array of JIPoint; r1: Float; r2: Float): JIIntersection;
  end;

  JIPatternOptions = class external
    repeat: String;
    offsetX: Float;
    offsetY: Float;
    source: Variant {String or JHTMLImageElement};
  end;

  JIPattern = class external(JIPatternOptions)
    constructor CreateJIPattern;
    function initialise: JIPattern; overload;
    function initialise(options: JIPatternOptions): JIPattern; overload;
    function toLive(ctx: JCanvasRenderingContext2D): JIPattern;
    function toObject: Variant;
    function toSVG(&object: JIObject): String;
  end;

  JIPatternStatic = class external
    constructor CreateJIPattern;
    prototype: Variant;
  end;

  JIPoint = class external
    x: Float;
    y: Float;
    function add(that: JIPoint): JIPoint;
    function addEquals(that: JIPoint): JIPoint;
    function scalarAdd(scalar: Float): JIPoint;
    function scalarAddEquals(scalar: Float): JIPoint;
    function subtract(that: JIPoint): JIPoint;
    function subtractEquals(that: JIPoint): JIPoint;
    function scalarSubtract(scalar: Float): JIPoint;
    function scalarSubtractEquals(scalar: Float): JIPoint;
    function multiply(scalar: Float): JIPoint;
    function multiplyEquals(scalar: Float): JIPoint;
    function divide(scalar: Float): JIPoint;
    function divideEquals(scalar: Float): JIPoint;
    function eq(that: JIPoint): JIPoint;
    function lt(that: JIPoint): JIPoint;
    function lte(that: JIPoint): JIPoint;
    function gt(that: JIPoint): JIPoint;
    function gte(that: JIPoint): JIPoint;
    function lerp(that: JIPoint; t: Float): JIPoint;
    function distanceFrom(that: JIPoint): Float;
    function midPointFrom(that: JIPoint): JIPoint;
    function min(that: JIPoint): JIPoint;
    function max(that: JIPoint): JIPoint;
    function toString: String;
    function setXY(x: Float; y: Float): JIPoint;
    function setFromPoint(that: JIPoint): JIPoint;
    function swap(that: JIPoint): JIPoint;
  end;

  JIPointStatic = class external
    constructor CreateJIPoint;
    prototype: Variant;
  end;

  JIShadowOptions = class external
    affectStrike: Boolean;
    blur: Float;
    color: String;
    includeDefaultValues: Boolean;
    offsetX: Float;
    offsetY: Float;
  end;

  JIShadow = class external(JIShadowOptions)
    function initialize: JIShadow; overload;
    function initialize(options: Variant {JIShadowOptions or String}): JIShadow; overload;
    function toObject: JIObject;
    function toString: String;
    function toSVG(&object: JIObject): String;
    reOffsetsAndBlur: JRegExp;
  end;

  JIShadowStatic = class external
    constructor CreateJIShadow;
    reOffsetsAndBlur: JRegExp;
  end;

  JICanvasDimensions = class external
    width: Float;
    height: Float;
  end;

  JICanvasDimensionsOptions = class external
    backstoreOnly: Boolean; // nullable
    cssOnly: Boolean; // nullable
  end;

  JIStaticCanvasOptions = class external
    allowTouchScrolling: Boolean; // nullable
    imageSmoothingEnabled: Boolean; // nullable
    preserveObjectStacking: Boolean; // nullable
    viewportTransform: array of Float; // nullable
    freeDrawingColor: String; // nullable
    freeDrawingLineWidth: Float; // nullable
    backgroundColor: Variant {String or JIPattern}; // nullable
    backgroundImage: Variant {JIImage or String}; // nullable
    backgroundImageOpacity: Float; // nullable
    backgroundImageStretch: Float; // nullable
    clipTo: (context: JCanvasRenderingContext2D); // nullable
    controlsAboveOverlay: Boolean; // nullable
    includeDefaultValues: Boolean; // nullable
    overlayColor: Variant {String or JIPattern}; // nullable
    overlayImage: JIImage; // nullable
    overlayImageLeft: Float; // nullable
    overlayImageTop: Float; // nullable
    renderOnAddRemove: Boolean; // nullable
    stateful: Boolean; // nullable
  end;

  JIStaticCanvas = class external(JIObservable {JIStaticCanvas} , JIStaticCanvasOptions, JICollection {JIStaticCanvas} , JICanvasAnimation {JIStaticCanvas} )
    function calcOffset: JIStaticCanvas;
    function setOverlayImage(image: Variant {JIImage or String}; callback: JFunction): JIStaticCanvas; overload;
    function setOverlayImage(image: Variant {JIImage or String}; callback: JFunction; options: JIObjectOptions): JIStaticCanvas; overload;
    function setBackgroundImage(image: Variant {JIImage or String}; callback: JFunction): JIStaticCanvas; overload;
    function setBackgroundImage(image: Variant {JIImage or String}; callback: JFunction; options: JIObjectOptions): JIStaticCanvas; overload;
    function setOverlayColor(overlayColor: Variant {String or JIPattern}; callback: JFunction): JIStaticCanvas;
    function setBackgroundColor(backgroundColor: Variant {String or JIPattern}; callback: JFunction): JIStaticCanvas;
    function getWidth: Float;
    function getHeight: Float;
    function setWidth(value: Variant {Float or String}): JIStaticCanvas; overload;
    function setWidth(value: Variant {Float or String}; options: JICanvasDimensionsOptions): JIStaticCanvas; overload;
    function setHeight(value: Variant {Float or String}): JIStaticCanvas; overload;
    function setHeight(value: Variant {Float or String}; options: JICanvasDimensionsOptions): JIStaticCanvas; overload;
    function setDimensions(dimensions: JICanvasDimensions): JIStaticCanvas; overload;
    function setDimensions(dimensions: JICanvasDimensions; options: JICanvasDimensionsOptions): JIStaticCanvas; overload;
    function getZoom: Float;
    function setViewportTransform(vpt: array of Float): JIStaticCanvas;
    function zoomToPoint(point: JIPoint; value: Float): JIStaticCanvas;
    function setZoom(value: Float): JIStaticCanvas;
    function absolutePan(point: JIPoint): JIStaticCanvas;
    function relativePan(point: JIPoint): JIStaticCanvas;
    function getElement: JHTMLCanvasElement;
    function getActiveObject: JIObject;
    function getActiveGroup: JIGroup;
    function clearContext(ctx: JCanvasRenderingContext2D): JIStaticCanvas;
    function getContext: JCanvasRenderingContext2D;
    function clear: JIStaticCanvas;
    function renderAll: JIStaticCanvas; overload;
    function renderAll(allOnTop: Boolean): JIStaticCanvas; overload;
    function renderTop: JIStaticCanvas;
    function getCenter:       top: Float;
      left: Float;
    end;;
    function centerObjectH(&object: JIObject): JIStaticCanvas;
    function centerObjectV(&object: JIObject): JIStaticCanvas;
    function centerObject(&object: JIObject): JIStaticCanvas;
    function toDatalessJSON: String; overload;
    function toDatalessJSON(propertiesToInclude: array of Variant): String; overload;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toDatalessObject: Variant; overload;
    function toDatalessObject(propertiesToInclude: array of Variant): Variant; overload;
    svgViewportTransformation: Boolean;
    function toSVG(options: JIToSVGOptions): String; overload;
    function toSVG(options: JIToSVGOptions; reviver: JFunction): String; overload;
    function sendToBack(&object: JIObject): JIStaticCanvas;
    function bringToFront(&object: JIObject): JIStaticCanvas;
    function sendBackwards(&object: JIObject): JIStaticCanvas;
    function bringForward(&object: JIObject): JIStaticCanvas;
    function moveTo(&object: JIObject; index: Float): JIStaticCanvas;
    function dispose: JIStaticCanvas;
    function toString: String;
    function toDataURL: String; overload;
    function toDataURL(options: JIDataURLOptions): String; overload;
    function supports(methodName: String): Boolean;
    function loadFromJSON(json: Variant {String or Variant}; callback: JFunction): JICanvas; overload;
    function loadFromJSON(json: Variant {String or Variant}; callback: JFunction; reviver: JFunction): JICanvas; overload;
    procedure clone(callback: (canvas: JIStaticCanvas): Variant); overload;
    procedure clone(callback: (canvas: JIStaticCanvas): Variant; properties: array of Variant); overload;
    procedure cloneWithoutData(callback: (canvas: JIStaticCanvas): Variant);
    procedure onBeforeScaleRotate(target: JIObject);
    function straightenObject(&object: JIObject): JIStaticCanvas;
    function fxStraightenObject(&object: JIObject): JIStaticCanvas;
  end;

  JIStaticCanvasStatic = class external
    constructor CreateJIStaticCanvas;
    EMPTY_JSON: String;
    function supports(methodName: String): Boolean;
    prototype: Variant;
    function toJSON: String; overload;
    function toJSON(propertiesToInclude: array of Variant): String; overload;
  end;

  JICanvasOptions = class external(JIStaticCanvasOptions)
    uniScaleTransform: Boolean; // nullable
    centeredScaling: Boolean; // nullable
    centeredRotation: Boolean; // nullable
    interactive: Boolean; // nullable
    selection: Boolean; // nullable
    selectionColor: String; // nullable
    selectionDashArray: array of Variant; // nullable
    selectionBorderColor: String; // nullable
    selectionLineWidth: Float; // nullable
    hoverCursor: String; // nullable
    moveCursor: String; // nullable
    defaultCursor: String; // nullable
    freeDrawingCursor: String; // nullable
    rotationCursor: String; // nullable
    containerClass: String; // nullable
    perPixelTargetFind: Boolean; // nullable
    targetFindTolerance: Float; // nullable
    skipTargetFind: Boolean; // nullable
    isDrawingMode: Boolean; // nullable
  end;

  JICanvas = class external(JIStaticCanvas, JICanvasOptions)
    _objects: array of JIObject;
    function containsPoint(e: JEvent; target: JIObject): Boolean;
    function deactivateAll: JICanvas;
    function deactivateAllWithDispatch: JICanvas; overload;
    function deactivateAllWithDispatch(e: JEvent): JICanvas; overload;
    function discardActiveGroup: JICanvas; overload;
    function discardActiveGroup(e: JEvent): JICanvas; overload;
    function discardActiveObject: JICanvas; overload;
    function discardActiveObject(e: JEvent): JICanvas; overload;
    procedure drawControls(ctx: JCanvasRenderingContext2D);
    function findTarget(e: JMouseEvent; skipGroup: Boolean): JICanvas;
    function getActiveGroup: JIGroup;
    function getActiveObject: JIObject;
    function getPointer(e: JEvent):       x: Float;
      y: Float;
    end;; overload;
    function getPointer(e: JEvent; ignoreZoom: Boolean):       x: Float;
      y: Float;
    end;; overload;
    function getPointer(e: JEvent; ignoreZoom: Boolean; upperCanvasEl: JCanvasRenderingContext2D):       x: Float;
      y: Float;
    end;; overload;
    function getSelectionContext: JCanvasRenderingContext2D;
    function getSelectionElement: JHTMLCanvasElement;
    function isTargetTransparent(target: JIObject; x: Float; y: Float): Boolean;
    function setActiveGroup(group: JIGroup): JICanvas; overload;
    function setActiveGroup(group: JIGroup; e: JEvent): JICanvas; overload;
    function setActiveObject(&object: JIObject): JICanvas; overload;
    function setActiveObject(&object: JIObject; e: JEvent): JICanvas; overload;
    procedure setCursor(value: String);
    procedure removeListeners;
  end;

  JICanvasStatic = class external
    constructor CreateJICanvas;
    EMPTY_JSON: String;
    function supports(methodName: String): Boolean;
    prototype: Variant;
    function toJSON: String; overload;
    function toJSON(propertiesToInclude: array of Variant): String; overload;
  end;

  JICircleOptions = class external(JIObjectOptions)
    radius: Float; // nullable
    startAngle: Float; // nullable
    endAngle: Float; // nullable
  end;

  JICircle = class external(JIObject, JICircleOptions)
    function complexity: Float;
    function getRadiusX: Float;
    function getRadiusY: Float;
    function setRadius(value: Float): Float;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JICircleStatic = class external
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement; options: JICircleOptions): JICircle;
    function fromObject(&object: Variant): JICircle;
    constructor CreateJICircle;
    prototype: Variant;
  end;

  JIEllipseOptions = class external(JIObjectOptions)
    rx: Float; // nullable
    ry: Float; // nullable
  end;

  JIEllipse = class external(JIObject, JIEllipseOptions)
    function getRx: Float;
    function getRy: Float;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
    function complexity: Float;
  end;

  JIEllipseStatic = class external
    constructor CreateJIEllipse;
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement): JIEllipse; overload;
    function fromElement(element: JSVGElement; options: JIEllipseOptions): JIEllipse; overload;
    function fromObject(&object: Variant): JIEllipse;
  end;

  JIGroup = class external(JIObject, JICollection {JIGroup} )
    function activateAllObjects: JIGroup;
    function addWithUpdate(&object: JIObject): JIGroup;
    function containsPoint(point: JIPoint): Boolean;
    function destroy: JIGroup;
    function get(prop: String): Variant;
    function hasMoved: Boolean;
    function removeWithUpdate(&object: JIObject): JIGroup;
    procedure render(ctx: JCanvasRenderingContext2D);
    function remove(&object: array of JIObject): JIGroup;
    function saveCoords: JIGroup;
    function setObjectsCoords: JIGroup;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toString: String;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JIGroupStatic = class external
    constructor CreateJIGroup;
    procedure fromObject(&object: Variant; callback: (group: JIGroup): Variant);
  end;

  JIImageOptions = class external(JIObjectOptions)
    crossOrigin: String;
    alignX: String;
    alignY: String;
    meetOrSlice: String;
    filters: array of JIBaseFilter;
  end;

  JIImage = class external(JIObject, JIImageOptions)
    procedure initialize; overload;
    procedure initialize(element: Variant {String or JHTMLImageElement}); overload;
    procedure initialize(element: Variant {String or JHTMLImageElement}; options: JIImageOptions); overload;
    procedure applyFilters(callback: JFunction);
    function clone: JIObject; overload;
    function clone(callback: JFunction): JIObject; overload;
    function clone(callback: JFunction; propertiesToInclude: array of Variant): JIObject; overload;
    function complexity: Float;
    function getElement: JHTMLImageElement;
    function getOriginalSize:       width: Float;
      height: Float;
    end;;
    function getSrc: String;
    procedure render(ctx: JCanvasRenderingContext2D; noTransform: Boolean);
    function setElement(element: JHTMLImageElement; callback: JFunction; options: JIImageOptions): JIImage;
    function setCrossOrigin(value: String): JIImage;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toString: String;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
    function setSrc(src: String; callback: JFunction; options: JIImageOptions): JIImage;
  end;

  JIImageStatic = class external
    constructor CreateJIImage;
    function fromURL(url: String): JIImage; overload;
    function fromURL(url: String; callback: (image: JIImage): Variant): JIImage; overload;
    function fromURL(url: String; callback: (image: JIImage): Variant; objObjects: JIObjectOptions): JIImage; overload;
    procedure fromObject(&object: Variant; callback: (image: JIImage):     end;);
    procedure fromElement(element: JSVGElement; callback: JFunction); overload;
    procedure fromElement(element: JSVGElement; callback: JFunction; options: JIImageOptions); overload;
    prototype: Variant;
    CSS_CANVAS: String;
    filters: JIAllFilters;
  end;

  JILineOptions = class external(JIObjectOptions)
    x1: Float;
    x2: Float;
    y1: Float;
    y2: Float;
  end;

  JILine = class external(JIObject, JILineOptions)
    function complexity: Float;
    function initialize: JILine; overload;
    function initialize(points: array of Float): JILine; overload;
    function initialize(points: array of Float; options: JILineOptions): JILine; overload;
    function toObject(propertiesToInclude: array of Variant): Variant;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JILineStatic = class external
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement): JILine; overload;
    function fromElement(element: JSVGElement; options: JILineOptions): JILine; overload;
    function fromObject(&object: Variant): JILine;
    prototype: Variant;
    constructor CreateJILine;
  end;

  JIObjectOptions = class external
    &type: String; // nullable
    originX: String; // nullable
    originY: String; // nullable
    top: Float; // nullable
    left: Float; // nullable
    width: Float; // nullable
    height: Float; // nullable
    scaleX: Float; // nullable
    scaleY: Float; // nullable
    flipX: Boolean; // nullable
    flipY: Boolean; // nullable
    opacity: Float; // nullable
    angle: Float; // nullable
    cornerSize: Float; // nullable
    transparentCorners: Boolean; // nullable
    hoverCursor: String; // nullable
    padding: Float; // nullable
    borderColor: String; // nullable
    cornerColor: String; // nullable
    centeredScaling: Boolean; // nullable
    centeredRotation: Boolean; // nullable
    fill: String; // nullable
    fillRule: String; // nullable
    globalCompositeOperation: String; // nullable
    backgroundColor: String; // nullable
    stroke: String; // nullable
    strokeWidth: Float; // nullable
    strokeDashArray: array of Variant; // nullable
    strokeLineCap: String; // nullable
    strokeLineJoin: String; // nullable
    strokeMiterLimit: Float; // nullable
    shadow: Variant {JIShadow or String}; // nullable
    borderOpacityWhenMoving: Float; // nullable
    borderScaleFactor: Float; // nullable
    transformMatrix: array of Variant; // nullable
    minScaleLimit: Float; // nullable
    selectable: Boolean; // nullable
    evented: Boolean; // nullable
    visible: Boolean; // nullable
    hasControls: Boolean; // nullable
    hasBorders: Boolean; // nullable
    hasRotatingPoint: Boolean; // nullable
    rotatingPointOffset: Float; // nullable
    perPixelTargetFind: Boolean; // nullable
    includeDefaultValues: Boolean; // nullable
    clipTo: JFunction; // nullable
    lockMovementX: Boolean; // nullable
    lockMovementY: Boolean; // nullable
    lockRotation: Boolean; // nullable
    lockScalingX: Boolean; // nullable
    lockScalingY: Boolean; // nullable
    lockUniScaling: Boolean; // nullable
    lockScalingFlip: Boolean; // nullable
    name: String; // nullable
    data: Variant; // nullable
  end;

  JIObject = class external(JIObservable {JIObject} , JIObjectOptions, JIObjectAnimation {JIObject} )
    function getCurrentWidth: Float;
    function getCurrentHeight: Float;
    function getAngle: Float;
    function setAngle(value: Float): JIObject;
    function getBorderColor: String;
    function setBorderColor(value: String): JIObject;
    function getBorderScaleFactor: Float;
    function getCornersize: Float;
    function setCornersize(value: Float): JIObject;
    function getFill: String;
    function setFill(value: String): JIObject;
    function getFillRule: String;
    function setFillRule(value: String): JIObject;
    function getFlipX: Boolean;
    function setFlipX(value: Boolean): JIObject;
    function getFlipY: Boolean;
    function setFlipY(value: Boolean): JIObject;
    function getHeight: Float;
    function setHeight(value: Float): JIObject;
    function getLeft: Float;
    function setLeft(value: Float): JIObject;
    function getOpacity: Float;
    function setOpacity(value: Float): JIObject;
    overlayFill: String;
    function getOverlayFill: String;
    function setOverlayFill(value: String): JIObject;
    function getScaleX: Float;
    function setScaleX(value: Float): JIObject;
    function getScaleY: Float;
    function setScaleY(value: Float): JIObject;
    function setShadow(options: Variant): JIObject;
    function getShadow: JIObject;
    stateProperties: array of Variant;
    function getTop: Float;
    function setTop(value: Float): JIObject;
    function getWidth: Float;
    function setWidth(value: Float): JIObject;
    procedure setOptions(options: Variant);
    procedure transform(ctx: JCanvasRenderingContext2D; fromLeft: Boolean);
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toDatalessObject: Variant; overload;
    function toDatalessObject(propertiesToInclude: array of Variant): Variant; overload;
    function toString: String;
    function get(&property: String): Variant;
    function set(key: String; value: Variant {Variant or JFunction}): JIObject;
    function set(key: Variant): JIObject;
    function toggle(&property: String): JIObject;
    function setSourcePath(value: String): JIObject;
    function getViewportTransform: Boolean;
    procedure render(ctx: JCanvasRenderingContext2D); overload;
    procedure render(ctx: JCanvasRenderingContext2D; noTransform: Boolean); overload;
    function clone(callback: JFunction): JIObject; overload;
    function clone(callback: JFunction; propertiesToInclude: array of Variant): JIObject; overload;
    function cloneAsImage(callback: (image: JIImage): Variant): JIObject;
    function toDataURL(options: JIDataURLOptions): String;
    function isType(&type: String): Boolean;
    function complexity: Float;
    function toJSON: Variant; overload;
    function toJSON(propertiesToInclude: array of Variant): Variant; overload;
    function setGradient(&property: String; options: JIGradientOptions): JIObject;
    function setPatternFill(options: JIFillOptions): JIObject;
    function setShadow: JIObject; overload;
    function setShadow(options: String): JIObject; overload;
    function setShadow(options: JIShadow): JIObject;
    function setColor(color: String): JIObject;
    function setAngle(angle: Float): JIObject;
    function rotate(angle: Float): JIObject;
    procedure centerH;
    procedure centerV;
    procedure center;
    function remove: JIObject;
    function getLocalPointer(e: JEvent; pointer: Variant): Variant;
    procedure setOptions(options: Variant);
    function setSourcePath(value: String): JIObject;
    function getSvgStyles: String;
    function getSvgTransform: String;
    function getSvgTransformMatrix: String;
    function hasStateChanged: Boolean;
    function saveState: JIObject; overload;
    function saveState(options:       stateProperties: array of Variant;
    end;): JIObject; overload;
    function setupState: JIObject;
    function straighten: JIObject;
    function fxStraighten(callbacks:       onComplete: JFunction; // nullable
      onChange: JFunction;
    end;): JIObject;
    function bringForward: JIObject; overload;
    function bringForward(intersecting: Boolean): JIObject; overload;
    function bringToFront: JIObject;
    function sendBackwards: JIObject; overload;
    function sendBackwards(intersecting: Boolean): JIObject; overload;
    function sendToBack: JIObject;
    function moveTo(index: Float): JIObject;
    function translateToCenterPoint(point: JIPoint; originX: String; originY: String): JIPoint;
    function translateToOriginPoint(center: JIPoint; originX: String; originY: String): JIPoint;
    function getCenterPoint: JIPoint;
    function getPointByOrigin: JIPoint;
    function toLocalPoint(point: JIPoint; originX: String; originY: String): JIPoint;
    procedure setPositionByOrigin(pos: JIPoint; originX: String; originY: String);
    procedure adjustPosition(to: String);
    function drawBorders(context: JCanvasRenderingContext2D): JIObject;
    function drawCorners(context: JCanvasRenderingContext2D): JIObject;
    function isControlVisible(controlName: String): Boolean;
    function setControlVisible(controlName: String; visible: Boolean): JIObject;
    function setControlsVisibility: JIObject; overload;
    function setControlsVisibility(options:       bl: Boolean; // nullable
      br: Boolean; // nullable
      mb: Boolean; // nullable
      ml: Boolean; // nullable
      mr: Boolean; // nullable
      mt: Boolean; // nullable
      tl: Boolean; // nullable
      tr: Boolean; // nullable
      mtr: Boolean; // nullable
    end;): JIObject; overload;
    function setCoords: JIObject;
    function getBoundingRect:       left: Float;
      top: Float;
      width: Float;
      height: Float;
    end;;
    function isContainedWithinObject(other: JIObject): Boolean;
    function isContainedWithinRect(pointTL: Variant; pointBR: Variant): Boolean;
    function containsPoint(point: JIPoint): Boolean;
    function scale(value: Float): JIObject;
    function scaleToHeight(value: Float): JIObject;
    function scaleToWidth(value: Float): JIObject;
    function intersectsWithObject(other: JIObject): Boolean;
    function intersectsWithRect(pointTL: Variant; pointBR: Variant): Boolean;
  end;

  JIObjectStatic = class external
    prototype: Variant;
  end;

  JIPathOptions = class external(JIObjectOptions)
    path: array of Variant; // nullable
    minX: Float; // nullable
    minY: Float; // nullable
  end;

  JIPath = class external(JIObject, JIPathOptions)
    function initialize: JIPath; overload;
    function initialize(path: array of Variant): JIPath; overload;
    function initialize(path: array of Variant; options: JIPathOptions): JIPath; overload;
    function complexity: Float;
    procedure render(ctx: JCanvasRenderingContext2D; noTransform: Boolean);
    function toDatalessObject: Variant; overload;
    function toDatalessObject(propertiesToInclude: array of Variant): Variant; overload;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toString: String;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JIPathStatic = class external
    procedure fromElement(element: JSVGElement; callback: (path: JIPath): Variant); overload;
    procedure fromElement(element: JSVGElement; callback: (path: JIPath): Variant; options: JIPathOptions); overload;
    procedure fromObject(&object: Variant; callback: (path: JIPath): Variant);
    constructor CreateJIPath;
  end;

  JIPathGroup = class external(JIObject)
    procedure initialize(paths: array of JIPath); overload;
    procedure initialize(paths: array of JIPath; options: JIObjectOptions); overload;
    function complexity: Float;
    function isSameColor: Boolean;
    procedure render(ctx: JCanvasRenderingContext2D);
    function toDatalessObject: Variant; overload;
    function toDatalessObject(propertiesToInclude: array of Variant): Variant; overload;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toString: String;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
    function getObjects: array of JIPath;
  end;

  JIPathGroupStatic = class external
    function fromObject(&object: Variant): JIPathGroup;
    constructor CreateJIPathGroup;
    procedure fromObject(&object: Variant; callback: (group: JIPathGroup): Variant);
    prototype: Variant;
  end;

  JIPolygonOptions = class external(JIObjectOptions)
    points: array of JIPoint; // nullable
    minX: Float; // nullable
    minY: Float; // nullable
  end;

  JIPolygon = class external(JIObject, JIPolygonOptions)
    function complexity: Float;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JIPolygonStatic = class external
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement): JIPolygon; overload;
    function fromElement(element: JSVGElement; options: JIPolygonOptions): JIPolygon; overload;
    function fromObject(&object: Variant): JIPolygon;
    constructor CreateJIPolygon;
    prototype: Variant;
  end;

  JIPolylineOptions = class external(JIObjectOptions)
    points: array of JIPoint; // nullable
    minX: Float; // nullable
    minY: Float; // nullable
  end;

  JIPolyline = class external(JIObject, JIPolylineOptions)
    procedure initialize(points: array of JIPoint); overload;
    procedure initialize(points: array of JIPoint; options: JIPolylineOptions); overload;
    function complexity: Float;
    function toObject: Variant; overload;
    function toObject(propertiesToInclude: array of Variant): Variant; overload;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JIPolylineStatic = class external
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement): JIPolyline; overload;
    function fromElement(element: JSVGElement; options: JIPolylineOptions): JIPolyline; overload;
    function fromObject(&object: Variant): JIPolyline;
    constructor CreateJIPolyline;
    prototype: Variant;
  end;

  JIRectOptions = class external(JIObjectOptions)
    x: Float; // nullable
    y: Float; // nullable
    rx: Float; // nullable
    ry: Float; // nullable
  end;

  JIRect = class external(JIObject, JIRectOptions)
    function initialize: JIRect; overload;
    function initialize(points: array of Float): JIRect; overload;
    function initialize(points: array of Float; options: Variant): JIRect; overload;
    function complexity: Float;
    function toObject(propertiesToInclude: array of Variant): Variant;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JIRectStatic = class external
    ATTRIBUTE_NAMES: array of String;
    function fromElement(element: JSVGElement): JIRect; overload;
    function fromElement(element: JSVGElement; options: JIRectOptions): JIRect; overload;
    function fromObject(&object: Variant): JIRect;
    constructor CreateJIRect;
    prototype: Variant;
  end;

  JITextOptions = class external(JIObjectOptions)
    fontSize: Float; // nullable
    fontWeight: Variant {Float or String}; // nullable
    fontFamily: String; // nullable
    textDecoration: String; // nullable
    textAlign: String; // nullable
    fontStyle: String; // nullable
    lineHeight: Float; // nullable
    stroke: String; // nullable
    shadow: Variant {JIShadow or String}; // nullable
    textBackgroundColor: String; // nullable
    path: String; // nullable
    useNative: JBoolean; // nullable
    text: String; // nullable
  end;

  JIText = class external(JIObject, JITextOptions)
    function complexity: Float;
    function toString: String;
    procedure render(ctx: JCanvasRenderingContext2D; noTransform: Boolean);
    function toObject: JIObject; overload;
    function toObject(propertiesToInclude: array of Variant): JIObject; overload;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
    function getFontSize: Float;
    function setFontSize(fontSize: Float): JIText;
    function getFontWeight: Variant {Float or String};
    function setFontWeight(fontWeight: Variant {String or Float}): JIText;
    function getFontFamily: String;
    function setFontFamily(fontFamily: String): JIText;
    function getText: String;
    function setText(text: String): JIText;
    function getTextDecoration: String;
    function setTextDecoration(textDecoration: String): JIText;
    function getFontStyle: String;
    function setFontStyle(fontStyle: String): JIText;
    function getLineHeight: Float;
    function setLineHeight(lineHeight: Float): JIText;
    function getTextAlign: String;
    function setTextAlign(textAlign: String): JIText;
    function getTextBackgroundColor: String;
    function setTextBackgroundColor(textBackgroundColor: String): JIText;
  end;

  JITextStatic = class external
    ATTRIBUTE_NAMES: array of String;
    DEFAULT_SVG_FONT_SIZE: Float;
    constructor CreateJIText;
    function fromElement(element: JSVGElement): JIText; overload;
    function fromElement(element: JSVGElement; options: JITextOptions): JIText; overload;
    function fromObject(&object: Variant): JIText;
  end;

  JIITextOptions = class external(JIObjectOptions, JITextOptions)
    selectionStart: Float; // nullable
    selectionEnd: Float; // nullable
    selectionColor: String; // nullable
    isEditing: Boolean; // nullable
    editable: Boolean; // nullable
    editingBorderColor: String; // nullable
    cursorWidth: Float; // nullable
    cursorColor: String; // nullable
    cursorDelay: Float; // nullable
    cursorDuration: Float; // nullable
    styles: Variant; // nullable
    caching: Boolean; // nullable
  end;

  JIIText = class external(JIObject, JIText, JIITextOptions)
    function isEmptyStyles: Boolean;
    procedure render(ctx: JCanvasRenderingContext2D; noTransform: Boolean);
    function toObject: JIObject; overload;
    function toObject(propertiesToInclude: array of Variant): JIObject; overload;
    function setText(value: String): JIText;
    procedure setSelectionStart(index: Float);
    procedure setSelectionEnd(index: Float);
    function getSelectionStyles(startIndex: Float; endIndex: Float): Variant;
    function setSelectionStyles(styles: Variant): JIText;
    procedure renderCursorOrSelection;
    procedure get2DCursorLocation; overload;
    procedure get2DCursorLocation(selectionStart: Float); overload;
    function getCurrentCharStyle(lineIndex: Float; charIndex: Float): Variant;
    function getCurrentCharFontSize(lineIndex: Float; charIndex: Float): Float;
    function getCurrentCharColor(lineIndex: Float; charIndex: Float): String;
    procedure renderCursor(boundaries: Variant);
    procedure renderSelection(chars: array of String; boundaries: Variant);
    procedure initBehavior;
    procedure initSelectedHandler;
    procedure initAddedHandler;
    procedure initRemovedHandler;
    procedure initDelayedCursor(restart: Boolean);
    procedure abortCursorAnimation;
    procedure selectAll;
    function getSelectedText: String;
    function findWordBoundaryLeft(startFrom: Float): Float;
    function findWordBoundaryRight(startFrom: Float): Float;
    function findLineBoundaryLeft(startFrom: Float): Float;
    function findLineBoundaryRight(startFrom: Float): Float;
    function getNumNewLinesInSelectedText: Float;
    function searchWordBoundary(selectionStart: Float; direction: Float): Float;
    procedure selectWord(selectionStart: Float);
    procedure selectLine(selectionStart: Float);
    function enterEditing: JIIText;
    procedure initMouseMoveHandler;
    function exitEditing: JIIText;
    procedure insertChars(_chars: String); overload;
    procedure insertChars(_chars: String; useCopiedStyle: Boolean); overload;
    procedure insertNewlineStyleObject(lineIndex: Float; charIndex: Float; isEndOfLine: Boolean);
    procedure insertCharStyleObject(lineIndex: Float; charIndex: Float; isEndOfLine: Boolean);
    procedure insertStyleObjects(_chars: String; isEndOfLine: Boolean); overload;
    procedure insertStyleObjects(_chars: String; isEndOfLine: Boolean; useCopiedStyle: Boolean); overload;
    procedure shiftLineStyles(lineIndex: Float; offset: Float);
    procedure removeStyleObject(isBeginningOfLine: Boolean); overload;
    procedure removeStyleObject(isBeginningOfLine: Boolean; index: Float); overload;
    procedure insertNewline;
  end;

  JIITextStatic = class external(JITextStatic)
    constructor CreateJIIText;
    function fromObject(&object: Variant): JIIText;
  end;

  JITriangleOptions = class external(JIObjectOptions)
  end;

  JITriangle = class external(JIObject)
    function complexity: Float;
    function toSVG: String; overload;
    function toSVG(reviver: JFunction): String; overload;
  end;

  JITriangleStatic = class external
    constructor CreateJITriangle;
    function fromObject(&object: Variant): JITriangle;
  end;

  JIAllFilters = class external
    BaseFilter:       constructor CreateJIBaseFilter;
    end;;
    Blend:       constructor CreateJIBlendFilter;
      function fromObject(&object: Variant): JIBlendFilter;
    end;;
    Brightness:       constructor CreateJIBrightnessFilter;
      function fromObject(&object: Variant): JIBrightnessFilter;
    end;;
    Convolute:       constructor CreateJIConvoluteFilter;
      function fromObject(&object: Variant): JIConvoluteFilter;
    end;;
    GradientTransparency:       constructor CreateJIGradientTransparencyFilter;
      function fromObject(&object: Variant): JIGradientTransparencyFilter;
    end;;
    Grayscale:       constructor CreateJIGrayscaleFilter;
      function fromObject(&object: Variant): JIGrayscaleFilter;
    end;;
    Invert:       constructor CreateJIInvertFilter;
      function fromObject(&object: Variant): JIInvertFilter;
    end;;
    Mask:       constructor CreateJIMaskFilter;
      function fromObject(&object: Variant): JIMaskFilter;
    end;;
    Multiply:       constructor CreateJIMultiplyFilter;
      function fromObject(&object: Variant): JIMultiplyFilter;
    end;;
    Noise:       constructor CreateJINoiseFilter;
      function fromObject(&object: Variant): JINoiseFilter;
    end;;
    Pixelate:       constructor CreateJIPixelateFilter;
      function fromObject(&object: Variant): JIPixelateFilter;
    end;;
    RemoveWhite:       constructor CreateJIRemoveWhiteFilter;
      function fromObject(&object: Variant): JIRemoveWhiteFilter;
    end;;
    Resize:       constructor CreateJIResizeFilter;
      function fromObject(&object: Variant): JIResizeFilter;
    end;;
    Sepia2:       constructor CreateJISepia2Filter;
      function fromObject(&object: Variant): JISepia2Filter;
    end;;
    Sepia:       constructor CreateJISepiaFilter;
      function fromObject(&object: Variant): JISepiaFilter;
    end;;
    Tint:       constructor CreateJITintFilter;
      function fromObject(&object: Variant): JITintFilter;
    end;;
  end;

  JIBaseFilter = class external
    procedure setOptions; overload;
    procedure setOptions(options: Variant); overload;
    function toObject: Variant;
    function toJSON: String;
  end;

  JIBlendFilter = class external(JIBaseFilter)
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIBrightnessFilter = class external(JIBaseFilter)
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIConvoluteFilter = class external(JIBaseFilter)
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIGradientTransparencyFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIGrayscaleFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIInvertFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIMaskFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIMultiplyFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JINoiseFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIPixelateFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIRemoveWhiteFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIResizeFilter = class external
    resizeType: String;
    scaleX: Float;
    scaleY: Float;
    lanczosLobes: Float;
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JISepiaFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JISepia2Filter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JITintFilter = class external
    procedure applyTo(canvasEl: JHTMLCanvasElement);
  end;

  JIBaseBrush = class external
    color: String;
    width: Float;
    shadow: Variant {JIShadow or String};
    strokeLineCap: String;
    strokeLineJoin: String;
    strokeDashArray: array of Variant;
    function setShadow(options: Variant {String or Variant}): JIBaseBrush;
  end;

  JICircleBrush = class external(JIBaseBrush)
    width: Float;
    procedure drawDot(pointer: Variant);
    function addPoint(pointer: Variant): JIPoint;
  end;

  JISprayBrush = class external(JIBaseBrush)
    width: Float;
    density: Float;
    dotWidth: Float;
    dotWidthVariance: Float;
    randomOpacity: Boolean;
    optimizeOverlapping: Boolean;
    procedure addSprayChunk(pointer: Variant);
  end;

  JIPatternBrush = class external(JIPencilBrush)
    function getPatternSrc: JHTMLCanvasElement;
    function getPatternSrcFunction: String;
    function getPattern: Variant;
    function createPath(pathData: String): JIPath;
  end;

  JIPencilBrush = class external(JIBaseBrush)
    function convertPointsToSVGPath(points: array of       x: Float;
      y: Float;
    end;): array of String; overload;
    function convertPointsToSVGPath(points: array of       x: Float;
      y: Float;
    end;; minX: Float): array of String; overload;
    function convertPointsToSVGPath(points: array of       x: Float;
      y: Float;
    end;; minX: Float; minY: Float): array of String; overload;
    function createPath(pathData: String): JIPath;
  end;

  JIUtilAnimationOptions = class external
    startValue: Float; // nullable
    endValue: Float; // nullable
    byValue: Float;
    duration: Float; // nullable
    onChange: JFunction; // nullable
    onComplete: JFunction; // nullable
    easing: JFunction; // nullable
  end;

  JIUtilAnimation = class external
    procedure animate; overload;
    procedure animate(options: JIUtilAnimationOptions); overload;
    procedure requestAnimFrame(callback: JFunction);
  end;

  JIUtilAminEaseFunction = class external
(t: Float; b: Float; c: Float; d: Float): Float  end;

  JIUtilAnimEase = class external
    easeInBack: JIUtilAminEaseFunction;
    easeInBounce: JIUtilAminEaseFunction;
    easeInCirc: JIUtilAminEaseFunction;
    easeInCubic: JIUtilAminEaseFunction;
    easeInElastic: JIUtilAminEaseFunction;
    easeInExpo: JIUtilAminEaseFunction;
    easeInOutBack: JIUtilAminEaseFunction;
    easeInOutBounce: JIUtilAminEaseFunction;
    easeInOutCirc: JIUtilAminEaseFunction;
    easeInOutCubic: JIUtilAminEaseFunction;
    easeInOutElastic: JIUtilAminEaseFunction;
    easeInOutExpo: JIUtilAminEaseFunction;
    easeInOutQuad: JIUtilAminEaseFunction;
    easeInOutQuart: JIUtilAminEaseFunction;
    easeInOutQuint: JIUtilAminEaseFunction;
    easeInOutSine: JIUtilAminEaseFunction;
    easeInQuad: JIUtilAminEaseFunction;
    easeInQuart: JIUtilAminEaseFunction;
    easeInQuint: JIUtilAminEaseFunction;
    easeInSine: JIUtilAminEaseFunction;
    easeOutBack: JIUtilAminEaseFunction;
    easeOutBounce: JIUtilAminEaseFunction;
    easeOutCirc: JIUtilAminEaseFunction;
    easeOutCubic: JIUtilAminEaseFunction;
    easeOutElastic: JIUtilAminEaseFunction;
    easeOutExpo: JIUtilAminEaseFunction;
    easeOutQuad: JIUtilAminEaseFunction;
    easeOutQuart: JIUtilAminEaseFunction;
    easeOutQuint: JIUtilAminEaseFunction;
    easeOutSine: JIUtilAminEaseFunction;
  end;

  JIUtilArc = class external
    procedure drawArc(ctx: JCanvasRenderingContext2D; fx: Float; fy: Float; coords: array of Float);
    function getBoundsOfArc(fx: Float; fy: Float; rx: Float; ry: Float; rot: Float; large: Float; sweep: Float; tx: Float; ty: Float): array of JIPoint;
    function getBoundsOfCurve(x0: Float; y0: Float; x1: Float; y1: Float; x2: Float; y2: Float; x3: Float; y3: Float): array of JIPoint;
  end;

  JIUtilDomEvent = class external
    function getPointer(event: JEvent; upperCanvasEl: JHTMLCanvasElement): JIPoint;
    procedure addListener(element: JHTMLElement; eventName: String; handler: JFunction);
    procedure removeListener(element: JHTMLElement; eventName: String; handler: JFunction);
  end;

  JIUtilDomMisc = class external
    function getById(id: Variant {String or JHTMLElement}): JHTMLElement;
    function toArray(arrayLike: Variant): array of Variant;
    function makeElement(tagName: String): JHTMLElement; overload;
    function makeElement(tagName: String; attributes: Variant): JHTMLElement; overload;
    procedure addClass(element: JHTMLElement; classname: String);
    function wrapElement(element: JHTMLElement; wrapper: Variant {JHTMLElement or String}): JHTMLElement; overload;
    function wrapElement(element: JHTMLElement; wrapper: Variant {JHTMLElement or String}; attributes: Variant): JHTMLElement; overload;
    function getScrollLeftTop(element: JHTMLElement; upperCanvasEl: JHTMLElement):       left: Float;
      right: Float;
    end;;
    function getElementOffset(element: JHTMLElement):       left: Float;
      right: Float;
    end;;
    function getElementStyle(elment: JHTMLElement; attr: String): String;
    procedure getScript(url: String; callback: JFunction);
    function makeElementUnselectable(element: JHTMLElement): JHTMLElement;
    function makeElementSelectable(element: JHTMLElement): JHTMLElement;
  end;

  JIUtilDomRequest = class external
    function request(url: String): JXMLHttpRequest; overload;
    function request(url: String; options:       method: String; // nullable
      onComplete: JFunction;
    end;): JXMLHttpRequest; overload;
  end;

  JIUtilDomStyle = class external
    function setStyle(element: JHTMLElement; styles: Variant): JHTMLElement;
  end;

  JIUtilArray = class external
    function invoke(array: array of Variant; method: String): array of Variant;
    function min(array: array of Variant; byProperty: String): Variant;
    function max(array: array of Variant; byProperty: String): Variant;
  end;

  JIUtilClass = class external
    procedure createClass(parent: JFunction); overload;
    procedure createClass(parent: JFunction; properties: Variant); overload;
    procedure createClass; overload;
    procedure createClass(properties: Variant); overload;
  end;

  JIUtilObject = class external
    function extend(destination: Variant; source: Variant): Variant;
    function clone(&object: Variant): Variant;
  end;

  JIUtilString = class external
    function camelize(&string: String): String;
    function capitalize(&string: String; firstLetterOnly: Boolean): String;
    function escapeXml(&string: String): String;
  end;

  JIUtilMisc = class external
    function removeFromArray(array: array of Variant; value: Variant): array of Variant;
    function getRandomInt(min: Float; max: Float): Float;
    function degreesToRadians(degrees: Float): Float;
    function radiansToDegrees(radians: Float): Float;
    function rotatePoint(point: JIPoint; origin: JIPoint; radians: Float): JIPoint;
    function transformPoint(p: JIPoint; t: array of Variant): JIPoint; overload;
    function transformPoint(p: JIPoint; t: array of Variant; ignoreOffset: Boolean): JIPoint; overload;
    function invertTransform(t: array of Variant): array of Variant;
    function toFixed(number: Float; fractionDigits: Float): Float;
    function parseUnit(value: Variant {Float or String}): Variant {Float or String}; overload;
    function parseUnit(value: Variant {Float or String}; fontSize: Float): Variant {Float or String}; overload;
    function falseFunction: Boolean;
    function getKlass(&type: String; namespace: String): Variant;
    function resolveNamespace(namespace: String): Variant;
    procedure loadImage(url: String; callback: (image: JHTMLImageElement):     end;); overload;
    procedure loadImage(url: String; callback: (image: JHTMLImageElement):     end;; context: Variant); overload;
    procedure loadImage(url: String; callback: (image: JHTMLImageElement):     end;; context: Variant; crossOrigin: Boolean); overload;
    procedure enlivenObjects(objects: array of Variant; callback: JFunction; namespace: String); overload;
    procedure enlivenObjects(objects: array of Variant; callback: JFunction; namespace: String; reviver: JFunction); overload;
    function groupSVGElements(elements: array of Variant): JIPathGroup; overload;
    function groupSVGElements(elements: array of Variant; options: Variant): JIPathGroup; overload;
    function groupSVGElements(elements: array of Variant; options: Variant; path: Variant): JIPathGroup; overload;
    procedure populateWithProperties(source: Variant; destination: Variant; properties: Variant);
    procedure drawDashedLine(ctx: JCanvasRenderingContext2D; x: Float; y: Float; x2: Float; y2: Float; da: array of Variant);
    function createCanvasElement: JHTMLCanvasElement; overload;
    function createCanvasElement(canvasEl: JHTMLCanvasElement): JHTMLCanvasElement; overload;
    function createImage: JHTMLImageElement;
    function createAccessors(klass: Variant): Variant;
    procedure clipContext(receiver: JIObject; ctx: JCanvasRenderingContext2D);
    function multiplyTransformMatrices(a: array of Variant; b: array of Variant): array of Variant;
    function getFunctionBody(fn: JFunction): String;
    function isTransparent(ctx: JCanvasRenderingContext2D; x: Float; y: Float; tolerance: Float): Boolean;
  end;

  JIUtil = class external(JIUtilAnimation, JIUtilArc, JIObservable {JIUtil} , JIUtilDomEvent, JIUtilDomMisc, JIUtilDomRequest, JIUtilDomStyle, JIUtilClass, JIUtilMisc)
    ease: JIUtilAnimEase;
    array: JIUtilArray;
    &object: JIUtilObject;
    &string: JIUtilString;
  end;

function createCanvasForNode(width: Float; height: Float): JICanvas;
function createSVGRefElementsMarkup(canvas: JIStaticCanvas): String;
function createSVGFontFacesMarkup(objects: array of JIObject): String;
procedure loadSVGFromString(&string: String; callback: (results: array of JIObject; options: Variant)); overload;
procedure loadSVGFromString(&string: String; callback: (results: array of JIObject; options: Variant); reviver: JFunction); overload;
procedure loadSVGFromURL(url: String; callback: (results: array of JIObject; options: Variant)); overload;
procedure loadSVGFromURL(url: String; callback: (results: array of JIObject; options: Variant); reviver: JFunction); overload;
function getCSSRules(doc: JSVGElement): Variant;
procedure parseElements(elements: array of Variant; callback: JFunction; options: Variant); overload;
procedure parseElements(elements: array of Variant; callback: JFunction; options: Variant; reviver: JFunction); overload;
function parsePointsAttribute(points: String): array of Variant;
function parseStyleAttribute(element: JSVGElement): Variant;
procedure parseElements(elements: array of Variant; callback: JFunction); overload;
procedure parseElements(elements: array of Variant; callback: JFunction; options: Variant); overload;
procedure parseElements(elements: array of Variant; callback: JFunction; options: Variant; reviver: JFunction); overload;
function parseAttributes(elemen: JHTMLElement; attributes: array of String):   // property Item[key: String]: String;
end;; overload;
function parseAttributes(elemen: JHTMLElement; attributes: array of String; svgUid: String):   // property Item[key: String]: String;
end;; overload;
function getGradientDefs(doc: JSVGElement):   // property Item[key: String]: Variant;
end;;
procedure parseFontDeclaration(value: String; oStyle: Variant);
procedure parseSVGDocument(doc: JSVGElement; callback: (results: array of JIObject; options: Variant)); overload;
procedure parseSVGDocument(doc: JSVGElement; callback: (results: array of JIObject; options: Variant); reviver: JFunction); overload;
function parseTransformAttribute(attributeValue: String): array of Float;
procedure log(values: array of Variant);
procedure warn(values: array of Variant);

var
  isLikelyNode: Boolean;
  isTouchSupported: Boolean;
  Canvas: JICanvasStatic;
  StaticCanvas: JIStaticCanvasStatic;
  Color: JIColorStatic;
  Pattern: JIPatternStatic;
  Intersection: JIIntersectionStatic;
  Point: JIPointStatic;
  Circle: JICircleStatic;
  Ellipse: JIEllipseStatic;
  Group: JIGroupStatic;
  Image: JIImageStatic;
  Line: JILineStatic;
  Object: JIObjectStatic;
  Path: JIPathStatic;
  PathGroup: JIPathGroupStatic;
  Polygon: JIPolygonStatic;
  Polyline: JIPolylineStatic;
  Rect: JIRectStatic;
  Shadow: JIShadowStatic;
  Text: JITextStatic;
  IText: JIITextStatic;
  Triangle: JITriangleStatic;
  util: JIUtil;
  BaseBrush:     constructor CreateJIBaseBrush;
  end;;
  CircleBrush:     constructor CreateJICircle;
  end;;
  SprayBrush:     constructor CreateJISprayBrush;
  end;;
  PencilBrush:     constructor CreateJIPencilBrush;
  end;;
  PatternBrush:     constructor CreateJIPatternBrush;
  end;;

