unit Gruntjs;

interface

type
  JString = class external
    yellow: String;
    cyan: String;
    white: String;
    magenta: String;
    green: String;
    red: String;
    grey: String;
    blue: String;
  end;

  JIGrunt = class external(Jgrunt.IConfigComponents, Jgrunt.fail.FailModule, Jgrunt.ITaskComponents)
    config: Jgrunt.config.ConfigModule;
    event: Jgrunt.event.EventModule;
    fail: Jgrunt.fail.FailModule;
    file: Jgrunt.file.FileModule;
    log: Jgrunt.log.LogModule;
    option: Jgrunt.option.OptionModule;
    task: Jgrunt.task.TaskModule;
    template: Jgrunt.template.TemplateModule;
    util: Jgrunt.util.UtilModule;
    package: Jnode.NodePackage;
    version: String;
  end;

//node

type
  JNodePackage = class external
    name: String;
    version: String;
    description: String; // nullable
    keywords: array of String; // nullable
    homepage: String; // nullable
  end;

//minimatch

type
  JIMinimatchOptions = class external
    debug: Boolean; // nullable
    nobrace: Boolean; // nullable
    noglobstar: Boolean; // nullable
    dot: Boolean; // nullable
    noext: Boolean; // nullable
    nocase: Boolean; // nullable
    nonull: Boolean; // nullable
    matchBase: Boolean; // nullable
    nocomment: Boolean; // nullable
    nonegate: Boolean; // nullable
    flipNegate: Boolean; // nullable
  end;

//grunt

type
  JIFlag = class external
    // property Item[flag: String]: Boolean;
  end;

  JIConfigComponents = class external(Jgrunt.config.ConfigModule)
    procedure initConfig(config: Jgrunt.config.IProjectConfig);
  end;

  JITaskComponents = class external(Jgrunt.task.CommonTaskModule)
    procedure loadTasks(tasksPath: String);
    procedure loadNpmTasks(pluginName: String);
  end;

//config

type
  JIProjectConfig = class external
    // property Item[plugin: String]: Variant;
  end;

  JConfigModule = class external
(prop: String; value: Variant): Variant(prop: String): Variant    procedure init(config: JIProjectConfig);
    function get(prop: String): JT;
    function get: JConfigModule;
    function process(value: String): JT;
    function getRaw(prop: String): JT;
    function set(prop: String; value: JT): JT;
    function escape(propString: String): String;
    procedure requires(prop: String; andProps: array of String);
    procedure requires(prop: array of String; andProps: array of array of String);
    procedure merge(configObject: JT);
  end;

//event

type
  JEventModule = class external
    function addListener(event: String; listener: JFunction): JEventModule;
    function on(event: String; listener: JFunction): JEventModule;
    function onAny(listener: JFunction): JEventModule;
    function offAny(listener: JFunction): JEventModule;
    function once(event: String; listener: JFunction): JEventModule;
    function many(event: String; timesToListen: Float; listener: JFunction): JEventModule;
    function removeListener(event: String; listener: JFunction): JEventModule;
    function off(event: String; listener: JFunction): JEventModule;
    function removeAllListeners(event: String): JEventModule;
    procedure setMaxListener(n: Float);
    function listeners(event: String): array of JFunction;
    function listenersAny: array of JFunction;
    function emit(event: String; args: array of Variant): Variant;
  end;

//fail

type
  JFailModule = class external
    procedure warn(error: String); overload;
    procedure warn(error: String; errorCode: JErrorCode); overload;
    procedure warn(error: JError); overload;
    procedure warn(error: JError; errorCode: JErrorCode); overload;
    procedure fatal(error: String); overload;
    procedure fatal(error: String; errorCode: JErrorCode); overload;
    procedure fatal(error: JError); overload;
    procedure fatal(error: JError; errorCode: JErrorCode); overload;
  end;

//file

type
  JIFileEncodedOption = class external
    encoding: String;
  end;

  JIFileWriteOptions = class external
    noProcess: Variant; // nullable
  end;

  JIFileWriteBufferOption = class external(Jgrunt.file.IFileWriteOptions)
    process: (buffer: JBuffer): Boolean; // nullable
  end;

  JIFileWriteStringOption = class external(Jgrunt.file.IFileWriteOptions)
    process: (file: String): Boolean; // nullable
  end;

  JFileModule = class external
    defaultEncoding: String;
    function read(filepath: String): String;
    function read(filepath: String; options: JIFileEncodedOption): JBuffer;
    function readJSON(filepath: String): Variant;
    function readJSON(filepath: String; options: JIFileEncodedOption): JBuffer;
    function readYAML(filepath: String): Variant;
    function readYAML(filepath: String; options: JIFileEncodedOption): JBuffer;
    procedure write(filepath: String; contents: String); overload;
    procedure write(filepath: String; contents: String; options: JIFileEncodedOption); overload;
    procedure write(filepath: String; contents: JBuffer);
    procedure copy(srcpath: String; destpath: String);
    procedure copy(srcpath: String; destpath: String; options: JIFileWriteStringOption);
    procedure copy(srcpath: String; destpath: String; options: JIFileWriteBufferOption);
    function delete(filepath: String): Boolean; overload;
    function delete(filepath: String; options:       force: Boolean; // nullable
    end;): Boolean; overload;
    procedure mkdir(dirpath: String); overload;
    procedure mkdir(dirpath: String; mode: String); overload;
    procedure recurse(rootdir: String; callback: (abspath: String; rootdir: String; subdir: String; filename: String));
    function expand(patterns: array of String): array of String;
    function expand(options: JIFilesConfig; patterns: array of String): array of String;
    function expandMapping(patterns: array of String; dest: String; options: JIExpandedFilesConfig): JArray{<JIFileMap>};
    function match(pattern: String; filepath: String): array of String;
    function match(pattern: String; filepaths: array of String): array of String;
    function match(patterns: array of String; filepath: String): array of String;
    function match(patterns: array of String; filepaths: array of String): array of String;
    function match(options: Jminimatch.IMinimatchOptions; pattern: String; filepath: String): array of String;
    function match(options: Jminimatch.IMinimatchOptions; pattern: String; filepaths: array of String): array of String;
    function match(options: Jminimatch.IMinimatchOptions; patterns: array of String; filepath: String): array of String;
    function match(options: Jminimatch.IMinimatchOptions; patterns: array of String; filepaths: array of String): array of String;
    function isMatch(pattern: String; filepath: String): Boolean;
    function isMatch(pattern: String; filepaths: array of String): Boolean;
    function isMatch(patterns: array of String; filepath: String): Boolean;
    function isMatch(patterns: array of String; filepaths: array of String): Boolean;
    function isMatch(options: Jminimatch.IMinimatchOptions; pattern: String; filepath: String): Boolean;
    function isMatch(options: Jminimatch.IMinimatchOptions; pattern: String; filepaths: array of String): Boolean;
    function isMatch(options: Jminimatch.IMinimatchOptions; patterns: array of String; filepath: String): Boolean;
    function isMatch(options: Jminimatch.IMinimatchOptions; patterns: array of String; filepaths: array of String): Boolean;
    function exists(path: String; append: array of String): Boolean;
    function isLink(path: String; append: array of String): Boolean;
    function isDir(path: String; append: array of String): Boolean;
    function isFile(path: String; append: array of String): Boolean;
    function isPathAbsolute(path: String; append: array of String): Boolean;
    function arePathsEquivalent(path: String; append: array of String): Boolean;
    function doesPathContain(ancestorPath: String; decendantPaths: array of String): Boolean;
    function isPathCwd(path: String; append: array of String): Boolean;
    procedure setBase(path: String; append: array of String);
    glob: Variant;
    minimatch: Variant;
    findup: Variant;
  end;

  JIFilesArray = class external(JArray {JIFilesConfig} )
  end;

  JIFilesConfig = class external(Jminimatch.IMinimatchOptions)
    src: array of String; // nullable
    dest: String; // nullable
    expand: Boolean; // nullable
    filter: Variant; // nullable
  end;

  JIExpandedFilesConfig = class external(JIFilesConfig)
    expand: Boolean; // nullable
    cwd: String; // nullable
    ext: String; // nullable
    flatten: Boolean; // nullable
    rename: JFunction; // nullable
  end;

  JIFileMap = class external
    src: array of String;
    dest: String;
  end;

//log

type
  JCommonLogging{<T>} = class external
    function write(msg: String): JT;
    function writeln(msg: String): JT;
    function error(msg: String): JT;
    function errorlns(msg: String): JT;
    function ok(msg: String): JT;
    function oklns(msg: String): JT;
    function subhead(msg: String): JT;
    function writeflags(obj: Variant): JT;
    function warn(msg: String): JT;
  end;

  JVerboseLogModule = class external(JCommonLogging {JVerboseLogModule} )
    or: JNotVerboseLogModule;
  end;

  JNotVerboseLogModule = class external(JCommonLogging {JNotVerboseLogModule} )
    or: JVerboseLogModule;
  end;

  JLogModule = class external(JCommonLogging {JLogModule} )
    verbose: JVerboseLogModule;
    notverbose: JNotVerboseLogModule;
  end;

//option

type
  JOptionModule = class external
{<T>}(key: String; value: JT){<T>}(key: String): JT    procedure init; overload;
    procedure init(initObject: Variant); overload;
    flags: array of Jgrunt.IFlag;
  end;

//task

type
  JCommonTaskModule = class external
    procedure registerTask(taskName: String; taskList: array of String);
    procedure registerTask(taskName: String; description: String; taskFunction: JFunction);
    procedure registerMultiTask(taskName: String; taskFunction: JFunction);
    procedure registerMultiTask(taskName: String; taskDescription: String; taskFunction: JFunction);
    function exists(name: String): Boolean;
    procedure renameTask(oldname: String; newname: String);
  end;

  JTaskModule = class external(JCommonTaskModule)
    procedure run(tasks: array of String);
    procedure run(task: String; thenTasks: array of String);
    procedure clearQueue;
    function normalizeMultiTaskFiles(data: Jgrunt.config.IProjectConfig): JArray{<Jgrunt.file.IFileMap>}; overload;
    function normalizeMultiTaskFiles(data: Jgrunt.config.IProjectConfig; targetname: String): JArray{<Jgrunt.file.IFileMap>}; overload;
    current: Jgrunt.task.IMultiTask{<Variant>};
  end;

  JAsyncResultCatcher = class external
(success: Boolean)(error: JError)(result: Variant)  end;

  JITask = class external
    function async: JAsyncResultCatcher;
    procedure requires(tasks: array of String);
    procedure requires(tasks: String; otherTasks: array of String);
    procedure requires(tasks: array of String; otherTasks: array of array of String);
    procedure requiresConfig(prop: String; andProps: array of String);
    name: String;
    nameArgs: String;
    args: array of String;
    flags: array of Jgrunt.IFlag;
    errorCount: Float;
    function options(defaultsObj: Variant): JITaskOptions;
    function options(defaultsObj: JT): JT;
  end;

  JIMultiTask{<T>} = class external(JITask)
    target: String;
    files: Jgrunt.file.IFilesArray;
    filesSrc: array of String;
    data: JT;
  end;

  JITaskOptions = class external
    options: Variant; // nullable
    files: Variant; // nullable
  end;

  JITaskCompactOptions = class external(Jgrunt.task.ITaskOptions, Jgrunt.file.IFilesConfig)
  end;

//template

type
  JTemplateModule = class external
    function process(template: String): (options: Variant): String;
    function process(template: String; options: Variant): String;
    procedure setDelimiters(name: String);
    procedure addDelimiters(name: String; opener: String; closer: String);
    function date: String; overload;
    function date(date: JDate): String; overload;
    function date(date: JDate; format: String): String; overload;
    function date: String; overload;
    function date(date: Float): String; overload;
    function date(date: Float; format: String): String; overload;
    function date: String; overload;
    function date(date: String): String; overload;
    function date(date: String; format: String): String; overload;
    function today: String; overload;
    function today(format: String): String; overload;
  end;

//util

type
  JUtilModule = class external
    function kindOf(value: Variant): String;
    function error(message: String): JError; overload;
    function error(message: String; origError: JError): JError; overload;
    function error(error: JError): JError; overload;
    function error(error: JError; origError: JError): JError; overload;
    function error(error: Variant): JError; overload;
    function error(error: Variant; origError: JError): JError; overload;
    linefeed: String;
    function normalizelf(str: String): String;
    procedure recurse(&object: Variant; callbackFunction: (value: Variant); continueFunction: (objOrValue: Variant): Boolean);
    function repeat(n: Float; str: String): String;
    function pluralize(n: Float; str: String): String; overload;
    function pluralize(n: Float; str: String; separator: String): String; overload;
    function spawn(options: JISpawnOptions; done: (error: JError; result: JISpawnResult; code: Float)): JISpawnedChild;
    function toArray(arrayLikeObject: Variant): array of JT;
    function callbackify(syncOrAsyncFunction: : JR): (callback: (result: JR));
    function callbackify(syncOrAsyncFunction: (a: JA): JR): (a: JA; callback: (result: JR));
    function callbackify(syncOrAsyncFunction: (a: JA; b: JB): JR): (a: JA; b: JB; callback: (result: JR));
    function callbackify(syncOrAsyncFunction: (a: JA; b: JB; c: JC): JR): (a: JA; b: JB; c: JC; callback: (result: JR));
    function callbackify(syncOrAsyncFunction: (a: JA; b: JB; c: JC; d: JD): JR): (a: JA; b: JB; c: JC; d: JD; callback: (result: JR));
    namespace: Variant;
    task: Variant;
  end;

  JISpawnOptions = class external
    cmd: String; // nullable
    grunt: Boolean; // nullable
    args: array of String; // nullable
    opts:       cwd: String; // nullable
      stdio: Variant; // nullable
      custom: Variant; // nullable
      env: Variant; // nullable
      detached: Boolean; // nullable
    end;; // nullable
    fallback: Variant; // nullable
  end;

  JISpawnResult = class external
    stdout: String;
    stderr: String;
    code: Float;
  end;

  JISpawnedChild = class external
    procedure start;
    procedure once;
    procedure forever;
    procedure kill;
  end;

//'grunt'

var
  grunt: JIGrunt;

