unit Jquery;

interface

type
  JJQueryAjaxSettings = class external
    accepts: Variant; // nullable
    async: Boolean; // nullable
    function beforeSend(jqXHR: JJQueryXHR; settings: JJQueryAjaxSettings): Variant;
    cache: Boolean; // nullable
    function complete(jqXHR: JJQueryXHR; textStatus: String): Variant;
    contents:       // property Item[key: String]: Variant;
    end;; // nullable
    contentType: Variant; // nullable
    context: Variant; // nullable
    converters:       // property Item[key: String]: Variant;
    end;; // nullable
    crossDomain: Boolean; // nullable
    data: Variant; // nullable
    function dataFilter(data: Variant; ty: Variant): Variant;
    dataType: String; // nullable
    function error(jqXHR: JJQueryXHR; textStatus: String; errorThrown: String): Variant;
    global: Boolean; // nullable
    headers:       // property Item[key: String]: Variant;
    end;; // nullable
    ifModified: Boolean; // nullable
    isLocal: Boolean; // nullable
    jsonp: Variant; // nullable
    jsonpCallback: Variant; // nullable
    method: String; // nullable
    mimeType: String; // nullable
    password: String; // nullable
    processData: Boolean; // nullable
    scriptCharset: String; // nullable
    statusCode:       // property Item[key: String]: Variant;
    end;; // nullable
    function success(data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant;
    timeout: Float; // nullable
    traditional: Boolean; // nullable
    &type: String; // nullable
    url: String; // nullable
    username: String; // nullable
    xhr: Variant; // nullable
    xhrFields:       // property Item[key: String]: Variant;
    end;; // nullable
  end;

  JJQueryXHR = class external(JXMLHttpRequest, JJQueryPromise {Variant} )
    function overrideMimeType(mimeType: String): Variant;
    procedure abort; overload;
    procedure abort(statusText: String); overload;
    function then(doneCallback: (data: Variant; textStatus: String; jqXHR: JJQueryXHR)): JJQueryPromise{<Variant>}; overload;
    function then(doneCallback: (data: Variant; textStatus: String; jqXHR: JJQueryXHR); failCallback: (jqXHR: JJQueryXHR; textStatus: String; errorThrown: Variant)): JJQueryPromise{<Variant>}; overload;
    responseJSON: Variant; // nullable
    procedure error(xhr: JJQueryXHR; textStatus: String; errorThrown: String);
  end;

  JJQueryCallback = class external
    function add(callbacks: JFunction): JJQueryCallback;
    function add(callbacks: array of JFunction): JJQueryCallback;
    function disable: JJQueryCallback;
    function disabled: Boolean;
    function empty: JJQueryCallback;
    function fire(arguments: array of Variant): JJQueryCallback;
    function fired: Boolean;
    function fireWith: JJQueryCallback; overload;
    function fireWith(context: Variant): JJQueryCallback; overload;
    function fireWith(context: Variant; args: array of Variant): JJQueryCallback; overload;
    function has(callback: JFunction): Boolean;
    function lock: JJQueryCallback;
    function locked: Boolean;
    function remove(callbacks: JFunction): JJQueryCallback;
    function remove(callbacks: array of JFunction): JJQueryCallback;
  end;

  JJQueryGenericPromise{<T>} = class external
    function then(doneFilter: (value: JT; values: array of Variant): Variant {JU or JJQueryPromise{<JU>}}): JJQueryPromise{<JU>}; overload;
    function then(doneFilter: (value: JT; values: array of Variant): Variant {JU or JJQueryPromise{<JU>}}; failFilter: (reasons: array of Variant): Variant): JJQueryPromise{<JU>}; overload;
    function then(doneFilter: (value: JT; values: array of Variant): Variant {JU or JJQueryPromise{<JU>}}; failFilter: (reasons: array of Variant): Variant; progressFilter: (progression: array of Variant): Variant): JJQueryPromise{<JU>}; overload;
    function then(doneFilter: (value: JT; values: array of Variant)): JJQueryPromise{<Variant>}; overload;
    function then(doneFilter: (value: JT; values: array of Variant); failFilter: (reasons: array of Variant): Variant): JJQueryPromise{<Variant>}; overload;
    function then(doneFilter: (value: JT; values: array of Variant); failFilter: (reasons: array of Variant): Variant; progressFilter: (progression: array of Variant): Variant): JJQueryPromise{<Variant>}; overload;
  end;

  JJQueryPromiseCallback{<T>} = class external
(value: JT; args: array of Variant)  end;

  JJQueryPromiseOperator{<TU>} = class external
(callback1: Variant {JJQueryPromiseCallback{<JT>} or array of JJQueryPromiseCallback{<JT>}}; callbacksN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryPromise{<JU>}  end;

  JJQueryPromise{<T>} = class external(JJQueryGenericPromise {JT} )
    function state: String;
    function always: JJQueryPromise{<JT>}; overload;
    function always(alwaysCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; alwaysCallbacksN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryPromise{<JT>}; overload;
    function done: JJQueryPromise{<JT>}; overload;
    function done(doneCallback1: Variant {JJQueryPromiseCallback{<JT>} or array of JJQueryPromiseCallback{<JT>}}; doneCallbackN: JArray{<Variant {JJQueryPromiseCallback{<JT>} or array of JJQueryPromiseCallback{<JT>}}>}): JJQueryPromise{<JT>}; overload;
    function fail: JJQueryPromise{<JT>}; overload;
    function fail(failCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; failCallbacksN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryPromise{<JT>}; overload;
    function progress: JJQueryPromise{<JT>}; overload;
    function progress(progressCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; progressCallbackN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryPromise{<JT>}; overload;
    function pipe: JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant; failFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant; failFilter: (x: Variant): Variant; progressFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
  end;

  JJQueryDeferred{<T>} = class external(JJQueryGenericPromise {JT} )
    function state: String;
    function always: JJQueryDeferred{<JT>}; overload;
    function always(alwaysCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; alwaysCallbacksN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryDeferred{<JT>}; overload;
    function done: JJQueryDeferred{<JT>}; overload;
    function done(doneCallback1: Variant {JJQueryPromiseCallback{<JT>} or array of JJQueryPromiseCallback{<JT>}}; doneCallbackN: JArray{<Variant {JJQueryPromiseCallback{<JT>} or array of JJQueryPromiseCallback{<JT>}}>}): JJQueryDeferred{<JT>}; overload;
    function fail: JJQueryDeferred{<JT>}; overload;
    function fail(failCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; failCallbacksN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryDeferred{<JT>}; overload;
    function progress: JJQueryDeferred{<JT>}; overload;
    function progress(progressCallback1: Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}; progressCallbackN: JArray{<Variant {JJQueryPromiseCallback{<Variant>} or array of JJQueryPromiseCallback{<Variant>}}>}): JJQueryDeferred{<JT>}; overload;
    function notify: JJQueryDeferred{<JT>}; overload;
    function notify(value: Variant; args: array of Variant): JJQueryDeferred{<JT>}; overload;
    function notifyWith(context: Variant): JJQueryDeferred{<JT>}; overload;
    function notifyWith(context: Variant; value: array of Variant): JJQueryDeferred{<JT>}; overload;
    function reject: JJQueryDeferred{<JT>}; overload;
    function reject(value: Variant; args: array of Variant): JJQueryDeferred{<JT>}; overload;
    function rejectWith(context: Variant): JJQueryDeferred{<JT>}; overload;
    function rejectWith(context: Variant; value: array of Variant): JJQueryDeferred{<JT>}; overload;
    function resolve: JJQueryDeferred{<JT>}; overload;
    function resolve(value: JT; args: array of Variant): JJQueryDeferred{<JT>}; overload;
    function resolveWith(context: Variant): JJQueryDeferred{<JT>}; overload;
    function resolveWith(context: Variant; value: array of JT): JJQueryDeferred{<JT>}; overload;
    function promise: JJQueryPromise{<JT>}; overload;
    function promise(target: Variant): JJQueryPromise{<JT>}; overload;
    function pipe: JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant; failFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
    function pipe(doneFilter: (x: Variant): Variant; failFilter: (x: Variant): Variant; progressFilter: (x: Variant): Variant): JJQueryPromise{<Variant>}; overload;
  end;

  JBaseJQueryEventObject = class external(JEvent)
    data: Variant;
    delegateTarget: JElement;
    function isDefaultPrevented: Boolean;
    function isImmediatePropagationStopped: Boolean;
    function isPropagationStopped: Boolean;
    namespace: String;
    originalEvent: JEvent;
    function preventDefault: Variant;
    relatedTarget: JElement;
    result: Variant;
    procedure stopImmediatePropagation;
    procedure stopPropagation;
    target: JElement;
    pageX: Float;
    pageY: Float;
    which: Float;
    metaKey: Boolean;
  end;

  JJQueryInputEventObject = class external(JBaseJQueryEventObject)
    altKey: Boolean;
    ctrlKey: Boolean;
    metaKey: Boolean;
    shiftKey: Boolean;
  end;

  JJQueryMouseEventObject = class external(JJQueryInputEventObject)
    button: Float;
    clientX: Float;
    clientY: Float;
    offsetX: Float;
    offsetY: Float;
    pageX: Float;
    pageY: Float;
    screenX: Float;
    screenY: Float;
  end;

  JJQueryKeyEventObject = class external(JJQueryInputEventObject)
    char: Variant;
    charCode: Float;
    key: Variant;
    keyCode: Float;
  end;

  JJQueryEventObject = class external(JBaseJQueryEventObject, JJQueryInputEventObject, JJQueryMouseEventObject, JJQueryKeyEventObject)
  end;

  JJQuerySupport = class external
    ajax: Boolean; // nullable
    boxModel: Boolean; // nullable
    changeBubbles: Boolean; // nullable
    checkClone: Boolean; // nullable
    checkOn: Boolean; // nullable
    cors: Boolean; // nullable
    cssFloat: Boolean; // nullable
    hrefNormalized: Boolean; // nullable
    htmlSerialize: Boolean; // nullable
    leadingWhitespace: Boolean; // nullable
    noCloneChecked: Boolean; // nullable
    noCloneEvent: Boolean; // nullable
    opacity: Boolean; // nullable
    optDisabled: Boolean; // nullable
    optSelected: Boolean; // nullable
    function scriptEval: Boolean;
    style: Boolean; // nullable
    submitBubbles: Boolean; // nullable
    tbody: Boolean; // nullable
  end;

  JJQueryParam = class external
(obj: Variant): String(obj: Variant; traditional: Boolean): String  end;

  JJQueryEventConstructor = class external
(name: String; eventProperties: Variant): JJQueryEventObject    constructor CreateJJQueryEventObject;
  end;

  JJQueryCoordinates = class external
    left: Float;
    top: Float;
  end;

  JJQuerySerializeArrayElement = class external
    name: String;
    value: String;
  end;

  JJQueryAnimationOptions = class external
    duration: Variant; // nullable
    easing: String; // nullable
    complete: JFunction; // nullable
    step: (now: Float; tween: Variant): Variant; // nullable
    progress: (animation: JJQueryPromise{<Variant>}; progress: Float; remainingMs: Float): Variant; // nullable
    start: (animation: JJQueryPromise{<Variant>}): Variant; // nullable
    done: (animation: JJQueryPromise{<Variant>}; jumpedToEnd: Boolean): Variant; // nullable
    fail: (animation: JJQueryPromise{<Variant>}; jumpedToEnd: Boolean): Variant; // nullable
    always: (animation: JJQueryPromise{<Variant>}; jumpedToEnd: Boolean): Variant; // nullable
    queue: Variant; // nullable
    specialEasing: JObject; // nullable
  end;

  JJQueryEasingFunction = class external
(percent: Float): Float  end;

  JJQueryEasingFunctions = class external
    // property Item[name: String]: JJQueryEasingFunction;
    linear: JJQueryEasingFunction;
    swing: JJQueryEasingFunction;
  end;

  JJQueryStatic = class external
    function ajax(settings: JJQueryAjaxSettings): JJQueryXHR;
    function ajax(url: String): JJQueryXHR; overload;
    function ajax(url: String; settings: JJQueryAjaxSettings): JJQueryXHR; overload;
    procedure ajaxPrefilter(dataTypes: String; handler: (opts: Variant; originalOpts: JJQueryAjaxSettings; jqXHR: JJQueryXHR): Variant);
    procedure ajaxPrefilter(handler: (opts: Variant; originalOpts: JJQueryAjaxSettings; jqXHR: JJQueryXHR): Variant);
    ajaxSettings: JJQueryAjaxSettings;
    procedure ajaxSetup(options: JJQueryAjaxSettings);
    function get(url: String): JJQueryXHR; overload;
    function get(url: String; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function get(url: String; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant; dataType: String): JJQueryXHR; overload;
    function get(url: String): JJQueryXHR; overload;
    function get(url: String; data: Variant {JObject or String}): JJQueryXHR; overload;
    function get(url: String; data: Variant {JObject or String}; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function get(url: String; data: Variant {JObject or String}; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant; dataType: String): JJQueryXHR; overload;
    function getJSON(url: String): JJQueryXHR; overload;
    function getJSON(url: String; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function getJSON(url: String): JJQueryXHR; overload;
    function getJSON(url: String; data: Variant {JObject or String}): JJQueryXHR; overload;
    function getJSON(url: String; data: Variant {JObject or String}; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function getScript(url: String): JJQueryXHR; overload;
    function getScript(url: String; success: (script: String; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    param: JJQueryParam;
    function post(url: String): JJQueryXHR; overload;
    function post(url: String; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function post(url: String; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant; dataType: String): JJQueryXHR; overload;
    function post(url: String): JJQueryXHR; overload;
    function post(url: String; data: Variant {JObject or String}): JJQueryXHR; overload;
    function post(url: String; data: Variant {JObject or String}; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant): JJQueryXHR; overload;
    function post(url: String; data: Variant {JObject or String}; success: (data: Variant; textStatus: String; jqXHR: JJQueryXHR): Variant; dataType: String): JJQueryXHR; overload;
    function Callbacks: JJQueryCallback; overload;
    function Callbacks(flags: String): JJQueryCallback; overload;
    procedure holdReady(hold: Boolean);
(selector: String; context: Variant {JElement or JJQuery}): JJQuery(element: JElement): JJQuery(elementArray: array of JElement): JJQuery(callback: (jQueryAlias: JJQueryStatic): Variant): JJQuery(&object:     end;): JJQuery(&object: JJQuery): JJQuery: JJQuery(html: String; ownerDocument: JDocument): JJQuery(html: String; attributes: JObject): JJQuery    function noConflict: JObject; overload;
    function noConflict(removeAll: Boolean): JObject; overload;
    function when(deferreds: JArray{<Variant {JT or JJQueryPromise{<JT>}}>}): JJQueryPromise{<JT>};
    cssHooks:       // property Item[key: String]: Variant;
    end;;
    cssNumber: Variant;
    function data(element: JElement; key: String; value: JT): JT;
    function data(element: JElement; key: String): Variant;
    function data(element: JElement): Variant;
    procedure dequeue(element: JElement); overload;
    procedure dequeue(element: JElement; queueName: String); overload;
    function hasData(element: JElement): Boolean;
    function queue(element: JElement): array of Variant; overload;
    function queue(element: JElement; queueName: String): array of Variant; overload;
    function queue(element: JElement; queueName: String; newQueue: array of JFunction): JJQuery;
    function queue(element: JElement; queueName: String; callback: JFunction): JJQuery;
    function removeData(element: JElement): JJQuery; overload;
    function removeData(element: JElement; name: String): JJQuery; overload;
    function Deferred: JJQueryDeferred{<JT>}; overload;
    function Deferred(beforeStart: (deferred: JJQueryDeferred{<JT>}): Variant): JJQueryDeferred{<JT>}; overload;
    easing: JJQueryEasingFunctions;
    fx:       tick: ;
      interval: Float;
      stop: ;
      speeds:         slow: Float;
        fast: Float;
      end;;
      off: Boolean;
      step: Variant;
    end;;
    function proxy(fnction: (args: array of Variant): Variant; context: JObject; additionalArguments: array of Variant): Variant;
    function proxy(context: JObject; name: String; additionalArguments: array of Variant): Variant;
    Event: JJQueryEventConstructor;
    function error(message: Variant): JJQuery;
    expr: Variant;
    fn: Variant;
    isReady: Boolean;
    support: JJQuerySupport;
    function contains(container: JElement; contained: JElement): Boolean;
    function each(collection: array of JT; callback: (indexInArray: Float; valueOfElement: JT): Variant): Variant;
    function each(collection: Variant; callback: (indexInArray: Variant; valueOfElement: Variant): Variant): Variant;
    function extend(target: Variant): Variant; overload;
    function extend(target: Variant; object1: Variant; objectN: array of Variant): Variant; overload;
    function extend(deep: Boolean; target: Variant): Variant; overload;
    function extend(deep: Boolean; target: Variant; object1: Variant; objectN: array of Variant): Variant; overload;
    function globalEval(code: String): Variant;
    function grep(array: array of JT; func: (elementOfArray: JT; indexInArray: Float): Boolean): array of JT; overload;
    function grep(array: array of JT; func: (elementOfArray: JT; indexInArray: Float): Boolean; invert: Boolean): array of JT; overload;
    function inArray(value: JT; array: array of JT): Float; overload;
    function inArray(value: JT; array: array of JT; fromIndex: Float): Float; overload;
    function isArray(obj: Variant): Boolean;
    function isEmptyObject(obj: Variant): Boolean;
    function isFunction(obj: Variant): Boolean;
    function isNumeric(value: Variant): Boolean;
    function isPlainObject(obj: Variant): Boolean;
    function isWindow(obj: Variant): Boolean;
    function isXMLDoc(node: JNode): Boolean;
    function makeArray(obj: Variant): array of Variant;
    function map(array: array of JT; callback: (elementOfArray: JT; indexInArray: Float): JU): array of JU;
    function map(arrayOrObject: Variant; callback: (value: Variant; indexOrKey: Variant): Variant): Variant;
    function merge(first: array of JT; second: array of JT): array of JT;
    function noop: Variant;
    function now: Float;
    function parseJSON(json: String): Variant;
    function parseXML(data: String): JXMLDocument;
    function trim(str: String): String;
    function type(obj: Variant): String;
    function unique(array: array of JElement): array of JElement;
    function parseHTML(data: String): array of Variant; overload;
    function parseHTML(data: String; context: JHTMLElement): array of Variant; overload;
    function parseHTML(data: String; context: JHTMLElement; keepScripts: Boolean): array of Variant; overload;
    function parseHTML(data: String): array of Variant; overload;
    function parseHTML(data: String; context: JDocument): array of Variant; overload;
    function parseHTML(data: String; context: JDocument; keepScripts: Boolean): array of Variant; overload;
  end;

  JJQuery = class external
    function ajaxComplete(handler: (event: JJQueryEventObject; XMLHttpRequest: JXMLHttpRequest; ajaxOptions: Variant): Variant): JJQuery;
    function ajaxError(handler: (event: JJQueryEventObject; jqXHR: JJQueryXHR; ajaxSettings: JJQueryAjaxSettings; thrownError: Variant): Variant): JJQuery;
    function ajaxSend(handler: (event: JJQueryEventObject; jqXHR: JJQueryXHR; ajaxOptions: JJQueryAjaxSettings): Variant): JJQuery;
    function ajaxStart(handler: : Variant): JJQuery;
    function ajaxStop(handler: : Variant): JJQuery;
    function ajaxSuccess(handler: (event: JJQueryEventObject; XMLHttpRequest: JXMLHttpRequest; ajaxOptions: JJQueryAjaxSettings): Variant): JJQuery;
    function load(url: String): JJQuery; overload;
    function load(url: String; data: Variant {String or JObject}): JJQuery; overload;
    function load(url: String; data: Variant {String or JObject}; complete: (responseText: String; textStatus: String; XMLHttpRequest: JXMLHttpRequest): Variant): JJQuery; overload;
    function serialize: String;
    function serializeArray: array of JJQuerySerializeArrayElement;
    function addClass(className: String): JJQuery;
    function addClass(func: (index: Float; className: String): String): JJQuery;
    function addBack: JJQuery; overload;
    function addBack(selector: String): JJQuery; overload;
    function attr(attributeName: String): String;
    function attr(attributeName: String; value: Variant {String or Float}): JJQuery;
    function attr(attributeName: String; func: (index: Float; attr: String): Variant {String or Float}): JJQuery;
    function attr(attributes: JObject): JJQuery;
    function hasClass(className: String): Boolean;
    function html: String;
    function html(htmlString: String): JJQuery;
    function html(func: (index: Float; oldhtml: String): String): JJQuery;
    function prop(propertyName: String): Variant;
    function prop(propertyName: String; value: Variant {String or Float or Boolean}): JJQuery;
    function prop(properties: JObject): JJQuery;
    function prop(propertyName: String; func: (index: Float; oldPropertyValue: Variant): Variant): JJQuery;
    function removeAttr(attributeName: String): JJQuery;
    function removeClass: JJQuery; overload;
    function removeClass(className: String): JJQuery; overload;
    function removeClass(func: (index: Float; className: String): String): JJQuery;
    function removeProp(propertyName: String): JJQuery;
    function toggleClass(className: String): JJQuery; overload;
    function toggleClass(className: String; swtch: Boolean): JJQuery; overload;
    function toggleClass: JJQuery; overload;
    function toggleClass(swtch: Boolean): JJQuery; overload;
    function toggleClass(func: (index: Float; className: String; swtch: Boolean): String): JJQuery; overload;
    function toggleClass(func: (index: Float; className: String; swtch: Boolean): String; swtch: Boolean): JJQuery; overload;
    function val: Variant;
    function val(value: Variant {String or array of String or Float}): JJQuery;
    function val(func: (index: Float; value: String): String): JJQuery;
    function css(propertyName: String): String;
    function css(propertyName: String; value: Variant {String or Float}): JJQuery;
    function css(propertyName: String; value: (index: Float; value: String): Variant {String or Float}): JJQuery;
    function css(properties: JObject): JJQuery;
    function height: Float;
    function height(value: Variant {Float or String}): JJQuery;
    function height(func: (index: Float; height: Float): Variant {Float or String}): JJQuery;
    function innerHeight: Float;
    function innerHeight(height: Variant {Float or String}): JJQuery;
    function innerWidth: Float;
    function innerWidth(width: Variant {Float or String}): JJQuery;
    function offset: JJQueryCoordinates;
    function offset(coordinates: JJQueryCoordinates): JJQuery;
    function offset(func: (index: Float; coords: JJQueryCoordinates): JJQueryCoordinates): JJQuery;
    function outerHeight: Float; overload;
    function outerHeight(includeMargin: Boolean): Float; overload;
    function outerHeight(height: Variant {Float or String}): JJQuery;
    function outerWidth: Float; overload;
    function outerWidth(includeMargin: Boolean): Float; overload;
    function outerWidth(width: Variant {Float or String}): JJQuery;
    function position: JJQueryCoordinates;
    function scrollLeft: Float;
    function scrollLeft(value: Float): JJQuery;
    function scrollTop: Float;
    function scrollTop(value: Float): JJQuery;
    function width: Float;
    function width(value: Variant {Float or String}): JJQuery;
    function width(func: (index: Float; width: Float): Variant {Float or String}): JJQuery;
    function clearQueue: JJQuery; overload;
    function clearQueue(queueName: String): JJQuery; overload;
    function data(key: String; value: Variant): JJQuery;
    function data(key: String): Variant;
    function data(obj:       // property Item[key: String]: Variant;
    end;): JJQuery;
    function data: Variant;
    function dequeue: JJQuery; overload;
    function dequeue(queueName: String): JJQuery; overload;
    function removeData(name: String): JJQuery;
    function removeData(list: array of String): JJQuery;
    function removeData: JJQuery;
    function promise: JJQueryPromise{<Variant>}; overload;
    function promise(&type: String): JJQueryPromise{<Variant>}; overload;
    function promise(&type: String; target: JObject): JJQueryPromise{<Variant>}; overload;
    function animate(properties: JObject): JJQuery; overload;
    function animate(properties: JObject; duration: Variant {String or Float}): JJQuery; overload;
    function animate(properties: JObject; duration: Variant {String or Float}; complete: JFunction): JJQuery; overload;
    function animate(properties: JObject): JJQuery; overload;
    function animate(properties: JObject; duration: Variant {String or Float}): JJQuery; overload;
    function animate(properties: JObject; duration: Variant {String or Float}; easing: String): JJQuery; overload;
    function animate(properties: JObject; duration: Variant {String or Float}; easing: String; complete: JFunction): JJQuery; overload;
    function animate(properties: JObject; options: JJQueryAnimationOptions): JJQuery;
    function delay(duration: Float): JJQuery; overload;
    function delay(duration: Float; queueName: String): JJQuery; overload;
    function fadeIn: JJQuery; overload;
    function fadeIn(duration: Variant {Float or String}): JJQuery; overload;
    function fadeIn(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function fadeIn: JJQuery; overload;
    function fadeIn(duration: Variant {Float or String}): JJQuery; overload;
    function fadeIn(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function fadeIn(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function fadeIn(options: JJQueryAnimationOptions): JJQuery;
    function fadeOut: JJQuery; overload;
    function fadeOut(duration: Variant {Float or String}): JJQuery; overload;
    function fadeOut(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function fadeOut: JJQuery; overload;
    function fadeOut(duration: Variant {Float or String}): JJQuery; overload;
    function fadeOut(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function fadeOut(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function fadeOut(options: JJQueryAnimationOptions): JJQuery;
    function fadeTo(duration: Variant {String or Float}; opacity: Float): JJQuery; overload;
    function fadeTo(duration: Variant {String or Float}; opacity: Float; complete: JFunction): JJQuery; overload;
    function fadeTo(duration: Variant {String or Float}; opacity: Float): JJQuery; overload;
    function fadeTo(duration: Variant {String or Float}; opacity: Float; easing: String): JJQuery; overload;
    function fadeTo(duration: Variant {String or Float}; opacity: Float; easing: String; complete: JFunction): JJQuery; overload;
    function fadeToggle: JJQuery; overload;
    function fadeToggle(duration: Variant {Float or String}): JJQuery; overload;
    function fadeToggle(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function fadeToggle: JJQuery; overload;
    function fadeToggle(duration: Variant {Float or String}): JJQuery; overload;
    function fadeToggle(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function fadeToggle(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function fadeToggle(options: JJQueryAnimationOptions): JJQuery;
    function finish: JJQuery; overload;
    function finish(queue: String): JJQuery; overload;
    function hide: JJQuery; overload;
    function hide(duration: Variant {Float or String}): JJQuery; overload;
    function hide(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function hide: JJQuery; overload;
    function hide(duration: Variant {Float or String}): JJQuery; overload;
    function hide(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function hide(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function hide(options: JJQueryAnimationOptions): JJQuery;
    function show: JJQuery; overload;
    function show(duration: Variant {Float or String}): JJQuery; overload;
    function show(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function show: JJQuery; overload;
    function show(duration: Variant {Float or String}): JJQuery; overload;
    function show(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function show(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function show(options: JJQueryAnimationOptions): JJQuery;
    function slideDown: JJQuery; overload;
    function slideDown(duration: Variant {Float or String}): JJQuery; overload;
    function slideDown(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function slideDown: JJQuery; overload;
    function slideDown(duration: Variant {Float or String}): JJQuery; overload;
    function slideDown(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function slideDown(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function slideDown(options: JJQueryAnimationOptions): JJQuery;
    function slideToggle: JJQuery; overload;
    function slideToggle(duration: Variant {Float or String}): JJQuery; overload;
    function slideToggle(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function slideToggle: JJQuery; overload;
    function slideToggle(duration: Variant {Float or String}): JJQuery; overload;
    function slideToggle(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function slideToggle(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function slideToggle(options: JJQueryAnimationOptions): JJQuery;
    function slideUp: JJQuery; overload;
    function slideUp(duration: Variant {Float or String}): JJQuery; overload;
    function slideUp(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function slideUp: JJQuery; overload;
    function slideUp(duration: Variant {Float or String}): JJQuery; overload;
    function slideUp(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function slideUp(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function slideUp(options: JJQueryAnimationOptions): JJQuery;
    function stop: JJQuery; overload;
    function stop(clearQueue: Boolean): JJQuery; overload;
    function stop(clearQueue: Boolean; jumpToEnd: Boolean): JJQuery; overload;
    function stop: JJQuery; overload;
    function stop(queue: String): JJQuery; overload;
    function stop(queue: String; clearQueue: Boolean): JJQuery; overload;
    function stop(queue: String; clearQueue: Boolean; jumpToEnd: Boolean): JJQuery; overload;
    function toggle: JJQuery; overload;
    function toggle(duration: Variant {Float or String}): JJQuery; overload;
    function toggle(duration: Variant {Float or String}; complete: JFunction): JJQuery; overload;
    function toggle: JJQuery; overload;
    function toggle(duration: Variant {Float or String}): JJQuery; overload;
    function toggle(duration: Variant {Float or String}; easing: String): JJQuery; overload;
    function toggle(duration: Variant {Float or String}; easing: String; complete: JFunction): JJQuery; overload;
    function toggle(options: JJQueryAnimationOptions): JJQuery;
    function toggle(showOrHide: Boolean): JJQuery;
    function bind(eventType: String; eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function bind(eventType: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function bind(eventType: String; eventData: Variant; preventBubble: Boolean): JJQuery;
    function bind(eventType: String; preventBubble: Boolean): JJQuery;
    function bind(events: Variant): JJQuery;
    function blur: JJQuery;
    function blur(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function blur: JJQuery; overload;
    function blur(eventData: Variant): JJQuery; overload;
    function blur(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function change: JJQuery;
    function change(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function change: JJQuery; overload;
    function change(eventData: Variant): JJQuery; overload;
    function change(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function click: JJQuery;
    function click(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function click: JJQuery; overload;
    function click(eventData: Variant): JJQuery; overload;
    function click(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function dblclick: JJQuery;
    function dblclick(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function dblclick: JJQuery; overload;
    function dblclick(eventData: Variant): JJQuery; overload;
    function dblclick(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function delegate(selector: Variant; eventType: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function delegate(selector: Variant; eventType: String; eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function focus: JJQuery;
    function focus(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function focus: JJQuery; overload;
    function focus(eventData: Variant): JJQuery; overload;
    function focus(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function focusin: JJQuery;
    function focusin(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function focusin(eventData: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function focusout: JJQuery;
    function focusout(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function focusout(eventData: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function hover(handlerIn: (eventObject: JJQueryEventObject): Variant; handlerOut: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function hover(handlerInOut: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function keydown: JJQuery;
    function keydown(handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery;
    function keydown: JJQuery; overload;
    function keydown(eventData: Variant): JJQuery; overload;
    function keydown(eventData: Variant; handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery; overload;
    function keypress: JJQuery;
    function keypress(handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery;
    function keypress: JJQuery; overload;
    function keypress(eventData: Variant): JJQuery; overload;
    function keypress(eventData: Variant; handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery; overload;
    function keyup: JJQuery;
    function keyup(handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery;
    function keyup: JJQuery; overload;
    function keyup(eventData: Variant): JJQuery; overload;
    function keyup(eventData: Variant; handler: (eventObject: JJQueryKeyEventObject): Variant): JJQuery; overload;
    function load(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function load: JJQuery; overload;
    function load(eventData: Variant): JJQuery; overload;
    function load(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function mousedown: JJQuery;
    function mousedown(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mousedown(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseenter: JJQuery;
    function mouseenter(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseenter(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseleave: JJQuery;
    function mouseleave(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseleave(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mousemove: JJQuery;
    function mousemove(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mousemove(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseout: JJQuery;
    function mouseout(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseout(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseover: JJQuery;
    function mouseover(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseover(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseup: JJQuery;
    function mouseup(handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function mouseup(eventData: JObject; handler: (eventObject: JJQueryMouseEventObject): Variant): JJQuery;
    function off: JJQuery;
    function off(events: String): JJQuery; overload;
    function off(events: String; selector: String): JJQuery; overload;
    function off(events: String; selector: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function off(events: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function off(events:       // property Item[key: String]: Variant;
    end;): JJQuery; overload;
    function off(events:       // property Item[key: String]: Variant;
    end;; selector: String): JJQuery; overload;
    function on(events: String; handler: (eventObject: JJQueryEventObject; args: array of Variant): Variant): JJQuery;
    function on(events: String; data: Variant; handler: (eventObject: JJQueryEventObject; args: array of Variant): Variant): JJQuery;
    function on(events: String; selector: String; handler: (eventObject: JJQueryEventObject; eventData: array of Variant): Variant): JJQuery;
    function on(events: String; selector: String; data: Variant; handler: (eventObject: JJQueryEventObject; eventData: array of Variant): Variant): JJQuery;
    function on(events:       // property Item[key: String]: Variant;
    end;): JJQuery; overload;
    function on(events:       // property Item[key: String]: Variant;
    end;; selector: String): JJQuery; overload;
    function on(events:       // property Item[key: String]: Variant;
    end;; selector: String; data: Variant): JJQuery; overload;
    function on(events:       // property Item[key: String]: Variant;
    end;): JJQuery; overload;
    function on(events:       // property Item[key: String]: Variant;
    end;; data: Variant): JJQuery; overload;
    function one(events: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function one(events: String; data: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function one(events: String; selector: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function one(events: String; selector: String; data: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function one(events:       // property Item[key: String]: Variant;
    end;): JJQuery; overload;
    function one(events:       // property Item[key: String]: Variant;
    end;; selector: String): JJQuery; overload;
    function one(events:       // property Item[key: String]: Variant;
    end;; selector: String; data: Variant): JJQuery; overload;
    function one(events:       // property Item[key: String]: Variant;
    end;): JJQuery; overload;
    function one(events:       // property Item[key: String]: Variant;
    end;; data: Variant): JJQuery; overload;
    function ready(handler: (jQueryAlias: JJQueryStatic): Variant): JJQuery;
    function resize: JJQuery;
    function resize(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function resize(eventData: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function scroll: JJQuery;
    function scroll(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function scroll(eventData: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function select: JJQuery;
    function select(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function select(eventData: JObject; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function submit: JJQuery;
    function submit(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function submit: JJQuery; overload;
    function submit(eventData: Variant): JJQuery; overload;
    function submit(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function trigger(eventType: String): JJQuery; overload;
    function trigger(eventType: String; extraParameters: Variant {array of Variant or JObject}): JJQuery; overload;
    function trigger(event: JJQueryEventObject): JJQuery; overload;
    function trigger(event: JJQueryEventObject; extraParameters: Variant {array of Variant or JObject}): JJQuery; overload;
    function triggerHandler(eventType: String; extraParameters: array of Variant): JObject;
    function triggerHandler(event: JJQueryEventObject; extraParameters: array of Variant): JObject;
    function unbind: JJQuery; overload;
    function unbind(eventType: String): JJQuery; overload;
    function unbind(eventType: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function unbind(eventType: String; fls: Boolean): JJQuery;
    function unbind(evt: Variant): JJQuery;
    function undelegate: JJQuery;
    function undelegate(selector: String; eventType: String): JJQuery; overload;
    function undelegate(selector: String; eventType: String; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    function undelegate(selector: String; events: JObject): JJQuery;
    function undelegate(namespace: String): JJQuery;
    function unload(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function unload: JJQuery; overload;
    function unload(eventData: Variant): JJQuery; overload;
    function unload(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery; overload;
    context: JElement;
    jquery: String;
    function error(handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function error(eventData: Variant; handler: (eventObject: JJQueryEventObject): Variant): JJQuery;
    function pushStack(elements: array of Variant): JJQuery;
    function pushStack(elements: array of Variant; name: String; arguments: array of Variant): JJQuery;
    function after(content1: Variant {JJQuery or array of Variant or JElement or JText or String}; content2: array of Variant): JJQuery;
    function after(func: (index: Float; html: String): Variant {String or JElement or JJQuery}): JJQuery;
    function append(content1: Variant {JJQuery or array of Variant or JElement or JText or String}; content2: array of Variant): JJQuery;
    function append(func: (index: Float; html: String): Variant {String or JElement or JJQuery}): JJQuery;
    function appendTo(target: Variant {JJQuery or array of Variant or JElement or String}): JJQuery;
    function before(content1: Variant {JJQuery or array of Variant or JElement or JText or String}; content2: array of Variant): JJQuery;
    function before(func: (index: Float; html: String): Variant {String or JElement or JJQuery}): JJQuery;
    function clone: JJQuery; overload;
    function clone(withDataAndEvents: Boolean): JJQuery; overload;
    function clone(withDataAndEvents: Boolean; deepWithDataAndEvents: Boolean): JJQuery; overload;
    function detach: JJQuery; overload;
    function detach(selector: String): JJQuery; overload;
    function empty: JJQuery;
    function insertAfter(target: Variant {JJQuery or array of Variant or JElement or JText or String}): JJQuery;
    function insertBefore(target: Variant {JJQuery or array of Variant or JElement or JText or String}): JJQuery;
    function prepend(content1: Variant {JJQuery or array of Variant or JElement or JText or String}; content2: array of Variant): JJQuery;
    function prepend(func: (index: Float; html: String): Variant {String or JElement or JJQuery}): JJQuery;
    function prependTo(target: Variant {JJQuery or array of Variant or JElement or String}): JJQuery;
    function remove: JJQuery; overload;
    function remove(selector: String): JJQuery; overload;
    function replaceAll(target: Variant {JJQuery or array of Variant or JElement or String}): JJQuery;
    function replaceWith(newContent: Variant {JJQuery or array of Variant or JElement or JText or String}): JJQuery;
    function replaceWith(func: : Variant {JElement or JJQuery}): JJQuery;
    function text: String;
    function text(text: Variant {String or Float or Boolean}): JJQuery;
    function text(func: (index: Float; text: String): String): JJQuery;
    function toArray: array of Variant;
    function unwrap: JJQuery;
    function wrap(wrappingElement: Variant {JJQuery or JElement or String}): JJQuery;
    function wrap(func: (index: Float): Variant {String or JJQuery}): JJQuery;
    function wrapAll(wrappingElement: Variant {JJQuery or JElement or String}): JJQuery;
    function wrapAll(func: (index: Float): String): JJQuery;
    function wrapInner(wrappingElement: Variant {JJQuery or JElement or String}): JJQuery;
    function wrapInner(func: (index: Float): String): JJQuery;
    function each(func: (index: Float; elem: JElement): Variant): JJQuery;
    function get(index: Float): JHTMLElement;
    function get: array of Variant;
    function index: Float;
    function index(selector: Variant {String or JJQuery or JElement}): Float;
    _length: Float;
    selector: String;
    // property Item[index: String]: Variant;
    // property Item[index: Integer]: JHTMLElement;
    function add(selector: String): JJQuery; overload;
    function add(selector: String; context: JElement): JJQuery; overload;
    function add(elements: array of JElement): JJQuery;
    function add(html: String): JJQuery;
    function add(obj: JJQuery): JJQuery;
    function children: JJQuery; overload;
    function children(selector: String): JJQuery; overload;
    function closest(selector: String): JJQuery;
    function closest(selector: String): JJQuery; overload;
    function closest(selector: String; context: JElement): JJQuery; overload;
    function closest(obj: JJQuery): JJQuery;
    function closest(element: JElement): JJQuery;
    function closest(selectors: Variant): array of Variant; overload;
    function closest(selectors: Variant; context: JElement): array of Variant; overload;
    function contents: JJQuery;
    function end: JJQuery;
    function eq(index: Float): JJQuery;
    function filter(selector: String): JJQuery;
    function filter(func: (index: Float; element: JElement): Variant): JJQuery;
    function filter(element: JElement): JJQuery;
    function filter(obj: JJQuery): JJQuery;
    function find(selector: String): JJQuery;
    function find(element: JElement): JJQuery;
    function find(obj: JJQuery): JJQuery;
    function first: JJQuery;
    function has(selector: String): JJQuery;
    function has(contained: JElement): JJQuery;
    function is(selector: String): Boolean;
    function is(func: (index: Float; element: JElement): Boolean): Boolean;
    function is(obj: JJQuery): Boolean;
    function is(elements: Variant): Boolean;
    function last: JJQuery;
    function map(callback: (index: Float; domElement: JElement): Variant): JJQuery;
    function next: JJQuery; overload;
    function next(selector: String): JJQuery; overload;
    function nextAll: JJQuery; overload;
    function nextAll(selector: String): JJQuery; overload;
    function nextUntil: JJQuery; overload;
    function nextUntil(selector: String): JJQuery; overload;
    function nextUntil(selector: String; filter: String): JJQuery; overload;
    function nextUntil: JJQuery; overload;
    function nextUntil(element: JElement): JJQuery; overload;
    function nextUntil(element: JElement; filter: String): JJQuery; overload;
    function nextUntil: JJQuery; overload;
    function nextUntil(obj: JJQuery): JJQuery; overload;
    function nextUntil(obj: JJQuery; filter: String): JJQuery; overload;
    function not(selector: String): JJQuery;
    function not(func: (index: Float; element: JElement): Boolean): JJQuery;
    function not(elements: Variant {JElement or array of JElement}): JJQuery;
    function not(obj: JJQuery): JJQuery;
    function offsetParent: JJQuery;
    function parent: JJQuery; overload;
    function parent(selector: String): JJQuery; overload;
    function parents: JJQuery; overload;
    function parents(selector: String): JJQuery; overload;
    function parentsUntil: JJQuery; overload;
    function parentsUntil(selector: String): JJQuery; overload;
    function parentsUntil(selector: String; filter: String): JJQuery; overload;
    function parentsUntil: JJQuery; overload;
    function parentsUntil(element: JElement): JJQuery; overload;
    function parentsUntil(element: JElement; filter: String): JJQuery; overload;
    function parentsUntil: JJQuery; overload;
    function parentsUntil(obj: JJQuery): JJQuery; overload;
    function parentsUntil(obj: JJQuery; filter: String): JJQuery; overload;
    function prev: JJQuery; overload;
    function prev(selector: String): JJQuery; overload;
    function prevAll: JJQuery; overload;
    function prevAll(selector: String): JJQuery; overload;
    function prevUntil: JJQuery; overload;
    function prevUntil(selector: String): JJQuery; overload;
    function prevUntil(selector: String; filter: String): JJQuery; overload;
    function prevUntil: JJQuery; overload;
    function prevUntil(element: JElement): JJQuery; overload;
    function prevUntil(element: JElement; filter: String): JJQuery; overload;
    function prevUntil: JJQuery; overload;
    function prevUntil(obj: JJQuery): JJQuery; overload;
    function prevUntil(obj: JJQuery; filter: String): JJQuery; overload;
    function siblings: JJQuery; overload;
    function siblings(selector: String): JJQuery; overload;
    function slice(start: Float): JJQuery; overload;
    function slice(start: Float; &end: Float): JJQuery; overload;
    function queue: array of Variant; overload;
    function queue(queueName: String): array of Variant; overload;
    function queue(newQueue: array of JFunction): JJQuery;
    function queue(callback: JFunction): JJQuery;
    function queue(queueName: String; newQueue: array of JFunction): JJQuery;
    function queue(queueName: String; callback: JFunction): JJQuery;
  end;

//"jquery"

jQuery: JJQueryStatic;
$: JJQueryStatic;
