unit Linq;

interface

//linq

type
  JEnumerableStatic = class external
    function Choice(contents: array of JT): JEnumerable{<JT>};
    function Choice(contents: array of JT): JEnumerable{<JT>};
    function Cycle(contents: array of JT): JEnumerable{<JT>};
    function Cycle(contents: array of JT): JEnumerable{<JT>};
    function Empty: JEnumerable{<JT>};
    function From(obj: array of JT): JEnumerable{<JT>};
    function From(obj: Float): JEnumerable{<Float>};
    function From(obj: String): JEnumerable{<String>};
    function From(obj: JNodeList): JEnumerable{<JNode>};
    function From(obj: JObject): JEnumerable{<JKeyValuePair{<StringVariant>}>};
    function Return(element: JT): JEnumerable{<JT>};
    function Matches(input: String; pattern: JRegExp): JEnumerable{<String>};
    function Matches(input: String; pattern: String): JEnumerable{<String>}; overload;
    function Matches(input: String; pattern: String; flags: String): JEnumerable{<String>}; overload;
    function Range(start: Float; count: Float): JEnumerable{<Float>}; overload;
    function Range(start: Float; count: Float; step: Float): JEnumerable{<Float>}; overload;
    function RangeDown(start: Float; count: Float): JEnumerable{<Float>}; overload;
    function RangeDown(start: Float; count: Float; step: Float): JEnumerable{<Float>}; overload;
    function RangeTo(start: Float; to: Float): JEnumerable{<Float>}; overload;
    function RangeTo(start: Float; to: Float; step: Float): JEnumerable{<Float>}; overload;
    function Repeat(obj: Variant): JEnumerable{<JT>}; overload;
    function Repeat(obj: Variant; count: Float): JEnumerable{<JT>}; overload;
    function RepeatWithFinalize(initializer: : JT; finalizer: (resource: JT)): JEnumerable{<JT>};
    function Generate(func: : JT): JEnumerable{<JT>}; overload;
    function Generate(func: : JT; count: Float): JEnumerable{<JT>}; overload;
    function Generate(func: String): JEnumerable{<Variant>}; overload;
    function Generate(func: String; count: Float): JEnumerable{<Variant>}; overload;
    function ToInfinity: JEnumerable{<Float>}; overload;
    function ToInfinity(start: Float): JEnumerable{<Float>}; overload;
    function ToInfinity(start: Float; step: Float): JEnumerable{<Float>}; overload;
    function ToNegativeInfinity: JEnumerable{<Float>}; overload;
    function ToNegativeInfinity(start: Float): JEnumerable{<Float>}; overload;
    function ToNegativeInfinity(start: Float; step: Float): JEnumerable{<Float>}; overload;
    function Unfold(seed: Variant; func: ($: Variant): JT): JEnumerable{<JT>};
    function Unfold(seed: Variant; func: String): JEnumerable{<Variant>};
  end;

  JEnumerable{<T>} = class external
    function CascadeBreadthFirst(func: ($: Variant): array of Variant; resultSelector: (v: Variant; i: Float): Variant): JEnumerable{<Variant>};
    function CascadeBreadthFirst(func: String; resultSelector: String): JEnumerable{<Variant>};
    function CascadeDepthFirst(func: ($: Variant): array of Variant; resultSelector: (v: Variant; i: Float): Variant): JEnumerable{<Variant>};
    function CascadeDepthFirst(func: String; resultSelector: String): JEnumerable{<Variant>};
    function Flatten(items: array of Variant): JEnumerable{<Variant>};
    function Pairwise(selector: (prev: Variant; next: Variant): Variant): JEnumerable{<Variant>};
    function Pairwise(selector: String): JEnumerable{<Variant>};
    function Scan(func: (a: Variant; b: Variant): Variant): JEnumerable{<Variant>};
    function Scan(func: String): JEnumerable{<Variant>};
    function Scan(seed: Variant; func: (a: Variant; b: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Scan(seed: Variant; func: (a: Variant; b: Variant): Variant; resultSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Scan(seed: Variant; func: String): JEnumerable{<Variant>}; overload;
    function Scan(seed: Variant; func: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function Select(selector: ($: JT; i: Float): JTResult): JEnumerable{<JTResult>};
    function Select(selector: String): JEnumerable{<Variant>};
    function SelectMany(collectionSelector: ($: Variant; i: Float): array of Variant): JEnumerable{<Variant>}; overload;
    function SelectMany(collectionSelector: ($: Variant; i: Float): array of Variant; resultSelector: ($: Variant; item: Variant): Variant): JEnumerable{<Variant>}; overload;
    function SelectMany(collectionSelector: ($: Variant; i: Float): JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function SelectMany(collectionSelector: ($: Variant; i: Float): JEnumerable{<Variant>}; resultSelector: ($: Variant; item: Variant): Variant): JEnumerable{<Variant>}; overload;
    function SelectMany(collectionSelector: String): JEnumerable{<Variant>}; overload;
    function SelectMany(collectionSelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function Where(predicate: ($: JT; i: Float): Boolean): JEnumerable{<JT>};
    function Where(predicate: String): JEnumerable{<Variant>};
    function OfType(&type: JFunction): JEnumerable{<Variant>};
    function Zip(second: array of Variant; selector: (v1: Variant; v2: Variant; i: Float): Variant): JEnumerable{<Variant>};
    function Zip(second: array of Variant; selector: String): JEnumerable{<Variant>};
    function Zip(second: JEnumerable{<Variant>}; selector: (v1: Variant; v2: Variant; i: Float): Variant): JEnumerable{<Variant>};
    function Zip(second: JEnumerable{<Variant>}; selector: String): JEnumerable{<Variant>};
    function Join(inner: array of Variant; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Join(inner: array of Variant; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: Variant): Variant; compareSelector: (v: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Join(inner: array of Variant; outerKeySelector: String; innerKeySelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function Join(inner: array of Variant; outerKeySelector: String; innerKeySelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function Join(inner: JEnumerable{<Variant>}; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Join(inner: JEnumerable{<Variant>}; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: Variant): Variant; compareSelector: (v: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Join(inner: JEnumerable{<Variant>}; outerKeySelector: String; innerKeySelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function Join(inner: JEnumerable{<Variant>}; outerKeySelector: String; innerKeySelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: array of Variant; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: JEnumerable{<Variant>}): Variant): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: array of Variant; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: JEnumerable{<Variant>}): Variant; compareSelector: (v: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: array of Variant; outerKeySelector: String; innerKeySelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: array of Variant; outerKeySelector: String; innerKeySelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: JEnumerable{<Variant>}; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: JEnumerable{<Variant>}): Variant): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: JEnumerable{<Variant>}; outerKeySelector: (v1: Variant): Variant; innerKeySelector: (v1: Variant): Variant; resultSelector: (v1: Variant; v2: JEnumerable{<Variant>}): Variant; compareSelector: (v: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: JEnumerable{<Variant>}; outerKeySelector: String; innerKeySelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function GroupJoin(inner: JEnumerable{<Variant>}; outerKeySelector: String; innerKeySelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function All(predicate: ($: JT): Boolean): Boolean;
    function All(predicate: String): Boolean;
    function Any: Boolean; overload;
    function Any(predicate: ($: JT): Boolean): Boolean; overload;
    function Any: Boolean; overload;
    function Any(predicate: String): Boolean; overload;
    function Concat(second: array of Variant): JEnumerable{<Variant>};
    function Concat(second: JEnumerable{<Variant>}): JEnumerable{<Variant>};
    function Insert(index: Float; second: array of Variant): JEnumerable{<Variant>};
    function Insert(index: Float; second: JEnumerable{<Variant>}): JEnumerable{<Variant>};
    function Alternate(value: Variant): JEnumerable{<Variant>};
    function Contains(value: Variant): Boolean; overload;
    function Contains(value: Variant; compareSelector: ($: Variant): Variant): Boolean; overload;
    function Contains(value: Variant): Boolean; overload;
    function Contains(value: Variant; compareSelector: String): Boolean; overload;
    function DefaultIfEmpty(defaultValue: Variant): JEnumerable{<Variant>};
    function Distinct: JEnumerable{<Variant>}; overload;
    function Distinct(compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Distinct: JEnumerable{<Variant>}; overload;
    function Distinct(compareSelector: String): JEnumerable{<Variant>}; overload;
    function Except(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Except(second: array of Variant; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Except(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Except(second: array of Variant; compareSelector: String): JEnumerable{<Variant>}; overload;
    function Except(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Except(second: JEnumerable{<Variant>}; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Except(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Except(second: JEnumerable{<Variant>}; compareSelector: String): JEnumerable{<Variant>}; overload;
    function Intersect(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Intersect(second: array of Variant; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Intersect(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Intersect(second: array of Variant; compareSelector: String): JEnumerable{<Variant>}; overload;
    function Intersect(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Intersect(second: JEnumerable{<Variant>}; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Intersect(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Intersect(second: JEnumerable{<Variant>}; compareSelector: String): JEnumerable{<Variant>}; overload;
    function SequenceEqual(second: array of Variant): Boolean; overload;
    function SequenceEqual(second: array of Variant; compareSelector: ($: Variant): Variant): Boolean; overload;
    function SequenceEqual(second: array of Variant): Boolean; overload;
    function SequenceEqual(second: array of Variant; compareSelector: String): Boolean; overload;
    function SequenceEqual(second: JEnumerable{<Variant>}): Boolean; overload;
    function SequenceEqual(second: JEnumerable{<Variant>}; compareSelector: ($: Variant): Variant): Boolean; overload;
    function SequenceEqual(second: JEnumerable{<Variant>}): Boolean; overload;
    function SequenceEqual(second: JEnumerable{<Variant>}; compareSelector: String): Boolean; overload;
    function Union(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Union(second: array of Variant; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Union(second: array of Variant): JEnumerable{<Variant>}; overload;
    function Union(second: array of Variant; compareSelector: String): JEnumerable{<Variant>}; overload;
    function Union(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Union(second: JEnumerable{<Variant>}; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Union(second: JEnumerable{<Variant>}): JEnumerable{<Variant>}; overload;
    function Union(second: JEnumerable{<Variant>}; compareSelector: String): JEnumerable{<Variant>}; overload;
    function OrderBy: JOrderedEnumerable{<JT>}; overload;
    function OrderBy(keySelector: ($: JT): Variant): JOrderedEnumerable{<JT>}; overload;
    function OrderBy: JOrderedEnumerable{<JT>}; overload;
    function OrderBy(keySelector: String): JOrderedEnumerable{<JT>}; overload;
    function OrderByDescending: JOrderedEnumerable{<JT>}; overload;
    function OrderByDescending(keySelector: ($: Variant): Variant): JOrderedEnumerable{<JT>}; overload;
    function OrderByDescending: JOrderedEnumerable{<JT>}; overload;
    function OrderByDescending(keySelector: String): JOrderedEnumerable{<JT>}; overload;
    function Reverse: JEnumerable{<JT>};
    function Shuffle: JEnumerable{<JT>};
    function GroupBy(keySelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; resultSelector: (key: Variant; e: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; resultSelector: (key: Variant; e: Variant): Variant; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: String): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: String; elementSelector: String): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: String; elementSelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function GroupBy(keySelector: String; elementSelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; resultSelector: (key: Variant; e: Variant): Variant): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; resultSelector: (key: Variant; e: Variant): Variant; compareSelector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: String): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: String; elementSelector: String): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: String; elementSelector: String; resultSelector: String): JEnumerable{<Variant>}; overload;
    function PartitionBy(keySelector: String; elementSelector: String; resultSelector: String; compareSelector: String): JEnumerable{<Variant>}; overload;
    function BufferWithCount(count: Float): JEnumerable{<Variant>};
    procedure Aggregate(func: (a: Variant; b: Variant): Variant);
    procedure Aggregate(seed: Variant; func: (a: Variant; b: Variant): Variant); overload;
    procedure Aggregate(seed: Variant; func: (a: Variant; b: Variant): Variant; resultSelector: ($: Variant): Variant); overload;
    procedure Aggregate(func: String);
    procedure Aggregate(seed: Variant; func: String); overload;
    procedure Aggregate(seed: Variant; func: String; resultSelector: String); overload;
    function Average: Float; overload;
    function Average(selector: ($: Variant): Float): Float; overload;
    function Average: Float; overload;
    function Average(selector: String): Float; overload;
    function Count: Float; overload;
    function Count(predicate: ($: Variant): Boolean): Float; overload;
    function Count: Float; overload;
    function Count(predicate: String): Float; overload;
    function Max: Variant; overload;
    function Max(selector: ($: JT): Variant): Variant; overload;
    function Max: JDate; overload;
    function Max(selector: ($: JT): JDate): JDate; overload;
    function Max: Float; overload;
    function Max(selector: ($: JT): Float): Float; overload;
    function Max(selector: ($: JT): String): String;
    function Max: Variant; overload;
    function Max(selector: String): Variant; overload;
    function Min: Variant; overload;
    function Min(selector: ($: JT): Variant): Variant; overload;
    function Min: JDate; overload;
    function Min(selector: ($: JT): JDate): JDate; overload;
    function Min(selector: ($: JT): String): String;
    function Min: Float; overload;
    function Min(selector: ($: JT): Float): Float; overload;
    function Min: Variant; overload;
    function Min(selector: String): Variant; overload;
    function MaxBy(selector: ($: JT): Variant): Variant;
    function MaxBy(selector: ($: JT): String): String;
    function MaxBy(selector: ($: JT): JDate): JDate;
    function MaxBy(selector: ($: JT): Float): Float;
    function MaxBy(selector: String): Variant;
    function MinBy(selector: ($: JT): JDate): JDate;
    function MinBy(selector: ($: JT): Float): Variant;
    function MinBy(selector: ($: JT): String): String;
    function MinBy(selector: ($: JT): Variant): Variant;
    function MinBy(selector: String): Variant;
    function Sum: Float; overload;
    function Sum(selector: ($: Variant): Float): Float; overload;
    function Sum: Float; overload;
    function Sum(selector: String): Float; overload;
    function ElementAt(index: Float): JT;
    function ElementAtOrDefault(index: Float; defaultValue: JT): JT;
    function First: JT; overload;
    function First(predicate: ($: JT): Boolean): JT; overload;
    function First: JT; overload;
    function First(predicate: String): JT; overload;
    function FirstOrDefault(defaultValue: JT): JT; overload;
    function FirstOrDefault(defaultValue: JT; predicate: ($: JT): Boolean): JT; overload;
    function FirstOrDefault(defaultValue: JT): JT; overload;
    function FirstOrDefault(defaultValue: JT; predicate: String): JT; overload;
    function Last: JT; overload;
    function Last(predicate: ($: JT): Boolean): JT; overload;
    function Last: JT; overload;
    function Last(predicate: String): JT; overload;
    function LastOrDefault(defaultValue: JT): JT; overload;
    function LastOrDefault(defaultValue: JT; predicate: ($: JT): Boolean): JT; overload;
    function LastOrDefault(defaultValue: JT): JT; overload;
    function LastOrDefault(defaultValue: JT; predicate: String): JT; overload;
    function Single: JT; overload;
    function Single(predicate: ($: JT): Boolean): JT; overload;
    function Single: JT; overload;
    function Single(predicate: String): JT; overload;
    function SingleOrDefault(defaultValue: JT): JT; overload;
    function SingleOrDefault(defaultValue: JT; predicate: ($: JT): Boolean): JT; overload;
    function SingleOrDefault(defaultValue: JT): JT; overload;
    function SingleOrDefault(defaultValue: JT; predicate: String): JT; overload;
    function Skip(count: Float): JEnumerable{<JT>};
    function SkipWhile(predicate: ($: JT; i: Float): Boolean): JEnumerable{<JT>};
    function SkipWhile(predicate: String): JEnumerable{<JT>};
    function Take(count: Float): JEnumerable{<JT>};
    function TakeWhile(predicate: ($: JT; i: Float): Boolean): JEnumerable{<JT>};
    function TakeWhile(predicate: String): JEnumerable{<JT>};
    function TakeExceptLast: JEnumerable{<JT>}; overload;
    function TakeExceptLast(count: Float): JEnumerable{<JT>}; overload;
    function TakeFromLast(count: Float): JEnumerable{<JT>};
    function IndexOf(item: Variant): Float;
    function LastIndexOf(item: Variant): Float;
    function ToArray: array of JT;
    function ToLookup(keySelector: ($: Variant): Variant): JLookup{<JT>}; overload;
    function ToLookup(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant): JLookup{<JT>}; overload;
    function ToLookup(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; compareSelector: (key: Variant): Variant): JLookup{<JT>}; overload;
    function ToLookup(keySelector: String): JLookup{<JT>}; overload;
    function ToLookup(keySelector: String; elementSelector: String): JLookup{<JT>}; overload;
    function ToLookup(keySelector: String; elementSelector: String; compareSelector: String): JLookup{<JT>}; overload;
    function ToObject(keySelector: ($: Variant): String; elementSelector: ($: Variant): Variant): Variant;
    function ToObject(keySelector: String; elementSelector: String): Variant;
    function ToDictionary(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant): JDictionary{<JT>}; overload;
    function ToDictionary(keySelector: ($: Variant): Variant; elementSelector: ($: Variant): Variant; compareSelector: (key: Variant): Variant): JDictionary{<JT>}; overload;
    function ToDictionary(keySelector: String; elementSelector: String): JDictionary{<JT>}; overload;
    function ToDictionary(keySelector: String; elementSelector: String; compareSelector: String): JDictionary{<JT>}; overload;
    function ToJSON: String; overload;
    function ToJSON(replacer: (key: Variant; value: Variant): Variant): String; overload;
    function ToJSON(replacer: (key: Variant; value: Variant): Variant; space: Float): String; overload;
    function ToJSON: String; overload;
    function ToJSON(replacer: String): String; overload;
    function ToJSON(replacer: String; space: Float): String; overload;
    function ToString: String; overload;
    function ToString(separator: String): String; overload;
    function ToString(separator: String; selector: ($: Variant): Variant): String; overload;
    function ToString: String; overload;
    function ToString(separator: String): String; overload;
    function ToString(separator: String; selector: String): String; overload;
    function Do(action: ($: Variant; i: Float)): JEnumerable{<Variant>};
    function Do(action: String): JEnumerable{<Variant>};
    procedure ForEach(action: ($: JT; i: Float));
    procedure ForEach(func: ($: JT; i: Float): Boolean);
    procedure ForEach(action_func: String);
    procedure Write; overload;
    procedure Write(separator: String); overload;
    procedure Write(separator: String; selector: ($: Variant): Variant); overload;
    procedure Write; overload;
    procedure Write(separator: String); overload;
    procedure Write(separator: String; selector: String); overload;
    procedure WriteLine; overload;
    procedure WriteLine(selector: ($: Variant): Variant); overload;
    procedure Force;
    function Let(func: (e: JEnumerable{<Variant>}): JEnumerable{<Variant>}): JEnumerable{<Variant>};
    function Share: JEnumerable{<Variant>};
    function MemoizeAll: JEnumerable{<Variant>};
    function Catch(handler: (error: JError)): JEnumerable{<Variant>};
    function Catch(handler: String): JEnumerable{<Variant>};
    function Finally(finallyAction: ): JEnumerable{<Variant>};
    function Finally(finallyAction: String): JEnumerable{<Variant>};
    function Trace: JEnumerable{<Variant>}; overload;
    function Trace(message: String): JEnumerable{<Variant>}; overload;
    function Trace(message: String; selector: ($: Variant): Variant): JEnumerable{<Variant>}; overload;
    function Trace: JEnumerable{<Variant>}; overload;
    function Trace(message: String): JEnumerable{<Variant>}; overload;
    function Trace(message: String; selector: String): JEnumerable{<Variant>}; overload;
  end;

  JOrderedEnumerable{<T>} = class external(JEnumerable {JT} )
    function ThenBy(keySelector: ($: JT): Variant): JOrderedEnumerable{<JT>};
    function ThenBy(keySelector: String): JOrderedEnumerable{<JT>};
    function ThenByDescending(keySelector: ($: JT): Variant): JOrderedEnumerable{<JT>};
    function ThenByDescending(keySelector: String): JOrderedEnumerable{<JT>};
  end;

  JGrouping{<T>} = class external(JEnumerable {JT} )
    procedure Key;
  end;

  JLookup{<TValue>} = class external
    function Count: Float;
    function Get(key: Variant): JEnumerable{<JTValue>};
    function Contains(key: Variant): Boolean;
    function ToEnumerable: JEnumerable{<JTValue>};
  end;

  JDictionary{<TValue>} = class external
    procedure Add(key: Variant; value: Variant);
    function Get(key: Variant): Variant;
    function Set(key: Variant; value: Variant): Boolean;
    function Contains(key: Variant): Boolean;
    procedure Clear;
    procedure Remove(key: Variant);
    function Count: Float;
    function ToEnumerable: JEnumerable{<JTValue>};
  end;

  JKeyValuePair{<TKeyTValue>} = class external
    Key: JTKey;
    Value: JTValue;
  end;

Enumerable: Jlinq.EnumerableStatic;
