unit Node;

interface

type
  JError = class external
    stack: String; // nullable
  end;

  JMapConstructor = class external
  end;

  JWeakMapConstructor = class external
  end;

  JSetConstructor = class external
  end;

  JWeakSetConstructor = class external
  end;

  JNodeRequireFunction = class external
(id: String): Variant  end;

  JNodeRequire = class external(JNodeRequireFunction)
    function resolve(id: String): String;
    cache: Variant;
    extensions: Variant;
    main: Variant;
  end;

  JNodeModule = class external
    exports: Variant;
    require: JNodeRequireFunction;
    id: String;
    filename: String;
    loaded: Boolean;
    parent: Variant;
    children: array of Variant;
  end;

  JBuffer = class external(JNodeBuffer)
  end;

  JNodeBuffer = class external
    // property Item[index: Integer]: Float;
    function write(&string: String): Float; overload;
    function write(&string: String; offset: Float): Float; overload;
    function write(&string: String; offset: Float; _length: Float): Float; overload;
    function write(&string: String; offset: Float; _length: Float; encoding: String): Float; overload;
    function toString: String; overload;
    function toString(encoding: String): String; overload;
    function toString(encoding: String; start: Float): String; overload;
    function toString(encoding: String; start: Float; &end: Float): String; overload;
    function toJSON: Variant;
    _length: Float;
    function equals(otherBuffer: JBuffer): Boolean;
    function compare(otherBuffer: JBuffer): Float;
    function copy(targetBuffer: JBuffer): Float; overload;
    function copy(targetBuffer: JBuffer; targetStart: Float): Float; overload;
    function copy(targetBuffer: JBuffer; targetStart: Float; sourceStart: Float): Float; overload;
    function copy(targetBuffer: JBuffer; targetStart: Float; sourceStart: Float; sourceEnd: Float): Float; overload;
    function slice: JBuffer; overload;
    function slice(start: Float): JBuffer; overload;
    function slice(start: Float; &end: Float): JBuffer; overload;
    function writeUIntLE(value: Float; offset: Float; byteLength: Float): Float; overload;
    function writeUIntLE(value: Float; offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function writeUIntBE(value: Float; offset: Float; byteLength: Float): Float; overload;
    function writeUIntBE(value: Float; offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function writeIntLE(value: Float; offset: Float; byteLength: Float): Float; overload;
    function writeIntLE(value: Float; offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function writeIntBE(value: Float; offset: Float; byteLength: Float): Float; overload;
    function writeIntBE(value: Float; offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function readUIntLE(offset: Float; byteLength: Float): Float; overload;
    function readUIntLE(offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function readUIntBE(offset: Float; byteLength: Float): Float; overload;
    function readUIntBE(offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function readIntLE(offset: Float; byteLength: Float): Float; overload;
    function readIntLE(offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function readIntBE(offset: Float; byteLength: Float): Float; overload;
    function readIntBE(offset: Float; byteLength: Float; noAssert: Boolean): Float; overload;
    function readUInt8(offset: Float): Float; overload;
    function readUInt8(offset: Float; noAsset: Boolean): Float; overload;
    function readUInt16LE(offset: Float): Float; overload;
    function readUInt16LE(offset: Float; noAssert: Boolean): Float; overload;
    function readUInt16BE(offset: Float): Float; overload;
    function readUInt16BE(offset: Float; noAssert: Boolean): Float; overload;
    function readUInt32LE(offset: Float): Float; overload;
    function readUInt32LE(offset: Float; noAssert: Boolean): Float; overload;
    function readUInt32BE(offset: Float): Float; overload;
    function readUInt32BE(offset: Float; noAssert: Boolean): Float; overload;
    function readInt8(offset: Float): Float; overload;
    function readInt8(offset: Float; noAssert: Boolean): Float; overload;
    function readInt16LE(offset: Float): Float; overload;
    function readInt16LE(offset: Float; noAssert: Boolean): Float; overload;
    function readInt16BE(offset: Float): Float; overload;
    function readInt16BE(offset: Float; noAssert: Boolean): Float; overload;
    function readInt32LE(offset: Float): Float; overload;
    function readInt32LE(offset: Float; noAssert: Boolean): Float; overload;
    function readInt32BE(offset: Float): Float; overload;
    function readInt32BE(offset: Float; noAssert: Boolean): Float; overload;
    function readFloatLE(offset: Float): Float; overload;
    function readFloatLE(offset: Float; noAssert: Boolean): Float; overload;
    function readFloatBE(offset: Float): Float; overload;
    function readFloatBE(offset: Float; noAssert: Boolean): Float; overload;
    function readDoubleLE(offset: Float): Float; overload;
    function readDoubleLE(offset: Float; noAssert: Boolean): Float; overload;
    function readDoubleBE(offset: Float): Float; overload;
    function readDoubleBE(offset: Float; noAssert: Boolean): Float; overload;
    function writeUInt8(value: Float; offset: Float): Float; overload;
    function writeUInt8(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeUInt16LE(value: Float; offset: Float): Float; overload;
    function writeUInt16LE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeUInt16BE(value: Float; offset: Float): Float; overload;
    function writeUInt16BE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeUInt32LE(value: Float; offset: Float): Float; overload;
    function writeUInt32LE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeUInt32BE(value: Float; offset: Float): Float; overload;
    function writeUInt32BE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeInt8(value: Float; offset: Float): Float; overload;
    function writeInt8(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeInt16LE(value: Float; offset: Float): Float; overload;
    function writeInt16LE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeInt16BE(value: Float; offset: Float): Float; overload;
    function writeInt16BE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeInt32LE(value: Float; offset: Float): Float; overload;
    function writeInt32LE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeInt32BE(value: Float; offset: Float): Float; overload;
    function writeInt32BE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeFloatLE(value: Float; offset: Float): Float; overload;
    function writeFloatLE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeFloatBE(value: Float; offset: Float): Float; overload;
    function writeFloatBE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeDoubleLE(value: Float; offset: Float): Float; overload;
    function writeDoubleLE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function writeDoubleBE(value: Float; offset: Float): Float; overload;
    function writeDoubleBE(value: Float; offset: Float; noAssert: Boolean): Float; overload;
    function fill(value: Variant): JBuffer; overload;
    function fill(value: Variant; offset: Float): JBuffer; overload;
    function fill(value: Variant; offset: Float; &end: Float): JBuffer; overload;
    function indexOf(value: Variant {String or Float or JBuffer}): Float; overload;
    function indexOf(value: Variant {String or Float or JBuffer}; byteOffset: Float): Float; overload;
  end;

process: JNodeJS.Process;
global: JNodeJS.Global;
__filename: String;
__dirname: String;
function setTimeout(callback: (args: array of Variant); ms: Float; args: array of Variant): JNodeJS.Timer;
procedure clearTimeout(timeoutId: JNodeJS.Timer);
function setInterval(callback: (args: array of Variant); ms: Float; args: array of Variant): JNodeJS.Timer;
procedure clearInterval(intervalId: JNodeJS.Timer);
function setImmediate(callback: (args: array of Variant); args: array of Variant): Variant;
procedure clearImmediate(immediateId: Variant);
require: JNodeRequire;
module: JNodeModule;
exports: Variant;
SlowBuffer:   constructor CreateJBuffer;
  constructor CreateJBuffer;
  constructor CreateJBuffer;
  constructor CreateJBuffer;
  prototype: JBuffer;
  function isBuffer(obj: Variant): Boolean;
  function byteLength(&string: String): Float; overload;
  function byteLength(&string: String; encoding: String): Float; overload;
  function concat(list: array of JBuffer): JBuffer; overload;
  function concat(list: array of JBuffer; totalLength: Float): JBuffer; overload;
end;;
Buffer:   constructor CreateJBuffer;
  constructor CreateJBuffer;
  constructor CreateJBuffer;
  constructor CreateJBuffer;
  constructor CreateJBuffer;
  prototype: JBuffer;
  function isBuffer(obj: Variant): Boolean;
  function isEncoding(encoding: String): Boolean;
  function byteLength(&string: String): Float; overload;
  function byteLength(&string: String; encoding: String): Float; overload;
  function concat(list: array of JBuffer): JBuffer; overload;
  function concat(list: array of JBuffer; totalLength: Float): JBuffer; overload;
  function compare(buf1: JBuffer; buf2: JBuffer): Float;
end;;
//NodeJS

type
  JErrnoException = class external(JError)
    errno: Float; // nullable
    code: String; // nullable
    path: String; // nullable
    syscall: String; // nullable
    stack: String; // nullable
  end;

  JEventEmitter = class external
    function addListener(event: String; listener: JFunction): JEventEmitter;
    function on(event: String; listener: JFunction): JEventEmitter;
    function once(event: String; listener: JFunction): JEventEmitter;
    function removeListener(event: String; listener: JFunction): JEventEmitter;
    function removeAllListeners: JEventEmitter; overload;
    function removeAllListeners(event: String): JEventEmitter; overload;
    function setMaxListeners(n: Float): JEventEmitter;
    function getMaxListeners: Float;
    function listeners(event: String): array of JFunction;
    function emit(event: String; args: array of Variant): Boolean;
    function listenerCount(&type: String): Float;
  end;

  JReadableStream = class external(JEventEmitter)
    readable: Boolean;
    function read: Variant {String or JBuffer}; overload;
    function read(size: Float): Variant {String or JBuffer}; overload;
    procedure setEncoding(encoding: String);
    procedure pause;
    procedure resume;
    procedure unshift(chunk: String);
    procedure unshift(chunk: JBuffer);
    function wrap(oldStream: JReadableStream): JReadableStream;
  end;

  JWritableStream = class external(JEventEmitter)
    writable: Boolean;
    function write(buffer: Variant {JBuffer or String}): Boolean; overload;
    function write(buffer: Variant {JBuffer or String}; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; cb: JFunction): Boolean; overload;
    procedure end;
    procedure end(buffer: JBuffer); overload;
    procedure end(buffer: JBuffer; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; encoding: String); overload;
    procedure end(str: String; encoding: String; cb: JFunction); overload;
  end;

  JReadWriteStream = class external(JReadableStream, JWritableStream)
  end;

  JProcess = class external(JEventEmitter)
    stdout: JWritableStream;
    stderr: JWritableStream;
    stdin: JReadableStream;
    argv: array of String;
    execPath: String;
    procedure abort;
    procedure chdir(directory: String);
    function cwd: String;
    env: Variant;
    procedure exit; overload;
    procedure exit(code: Float); overload;
    function getgid: Float;
    procedure setgid(id: Float);
    procedure setgid(id: String);
    function getuid: Float;
    procedure setuid(id: Float);
    procedure setuid(id: String);
    version: String;
    versions:       http_parser: String;
      node: String;
      v8: String;
      ares: String;
      uv: String;
      zlib: String;
      openssl: String;
    end;;
    config:       target_defaults:         cflags: array of Variant;
        default_configuration: String;
        defines: array of String;
        include_dirs: array of String;
        libraries: array of String;
      end;;
      variables:         clang: Float;
        host_arch: String;
        node_install_npm: Boolean;
        node_install_waf: Boolean;
        node_prefix: String;
        node_shared_openssl: Boolean;
        node_shared_v8: Boolean;
        node_shared_zlib: Boolean;
        node_use_dtrace: Boolean;
        node_use_etw: Boolean;
        node_use_openssl: Boolean;
        target_arch: String;
        v8_no_strict_aliasing: Float;
        v8_use_snapshot: Boolean;
        visibility: String;
      end;;
    end;;
    procedure kill(pid: Float); overload;
    procedure kill(pid: Float; signal: Variant {String or Float}); overload;
    pid: Float;
    title: String;
    arch: String;
    platform: String;
    function memoryUsage:       rss: Float;
      heapTotal: Float;
      heapUsed: Float;
    end;;
    procedure nextTick(callback: JFunction);
    function umask: Float; overload;
    function umask(mask: Float): Float; overload;
    function uptime: Float;
    function hrtime: array of Float; overload;
    function hrtime(time: array of Float): array of Float; overload;
    procedure send(message: Variant); overload;
    procedure send(message: Variant; sendHandle: Variant); overload;
  end;

  JGlobal = class external
    Array: Jtype of;
    ArrayBuffer: Jtype of;
    Boolean: Jtype of;
    Buffer: Jtype of;
    DataView: Jtype of;
    Date: Jtype of;
    Error: Jtype of;
    EvalError: Jtype of;
    Float32Array: Jtype of;
    Float64Array: Jtype of;
    &Function: Jtype of;
    GLOBAL: JGlobal;
    Infinity: Jtype of;
    Int16Array: Jtype of;
    Int32Array: Jtype of;
    Int8Array: Jtype of;
    Intl: Jtype of;
    JSON: Jtype of;
    Map: JMapConstructor;
    Math: Jtype of;
    NaN: Jtype of;
    Number: Jtype of;
    &Object: Jtype of;
    Promise: JFunction;
    RangeError: Jtype of;
    ReferenceError: Jtype of;
    RegExp: Jtype of;
    Set: JSetConstructor;
    &String: Jtype of;
    Symbol: JFunction;
    SyntaxError: Jtype of;
    TypeError: Jtype of;
    URIError: Jtype of;
    Uint16Array: Jtype of;
    Uint32Array: Jtype of;
    Uint8Array: Jtype of;
    Uint8ClampedArray: JFunction;
    WeakMap: JWeakMapConstructor;
    WeakSet: JWeakSetConstructor;
    clearImmediate: (immediateId: Variant);
    clearInterval: (intervalId: JNodeJS.Timer);
    clearTimeout: (timeoutId: JNodeJS.Timer);
    console: Jtype of;
    decodeURI: Jtype of;
    decodeURIComponent: Jtype of;
    encodeURI: Jtype of;
    encodeURIComponent: Jtype of;
    escape: (str: String): String;
    eval: Jtype of;
    global: JGlobal;
    isFinite: Jtype of;
    isNaN: Jtype of;
    parseFloat: Jtype of;
    parseInt: Jtype of;
    process: JProcess;
    root: JGlobal;
    setImmediate: (callback: (args: array of Variant); args: array of Variant): Variant;
    setInterval: (callback: (args: array of Variant); ms: Float; args: array of Variant): JNodeJS.Timer;
    setTimeout: (callback: (args: array of Variant); ms: Float; args: array of Variant): JNodeJS.Timer;
    undefined: Jtype of;
    unescape: (str: String): String;
    gc: ;
    v8debug: Variant; // nullable
  end;

  JTimer = class external
    procedure ref;
    procedure unref;
  end;

//"buffer"

var
  INSPECT_MAX_BYTES: Float;

//"querystring"

type
  JStringifyOptions = class external
    encodeURIComponent: JFunction; // nullable
  end;

  JParseOptions = class external
    maxKeys: Float; // nullable
    decodeURIComponent: JFunction; // nullable
  end;

function stringify(obj: JT): String; overload;
function stringify(obj: JT; sep: String): String; overload;
function stringify(obj: JT; sep: String; eq: String): String; overload;
function stringify(obj: JT; sep: String; eq: String; options: JStringifyOptions): String; overload;
function parse(str: String): Variant; overload;
function parse(str: String; sep: String): Variant; overload;
function parse(str: String; sep: String; eq: String): Variant; overload;
function parse(str: String; sep: String; eq: String; options: JParseOptions): Variant; overload;
function parse(str: String): JT; overload;
function parse(str: String; sep: String): JT; overload;
function parse(str: String; sep: String; eq: String): JT; overload;
function parse(str: String; sep: String; eq: String; options: JParseOptions): JT; overload;
function escape(str: String): String;
function unescape(str: String): String;

//"events"

type
  JEventEmitter = class external 'EventEmitter'
    EventEmitter: JEventEmitter;
    function listenerCount(emitter: JEventEmitter; event: String): Float;
    defaultMaxListeners: Float;
    function addListener(event: String; listener: JFunction): JEventEmitter;
    function on(event: String; listener: JFunction): JEventEmitter;
    function once(event: String; listener: JFunction): JEventEmitter;
    function removeListener(event: String; listener: JFunction): JEventEmitter;
    function removeAllListeners: JEventEmitter; overload;
    function removeAllListeners(event: String): JEventEmitter; overload;
    function setMaxListeners(n: Float): JEventEmitter;
    function getMaxListeners: Float;
    function listeners(event: String): array of JFunction;
    function emit(event: String; args: array of Variant): Boolean;
    function listenerCount(&type: String): Float;
  end;

//"http"

type
  JAgent = class external 'Agent'
    maxSockets: Float;
    sockets: Variant;
    requests: Variant;
    constructor Create(opts: JAgentOptions);
    procedure destroy;
  end;

  JRequestOptions = class external
    protocol: String; // nullable
    host: String; // nullable
    hostname: String; // nullable
    family: Float; // nullable
    port: Float; // nullable
    localAddress: String; // nullable
    socketPath: String; // nullable
    method: String; // nullable
    path: String; // nullable
    headers:       // property Item[key: String]: Variant;
    end;; // nullable
    auth: String; // nullable
    agent: Variant {JAgent or Boolean}; // nullable
  end;

  JServer = class external(Jevents.EventEmitter)
    function listen(port: Float): JServer; overload;
    function listen(port: Float; hostname: String): JServer; overload;
    function listen(port: Float; hostname: String; backlog: Float): JServer; overload;
    function listen(port: Float; hostname: String; backlog: Float; callback: JFunction): JServer; overload;
    function listen(port: Float): JServer; overload;
    function listen(port: Float; hostname: String): JServer; overload;
    function listen(port: Float; hostname: String; callback: JFunction): JServer; overload;
    function listen(path: String): JServer; overload;
    function listen(path: String; callback: JFunction): JServer; overload;
    function listen(handle: Variant): JServer; overload;
    function listen(handle: Variant; listeningListener: JFunction): JServer; overload;
    function close: JServer; overload;
    function close(cb: Variant): JServer; overload;
    function address:       port: Float;
      family: String;
      address: String;
    end;;
    maxHeadersCount: Float;
  end;

  JServerRequest = class external(JIncomingMessage)
    connection: Jnet.Socket;
  end;

  JServerResponse = class external(Jevents.EventEmitter, Jstream.Writable)
    function write(buffer: JBuffer): Boolean;
    function write(buffer: JBuffer): Boolean; overload;
    function write(buffer: JBuffer; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; fd: String): Boolean; overload;
    procedure writeContinue;
    procedure writeHead(statusCode: Float); overload;
    procedure writeHead(statusCode: Float; reasonPhrase: String); overload;
    procedure writeHead(statusCode: Float; reasonPhrase: String; headers: Variant); overload;
    procedure writeHead(statusCode: Float); overload;
    procedure writeHead(statusCode: Float; headers: Variant); overload;
    statusCode: Float;
    statusMessage: String;
    headersSent: Boolean;
    procedure setHeader(name: String; value: String);
    sendDate: Boolean;
    function getHeader(name: String): String;
    procedure removeHeader(name: String);
    function write(chunk: Variant): Variant; overload;
    function write(chunk: Variant; encoding: String): Variant; overload;
    procedure addTrailers(headers: Variant);
    procedure end;
    procedure end(buffer: JBuffer); overload;
    procedure end(buffer: JBuffer; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; encoding: String); overload;
    procedure end(str: String; encoding: String; cb: JFunction); overload;
    procedure end; overload;
    procedure end(data: Variant); overload;
    procedure end(data: Variant; encoding: String); overload;
  end;

  JClientRequest = class external(Jevents.EventEmitter, Jstream.Writable)
    function write(buffer: JBuffer): Boolean;
    function write(buffer: JBuffer): Boolean; overload;
    function write(buffer: JBuffer; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; fd: String): Boolean; overload;
    procedure write(chunk: Variant); overload;
    procedure write(chunk: Variant; encoding: String); overload;
    procedure abort;
    procedure setTimeout(timeout: Float); overload;
    procedure setTimeout(timeout: Float; callback: JFunction); overload;
    procedure setNoDelay; overload;
    procedure setNoDelay(noDelay: Boolean); overload;
    procedure setSocketKeepAlive; overload;
    procedure setSocketKeepAlive(enable: Boolean); overload;
    procedure setSocketKeepAlive(enable: Boolean; initialDelay: Float); overload;
    procedure end;
    procedure end(buffer: JBuffer); overload;
    procedure end(buffer: JBuffer; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; encoding: String); overload;
    procedure end(str: String; encoding: String; cb: JFunction); overload;
    procedure end; overload;
    procedure end(data: Variant); overload;
    procedure end(data: Variant; encoding: String); overload;
  end;

  JIncomingMessage = class external(Jevents.EventEmitter, Jstream.Readable)
    httpVersion: String;
    headers: Variant;
    rawHeaders: array of String;
    trailers: Variant;
    rawTrailers: Variant;
    function setTimeout(msecs: Float; callback: JFunction): JNodeJS.Timer;
    method: String; // nullable
    url: String; // nullable
    statusCode: Float; // nullable
    statusMessage: String; // nullable
    socket: Jnet.Socket;
  end;

  JClientResponse = class external(JIncomingMessage)
  end;

  JAgentOptions = class external
    keepAlive: Boolean; // nullable
    keepAliveMsecs: Float; // nullable
    maxSockets: Float; // nullable
    maxFreeSockets: Float; // nullable
  end;

function createServer: JServer; overload;
function createServer(requestListener: (request: JIncomingMessage; response: JServerResponse)): JServer; overload;
function createClient: Variant; overload;
function createClient(port: Float): Variant; overload;
function createClient(port: Float; host: String): Variant; overload;
function request(options: JRequestOptions): JClientRequest; overload;
function request(options: JRequestOptions; callback: (res: JIncomingMessage)): JClientRequest; overload;
function get(options: Variant): JClientRequest; overload;
function get(options: Variant; callback: (res: JIncomingMessage)): JClientRequest; overload;

var
  METHODS: array of String;
  STATUS_CODES:     // property Item[errorCode: Integer]: String;
    // property Item[errorCode: String]: String;
  end;;
  globalAgent: JAgent;

//"cluster"

type
  JWorker = class external 'Worker'(Jevents.EventEmitter)
    id: String;
    process: Jchild.ChildProcess;
    suicide: Boolean;
    procedure send(message: Variant); overload;
    procedure send(message: Variant; sendHandle: Variant); overload;
    procedure kill; overload;
    procedure kill(signal: String); overload;
    procedure destroy; overload;
    procedure destroy(signal: String); overload;
    procedure disconnect;
  end;

  JClusterSettings = class external
    exec: String; // nullable
    args: array of String; // nullable
    silent: Boolean; // nullable
  end;

procedure setupMaster; overload;
procedure setupMaster(settings: JClusterSettings); overload;
function fork: JWorker; overload;
function fork(env: Variant): JWorker; overload;
procedure disconnect; overload;
procedure disconnect(callback: JFunction); overload;
procedure addListener(event: String; listener: JFunction);
function on(event: String; listener: JFunction): Variant;
procedure once(event: String; listener: JFunction);
procedure removeListener(event: String; listener: JFunction);
procedure removeAllListeners; overload;
procedure removeAllListeners(event: String); overload;
procedure setMaxListeners(n: Float);
function listeners(event: String): array of JFunction;
function emit(event: String; args: array of Variant): Boolean;

var
  settings: JClusterSettings;
  isMaster: Boolean;
  isWorker: Boolean;
  worker: JWorker;
  workers: array of JWorker;

//"zlib"

type
  JZlibOptions = class external
    chunkSize: Float; // nullable
    windowBits: Float; // nullable
    level: Float; // nullable
    memLevel: Float; // nullable
    strategy: Float; // nullable
    dictionary: Variant; // nullable
  end;

  JGzip = class external(Jstream.Transform)
  end;

  JGunzip = class external(Jstream.Transform)
  end;

  JDeflate = class external(Jstream.Transform)
  end;

  JInflate = class external(Jstream.Transform)
  end;

  JDeflateRaw = class external(Jstream.Transform)
  end;

  JInflateRaw = class external(Jstream.Transform)
  end;

  JUnzip = class external(Jstream.Transform)
  end;

function createGzip: JGzip; overload;
function createGzip(options: JZlibOptions): JGzip; overload;
function createGunzip: JGunzip; overload;
function createGunzip(options: JZlibOptions): JGunzip; overload;
function createDeflate: JDeflate; overload;
function createDeflate(options: JZlibOptions): JDeflate; overload;
function createInflate: JInflate; overload;
function createInflate(options: JZlibOptions): JInflate; overload;
function createDeflateRaw: JDeflateRaw; overload;
function createDeflateRaw(options: JZlibOptions): JDeflateRaw; overload;
function createInflateRaw: JInflateRaw; overload;
function createInflateRaw(options: JZlibOptions): JInflateRaw; overload;
function createUnzip: JUnzip; overload;
function createUnzip(options: JZlibOptions): JUnzip; overload;
procedure deflate(buf: JBuffer; callback: (error: JError; result: Variant));
function deflateSync(buf: JBuffer): Variant; overload;
function deflateSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure deflateRaw(buf: JBuffer; callback: (error: JError; result: Variant));
function deflateRawSync(buf: JBuffer): Variant; overload;
function deflateRawSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure gzip(buf: JBuffer; callback: (error: JError; result: Variant));
function gzipSync(buf: JBuffer): Variant; overload;
function gzipSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure gunzip(buf: JBuffer; callback: (error: JError; result: Variant));
function gunzipSync(buf: JBuffer): Variant; overload;
function gunzipSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure inflate(buf: JBuffer; callback: (error: JError; result: Variant));
function inflateSync(buf: JBuffer): Variant; overload;
function inflateSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure inflateRaw(buf: JBuffer; callback: (error: JError; result: Variant));
function inflateRawSync(buf: JBuffer): Variant; overload;
function inflateRawSync(buf: JBuffer; options: JZlibOptions): Variant; overload;
procedure unzip(buf: JBuffer; callback: (error: JError; result: Variant));
function unzipSync(buf: JBuffer): Variant; overload;
function unzipSync(buf: JBuffer; options: JZlibOptions): Variant; overload;

var
  Z_NO_FLUSH: Float;
  Z_PARTIAL_FLUSH: Float;
  Z_SYNC_FLUSH: Float;
  Z_FULL_FLUSH: Float;
  Z_FINISH: Float;
  Z_BLOCK: Float;
  Z_TREES: Float;
  Z_OK: Float;
  Z_STREAM_END: Float;
  Z_NEED_DICT: Float;
  Z_ERRNO: Float;
  Z_STREAM_ERROR: Float;
  Z_DATA_ERROR: Float;
  Z_MEM_ERROR: Float;
  Z_BUF_ERROR: Float;
  Z_VERSION_ERROR: Float;
  Z_NO_COMPRESSION: Float;
  Z_BEST_SPEED: Float;
  Z_BEST_COMPRESSION: Float;
  Z_DEFAULT_COMPRESSION: Float;
  Z_FILTERED: Float;
  Z_HUFFMAN_ONLY: Float;
  Z_RLE: Float;
  Z_FIXED: Float;
  Z_DEFAULT_STRATEGY: Float;
  Z_BINARY: Float;
  Z_TEXT: Float;
  Z_ASCII: Float;
  Z_UNKNOWN: Float;
  Z_DEFLATED: Float;
  Z_NULL: Float;

//"os"

type
  JCpuInfo = class external
    model: String;
    speed: Float;
    times:       user: Float;
      nice: Float;
      sys: Float;
      idle: Float;
      irq: Float;
    end;;
  end;

  JNetworkInterfaceInfo = class external
    address: String;
    netmask: String;
    family: String;
    mac: String;
    internal: Boolean;
  end;

function tmpdir: String;
function homedir: String;
function endianness: String;
function hostname: String;
function type: String;
function platform: String;
function arch: String;
function release: String;
function uptime: Float;
function loadavg: array of Float;
function totalmem: Float;
function freemem: Float;
function cpus: array of JCpuInfo;
function networkInterfaces:   // property Item[index: String]: array of JNetworkInterfaceInfo;
end;;

var
  EOL: String;

//"https"

type
  JServerOptions = class external
    pfx: Variant; // nullable
    key: Variant; // nullable
    passphrase: String; // nullable
    cert: Variant; // nullable
    ca: Variant; // nullable
    crl: Variant; // nullable
    ciphers: String; // nullable
    honorCipherOrder: Boolean; // nullable
    requestCert: Boolean; // nullable
    rejectUnauthorized: Boolean; // nullable
    NPNProtocols: Variant; // nullable
    SNICallback: (servername: String): Variant; // nullable
  end;

  JRequestOptions = class external(Jhttp.RequestOptions)
    pfx: Variant; // nullable
    key: Variant; // nullable
    passphrase: String; // nullable
    cert: Variant; // nullable
    ca: Variant; // nullable
    ciphers: String; // nullable
    rejectUnauthorized: Boolean; // nullable
    secureProtocol: String; // nullable
  end;

  JAgent = class external
    maxSockets: Float;
    sockets: Variant;
    requests: Variant;
  end;

  JServer = class external(Jtls.Server)
  end;

function createServer(options: JServerOptions): JServer; overload;
function createServer(options: JServerOptions; requestListener: JFunction): JServer; overload;
function request(options: JRequestOptions): Jhttp.ClientRequest; overload;
function request(options: JRequestOptions; callback: (res: Jhttp.IncomingMessage)): Jhttp.ClientRequest; overload;
function get(options: JRequestOptions): Jhttp.ClientRequest; overload;
function get(options: JRequestOptions; callback: (res: Jhttp.IncomingMessage)): Jhttp.ClientRequest; overload;

var
  Agent:     constructor CreateJAgent;
  end;;
  globalAgent: JAgent;

//"punycode"

type
  Jucs2 = class external
    function decode(&string: String): array of Float;
    function encode(codePoints: array of Float): String;
  end;

function decode(&string: String): String;
function encode(&string: String): String;
function toUnicode(domain: String): String;
function toASCII(domain: String): String;

var
  ucs2: Jucs2;
  version: Variant;

//"repl"

type
  JReplOptions = class external
    prompt: String; // nullable
    input: JNodeJS.ReadableStream; // nullable
    output: JNodeJS.WritableStream; // nullable
    terminal: Boolean; // nullable
    eval: JFunction; // nullable
    useColors: Boolean; // nullable
    useGlobal: Boolean; // nullable
    ignoreUndefined: Boolean; // nullable
    writer: JFunction; // nullable
  end;

function start(options: JReplOptions): Jevents.EventEmitter;

//"readline"

type
  JKey = class external
    sequence: String; // nullable
    name: String; // nullable
    ctrl: Boolean; // nullable
    meta: Boolean; // nullable
    shift: Boolean; // nullable
  end;

  JReadLine = class external(Jevents.EventEmitter)
    procedure setPrompt(prompt: String);
    procedure prompt; overload;
    procedure prompt(preserveCursor: Boolean); overload;
    procedure question(query: String; callback: (answer: String));
    function pause: JReadLine;
    function resume: JReadLine;
    procedure close;
    procedure write(data: Variant {String or JBuffer}); overload;
    procedure write(data: Variant {String or JBuffer}; key: JKey); overload;
  end;

  JCompleter = class external
(line: String): JCompleterResult(line: String; callback: (err: Variant; result: JCompleterResult)): Variant  end;

  JCompleterResult = class external
    completions: array of String;
    line: String;
  end;

  JReadLineOptions = class external
    input: JNodeJS.ReadableStream;
    output: JNodeJS.WritableStream; // nullable
    completer: JCompleter; // nullable
    terminal: Boolean; // nullable
    historySize: Float; // nullable
  end;

function createInterface(input: JNodeJS.ReadableStream): JReadLine; overload;
function createInterface(input: JNodeJS.ReadableStream; output: JNodeJS.WritableStream): JReadLine; overload;
function createInterface(input: JNodeJS.ReadableStream; output: JNodeJS.WritableStream; completer: JCompleter): JReadLine; overload;
function createInterface(input: JNodeJS.ReadableStream; output: JNodeJS.WritableStream; completer: JCompleter; terminal: Boolean): JReadLine; overload;
function createInterface(options: JReadLineOptions): JReadLine;
procedure cursorTo(stream: JNodeJS.WritableStream; x: Float; y: Float);
procedure moveCursor(stream: JNodeJS.WritableStream; dx: Variant {Float or String}; dy: Variant {Float or String});
procedure clearLine(stream: JNodeJS.WritableStream; dir: Float);
procedure clearScreenDown(stream: JNodeJS.WritableStream);

//"vm"

type
  JContext = class external
  end;

  JScript = class external
    procedure runInThisContext;
    procedure runInNewContext; overload;
    procedure runInNewContext(sandbox: JContext); overload;
  end;

procedure runInThisContext(code: String); overload;
procedure runInThisContext(code: String; filename: String); overload;
procedure runInNewContext(code: String); overload;
procedure runInNewContext(code: String; sandbox: JContext); overload;
procedure runInNewContext(code: String; sandbox: JContext; filename: String); overload;
procedure runInContext(code: String; context: JContext); overload;
procedure runInContext(code: String; context: JContext; filename: String); overload;
function createContext: JContext; overload;
function createContext(initSandbox: JContext): JContext; overload;
function createScript(code: String): JScript; overload;
function createScript(code: String; filename: String): JScript; overload;

//"child_process"

type
  JChildProcess = class external(Jevents.EventEmitter)
    stdin: Jstream.Writable;
    stdout: Jstream.Readable;
    stderr: Jstream.Readable;
    pid: Float;
    procedure kill; overload;
    procedure kill(signal: String); overload;
    procedure send(message: Variant); overload;
    procedure send(message: Variant; sendHandle: Variant); overload;
    procedure disconnect;
    procedure unref;
  end;

function spawn(command: String): JChildProcess; overload;
function spawn(command: String; args: array of String): JChildProcess; overload;
function spawn(command: String; args: array of String; options:   cwd: String; // nullable
  stdio: Variant; // nullable
  custom: Variant; // nullable
  env: Variant; // nullable
  detached: Boolean; // nullable
end;): JChildProcess; overload;
function exec(command: String; options:   cwd: String; // nullable
  stdio: Variant; // nullable
  customFds: Variant; // nullable
  env: Variant; // nullable
  encoding: String; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
end;): JChildProcess; overload;
function exec(command: String; options:   cwd: String; // nullable
  stdio: Variant; // nullable
  customFds: Variant; // nullable
  env: Variant; // nullable
  encoding: String; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
end;; callback: (error: JError; stdout: JBuffer; stderr: JBuffer)): JChildProcess; overload;
function exec(command: String): JChildProcess; overload;
function exec(command: String; callback: (error: JError; stdout: JBuffer; stderr: JBuffer)): JChildProcess; overload;
function execFile(file: String): JChildProcess; overload;
function execFile(file: String; callback: (error: JError; stdout: JBuffer; stderr: JBuffer)): JChildProcess; overload;
function execFile(file: String): JChildProcess; overload;
function execFile(file: String; args: array of String): JChildProcess; overload;
function execFile(file: String; args: array of String; callback: (error: JError; stdout: JBuffer; stderr: JBuffer)): JChildProcess; overload;
function execFile(file: String): JChildProcess; overload;
function execFile(file: String; args: array of String): JChildProcess; overload;
function execFile(file: String; args: array of String; options:   cwd: String; // nullable
  stdio: Variant; // nullable
  customFds: Variant; // nullable
  env: Variant; // nullable
  encoding: String; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
end;): JChildProcess; overload;
function execFile(file: String; args: array of String; options:   cwd: String; // nullable
  stdio: Variant; // nullable
  customFds: Variant; // nullable
  env: Variant; // nullable
  encoding: String; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
end;; callback: (error: JError; stdout: JBuffer; stderr: JBuffer)): JChildProcess; overload;
function fork(modulePath: String): JChildProcess; overload;
function fork(modulePath: String; args: array of String): JChildProcess; overload;
function fork(modulePath: String; args: array of String; options:   cwd: String; // nullable
  env: Variant; // nullable
  execPath: String; // nullable
  execArgv: array of String; // nullable
  silent: Boolean; // nullable
  uid: Float; // nullable
  gid: Float; // nullable
end;): JChildProcess; overload;
function spawnSync(command: String):   pid: Float;
  output: array of String;
  stdout: Variant {String or JBuffer};
  stderr: Variant {String or JBuffer};
  status: Float;
  signal: String;
  error: JError;
end;; overload;
function spawnSync(command: String; args: array of String):   pid: Float;
  output: array of String;
  stdout: Variant {String or JBuffer};
  stderr: Variant {String or JBuffer};
  status: Float;
  signal: String;
  error: JError;
end;; overload;
function spawnSync(command: String; args: array of String; options:   cwd: String; // nullable
  input: Variant {String or JBuffer}; // nullable
  stdio: Variant; // nullable
  env: Variant; // nullable
  uid: Float; // nullable
  gid: Float; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
  encoding: String; // nullable
end;):   pid: Float;
  output: array of String;
  stdout: Variant {String or JBuffer};
  stderr: Variant {String or JBuffer};
  status: Float;
  signal: String;
  error: JError;
end;; overload;
function execSync(command: String): Variant {String or JBuffer}; overload;
function execSync(command: String; options:   cwd: String; // nullable
  input: Variant {String or JBuffer}; // nullable
  stdio: Variant; // nullable
  env: Variant; // nullable
  uid: Float; // nullable
  gid: Float; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
  encoding: String; // nullable
end;): Variant {String or JBuffer}; overload;
function execFileSync(command: String): Variant {String or JBuffer}; overload;
function execFileSync(command: String; args: array of String): Variant {String or JBuffer}; overload;
function execFileSync(command: String; args: array of String; options:   cwd: String; // nullable
  input: Variant {String or JBuffer}; // nullable
  stdio: Variant; // nullable
  env: Variant; // nullable
  uid: Float; // nullable
  gid: Float; // nullable
  timeout: Float; // nullable
  maxBuffer: Float; // nullable
  killSignal: String; // nullable
  encoding: String; // nullable
end;): Variant {String or JBuffer}; overload;

//"url"

type
  JUrl = class external
    href: String; // nullable
    protocol: String; // nullable
    auth: String; // nullable
    hostname: String; // nullable
    port: String; // nullable
    host: String; // nullable
    pathname: String; // nullable
    search: String; // nullable
    query: Variant; // nullable
    slashes: Boolean; // nullable
    hash: String; // nullable
    path: String; // nullable
  end;

function parse(urlStr: String): JUrl; overload;
function parse(urlStr: String; parseQueryString: Boolean): JUrl; overload;
function parse(urlStr: String; parseQueryString: Boolean; slashesDenoteHost: Boolean): JUrl; overload;
function format(url: JUrl): String;
function resolve(from: String; to: String): String;

//"dns"

function lookup(domain: String; family: Float; callback: (err: JError; address: String; family: Float)): String;
function lookup(domain: String; callback: (err: JError; address: String; family: Float)): String;
function resolve(domain: String; rrtype: String; callback: (err: JError; addresses: array of String)): array of String;
function resolve(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolve4(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolve6(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolveMx(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolveTxt(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolveSrv(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolveNs(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function resolveCname(domain: String; callback: (err: JError; addresses: array of String)): array of String;
function reverse(ip: String; callback: (err: JError; domains: array of String)): array of String;

//"net"

type
  JSocket = class external(Jstream.Duplex)
    function write(buffer: JBuffer): Boolean;
    function write(buffer: JBuffer): Boolean; overload;
    function write(buffer: JBuffer; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; cb: JFunction): Boolean; overload;
    function write(str: String): Boolean; overload;
    function write(str: String; encoding: String): Boolean; overload;
    function write(str: String; encoding: String; fd: String): Boolean; overload;
    procedure connect(port: Float); overload;
    procedure connect(port: Float; host: String); overload;
    procedure connect(port: Float; host: String; connectionListener: JFunction); overload;
    procedure connect(path: String); overload;
    procedure connect(path: String; connectionListener: JFunction); overload;
    bufferSize: Float;
    procedure setEncoding; overload;
    procedure setEncoding(encoding: String); overload;
    procedure write(data: Variant); overload;
    procedure write(data: Variant; encoding: String); overload;
    procedure write(data: Variant; encoding: String; callback: JFunction); overload;
    procedure destroy;
    procedure pause;
    procedure resume;
    procedure setTimeout(timeout: Float); overload;
    procedure setTimeout(timeout: Float; callback: JFunction); overload;
    procedure setNoDelay; overload;
    procedure setNoDelay(noDelay: Boolean); overload;
    procedure setKeepAlive; overload;
    procedure setKeepAlive(enable: Boolean); overload;
    procedure setKeepAlive(enable: Boolean; initialDelay: Float); overload;
    function address:       port: Float;
      family: String;
      address: String;
    end;;
    procedure unref;
    procedure ref;
    remoteAddress: String;
    remoteFamily: String;
    remotePort: Float;
    localAddress: String;
    localPort: Float;
    bytesRead: Float;
    bytesWritten: Float;
    procedure end;
    procedure end(buffer: JBuffer); overload;
    procedure end(buffer: JBuffer; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; cb: JFunction); overload;
    procedure end(str: String); overload;
    procedure end(str: String; encoding: String); overload;
    procedure end(str: String; encoding: String; cb: JFunction); overload;
    procedure end; overload;
    procedure end(data: Variant); overload;
    procedure end(data: Variant; encoding: String); overload;
  end;

  JServer = class external(JSocket)
    function listen(port: Float): JServer; overload;
    function listen(port: Float; host: String): JServer; overload;
    function listen(port: Float; host: String; backlog: Float): JServer; overload;
    function listen(port: Float; host: String; backlog: Float; listeningListener: JFunction): JServer; overload;
    function listen(path: String): JServer; overload;
    function listen(path: String; listeningListener: JFunction): JServer; overload;
    function listen(handle: Variant): JServer; overload;
    function listen(handle: Variant; listeningListener: JFunction): JServer; overload;
    function close: JServer; overload;
    function close(callback: JFunction): JServer; overload;
    function address:       port: Float;
      family: String;
      address: String;
    end;;
    maxConnections: Float;
    connections: Float;
  end;

function createServer: JServer; overload;
function createServer(connectionListener: (socket: JSocket)): JServer; overload;
function createServer: JServer; overload;
function createServer(options:   allowHalfOpen: Boolean; // nullable
end;): JServer; overload;
function createServer(options:   allowHalfOpen: Boolean; // nullable
end;; connectionListener: (socket: JSocket)): JServer; overload;
function connect(options:   port: Float;
  host: String; // nullable
  localAddress: String; // nullable
  localPort: String; // nullable
  family: Float; // nullable
  allowHalfOpen: Boolean; // nullable
end;): JSocket; overload;
function connect(options:   port: Float;
  host: String; // nullable
  localAddress: String; // nullable
  localPort: String; // nullable
  family: Float; // nullable
  allowHalfOpen: Boolean; // nullable
end;; connectionListener: JFunction): JSocket; overload;
function connect(port: Float): JSocket; overload;
function connect(port: Float; host: String): JSocket; overload;
function connect(port: Float; host: String; connectionListener: JFunction): JSocket; overload;
function connect(path: String): JSocket; overload;
function connect(path: String; connectionListener: JFunction): JSocket; overload;
function createConnection(options:   port: Float;
  host: String; // nullable
  localAddress: String; // nullable
  localPort: String; // nullable
  family: Float; // nullable
  allowHalfOpen: Boolean; // nullable
end;): JSocket; overload;
function createConnection(options:   port: Float;
  host: String; // nullable
  localAddress: String; // nullable
  localPort: String; // nullable
  family: Float; // nullable
  allowHalfOpen: Boolean; // nullable
end;; connectionListener: JFunction): JSocket; overload;
function createConnection(port: Float): JSocket; overload;
function createConnection(port: Float; host: String): JSocket; overload;
function createConnection(port: Float; host: String; connectionListener: JFunction): JSocket; overload;
function createConnection(path: String): JSocket; overload;
function createConnection(path: String; connectionListener: JFunction): JSocket; overload;
function isIP(input: String): Float;
function isIPv4(input: String): Boolean;
function isIPv6(input: String): Boolean;

var
  Socket:     constructor CreateJSocket;
  end;;

//"dgram"

type
  JRemoteInfo = class external
    address: String;
    port: Float;
    size: Float;
  end;

  JAddressInfo = class external
    address: String;
    family: String;
    port: Float;
  end;

  JSocket = class external(Jevents.EventEmitter)
    procedure send(buf: JBuffer; offset: Float; _length: Float; port: Float; address: String); overload;
    procedure send(buf: JBuffer; offset: Float; _length: Float; port: Float; address: String; callback: (error: JError; bytes: Float)); overload;
    procedure bind(port: Float); overload;
    procedure bind(port: Float; address: String); overload;
    procedure bind(port: Float; address: String; callback: ); overload;
    procedure close;
    function address: JAddressInfo;
    procedure setBroadcast(flag: Boolean);
    procedure setMulticastTTL(ttl: Float);
    procedure setMulticastLoopback(flag: Boolean);
    procedure addMembership(multicastAddress: String); overload;
    procedure addMembership(multicastAddress: String; multicastInterface: String); overload;
    procedure dropMembership(multicastAddress: String); overload;
    procedure dropMembership(multicastAddress: String; multicastInterface: String); overload;
  end;

function createSocket(&type: String): JSocket; overload;
function createSocket(&type: String; callback: (msg: JBuffer; rinfo: JRemoteInfo)): JSocket; overload;

//"fs"

type
  JStats = class external
    function isFile: Boolean;
    function isDirectory: Boolean;
    function isBlockDevice: Boolean;
    function isCharacterDevice: Boolean;
    function isSymbolicLink: Boolean;
    function isFIFO: Boolean;
    function isSocket: Boolean;
    dev: Float;
    ino: Float;
    mode: Float;
    nlink: Float;
    uid: Float;
    gid: Float;
    rdev: Float;
    size: Float;
    blksize: Float;
    blocks: Float;
    atime: JDate;
    mtime: JDate;
    ctime: JDate;
    birthtime: JDate;
  end;

  JFSWatcher = class external(Jevents.EventEmitter)
    procedure close;
  end;

  JReadStream = class external(Jstream.Readable)
    procedure close;
  end;

  JWriteStream = class external(Jstream.Writable)
    procedure close;
    bytesWritten: Float;
  end;

procedure rename(oldPath: String; newPath: String); overload;
procedure rename(oldPath: String; newPath: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure renameSync(oldPath: String; newPath: String);
procedure truncate(path: String); overload;
procedure truncate(path: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure truncate(path: String; len: Float); overload;
procedure truncate(path: String; len: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure truncateSync(path: String); overload;
procedure truncateSync(path: String; len: Float); overload;
procedure ftruncate(fd: Float); overload;
procedure ftruncate(fd: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure ftruncate(fd: Float; len: Float); overload;
procedure ftruncate(fd: Float; len: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure ftruncateSync(fd: Float); overload;
procedure ftruncateSync(fd: Float; len: Float); overload;
procedure chown(path: String; uid: Float; gid: Float); overload;
procedure chown(path: String; uid: Float; gid: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure chownSync(path: String; uid: Float; gid: Float);
procedure fchown(fd: Float; uid: Float; gid: Float); overload;
procedure fchown(fd: Float; uid: Float; gid: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure fchownSync(fd: Float; uid: Float; gid: Float);
procedure lchown(path: String; uid: Float; gid: Float); overload;
procedure lchown(path: String; uid: Float; gid: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure lchownSync(path: String; uid: Float; gid: Float);
procedure chmod(path: String; mode: Float); overload;
procedure chmod(path: String; mode: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure chmod(path: String; mode: String); overload;
procedure chmod(path: String; mode: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure chmodSync(path: String; mode: Float);
procedure chmodSync(path: String; mode: String);
procedure fchmod(fd: Float; mode: Float); overload;
procedure fchmod(fd: Float; mode: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure fchmod(fd: Float; mode: String); overload;
procedure fchmod(fd: Float; mode: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure fchmodSync(fd: Float; mode: Float);
procedure fchmodSync(fd: Float; mode: String);
procedure lchmod(path: String; mode: Float); overload;
procedure lchmod(path: String; mode: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure lchmod(path: String; mode: String); overload;
procedure lchmod(path: String; mode: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure lchmodSync(path: String; mode: Float);
procedure lchmodSync(path: String; mode: String);
procedure stat(path: String); overload;
procedure stat(path: String; callback: (err: JNodeJS.ErrnoException; stats: JStats): Variant); overload;
procedure lstat(path: String); overload;
procedure lstat(path: String; callback: (err: JNodeJS.ErrnoException; stats: JStats): Variant); overload;
procedure fstat(fd: Float); overload;
procedure fstat(fd: Float; callback: (err: JNodeJS.ErrnoException; stats: JStats): Variant); overload;
function statSync(path: String): JStats;
function lstatSync(path: String): JStats;
function fstatSync(fd: Float): JStats;
procedure link(srcpath: String; dstpath: String); overload;
procedure link(srcpath: String; dstpath: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure linkSync(srcpath: String; dstpath: String);
procedure symlink(srcpath: String; dstpath: String); overload;
procedure symlink(srcpath: String; dstpath: String; &type: String); overload;
procedure symlink(srcpath: String; dstpath: String; &type: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure symlinkSync(srcpath: String; dstpath: String); overload;
procedure symlinkSync(srcpath: String; dstpath: String; &type: String); overload;
procedure readlink(path: String); overload;
procedure readlink(path: String; callback: (err: JNodeJS.ErrnoException; linkString: String): Variant); overload;
function readlinkSync(path: String): String;
procedure realpath(path: String); overload;
procedure realpath(path: String; callback: (err: JNodeJS.ErrnoException; resolvedPath: String): Variant); overload;
procedure realpath(path: String; cache:   // property Item[path: String]: String;
end;; callback: (err: JNodeJS.ErrnoException; resolvedPath: String): Variant);
function realpathSync(path: String): String; overload;
function realpathSync(path: String; cache:   // property Item[path: String]: String;
end;): String; overload;
procedure unlink(path: String); overload;
procedure unlink(path: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure unlinkSync(path: String);
procedure rmdir(path: String); overload;
procedure rmdir(path: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure rmdirSync(path: String);
procedure mkdir(path: String); overload;
procedure mkdir(path: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure mkdir(path: String; mode: Float); overload;
procedure mkdir(path: String; mode: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure mkdir(path: String; mode: String); overload;
procedure mkdir(path: String; mode: String; callback: (err: JNodeJS.ErrnoException)); overload;
procedure mkdirSync(path: String); overload;
procedure mkdirSync(path: String; mode: Float); overload;
procedure mkdirSync(path: String); overload;
procedure mkdirSync(path: String; mode: String); overload;
procedure readdir(path: String); overload;
procedure readdir(path: String; callback: (err: JNodeJS.ErrnoException; files: array of String)); overload;
function readdirSync(path: String): array of String;
procedure close(fd: Float); overload;
procedure close(fd: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure closeSync(fd: Float);
procedure open(path: String; flags: String); overload;
procedure open(path: String; flags: String; callback: (err: JNodeJS.ErrnoException; fd: Float): Variant); overload;
procedure open(path: String; flags: String; mode: Float); overload;
procedure open(path: String; flags: String; mode: Float; callback: (err: JNodeJS.ErrnoException; fd: Float): Variant); overload;
procedure open(path: String; flags: String; mode: String); overload;
procedure open(path: String; flags: String; mode: String; callback: (err: JNodeJS.ErrnoException; fd: Float): Variant); overload;
function openSync(path: String; flags: String): Float; overload;
function openSync(path: String; flags: String; mode: Float): Float; overload;
function openSync(path: String; flags: String): Float; overload;
function openSync(path: String; flags: String; mode: String): Float; overload;
procedure utimes(path: String; atime: Float; mtime: Float); overload;
procedure utimes(path: String; atime: Float; mtime: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure utimes(path: String; atime: JDate; mtime: JDate); overload;
procedure utimes(path: String; atime: JDate; mtime: JDate; callback: (err: JNodeJS.ErrnoException)); overload;
procedure utimesSync(path: String; atime: Float; mtime: Float);
procedure utimesSync(path: String; atime: JDate; mtime: JDate);
procedure futimes(fd: Float; atime: Float; mtime: Float); overload;
procedure futimes(fd: Float; atime: Float; mtime: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure futimes(fd: Float; atime: JDate; mtime: JDate); overload;
procedure futimes(fd: Float; atime: JDate; mtime: JDate; callback: (err: JNodeJS.ErrnoException)); overload;
procedure futimesSync(fd: Float; atime: Float; mtime: Float);
procedure futimesSync(fd: Float; atime: JDate; mtime: JDate);
procedure fsync(fd: Float); overload;
procedure fsync(fd: Float; callback: (err: JNodeJS.ErrnoException)); overload;
procedure fsyncSync(fd: Float);
procedure write(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float); overload;
procedure write(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float; callback: (err: JNodeJS.ErrnoException; written: Float; buffer: JBuffer)); overload;
procedure write(fd: Float; buffer: JBuffer; offset: Float; _length: Float); overload;
procedure write(fd: Float; buffer: JBuffer; offset: Float; _length: Float; callback: (err: JNodeJS.ErrnoException; written: Float; buffer: JBuffer)); overload;
procedure write(fd: Float; data: Variant); overload;
procedure write(fd: Float; data: Variant; callback: (err: JNodeJS.ErrnoException; written: Float; str: String)); overload;
procedure write(fd: Float; data: Variant; offset: Float); overload;
procedure write(fd: Float; data: Variant; offset: Float; callback: (err: JNodeJS.ErrnoException; written: Float; str: String)); overload;
procedure write(fd: Float; data: Variant; offset: Float; encoding: String); overload;
procedure write(fd: Float; data: Variant; offset: Float; encoding: String; callback: (err: JNodeJS.ErrnoException; written: Float; str: String)); overload;
function writeSync(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float): Float;
procedure read(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float); overload;
procedure read(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float; callback: (err: JNodeJS.ErrnoException; bytesRead: Float; buffer: JBuffer)); overload;
function readSync(fd: Float; buffer: JBuffer; offset: Float; _length: Float; position: Float): Float;
procedure readFile(filename: String; encoding: String; callback: (err: JNodeJS.ErrnoException; data: String));
procedure readFile(filename: String; options:   encoding: String;
  flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException; data: String));
procedure readFile(filename: String; options:   flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException; data: JBuffer));
procedure readFile(filename: String; callback: (err: JNodeJS.ErrnoException; data: JBuffer));
function readFileSync(filename: String; encoding: String): String;
function readFileSync(filename: String; options:   encoding: String;
  flag: String; // nullable
end;): String;
function readFileSync(filename: String): JBuffer; overload;
function readFileSync(filename: String; options:   flag: String; // nullable
end;): JBuffer; overload;
procedure writeFile(filename: String; data: Variant); overload;
procedure writeFile(filename: String; data: Variant; callback: (err: JNodeJS.ErrnoException)); overload;
procedure writeFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;); overload;
procedure writeFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException)); overload;
procedure writeFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;); overload;
procedure writeFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException)); overload;
procedure writeFileSync(filename: String; data: Variant); overload;
procedure writeFileSync(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;); overload;
procedure writeFileSync(filename: String; data: Variant); overload;
procedure writeFileSync(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;); overload;
procedure appendFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;); overload;
procedure appendFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException)); overload;
procedure appendFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;); overload;
procedure appendFile(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;; callback: (err: JNodeJS.ErrnoException)); overload;
procedure appendFile(filename: String; data: Variant); overload;
procedure appendFile(filename: String; data: Variant; callback: (err: JNodeJS.ErrnoException)); overload;
procedure appendFileSync(filename: String; data: Variant); overload;
procedure appendFileSync(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: Float; // nullable
  flag: String; // nullable
end;); overload;
procedure appendFileSync(filename: String; data: Variant); overload;
procedure appendFileSync(filename: String; data: Variant; options:   encoding: String; // nullable
  mode: String; // nullable
  flag: String; // nullable
end;); overload;
procedure watchFile(filename: String; listener: (curr: JStats; prev: JStats));
procedure watchFile(filename: String; options:   persistent: Boolean; // nullable
  interval: Float; // nullable
end;; listener: (curr: JStats; prev: JStats));
procedure unwatchFile(filename: String); overload;
procedure unwatchFile(filename: String; listener: (curr: JStats; prev: JStats)); overload;
function watch(filename: String): JFSWatcher; overload;
function watch(filename: String; listener: (event: String; filename: String): Variant): JFSWatcher; overload;
function watch(filename: String; options:   persistent: Boolean; // nullable
end;): JFSWatcher; overload;
function watch(filename: String; options:   persistent: Boolean; // nullable
end;; listener: (event: String; filename: String): Variant): JFSWatcher; overload;
procedure exists(path: String); overload;
procedure exists(path: String; callback: (exists: Boolean)); overload;
function existsSync(path: String): Boolean;
procedure access(path: String; callback: (err: JNodeJS.ErrnoException));
procedure access(path: String; mode: Float; callback: (err: JNodeJS.ErrnoException));
procedure accessSync(path: String); overload;
procedure accessSync(path: String; mode: Float); overload;
function createReadStream(path: String): JReadStream; overload;
function createReadStream(path: String; options:   flags: String; // nullable
  encoding: String; // nullable
  fd: Float; // nullable
  mode: Float; // nullable
  autoClose: Boolean; // nullable
end;): JReadStream; overload;
function createWriteStream(path: String): JWriteStream; overload;
function createWriteStream(path: String; options:   flags: String; // nullable
  encoding: String; // nullable
  fd: Float; // nullable
  mode: Float; // nullable
end;): JWriteStream; overload;

var
  F_OK: Float;
  R_OK: Float;
  W_OK: Float;
  X_OK: Float;

//"path"

type
  JParsedPath = class external
    root: String;
    dir: String;
    base: String;
    ext: String;
    name: String;
  end;

//posix

function normalize(p: String): String;
function join(paths: array of Variant): String;
function resolve(pathSegments: array of Variant): String;
function isAbsolute(p: String): Boolean;
function relative(from: String; to: String): String;
function dirname(p: String): String;
function basename(p: String): String; overload;
function basename(p: String; ext: String): String; overload;
function extname(p: String): String;
function parse(p: String): JParsedPath;
function format(pP: JParsedPath): String;

var
  sep: String;
  delimiter: String;

//win32

function normalize(p: String): String;
function join(paths: array of Variant): String;
function resolve(pathSegments: array of Variant): String;
function isAbsolute(p: String): Boolean;
function relative(from: String; to: String): String;
function dirname(p: String): String;
function basename(p: String): String; overload;
function basename(p: String; ext: String): String; overload;
function extname(p: String): String;
function parse(p: String): JParsedPath;
function format(pP: JParsedPath): String;

var
  sep: String;
  delimiter: String;

function normalize(p: String): String;
function join(paths: array of Variant): String;
function join(paths: array of String): String;
function resolve(pathSegments: array of Variant): String;
function isAbsolute(path: String): Boolean;
function relative(from: String; to: String): String;
function dirname(p: String): String;
function basename(p: String): String; overload;
function basename(p: String; ext: String): String; overload;
function extname(p: String): String;
function parse(pathString: String): JParsedPath;
function format(pathObject: JParsedPath): String;

var
  sep: String;
  delimiter: String;

//"string_decoder"

type
  JNodeStringDecoder = class external
    function write(buffer: JBuffer): String;
    function detectIncompleteChar(buffer: JBuffer): Float;
  end;

var
  StringDecoder:     constructor CreateJNodeStringDecoder;
  end;;

//"tls"

type
  JTlsOptions = class external
    host: String; // nullable
    port: Float; // nullable
    pfx: Variant; // nullable
    key: Variant; // nullable
    passphrase: String; // nullable
    cert: Variant; // nullable
    ca: Variant; // nullable
    crl: Variant; // nullable
    ciphers: String; // nullable
    honorCipherOrder: Variant; // nullable
    requestCert: Boolean; // nullable
    rejectUnauthorized: Boolean; // nullable
    NPNProtocols: Variant; // nullable
    SNICallback: (servername: String): Variant; // nullable
  end;

  JConnectionOptions = class external
    host: String; // nullable
    port: Float; // nullable
    socket: Jnet.Socket; // nullable
    pfx: Variant; // nullable
    key: Variant; // nullable
    passphrase: String; // nullable
    cert: Variant; // nullable
    ca: Variant; // nullable
    rejectUnauthorized: Boolean; // nullable
    NPNProtocols: Variant; // nullable
    servername: String; // nullable
  end;

  JServer = class external(Jnet.Server)
    function listen(port: Float): JServer; overload;
    function listen(port: Float; host: String): JServer; overload;
    function listen(port: Float; host: String; backlog: Float): JServer; overload;
    function listen(port: Float; host: String; backlog: Float; listeningListener: JFunction): JServer; overload;
    function listen(path: String): JServer; overload;
    function listen(path: String; listeningListener: JFunction): JServer; overload;
    function listen(handle: Variant): JServer; overload;
    function listen(handle: Variant; listeningListener: JFunction): JServer; overload;
    function listen(port: Float): JServer; overload;
    function listen(port: Float; host: String): JServer; overload;
    function listen(port: Float; host: String; callback: JFunction): JServer; overload;
    function close: JServer;
    function address:       port: Float;
      family: String;
      address: String;
    end;;
    procedure addContext(hostName: String; credentials:       key: String;
      cert: String;
      ca: String;
    end;);
    maxConnections: Float;
    connections: Float;
  end;

  JClearTextStream = class external(Jstream.Duplex)
    authorized: Boolean;
    authorizationError: JError;
    function getPeerCertificate: Variant;
    getCipher:       name: String;
      version: String;
    end;;
    address:       port: Float;
      family: String;
      address: String;
    end;;
    remoteAddress: String;
    remotePort: Float;
  end;

  JSecurePair = class external
    encrypted: Variant;
    cleartext: Variant;
  end;

  JSecureContextOptions = class external
    pfx: Variant; // nullable
    key: Variant; // nullable
    passphrase: String; // nullable
    cert: Variant; // nullable
    ca: Variant; // nullable
    crl: Variant; // nullable
    ciphers: String; // nullable
    honorCipherOrder: Boolean; // nullable
  end;

  JSecureContext = class external
    context: Variant;
  end;

function createServer(options: JTlsOptions): JServer; overload;
function createServer(options: JTlsOptions; secureConnectionListener: (cleartextStream: JClearTextStream)): JServer; overload;
function connect(options: JTlsOptions): JClearTextStream; overload;
function connect(options: JTlsOptions; secureConnectionListener: ): JClearTextStream; overload;
function connect(port: Float): JClearTextStream; overload;
function connect(port: Float; host: String): JClearTextStream; overload;
function connect(port: Float; host: String; options: JConnectionOptions): JClearTextStream; overload;
function connect(port: Float; host: String; options: JConnectionOptions; secureConnectListener: ): JClearTextStream; overload;
function connect(port: Float): JClearTextStream; overload;
function connect(port: Float; options: JConnectionOptions): JClearTextStream; overload;
function connect(port: Float; options: JConnectionOptions; secureConnectListener: ): JClearTextStream; overload;
function createSecurePair: JSecurePair; overload;
function createSecurePair(credentials: Jcrypto.Credentials): JSecurePair; overload;
function createSecurePair(credentials: Jcrypto.Credentials; isServer: Boolean): JSecurePair; overload;
function createSecurePair(credentials: Jcrypto.Credentials; isServer: Boolean; requestCert: Boolean): JSecurePair; overload;
function createSecurePair(credentials: Jcrypto.Credentials; isServer: Boolean; requestCert: Boolean; rejectUnauthorized: Boolean): JSecurePair; overload;
function createSecureContext(details: JSecureContextOptions): JSecureContext;

var
  CLIENT_RENEG_LIMIT: Float;
  CLIENT_RENEG_WINDOW: Float;

//"crypto"

type
  JCredentialDetails = class external
    pfx: String;
    key: String;
    passphrase: String;
    cert: String;
    ca: Variant;
    crl: Variant;
    ciphers: String;
  end;

  JCredentials = class external
    context: Variant; // nullable
  end;

  JHash = class external
    function update(data: Variant): JHash; overload;
    function update(data: Variant; input_encoding: String): JHash; overload;
    function digest(encoding: Jbuffer): JBuffer;
    function digest(encoding: String): Variant;
    function digest: JBuffer;
  end;

  JHmac = class external(JNodeJS.ReadWriteStream)
    function update(data: Variant): JHmac; overload;
    function update(data: Variant; input_encoding: String): JHmac; overload;
    function digest(encoding: Jbuffer): JBuffer;
    function digest(encoding: String): Variant;
    function digest: JBuffer;
  end;

  JCipher = class external
    function update(data: JBuffer): JBuffer;
    function update(data: String): String; overload;
    function update(data: String; input_encoding: String): String; overload;
    function update(data: String; input_encoding: String; output_encoding: String): String; overload;
    function final: JBuffer;
    function final(output_encoding: String): String;
    procedure setAutoPadding(auto_padding: Boolean);
  end;

  JDecipher = class external
    function update(data: JBuffer): JBuffer;
    function update(data: String): String; overload;
    function update(data: String; input_encoding: String): String; overload;
    function update(data: String; input_encoding: String; output_encoding: String): String; overload;
    function final: JBuffer;
    function final(output_encoding: String): String;
    procedure setAutoPadding(auto_padding: Boolean);
  end;

  JSigner = class external(JNodeJS.WritableStream)
    procedure update(data: Variant);
    function sign(private_key: String; output_format: String): String;
  end;

  JVerify = class external(JNodeJS.WritableStream)
    procedure update(data: Variant);
    function verify(&object: String; signature: String): Boolean; overload;
    function verify(&object: String; signature: String; signature_format: String): Boolean; overload;
  end;

  JDiffieHellman = class external
    function generateKeys: String; overload;
    function generateKeys(encoding: String): String; overload;
    function computeSecret(other_public_key: String): String; overload;
    function computeSecret(other_public_key: String; input_encoding: String): String; overload;
    function computeSecret(other_public_key: String; input_encoding: String; output_encoding: String): String; overload;
    function getPrime: String; overload;
    function getPrime(encoding: String): String; overload;
    function getGenerator(encoding: String): String;
    function getPublicKey: String; overload;
    function getPublicKey(encoding: String): String; overload;
    function getPrivateKey: String; overload;
    function getPrivateKey(encoding: String): String; overload;
    procedure setPublicKey(public_key: String); overload;
    procedure setPublicKey(public_key: String; encoding: String); overload;
    procedure setPrivateKey(public_key: String); overload;
    procedure setPrivateKey(public_key: String; encoding: String); overload;
  end;

function createCredentials(details: JCredentialDetails): JCredentials;
function createHash(algorithm: String): JHash;
function createHmac(algorithm: String; key: String): JHmac;
function createHmac(algorithm: String; key: JBuffer): JHmac;
function createCipher(algorithm: String; password: Variant): JCipher;
function createCipheriv(algorithm: String; key: Variant; iv: Variant): JCipher;
function createDecipher(algorithm: String; password: Variant): JDecipher;
function createDecipheriv(algorithm: String; key: Variant; iv: Variant): JDecipher;
function createSign(algorithm: String): JSigner;
function createVerify(algorith: String): JVerify;
function createDiffieHellman(prime_length: Float): JDiffieHellman;
function createDiffieHellman(prime: Float): JDiffieHellman; overload;
function createDiffieHellman(prime: Float; encoding: String): JDiffieHellman; overload;
function getDiffieHellman(group_name: String): JDiffieHellman;
procedure pbkdf2(password: Variant {String or JBuffer}; salt: Variant {String or JBuffer}; iterations: Float; keylen: Float; callback: (err: JError; derivedKey: JBuffer): Variant);
procedure pbkdf2(password: Variant {String or JBuffer}; salt: Variant {String or JBuffer}; iterations: Float; keylen: Float; digest: String; callback: (err: JError; derivedKey: JBuffer): Variant);
function pbkdf2Sync(password: Variant {String or JBuffer}; salt: Variant {String or JBuffer}; iterations: Float; keylen: Float): JBuffer;
function pbkdf2Sync(password: Variant {String or JBuffer}; salt: Variant {String or JBuffer}; iterations: Float; keylen: Float; digest: String): JBuffer;
function randomBytes(size: Float): JBuffer;
procedure randomBytes(size: Float; callback: (err: JError; buf: JBuffer));
function pseudoRandomBytes(size: Float): JBuffer;
procedure pseudoRandomBytes(size: Float; callback: (err: JError; buf: JBuffer));

//"stream"

type
  JStream = class external 'Stream'(Jevents.EventEmitter)
    function pipe(destination: JT): JT; overload;
    function pipe(destination: JT; options:       &end: Boolean; // nullable
    end;): JT; overload;
  end;

  JReadable = class external 'Readable'(Jevents.EventEmitter)
    readable: Boolean;
    constructor Create(opts: JReadableOptions);
    procedure _read(size: Float);
    function read: Variant; overload;
    function read(size: Float): Variant; overload;
    procedure setEncoding(encoding: String);
    procedure pause;
    procedure resume;
    function pipe(destination: JT): JT; overload;
    function pipe(destination: JT; options:       &end: Boolean; // nullable
    end;): JT; overload;
    procedure unpipe; overload;
    procedure unpipe(destination: JT); overload;
    procedure unshift(chunk: Variant);
    function wrap(oldStream: JNodeJS.ReadableStream): JNodeJS.ReadableStream;
    function push(chunk: Variant): Boolean; overload;
    function push(chunk: Variant; encoding: String): Boolean; overload;
  end;

  JWritable = class external 'Writable'(Jevents.EventEmitter)
    writable: Boolean;
    constructor Create(opts: JWritableOptions);
    procedure _write(chunk: Variant; encoding: String; callback: JFunction);
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; cb: JFunction): Boolean; overload;
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; encoding: String): Boolean; overload;
    function write(chunk: Variant; encoding: String; cb: JFunction): Boolean; overload;
    procedure end;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; cb: JFunction); overload;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; encoding: String); overload;
    procedure end(chunk: Variant; encoding: String; cb: JFunction); overload;
  end;

  JDuplex = class external 'Duplex'(JReadable)
    writable: Boolean;
    constructor Create(opts: JDuplexOptions);
    procedure _write(chunk: Variant; encoding: String; callback: JFunction);
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; cb: JFunction): Boolean; overload;
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; encoding: String): Boolean; overload;
    function write(chunk: Variant; encoding: String; cb: JFunction): Boolean; overload;
    procedure end;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; cb: JFunction); overload;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; encoding: String); overload;
    procedure end(chunk: Variant; encoding: String; cb: JFunction); overload;
  end;

  JTransform = class external 'Transform'(Jevents.EventEmitter)
    readable: Boolean;
    writable: Boolean;
    constructor Create(opts: JTransformOptions);
    procedure _transform(chunk: Variant; encoding: String; callback: JFunction);
    procedure _flush(callback: JFunction);
    function read: Variant; overload;
    function read(size: Float): Variant; overload;
    procedure setEncoding(encoding: String);
    procedure pause;
    procedure resume;
    function pipe(destination: JT): JT; overload;
    function pipe(destination: JT; options:       &end: Boolean; // nullable
    end;): JT; overload;
    procedure unpipe; overload;
    procedure unpipe(destination: JT); overload;
    procedure unshift(chunk: Variant);
    function wrap(oldStream: JNodeJS.ReadableStream): JNodeJS.ReadableStream;
    function push(chunk: Variant): Boolean; overload;
    function push(chunk: Variant; encoding: String): Boolean; overload;
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; cb: JFunction): Boolean; overload;
    function write(chunk: Variant): Boolean; overload;
    function write(chunk: Variant; encoding: String): Boolean; overload;
    function write(chunk: Variant; encoding: String; cb: JFunction): Boolean; overload;
    procedure end;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; cb: JFunction); overload;
    procedure end(chunk: Variant); overload;
    procedure end(chunk: Variant; encoding: String); overload;
    procedure end(chunk: Variant; encoding: String; cb: JFunction); overload;
  end;

  JPassThrough = class external 'PassThrough'(JTransform)
  end;

  JReadableOptions = class external
    highWaterMark: Float; // nullable
    encoding: String; // nullable
    objectMode: Boolean; // nullable
  end;

  JWritableOptions = class external
    highWaterMark: Float; // nullable
    decodeStrings: Boolean; // nullable
    objectMode: Boolean; // nullable
  end;

  JDuplexOptions = class external(JReadableOptions, JWritableOptions)
    allowHalfOpen: Boolean; // nullable
  end;

  JTransformOptions = class external(JReadableOptions, JWritableOptions)
  end;

//"util"

type
  JInspectOptions = class external
    showHidden: Boolean; // nullable
    depth: Float; // nullable
    colors: Boolean; // nullable
    customInspect: Boolean; // nullable
  end;

function format(format: Variant; param: array of Variant): String;
procedure debug(&string: String);
procedure error(param: array of Variant);
procedure puts(param: array of Variant);
procedure print(param: array of Variant);
procedure log(&string: String);
function inspect(&object: Variant): String; overload;
function inspect(&object: Variant; showHidden: Boolean): String; overload;
function inspect(&object: Variant; showHidden: Boolean; depth: Float): String; overload;
function inspect(&object: Variant; showHidden: Boolean; depth: Float; color: Boolean): String; overload;
function inspect(&object: Variant; options: JInspectOptions): String;
function isArray(&object: Variant): Boolean;
function isRegExp(&object: Variant): Boolean;
function isDate(&object: Variant): Boolean;
function isError(&object: Variant): Boolean;
procedure inherits(&constructor: Variant; superConstructor: Variant);
function debuglog(key: String): (msg: String; param: array of Variant);

//"assert"

//internal

type
  JAssertionError = class external 'AssertionError'
    name: String;
    message: String;
    actual: Variant;
    expected: Variant;
    operator: String;
    generatedMessage: Boolean;
    constructor Create(options:       message: String; // nullable
      actual: Variant; // nullable
      expected: Variant; // nullable
      operator: String; // nullable
      stackStartFunction: JFunction; // nullable
    end;);
  end;

procedure fail; overload;
procedure fail(actual: Variant); overload;
procedure fail(actual: Variant; expected: Variant); overload;
procedure fail(actual: Variant; expected: Variant; message: String); overload;
procedure fail(actual: Variant; expected: Variant; message: String; operator: String); overload;
procedure ok(value: Variant); overload;
procedure ok(value: Variant; message: String); overload;
procedure equal(actual: Variant; expected: Variant); overload;
procedure equal(actual: Variant; expected: Variant; message: String); overload;
procedure notEqual(actual: Variant; expected: Variant); overload;
procedure notEqual(actual: Variant; expected: Variant; message: String); overload;
procedure deepEqual(actual: Variant; expected: Variant); overload;
procedure deepEqual(actual: Variant; expected: Variant; message: String); overload;
procedure notDeepEqual(acutal: Variant; expected: Variant); overload;
procedure notDeepEqual(acutal: Variant; expected: Variant; message: String); overload;
procedure strictEqual(actual: Variant; expected: Variant); overload;
procedure strictEqual(actual: Variant; expected: Variant; message: String); overload;
procedure notStrictEqual(actual: Variant; expected: Variant); overload;
procedure notStrictEqual(actual: Variant; expected: Variant; message: String); overload;
procedure deepStrictEqual(actual: Variant; expected: Variant); overload;
procedure deepStrictEqual(actual: Variant; expected: Variant; message: String); overload;
procedure notDeepStrictEqual(actual: Variant; expected: Variant); overload;
procedure notDeepStrictEqual(actual: Variant; expected: Variant; message: String); overload;
procedure ifError(value: Variant);

var
  throws: (block: JFunction; message: String)(block: JFunction; error: JFunction; message: String)(block: JFunction; error: JRegExp; message: String)(block: JFunction; error: (err: Variant): Boolean; message: String)  end;;
  doesNotThrow: (block: JFunction; message: String)(block: JFunction; error: JFunction; message: String)(block: JFunction; error: JRegExp; message: String)(block: JFunction; error: (err: Variant): Boolean; message: String)  end;;

procedure internal(value: Variant); overload;
procedure internal(value: Variant; message: String); overload;

//"tty"

type
  JReadStream = class external(Jnet.Socket)
    isRaw: Boolean;
    procedure setRawMode(mode: Boolean);
    isTTY: Boolean;
  end;

  JWriteStream = class external(Jnet.Socket)
    columns: Float;
    rows: Float;
    isTTY: Boolean;
  end;

function isatty(fd: Float): Boolean;

//"domain"

type
  JDomain = class external 'Domain'(Jevents.EventEmitter)
    procedure run(fn: JFunction);
    procedure add(emitter: Jevents.EventEmitter);
    procedure remove(emitter: Jevents.EventEmitter);
    function bind(cb: (err: JError; data: Variant): Variant): Variant;
    function intercept(cb: (data: Variant): Variant): Variant;
    procedure dispose;
    function addListener(event: String; listener: JFunction): JDomain;
    function on(event: String; listener: JFunction): JDomain;
    function once(event: String; listener: JFunction): JDomain;
    function removeListener(event: String; listener: JFunction): JDomain;
    function removeAllListeners: JDomain; overload;
    function removeAllListeners(event: String): JDomain; overload;
  end;

function create: JDomain;

//"constants"

var
  E2BIG: Float;
  EACCES: Float;
  EADDRINUSE: Float;
  EADDRNOTAVAIL: Float;
  EAFNOSUPPORT: Float;
  EAGAIN: Float;
  EALREADY: Float;
  EBADF: Float;
  EBADMSG: Float;
  EBUSY: Float;
  ECANCELED: Float;
  ECHILD: Float;
  ECONNABORTED: Float;
  ECONNREFUSED: Float;
  ECONNRESET: Float;
  EDEADLK: Float;
  EDESTADDRREQ: Float;
  EDOM: Float;
  EEXIST: Float;
  EFAULT: Float;
  EFBIG: Float;
  EHOSTUNREACH: Float;
  EIDRM: Float;
  EILSEQ: Float;
  EINPROGRESS: Float;
  EINTR: Float;
  EINVAL: Float;
  EIO: Float;
  EISCONN: Float;
  EISDIR: Float;
  ELOOP: Float;
  EMFILE: Float;
  EMLINK: Float;
  EMSGSIZE: Float;
  ENAMETOOLONG: Float;
  ENETDOWN: Float;
  ENETRESET: Float;
  ENETUNREACH: Float;
  ENFILE: Float;
  ENOBUFS: Float;
  ENODATA: Float;
  ENODEV: Float;
  ENOENT: Float;
  ENOEXEC: Float;
  ENOLCK: Float;
  ENOLINK: Float;
  ENOMEM: Float;
  ENOMSG: Float;
  ENOPROTOOPT: Float;
  ENOSPC: Float;
  ENOSR: Float;
  ENOSTR: Float;
  ENOSYS: Float;
  ENOTCONN: Float;
  ENOTDIR: Float;
  ENOTEMPTY: Float;
  ENOTSOCK: Float;
  ENOTSUP: Float;
  ENOTTY: Float;
  ENXIO: Float;
  EOPNOTSUPP: Float;
  EOVERFLOW: Float;
  EPERM: Float;
  EPIPE: Float;
  EPROTO: Float;
  EPROTONOSUPPORT: Float;
  EPROTOTYPE: Float;
  ERANGE: Float;
  EROFS: Float;
  ESPIPE: Float;
  ESRCH: Float;
  ETIME: Float;
  ETIMEDOUT: Float;
  ETXTBSY: Float;
  EWOULDBLOCK: Float;
  EXDEV: Float;
  WSAEINTR: Float;
  WSAEBADF: Float;
  WSAEACCES: Float;
  WSAEFAULT: Float;
  WSAEINVAL: Float;
  WSAEMFILE: Float;
  WSAEWOULDBLOCK: Float;
  WSAEINPROGRESS: Float;
  WSAEALREADY: Float;
  WSAENOTSOCK: Float;
  WSAEDESTADDRREQ: Float;
  WSAEMSGSIZE: Float;
  WSAEPROTOTYPE: Float;
  WSAENOPROTOOPT: Float;
  WSAEPROTONOSUPPORT: Float;
  WSAESOCKTNOSUPPORT: Float;
  WSAEOPNOTSUPP: Float;
  WSAEPFNOSUPPORT: Float;
  WSAEAFNOSUPPORT: Float;
  WSAEADDRINUSE: Float;
  WSAEADDRNOTAVAIL: Float;
  WSAENETDOWN: Float;
  WSAENETUNREACH: Float;
  WSAENETRESET: Float;
  WSAECONNABORTED: Float;
  WSAECONNRESET: Float;
  WSAENOBUFS: Float;
  WSAEISCONN: Float;
  WSAENOTCONN: Float;
  WSAESHUTDOWN: Float;
  WSAETOOMANYREFS: Float;
  WSAETIMEDOUT: Float;
  WSAECONNREFUSED: Float;
  WSAELOOP: Float;
  WSAENAMETOOLONG: Float;
  WSAEHOSTDOWN: Float;
  WSAEHOSTUNREACH: Float;
  WSAENOTEMPTY: Float;
  WSAEPROCLIM: Float;
  WSAEUSERS: Float;
  WSAEDQUOT: Float;
  WSAESTALE: Float;
  WSAEREMOTE: Float;
  WSASYSNOTREADY: Float;
  WSAVERNOTSUPPORTED: Float;
  WSANOTINITIALISED: Float;
  WSAEDISCON: Float;
  WSAENOMORE: Float;
  WSAECANCELLED: Float;
  WSAEINVALIDPROCTABLE: Float;
  WSAEINVALIDPROVIDER: Float;
  WSAEPROVIDERFAILEDINIT: Float;
  WSASYSCALLFAILURE: Float;
  WSASERVICE_NOT_FOUND: Float;
  WSATYPE_NOT_FOUND: Float;
  WSA_E_NO_MORE: Float;
  WSA_E_CANCELLED: Float;
  WSAEREFUSED: Float;
  SIGHUP: Float;
  SIGINT: Float;
  SIGILL: Float;
  SIGABRT: Float;
  SIGFPE: Float;
  SIGKILL: Float;
  SIGSEGV: Float;
  SIGTERM: Float;
  SIGBREAK: Float;
  SIGWINCH: Float;
  SSL_OP_ALL: Float;
  SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: Float;
  SSL_OP_CIPHER_SERVER_PREFERENCE: Float;
  SSL_OP_CISCO_ANYCONNECT: Float;
  SSL_OP_COOKIE_EXCHANGE: Float;
  SSL_OP_CRYPTOPRO_TLSEXT_BUG: Float;
  SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: Float;
  SSL_OP_EPHEMERAL_RSA: Float;
  SSL_OP_LEGACY_SERVER_CONNECT: Float;
  SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: Float;
  SSL_OP_MICROSOFT_SESS_ID_BUG: Float;
  SSL_OP_MSIE_SSLV2_RSA_PADDING: Float;
  SSL_OP_NETSCAPE_CA_DN_BUG: Float;
  SSL_OP_NETSCAPE_CHALLENGE_BUG: Float;
  SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: Float;
  SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: Float;
  SSL_OP_NO_COMPRESSION: Float;
  SSL_OP_NO_QUERY_MTU: Float;
  SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: Float;
  SSL_OP_NO_SSLv2: Float;
  SSL_OP_NO_SSLv3: Float;
  SSL_OP_NO_TICKET: Float;
  SSL_OP_NO_TLSv1: Float;
  SSL_OP_NO_TLSv1_1: Float;
  SSL_OP_NO_TLSv1_2: Float;
  SSL_OP_PKCS1_CHECK_1: Float;
  SSL_OP_PKCS1_CHECK_2: Float;
  SSL_OP_SINGLE_DH_USE: Float;
  SSL_OP_SINGLE_ECDH_USE: Float;
  SSL_OP_SSLEAY_080_CLIENT_DH_BUG: Float;
  SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: Float;
  SSL_OP_TLS_BLOCK_PADDING_BUG: Float;
  SSL_OP_TLS_D5_BUG: Float;
  SSL_OP_TLS_ROLLBACK_BUG: Float;
  ENGINE_METHOD_DSA: Float;
  ENGINE_METHOD_DH: Float;
  ENGINE_METHOD_RAND: Float;
  ENGINE_METHOD_ECDH: Float;
  ENGINE_METHOD_ECDSA: Float;
  ENGINE_METHOD_CIPHERS: Float;
  ENGINE_METHOD_DIGESTS: Float;
  ENGINE_METHOD_STORE: Float;
  ENGINE_METHOD_PKEY_METHS: Float;
  ENGINE_METHOD_PKEY_ASN1_METHS: Float;
  ENGINE_METHOD_ALL: Float;
  ENGINE_METHOD_NONE: Float;
  DH_CHECK_P_NOT_SAFE_PRIME: Float;
  DH_CHECK_P_NOT_PRIME: Float;
  DH_UNABLE_TO_CHECK_GENERATOR: Float;
  DH_NOT_SUITABLE_GENERATOR: Float;
  NPN_ENABLED: Float;
  RSA_PKCS1_PADDING: Float;
  RSA_SSLV23_PADDING: Float;
  RSA_NO_PADDING: Float;
  RSA_PKCS1_OAEP_PADDING: Float;
  RSA_X931_PADDING: Float;
  RSA_PKCS1_PSS_PADDING: Float;
  POINT_CONVERSION_COMPRESSED: Float;
  POINT_CONVERSION_UNCOMPRESSED: Float;
  POINT_CONVERSION_HYBRID: Float;
  O_RDONLY: Float;
  O_WRONLY: Float;
  O_RDWR: Float;
  S_IFMT: Float;
  S_IFREG: Float;
  S_IFDIR: Float;
  S_IFCHR: Float;
  S_IFLNK: Float;
  O_CREAT: Float;
  O_EXCL: Float;
  O_TRUNC: Float;
  O_APPEND: Float;
  F_OK: Float;
  R_OK: Float;
  W_OK: Float;
  X_OK: Float;
  UV_UDP_REUSEADDR: Float;

