unit Office_js;

interface

//Office

type
  JAsyncResult = class external
    asyncContext: Variant;
    status: JAsyncResultStatus;
    error: JError;
    value: Variant;
  end;

  JContext = class external
    contentLanguage: String;
    displayLanguage: String;
    license: String;
    touchEnabled: Boolean;
    requirements:       function isSetSupported(name: String): Boolean; overload;
      function isSetSupported(name: String; minVersion: Float): Boolean; overload;
    end;;
  end;

  JError = class external
    message: String;
    name: String;
  end;

procedure initialize(reason: JInitializationReason);
procedure useShortNamespace(useShortNamespace: Boolean);

var
  context: JContext;

//OfficeExtension

type
  JClientObject = class external 'ClientObject'
    context: JClientRequestContext;
  end;

//OfficeExtension

type
  JClientRequestContext = class external 'ClientRequestContext'
    constructor Create(url: String);
    trackedObjects: JTrackedObjects;
    procedure load(&object: JClientObject); overload;
    procedure load(&object: JClientObject; option: Variant {String or array of String or JLoadOption}); overload;
    procedure trace(message: String);
    function sync: JIPromise{<JT>}; overload;
    function sync(passThroughValue: JT): JIPromise{<JT>}; overload;
  end;

  JLoadOption = class external
    select: Variant {String or array of String}; // nullable
    expand: Variant {String or array of String}; // nullable
    top: Float; // nullable
    skip: Float; // nullable
  end;

//OfficeExtension

type
  JClientResult = class external 'ClientResult'
    value: JT;
  end;

//OfficeExtension

type
  JError = class external 'Error'
    name: String;
    message: String;
    stack: String;
    code: String;
    traceMessages: JArray{<String>};
    debugInfo:       errorLocation: String; // nullable
    end;;
  end;

//OfficeExtension

type
  JErrorCodes = class external 'ErrorCodes'
    accessDenied: String;
    generalException: String;
    activityLimitReached: String;
  end;

//OfficeExtension

type
  JIPromise{<R>} = class external
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}; onRejected: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}; onRejected: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JIPromise{<JU>}; onRejected: (error: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU; onRejected: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU; onRejected: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU): JIPromise{<JU>}; overload;
    function then(onFulfilled: (value: JR): JU; onRejected: (error: Variant)): JIPromise{<JU>}; overload;
    function catch: JIPromise{<JU>}; overload;
    function catch(onRejected: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function catch: JIPromise{<JU>}; overload;
    function catch(onRejected: (error: Variant): JU): JIPromise{<JU>}; overload;
    function catch: JIPromise{<JU>}; overload;
    function catch(onRejected: (error: Variant)): JIPromise{<JU>}; overload;
  end;

//OfficeExtension

type
  JTrackedObjects = class external 'TrackedObjects'
    procedure add(&object: JClientObject);
    procedure add(objects: array of JClientObject);
    procedure remove(&object: JClientObject);
    procedure remove(objects: array of JClientObject);
  end;

//Office

type
  JTableData = class external 'TableData'
    constructor Create(rows: array of array of Variant; headers: array of array of Variant);
    headers: array of array of Variant;
    rows: array of array of Variant;
  end;

  JBinding = class external
    document: JDocument;
    id: String;
    &type: JBindingType;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getDataAsync; overload;
    procedure getDataAsync(options: Variant); overload;
    procedure getDataAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeHandlerAsync(eventType: JEventType); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setDataAsync(data: Variant); overload;
    procedure setDataAsync(data: Variant; options: Variant); overload;
    procedure setDataAsync(data: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JBindings = class external
    document: JDocument;
    procedure addFromNamedItemAsync(itemName: String; bindingType: JBindingType); overload;
    procedure addFromNamedItemAsync(itemName: String; bindingType: JBindingType; options: Variant); overload;
    procedure addFromNamedItemAsync(itemName: String; bindingType: JBindingType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addFromPromptAsync(bindingType: JBindingType); overload;
    procedure addFromPromptAsync(bindingType: JBindingType; options: Variant); overload;
    procedure addFromPromptAsync(bindingType: JBindingType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addFromSelectionAsync(bindingType: JBindingType); overload;
    procedure addFromSelectionAsync(bindingType: JBindingType; options: Variant); overload;
    procedure addFromSelectionAsync(bindingType: JBindingType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getAllAsync; overload;
    procedure getAllAsync(options: Variant); overload;
    procedure getAllAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getByIdAsync(id: String); overload;
    procedure getByIdAsync(id: String; options: Variant); overload;
    procedure getByIdAsync(id: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure releaseByIdAsync(id: String); overload;
    procedure releaseByIdAsync(id: String; options: Variant); overload;
    procedure releaseByIdAsync(id: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JBindings = class external
    procedure getTypeAsync; overload;
    procedure getTypeAsync(options: Variant); overload;
    procedure getTypeAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure prependAsync(data: String); overload;
    procedure prependAsync(data: String; options: Variant); overload;
    procedure prependAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setSelectedDataAsync(data: String); overload;
    procedure setSelectedDataAsync(data: String; options: Variant); overload;
    procedure setSelectedDataAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JContext = class external
    document: JDocument;
  end;

  JCustomXmlNode = class external
    baseName: String;
    namespaceUri: String;
    nodeType: String;
    procedure getNodesAsync(xPath: String); overload;
    procedure getNodesAsync(xPath: String; options: Variant); overload;
    procedure getNodesAsync(xPath: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getNodeValueAsync; overload;
    procedure getNodeValueAsync(options: Variant); overload;
    procedure getNodeValueAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getXmlAsync; overload;
    procedure getXmlAsync(options: Variant); overload;
    procedure getXmlAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setNodeValueAsync(value: String); overload;
    procedure setNodeValueAsync(value: String; options: Variant); overload;
    procedure setNodeValueAsync(value: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setXmlAsync(xml: String); overload;
    procedure setXmlAsync(xml: String; options: Variant); overload;
    procedure setXmlAsync(xml: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JCustomXmlPart = class external
    builtIn: Boolean;
    id: String;
    namespaceManager: JCustomXmlPrefixMappings;
    procedure addHandlerAsync(eventType: JEventType); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: (result: Variant)); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: (result: Variant); options: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: (result: Variant); options: Variant; callback: (result: JAsyncResult)); overload;
    procedure deleteAsync; overload;
    procedure deleteAsync(options: Variant); overload;
    procedure deleteAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getNodesAsync(xPath: String); overload;
    procedure getNodesAsync(xPath: String; options: Variant); overload;
    procedure getNodesAsync(xPath: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getXmlAsync; overload;
    procedure getXmlAsync(options: Variant); overload;
    procedure getXmlAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeHandlerAsync(eventType: JEventType); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JCustomXmlParts = class external
    procedure addAsync(xml: String); overload;
    procedure addAsync(xml: String; options: Variant); overload;
    procedure addAsync(xml: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getByIdAsync(id: String); overload;
    procedure getByIdAsync(id: String; options: Variant); overload;
    procedure getByIdAsync(id: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getByNamespaceAsync(ns: String); overload;
    procedure getByNamespaceAsync(ns: String; options: Variant); overload;
    procedure getByNamespaceAsync(ns: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JCustomXmlPrefixMappings = class external
    procedure addNamespaceAsync(prefix: String; ns: String); overload;
    procedure addNamespaceAsync(prefix: String; ns: String; options: Variant); overload;
    procedure addNamespaceAsync(prefix: String; ns: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getNamespaceAsync(prefix: String); overload;
    procedure getNamespaceAsync(prefix: String; options: Variant); overload;
    procedure getNamespaceAsync(prefix: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getPrefixAsync(ns: String); overload;
    procedure getPrefixAsync(ns: String; options: Variant); overload;
    procedure getPrefixAsync(ns: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JDocument = class external
    bindings: JBindings;
    customXmlParts: JCustomXmlParts;
    mode: JDocumentMode;
    settings: JSettings;
    url: String;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getActiveViewAsync; overload;
    procedure getActiveViewAsync(options: Variant); overload;
    procedure getActiveViewAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getFileAsync(fileType: JFileType); overload;
    procedure getFileAsync(fileType: JFileType; options: Variant); overload;
    procedure getFileAsync(fileType: JFileType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getFilePropertiesAsync; overload;
    procedure getFilePropertiesAsync(options: Variant); overload;
    procedure getFilePropertiesAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getSelectedDataAsync(coercionType: JCoercionType); overload;
    procedure getSelectedDataAsync(coercionType: JCoercionType; options: Variant); overload;
    procedure getSelectedDataAsync(coercionType: JCoercionType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure goToByIdAsync(id: String; goToType: JGoToType); overload;
    procedure goToByIdAsync(id: String; goToType: JGoToType; options: Variant); overload;
    procedure goToByIdAsync(id: String; goToType: JGoToType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure goToByIdAsync(id: Float; goToType: JGoToType); overload;
    procedure goToByIdAsync(id: Float; goToType: JGoToType; options: Variant); overload;
    procedure goToByIdAsync(id: Float; goToType: JGoToType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeHandlerAsync(eventType: JEventType); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setSelectedDataAsync(data: String); overload;
    procedure setSelectedDataAsync(data: String; options: Variant); overload;
    procedure setSelectedDataAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JFile = class external
    size: Float;
    sliceCount: Float;
    procedure closeAsync; overload;
    procedure closeAsync(callback: (result: JAsyncResult)); overload;
    procedure getSliceAsync(sliceIndex: Float); overload;
    procedure getSliceAsync(sliceIndex: Float; callback: (result: JAsyncResult)); overload;
  end;

  JFileProperties = class external
    url: String;
  end;

  JMatrixBinding = class external(JBinding)
    columnCount: Float;
    rowCount: Float;
  end;

  JSettings = class external
    procedure addHandlerAsync(eventType: JEventType; handler: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant); overload;
    procedure addHandlerAsync(eventType: JEventType; handler: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    function get(name: String): Variant;
    procedure refreshAsync; overload;
    procedure refreshAsync(callback: (result: JAsyncResult)); overload;
    procedure remove(name: String);
    procedure removeHandlerAsync(eventType: JEventType); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant); overload;
    procedure removeHandlerAsync(eventType: JEventType; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure saveAsync; overload;
    procedure saveAsync(callback: (result: JAsyncResult)); overload;
    procedure set(name: String; value: Variant);
  end;

  JSlice = class external
    data: Variant;
    index: Float;
    size: Float;
  end;

  JTableBinding = class external(JBinding)
    columnCount: Float;
    hasHeaders: Boolean;
    rowCount: Float;
    procedure addColumnsAsync(tableData: JTableData); overload;
    procedure addColumnsAsync(tableData: JTableData; options: Variant); overload;
    procedure addColumnsAsync(tableData: JTableData; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addRowsAsync(rows: array of array of Variant); overload;
    procedure addRowsAsync(rows: array of array of Variant; options: Variant); overload;
    procedure addRowsAsync(rows: array of array of Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure deleteAllDataValuesAsync; overload;
    procedure deleteAllDataValuesAsync(options: Variant); overload;
    procedure deleteAllDataValuesAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure clearFormatsAsync; overload;
    procedure clearFormatsAsync(options: Variant); overload;
    procedure clearFormatsAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getFormatsAsync; overload;
    procedure getFormatsAsync(cellReference: Variant); overload;
    procedure getFormatsAsync(cellReference: Variant; formats: array of Variant); overload;
    procedure getFormatsAsync(cellReference: Variant; formats: array of Variant; options: Variant); overload;
    procedure getFormatsAsync(cellReference: Variant; formats: array of Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setFormatsAsync; overload;
    procedure setFormatsAsync(formatsInfo: array of array of Variant); overload;
    procedure setFormatsAsync(formatsInfo: array of array of Variant; options: Variant); overload;
    procedure setFormatsAsync(formatsInfo: array of array of Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setTableOptionsAsync(tableOptions: Variant); overload;
    procedure setTableOptionsAsync(tableOptions: Variant; options: Variant); overload;
    procedure setTableOptionsAsync(tableOptions: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JTextBinding = class external(JBinding)
  end;

  JDocument = class external
    procedure getProjectFieldAsync(fieldId: Float); overload;
    procedure getProjectFieldAsync(fieldId: Float; options: Variant); overload;
    procedure getProjectFieldAsync(fieldId: Float; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getResourceFieldAsync(resourceId: String; fieldId: Float); overload;
    procedure getResourceFieldAsync(resourceId: String; fieldId: Float; options: Variant); overload;
    procedure getResourceFieldAsync(resourceId: String; fieldId: Float; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getSelectedResourceAsync; overload;
    procedure getSelectedResourceAsync(options: Variant); overload;
    procedure getSelectedResourceAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getSelectedTaskAsync; overload;
    procedure getSelectedTaskAsync(options: Variant); overload;
    procedure getSelectedTaskAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getSelectedViewAsync; overload;
    procedure getSelectedViewAsync(options: Variant); overload;
    procedure getSelectedViewAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getTaskAsync(taskId: String); overload;
    procedure getTaskAsync(taskId: String; options: Variant); overload;
    procedure getTaskAsync(taskId: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getTaskFieldAsync(taskId: String; fieldId: Float); overload;
    procedure getTaskFieldAsync(taskId: String; fieldId: Float; options: Variant); overload;
    procedure getTaskFieldAsync(taskId: String; fieldId: Float; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getWSSUrlAsync; overload;
    procedure getWSSUrlAsync(options: Variant); overload;
    procedure getWSSUrlAsync(options: Variant; callback: (result: JAsyncResult)); overload;
  end;

function select(expression: String): JBinding; overload;
function select(expression: String; callback: (result: JAsyncResult)): JBinding; overload;

//Excel

type
  JApplication = class external 'Application'(JOfficeExtension.ClientObject)
    m_calculationMode: Variant;
    calculationMode: String;
    procedure calculate(calculationType: String);
    function load: JExcel.Application; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Application; overload;
  end;

  JWorkbook = class external 'Workbook'(JOfficeExtension.ClientObject)
    m_application: Variant;
    m_bindings: Variant;
    m_names: Variant;
    m_tables: Variant;
    m_worksheets: Variant;
    application: JExcel.Application;
    bindings: JExcel.BindingCollection;
    names: JExcel.NamedItemCollection;
    tables: JExcel.TableCollection;
    worksheets: JExcel.WorksheetCollection;
    function getSelectedRange: JExcel.Range;
    function load: JExcel.Workbook; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Workbook; overload;
  end;

  JWorksheet = class external 'Worksheet'(JOfficeExtension.ClientObject)
    m_charts: Variant;
    m_id: Variant;
    m_name: Variant;
    m_position: Variant;
    m_tables: Variant;
    m_visibility: Variant;
    charts: JExcel.ChartCollection;
    tables: JExcel.TableCollection;
    id: String;
    name: String;
    position: Float;
    visibility: String;
    procedure activate;
    procedure delete;
    function getCell(row: Float; column: Float): JExcel.Range;
    function getRange: JExcel.Range; overload;
    function getRange(address: String): JExcel.Range; overload;
    function getUsedRange: JExcel.Range;
    function load: JExcel.Worksheet; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Worksheet; overload;
  end;

  JWorksheetCollection = class external 'WorksheetCollection'(JOfficeExtension.ClientObject)
    m__items: Variant;
    items: JArray{<JExcel.Worksheet>};
    function add: JExcel.Worksheet; overload;
    function add(name: String): JExcel.Worksheet; overload;
    function getActiveWorksheet: JExcel.Worksheet;
    function getItem(key: String): JExcel.Worksheet;
    function load: JExcel.WorksheetCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.WorksheetCollection; overload;
  end;

  JRange = class external 'Range'(JOfficeExtension.ClientObject)
    m_address: Variant;
    m_addressLocal: Variant;
    m_cellCount: Variant;
    m_columnCount: Variant;
    m_columnIndex: Variant;
    m_format: Variant;
    m_formulas: Variant;
    m_formulasLocal: Variant;
    m_numberFormat: Variant;
    m_rowCount: Variant;
    m_rowIndex: Variant;
    m_text: Variant;
    m_valueTypes: Variant;
    m_values: Variant;
    m_worksheet: Variant;
    m__ReferenceId: Variant;
    format: JExcel.RangeFormat;
    worksheet: JExcel.Worksheet;
    address: String;
    addressLocal: String;
    cellCount: Float;
    columnCount: Float;
    columnIndex: Float;
    formulas: JArray{<JArray{<Variant>}>};
    formulasLocal: JArray{<JArray{<Variant>}>};
    numberFormat: JArray{<JArray{<Variant>}>};
    rowCount: Float;
    rowIndex: Float;
    text: JArray{<JArray{<Variant>}>};
    valueTypes: JArray{<JArray{<String>}>};
    values: JArray{<JArray{<Variant>}>};
    procedure clear; overload;
    procedure clear(applyTo: String); overload;
    procedure delete(shift: String);
    function getBoundingRect(anotherRange: Variant {JExcel.Range or String}): JExcel.Range;
    function getCell(row: Float; column: Float): JExcel.Range;
    function getColumn(column: Float): JExcel.Range;
    function getEntireColumn: JExcel.Range;
    function getEntireRow: JExcel.Range;
    function getIntersection(anotherRange: Variant {JExcel.Range or String}): JExcel.Range;
    function getLastCell: JExcel.Range;
    function getLastColumn: JExcel.Range;
    function getLastRow: JExcel.Range;
    function getOffsetRange(rowOffset: Float; columnOffset: Float): JExcel.Range;
    function getRow(row: Float): JExcel.Range;
    function getUsedRange: JExcel.Range;
    function insert(shift: String): JExcel.Range;
    procedure select;
    function load: JExcel.Range; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Range; overload;
  end;

  JNamedItemCollection = class external 'NamedItemCollection'(JOfficeExtension.ClientObject)
    m__items: Variant;
    items: JArray{<JExcel.NamedItem>};
    function getItem(name: String): JExcel.NamedItem;
    function load: JExcel.NamedItemCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.NamedItemCollection; overload;
  end;

  JNamedItem = class external 'NamedItem'(JOfficeExtension.ClientObject)
    m_name: Variant;
    m_type: Variant;
    m_value: Variant;
    m_visible: Variant;
    m__Id: Variant;
    name: String;
    &type: String;
    value: Variant;
    visible: Boolean;
    function getRange: JExcel.Range;
    function load: JExcel.NamedItem; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.NamedItem; overload;
  end;

  JBinding = class external 'Binding'(JOfficeExtension.ClientObject)
    m_id: Variant;
    m_type: Variant;
    id: String;
    &type: String;
    function getRange: JExcel.Range;
    function getTable: JExcel.Table;
    function getText: JOfficeExtension.ClientResult{<String>};
    function load: JExcel.Binding; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Binding; overload;
  end;

  JBindingCollection = class external 'BindingCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.Binding>};
    count: Float;
    function getItem(id: String): JExcel.Binding;
    function getItemAt(index: Float): JExcel.Binding;
    function load: JExcel.BindingCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.BindingCollection; overload;
  end;

  JTableCollection = class external 'TableCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.Table>};
    count: Float;
    function add(address: String; hasHeaders: Boolean): JExcel.Table;
    function getItem(key: Variant {Float or String}): JExcel.Table;
    function getItemAt(index: Float): JExcel.Table;
    function load: JExcel.TableCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.TableCollection; overload;
  end;

  JTable = class external 'Table'(JOfficeExtension.ClientObject)
    m_columns: Variant;
    m_id: Variant;
    m_name: Variant;
    m_rows: Variant;
    m_showHeaders: Variant;
    m_showTotals: Variant;
    m_style: Variant;
    columns: JExcel.TableColumnCollection;
    rows: JExcel.TableRowCollection;
    id: Float;
    name: String;
    showHeaders: Boolean;
    showTotals: Boolean;
    style: String;
    procedure delete;
    function getDataBodyRange: JExcel.Range;
    function getHeaderRowRange: JExcel.Range;
    function getRange: JExcel.Range;
    function getTotalRowRange: JExcel.Range;
    function load: JExcel.Table; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Table; overload;
  end;

  JTableColumnCollection = class external 'TableColumnCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.TableColumn>};
    count: Float;
    function add(index: Float): JExcel.TableColumn; overload;
    function add(index: Float; values: Variant {JArray{<JArray{<Variant {Boolean or String or Float}>}>} or Boolean or String or Float}): JExcel.TableColumn; overload;
    function getItem(key: Variant {Float or String}): JExcel.TableColumn;
    function getItemAt(index: Float): JExcel.TableColumn;
    function load: JExcel.TableColumnCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.TableColumnCollection; overload;
  end;

  JTableColumn = class external 'TableColumn'(JOfficeExtension.ClientObject)
    m_id: Variant;
    m_index: Variant;
    m_name: Variant;
    m_values: Variant;
    id: Float;
    index: Float;
    name: String;
    values: JArray{<JArray{<Variant>}>};
    procedure delete;
    function getDataBodyRange: JExcel.Range;
    function getHeaderRowRange: JExcel.Range;
    function getRange: JExcel.Range;
    function getTotalRowRange: JExcel.Range;
    function load: JExcel.TableColumn; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.TableColumn; overload;
  end;

  JTableRowCollection = class external 'TableRowCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.TableRow>};
    count: Float;
    function add: JExcel.TableRow; overload;
    function add(index: Float): JExcel.TableRow; overload;
    function add(index: Float; values: Variant {JArray{<JArray{<Variant {Boolean or String or Float}>}>} or Boolean or String or Float}): JExcel.TableRow; overload;
    function getItemAt(index: Float): JExcel.TableRow;
    function load: JExcel.TableRowCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.TableRowCollection; overload;
  end;

  JTableRow = class external 'TableRow'(JOfficeExtension.ClientObject)
    m_index: Variant;
    m_values: Variant;
    index: Float;
    values: JArray{<JArray{<Variant>}>};
    procedure delete;
    function getRange: JExcel.Range;
    function load: JExcel.TableRow; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.TableRow; overload;
  end;

  JRangeFormat = class external 'RangeFormat'(JOfficeExtension.ClientObject)
    m_borders: Variant;
    m_fill: Variant;
    m_font: Variant;
    m_horizontalAlignment: Variant;
    m_verticalAlignment: Variant;
    m_wrapText: Variant;
    borders: JExcel.RangeBorderCollection;
    fill: JExcel.RangeFill;
    font: JExcel.RangeFont;
    horizontalAlignment: String;
    verticalAlignment: String;
    wrapText: Boolean;
    function load: JExcel.RangeFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.RangeFormat; overload;
  end;

  JRangeFill = class external 'RangeFill'(JOfficeExtension.ClientObject)
    m_color: Variant;
    color: String;
    procedure clear;
    function load: JExcel.RangeFill; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.RangeFill; overload;
  end;

  JRangeBorder = class external 'RangeBorder'(JOfficeExtension.ClientObject)
    m_color: Variant;
    m_sideIndex: Variant;
    m_style: Variant;
    m_weight: Variant;
    color: String;
    sideIndex: String;
    style: String;
    weight: String;
    function load: JExcel.RangeBorder; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.RangeBorder; overload;
  end;

  JRangeBorderCollection = class external 'RangeBorderCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.RangeBorder>};
    count: Float;
    function getItem(index: String): JExcel.RangeBorder;
    function getItemAt(index: Float): JExcel.RangeBorder;
    function load: JExcel.RangeBorderCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.RangeBorderCollection; overload;
  end;

  JRangeFont = class external 'RangeFont'(JOfficeExtension.ClientObject)
    m_bold: Variant;
    m_color: Variant;
    m_italic: Variant;
    m_name: Variant;
    m_size: Variant;
    m_underline: Variant;
    bold: Boolean;
    color: String;
    italic: Boolean;
    name: String;
    size: Float;
    underline: String;
    function load: JExcel.RangeFont; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.RangeFont; overload;
  end;

  JChartCollection = class external 'ChartCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.Chart>};
    count: Float;
    function add(&type: String; sourceData: JExcel.Range): JExcel.Chart; overload;
    function add(&type: String; sourceData: JExcel.Range; seriesBy: String): JExcel.Chart; overload;
    function getItem(name: String): JExcel.Chart;
    function getItemAt(index: Float): JExcel.Chart;
    function load: JExcel.ChartCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartCollection; overload;
  end;

  JChart = class external 'Chart'(JOfficeExtension.ClientObject)
    m_axes: Variant;
    m_dataLabels: Variant;
    m_format: Variant;
    m_height: Variant;
    m_left: Variant;
    m_legend: Variant;
    m_name: Variant;
    m_series: Variant;
    m_title: Variant;
    m_top: Variant;
    m_width: Variant;
    m__Id: Variant;
    axes: JExcel.ChartAxes;
    dataLabels: JExcel.ChartDataLabels;
    format: JExcel.ChartAreaFormat;
    legend: JExcel.ChartLegend;
    series: JExcel.ChartSeriesCollection;
    title: JExcel.ChartTitle;
    height: Float;
    left: Float;
    name: String;
    top: Float;
    width: Float;
    procedure delete;
    procedure setData(sourceData: JExcel.Range); overload;
    procedure setData(sourceData: JExcel.Range; seriesBy: String); overload;
    procedure setPosition(startCell: Variant {JExcel.Range or String}); overload;
    procedure setPosition(startCell: Variant {JExcel.Range or String}; endCell: Variant {JExcel.Range or String}); overload;
    function load: JExcel.Chart; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.Chart; overload;
  end;

  JChartAreaFormat = class external 'ChartAreaFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    m_font: Variant;
    fill: JExcel.ChartFill;
    font: JExcel.ChartFont;
    function load: JExcel.ChartAreaFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAreaFormat; overload;
  end;

  JChartSeriesCollection = class external 'ChartSeriesCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.ChartSeries>};
    count: Float;
    function getItemAt(index: Float): JExcel.ChartSeries;
    function load: JExcel.ChartSeriesCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartSeriesCollection; overload;
  end;

  JChartSeries = class external 'ChartSeries'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_name: Variant;
    m_points: Variant;
    format: JExcel.ChartSeriesFormat;
    points: JExcel.ChartPointsCollection;
    name: String;
    function load: JExcel.ChartSeries; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartSeries; overload;
  end;

  JChartSeriesFormat = class external 'ChartSeriesFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    m_line: Variant;
    fill: JExcel.ChartFill;
    line: JExcel.ChartLineFormat;
    function load: JExcel.ChartSeriesFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartSeriesFormat; overload;
  end;

  JChartPointsCollection = class external 'ChartPointsCollection'(JOfficeExtension.ClientObject)
    m_count: Variant;
    m__items: Variant;
    items: JArray{<JExcel.ChartPoint>};
    count: Float;
    function getItemAt(index: Float): JExcel.ChartPoint;
    function load: JExcel.ChartPointsCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartPointsCollection; overload;
  end;

  JChartPoint = class external 'ChartPoint'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_value: Variant;
    format: JExcel.ChartPointFormat;
    value: Variant;
    function load: JExcel.ChartPoint; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartPoint; overload;
  end;

  JChartPointFormat = class external 'ChartPointFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    fill: JExcel.ChartFill;
    function load: JExcel.ChartPointFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartPointFormat; overload;
  end;

  JChartAxes = class external 'ChartAxes'(JOfficeExtension.ClientObject)
    m_categoryAxis: Variant;
    m_seriesAxis: Variant;
    m_valueAxis: Variant;
    categoryAxis: JExcel.ChartAxis;
    seriesAxis: JExcel.ChartAxis;
    valueAxis: JExcel.ChartAxis;
    function load: JExcel.ChartAxes; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAxes; overload;
  end;

  JChartAxis = class external 'ChartAxis'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_majorGridlines: Variant;
    m_majorUnit: Variant;
    m_maximum: Variant;
    m_minimum: Variant;
    m_minorGridlines: Variant;
    m_minorUnit: Variant;
    m_title: Variant;
    format: JExcel.ChartAxisFormat;
    majorGridlines: JExcel.ChartGridlines;
    minorGridlines: JExcel.ChartGridlines;
    title: JExcel.ChartAxisTitle;
    majorUnit: Variant;
    maximum: Variant;
    minimum: Variant;
    minorUnit: Variant;
    function load: JExcel.ChartAxis; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAxis; overload;
  end;

  JChartAxisFormat = class external 'ChartAxisFormat'(JOfficeExtension.ClientObject)
    m_font: Variant;
    m_line: Variant;
    font: JExcel.ChartFont;
    line: JExcel.ChartLineFormat;
    function load: JExcel.ChartAxisFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAxisFormat; overload;
  end;

  JChartAxisTitle = class external 'ChartAxisTitle'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_text: Variant;
    m_visible: Variant;
    format: JExcel.ChartAxisTitleFormat;
    text: String;
    visible: Boolean;
    function load: JExcel.ChartAxisTitle; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAxisTitle; overload;
  end;

  JChartAxisTitleFormat = class external 'ChartAxisTitleFormat'(JOfficeExtension.ClientObject)
    m_font: Variant;
    font: JExcel.ChartFont;
    function load: JExcel.ChartAxisTitleFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartAxisTitleFormat; overload;
  end;

  JChartDataLabels = class external 'ChartDataLabels'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_position: Variant;
    m_separator: Variant;
    m_showBubbleSize: Variant;
    m_showCategoryName: Variant;
    m_showLegendKey: Variant;
    m_showPercentage: Variant;
    m_showSeriesName: Variant;
    m_showValue: Variant;
    format: JExcel.ChartDataLabelFormat;
    position: String;
    separator: String;
    showBubbleSize: Boolean;
    showCategoryName: Boolean;
    showLegendKey: Boolean;
    showPercentage: Boolean;
    showSeriesName: Boolean;
    showValue: Boolean;
    function load: JExcel.ChartDataLabels; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartDataLabels; overload;
  end;

  JChartDataLabelFormat = class external 'ChartDataLabelFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    m_font: Variant;
    fill: JExcel.ChartFill;
    font: JExcel.ChartFont;
    function load: JExcel.ChartDataLabelFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartDataLabelFormat; overload;
  end;

  JChartGridlines = class external 'ChartGridlines'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_visible: Variant;
    format: JExcel.ChartGridlinesFormat;
    visible: Boolean;
    function load: JExcel.ChartGridlines; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartGridlines; overload;
  end;

  JChartGridlinesFormat = class external 'ChartGridlinesFormat'(JOfficeExtension.ClientObject)
    m_line: Variant;
    line: JExcel.ChartLineFormat;
    function load: JExcel.ChartGridlinesFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartGridlinesFormat; overload;
  end;

  JChartLegend = class external 'ChartLegend'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_overlay: Variant;
    m_position: Variant;
    m_visible: Variant;
    format: JExcel.ChartLegendFormat;
    overlay: Boolean;
    position: String;
    visible: Boolean;
    function load: JExcel.ChartLegend; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartLegend; overload;
  end;

  JChartLegendFormat = class external 'ChartLegendFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    m_font: Variant;
    fill: JExcel.ChartFill;
    font: JExcel.ChartFont;
    function load: JExcel.ChartLegendFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartLegendFormat; overload;
  end;

  JChartTitle = class external 'ChartTitle'(JOfficeExtension.ClientObject)
    m_format: Variant;
    m_overlay: Variant;
    m_text: Variant;
    m_visible: Variant;
    format: JExcel.ChartTitleFormat;
    overlay: Boolean;
    text: String;
    visible: Boolean;
    function load: JExcel.ChartTitle; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartTitle; overload;
  end;

  JChartTitleFormat = class external 'ChartTitleFormat'(JOfficeExtension.ClientObject)
    m_fill: Variant;
    m_font: Variant;
    fill: JExcel.ChartFill;
    font: JExcel.ChartFont;
    function load: JExcel.ChartTitleFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartTitleFormat; overload;
  end;

  JChartFill = class external 'ChartFill'(JOfficeExtension.ClientObject)
    procedure clear;
    procedure setSolidColor(color: String);
    function load: JExcel.ChartFill; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartFill; overload;
  end;

  JChartLineFormat = class external 'ChartLineFormat'(JOfficeExtension.ClientObject)
    m_color: Variant;
    color: String;
    procedure clear;
    function load: JExcel.ChartLineFormat; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartLineFormat; overload;
  end;

  JChartFont = class external 'ChartFont'(JOfficeExtension.ClientObject)
    m_bold: Variant;
    m_color: Variant;
    m_italic: Variant;
    m_name: Variant;
    m_size: Variant;
    m_underline: Variant;
    bold: Boolean;
    color: String;
    italic: Boolean;
    name: String;
    size: Float;
    underline: String;
    function load: JExcel.ChartFont; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JExcel.ChartFont; overload;
  end;

//BindingType

var
  range: String;
  table: String;
  text: String;

//BorderIndex

var
  edgeTop: String;
  edgeBottom: String;
  edgeLeft: String;
  edgeRight: String;
  insideVertical: String;
  insideHorizontal: String;
  diagonalDown: String;
  diagonalUp: String;

//BorderLineStyle

var
  none: String;
  continuous: String;
  dash: String;
  dashDot: String;
  dashDotDot: String;
  dot: String;
  double: String;
  slantDashDot: String;

//BorderWeight

var
  hairline: String;
  thin: String;
  medium: String;
  thick: String;

//CalculationMode

var
  automatic: String;
  automaticExceptTables: String;
  manual: String;

//CalculationType

var
  recalculate: String;
  full: String;
  fullRebuild: String;

//ClearApplyTo

var
  all: String;
  formats: String;
  contents: String;

//ChartDataLabelPosition

var
  invalid: String;
  none: String;
  center: String;
  insideEnd: String;
  insideBase: String;
  outsideEnd: String;
  left: String;
  right: String;
  top: String;
  bottom: String;
  bestFit: String;
  callout: String;

//ChartLegendPosition

var
  invalid: String;
  top: String;
  bottom: String;
  left: String;
  right: String;
  corner: String;
  custom: String;

//ChartSeriesBy

var
  auto: String;
  columns: String;
  rows: String;

//ChartType

var
  invalid: String;
  columnClustered: String;
  columnStacked: String;
  columnStacked100: String;
  _3DColumnClustered: String;
  _3DColumnStacked: String;
  _3DColumnStacked100: String;
  barClustered: String;
  barStacked: String;
  barStacked100: String;
  _3DBarClustered: String;
  _3DBarStacked: String;
  _3DBarStacked100: String;
  lineStacked: String;
  lineStacked100: String;
  lineMarkers: String;
  lineMarkersStacked: String;
  lineMarkersStacked100: String;
  pieOfPie: String;
  pieExploded: String;
  _3DPieExploded: String;
  barOfPie: String;
  xyscatterSmooth: String;
  xyscatterSmoothNoMarkers: String;
  xyscatterLines: String;
  xyscatterLinesNoMarkers: String;
  areaStacked: String;
  areaStacked100: String;
  _3DAreaStacked: String;
  _3DAreaStacked100: String;
  doughnutExploded: String;
  radarMarkers: String;
  radarFilled: String;
  surface: String;
  surfaceWireframe: String;
  surfaceTopView: String;
  surfaceTopViewWireframe: String;
  bubble: String;
  bubble3DEffect: String;
  stockHLC: String;
  stockOHLC: String;
  stockVHLC: String;
  stockVOHLC: String;
  cylinderColClustered: String;
  cylinderColStacked: String;
  cylinderColStacked100: String;
  cylinderBarClustered: String;
  cylinderBarStacked: String;
  cylinderBarStacked100: String;
  cylinderCol: String;
  coneColClustered: String;
  coneColStacked: String;
  coneColStacked100: String;
  coneBarClustered: String;
  coneBarStacked: String;
  coneBarStacked100: String;
  coneCol: String;
  pyramidColClustered: String;
  pyramidColStacked: String;
  pyramidColStacked100: String;
  pyramidBarClustered: String;
  pyramidBarStacked: String;
  pyramidBarStacked100: String;
  pyramidCol: String;
  _3DColumn: String;
  line: String;
  _3DLine: String;
  _3DPie: String;
  pie: String;
  xyscatter: String;
  _3DArea: String;
  area: String;
  doughnut: String;
  radar: String;

//ChartUnderlineStyle

var
  none: String;
  single: String;

//DeleteShiftDirection

var
  up: String;
  left: String;

//HorizontalAlignment

var
  general: String;
  left: String;
  center: String;
  right: String;
  fill: String;
  justify: String;
  centerAcrossSelection: String;
  distributed: String;

//InsertShiftDirection

var
  down: String;
  right: String;

//NamedItemType

var
  string: String;
  integer: String;
  double: String;
  boolean: String;
  range: String;

//RangeUnderlineStyle

var
  none: String;
  single: String;
  double: String;
  singleAccountant: String;
  doubleAccountant: String;

//SheetVisibility

var
  visible: String;
  hidden: String;
  veryHidden: String;

//RangeValueType

var
  unknown: String;
  empty: String;
  string: String;
  integer: String;
  double: String;
  boolean: String;
  error: String;

//VerticalAlignment

var
  top: String;
  center: String;
  bottom: String;
  justify: String;
  distributed: String;

//ErrorCodes

var
  accessDenied: String;
  generalException: String;
  insertDeleteConflict: String;
  invalidArgument: String;
  invalidBinding: String;
  invalidOperation: String;
  invalidReference: String;
  invalidSelection: String;
  itemAlreadyExists: String;
  itemNotFound: String;
  notImplemented: String;
  unsupportedOperation: String;

//Excel

type
  JRequestContext = class external 'RequestContext'(JOfficeExtension.ClientRequestContext)
    m_workbook: Variant;
    constructor Create(url: String);
    workbook: JWorkbook;
  end;

function run(batch: (context: JExcel.RequestContext): JOfficeExtension.IPromise{<JT>}): JOfficeExtension.IPromise{<JT>};

//Word

type
  JBody = class external 'Body'(JOfficeExtension.ClientObject)
    m_contentControls: Variant;
    m_font: Variant;
    m_inlinePictures: Variant;
    m_paragraphs: Variant;
    m_parentContentControl: Variant;
    m_style: Variant;
    m_text: Variant;
    m__ReferenceId: Variant;
    contentControls: JWord.ContentControlCollection;
    font: JWord.Font;
    inlinePictures: JWord.InlinePictureCollection;
    paragraphs: JWord.ParagraphCollection;
    parentContentControl: JWord.ContentControl;
    style: String;
    text: String;
    procedure clear;
    function getHtml: JOfficeExtension.ClientResult{<String>};
    function getOoxml: JOfficeExtension.ClientResult{<String>};
    procedure insertBreak(breakType: String; insertLocation: String);
    function insertContentControl: JWord.ContentControl;
    function insertFileFromBase64(base64File: String; insertLocation: String): JWord.Range;
    function insertHtml(html: String; insertLocation: String): JWord.Range;
    function insertOoxml(ooxml: String; insertLocation: String): JWord.Range;
    function insertParagraph(paragraphText: String; insertLocation: String): JWord.Paragraph;
    function insertText(text: String; insertLocation: String): JWord.Range;
    function search(searchText: String): JWord.SearchResultCollection; overload;
    function search(searchText: String; searchOptions: Variant {JWord.SearchOptions or       ignorePunct: Boolean; // nullable
      ignoreSpace: Boolean; // nullable
      matchCase: Boolean; // nullable
      matchPrefix: Boolean; // nullable
      matchSoundsLike: Boolean; // nullable
      matchSuffix: Boolean; // nullable
      matchWholeWord: Boolean; // nullable
      matchWildCards: Boolean; // nullable
    end;}): JWord.SearchResultCollection; overload;
    procedure select;
    function load: JWord.Body; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Body; overload;
  end;

  JContentControl = class external 'ContentControl'(JOfficeExtension.ClientObject)
    m_appearance: Variant;
    m_cannotDelete: Variant;
    m_cannotEdit: Variant;
    m_color: Variant;
    m_contentControls: Variant;
    m_font: Variant;
    m_id: Variant;
    m_inlinePictures: Variant;
    m_paragraphs: Variant;
    m_parentContentControl: Variant;
    m_placeholderText: Variant;
    m_removeWhenEdited: Variant;
    m_style: Variant;
    m_tag: Variant;
    m_text: Variant;
    m_title: Variant;
    m_type: Variant;
    m__ReferenceId: Variant;
    contentControls: JWord.ContentControlCollection;
    font: JWord.Font;
    inlinePictures: JWord.InlinePictureCollection;
    paragraphs: JWord.ParagraphCollection;
    parentContentControl: JWord.ContentControl;
    appearance: String;
    cannotDelete: Boolean;
    cannotEdit: Boolean;
    color: String;
    id: Float;
    placeholderText: String;
    removeWhenEdited: Boolean;
    style: String;
    tag: String;
    text: String;
    title: String;
    &type: String;
    procedure clear;
    procedure delete(keepContent: Boolean);
    function getHtml: JOfficeExtension.ClientResult{<String>};
    function getOoxml: JOfficeExtension.ClientResult{<String>};
    procedure insertBreak(breakType: String; insertLocation: String);
    function insertFileFromBase64(base64File: String; insertLocation: String): JWord.Range;
    function insertHtml(html: String; insertLocation: String): JWord.Range;
    function insertOoxml(ooxml: String; insertLocation: String): JWord.Range;
    function insertParagraph(paragraphText: String; insertLocation: String): JWord.Paragraph;
    function insertText(text: String; insertLocation: String): JWord.Range;
    function search(searchText: String): JWord.SearchResultCollection; overload;
    function search(searchText: String; searchOptions: Variant {JWord.SearchOptions or       ignorePunct: Boolean; // nullable
      ignoreSpace: Boolean; // nullable
      matchCase: Boolean; // nullable
      matchPrefix: Boolean; // nullable
      matchSoundsLike: Boolean; // nullable
      matchSuffix: Boolean; // nullable
      matchWholeWord: Boolean; // nullable
      matchWildCards: Boolean; // nullable
    end;}): JWord.SearchResultCollection; overload;
    procedure select;
    function load: JWord.ContentControl; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.ContentControl; overload;
  end;

  JContentControlCollection = class external 'ContentControlCollection'(JOfficeExtension.ClientObject)
    m__ReferenceId: Variant;
    m__items: Variant;
    items: JArray{<JWord.ContentControl>};
    function getById(id: Float): JWord.ContentControl;
    function getByTag(tag: String): JWord.ContentControlCollection;
    function getByTitle(title: String): JWord.ContentControlCollection;
    function getItem(index: Float): JWord.ContentControl;
    function load: JWord.ContentControlCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.ContentControlCollection; overload;
  end;

  JDocument = class external 'Document'(JOfficeExtension.ClientObject)
    m_body: Variant;
    m_contentControls: Variant;
    m_saved: Variant;
    m_sections: Variant;
    body: JWord.Body;
    contentControls: JWord.ContentControlCollection;
    sections: JWord.SectionCollection;
    saved: Boolean;
    function getSelection: JWord.Range;
    procedure save;
    function load: JWord.Document; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Document; overload;
  end;

  JFont = class external 'Font'(JOfficeExtension.ClientObject)
    m_bold: Variant;
    m_color: Variant;
    m_doubleStrikeThrough: Variant;
    m_highlightColor: Variant;
    m_italic: Variant;
    m_name: Variant;
    m_size: Variant;
    m_strikeThrough: Variant;
    m_subscript: Variant;
    m_superscript: Variant;
    m_underline: Variant;
    m__ReferenceId: Variant;
    bold: Boolean;
    color: String;
    doubleStrikeThrough: Boolean;
    highlightColor: String;
    italic: Boolean;
    name: String;
    size: Float;
    strikeThrough: Boolean;
    subscript: Boolean;
    superscript: Boolean;
    underline: String;
    function load: JWord.Font; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Font; overload;
  end;

  JInlinePicture = class external 'InlinePicture'(JOfficeExtension.ClientObject)
    m_altTextDescription: Variant;
    m_altTextTitle: Variant;
    m_height: Variant;
    m_hyperlink: Variant;
    m_lockAspectRatio: Variant;
    m_parentContentControl: Variant;
    m_width: Variant;
    m__Id: Variant;
    m__ReferenceId: Variant;
    parentContentControl: JWord.ContentControl;
    altTextDescription: String;
    altTextTitle: String;
    height: Float;
    hyperlink: String;
    lockAspectRatio: Boolean;
    width: Float;
    function getBase64ImageSrc: JOfficeExtension.ClientResult{<String>};
    function insertContentControl: JWord.ContentControl;
    function load: JWord.InlinePicture; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.InlinePicture; overload;
  end;

  JInlinePictureCollection = class external 'InlinePictureCollection'(JOfficeExtension.ClientObject)
    m__ReferenceId: Variant;
    m__items: Variant;
    items: JArray{<JWord.InlinePicture>};
    function load: JWord.InlinePictureCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.InlinePictureCollection; overload;
  end;

  JParagraph = class external 'Paragraph'(JOfficeExtension.ClientObject)
    m_alignment: Variant;
    m_contentControls: Variant;
    m_firstLineIndent: Variant;
    m_font: Variant;
    m_inlinePictures: Variant;
    m_leftIndent: Variant;
    m_lineSpacing: Variant;
    m_lineUnitAfter: Variant;
    m_lineUnitBefore: Variant;
    m_outlineLevel: Variant;
    m_parentContentControl: Variant;
    m_rightIndent: Variant;
    m_spaceAfter: Variant;
    m_spaceBefore: Variant;
    m_style: Variant;
    m_text: Variant;
    m__Id: Variant;
    m__ReferenceId: Variant;
    contentControls: JWord.ContentControlCollection;
    font: JWord.Font;
    inlinePictures: JWord.InlinePictureCollection;
    parentContentControl: JWord.ContentControl;
    alignment: String;
    firstLineIndent: Float;
    leftIndent: Float;
    lineSpacing: Float;
    lineUnitAfter: Float;
    lineUnitBefore: Float;
    outlineLevel: Float;
    rightIndent: Float;
    spaceAfter: Float;
    spaceBefore: Float;
    style: String;
    text: String;
    procedure clear;
    procedure delete;
    function getHtml: JOfficeExtension.ClientResult{<String>};
    function getOoxml: JOfficeExtension.ClientResult{<String>};
    procedure insertBreak(breakType: String; insertLocation: String);
    function insertContentControl: JWord.ContentControl;
    function insertFileFromBase64(base64File: String; insertLocation: String): JWord.Range;
    function insertHtml(html: String; insertLocation: String): JWord.Range;
    function insertInlinePictureFromBase64(base64EncodedImage: String; insertLocation: String): JWord.InlinePicture;
    function insertOoxml(ooxml: String; insertLocation: String): JWord.Range;
    function insertParagraph(paragraphText: String; insertLocation: String): JWord.Paragraph;
    function insertText(text: String; insertLocation: String): JWord.Range;
    function search(searchText: String): JWord.SearchResultCollection; overload;
    function search(searchText: String; searchOptions: Variant {JWord.SearchOptions or       ignorePunct: Boolean; // nullable
      ignoreSpace: Boolean; // nullable
      matchCase: Boolean; // nullable
      matchPrefix: Boolean; // nullable
      matchSoundsLike: Boolean; // nullable
      matchSuffix: Boolean; // nullable
      matchWholeWord: Boolean; // nullable
      matchWildCards: Boolean; // nullable
    end;}): JWord.SearchResultCollection; overload;
    procedure select;
    function load: JWord.Paragraph; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Paragraph; overload;
  end;

  JParagraphCollection = class external 'ParagraphCollection'(JOfficeExtension.ClientObject)
    m__ReferenceId: Variant;
    m__items: Variant;
    items: JArray{<JWord.Paragraph>};
    function load: JWord.ParagraphCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.ParagraphCollection; overload;
  end;

  JRange = class external 'Range'(JOfficeExtension.ClientObject)
    m_contentControls: Variant;
    m_font: Variant;
    m_paragraphs: Variant;
    m_parentContentControl: Variant;
    m_style: Variant;
    m_text: Variant;
    m__Id: Variant;
    m__ReferenceId: Variant;
    contentControls: JWord.ContentControlCollection;
    font: JWord.Font;
    paragraphs: JWord.ParagraphCollection;
    parentContentControl: JWord.ContentControl;
    style: String;
    text: String;
    procedure clear;
    procedure delete;
    function getHtml: JOfficeExtension.ClientResult{<String>};
    function getOoxml: JOfficeExtension.ClientResult{<String>};
    procedure insertBreak(breakType: String; insertLocation: String);
    function insertContentControl: JWord.ContentControl;
    function insertFileFromBase64(base64File: String; insertLocation: String): JWord.Range;
    function insertHtml(html: String; insertLocation: String): JWord.Range;
    function insertOoxml(ooxml: String; insertLocation: String): JWord.Range;
    function insertParagraph(paragraphText: String; insertLocation: String): JWord.Paragraph;
    function insertText(text: String; insertLocation: String): JWord.Range;
    function search(searchText: String): JWord.SearchResultCollection; overload;
    function search(searchText: String; searchOptions: Variant {JWord.SearchOptions or       ignorePunct: Boolean; // nullable
      ignoreSpace: Boolean; // nullable
      matchCase: Boolean; // nullable
      matchPrefix: Boolean; // nullable
      matchSoundsLike: Boolean; // nullable
      matchSuffix: Boolean; // nullable
      matchWholeWord: Boolean; // nullable
      matchWildCards: Boolean; // nullable
    end;}): JWord.SearchResultCollection; overload;
    procedure select;
    function load: JWord.Range; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Range; overload;
  end;

  JSearchOptions = class external 'SearchOptions'(JOfficeExtension.ClientObject)
    m_ignorePunct: Variant;
    m_ignoreSpace: Variant;
    m_matchCase: Variant;
    m_matchPrefix: Variant;
    m_matchSoundsLike: Variant;
    m_matchSuffix: Variant;
    m_matchWholeWord: Variant;
    m_matchWildCards: Variant;
    ignorePunct: Boolean;
    ignoreSpace: Boolean;
    matchCase: Boolean;
    matchPrefix: Boolean;
    matchSoundsLike: Boolean;
    matchSuffix: Boolean;
    matchWholeWord: Boolean;
    matchWildCards: Boolean;
    function load: JWord.SearchOptions; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.SearchOptions; overload;
    function newObject(context: JOfficeExtension.ClientRequestContext): JWord.SearchOptions;
  end;

  JSearchResultCollection = class external 'SearchResultCollection'(JOfficeExtension.ClientObject)
    m__ReferenceId: Variant;
    m__items: Variant;
    items: JArray{<JWord.Range>};
    function load: JWord.SearchResultCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.SearchResultCollection; overload;
  end;

  JSection = class external 'Section'(JOfficeExtension.ClientObject)
    m_body: Variant;
    m__Id: Variant;
    m__ReferenceId: Variant;
    body: JWord.Body;
    function getFooter(&type: String): JWord.Body;
    function getHeader(&type: String): JWord.Body;
    function load: JWord.Section; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.Section; overload;
  end;

  JSectionCollection = class external 'SectionCollection'(JOfficeExtension.ClientObject)
    m__ReferenceId: Variant;
    m__items: Variant;
    items: JArray{<JWord.Section>};
    function load: JWord.SectionCollection; overload;
    function load(option: Variant {String or array of String or JOfficeExtension.LoadOption}): JWord.SectionCollection; overload;
  end;

//ContentControlType

var
  richText: String;

//ContentControlAppearance

var
  boundingBox: String;
  tags: String;
  hidden: String;

//UnderlineType

var
  none: String;
  single: String;
  word: String;
  double: String;
  dotted: String;
  hidden: String;
  thick: String;
  dashLine: String;
  dotLine: String;
  dotDashLine: String;
  twoDotDashLine: String;
  wave: String;

//BreakType

var
  page: String;
  column: String;
  next: String;
  sectionContinuous: String;
  sectionEven: String;
  sectionOdd: String;
  line: String;
  lineClearLeft: String;
  lineClearRight: String;
  textWrapping: String;

//InsertLocation

var
  before: String;
  after: String;
  start: String;
  end: String;
  replace: String;

//Alignment

var
  unknown: String;
  left: String;
  centered: String;
  right: String;
  justified: String;

//HeaderFooterType

var
  primary: String;
  firstPage: String;
  evenPages: String;

//ErrorCodes

var
  accessDenied: String;
  generalException: String;
  invalidArgument: String;
  itemNotFound: String;
  notImplemented: String;

//Word

type
  JRequestContext = class external 'RequestContext'(JOfficeExtension.ClientRequestContext)
    m_document: Variant;
    constructor Create(url: String);
    document: JDocument;
  end;

function run(batch: (context: JWord.RequestContext): JOfficeExtension.IPromise{<JT>}): JOfficeExtension.IPromise{<JT>};

//Office.MailboxEnums

//Office

type
  JAttachmentDetails = class external
    attachmentType: JOffice.MailboxEnums.AttachmentType;
    contentType: String;
    id: String;
    isInline: Boolean;
    name: String;
    size: Float;
  end;

  JContact = class external
    personName: String;
    businessName: String;
    phoneNumbers: array of JPhoneNumber;
    emailAddresses: array of String;
    urls: array of String;
    addresses: array of String;
    contactString: String;
  end;

  JContext = class external
    mailbox: JMailbox;
    roamingSettings: JRoamingSettings;
  end;

  JCustomProperties = class external
    function get(name: String): Variant;
    procedure set(name: String; value: String);
    procedure remove(name: String);
    procedure saveAsync; overload;
    procedure saveAsync(callback: (result: JAsyncResult)); overload;
    procedure saveAsync(callback: (result: JAsyncResult); userContext: Variant); overload;
  end;

  JEmailAddressDetails = class external
    emailAddress: String;
    displayName: String;
    appointmentResponse: JOffice.MailboxEnums.ResponseType;
    recipientType: JOffice.MailboxEnums.RecipientType;
  end;

  JEmailUser = class external
    name: String;
    userId: String;
  end;

  JEntities = class external
    addresses: array of String;
    taskSuggestions: array of String;
    meetingSuggestions: array of JMeetingSuggestion;
    emailAddresses: array of String;
    urls: array of String;
    phoneNumbers: array of JPhoneNumber;
    contacts: array of JContact;
  end;

  JItem = class external
    dateTimeCreated: JDate;
    dateTimeModified: JDate;
    itemClass: String;
    itemId: String;
    itemType: JOffice.MailboxEnums.ItemType;
    procedure loadCustomPropertiesAsync; overload;
    procedure loadCustomPropertiesAsync(callback: (result: JAsyncResult)); overload;
    procedure loadCustomPropertiesAsync(callback: (result: JAsyncResult); userContext: Variant); overload;
  end;

  JAppointment = class external(JItem)
  end;

  JBody = class external
    procedure getTypeAsync; overload;
    procedure getTypeAsync(options: Variant); overload;
    procedure getTypeAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure prependAsync(data: String); overload;
    procedure prependAsync(data: String; options: Variant); overload;
    procedure prependAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setSelectedDataAsync(data: String); overload;
    procedure setSelectedDataAsync(data: String; options: Variant); overload;
    procedure setSelectedDataAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JLocation = class external
    procedure getAsync; overload;
    procedure getAsync(options: Variant); overload;
    procedure getAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setAsync(location: String); overload;
    procedure setAsync(location: String; options: Variant); overload;
    procedure setAsync(location: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JMailbox = class external
    item: JItem;
    userProfile: JUserProfile;
    function convertToLocalClientTime(timeValue: JDate): Variant;
    function convertToUtcClientTime(input: Variant): JDate;
    procedure displayAppointmentForm(itemId: Variant);
    procedure displayMessageForm(itemId: Variant);
    procedure displayNewAppointmentForm(requiredAttendees: Variant; optionalAttendees: Variant; start: JDate; &end: JDate; location: String; resources: array of String; subject: String; body: String);
    procedure getCallbackTokenAsync; overload;
    procedure getCallbackTokenAsync(callback: (result: JAsyncResult)); overload;
    procedure getCallbackTokenAsync(callback: (result: JAsyncResult); userContext: Variant); overload;
    procedure getUserIdentityTokenAsync; overload;
    procedure getUserIdentityTokenAsync(callback: (result: JAsyncResult)); overload;
    procedure getUserIdentityTokenAsync(callback: (result: JAsyncResult); userContext: Variant); overload;
    procedure makeEwsRequestAsync(data: Variant); overload;
    procedure makeEwsRequestAsync(data: Variant; callback: (result: JAsyncResult)); overload;
    procedure makeEwsRequestAsync(data: Variant; callback: (result: JAsyncResult); userContext: Variant); overload;
  end;

  JMessage = class external(JItem)
    conversationId: String;
  end;

  JMeetingRequest = class external(JMessage)
    start: JDate;
    &end: JDate;
    location: String;
    optionalAttendees: array of JEmailAddressDetails;
    requiredAttendees: array of JEmailAddressDetails;
  end;

  JMeetingSuggestion = class external
    meetingString: String;
    attendees: array of JEmailAddressDetails;
    location: String;
    subject: String;
    start: JDate;
    &end: JDate;
  end;

  JPhoneNumber = class external
    phoneString: String;
    originalPhoneString: String;
    &type: String;
  end;

  JRecipients = class external
    procedure addAsync(recipients: Variant); overload;
    procedure addAsync(recipients: Variant; options: Variant); overload;
    procedure addAsync(recipients: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure getAsync; overload;
    procedure getAsync(options: Variant); overload;
    procedure getAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setAsync(recipients: Variant); overload;
    procedure setAsync(recipients: Variant; options: Variant); overload;
    procedure setAsync(recipients: Variant; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JRoamingSettings = class external
    function get(name: String): Variant;
    procedure remove(name: String);
    procedure saveAsync; overload;
    procedure saveAsync(callback: (result: JAsyncResult)); overload;
    procedure set(name: String; value: Variant);
  end;

  JSubject = class external
    procedure getAsync; overload;
    procedure getAsync(options: Variant); overload;
    procedure getAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setAsync(data: String); overload;
    procedure setAsync(data: String; options: Variant); overload;
    procedure setAsync(data: String; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JTaskSuggestion = class external
    assignees: array of JEmailUser;
    taskString: String;
  end;

  JTime = class external
    procedure getAsync; overload;
    procedure getAsync(options: Variant); overload;
    procedure getAsync(options: Variant; callback: (result: JAsyncResult)); overload;
    procedure setAsync(dateTime: JDate); overload;
    procedure setAsync(dateTime: JDate; options: Variant); overload;
    procedure setAsync(dateTime: JDate; options: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JUserProfile = class external
    displayName: String;
    emailAddress: String;
    timeZone: String;
  end;

//Types

type
  JItemRead = class external(JOffice.Item)
    subject: Variant;
    procedure displayReplyAllForm(htmlBody: String);
    procedure displayReplyForm(htmlBody: String);
    function getEntities: JOffice.Entities;
    function getEntitiesByType(entityType: JOffice.MailboxEnums.EntityType): JOffice.Entities;
    function getFilteredEntitiesByName(name: String): JOffice.Entities;
    function getRegExMatches: array of String;
    function getRegExMatchesByName(name: String): array of String;
  end;

  JItemCompose = class external(JOffice.Item)
    body: JOffice.Body;
    subject: Variant;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeAttachmentAsync(attachmentIndex: String); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JMessageCompose = class external(JOffice.Message)
    attachments: array of JOffice.AttachmentDetails;
    body: JOffice.Body;
    bcc: JOffice.Recipients;
    cc: JOffice.Recipients;
    subject: JOffice.Subject;
    to: JOffice.Recipients;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeAttachmentAsync(attachmentIndex: String); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JMessageRead = class external(JOffice.Message)
    cc: array of JOffice.EmailAddressDetails;
    from: JOffice.EmailAddressDetails;
    internetMessageId: String;
    normalizedSubject: String;
    sender: JOffice.EmailAddressDetails;
    subject: String;
    to: JOffice.EmailAddressDetails;
    procedure displayReplyAllForm(htmlBody: String);
    procedure displayReplyForm(htmlBody: String);
    function getEntities: JOffice.Entities;
    function getEntitiesByType(entityType: JOffice.MailboxEnums.EntityType): JOffice.Entities;
    function getFilteredEntitiesByName(name: String): JOffice.Entities;
    function getRegExMatches: array of String;
    function getRegExMatchesByName(name: String): array of String;
  end;

  JAppointmentCompose = class external(JOffice.Appointment)
    body: JOffice.Body;
    &end: JOffice.Time;
    location: JOffice.Location;
    optionalAttendees: JOffice.Recipients;
    requiredAttendees: JOffice.Recipients;
    start: JOffice.Time;
    subject: JOffice.Subject;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant); overload;
    procedure addFileAttachmentAsync(uri: String; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant); overload;
    procedure addItemAttachmentAsync(itemId: Variant; attachmentName: String; options: Variant; callback: (result: JAsyncResult)); overload;
    procedure removeAttachmentAsync(attachmentIndex: String); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant); overload;
    procedure removeAttachmentAsync(attachmentIndex: String; option: Variant; callback: (result: JAsyncResult)); overload;
  end;

  JAppointmentRead = class external(JOffice.Appointment)
    attachments: array of JOffice.AttachmentDetails;
    &end: JDate;
    location: String;
    normalizedSubject: String;
    optionalAttendees: JOffice.EmailAddressDetails;
    organizer: JOffice.EmailAddressDetails;
    requiredAttendees: JOffice.EmailAddressDetails;
    resources: array of String;
    start: JDate;
    subject: String;
    procedure displayReplyAllForm(htmlBody: String);
    procedure displayReplyForm(htmlBody: String);
    function getEntities: JOffice.Entities;
    function getEntitiesByType(entityType: JOffice.MailboxEnums.EntityType): JOffice.Entities;
    function getFilteredEntitiesByName(name: String): JOffice.Entities;
    function getRegExMatches: array of String;
    function getRegExMatchesByName(name: String): array of String;
  end;

//cast

//item

function toAppointmentCompose(item: JOffice.Item): JOffice.Types.AppointmentCompose;
function toAppointmentRead(item: JOffice.Item): JOffice.Types.AppointmentRead;
function toAppointment(item: JOffice.Item): JOffice.Appointment;
function toMessageCompose(item: JOffice.Item): JOffice.Types.MessageCompose;
function toMessageRead(item: JOffice.Item): JOffice.Types.MessageRead;
function toMessage(item: JOffice.Item): JOffice.Message;
function toItemCompose(item: JOffice.Item): JOffice.Types.ItemCompose;
function toItemRead(item: JOffice.Item): JOffice.Types.ItemRead;

