unit Phonegap;

interface

type
  JGeolocationError = class external
    code: Float;
    message: String;
  end;

  JAcceleration = class external
    x: Float;
    y: Float;
    z: Float;
    timestamp: Float;
  end;

  JAccelerometerOptions = class external
    frequency: Float; // nullable
  end;

  JAccelerometer = class external
    procedure getCurrentAcceleration(accelerometerSuccess: (acceleration: JAcceleration); accelerometerError: );
    procedure watchAcceleration(accelerometerSuccess: (acceleration: JAcceleration); accelerometerError: ); overload;
    procedure watchAcceleration(accelerometerSuccess: (acceleration: JAcceleration); accelerometerError: ; accelerometerOptions: JAccelerometerOptions); overload;
    procedure clearWatch(watchID: Float);
  end;

  JCameraPopoverOptions = class external
    x: Float; // nullable
    y: Float; // nullable
    width: Float; // nullable
    height: Float; // nullable
    arrowDir: Float; // nullable
  end;

  JCameraOptions = class external
    quality: Float; // nullable
    destinationType: Float; // nullable
    sourceType: Float; // nullable
    allowEdit: Boolean; // nullable
    encodingType: Float; // nullable
    targetWidth: Float; // nullable
    targetHeight: Float; // nullable
    mediaType: Float; // nullable
    correctOrientation: Boolean; // nullable
    saveToPhotoAlbum: Boolean; // nullable
    popoverOptions: JCameraPopoverOptions; // nullable
  end;

  JCameraPictureSourceTypeObject = class external
    CAMERA: Float;
    PHOTOLIBRARY: Float;
    SAVEDPHOTOALBUM: Float;
  end;

  JCameraDestinationTypeObject = class external
    FILE_URI: Float;
    DATA_URL: Float;
  end;

  JCameraEncodingTypeObject = class external
    JPEG: Float;
    PNG: Float;
  end;

  JCameraMediaTypeObject = class external
    PICTURE: Float;
    VIDEO: Float;
    ALLMEDIA: Float;
  end;

  JCameraPopoverArrowDirectionObject = class external
    ARROW_UP: Float;
    ARROW_DOWN: Float;
    ARROW_LEFT: Float;
    ARROW_RIGHT: Float;
    ARROW_ANY: Float;
  end;

  JCamera = class external
    sourceType: Variant;
    PictureSourceType: JCameraPictureSourceTypeObject;
    DestinationType: JCameraDestinationTypeObject;
    EncodingType: JCameraEncodingTypeObject;
    MediaType: JCameraMediaTypeObject;
    PopoverArrowDirection: JCameraPopoverArrowDirectionObject;
    procedure getPicture(cameraSuccess: (imageData: String); cameraError: (message: String)); overload;
    procedure getPicture(cameraSuccess: (imageData: String); cameraError: (message: String); cameraOptions: JCameraOptions); overload;
    procedure cleanup(cameraSuccess: (imageData: String); cameraError: (message: String));
  end;

  JCaptureAudioOptions = class external
    limit: Float; // nullable
    duration: Float; // nullable
    mode: Float; // nullable
  end;

  JCaptureImageOptions = class external
    limit: Float; // nullable
    mode: Float; // nullable
  end;

  JMediaFile = class external
    name: String;
    fullPath: String;
    &type: String;
    lastModifiedDate: JDate;
    size: Float;
    procedure getFormatData(successCallback: JFunction); overload;
    procedure getFormatData(successCallback: JFunction; errorCallback: JFunction); overload;
  end;

  JCaptureError = class external
    code: Float;
    message: String;
  end;

  JCapture = class external
    procedure captureAudio(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError)); overload;
    procedure captureAudio(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError); options: JCaptureAudioOptions); overload;
    procedure captureImage(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError)); overload;
    procedure captureImage(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError); options: JCaptureImageOptions); overload;
    procedure captureVideo(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError)); overload;
    procedure captureVideo(captureSuccess: (mediaFiles: array of JMediaFile); captureError: (error: JCaptureError); options: JCaptureImageOptions); overload;
  end;

  JConnection = class external
    UNKNOWN: Float;
    ETHERNET: Float;
    WIFI: Float;
    CELL_2G: Float;
    CELL_3G: Float;
    CELL_4G: Float;
    NONE: Float;
  end;

  JCompassOptions = class external
    frequency: Float; // nullable
    filter: Float; // nullable
  end;

  JCompassHeading = class external
    magneticHeading: Float; // nullable
    trueHeading: Float; // nullable
    headingAccuracy: Float; // nullable
    timestamp: Float; // nullable
  end;

  JCompassError = class external
    code: Float;
  end;

  JCompass = class external
    procedure getCurrentHeading(compassSuccess: (heading: JCompassHeading); compassError: (error: JCompassError)); overload;
    procedure getCurrentHeading(compassSuccess: (heading: JCompassHeading); compassError: (error: JCompassError); compassOptions: JCompassOptions); overload;
    procedure watchHeading(compassSuccess: (heading: JCompassHeading); compassError: (error: JCompassError)); overload;
    procedure watchHeading(compassSuccess: (heading: JCompassHeading); compassError: (error: JCompassError); compassOptions: JCompassOptions); overload;
    procedure clearWatch(watchID: Float);
  end;

  JConnection = class external
    &type: Float;
  end;

  JContactAddress = class external
    pref: Boolean;
    &type: String;
    formatted: String;
    streetAddress: String;
    locality: String;
    region: String;
    postalCode: String;
    country: String;
  end;

  JContactField = class external
    &type: String;
    value: String;
    pref: Boolean;
  end;

  JContact = class external
    id: String;
    displayName: String;
    name: JContactName;
    nickname: String;
    phoneNumbers: array of JContactField;
    emails: array of JContactField;
    addresses: array of JContactAddress;
    ims: array of JContactField;
    organizations: array of JContactOrganization;
    birthday: JDate;
    note: String;
    photos: array of JContactField;
    categories: array of JContactField;
    urls: array of JContactField;
    procedure save; overload;
    procedure save(onSuccess: (contacts: JContacts)); overload;
    procedure save(onSuccess: (contacts: JContacts); onError: (contactError: JContactError)); overload;
    procedure remove; overload;
    procedure remove(onSuccess: (contacts: JContacts)); overload;
    procedure remove(onSuccess: (contacts: JContacts); onError: (contactError: JContactError)); overload;
    function clone: JContact;
  end;

  JContactFindOptions = class external
    filter: String; // nullable
    multiple: Boolean; // nullable
  end;

  JContactName = class external
    formatted: String;
    familyName: String;
    givenName: String;
    middleName: String;
    honorificPrefix: String;
    honorificSuffix: String;
  end;

  JContactOrganization = class external
    pref: Boolean;
    &type: String;
    name: String;
    department: String;
    title: String;
  end;

  JContactError = class external
    code: Float;
  end;

  JContacts = class external
    function create: JContact; overload;
    function create(properties: Variant): JContact; overload;
    procedure find(contactFields: array of String; contactSuccess: (contacts: array of JContact); contactError: (error: JContactError)); overload;
    procedure find(contactFields: array of String; contactSuccess: (contacts: array of JContact); contactError: (error: JContactError); contactFindOptions: JContactFindOptions); overload;
  end;

  JDevice = class external
    available: Boolean;
    name: String;
    cordova: String;
    platform: String;
    uuid: String;
    version: String;
    model: String;
    capture: JCapture;
  end;

  JFileWriter = class external
    readyState: Variant;
    fileName: String;
    _length: Float;
    position: Float;
    error: JFileError;
    onwritestart: JFunction;
    onprogress: JFunction;
    onwrite: JFunction;
    onabort: JFunction;
    onerror: JFunction;
    onwriteend: JFunction;
    procedure abort;
    procedure seek(arg: Float);
    procedure truncate(arg: Float);
    procedure write(arg: Variant);
  end;

  JFileSystem = class external
    name: String;
    root: JDirectoryEntry;
  end;

  JFileSystemEntry = class external
    isFile: Boolean;
    isDirectory: Boolean;
    name: String;
    fullPath: String;
    filesystem: JFileSystem;
    procedure getMetadata; overload;
    procedure getMetadata(onSuccess: (arg: JMetadata)); overload;
    procedure getMetadata(onSuccess: (arg: JMetadata); onError: (arg: JFileError)); overload;
    procedure setMetadata; overload;
    procedure setMetadata(onSuccess: (arg: JMetadata)); overload;
    procedure setMetadata(onSuccess: (arg: JMetadata); onError: (arg: JFileError)); overload;
    procedure setMetadata(onSuccess: (arg: JMetadata); onError: (arg: JFileError); options: Variant); overload;
    function toURL: String;
    procedure remove; overload;
    procedure remove(onSuccess: ); overload;
    procedure remove(onSuccess: ; onError: (arg: JFileError)); overload;
    procedure getParent; overload;
    procedure getParent(onSuccess: (arg: JDirectoryEntry)); overload;
    procedure getParent(onSuccess: (arg: JDirectoryEntry); onError: (arg: JFileError)); overload;
  end;

  JFileEntry = class external(JFileSystemEntry)
    procedure moveTo(parentEntry: JDirectoryEntry; file: String; onSuccess: (arg: JDirectoryEntry); onError: (arg: JFileError));
    procedure copyTo(parentEntry: JDirectoryEntry; file: String; onSuccess: (arg: JDirectoryEntry); onError: (arg: JFileError));
    procedure createWriter; overload;
    procedure createWriter(onSuccess: (arg: JFileWriter)); overload;
    procedure createWriter(onSuccess: (arg: JFileWriter); onError: (arg: JFileError)); overload;
    procedure file; overload;
    procedure file(onSuccess: (arg: JFile)); overload;
    procedure file(onSuccess: (arg: JFile); onError: (arg: JFileError)); overload;
  end;

  JDirectoryEntry = class external(JFileSystemEntry)
    function createReader: JDirectoryReader;
    procedure getDirectory(path: String; options: JFlags; successCallback: (result: JDirectoryEntry); errorCallback: (error: JFileError));
    procedure getFile(path: String; options: JFlags; successCallback: (result: JFileEntry); errorCallback: (error: JFileError));
    procedure removeRecursively(successCallback: ; errorCallback: (error: JFileError));
  end;

  JDirectoryReader = class external
    procedure readEntries(successCallback: (entries: JFileSystemEntry); errorCallback: (error: JFileError));
  end;

  JFileTransfer = class external
    onprogress: JFunction;
    procedure upload(filePath: String; server: String; successCallback: (result: JFileUploadResult); errorCallback: (error: JFileError)); overload;
    procedure upload(filePath: String; server: String; successCallback: (result: JFileUploadResult); errorCallback: (error: JFileError); options: Variant); overload;
    procedure download(source: String; target: String; successCallback: (fileEntry: JFileEntry); errorCallback: (error: JFileError)); overload;
    procedure download(source: String; target: String; successCallback: (fileEntry: JFileEntry); errorCallback: (error: JFileError); options: Variant); overload;
    procedure abort;
  end;

  JFileUploadOptions = class external
    fileKey: String; // nullable
    fileName: String; // nullable
    mimeType: String; // nullable
    params: Variant; // nullable
    chunkedMode: Boolean; // nullable
    headers: Variant; // nullable
  end;

  JFileUploadResult = class external
    bytesSent: Float;
    responseCode: Float;
    response: String;
  end;

  JFlags = class external
    create: Boolean;
    exclusive: Boolean; // nullable
  end;

  JLocalFileSystem = class external
    PERSISTENT: Float;
    TEMPORARY: Float;
  end;

  JMetadata = class external
    modificationTime: JDate;
  end;

  JFileError = class external
    code: Float;
  end;

  JFileTransferError = class external
    code: Float;
    source: String;
    target: String;
    http_status: Float;
  end;

  JGeolocationOptions = class external
    enableHighAccuracy: Boolean; // nullable
    timeout: Float; // nullable
    maximumAge: Float; // nullable
  end;

  JGlobalizationError = class external
    code: Float;
    message: String;
  end;

  JGlobalizationDate = class external
    year: Float;
    month: Float;
    day: Float;
    hour: Float;
    minute: Float;
    second: Float;
    millisecond: Float;
  end;

  JGlobalizationDateOptions = class external
    formatLength: String; // nullable
    selector: String; // nullable
  end;

  JGlobalizationDatePattern = class external
    pattern: String;
    timezone: String;
    utc_offset: Float;
    dst_offset: Float;
  end;

  JGlobalizationDateNameOptions = class external
    &type: String; // nullable
    item: String; // nullable
  end;

  JGlobalizationNumberOptions = class external
    &type: String; // nullable
  end;

  JGlobalizationNumberPattern = class external
    pattern: String;
    symbol: String;
    fraction: Float;
    rounding: Float;
    positive: String;
    negative: String;
    decimal: String;
    grouping: String;
  end;

  JGlobalizationCurrencyPattern = class external
    pattern: String;
    code: String;
    fraction: Float;
    rounding: Float;
    decimal: String;
    grouping: String;
  end;

  JGlobalization = class external
    procedure getPreferredLanguage(successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError));
    procedure getLocaleName(successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError));
    procedure dateToString(date: JDate; successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError)); overload;
    procedure dateToString(date: JDate; successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError); options: JGlobalizationDateOptions); overload;
    procedure stringToDate(dateString: String; successCallback: (properties: JGlobalizationDate); errorCallback: (error: JGlobalizationError)); overload;
    procedure stringToDate(dateString: String; successCallback: (properties: JGlobalizationDate); errorCallback: (error: JGlobalizationError); options: JGlobalizationDateOptions); overload;
    procedure getDatePattern(successCallback: (properties: JGlobalizationDatePattern); errorCallback: (error: JGlobalizationError)); overload;
    procedure getDatePattern(successCallback: (properties: JGlobalizationDatePattern); errorCallback: (error: JGlobalizationError); options: JGlobalizationDateOptions); overload;
    procedure getDateNames(successCallback: (properties:       value: array of String;
    end;); errorCallback: (error: JGlobalizationError)); overload;
    procedure getDateNames(successCallback: (properties:       value: array of String;
    end;); errorCallback: (error: JGlobalizationError); options: JGlobalizationDateNameOptions); overload;
    procedure isDayLightSavingsTime(date: JDate; successCallback: (properties:       dst: Boolean;
    end;); errorCallback: (error: JGlobalizationError));
    procedure getFirstDayOfWeek(successCallback: (properties:       value: Float;
    end;); errorCallback: (error: JGlobalizationError));
    procedure numberToString(number: Float; successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError)); overload;
    procedure numberToString(number: Float; successCallback: (properties:       value: String;
    end;); errorCallback: (error: JGlobalizationError); options: JGlobalizationNumberOptions); overload;
    procedure stringToNumber(&string: String; successCallback: (properties:       value: Float;
    end;); errorCallback: (error: JGlobalizationError)); overload;
    procedure stringToNumber(&string: String; successCallback: (properties:       value: Float;
    end;); errorCallback: (error: JGlobalizationError); options: JGlobalizationNumberOptions); overload;
    procedure getNumberPattern(successCallback: (parameters: JGlobalizationNumberPattern); errorCallback: (error: JGlobalizationError)); overload;
    procedure getNumberPattern(successCallback: (parameters: JGlobalizationNumberPattern); errorCallback: (error: JGlobalizationError); options: JGlobalizationNumberOptions); overload;
    procedure getCurrencyPattern(currencyCode: String; successCallback: (parameters: JGlobalizationCurrencyPattern); errorCallback: (error: JGlobalizationError));
  end;

  JMedia = class external
    constructor CreateJMedia;
    procedure getCurrentPosition(mediaSuccess: JFunction); overload;
    procedure getCurrentPosition(mediaSuccess: JFunction; mediaError: (mediaError: JMediaError): Variant); overload;
    function getDuration: Variant;
    procedure play;
    procedure pause;
    procedure release;
    procedure seekTo(milliseconds: Float);
    procedure startRecord;
    procedure stopRecord;
    procedure stop;
  end;

  JNotification = class external
    procedure alert(message: String; alertCallback: JFunction); overload;
    procedure alert(message: String; alertCallback: JFunction; title: String); overload;
    procedure alert(message: String; alertCallback: JFunction; title: String; buttonName: String); overload;
    procedure confirm(message: String; confirmCallback: JFunction); overload;
    procedure confirm(message: String; confirmCallback: JFunction; title: String); overload;
    procedure confirm(message: String; confirmCallback: JFunction; title: String; buttonLabels: String); overload;
    procedure confirm(message: String; confirmCallback: JFunction); overload;
    procedure confirm(message: String; confirmCallback: JFunction; title: String); overload;
    procedure confirm(message: String; confirmCallback: JFunction; title: String; buttonLabels: array of String); overload;
    procedure beep(times: Float);
    procedure vibrate(milliseconds: Float);
  end;

  JSplashscreen = class external
    procedure show;
    procedure hide;
  end;

  JDatabase = class external
    procedure transaction; overload;
    procedure transaction(populateDB: (tx: JSQLTransaction): Variant); overload;
    procedure transaction(populateDB: (tx: JSQLTransaction): Variant; errorCB: (err: Variant): Variant); overload;
    procedure transaction(populateDB: (tx: JSQLTransaction): Variant; errorCB: (err: Variant): Variant; successCB: : Variant); overload;
    procedure changeVersion(var1: String; var2: String);
  end;

  JSQLResultSetRowList = class external
    _length: Float;
    function item(index: Float): Variant;
  end;

  JSQLError = class external
    code: Float;
    message: String;
  end;

  JSQLResultSet = class external
    insertId: Float;
    rowsAffected: Float;
    rows: JSQLResultSetRowList;
  end;

  JSQLTransaction = class external
    function executeSql(sql: String): JSQLResultSet;
  end;

  JStatusBar = class external
    isVisible: Boolean;
    procedure overlaysWebView(doOverlay: Boolean);
    procedure styleDefault;
    procedure styleLightContent;
    procedure styleBlackTranslucent;
    procedure styleBlackOpaque;
    procedure backgroundColorByName(colorname: String);
    procedure backgroundColorByHexString(hexString: String);
    procedure hide;
    procedure show;
  end;

  JKeyboard = class external
    automaticScrollToTopOnHiding: Boolean;
    isVisible: Boolean;
    onshow: JFunction;
    onhide: JFunction;
    onshowing: JFunction;
    onhiding: JFunction;
    procedure disableScrollingInShrinkView(disable: Boolean);
    procedure hideFormAccessoryBar(hide: Boolean);
    procedure shrinkView(shrink: Boolean);
  end;

  JNavigator = class external
    accelerometer: JAccelerometer;
    camera: JCamera;
    capture: JCapture;
    compass: JCompass;
    connection: JConnection;
    contacts: JContacts;
    device: JDevice;
    globalization: JGlobalization;
    notification: JNotification;
    splashscreen: JSplashscreen;
  end;

  JWindow = class external
    requestFileSystem: Variant;
    function openDatabase(database_name: String; database_version: String; database_displayname: String; database_size: Float): JDatabase;
  end;

Acceleration:   constructor CreateJAcceleration;
end;;
CameraPopoverOptions:   constructor CreateJCameraPopoverOptions;
end;;
Connection: JConnection;
CompassError:   COMPASS_INTERNAL_ERR: Float;
  COMPASS_NOT_SUPPORTED: Float;
end;;
ContactField:   constructor CreateJContactField;
end;;
ContactFindOptions:   constructor CreateJContactFindOptions;
end;;
ContactName:   constructor CreateJContactName;
end;;
ContactError:   UNKNOWN_ERROR: Float;
  INVALID_ARGUMENT_ERROR: Float;
  TIMEOUT_ERROR: Float;
  PENDING_OPERATION_ERROR: Float;
  IO_ERROR: Float;
  NOT_SUPPORTED_ERROR: Float;
  PERMISSION_DENIED_ERROR: Float;
end;;
DirectoryEntry:   constructor CreateJDirectoryEntry;
end;;
FileTransfer:   constructor CreateJFileTransfer;
end;;
FileUploadOptions:   constructor CreateJFileUploadOptions;
end;;
LocalFileSystem: JLocalFileSystem;
FileError:   NOT_FOUND_ERR: Float;
  SECURITY_ERR: Float;
  ABORT_ERR: Float;
  NOT_READABLE_ERR: Float;
  ENCODING_ERR: Float;
  NO_MODIFICATION_ALLOWED_ERR: Float;
  INVALID_STATE_ERR: Float;
  SYNTAX_ERR: Float;
  INVALID_MODIFICATION_ERR: Float;
  QUOTA_EXCEEDED_ERR: Float;
  TYPE_MISMATCH_ERR: Float;
  PATH_EXISTS_ERR: Float;
end;;
FileTransferError:   FILE_NOT_FOUND_ERR: Float;
  INVALID_URL_ERR: Float;
  CONNECTION_ERR: Float;
  ABORT_ERR: Float;
end;;
GlobalizationError:   UNKNOWN_ERROR: Float;
  FORMATTING_ERROR: Float;
  PARSING_ERROR: Float;
  PATTERN_ERROR: Float;
end;;
Media:   constructor CreateJMedia;
end;;
StatusBar: JStatusBar;
Keyboard: JKeyboard;
device: JDevice;
phoneGapNavigator: JNavigator;
