unit Preloadjs;

interface

//createjs

type
  JAbstractLoader = class external 'AbstractLoader'(JEventDispatcher)
    BINARY: String;
    canceled: Boolean;
    CSS: String;
    GET: String;
    IMAGE: String;
    JAVASCRIPT: String;
    JSON: String;
    JSONP: String;
    loaded: Boolean;
    MANIFEST: String;
    POST: String;
    progress: Float;
    resultFormatter: : Variant;
    SOUND: String;
    SPRITESHEET: String;
    SVG: String;
    TEXT: String;
    &type: String;
    VIDEO: String;
    XML: String;
    procedure cancel;
    procedure destroy;
    function getItem: JObject; overload;
    function getItem(value: String): JObject; overload;
    function getLoadedItems: array of JObject;
    function getResult: JObject; overload;
    function getResult(value: Variant): JObject; overload;
    function getResult(value: Variant; rawResult: Boolean): JObject; overload;
    function getTag: JObject;
    procedure load;
    procedure setTag(tag: JObject);
    function toString: String;
  end;

  JAbstractMediaLoader = class external 'AbstractMediaLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean; &type: String);
  end;

  JAbstractRequest = class external 'AbstractRequest'
    constructor Create(item: JLoadItem);
    procedure cancel;
    procedure destroy;
    procedure load;
  end;

  JBinaryLoader = class external 'BinaryLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

  JCSSLoader = class external 'CSSLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JErrorEvent = class external 'ErrorEvent'
    constructor Create(title: String; message: String; data: JObject);
    data: JObject;
    message: String;
    title: String;
  end;

  JImageLoader = class external 'ImageLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JJavaScriptLoader = class external 'JavaScriptLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JJSONLoader = class external 'JSONLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

  JJSONPLoader = class external 'JSONPLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

  JLoadItem = class external 'LoadItem'
    callback: String;
    crossOrigin: Boolean;
    data: JObject;
    headers: JObject;
    id: String;
    loadTimeout: Float;
    maintainOrder: Boolean;
    method: String;
    mimeType: String;
    src: String;
    &type: String;
    values: JObject;
    withCredentials: Boolean;
    function create(value: Variant {JLoadItem or String or JObject}): Variant {JObject or JLoadItem};
    function set(props: JObject): JLoadItem;
  end;

  JLoadQueue = class external 'LoadQueue'(JAbstractLoader)
    constructor Create(preferXHR: Boolean; basePath: String; crossOrigin: Variant {String or Boolean});
    maintainScriptOrder: Boolean;
    next: JLoadQueue;
    stopOnError: Boolean;
    procedure close;
    function getItems(loaded: Boolean): array of JObject;
    procedure installPlugin(plugin: : Variant);
    procedure loadFile(file: Variant {JObject or String}); overload;
    procedure loadFile(file: Variant {JObject or String}; loadNow: Boolean); overload;
    procedure loadFile(file: Variant {JObject or String}; loadNow: Boolean; basePath: String); overload;
    procedure loadManifest(manifest: Variant {JObject or String or array of Variant}); overload;
    procedure loadManifest(manifest: Variant {JObject or String or array of Variant}; loadNow: Boolean); overload;
    procedure loadManifest(manifest: Variant {JObject or String or array of Variant}; loadNow: Boolean; basePath: String); overload;
    procedure registerLoader(loader: JAbstractLoader);
    procedure remove(idsOrUrls: Variant {String or array of Variant});
    procedure removeAll;
    procedure reset;
    procedure setMaxConnections(value: Float);
    procedure setPaused(value: Boolean);
    function setPreferXHR(value: Boolean): Boolean;
    procedure setUseXHR(value: Boolean);
    procedure unregisterLoader(loader: JAbstractLoader);
  end;

  JManifestLoader = class external 'ManifestLoader'
    constructor Create(loadItem: Variant {JLoadItem or JObject});
    function canLoadItem(item: Variant {JLoadItem or JObject}): Boolean;
  end;

  JMediaTagRequest = class external 'MediaTagRequest'
    constructor Create(loadItem: JLoadItem; tag: Variant {JHTMLAudioElement or JHTMLVideoElement}; srcAttribute: String);
  end;

  JPreloadJS = class external 'PreloadJS'
    buildDate: String;
    version: String;
  end;

  JProgressEvent = class external 'ProgressEvent'
    constructor Create(loaded: Float; total: Float);
    loaded: Float;
    progress: Float;
    total: Float;
    function clone: JProgressEvent;
  end;

  JRequestUtils = class external 'RequestUtils'
    ABSOLUTE_PATH: JRegExp;
    EXTENSION_PATT: JRegExp;
    RELATIVE_PATH: JRegExp;
    function buildPath(src: String): String; overload;
    function buildPath(src: String; data: JObject): String; overload;
    function formatQueryString(data: JObject): String; overload;
    function formatQueryString(data: JObject; query: array of JObject): String; overload;
    function getTypeByExtension(extension: String): String;
    function isAudioTag(item: JObject): Boolean;
    function isBinary(&type: String): Boolean;
    function isCrossDomain(item: JObject): Boolean;
    function isImageTag(item: JObject): Boolean;
    function isLocal(item: JObject): Boolean;
    function isText(&type: String): Boolean;
    function isVideoTag(item: JObject): Boolean;
    function parseURI(path: String): JObject;
  end;

  JSoundLoader = class external 'SoundLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JSpriteSheetLoader = class external 'SpriteSheetLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

  JSVGLoader = class external 'SVGLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JTagRequest = class external 'TagRequest'
  end;

  JTextLoader = class external 'TextLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

  JVideoLoader = class external 'VideoLoader'
    constructor Create(loadItem: JObject; preferXHR: Boolean);
    function canLoadItem(item: JObject): Boolean;
  end;

  JXHRRequest = class external 'XHRRequest'(JAbstractLoader)
    constructor Create(item: JObject);
    function getAllResponseHeaders: String;
    function getResponseHeader(header: String): String;
  end;

  JXMLLoader = class external 'XMLLoader'
    constructor Create(loadItem: JObject);
    function canLoadItem(item: JObject): Boolean;
  end;

//DataUtils

function parseJSON(value: String): JObject;
function parseXML(text: String; &type: String): JXMLDocument;

