unit Socket.io;

interface

type
  JSocketIOStatic = class external
: JSocketIO.Server(srv: Variant; opts: JSocketIO.ServerOptions): JSocketIO.Server(port: Variant {String or Float}; opts: JSocketIO.ServerOptions): JSocketIO.Server(opts: JSocketIO.ServerOptions): JSocketIO.Server    listen: JSocketIOStatic;
  end;

//'socket.io'

var
  server: JSocketIOStatic;

//SocketIO

type
  JServer = class external
    nsps:       // property Item[namespace: String]: JNamespace;
    end;;
    sockets: JNamespace;
    json: JServer;
    procedure checkRequest(req: Variant; fn: (err: Variant; success: Boolean));
    function serveClient: Boolean;
    function serveClient(v: Boolean): JServer;
    function path: String;
    function path(v: String): JServer;
    function adapter: Variant;
    function adapter(v: Variant): JServer;
    function origins: String;
    function origins(v: String): JServer;
    function attach(srv: Variant): JServer; overload;
    function attach(srv: Variant; opts: JServerOptions): JServer; overload;
    function attach(port: Float): JServer; overload;
    function attach(port: Float; opts: JServerOptions): JServer; overload;
    function listen(srv: Variant): JServer; overload;
    function listen(srv: Variant; opts: JServerOptions): JServer; overload;
    function listen(port: Float): JServer; overload;
    function listen(port: Float; opts: JServerOptions): JServer; overload;
    function bind(srv: Variant): JServer;
    function onconnection(socket: Variant): JServer;
    function of(nsp: String): JNamespace;
    procedure close;
    function on(event: Jconnection; listener: (socket: JSocket)): JNamespace;
    function on(event: Jconnect; listener: (socket: JSocket)): JNamespace;
    function on(event: String; listener: JFunction): JNamespace;
    function to(room: String): JNamespace;
    function in(room: String): JNamespace;
    function use(fn: (socket: JSocket; fn: (err: Variant))): JNamespace;
    function emit(event: String; args: array of Variant): JNamespace;
    function send(args: array of Variant): JNamespace;
    function write(args: array of Variant): JNamespace;
    function clients(args: array of Variant): JNamespace;
    function compress(args: array of Variant): JNamespace;
  end;

  JServerOptions = class external
    path: String; // nullable
    serveClient: Boolean; // nullable
    adapter: JAdapter; // nullable
    origins: String; // nullable
    pingTimeout: Float; // nullable
    pingInterval: Float; // nullable
    maxHttpBufferSize: Float; // nullable
    allowRequest: (request: Variant; callback: (err: Float; success: Boolean)); // nullable
    transports: array of String; // nullable
    allowUpgrades: Boolean; // nullable
    perMessageDeflate: Variant {JObject or Boolean}; // nullable
    httpCompression: Variant {JObject or Boolean}; // nullable
    cookie: Variant {String or Boolean}; // nullable
  end;

  JNamespace = class external(JNodeJS.EventEmitter)
    name: String;
    server: JServer;
    sockets:       // property Item[id: String]: JSocket;
    end;;
    connected:       // property Item[id: String]: JSocket;
    end;;
    adapter: JAdapter;
    json: JNamespace;
    function use(fn: (socket: JSocket; fn: (err: Variant))): JNamespace;
    function to(room: String): JNamespace;
    function in(room: String): JNamespace;
    function send(args: array of Variant): JNamespace;
    function write(args: array of Variant): JNamespace;
    function on(event: Jconnection; listener: (socket: JSocket)): JNamespace;
    function on(event: Jconnect; listener: (socket: JSocket)): JNamespace;
    function on(event: String; listener: JFunction): JNamespace;
    function clients(fn: JFunction): JNamespace;
    function compress(compress: Boolean): JNamespace;
  end;

  JSocket = class external
    nsp: JNamespace;
    server: JServer;
    adapter: JAdapter;
    id: String;
    request: Variant;
    client: JClient;
    conn:       id: String;
      server: Variant;
      readyState: String;
      remoteAddress: String;
    end;;
    rooms:       // property Item[id: String]: String;
    end;;
    connected: Boolean;
    disconnected: Boolean;
    handshake:       headers: Variant;
      time: String;
      address: String;
      xdomain: Boolean;
      secure: Boolean;
      issued: Float;
      url: String;
      query: Variant;
    end;;
    json: JSocket;
    volatile: JSocket;
    broadcast: JSocket;
    function emit(event: String; args: array of Variant): JSocket;
    function to(room: String): JSocket;
    function in(room: String): JSocket;
    function send(args: array of Variant): JSocket;
    function write(args: array of Variant): JSocket;
    function join(name: String): JSocket; overload;
    function join(name: String; fn: (err: Variant)): JSocket; overload;
    function leave(name: String): JSocket; overload;
    function leave(name: String; fn: JFunction): JSocket; overload;
    procedure leaveAll;
    function disconnect: JSocket; overload;
    function disconnect(close: Boolean): JSocket; overload;
    function on(event: String; fn: JFunction): JSocket;
    function addListener(event: String; fn: JFunction): JSocket;
    function once(event: String; fn: JFunction): JSocket;
    function removeListener(event: String): JSocket; overload;
    function removeListener(event: String; fn: JFunction): JSocket; overload;
    function removeAllListeners: JSocket; overload;
    function removeAllListeners(event: String): JSocket; overload;
    function setMaxListeners(n: Float): JSocket;
    function listeners(event: String): array of JFunction;
    function compress(compress: Boolean): JSocket;
  end;

  JAdapter = class external(JNodeJS.EventEmitter)
    nsp: JNamespace;
    rooms:       // property Item[room: String]:         sockets:           // property Item[id: String]: Boolean;
        end;;
      end;;
    end;;
    sids:       // property Item[id: String]:         // property Item[room: String]: Boolean;
      end;;
    end;;
    procedure add(id: String; room: String); overload;
    procedure add(id: String; room: String; callback: (err: Variant)); overload;
    procedure del(id: String; room: String); overload;
    procedure del(id: String; room: String; callback: (err: Variant)); overload;
    procedure delAll(id: String);
    procedure broadcast(packet: Variant; opts:       rooms: array of String; // nullable
      except: array of String; // nullable
      flags:         // property Item[flag: String]: Boolean;
      end;; // nullable
    end;);
  end;

  JClient = class external
    server: JServer;
    conn:       id: String;
      server: Variant;
      readyState: String;
      remoteAddress: String;
    end;;
    id: String;
    request: Variant;
    sockets:       // property Item[id: String]: JSocket;
    end;;
    nsps:       // property Item[nsp: String]: JSocket;
    end;;
  end;

