unit Soundjs;

interface

//createjs

type
  JAbstractPlugin = class external 'AbstractPlugin'
    function create(src: String; startTime: Float; duration: Float): JAbstractSoundInstance;
    function getVolume: Float;
    function isPreloadComplete(src: String): Boolean;
    function isPreloadStarted(src: String): Boolean;
    function isSupported: Boolean;
    procedure preload(loader: JObject);
    function register(loadItem: String; instances: Float): JObject;
    procedure removeAllSounds(src: String);
    procedure removeSound(src: String);
    function setMute(value: Boolean): Boolean;
    function setVolume(value: Float): Boolean;
  end;

  JAbstractSoundInstance = class external 'AbstractSoundInstance'(JEventDispatcher)
    constructor Create(src: String; startTime: Float; duration: Float; playbackResource: JObject);
    duration: Float;
    loop: Float;
    muted: Boolean;
    pan: Float;
    paused: Boolean;
    playbackResource: JObject;
    playState: String;
    position: Float;
    src: String;
    uniqueId: Variant {Float or String};
    volume: Float;
    procedure destroy;
    function getDuration: Float;
    function getLoop: Float;
    function getMute: Boolean;
    function getPan: Float;
    function getPaused: Boolean;
    function getPosition: Float;
    function getVolume: Float;
    function play: JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}): JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}; delay: Float): JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}; delay: Float; offset: Float): JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}; delay: Float; offset: Float; loop: Float): JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}; delay: Float; offset: Float; loop: Float; volume: Float): JAbstractSoundInstance; overload;
    function play(interrupt: Variant {String or JObject}; delay: Float; offset: Float; loop: Float; volume: Float; pan: Float): JAbstractSoundInstance; overload;
    function setDuration(value: Float): JAbstractSoundInstance;
    procedure setLoop(value: Float);
    function setMute(value: Boolean): JAbstractSoundInstance;
    function setPan(value: Float): JAbstractSoundInstance;
    function setPlayback(value: JObject): JAbstractSoundInstance;
    function setPosition(value: Float): JAbstractSoundInstance;
    function setVolume(value: Float): JAbstractSoundInstance;
    function stop: JAbstractSoundInstance;
  end;

  JFlashAudioLoader = class external 'FlashAudioLoader'(JAbstractLoader)
    flashId: String;
    procedure setFlash(flash: JObject);
  end;

  JFlashAudioPlugin = class external 'FlashAudioPlugin'(JAbstractPlugin)
    flashReady: Boolean;
    showOutput: Boolean;
    swfPath: String;
    function isSupported: Boolean;
  end;

  JFlashAudioSoundInstance = class external 'FlashAudioSoundInstance'(JAbstractSoundInstance)
    constructor Create(src: String; startTime: Float; duration: Float; playbackResource: JObject);
  end;

  JFlashPlugin = class external 'FlashPlugin'
    constructor Create;
    buildDate: String;
    flashReady: Boolean;
    showOutput: Boolean;
    swfPath: String;
    version: String;
    function create(src: String): JAbstractSoundInstance;
    function getVolume: Float;
    function isPreloadStarted(src: String): Boolean;
    function isSupported: Boolean;
    procedure preload(src: String; instance: JObject);
    function register(src: String; instances: Float): JObject;
    procedure removeAllSounds;
    procedure removeSound(src: String);
    function setMute(value: Boolean): Boolean;
    function setVolume(value: Float): Boolean;
  end;

  JHTMLAudioPlugin = class external 'HTMLAudioPlugin'(JAbstractPlugin)
    constructor Create;
    defaultNumChannels: Float;
    enableIOS: Boolean;
    MAX_INSTANCES: Float;
    function isSupported: Boolean;
  end;

  JHTMLAudioSoundInstance = class external 'HTMLAudioSoundInstance'(JAbstractSoundInstance)
    constructor Create(src: String; startTime: Float; duration: Float; playbackResource: JObject);
  end;

  JHTMLAudioTagPool = class external 'HTMLAudioTagPool'
  end;

  JPlayPropsConfig = class external 'PlayPropsConfig'
    delay: Float;
    duration: Float;
    interrupt: String;
    loop: Float;
    offset: Float;
    pan: Float;
    startTime: Float;
    volume: Float;
    function create(value: Variant {JPlayPropsConfig or Variant}): JPlayPropsConfig;
    function set(props: Variant): JPlayPropsConfig;
  end;

  JSound = class external 'Sound'(JEventDispatcher)
    activePlugin: JObject;
    alternateExtensions: array of Variant;
    defaultInterruptBehavior: String;
    EXTENSION_MAP: JObject;
    INTERRUPT_ANY: String;
    INTERRUPT_EARLY: String;
    INTERRUPT_LATE: String;
    INTERRUPT_NONE: String;
    PLAY_FAILED: String;
    PLAY_FINISHED: String;
    PLAY_INITED: String;
    PLAY_INTERRUPTED: String;
    PLAY_SUCCEEDED: String;
    SUPPORTED_EXTENSIONS: array of String;
    muted: Boolean;
    volume: Float;
    capabilities: Variant;
    function createInstance(src: String): JAbstractSoundInstance;
    function getCapabilities: JObject;
    function getCapability(key: String): Variant {Float or Boolean};
    function getMute: Boolean;
    function getVolume: Float;
    function initializeDefaultPlugins: Boolean;
    function isReady: Boolean;
    function loadComplete(src: String): Boolean;
    function play(src: String): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant; delay: Float): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant; delay: Float; offset: Float): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant; delay: Float; offset: Float; loop: Float): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant; delay: Float; offset: Float; loop: Float; volume: Float): JAbstractSoundInstance; overload;
    function play(src: String; interrupt: Variant; delay: Float; offset: Float; loop: Float; volume: Float; pan: Float): JAbstractSoundInstance; overload;
    function registerManifest(manifest: array of JObject; basePath: String): JObject;
    function registerPlugins(plugins: array of Variant): Boolean;
    function registerSound(src: Variant {String or JObject}): JObject; overload;
    function registerSound(src: Variant {String or JObject}; id: String): JObject; overload;
    function registerSound(src: Variant {String or JObject}; id: String; data: Variant {Float or JObject}): JObject; overload;
    function registerSound(src: Variant {String or JObject}; id: String; data: Variant {Float or JObject}; basePath: String): JObject; overload;
    function registerSounds(sounds: array of JObject): array of JObject; overload;
    function registerSounds(sounds: array of JObject; basePath: String): array of JObject; overload;
    procedure removeAllSounds;
    function removeManifest(manifest: array of Variant; basePath: String): JObject;
    function removeSound(src: Variant {String or JObject}; basePath: String): Boolean;
    function setMute(value: Boolean): Boolean;
    procedure setVolume(value: Float);
    procedure stop;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function addEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean): JFunction; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function addEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean): JObject; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}): Boolean; overload;
    function dispatchEvent(eventObj: Variant {JObject or String or JEvent}; target: JObject): Boolean; overload;
    function hasEventListener(&type: String): Boolean;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure off(&type: String; listener: (eventObj: JObject)); overload;
    procedure off(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure off(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure off(&type: String; listener: JFunction); overload;
    procedure off(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject): Boolean; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject)): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant): JFunction; overload;
    function on(&type: String; listener: (eventObj: JObject); scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JFunction; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant): JObject; overload;
    function on(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; scope: JObject; once: Boolean; data: Variant; useCapture: Boolean): JObject; overload;
    procedure removeAllEventListeners; overload;
    procedure removeAllEventListeners(&type: String); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject): Boolean; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject)); overload;
    procedure removeEventListener(&type: String; listener: (eventObj: JObject); useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject): Boolean;
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;); overload;
    procedure removeEventListener(&type: String; listener:       handleEvent: (eventObj: JObject);
    end;; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function toString: String;
    function willTrigger(&type: String): Boolean;
  end;

  JSoundJS = class external 'SoundJS'
    buildDate: String;
    version: String;
  end;

  JWebAudioLoader = class external 'WebAudioLoader'
    context: JAudioContext;
  end;

  JWebAudioPlugin = class external 'WebAudioPlugin'(JAbstractPlugin)
    constructor Create;
    context: JAudioContext;
    context: JAudioContext;
    dynamicsCompressorNode: JDynamicsCompressorNode;
    gainNode: JGainNode;
    function isSupported: Boolean;
    procedure playEmptySound;
  end;

  JWebAudioSoundInstance = class external 'WebAudioSoundInstance'(JAbstractSoundInstance)
    constructor Create(src: String; startTime: Float; duration: Float; playbackResource: JObject);
    context: JAudioContext;
    destinationNode: JAudioNode;
    gainNode: JGainNode;
    panNode: JPannerNode;
    sourceNode: JAudioNode;
  end;

