unit Tweenjs;

interface

//createjs

type
  JCSSPlugin = class external 'CSSPlugin'
    constructor Create;
    cssSuffixMap: JObject;
    procedure install;
  end;

  JEase = class external 'Ease'
    backIn: (amount: Float): Float;
    backInOut: (amount: Float): Float;
    backOut: (amount: Float): Float;
    bounceIn: (amount: Float): Float;
    bounceInOut: (amount: Float): Float;
    bounceOut: (amount: Float): Float;
    circIn: (amount: Float): Float;
    circInOut: (amount: Float): Float;
    circOut: (amount: Float): Float;
    cubicIn: (amount: Float): Float;
    cubicInOut: (amount: Float): Float;
    cubicOut: (amount: Float): Float;
    elasticIn: (amount: Float): Float;
    elasticInOut: (amount: Float): Float;
    elasticOut: (amount: Float): Float;
    function get(amount: Float): (amount: Float): Float;
    function getBackIn(amount: Float): (amount: Float): Float;
    function getBackInOut(amount: Float): (amount: Float): Float;
    function getBackOut(amount: Float): (amount: Float): Float;
    function getElasticIn(amplitude: Float; period: Float): (amount: Float): Float;
    function getElasticInOut(amplitude: Float; period: Float): (amount: Float): Float;
    function getElasticOut(amplitude: Float; period: Float): (amount: Float): Float;
    function getPowIn(pow: Float): (amount: Float): Float;
    function getPowInOut(pow: Float): (amount: Float): Float;
    function getPowOut(pow: Float): (amount: Float): Float;
    linear: (amount: Float): Float;
    none: (amount: Float): Float;
    quadIn: (amount: Float): Float;
    quadInOut: (amount: Float): Float;
    quadOut: (amount: Float): Float;
    quartIn: (amount: Float): Float;
    quartInOut: (amount: Float): Float;
    quartOut: (amount: Float): Float;
    quintIn: (amount: Float): Float;
    quintInOut: (amount: Float): Float;
    quintOut: (amount: Float): Float;
    sineIn: (amount: Float): Float;
    sineInOut: (amount: Float): Float;
    sineOut: (amount: Float): Float;
  end;

  JMotionGuidePlugin = class external 'MotionGuidePlugin'
    constructor Create;
    function install: JObject;
  end;

  JTimeline = class external 'Timeline'(JEventDispatcher)
    constructor Create(tweens: array of JTween; labels: JObject; props: JObject);
    duration: Float;
    ignoreGlobalPause: Boolean;
    loop: Boolean;
    position: JObject;
    procedure addLabel(&label: String; position: Float);
    procedure addTween(tween: array of JTween);
    function getCurrentLabel: String;
    function getLabels: array of JObject;
    procedure gotoAndPlay(positionOrLabel: Variant {String or Float});
    procedure gotoAndStop(positionOrLabel: Variant {String or Float});
    procedure removeTween(tween: array of JTween);
    function resolve(positionOrLabel: Variant {String or Float}): Float;
    procedure setLabels(o: JObject);
    procedure setPaused(value: Boolean);
    function setPosition(value: Float): Boolean; overload;
    function setPosition(value: Float; actionsMode: Float): Boolean; overload;
    procedure tick(delta: Float);
    procedure updateDuration;
  end;

  JTween = class external 'Tween'(JEventDispatcher)
    constructor Create(target: JObject; props: JObject; pluginData: JObject);
    duration: Float;
    IGNORE: JObject;
    ignoreGlobalPause: Boolean;
    LOOP: Float;
    loop: Boolean;
    NONE: Float;
    onChange: JFunction;
    passive: Boolean;
    pluginData: JObject;
    position: Float;
    REVERSE: Float;
    target: JObject;
    function call(callback: (tweenObject: JTween): Variant): JTween; overload;
    function call(callback: (tweenObject: JTween): Variant; params: array of Variant): JTween; overload;
    function call(callback: (tweenObject: JTween): Variant; params: array of Variant; scope: JObject): JTween; overload;
    function call(callback: (params: array of Variant): Variant): JTween; overload;
    function call(callback: (params: array of Variant): Variant; params: array of Variant): JTween; overload;
    function call(callback: (params: array of Variant): Variant; params: array of Variant; scope: JObject): JTween; overload;
    function get(target: JObject): JTween; overload;
    function get(target: JObject; props: JObject): JTween; overload;
    function get(target: JObject; props: JObject; pluginData: JObject): JTween; overload;
    function get(target: JObject; props: JObject; pluginData: JObject; override: Boolean): JTween; overload;
    function hasActiveTweens: Boolean; overload;
    function hasActiveTweens(target: JObject): Boolean; overload;
    procedure installPlugin(plugin: JObject; properties: array of Variant);
    function pause(tween: JTween): JTween;
    function play(tween: JTween): JTween;
    procedure removeAllTweens;
    procedure removeTweens(target: JObject);
    function set(props: JObject): JTween; overload;
    function set(props: JObject; target: JObject): JTween; overload;
    function setPaused(value: Boolean): JTween;
    function setPosition(value: Float; actionsMode: Float): Boolean;
    procedure tick(delta: Float; paused: Boolean);
    procedure tick(delta: Float);
    function to(props: JObject): JTween; overload;
    function to(props: JObject; duration: Float): JTween; overload;
    function to(props: JObject; duration: Float; ease: (t: Float): Float): JTween; overload;
    function wait(duration: Float): JTween; overload;
    function wait(duration: Float; passive: Boolean): JTween; overload;
  end;

  JTweenJS = class external 'TweenJS'
    buildDate: String;
    version: String;
  end;

