unit Ui_grid;

interface

//uiGrid

type
  JIUiGridConstants = class external
    LOG_DEBUG_MESSAGES: Boolean;
    LOG_WARN_MESSAGES: Boolean;
    LOG_ERROR_MESSAGES: Boolean;
    CUSTOM_FILTERS: JRegExp;
    COL_FIELD: JRegExp;
    MODEL_COL_FIELD: JRegExp;
    TOOLTIP: JRegExp;
    DISPLAY_CELL_TEMPLATE: JRegExp;
    TEMPLATE_REGEXP: JRegExp;
    FUNC_REGEXP: JRegExp;
    DOT_REGEXP: JRegExp;
    APOS_REGEXP: JRegExp;
    BRACKET_REGEXP: JRegExp;
    COL_CLASS_PREFIX: String;
    events:       GRID_SCROLL: String;
      COLUMN_MENU_SHOWN: String;
      ITEM_DRAGGING: String;
      COLUMN_HEADER_CLICK: String;
    end;;
    keymap:       TAB: Float;
      STRG: Float;
      CAPSLOCK: Float;
      CTRL: Float;
      CTRLRIGHT: Float;
      CTRLR: Float;
      SHIFT: Float;
      RETURN: Float;
      ENTER: Float;
      BACKSPACE: Float;
      BCKSP: Float;
      ALT: Float;
      ALTR: Float;
      ALTRIGHT: Float;
      SPACE: Float;
      WIN: Float;
      MAC: Float;
      FN: Float;
      PG_UP: Float;
      PG_DOWN: Float;
      UP: Float;
      DOWN: Float;
      LEFT: Float;
      RIGHT: Float;
      ESC: Float;
      DEL: Float;
      F1: Float;
      F2: Float;
      F3: Float;
      F4: Float;
      F5: Float;
      F6: Float;
      F7: Float;
      F8: Float;
      F9: Float;
      F10: Float;
      F11: Float;
      F12: Float;
    end;;
    ASC: String;
    DESC: String;
    filter:       STARTS_WITH: Float;
      ENDS_WITH: Float;
      EXACT: Float;
      CONTAINS: Float;
      GREATER_THAN: Float;
      GREATER_THAN_OR_EQUAL: Float;
      LESS_THAN: Float;
      LESS_THAN_OR_EQUAL: Float;
      NOT_EQUAL: Float;
      SELECT: String;
      INPUT: String;
    end;;
    scrollDirection:       UP: String;
      DOWN: String;
      LEFT: String;
      RIGHT: String;
      NONE: String;
    end;;
    aggregationTypes:       sum: Float;
      count: Float;
      avg: Float;
      min: Float;
      max: Float;
    end;;
    CURRENCY_SYMBOLS: JArray{<String>};
    dataChange:       ALL: String;
      EDIT: String;
      ROW: String;
      COLUMN: String;
      OPTIONS: String;
    end;;
    scrollbars:       NEVER: Float;
      ALWAYS: Float;
    end;;
  end;

  JIGridInstanceOf{<TEntity>} = class external
    procedure addRowHeaderColumn(colDef: JIColumnDefOf{<JTEntity>});
    procedure assignTypes;
    procedure buildColumnDefsFromData(rowBuilder: JIRowBuilder{<JTEntity>});
    function buildColumns(options: JIBuildColumnsOptions): Jng.IPromise{<Variant>};
    procedure buildStyles;
    procedure callDataChangeCallbacks(&type: Float);
    function clearAllFilters(refreshRows: Boolean; clearConditions: Boolean; clearFlags: Boolean): Jng.IPromise{<Variant>};
    procedure columnRefreshCallback(name: String);
    procedure createLeftContainer;
    procedure createRightContainer;
    procedure flagScrollingHorizontally;
    procedure flagScrollingVertically;
    function getCellDisplayValue(row: JIGridRowOf{<JTEntity>}; col: JIGridColumnOf{<JTEntity>}): String;
    function getCellValue(row: JIGridRowOf{<JTEntity>}; col: JIGridColumnOf{<JTEntity>}): Variant;
    function getColDef(name: String): JIColumnDefOf{<JTEntity>};
    function getColumn(name: String): JIGridColumnOf{<JTEntity>};
    function getColumnSorting: JArray{<JIGridColumnOf{<JTEntity>}>};
    function getGridQualifiedColField(col: JIGridColumnOf{<JTEntity>}): String;
    function getOnlyDataColumns: JArray{<JIGridColumnOf{<JTEntity>}>};
    function getRow(rowEntity: JTEntity): JIGridRowOf{<JTEntity>}; overload;
    function getRow(rowEntity: JTEntity; rows: JArray{<JIGridRowOf{<JTEntity>}>}): JIGridRowOf{<JTEntity>}; overload;
    procedure handleWindowResize($event: Jng.IAngularEvent);
    function hasLeftContainer: Boolean;
    function hasRightContainer: Boolean;
    function hasLeftContainerColumns: Boolean;
    function hasRightContainerColumns: Boolean;
    function isRTL: Boolean;
    function isRowHeaderColumn(column: JIGridColumnOf{<JTEntity>}): Boolean;
    function modifyRows(newRawData: JArray{<JTEntity>}): Jng.IPromise{<Variant>};
    procedure notifyDataChange(&type: String);
    procedure precompileCellTemplates;
    function processRowBuilders(gridRow: JIGridRowOf{<JTEntity>}): JIGridRowOf{<JTEntity>};
    procedure processRowsCallback(name: String);
    procedure queueGridRefresh;
    procedure queueRefresh;
    procedure redrawCanvas; overload;
    procedure redrawCanvas(rowsAdded: Boolean); overload;
    procedure refresh; overload;
    procedure refresh(rowsAltered: Boolean); overload;
    function refreshCanvas: Jng.IPromise{<Variant>}; overload;
    function refreshCanvas(buildStyles: Boolean): Jng.IPromise{<Variant>}; overload;
    function refreshRows: Jng.IPromise{<Variant>};
    procedure registerColumnBuilder(columnBuilder: JIColumnBuilder{<JTEntity>});
    procedure registerColumnsProcessor(columnProcessor: JIColumnProcessor{<JTEntity>}; priority: Float);
    function registerDataChangeCallback(callback: (grid: JIGridInstanceOf{<JTEntity>}); types: JArray{<String>}): JFunction;
    procedure registerRowBuilder(rowBuilder: JIRowBuilder{<JTEntity>});
    procedure registerRowsProcessor(rowProcessor: JIRowProcessor{<JTEntity>}; priority: Float);
    procedure registerStyleComputation(styleComputation: ($scope: Jng.IScope): String);
    procedure removeRowsProcessor(rows: JIRowProcessor{<JTEntity>});
    procedure resetColumnSorting(excludedColumn: JIGridColumnOf{<JTEntity>});
    function scrollTo: Jng.IPromise{<Variant>}; overload;
    function scrollTo(rowEntity: JTEntity): Jng.IPromise{<Variant>}; overload;
    function scrollTo(rowEntity: JTEntity; colDef: JIColumnDefOf{<JTEntity>}): Jng.IPromise{<Variant>}; overload;
    function scrollToIfNecessary(gridRow: JIGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>}): Jng.IPromise{<Variant>};
    function sortColumn(column: JIGridColumnOf{<JTEntity>}): Jng.IPromise{<JIGridColumnOf{<JTEntity>}>}; overload;
    function sortColumn(column: JIGridColumnOf{<JTEntity>}; direction: String): Jng.IPromise{<JIGridColumnOf{<JTEntity>}>}; overload;
    function sortColumn(column: JIGridColumnOf{<JTEntity>}; direction: String; add: Boolean): Jng.IPromise{<JIGridColumnOf{<JTEntity>}>}; overload;
    procedure updateCanvasHeight;
    procedure updateFooterHeightCallback(name: String);
    appScope: Jng.IScope; // nullable
    columns: JArray{<JIGridColumn>};
    columnFooterHeight: Float; // nullable
    footerHeight: Float; // nullable
    gridHeight: Float; // nullable
    isScrollingHorizontally: Boolean; // nullable
    isScrollingVertically: Boolean; // nullable
    scrollDirection: Float; // nullable
  end;

  JIBuildColumnsOptions = class external
    orderByColumnDefs: Boolean; // nullable
  end;

  JIStyleComputation = class external
($scope: Jng.IScope): String  end;

  JIColumnBuilder{<TEntity>} = class external
(colDef: JIColumnDefOf{<JTEntity>}; col: JIGridColumnOf{<JTEntity>}; gridOptions: JIGridOptionsOf{<JTEntity>})  end;

  JIRowBuilder{<TEntity>} = class external
(row: JIGridRowOf{<JTEntity>}; gridOptions: JIGridOptionsOf{<JTEntity>})  end;

  JIRowProcessor{<TEntity>} = class external
(renderedRowsToProcess: JArray{<JIGridRowOf{<JTEntity>}>}; columns: JArray{<JIGridColumnOf{<JTEntity>}>}): JArray{<JIGridRowOf{<JTEntity>}>}  end;

  JIColumnProcessor{<TEntity>} = class external
(renderedColumnsToProcess: JArray{<JIGridColumnOf{<JTEntity>}>}; rows: JArray{<JIGridRowOf{<JTEntity>}>}): JArray{<JIGridColumnOf{<JTEntity>}>}  end;

  JIGridOptionsOf{<TEntity>} = class external(JcellNav.IGridOptions, Jedit.IGridOptions, Jexpandable.IGridOptions, Jexporter.IGridOptions {JTEntity} , Jgrouping.IGridOptions, Jimporter.IGridOptions {JTEntity} , JinfiniteScroll.IGridOptions, JmoveColumns.IGridOptions, Jpagination.IGridOptions, Jpinning.IGridOptions, JresizeColumns.IGridOptions, JrowEdit.IGridOptions, JsaveState.IGridOptions, Jselection.IGridOptions, JtreeBase.IGridOptions {JTEntity} , JtreeView.IGridOptions)
    aggregationCalcThrottle: Float; // nullable
    appScopeProvider: Variant {Jng.IScope or JObject}; // nullable
    columnDefs: JArray{<JIColumnDefOf{<JTEntity>}>}; // nullable
    columnFooterHeight: Float; // nullable
    columnVirtualizationThreshold: Float; // nullable
    data: Variant {JArray{<JTEntity>} or String}; // nullable
    enableColumnMenus: Boolean; // nullable
    enableFiltering: Boolean; // nullable
    enableGridMenu: Boolean; // nullable
    enableHorizontalScrollbar: Variant {Boolean or Float}; // nullable
    enableMinHeightCheck: Boolean; // nullable
    enableRowHashing: Boolean; // nullable
    enableSorting: Boolean; // nullable
    enableVerticalScrollbar: Variant {Boolean or Float}; // nullable
    excessColumns: Float; // nullable
    excessRows: Float; // nullable
    excludeProperties: JArray{<String>}; // nullable
    flatEntityAccess: Boolean; // nullable
    footerTemplate: String; // nullable
    gridFooterTemplate: String; // nullable
    headerTemplate: String; // nullable
    horizontalScrollThreshold: Float; // nullable
    infiniteScrollRowsFromEnd: Float; // nullable
    infiniteScrollUp: Boolean; // nullable
    infiniteScrollDown: Boolean; // nullable
    maxVisibleColumnCount: Float; // nullable
    minRowsToShow: Float; // nullable
    minimumColumnSize: Float; // nullable
    onRegisterApi: (gridApi: JIGridApiOf{<JTEntity>}); // nullable
    rowHeight: Float; // nullable
    rowTemplate: String; // nullable
    scrollDebounce: Float; // nullable
    scrollThreshold: Float; // nullable
    showColumnFooter: Boolean; // nullable
    showGridFooter: Boolean; // nullable
    showHeader: Boolean; // nullable
    virtualizationThreshold: Float; // nullable
    useExternalFiltering: Boolean; // nullable
    wheelScrollThrottle: Float; // nullable
    function getRowIdentity(row: JIGridRowOf{<JTEntity>}): Variant;
    function rowEquality(entityA: JTEntity; entityB: JTEntity): Boolean;
    function rowIdentity: Variant;
  end;

  JIGridCoreApi{<TEntity>} = class external
    procedure addRowHeaderColumn(column: JIColumnDefOf{<JTEntity>});
    procedure addToGridMenu(grid: JIGridInstanceOf{<JTEntity>}; items: JArray{<JIMenuItem>});
    function clearAllFilters: Jng.IPromise{<JArray{<JIGridRowOf{<JTEntity>}>}>}; overload;
    function clearAllFilters(refreshRows: Boolean): Jng.IPromise{<JArray{<JIGridRowOf{<JTEntity>}>}>}; overload;
    function clearAllFilters(refreshRows: Boolean; clearConditions: Boolean): Jng.IPromise{<JArray{<JIGridRowOf{<JTEntity>}>}>}; overload;
    function clearAllFilters(refreshRows: Boolean; clearConditions: Boolean; clearFlags: Boolean): Jng.IPromise{<JArray{<JIGridRowOf{<JTEntity>}>}>}; overload;
    procedure clearRowInvisible(rowEntity: JTEntity);
    function getVisibleRows(grid: JIGridInstanceOf{<JTEntity>}): JArray{<JIGridRowOf{<JTEntity>}>};
    procedure handleWindowResize;
    procedure notifyDataChange(&type: String);
    function refreshRows: Jng.IPromise{<Boolean>};
    procedure registerColumnsProcessor(processorFunction: JIColumnProcessor{<JTEntity>}; priority: Float);
    procedure registerRowsProcessor(rowProcessor: JIRowProcessor{<JTEntity>}; priority: Float);
    procedure scrollTo(entity: JTEntity; colDef: JIColumnDefOf{<JTEntity>});
    procedure scrollToIfNecessary(gridRow: JIGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>});
    function sortHandleNulls(a: Variant; b: Variant): Float;
    procedure queueGridRefresh;
    procedure queueRefresh;
    on:       canvasHeightChanged: (scope: Jng.IScope; handler: JcanvasHeightChangedHandler);
      columnVisibilityChanged: (scope: Jng.IScope; callBack: JcolumnVisibilityChangedHandler{<JTEntity>});
      filterChanged: (scope: Jng.IScope; handler: JfilterChangedHandler{<JTEntity>});
      rowsRendered: (scope: Jng.IScope; handler: JrowsRenderedHandler{<JTEntity>});
      rowsVisibleChanged: (scope: Jng.IScope; handler: JrowsVisibleChangedHandler{<JTEntity>});
      scrollBegin: (scope: Jng.IScope; handler: JscrollBeginHandler);
      scrollEnd: (scope: Jng.IScope; handler: JscrollEndHandler);
      sortChanged: (scope: Jng.IScope; handler: JsortChangedHandler{<JTEntity>});
    end;;
  end;

  JcolumnVisibilityChangedHandler{<TEntity>} = class external
(column: JIGridColumnOf{<JTEntity>})  end;

  JcanvasHeightChangedHandler = class external
(oldHeight: Float; newHeight: Float)  end;

  JfilterChangedHandler{<TEntity>} = class external
(gridApi: JIGridApiOf{<JTEntity>})  end;

  JrowsRenderedHandler{<TEntity>} = class external
(gridApi: JIGridApiOf{<JTEntity>})  end;

  JrowsVisibleChangedHandler{<TEntity>} = class external
(gridApi: JIGridApiOf{<JTEntity>})  end;

  JscrollBeginHandler = class external
(scrollEvent: JJQueryMouseEventObject)  end;

  JscrollEndHandler = class external
(scrollEvent: JJQueryMouseEventObject)  end;

  JsortChangedHandler{<TEntity>} = class external
(grid: JIGridInstanceOf{<JTEntity>}; columns: JArray{<JIGridColumnOf{<JTEntity>}>})  end;

  JISharedTreeConstants = class external
    rowHeaderColName: String;
    EXPANDED: String;
    COLLAPSED: String;
    aggregation:       COUNT: String;
      SUM: String;
      MAX: String;
      MIN: String;
      AVG: String;
    end;;
  end;

  JIGridApiConstructor{<TEntity>} = class external
    constructor CreateJIGridApiOf{<JTEntity>};
  end;

  JIGridApiOf{<TEntity>} = class external
    procedure registerEvent(featureName: String; eventName: String);
    procedure registerEventsFromObject(eventObjectMap: Variant);
    procedure registerMethod(featureName: String; methodName: String; callBackFn: JFunction; _this: Variant);
    procedure registerMethodsFromObject(eventObjectMap: Variant; _this: Variant);
    procedure suppressEvents(listenerFuncs: Variant {JFunction or JArray{<JFunction>}}; callBackFn: JFunction);
    core: JIGridCoreApi{<JTEntity>};
    cellNav: JcellNav.ICellNavApi{<JTEntity>};
    colMovable: JmoveColumns.IGridMoveColumnsApi;
    colResizable: JresizeColumns.IGridResizeColumnsApi;
    edit: Jedit.IGridEditApi{<JTEntity>};
    expandable: Jexpandable.IGridExpandableApi{<JTEntity>};
    exporter: Jexporter.IGridExporterApi;
    grouping: Jgrouping.IGridGroupingApi{<JTEntity>};
    importer: Jimporter.IGridImporterApi;
    infiniteScroll: JinfiniteScroll.IGridInfiniteScrollApi{<JTEntity>};
    pagination: Jpagination.IGridPaginationApi;
    pinning: Jpinning.IGridPinningApi{<JTEntity>};
    rowEdit: JrowEdit.IGridRowEditApi{<JTEntity>};
    saveState: JsaveState.IGridSaveStateApi;
    selection: Jselection.IGridSelectionApi{<JTEntity>};
    treeBase: JtreeBase.IGridTreeBaseApi{<JTEntity>};
    grid: JIGridInstanceOf{<JTEntity>};
  end;

  JIGridRowConstructor{<TEntity>} = class external
    constructor CreateJIGridRowOf{<JTEntity>};
  end;

  JIGridRowOf{<TEntity>} = class external(JcellNav.IGridRow, Jedit.IGridRow, Jexporter.IGridRow, Jselection.IGridRow, Jexpandable.IGridRow)
    entity: JTEntity;
    grid: JIGridInstanceOf{<JTEntity>};
    height: Float;
    uid: String;
    visible: Boolean;
    exporterEnableExporting: Boolean;
    procedure clearRowInvisible(row: JIGridRowOf{<JTEntity>});
    procedure clearRowInvisible(reason: String; fromRowsProcessor: Boolean);
    procedure evaluateRowVisibility(fromRowProcessor: Boolean);
    function getEntityQualifiedColField(col: JIGridColumnOf{<JTEntity>}): String;
    function getQualifiedColField(col: JIGridColumnOf{<JTEntity>}): String;
    procedure setRowInvisible(row: JIGridRowOf{<JTEntity>});
    procedure setThisRowInvisible(reason: String; fromRowsProcessor: Boolean);
  end;

  JIGridColumnConstructor{<TEntity>} = class external
    constructor CreateJIGridColumnOf{<JTEntity>};
  end;

  JIGridColumnOf{<TEntity>} = class external
    colDef: JuiGrid.IColumnDefOf{<JTEntity>};
    displayName: String; // nullable
    field: String; // nullable
    filter: JIFilterOptions; // nullable
    filters: JArray{<JIFilterOptions>}; // nullable
    grid: JIGridInstanceOf{<JTEntity>};
    name: String; // nullable
    sort: JISortInfo; // nullable
    sortingAlgorithm: (a: Variant; b: Variant): Float; // nullable
    width: Float;
    procedure GridColumn(colDef: JIColumnDefOf{<JTEntity>}; uid: Float; grid: JIGridInstanceOf{<JTEntity>});
    procedure getAggregationText(&label: String);
    function getAggregationValue: String;
    function getColClass(prefixDot: Boolean): String;
    function getColClassDefinition: String;
    function getRenderContainer: Variant;
    procedure hideColumn;
    function isPinnedLeft: Boolean;
    function isPinnedRight: Boolean;
    procedure setPropertyOrDefault(colDef: JIColumnDefOf{<JTEntity>}; propName: String; defaultValue: Variant);
    procedure showColumn;
    procedure updateColumnDef(colDef: JIColumnDefOf{<JTEntity>}; isNew: Boolean);
  end;

  JIColumnDefOf{<TEntity>} = class external(JcellNav.IColumnDef, Jedit.IColumnDef {JTEntity} , Jexporter.IColumnDef, Jgrouping.IColumnDef, JmoveColumns.IColumnDef, Jpinning.IColumnDef, JresizeColumns.IColumnDef, JtreeBase.IColumnDef {JTEntity} )
    aggregationHideLabel: Boolean; // nullable
    aggregationType: Variant {Float or JFunction}; // nullable
    cellClass: Variant {String or JICellClassGetter{<JTEntity>}}; // nullable
    cellFilter: String; // nullable
    cellTemplate: String; // nullable
    cellTooltip: Variant {Boolean or String or JICellTooltipGetter{<JTEntity>}}; // nullable
    displayName: String; // nullable
    enableColumnMenu: Boolean; // nullable
    enableColumnMenus: Boolean; // nullable
    enableFiltering: Boolean; // nullable
    enableHiding: Boolean; // nullable
    enableSorting: Boolean; // nullable
    field: String; // nullable
    filter: JIFilterOptions; // nullable
    filterCellFiltered: Boolean; // nullable
    filterHeaderTemplate: String; // nullable
    filters: JArray{<JIFilterOptions>}; // nullable
    footerCellClass: Variant {String or JIHeaderFooterCellClassGetter{<JTEntity>}}; // nullable
    footerCellFilter: String; // nullable
    footerCellTemplate: String; // nullable
    headerCellClass: Variant {String or JIHeaderFooterCellClassGetter{<JTEntity>}}; // nullable
    headerCellFilter: String; // nullable
    headerCellTemplate: String; // nullable
    headerTooltip: Variant {Boolean or String or JIHeaderTooltipGetter{<JTEntity>}}; // nullable
    maxWidth: Float; // nullable
    menuItems: JArray{<JIMenuItem>}; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    sort: JISortInfo; // nullable
    sortCellFiltered: Boolean; // nullable
    sortDirectionCycle: JArray{<JIUiGridConstants>}; // nullable
    sortingAlgorithm: (a: Variant; b: Variant): Float; // nullable
    suppressRemoveSort: Boolean; // nullable
    &type: String; // nullable
    visible: Boolean; // nullable
    width: Variant {Float or String}; // nullable
  end;

  JICellClassGetter{<TEntity>} = class external
(grid: JIGridInstanceOf{<JTEntity>}; gridRow: JIGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>}; rowRenderIndex: Float; colRenderIndex: Float): String  end;

  JICellTooltipGetter{<TEntity>} = class external
(gridRow: JIGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>}): String  end;

  JIHeaderTooltipGetter{<TEntity>} = class external
(gridCol: JIGridColumnOf{<JTEntity>}): String  end;

  JIHeaderFooterCellClassGetter{<TEntity>} = class external
(grid: JIGridInstanceOf{<JTEntity>}; gridRow: JIGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>}; rowRenderIndex: Float; colRenderIndex: Float): String  end;

  JIMenuItem = class external
    title: String; // nullable
    icon: String; // nullable
    action: ($event: Jng.IAngularEvent); // nullable
    shown: : Boolean; // nullable
    active: : Boolean; // nullable
    context: Variant; // nullable
    leaveOpen: Boolean; // nullable
  end;

  JISortInfo = class external
    direction: String; // nullable
    ignoreSort: Boolean; // nullable
    priority: Float; // nullable
  end;

  JIFilterOptions = class external
    condition: Float; // nullable
    term: String; // nullable
    placeholder: String; // nullable
    noTerm: Boolean; // nullable
    flags: JIFilterFlags; // nullable
    &type: Variant {Float or String}; // nullable
    selectOptions: JArray{<JISelectOption>}; // nullable
    disableCancelButton: Boolean; // nullable
  end;

  JISelectOption = class external
    value: Variant {Float or String};
    &label: String;
  end;

  JIFilterFlags = class external
    caseSensitive: Boolean; // nullable
  end;

IGridInstance = JIGridInstanceOf{<Variant>}IGridOptions = JIGridOptionsOf{<Variant>}IGridApi = JIGridApiOf{<Variant>}IGridRow = JIGridRowOf{<Variant>}IGridColumn = JIGridColumnOf{<Variant>}IColumnDef = JIColumnDefOf{<Variant>}//cellNav

type
  JIColumnDef = class external
    allowCellFocus: Boolean; // nullable
  end;

  JIGridOptions = class external
    modifierKeysToMultiSelectCells: Boolean; // nullable
  end;

  JIGridRow = class external
    allowCellFocus: Boolean; // nullable
  end;

  JICellNavApi{<TEntity>} = class external
    function getCurrentSelection: JArray{<JIRowCol{<JTEntity>}>};
    function getFocusedCell: JIRowCol{<JTEntity>};
    function rowColSelectIndex(rowCol: JIRowCol{<JTEntity>}): Float;
    function scrollToFocus(rowEntity: JTEntity; colDef: JIColumnDef): Jng.IPromise{<Variant>};
    on:       navigate: (scope: Jng.IScope; handler: JnavigateHandler{<JTEntity>});
      viewportKeyDown: (scope: Jng.IScope; handler: JviewportKeyDownHandler{<JTEntity>});
      viewportKeyPress: (scope: Jng.IScope; handler: JviewportKeyPressHandler{<JTEntity>});
    end;;
  end;

  JnavigateHandler{<TEntity>} = class external
(newRowCol: JIRowCol{<JTEntity>}; oldRowCol: JIRowCol{<JTEntity>})  end;

  JviewportKeyDownHandler{<TEntity>} = class external
(event: JJQueryKeyEventObject; rowCol: JIRowCol{<JTEntity>})  end;

  JviewportKeyPressHandler{<TEntity>} = class external
(event: JJQueryKeyEventObject; rowCol: JIRowCol{<JTEntity>})  end;

  JIRowColConstructor{<TEntity>} = class external
    constructor CreateJIRowCol{<JTEntity>};
  end;

  JIRowCol{<TEntity>} = class external
    row: JuiGrid.IGridRowOf{<JTEntity>};
    col: JIGridColumnOf{<JTEntity>};
    function getIntersectionValueRaw: Variant {JString or JNumber or JObject};
    function getIntersectionValueFiltered: Variant {JString or JNumber or JObject};
  end;

  JIUiGridCellNavConstants = class external
    FEATURE_NAME: String;
    CELL_NAV_EVENT: String;
    direction:       LEFT: Float;
      RIGHT: Float;
      UP: Float;
      DOWN: Float;
      PG_UP: Float;
      PG_DOWN: Float;
    end;;
    EVENT_TYPE:       KEYDOWN: Float;
      CLICK: Float;
      CLEAR: Float;
    end;;
  end;

//edit

type
  JIColumnDef{<TEntity>} = class external
    cellEditableCondition: Variant {Variant or ($scope: Jng.IScope): Boolean    end;}; // nullable
    editDropdownFilter: String; // nullable
    editDropdownIdLabel: String; // nullable
    editDropdownOptionsArray: JArray{<JIEditDropdown>}; // nullable
    editDropdownRowEntityOptionsArrayPath: String; // nullable
    editDropdownValueLabel: String; // nullable
    editFileChooserCallback: (gridRow: JuiGrid.IGridRowOf{<JTEntity>}; gridCol: JIGridColumnOf{<JTEntity>}; files: JFileList); // nullable
    editModelField: String; // nullable
    editableCellTemplate: String; // nullable
    enableCellEdit: Boolean; // nullable
    enableCellEditOnFocus: Boolean; // nullable
  end;

  JIEditDropdown = class external
    id: Variant {Float or String};
    value: Variant;
  end;

  JIGridOptions = class external
    cellEditableCondition: Variant {Variant or ($scope: Jng.IScope): Boolean    end;}; // nullable
    editableCellTemplate: String; // nullable
    enableCellEdit: Boolean; // nullable
    enableCellEditOnFocus: Boolean; // nullable
  end;

  JIGridRow = class external
    enableCellEdit: Boolean; // nullable
  end;

  JIGridEditApi{<TEntity>} = class external
    on:       afterCellEdit: (scope: Jng.IScope; handler: JafterCellEditHandler{<JTEntity>});
      beginCellEdit: (scope: Jng.IScope; handler: JbeginCellEditHandler{<JTEntity>});
      cancelCellEdit: (scope: Jng.IScope; handler: JcancelCellEditHandler{<JTEntity>});
    end;;
  end;

  JafterCellEditHandler{<TEntity>} = class external
(rowEntity: JTEntity; colDef: JIColumnDef{<JTEntity>}; newValue: Variant; oldValue: Variant)  end;

  JbeginCellEditHandler{<TEntity>} = class external
(rowEntity: JTEntity; colDef: JIColumnDef{<JTEntity>}; triggerEvent: JJQueryEventObject)  end;

  JcancelCellEditHandler{<TEntity>} = class external
(rowEntity: JTEntity; colDef: JIColumnDef{<JTEntity>})  end;

  JIUiGridEditConstants = class external
    EDITABLE_CELL_TEMPLATE: String;
    EDITABLE_CELL_DIRECTIVE: String;
    events:       BEGIN_CELL_EDIT: String;
      END_CELL_EDIT: String;
      CANCEL_CELL_EDIT: String;
    end;;
  end;

//expandable

type
  JIGridOptions = class external
    expandableRowHeaderWidth: Float; // nullable
    enableExpandable: Boolean; // nullable
    enableExpandableRowHeader: Boolean; // nullable
    expandableRowHeight: Float; // nullable
    expandableRowTemplate: String; // nullable
  end;

  JIGridExpandableApi{<TEntity>} = class external
    procedure collapseAllRows;
    procedure expandAllRows;
    procedure toggleAllRows;
    procedure toggleRowExpansion(rowEntity: JTEntity);
    on:       rowExpandedStateChanged: (scope: Jng.IScope; handler: JrowExpandedStateChangedHandler{<JTEntity>});
    end;;
  end;

  JrowExpandedStateChangedHandler{<TEntity>} = class external
(row: JIGridRowOf{<JTEntity>})  end;

  JIGridRow = class external
    isExpanded: Boolean; // nullable
  end;

//exporter

type
  JIColumnDef = class external
    exporterPdfAlign: String; // nullable
    exporterSuppressExport: Boolean; // nullable
  end;

  JIGridOptions{<TEntity>} = class external
    exporterAllDataFn: : Jng.IPromise{<JArray{<JTEntity>}>}; // nullable
    exporterAllDataPromise: : Jng.IPromise{<JArray{<JTEntity>}>}; // nullable
    exporterCsvColumnSeparator: String; // nullable
    exporterCsvFilename: String; // nullable
    exporterFieldCallback: (grid: JIGridInstanceOf{<JTEntity>}; row: JuiGrid.IGridRowOf{<JTEntity>}; col: JIGridColumnOf{<JTEntity>}; value: Variant): Variant; // nullable
    exporterHeaderFilter: (displayName: String): String; // nullable
    exporterHeaderFilterUseName: Boolean; // nullable
    exporterMenuCsv: Boolean; // nullable
    exporterMenuLabel: String; // nullable
    exporterMenuPdf: Boolean; // nullable
    exporterOlderExcelCompatibility: Boolean; // nullable
    exporterPdfCustomFormatter: (docDefinition: Variant): Variant; // nullable
    exporterPdfDefaultStyle: Variant; // nullable
    exporterPdfFilename: String; // nullable
    exporterPdfFooter: Variant {String or Variant or (currentPage: Float; pageCount: Float): String    end;}; // nullable
    exporterPdfHeader: Variant {String or Variant or (currentPage: Float; pageCount: Float): String    end;}; // nullable
    exporterPdfMaxGridWidth: Float; // nullable
    exporterPdfOrientation: String; // nullable
    exporterPdfPageSize: String; // nullable
    exporterPdfTableHeaderStyle: Variant; // nullable
    exporterPdfTableLayout: Variant; // nullable
    exporterPdfTableStyle: Variant; // nullable
    exporterSuppressColumns: JArray{<String>}; // nullable
    exporterSuppressMenu: Boolean; // nullable
  end;

  JIGridRow = class external
    exporterEnableExporting: Boolean; // nullable
  end;

  JIGridExporterApi = class external
    procedure csvExport(rowTypes: String; colTypes: String);
    procedure pdfExport(rowTypes: String; colTypes: String);
  end;

  JIUiGridExporterConstants = class external
    featureName: String;
    ALL: String;
    VISIBLE: String;
    SELECTED: String;
    CSV_CONTENT: String;
    BUTTON_LABEL: String;
    FILE_NAME: String;
  end;

//grouping

type
  JIColumnDef = class external
    enableGrouping: Boolean; // nullable
    grouping:       groupPriority: Float;
    end;; // nullable
    groupingShowAggregationMenu: Boolean; // nullable
    groupingShowGroupingMenu: Boolean; // nullable
  end;

  JIGridOptions = class external
    enableGrouping: Boolean; // nullable
    enableGroupHeaderSelection: Boolean; // nullable
    groupingNullLabel: String; // nullable
    groupingShowCounts: Boolean; // nullable
  end;

  JIGridGroupingApi{<TEntity>} = class external
    procedure aggregateColumn(columnName: String; or: Variant {String or JFunction}); overload;
    procedure aggregateColumn(columnName: String; or: Variant {String or JFunction}; aggregationLabel: String); overload;
    procedure clearGrouping;
    function getGrouping(getExpanded: Boolean): JIGridGroupingConfiguration;
    procedure groupColumn(columnName: String);
    procedure setGrouping(config: JIGridGroupingConfiguration);
    procedure ungroupColumn(columnName: String);
    on:       aggregationChanged: (scope: Jng.IScope; handler: JaggregationChangedHandler{<JTEntity>});
      groupingChanged: (scope: Jng.IScope; handler: JgroupingChangedHandler{<JTEntity>});
    end;;
  end;

  JIGridGroupingConfiguration = class external
    grouping: JArray{<JIGripGroup>};
    treeAggregations: JArray{<JIGridTreeAggregations>};
    expandedState: JIGridExpandedHash; // nullable
  end;

  JIGripGroup = class external
    field: String;
    colName: String;
    groupPriority: Float;
  end;

  JIGridTreeAggregations = class external
    field: String;
    colName: String;
    aggregation: String;
  end;

  JIGridExpandedHash = class external
    // property Item[key: String]: Variant {JIGridExpandedHash or String};
  end;

  JaggregationChangedHandler{<TEntity>} = class external
(col: JIGridColumnOf{<JTEntity>})  end;

  JgroupingChangedHandler{<TEntity>} = class external
(col: JIGridColumnOf{<JTEntity>})  end;

  JIUiGridGroupingConstants = class external(JISharedTreeConstants)
    featureName: String;
  end;

//importer

type
  JIGridOptions{<TEntity>} = class external
    importerDataAddCallback: (grid: JIGridInstanceOf{<JTEntity>}; newObjects: JArray{<JTEntity>}); // nullable
    importerErrorCallback: (grid: JIGridInstanceOf{<JTEntity>}; errorKey: String; consoleMessage: String; context: Variant); // nullable
    importerHeaderFilter: (displayName: String): String; // nullable
    importerObjectCallback: (grid: JIGridInstanceOf{<JTEntity>}; newObject: JTEntity): JTEntity; // nullable
    importerProcessHeaders: (grid: JIGridInstanceOf{<JTEntity>}; headerArray: JArray{<String>}): JArray{<String>}; // nullable
    enableImporter: Boolean; // nullable
    importerNewObject: JFunction; // nullable
    importerShowMenu: Boolean; // nullable
  end;

  JIGridImporterApi = class external
    procedure importFile(fileObject: JFile);
  end;

  JIUiGridImporterConstants = class external
    featureName: String;
  end;

//infiniteScroll

type
  JIGridOptions = class external
    enableInfiniteScroll: Boolean; // nullable
  end;

  JIGridInfiniteScrollApi{<TEntity>} = class external
    function dataLoaded(scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    function dataRemovedBottom(scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    function dataRemovedBottom(grid: JIGridInstanceOf{<JTEntity>}; scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    function dataRemovedTop(scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    function dataRemovedTop(grid: JIGridInstanceOf{<JTEntity>}; scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    function resetScroll(scrollUp: Boolean; scrollDown: Boolean): Jng.IPromise{<Variant>};
    procedure saveScrollPercentage;
    on:       needLoadMoreData: JFunction;
      needLoadMoreDataTop: JFunction;
    end;;
  end;

//moveColumns

type
  JIColumnDef = class external
    enableColumnMoving: Boolean; // nullable
  end;

  JIGridOptions = class external
    enableColumnMoving: Boolean; // nullable
  end;

  JIGridMoveColumnsApi = class external
    procedure moveColumn(originalPosition: Float; newPosition: Float);
    on:       columnPositionChanged: (scope: Jng.IScope; handler: JcolumnPositionChangedHandler); // nullable
    end;;
  end;

  JcolumnPositionChangedHandler = class external
(colDef: JIColumnDef; originalPosition: Float; finalPosition: Float)  end;

//pagination

type
  JIGridOptions = class external
    enablePagination: Boolean; // nullable
    enablePaginationControls: Boolean; // nullable
    paginationCurrentPage: Float; // nullable
    paginationPageSize: Float; // nullable
    paginationPageSizes: JArray{<Float>}; // nullable
    paginationTemplate: String; // nullable
    totalItems: Float; // nullable
    useExternalPagination: Boolean; // nullable
  end;

  JIGridPaginationApi = class external
    function getPage: Float;
    function getTotalPages: Float;
    procedure nextPage;
    procedure previousPage;
    procedure seek(page: Float);
    on:       paginationChanged: (scope: Jng.IScope; handler: JpaginationChangedHandler);
    end;;
  end;

  JpaginationChangedHandler = class external
(newPage: Float; pageSize: Float)  end;

//pinning

type
  JIColumnDef = class external
    enablePinning: Boolean; // nullable
    pinnedLeft: Boolean; // nullable
    pinnedRight: Boolean; // nullable
  end;

  JIGridOptions = class external
    enablePinning: Boolean; // nullable
  end;

  JIGridPinningApi{<TEntity>} = class external
    procedure pinColumn(col: JIGridColumnOf{<JTEntity>}; container: String);
    columnPin: (scope: Jng.IScope; handler: JcolumnPinHandler);
  end;

  JcolumnPinHandler = class external
(colDef: JIColumnDef; container: String)  end;

  JIUiGridPinningConstants = class external
    container:       LEFT: String;
      RIGHT: String;
      NONE: String;
    end;;
  end;

//resizeColumns

type
  JIColumnDef = class external
    enableColumnResizing: Boolean; // nullable
  end;

  JIGridOptions = class external
    enableColumnResizing: Boolean; // nullable
  end;

  JIGridResizeColumnsApi = class external
    on:       columnSizeChanged: (scope: Jng.IScope; handler: JcolumnSizeChangedHandler);
    end;;
  end;

  JcolumnSizeChangedHandler = class external
(colDef: JIColumnDef; delta: Float)  end;

//rowEdit

type
  JIGridOptions = class external
    rowEditWaitInterval: Float; // nullable
  end;

  JIGridRowEditApi{<TEntity>} = class external
    function flushDirtyRows: Jng.IPromise{<JArray{<Variant>}>}; overload;
    function flushDirtyRows(grid: JIGridInstanceOf{<JTEntity>}): Jng.IPromise{<JArray{<Variant>}>}; overload;
    function getDirtyRows: JArray{<JIGridRowOf{<JTEntity>}>}; overload;
    function getDirtyRows(grid: JIGridInstanceOf{<JTEntity>}): JArray{<JIGridRowOf{<JTEntity>}>}; overload;
    function getErrorRows: JArray{<JIGridRowOf{<JTEntity>}>}; overload;
    function getErrorRows(grid: JIGridInstanceOf{<JTEntity>}): JArray{<JIGridRowOf{<JTEntity>}>}; overload;
    procedure setRowsClean(dataRows: JArray{<JTEntity>});
    procedure setRowsDirty(dataRows: JArray{<JTEntity>});
    procedure setSavePromise(rowEntity: JObject; savePromise: Jng.IPromise{<Variant>});
    on:       saveRow: (scope: Jng.IScope; handler: JsaveRowHandler{<JTEntity>});
    end;;
  end;

  JsaveRowHandler{<TEntity>} = class external
(rowEntity: JTEntity)  end;

//saveState

type
  JIGridOptions = class external
    saveFilter: Boolean; // nullable
    saveFocus: Boolean; // nullable
    saveGrouping: Boolean; // nullable
    saveGroupingExpandedStates: Boolean; // nullable
    saveOrder: Boolean; // nullable
    savePinning: Boolean; // nullable
    saveRowIdentity: Boolean; // nullable
    saveScroll: Boolean; // nullable
    saveSelection: Boolean; // nullable
    saveSort: Boolean; // nullable
    saveTreeView: Boolean; // nullable
    saveVisible: Boolean; // nullable
    saveWidths: Boolean; // nullable
  end;

  JIGridSaveStateApi = class external
    procedure restore($scope: Jng.IScope; state: JIGridSavedState);
    function save: JIGridSavedState;
  end;

  JIGridSavedState = class external
    columns: JArray{<JISavedColumn>}; // nullable
    scrollFocus: JISavedScrollFocus; // nullable
    selection: JArray{<JIRowVal>};
    grouping: Jgrouping.IGridGroupingConfiguration;
    treeView: JtreeBase.ITreeState;
  end;

  JISavedColumn = class external
    name: String;
    visible: Boolean; // nullable
    width: Float; // nullable
    sort: JISortInfo; // nullable
    filters: JArray{<JIFilterOptions>}; // nullable
    pinned: String; // nullable
  end;

  JISavedScrollFocus = class external
    focus: Boolean; // nullable
    colName: String; // nullable
    rowVal: JIRowVal; // nullable
  end;

  JIRowVal = class external
    identity: Boolean;
    row: Variant {Float or Variant};
  end;

//selection

type
  JIGridOptions = class external
    enableFooterTotalSelected: Boolean; // nullable
    enableFullRowSelection: Boolean; // nullable
    enableRowHeaderSelection: Boolean; // nullable
    enableRowSelection: Boolean; // nullable
    enableSelectAll: Boolean; // nullable
    enableSelectionBatchEvent: Boolean; // nullable
    isRowSelectable: Boolean; // nullable
    modifierKeysToMultiSelect: Boolean; // nullable
    multiSelect: Boolean; // nullable
    noUnselect: Boolean; // nullable
    selectionRowHeaderWidth: Float; // nullable
  end;

  JIGridRow = class external
    enableSelection: Boolean; // nullable
    isSelected: Boolean; // nullable
    procedure setSelected(selected: Boolean);
  end;

  JIGridSelectionApi{<TEntity>} = class external
    procedure clearSelectedRows; overload;
    procedure clearSelectedRows(event: Jng.IAngularEvent); overload;
    function getSelectAllState: Boolean;
    function getSelectedGridRows: JArray{<JuiGrid.IGridRowOf{<JTEntity>}>};
    function getSelectedRows: JArray{<JTEntity>};
    procedure selectAllRows; overload;
    procedure selectAllRows(event: Jng.IAngularEvent); overload;
    procedure selectAllVisibleRows; overload;
    procedure selectAllVisibleRows(event: Jng.IAngularEvent); overload;
    procedure selectRow(rowEntity: JTEntity); overload;
    procedure selectRow(rowEntity: JTEntity; event: Jng.IAngularEvent); overload;
    procedure selectRowByVisibleIndex(index: Float); overload;
    procedure selectRowByVisibleIndex(index: Float; event: Jng.IAngularEvent); overload;
    procedure setModifierKeysToMultiSelect(multiSelect: Boolean);
    procedure setMultiSelect(multiSelect: Boolean);
    procedure toggleRowSelection(rowEntity: JTEntity); overload;
    procedure toggleRowSelection(rowEntity: JTEntity; event: Jng.IAngularEvent); overload;
    procedure unSelectRow(rowEntity: JTEntity); overload;
    procedure unSelectRow(rowEntity: JTEntity; event: Jng.IAngularEvent); overload;
    on:       rowSelectionChanged: (scope: Jng.IScope; handler: JrowSelectionChangedHandler{<JTEntity>});
      rowSelectionChangedBatch: (scope: Jng.IScope; handler: JrowSelectionChangedBatchHandler{<JTEntity>});
    end;;
  end;

  JrowSelectionChangedHandler{<TEntity>} = class external
(row: JuiGrid.IGridRowOf{<JTEntity>}; event: Jng.IAngularEvent)  end;

  JrowSelectionChangedBatchHandler{<TEntity>} = class external
(row: JArray{<JuiGrid.IGridRowOf{<JTEntity>}>}; event: Jng.IAngularEvent)  end;

//treeBase

type
  JIColumnDef{<TEntity>} = class external
    customTreeAggregationFinalizerFn: (aggregation: JIGridTreeBaseAggregationObject); // nullable
    customerTreeAggregationFn: (aggregation: JIGridTreeBaseAggregationObject; fieldValue: Variant; numValue: Float; row: JIGridRowOf{<JTEntity>}); // nullable
    treeAggregationLabel: String; // nullable
    treeAggregationType: String; // nullable
    treeAggregationUpdateEntity: Boolean; // nullable
  end;

  JIGridOptions{<TEntity>} = class external
    showTreeExpandNoChildren: Boolean; // nullable
    showTreeRowHeader: Boolean; // nullable
    treeCustomAggregations:       // property Item[index: String]: JIGridTreeBaseCustomAggregation{<JTEntity>};
    end;; // nullable
    treeIndent: Float; // nullable
    treeRowHeaderAlwaysVisible: Boolean; // nullable
    treeRowHeaderBaseWidth: Float; // nullable
  end;

  JIGridTreeBaseCustomAggregation{<TEntity>} = class external
    &label: String;
    aggregationFn: (aggregation: JIGridTreeBaseAggregationObject; fieldValue: Variant; numValue: Float; row: JIGridRowOf{<JTEntity>});
    finalizerFn: (aggregation: JIGridTreeBaseAggregationObject); // nullable
  end;

  JIGridTreeBaseAggregationObject = class external
    count: Float;
    sum: Float;
    value: Float;
    rendered: String; // nullable
  end;

  JIGridTreeBaseApi{<TEntity>} = class external
    procedure collapseAllRows;
    procedure collapseRow(row: JIGridRowOf{<JTEntity>});
    procedure collapseRowChildren(row: JIGridRowOf{<JTEntity>});
    procedure expandAllRows;
    procedure expandRow(row: JIGridRowOf{<JTEntity>});
    function getRowChildren(row: JIGridRowOf{<JTEntity>}): JArray{<JIGridRowOf{<JTEntity>}>};
    function getTreeState: JITreeState;
    procedure setTreeState(config: JITreeState);
    procedure toggleRowTreeState(row: JIGridRowOf{<JTEntity>});
    on:       rowCollapsed: (scope: Jng.IScope; handler: JrowCollapsedHandler{<JTEntity>});
      rowExpanded: (scope: Jng.IScope; handler: JrowExpandedHandler{<JTEntity>});
    end;;
  end;

  JITreeState = class external
    expandedState:       // property Item[index: String]: String;
    end;;
  end;

  JrowCollapsedHandler{<TEntity>} = class external
(row: JIGridRowOf{<JTEntity>})  end;

  JrowExpandedHandler{<TEntity>} = class external
(row: JIGridRowOf{<JTEntity>})  end;

  JIUiGridTreeBaseConstants = class external(JISharedTreeConstants)
    featureName: String;
  end;

//treeView

type
  JIGridOptions = class external
    enableTreeView: Boolean; // nullable
  end;

  JIUiGridTreeViewConstants = class external(JISharedTreeConstants)
    featureName: String;
  end;

//'angular-ui-grid'

