unit Winjs;

interface

type
  JElement = class external
    winControl: Variant;
  end;

  JIOHelper = class external
    function exists(filename: String): JWinJS.Promise{<Boolean>};
    function readText(fileName: String): JWinJS.Promise{<String>}; overload;
    function readText(fileName: String; def: String): JWinJS.Promise{<String>}; overload;
    function remove(fileName: String): JWinJS.Promise{<Variant>};
    function writeText(fileName: String; text: String): JWinJS.Promise{<Float>};
    storage: Variant;
  end;

//WinJS.Application

type
  JIPromiseEvent = class external(JCustomEvent)
    procedure setPromise(promise: JIPromise{<Variant>});
  end;

procedure addEventListener(&type: String; listener: JFunction); overload;
procedure addEventListener(&type: String; listener: JFunction; capture: Boolean); overload;
procedure checkpoint;
procedure queueEvent(eventRecord: Variant);
procedure removeEventListener(&type: String; listener: JFunction); overload;
procedure removeEventListener(&type: String; listener: JFunction; useCapture: Variant); overload;
procedure start;
procedure stop;
procedure onactivated(eventInfo: JIPromiseEvent);
procedure oncheckpoint(eventInfo: JIPromiseEvent);
procedure onerror(eventInfo: JIPromiseEvent);
procedure onloaded(eventInfo: JIPromiseEvent);
procedure onready(eventInfo: JIPromiseEvent);
procedure onsettings(eventInfo: JIPromiseEvent);
procedure onunload(eventInfo: JIPromiseEvent);
procedure onbackclick(eventInfo: JIPromiseEvent);

var
  local: JIOHelper;
  roaming: JIOHelper;
  temp: JIOHelper;
  sessionState: Variant;

//WinJS.Binding

type
  JList = class external 'List'
    constructor Create(list: array of JT; options: Variant);
    procedure onitemchanged(eventInfo: JCustomEvent);
    procedure oniteminserted(eventInfo: JCustomEvent);
    procedure onitemmoved(eventInfo: JCustomEvent);
    procedure onitemmutated(eventInfo: JCustomEvent);
    procedure onitemremoved(eventInfo: JCustomEvent);
    procedure onreload(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function bind(name: String; action: JFunction): Variant;
    function concat(item: array of JT): array of JT;
    function createFiltered(predicate: (x: JT): Boolean): JFilteredListProjection{<JT>};
    function createGrouped(groupKey: (x: JT): String; groupData: (x: JT): JG): JGroupedSortedListProjection{<JTJG>}; overload;
    function createGrouped(groupKey: (x: JT): String; groupData: (x: JT): JG; groupSorter: (left: String; right: String): Float): JGroupedSortedListProjection{<JTJG>}; overload;
    function createSorted(sorter: (left: JT; right: JT): Float): JSortedListProjection{<JT>};
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    function every(callback: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function every(callback: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    function filter(callback: (value: JT; index: Float; array: array of JT): Variant): array of JT; overload;
    function filter(callback: (value: JT; index: Float; array: array of JT): Variant; thisArg: Variant): array of JT; overload;
    procedure forEach(callback: (value: JT; index: Float; array: array of JT)); overload;
    procedure forEach(callback: (value: JT; index: Float; array: array of JT); thisArg: Variant); overload;
    function getAt(index: Float): JT;
    function getItem(index: Float): JIKeyDataPair{<JT>};
    function getItemFromKey(key: String): JIKeyDataPair{<JT>};
    function indexOf(searchElement: JT): Float; overload;
    function indexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function indexOfKey(key: String): Float;
    function join: String; overload;
    function join(separator: String): String; overload;
    function lastIndexOf(searchElement: JT): Float; overload;
    function lastIndexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function map(callback: (value: JT; index: Float; array: array of JT): JG): array of JG; overload;
    function map(callback: (value: JT; index: Float; array: array of JT): JG; thisArg: Variant): array of JG; overload;
    procedure move(index: Float; newIndex: Float);
    function notify(name: String; newValue: Variant; oldValue: Variant): JPromise{<Variant>};
    procedure notifyMutated(index: Float);
    procedure notifyReload;
    function pop: JT;
    function push(value: JT): Float;
    function push(values: array of JT): Float;
    function reduce(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduce(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT; initiallValue: JT): JT; overload;
    function reduceRight(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduceRight(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT; initialValue: JT): JT; overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure reverse;
    procedure setAt(index: Float; newValue: JT);
    function shift: JT;
    function slice(begin: Float): array of JT; overload;
    function slice(begin: Float; &end: Float): array of JT; overload;
    function some(callback: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function some(callback: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    procedure sort; overload;
    procedure sort(sortFunction: (left: JT; right: JT): Float); overload;
    function splice(start: Float): array of JT; overload;
    function splice(start: Float; howMany: Float; item: array of JT): array of JT; overload;
    function unbind(name: String; action: JFunction): Variant;
    function unshift(value: JT): Float;
    function unshift(values: array of JT): Float;
    dataSource: JWinJS.UI.IListDataSource{<JT>};
    _length: Float;
    supportedForProcessing: Boolean;
  end;

  JTemplate = class external 'Template'
    constructor Create(element: JHTMLElement; options: Variant);
    function render(dataContext: Variant): JPromise{<JHTMLElement>}; overload;
    function render(dataContext: Variant; container: JHTMLElement): JPromise{<JHTMLElement>}; overload;
    function renderItem(item: JWinJS.Promise{<JT>}; recyled: JHTMLElement):       element: JWinJS.Promise{<JHTMLElement>};
      renderComplete: JWinJS.Promise{<Variant>};
    end;;
    function render(href: String; dataContext: Variant): JPromise{<JHTMLElement>}; overload;
    function render(href: String; dataContext: Variant; container: JHTMLElement): JPromise{<JHTMLElement>}; overload;
    bindingInitializer: Variant;
    debugBreakOnRender: Boolean;
    disableOptimizedProcessing: Boolean;
    element: JHTMLElement;
    extractChild: Boolean;
    processTimeout: Float;
    isDeclarativeControlContainer: Boolean;
    supportedForProcessing: Boolean;
  end;

  JFilteredListProjection{<T>} = class external(JListProjection {JT} )
    function getItem(index: Float): JIKeyDataPair{<JT>};
    function indexOfKey(key: String): Float;
    procedure notifyMutated(index: Float);
    procedure setAt(index: Float; newValue: JT);
    _length: Float;
  end;

  JGroupsListProjection{<T>} = class external(JListBase {JT} )
    function getItem(index: Float): JIKeyDataPair{<JT>};
    function getItemFromKey(key: String): JIKeyDataPair{<JT>};
    function indexOfKey(key: String): Float;
    _length: Float;
  end;

  JGroupedSortedListProjection{<TG>} = class external(JSortedListProjection {JT} )
    groups: JGroupsListProjection{<JG>};
    function getItem(index: Float): JIGroupKeyDataPair{<JT>};
  end;

  JListBase{<T>} = class external
    procedure onitemchanged(eventInfo: JCustomEvent);
    procedure oniteminserted(eventInfo: JCustomEvent);
    procedure onitemmoved(eventInfo: JCustomEvent);
    procedure onitemmutated(eventInfo: JCustomEvent);
    procedure onitemremoved(eventInfo: JCustomEvent);
    procedure onreload(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function bind(name: String; action: JFunction): Variant;
    function concat(item: array of JT): array of JT;
    function createFiltered(predicate: (x: JT): Boolean): JFilteredListProjection{<JT>};
    function createGrouped(groupKey: (x: JT): String; groupData: (x: JT): JG): JGroupedSortedListProjection{<JTJG>}; overload;
    function createGrouped(groupKey: (x: JT): String; groupData: (x: JT): JG; groupSorter: (left: String; right: String): Float): JGroupedSortedListProjection{<JTJG>}; overload;
    function createSorted(sorter: (left: JT; right: JT): Float): JSortedListProjection{<JT>};
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    function every(callback: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function every(callback: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    function filter(callback: (value: JT; index: Float; array: array of JT): Variant): array of JT; overload;
    function filter(callback: (value: JT; index: Float; array: array of JT): Variant; thisArg: Variant): array of JT; overload;
    procedure forEach(callback: (value: JT; index: Float; array: array of JT)); overload;
    procedure forEach(callback: (value: JT; index: Float; array: array of JT); thisArg: Variant); overload;
    function getAt(index: Float): JT;
    function indexOf(searchElement: JT): Float; overload;
    function indexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function join: String; overload;
    function join(separator: String): String; overload;
    function lastIndexOf(searchElement: JT): Float; overload;
    function lastIndexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function map(callback: (value: JT; index: Float; array: array of JT): JG): array of JG; overload;
    function map(callback: (value: JT; index: Float; array: array of JT): JG; thisArg: Variant): array of JG; overload;
    function notify(name: String; newValue: Variant; oldValue: Variant): JPromise{<Variant>};
    procedure notifyReload;
    function reduce(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduce(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT; initiallValue: JT): JT; overload;
    function reduceRight(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduceRight(callback: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): JT; initialValue: JT): JT; overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function slice(begin: Float): array of JT; overload;
    function slice(begin: Float; &end: Float): array of JT; overload;
    function some(callback: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function some(callback: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    function unbind(name: String; action: JFunction): Variant;
    dataSource: JWinJS.UI.IListDataSource{<JT>};
  end;

  JListBaseWithMutators{<T>} = class external(JListBase {JT} )
    function pop: JT;
    function push(value: JT): Float;
    function push(values: array of JT): Float;
    function shift: JT;
    function unshift(value: JT): Float;
    function unshift(values: array of JT): Float;
  end;

  JListProjection{<T>} = class external(JListBaseWithMutators {JT} )
    procedure dispose;
    function getItemFromKey(key: String): JIKeyDataPair{<JT>};
    procedure move(index: Float; newIndex: Float);
    function splice(start: Float): array of JT; overload;
    function splice(start: Float; howMany: Float; item: array of JT): array of JT; overload;
  end;

  JSortedListProjection{<T>} = class external(JListProjection {JT} )
    function getItem(index: Float): JIKeyDataPair{<JT>};
    function indexOfKey(key: String): Float;
    procedure notifyMutated(index: Float);
    procedure setAt(index: Float; newValue: JT);
    _length: Float;
  end;

  JIKeyDataPair{<T>} = class external
    key: String;
    data: JT;
  end;

  JIGroupKeyDataPair{<T>} = class external(JIKeyDataPair {JT} )
    groupSize: Float;
    firstItemIndexHint: Float;
    firstItemKey: String;
  end;

procedure addClassOneTime(source: Variant; sourceProperties: array of Variant; dest: JHTMLElement);
function as(data: JU): JU;
function bind(observable: Variant; bindingDescriptor: Variant): Variant;
function converter(convert: JFunction): JFunction;
function defaultBind(source: Variant; sourceProperties: Variant; dest: Variant; destProperties: Variant): Variant;
function define(data: Variant): JFunction;
function expandProperties(shape: Variant): Variant;
function getValue(obj: Variant): Variant; overload;
function getValue(obj: Variant; path: Variant): Variant; overload;
function initializer(customInitializer: JFunction): JFunction;
function oneTime(source: Variant; sourceProperties: Variant; dest: Variant; destProperties: Variant): Variant;
function processAll: JPromise{<Variant>}; overload;
function processAll(rootElement: JElement): JPromise{<Variant>}; overload;
function processAll(rootElement: JElement; dataContext: Variant): JPromise{<Variant>}; overload;
function processAll(rootElement: JElement; dataContext: Variant; skipRoot: Boolean): JPromise{<Variant>}; overload;
function processAll(rootElement: JElement; dataContext: Variant; skipRoot: Boolean; bindingCache: Variant): JPromise{<Variant>}; overload;
function processAll(rootElement: JElement; dataContext: Variant; skipRoot: Boolean; bindingCache: Variant; defaultInitializer: JFunction): JPromise{<Variant>}; overload;
function setAttribute(source: Variant; sourceProperties: array of Variant; dest: JElement; destProperties: array of Variant): Variant;
procedure setAttributeOneTime(source: Variant; sourceProperties: array of Variant; dest: JElement; destProperties: array of Variant);
function unwrap(data: Variant): Variant;

var
  dynamicObservableMixin:     procedure addProperty(name: String; value: Variant);
    function bind(name: String; action: Variant): JFunction;
    function getProperty(name: String): Variant;
    function notify(name: String; newValue: String; oldValue: String): JPromise{<Variant>};
    function removeProperty(name: String): Variant;
    function setProperty(name: String; value: Variant): Variant;
    function unbind(name: String; action: JFunction): Variant;
    function updateProperty(name: String; value: Variant): JPromise{<Variant>};
  end;;
  mixin:     function addProperty(name: String; value: Variant): Variant;
    function bind(name: String; action: Variant): JFunction;
    function getProperty(name: String): Variant;
    function notify(name: String; newValue: String; oldValue: String): JPromise{<Variant>};
    function removeProperty(name: String): Variant;
    function setProperty(name: String; value: Variant): Variant;
    function unbind(name: String; action: JFunction): Variant;
    function updateProperty(name: String; value: Variant): JPromise{<Variant>};
  end;;
  observableMixin:     function bind(name: String; action: JFunction): Variant;
    function notify(name: String; newValue: Variant; oldValue: Variant): JPromise{<Variant>};
    function unbind(name: String; action: JFunction): Variant;
  end;;

//WinJS.Class

function define: Variant; overload;
function define(&constructor: JFunction): Variant; overload;
function define(&constructor: JFunction; instanceMembers: Variant): Variant; overload;
function define(&constructor: JFunction; instanceMembers: Variant; staticMembers: Variant): Variant; overload;
function derive(baseClass: Variant; &constructor: JFunction): Variant; overload;
function derive(baseClass: Variant; &constructor: JFunction; instanceMembers: Variant): Variant; overload;
function derive(baseClass: Variant; &constructor: JFunction; instanceMembers: Variant; staticMembers: Variant): Variant; overload;
function mix(&constructor: JFunction; mixin: array of Variant): Variant;

//WinJS

type
  JErrorFromName = class external 'ErrorFromName'
    constructor Create(name: String; message: String);
    supportedForProcessing: Boolean;
  end;

  JPromise = class external 'Promise'
    constructor Create(init: (completeDispatch: Variant; errorDispatch: Variant; progressDispatch: Variant); onCancel: JFunction);
    procedure onerror(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; capture: Boolean); overload;
    function any(value: array of JIPromise{<Variant>}): JIPromise{<Variant>};
    function any(value: Variant): JIPromise{<Variant>};
    function as: JIPromise{<JU>}; overload;
    function as(value: JU): JIPromise{<JU>}; overload;
    procedure cancel;
    cancel: JIPromise{<Variant>};
    function dispatchEvent(&type: String; details: Variant): Boolean;
    procedure done; overload;
    procedure done(onComplete: (value: JT): Variant); overload;
    procedure done(onComplete: (value: JT): Variant; onError: (error: Variant): Variant); overload;
    procedure done(onComplete: (value: JT): Variant; onError: (error: Variant): Variant; onProgress: (progress: Variant)); overload;
    function is(value: Variant): Boolean;
    function join(values: Variant): JIPromise{<Variant>};
    procedure removeEventListener(eventType: String; listener: JFunction); overload;
    procedure removeEventListener(eventType: String; listener: JFunction; capture: Boolean); overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then(promise: JIPromise{<Variant>}): JIPromise{<Variant>}; overload;
    function then(promise: JIPromise{<Variant>}; onComplete: (value: Variant): Variant): JIPromise{<Variant>}; overload;
    function then(promise: JIPromise{<Variant>}; onComplete: (value: Variant): Variant; onError: (error: Variant): Variant): JIPromise{<Variant>}; overload;
    function then(promise: JIPromise{<Variant>}; onComplete: (value: Variant): Variant; onError: (error: Variant): Variant; onProgress: (progress: Variant)): JIPromise{<Variant>}; overload;
    function thenEach(values: Variant): JIPromise{<Variant>}; overload;
    function thenEach(values: Variant; complete: (value: Variant)): JIPromise{<Variant>}; overload;
    function thenEach(values: Variant; complete: (value: Variant); error: (error: Variant)): JIPromise{<Variant>}; overload;
    function thenEach(values: Variant; complete: (value: Variant); error: (error: Variant); progress: (progress: Variant)): JIPromise{<Variant>}; overload;
    function timeout: JIPromise{<Variant>}; overload;
    function timeout(timeout: Float): JIPromise{<Variant>}; overload;
    function timeout(timeout: Float; promise: JIPromise{<Variant>}): JIPromise{<Variant>}; overload;
    function wrap: JIPromise{<JU>}; overload;
    function wrap(value: JU): JIPromise{<JU>}; overload;
    function wrapError(error: JU): JIPromise{<JU>};
    supportedForProcessing: Boolean;
  end;

  JIPromise{<T>} = class external
    procedure cancel;
    procedure done; overload;
    procedure done(onComplete: (value: JT): Variant); overload;
    procedure done(onComplete: (value: JT): Variant; onError: (error: Variant): Variant); overload;
    procedure done(onComplete: (value: JT): Variant; onError: (error: Variant): Variant; onProgress: (progress: Variant)); overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JIPromise{<JU>}; onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT): JU; onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JIPromise{<JU>}; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant): JU; onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant)): JIPromise{<JU>}; overload;
    function then(onComplete: (value: JT); onError: (error: Variant); onProgress: (progress: Variant)): JIPromise{<JU>}; overload;
  end;

  JIXHROptions = class external
    &type: String; // nullable
    url: String;
    user: String; // nullable
    password: String; // nullable
    headers: Variant; // nullable
    data: Variant; // nullable
    responseType: String; // nullable
    customRequestInitializer: (request: JXMLHttpRequest); // nullable
  end;

procedure log(message: String); overload;
procedure log(message: String; tags: String); overload;
procedure log(message: String; tags: String; &type: String); overload;
procedure log(message: : String); overload;
procedure log(message: : String; tags: String); overload;
procedure log(message: : String; tags: String; &type: String); overload;
function xhr(options: JIXHROptions): JPromise{<JXMLHttpRequest>};

var
  validation: Boolean;

//WinJS.Namespace

function define: Variant; overload;
function define(name: String): Variant; overload;
function define(name: String; members: Variant): Variant; overload;
function defineWithParent: Variant; overload;
function defineWithParent(parentNamespace: Variant): Variant; overload;
function defineWithParent(parentNamespace: Variant; name: String): Variant; overload;
function defineWithParent(parentNamespace: Variant; name: String; members: Variant): Variant; overload;

//WinJS.Navigation

procedure addEventListener(eventType: String; listener: JFunction); overload;
procedure addEventListener(eventType: String; listener: JFunction; capture: Boolean); overload;
function back: JPromise{<Boolean>}; overload;
function back(distance: Float): JPromise{<Boolean>}; overload;
function forward: JPromise{<Boolean>}; overload;
function forward(distance: Float): JPromise{<Boolean>}; overload;
function navigate(location: Variant): JPromise{<Boolean>}; overload;
function navigate(location: Variant; initialState: Variant): JPromise{<Boolean>}; overload;
procedure removeEventListener(eventType: String; listener: JFunction); overload;
procedure removeEventListener(eventType: String; listener: JFunction; useCapture: Boolean); overload;
procedure onbeforenavigate(eventInfo: JCustomEvent);
procedure onnavigated(eventInfo: JCustomEvent);
procedure onnavigating(eventInfo: JCustomEvent);

var
  canGoBack: Boolean;
  canGoForward: Boolean;
  history: Variant;
  location: String;
  state: Variant;

//WinJS.Resources

procedure addEventListener(&type: String; listener: JFunction); overload;
procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
procedure dispatchEvent(&type: String; details: Variant);
function getString(resourceId: String):   value: String;
  empty: Boolean; // nullable
  lang: String; // nullable
end;;
function processAll: JPromise{<Variant>}; overload;
function processAll(rootElement: JHTMLElement): JPromise{<Variant>}; overload;
procedure removeEventListener(&type: String; listener: JFunction); overload;
procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
procedure oncontextchanged(eventInfo: JCustomEvent);

//WinJS.UI.Animation

type
  JIAnimationMethodResponse = class external
    function execute: JPromise{<Variant>};
  end;

function createAddToListAnimation(added: Variant; affected: Variant): JIAnimationMethodResponse;
function createAddToSearchListAnimation(added: Variant; affected: Variant): JIAnimationMethodResponse;
function createCollapseAnimation(hidden: Variant; affected: Variant): JIAnimationMethodResponse;
function createDeleteFromListAnimation(deleted: Variant; remaining: Variant): JIAnimationMethodResponse;
function createDeleteFromSearchListAnimation(deleted: Variant; remaining: Variant): JIAnimationMethodResponse;
function createExpandAnimation(revealed: Variant; affected: Variant): JIAnimationMethodResponse;
function createPageNavigationAnimations(currentPreferredAnimation: String; nextPreferredAnimation: String; movingBackwards: Boolean):   exit: JFunction;
  entrance: JFunction;
end;;
function createPeekAnimation(element: Variant): JIAnimationMethodResponse;
function createRepositionAnimation(element: Variant): JIAnimationMethodResponse;
function crossFade(incoming: Variant; outgoing: Variant): JPromise{<Variant>};
function dragBetweenEnter(target: Variant): JPromise{<Variant>}; overload;
function dragBetweenEnter(target: Variant; offset: Variant): JPromise{<Variant>}; overload;
function dragBetweenLeave(target: Variant): JPromise{<Variant>};
function dragSourceEnd(dragSource: Variant): JPromise{<Variant>}; overload;
function dragSourceEnd(dragSource: Variant; offset: Variant): JPromise{<Variant>}; overload;
function dragSourceEnd(dragSource: Variant; offset: Variant; affected: Variant): JPromise{<Variant>}; overload;
function dragSourceStart(dragSource: Variant): JPromise{<Variant>}; overload;
function dragSourceStart(dragSource: Variant; affected: Variant): JPromise{<Variant>}; overload;
function drillInIncoming(incomingPage: JHTMLElement): JPromise{<Variant>};
function drillInOutgoing(outgoingPage: JHTMLElement): JPromise{<Variant>};
function drillOutIncoming(incomingPage: JHTMLElement): JPromise{<Variant>};
function drillOutOutgoing(outgoingPage: JHTMLElement): JPromise{<Variant>};
function enterContent(incoming: Variant): JPromise{<Variant>}; overload;
function enterContent(incoming: Variant; offset: Variant): JPromise{<Variant>}; overload;
function enterContent(incoming: Variant; offset: Variant; options: Variant): JPromise{<Variant>}; overload;
function enterPage(element: Variant): JPromise{<Variant>}; overload;
function enterPage(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function exitContent(outgoing: Variant): JPromise{<Variant>}; overload;
function exitContent(outgoing: Variant; offset: Variant): JPromise{<Variant>}; overload;
function exitPage(outgoing: Variant): JPromise{<Variant>}; overload;
function exitPage(outgoing: Variant; offset: Variant): JPromise{<Variant>}; overload;
function fadeIn(shown: Variant): JPromise{<Variant>};
function fadeOut(hidden: Variant): JPromise{<Variant>};
function hideEdgeUI(element: Variant): JPromise{<Variant>}; overload;
function hideEdgeUI(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function hideEdgeUI(element: Variant; offset: Variant; options: Variant): JPromise{<Variant>}; overload;
function hidePanel(element: Variant): JPromise{<Variant>}; overload;
function hidePanel(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function hidePopup(element: Variant): JPromise{<Variant>};
function pointerDown(element: Variant): JPromise{<Variant>};
function pointerUp(element: Variant): JPromise{<Variant>};
function showEdgeUI(element: Variant): JPromise{<Variant>}; overload;
function showEdgeUI(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function showEdgeUI(element: Variant; offset: Variant; options: Variant): JPromise{<Variant>}; overload;
function showPanel(element: Variant): JPromise{<Variant>}; overload;
function showPanel(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function showPopup(element: Variant): JPromise{<Variant>}; overload;
function showPopup(element: Variant; offset: Variant): JPromise{<Variant>}; overload;
function swipeDeselect(deselected: Variant; selection: Variant): JPromise{<Variant>};
function swipeReveal(target: Variant): JPromise{<Variant>}; overload;
function swipeReveal(target: Variant; offset: Variant): JPromise{<Variant>}; overload;
function swipeSelect(selected: Variant; selection: Variant): JPromise{<Variant>};
function updateBadge(incoming: Variant): JPromise{<Variant>}; overload;
function updateBadge(incoming: Variant; offset: Variant): JPromise{<Variant>}; overload;
function slideUp(incoming: Variant): JPromise{<Variant>};
function slideDown(incoming: Variant): JPromise{<Variant>};
function slideLeftIn(page: Variant; first: Variant; second: Variant; third: Variant): JPromise{<Variant>};
function slideLeftOut(page: Variant; first: Variant; second: Variant; third: Variant): JPromise{<Variant>};
function slideRightIn(page: Variant; first: Variant; second: Variant; third: Variant): JPromise{<Variant>};
function slideRightOut(page: Variant; first: Variant; second: Variant; third: Variant): JPromise{<Variant>};
function continuumForwardIn(page: Variant; itemRoot: Variant; itemContent: Variant): JPromise{<Variant>};
function continuumForwardOut(page: Variant; item: Variant): JPromise{<Variant>};
function continuumBackwardIn(page: Variant; item: Variant): JPromise{<Variant>};
function continuumBackwardOut(page: Variant): JPromise{<Variant>};
function turnstileForwardIn(incoming: Variant): JPromise{<Variant>};
function turnstileForwardOut(outgoing: Variant): JPromise{<Variant>};
function turnstileBackwardIn(incoming: Variant): JPromise{<Variant>};
function turnstileBackwardOut(outgoing: Variant): JPromise{<Variant>};

//WinJS.UI

type
  JAppBar = class external 'AppBar'
    constructor Create(element: JHTMLElement; options: Variant);
    onafterclose: (eventInfo: JCustomEvent);
    onafteropen: (eventInfo: JCustomEvent);
    onbeforeclose: (eventInfo: JCustomEvent);
    onbeforeopen: (eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure removeEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure removeEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(eventName: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function getCommandById(id: String): JICommand;
    procedure showOnlyCommands(commands: JArray{<Variant {String or JICommand}>});
    procedure open;
    procedure close;
    procedure forceLayout;
    closedDisplayMode: String;
    data: JWinJS.Binding.List{<JICommand>};
    element: JHTMLElement;
    opened: Boolean;
    placement: String;
    ClosedDisplayMode:       none: String;
      minimal: String;
      compact: String;
      full: String;
    end;;
    Placement:       top: String;
      bottom: String;
    end;;
    supportedForProcessing: Boolean;
  end;

  JAppBarCommand = class external 'AppBarCommand'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure dispose;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    disabled: Boolean;
    element: JHTMLElement;
    extraClass: String;
    firstElementFocus: JHTMLElement;
    flyout: JFlyout;
    hidden: Boolean;
    icon: String;
    id: String;
    &label: String;
    lastElementFocus: JHTMLElement;
    onclick: JFunction;
    section: String;
    selected: Boolean;
    tooltip: String;
    &type: String;
    priority: Float;
    supportedForProcessing: Boolean;
  end;

  JAutoSuggestBox = class external 'AutoSuggestBox'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onquerychanged(eventInfo: JCustomEvent);
    procedure onquerysubmitted(eventInfo: JCustomEvent);
    procedure onresultsuggestionchosen(eventInfo: JCustomEvent);
    procedure onsuggestionsrequested(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    procedure setLocalContentSuggestionSettings(settings: Variant);
    chooseSuggestionOnEnter: Boolean;
    disabled: Boolean;
    element: JHTMLElement;
    placeholderText: String;
    queryText: String;
    searchHistoryContext: String;
    searchHistoryDisabled: Boolean;
    supportedForProcessing: Boolean;
    function createResultSuggestionImage(url: String): Variant;
  end;

  JBackButton = class external 'BackButton'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure refresh;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    supportedForProcessing: Boolean;
  end;

  JCellSpanningLayout = class external 'CellSpanningLayout'
    constructor Create(options: Variant);
    procedure dragLeave;
    procedure dragOver;
    procedure executeAnimations;
    function getAdjacent(currentItem: Variant; pressedKey: JWinJS.Utilities.Key): Variant;
    procedure hitTest(x: Float; y: Float);
    procedure initialize(site: JILayoutSite2; groupsEnabled: Boolean);
    procedure itemsFromRange(firstPixel: Float; lastPixel: Float);
    procedure layout(tree: JILayoutSite2; changedRange: Variant; modifiedItems: Variant; modifiedGroups: Variant);
    procedure setupAnimations;
    procedure uninitialize;
    groupHeaderPosition: JWinJS.UI.HeaderPosition;
    groupInfo: JFunction;
    itemInfo: JFunction;
    maximumRowsOrColumns: Float;
    numberOfItemsPerItemsBlock: Variant;
    orientation: JWinJS.UI.Orientation;
    supportedForProcessing: Boolean;
  end;

  JCommand = class external 'Command'(JAppBarCommand)
    supportedForProcessing: Boolean;
  end;

  JContentDialog = class external 'ContentDialog'
    DismissalResult:       none: String;
      primary: String;
      secondary: String;
    end;;
    supportedForProcessing: Boolean;
    constructor Create(element: JHTMLElement; options: Variant);
    element: JHTMLElement;
    hidden: Boolean;
    title: String;
    primaryCommandText: String;
    primaryCommandDisabled: Boolean;
    secondaryCommandText: String;
    secondaryCommandDisabled: Boolean;
    function show: JPromise{<JContentDialogHideInfo>};
    procedure hide; overload;
    procedure hide(result: Variant); overload;
    procedure dispose;
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure onbeforeshow(eventInfo: JEvent);
    procedure onaftershow(eventInfo: JEvent);
    procedure onbeforehide(eventInfo: JContentDialogHideEvent);
    procedure onafterhide(eventInfo: JContentDialogHideEvent);
  end;

  JDatePicker = class external 'DatePicker'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onchange(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; capture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function getInformation(startDate: Variant; endDate: Variant): Variant; overload;
    function getInformation(startDate: Variant; endDate: Variant; calendar: Variant): Variant; overload;
    function getInformation(startDate: Variant; endDate: Variant; calendar: Variant; datePatterns: Variant): Variant; overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Variant); overload;
    calendar: String;
    current: JDate;
    datePattern: String;
    disabled: Boolean;
    element: JHTMLElement;
    maxYear: Float;
    minYear: Float;
    monthPattern: String;
    yearPattern: String;
    supportedForProcessing: Boolean;
  end;

  JFlipView = class external 'FlipView'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure ondatasourcecountchanged(eventInfo: JEvent);
    procedure onpagecompleted(eventInfo: JCustomEvent);
    procedure onpageselected(eventInfo: JCustomEvent);
    procedure onpagevisibilitychanged(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function count: JPromise{<Float>};
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    function next: Boolean;
    function previous: Boolean;
    procedure removeEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure removeEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure setCustomAnimations(animations: Variant);
    currentPage: Float;
    element: JHTMLElement;
    itemDataSource: JIListDataSource{<JT>};
    itemSpacing: Float;
    itemTemplate: Variant;
    orientation: String;
    supportedForProcessing: Boolean;
    datasourceCountChangedEvent: String;
    pageCompletedEvent: String;
    pageSelectedEvent: String;
    pageVisibilityChangedEvent: String;
  end;

  JFlyout = class external 'Flyout'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onafterhide(eventInfo: JEvent);
    procedure onaftershow(eventInfo: JEvent);
    procedure onbeforehide(eventInfo: JEvent);
    procedure onbeforeshow(eventInfo: JEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(eventName: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure hide;
    procedure show; overload;
    procedure show(anchor: JHTMLElement); overload;
    procedure show(anchor: JHTMLElement; placement: String); overload;
    procedure show(anchor: JHTMLElement; placement: String; alignment: String); overload;
    procedure showAt(coordinates:       x: Float;
      y: Float;
    end;);
    procedure showAt(mouseEventObj: JMouseEvent);
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    alignment: String;
    anchor: JHTMLElement;
    disabled: Boolean;
    element: JHTMLElement;
    hidden: Boolean;
    placement: String;
    supportedForProcessing: Boolean;
  end;

  JGridLayout = class external 'GridLayout'
    constructor Create(options: Variant);
    procedure dragLeave;
    procedure dragOver;
    procedure executeAnimations;
    function getAdjacent(currentItem: Variant; pressedKey: JWinJS.Utilities.Key): Variant;
    procedure hitTest(x: Float; y: Float);
    procedure initialize(site: JILayoutSite2; groupsEnabled: Boolean);
    procedure itemsFromRange(firstPixel: Float; lastPixel: Float);
    procedure layout(tree: Variant; changedRange: Variant; modifiedItems: Variant; modifiedGroups: Variant);
    procedure setupAnimations;
    procedure uninitialize;
    backdropColor: String;
    disableBackdrop: Boolean;
    groupHeaderPosition: JWinJS.UI.HeaderPosition;
    groupInfo: JFunction;
    itemInfo: JFunction;
    maximumRowsOrColumns: Float;
    maxRows: Float;
    numberOfItemsPerItemsBlock: Variant;
    orientation: JWinJS.UI.Orientation;
    supportedForProcessing: Boolean;
  end;

  JHub = class external 'Hub'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure oncontentanimating(eventInfo: JCustomEvent);
    procedure onheaderinvoked(eventInfo: JCustomEvent);
    procedure onloadingstatechanged(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    headerTemplate: Variant;
    indexOfFirstVisible: Float;
    indexOfLastVisible: Float;
    loadingState: String;
    orientation: JOrientation;
    scrollPosition: Float;
    sectionOnScreen: Float;
    sections: JWinJS.Binding.List{<JHubSection>};
    zoomableView: JIZoomableView{<Variant>};
    supportedForProcessing: Boolean;
    AnimationType:       entrance: String;
      contentTransition: String;
      insert: String;
      remove: String;
    end;;
    LoadingState:       loading: String;
      complete: String;
    end;;
  end;

  JHubSection = class external 'HubSection'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure dispose;
    contentElement: JHTMLElement;
    element: JHTMLElement;
    header: String;
    isHeaderStatic: Boolean;
    isDeclarativeControlContainer: Variant;
    supportedForProcessing: Boolean;
  end;

  JHtmlControl = class external 'HtmlControl'
    constructor Create(element: JHTMLElement; options: Variant);
    supportedForProcessing: Boolean;
  end;

  JItemContainer = class external 'ItemContainer'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure oninvoked(eventInfo: JCustomEvent);
    procedure onselectionchanged(eventInfo: JCustomEvent);
    procedure onselectionchanging(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    draggable: Boolean;
    element: JHTMLElement;
    selected: Boolean;
    selectionDisabled: Boolean;
    swipeBehavior: JWinJS.UI.SwipeBehavior;
    swipeOrientation: JOrientation;
    tapBehavior: JTapBehavior;
    supportedForProcessing: Boolean;
  end;

  JLayout = class external 'Layout'
    supportedForProcessing: Boolean;
  end;

  JListLayout = class external 'ListLayout'
    constructor Create(options: Variant);
    procedure dragLeave;
    procedure dragOver;
    procedure executeAnimations;
    function getAdjacent(currentItem: Variant; pressedKey: JWinJS.Utilities.Key): Variant;
    procedure hitTest(x: Float; y: Float);
    procedure initialize;
    procedure itemsFromRange(firstPixel: Float; lastPixel: Float);
    procedure layout(tree: Variant; changedRange: Variant; modifiedItems: Variant; modifiedGroups: Variant);
    procedure setupAnimations;
    procedure uninitialize;
    backdropColor: String;
    disableBackdrop: Boolean;
    groupHeaderPosition: JWinJS.UI.HeaderPosition;
    numberOfItemsPerItemsBlock: Variant;
    orientation: JWinJS.UI.Orientation;
    supportedForProcessing: Boolean;
  end;

  JListView = class external 'ListView'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onaccessibilityannotationcomplete(eventInfo: JCustomEvent);
    procedure oncontentanimating(eventInfo: JCustomEvent);
    procedure ongroupheaderinvoked(eventInfo: JCustomEvent);
    procedure onitemdragbetween(eventInfo: JCustomEvent);
    procedure onitemdragchanged(eventInfo: JCustomEvent);
    procedure onitemdragdrop(eventInfo: JCustomEvent);
    procedure onitemdragend(eventInfo: JCustomEvent);
    procedure onitemdragenter(eventInfo: JCustomEvent);
    procedure onitemdragleave(eventInfo: JCustomEvent);
    procedure onitemdragstart(eventInfo: JCustomEvent);
    procedure oniteminvoked(eventInfo: JCustomEvent);
    procedure onkeyboardnavigating(eventInfo: JCustomEvent);
    procedure onloadingstatechanged(eventInfo: JCustomEvent);
    procedure onselectionchanged(eventInfo: JCustomEvent);
    procedure onselectionchanging(eventInfo: JCustomEvent);
    procedure onheadervisibilitychanged(eventInfo: JCustomEvent);
    procedure onfootervisibilitychanged(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function elementFromIndex(itemIndex: Float): JHTMLElement;
    procedure ensureVisible(itemIndex: Float);
    procedure forceLayout;
    function indexOfElement(element: JHTMLElement): Float;
    procedure loadMorePages;
    procedure recalculateItemPosition;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    procedure triggerDispose;
    automaticallyLoadPages: Boolean;
    currentItem: JIListViewItem;
    element: JHTMLElement;
    groupDataSource: JIListDataSource{<JT>};
    groupHeaderTapBehavior: JGroupHeaderTapBehavior;
    groupHeaderTemplate: Variant;
    indexOfFirstVisible: Float;
    indexOfLastVisible: Float;
    itemDataSource: JIListDataSource{<JT>};
    itemsDraggable: Boolean;
    itemsReorderable: Boolean;
    itemTemplate: Variant;
    layout: JILayout2;
    footer: JHTMLElement;
    header: JHTMLElement;
    loadingBehavior: String;
    loadingState: String;
    maxDeferredItemCleanup: Float;
    pagesToLoad: Float;
    pagesToLoadThreshold: Float;
    maxLeadingPages: Float;
    maxTrailingPages: Float;
    resetGroupHeader: (header: Variant; element: JHTMLElement);
    resetItem: (item: JT; element: JHTMLElement);
    scrollPosition: Float;
    selection: JISelection{<JT>};
    selectionMode: JSelectionMode;
    swipeBehavior: JWinJS.UI.SwipeBehavior;
    tapBehavior: JTapBehavior;
    zoomableView: JIZoomableView{<JListView{<JT>}>};
    supportedForProcessing: Boolean;
  end;

  JPivot = class external 'Pivot'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onitemanimationend(eventInfo: JEvent);
    procedure onitemanimationstart(eventInfo: JEvent);
    procedure onselectionchanged(eventInfo: JEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    customLeftHeader: JHTMLElement;
    customRightHeader: JHTMLElement;
    items: JBinding.List{<JPivotItem>};
    locked: Boolean;
    selectedIndex: Float;
    selectedItem: JPivotItem;
    supportedForProcessing: Boolean;
    title: String;
  end;

  JPivotItem = class external 'PivotItem'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure dispose;
    contentElement: JHTMLElement;
    element: JHTMLElement;
    header: String;
    isDeclarativeControlContainer: Variant;
    supportedForProcessing: Boolean;
  end;

  JMenu = class external 'Menu'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onafterhide(eventInfo: JEvent);
    procedure onaftershow(eventInfo: JEvent);
    procedure onbeforehide(eventInfo: JEvent);
    procedure onbeforeshow(eventInfo: JEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(eventName: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function getCommandById(id: String): JMenuCommand;
    procedure hide;
    procedure hideCommands(commands: array of Variant); overload;
    procedure hideCommands(commands: array of Variant; immediate: Boolean); overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure show(anchor: JHTMLElement); overload;
    procedure show(anchor: JHTMLElement; placement: String); overload;
    procedure show(anchor: JHTMLElement; placement: String; alignment: String); overload;
    procedure showAt(coordinates:       x: Float;
      y: Float;
    end;);
    procedure showAt(mouseEventObj: JMouseEvent);
    procedure showCommands(commands: array of Variant); overload;
    procedure showCommands(commands: array of Variant; immediate: Boolean); overload;
    procedure showOnlyCommands(commands: array of Variant); overload;
    procedure showOnlyCommands(commands: array of Variant; immediate: Boolean); overload;
    alignment: String;
    anchor: JHTMLElement;
    commands: array of JMenuCommand;
    disabled: Boolean;
    element: JHTMLElement;
    hidden: Boolean;
    placement: String;
    supportedForProcessing: Boolean;
  end;

  JMenuCommand = class external 'MenuCommand'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure dispose;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    disabled: Boolean;
    element: JHTMLElement;
    extraClass: String;
    flyout: JFlyout;
    hidden: Boolean;
    id: String;
    &label: String;
    onclick: JFunction;
    selected: Boolean;
    supportedForProcessing: Boolean;
    &type: String;
  end;

  JNavBar = class external 'NavBar'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onafterclose(eventInfo: JEvent);
    procedure onafteropen(eventInfo: JEvent);
    procedure onbeforeclose(eventInfo: JEvent);
    procedure onbeforeopen(eventInfo: JEvent);
    procedure onchildrenprocessed(eventInfo: JEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure close;
    procedure hideCommands(commands: array of Variant); overload;
    procedure hideCommands(commands: array of Variant; immediate: Boolean); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    procedure open;
    procedure showCommands(commands: array of Variant); overload;
    procedure showCommands(commands: array of Variant; immediate: Boolean); overload;
    procedure showOnlyCommands(commands: array of Variant); overload;
    procedure showOnlyCommands(commands: array of Variant; immediate: Boolean); overload;
    closedDisplayMode: String;
    commands: JAppBarCommand;
    element: JHTMLElement;
    function getCommandById(id: String): JNavBarCommand;
    hidden: Boolean;
    opened: Boolean;
    placement: String;
    isDeclarativeControlContainer: Variant;
    supportedForProcessing: Boolean;
  end;

  JNavBarCommand = class external 'NavBarCommand'
    constructor Create(element: JHTMLElement; options: Variant);
    oninvoked: Variant;
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    icon: String;
    &label: String;
    location: Variant;
    splitButton: Boolean;
    splitOpened: Boolean;
    state: Variant;
    supportedForProcessing: Boolean;
    tooltip: String;
  end;

  JNavBarContainer = class external 'NavBarContainer'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure oninvoked(eventInfo: JCustomEvent);
    procedure onsplittoggle(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    currentIndex: Float;
    data: JWinJS.Binding.List{<JNavBarCommand>};
    element: JHTMLElement;
    fixedSize: Boolean;
    layout: JOrientation;
    maxRows: Float;
    supportedForProcessing: Boolean;
    template: JWinJS.Binding.Template;
  end;

  JRating = class external 'Rating'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure oncancel(eventInfo: JEvent);
    procedure onchange(eventInfo: JCustomEvent);
    procedure onpreviewchange(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    averageRating: Float;
    disabled: Boolean;
    element: JHTMLElement;
    enableClear: Boolean;
    maxRating: Float;
    supportedForProcessing: Boolean;
    tooltipStrings: array of String;
    userRating: Float;
  end;

  JRepeater = class external 'Repeater'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onitemchanged(eventInfo: JCustomEvent);
    procedure onitemchanging(eventInfo: JCustomEvent);
    procedure oniteminserted(eventInfo: JCustomEvent);
    procedure oniteminserting(eventInfo: JCustomEvent);
    procedure onitemmoved(eventInfo: JCustomEvent);
    procedure onitemmoving(eventInfo: JCustomEvent);
    procedure onitemremoved(eventInfo: JCustomEvent);
    procedure onitemremoving(eventInfo: JCustomEvent);
    procedure onitemsloaded(eventInfo: JCustomEvent);
    procedure onitemsreloaded(eventInfo: JCustomEvent);
    procedure onitemsreloading(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function elementFromIndex(index: Float): JHTMLElement;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    data: JWinJS.Binding.List{<Variant>};
    element: JHTMLElement;
    _length: Float;
    isDeclarativeControlContainer: Variant;
    supportedForProcessing: Boolean;
    template: JWinJS.Binding.Template;
  end;

  JSearchBox = class external 'SearchBox'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onquerychanged(eventInfo: JCustomEvent);
    procedure onquerysubmitted(eventInfo: JCustomEvent);
    procedure onresultsuggestionchosen(eventInfo: JCustomEvent);
    procedure onsuggestionsrequested(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    procedure setLocalContentSuggestionSettings(settings: Variant);
    chooseSuggestionOnEnter: Boolean;
    disabled: Boolean;
    element: JHTMLElement;
    focusOnKeyboardInput: Boolean;
    placeholderText: String;
    queryText: String;
    searchHistoryContext: String;
    searchHistoryDisabled: Boolean;
    supportedForProcessing: Boolean;
    function createResultSuggestionImage(url: String): Variant;
  end;

  JSemanticZoom = class external 'SemanticZoom'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onzoomchanged(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    procedure setTimeoutAfterTTFF(callback: JFunction; delay: Float);
    element: JHTMLElement;
    enableButton: Boolean;
    locked: Boolean;
    supportedForProcessing: Boolean;
    zoomedOut: Boolean;
    zoomFactor: Float;
    zoomedInItem: (any: Variant): Variant;
    zoomedOutItem: (any: Variant): Variant;
  end;

  JSettingsFlyout = class external 'SettingsFlyout'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onafterhide(eventInfo: JEvent);
    procedure onaftershow(eventInfo: JEvent);
    procedure onbeforehide(eventInfo: JEvent);
    procedure onbeforeshow(eventInfo: JEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure hide;
    procedure populateSettings(e: JCustomEvent);
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure show;
    procedure show;
    procedure showSettings(id: String; path: Variant);
    supportedForProcessing: Boolean;
    disabled: Boolean;
    element: JHTMLElement;
    hidden: Boolean;
    settingsCommandId: String;
    width: String;
  end;

  JSplitView = class external 'SplitView'
    PanePlacement:       left: String;
      right: String;
      top: String;
      bottom: String;
    end;;
    ClosedDisplayMode:       none: String;
      inline: String;
    end;;
    OpenedDisplayMode:       inline: String;
      overlay: String;
    end;;
    supportedForProcessing: Boolean;
    constructor Create(element: JHTMLElement; options: Variant);
    element: JHTMLElement;
    paneElement: JHTMLElement;
    contentElement: JHTMLElement;
    panePlacement: String;
    closedDisplayMode: String;
    openedDisplayMode: String;
    paneOpened: Boolean;
    procedure openPane;
    procedure closePane;
    procedure dispose;
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure onbeforeopen(eventInfo: JEvent);
    procedure onafteropen(eventInfo: JEvent);
    procedure onbeforeclose(eventInfo: JEvent);
    procedure onafterclose(eventInfo: JEvent);
  end;

  JSplitViewPaneToggle = class external 'SplitViewPaneToggle'
    constructor Create(element: JHTMLButtonElement; options: Variant);
    element: JHTMLButtonElement;
    splitView: JHTMLElement;
    procedure dispose;
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure oninvoked(eventInfo: JEvent);
    supportedForProcessing: Boolean;
  end;

  JSplitViewCommand = class external 'SplitViewCommand'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure oninvoked(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    icon: String;
    &label: String;
    supportedForProcessing: Boolean;
    tooltip: String;
  end;

  JStorageDataSource = class external 'StorageDataSource'
    constructor Create(query: Variant; options: Variant);
    function loadThumbnail(item: JIItem{<JT>}; image: JHTMLImageElement): JPromise{<Variant>};
    procedure addEventListener(&type: String; eventHandler: JFunction); overload;
    procedure addEventListener(&type: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; details: Variant): Boolean;
    procedure removeEventListener(&type: String; eventHandler: JFunction); overload;
    procedure removeEventListener(&type: String; eventHandler: JFunction; useCapture: Variant); overload;
    supportedForProcessing: Boolean;
  end;

  JTabContainer = class external 'TabContainer'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure dispose;
    childFocus: JHTMLElement;
    supportedForProcessing: Boolean;
    tabIndex: Float;
  end;

  JTimePicker = class external 'TimePicker'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onchange(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; capture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    function getInformation(clock: Variant; minuteIncrement: Variant): Variant; overload;
    function getInformation(clock: Variant; minuteIncrement: Variant; timerPatterns: Variant): Variant; overload;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Variant); overload;
    clock: String;
    current: JDate;
    disabled: Boolean;
    element: JHTMLElement;
    hourPattern: String;
    minuteIncrement: Float;
    minutePattern: String;
    periodPattern: String;
    supportedForProcessing: Boolean;
  end;

  JToggleSwitch = class external 'ToggleSwitch'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onchange(eventInfo: JEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    checked: Boolean;
    disabled: Boolean;
    element: JHTMLElement;
    labelOff: String;
    labelOn: String;
    supportedForProcessing: Boolean;
    title: String;
  end;

  JToolBar = class external 'ToolBar'
    ClosedDisplayMode:       compact: String;
      full: String;
    end;;
    supportedForProcessing: Boolean;
    element: JHTMLElement;
    data: JWinJS.Binding.List{<JICommand>};
    closedDisplayMode: String;
    constructor Create(element: JHTMLElement; options: Variant);
    procedure dispose;
    procedure forceLayout;
    procedure open;
    procedure close;
    function getCommandById(id: String): JICommand;
    procedure showOnlyCommands(commands: JArray{<Variant {String or JICommand}>});
    opened: Boolean;
    onbeforeopen: (eventInfo: JCustomEvent);
    onafteropen: (eventInfo: JCustomEvent);
    onbeforeclose: (eventInfo: JCustomEvent);
    onafterclose: (eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure removeEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure removeEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(eventName: String; eventProperties: Variant): Boolean;
  end;

  JTooltip = class external 'Tooltip'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure onbeforeclose(eventInfo: JCustomEvent);
    procedure onbeforeopen(eventInfo: JCustomEvent);
    procedure onclosed(eventInfo: JCustomEvent);
    procedure onopened(eventInfo: JCustomEvent);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    procedure close;
    procedure dispose;
    procedure open; overload;
    procedure open(&type: String); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    contentElement: JHTMLElement;
    element: JHTMLElement;
    extraClass: String;
    infotip: Boolean;
    innerHTML: String;
    placement: String;
    supportedForProcessing: Boolean;
  end;

  JViewBox = class external 'ViewBox'
    constructor Create(element: JHTMLElement; options: Variant);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(eventName: String; eventProperties: Variant): Boolean;
    procedure dispose;
    procedure forceLayout;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    element: JHTMLElement;
    supportedForProcessing: Boolean;
  end;

  JVirtualizedDataSource = class external 'VirtualizedDataSource'
    constructor Create(listDataAdapter: JIListDataAdapter{<JT>}; options: Variant);
    procedure addEventListener(eventName: String; eventHandler: JFunction); overload;
    procedure addEventListener(eventName: String; eventHandler: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure removeEventListener(eventName: String; eventCallback: JFunction); overload;
    procedure removeEventListener(eventName: String; eventCallback: JFunction; useCapture: Boolean); overload;
    supportedForProcessing: Boolean;
  end;

  JICommand = class external
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    procedure dispose;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    disabled: Boolean;
    element: JHTMLElement;
    extraClass: String;
    firstElementFocus: JHTMLElement;
    flyout: JFlyout;
    hidden: Boolean;
    icon: String;
    id: String;
    &label: String;
    lastElementFocus: JHTMLElement;
    onclick: JFunction;
    section: String;
    selected: Boolean;
    tooltip: String;
    &type: String;
    priority: Float;
  end;

  JIFetchResult{<T>} = class external
    absoluteIndex: Float;
    atEnd: Boolean;
    atStart: Boolean;
    items: array of JT;
    offset: Float;
    totalCount: Float;
  end;

  JIItem{<T>} = class external
    data: JT;
    groupKey: String;
    handle: String;
    index: Float;
    key: String;
  end;

  JIItemPromise{<T>} = class external(JIPromise {JT} )
    procedure release;
    function retain: JIItemPromise{<JT>};
    handle: String;
    index: Float;
  end;

  JILayout2 = class external
    procedure dragLeave;
    procedure dragOver(x: Float; y: Float; dragInfo: Float);
    procedure executeAnimations;
    function getAdjacent(currentItem: Variant; pressedKey: JWinJS.Utilities.Key): Variant;
    function hitTest(x: Float; y: Float): Variant;
    procedure initialize(site: JILayoutSite2; groupsEnabled: Boolean);
    procedure itemsFromRange(firstPixel: Float; lastPixel: Float);
    function layout(tree: Variant; changedRange: Variant; modifiedItems: Variant; modifiedGroups: Variant): Variant;
    procedure setupAnimations;
    procedure uninitialize;
    orientation: Variant;
  end;

  JILayoutSite = class external
    animationsDisabled: Boolean;
    itemSurface: JHTMLElement;
    rtl: Boolean;
    scrollbarPos: Float;
    surface: JHTMLElement;
    viewport: JHTMLElement;
    viewportSize: Variant;
  end;

  JILayoutSite2 = class external
    groupCount: Float;
    itemCount: JPromise{<Float>};
    realizedRange: Variant;
    tree: Variant;
    visibleRange: Variant;
  end;

  JIListBinding{<T>} = class external
    function current: JIItemPromise{<JIItem{<JT>}>};
    function first: JIItemPromise{<JIItem{<JT>}>};
    function fromDescription(description: String): JIItemPromise{<JIItem{<JT>}>};
    function fromIndex(index: Float): JIItemPromise{<JIItem{<JT>}>};
    function fromKey(key: String): JIItemPromise{<JIItem{<JT>}>}; overload;
    function fromKey(key: String; hints: Variant): JIItemPromise{<JIItem{<JT>}>}; overload;
    function jumpToItem(item: JIItem{<JT>}): JIItemPromise{<JIItem{<JT>}>};
    function last: JIItemPromise{<JIItem{<JT>}>};
    function next: JIItemPromise{<JIItem{<JT>}>};
    function previous: JIItemPromise{<JIItem{<JT>}>};
    procedure release;
    procedure releaseItem(item: JIItem{<JT>});
  end;

  JIListDataAdapter{<T>} = class external
    function change(key: String; newData: JT; indexHint: Float): JPromise{<Variant>};
    function getCount: JPromise{<Float>};
    function insertAfter(key: String; data: JT; previousKey: String; previousIndexHint: Float): JPromise{<JIItem{<JT>}>};
    function insertAtEnd(key: String; data: JT): JPromise{<JIItem{<JT>}>};
    function insertAtStart(key: String; data: JT): JPromise{<JIItem{<JT>}>};
    function insertBefore(key: String; data: JT; nextKey: String; nextIndexHint: Float): JPromise{<JIItem{<JT>}>};
    function itemsFromDescription(description: String; countBefore: Float; countAfter: Float): JPromise{<JIFetchResult{<JT>}>};
    function itemsFromEnd(count: Float): JPromise{<JIFetchResult{<JT>}>};
    function itemsFromIndex(index: Float; countBefore: Float; countAfter: Float): JPromise{<JIFetchResult{<JT>}>};
    function itemsFromKey(key: String; countBefore: Float; countAfter: Float): JPromise{<JIFetchResult{<JT>}>};
    function itemsFromStart(count: Float): JPromise{<JIFetchResult{<JT>}>};
    function itemSignature(item: JIItem{<JT>}): String;
    function moveAfter(key: String; previousKey: Variant; indexHint: String; previousIndexHint: Float): JPromise{<JIItem{<JT>}>};
    function moveBefore(key: String; nextKey: Variant; indexHint: String; nextIndexHint: Float): JPromise{<JIItem{<JT>}>};
    function moveToEnd(key: String; indexHint: Float): JPromise{<JIItem{<JT>}>};
    function moveToStart(key: String; indexHint: Float): JPromise{<JIItem{<JT>}>};
    function remove(key: String; data: JT; indexHint: Float): JPromise{<Variant>};
    procedure setNotificationHandler(notificationHandler: JIListDataNotificationHandler{<JT>});
    compareByIdentity: Boolean;
  end;

  JIListDataNotificationHandler{<T>} = class external
    procedure beginNotifications;
    procedure changed(item: JIItem{<JT>});
    procedure endNotifications;
    procedure inserted(newItem: JIItem{<JT>}; previousKey: String; nextKey: String); overload;
    procedure inserted(newItem: JIItem{<JT>}; previousKey: String; nextKey: String; index: Float); overload;
    function invalidateAll: JPromise{<Variant>};
    procedure moved(item: JIItem{<JT>}; previousKey: String; nextKey: String); overload;
    procedure moved(item: JIItem{<JT>}; previousKey: String; nextKey: String; oldIndex: Float); overload;
    procedure moved(item: JIItem{<JT>}; previousKey: String; nextKey: String; oldIndex: Float; newIndex: Float); overload;
    procedure reload;
    procedure removed(key: String); overload;
    procedure removed(key: String; index: Float); overload;
  end;

  JIListDataSource{<T>} = class external
    procedure statuschanged(eventInfo: JCustomEvent);
    procedure beginEdits;
    function change(key: String; newData: JT): JPromise{<JIItem{<JT>}>};
    function createListBinding: JIListBinding{<JT>}; overload;
    function createListBinding(notificationHandler: JIListNotificationHandler{<JT>}): JIListBinding{<JT>}; overload;
    procedure endEdits;
    function getCount: JPromise{<Float>};
    function insertAfter(key: String; data: JT; previousKey: String): JPromise{<JIItem{<JT>}>};
    function insertAtEnd(key: String; data: JT): JPromise{<JIItem{<JT>}>};
    function insertAtStart(key: String; data: JT): JPromise{<JIItem{<JT>}>};
    function insertBefore(key: String; data: JT; nextKey: String): JPromise{<JIItem{<JT>}>};
    function invalidateAll: JPromise{<Variant>};
    function itemFromDescription(description: Variant): JPromise{<JIItem{<JT>}>};
    function itemFromIndex(index: Float): JPromise{<JIItem{<JT>}>};
    function itemFromKey(key: String): JPromise{<JIItem{<JT>}>}; overload;
    function itemFromKey(key: String; description: Variant): JPromise{<JIItem{<JT>}>}; overload;
    function moveAfter(key: String; previousKey: String): JPromise{<JIItem{<JT>}>};
    function moveBefore(key: String; nextKey: String): JPromise{<JIItem{<JT>}>};
    function moveToEnd(key: String): JPromise{<JIItem{<JT>}>};
    function moveToStart(key: String): JPromise{<JIItem{<JT>}>};
    function remove(key: String): JPromise{<JIItem{<JT>}>};
  end;

  JIListNotificationHandler{<T>} = class external
    procedure beginNotifications;
    procedure changed(newItem: JIItem{<JT>}; oldItem: JIItem{<JT>});
    procedure countChanged(newCount: Float; oldCount: Float);
    procedure endNotifications;
    procedure indexChanged(handle: String; newIndex: Float; oldIndex: Float);
    procedure inserted(itemPromise: JIItemPromise{<JT>}; previousHandle: String; nextHandle: String);
    procedure itemAvailable(item: JIItem{<JT>});
    procedure moved(item: JIItemPromise{<JT>}; previousHandle: String; nextHandle: String);
    procedure removed(handle: String; mirage: Boolean);
  end;

  JIListViewItem = class external
    index: Float; // nullable
    key: String; // nullable
    hasFocus: Boolean; // nullable
    showFocus: Boolean; // nullable
    &type: JWinJS.UI.ObjectType; // nullable
  end;

  JISelection{<T>} = class external
    function add(items: Variant): JPromise{<Variant>};
    function clear: JPromise{<Variant>};
    function count: Float;
    function getIndices: array of Float;
    function getItems: JPromise{<array of JIItem{<JT>}>};
    function getRanges: array of JISelectionRange;
    function isEverything: Boolean;
    function remove(items: Variant): JPromise{<Variant>};
    procedure selectAll;
    function set(items: Variant): JPromise{<Variant>};
  end;

  JISelectionRange = class external
    firstIndex: Float;
    firstKey: Variant;
    lastIndex: Float;
    lastKey: Variant;
  end;

  JIZoomableView{<T>} = class external
    procedure beginZoom;
    procedure configureForZoom(isZoomedOut: Boolean; isCurrentView: Boolean; triggerZoom: JFunction; prefetchedPages: Float);
    procedure endZoom(isCurrentView: Boolean);
    function getCurrentItem: JPromise{<      item: JT;
      position: JUtilities.IPosition;
    end;>};
    function getPanAxis: String;
    procedure handlePointer(pointerId: String);
    procedure positionItem(item: JT; position: JUtilities.IPosition);
    procedure setCurrentItem(x: Float; y: Float);
  end;

  JContentDialogHideInfo = class external
    result: String;
  end;

  JContentDialogHideEvent = class external(JEvent)
    detail: JContentDialogHideInfo;
  end;

  JMediaCommand = class external
    audioTracks: String;
    cast: String;
    chapterSkipBack: String;
    chapterSkipForward: String;
    closedCaptions: String;
    fastForward: String;
    goToLive: String;
    nextTrack: String;
    pause: String;
    play: String;
    playbackRate: String;
    playFromBeginning: String;
    previousTrack: String;
    rewind: String;
    seek: String;
    stop: String;
    timeSkipBack: String;
    timeSkipForward: String;
    volume: String;
    zoom: String;
  end;

  JMarkerType = class external
    advertisement: String;
    chapter: String;
    custom: String;
  end;

  JIListGroupDataSource{<T>} = class external(JIListDataSource {JT} )
    groups: JIListDataSource{<JT>};
  end;

//DOMEventMixin

procedure addEventListener(&type: String; listener: JFunction); overload;
procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
procedure removeEventListener(&type: String; listener: JFunction); overload;
procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;

function computeDataSourceGroups(listDataSource: JIListDataSource{<JT>}; groupKey: JFunction; groupData: JFunction): JIListGroupDataSource{<JT>}; overload;
function computeDataSourceGroups(listDataSource: JIListDataSource{<JT>}; groupKey: JFunction; groupData: JFunction; options: Variant): JIListGroupDataSource{<JT>}; overload;
procedure disableAnimations;
procedure enableAnimations;
function eventHandler(handler: Variant): Variant;
function executeAnimation(element: JHTMLElement; animation: Variant): JPromise{<Variant>};
function executeTransition(element: JHTMLElement; transition: Variant): JPromise{<Variant>};
function getItemsFromRanges(dataSource: JIListDataSource{<JU>}; ranges: array of JISelectionRange): JPromise{<JIItem{<JU>}>};
function isAnimationEnabled: Boolean;
function optionsParser(value: String): Variant; overload;
function optionsParser(value: String; context: Variant): Variant; overload;
function optionsParser(value: String; context: Variant; functionContext: Variant): Variant; overload;
function processAll: JPromise{<Variant>}; overload;
function processAll(rootElement: JElement): JPromise{<Variant>}; overload;
function processAll(rootElement: JElement; skipRoot: Boolean): JPromise{<Variant>}; overload;
function process(element: JElement): JPromise{<Variant>};
function scopedSelect(selector: String; element: JHTMLElement): JHTMLElement;
procedure setOptions(control: Variant); overload;
procedure setOptions(control: Variant; options: Variant); overload;
function simpleItemRenderer(fn: JFunction): JFunction;

//WinJS.UI.XYFocus

type
  JXYFocusOptions = class external
    focusRoot: JHTMLElement; // nullable
    historyRect: JIRect; // nullable
    referenceElement: JHTMLElement; // nullable
    referenceRect: JIRect; // nullable
  end;

  JIRect = class external
    left: Float;
    right: Float; // nullable
    top: Float;
    bottom: Float; // nullable
    height: Float;
    width: Float;
  end;

  JXYFocusEvent = class external(JCustomEvent)
    detail:       nextFocusElement: JHTMLElement;
      keyCode: Float;
      previousFocusElement: JHTMLElement;
    end;;
  end;

procedure addEventListener(&type: String; handler: JEventListener);
function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
procedure removeEventListener(&type: String; handler: JEventListener);
function findNextFocusElement(direction: String): JHTMLElement; overload;
function findNextFocusElement(direction: String; options: JXYFocusOptions): JHTMLElement; overload;
function findNextFocusElement(direction: Jleft): JHTMLElement; overload;
function findNextFocusElement(direction: Jleft; options: JXYFocusOptions): JHTMLElement; overload;
function findNextFocusElement(direction: Jright): JHTMLElement; overload;
function findNextFocusElement(direction: Jright; options: JXYFocusOptions): JHTMLElement; overload;
function findNextFocusElement(direction: Jup): JHTMLElement; overload;
function findNextFocusElement(direction: Jup; options: JXYFocusOptions): JHTMLElement; overload;
function findNextFocusElement(direction: Jdown): JHTMLElement; overload;
function findNextFocusElement(direction: Jdown; options: JXYFocusOptions): JHTMLElement; overload;
function moveFocus(direction: String): JHTMLElement; overload;
function moveFocus(direction: String; options: JXYFocusOptions): JHTMLElement; overload;
function moveFocus(direction: Jleft): JHTMLElement; overload;
function moveFocus(direction: Jleft; options: JXYFocusOptions): JHTMLElement; overload;
function moveFocus(direction: Jright): JHTMLElement; overload;
function moveFocus(direction: Jright; options: JXYFocusOptions): JHTMLElement; overload;
function moveFocus(direction: Jup): JHTMLElement; overload;
function moveFocus(direction: Jup; options: JXYFocusOptions): JHTMLElement; overload;
function moveFocus(direction: Jdown): JHTMLElement; overload;
function moveFocus(direction: Jdown; options: JXYFocusOptions): JHTMLElement; overload;
procedure onfocuschanged(eventInfo: JCustomEvent);
procedure onfocuschanging(eventInfo: JCustomEvent);

var
  keyCodeMap:     accept: JArray{<Float>};
    cancel: JArray{<Float>};
    down: JArray{<Float>};
    left: JArray{<Float>};
    right: JArray{<Float>};
    up: JArray{<Float>};
  end;;
  focusRoot: JHTMLElement;

//WinJS.UI.Fragments

function cache(href: String): JPromise{<Variant>};
procedure clearCache(href: String);
procedure clearCache(href: JHTMLElement);
function render(href: String): JPromise{<JHTMLElement>}; overload;
function render(href: String; element: JHTMLElement): JPromise{<JHTMLElement>}; overload;
function renderCopy(href: String): JPromise{<JHTMLElement>}; overload;
function renderCopy(href: String; target: JHTMLElement): JPromise{<JHTMLElement>}; overload;
function renderCopy(href: JHTMLElement): JPromise{<JHTMLElement>}; overload;
function renderCopy(href: JHTMLElement; target: JHTMLElement): JPromise{<JHTMLElement>}; overload;

//WinJS.UI.Pages

type
  JIPageControlMembers = class external
    function error(err: Variant): Variant;
    function init(element: JHTMLElement; options: Variant): Variant;
    function load(uri: String): Variant;
    function processed(element: JHTMLElement; options: Variant): Variant;
    function ready(element: JHTMLElement; options: Variant): Variant;
    procedure render(element: JHTMLElement; options: Variant; loadResult: JPromise{<Variant>});
  end;

function define(uri: String; members: JIPageControlMembers): (element: JHTMLElement; options: Variant; complete: (page: Variant); parentedPromise: JPromise{<Variant>});
function get(uri: String): (element: JHTMLElement; options: Variant; complete: (page: Variant); parentedPromise: JPromise{<Variant>});
function render(uri: String): JPromise{<Variant>}; overload;
function render(uri: String; element: JHTMLElement): JPromise{<Variant>}; overload;
function render(uri: String; element: JHTMLElement; options: Variant): JPromise{<Variant>}; overload;
function render(uri: String; element: JHTMLElement; options: Variant; parentedPromise: JPromise{<Variant>}): JPromise{<Variant>}; overload;

//WinJS.UI.TrackTabBehavior

procedure attach(element: JHTMLElement; tabIndex: Float);
procedure detach(element: JHTMLElement);

//WinJS.Utilities

type
  JQueryCollection = class external 'QueryCollection'
    function addClass(name: String): JQueryCollection{<JT>};
    function clearStyle(name: String): JQueryCollection{<JT>};
    function control(ctor: Variant): JQueryCollection{<JT>}; overload;
    function control(ctor: Variant; options: Variant): JQueryCollection{<JT>}; overload;
    function forEach(callbackFn: (value: JT; index: Float; array: array of JT)): JQueryCollection{<JT>}; overload;
    function forEach(callbackFn: (value: JT; index: Float; array: array of JT); thisArg: Variant): JQueryCollection{<JT>}; overload;
    function get(index: Float): JT;
    function getAttribute(name: String): Variant;
    function hasClass(name: String): Boolean;
    procedure include(items: JT);
    procedure include(items: array of JT);
    procedure include(items: JHTMLCollection);
    procedure listen(eventType: String; listener: JFunction); overload;
    procedure listen(eventType: String; listener: JFunction; capture: Boolean); overload;
    function query(query: Variant): JQueryCollection{<JT>};
    function removeClass(name: String): JQueryCollection{<JT>};
    function removeEventListener(eventType: String; listener: JFunction): JQueryCollection{<JT>}; overload;
    function removeEventListener(eventType: String; listener: JFunction; capture: Boolean): JQueryCollection{<JT>}; overload;
    function setAttribute(name: String; value: Variant): JQueryCollection{<JT>};
    function setStyle(name: String; value: Variant): JQueryCollection{<JT>};
    function template(templateElement: JHTMLElement; data: Variant): JQueryCollection{<JT>}; overload;
    function template(templateElement: JHTMLElement; data: Variant; renderDonePromiseCallback: JFunction): JQueryCollection{<JT>}; overload;
    function toggleClass(name: String): JQueryCollection{<JT>};
    supportedForProcessing: Boolean;
    function concat(items: array of JU): array of JT;
    function concat(items: array of JT): array of JT;
    function join: String; overload;
    function join(separator: String): String; overload;
    function pop: JT;
    function push(items: array of JT): Float;
    function reverse: array of JT;
    function shift: JT;
    function slice: array of JT; overload;
    function slice(start: Float): array of JT; overload;
    function slice(start: Float; &end: Float): array of JT; overload;
    function sort: array of JT; overload;
    function sort(compareFn: (a: JT; b: JT): Float): array of JT; overload;
    function splice(start: Float): array of JT;
    function splice(start: Float; deleteCount: Float; items: array of JT): array of JT;
    function unshift(items: array of JT): Float;
    function indexOf(searchElement: JT): Float; overload;
    function indexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function lastIndexOf(searchElement: JT): Float; overload;
    function lastIndexOf(searchElement: JT; fromIndex: Float): Float; overload;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean; overload;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean; overload;
    function map(callbackfn: (value: JT; index: Float; array: array of JT): JU): array of JU; overload;
    function map(callbackfn: (value: JT; index: Float; array: array of JT): JU; thisArg: Variant): array of JU; overload;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): array of JT; overload;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): array of JT; overload;
    function reduce(callbackfn: (previousValue: JT; currentValue: JT; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduce(callbackfn: (previousValue: JT; currentValue: JT; currentIndex: Float; array: array of JT): JT; initialValue: JT): JT; overload;
    function reduce(callbackfn: (previousValue: JU; currentValue: JT; currentIndex: Float; array: array of JT): JU; initialValue: JU): JU;
    function reduceRight(callbackfn: (previousValue: JT; currentValue: JT; currentIndex: Float; array: array of JT): JT): JT; overload;
    function reduceRight(callbackfn: (previousValue: JT; currentValue: JT; currentIndex: Float; array: array of JT): JT; initialValue: JT): JT; overload;
    function reduceRight(callbackfn: (previousValue: JU; currentValue: JT; currentIndex: Float; array: array of JT): JU; initialValue: JU): JU;
    _length: Float;
    // property Item[n: Integer]: JT;
;
  end;

  JILogOptions = class external
    &type: String; // nullable
    action: (message: String; tags: String; &type: String); // nullable
    excludeTags: String; // nullable
    tags: String; // nullable
  end;

  JIPosition = class external
    left: Float;
    top: Float;
    width: Float;
    height: Float;
  end;

function addClass(e: JT; name: String): JT;
function children(element: JHTMLElement): JQueryCollection{<JHTMLElement>};
function convertToPixels(element: JHTMLElement; value: String): Float;
function createEventProperties(events: array of String): Variant;
function data(element: JHTMLElement): Variant;
procedure disposeSubTree(element: JHTMLElement);
function empty(element: JT): JT;
function eventWithinElement(element: JHTMLElement; event: JEvent): Boolean;
function formatLog(message: String; tag: String; &type: String): String;
function getContentHeight(element: JHTMLElement): Float;
function getContentWidth(element: JHTMLElement): Float;
function getMember(name: String): Variant; overload;
function getMember(name: String; root: Variant): Variant; overload;
function getPosition(element: JHTMLElement): JIPosition;
function getRelativeLeft: Float; overload;
function getRelativeLeft(element: JHTMLElement): Float; overload;
function getRelativeLeft(element: JHTMLElement; parent: JHTMLElement): Float; overload;
function getRelativeTop: Float; overload;
function getRelativeTop(element: JHTMLElement): Float; overload;
function getRelativeTop(element: JHTMLElement; parent: JHTMLElement): Float; overload;
function getScrollPosition(element: JHTMLElement):   scrollLeft: Float;
  scrollTop: Float;
end;;
function getTabIndex(element: JHTMLElement): Float;
function getTotalHeight(element: JHTMLElement): Float;
function getTotalWidth(element: JHTMLElement): Float;
function hasClass(e: JHTMLElement; name: String): Boolean;
function id(id: String): JQueryCollection{<JHTMLElement>};
procedure insertAdjacentHTML(element: JHTMLElement; position: String; text: String);
procedure insertAdjacentHTMLUnsafe(element: JHTMLElement; position: String; text: String);
procedure markDisposable(element: JHTMLElement); overload;
procedure markDisposable(element: JHTMLElement; disposeImpl: JFunction); overload;
function markSupportedForProcessing(func: JU): JU;
function query(query: Variant): JQueryCollection{<JHTMLElement>}; overload;
function query(query: Variant; element: JHTMLElement): JQueryCollection{<JHTMLElement>}; overload;
function ready: JPromise{<Variant>}; overload;
function ready(callback: JFunction): JPromise{<Variant>}; overload;
function ready(callback: JFunction; async: Boolean): JPromise{<Variant>}; overload;
function removeClass(e: JT; name: String): JT;
function requireSupportedForProcessing(value: JT): JT;
procedure setInnerHTML(element: JHTMLElement; text: String);
procedure setInnerHTMLUnsafe(element: JHTMLElement; text: String);
procedure setOuterHTML(element: JHTMLElement; text: String);
procedure setOuterHTMLUnsafe(element: JHTMLElement; text: String);
procedure setScrollPosition(element: JHTMLElement; position:   scrollLeft: Float;
  scrollTop: Float;
end;);
procedure startLog; overload;
procedure startLog(options: JILogOptions); overload;
procedure startLog; overload;
procedure startLog(tags: String); overload;
procedure stopLog;
function toggleClass(e: JT; name: String): JT;

var
  eventMixin:     procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
    function dispatchEvent(&type: String; eventProperties: Variant): Boolean;
    procedure removeEventListener(&type: String; listener: JFunction); overload;
    procedure removeEventListener(&type: String; listener: JFunction; useCapture: Boolean); overload;
  end;;
  hasWinRT: Boolean;
  strictProcessing: Boolean;

//WinJS.Utilities.Scheduler

type
  JIJob = class external
    procedure cancel;
    procedure pause;
    procedure resume;
    completed: Boolean;
    id: Float;
    name: String;
    owner: JIOwnerToken;
    priority: JPriority;
  end;

  JIJobInfo = class external
    procedure setPromise(promise: JPromise{<Variant>});
    procedure setWork(work: JFunction);
    job: JIJob;
    shouldYield: Boolean;
  end;

  JIOwnerToken = class external
    procedure cancelAll;
  end;

function createOwnerToken: JIOwnerToken;
function execHigh(callback: : JU): JU;
function retrieveState: String;
function requestDrain: JPromise{<Variant>}; overload;
function requestDrain(priority: JPriority): JPromise{<Variant>}; overload;
function requestDrain(priority: JPriority; name: String): JPromise{<Variant>}; overload;
function schedule(work: (jobInfo: JIJobInfo): Variant): JIJob; overload;
function schedule(work: (jobInfo: JIJobInfo): Variant; priority: JPriority): JIJob; overload;
function schedule(work: (jobInfo: JIJobInfo): Variant; priority: JPriority; thisArg: Variant): JIJob; overload;
function schedule(work: (jobInfo: JIJobInfo): Variant; priority: JPriority; thisArg: Variant; name: String): JIJob; overload;
function schedulePromiseAboveNormal: JPromise{<JU>}; overload;
function schedulePromiseAboveNormal(promiseValue: JU): JPromise{<JU>}; overload;
function schedulePromiseAboveNormal(promiseValue: JU; jobName: String): JPromise{<JU>}; overload;
function schedulePromiseBelowNormal: JPromise{<JU>}; overload;
function schedulePromiseBelowNormal(promiseValue: JU): JPromise{<JU>}; overload;
function schedulePromiseBelowNormal(promiseValue: JU; jobName: String): JPromise{<JU>}; overload;
function schedulePromiseHigh: JPromise{<JU>}; overload;
function schedulePromiseHigh(promiseValue: JU): JPromise{<JU>}; overload;
function schedulePromiseHigh(promiseValue: JU; jobName: String): JPromise{<JU>}; overload;
function schedulePromiseIdle: JPromise{<JU>}; overload;
function schedulePromiseIdle(promiseValue: JU): JPromise{<JU>}; overload;
function schedulePromiseIdle(promiseValue: JU; jobName: String): JPromise{<JU>}; overload;
function schedulePromiseNormal: JPromise{<JU>}; overload;
function schedulePromiseNormal(promiseValue: JU): JPromise{<JU>}; overload;
function schedulePromiseNormal(promiseValue: JU; jobName: String): JPromise{<JU>}; overload;

var
  currentPriority: JPriority;

//'winjs'

