unit ExtJS;

interface

//Ext

type
  JAbstractComponent = class external 'AbstractComponent'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure cancelLayout; overload;
    procedure cancelLayout(comp: JExt.IComponent); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure flushLayouts;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    procedure resumeLayouts; overload;
    procedure resumeLayouts(flush: Boolean); overload;
    procedure suspendLayouts;
    procedure updateLayout; overload;
    procedure updateLayout(comp: JExt.IComponent); overload;
    procedure updateLayout(comp: JExt.IComponent; defer: Boolean); overload;
  end;

  JIAbstractComponent = class external(JExt.IBase, JExt.util.IPositionable, JExt.util.IObservable, JExt.util.IAnimate, JExt.util.IElementContainer, JExt.util.IRenderable, JExt.state.IStateful)
    autoEl: Variant; // nullable
    autoLoad: Variant; // nullable
    autoRender: Variant; // nullable
    autoShow: Boolean; // nullable
    baseCls: String; // nullable
    border: Variant; // nullable
    childEls: array of Variant; // nullable
    cls: String; // nullable
    componentCls: String; // nullable
    componentLayout: Variant; // nullable
    contentEl: String; // nullable
    data: Variant; // nullable
    disabled: Boolean; // nullable
    disabledCls: String; // nullable
    draggable: Boolean; // nullable
    floating: Boolean; // nullable
    frame: Boolean; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hideMode: String; // nullable
    html: Variant; // nullable
    id: String; // nullable
    itemId: String; // nullable
    loader: Variant; // nullable
    margin: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    overCls: String; // nullable
    padding: Variant; // nullable
    plugins: Variant; // nullable
    renderData: Variant; // nullable
    renderSelectors: Variant; // nullable
    renderTo: Variant; // nullable
    renderTpl: Variant; // nullable
    rtl: Boolean; // nullable
    shrinkWrap: Variant; // nullable
    style: Variant; // nullable
    tpl: Variant; // nullable
    tplWriteMode: String; // nullable
    ui: String; // nullable
    width: Float; // nullable
    xtype: JExt.enums.IWidget; // nullable
    _isLayoutRoot: Boolean; // nullable
    contentPaddingProperty: String; // nullable
    frameSize: Variant; // nullable
    isComponent: Boolean; // nullable
    maskOnDisable: Boolean; // nullable
    ownerCt: JExt.IContainer; // nullable
    rendered: Boolean; // nullable
    procedure addChildEls;
    function addClass: JExt.IComponent; overload;
    function addClass(cls: Variant): JExt.IComponent; overload;
    function addCls: JExt.IComponent; overload;
    function addCls(cls: Variant): JExt.IComponent; overload;
    procedure addClsWithUI; overload;
    procedure addClsWithUI(classes: Variant); overload;
    procedure addClsWithUI(classes: Variant; skip: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(element: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addPropertyToState: Boolean; overload;
    function addPropertyToState(state: Variant): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String; value: String): Boolean; overload;
    procedure addStateEvents; overload;
    procedure addStateEvents(events: Variant); overload;
    procedure addUIClsToElement; overload;
    procedure addUIClsToElement(ui: String); overload;
    procedure afterComponentLayout; overload;
    procedure afterComponentLayout(width: Float); overload;
    procedure afterComponentLayout(width: Float; height: Float); overload;
    procedure afterComponentLayout(width: Float; height: Float; oldWidth: Variant); overload;
    procedure afterComponentLayout(width: Float; height: Float; oldWidth: Variant; oldHeight: Variant); overload;
    procedure afterRender;
    procedure afterSetPosition; overload;
    procedure afterSetPosition(x: Float); overload;
    procedure afterSetPosition(x: Float; y: Float); overload;
    function alignTo: JExt.util.IPositionable; overload;
    function alignTo(element: Variant): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo: JExt.util.IPositionable; overload;
    function anchorTo(element: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant; callback: Variant): JExt.util.IPositionable; overload;
    animate: Variant; // nullable
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure beforeBlur; overload;
    procedure beforeBlur(e: JExt.IEventObject); overload;
    procedure beforeComponentLayout; overload;
    procedure beforeComponentLayout(adjWidth: Float); overload;
    procedure beforeComponentLayout(adjWidth: Float; adjHeight: Float); overload;
    procedure beforeDestroy;
    procedure beforeFocus; overload;
    procedure beforeFocus(e: JExt.IEventObject); overload;
    procedure beforeLayout;
    function calculateConstrainedPosition: array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean; proposedSize: array of Float): array of Float; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure destroy;
    procedure disable; overload;
    procedure disable(silent: Boolean); overload;
    procedure doAutoRender;
    function doComponentLayout: JExt.container.IContainer;
    procedure enable; overload;
    procedure enable(silent: Boolean); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure ensureAttachedToBody; overload;
    procedure ensureAttachedToBody(runLayout: Boolean); overload;
    function findPlugin: JExt.IAbstractPlugin; overload;
    function findPlugin(ptype: String): JExt.IAbstractPlugin; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    procedure forceComponentLayout;
    function getActiveAnimation: Variant;
    function getAlignToXY: array of Float; overload;
    function getAlignToXY(element: Variant): array of Float; overload;
    function getAlignToXY(element: Variant; position: String): array of Float; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Float): array of Float; overload;
    function getAnchorXY: array of Float; overload;
    function getAnchorXY(anchor: String): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Float; overload;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getBubbleTarget: JExt.container.IContainer;
    function getConstrainVector: Variant; overload;
    function getConstrainVector(constrainTo: Variant): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float; proposedSize: array of Float): Variant; overload;
    function getEl: JExt.dom.IElement;
    function getHeight: Float;
    function getId: String;
    function getInsertPosition: JHTMLElement; overload;
    function getInsertPosition(position: Variant): JHTMLElement; overload;
    function getItemId: String;
    function getLoader: JExt.IComponentLoader;
    function getLocalX: Float;
    function getLocalXY: array of Float;
    function getLocalY: Float;
    function getOffsetsTo: array of Float; overload;
    function getOffsetsTo(offsetsTo: Variant): array of Float; overload;
    function getPlugin: JExt.IAbstractPlugin; overload;
    function getPlugin(pluginId: String): JExt.IAbstractPlugin; overload;
    function getRegion: JExt.util.IRegion;
    function getSize: Variant;
    function getSizeModel: Variant; overload;
    function getSizeModel(ownerCtSizeModel: Variant): Variant; overload;
    function getState: Variant;
    function getViewRegion: JExt.util.IRegion;
    function getWidth: Float;
    function getX: Float;
    function getXTypes: String;
    function getXY: array of Float;
    function getY: Float;
    function hasActiveFx: Variant;
    function hasCls: Boolean; overload;
    function hasCls(className: String): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hasUICls; overload;
    procedure hasUICls(cls: String); overload;
    procedure initEvents;
    function initRenderData: Variant;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    function isDescendantOf: Boolean; overload;
    function isDescendantOf(container: JExt.IContainer): Boolean; overload;
    function isDisabled: Boolean;
    function isDraggable: Boolean;
    function isDroppable: Boolean;
    function isFloating: Boolean;
    function isHidden: Boolean;
    procedure isLayoutRoot;
    function isLayoutSuspended: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Boolean): Boolean; overload;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure move; overload;
    procedure move(direction: String); overload;
    procedure move(direction: String; distance: Float); overload;
    procedure move(direction: String; distance: Float; animate: Variant); overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function nextNode: JExt.IComponent; overload;
    function nextNode(selector: String): JExt.IComponent; overload;
    function nextSibling: JExt.IComponent; overload;
    function nextSibling(selector: String): JExt.IComponent; overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onAdded; overload;
    procedure onAdded(container: JExt.container.IContainer); overload;
    procedure onAdded(container: JExt.container.IContainer; pos: Float); overload;
    procedure onDisable;
    procedure onEnable;
    procedure onPosition; overload;
    procedure onPosition(x: Float); overload;
    procedure onPosition(x: Float; y: Float); overload;
    procedure onRemoved; overload;
    procedure onRemoved(destroying: Boolean); overload;
    procedure onRender; overload;
    procedure onRender(parentNode: JExt.core.IElement); overload;
    procedure onRender(parentNode: JExt.core.IElement; containerIdx: Float); overload;
    procedure onResize; overload;
    procedure onResize(width: Variant); overload;
    procedure onResize(width: Variant; height: Variant); overload;
    procedure onResize(width: Variant; height: Variant; oldWidth: Variant); overload;
    procedure onResize(width: Variant; height: Variant; oldWidth: Variant; oldHeight: Variant); overload;
    procedure postBlur; overload;
    procedure postBlur(e: JExt.IEventObject); overload;
    function previousNode: JExt.IComponent; overload;
    function previousNode(selector: String): JExt.IComponent; overload;
    function previousSibling: JExt.IComponent; overload;
    function previousSibling(selector: String): JExt.IComponent; overload;
    procedure registerFloatingItem; overload;
    procedure registerFloatingItem(cmp: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function removeAnchor: JExt.util.IPositionable;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
    function removeCls: JExt.IComponent; overload;
    function removeCls(cls: Variant): JExt.IComponent; overload;
    procedure removeClsWithUI; overload;
    procedure removeClsWithUI(cls: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure removeUIClsFromElement; overload;
    procedure removeUIClsFromElement(ui: String); overload;
    procedure render; overload;
    procedure render(container: Variant); overload;
    procedure render(container: Variant; position: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function savePropToState: Boolean; overload;
    function savePropToState(propName: String): Boolean; overload;
    function savePropToState(propName: String; state: Variant): Boolean; overload;
    function savePropToState(propName: String; state: Variant; stateName: String): Boolean; overload;
    function savePropsToState: Variant; overload;
    function savePropsToState(propNames: Variant): Variant; overload;
    function savePropsToState(propNames: Variant; state: Variant): Variant; overload;
    procedure saveState;
    function sequenceFx: Variant;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    function setBox: JExt.util.IPositionable; overload;
    function setBox(box: Variant): JExt.util.IPositionable; overload;
    function setBox(box: Variant; animate: Variant): JExt.util.IPositionable; overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    function setDocked: JExt.IComponent; overload;
    function setDocked(dock: Variant): JExt.IComponent; overload;
    function setDocked(dock: Variant; layoutParent: Boolean): JExt.IComponent; overload;
    function setHeight: JExt.IComponent; overload;
    function setHeight(height: Float): JExt.IComponent; overload;
    function setLocalX: JExt.util.IPositionable; overload;
    function setLocalX(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY: JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant; y: Variant): JExt.util.IPositionable; overload;
    function setLocalY: JExt.util.IPositionable; overload;
    function setLocalY(y: Variant): JExt.util.IPositionable; overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    function setRegion: JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion): JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion; animate: Variant): JExt.util.IPositionable; overload;
    function setSize: JExt.IComponent; overload;
    function setSize(width: Variant): JExt.IComponent; overload;
    function setSize(width: Variant; height: Variant): JExt.IComponent; overload;
    procedure setUI; overload;
    procedure setUI(ui: String); overload;
    function setVisible: JExt.IComponent; overload;
    function setVisible(visible: Boolean): JExt.IComponent; overload;
    function setWidth: JExt.IComponent; overload;
    function setWidth(width: Float): JExt.IComponent; overload;
    function setX: JExt.util.IPositionable; overload;
    function setX(x: Variant): JExt.util.IPositionable; overload;
    function setX(x: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setXY: JExt.util.IPositionable; overload;
    function setXY(xy: Variant): JExt.util.IPositionable; overload;
    function setXY(xy: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setY: JExt.util.IPositionable; overload;
    function setY(y: Variant): JExt.util.IPositionable; overload;
    function setY(y: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    function syncFx: Variant;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    function up: JExt.container.IContainer; overload;
    function up(selector: Variant): JExt.container.IContainer; overload;
    function up(selector: Variant; limit: Variant): JExt.container.IContainer; overload;
    procedure update; overload;
    procedure update(htmlOrData: Variant); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean; callback: Variant); overload;
    procedure updateLayout; overload;
    procedure updateLayout(options: Variant); overload;
  end;

//Ext

type
  JIAbstractManager = class external(JExt.IBase)
    all: JExt.util.IHashMap; // nullable
    function create: Variant; overload;
    function create(config: Variant): Variant; overload;
    function create(config: Variant; defaultType: String): Variant; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: String); overload;
    procedure registerType(&type: String; cls: Variant); overload;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

//Ext

type
  JIAbstractPlugin = class external(JExt.IBase)
    pluginId: String; // nullable
    isPlugin: Boolean; // nullable
    procedure clonePlugin; overload;
    procedure clonePlugin(overrideCfg: Variant); overload;
    procedure destroy;
    procedure disable;
    procedure enable;
    function getCmp: JExt.IComponent;
    procedure init; overload;
    procedure init(client: JExt.IComponent); overload;
    procedure setCmp; overload;
    procedure setCmp(cmp: JExt.IComponent); overload;
  end;

//Ext

type
  JIAction = class external(JExt.IBase)
    disabled: Boolean; // nullable
    handler: Variant; // nullable
    hidden: Boolean; // nullable
    iconCls: String; // nullable
    itemId: String; // nullable
    scope: Variant; // nullable
    text: String; // nullable
    procedure disable;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure enable;
    procedure execute(args: array of Variant);
    procedure getIconCls;
    procedure getText;
    procedure hide;
    procedure isDisabled;
    procedure isHidden;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setHandler; overload;
    procedure setHandler(fn: Variant); overload;
    procedure setHandler(fn: Variant; scope: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setIconCls; overload;
    procedure setIconCls(cls: String); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    procedure show;
  end;

//Ext

type
  JAjax = class external 'Ajax'
    autoAbort: Boolean;
    defaultHeaders: Variant;
    disableCaching: Boolean;
    extraParams: Variant;
    hasListeners: Variant;
    isObservable: Boolean;
    method: String;
    self: JExt.IClass;
    timeout: Float;
    url: String;
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    procedure abortAll;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isLoading: Boolean; overload;
    function isLoading(request: Variant): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function parseStatus: Variant; overload;
    function parseStatus(status: Float): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function setOptions: Variant; overload;
    function setOptions(options: Variant): Variant; overload;
    function setOptions(options: Variant; scope: Variant): Variant; overload;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure upload; overload;
    procedure upload(form: Variant); overload;
    procedure upload(form: Variant; url: String); overload;
    procedure upload(form: Variant; url: String; params: String); overload;
    procedure upload(form: Variant; url: String; params: String; options: Variant); overload;
  end;

  JIAjax = class external(JExt.data.IConnection)
  end;

//Ext.app

type
  JIApplication = class external(JExt.app.IController)
    appFolder: String; // nullable
    appProperty: String; // nullable
    autoCreateViewport: Boolean; // nullable
    controllers: Variant; // nullable
    enableQuickTips: Boolean; // nullable
    name: String; // nullable
    namespaces: Variant; // nullable
    paths: Variant; // nullable
    scope: Variant; // nullable
    function getApplication: JExt.app.IApplication;
    function getController: JExt.app.IController; overload;
    function getController(name: Variant): JExt.app.IController; overload;
    function launch: Boolean; overload;
    function launch(profile: String): Boolean; overload;
  end;

//Ext.app

type
  JIController = class external(JExt.IBase, JExt.util.IObservable)
    id: String; // nullable
    models: Variant; // nullable
    refs: array of Variant; // nullable
    stores: Variant; // nullable
    views: Variant; // nullable
    application: JExt.app.IApplication; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addRef; overload;
    procedure addRef(refs: Variant); overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure control; overload;
    procedure control(selectors: Variant); overload;
    procedure control(selectors: Variant; listeners: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getApplication: JExt.app.IApplication;
    function getController: JExt.app.IController; overload;
    function getController(id: String): JExt.app.IController; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(name: String): JExt.data.IModel; overload;
    function getStore: JExt.data.IStore; overload;
    function getStore(name: String): JExt.data.IStore; overload;
    function getView: JExt.IBase; overload;
    function getView(name: String): JExt.IBase; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function hasRef: Boolean; overload;
    function hasRef(ref: Variant): Boolean; overload;
    procedure init; overload;
    procedure init(application: JExt.app.IApplication); overload;
    procedure listen; overload;
    procedure listen(to: Variant); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onLaunch; overload;
    procedure onLaunch(application: JExt.app.IApplication); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.app.domain

type
  JComponent = class external 'Component'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function match(target: Variant; selector: Variant): Boolean; overload;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
    function statics: JExt.IClass;
  end;

  JIComponent = class external(JExt.app.IEventDomain)
  end;

//Ext.app.domain

type
  JController = class external 'Controller'
    idProperty: String;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function match(target: Variant; selector: String): Boolean; overload;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
    function statics: JExt.IClass;
  end;

  JIController = class external(JExt.app.IEventDomain)
  end;

//Ext.app.domain

type
  JDirect = class external 'Direct'
    idProperty: String;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function match(target: Variant; selector: String): Boolean; overload;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
    function statics: JExt.IClass;
  end;

  JIDirect = class external(JExt.app.IEventDomain)
  end;

//Ext.app.domain

type
  JGlobal = class external 'Global'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function match: Boolean;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
    function statics: JExt.IClass;
  end;

  JIGlobal = class external(JExt.app.IEventDomain)
  end;

//Ext.app.domain

type
  JStore = class external 'Store'
    idProperty: String;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function match(target: Variant; selector: String): Boolean; overload;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
    function statics: JExt.IClass;
  end;

  JIStore = class external(JExt.app.IEventDomain)
  end;

//Ext.app

type
  JEventBus = class external 'EventBus'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure control; overload;
    procedure control(selectors: Variant); overload;
    procedure control(selectors: Variant; controller: JExt.app.IController); overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure listen; overload;
    procedure listen(to: Variant); overload;
    procedure listen(to: Variant; controller: JExt.app.IController); overload;
    function statics: JExt.IClass;
    procedure unlisten; overload;
    procedure unlisten(controllerId: String); overload;
  end;

  JIEventBus = class external(JExt.IBase)
  end;

//Ext.app

type
  JIEventDomain = class external(JExt.IBase)
    idProperty: String; // nullable
    instances: Variant; // nullable
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function match(target: Variant; selector: String): Boolean; overload;
    procedure monitor; overload;
    procedure monitor(observable: JExt.IClass); overload;
  end;

//Ext

type
  JArray = class external 'Array'
    function clean: array of Variant; overload;
    function clean(array: array of Variant): array of Variant; overload;
    function clone: array of Variant; overload;
    function clone(array: array of Variant): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(array: array of Variant): Boolean; overload;
    function contains(array: array of Variant; item: Variant): Boolean; overload;
    function difference: array of Variant; overload;
    function difference(arrayA: array of Variant): array of Variant; overload;
    function difference(arrayA: array of Variant; arrayB: array of Variant): array of Variant; overload;
    function each: Boolean; overload;
    function each(iterable: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant; scope: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant; scope: Variant; reverse: Boolean): Boolean; overload;
    function equals: Boolean; overload;
    function equals(array1: array of Variant): Boolean; overload;
    function equals(array1: array of Variant; array2: array of Variant): Boolean; overload;
    function erase: array of Variant; overload;
    function erase(array: array of Variant): array of Variant; overload;
    function erase(array: array of Variant; index: Float): array of Variant; overload;
    function erase(array: array of Variant; index: Float; removeCount: Float): array of Variant; overload;
    function every: Boolean; overload;
    function every(array: array of Variant): Boolean; overload;
    function every(array: array of Variant; fn: Variant): Boolean; overload;
    function every(array: array of Variant; fn: Variant; scope: Variant): Boolean; overload;
    function filter: array of Variant; overload;
    function filter(array: array of Variant): array of Variant; overload;
    function filter(array: array of Variant; fn: Variant): array of Variant; overload;
    function filter(array: array of Variant; fn: Variant; scope: Variant): array of Variant; overload;
    function findBy: Variant; overload;
    function findBy(array: array of Variant): Variant; overload;
    function findBy(array: array of Variant; fn: Variant): Variant; overload;
    function findBy(array: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function flatten: array of Variant; overload;
    function flatten(array: array of Variant): array of Variant; overload;
    procedure forEach; overload;
    procedure forEach(array: array of Variant); overload;
    procedure forEach(array: array of Variant; fn: Variant); overload;
    procedure forEach(array: array of Variant; fn: Variant; scope: Variant); overload;
    function from: array of Variant; overload;
    function from(value: Variant): array of Variant; overload;
    function from(value: Variant; newReference: Boolean): array of Variant; overload;
    procedure include; overload;
    procedure include(array: array of Variant); overload;
    procedure include(array: array of Variant; item: Variant); overload;
    function indexOf: Float; overload;
    function indexOf(array: array of Variant): Float; overload;
    function indexOf(array: array of Variant; item: Variant): Float; overload;
    function indexOf(array: array of Variant; item: Variant; from: Float): Float; overload;
    function insert: array of Variant; overload;
    function insert(array: array of Variant): array of Variant; overload;
    function insert(array: array of Variant; index: Float): array of Variant; overload;
    function insert(array: array of Variant; index: Float; items: array of Variant): array of Variant; overload;
    function intersect: array of Variant; overload;
    function intersect(array1: array of Variant): array of Variant; overload;
    function intersect(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function intersect(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function map: array of Variant; overload;
    function map(array: array of Variant): array of Variant; overload;
    function map(array: array of Variant; fn: Variant): array of Variant; overload;
    function map(array: array of Variant; fn: Variant; scope: Variant): array of Variant; overload;
    function max: Variant; overload;
    function max(array: Variant): Variant; overload;
    function max(array: Variant; comparisonFn: Variant): Variant; overload;
    function mean: Float; overload;
    function mean(array: array of Variant): Float; overload;
    function merge: array of Variant; overload;
    function merge(array1: array of Variant): array of Variant; overload;
    function merge(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function merge(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function min: Variant; overload;
    function min(array: Variant): Variant; overload;
    function min(array: Variant; comparisonFn: Variant): Variant; overload;
    function pluck: array of Variant; overload;
    function pluck(array: Variant): array of Variant; overload;
    function pluck(array: Variant; propertyName: String): array of Variant; overload;
    function push(target: array of Variant; elements: array of Variant): array of Variant;
    function remove: array of Variant; overload;
    function remove(array: array of Variant): array of Variant; overload;
    function remove(array: array of Variant; item: Variant): array of Variant; overload;
    function replace: array of Variant; overload;
    function replace(array: array of Variant): array of Variant; overload;
    function replace(array: array of Variant; index: Float): array of Variant; overload;
    function replace(array: array of Variant; index: Float; removeCount: Float): array of Variant; overload;
    function replace(array: array of Variant; index: Float; removeCount: Float; insert: array of Variant): array of Variant; overload;
    function slice: array of Variant; overload;
    function slice(array: array of Variant): array of Variant; overload;
    function slice(array: array of Variant; begin: Float): array of Variant; overload;
    function slice(array: array of Variant; begin: Float; &end: Float): array of Variant; overload;
    function some: Boolean; overload;
    function some(array: array of Variant): Boolean; overload;
    function some(array: array of Variant; fn: Variant): Boolean; overload;
    function some(array: array of Variant; fn: Variant; scope: Variant): Boolean; overload;
    function sort: array of Variant; overload;
    function sort(array: array of Variant): array of Variant; overload;
    function sort(array: array of Variant; sortFn: Variant): array of Variant; overload;
    function splice(array: array of Variant; index: Float; removeCount: Float; elements: array of Variant): array of Variant;
    function sum: Float; overload;
    function sum(array: array of Variant): Float; overload;
    function toArray: array of Variant; overload;
    function toArray(iterable: Variant): array of Variant; overload;
    function toArray(iterable: Variant; start: Float): array of Variant; overload;
    function toArray(iterable: Variant; start: Float; &end: Float): array of Variant; overload;
    function toMap: Variant; overload;
    function toMap(array: array of Variant): Variant; overload;
    function toMap(array: array of Variant; getKey: Variant): Variant; overload;
    function toMap(array: array of Variant; getKey: Variant; scope: Variant): Variant; overload;
    function toValueMap: Variant; overload;
    function toValueMap(array: array of Variant): Variant; overload;
    function toValueMap(array: array of Variant; getKey: Variant): Variant; overload;
    function toValueMap(array: array of Variant; getKey: Variant; scope: Variant): Variant; overload;
    function union: array of Variant; overload;
    function union(array1: array of Variant): array of Variant; overload;
    function union(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function union(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function unique: array of Variant; overload;
    function unique(array: array of Variant): array of Variant; overload;
  end;

  JIArray = class external
  end;

//Ext

type
  JBase = class external 'Base'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIBase = class external(JExt.IClass)
    self: JExt.IClass; // nullable
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
  end;

//Ext.button

type
  JIButton = class external(JExt.IComponent, JExt.IQueryable)
    allowDepress: Boolean; // nullable
    arrowAlign: String; // nullable
    arrowCls: String; // nullable
    baseCls: String; // nullable
    baseParams: Variant; // nullable
    clickEvent: String; // nullable
    cls: String; // nullable
    componentLayout: Variant; // nullable
    destroyMenu: Boolean; // nullable
    disabled: Boolean; // nullable
    enableToggle: Boolean; // nullable
    focusCls: String; // nullable
    frame: Boolean; // nullable
    glyph: Variant; // nullable
    handleMouseEvents: Boolean; // nullable
    handler: Variant; // nullable
    hidden: Boolean; // nullable
    href: String; // nullable
    hrefTarget: String; // nullable
    icon: String; // nullable
    iconAlign: String; // nullable
    iconCls: String; // nullable
    menu: Variant; // nullable
    menuActiveCls: String; // nullable
    menuAlign: String; // nullable
    minWidth: Float; // nullable
    overCls: String; // nullable
    overflowText: String; // nullable
    params: Variant; // nullable
    pressed: Boolean; // nullable
    pressedCls: String; // nullable
    preventDefault: Boolean; // nullable
    renderTpl: Variant; // nullable
    repeat: Variant; // nullable
    scale: Variant; // nullable
    scope: Variant; // nullable
    showEmptyMenu: Boolean; // nullable
    shrinkWrap: Variant; // nullable
    tabIndex: Float; // nullable
    text: String; // nullable
    textAlign: String; // nullable
    toggleGroup: String; // nullable
    toggleHandler: Variant; // nullable
    tooltip: Variant; // nullable
    tooltipType: String; // nullable
    isAction: Boolean; // nullable
    template: JExt.ITemplate; // nullable
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    procedure disable; overload;
    procedure disable(silent: Variant); overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure enable; overload;
    procedure enable(silent: Variant); overload;
    function getTemplateArgs: Variant;
    function getText: String;
    function hasVisibleMenu: Boolean;
    function hideMenu: JExt.button.IButton;
    procedure initComponent;
    procedure onDisable;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    function setGlyph: JExt.button.IButton; overload;
    function setGlyph(glyph: Variant): JExt.button.IButton; overload;
    function setHandler: JExt.button.IButton; overload;
    function setHandler(handler: Variant): JExt.button.IButton; overload;
    function setHandler(handler: Variant; scope: Variant): JExt.button.IButton; overload;
    procedure setHref; overload;
    procedure setHref(href: String); overload;
    function setIcon: JExt.button.IButton; overload;
    function setIcon(icon: String): JExt.button.IButton; overload;
    function setIconCls: JExt.button.IButton; overload;
    function setIconCls(cls: String): JExt.button.IButton; overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
    procedure setScale; overload;
    procedure setScale(scale: String); overload;
    function setText: JExt.button.IButton; overload;
    function setText(text: String): JExt.button.IButton; overload;
    procedure setTextAlign; overload;
    procedure setTextAlign(align: String); overload;
    function setTooltip: JExt.button.IButton; overload;
    function setTooltip(tooltip: Variant): JExt.button.IButton; overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    procedure showMenu; overload;
    procedure showMenu(fromEvent: Variant); overload;
    function toggle: JExt.button.IButton; overload;
    function toggle(state: Boolean): JExt.button.IButton; overload;
    function toggle(state: Boolean; suppressEvent: Boolean): JExt.button.IButton; overload;
  end;

//Ext

type
  JIButton = class external(JExt.IComponent, JExt.IQueryable)
    allowDepress: Boolean; // nullable
    arrowAlign: String; // nullable
    arrowCls: String; // nullable
    baseCls: String; // nullable
    baseParams: Variant; // nullable
    clickEvent: String; // nullable
    cls: String; // nullable
    componentLayout: Variant; // nullable
    destroyMenu: Boolean; // nullable
    disabled: Boolean; // nullable
    enableToggle: Boolean; // nullable
    focusCls: String; // nullable
    frame: Boolean; // nullable
    glyph: Variant; // nullable
    handleMouseEvents: Boolean; // nullable
    handler: Variant; // nullable
    hidden: Boolean; // nullable
    href: String; // nullable
    hrefTarget: String; // nullable
    icon: String; // nullable
    iconAlign: String; // nullable
    iconCls: String; // nullable
    menu: Variant; // nullable
    menuActiveCls: String; // nullable
    menuAlign: String; // nullable
    minWidth: Float; // nullable
    overCls: String; // nullable
    overflowText: String; // nullable
    params: Variant; // nullable
    pressed: Boolean; // nullable
    pressedCls: String; // nullable
    preventDefault: Boolean; // nullable
    renderTpl: Variant; // nullable
    repeat: Variant; // nullable
    scale: Variant; // nullable
    scope: Variant; // nullable
    showEmptyMenu: Boolean; // nullable
    shrinkWrap: Variant; // nullable
    tabIndex: Float; // nullable
    text: String; // nullable
    textAlign: String; // nullable
    toggleGroup: String; // nullable
    toggleHandler: Variant; // nullable
    tooltip: Variant; // nullable
    tooltipType: String; // nullable
    isAction: Boolean; // nullable
    template: JExt.ITemplate; // nullable
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    procedure disable; overload;
    procedure disable(silent: Variant); overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure enable; overload;
    procedure enable(silent: Variant); overload;
    function getTemplateArgs: Variant;
    function getText: String;
    function hasVisibleMenu: Boolean;
    function hideMenu: JExt.button.IButton;
    procedure initComponent;
    procedure onDisable;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    function setGlyph: JExt.button.IButton; overload;
    function setGlyph(glyph: Variant): JExt.button.IButton; overload;
    function setHandler: JExt.button.IButton; overload;
    function setHandler(handler: Variant): JExt.button.IButton; overload;
    function setHandler(handler: Variant; scope: Variant): JExt.button.IButton; overload;
    procedure setHref; overload;
    procedure setHref(href: String); overload;
    function setIcon: JExt.button.IButton; overload;
    function setIcon(icon: String): JExt.button.IButton; overload;
    function setIconCls: JExt.button.IButton; overload;
    function setIconCls(cls: String): JExt.button.IButton; overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
    procedure setScale; overload;
    procedure setScale(scale: String); overload;
    function setText: JExt.button.IButton; overload;
    function setText(text: String): JExt.button.IButton; overload;
    procedure setTextAlign; overload;
    procedure setTextAlign(align: String); overload;
    function setTooltip: JExt.button.IButton; overload;
    function setTooltip(tooltip: Variant): JExt.button.IButton; overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    procedure showMenu; overload;
    procedure showMenu(fromEvent: Variant); overload;
    function toggle: JExt.button.IButton; overload;
    function toggle(state: Boolean): JExt.button.IButton; overload;
    function toggle(state: Boolean; suppressEvent: Boolean): JExt.button.IButton; overload;
  end;

//Ext.button

type
  JICycle = class external(JExt.button.ISplit)
    changeHandler: Variant; // nullable
    forceGlyph: Variant; // nullable
    forceIcon: String; // nullable
    items: array of Variant; // nullable
    prependText: String; // nullable
    showText: Boolean; // nullable
    menu: JExt.menu.IMenu; // nullable
    function getActiveItem: JExt.menu.ICheckItem;
    procedure setActiveItem; overload;
    procedure setActiveItem(item: JExt.menu.ICheckItem); overload;
    procedure setActiveItem(item: JExt.menu.ICheckItem; suppressEvent: Boolean); overload;
    procedure toggleSelected;
  end;

//Ext

type
  JICycleButton = class external(JExt.button.ISplit)
    changeHandler: Variant; // nullable
    forceGlyph: Variant; // nullable
    forceIcon: String; // nullable
    items: array of Variant; // nullable
    prependText: String; // nullable
    showText: Boolean; // nullable
    menu: JExt.menu.IMenu; // nullable
    function getActiveItem: JExt.menu.ICheckItem;
    procedure setActiveItem; overload;
    procedure setActiveItem(item: JExt.menu.ICheckItem); overload;
    procedure setActiveItem(item: JExt.menu.ICheckItem; suppressEvent: Boolean); overload;
    procedure toggleSelected;
  end;

//Ext.button

type
  JManager = class external 'Manager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIManager = class external(JExt.IBase)
  end;

//Ext

type
  JButtonToggleManager = class external 'ButtonToggleManager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIButtonToggleManager = class external(JExt.IBase)
  end;

//Ext.button

type
  JISplit = class external(JExt.button.IButton)
    arrowHandler: Variant; // nullable
    arrowTooltip: String; // nullable
    procedure setArrowHandler; overload;
    procedure setArrowHandler(handler: Variant); overload;
    procedure setArrowHandler(handler: Variant; scope: Variant); overload;
  end;

//Ext

type
  JISplitButton = class external(JExt.button.IButton)
    arrowHandler: Variant; // nullable
    arrowTooltip: String; // nullable
    procedure setArrowHandler; overload;
    procedure setArrowHandler(handler: Variant); overload;
    procedure setArrowHandler(handler: Variant; scope: Variant); overload;
  end;

//Ext.chart.axis

type
  JIAbstract = class external(JExt.IBase)
    fields: array of String; // nullable
    &label: JExt.chart.ILabel; // nullable
  end;

//Ext.chart.axis

type
  JIAxis = class external(JExt.chart.axis.IAbstract)
    adjustEnd: Boolean; // nullable
    dashSize: Float; // nullable
    grid: Variant; // nullable
    hidden: Boolean; // nullable
    _length: Float; // nullable
    majorTickSteps: Float; // nullable
    minorTickSteps: Float; // nullable
    position: String; // nullable
    title: String; // nullable
    width: Float; // nullable
    procedure drawAxis; overload;
    procedure drawAxis(init: Variant); overload;
    procedure drawGrid;
    procedure drawLabel;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext.chart

type
  JIAxis = class external(JExt.chart.axis.IAbstract)
    adjustEnd: Boolean; // nullable
    dashSize: Float; // nullable
    grid: Variant; // nullable
    hidden: Boolean; // nullable
    _length: Float; // nullable
    majorTickSteps: Float; // nullable
    minorTickSteps: Float; // nullable
    position: String; // nullable
    title: String; // nullable
    width: Float; // nullable
    procedure drawAxis; overload;
    procedure drawAxis(init: Variant); overload;
    procedure drawGrid;
    procedure drawLabel;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext.chart.axis

type
  JICategory = class external(JExt.chart.axis.IAxis)
    calculateCategoryCount: Boolean; // nullable
    categoryNames: String; // nullable
  end;

//Ext.chart

type
  JICategoryAxis = class external(JExt.chart.axis.IAxis)
    calculateCategoryCount: Boolean; // nullable
    categoryNames: String; // nullable
  end;

//Ext.chart.axis

type
  JIGauge = class external(JExt.chart.axis.IAbstract)
    margin: Float; // nullable
    maximum: Float; // nullable
    minimum: Float; // nullable
    steps: Float; // nullable
    title: String; // nullable
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext.chart.axis

type
  JINumeric = class external(JExt.chart.axis.IAxis)
    adjustMaximumByMajorUnit: Boolean; // nullable
    adjustMinimumByMajorUnit: Boolean; // nullable
    constrain: Boolean; // nullable
    decimals: Float; // nullable
    maximum: Float; // nullable
    minimum: Float; // nullable
    position: String; // nullable
  end;

//Ext.chart

type
  JINumericAxis = class external(JExt.chart.axis.IAxis)
    adjustMaximumByMajorUnit: Boolean; // nullable
    adjustMinimumByMajorUnit: Boolean; // nullable
    constrain: Boolean; // nullable
    decimals: Float; // nullable
    maximum: Float; // nullable
    minimum: Float; // nullable
    position: String; // nullable
  end;

//Ext.chart.axis

type
  JIRadial = class external(JExt.chart.axis.INumeric)
    maximum: Float; // nullable
    position: String; // nullable
    steps: Float; // nullable
    procedure drawLabel;
  end;

//Ext.chart.axis

type
  JITime = class external(JExt.chart.axis.INumeric)
    constrain: Boolean; // nullable
    dateFormat: Variant; // nullable
    fromDate: Variant; // nullable
    step: array of Variant; // nullable
    toDate: Variant; // nullable
  end;

//Ext.chart

type
  JITimeAxis = class external(JExt.chart.axis.INumeric)
    constrain: Boolean; // nullable
    dateFormat: Variant; // nullable
    fromDate: Variant; // nullable
    step: array of Variant; // nullable
    toDate: Variant; // nullable
  end;

//Ext.chart

type
  JICallout = class external(JExt.IBase)
  end;

//Ext.chart

type
  JIChart = class external(JExt.draw.IComponent, JExt.chart.theme.ITheme, JExt.chart.IMask, JExt.chart.INavigation, JExt.util.IBindable, JExt.util.IObservable)
    animate: Variant; // nullable
    axes: array of JExt.chart.axis.IAxis; // nullable
    background: Variant; // nullable
    gradients: array of Variant; // nullable
    insetPadding: Float; // nullable
    legend: Variant; // nullable
    series: array of JExt.chart.series.ISeries; // nullable
    store: JExt.data.IStore; // nullable
    theme: String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure initComponent;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onShow;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure redraw; overload;
    procedure redraw(resize: Boolean); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure restoreZoom;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function save: Variant; overload;
    function save(config: Variant): Variant; overload;
    procedure setZoom; overload;
    procedure setZoom(zoomConfig: Variant); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.chart

type
  JIHighlight = class external(JExt.IBase)
    highlight: Variant; // nullable
    highlightCfg: Variant; // nullable
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart

type
  JILabel = class external(JExt.IBase)
    &label: Variant; // nullable
    function onCreateLabel: JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant; i: Float): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant; i: Float; display: String): JExt.draw.ISprite; overload;
    procedure onPlaceLabel; overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String; animate: Boolean); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String; animate: Boolean; index: Float); overload;
  end;

//Ext.chart

type
  JILegend = class external(JExt.IBase)
    boxFill: String; // nullable
    boxStroke: String; // nullable
    boxStrokeWidth: String; // nullable
    boxZIndex: Float; // nullable
    itemSpacing: Float; // nullable
    labelColor: String; // nullable
    labelFont: String; // nullable
    padding: Float; // nullable
    position: String; // nullable
    update: Boolean; // nullable
    visible: Boolean; // nullable
    x: Float; // nullable
    y: Float; // nullable
    isVertical: Boolean; // nullable
    procedure toggle; overload;
    procedure toggle(show: Boolean); overload;
  end;

//Ext.chart

type
  JILegendItem = class external(JExt.draw.ICompositeSprite)
    procedure createLegend; overload;
    procedure createLegend(config: Variant); overload;
    procedure updatePosition; overload;
    procedure updatePosition(relativeTo: Variant); overload;
  end;

//Ext.chart

type
  JIMask = class external(JExt.IBase)
    mask: Variant; // nullable
  end;

//Ext.chart

type
  JIMaskLayer = class external(JExt.IComponent)
    procedure initComponent;
  end;

//Ext.chart

type
  JINavigation = class external(JExt.IBase)
    procedure restoreZoom;
    procedure setZoom; overload;
    procedure setZoom(zoomConfig: Variant); overload;
  end;

//Ext.chart.series

type
  JIArea = class external(JExt.chart.series.ICartesian)
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(item: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure highlightSeries; overload;
    procedure highlightSeries(item: Variant); overload;
    procedure unHighlightItem; overload;
    procedure unHighlightItem(item: Variant); overload;
    procedure unHighlightSeries; overload;
    procedure unHighlightSeries(item: Variant); overload;
  end;

//Ext.chart.series

type
  JIBar = class external(JExt.chart.series.ICartesian)
    column: Boolean; // nullable
    groupGutter: Float; // nullable
    gutter: Float; // nullable
    stacked: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(index: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart

type
  JIBarSeries = class external(JExt.chart.series.ICartesian)
    column: Boolean; // nullable
    groupGutter: Float; // nullable
    gutter: Float; // nullable
    stacked: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(index: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart

type
  JIBarChart = class external(JExt.chart.series.ICartesian)
    column: Boolean; // nullable
    groupGutter: Float; // nullable
    gutter: Float; // nullable
    stacked: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(index: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart

type
  JIStackedBarChart = class external(JExt.chart.series.ICartesian)
    column: Boolean; // nullable
    groupGutter: Float; // nullable
    gutter: Float; // nullable
    stacked: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(index: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart.series

type
  JICartesian = class external(JExt.chart.series.ISeries)
    axis: Variant; // nullable
    xField: String; // nullable
    yField: Variant; // nullable
    procedure eachYValue; overload;
    procedure eachYValue(record: JExt.data.IModel); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant; scope: Variant); overload;
    function getMinMaxXValues: array of Variant;
    function getMinMaxYValues: array of Variant;
    function getYValueAccessors: array of Variant;
    function getYValueCount: Float;
  end;

//Ext.chart

type
  JICartesianSeries = class external(JExt.chart.series.ISeries)
    axis: Variant; // nullable
    xField: String; // nullable
    yField: Variant; // nullable
    procedure eachYValue; overload;
    procedure eachYValue(record: JExt.data.IModel); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant; scope: Variant); overload;
    function getMinMaxXValues: array of Variant;
    function getMinMaxYValues: array of Variant;
    function getYValueAccessors: array of Variant;
    function getYValueCount: Float;
  end;

//Ext.chart

type
  JICartesianChart = class external(JExt.chart.series.ISeries)
    axis: Variant; // nullable
    xField: String; // nullable
    yField: Variant; // nullable
    procedure eachYValue; overload;
    procedure eachYValue(record: JExt.data.IModel); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant); overload;
    procedure eachYValue(record: JExt.data.IModel; fn: Variant; scope: Variant); overload;
    function getMinMaxXValues: array of Variant;
    function getMinMaxYValues: array of Variant;
    function getYValueAccessors: array of Variant;
    function getYValueCount: Float;
  end;

//Ext.chart.series

type
  JIColumn = class external(JExt.chart.series.IBar)
    axis: String; // nullable
    column: Boolean; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
  end;

//Ext.chart

type
  JIColumnSeries = class external(JExt.chart.series.IBar)
    axis: String; // nullable
    column: Boolean; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
  end;

//Ext.chart

type
  JIColumnChart = class external(JExt.chart.series.IBar)
    axis: String; // nullable
    column: Boolean; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
  end;

//Ext.chart

type
  JIStackedColumnChart = class external(JExt.chart.series.IBar)
    axis: String; // nullable
    column: Boolean; // nullable
    &type: String; // nullable
    xPadding: Variant; // nullable
    yPadding: Variant; // nullable
  end;

//Ext.chart.series

type
  JIGauge = class external(JExt.chart.series.ISeries)
    angleField: String; // nullable
    donut: Variant; // nullable
    highlightDuration: Float; // nullable
    needle: Boolean; // nullable
    showInLegend: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(item: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.chart.series

type
  JILine = class external(JExt.chart.series.ICartesian)
    fill: Boolean; // nullable
    markerConfig: Variant; // nullable
    selectionTolerance: Float; // nullable
    showMarkers: Boolean; // nullable
    smooth: Variant; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
  end;

//Ext.chart

type
  JILineSeries = class external(JExt.chart.series.ICartesian)
    fill: Boolean; // nullable
    markerConfig: Variant; // nullable
    selectionTolerance: Float; // nullable
    showMarkers: Boolean; // nullable
    smooth: Variant; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
  end;

//Ext.chart

type
  JILineChart = class external(JExt.chart.series.ICartesian)
    fill: Boolean; // nullable
    markerConfig: Variant; // nullable
    selectionTolerance: Float; // nullable
    showMarkers: Boolean; // nullable
    smooth: Variant; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
  end;

//Ext.chart.series

type
  JIPie = class external(JExt.chart.series.ISeries)
    angleField: String; // nullable
    colorSet: array of Variant; // nullable
    donut: Variant; // nullable
    field: String; // nullable
    highlightDuration: Float; // nullable
    lengthField: String; // nullable
    showInLegend: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xField: String; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(item: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem; overload;
    procedure unHighlightItem(item: Variant); overload;
  end;

//Ext.chart

type
  JIPieSeries = class external(JExt.chart.series.ISeries)
    angleField: String; // nullable
    colorSet: array of Variant; // nullable
    donut: Variant; // nullable
    field: String; // nullable
    highlightDuration: Float; // nullable
    lengthField: String; // nullable
    showInLegend: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xField: String; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(item: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem; overload;
    procedure unHighlightItem(item: Variant); overload;
  end;

//Ext.chart

type
  JIPieChart = class external(JExt.chart.series.ISeries)
    angleField: String; // nullable
    colorSet: array of Variant; // nullable
    donut: Variant; // nullable
    field: String; // nullable
    highlightDuration: Float; // nullable
    lengthField: String; // nullable
    showInLegend: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xField: String; // nullable
    procedure drawSeries;
    procedure getLegendColor; overload;
    procedure getLegendColor(item: Variant); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure unHighlightItem; overload;
    procedure unHighlightItem(item: Variant); overload;
  end;

//Ext.chart.series

type
  JIRadar = class external(JExt.chart.series.ISeries)
    markerConfig: Variant; // nullable
    showInLegend: Boolean; // nullable
    showMarkers: Boolean; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    xField: String; // nullable
    yField: String; // nullable
    procedure drawSeries;
  end;

//Ext.chart.series

type
  JIScatter = class external(JExt.chart.series.ICartesian)
    markerConfig: Variant; // nullable
    style: Variant; // nullable
    &type: String; // nullable
    procedure drawSeries;
  end;

//Ext.chart.series

type
  JISeries = class external(JExt.IBase, JExt.util.IObservable, JExt.chart.ILabel, JExt.chart.IHighlight, JExt.chart.ITip, JExt.chart.ICallout)
    highlight: Variant; // nullable
    listeners: Variant; // nullable
    renderer: Variant; // nullable
    shadowAttributes: array of Variant; // nullable
    showInLegend: Boolean; // nullable
    tips: Variant; // nullable
    title: String; // nullable
    &type: String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure eachRecord; overload;
    procedure eachRecord(fn: Variant); overload;
    procedure eachRecord(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Float): Variant; overload;
    function getItemForPoint(x: Float; y: Float): Variant; overload;
    procedure getLegendColor; overload;
    procedure getLegendColor(index: Variant); overload;
    procedure getRecordCount;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hideAll;
    procedure highlightItem; overload;
    procedure highlightItem(item: Variant); overload;
    procedure isExcluded; overload;
    procedure isExcluded(index: Variant); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function onCreateLabel: JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant; i: Float): JExt.draw.ISprite; overload;
    function onCreateLabel(storeItem: JExt.data.IModel; item: Variant; i: Float; display: String): JExt.draw.ISprite; overload;
    procedure onPlaceLabel; overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String; animate: Boolean); overload;
    procedure onPlaceLabel(&label: JExt.draw.ISprite; storeItem: JExt.data.IModel; item: Variant; i: Float; display: String; animate: Boolean; index: Float); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setTitle; overload;
    procedure setTitle(index: Float); overload;
    procedure setTitle(index: Float; title: String); overload;
    procedure showAll;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unHighlightItem;
  end;

//Ext.chart

type
  JShape = class external 'Shape'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIShape = class external(JExt.IBase)
  end;

//Ext.chart.theme

type
  JIBase = class external(JExt.IBase)
  end;

//Ext.chart.theme

type
  JITheme = class external
  end;

//Ext.chart

type
  JITip = class external(JExt.IBase)
  end;

//Ext.chart

type
  JITipSurface = class external(JExt.draw.IComponent)
  end;

//Ext

type
  JIClass = class external
    alias: array of String; // nullable
    alternateClassName: Variant; // nullable
    config: Variant; // nullable
    extend: String; // nullable
    inheritableStatics: Variant; // nullable
    mixins: Variant; // nullable
    requires: array of String; // nullable
    singleton: Boolean; // nullable
    statics: Variant; // nullable
    &uses: array of String; // nullable
  end;

//Ext

type
  JClassManager = class external 'ClassManager'
    function addNameAliasMappings: JExt.IClassManager; overload;
    function addNameAliasMappings(aliases: Variant): JExt.IClassManager; overload;
    function addNameAlternateMappings: JExt.IClassManager; overload;
    function addNameAlternateMappings(alternates: Variant): JExt.IClassManager; overload;
    procedure create; overload;
    procedure create(className: Variant); overload;
    procedure create(className: Variant; data: Variant); overload;
    procedure create(className: Variant; data: Variant; createdFn: Variant); overload;
    function get: JExt.IClass; overload;
    function get(name: String): JExt.IClass; overload;
    function getAliasesByName: array of Variant; overload;
    function getAliasesByName(name: String): array of Variant; overload;
    function getByAlias: JExt.IClass; overload;
    function getByAlias(alias: String): JExt.IClass; overload;
    function getClass: JExt.IClass; overload;
    function getClass(&object: Variant): JExt.IClass; overload;
    function getDisplayName: String; overload;
    function getDisplayName(&object: Variant): String; overload;
    function getName: String; overload;
    function getName(&object: Variant): String; overload;
    function getNameByAlias: String; overload;
    function getNameByAlias(alias: String): String; overload;
    function getNameByAlternate: String; overload;
    function getNameByAlternate(alternate: String): String; overload;
    function getNamesByExpression: array of String; overload;
    function getNamesByExpression(expression: String): array of String; overload;
    function instantiateByAlias(alias: String; args: array of Variant): Variant;
    function isCreated: Boolean; overload;
    function isCreated(className: String): Boolean; overload;
    function set: JExt.IClassManager; overload;
    function set(name: String): JExt.IClassManager; overload;
    function set(name: String; value: Variant): JExt.IClassManager; overload;
    function setAlias: JExt.IClassManager; overload;
    function setAlias(cls: Variant): JExt.IClassManager; overload;
    function setAlias(cls: Variant; alias: String): JExt.IClassManager; overload;
    procedure setNamespace; overload;
    procedure setNamespace(name: String); overload;
    procedure setNamespace(name: String; value: Variant); overload;
  end;

  JIClassManager = class external
  end;

//Ext

type
  JIComponent = class external(JExt.IAbstractComponent, JExt.util.IFloating)
    autoScroll: Boolean; // nullable
    columnWidth: Variant; // nullable
    constrainTo: Variant; // nullable
    constraintInsets: Variant; // nullable
    defaultAlign: String; // nullable
    floating: Boolean; // nullable
    formBind: Boolean; // nullable
    overflowX: String; // nullable
    overflowY: String; // nullable
    region: Variant; // nullable
    resizable: Variant; // nullable
    resizeHandles: String; // nullable
    toFrontOnShow: Boolean; // nullable
    floatParent: JExt.IContainer; // nullable
    scrollFlags: Variant; // nullable
    zIndexManager: JExt.IZIndexManager; // nullable
    zIndexParent: JExt.IContainer; // nullable
    procedure afterComponentLayout;
    procedure afterHide; overload;
    procedure afterHide(callback: Variant); overload;
    procedure afterHide(callback: Variant; scope: Variant); overload;
    procedure afterRender;
    procedure afterSetPosition; overload;
    procedure afterSetPosition(ax: Variant); overload;
    procedure afterSetPosition(ax: Variant; ay: Variant); overload;
    procedure afterShow; overload;
    procedure afterShow(animateTarget: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant; scope: Variant); overload;
    procedure beforeLayout;
    procedure beforeShow;
    function bubble: JExt.IComponent; overload;
    function bubble(fn: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant; args: array of Variant): JExt.IComponent; overload;
    procedure cancelFocus;
    function center: JExt.IComponent;
    function cloneConfig: JExt.IComponent; overload;
    function cloneConfig(overrides: Variant): JExt.IComponent; overload;
    procedure doConstrain; overload;
    procedure doConstrain(constrainTo: Variant); overload;
    function findParentBy: JExt.container.IContainer; overload;
    function findParentBy(fn: Variant): JExt.container.IContainer; overload;
    function findParentByType: JExt.container.IContainer; overload;
    function findParentByType(xtype: Variant): JExt.container.IContainer; overload;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Boolean): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant; scope: Variant): JExt.IComponent; overload;
    function getEl: JExt.dom.IElement;
    function getId: String;
    function getPosition: array of Float; overload;
    function getPosition(local: Boolean): array of Float; overload;
    function getXType: String;
    function hide: JExt.IComponent; overload;
    function hide(animateTarget: Variant): JExt.IComponent; overload;
    function hide(animateTarget: Variant; callback: Variant): JExt.IComponent; overload;
    function hide(animateTarget: Variant; callback: Variant; scope: Variant): JExt.IComponent; overload;
    procedure initComponent;
    procedure onAdded;
    procedure onDestroy;
    procedure onHide; overload;
    procedure onHide(animateTarget: Variant); overload;
    procedure onHide(animateTarget: Variant; callback: Variant); overload;
    procedure onHide(animateTarget: Variant; callback: Variant; scope: Variant); overload;
    procedure onShow; overload;
    procedure onShow(animateTarget: Variant); overload;
    procedure onShow(animateTarget: Variant; callback: Variant); overload;
    procedure onShow(animateTarget: Variant; callback: Variant; scope: Variant); overload;
    procedure onShowComplete; overload;
    procedure onShowComplete(callback: Variant); overload;
    procedure onShowComplete(callback: Variant; scope: Variant); overload;
    procedure scrollBy; overload;
    procedure scrollBy(deltaX: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant); overload;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActive(active: Boolean; newActive: JExt.IComponent); overload;
    function setAutoScroll: JExt.IComponent; overload;
    function setAutoScroll(scroll: Boolean): JExt.IComponent; overload;
    function setBorderRegion: String; overload;
    function setBorderRegion(region: String): String; overload;
    function setLoading: JExt.ILoadMask; overload;
    function setLoading(load: Variant): JExt.ILoadMask; overload;
    function setLoading(load: Variant; targetEl: Boolean): JExt.ILoadMask; overload;
    function setOverflowXY: JExt.IComponent; overload;
    function setOverflowXY(overflowX: String): JExt.IComponent; overload;
    function setOverflowXY(overflowX: String; overflowY: String): JExt.IComponent; overload;
    function setPagePosition: JExt.IComponent; overload;
    function setPagePosition(x: Variant): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setPosition: JExt.IComponent; overload;
    function setPosition(x: Variant): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setRegionWeight: Float; overload;
    function setRegionWeight(weight: Float): Float; overload;
    function show: JExt.IComponent; overload;
    function show(animateTarget: Variant): JExt.IComponent; overload;
    function show(animateTarget: Variant; callback: Variant): JExt.IComponent; overload;
    function show(animateTarget: Variant; callback: Variant; scope: Variant): JExt.IComponent; overload;
    function showAt: JExt.IComponent; overload;
    function showAt(x: Variant): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function showBy: JExt.IComponent; overload;
    function showBy(component: Variant): JExt.IComponent; overload;
    function showBy(component: Variant; position: String): JExt.IComponent; overload;
    function showBy(component: Variant; position: String; offsets: array of Float): JExt.IComponent; overload;
    function toBack: JExt.IComponent;
    function toFront: JExt.IComponent; overload;
    function toFront(preventFocus: Boolean): JExt.IComponent; overload;
    function updateBox: JExt.IComponent; overload;
    function updateBox(box: Variant): JExt.IComponent; overload;
  end;

//Ext

type
  JIComponentLoader = class external(JExt.IElementLoader)
    loadMask: Variant; // nullable
    scripts: Boolean; // nullable
    target: Variant; // nullable
    procedure setTarget; overload;
    procedure setTarget(target: Variant); overload;
  end;

//Ext

type
  JComponentManager = class external 'ComponentManager'
    all: JExt.util.IHashMap;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(config: Variant): JExt.IComponent; overload;
    function create(config: Variant; defaultType: String): JExt.IComponent; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: Variant); overload;
    procedure registerType(&type: Variant; cls: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIComponentManager = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JComponentMgr = class external 'ComponentMgr'
    all: JExt.util.IHashMap;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(config: Variant): JExt.IComponent; overload;
    function create(config: Variant; defaultType: String): JExt.IComponent; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: Variant); overload;
    procedure registerType(&type: Variant; cls: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIComponentMgr = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JComponentQuery = class external 'ComponentQuery'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function is: Boolean; overload;
    function is(component: JExt.IComponent): Boolean; overload;
    function is(component: JExt.IComponent; selector: String): Boolean; overload;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function query(selector: String; root: JExt.container.IContainer): array of JExt.IComponent; overload;
    function statics: JExt.IClass;
  end;

  JIComponentQuery = class external(JExt.IBase)
  end;

//Ext.container

type
  JIAbstractContainer = class external(JExt.IComponent, JExt.IQueryable)
    activeItem: Variant; // nullable
    autoDestroy: Boolean; // nullable
    baseCls: String; // nullable
    bubbleEvents: array of String; // nullable
    defaultType: String; // nullable
    defaults: Variant; // nullable
    detachOnRemove: Boolean; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    renderTpl: Variant; // nullable
    suspendLayout: Boolean; // nullable
    function add: Variant; overload;
    function add(component: Variant): Variant; overload;
    procedure afterComponentLayout;
    procedure afterLayout; overload;
    procedure afterLayout(layout: JExt.layout.container.IContainer); overload;
    function cascade: JExt.IContainer; overload;
    function cascade(fn: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant; args: array of Variant): JExt.IContainer; overload;
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function contains: Boolean; overload;
    function contains(comp: JExt.IComponent): Boolean; overload;
    function contains(comp: JExt.IComponent; deep: Boolean): Boolean; overload;
    function disable: JExt.container.IAbstractContainer;
    function doLayout: JExt.container.IContainer;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    function getComponent: JExt.IComponent; overload;
    function getComponent(comp: Variant): JExt.IComponent; overload;
    function getLayout: JExt.layout.container.IContainer;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function insert: JExt.IComponent; overload;
    function insert(index: Float): JExt.IComponent; overload;
    function insert(index: Float; component: Variant): JExt.IComponent; overload;
    procedure isAncestor; overload;
    procedure isAncestor(possibleDescendant: JExt.IComponent); overload;
    function move: JExt.IComponent; overload;
    function move(fromIdx: Variant): JExt.IComponent; overload;
    function move(fromIdx: Variant; toIdx: Float): JExt.IComponent; overload;
    procedure onAdd; overload;
    procedure onAdd(component: JExt.IComponent); overload;
    procedure onAdd(component: JExt.IComponent; position: Float); overload;
    procedure onBeforeAdd; overload;
    procedure onBeforeAdd(item: JExt.IComponent); overload;
    procedure onPosition;
    procedure onRemove; overload;
    procedure onRemove(component: JExt.IComponent); overload;
    procedure onRemove(component: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure onResize;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    function remove: JExt.IComponent; overload;
    function remove(component: Variant): JExt.IComponent; overload;
    function remove(component: Variant; autoDestroy: Boolean): JExt.IComponent; overload;
    function removeAll: array of JExt.IComponent; overload;
    function removeAll(autoDestroy: Boolean): array of JExt.IComponent; overload;
  end;

//Ext.container

type
  JIButtonGroup = class external(JExt.panel.IPanel)
    baseCls: String; // nullable
    columns: Float; // nullable
    defaultButtonUI: String; // nullable
    defaultType: String; // nullable
    frame: Boolean; // nullable
    layout: Variant; // nullable
    titleAlign: String; // nullable
    procedure onBeforeAdd; overload;
    procedure onBeforeAdd(component: Variant); overload;
  end;

//Ext

type
  JIButtonGroup = class external(JExt.panel.IPanel)
    baseCls: String; // nullable
    columns: Float; // nullable
    defaultButtonUI: String; // nullable
    defaultType: String; // nullable
    frame: Boolean; // nullable
    layout: Variant; // nullable
    titleAlign: String; // nullable
    procedure onBeforeAdd; overload;
    procedure onBeforeAdd(component: Variant); overload;
  end;

//Ext.container

type
  JIContainer = class external(JExt.container.IAbstractContainer)
    anchorSize: Variant; // nullable
    function getChildByElement: JExt.IComponent; overload;
    function getChildByElement(el: Variant): JExt.IComponent; overload;
    function getChildByElement(el: Variant; deep: Boolean): JExt.IComponent; overload;
  end;

//Ext

type
  JIContainer = class external(JExt.container.IAbstractContainer)
    anchorSize: Variant; // nullable
    function getChildByElement: JExt.IComponent; overload;
    function getChildByElement(el: Variant): JExt.IComponent; overload;
    function getChildByElement(el: Variant; deep: Boolean): JExt.IComponent; overload;
  end;

//Ext.container

type
  JIDockingContainer = class external(JExt.IBase)
    defaultDockWeights: Variant; // nullable
    function addDocked: array of JExt.IComponent; overload;
    function addDocked(component: Variant): array of JExt.IComponent; overload;
    function addDocked(component: Variant; pos: Float): array of JExt.IComponent; overload;
    function getDockedComponent: JExt.IComponent; overload;
    function getDockedComponent(comp: Variant): JExt.IComponent; overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(selector: String): array of JExt.IComponent; overload;
    function getDockedItems(selector: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    procedure insertDocked; overload;
    procedure insertDocked(pos: Float); overload;
    procedure insertDocked(pos: Float; component: Variant); overload;
    procedure onDockedAdd; overload;
    procedure onDockedAdd(component: JExt.IComponent); overload;
    procedure onDockedRemove; overload;
    procedure onDockedRemove(component: JExt.IComponent); overload;
    procedure removeDocked; overload;
    procedure removeDocked(item: JExt.IComponent); overload;
    procedure removeDocked(item: JExt.IComponent; autoDestroy: Boolean); overload;
  end;

//Ext.container

type
  JIMonitor = class external(JExt.IBase)
  end;

//Ext.container

type
  JIViewport = class external(JExt.container.IContainer)
    isViewport: Boolean; // nullable
    procedure onRender;
  end;

//Ext

type
  JIViewport = class external(JExt.container.IContainer)
    isViewport: Boolean; // nullable
    procedure onRender;
  end;

//Ext.data

type
  JAbstractStore = class external 'AbstractStore'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: JExt.data.IAbstractStore; overload;
    function create(store: Variant): JExt.data.IAbstractStore; overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIAbstractStore = class external(JExt.IBase, JExt.util.IObservable, JExt.util.ISortable)
    autoLoad: Variant; // nullable
    autoSync: Boolean; // nullable
    batchUpdateMode: String; // nullable
    fields: array of Variant; // nullable
    filterOnLoad: Boolean; // nullable
    filters: Variant; // nullable
    model: String; // nullable
    proxy: Variant; // nullable
    remoteFilter: Boolean; // nullable
    remoteSort: Boolean; // nullable
    sortOnLoad: Boolean; // nullable
    statefulFilters: Boolean; // nullable
    storeId: String; // nullable
    defaultProxyType: String; // nullable
    isDestroyed: Boolean; // nullable
    isStore: Boolean; // nullable
    removed: array of JExt.data.IModel; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    procedure generateComparator;
    function getFirstSorter: JExt.util.ISorter;
    function getModifiedRecords: array of JExt.data.IModel;
    function getNewRecords: array of JExt.data.IModel;
    function getProxy: JExt.data.proxy.IProxy;
    function getRemovedRecords: array of JExt.data.IModel;
    function getUpdatedRecords: array of JExt.data.IModel;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure initSortable;
    function isLoading: Boolean;
    procedure load; overload;
    procedure load(options: Variant); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure reload; overload;
    procedure reload(options: Variant); overload;
    procedure removeAll;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeAutoSync;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure save;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure suspendAutoSync;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    function sync: JExt.data.IStore; overload;
    function sync(options: Variant): JExt.data.IStore; overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIArrayStore = class external(JExt.data.IStore)
    procedure loadData; overload;
    procedure loadData(data: Variant); overload;
    procedure loadData(data: Variant; append: Variant); overload;
  end;

//Ext.data.association

type
  JIAssociation = class external(JExt.IBase)
    associatedModel: String; // nullable
    associationKey: String; // nullable
    model: String; // nullable
    ownerModel: String; // nullable
    primaryKey: String; // nullable
    reader: JExt.data.reader.IReader; // nullable
    associatedName: String; // nullable
    ownerName: String; // nullable
    function getReader: JExt.data.reader.IReader;
  end;

//Ext.data

type
  JIAssociation = class external(JExt.IBase)
    associatedModel: String; // nullable
    associationKey: String; // nullable
    model: String; // nullable
    ownerModel: String; // nullable
    primaryKey: String; // nullable
    reader: JExt.data.reader.IReader; // nullable
    associatedName: String; // nullable
    ownerName: String; // nullable
    function getReader: JExt.data.reader.IReader;
  end;

//Ext.data.association

type
  JIBelongsTo = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    &type: String; // nullable
  end;

//Ext.data

type
  JIBelongsToAssociation = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    &type: String; // nullable
  end;

//Ext.data.association

type
  JIHasMany = class external(JExt.data.association.IAssociation)
    autoLoad: Boolean; // nullable
    filterProperty: String; // nullable
    foreignKey: String; // nullable
    name: String; // nullable
    storeConfig: Variant; // nullable
    &type: String; // nullable
  end;

//Ext.data

type
  JIHasManyAssociation = class external(JExt.data.association.IAssociation)
    autoLoad: Boolean; // nullable
    filterProperty: String; // nullable
    foreignKey: String; // nullable
    name: String; // nullable
    storeConfig: Variant; // nullable
    &type: String; // nullable
  end;

//Ext.data.association

type
  JIHasOne = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    &type: String; // nullable
  end;

//Ext.data

type
  JIHasOneAssociation = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    &type: String; // nullable
  end;

//Ext.data

type
  JIBatch = class external(JExt.IBase, JExt.util.IObservable)
    autoStart: Boolean; // nullable
    pauseOnException: Boolean; // nullable
    current: Float; // nullable
    exceptions: array of JExt.data.IOperation; // nullable
    hasException: Boolean; // nullable
    isComplete: Boolean; // nullable
    isRunning: Boolean; // nullable
    operations: array of JExt.data.IOperation; // nullable
    total: Float; // nullable
    function add: JExt.data.IBatch; overload;
    function add(operation: Variant): JExt.data.IBatch; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function pause: JExt.data.IBatch;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function retry: JExt.data.IBatch;
    function runOperation: JExt.data.IBatch; overload;
    function runOperation(index: Float): JExt.data.IBatch; overload;
    function start: JExt.data.IBatch; overload;
    function start(index: Variant): JExt.data.IBatch; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIBufferStore = class external(JExt.data.IStore)
    filterOnLoad: Boolean; // nullable
    sortOnLoad: Boolean; // nullable
  end;

//Ext.data

type
  JIConnection = class external(JExt.IBase, JExt.util.IObservable)
    autoAbort: Boolean; // nullable
    binary: Boolean; // nullable
    cors: Boolean; // nullable
    defaultHeaders: Variant; // nullable
    disableCaching: Boolean; // nullable
    disableCachingParam: String; // nullable
    extraParams: Variant; // nullable
    method: String; // nullable
    timeout: Float; // nullable
    withCredentials: Boolean; // nullable
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    procedure abortAll;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isLoading: Boolean; overload;
    function isLoading(request: Variant): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function parseStatus: Variant; overload;
    function parseStatus(status: Float): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function setOptions: Variant; overload;
    function setOptions(options: Variant): Variant; overload;
    function setOptions(options: Variant; scope: Variant): Variant; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure upload; overload;
    procedure upload(form: Variant); overload;
    procedure upload(form: Variant; url: String); overload;
    procedure upload(form: Variant; url: String; params: String); overload;
    procedure upload(form: Variant; url: String; params: String; options: Variant); overload;
  end;

//Ext.data

type
  JIDirectStore = class external(JExt.data.IStore)
  end;

//Ext.data

type
  JIErrors = class external(JExt.util.IMixedCollection)
    function getByField: array of Variant; overload;
    function getByField(fieldName: String): array of Variant; overload;
    function isValid: Boolean;
  end;

//Ext.data

type
  JIField = class external(JExt.IBase)
    convert: Variant; // nullable
    dateFormat: String; // nullable
    dateReadFormat: String; // nullable
    dateWriteFormat: String; // nullable
    defaultValue: Variant; // nullable
    mapping: Variant; // nullable
    name: String; // nullable
    persist: Boolean; // nullable
    serialize: Variant; // nullable
    sortDir: String; // nullable
    sortType: Variant; // nullable
    &type: Variant; // nullable
    useNull: Boolean; // nullable
  end;

//Ext.data.flash

type
  JIBinaryXhr = class external(JExt.IBase)
    readyState: Float; // nullable
    responseBytes: array of Variant; // nullable
    status: Float; // nullable
    statusText: String; // nullable
    procedure abort;
    procedure getAllResponseHeaders;
    procedure getResponseHeader; overload;
    procedure getResponseHeader(header: Variant); overload;
    procedure onreadystatechange;
    procedure open; overload;
    procedure open(method: Variant); overload;
    procedure open(method: Variant; url: Variant); overload;
    procedure open(method: Variant; url: Variant; async: Variant); overload;
    procedure open(method: Variant; url: Variant; async: Variant; user: Variant); overload;
    procedure open(method: Variant; url: Variant; async: Variant; user: Variant; password: Variant); overload;
    procedure overrideMimeType; overload;
    procedure overrideMimeType(mimeType: Variant); overload;
    procedure send; overload;
    procedure send(body: array of Variant); overload;
    procedure setRequestHeader; overload;
    procedure setRequestHeader(header: Variant); overload;
    procedure setRequestHeader(header: Variant; value: Variant); overload;
  end;

//Ext.data

type
  JIGroup = class external(JExt.util.IObservable)
  end;

//Ext.data

type
  JIdGenerator = class external 'IdGenerator'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure get; overload;
    procedure get(config: Variant); overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIIdGenerator = class external(JExt.IBase)
    id: String; // nullable
    isGenerator: Boolean; // nullable
    function generate: String;
  end;

//Ext.data

type
  JJsonP = class external 'JsonP'
    callbackKey: String;
    disableCaching: Boolean;
    disableCachingParam: String;
    self: JExt.IClass;
    timeout: Float;
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIJsonP = class external(JExt.IBase)
  end;

//Ext.data

type
  JIJsonPStore = class external(JExt.data.IStore)
  end;

//Ext.data

type
  JIJsonStore = class external(JExt.data.IStore)
  end;

//Ext.data

type
  JModel = class external 'Model'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getFields: array of JExt.data.IField;
    function getName: String;
    function getProxy: JExt.data.proxy.IProxy;
    function id: String; overload;
    function id(rec: JExt.data.IModel): String; overload;
    procedure implement;
    procedure load; overload;
    procedure load(id: Variant); overload;
    procedure load(id: Variant; config: Variant); overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    procedure setFields; overload;
    procedure setFields(fields: Variant); overload;
    procedure setFields(fields: Variant; idProperty: Variant); overload;
    procedure setFields(fields: Variant; idProperty: Variant; clientIdProperty: Variant); overload;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
  end;

  JIModel = class external(JExt.IBase, JExt.util.IObservable)
    associations: array of Variant; // nullable
    belongsTo: Variant; // nullable
    clientIdProperty: String; // nullable
    defaultProxyType: String; // nullable
    fields: Variant; // nullable
    hasMany: Variant; // nullable
    idProperty: Variant; // nullable
    idgen: Variant; // nullable
    persistenceProperty: String; // nullable
    proxy: Variant; // nullable
    validations: array of Variant; // nullable
    dirty: Boolean; // nullable
    editing: Boolean; // nullable
    isModel: Boolean; // nullable
    modified: Variant; // nullable
    phantom: Boolean; // nullable
    raw: Variant; // nullable
    store: JExt.data.IStore; // nullable
    stores: array of JExt.data.IStore; // nullable
    COMMIT: String; // nullable
    EDIT: String; // nullable
    REJECT: String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure beginEdit;
    procedure cancelEdit;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure commit; overload;
    procedure commit(silent: Boolean); overload;
    procedure commit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function copy: JExt.data.IModel; overload;
    function copy(id: String): JExt.data.IModel; overload;
    function destroy: JExt.data.IModel; overload;
    function destroy(options: Variant): JExt.data.IModel; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure endEdit; overload;
    procedure endEdit(silent: Boolean); overload;
    procedure endEdit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function get: Variant; overload;
    function get(fieldName: String): Variant; overload;
    function getAssociatedData: Variant;
    function getChanges: Variant;
    function getData: Variant; overload;
    function getData(includeAssociated: Boolean): Variant; overload;
    function getId: Variant;
    function getProxy: JExt.data.proxy.IProxy;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isModified: Boolean; overload;
    function isModified(fieldName: String): Boolean; overload;
    function isValid: Boolean;
    procedure join; overload;
    procedure join(store: JExt.data.IStore); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure reject; overload;
    procedure reject(silent: Boolean); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function save: JExt.data.IModel; overload;
    function save(options: Variant): JExt.data.IModel; overload;
    function set: array of String; overload;
    function set(fieldName: Variant): array of String; overload;
    function set(fieldName: Variant; newValue: Variant): array of String; overload;
    procedure setDirty;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unjoin; overload;
    procedure unjoin(store: JExt.data.IStore); overload;
    function validate: JExt.data.IErrors;
  end;

//Ext.data

type
  JRecord = class external 'Record'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getFields: array of JExt.data.IField;
    function getName: String;
    function getProxy: JExt.data.proxy.IProxy;
    function id: String; overload;
    function id(rec: JExt.data.IModel): String; overload;
    procedure implement;
    procedure load; overload;
    procedure load(id: Variant); overload;
    procedure load(id: Variant; config: Variant); overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    procedure setFields; overload;
    procedure setFields(fields: Variant); overload;
    procedure setFields(fields: Variant; idProperty: Variant); overload;
    procedure setFields(fields: Variant; idProperty: Variant; clientIdProperty: Variant); overload;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
  end;

  JIRecord = class external(JExt.IBase, JExt.util.IObservable)
    associations: array of Variant; // nullable
    belongsTo: Variant; // nullable
    clientIdProperty: String; // nullable
    defaultProxyType: String; // nullable
    fields: Variant; // nullable
    hasMany: Variant; // nullable
    idProperty: Variant; // nullable
    idgen: Variant; // nullable
    persistenceProperty: String; // nullable
    proxy: Variant; // nullable
    validations: array of Variant; // nullable
    dirty: Boolean; // nullable
    editing: Boolean; // nullable
    isModel: Boolean; // nullable
    modified: Variant; // nullable
    phantom: Boolean; // nullable
    raw: Variant; // nullable
    store: JExt.data.IStore; // nullable
    stores: array of JExt.data.IStore; // nullable
    COMMIT: String; // nullable
    EDIT: String; // nullable
    REJECT: String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure beginEdit;
    procedure cancelEdit;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure commit; overload;
    procedure commit(silent: Boolean); overload;
    procedure commit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function copy: JExt.data.IModel; overload;
    function copy(id: String): JExt.data.IModel; overload;
    function destroy: JExt.data.IModel; overload;
    function destroy(options: Variant): JExt.data.IModel; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure endEdit; overload;
    procedure endEdit(silent: Boolean); overload;
    procedure endEdit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function get: Variant; overload;
    function get(fieldName: String): Variant; overload;
    function getAssociatedData: Variant;
    function getChanges: Variant;
    function getData: Variant; overload;
    function getData(includeAssociated: Boolean): Variant; overload;
    function getId: Variant;
    function getProxy: JExt.data.proxy.IProxy;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isModified: Boolean; overload;
    function isModified(fieldName: String): Boolean; overload;
    function isValid: Boolean;
    procedure join; overload;
    procedure join(store: JExt.data.IStore); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure reject; overload;
    procedure reject(silent: Boolean); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function save: JExt.data.IModel; overload;
    function save(options: Variant): JExt.data.IModel; overload;
    function set: array of String; overload;
    function set(fieldName: Variant): array of String; overload;
    function set(fieldName: Variant; newValue: Variant): array of String; overload;
    procedure setDirty;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unjoin; overload;
    procedure unjoin(store: JExt.data.IStore); overload;
    function validate: JExt.data.IErrors;
  end;

//Ext.data

type
  JNodeInterface = class external 'NodeInterface'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure decorate; overload;
    procedure decorate(modelClass: Variant); overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JINodeInterface = class external(JExt.IBase)
    allowDrag: Boolean; // nullable
    allowDrop: Boolean; // nullable
    checked: Boolean; // nullable
    children: array of JExt.data.INodeInterface; // nullable
    cls: String; // nullable
    depth: Float; // nullable
    expandable: Boolean; // nullable
    expanded: Boolean; // nullable
    href: String; // nullable
    hrefTarget: String; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    index: Float; // nullable
    isFirst: Boolean; // nullable
    isLast: Boolean; // nullable
    leaf: Boolean; // nullable
    loaded: Boolean; // nullable
    loading: Boolean; // nullable
    parentId: String; // nullable
    qshowDelay: Float; // nullable
    qtip: String; // nullable
    qtitle: String; // nullable
    root: Boolean; // nullable
    text: String; // nullable
    childNodes: array of JExt.data.INodeInterface; // nullable
    firstChild: JExt.data.INodeInterface; // nullable
    isNode: Boolean; // nullable
    lastChild: JExt.data.INodeInterface; // nullable
    nextSibling: JExt.data.INodeInterface; // nullable
    parentNode: JExt.data.INodeInterface; // nullable
    previousSibling: JExt.data.INodeInterface; // nullable
    function appendChild: JExt.data.INodeInterface; overload;
    function appendChild(node: Variant): JExt.data.INodeInterface; overload;
    function appendChild(node: Variant; suppressEvents: Boolean): JExt.data.INodeInterface; overload;
    function appendChild(node: Variant; suppressEvents: Boolean; commit: Boolean): JExt.data.INodeInterface; overload;
    procedure bubble; overload;
    procedure bubble(fn: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure cascadeBy; overload;
    procedure cascadeBy(fn: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure collapse; overload;
    procedure collapse(recursive: Boolean); overload;
    procedure collapse(recursive: Boolean; callback: Variant); overload;
    procedure collapse(recursive: Boolean; callback: Variant; scope: Variant); overload;
    procedure collapseChildren; overload;
    procedure collapseChildren(recursive: Variant); overload;
    procedure collapseChildren(recursive: Variant; callback: Variant); overload;
    procedure collapseChildren(recursive: Variant; callback: Variant; scope: Variant); overload;
    function contains: Boolean; overload;
    function contains(node: JExt.data.INodeInterface): Boolean; overload;
    function copy: JExt.data.INodeInterface; overload;
    function copy(id: String): JExt.data.INodeInterface; overload;
    function copy(id: String; deep: Boolean): JExt.data.INodeInterface; overload;
    function createNode: JExt.data.INodeInterface; overload;
    function createNode(node: Variant): JExt.data.INodeInterface; overload;
    procedure destroy; overload;
    procedure destroy(silent: Variant); overload;
    procedure eachChild; overload;
    procedure eachChild(fn: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure expand; overload;
    procedure expand(recursive: Boolean); overload;
    procedure expand(recursive: Boolean; callback: Variant); overload;
    procedure expand(recursive: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandChildren; overload;
    procedure expandChildren(recursive: Boolean); overload;
    procedure expandChildren(recursive: Boolean; callback: Variant); overload;
    procedure expandChildren(recursive: Boolean; callback: Variant; scope: Variant); overload;
    function findChild: JExt.data.INodeInterface; overload;
    function findChild(attribute: String): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function findChildBy: JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function getChildAt: JExt.data.INodeInterface; overload;
    function getChildAt(index: Float): JExt.data.INodeInterface; overload;
    function getDepth: Float;
    function getOwnerTree: JExt.tree.IPanel;
    function getPath: String; overload;
    function getPath(field: String): String; overload;
    function getPath(field: String; separator: String): String; overload;
    function hasChildNodes: Boolean;
    function indexOf: Float; overload;
    function indexOf(node: JExt.data.INodeInterface): Float; overload;
    function indexOfId: Float; overload;
    function indexOfId(id: String): Float; overload;
    function insertBefore: JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface; refNode: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertChild: JExt.data.INodeInterface; overload;
    function insertChild(index: Float): JExt.data.INodeInterface; overload;
    function insertChild(index: Float; node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function isAncestor: Boolean; overload;
    function isAncestor(node: JExt.data.INodeInterface): Boolean; overload;
    function isExpandable: Boolean;
    function isExpanded: Boolean;
    function isLeaf: Boolean;
    function isLoaded: Boolean;
    function isLoading: Boolean;
    function isRoot: Boolean;
    function isVisible: Boolean;
    function remove: JExt.data.INodeInterface; overload;
    function remove(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeAll: JExt.data.INodeInterface; overload;
    function removeAll(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeChild: JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface; destroy: Boolean): JExt.data.INodeInterface; overload;
    function replaceChild: JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface; oldChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    procedure serialize;
    procedure sort; overload;
    procedure sort(fn: Variant); overload;
    procedure sort(fn: Variant; recursive: Boolean); overload;
    procedure sort(fn: Variant; recursive: Boolean; suppressEvent: Boolean); overload;
    procedure updateInfo; overload;
    procedure updateInfo(commit: Boolean); overload;
    procedure updateInfo(commit: Boolean; info: Variant); overload;
  end;

//Ext.data

type
  JINodeStore = class external(JExt.data.IStore)
    node: JExt.data.IModel; // nullable
    recursive: Boolean; // nullable
    rootVisible: Boolean; // nullable
    treeStore: JExt.data.ITreeStore; // nullable
    isExpandingOrCollapsing: Float; // nullable
    isNodeStore: Boolean; // nullable
    function getTotalCount: Float;
  end;

//Ext.data

type
  JIOperation = class external(JExt.IBase)
    action: String; // nullable
    batch: JExt.data.IBatch; // nullable
    callback: Variant; // nullable
    filters: array of JExt.util.IFilter; // nullable
    groupers: array of JExt.util.IGrouper; // nullable
    limit: Float; // nullable
    params: Variant; // nullable
    scope: Variant; // nullable
    sorters: array of JExt.util.ISorter; // nullable
    start: Float; // nullable
    synchronous: Boolean; // nullable
    actionCommitRecordsRe: JRegExp; // nullable
    actionSkipSyncRe: JRegExp; // nullable
    function allowWrite: Boolean;
    procedure commitRecords; overload;
    procedure commitRecords(serverRecords: array of JExt.data.IModel); overload;
    function getError: Variant;
    function getRecords: array of JExt.data.IModel;
    function getResultSet: JExt.data.IResultSet;
    function hasException: Boolean;
    function isComplete: Boolean;
    function isRunning: Boolean;
    function isStarted: Boolean;
    procedure setCompleted;
    procedure setException; overload;
    procedure setException(error: Variant); overload;
    procedure setStarted;
    procedure setSuccessful;
    function wasSuccessful: Boolean;
  end;

//Ext.data

type
  JIPageMap = class external(JExt.util.ILruCache)
    function clear: JExt.util.IHashMap; overload;
    function clear(initial: Variant): JExt.util.IHashMap; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function getCount: Float;
    function remove: Boolean;
  end;

//Ext.data.proxy

type
  JIAjax = class external(JExt.data.proxy.IServer)
    binary: Boolean; // nullable
    headers: Variant; // nullable
    actionMethods: Variant; // nullable
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
  end;

//Ext.data

type
  JIHttpProxy = class external(JExt.data.proxy.IServer)
    binary: Boolean; // nullable
    headers: Variant; // nullable
    actionMethods: Variant; // nullable
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
  end;

//Ext.data

type
  JIAjaxProxy = class external(JExt.data.proxy.IServer)
    binary: Boolean; // nullable
    headers: Variant; // nullable
    actionMethods: Variant; // nullable
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
  end;

//Ext.data.proxy

type
  JIClient = class external(JExt.data.proxy.IProxy)
    isSynchronous: Boolean; // nullable
    procedure clear;
  end;

//Ext.data

type
  JIClientProxy = class external(JExt.data.proxy.IProxy)
    isSynchronous: Boolean; // nullable
    procedure clear;
  end;

//Ext.data.proxy

type
  JIDirect = class external(JExt.data.proxy.IServer)
    api: Variant; // nullable
    directFn: Variant; // nullable
    extraParams: Variant; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    function buildUrl: String;
    procedure doRequest; overload;
    procedure doRequest(operation: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIDirectProxy = class external(JExt.data.proxy.IServer)
    api: Variant; // nullable
    directFn: Variant; // nullable
    extraParams: Variant; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    function buildUrl: String;
    procedure doRequest; overload;
    procedure doRequest(operation: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIJsonP = class external(JExt.data.proxy.IServer)
    autoAppendParams: Boolean; // nullable
    callbackKey: String; // nullable
    recordParam: String; // nullable
    procedure abort;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    function encodeRecords: array of Variant; overload;
    function encodeRecords(records: array of JExt.data.IModel): array of Variant; overload;
  end;

//Ext.data

type
  JIScriptTagProxy = class external(JExt.data.proxy.IServer)
    autoAppendParams: Boolean; // nullable
    callbackKey: String; // nullable
    recordParam: String; // nullable
    procedure abort;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    function encodeRecords: array of Variant; overload;
    function encodeRecords(records: array of JExt.data.IModel): array of Variant; overload;
  end;

//Ext.data.proxy

type
  JILocalStorage = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data

type
  JILocalStorageProxy = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data.proxy

type
  JIMemory = class external(JExt.data.proxy.IClient)
    data: Variant; // nullable
    enablePaging: Boolean; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIMemoryProxy = class external(JExt.data.proxy.IClient)
    data: Variant; // nullable
    enablePaging: Boolean; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIProxy = class external(JExt.IBase, JExt.util.IObservable)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    isProxy: Boolean; // nullable
    isSynchronous: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getModel: JExt.data.IModel;
    function getReader: JExt.data.reader.IReader;
    function getWriter: JExt.data.writer.IWriter;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setModel(model: Variant; setOnStore: Boolean); overload;
    function setReader: JExt.data.reader.IReader; overload;
    function setReader(reader: Variant): JExt.data.reader.IReader; overload;
    function setWriter: JExt.data.writer.IWriter; overload;
    function setWriter(writer: Variant): JExt.data.writer.IWriter; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIDataProxy = class external(JExt.IBase, JExt.util.IObservable)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    isProxy: Boolean; // nullable
    isSynchronous: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getModel: JExt.data.IModel;
    function getReader: JExt.data.reader.IReader;
    function getWriter: JExt.data.writer.IWriter;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setModel(model: Variant; setOnStore: Boolean); overload;
    function setReader: JExt.data.reader.IReader; overload;
    function setReader(reader: Variant): JExt.data.reader.IReader; overload;
    function setWriter: JExt.data.writer.IWriter; overload;
    function setWriter(writer: Variant): JExt.data.writer.IWriter; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIProxy = class external(JExt.IBase, JExt.util.IObservable)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    isProxy: Boolean; // nullable
    isSynchronous: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getModel: JExt.data.IModel;
    function getReader: JExt.data.reader.IReader;
    function getWriter: JExt.data.writer.IWriter;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setModel(model: Variant; setOnStore: Boolean); overload;
    function setReader: JExt.data.reader.IReader; overload;
    function setReader(reader: Variant): JExt.data.reader.IReader; overload;
    function setWriter: JExt.data.writer.IWriter; overload;
    function setWriter(writer: Variant): JExt.data.writer.IWriter; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIRest = class external(JExt.data.proxy.IAjax)
    appendId: Boolean; // nullable
    batchActions: Boolean; // nullable
    format: String; // nullable
    actionMethods: Variant; // nullable
  end;

//Ext.data

type
  JIRestProxy = class external(JExt.data.proxy.IAjax)
    appendId: Boolean; // nullable
    batchActions: Boolean; // nullable
    format: String; // nullable
    actionMethods: Variant; // nullable
  end;

//Ext.data.proxy

type
  JIServer = class external(JExt.data.proxy.IProxy)
    api: Variant; // nullable
    cacheString: String; // nullable
    directionParam: String; // nullable
    extraParams: Variant; // nullable
    filterParam: String; // nullable
    groupDirectionParam: String; // nullable
    groupParam: String; // nullable
    idParam: String; // nullable
    limitParam: String; // nullable
    noCache: Boolean; // nullable
    pageParam: String; // nullable
    simpleGroupMode: Boolean; // nullable
    simpleSortMode: Boolean; // nullable
    sortParam: String; // nullable
    startParam: String; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure afterRequest; overload;
    procedure afterRequest(request: JExt.data.IRequest); overload;
    procedure afterRequest(request: JExt.data.IRequest; success: Boolean); overload;
    function buildRequest: JExt.data.IRequest; overload;
    function buildRequest(operation: JExt.data.IOperation): JExt.data.IRequest; overload;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure create;
    procedure destroy;
    procedure doRequest; overload;
    procedure doRequest(operation: JExt.data.IOperation); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function encodeFilters: String; overload;
    function encodeFilters(filters: array of JExt.util.IFilter): String; overload;
    function encodeSorters: String; overload;
    function encodeSorters(sorters: array of JExt.util.ISorter): String; overload;
    procedure read;
    procedure setExtraParam; overload;
    procedure setExtraParam(name: String); overload;
    procedure setExtraParam(name: String; value: Variant); overload;
    procedure update;
  end;

//Ext.data

type
  JIServerProxy = class external(JExt.data.proxy.IProxy)
    api: Variant; // nullable
    cacheString: String; // nullable
    directionParam: String; // nullable
    extraParams: Variant; // nullable
    filterParam: String; // nullable
    groupDirectionParam: String; // nullable
    groupParam: String; // nullable
    idParam: String; // nullable
    limitParam: String; // nullable
    noCache: Boolean; // nullable
    pageParam: String; // nullable
    simpleGroupMode: Boolean; // nullable
    simpleSortMode: Boolean; // nullable
    sortParam: String; // nullable
    startParam: String; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure afterRequest; overload;
    procedure afterRequest(request: JExt.data.IRequest); overload;
    procedure afterRequest(request: JExt.data.IRequest; success: Boolean); overload;
    function buildRequest: JExt.data.IRequest; overload;
    function buildRequest(operation: JExt.data.IOperation): JExt.data.IRequest; overload;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure create;
    procedure destroy;
    procedure doRequest; overload;
    procedure doRequest(operation: JExt.data.IOperation); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function encodeFilters: String; overload;
    function encodeFilters(filters: array of JExt.util.IFilter): String; overload;
    function encodeSorters: String; overload;
    function encodeSorters(sorters: array of JExt.util.ISorter): String; overload;
    procedure read;
    procedure setExtraParam; overload;
    procedure setExtraParam(name: String); overload;
    procedure setExtraParam(name: String; value: Variant); overload;
    procedure update;
  end;

//Ext.data.proxy

type
  JISessionStorage = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data

type
  JISessionStorageProxy = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data.proxy

type
  JIWebStorage = class external(JExt.data.proxy.IClient)
    id: String; // nullable
    cache: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: Variant); overload;
    procedure create(operation: Variant; callback: Variant); overload;
    procedure create(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure read; overload;
    procedure read(operation: Variant); overload;
    procedure read(operation: Variant; callback: Variant); overload;
    procedure read(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRecord(record: JExt.data.IModel; id: String); overload;
    procedure update; overload;
    procedure update(operation: Variant); overload;
    procedure update(operation: Variant; callback: Variant); overload;
    procedure update(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIWebStorageProxy = class external(JExt.data.proxy.IClient)
    id: String; // nullable
    cache: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: Variant); overload;
    procedure create(operation: Variant; callback: Variant); overload;
    procedure create(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure read; overload;
    procedure read(operation: Variant); overload;
    procedure read(operation: Variant; callback: Variant); overload;
    procedure read(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRecord(record: JExt.data.IModel; id: String); overload;
    procedure update; overload;
    procedure update(operation: Variant); overload;
    procedure update(operation: Variant; callback: Variant); overload;
    procedure update(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.reader

type
  JIArray = class external(JExt.data.reader.IJson)
    successProperty: String; // nullable
    totalProperty: String; // nullable
  end;

//Ext.data

type
  JIArrayReader = class external(JExt.data.reader.IJson)
    successProperty: String; // nullable
    totalProperty: String; // nullable
  end;

//Ext.data.reader

type
  JIJson = class external(JExt.data.reader.IReader)
    metaProperty: String; // nullable
    record: String; // nullable
    root: String; // nullable
    useSimpleAccessors: Boolean; // nullable
    jsonData: Variant; // nullable
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
  end;

//Ext.data

type
  JIJsonReader = class external(JExt.data.reader.IReader)
    metaProperty: String; // nullable
    record: String; // nullable
    root: String; // nullable
    useSimpleAccessors: Boolean; // nullable
    jsonData: Variant; // nullable
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
  end;

//Ext.data.reader

type
  JIReader = class external(JExt.IBase, JExt.util.IObservable)
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    readRecordsOnFailure: Boolean; // nullable
    root: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIReader = class external(JExt.IBase, JExt.util.IObservable)
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    readRecordsOnFailure: Boolean; // nullable
    root: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIDataReader = class external(JExt.IBase, JExt.util.IObservable)
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    readRecordsOnFailure: Boolean; // nullable
    root: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data.reader

type
  JIXml = class external(JExt.data.reader.IReader)
    namespace: String; // nullable
    record: String; // nullable
    xmlData: Variant; // nullable
    function getData: Variant; overload;
    function getData(data: Variant): Variant; overload;
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(doc: Variant): JExt.data.IResultSet; overload;
  end;

//Ext.data

type
  JIXmlReader = class external(JExt.data.reader.IReader)
    namespace: String; // nullable
    record: String; // nullable
    xmlData: Variant; // nullable
    function getData: Variant; overload;
    function getData(data: Variant): Variant; overload;
    function getResponseData: JExt.data.IResultSet; overload;
    function getResponseData(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(doc: Variant): JExt.data.IResultSet; overload;
  end;

//Ext.data

type
  JIRequest = class external(JExt.IBase)
    action: String; // nullable
    method: String; // nullable
    params: Variant; // nullable
    url: String; // nullable
  end;

//Ext.data

type
  JIResultSet = class external(JExt.IBase)
    count: Float; // nullable
    loaded: Boolean; // nullable
    records: array of JExt.data.IModel; // nullable
    success: Boolean; // nullable
    total: Float; // nullable
    totalRecords: Float; // nullable
  end;

//Ext.data

type
  JISequentialIdGenerator = class external(JExt.data.IIdGenerator)
    prefix: String; // nullable
    seed: Float; // nullable
    function generate: String;
  end;

//Ext.data

type
  JSortTypes = class external 'SortTypes'
    self: JExt.IClass;
    stripTagsRE: JRegExp;
    function asDate: Float; overload;
    function asDate(s: Variant): Float; overload;
    function asFloat: Float; overload;
    function asFloat(s: Variant): Float; overload;
    function asInt: Float; overload;
    function asInt(s: Variant): Float; overload;
    function asText: String; overload;
    function asText(s: Variant): String; overload;
    function asUCString: String; overload;
    function asUCString(s: Variant): String; overload;
    function asUCText: String; overload;
    function asUCText(s: Variant): String; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function none: Variant; overload;
    function none(s: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JISortTypes = class external(JExt.IBase)
  end;

//Ext.data

type
  JIStore = class external(JExt.data.IAbstractStore)
    autoDestroy: Boolean; // nullable
    buffered: Boolean; // nullable
    clearOnPageLoad: Boolean; // nullable
    clearRemovedOnLoad: Boolean; // nullable
    data: Variant; // nullable
    groupDir: String; // nullable
    groupField: String; // nullable
    groupers: JExt.util.IMixedCollection; // nullable
    leadingBufferZone: Float; // nullable
    pageSize: Float; // nullable
    proxy: Variant; // nullable
    purgePageCount: Float; // nullable
    remoteFilter: Boolean; // nullable
    remoteGroup: Boolean; // nullable
    remoteSort: Boolean; // nullable
    sortOnFilter: Boolean; // nullable
    trailingBufferZone: Float; // nullable
    currentPage: Float; // nullable
    snapshot: JExt.util.IMixedCollection; // nullable
    function add: array of JExt.data.IModel; overload;
    function add(model: Variant): array of JExt.data.IModel; overload;
    procedure addFilter; overload;
    procedure addFilter(filters: Variant); overload;
    procedure addFilter(filters: Variant; applyFilters: Boolean); overload;
    procedure addSorted; overload;
    procedure addSorted(record: JExt.data.IRecord); overload;
    function aggregate: Variant; overload;
    function aggregate(fn: Variant): Variant; overload;
    function aggregate(fn: Variant; scope: Variant): Variant; overload;
    function aggregate(fn: Variant; scope: Variant; grouped: Boolean): Variant; overload;
    function aggregate(fn: Variant; scope: Variant; grouped: Boolean; args: array of Variant): Variant; overload;
    function average: Variant; overload;
    function average(field: String): Variant; overload;
    function average(field: String; grouped: Boolean): Variant; overload;
    procedure clearFilter; overload;
    procedure clearFilter(suppressEvent: Boolean); overload;
    procedure clearGrouping;
    function collect: array of Variant; overload;
    function collect(dataIndex: String): array of Variant; overload;
    function collect(dataIndex: String; allowNull: Boolean): array of Variant; overload;
    function collect(dataIndex: String; allowNull: Boolean; bypassFilter: Boolean): array of Variant; overload;
    procedure commitChanges;
    function count: Float; overload;
    function count(grouped: Boolean): Float; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure filter; overload;
    procedure filter(filters: Variant); overload;
    procedure filter(filters: Variant; value: String); overload;
    procedure filterBy; overload;
    procedure filterBy(fn: Variant); overload;
    procedure filterBy(fn: Variant; scope: Variant); overload;
    function find: Float; overload;
    function find(fieldName: String): Float; overload;
    function find(fieldName: String; value: Variant): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean; exactMatch: Boolean): Float; overload;
    function findBy: Float; overload;
    function findBy(fn: Variant): Float; overload;
    function findBy(fn: Variant; scope: Variant): Float; overload;
    function findBy(fn: Variant; scope: Variant; startIndex: Float): Float; overload;
    function findExact: Float; overload;
    function findExact(fieldName: String): Float; overload;
    function findExact(fieldName: String; value: Variant): Float; overload;
    function findExact(fieldName: String; value: Variant; startIndex: Float): Float; overload;
    function findRecord: JExt.data.IModel; overload;
    function findRecord(fieldName: String): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean; exactMatch: Boolean): JExt.data.IModel; overload;
    function first: Variant; overload;
    function first(grouped: Boolean): Variant; overload;
    function getAt: JExt.data.IModel; overload;
    function getAt(index: Float): JExt.data.IModel; overload;
    function getById: JExt.data.IModel; overload;
    function getById(id: Variant): JExt.data.IModel; overload;
    function getCount: Float;
    function getGroupString: String; overload;
    function getGroupString(instance: JExt.data.IModel): String; overload;
    function getGroups: Variant; overload;
    function getGroups(groupName: String): Variant; overload;
    function getNewRecords: array of JExt.data.IModel;
    function getPageFromRecordIndex: Float; overload;
    function getPageFromRecordIndex(index: Float): Float; overload;
    function getRange: array of JExt.data.IModel; overload;
    function getRange(start: Float): array of JExt.data.IModel; overload;
    function getRange(start: Float; &end: Float): array of JExt.data.IModel; overload;
    function getRange(start: Float; &end: Float; options: Variant): array of JExt.data.IModel; overload;
    function getTotalCount: Float;
    function getUpdatedRecords: array of JExt.data.IModel;
    procedure group; overload;
    procedure group(groupers: Variant); overload;
    procedure group(groupers: Variant; direction: String); overload;
    procedure guaranteeRange; overload;
    procedure guaranteeRange(start: Variant); overload;
    procedure guaranteeRange(start: Variant; &end: Variant); overload;
    procedure guaranteeRange(start: Variant; &end: Variant; callback: Variant); overload;
    procedure guaranteeRange(start: Variant; &end: Variant; callback: Variant; scope: Variant); overload;
    procedure guaranteeRange(start: Variant; &end: Variant; callback: Variant; scope: Variant; options: Variant); overload;
    function indexOf: Float; overload;
    function indexOf(record: JExt.data.IModel): Float; overload;
    function indexOfId: Float; overload;
    function indexOfId(id: String): Float; overload;
    function indexOfTotal: Float; overload;
    function indexOfTotal(record: JExt.data.IModel): Float; overload;
    function insert: array of JExt.data.IModel; overload;
    function insert(index: Float): array of JExt.data.IModel; overload;
    function insert(index: Float; records: array of JExt.data.IModel): array of JExt.data.IModel; overload;
    function isFiltered: Boolean;
    function isGrouped: Boolean;
    function last: Variant; overload;
    function last(grouped: Boolean): Variant; overload;
    procedure load; overload;
    procedure load(options: Variant); overload;
    procedure loadData; overload;
    procedure loadData(data: Variant); overload;
    procedure loadData(data: Variant; append: Boolean); overload;
    procedure loadPage; overload;
    procedure loadPage(page: Float); overload;
    procedure loadPage(page: Float; options: Variant); overload;
    procedure loadRawData; overload;
    procedure loadRawData(data: array of Variant); overload;
    procedure loadRawData(data: array of Variant; append: Boolean); overload;
    procedure loadRecords; overload;
    procedure loadRecords(records: array of JExt.data.IModel); overload;
    procedure loadRecords(records: array of JExt.data.IModel; options: Variant); overload;
    function max: Variant; overload;
    function max(field: String): Variant; overload;
    function max(field: String; grouped: Boolean): Variant; overload;
    function min: Variant; overload;
    function min(field: String): Variant; overload;
    function min(field: String; grouped: Boolean): Variant; overload;
    procedure nextPage; overload;
    procedure nextPage(options: Variant); overload;
    procedure prefetch; overload;
    procedure prefetch(options: Variant); overload;
    procedure prefetchPage; overload;
    procedure prefetchPage(page: Float); overload;
    procedure prefetchPage(page: Float; options: Variant); overload;
    procedure prefetchRange; overload;
    procedure prefetchRange(start: Variant); overload;
    procedure prefetchRange(start: Variant; &end: Variant); overload;
    procedure previousPage; overload;
    procedure previousPage(options: Variant); overload;
    function query: JExt.util.IMixedCollection; overload;
    function query(&property: String): JExt.util.IMixedCollection; overload;
    function query(&property: String; value: Variant): JExt.util.IMixedCollection; overload;
    function query(&property: String; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function query(&property: String; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function query(&property: String; value: Variant; anyMatch: Boolean; caseSensitive: Boolean; exactMatch: Boolean): JExt.util.IMixedCollection; overload;
    function queryBy: JExt.util.IMixedCollection; overload;
    function queryBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function queryBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure rejectChanges;
    procedure reload; overload;
    procedure reload(options: Variant); overload;
    procedure remove; overload;
    procedure remove(records: Variant); overload;
    procedure removeAll; overload;
    procedure removeAll(silent: Boolean); overload;
    procedure removeAt; overload;
    procedure removeAt(index: Float); overload;
    procedure removeAt(index: Float; count: Float); overload;
    procedure removeFilter; overload;
    procedure removeFilter(toRemove: Variant); overload;
    procedure removeFilter(toRemove: Variant; applyFilters: Boolean); overload;
    function sort: array of JExt.util.ISorter;
    function sum: Float; overload;
    function sum(field: String): Float; overload;
    function sum(field: String; grouped: Boolean): Float; overload;
  end;

//Ext.data

type
  JStoreManager = class external 'StoreManager'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure register(stores: JExt.data.IStore);
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JIStoreManager = class external(JExt.util.IMixedCollection)
  end;

//Ext

type
  JStoreMgr = class external 'StoreMgr'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure register(stores: JExt.data.IStore);
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JIStoreMgr = class external(JExt.util.IMixedCollection)
  end;

//Ext.data

type
  JStoreMgr = class external 'StoreMgr'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure register(stores: JExt.data.IStore);
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JIStoreMgr = class external(JExt.util.IMixedCollection)
  end;

//Ext

type
  JStoreManager = class external 'StoreManager'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure register(stores: JExt.data.IStore);
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JIStoreManager = class external(JExt.util.IMixedCollection)
  end;

//Ext.data

type
  JITree = class external(JExt.IBase, JExt.util.IObservable)
    root: JExt.data.INodeInterface; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getNodeById: JExt.data.INodeInterface; overload;
    function getNodeById(id: String): JExt.data.INodeInterface; overload;
    function getRootNode: JExt.data.INodeInterface;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRootNode: JExt.data.INodeInterface;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function setRootNode: JExt.data.INodeInterface; overload;
    function setRootNode(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JITreeModel = class external(JExt.data.IModel)
  end;

//Ext.data

type
  JITreeStore = class external(JExt.data.IAbstractStore)
    clearOnLoad: Boolean; // nullable
    clearRemovedOnLoad: Boolean; // nullable
    defaultRootId: String; // nullable
    defaultRootProperty: String; // nullable
    defaultRootText: String; // nullable
    folderSort: Boolean; // nullable
    nodeParam: String; // nullable
    root: Variant; // nullable
    function getNewRecords: array of JExt.data.IModel;
    function getNodeById: JExt.data.INodeInterface; overload;
    function getNodeById(id: Variant): JExt.data.INodeInterface; overload;
    function getRootNode: JExt.data.INodeInterface;
    function getUpdatedRecords: array of JExt.data.IModel;
    procedure load; overload;
    procedure load(options: Variant); overload;
    procedure removeAll;
    function setProxy: JExt.data.proxy.IProxy; overload;
    function setProxy(proxy: Variant): JExt.data.proxy.IProxy; overload;
    function setRootNode: JExt.data.INodeInterface; overload;
    function setRootNode(root: Variant): JExt.data.INodeInterface; overload;
  end;

//Ext.data

type
  JTypes = class external 'Types'
    AUTO: Variant;
    BOOL: Variant;
    BOOLEAN: Variant;
    DATE: Variant;
    FLOAT: Variant;
    INT: Variant;
    INTEGER: Variant;
    NUMBER: Variant;
    &STRING: Variant;
    self: JExt.IClass;
    stripRe: JRegExp;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JITypes = class external(JExt.IBase)
  end;

//Ext.data

type
  JIUuidGenerator = class external(JExt.data.IIdGenerator)
    version: Float; // nullable
    salt: Variant; // nullable
    timestamp: Variant; // nullable
    procedure reconfigure; overload;
    procedure reconfigure(config: Variant); overload;
  end;

//Ext.data

type
  JValidations = class external 'Validations'
    emailMessage: String;
    emailRe: JRegExp;
    exclusionMessage: String;
    formatMessage: String;
    inclusionMessage: String;
    lengthMessage: String;
    presenceMessage: String;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function email: Boolean; overload;
    function email(config: Variant): Boolean; overload;
    function email(config: Variant; email: String): Boolean; overload;
    function exclusion: Boolean; overload;
    function exclusion(config: Variant): Boolean; overload;
    function exclusion(config: Variant; value: String): Boolean; overload;
    function format: Boolean; overload;
    function format(config: Variant): Boolean; overload;
    function format(config: Variant; value: String): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function inclusion: Boolean; overload;
    function inclusion(config: Variant): Boolean; overload;
    function inclusion(config: Variant; value: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function length: Boolean; overload;
    function length(config: Variant): Boolean; overload;
    function length(config: Variant; value: String): Boolean; overload;
    function presence: Boolean; overload;
    function presence(config: Variant): Boolean; overload;
    function presence(config: Variant; value: Variant): Boolean; overload;
    function statics: JExt.IClass;
  end;

  JIValidations = class external(JExt.IBase)
  end;

//Ext.data.writer

type
  JIJson = class external(JExt.data.writer.IWriter)
    allowSingle: Boolean; // nullable
    encode: Boolean; // nullable
    expandData: Boolean; // nullable
    root: String; // nullable
    procedure getExpandedData; overload;
    procedure getExpandedData(data: Variant); overload;
  end;

//Ext.data

type
  JIJsonWriter = class external(JExt.data.writer.IWriter)
    allowSingle: Boolean; // nullable
    encode: Boolean; // nullable
    expandData: Boolean; // nullable
    root: String; // nullable
    procedure getExpandedData; overload;
    procedure getExpandedData(data: Variant); overload;
  end;

//Ext.data.writer

type
  JIWriter = class external(JExt.IBase)
    dateFormat: String; // nullable
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    writeRecordId: Boolean; // nullable
    function getRecordData: Variant; overload;
    function getRecordData(record: JExt.data.IModel): Variant; overload;
    function getRecordData(record: JExt.data.IModel; operation: JExt.data.IOperation): Variant; overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data

type
  JIDataWriter = class external(JExt.IBase)
    dateFormat: String; // nullable
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    writeRecordId: Boolean; // nullable
    function getRecordData: Variant; overload;
    function getRecordData(record: JExt.data.IModel): Variant; overload;
    function getRecordData(record: JExt.data.IModel; operation: JExt.data.IOperation): Variant; overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data

type
  JIWriter = class external(JExt.IBase)
    dateFormat: String; // nullable
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    writeRecordId: Boolean; // nullable
    function getRecordData: Variant; overload;
    function getRecordData(record: JExt.data.IModel): Variant; overload;
    function getRecordData(record: JExt.data.IModel; operation: JExt.data.IOperation): Variant; overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data.writer

type
  JIXml = class external(JExt.data.writer.IWriter)
    defaultDocumentRoot: String; // nullable
    documentRoot: String; // nullable
    header: String; // nullable
    record: String; // nullable
  end;

//Ext.data

type
  JIXmlWriter = class external(JExt.data.writer.IWriter)
    defaultDocumentRoot: String; // nullable
    documentRoot: String; // nullable
    header: String; // nullable
    record: String; // nullable
  end;

//Ext.data

type
  JIXmlStore = class external(JExt.data.IStore)
  end;

//Ext

type
  JDate = class external 'Date'
    DAY: String;
    HOUR: String;
    MILLI: String;
    MINUTE: String;
    MONTH: String;
    SECOND: String;
    YEAR: String;
    dayNames: array of String;
    defaultFormat: String;
    defaults: Variant;
    formatCodes: Variant;
    formatFunctions: Variant;
    monthNames: array of String;
    monthNumbers: Variant;
    parseFunctions: Variant;
    useStrict: Boolean;
    function add: Variant; overload;
    function add(date: Variant): Variant; overload;
    function add(date: Variant; interval: String): Variant; overload;
    function add(date: Variant; interval: String; value: Float): Variant; overload;
    function between: Boolean; overload;
    function between(date: Variant): Boolean; overload;
    function between(date: Variant; start: Variant): Boolean; overload;
    function between(date: Variant; start: Variant; &end: Variant): Boolean; overload;
    function clearTime: Variant; overload;
    function clearTime(date: Variant): Variant; overload;
    function clearTime(date: Variant; clone: Boolean): Variant; overload;
    function clone: Variant; overload;
    function clone(date: Variant): Variant; overload;
    function format: String; overload;
    function format(date: Variant): String; overload;
    function format(date: Variant; format: String): String; overload;
    function formatContainsDateInfo: Boolean; overload;
    function formatContainsDateInfo(format: String): Boolean; overload;
    function formatContainsHourInfo: Boolean; overload;
    function formatContainsHourInfo(format: String): Boolean; overload;
    function getDayOfYear: Float; overload;
    function getDayOfYear(date: Variant): Float; overload;
    function getDaysInMonth: Float; overload;
    function getDaysInMonth(date: Variant): Float; overload;
    function getElapsed: Float; overload;
    function getElapsed(dateA: Variant): Float; overload;
    function getElapsed(dateA: Variant; dateB: Variant): Float; overload;
    function getFirstDateOfMonth: Variant; overload;
    function getFirstDateOfMonth(date: Variant): Variant; overload;
    function getFirstDayOfMonth: Float; overload;
    function getFirstDayOfMonth(date: Variant): Float; overload;
    function getGMTOffset: String; overload;
    function getGMTOffset(date: Variant): String; overload;
    function getGMTOffset(date: Variant; colon: Boolean): String; overload;
    function getLastDateOfMonth: Variant; overload;
    function getLastDateOfMonth(date: Variant): Variant; overload;
    function getLastDayOfMonth: Float; overload;
    function getLastDayOfMonth(date: Variant): Float; overload;
    function getMonthNumber: Float; overload;
    function getMonthNumber(name: String): Float; overload;
    function getShortDayName: String; overload;
    function getShortDayName(day: Float): String; overload;
    function getShortMonthName: String; overload;
    function getShortMonthName(month: Float): String; overload;
    function getSuffix: String; overload;
    function getSuffix(date: Variant): String; overload;
    function getTimezone: String; overload;
    function getTimezone(date: Variant): String; overload;
    function getWeekOfYear: Float; overload;
    function getWeekOfYear(date: Variant): Float; overload;
    function isDST: Boolean; overload;
    function isDST(date: Variant): Boolean; overload;
    function isEqual: Boolean; overload;
    function isEqual(date1: Variant): Boolean; overload;
    function isEqual(date1: Variant; date2: Variant): Boolean; overload;
    function isLeapYear: Boolean; overload;
    function isLeapYear(date: Variant): Boolean; overload;
    function isValid: Boolean; overload;
    function isValid(year: Float): Boolean; overload;
    function isValid(year: Float; month: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float; millisecond: Float): Boolean; overload;
    function now: Float;
    function parse: Variant; overload;
    function parse(input: String): Variant; overload;
    function parse(input: String; format: String): Variant; overload;
    function parse(input: String; format: String; strict: Boolean): Variant; overload;
    function subtract: Variant; overload;
    function subtract(date: Variant): Variant; overload;
    function subtract(date: Variant; interval: String): Variant; overload;
    function subtract(date: Variant; interval: String; value: Float): Variant; overload;
    function unescapeFormat: String; overload;
    function unescapeFormat(format: String): String; overload;
  end;

  JIDate = class external
  end;

//Ext.dd

type
  JIDD = class external(JExt.dd.IDragDrop)
    scroll: Boolean; // nullable
    procedure alignElWithMouse; overload;
    procedure alignElWithMouse(el: JHTMLElement); overload;
    procedure alignElWithMouse(el: JHTMLElement; iPageX: Float); overload;
    procedure alignElWithMouse(el: JHTMLElement; iPageX: Float; iPageY: Float); overload;
    procedure applyConfig;
    procedure autoOffset; overload;
    procedure autoOffset(iPageX: Float); overload;
    procedure autoOffset(iPageX: Float; iPageY: Float); overload;
    procedure b4Drag; overload;
    procedure b4Drag(e: Variant); overload;
    procedure b4MouseDown; overload;
    procedure b4MouseDown(e: Variant); overload;
    procedure cachePosition; overload;
    procedure cachePosition(iPageX: Float); overload;
    procedure cachePosition(iPageX: Float; iPageY: Float); overload;
    procedure setDelta; overload;
    procedure setDelta(iDeltaX: Float); overload;
    procedure setDelta(iDeltaX: Float; iDeltaY: Float); overload;
    procedure setDragElPos; overload;
    procedure setDragElPos(iPageX: Float); overload;
    procedure setDragElPos(iPageX: Float; iPageY: Float); overload;
    function toString: String;
  end;

//Ext.dd

type
  JIDDProxy = class external(JExt.dd.IDD)
    centerFrame: Boolean; // nullable
    resizeFrame: Boolean; // nullable
    dragElId: String; // nullable
    procedure applyConfig;
    procedure b4MouseDown; overload;
    procedure b4MouseDown(e: Variant); overload;
    procedure createFrame;
    procedure endDrag; overload;
    procedure endDrag(e: Variant); overload;
    procedure initFrame;
    function toString: String;
  end;

//Ext.dd

type
  JIDDTarget = class external(JExt.dd.IDragDrop)
    function toString: String;
  end;

//Ext.dd

type
  JIDragDrop = class external(JExt.IBase)
    available: Boolean; // nullable
    config: Variant; // nullable
    defaultPadding: Variant; // nullable
    groups: Variant; // nullable
    hasOuterHandles: Boolean; // nullable
    id: String; // nullable
    ignoreSelf: Boolean; // nullable
    invalidHandleClasses: array of String; // nullable
    invalidHandleIds: Variant; // nullable
    invalidHandleTypes: Variant; // nullable
    isTarget: Boolean; // nullable
    maintainOffset: Boolean; // nullable
    moveOnly: Boolean; // nullable
    padding: array of Float; // nullable
    primaryButtonOnly: Boolean; // nullable
    xTicks: array of Float; // nullable
    yTicks: array of Float; // nullable
    procedure addInvalidHandleClass; overload;
    procedure addInvalidHandleClass(cssClass: String); overload;
    procedure addInvalidHandleId; overload;
    procedure addInvalidHandleId(id: String); overload;
    procedure addInvalidHandleType; overload;
    procedure addInvalidHandleType(tagName: String); overload;
    procedure addToGroup; overload;
    procedure addToGroup(sGroup: String); overload;
    procedure applyConfig;
    procedure clearConstraints;
    procedure clearTicks;
    procedure constrainTo; overload;
    procedure constrainTo(constrainTo: Variant); overload;
    procedure constrainTo(constrainTo: Variant; pad: Variant); overload;
    procedure constrainTo(constrainTo: Variant; pad: Variant; inContent: Boolean); overload;
    procedure destroy;
    procedure endDrag; overload;
    procedure endDrag(e: JEvent); overload;
    function getDragEl: JHTMLElement;
    function getEl: JHTMLElement;
    procedure init; overload;
    procedure init(id: String); overload;
    procedure init(id: String; sGroup: String); overload;
    procedure init(id: String; sGroup: String; config: Variant); overload;
    procedure initTarget; overload;
    procedure initTarget(id: String); overload;
    procedure initTarget(id: String; sGroup: String); overload;
    procedure initTarget(id: String; sGroup: String; config: Variant); overload;
    function isLocked: Boolean;
    function isValidHandleChild: Boolean; overload;
    function isValidHandleChild(node: JHTMLElement): Boolean; overload;
    procedure lock;
    procedure onAvailable;
    procedure onDrag; overload;
    procedure onDrag(e: JEvent); overload;
    procedure onDragDrop; overload;
    procedure onDragDrop(e: JEvent); overload;
    procedure onDragDrop(e: JEvent; id: Variant); overload;
    procedure onDragEnter; overload;
    procedure onDragEnter(e: JEvent); overload;
    procedure onDragEnter(e: JEvent; id: Variant); overload;
    procedure onDragOut; overload;
    procedure onDragOut(e: JEvent); overload;
    procedure onDragOut(e: JEvent; id: Variant); overload;
    procedure onDragOver; overload;
    procedure onDragOver(e: JEvent); overload;
    procedure onDragOver(e: JEvent; id: Variant); overload;
    procedure onInvalidDrop; overload;
    procedure onInvalidDrop(e: JEvent); overload;
    procedure onMouseDown; overload;
    procedure onMouseDown(e: JEvent); overload;
    procedure onMouseUp; overload;
    procedure onMouseUp(e: JEvent); overload;
    procedure removeFromGroup; overload;
    procedure removeFromGroup(sGroup: String); overload;
    procedure removeInvalidHandleClass; overload;
    procedure removeInvalidHandleClass(cssClass: String); overload;
    procedure removeInvalidHandleId; overload;
    procedure removeInvalidHandleId(id: String); overload;
    procedure removeInvalidHandleType; overload;
    procedure removeInvalidHandleType(tagName: String); overload;
    procedure resetConstraints; overload;
    procedure resetConstraints(maintainOffset: Boolean); overload;
    procedure setDragElId; overload;
    procedure setDragElId(id: String); overload;
    procedure setHandleElId; overload;
    procedure setHandleElId(id: String); overload;
    procedure setInitPosition; overload;
    procedure setInitPosition(diffX: Float); overload;
    procedure setInitPosition(diffX: Float; diffY: Float); overload;
    procedure setOuterHandleElId; overload;
    procedure setOuterHandleElId(id: String); overload;
    procedure setPadding; overload;
    procedure setPadding(iTop: Float); overload;
    procedure setPadding(iTop: Float; iRight: Float); overload;
    procedure setPadding(iTop: Float; iRight: Float; iBot: Float); overload;
    procedure setPadding(iTop: Float; iRight: Float; iBot: Float; iLeft: Float); overload;
    procedure setXConstraint; overload;
    procedure setXConstraint(iLeft: Float); overload;
    procedure setXConstraint(iLeft: Float; iRight: Float); overload;
    procedure setXConstraint(iLeft: Float; iRight: Float; iTickSize: Float); overload;
    procedure setYConstraint; overload;
    procedure setYConstraint(iUp: Float); overload;
    procedure setYConstraint(iUp: Float; iDown: Float); overload;
    procedure setYConstraint(iUp: Float; iDown: Float; iTickSize: Float); overload;
    procedure startDrag; overload;
    procedure startDrag(x: Float); overload;
    procedure startDrag(x: Float; y: Float); overload;
    function toString: String;
    procedure unlock;
    procedure unreg;
  end;

//Ext.dd

type
  JIDragDropElement = class external
    function getPosX: Float; overload;
    function getPosX(el: JHTMLElement): Float; overload;
    function getPosY: Float; overload;
    function getPosY(el: JHTMLElement): Float; overload;
    function getScrollLeft: Float;
    function getScrollTop: Float;
    function getStyle: String; overload;
    function getStyle(el: JHTMLElement): String; overload;
    function getStyle(el: JHTMLElement; styleProp: String): String; overload;
    procedure handleWasClicked; overload;
    procedure handleWasClicked(node: JHTMLElement); overload;
    procedure moveToEl; overload;
    procedure moveToEl(moveEl: JHTMLElement); overload;
    procedure moveToEl(moveEl: JHTMLElement; targetEl: JHTMLElement); overload;
    function numericSort: Float; overload;
    function numericSort(a: Float): Float; overload;
    function numericSort(a: Float; b: Float): Float; overload;
    procedure swapNode; overload;
    procedure swapNode(n1: JHTMLElement); overload;
    procedure swapNode(n1: JHTMLElement; n2: JHTMLElement); overload;
  end;

//Ext.dd.dragdropmanager

type
  JIElementWrapper = class external
    css: Variant; // nullable
    el: Variant; // nullable
    id: Variant; // nullable
  end;

//Ext.dd

type
  JDragDropManager = class external 'DragDropManager'
    INTERSECT: Float;
    POINT: Float;
    clickPixelThresh: Float;
    clickTimeThresh: Float;
    dragCls: String;
    mode: Float;
    notifyOccluded: Boolean;
    preventDefault: Boolean;
    self: JExt.IClass;
    stopPropagation: Boolean;
    useCache: Boolean;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getBestMatch: JExt.dd.IDragDrop; overload;
    function getBestMatch(dds: array of JExt.dd.IDragDrop): JExt.dd.IDragDrop; overload;
    function getCss: Variant; overload;
    function getCss(id: String): Variant; overload;
    function getDDById: JExt.dd.IDragDrop; overload;
    function getDDById(id: String): JExt.dd.IDragDrop; overload;
    function getElement: Variant; overload;
    function getElement(id: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getLocation: JExt.util.IRegion; overload;
    function getLocation(oDD: JExt.dd.IDragDrop): JExt.util.IRegion; overload;
    function getRelated: array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop): array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop; bTargetsOnly: Boolean): array of JExt.dd.IDragDrop; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isDragDrop: Boolean; overload;
    function isDragDrop(id: String): Boolean; overload;
    function isHandle: Boolean; overload;
    function isHandle(id: String): Boolean; overload;
    function isLegalTarget: Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop; oTargetDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLocked: Boolean;
    function isTypeOfDD: Boolean; overload;
    function isTypeOfDD(the: Variant): Boolean; overload;
    procedure lock;
    procedure refreshCache; overload;
    procedure refreshCache(groups: Variant); overload;
    procedure regDragDrop; overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop); overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop; sGroup: String); overload;
    procedure regHandle; overload;
    procedure regHandle(sDDId: String); overload;
    procedure regHandle(sDDId: String; sHandleId: String); overload;
    procedure startDrag; overload;
    procedure startDrag(x: Float); overload;
    procedure startDrag(x: Float; y: Float); overload;
    function statics: JExt.IClass;
    procedure stopEvent; overload;
    procedure stopEvent(e: JEvent); overload;
    procedure unlock;
    function verifyEl: Boolean; overload;
    function verifyEl(el: JHTMLElement): Boolean; overload;
  end;

  JIDragDropManager = class external(JExt.IBase)
  end;

//Ext.dd

type
  JDragDropMgr = class external 'DragDropMgr'
    INTERSECT: Float;
    POINT: Float;
    clickPixelThresh: Float;
    clickTimeThresh: Float;
    dragCls: String;
    mode: Float;
    notifyOccluded: Boolean;
    preventDefault: Boolean;
    self: JExt.IClass;
    stopPropagation: Boolean;
    useCache: Boolean;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getBestMatch: JExt.dd.IDragDrop; overload;
    function getBestMatch(dds: array of JExt.dd.IDragDrop): JExt.dd.IDragDrop; overload;
    function getCss: Variant; overload;
    function getCss(id: String): Variant; overload;
    function getDDById: JExt.dd.IDragDrop; overload;
    function getDDById(id: String): JExt.dd.IDragDrop; overload;
    function getElement: Variant; overload;
    function getElement(id: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getLocation: JExt.util.IRegion; overload;
    function getLocation(oDD: JExt.dd.IDragDrop): JExt.util.IRegion; overload;
    function getRelated: array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop): array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop; bTargetsOnly: Boolean): array of JExt.dd.IDragDrop; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isDragDrop: Boolean; overload;
    function isDragDrop(id: String): Boolean; overload;
    function isHandle: Boolean; overload;
    function isHandle(id: String): Boolean; overload;
    function isLegalTarget: Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop; oTargetDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLocked: Boolean;
    function isTypeOfDD: Boolean; overload;
    function isTypeOfDD(the: Variant): Boolean; overload;
    procedure lock;
    procedure refreshCache; overload;
    procedure refreshCache(groups: Variant); overload;
    procedure regDragDrop; overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop); overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop; sGroup: String); overload;
    procedure regHandle; overload;
    procedure regHandle(sDDId: String); overload;
    procedure regHandle(sDDId: String; sHandleId: String); overload;
    procedure startDrag; overload;
    procedure startDrag(x: Float); overload;
    procedure startDrag(x: Float; y: Float); overload;
    function statics: JExt.IClass;
    procedure stopEvent; overload;
    procedure stopEvent(e: JEvent); overload;
    procedure unlock;
    function verifyEl: Boolean; overload;
    function verifyEl(el: JHTMLElement): Boolean; overload;
  end;

  JIDragDropMgr = class external(JExt.IBase)
  end;

//Ext.dd

type
  JDDM = class external 'DDM'
    INTERSECT: Float;
    POINT: Float;
    clickPixelThresh: Float;
    clickTimeThresh: Float;
    dragCls: String;
    mode: Float;
    notifyOccluded: Boolean;
    preventDefault: Boolean;
    self: JExt.IClass;
    stopPropagation: Boolean;
    useCache: Boolean;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getBestMatch: JExt.dd.IDragDrop; overload;
    function getBestMatch(dds: array of JExt.dd.IDragDrop): JExt.dd.IDragDrop; overload;
    function getCss: Variant; overload;
    function getCss(id: String): Variant; overload;
    function getDDById: JExt.dd.IDragDrop; overload;
    function getDDById(id: String): JExt.dd.IDragDrop; overload;
    function getElement: Variant; overload;
    function getElement(id: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getLocation: JExt.util.IRegion; overload;
    function getLocation(oDD: JExt.dd.IDragDrop): JExt.util.IRegion; overload;
    function getRelated: array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop): array of JExt.dd.IDragDrop; overload;
    function getRelated(p_oDD: JExt.dd.IDragDrop; bTargetsOnly: Boolean): array of JExt.dd.IDragDrop; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isDragDrop: Boolean; overload;
    function isDragDrop(id: String): Boolean; overload;
    function isHandle: Boolean; overload;
    function isHandle(id: String): Boolean; overload;
    function isLegalTarget: Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLegalTarget(oDD: JExt.dd.IDragDrop; oTargetDD: JExt.dd.IDragDrop): Boolean; overload;
    function isLocked: Boolean;
    function isTypeOfDD: Boolean; overload;
    function isTypeOfDD(the: Variant): Boolean; overload;
    procedure lock;
    procedure refreshCache; overload;
    procedure refreshCache(groups: Variant); overload;
    procedure regDragDrop; overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop); overload;
    procedure regDragDrop(oDD: JExt.dd.IDragDrop; sGroup: String); overload;
    procedure regHandle; overload;
    procedure regHandle(sDDId: String); overload;
    procedure regHandle(sDDId: String; sHandleId: String); overload;
    procedure startDrag; overload;
    procedure startDrag(x: Float); overload;
    procedure startDrag(x: Float; y: Float); overload;
    function statics: JExt.IClass;
    procedure stopEvent; overload;
    procedure stopEvent(e: JEvent); overload;
    procedure unlock;
    function verifyEl: Boolean; overload;
    function verifyEl(el: JHTMLElement): Boolean; overload;
  end;

  JIDDM = class external(JExt.IBase)
  end;

//Ext.dd

type
  JIDragSource = class external(JExt.dd.IDDProxy)
    animRepair: Boolean; // nullable
    ddGroup: String; // nullable
    dropAllowed: String; // nullable
    dropNotAllowed: String; // nullable
    repairHighlightColor: String; // nullable
    dragData: Variant; // nullable
    procedure afterDragDrop; overload;
    procedure afterDragDrop(target: JExt.dd.IDragDrop); overload;
    procedure afterDragDrop(target: JExt.dd.IDragDrop; e: JEvent); overload;
    procedure afterDragDrop(target: JExt.dd.IDragDrop; e: JEvent; id: String); overload;
    procedure afterDragEnter; overload;
    procedure afterDragEnter(target: JExt.dd.IDragDrop); overload;
    procedure afterDragEnter(target: JExt.dd.IDragDrop; e: JEvent); overload;
    procedure afterDragEnter(target: JExt.dd.IDragDrop; e: JEvent; id: String); overload;
    procedure afterDragOut; overload;
    procedure afterDragOut(target: JExt.dd.IDragDrop); overload;
    procedure afterDragOut(target: JExt.dd.IDragDrop; e: JEvent); overload;
    procedure afterDragOut(target: JExt.dd.IDragDrop; e: JEvent; id: String); overload;
    procedure afterDragOver; overload;
    procedure afterDragOver(target: JExt.dd.IDragDrop); overload;
    procedure afterDragOver(target: JExt.dd.IDragDrop; e: JEvent); overload;
    procedure afterDragOver(target: JExt.dd.IDragDrop; e: JEvent; id: String); overload;
    procedure afterInvalidDrop; overload;
    procedure afterInvalidDrop(e: JEvent); overload;
    procedure afterInvalidDrop(e: JEvent; id: String); overload;
    procedure afterValidDrop; overload;
    procedure afterValidDrop(target: Variant); overload;
    procedure afterValidDrop(target: Variant; e: JEvent); overload;
    procedure afterValidDrop(target: Variant; e: JEvent; id: String); overload;
    procedure alignElWithMouse;
    function beforeDragDrop: Boolean; overload;
    function beforeDragDrop(target: JExt.dd.IDragDrop): Boolean; overload;
    function beforeDragDrop(target: JExt.dd.IDragDrop; e: JEvent): Boolean; overload;
    function beforeDragDrop(target: JExt.dd.IDragDrop; e: JEvent; id: String): Boolean; overload;
    function beforeDragEnter: Boolean; overload;
    function beforeDragEnter(target: JExt.dd.IDragDrop): Boolean; overload;
    function beforeDragEnter(target: JExt.dd.IDragDrop; e: JEvent): Boolean; overload;
    function beforeDragEnter(target: JExt.dd.IDragDrop; e: JEvent; id: String): Boolean; overload;
    function beforeDragOut: Boolean; overload;
    function beforeDragOut(target: JExt.dd.IDragDrop): Boolean; overload;
    function beforeDragOut(target: JExt.dd.IDragDrop; e: JEvent): Boolean; overload;
    function beforeDragOut(target: JExt.dd.IDragDrop; e: JEvent; id: String): Boolean; overload;
    function beforeDragOver: Boolean; overload;
    function beforeDragOver(target: JExt.dd.IDragDrop): Boolean; overload;
    function beforeDragOver(target: JExt.dd.IDragDrop; e: JEvent): Boolean; overload;
    function beforeDragOver(target: JExt.dd.IDragDrop; e: JEvent; id: String): Boolean; overload;
    function beforeInvalidDrop: Boolean; overload;
    function beforeInvalidDrop(target: JExt.dd.IDragDrop): Boolean; overload;
    function beforeInvalidDrop(target: JExt.dd.IDragDrop; e: JEvent): Boolean; overload;
    function beforeInvalidDrop(target: JExt.dd.IDragDrop; e: JEvent; id: String): Boolean; overload;
    procedure destroy;
    function getDragData: Variant; overload;
    function getDragData(e: Variant): Variant; overload;
    function getProxy: JExt.dd.IStatusProxy;
    procedure hideProxy;
    function onBeforeDrag: Boolean; overload;
    function onBeforeDrag(data: Variant): Boolean; overload;
    function onBeforeDrag(data: Variant; e: JEvent): Boolean; overload;
    procedure onStartDrag; overload;
    procedure onStartDrag(x: Float); overload;
    procedure onStartDrag(x: Float; y: Float); overload;
  end;

//Ext.dd

type
  JIDragTracker = class external(JExt.IBase, JExt.util.IObservable)
    autoStart: Variant; // nullable
    constrainTo: Variant; // nullable
    delegate: String; // nullable
    overCls: String; // nullable
    preventDefault: Boolean; // nullable
    stopEvent: Boolean; // nullable
    tolerance: Float; // nullable
    trackOver: Boolean; // nullable
    active: Boolean; // nullable
    dragTarget: JHTMLElement; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getDragTarget: JExt.IElement;
    function getOffset: array of Float; overload;
    function getOffset(constrainMode: String): array of Float; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure initEl; overload;
    procedure initEl(el: Variant); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onBeforeStart; overload;
    procedure onBeforeStart(e: JExt.IEventObject); overload;
    procedure onDrag; overload;
    procedure onDrag(e: JExt.IEventObject); overload;
    procedure onEnd; overload;
    procedure onEnd(e: JExt.IEventObject); overload;
    procedure onStart; overload;
    procedure onStart(e: JExt.IEventObject); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.dd

type
  JIDragZone = class external(JExt.dd.IDragSource)
    containerScroll: Variant; // nullable
    scrollEl: Variant; // nullable
    procedure destroy;
    function getDragData: Variant; overload;
    function getDragData(e: JEvent): Variant; overload;
    function getRepairXY: array of Float; overload;
    function getRepairXY(e: JEvent): array of Float; overload;
    function onInitDrag: Boolean; overload;
    function onInitDrag(x: Float): Boolean; overload;
    function onInitDrag(x: Float; y: Float): Boolean; overload;
  end;

//Ext.dd

type
  JIDropTarget = class external(JExt.dd.IDDTarget)
    ddGroup: String; // nullable
    dropAllowed: String; // nullable
    dropNotAllowed: String; // nullable
    overClass: String; // nullable
    isTarget: Boolean; // nullable
    procedure destroy;
    function notifyDrop: Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource): Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource; e: JEvent): Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource; e: JEvent; data: Variant): Boolean; overload;
    function notifyEnter: String; overload;
    function notifyEnter(source: JExt.dd.IDragSource): String; overload;
    function notifyEnter(source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function notifyEnter(source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
    procedure notifyOut; overload;
    procedure notifyOut(source: JExt.dd.IDragSource); overload;
    procedure notifyOut(source: JExt.dd.IDragSource; e: JEvent); overload;
    procedure notifyOut(source: JExt.dd.IDragSource; e: JEvent; data: Variant); overload;
    function notifyOver: String; overload;
    function notifyOver(source: JExt.dd.IDragSource): String; overload;
    function notifyOver(source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function notifyOver(source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
  end;

//Ext.dd

type
  JIDropZone = class external(JExt.dd.IDropTarget)
    function getTargetFromEvent: Variant; overload;
    function getTargetFromEvent(e: JEvent): Variant; overload;
    function notifyDrop: Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource): Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource; e: JEvent): Boolean; overload;
    function notifyDrop(source: JExt.dd.IDragSource; e: JEvent; data: Variant): Boolean; overload;
    function notifyEnter: String; overload;
    function notifyEnter(source: JExt.dd.IDragSource): String; overload;
    function notifyEnter(source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function notifyEnter(source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
    procedure notifyOut; overload;
    procedure notifyOut(source: JExt.dd.IDragSource); overload;
    procedure notifyOut(source: JExt.dd.IDragSource; e: JEvent); overload;
    procedure notifyOut(source: JExt.dd.IDragSource; e: JEvent; data: Variant); overload;
    function notifyOver: String; overload;
    function notifyOver(source: JExt.dd.IDragSource): String; overload;
    function notifyOver(source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function notifyOver(source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
    function onContainerDrop: Boolean; overload;
    function onContainerDrop(source: JExt.dd.IDragSource): Boolean; overload;
    function onContainerDrop(source: JExt.dd.IDragSource; e: JEvent): Boolean; overload;
    function onContainerDrop(source: JExt.dd.IDragSource; e: JEvent; data: Variant): Boolean; overload;
    function onContainerOver: String; overload;
    function onContainerOver(source: JExt.dd.IDragSource): String; overload;
    function onContainerOver(source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function onContainerOver(source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
    function onNodeDrop: Boolean; overload;
    function onNodeDrop(nodeData: Variant): Boolean; overload;
    function onNodeDrop(nodeData: Variant; source: JExt.dd.IDragSource): Boolean; overload;
    function onNodeDrop(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent): Boolean; overload;
    function onNodeDrop(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent; data: Variant): Boolean; overload;
    procedure onNodeEnter; overload;
    procedure onNodeEnter(nodeData: Variant); overload;
    procedure onNodeEnter(nodeData: Variant; source: JExt.dd.IDragSource); overload;
    procedure onNodeEnter(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent); overload;
    procedure onNodeEnter(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent; data: Variant); overload;
    procedure onNodeOut; overload;
    procedure onNodeOut(nodeData: Variant); overload;
    procedure onNodeOut(nodeData: Variant; source: JExt.dd.IDragSource); overload;
    procedure onNodeOut(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent); overload;
    procedure onNodeOut(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent; data: Variant); overload;
    function onNodeOver: String; overload;
    function onNodeOver(nodeData: Variant): String; overload;
    function onNodeOver(nodeData: Variant; source: JExt.dd.IDragSource): String; overload;
    function onNodeOver(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent): String; overload;
    function onNodeOver(nodeData: Variant; source: JExt.dd.IDragSource; e: JEvent; data: Variant): String; overload;
  end;

//Ext.dd

type
  JRegistry = class external 'Registry'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getHandle: Variant; overload;
    function getHandle(id: Variant): Variant; overload;
    function getHandleFromEvent: Variant; overload;
    function getHandleFromEvent(e: JEvent): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getTarget: Variant; overload;
    function getTarget(id: Variant): Variant; overload;
    function getTargetFromEvent: Variant; overload;
    function getTargetFromEvent(e: JEvent): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure register; overload;
    procedure register(element: Variant); overload;
    procedure register(element: Variant; data: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(element: Variant); overload;
  end;

  JIRegistry = class external(JExt.IBase)
  end;

//Ext.dd

type
  JScrollManager = class external 'ScrollManager'
    animDuration: Float;
    animate: Boolean;
    ddGroup: String;
    frequency: Float;
    hthresh: Float;
    increment: Float;
    self: JExt.IClass;
    vthresh: Float;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure refreshCache;
    procedure register; overload;
    procedure register(el: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(el: Variant); overload;
  end;

  JIScrollManager = class external(JExt.IBase)
  end;

//Ext.dd

type
  JIStatusProxy = class external(JExt.IComponent)
    dropAllowed: String; // nullable
    dropNotAllowed: String; // nullable
    renderTpl: Variant; // nullable
    function getGhost: JExt.IElement;
    procedure repair; overload;
    procedure repair(xy: array of Float); overload;
    procedure repair(xy: array of Float; callback: Variant); overload;
    procedure repair(xy: array of Float; callback: Variant; scope: Variant); overload;
    procedure reset; overload;
    procedure reset(clearGhost: Boolean); overload;
    procedure setStatus; overload;
    procedure setStatus(cssClass: String); overload;
    procedure stop;
    procedure sync;
    procedure update; overload;
    procedure update(html: Variant); overload;
  end;

//Ext.direct

type
  JIEvent = class external(JExt.IBase)
    function getData: Variant;
    function getName: String;
  end;

//Ext.direct

type
  JIExceptionEvent = class external(JExt.direct.IRemotingEvent)
  end;

//Ext.direct

type
  JIJsonProvider = class external(JExt.direct.IProvider)
    function createEvent: JExt.direct.IEvent; overload;
    function createEvent(response: Variant): JExt.direct.IEvent; overload;
    function createEvents: array of JExt.direct.IEvent; overload;
    function createEvents(response: Variant): array of JExt.direct.IEvent; overload;
  end;

//Ext.direct

type
  JManager = class external 'Manager'
    exceptions: Variant;
    hasListeners: Variant;
    isObservable: Boolean;
    self: JExt.IClass;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addProvider; overload;
    procedure addProvider(provider: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    procedure getProvider; overload;
    procedure getProvider(id: Variant); overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function parseMethod: Variant; overload;
    function parseMethod(fn: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeProvider: JExt.direct.IProvider; overload;
    function removeProvider(provider: Variant): JExt.direct.IProvider; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIManager = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext

type
  JDirect = class external 'Direct'
    exceptions: Variant;
    hasListeners: Variant;
    isObservable: Boolean;
    self: JExt.IClass;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addProvider; overload;
    procedure addProvider(provider: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    procedure getProvider; overload;
    procedure getProvider(id: Variant); overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function parseMethod: Variant; overload;
    function parseMethod(fn: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeProvider: JExt.direct.IProvider; overload;
    function removeProvider(provider: Variant): JExt.direct.IProvider; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIDirect = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext.direct

type
  JIPollingProvider = class external(JExt.direct.IJsonProvider)
    baseParams: Variant; // nullable
    interval: Float; // nullable
    url: Variant; // nullable
    procedure connect;
    procedure disconnect;
    procedure isConnected;
  end;

//Ext.direct

type
  JIProvider = class external(JExt.IBase, JExt.util.IObservable)
    id: String; // nullable
    relayedEvents: array of String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure connect;
    procedure disconnect;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure isConnected;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.direct

type
  JIRemotingEvent = class external(JExt.direct.IEvent)
    function getTransaction: JExt.direct.ITransaction;
  end;

//Ext.direct

type
  JIRemotingMethod = class external(JExt.IBase)
    function getCallData: Variant; overload;
    function getCallData(args: array of Variant): Variant; overload;
  end;

//Ext.direct

type
  JIRemotingProvider = class external(JExt.direct.IJsonProvider)
    actions: Variant; // nullable
    disableNestedActions: Boolean; // nullable
    enableBuffer: Variant; // nullable
    enableUrlEncode: String; // nullable
    maxRetries: Float; // nullable
    namespace: Variant; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure connect;
    procedure disconnect;
    procedure isConnected;
  end;

//Ext.direct

type
  JITransaction = class external(JExt.IBase)
    provider: JExt.direct.IProvider; // nullable
  end;

//Ext.dom

type
  JAbstractElement = class external 'AbstractElement'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fly: JExt.dom.element.IFly; overload;
    function fly(dom: Variant): JExt.dom.element.IFly; overload;
    function fly(dom: Variant; named: String): JExt.dom.element.IFly; overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(el: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    procedure implement;
    function mergeClsList: array of Variant; overload;
    function mergeClsList(clsList1: Variant): array of Variant; overload;
    function mergeClsList(clsList1: Variant; clsList2: Variant): array of Variant; overload;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function removeCls: array of Variant; overload;
    function removeCls(existingClsList: Variant): array of Variant; overload;
    function removeCls(existingClsList: Variant; removeClsList: Variant): array of Variant; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIAbstractElement = class external(JExt.IBase)
    defaultUnit: String; // nullable
    dom: JHTMLElement; // nullable
    id: String; // nullable
    ASCLASS: Float; // nullable
    DISPLAY: Float; // nullable
    OFFSETS: Float; // nullable
    VISIBILITY: Float; // nullable
    function addCls: JExt.dom.IElement; overload;
    function addCls(className: Variant): JExt.dom.IElement; overload;
    function appendChild: JExt.dom.IAbstractElement; overload;
    function appendChild(el: Variant): JExt.dom.IAbstractElement; overload;
    function appendChild(el: Variant; returnDom: Boolean): JExt.dom.IAbstractElement; overload;
    function appendTo: JExt.dom.IAbstractElement; overload;
    function appendTo(el: Variant): JExt.dom.IAbstractElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function createChild: JExt.dom.IAbstractElement; overload;
    function createChild(config: Variant): JExt.dom.IAbstractElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IAbstractElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IAbstractElement; overload;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    function findParent: JHTMLElement; overload;
    function findParent(selector: String): JHTMLElement; overload;
    function findParent(selector: String; limit: Variant): JHTMLElement; overload;
    function findParent(selector: String; limit: Variant; returnEl: Boolean): JHTMLElement; overload;
    function findParentNode: JHTMLElement; overload;
    function findParentNode(selector: String): JHTMLElement; overload;
    function findParentNode(selector: String; limit: Variant): JHTMLElement; overload;
    function findParentNode(selector: String; limit: Variant; returnEl: Boolean): JHTMLElement; overload;
    function first: Variant; overload;
    function first(selector: String): Variant; overload;
    function first(selector: String; returnDom: Boolean): Variant; overload;
    function getActiveElement: JHTMLElement;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    procedure getById; overload;
    procedure getById(id: String); overload;
    procedure getById(id: String; asDom: Boolean); overload;
    procedure getHTML;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: Variant; overload;
    function getStyle(&property: Variant): Variant; overload;
    function getStyle(&property: Variant; inline: Boolean): Variant; overload;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function hasCls: Boolean; overload;
    function hasCls(className: String): Boolean; overload;
    function hide: JExt.dom.IElement; overload;
    function hide(animate: Variant): JExt.dom.IElement; overload;
    function insertAfter: JExt.dom.IAbstractElement; overload;
    function insertAfter(el: Variant): JExt.dom.IAbstractElement; overload;
    function insertBefore: JExt.dom.IAbstractElement; overload;
    function insertBefore(el: Variant): JExt.dom.IAbstractElement; overload;
    function insertFirst: JExt.dom.IAbstractElement; overload;
    function insertFirst(el: Variant): JExt.dom.IAbstractElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IAbstractElement; overload;
    function insertSibling(el: Variant): JExt.dom.IAbstractElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IAbstractElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IAbstractElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function last: Variant; overload;
    function last(selector: String): Variant; overload;
    function last(selector: String; returnDom: Boolean): Variant; overload;
    procedure mask; overload;
    procedure mask(msg: String); overload;
    procedure mask(msg: String; msgCls: String); overload;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    procedure remove;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(className: Variant): JExt.dom.IElement; overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IAbstractElement; overload;
    function replace(el: Variant): JExt.dom.IAbstractElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldClassName: String): JExt.dom.IElement; overload;
    function replaceCls(oldClassName: String; newClassName: String): JExt.dom.IElement; overload;
    function replaceWith: JExt.dom.IAbstractElement; overload;
    function replaceWith(el: Variant): JExt.dom.IAbstractElement; overload;
    function select: JExt.ICompositeElement; overload;
    function select(selector: String): JExt.ICompositeElement; overload;
    function select(selector: String; unique: Boolean): JExt.ICompositeElement; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(o: Variant): JExt.dom.IElement; overload;
    function set(o: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setHTML: JExt.IElement; overload;
    function setHTML(html: String): JExt.IElement; overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setVisibilityMode: JExt.dom.IAbstractElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IAbstractElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Boolean): JExt.dom.IElement; overload;
    function setVisible(visible: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function show: JExt.dom.IElement; overload;
    function show(animate: Variant): JExt.dom.IElement; overload;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    procedure unmask;
    function up: JExt.IElement; overload;
    function up(selector: String): JExt.IElement; overload;
    function up(selector: String; limit: Variant): JExt.IElement; overload;
    function up(selector: String; limit: Variant; returnDom: Boolean): JExt.IElement; overload;
    function update: JExt.dom.IElement; overload;
    function update(html: String): JExt.dom.IElement; overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; returnDom: Boolean): Variant; overload;
    function wrap(config: Variant; returnDom: Boolean; selector: String): Variant; overload;
  end;

//Ext.dom

type
  JIAbstractHelper = class external(JExt.IBase)
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; o: Variant): Variant; overload;
    function append(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    procedure applyStyles; overload;
    procedure applyStyles(el: Variant); overload;
    procedure applyStyles(el: Variant; styles: Variant); overload;
    function generateStyles: Variant; overload;
    function generateStyles(styles: Variant): Variant; overload;
    function generateStyles(styles: Variant; buffer: array of String): Variant; overload;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertHtml: JHTMLElement; overload;
    function insertHtml(where: String): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant; html: String): JHTMLElement; overload;
    function markup: String; overload;
    function markup(spec: Variant): String; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
  end;

//Ext.dom

type
  JIAbstractQuery = class external(JExt.IBase)
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function select: array of JHTMLElement; overload;
    function select(selector: String): array of JHTMLElement; overload;
    function select(selector: String; root: Variant): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: Variant): JHTMLElement; overload;
  end;

//Ext.dom

type
  JICompositeElement = class external(JExt.dom.ICompositeElementLite)
  end;

//Ext

type
  JICompositeElement = class external(JExt.dom.ICompositeElementLite)
  end;

//Ext.dom

type
  JICompositeElementLite = class external(JExt.IBase)
    elements: array of JHTMLElement; // nullable
    isComposite: Boolean; // nullable
    function add: JExt.dom.ICompositeElement; overload;
    function add(els: Variant): JExt.dom.ICompositeElement; overload;
    procedure clear; overload;
    procedure clear(removeDom: Boolean); overload;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function each: JExt.dom.ICompositeElement; overload;
    function each(fn: Variant): JExt.dom.ICompositeElement; overload;
    function each(fn: Variant; scope: Variant): JExt.dom.ICompositeElement; overload;
    function fill: JExt.dom.ICompositeElement; overload;
    function fill(els: Variant): JExt.dom.ICompositeElement; overload;
    function filter: JExt.dom.ICompositeElement; overload;
    function filter(selector: Variant): JExt.dom.ICompositeElement; overload;
    function first: JExt.dom.IElement;
    function getCount: Float;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    function item: JExt.dom.IElement; overload;
    function item(index: Float): JExt.dom.IElement; overload;
    function last: JExt.dom.IElement;
    function removeElement: JExt.dom.ICompositeElement; overload;
    function removeElement(el: Variant): JExt.dom.ICompositeElement; overload;
    function removeElement(el: Variant; removeDom: Boolean): JExt.dom.ICompositeElement; overload;
    function replaceElement: JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant): JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.dom.ICompositeElement; overload;
    function slice: array of JHTMLElement; overload;
    function slice(start: Float): array of JHTMLElement; overload;
    function slice(start: Float; &end: Float): array of JHTMLElement; overload;
  end;

//Ext

type
  JICompositeElementLite = class external(JExt.IBase)
    elements: array of JHTMLElement; // nullable
    isComposite: Boolean; // nullable
    function add: JExt.dom.ICompositeElement; overload;
    function add(els: Variant): JExt.dom.ICompositeElement; overload;
    procedure clear; overload;
    procedure clear(removeDom: Boolean); overload;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function each: JExt.dom.ICompositeElement; overload;
    function each(fn: Variant): JExt.dom.ICompositeElement; overload;
    function each(fn: Variant; scope: Variant): JExt.dom.ICompositeElement; overload;
    function fill: JExt.dom.ICompositeElement; overload;
    function fill(els: Variant): JExt.dom.ICompositeElement; overload;
    function filter: JExt.dom.ICompositeElement; overload;
    function filter(selector: Variant): JExt.dom.ICompositeElement; overload;
    function first: JExt.dom.IElement;
    function getCount: Float;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    function item: JExt.dom.IElement; overload;
    function item(index: Float): JExt.dom.IElement; overload;
    function last: JExt.dom.IElement;
    function removeElement: JExt.dom.ICompositeElement; overload;
    function removeElement(el: Variant): JExt.dom.ICompositeElement; overload;
    function removeElement(el: Variant; removeDom: Boolean): JExt.dom.ICompositeElement; overload;
    function replaceElement: JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant): JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.dom.ICompositeElement; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.dom.ICompositeElement; overload;
    function slice: array of JHTMLElement; overload;
    function slice(start: Float): array of JHTMLElement; overload;
    function slice(start: Float; &end: Float): array of JHTMLElement; overload;
  end;

//Ext.dom.element

type
  JIFly = class external(JExt.dom.IElement)
    isFly: Boolean; // nullable
  end;

//Ext.dom.abstractelement

type
  JIFly = class external(JExt.dom.IElement)
    isFly: Boolean; // nullable
  end;

//Ext.dom

type
  JElement = class external 'Element'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(el: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    procedure implement;
    function mergeClsList: array of Variant; overload;
    function mergeClsList(clsList1: Variant): array of Variant; overload;
    function mergeClsList(clsList1: Variant; clsList2: Variant): array of Variant; overload;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function removeCls: array of Variant; overload;
    function removeCls(existingClsList: Variant): array of Variant; overload;
    function removeCls(existingClsList: Variant; removeClsList: Variant): array of Variant; overload;
    function select: Variant; overload;
    function select(selector: Variant): Variant; overload;
    function select(selector: Variant; unique: Boolean): Variant; overload;
    function select(selector: Variant; unique: Boolean; root: Variant): Variant; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIElement = class external(JExt.dom.IAbstractElement)
    autoBoxAdjust: Boolean; // nullable
    originalDisplay: String; // nullable
    function addClsOnClick: JExt.dom.IElement; overload;
    function addClsOnClick(className: String): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus: JExt.dom.IElement; overload;
    function addClsOnFocus(className: String): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnOver: JExt.dom.IElement; overload;
    function addClsOnOver(className: String): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addKeyListener: JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant; scope: Variant): JExt.util.IKeyMap; overload;
    function addKeyMap: JExt.util.IKeyMap; overload;
    function addKeyMap(config: Variant): JExt.util.IKeyMap; overload;
    function addListener: JExt.dom.IElement; overload;
    function addListener(eventName: String): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function animate: JExt.dom.IElement; overload;
    function animate(config: Variant): JExt.dom.IElement; overload;
    function blur: JExt.dom.IElement;
    function boxWrap: JExt.dom.IElement; overload;
    function boxWrap(clazz: String): JExt.dom.IElement; overload;
    function cacheScrollValues: Variant;
    procedure center; overload;
    procedure center(centerIn: Variant); overload;
    procedure clean; overload;
    procedure clean(forceReclean: Boolean); overload;
    function clearListeners: JExt.dom.IElement;
    function clearOpacity: JExt.dom.IElement;
    function clearPositioning: JExt.dom.IElement; overload;
    function clearPositioning(value: String): JExt.dom.IElement; overload;
    function clip: JExt.dom.IElement;
    function createProxy: JExt.dom.IElement; overload;
    function createProxy(config: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant; matchBox: Boolean): JExt.dom.IElement; overload;
    function createShim: JExt.dom.IElement;
    function enableDisplayMode: JExt.dom.IElement; overload;
    function enableDisplayMode(display: String): JExt.dom.IElement; overload;
    function fadeIn: JExt.IElement; overload;
    function fadeIn(options: Variant): JExt.IElement; overload;
    function fadeOut: JExt.IElement; overload;
    function fadeOut(options: Variant): JExt.IElement; overload;
    function focus: JExt.dom.IElement; overload;
    function focus(defer: Float): JExt.dom.IElement; overload;
    function focusable: Boolean;
    function frame: JExt.dom.IElement; overload;
    function frame(color: String): JExt.dom.IElement; overload;
    function frame(color: String; count: Float): JExt.dom.IElement; overload;
    function frame(color: String; count: Float; options: Variant): JExt.dom.IElement; overload;
    function getAttributeNS: String; overload;
    function getAttributeNS(namespace: String): String; overload;
    function getAttributeNS(namespace: String; name: String): String; overload;
    function getBottom: Float; overload;
    function getBottom(local: Boolean): Float; overload;
    function getCenterXY: array of Float;
    procedure getColor; overload;
    procedure getColor(attr: String); overload;
    procedure getColor(attr: String; defaultValue: String); overload;
    procedure getColor(attr: String; defaultValue: String; prefix: String); overload;
    function getComputedHeight: Float;
    function getComputedWidth: Float;
    function getFrameWidth: Float; overload;
    function getFrameWidth(sides: String): Float; overload;
    function getLeft: Float; overload;
    function getLeft(local: Boolean): Float; overload;
    function getLoader: JExt.IElementLoader;
    function getLocalX: Float;
    function getLocalXY: array of Variant;
    function getLocalY: Float;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getPositioning: Variant; overload;
    function getPositioning(autoPx: Boolean): Variant; overload;
    function getRight: Float; overload;
    function getRight(local: Boolean): Float; overload;
    function getScroll: Variant;
    function getScrollLeft: Float;
    function getScrollTop: Float;
    function getStyleSize: Variant;
    function getTextWidth: Float; overload;
    function getTextWidth(text: String): Float; overload;
    function getTextWidth(text: String; min: Float): Float; overload;
    function getTextWidth(text: String; min: Float; max: Float): Float; overload;
    function getTop: Float; overload;
    function getTop(local: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function ghost: JExt.dom.IElement; overload;
    function ghost(anchor: String): JExt.dom.IElement; overload;
    function ghost(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function hide: JExt.dom.IElement; overload;
    function hide(animate: Variant): JExt.dom.IElement; overload;
    function highlight: JExt.dom.IElement; overload;
    function highlight(color: String): JExt.dom.IElement; overload;
    function highlight(color: String; options: Variant): JExt.dom.IElement; overload;
    function hover: JExt.dom.IElement; overload;
    function hover(overFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function initDD: JExt.dd.IDD; overload;
    function initDD(group: String): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant; overrides: Variant): JExt.dd.IDD; overload;
    function initDDProxy: JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant; overrides: Variant): JExt.dd.IDDProxy; overload;
    function initDDTarget: JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant; overrides: Variant): JExt.dd.IDDTarget; overload;
    function isBorderBox: Boolean;
    function isDisplayed: Boolean;
    function isFocusable: Boolean; overload;
    function isFocusable(asFocusEl: Variant): Boolean; overload;
    function isMasked: Boolean;
    function isScrollable: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Boolean): Boolean; overload;
    function load: JExt.dom.IElement; overload;
    function load(options: Variant): JExt.dom.IElement; overload;
    function mask: JExt.dom.IElement; overload;
    function mask(msg: String): JExt.dom.IElement; overload;
    function mask(msg: String; msgCls: String): JExt.dom.IElement; overload;
    function monitorMouseLeave: Variant; overload;
    function monitorMouseLeave(delay: Float): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant; scope: Variant): Variant; overload;
    function moveTo: JExt.dom.IElement; overload;
    function moveTo(x: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    procedure needsTabIndex;
    function on: JExt.dom.IElement; overload;
    function on(eventName: String): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function pause: JExt.IElement; overload;
    function pause(seconds: Float): JExt.IElement; overload;
    procedure position; overload;
    procedure position(pos: String); overload;
    procedure position(pos: String; zIndex: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float; y: Float); overload;
    function puff: JExt.dom.IElement; overload;
    function puff(options: Variant): JExt.dom.IElement; overload;
    function purgeAllListeners: JExt.dom.IElement;
    procedure relayEvent; overload;
    procedure relayEvent(eventName: String); overload;
    procedure relayEvent(eventName: String; observable: Variant); overload;
    function removeAllListeners: JExt.dom.IElement;
    function removeListener: JExt.dom.IElement; overload;
    function removeListener(eventName: String): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function scale: JExt.IElement; overload;
    function scale(width: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float; options: Variant): JExt.IElement; overload;
    function scroll: Boolean; overload;
    function scroll(direction: String): Boolean; overload;
    function scroll(direction: String; distance: Float): Boolean; overload;
    function scroll(direction: String; distance: Float; animate: Variant): Boolean; overload;
    function scrollBy: JExt.IElement; overload;
    function scrollBy(deltaX: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant): JExt.IElement; overload;
    function scrollIntoView: JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant; highlight: Boolean): JExt.dom.IElement; overload;
    function scrollTo: JExt.IElement; overload;
    function scrollTo(side: String): JExt.IElement; overload;
    function scrollTo(side: String; value: Float): JExt.IElement; overload;
    function scrollTo(side: String; value: Float; animate: Variant): JExt.IElement; overload;
    function selectable: JExt.IElement;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: Variant): JExt.dom.IElement; overload;
    function setBounds: JExt.dom.IElement; overload;
    function setBounds(x: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setDisplayed: JExt.dom.IElement; overload;
    function setDisplayed(value: Variant): JExt.dom.IElement; overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop: JExt.dom.IElement; overload;
    function setLeftTop(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop(left: Variant; top: Variant): JExt.dom.IElement; overload;
    function setLocation: JExt.dom.IElement; overload;
    function setLocation(x: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    function setOpacity: JExt.dom.IElement; overload;
    function setOpacity(opacity: Float): JExt.dom.IElement; overload;
    function setOpacity(opacity: Float; animate: Variant): JExt.dom.IElement; overload;
    function setPositioning: JExt.dom.IElement; overload;
    function setPositioning(posCfg: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: Variant): JExt.dom.IElement; overload;
    function setScrollLeft: JExt.dom.IElement; overload;
    function setScrollLeft(left: Float): JExt.dom.IElement; overload;
    function setScrollTop: JExt.dom.IElement; overload;
    function setScrollTop(top: Float): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Boolean): JExt.dom.IElement; overload;
    function setVisible(visible: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function shift: JExt.IElement; overload;
    function shift(options: Variant): JExt.IElement; overload;
    function show: JExt.dom.IElement; overload;
    function show(animate: Variant): JExt.dom.IElement; overload;
    function slideIn: JExt.dom.IElement; overload;
    function slideIn(anchor: String): JExt.dom.IElement; overload;
    function slideIn(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function slideOut: JExt.dom.IElement; overload;
    function slideOut(anchor: String): JExt.dom.IElement; overload;
    function slideOut(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function swallowEvent: JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant): JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant; preventDefault: Boolean): JExt.dom.IElement; overload;
    function switchOff: JExt.dom.IElement; overload;
    function switchOff(options: Variant): JExt.dom.IElement; overload;
    function toggle: JExt.dom.IElement; overload;
    function toggle(animate: Variant): JExt.dom.IElement; overload;
    function un: JExt.dom.IElement; overload;
    function un(eventName: String): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function unclip: JExt.dom.IElement;
    procedure unmask;
    function unselectable: JExt.dom.IElement;
    function update: JExt.dom.IElement; overload;
    function update(html: String): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean; callback: Variant): JExt.dom.IElement; overload;
  end;

//Ext

type
  JElement = class external 'Element'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(el: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    procedure implement;
    function mergeClsList: array of Variant; overload;
    function mergeClsList(clsList1: Variant): array of Variant; overload;
    function mergeClsList(clsList1: Variant; clsList2: Variant): array of Variant; overload;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function removeCls: array of Variant; overload;
    function removeCls(existingClsList: Variant): array of Variant; overload;
    function removeCls(existingClsList: Variant; removeClsList: Variant): array of Variant; overload;
    function select: Variant; overload;
    function select(selector: Variant): Variant; overload;
    function select(selector: Variant; unique: Boolean): Variant; overload;
    function select(selector: Variant; unique: Boolean; root: Variant): Variant; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIElement = class external(JExt.dom.IAbstractElement)
    autoBoxAdjust: Boolean; // nullable
    originalDisplay: String; // nullable
    function addClsOnClick: JExt.dom.IElement; overload;
    function addClsOnClick(className: String): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus: JExt.dom.IElement; overload;
    function addClsOnFocus(className: String): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnOver: JExt.dom.IElement; overload;
    function addClsOnOver(className: String): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addKeyListener: JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant; scope: Variant): JExt.util.IKeyMap; overload;
    function addKeyMap: JExt.util.IKeyMap; overload;
    function addKeyMap(config: Variant): JExt.util.IKeyMap; overload;
    function addListener: JExt.dom.IElement; overload;
    function addListener(eventName: String): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function animate: JExt.dom.IElement; overload;
    function animate(config: Variant): JExt.dom.IElement; overload;
    function blur: JExt.dom.IElement;
    function boxWrap: JExt.dom.IElement; overload;
    function boxWrap(clazz: String): JExt.dom.IElement; overload;
    function cacheScrollValues: Variant;
    procedure center; overload;
    procedure center(centerIn: Variant); overload;
    procedure clean; overload;
    procedure clean(forceReclean: Boolean); overload;
    function clearListeners: JExt.dom.IElement;
    function clearOpacity: JExt.dom.IElement;
    function clearPositioning: JExt.dom.IElement; overload;
    function clearPositioning(value: String): JExt.dom.IElement; overload;
    function clip: JExt.dom.IElement;
    function createProxy: JExt.dom.IElement; overload;
    function createProxy(config: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant; matchBox: Boolean): JExt.dom.IElement; overload;
    function createShim: JExt.dom.IElement;
    function enableDisplayMode: JExt.dom.IElement; overload;
    function enableDisplayMode(display: String): JExt.dom.IElement; overload;
    function fadeIn: JExt.IElement; overload;
    function fadeIn(options: Variant): JExt.IElement; overload;
    function fadeOut: JExt.IElement; overload;
    function fadeOut(options: Variant): JExt.IElement; overload;
    function focus: JExt.dom.IElement; overload;
    function focus(defer: Float): JExt.dom.IElement; overload;
    function focusable: Boolean;
    function frame: JExt.dom.IElement; overload;
    function frame(color: String): JExt.dom.IElement; overload;
    function frame(color: String; count: Float): JExt.dom.IElement; overload;
    function frame(color: String; count: Float; options: Variant): JExt.dom.IElement; overload;
    function getAttributeNS: String; overload;
    function getAttributeNS(namespace: String): String; overload;
    function getAttributeNS(namespace: String; name: String): String; overload;
    function getBottom: Float; overload;
    function getBottom(local: Boolean): Float; overload;
    function getCenterXY: array of Float;
    procedure getColor; overload;
    procedure getColor(attr: String); overload;
    procedure getColor(attr: String; defaultValue: String); overload;
    procedure getColor(attr: String; defaultValue: String; prefix: String); overload;
    function getComputedHeight: Float;
    function getComputedWidth: Float;
    function getFrameWidth: Float; overload;
    function getFrameWidth(sides: String): Float; overload;
    function getLeft: Float; overload;
    function getLeft(local: Boolean): Float; overload;
    function getLoader: JExt.IElementLoader;
    function getLocalX: Float;
    function getLocalXY: array of Variant;
    function getLocalY: Float;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getPositioning: Variant; overload;
    function getPositioning(autoPx: Boolean): Variant; overload;
    function getRight: Float; overload;
    function getRight(local: Boolean): Float; overload;
    function getScroll: Variant;
    function getScrollLeft: Float;
    function getScrollTop: Float;
    function getStyleSize: Variant;
    function getTextWidth: Float; overload;
    function getTextWidth(text: String): Float; overload;
    function getTextWidth(text: String; min: Float): Float; overload;
    function getTextWidth(text: String; min: Float; max: Float): Float; overload;
    function getTop: Float; overload;
    function getTop(local: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function ghost: JExt.dom.IElement; overload;
    function ghost(anchor: String): JExt.dom.IElement; overload;
    function ghost(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function hide: JExt.dom.IElement; overload;
    function hide(animate: Variant): JExt.dom.IElement; overload;
    function highlight: JExt.dom.IElement; overload;
    function highlight(color: String): JExt.dom.IElement; overload;
    function highlight(color: String; options: Variant): JExt.dom.IElement; overload;
    function hover: JExt.dom.IElement; overload;
    function hover(overFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function initDD: JExt.dd.IDD; overload;
    function initDD(group: String): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant; overrides: Variant): JExt.dd.IDD; overload;
    function initDDProxy: JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant; overrides: Variant): JExt.dd.IDDProxy; overload;
    function initDDTarget: JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant; overrides: Variant): JExt.dd.IDDTarget; overload;
    function isBorderBox: Boolean;
    function isDisplayed: Boolean;
    function isFocusable: Boolean; overload;
    function isFocusable(asFocusEl: Variant): Boolean; overload;
    function isMasked: Boolean;
    function isScrollable: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Boolean): Boolean; overload;
    function load: JExt.dom.IElement; overload;
    function load(options: Variant): JExt.dom.IElement; overload;
    function mask: JExt.dom.IElement; overload;
    function mask(msg: String): JExt.dom.IElement; overload;
    function mask(msg: String; msgCls: String): JExt.dom.IElement; overload;
    function monitorMouseLeave: Variant; overload;
    function monitorMouseLeave(delay: Float): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant; scope: Variant): Variant; overload;
    function moveTo: JExt.dom.IElement; overload;
    function moveTo(x: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    procedure needsTabIndex;
    function on: JExt.dom.IElement; overload;
    function on(eventName: String): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function pause: JExt.IElement; overload;
    function pause(seconds: Float): JExt.IElement; overload;
    procedure position; overload;
    procedure position(pos: String); overload;
    procedure position(pos: String; zIndex: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float; y: Float); overload;
    function puff: JExt.dom.IElement; overload;
    function puff(options: Variant): JExt.dom.IElement; overload;
    function purgeAllListeners: JExt.dom.IElement;
    procedure relayEvent; overload;
    procedure relayEvent(eventName: String); overload;
    procedure relayEvent(eventName: String; observable: Variant); overload;
    function removeAllListeners: JExt.dom.IElement;
    function removeListener: JExt.dom.IElement; overload;
    function removeListener(eventName: String): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function scale: JExt.IElement; overload;
    function scale(width: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float; options: Variant): JExt.IElement; overload;
    function scroll: Boolean; overload;
    function scroll(direction: String): Boolean; overload;
    function scroll(direction: String; distance: Float): Boolean; overload;
    function scroll(direction: String; distance: Float; animate: Variant): Boolean; overload;
    function scrollBy: JExt.IElement; overload;
    function scrollBy(deltaX: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant): JExt.IElement; overload;
    function scrollIntoView: JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant; highlight: Boolean): JExt.dom.IElement; overload;
    function scrollTo: JExt.IElement; overload;
    function scrollTo(side: String): JExt.IElement; overload;
    function scrollTo(side: String; value: Float): JExt.IElement; overload;
    function scrollTo(side: String; value: Float; animate: Variant): JExt.IElement; overload;
    function selectable: JExt.IElement;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: Variant): JExt.dom.IElement; overload;
    function setBounds: JExt.dom.IElement; overload;
    function setBounds(x: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setDisplayed: JExt.dom.IElement; overload;
    function setDisplayed(value: Variant): JExt.dom.IElement; overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop: JExt.dom.IElement; overload;
    function setLeftTop(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop(left: Variant; top: Variant): JExt.dom.IElement; overload;
    function setLocation: JExt.dom.IElement; overload;
    function setLocation(x: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    function setOpacity: JExt.dom.IElement; overload;
    function setOpacity(opacity: Float): JExt.dom.IElement; overload;
    function setOpacity(opacity: Float; animate: Variant): JExt.dom.IElement; overload;
    function setPositioning: JExt.dom.IElement; overload;
    function setPositioning(posCfg: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: Variant): JExt.dom.IElement; overload;
    function setScrollLeft: JExt.dom.IElement; overload;
    function setScrollLeft(left: Float): JExt.dom.IElement; overload;
    function setScrollTop: JExt.dom.IElement; overload;
    function setScrollTop(top: Float): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Boolean): JExt.dom.IElement; overload;
    function setVisible(visible: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function shift: JExt.IElement; overload;
    function shift(options: Variant): JExt.IElement; overload;
    function show: JExt.dom.IElement; overload;
    function show(animate: Variant): JExt.dom.IElement; overload;
    function slideIn: JExt.dom.IElement; overload;
    function slideIn(anchor: String): JExt.dom.IElement; overload;
    function slideIn(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function slideOut: JExt.dom.IElement; overload;
    function slideOut(anchor: String): JExt.dom.IElement; overload;
    function slideOut(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function swallowEvent: JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant): JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant; preventDefault: Boolean): JExt.dom.IElement; overload;
    function switchOff: JExt.dom.IElement; overload;
    function switchOff(options: Variant): JExt.dom.IElement; overload;
    function toggle: JExt.dom.IElement; overload;
    function toggle(animate: Variant): JExt.dom.IElement; overload;
    function un: JExt.dom.IElement; overload;
    function un(eventName: String): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function unclip: JExt.dom.IElement;
    procedure unmask;
    function unselectable: JExt.dom.IElement;
    function update: JExt.dom.IElement; overload;
    function update(html: String): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean; callback: Variant): JExt.dom.IElement; overload;
  end;

//Ext.core

type
  JElement = class external 'Element'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(el: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    procedure implement;
    function mergeClsList: array of Variant; overload;
    function mergeClsList(clsList1: Variant): array of Variant; overload;
    function mergeClsList(clsList1: Variant; clsList2: Variant): array of Variant; overload;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function removeCls: array of Variant; overload;
    function removeCls(existingClsList: Variant): array of Variant; overload;
    function removeCls(existingClsList: Variant; removeClsList: Variant): array of Variant; overload;
    function select: Variant; overload;
    function select(selector: Variant): Variant; overload;
    function select(selector: Variant; unique: Boolean): Variant; overload;
    function select(selector: Variant; unique: Boolean; root: Variant): Variant; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIElement = class external(JExt.dom.IAbstractElement)
    autoBoxAdjust: Boolean; // nullable
    originalDisplay: String; // nullable
    function addClsOnClick: JExt.dom.IElement; overload;
    function addClsOnClick(className: String): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnClick(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus: JExt.dom.IElement; overload;
    function addClsOnFocus(className: String): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnFocus(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addClsOnOver: JExt.dom.IElement; overload;
    function addClsOnOver(className: String): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant): JExt.dom.IElement; overload;
    function addClsOnOver(className: String; testFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addKeyListener: JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant): JExt.util.IKeyMap; overload;
    function addKeyListener(key: Variant; fn: Variant; scope: Variant): JExt.util.IKeyMap; overload;
    function addKeyMap: JExt.util.IKeyMap; overload;
    function addKeyMap(config: Variant): JExt.util.IKeyMap; overload;
    function addListener: JExt.dom.IElement; overload;
    function addListener(eventName: String): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function addListener(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function animate: JExt.dom.IElement; overload;
    function animate(config: Variant): JExt.dom.IElement; overload;
    function blur: JExt.dom.IElement;
    function boxWrap: JExt.dom.IElement; overload;
    function boxWrap(clazz: String): JExt.dom.IElement; overload;
    function cacheScrollValues: Variant;
    procedure center; overload;
    procedure center(centerIn: Variant); overload;
    procedure clean; overload;
    procedure clean(forceReclean: Boolean); overload;
    function clearListeners: JExt.dom.IElement;
    function clearOpacity: JExt.dom.IElement;
    function clearPositioning: JExt.dom.IElement; overload;
    function clearPositioning(value: String): JExt.dom.IElement; overload;
    function clip: JExt.dom.IElement;
    function createProxy: JExt.dom.IElement; overload;
    function createProxy(config: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant): JExt.dom.IElement; overload;
    function createProxy(config: Variant; renderTo: Variant; matchBox: Boolean): JExt.dom.IElement; overload;
    function createShim: JExt.dom.IElement;
    function enableDisplayMode: JExt.dom.IElement; overload;
    function enableDisplayMode(display: String): JExt.dom.IElement; overload;
    function fadeIn: JExt.IElement; overload;
    function fadeIn(options: Variant): JExt.IElement; overload;
    function fadeOut: JExt.IElement; overload;
    function fadeOut(options: Variant): JExt.IElement; overload;
    function focus: JExt.dom.IElement; overload;
    function focus(defer: Float): JExt.dom.IElement; overload;
    function focusable: Boolean;
    function frame: JExt.dom.IElement; overload;
    function frame(color: String): JExt.dom.IElement; overload;
    function frame(color: String; count: Float): JExt.dom.IElement; overload;
    function frame(color: String; count: Float; options: Variant): JExt.dom.IElement; overload;
    function getAttributeNS: String; overload;
    function getAttributeNS(namespace: String): String; overload;
    function getAttributeNS(namespace: String; name: String): String; overload;
    function getBottom: Float; overload;
    function getBottom(local: Boolean): Float; overload;
    function getCenterXY: array of Float;
    procedure getColor; overload;
    procedure getColor(attr: String); overload;
    procedure getColor(attr: String; defaultValue: String); overload;
    procedure getColor(attr: String; defaultValue: String; prefix: String); overload;
    function getComputedHeight: Float;
    function getComputedWidth: Float;
    function getFrameWidth: Float; overload;
    function getFrameWidth(sides: String): Float; overload;
    function getLeft: Float; overload;
    function getLeft(local: Boolean): Float; overload;
    function getLoader: JExt.IElementLoader;
    function getLocalX: Float;
    function getLocalXY: array of Variant;
    function getLocalY: Float;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getPositioning: Variant; overload;
    function getPositioning(autoPx: Boolean): Variant; overload;
    function getRight: Float; overload;
    function getRight(local: Boolean): Float; overload;
    function getScroll: Variant;
    function getScrollLeft: Float;
    function getScrollTop: Float;
    function getStyleSize: Variant;
    function getTextWidth: Float; overload;
    function getTextWidth(text: String): Float; overload;
    function getTextWidth(text: String; min: Float): Float; overload;
    function getTextWidth(text: String; min: Float; max: Float): Float; overload;
    function getTop: Float; overload;
    function getTop(local: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function ghost: JExt.dom.IElement; overload;
    function ghost(anchor: String): JExt.dom.IElement; overload;
    function ghost(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function hide: JExt.dom.IElement; overload;
    function hide(animate: Variant): JExt.dom.IElement; overload;
    function highlight: JExt.dom.IElement; overload;
    function highlight(color: String): JExt.dom.IElement; overload;
    function highlight(color: String; options: Variant): JExt.dom.IElement; overload;
    function hover: JExt.dom.IElement; overload;
    function hover(overFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function hover(overFn: Variant; outFn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function initDD: JExt.dd.IDD; overload;
    function initDD(group: String): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant): JExt.dd.IDD; overload;
    function initDD(group: String; config: Variant; overrides: Variant): JExt.dd.IDD; overload;
    function initDDProxy: JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant): JExt.dd.IDDProxy; overload;
    function initDDProxy(group: String; config: Variant; overrides: Variant): JExt.dd.IDDProxy; overload;
    function initDDTarget: JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant): JExt.dd.IDDTarget; overload;
    function initDDTarget(group: String; config: Variant; overrides: Variant): JExt.dd.IDDTarget; overload;
    function isBorderBox: Boolean;
    function isDisplayed: Boolean;
    function isFocusable: Boolean; overload;
    function isFocusable(asFocusEl: Variant): Boolean; overload;
    function isMasked: Boolean;
    function isScrollable: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Boolean): Boolean; overload;
    function load: JExt.dom.IElement; overload;
    function load(options: Variant): JExt.dom.IElement; overload;
    function mask: JExt.dom.IElement; overload;
    function mask(msg: String): JExt.dom.IElement; overload;
    function mask(msg: String; msgCls: String): JExt.dom.IElement; overload;
    function monitorMouseLeave: Variant; overload;
    function monitorMouseLeave(delay: Float): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant): Variant; overload;
    function monitorMouseLeave(delay: Float; handler: Variant; scope: Variant): Variant; overload;
    function moveTo: JExt.dom.IElement; overload;
    function moveTo(x: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float): JExt.dom.IElement; overload;
    function moveTo(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    procedure needsTabIndex;
    function on: JExt.dom.IElement; overload;
    function on(eventName: String): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function on(eventName: String; fn: Variant; scope: Variant; options: Variant): JExt.dom.IElement; overload;
    function pause: JExt.IElement; overload;
    function pause(seconds: Float): JExt.IElement; overload;
    procedure position; overload;
    procedure position(pos: String); overload;
    procedure position(pos: String; zIndex: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float); overload;
    procedure position(pos: String; zIndex: Float; x: Float; y: Float); overload;
    function puff: JExt.dom.IElement; overload;
    function puff(options: Variant): JExt.dom.IElement; overload;
    function purgeAllListeners: JExt.dom.IElement;
    procedure relayEvent; overload;
    procedure relayEvent(eventName: String); overload;
    procedure relayEvent(eventName: String; observable: Variant); overload;
    function removeAllListeners: JExt.dom.IElement;
    function removeListener: JExt.dom.IElement; overload;
    function removeListener(eventName: String): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function removeListener(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function scale: JExt.IElement; overload;
    function scale(width: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float): JExt.IElement; overload;
    function scale(width: Float; height: Float; options: Variant): JExt.IElement; overload;
    function scroll: Boolean; overload;
    function scroll(direction: String): Boolean; overload;
    function scroll(direction: String; distance: Float): Boolean; overload;
    function scroll(direction: String; distance: Float; animate: Variant): Boolean; overload;
    function scrollBy: JExt.IElement; overload;
    function scrollBy(deltaX: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant): JExt.IElement; overload;
    function scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant): JExt.IElement; overload;
    function scrollIntoView: JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function scrollIntoView(container: Variant; hscroll: Boolean; animate: Variant; highlight: Boolean): JExt.dom.IElement; overload;
    function scrollTo: JExt.IElement; overload;
    function scrollTo(side: String): JExt.IElement; overload;
    function scrollTo(side: String; value: Float): JExt.IElement; overload;
    function scrollTo(side: String; value: Float; animate: Variant): JExt.IElement; overload;
    function selectable: JExt.IElement;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: Variant): JExt.dom.IElement; overload;
    function setBounds: JExt.dom.IElement; overload;
    function setBounds(x: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Float; y: Float; width: Variant; height: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setDisplayed: JExt.dom.IElement; overload;
    function setDisplayed(value: Variant): JExt.dom.IElement; overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop: JExt.dom.IElement; overload;
    function setLeftTop(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop(left: Variant; top: Variant): JExt.dom.IElement; overload;
    function setLocation: JExt.dom.IElement; overload;
    function setLocation(x: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float): JExt.dom.IElement; overload;
    function setLocation(x: Float; y: Float; animate: Variant): JExt.dom.IElement; overload;
    function setOpacity: JExt.dom.IElement; overload;
    function setOpacity(opacity: Float): JExt.dom.IElement; overload;
    function setOpacity(opacity: Float; animate: Variant): JExt.dom.IElement; overload;
    function setPositioning: JExt.dom.IElement; overload;
    function setPositioning(posCfg: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: Variant): JExt.dom.IElement; overload;
    function setScrollLeft: JExt.dom.IElement; overload;
    function setScrollLeft(left: Float): JExt.dom.IElement; overload;
    function setScrollTop: JExt.dom.IElement; overload;
    function setScrollTop(top: Float): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Boolean): JExt.dom.IElement; overload;
    function setVisible(visible: Boolean; animate: Variant): JExt.dom.IElement; overload;
    function shift: JExt.IElement; overload;
    function shift(options: Variant): JExt.IElement; overload;
    function show: JExt.dom.IElement; overload;
    function show(animate: Variant): JExt.dom.IElement; overload;
    function slideIn: JExt.dom.IElement; overload;
    function slideIn(anchor: String): JExt.dom.IElement; overload;
    function slideIn(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function slideOut: JExt.dom.IElement; overload;
    function slideOut(anchor: String): JExt.dom.IElement; overload;
    function slideOut(anchor: String; options: Variant): JExt.dom.IElement; overload;
    function swallowEvent: JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant): JExt.dom.IElement; overload;
    function swallowEvent(eventName: Variant; preventDefault: Boolean): JExt.dom.IElement; overload;
    function switchOff: JExt.dom.IElement; overload;
    function switchOff(options: Variant): JExt.dom.IElement; overload;
    function toggle: JExt.dom.IElement; overload;
    function toggle(animate: Variant): JExt.dom.IElement; overload;
    function un: JExt.dom.IElement; overload;
    function un(eventName: String): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant): JExt.dom.IElement; overload;
    function un(eventName: String; fn: Variant; scope: Variant): JExt.dom.IElement; overload;
    function unclip: JExt.dom.IElement;
    procedure unmask;
    function unselectable: JExt.dom.IElement;
    function update: JExt.dom.IElement; overload;
    function update(html: String): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean): JExt.dom.IElement; overload;
    function update(html: String; loadScripts: Boolean; callback: Variant): JExt.dom.IElement; overload;
  end;

//Ext.dom

type
  JIHelper = class external(JExt.dom.IAbstractHelper)
    useDom: Boolean; // nullable
    function createDom: JHTMLElement; overload;
    function createDom(o: Variant): JHTMLElement; overload;
    function createHtml: String; overload;
    function createHtml(spec: Variant): String; overload;
    function createTemplate: JExt.ITemplate; overload;
    function createTemplate(o: Variant): JExt.ITemplate; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
  end;

//Ext.dom

type
  JILayer = class external(JExt.IElement)
    cls: String; // nullable
    constrain: Boolean; // nullable
    dh: Variant; // nullable
    hideMode: String; // nullable
    shadow: Variant; // nullable
    shadowOffset: Float; // nullable
    shim: Boolean; // nullable
    useDisplay: Boolean; // nullable
    visibilityCls: String; // nullable
    zindex: Float; // nullable
    procedure remove;
    function setBounds: JExt.dom.IElement; overload;
    function setBounds(x: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(h: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop: JExt.dom.IElement; overload;
    function setLeftTop(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop(left: Variant; top: Variant): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(w: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(w: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setZIndex: JExt.ILayer; overload;
    function setZIndex(zindex: Float): JExt.ILayer; overload;
  end;

//Ext

type
  JILayer = class external(JExt.IElement)
    cls: String; // nullable
    constrain: Boolean; // nullable
    dh: Variant; // nullable
    hideMode: String; // nullable
    shadow: Variant; // nullable
    shadowOffset: Float; // nullable
    shim: Boolean; // nullable
    useDisplay: Boolean; // nullable
    visibilityCls: String; // nullable
    zindex: Float; // nullable
    procedure remove;
    function setBounds: JExt.dom.IElement; overload;
    function setBounds(x: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setBounds(x: Variant; y: Variant; width: Variant; height: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(h: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setHeight(h: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop: JExt.dom.IElement; overload;
    function setLeftTop(left: Variant): JExt.dom.IElement; overload;
    function setLeftTop(left: Variant; top: Variant): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(w: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setSize(w: Variant; h: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.dom.IElement; overload;
    function setVisible(visible: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setVisible(visible: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(w: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant; callback: Variant): JExt.dom.IElement; overload;
    function setWidth(w: Variant; animate: Variant; duration: Variant; callback: Variant; easing: Variant): JExt.dom.IElement; overload;
    function setZIndex: JExt.ILayer; overload;
    function setZIndex(zindex: Float): JExt.ILayer; overload;
  end;

//Ext.dom

type
  JQuery = class external 'Query'
    matchers: Variant;
    operators: Variant;
    pseudos: Variant;
    function compile: Variant; overload;
    function compile(selector: String): Variant; overload;
    function compile(selector: String; &type: String): Variant; overload;
    function filter: array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String; nonMatches: Boolean): array of JHTMLElement; overload;
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function jsSelect: array of JHTMLElement; overload;
    function jsSelect(selector: String): array of JHTMLElement; overload;
    function jsSelect(selector: String; root: Variant): array of JHTMLElement; overload;
    function select: array of JHTMLElement; overload;
    function select(path: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String; single: Boolean): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: JHTMLElement): JHTMLElement; overload;
    function selectNumber: Float; overload;
    function selectNumber(selector: String): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement; defaultValue: Float): Float; overload;
    function selectValue: String; overload;
    function selectValue(selector: String): String; overload;
    function selectValue(selector: String; root: JHTMLElement): String; overload;
    function selectValue(selector: String; root: JHTMLElement; defaultValue: String): String; overload;
  end;

  JIQuery = class external
  end;

//Ext

type
  JDomQuery = class external 'DomQuery'
    matchers: Variant;
    operators: Variant;
    pseudos: Variant;
    function compile: Variant; overload;
    function compile(selector: String): Variant; overload;
    function compile(selector: String; &type: String): Variant; overload;
    function filter: array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String; nonMatches: Boolean): array of JHTMLElement; overload;
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function jsSelect: array of JHTMLElement; overload;
    function jsSelect(selector: String): array of JHTMLElement; overload;
    function jsSelect(selector: String; root: Variant): array of JHTMLElement; overload;
    function select: array of JHTMLElement; overload;
    function select(path: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String; single: Boolean): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: JHTMLElement): JHTMLElement; overload;
    function selectNumber: Float; overload;
    function selectNumber(selector: String): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement; defaultValue: Float): Float; overload;
    function selectValue: String; overload;
    function selectValue(selector: String): String; overload;
    function selectValue(selector: String; root: JHTMLElement): String; overload;
    function selectValue(selector: String; root: JHTMLElement; defaultValue: String): String; overload;
  end;

  JIDomQuery = class external
  end;

//Ext.core

type
  JDomQuery = class external 'DomQuery'
    matchers: Variant;
    operators: Variant;
    pseudos: Variant;
    function compile: Variant; overload;
    function compile(selector: String): Variant; overload;
    function compile(selector: String; &type: String): Variant; overload;
    function filter: array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String): array of JHTMLElement; overload;
    function filter(el: array of JHTMLElement; selector: String; nonMatches: Boolean): array of JHTMLElement; overload;
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function jsSelect: array of JHTMLElement; overload;
    function jsSelect(selector: String): array of JHTMLElement; overload;
    function jsSelect(selector: String; root: Variant): array of JHTMLElement; overload;
    function select: array of JHTMLElement; overload;
    function select(path: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String): array of JHTMLElement; overload;
    function select(path: String; root: JHTMLElement; &type: String; single: Boolean): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: JHTMLElement): JHTMLElement; overload;
    function selectNumber: Float; overload;
    function selectNumber(selector: String): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement): Float; overload;
    function selectNumber(selector: String; root: JHTMLElement; defaultValue: Float): Float; overload;
    function selectValue: String; overload;
    function selectValue(selector: String): String; overload;
    function selectValue(selector: String; root: JHTMLElement): String; overload;
    function selectValue(selector: String; root: JHTMLElement; defaultValue: String): String; overload;
  end;

  JIDomQuery = class external
  end;

//Ext

type
  JDomHelper = class external 'DomHelper'
    self: JExt.IClass;
    useDom: Boolean;
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; o: Variant): Variant; overload;
    function append(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    procedure applyStyles; overload;
    procedure applyStyles(el: Variant); overload;
    procedure applyStyles(el: Variant; styles: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function createDom: JHTMLElement; overload;
    function createDom(o: Variant): JHTMLElement; overload;
    function createHtml: String; overload;
    function createHtml(spec: Variant): String; overload;
    function createTemplate: JExt.ITemplate; overload;
    function createTemplate(o: Variant): JExt.ITemplate; overload;
    function generateStyles: Variant; overload;
    function generateStyles(styles: Variant): Variant; overload;
    function generateStyles(styles: Variant; buffer: array of String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertHtml: JHTMLElement; overload;
    function insertHtml(where: String): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant; html: String): JHTMLElement; overload;
    function markup: String; overload;
    function markup(spec: Variant): String; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIDomHelper = class external(JExt.dom.IHelper)
  end;

//Ext.core

type
  JDomHelper = class external 'DomHelper'
    self: JExt.IClass;
    useDom: Boolean;
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; o: Variant): Variant; overload;
    function append(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    procedure applyStyles; overload;
    procedure applyStyles(el: Variant); overload;
    procedure applyStyles(el: Variant; styles: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function createDom: JHTMLElement; overload;
    function createDom(o: Variant): JHTMLElement; overload;
    function createHtml: String; overload;
    function createHtml(spec: Variant): String; overload;
    function createTemplate: JExt.ITemplate; overload;
    function createTemplate(o: Variant): JExt.ITemplate; overload;
    function generateStyles: Variant; overload;
    function generateStyles(styles: Variant): Variant; overload;
    function generateStyles(styles: Variant; buffer: array of String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertHtml: JHTMLElement; overload;
    function insertHtml(where: String): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant; html: String): JHTMLElement; overload;
    function markup: String; overload;
    function markup(spec: Variant): String; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIDomHelper = class external(JExt.dom.IHelper)
  end;

//Ext.draw

type
  JColor = class external 'Color'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fromHSL: Variant; overload;
    function fromHSL(h: Float): Variant; overload;
    function fromHSL(h: Float; s: Float): Variant; overload;
    function fromHSL(h: Float; s: Float; l: Float): Variant; overload;
    function fromString: Variant; overload;
    function fromString(str: String): Variant; overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function toHex: String; overload;
    function toHex(color: Variant): String; overload;
  end;

  JIColor = class external(JExt.IBase)
    lightnessFactor: Float; // nullable
    function getBlue: Float;
    function getDarker: Variant; overload;
    function getDarker(factor: Float): Variant; overload;
    function getGrayscale: Float;
    function getGreen: Float;
    function getHSL: array of Float;
    function getLighter: Variant; overload;
    function getLighter(factor: Float): Variant; overload;
    function getRGB: array of Float;
    function getRed: Float;
    function toString: String;
  end;

//Ext.draw

type
  JIComponent = class external(JExt.IComponent)
    autoSize: Boolean; // nullable
    baseCls: String; // nullable
    componentLayout: Variant; // nullable
    enginePriority: array of String; // nullable
    gradients: array of Variant; // nullable
    items: array of JExt.draw.ISprite; // nullable
    shrinkWrap: Variant; // nullable
    viewBox: Boolean; // nullable
    surface: JExt.draw.ISurface; // nullable
  end;

//Ext.draw

type
  JICompositeSprite = class external(JExt.util.IMixedCollection, JExt.util.IAnimate)
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; o: Variant): Variant; overload;
    procedure addCls; overload;
    procedure addCls(cls: String); overload;
    function animate: Variant; overload;
    function animate(config: Variant): Variant; overload;
    procedure destroy;
    function getActiveAnimation: Variant;
    function getBBox: Variant;
    function hasActiveFx: Variant;
    function hide: JExt.draw.ICompositeSprite; overload;
    function hide(redraw: Boolean): JExt.draw.ICompositeSprite; overload;
    function insert: Variant; overload;
    function insert(index: Variant): Variant; overload;
    function insert(index: Variant; key: Variant): Variant; overload;
    function insert(index: Variant; key: Variant; o: Variant): Variant; overload;
    procedure redraw;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    procedure removeCls; overload;
    procedure removeCls(cls: String); overload;
    function sequenceFx: Variant;
    function setAttributes: JExt.draw.ICompositeSprite; overload;
    function setAttributes(attrs: Variant): JExt.draw.ICompositeSprite; overload;
    function setAttributes(attrs: Variant; redraw: Boolean): JExt.draw.ICompositeSprite; overload;
    procedure setStyle; overload;
    procedure setStyle(style: String); overload;
    function show: JExt.draw.ICompositeSprite; overload;
    function show(redraw: Boolean): JExt.draw.ICompositeSprite; overload;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    function syncFx: Variant;
  end;

//Ext.draw

type
  JDraw = class external 'Draw'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function snapEndsByDate: Variant; overload;
    function snapEndsByDate(from: Variant): Variant; overload;
    function snapEndsByDate(from: Variant; to: Variant): Variant; overload;
    function snapEndsByDate(from: Variant; to: Variant; stepsMax: Float): Variant; overload;
    function snapEndsByDate(from: Variant; to: Variant; stepsMax: Float; lockEnds: Boolean): Variant; overload;
    function snapEndsByDateAndStep: Variant; overload;
    function snapEndsByDateAndStep(from: Variant): Variant; overload;
    function snapEndsByDateAndStep(from: Variant; to: Variant): Variant; overload;
    function snapEndsByDateAndStep(from: Variant; to: Variant; step: array of Variant): Variant; overload;
    function snapEndsByDateAndStep(from: Variant; to: Variant; step: array of Variant; lockEnds: Boolean): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIDraw = class external(JExt.IBase)
  end;

//Ext.draw.engine

type
  JImageExporter = class external 'ImageExporter'
    defaultUrl: String;
    heightParam: String;
    self: JExt.IClass;
    supportedTypes: array of Variant;
    svgParam: String;
    typeParam: String;
    widthParam: String;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function generate: Boolean; overload;
    function generate(surface: JExt.draw.ISurface): Boolean; overload;
    function generate(surface: JExt.draw.ISurface; config: Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIImageExporter = class external(JExt.IBase)
  end;

//Ext.draw.engine

type
  JISvg = class external(JExt.draw.ISurface)
    procedure addCls; overload;
    procedure addCls(sprite: Variant); overload;
    procedure addCls(sprite: Variant; className: Variant); overload;
    procedure addGradient; overload;
    procedure addGradient(gradient: Variant); overload;
    procedure applyZIndex; overload;
    procedure applyZIndex(sprite: JExt.draw.ISprite); overload;
    procedure destroy;
    function getRegion: JExt.util.IRegion;
    function hasCls: Boolean; overload;
    function hasCls(sprite: JExt.draw.ISprite): Boolean; overload;
    function hasCls(sprite: JExt.draw.ISprite; className: String): Boolean; overload;
    procedure removeCls; overload;
    procedure removeCls(sprite: Variant); overload;
    procedure removeCls(sprite: Variant; className: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Variant); overload;
    procedure setSize(width: Variant; height: Variant); overload;
    procedure setText; overload;
    procedure setText(sprite: Variant); overload;
    procedure setText(sprite: Variant; textString: Variant); overload;
  end;

//Ext.draw.engine

type
  JSvgExporter = class external 'SvgExporter'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function generate: String; overload;
    function generate(surface: JExt.draw.ISurface): String; overload;
    function generate(surface: JExt.draw.ISurface; config: Variant): String; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JISvgExporter = class external(JExt.IBase)
  end;

//Ext.draw.engine

type
  JIVml = class external(JExt.draw.ISurface)
    procedure addCls; overload;
    procedure addCls(sprite: Variant); overload;
    procedure addCls(sprite: Variant; className: Variant); overload;
    procedure addGradient; overload;
    procedure addGradient(gradient: Variant); overload;
    procedure destroy;
    procedure removeCls; overload;
    procedure removeCls(sprite: Variant); overload;
    procedure removeCls(sprite: Variant; className: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Variant); overload;
    procedure setSize(width: Variant; height: Variant); overload;
    procedure setText; overload;
    procedure setText(sprite: Variant); overload;
    procedure setText(sprite: Variant; text: Variant); overload;
  end;

//Ext.draw

type
  JIMatrix = class external(JExt.IBase)
  end;

//Ext.draw

type
  JISprite = class external(JExt.IBase, JExt.util.IObservable, JExt.util.IAnimate)
    draggable: Boolean; // nullable
    fill: String; // nullable
    font: String; // nullable
    group: Variant; // nullable
    height: Float; // nullable
    opacity: Float; // nullable
    path: String; // nullable
    radius: Float; // nullable
    radiusX: Float; // nullable
    radiusY: Float; // nullable
    src: String; // nullable
    stroke: String; // nullable
    strokewidth: Float; // nullable
    text: String; // nullable
    &type: String; // nullable
    width: Float; // nullable
    x: Float; // nullable
    y: Float; // nullable
    dd: JExt.dd.IDragSource; // nullable
    isSprite: Boolean; // nullable
    function addCls: JExt.draw.ISprite; overload;
    function addCls(className: Variant): JExt.draw.ISprite; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function animate: Variant; overload;
    function animate(config: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getActiveAnimation: Variant;
    function getBBox: Variant;
    function hasActiveFx: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function hide: JExt.draw.ISprite; overload;
    function hide(redraw: Boolean): JExt.draw.ISprite; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function redraw: JExt.draw.ISprite;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Boolean;
    function removeCls: JExt.draw.ISprite; overload;
    function removeCls(className: Variant): JExt.draw.ISprite; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sequenceFx: Variant;
    function setAttributes: JExt.draw.ISprite; overload;
    function setAttributes(attrs: Variant): JExt.draw.ISprite; overload;
    function setAttributes(attrs: Variant; redraw: Boolean): JExt.draw.ISprite; overload;
    function setStyle: JExt.draw.ISprite; overload;
    function setStyle(&property: Variant): JExt.draw.ISprite; overload;
    function setStyle(&property: Variant; value: String): JExt.draw.ISprite; overload;
    function show: JExt.draw.ISprite; overload;
    function show(redraw: Boolean): JExt.draw.ISprite; overload;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    function syncFx: Variant;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.draw

type
  JISpriteDD = class external(JExt.dd.IDragSource)
    procedure createFrame;
    function getDragEl: JHTMLElement; overload;
    function getDragEl(e: Variant): JHTMLElement; overload;
    procedure onDrag; overload;
    procedure onDrag(e: Variant); overload;
    procedure setDragElPos;
  end;

//Ext.draw

type
  JSurface = class external 'Surface'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant; overload;
    function create(config: Variant): Variant; overload;
    function create(config: Variant; enginePriority: array of String): Variant; overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function save: Variant; overload;
    function save(surface: JExt.draw.ISurface): Variant; overload;
    function save(surface: JExt.draw.ISurface; config: Variant): Variant; overload;
  end;

  JISurface = class external(JExt.IBase, JExt.util.IObservable)
    height: Float; // nullable
    items: array of JExt.draw.ISprite; // nullable
    width: Float; // nullable
    function add: Variant; overload;
    function add(args: Variant): Variant; overload;
    procedure addCls; overload;
    procedure addCls(sprite: Variant); overload;
    procedure addCls(sprite: Variant; className: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addGradient; overload;
    procedure addGradient(gradient: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getGroup: Variant; overload;
    function getGroup(id: String): Variant; overload;
    procedure getId;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure remove; overload;
    procedure remove(sprite: JExt.draw.ISprite); overload;
    procedure remove(sprite: JExt.draw.ISprite; destroySprite: Boolean); overload;
    procedure removeAll; overload;
    procedure removeAll(destroySprites: Boolean); overload;
    procedure removeCls; overload;
    procedure removeCls(sprite: Variant); overload;
    procedure removeCls(sprite: Variant; className: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setSize; overload;
    procedure setSize(w: Float); overload;
    procedure setSize(w: Float; h: Float); overload;
    procedure setStyle; overload;
    procedure setStyle(sprite: Variant); overload;
    procedure setStyle(sprite: Variant; styles: Variant); overload;
    procedure setText; overload;
    procedure setText(sprite: Variant); overload;
    procedure setText(sprite: Variant; text: String); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.draw

type
  JIText = class external(JExt.draw.IComponent)
    autoSize: Boolean; // nullable
    baseCls: String; // nullable
    degrees: Float; // nullable
    styleSelector: String; // nullable
    text: String; // nullable
    viewBox: Boolean; // nullable
    procedure initComponent;
    procedure setAngle; overload;
    procedure setAngle(degrees: Float); overload;
    procedure setText; overload;
    procedure setText(t: String); overload;
  end;

//Ext

type
  JIEditor = class external(JExt.container.IContainer)
    alignment: String; // nullable
    allowBlur: Boolean; // nullable
    autoSize: Variant; // nullable
    baseCls: String; // nullable
    cancelOnEsc: Boolean; // nullable
    completeOnEnter: Boolean; // nullable
    constrain: Boolean; // nullable
    field: JExt.form.field.IField; // nullable
    focusOnToFront: Boolean; // nullable
    hidden: Boolean; // nullable
    hideEl: Boolean; // nullable
    ignoreNoChange: Boolean; // nullable
    layout: Variant; // nullable
    offsets: array of Float; // nullable
    parentEl: Variant; // nullable
    revertInvalid: Boolean; // nullable
    shadow: Variant; // nullable
    swallowKeys: Boolean; // nullable
    updateEl: Boolean; // nullable
    value: Variant; // nullable
    procedure afterRender; overload;
    procedure afterRender(ct: Variant); overload;
    procedure afterRender(ct: Variant; position: Variant); overload;
    procedure cancelEdit; overload;
    procedure cancelEdit(remainVisible: Boolean); overload;
    procedure completeEdit; overload;
    procedure completeEdit(remainVisible: Boolean); overload;
    function getValue: Variant;
    procedure onHide;
    procedure onShow;
    procedure realign; overload;
    procedure realign(autoSize: Boolean); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
    procedure startEdit; overload;
    procedure startEdit(el: Variant); overload;
    procedure startEdit(el: Variant; value: String); overload;
  end;

//Ext

type
  JIElementLoader = class external(JExt.IBase, JExt.util.IObservable)
    ajaxOptions: Variant; // nullable
    autoLoad: Variant; // nullable
    baseParams: Variant; // nullable
    callback: Variant; // nullable
    failure: Variant; // nullable
    loadMask: Variant; // nullable
    params: Variant; // nullable
    renderer: Variant; // nullable
    scope: Variant; // nullable
    scripts: Boolean; // nullable
    success: Variant; // nullable
    target: Variant; // nullable
    url: String; // nullable
    isLoader: Boolean; // nullable
    procedure abort;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getTarget: JExt.IComponent;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isAutoRefreshing: Boolean;
    procedure load; overload;
    procedure load(options: Variant); overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure setTarget; overload;
    procedure setTarget(target: Variant); overload;
    procedure startAutoRefresh; overload;
    procedure startAutoRefresh(interval: Float); overload;
    procedure startAutoRefresh(interval: Float; options: Variant); overload;
    procedure stopAutoRefresh;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.enums

type
  JIFeature = class external
    abstractsummary: String; // nullable
    feature: String; // nullable
    grouping: String; // nullable
    groupingsummary: String; // nullable
    rowbody: String; // nullable
    summary: String; // nullable
  end;

//Ext.enums

type
  JILayout = class external
    absolute: String; // nullable
    accordion: String; // nullable
    anchor: String; // nullable
    auto: String; // nullable
    autocomponent: String; // nullable
    autocontainer: String; // nullable
    border: String; // nullable
    box: String; // nullable
    card: String; // nullable
    checkboxgroup: String; // nullable
    column: String; // nullable
    container: String; // nullable
    fit: String; // nullable
    form: String; // nullable
    hbox: String; // nullable
    table: String; // nullable
    vbox: String; // nullable
  end;

//Ext.enums

type
  JIPlugin = class external
    bufferedrenderer: String; // nullable
    cellediting: String; // nullable
    gridheaderresizer: String; // nullable
    gridviewdragdrop: String; // nullable
    rowediting: String; // nullable
    rowexpander: String; // nullable
    treeviewdragdrop: String; // nullable
  end;

//Ext.enums

type
  JIWidget = class external
    actioncolumn: String; // nullable
    booleancolumn: String; // nullable
    boundlist: String; // nullable
    box: String; // nullable
    button: String; // nullable
    buttongroup: String; // nullable
    chart: String; // nullable
    checkbox: String; // nullable
    checkboxfield: String; // nullable
    checkboxgroup: String; // nullable
    checkcolumn: String; // nullable
    colormenu: String; // nullable
    colorpicker: String; // nullable
    combo: String; // nullable
    combobox: String; // nullable
    component: String; // nullable
    container: String; // nullable
    cycle: String; // nullable
    dataview: String; // nullable
    datecolumn: String; // nullable
    datefield: String; // nullable
    datemenu: String; // nullable
    datepicker: String; // nullable
    displayfield: String; // nullable
    draw: String; // nullable
    editor: String; // nullable
    field: String; // nullable
    fieldcontainer: String; // nullable
    fieldset: String; // nullable
    filebutton: String; // nullable
    filefield: String; // nullable
    fileuploadfield: String; // nullable
    flash: String; // nullable
    form: String; // nullable
    grid: String; // nullable
    gridcolumn: String; // nullable
    gridpanel: String; // nullable
    gridview: String; // nullable
    header: String; // nullable
    headercontainer: String; // nullable
    hidden: String; // nullable
    hiddenfield: String; // nullable
    htmleditor: String; // nullable
    image: String; // nullable
    imagecomponent: String; // nullable
    jsonpstore: String; // nullable
    &label: String; // nullable
    loadmask: String; // nullable
    menu: String; // nullable
    menucheckitem: String; // nullable
    menuitem: String; // nullable
    menuseparator: String; // nullable
    messagebox: String; // nullable
    multislider: String; // nullable
    numbercolumn: String; // nullable
    numberfield: String; // nullable
    pagingtoolbar: String; // nullable
    panel: String; // nullable
    pickerfield: String; // nullable
    progressbar: String; // nullable
    propertygrid: String; // nullable
    quicktip: String; // nullable
    radio: String; // nullable
    radiofield: String; // nullable
    radiogroup: String; // nullable
    rownumberer: String; // nullable
    slider: String; // nullable
    sliderfield: String; // nullable
    slidertip: String; // nullable
    spinnerfield: String; // nullable
    splitbutton: String; // nullable
    splitter: String; // nullable
    tab: String; // nullable
    tabbar: String; // nullable
    tablepanel: String; // nullable
    tableview: String; // nullable
    tabpanel: String; // nullable
    tbfill: String; // nullable
    tbitem: String; // nullable
    tbseparator: String; // nullable
    tbspacer: String; // nullable
    tbtext: String; // nullable
    templatecolumn: String; // nullable
    text: String; // nullable
    textarea: String; // nullable
    textareafield: String; // nullable
    textfield: String; // nullable
    timefield: String; // nullable
    timepicker: String; // nullable
    tip: String; // nullable
    tool: String; // nullable
    toolbar: String; // nullable
    tooltip: String; // nullable
    treepanel: String; // nullable
    treeview: String; // nullable
    trigger: String; // nullable
    triggerfield: String; // nullable
    viewport: String; // nullable
    window: String; // nullable
  end;

//Ext

type
  JError = class external 'Error'
    procedure handle; overload;
    procedure handle(err: JExt.IError); overload;
    procedure raise; overload;
    procedure raise(err: Variant); overload;
  end;

  JIError = class external
    ignore: Boolean; // nullable
    notify: Boolean; // nullable
    function toString: String;
  end;

//Ext

type
  JEventManager = class external 'EventManager'
    idleEvent: Variant;
    procedure addListener; overload;
    procedure addListener(el: Variant); overload;
    procedure addListener(el: Variant; eventName: String); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant; scope: Variant); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant; scope: Variant; options: Variant); overload;
    function getId: String; overload;
    function getId(element: Variant): String; overload;
    function getKeyEvent: String;
    function getPageX: Float; overload;
    function getPageX(event: Variant): Float; overload;
    function getPageXY: array of Float; overload;
    function getPageXY(event: Variant): array of Float; overload;
    function getPageY: Float; overload;
    function getPageY(event: Variant): Float; overload;
    function getRelatedTarget: JHTMLElement; overload;
    function getRelatedTarget(event: Variant): JHTMLElement; overload;
    function getTarget: JHTMLElement; overload;
    function getTarget(event: Variant): JHTMLElement; overload;
    procedure on; overload;
    procedure on(el: Variant); overload;
    procedure on(el: Variant; eventName: String); overload;
    procedure on(el: Variant; eventName: String; handler: Variant); overload;
    procedure on(el: Variant; eventName: String; handler: Variant; scope: Variant); overload;
    procedure on(el: Variant; eventName: String; handler: Variant; scope: Variant; options: Variant); overload;
    procedure onDocumentReady; overload;
    procedure onDocumentReady(fn: Variant); overload;
    procedure onDocumentReady(fn: Variant; scope: Variant); overload;
    procedure onDocumentReady(fn: Variant; scope: Variant; options: Variant); overload;
    procedure onWindowResize; overload;
    procedure onWindowResize(fn: Variant); overload;
    procedure onWindowResize(fn: Variant; scope: Variant); overload;
    procedure onWindowResize(fn: Variant; scope: Variant; options: Boolean); overload;
    procedure onWindowUnload; overload;
    procedure onWindowUnload(fn: Variant); overload;
    procedure onWindowUnload(fn: Variant; scope: Variant); overload;
    procedure onWindowUnload(fn: Variant; scope: Variant; options: Boolean); overload;
    procedure pollScroll;
    procedure preventDefault; overload;
    procedure preventDefault(event: JEvent); overload;
    procedure purgeElement; overload;
    procedure purgeElement(el: Variant); overload;
    procedure purgeElement(el: Variant; eventName: String); overload;
    procedure removeAll; overload;
    procedure removeAll(el: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(el: Variant); overload;
    procedure removeListener(el: Variant; eventName: String); overload;
    procedure removeListener(el: Variant; eventName: String; fn: Variant); overload;
    procedure removeListener(el: Variant; eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeResizeListener; overload;
    procedure removeResizeListener(fn: Variant); overload;
    procedure removeResizeListener(fn: Variant; scope: Variant); overload;
    procedure removeUnloadListener; overload;
    procedure removeUnloadListener(fn: Variant); overload;
    procedure removeUnloadListener(fn: Variant; scope: Variant); overload;
    procedure stopEvent; overload;
    procedure stopEvent(event: JEvent); overload;
    procedure stopPropagation; overload;
    procedure stopPropagation(event: JEvent); overload;
    procedure un; overload;
    procedure un(el: Variant); overload;
    procedure un(el: Variant; eventName: String); overload;
    procedure un(el: Variant; eventName: String; fn: Variant); overload;
    procedure un(el: Variant; eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIEventManager = class external
  end;

//Ext

type
  JEventObject = class external 'EventObject'
    A: Float;
    ALT: Float;
    B: Float;
    BACKSPACE: Float;
    C: Float;
    CAPS_LOCK: Float;
    CONTEXT_MENU: Float;
    CTRL: Float;
    D: Float;
    DELETE: Float;
    DOWN: Float;
    E: Float;
    EIGHT: Float;
    &END: Float;
    ENTER: Float;
    ESC: Float;
    F: Float;
    F1: Float;
    F10: Float;
    F11: Float;
    F12: Float;
    F2: Float;
    F3: Float;
    F4: Float;
    F5: Float;
    F6: Float;
    F7: Float;
    F8: Float;
    F9: Float;
    FIVE: Float;
    FOUR: Float;
    G: Float;
    H: Float;
    HOME: Float;
    I: Float;
    INSERT: Float;
    J: Float;
    K: Float;
    L: Float;
    LEFT: Float;
    M: Float;
    N: Float;
    NINE: Float;
    NUM_CENTER: Float;
    NUM_DIVISION: Float;
    NUM_EIGHT: Float;
    NUM_FIVE: Float;
    NUM_FOUR: Float;
    NUM_MINUS: Float;
    NUM_MULTIPLY: Float;
    NUM_NINE: Float;
    NUM_ONE: Float;
    NUM_PERIOD: Float;
    NUM_PLUS: Float;
    NUM_SEVEN: Float;
    NUM_SIX: Float;
    NUM_THREE: Float;
    NUM_TWO: Float;
    NUM_ZERO: Float;
    O: Float;
    ONE: Float;
    P: Float;
    PAGE_DOWN: Float;
    PAGE_UP: Float;
    PAUSE: Float;
    PRINT_SCREEN: Float;
    Q: Float;
    R: Float;
    RETURN: Float;
    RIGHT: Float;
    S: Float;
    SEVEN: Float;
    SHIFT: Float;
    SIX: Float;
    SPACE: Float;
    T: Float;
    TAB: Float;
    THREE: Float;
    TWO: Float;
    U: Float;
    UP: Float;
    V: Float;
    W: Float;
    WHEEL_SCALE: Float;
    X: Float;
    Y: Float;
    Z: Float;
    ZERO: Float;
    altKey: Boolean;
    ctrlKey: Boolean;
    shiftKey: Boolean;
    procedure correctWheelDelta; overload;
    procedure correctWheelDelta(delta: Float); overload;
    function getCharCode: Float;
    function getKey: Float;
    function getPageX: Float;
    function getPageY: Float;
    function getPoint: JExt.util.IPoint;
    function getRelatedTarget: JHTMLElement; overload;
    function getRelatedTarget(selector: String): JHTMLElement; overload;
    function getRelatedTarget(selector: String; maxDepth: Variant): JHTMLElement; overload;
    function getRelatedTarget(selector: String; maxDepth: Variant; returnEl: Boolean): JHTMLElement; overload;
    function getTarget: JHTMLElement; overload;
    function getTarget(selector: String): JHTMLElement; overload;
    function getTarget(selector: String; maxDepth: Variant): JHTMLElement; overload;
    function getTarget(selector: String; maxDepth: Variant; returnEl: Boolean): JHTMLElement; overload;
    function getWheelDelta: Float;
    function getWheelDeltas: Variant;
    function getX: Float;
    function getXY: array of Float;
    function getY: Float;
    function hasModifier: Boolean;
    procedure injectEvent; overload;
    procedure injectEvent(target: Variant); overload;
    function isNavKeyPress: Boolean;
    function isSpecialKey: Boolean;
    procedure preventDefault;
    procedure stopEvent;
    procedure stopPropagation;
    function within: Boolean; overload;
    function within(el: Variant): Boolean; overload;
    function within(el: Variant; related: Boolean): Boolean; overload;
    function within(el: Variant; related: Boolean; allowEl: Boolean): Boolean; overload;
  end;

  JIEventObject = class external
  end;

//Ext.flash

type
  JIComponent = class external(JExt.IComponent)
    backgroundColor: String; // nullable
    expressInstall: Boolean; // nullable
    flashAttributes: Variant; // nullable
    flashParams: Variant; // nullable
    flashVars: Variant; // nullable
    flashVersion: String; // nullable
    renderTpl: Variant; // nullable
    swfHeight: Variant; // nullable
    swfWidth: Variant; // nullable
    url: String; // nullable
    wmode: String; // nullable
    swf: JExt.IElement; // nullable
    EXPRESS_INSTALL_URL: String; // nullable
    procedure afterRender;
    procedure beforeDestroy;
    procedure getSwfId;
    procedure initComponent;
  end;

//Ext

type
  JIFlashComponent = class external(JExt.IComponent)
    backgroundColor: String; // nullable
    expressInstall: Boolean; // nullable
    flashAttributes: Variant; // nullable
    flashParams: Variant; // nullable
    flashVars: Variant; // nullable
    flashVersion: String; // nullable
    renderTpl: Variant; // nullable
    swfHeight: Variant; // nullable
    swfWidth: Variant; // nullable
    url: String; // nullable
    wmode: String; // nullable
    swf: JExt.IElement; // nullable
    EXPRESS_INSTALL_URL: String; // nullable
    procedure afterRender;
    procedure beforeDestroy;
    procedure getSwfId;
    procedure initComponent;
  end;

//Ext

type
  JFocusManager = class external 'FocusManager'
    enabled: Boolean;
    focusedCmp: JExt.IComponent;
    hasListeners: Variant;
    isObservable: Boolean;
    self: JExt.IClass;
    whitelist: array of String;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addXTypeToWhitelist; overload;
    procedure addXTypeToWhitelist(xtype: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure disable;
    procedure enable; overload;
    procedure enable(options: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure removeXTypeFromWhitelist; overload;
    procedure removeXTypeFromWhitelist(xtype: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIFocusManager = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext

type
  JFocusMgr = class external 'FocusMgr'
    enabled: Boolean;
    focusedCmp: JExt.IComponent;
    hasListeners: Variant;
    isObservable: Boolean;
    self: JExt.IClass;
    whitelist: array of String;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addXTypeToWhitelist; overload;
    procedure addXTypeToWhitelist(xtype: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure disable;
    procedure enable; overload;
    procedure enable(options: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure removeXTypeFromWhitelist; overload;
    procedure removeXTypeFromWhitelist(xtype: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIFocusMgr = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext.form.action

type
  JIAction = class external(JExt.IBase)
    failure: Variant; // nullable
    form: JExt.form.IBasic; // nullable
    headers: Variant; // nullable
    method: String; // nullable
    params: Variant; // nullable
    reset: Boolean; // nullable
    scope: Variant; // nullable
    submitEmptyText: Boolean; // nullable
    success: Variant; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    waitMsg: String; // nullable
    waitTitle: String; // nullable
    failureType: String; // nullable
    response: Variant; // nullable
    result: Variant; // nullable
    &type: String; // nullable
    CLIENT_INVALID: String; // nullable
    CONNECT_FAILURE: String; // nullable
    LOAD_FAILURE: String; // nullable
    SERVER_INVALID: String; // nullable
    procedure run;
  end;

//Ext.form

type
  JIAction = class external(JExt.IBase)
    failure: Variant; // nullable
    form: JExt.form.IBasic; // nullable
    headers: Variant; // nullable
    method: String; // nullable
    params: Variant; // nullable
    reset: Boolean; // nullable
    scope: Variant; // nullable
    submitEmptyText: Boolean; // nullable
    success: Variant; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    waitMsg: String; // nullable
    waitTitle: String; // nullable
    failureType: String; // nullable
    response: Variant; // nullable
    result: Variant; // nullable
    &type: String; // nullable
    CLIENT_INVALID: String; // nullable
    CONNECT_FAILURE: String; // nullable
    LOAD_FAILURE: String; // nullable
    SERVER_INVALID: String; // nullable
    procedure run;
  end;

//Ext.form.action

type
  JIDirectLoad = class external(JExt.form.action.ILoad)
    &type: String; // nullable
  end;

//Ext.form.action

type
  JIDirectSubmit = class external(JExt.form.action.ISubmit)
    &type: String; // nullable
  end;

//Ext.form.action

type
  JILoad = class external(JExt.form.action.IAction)
    &type: String; // nullable
  end;

//Ext.form.action

type
  JIStandardSubmit = class external(JExt.form.action.ISubmit)
    target: String; // nullable
  end;

//Ext.form.action

type
  JISubmit = class external(JExt.form.action.IAction)
    clientValidation: Boolean; // nullable
    &type: String; // nullable
    procedure run;
  end;

//Ext.form

type
  JIBasic = class external(JExt.util.IObservable)
    api: Variant; // nullable
    baseParams: Variant; // nullable
    errorReader: Variant; // nullable
    jsonSubmit: Boolean; // nullable
    method: String; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    reader: Variant; // nullable
    standardSubmit: Boolean; // nullable
    timeout: Float; // nullable
    trackResetOnLoad: Boolean; // nullable
    url: String; // nullable
    waitMsgTarget: Variant; // nullable
    waitTitle: String; // nullable
    owner: JExt.container.IContainer; // nullable
    function applyIfToFields: JExt.form.IBasic; overload;
    function applyIfToFields(obj: Variant): JExt.form.IBasic; overload;
    function applyToFields: JExt.form.IBasic; overload;
    function applyToFields(obj: Variant): JExt.form.IBasic; overload;
    procedure checkDirty;
    procedure checkValidity;
    function clearInvalid: JExt.form.IBasic;
    procedure destroy;
    function doAction: JExt.form.IBasic; overload;
    function doAction(action: Variant): JExt.form.IBasic; overload;
    function doAction(action: Variant; options: Variant): JExt.form.IBasic; overload;
    function findField: Variant; overload;
    function findField(id: String): Variant; overload;
    function getFieldValues: Variant; overload;
    function getFieldValues(dirtyOnly: Boolean): Variant; overload;
    function getFields: JExt.util.IMixedCollection;
    function getRecord: JExt.data.IModel;
    function getValues: Variant; overload;
    function getValues(asString: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean; useDataValues: Boolean): Variant; overload;
    procedure hasInvalidField;
    function hasUpload: Boolean;
    function isDirty: Boolean;
    function isValid: Boolean;
    function load: JExt.form.IBasic; overload;
    function load(options: Variant): JExt.form.IBasic; overload;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
    function markInvalid: JExt.form.IBasic; overload;
    function markInvalid(errors: Variant): JExt.form.IBasic; overload;
    function reset: JExt.form.IBasic; overload;
    function reset(resetRecord: Boolean): JExt.form.IBasic; overload;
    function setValues: JExt.form.IBasic; overload;
    function setValues(values: Variant): JExt.form.IBasic; overload;
    function submit: JExt.form.IBasic; overload;
    function submit(options: Variant): JExt.form.IBasic; overload;
    function updateRecord: JExt.form.IBasic; overload;
    function updateRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
  end;

//Ext.form

type
  JIBasicForm = class external(JExt.util.IObservable)
    api: Variant; // nullable
    baseParams: Variant; // nullable
    errorReader: Variant; // nullable
    jsonSubmit: Boolean; // nullable
    method: String; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    reader: Variant; // nullable
    standardSubmit: Boolean; // nullable
    timeout: Float; // nullable
    trackResetOnLoad: Boolean; // nullable
    url: String; // nullable
    waitMsgTarget: Variant; // nullable
    waitTitle: String; // nullable
    owner: JExt.container.IContainer; // nullable
    function applyIfToFields: JExt.form.IBasic; overload;
    function applyIfToFields(obj: Variant): JExt.form.IBasic; overload;
    function applyToFields: JExt.form.IBasic; overload;
    function applyToFields(obj: Variant): JExt.form.IBasic; overload;
    procedure checkDirty;
    procedure checkValidity;
    function clearInvalid: JExt.form.IBasic;
    procedure destroy;
    function doAction: JExt.form.IBasic; overload;
    function doAction(action: Variant): JExt.form.IBasic; overload;
    function doAction(action: Variant; options: Variant): JExt.form.IBasic; overload;
    function findField: Variant; overload;
    function findField(id: String): Variant; overload;
    function getFieldValues: Variant; overload;
    function getFieldValues(dirtyOnly: Boolean): Variant; overload;
    function getFields: JExt.util.IMixedCollection;
    function getRecord: JExt.data.IModel;
    function getValues: Variant; overload;
    function getValues(asString: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean; useDataValues: Boolean): Variant; overload;
    procedure hasInvalidField;
    function hasUpload: Boolean;
    function isDirty: Boolean;
    function isValid: Boolean;
    function load: JExt.form.IBasic; overload;
    function load(options: Variant): JExt.form.IBasic; overload;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
    function markInvalid: JExt.form.IBasic; overload;
    function markInvalid(errors: Variant): JExt.form.IBasic; overload;
    function reset: JExt.form.IBasic; overload;
    function reset(resetRecord: Boolean): JExt.form.IBasic; overload;
    function setValues: JExt.form.IBasic; overload;
    function setValues(values: Variant): JExt.form.IBasic; overload;
    function submit: JExt.form.IBasic; overload;
    function submit(options: Variant): JExt.form.IBasic; overload;
    function updateRecord: JExt.form.IBasic; overload;
    function updateRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
  end;

//Ext.form

type
  JICheckboxGroup = class external(JExt.form.IFieldContainer, JExt.form.field.IField)
    allowBlank: Boolean; // nullable
    blankText: String; // nullable
    columns: Variant; // nullable
    componentCls: String; // nullable
    defaultType: String; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    vertical: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    procedure clearInvalid;
    function extractFileInput: JHTMLElement;
    function getChecked: array of JExt.form.field.ICheckbox;
    function getErrors: array of String;
    function getModelData: Variant;
    function getName: String;
    function getSubmitData: Variant;
    procedure getValue;
    procedure initField;
    procedure initValue;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure onAdd; overload;
    procedure onAdd(field: Variant); overload;
    procedure onRemove; overload;
    procedure onRemove(item: Variant); overload;
    procedure reset;
    procedure resetOriginalValue;
    function setValue: JExt.form.ICheckboxGroup; overload;
    function setValue(value: Variant): JExt.form.ICheckboxGroup; overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function validate: Boolean;
  end;

//Ext.form

type
  JCheckboxManager = class external 'CheckboxManager'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JICheckboxManager = class external(JExt.util.IMixedCollection)
  end;

//Ext.form.field

type
  JIBase = class external(JExt.IComponent, JExt.form.ILabelable, JExt.form.field.IField)
    baseCls: String; // nullable
    checkChangeBuffer: Float; // nullable
    checkChangeEvents: array of String; // nullable
    componentLayout: Variant; // nullable
    dirtyCls: String; // nullable
    fieldCls: String; // nullable
    fieldStyle: String; // nullable
    focusCls: String; // nullable
    inputAttrTpl: Variant; // nullable
    inputId: String; // nullable
    inputType: String; // nullable
    invalidText: String; // nullable
    name: String; // nullable
    readOnly: Boolean; // nullable
    readOnlyCls: String; // nullable
    tabIndex: Float; // nullable
    validateOnBlur: Boolean; // nullable
    inputEl: JExt.IElement; // nullable
    maskOnDisable: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    procedure clearInvalid;
    function doComponentLayout: JExt.container.IContainer;
    function extractFileInput: JHTMLElement;
    function getActiveError: String;
    function getActiveErrors: array of String;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getFieldLabel: String;
    function getLabelWidth: Float;
    function getLabelableRenderData: Variant;
    function getModelData: Variant;
    function getName: String;
    function getRawValue: Variant;
    function getSubTplData: Variant;
    function getSubmitData: Variant;
    function getSubmitValue: Variant;
    function getValue: Variant;
    function hasActiveError: Boolean;
    function hasVisibleLabel: Boolean;
    procedure initComponent;
    procedure initEvents;
    procedure initField;
    procedure initLabelable;
    function initRenderData: Variant;
    procedure initValue;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    function processRawValue: Variant; overload;
    function processRawValue(value: Variant): Variant; overload;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure reset;
    procedure resetOriginalValue;
    procedure setActiveError; overload;
    procedure setActiveError(msg: String); overload;
    procedure setActiveErrors; overload;
    procedure setActiveErrors(errors: array of String); overload;
    procedure setFieldDefaults; overload;
    procedure setFieldDefaults(defaults: Variant); overload;
    procedure setFieldLabel; overload;
    procedure setFieldLabel(&label: String); overload;
    procedure setFieldStyle; overload;
    procedure setFieldStyle(style: Variant); overload;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function transformRawValue: Variant; overload;
    function transformRawValue(value: Variant): Variant; overload;
    function trimLabelSeparator: String;
    procedure unsetActiveError;
    function validate: Boolean;
    function validateValue: Boolean; overload;
    function validateValue(value: Variant): Boolean; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JIField = class external(JExt.IComponent, JExt.form.ILabelable, JExt.form.field.IField)
    baseCls: String; // nullable
    checkChangeBuffer: Float; // nullable
    checkChangeEvents: array of String; // nullable
    componentLayout: Variant; // nullable
    dirtyCls: String; // nullable
    fieldCls: String; // nullable
    fieldStyle: String; // nullable
    focusCls: String; // nullable
    inputAttrTpl: Variant; // nullable
    inputId: String; // nullable
    inputType: String; // nullable
    invalidText: String; // nullable
    name: String; // nullable
    readOnly: Boolean; // nullable
    readOnlyCls: String; // nullable
    tabIndex: Float; // nullable
    validateOnBlur: Boolean; // nullable
    inputEl: JExt.IElement; // nullable
    maskOnDisable: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    procedure clearInvalid;
    function doComponentLayout: JExt.container.IContainer;
    function extractFileInput: JHTMLElement;
    function getActiveError: String;
    function getActiveErrors: array of String;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getFieldLabel: String;
    function getLabelWidth: Float;
    function getLabelableRenderData: Variant;
    function getModelData: Variant;
    function getName: String;
    function getRawValue: Variant;
    function getSubTplData: Variant;
    function getSubmitData: Variant;
    function getSubmitValue: Variant;
    function getValue: Variant;
    function hasActiveError: Boolean;
    function hasVisibleLabel: Boolean;
    procedure initComponent;
    procedure initEvents;
    procedure initField;
    procedure initLabelable;
    function initRenderData: Variant;
    procedure initValue;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    function processRawValue: Variant; overload;
    function processRawValue(value: Variant): Variant; overload;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure reset;
    procedure resetOriginalValue;
    procedure setActiveError; overload;
    procedure setActiveError(msg: String); overload;
    procedure setActiveErrors; overload;
    procedure setActiveErrors(errors: array of String); overload;
    procedure setFieldDefaults; overload;
    procedure setFieldDefaults(defaults: Variant); overload;
    procedure setFieldLabel; overload;
    procedure setFieldLabel(&label: String); overload;
    procedure setFieldStyle; overload;
    procedure setFieldStyle(style: Variant); overload;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function transformRawValue: Variant; overload;
    function transformRawValue(value: Variant): Variant; overload;
    function trimLabelSeparator: String;
    procedure unsetActiveError;
    function validate: Boolean;
    function validateValue: Boolean; overload;
    function validateValue(value: Variant): Boolean; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JIBaseField = class external(JExt.IComponent, JExt.form.ILabelable, JExt.form.field.IField)
    baseCls: String; // nullable
    checkChangeBuffer: Float; // nullable
    checkChangeEvents: array of String; // nullable
    componentLayout: Variant; // nullable
    dirtyCls: String; // nullable
    fieldCls: String; // nullable
    fieldStyle: String; // nullable
    focusCls: String; // nullable
    inputAttrTpl: Variant; // nullable
    inputId: String; // nullable
    inputType: String; // nullable
    invalidText: String; // nullable
    name: String; // nullable
    readOnly: Boolean; // nullable
    readOnlyCls: String; // nullable
    tabIndex: Float; // nullable
    validateOnBlur: Boolean; // nullable
    inputEl: JExt.IElement; // nullable
    maskOnDisable: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    procedure clearInvalid;
    function doComponentLayout: JExt.container.IContainer;
    function extractFileInput: JHTMLElement;
    function getActiveError: String;
    function getActiveErrors: array of String;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getFieldLabel: String;
    function getLabelWidth: Float;
    function getLabelableRenderData: Variant;
    function getModelData: Variant;
    function getName: String;
    function getRawValue: Variant;
    function getSubTplData: Variant;
    function getSubmitData: Variant;
    function getSubmitValue: Variant;
    function getValue: Variant;
    function hasActiveError: Boolean;
    function hasVisibleLabel: Boolean;
    procedure initComponent;
    procedure initEvents;
    procedure initField;
    procedure initLabelable;
    function initRenderData: Variant;
    procedure initValue;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    function processRawValue: Variant; overload;
    function processRawValue(value: Variant): Variant; overload;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure reset;
    procedure resetOriginalValue;
    procedure setActiveError; overload;
    procedure setActiveError(msg: String); overload;
    procedure setActiveErrors; overload;
    procedure setActiveErrors(errors: array of String); overload;
    procedure setFieldDefaults; overload;
    procedure setFieldDefaults(defaults: Variant); overload;
    procedure setFieldLabel; overload;
    procedure setFieldLabel(&label: String); overload;
    procedure setFieldStyle; overload;
    procedure setFieldStyle(style: Variant); overload;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function transformRawValue: Variant; overload;
    function transformRawValue(value: Variant): Variant; overload;
    function trimLabelSeparator: String;
    procedure unsetActiveError;
    function validate: Boolean;
    function validateValue: Boolean; overload;
    function validateValue(value: Variant): Boolean; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JICheckbox = class external(JExt.form.field.IBase)
    afterBoxLabelTextTpl: Variant; // nullable
    afterBoxLabelTpl: Variant; // nullable
    beforeBoxLabelTextTpl: Variant; // nullable
    beforeBoxLabelTpl: Variant; // nullable
    boxLabel: String; // nullable
    boxLabelAlign: String; // nullable
    boxLabelAttrTpl: Variant; // nullable
    boxLabelCls: String; // nullable
    checkChangeEvents: array of String; // nullable
    checked: Boolean; // nullable
    checkedCls: String; // nullable
    componentLayout: Variant; // nullable
    fieldCls: String; // nullable
    focusCls: String; // nullable
    handler: Variant; // nullable
    inputType: String; // nullable
    inputValue: String; // nullable
    scope: Variant; // nullable
    uncheckedValue: String; // nullable
    boxLabelEl: JExt.IElement; // nullable
    originalValue: Variant; // nullable
    procedure beforeDestroy;
    function getRawValue: Boolean;
    function getSubTplData: Variant;
    function getSubmitValue: Variant;
    function getValue: Boolean;
    procedure initComponent;
    procedure initEvents;
    procedure initValue;
    procedure onEnable;
    procedure resetOriginalValue; overload;
    procedure resetOriginalValue(fromBoxInGroup: Variant); overload;
    procedure setBoxLabel; overload;
    procedure setBoxLabel(boxLabel: String); overload;
    function setRawValue: Boolean; overload;
    function setRawValue(value: Variant): Boolean; overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Variant); overload;
    function setValue: JExt.form.field.ICheckbox; overload;
    function setValue(checked: Variant): JExt.form.field.ICheckbox; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JICheckbox = class external(JExt.form.field.IBase)
    afterBoxLabelTextTpl: Variant; // nullable
    afterBoxLabelTpl: Variant; // nullable
    beforeBoxLabelTextTpl: Variant; // nullable
    beforeBoxLabelTpl: Variant; // nullable
    boxLabel: String; // nullable
    boxLabelAlign: String; // nullable
    boxLabelAttrTpl: Variant; // nullable
    boxLabelCls: String; // nullable
    checkChangeEvents: array of String; // nullable
    checked: Boolean; // nullable
    checkedCls: String; // nullable
    componentLayout: Variant; // nullable
    fieldCls: String; // nullable
    focusCls: String; // nullable
    handler: Variant; // nullable
    inputType: String; // nullable
    inputValue: String; // nullable
    scope: Variant; // nullable
    uncheckedValue: String; // nullable
    boxLabelEl: JExt.IElement; // nullable
    originalValue: Variant; // nullable
    procedure beforeDestroy;
    function getRawValue: Boolean;
    function getSubTplData: Variant;
    function getSubmitValue: Variant;
    function getValue: Boolean;
    procedure initComponent;
    procedure initEvents;
    procedure initValue;
    procedure onEnable;
    procedure resetOriginalValue; overload;
    procedure resetOriginalValue(fromBoxInGroup: Variant); overload;
    procedure setBoxLabel; overload;
    procedure setBoxLabel(boxLabel: String); overload;
    function setRawValue: Boolean; overload;
    function setRawValue(value: Variant): Boolean; overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Variant); overload;
    function setValue: JExt.form.field.ICheckbox; overload;
    function setValue(checked: Variant): JExt.form.field.ICheckbox; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JIComboBox = class external(JExt.form.field.IPicker, JExt.util.IBindable)
    allQuery: String; // nullable
    anyMatch: Boolean; // nullable
    autoSelect: Boolean; // nullable
    caseSensitive: Boolean; // nullable
    componentLayout: Variant; // nullable
    defaultListConfig: Variant; // nullable
    delimiter: String; // nullable
    displayField: String; // nullable
    enableRegEx: Boolean; // nullable
    fieldSubTpl: JExt.IXTemplate; // nullable
    forceSelection: Boolean; // nullable
    growToLongestValue: Boolean; // nullable
    hiddenName: String; // nullable
    listConfig: Variant; // nullable
    minChars: Float; // nullable
    multiSelect: Boolean; // nullable
    pageSize: Float; // nullable
    queryCaching: Boolean; // nullable
    queryDelay: Float; // nullable
    queryMode: String; // nullable
    queryParam: String; // nullable
    selectOnTab: Boolean; // nullable
    store: Variant; // nullable
    transform: Variant; // nullable
    triggerAction: String; // nullable
    triggerCls: String; // nullable
    typeAhead: Boolean; // nullable
    typeAheadDelay: Float; // nullable
    valueField: String; // nullable
    valueNotFoundText: String; // nullable
    lastQuery: String; // nullable
    procedure afterQuery; overload;
    procedure afterQuery(queryPlan: Variant); overload;
    procedure afterRender;
    procedure alignPicker;
    procedure beforeBlur;
    procedure beforeQuery; overload;
    procedure beforeQuery(queryPlan: Variant); overload;
    procedure beforeReset;
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure clearValue;
    procedure createPicker;
    function doQuery: Boolean; overload;
    function doQuery(queryString: String): Boolean; overload;
    function doQuery(queryString: String; forceAll: Boolean): Boolean; overload;
    function doQuery(queryString: String; forceAll: Boolean; rawQuery: Boolean): Boolean; overload;
    function findRecord: JExt.data.IModel; overload;
    function findRecord(field: String): JExt.data.IModel; overload;
    function findRecord(field: String; value: Variant): JExt.data.IModel; overload;
    function findRecordByDisplay: JExt.data.IModel; overload;
    function findRecordByDisplay(value: Variant): JExt.data.IModel; overload;
    function findRecordByValue: JExt.data.IModel; overload;
    function findRecordByValue(value: Variant): JExt.data.IModel; overload;
    function getStore: JExt.data.IStore;
    function getStoreListeners: Variant;
    function getSubTplData: Variant;
    function getSubmitValue: String;
    function getValue: Variant;
    procedure initComponent;
    procedure initEvents;
    procedure onAdded;
    procedure onBindStore; overload;
    procedure onBindStore(store: Variant); overload;
    procedure onBindStore(store: Variant; initial: Variant); overload;
    procedure onTriggerClick;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: Variant); overload;
    procedure select; overload;
    procedure select(r: Variant); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.form

type
  JIComboBox = class external(JExt.form.field.IPicker, JExt.util.IBindable)
    allQuery: String; // nullable
    anyMatch: Boolean; // nullable
    autoSelect: Boolean; // nullable
    caseSensitive: Boolean; // nullable
    componentLayout: Variant; // nullable
    defaultListConfig: Variant; // nullable
    delimiter: String; // nullable
    displayField: String; // nullable
    enableRegEx: Boolean; // nullable
    fieldSubTpl: JExt.IXTemplate; // nullable
    forceSelection: Boolean; // nullable
    growToLongestValue: Boolean; // nullable
    hiddenName: String; // nullable
    listConfig: Variant; // nullable
    minChars: Float; // nullable
    multiSelect: Boolean; // nullable
    pageSize: Float; // nullable
    queryCaching: Boolean; // nullable
    queryDelay: Float; // nullable
    queryMode: String; // nullable
    queryParam: String; // nullable
    selectOnTab: Boolean; // nullable
    store: Variant; // nullable
    transform: Variant; // nullable
    triggerAction: String; // nullable
    triggerCls: String; // nullable
    typeAhead: Boolean; // nullable
    typeAheadDelay: Float; // nullable
    valueField: String; // nullable
    valueNotFoundText: String; // nullable
    lastQuery: String; // nullable
    procedure afterQuery; overload;
    procedure afterQuery(queryPlan: Variant); overload;
    procedure afterRender;
    procedure alignPicker;
    procedure beforeBlur;
    procedure beforeQuery; overload;
    procedure beforeQuery(queryPlan: Variant); overload;
    procedure beforeReset;
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure clearValue;
    procedure createPicker;
    function doQuery: Boolean; overload;
    function doQuery(queryString: String): Boolean; overload;
    function doQuery(queryString: String; forceAll: Boolean): Boolean; overload;
    function doQuery(queryString: String; forceAll: Boolean; rawQuery: Boolean): Boolean; overload;
    function findRecord: JExt.data.IModel; overload;
    function findRecord(field: String): JExt.data.IModel; overload;
    function findRecord(field: String; value: Variant): JExt.data.IModel; overload;
    function findRecordByDisplay: JExt.data.IModel; overload;
    function findRecordByDisplay(value: Variant): JExt.data.IModel; overload;
    function findRecordByValue: JExt.data.IModel; overload;
    function findRecordByValue(value: Variant): JExt.data.IModel; overload;
    function getStore: JExt.data.IStore;
    function getStoreListeners: Variant;
    function getSubTplData: Variant;
    function getSubmitValue: String;
    function getValue: Variant;
    procedure initComponent;
    procedure initEvents;
    procedure onAdded;
    procedure onBindStore; overload;
    procedure onBindStore(store: Variant); overload;
    procedure onBindStore(store: Variant; initial: Variant); overload;
    procedure onTriggerClick;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: Variant); overload;
    procedure select; overload;
    procedure select(r: Variant); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.form.field

type
  JIDate = class external(JExt.form.field.IPicker)
    altFormats: String; // nullable
    disabledDates: array of String; // nullable
    disabledDatesText: String; // nullable
    disabledDays: array of Float; // nullable
    disabledDaysText: String; // nullable
    format: String; // nullable
    invalidText: String; // nullable
    matchFieldWidth: Boolean; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    showToday: Boolean; // nullable
    startDay: Float; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    useStrict: Boolean; // nullable
    procedure beforeBlur;
    procedure createPicker;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    procedure initComponent;
    procedure initValue;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    safeParse: Variant; // nullable
    procedure setDisabledDates; overload;
    procedure setDisabledDates(disabledDates: array of String); overload;
    procedure setDisabledDays; overload;
    procedure setDisabledDays(disabledDays: array of Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: JExt.form.field.IDate; overload;
    function setValue(date: Variant): JExt.form.field.IDate; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JIDateField = class external(JExt.form.field.IPicker)
    altFormats: String; // nullable
    disabledDates: array of String; // nullable
    disabledDatesText: String; // nullable
    disabledDays: array of Float; // nullable
    disabledDaysText: String; // nullable
    format: String; // nullable
    invalidText: String; // nullable
    matchFieldWidth: Boolean; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    showToday: Boolean; // nullable
    startDay: Float; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    useStrict: Boolean; // nullable
    procedure beforeBlur;
    procedure createPicker;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    procedure initComponent;
    procedure initValue;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    safeParse: Variant; // nullable
    procedure setDisabledDates; overload;
    procedure setDisabledDates(disabledDates: array of String); overload;
    procedure setDisabledDays; overload;
    procedure setDisabledDays(disabledDays: array of Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: JExt.form.field.IDate; overload;
    function setValue(date: Variant): JExt.form.field.IDate; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JIDate = class external(JExt.form.field.IPicker)
    altFormats: String; // nullable
    disabledDates: array of String; // nullable
    disabledDatesText: String; // nullable
    disabledDays: array of Float; // nullable
    disabledDaysText: String; // nullable
    format: String; // nullable
    invalidText: String; // nullable
    matchFieldWidth: Boolean; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    showToday: Boolean; // nullable
    startDay: Float; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    useStrict: Boolean; // nullable
    procedure beforeBlur;
    procedure createPicker;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    procedure initComponent;
    procedure initValue;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    safeParse: Variant; // nullable
    procedure setDisabledDates; overload;
    procedure setDisabledDates(disabledDates: array of String); overload;
    procedure setDisabledDays; overload;
    procedure setDisabledDays(disabledDays: array of Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: JExt.form.field.IDate; overload;
    function setValue(date: Variant): JExt.form.field.IDate; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JIDisplay = class external(JExt.form.field.IBase)
    fieldBodyCls: String; // nullable
    fieldCls: String; // nullable
    htmlEncode: Boolean; // nullable
    renderer: Variant; // nullable
    scope: Variant; // nullable
    submitValue: Boolean; // nullable
    function getRawValue: String;
    function getSubTplData: Variant;
    procedure initEvents;
    function isDirty: Boolean;
    function isValid: Boolean;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    function validate: Boolean;
  end;

//Ext.form

type
  JIDisplayField = class external(JExt.form.field.IBase)
    fieldBodyCls: String; // nullable
    fieldCls: String; // nullable
    htmlEncode: Boolean; // nullable
    renderer: Variant; // nullable
    scope: Variant; // nullable
    submitValue: Boolean; // nullable
    function getRawValue: String;
    function getSubTplData: Variant;
    procedure initEvents;
    function isDirty: Boolean;
    function isValid: Boolean;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    function validate: Boolean;
  end;

//Ext.form

type
  JIDisplay = class external(JExt.form.field.IBase)
    fieldBodyCls: String; // nullable
    fieldCls: String; // nullable
    htmlEncode: Boolean; // nullable
    renderer: Variant; // nullable
    scope: Variant; // nullable
    submitValue: Boolean; // nullable
    function getRawValue: String;
    function getSubTplData: Variant;
    procedure initEvents;
    function isDirty: Boolean;
    function isValid: Boolean;
    function setRawValue: Variant; overload;
    function setRawValue(value: Variant): Variant; overload;
    function validate: Boolean;
  end;

//Ext.form.field

type
  JIField = class external(JExt.IBase)
    disabled: Boolean; // nullable
    name: String; // nullable
    submitValue: Boolean; // nullable
    validateOnChange: Boolean; // nullable
    value: Variant; // nullable
    isFormField: Boolean; // nullable
    originalValue: Variant; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    procedure clearInvalid;
    function extractFileInput: Variant;
    function getErrors: Variant; overload;
    function getErrors(value: Variant): Variant; overload;
    function getModelData: Variant;
    function getName: String;
    function getSubmitData: Variant;
    function getValue: Variant;
    procedure initField;
    procedure initValue;
    function isDirty: Variant;
    function isEqual: Variant; overload;
    function isEqual(value1: Variant): Variant; overload;
    function isEqual(value1: Variant; value2: Variant): Variant; overload;
    function isFileUpload: Variant;
    function isValid: Variant;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure reset;
    procedure resetOriginalValue;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function validate: Variant;
  end;

//Ext.form.field

type
  JIFile = class external(JExt.form.field.ITrigger)
    buttonConfig: Variant; // nullable
    buttonMargin: Float; // nullable
    buttonOnly: Boolean; // nullable
    buttonText: String; // nullable
    clearOnSubmit: Boolean; // nullable
    componentLayout: Variant; // nullable
    readOnly: Boolean; // nullable
    button: JExt.button.IButton; // nullable
    fileInputEl: JExt.IElement; // nullable
    function extractFileInput: JHTMLElement;
    procedure getTriggerMarkup;
    function isFileUpload: Boolean;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure onShow;
    procedure reset;
    procedure setValue;
  end;

//Ext.form

type
  JIFileUploadField = class external(JExt.form.field.ITrigger)
    buttonConfig: Variant; // nullable
    buttonMargin: Float; // nullable
    buttonOnly: Boolean; // nullable
    buttonText: String; // nullable
    clearOnSubmit: Boolean; // nullable
    componentLayout: Variant; // nullable
    readOnly: Boolean; // nullable
    button: JExt.button.IButton; // nullable
    fileInputEl: JExt.IElement; // nullable
    function extractFileInput: JHTMLElement;
    procedure getTriggerMarkup;
    function isFileUpload: Boolean;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure onShow;
    procedure reset;
    procedure setValue;
  end;

//Ext.ux.form

type
  JIFileUploadField = class external(JExt.form.field.ITrigger)
    buttonConfig: Variant; // nullable
    buttonMargin: Float; // nullable
    buttonOnly: Boolean; // nullable
    buttonText: String; // nullable
    clearOnSubmit: Boolean; // nullable
    componentLayout: Variant; // nullable
    readOnly: Boolean; // nullable
    button: JExt.button.IButton; // nullable
    fileInputEl: JExt.IElement; // nullable
    function extractFileInput: JHTMLElement;
    procedure getTriggerMarkup;
    function isFileUpload: Boolean;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure onShow;
    procedure reset;
    procedure setValue;
  end;

//Ext.form

type
  JIFile = class external(JExt.form.field.ITrigger)
    buttonConfig: Variant; // nullable
    buttonMargin: Float; // nullable
    buttonOnly: Boolean; // nullable
    buttonText: String; // nullable
    clearOnSubmit: Boolean; // nullable
    componentLayout: Variant; // nullable
    readOnly: Boolean; // nullable
    button: JExt.button.IButton; // nullable
    fileInputEl: JExt.IElement; // nullable
    function extractFileInput: JHTMLElement;
    procedure getTriggerMarkup;
    function isFileUpload: Boolean;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure onShow;
    procedure reset;
    procedure setValue;
  end;

//Ext.form.field

type
  JIFileButton = class external(JExt.button.IButton)
    cls: String; // nullable
    preventDefault: Boolean; // nullable
    renderTpl: Variant; // nullable
    procedure afterRender;
    function getTemplateArgs: Variant;
    procedure onDisable;
    procedure onEnable;
  end;

//Ext.form.field

type
  JIHidden = class external(JExt.form.field.IBase)
    hidden: Boolean; // nullable
    hideLabel: Boolean; // nullable
    inputType: String; // nullable
    procedure clearInvalid;
    procedure initComponent;
    procedure initEvents;
    procedure markInvalid;
    function setHeight: JExt.IComponent;
    function setPagePosition: JExt.IComponent;
    function setPosition: JExt.IComponent;
    function setSize: JExt.IComponent;
    function setWidth: JExt.IComponent;
  end;

//Ext.form

type
  JIHidden = class external(JExt.form.field.IBase)
    hidden: Boolean; // nullable
    hideLabel: Boolean; // nullable
    inputType: String; // nullable
    procedure clearInvalid;
    procedure initComponent;
    procedure initEvents;
    procedure markInvalid;
    function setHeight: JExt.IComponent;
    function setPagePosition: JExt.IComponent;
    function setPosition: JExt.IComponent;
    function setSize: JExt.IComponent;
    function setWidth: JExt.IComponent;
  end;

//Ext.form.field

type
  JIHtmlEditor = class external(JExt.form.IFieldContainer, JExt.form.field.IField)
    afterIFrameTpl: Variant; // nullable
    afterTextAreaTpl: Variant; // nullable
    beforeIFrameTpl: Variant; // nullable
    beforeTextAreaTpl: Variant; // nullable
    componentLayout: Variant; // nullable
    createLinkText: String; // nullable
    defaultButtonUI: String; // nullable
    defaultLinkValue: String; // nullable
    defaultValue: String; // nullable
    enableAlignments: Boolean; // nullable
    enableColors: Boolean; // nullable
    enableFont: Boolean; // nullable
    enableFontSize: Boolean; // nullable
    enableFormat: Boolean; // nullable
    enableLinks: Boolean; // nullable
    enableLists: Boolean; // nullable
    enableSourceEdit: Boolean; // nullable
    fontFamilies: array of String; // nullable
    iframeAttrTpl: Variant; // nullable
    buttonTips: Variant; // nullable
    maskOnDisable: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    function cleanHtml: String; overload;
    function cleanHtml(html: String): String; overload;
    procedure clearInvalid;
    procedure execCmd; overload;
    procedure execCmd(cmd: String); overload;
    procedure execCmd(cmd: String; value: Variant); overload;
    function extractFileInput: JHTMLElement;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Variant): JExt.IComponent; overload;
    function focus(selectText: Variant; delay: Variant): JExt.IComponent; overload;
    procedure getDocMarkup;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getModelData: Variant;
    function getName: String;
    function getSubmitData: Variant;
    function getToolbar: JExt.toolbar.IToolbar;
    function getValue: Variant;
    procedure initField;
    procedure initValue;
    procedure insertAtCursor; overload;
    procedure insertAtCursor(text: String); overload;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure pushValue;
    procedure relayCmd; overload;
    procedure relayCmd(cmd: String); overload;
    procedure relayCmd(cmd: String; value: Variant); overload;
    procedure reset;
    procedure resetOriginalValue;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    procedure syncValue;
    procedure toggleSourceEdit; overload;
    procedure toggleSourceEdit(sourceEditMode: Boolean); overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    procedure updateToolbar;
  end;

//Ext.form

type
  JIHtmlEditor = class external(JExt.form.IFieldContainer, JExt.form.field.IField)
    afterIFrameTpl: Variant; // nullable
    afterTextAreaTpl: Variant; // nullable
    beforeIFrameTpl: Variant; // nullable
    beforeTextAreaTpl: Variant; // nullable
    componentLayout: Variant; // nullable
    createLinkText: String; // nullable
    defaultButtonUI: String; // nullable
    defaultLinkValue: String; // nullable
    defaultValue: String; // nullable
    enableAlignments: Boolean; // nullable
    enableColors: Boolean; // nullable
    enableFont: Boolean; // nullable
    enableFontSize: Boolean; // nullable
    enableFormat: Boolean; // nullable
    enableLinks: Boolean; // nullable
    enableLists: Boolean; // nullable
    enableSourceEdit: Boolean; // nullable
    fontFamilies: array of String; // nullable
    iframeAttrTpl: Variant; // nullable
    buttonTips: Variant; // nullable
    maskOnDisable: Boolean; // nullable
    procedure batchChanges; overload;
    procedure batchChanges(fn: Variant); overload;
    procedure beforeReset;
    procedure checkChange;
    procedure checkDirty;
    function cleanHtml: String; overload;
    function cleanHtml(html: String): String; overload;
    procedure clearInvalid;
    procedure execCmd; overload;
    procedure execCmd(cmd: String); overload;
    procedure execCmd(cmd: String; value: Variant); overload;
    function extractFileInput: JHTMLElement;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Variant): JExt.IComponent; overload;
    function focus(selectText: Variant; delay: Variant): JExt.IComponent; overload;
    procedure getDocMarkup;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getModelData: Variant;
    function getName: String;
    function getSubmitData: Variant;
    function getToolbar: JExt.toolbar.IToolbar;
    function getValue: Variant;
    procedure initField;
    procedure initValue;
    procedure insertAtCursor; overload;
    procedure insertAtCursor(text: String); overload;
    function isDirty: Boolean;
    function isEqual: Boolean; overload;
    function isEqual(value1: Variant): Boolean; overload;
    function isEqual(value1: Variant; value2: Variant): Boolean; overload;
    function isFileUpload: Boolean;
    function isValid: Boolean;
    procedure markInvalid; overload;
    procedure markInvalid(errors: Variant); overload;
    procedure pushValue;
    procedure relayCmd; overload;
    procedure relayCmd(cmd: String); overload;
    procedure relayCmd(cmd: String; value: Variant); overload;
    procedure reset;
    procedure resetOriginalValue;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
    procedure syncValue;
    procedure toggleSourceEdit; overload;
    procedure toggleSourceEdit(sourceEditMode: Boolean); overload;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    procedure updateToolbar;
  end;

//Ext.form.field

type
  JINumber = class external(JExt.form.field.ISpinner)
    allowDecimals: Boolean; // nullable
    allowExponential: Boolean; // nullable
    autoStripChars: Boolean; // nullable
    baseChars: String; // nullable
    decimalPrecision: Float; // nullable
    decimalSeparator: String; // nullable
    maxText: String; // nullable
    maxValue: Float; // nullable
    minText: String; // nullable
    minValue: Float; // nullable
    nanText: String; // nullable
    negativeText: String; // nullable
    step: Float; // nullable
    submitLocaleSeparator: Boolean; // nullable
    procedure beforeBlur;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getSubmitValue: String;
    procedure initComponent;
    procedure onSpinDown;
    procedure onSpinUp;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Float); overload;
    procedure setSpinDownEnabled; overload;
    procedure setSpinDownEnabled(enabled: Variant); overload;
    procedure setSpinDownEnabled(enabled: Variant; internal: Variant); overload;
    procedure setSpinUpEnabled; overload;
    procedure setSpinUpEnabled(enabled: Variant); overload;
    procedure setSpinUpEnabled(enabled: Variant; internal: Variant); overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JINumberField = class external(JExt.form.field.ISpinner)
    allowDecimals: Boolean; // nullable
    allowExponential: Boolean; // nullable
    autoStripChars: Boolean; // nullable
    baseChars: String; // nullable
    decimalPrecision: Float; // nullable
    decimalSeparator: String; // nullable
    maxText: String; // nullable
    maxValue: Float; // nullable
    minText: String; // nullable
    minValue: Float; // nullable
    nanText: String; // nullable
    negativeText: String; // nullable
    step: Float; // nullable
    submitLocaleSeparator: Boolean; // nullable
    procedure beforeBlur;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getSubmitValue: String;
    procedure initComponent;
    procedure onSpinDown;
    procedure onSpinUp;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Float); overload;
    procedure setSpinDownEnabled; overload;
    procedure setSpinDownEnabled(enabled: Variant); overload;
    procedure setSpinDownEnabled(enabled: Variant; internal: Variant); overload;
    procedure setSpinUpEnabled; overload;
    procedure setSpinUpEnabled(enabled: Variant); overload;
    procedure setSpinUpEnabled(enabled: Variant; internal: Variant); overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JINumber = class external(JExt.form.field.ISpinner)
    allowDecimals: Boolean; // nullable
    allowExponential: Boolean; // nullable
    autoStripChars: Boolean; // nullable
    baseChars: String; // nullable
    decimalPrecision: Float; // nullable
    decimalSeparator: String; // nullable
    maxText: String; // nullable
    maxValue: Float; // nullable
    minText: String; // nullable
    minValue: Float; // nullable
    nanText: String; // nullable
    negativeText: String; // nullable
    step: Float; // nullable
    submitLocaleSeparator: Boolean; // nullable
    procedure beforeBlur;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getSubmitValue: String;
    procedure initComponent;
    procedure onSpinDown;
    procedure onSpinUp;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Float); overload;
    procedure setSpinDownEnabled; overload;
    procedure setSpinDownEnabled(enabled: Variant); overload;
    procedure setSpinDownEnabled(enabled: Variant; internal: Variant); overload;
    procedure setSpinUpEnabled; overload;
    procedure setSpinUpEnabled(enabled: Variant); overload;
    procedure setSpinUpEnabled(enabled: Variant; internal: Variant); overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JIPicker = class external(JExt.form.field.ITrigger)
    editable: Boolean; // nullable
    matchFieldWidth: Boolean; // nullable
    openCls: String; // nullable
    pickerAlign: String; // nullable
    pickerOffset: array of Float; // nullable
    isExpanded: Boolean; // nullable
    procedure alignPicker;
    procedure collapse;
    procedure createPicker;
    procedure expand;
    function getPicker: JExt.IComponent;
    procedure initComponent;
    procedure initEvents;
    procedure onTriggerClick;
  end;

//Ext.form

type
  JIPicker = class external(JExt.form.field.ITrigger)
    editable: Boolean; // nullable
    matchFieldWidth: Boolean; // nullable
    openCls: String; // nullable
    pickerAlign: String; // nullable
    pickerOffset: array of Float; // nullable
    isExpanded: Boolean; // nullable
    procedure alignPicker;
    procedure collapse;
    procedure createPicker;
    procedure expand;
    function getPicker: JExt.IComponent;
    procedure initComponent;
    procedure initEvents;
    procedure onTriggerClick;
  end;

//Ext.form.field

type
  JIRadio = class external(JExt.form.field.ICheckbox)
    focusCls: String; // nullable
    inputType: String; // nullable
    isRadio: Boolean; // nullable
    function getGroupValue: String;
    function getModelData: Variant;
    function getSubmitValue: Variant;
    procedure onRemoved;
    function setValue: JExt.form.field.IRadio; overload;
    function setValue(value: Variant): JExt.form.field.IRadio; overload;
  end;

//Ext.form

type
  JIRadio = class external(JExt.form.field.ICheckbox)
    focusCls: String; // nullable
    inputType: String; // nullable
    isRadio: Boolean; // nullable
    function getGroupValue: String;
    function getModelData: Variant;
    function getSubmitValue: Variant;
    procedure onRemoved;
    function setValue: JExt.form.field.IRadio; overload;
    function setValue(value: Variant): JExt.form.field.IRadio; overload;
  end;

//Ext.form.field

type
  JISpinner = class external(JExt.form.field.ITrigger)
    keyNavEnabled: Boolean; // nullable
    mouseWheelEnabled: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    spinDownEnabled: Boolean; // nullable
    spinUpEnabled: Boolean; // nullable
    spinDownEl: JExt.IElement; // nullable
    spinUpEl: JExt.IElement; // nullable
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onSpinDown;
    procedure onSpinUp;
    procedure setSpinDownEnabled; overload;
    procedure setSpinDownEnabled(enabled: Boolean); overload;
    procedure setSpinUpEnabled; overload;
    procedure setSpinUpEnabled(enabled: Boolean); overload;
    procedure spinDown;
    procedure spinUp;
  end;

//Ext.form

type
  JISpinner = class external(JExt.form.field.ITrigger)
    keyNavEnabled: Boolean; // nullable
    mouseWheelEnabled: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    spinDownEnabled: Boolean; // nullable
    spinUpEnabled: Boolean; // nullable
    spinDownEl: JExt.IElement; // nullable
    spinUpEl: JExt.IElement; // nullable
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onSpinDown;
    procedure onSpinUp;
    procedure setSpinDownEnabled; overload;
    procedure setSpinDownEnabled(enabled: Boolean); overload;
    procedure setSpinUpEnabled; overload;
    procedure setSpinUpEnabled(enabled: Boolean); overload;
    procedure spinDown;
    procedure spinUp;
  end;

//Ext.form.field

type
  JIText = class external(JExt.form.field.IBase)
    allowBlank: Boolean; // nullable
    allowOnlyWhitespace: Boolean; // nullable
    blankText: String; // nullable
    disableKeyFilter: Boolean; // nullable
    emptyCls: String; // nullable
    emptyText: String; // nullable
    enableKeyEvents: Boolean; // nullable
    enforceMaxLength: Boolean; // nullable
    grow: Boolean; // nullable
    growAppend: String; // nullable
    growMax: Float; // nullable
    growMin: Float; // nullable
    maskRe: JRegExp; // nullable
    maxLength: Float; // nullable
    maxLengthText: String; // nullable
    minLength: Float; // nullable
    minLengthText: String; // nullable
    regex: JRegExp; // nullable
    regexText: String; // nullable
    requiredCls: String; // nullable
    selectOnFocus: Boolean; // nullable
    size: Float; // nullable
    stripCharsRe: JRegExp; // nullable
    validateBlank: Boolean; // nullable
    validator: Variant; // nullable
    vtype: String; // nullable
    vtypeText: String; // nullable
    procedure afterComponentLayout;
    procedure afterRender;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure autoSize;
    procedure beforeFocus;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getRawValue: String;
    function getState: Variant;
    function getSubTplData: Variant;
    procedure initComponent;
    procedure initEvents;
    procedure onDestroy;
    procedure onDisable;
    procedure onEnable;
    procedure postBlur;
    function processRawValue: String; overload;
    function processRawValue(value: String): String; overload;
    procedure reset;
    procedure selectText; overload;
    procedure selectText(start: Float); overload;
    procedure selectText(start: Float; &end: Float); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JITextField = class external(JExt.form.field.IBase)
    allowBlank: Boolean; // nullable
    allowOnlyWhitespace: Boolean; // nullable
    blankText: String; // nullable
    disableKeyFilter: Boolean; // nullable
    emptyCls: String; // nullable
    emptyText: String; // nullable
    enableKeyEvents: Boolean; // nullable
    enforceMaxLength: Boolean; // nullable
    grow: Boolean; // nullable
    growAppend: String; // nullable
    growMax: Float; // nullable
    growMin: Float; // nullable
    maskRe: JRegExp; // nullable
    maxLength: Float; // nullable
    maxLengthText: String; // nullable
    minLength: Float; // nullable
    minLengthText: String; // nullable
    regex: JRegExp; // nullable
    regexText: String; // nullable
    requiredCls: String; // nullable
    selectOnFocus: Boolean; // nullable
    size: Float; // nullable
    stripCharsRe: JRegExp; // nullable
    validateBlank: Boolean; // nullable
    validator: Variant; // nullable
    vtype: String; // nullable
    vtypeText: String; // nullable
    procedure afterComponentLayout;
    procedure afterRender;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure autoSize;
    procedure beforeFocus;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getRawValue: String;
    function getState: Variant;
    function getSubTplData: Variant;
    procedure initComponent;
    procedure initEvents;
    procedure onDestroy;
    procedure onDisable;
    procedure onEnable;
    procedure postBlur;
    function processRawValue: String; overload;
    function processRawValue(value: String): String; overload;
    procedure reset;
    procedure selectText; overload;
    procedure selectText(start: Float); overload;
    procedure selectText(start: Float; &end: Float); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JIText = class external(JExt.form.field.IBase)
    allowBlank: Boolean; // nullable
    allowOnlyWhitespace: Boolean; // nullable
    blankText: String; // nullable
    disableKeyFilter: Boolean; // nullable
    emptyCls: String; // nullable
    emptyText: String; // nullable
    enableKeyEvents: Boolean; // nullable
    enforceMaxLength: Boolean; // nullable
    grow: Boolean; // nullable
    growAppend: String; // nullable
    growMax: Float; // nullable
    growMin: Float; // nullable
    maskRe: JRegExp; // nullable
    maxLength: Float; // nullable
    maxLengthText: String; // nullable
    minLength: Float; // nullable
    minLengthText: String; // nullable
    regex: JRegExp; // nullable
    regexText: String; // nullable
    requiredCls: String; // nullable
    selectOnFocus: Boolean; // nullable
    size: Float; // nullable
    stripCharsRe: JRegExp; // nullable
    validateBlank: Boolean; // nullable
    validator: Variant; // nullable
    vtype: String; // nullable
    vtypeText: String; // nullable
    procedure afterComponentLayout;
    procedure afterRender;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure autoSize;
    procedure beforeFocus;
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getRawValue: String;
    function getState: Variant;
    function getSubTplData: Variant;
    procedure initComponent;
    procedure initEvents;
    procedure onDestroy;
    procedure onDisable;
    procedure onEnable;
    procedure postBlur;
    function processRawValue: String; overload;
    function processRawValue(value: String): String; overload;
    procedure reset;
    procedure selectText; overload;
    procedure selectText(start: Float); overload;
    procedure selectText(start: Float; &end: Float); overload;
    function setValue: Variant; overload;
    function setValue(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JITextArea = class external(JExt.form.field.IText)
    cols: Float; // nullable
    componentLayout: Variant; // nullable
    enterIsSpecial: Boolean; // nullable
    growAppend: String; // nullable
    growMax: Float; // nullable
    growMin: Float; // nullable
    preventScrollbars: Boolean; // nullable
    rows: Float; // nullable
    procedure afterRender;
    procedure autoSize;
    procedure beforeDestroy;
    function getSubTplData: Variant;
    function getValue: Variant;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function transformRawValue: Variant; overload;
    function transformRawValue(value: Variant): Variant; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JITextArea = class external(JExt.form.field.IText)
    cols: Float; // nullable
    componentLayout: Variant; // nullable
    enterIsSpecial: Boolean; // nullable
    growAppend: String; // nullable
    growMax: Float; // nullable
    growMin: Float; // nullable
    preventScrollbars: Boolean; // nullable
    rows: Float; // nullable
    procedure afterRender;
    procedure autoSize;
    procedure beforeDestroy;
    function getSubTplData: Variant;
    function getValue: Variant;
    function transformOriginalValue: Variant; overload;
    function transformOriginalValue(value: Variant): Variant; overload;
    function transformRawValue: Variant; overload;
    function transformRawValue(value: Variant): Variant; overload;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JITime = class external(JExt.form.field.IComboBox)
    altFormats: String; // nullable
    displayField: String; // nullable
    format: String; // nullable
    increment: Float; // nullable
    invalidText: String; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    pickerMaxHeight: Float; // nullable
    queryMode: String; // nullable
    selectOnTab: Boolean; // nullable
    snapToIncrement: Boolean; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    valueField: String; // nullable
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getValue: Variant;
    procedure initComponent;
    procedure postBlur;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: Variant;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JITimeField = class external(JExt.form.field.IComboBox)
    altFormats: String; // nullable
    displayField: String; // nullable
    format: String; // nullable
    increment: Float; // nullable
    invalidText: String; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    pickerMaxHeight: Float; // nullable
    queryMode: String; // nullable
    selectOnTab: Boolean; // nullable
    snapToIncrement: Boolean; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    valueField: String; // nullable
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getValue: Variant;
    procedure initComponent;
    procedure postBlur;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: Variant;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form

type
  JITime = class external(JExt.form.field.IComboBox)
    altFormats: String; // nullable
    displayField: String; // nullable
    format: String; // nullable
    increment: Float; // nullable
    invalidText: String; // nullable
    maxText: String; // nullable
    maxValue: Variant; // nullable
    minText: String; // nullable
    minValue: Variant; // nullable
    pickerMaxHeight: Float; // nullable
    queryMode: String; // nullable
    selectOnTab: Boolean; // nullable
    snapToIncrement: Boolean; // nullable
    submitFormat: String; // nullable
    triggerCls: String; // nullable
    valueField: String; // nullable
    function getErrors: array of String; overload;
    function getErrors(value: Variant): array of String; overload;
    function getValue: Variant;
    procedure initComponent;
    procedure postBlur;
    function rawToValue: Variant; overload;
    function rawToValue(rawValue: Variant): Variant; overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    function setValue: Variant;
    function valueToRaw: Variant; overload;
    function valueToRaw(value: Variant): Variant; overload;
  end;

//Ext.form.field

type
  JITrigger = class external(JExt.form.field.IText)
    componentLayout: Variant; // nullable
    editable: Boolean; // nullable
    hideTrigger: Boolean; // nullable
    readOnly: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    selectOnFocus: Boolean; // nullable
    triggerBaseCls: String; // nullable
    triggerCls: String; // nullable
    triggerNoEditCls: String; // nullable
    triggerWrapCls: String; // nullable
    inputCell: JExt.IElement; // nullable
    triggerEl: JExt.ICompositeElement; // nullable
    triggerWrap: JExt.IElement; // nullable
    function getLabelableRenderData: Variant;
    function getSubTplData: Variant;
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onRender;
    procedure onTriggerClick; overload;
    procedure onTriggerClick(e: JExt.IEventObject); overload;
    procedure setEditable; overload;
    procedure setEditable(editable: Boolean); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
  end;

//Ext.form

type
  JITriggerField = class external(JExt.form.field.IText)
    componentLayout: Variant; // nullable
    editable: Boolean; // nullable
    hideTrigger: Boolean; // nullable
    readOnly: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    selectOnFocus: Boolean; // nullable
    triggerBaseCls: String; // nullable
    triggerCls: String; // nullable
    triggerNoEditCls: String; // nullable
    triggerWrapCls: String; // nullable
    inputCell: JExt.IElement; // nullable
    triggerEl: JExt.ICompositeElement; // nullable
    triggerWrap: JExt.IElement; // nullable
    function getLabelableRenderData: Variant;
    function getSubTplData: Variant;
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onRender;
    procedure onTriggerClick; overload;
    procedure onTriggerClick(e: JExt.IEventObject); overload;
    procedure setEditable; overload;
    procedure setEditable(editable: Boolean); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
  end;

//Ext.form

type
  JITwinTriggerField = class external(JExt.form.field.IText)
    componentLayout: Variant; // nullable
    editable: Boolean; // nullable
    hideTrigger: Boolean; // nullable
    readOnly: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    selectOnFocus: Boolean; // nullable
    triggerBaseCls: String; // nullable
    triggerCls: String; // nullable
    triggerNoEditCls: String; // nullable
    triggerWrapCls: String; // nullable
    inputCell: JExt.IElement; // nullable
    triggerEl: JExt.ICompositeElement; // nullable
    triggerWrap: JExt.IElement; // nullable
    function getLabelableRenderData: Variant;
    function getSubTplData: Variant;
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onRender;
    procedure onTriggerClick; overload;
    procedure onTriggerClick(e: JExt.IEventObject); overload;
    procedure setEditable; overload;
    procedure setEditable(editable: Boolean); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
  end;

//Ext.form

type
  JITrigger = class external(JExt.form.field.IText)
    componentLayout: Variant; // nullable
    editable: Boolean; // nullable
    hideTrigger: Boolean; // nullable
    readOnly: Boolean; // nullable
    repeatTriggerClick: Boolean; // nullable
    selectOnFocus: Boolean; // nullable
    triggerBaseCls: String; // nullable
    triggerCls: String; // nullable
    triggerNoEditCls: String; // nullable
    triggerWrapCls: String; // nullable
    inputCell: JExt.IElement; // nullable
    triggerEl: JExt.ICompositeElement; // nullable
    triggerWrap: JExt.IElement; // nullable
    function getLabelableRenderData: Variant;
    function getSubTplData: Variant;
    function getTriggerWidth: Float;
    procedure initComponent;
    procedure onRender;
    procedure onTriggerClick; overload;
    procedure onTriggerClick(e: JExt.IEventObject); overload;
    procedure setEditable; overload;
    procedure setEditable(editable: Boolean); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
  end;

//Ext.form.field

type
  JVTypes = class external 'VTypes'
    alphaMask: JRegExp;
    alphaText: String;
    alphanumMask: JRegExp;
    alphanumText: String;
    emailMask: JRegExp;
    emailText: String;
    self: JExt.IClass;
    urlText: String;
    function alpha: Boolean; overload;
    function alpha(value: String): Boolean; overload;
    function alphanum: Boolean; overload;
    function alphanum(value: String): Boolean; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function email: Boolean; overload;
    function email(value: String): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
    function url: Boolean; overload;
    function url(value: String): Boolean; overload;
  end;

  JIVTypes = class external(JExt.IBase)
  end;

//Ext.form

type
  JVTypes = class external 'VTypes'
    alphaMask: JRegExp;
    alphaText: String;
    alphanumMask: JRegExp;
    alphanumText: String;
    emailMask: JRegExp;
    emailText: String;
    self: JExt.IClass;
    urlText: String;
    function alpha: Boolean; overload;
    function alpha(value: String): Boolean; overload;
    function alphanum: Boolean; overload;
    function alphanum(value: String): Boolean; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function email: Boolean; overload;
    function email(value: String): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
    function url: Boolean; overload;
    function url(value: String): Boolean; overload;
  end;

  JIVTypes = class external(JExt.IBase)
  end;

//Ext.form

type
  JIFieldAncestor = class external(JExt.IBase)
    fieldDefaults: Variant; // nullable
    procedure initFieldAncestor;
    procedure onFieldErrorChange; overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable); overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable; error: String); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
  end;

//Ext.form

type
  JIFieldContainer = class external(JExt.container.IContainer, JExt.form.ILabelable, JExt.form.IFieldAncestor)
    combineErrors: Boolean; // nullable
    combineLabels: Boolean; // nullable
    componentCls: String; // nullable
    componentLayout: Variant; // nullable
    invalidCls: String; // nullable
    labelConnector: String; // nullable
    maskOnDisable: Boolean; // nullable
    function getActiveError: String;
    function getActiveErrors: array of String;
    function getCombinedErrors: array of String; overload;
    function getCombinedErrors(invalidFields: array of JExt.form.field.IField): array of String; overload;
    function getFieldLabel: String;
    function getInputId: String;
    function getLabelWidth: Float;
    function getLabelableRenderData: Variant;
    function getSubTplMarkup: String;
    function hasActiveError: Boolean;
    function hasVisibleLabel: Boolean;
    procedure initFieldAncestor;
    procedure initLabelable;
    function initRenderData: Variant;
    procedure onAdd; overload;
    procedure onAdd(labelable: JExt.form.ILabelable); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
    procedure onRemove; overload;
    procedure onRemove(labelable: JExt.form.ILabelable); overload;
    procedure setActiveError; overload;
    procedure setActiveError(msg: String); overload;
    procedure setActiveErrors; overload;
    procedure setActiveErrors(errors: array of String); overload;
    procedure setFieldDefaults; overload;
    procedure setFieldDefaults(defaults: Variant); overload;
    procedure setFieldLabel; overload;
    procedure setFieldLabel(&label: String); overload;
    function trimLabelSeparator: String;
    procedure unsetActiveError;
  end;

//Ext.form

type
  JIFieldSet = class external(JExt.container.IContainer, JExt.form.IFieldAncestor)
    autoEl: Variant; // nullable
    baseCls: String; // nullable
    checkboxName: String; // nullable
    checkboxToggle: Boolean; // nullable
    collapsed: Boolean; // nullable
    collapsible: Boolean; // nullable
    componentLayout: Variant; // nullable
    layout: Variant; // nullable
    renderTpl: Variant; // nullable
    stateEvents: array of String; // nullable
    title: String; // nullable
    toggleOnTitleClick: Boolean; // nullable
    checkboxCmp: JExt.form.field.ICheckbox; // nullable
    legend: JExt.IComponent; // nullable
    maskOnDisable: Boolean; // nullable
    toggleCmp: JExt.panel.ITool; // nullable
    function collapse: JExt.form.IFieldSet;
    function createCheckboxCmp: JExt.IComponent;
    function createTitleCmp: JExt.IComponent;
    function createToggleCmp: JExt.IComponent;
    function expand: JExt.form.IFieldSet;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function getState: Variant;
    procedure initFieldAncestor;
    procedure onFieldErrorChange; overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable); overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable; error: String); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
    function setTitle: JExt.form.IFieldSet; overload;
    function setTitle(title: String): JExt.form.IFieldSet; overload;
    procedure toggle;
  end;

//Ext.form

type
  JILabel = class external(JExt.IComponent)
    autoEl: Variant; // nullable
    forId: String; // nullable
    html: String; // nullable
    text: String; // nullable
    function setText: JExt.form.ILabel; overload;
    function setText(text: String): JExt.form.ILabel; overload;
    function setText(text: String; encode: Boolean): JExt.form.ILabel; overload;
  end;

//Ext.form

type
  JILabelable = class external(JExt.IBase)
    activeError: String; // nullable
    activeErrorsTpl: Variant; // nullable
    afterBodyEl: Variant; // nullable
    afterLabelTextTpl: Variant; // nullable
    afterLabelTpl: Variant; // nullable
    afterSubTpl: Variant; // nullable
    autoFitErrors: Boolean; // nullable
    baseBodyCls: String; // nullable
    beforeBodyEl: Variant; // nullable
    beforeLabelTextTpl: Variant; // nullable
    beforeLabelTpl: Variant; // nullable
    beforeSubTpl: Variant; // nullable
    clearCls: String; // nullable
    errorMsgCls: String; // nullable
    fieldBodyCls: String; // nullable
    fieldLabel: String; // nullable
    formItemCls: String; // nullable
    hideEmptyLabel: Boolean; // nullable
    hideLabel: Boolean; // nullable
    invalidCls: String; // nullable
    labelAlign: String; // nullable
    labelAttrTpl: Variant; // nullable
    labelCls: String; // nullable
    labelClsExtra: String; // nullable
    labelPad: Float; // nullable
    labelSeparator: String; // nullable
    labelStyle: String; // nullable
    labelWidth: Float; // nullable
    msgTarget: String; // nullable
    preventMark: Boolean; // nullable
    bodyEl: JExt.IElement; // nullable
    errorEl: JExt.IElement; // nullable
    isFieldLabelable: Boolean; // nullable
    labelCell: JExt.IElement; // nullable
    labelEl: JExt.IElement; // nullable
    function getActiveError: String;
    function getActiveErrors: array of String;
    function getFieldLabel: String;
    function getInputId: String;
    function getLabelWidth: Float;
    function getLabelableRenderData: Variant;
    function getSubTplMarkup: String;
    function hasActiveError: Boolean;
    function hasVisibleLabel: Boolean;
    procedure initLabelable;
    procedure setActiveError; overload;
    procedure setActiveError(msg: String); overload;
    procedure setActiveErrors; overload;
    procedure setActiveErrors(errors: array of String); overload;
    procedure setFieldDefaults; overload;
    procedure setFieldDefaults(defaults: Variant); overload;
    procedure setFieldLabel; overload;
    procedure setFieldLabel(&label: String); overload;
    function trimLabelSeparator: String;
    procedure unsetActiveError;
  end;

//Ext.form

type
  JIPanel = class external(JExt.panel.IPanel, JExt.form.IFieldAncestor)
    layout: Variant; // nullable
    pollForChanges: Boolean; // nullable
    pollInterval: Float; // nullable
    procedure checkChange;
    function getForm: JExt.form.IBasic;
    function getRecord: JExt.data.IModel;
    function getValues: Variant; overload;
    function getValues(asString: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean; useDataValues: Boolean): Variant; overload;
    procedure hasInvalidField;
    procedure initFieldAncestor;
    function isDirty: Boolean;
    function isValid: Boolean;
    procedure load; overload;
    procedure load(options: Variant); overload;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
    procedure onFieldErrorChange; overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable); overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable; error: String); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
    procedure startPolling; overload;
    procedure startPolling(interval: Float); overload;
    procedure stopPolling;
    procedure submit; overload;
    procedure submit(options: Variant); overload;
    function updateRecord: JExt.form.IBasic; overload;
    function updateRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
  end;

//Ext

type
  JIFormPanel = class external(JExt.panel.IPanel, JExt.form.IFieldAncestor)
    layout: Variant; // nullable
    pollForChanges: Boolean; // nullable
    pollInterval: Float; // nullable
    procedure checkChange;
    function getForm: JExt.form.IBasic;
    function getRecord: JExt.data.IModel;
    function getValues: Variant; overload;
    function getValues(asString: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean; useDataValues: Boolean): Variant; overload;
    procedure hasInvalidField;
    procedure initFieldAncestor;
    function isDirty: Boolean;
    function isValid: Boolean;
    procedure load; overload;
    procedure load(options: Variant); overload;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
    procedure onFieldErrorChange; overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable); overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable; error: String); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
    procedure startPolling; overload;
    procedure startPolling(interval: Float); overload;
    procedure stopPolling;
    procedure submit; overload;
    procedure submit(options: Variant); overload;
    function updateRecord: JExt.form.IBasic; overload;
    function updateRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
  end;

//Ext.form

type
  JIFormPanel = class external(JExt.panel.IPanel, JExt.form.IFieldAncestor)
    layout: Variant; // nullable
    pollForChanges: Boolean; // nullable
    pollInterval: Float; // nullable
    procedure checkChange;
    function getForm: JExt.form.IBasic;
    function getRecord: JExt.data.IModel;
    function getValues: Variant; overload;
    function getValues(asString: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean): Variant; overload;
    function getValues(asString: Boolean; dirtyOnly: Boolean; includeEmptyText: Boolean; useDataValues: Boolean): Variant; overload;
    procedure hasInvalidField;
    procedure initFieldAncestor;
    function isDirty: Boolean;
    function isValid: Boolean;
    procedure load; overload;
    procedure load(options: Variant); overload;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
    procedure onFieldErrorChange; overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable); overload;
    procedure onFieldErrorChange(field: JExt.form.ILabelable; error: String); overload;
    procedure onFieldValidityChange; overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField); overload;
    procedure onFieldValidityChange(field: JExt.form.field.IField; valid: Boolean); overload;
    procedure startPolling; overload;
    procedure startPolling(interval: Float); overload;
    procedure stopPolling;
    procedure submit; overload;
    procedure submit(options: Variant); overload;
    function updateRecord: JExt.form.IBasic; overload;
    function updateRecord(record: JExt.data.IModel): JExt.form.IBasic; overload;
  end;

//Ext.form

type
  JIRadioGroup = class external(JExt.form.ICheckboxGroup)
    allowBlank: Boolean; // nullable
    blankText: String; // nullable
    defaultType: String; // nullable
    items: Variant; // nullable
    procedure checkChange;
    function setValue: JExt.form.ICheckboxGroup; overload;
    function setValue(value: Variant): JExt.form.ICheckboxGroup; overload;
  end;

//Ext.form

type
  JRadioManager = class external 'RadioManager'
    hasListeners: Variant;
    isMixedCollection: Boolean;
    isObservable: Boolean;
    isSortable: Boolean;
    self: JExt.IClass;
    sorters: JExt.util.IMixedCollection;
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    procedure generateComparator;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getFirstSorter: JExt.util.ISorter;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initSortable;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
    function statics: JExt.IClass;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

  JIRadioManager = class external(JExt.util.IMixedCollection)
  end;

//Ext

type
  JFunction = class external 'Function'
    function alias: Variant; overload;
    function alias(&object: Variant): Variant; overload;
    function alias(&object: Variant; methodName: String): Variant; overload;
    function bind: Variant; overload;
    function bind(fn: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function clone: Variant; overload;
    function clone(method: Variant): Variant; overload;
    function createBuffered: Variant; overload;
    function createBuffered(fn: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed: Variant; overload;
    function createDelayed(fn: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createInterceptor: Variant; overload;
    function createInterceptor(origFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant; returnValue: Variant): Variant; overload;
    function createSequence: Variant; overload;
    function createSequence(originalFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createThrottled: Variant; overload;
    function createThrottled(fn: Variant): Variant; overload;
    function createThrottled(fn: Variant; interval: Float): Variant; overload;
    function createThrottled(fn: Variant; interval: Float; scope: Variant): Variant; overload;
    function defer: Float; overload;
    function defer(fn: Variant): Float; overload;
    function defer(fn: Variant; millis: Float): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
    function flexSetter: Variant; overload;
    function flexSetter(setter: Variant): Variant; overload;
    function interceptAfter: Variant; overload;
    function interceptAfter(&object: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function interceptBefore: Variant; overload;
    function interceptBefore(&object: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function pass: Variant; overload;
    function pass(fn: Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
  end;

  JIFunction = class external
  end;

//Ext.util

type
  JFunctions = class external 'Functions'
    function alias: Variant; overload;
    function alias(&object: Variant): Variant; overload;
    function alias(&object: Variant; methodName: String): Variant; overload;
    function bind: Variant; overload;
    function bind(fn: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function clone: Variant; overload;
    function clone(method: Variant): Variant; overload;
    function createBuffered: Variant; overload;
    function createBuffered(fn: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed: Variant; overload;
    function createDelayed(fn: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createInterceptor: Variant; overload;
    function createInterceptor(origFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant; returnValue: Variant): Variant; overload;
    function createSequence: Variant; overload;
    function createSequence(originalFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createThrottled: Variant; overload;
    function createThrottled(fn: Variant): Variant; overload;
    function createThrottled(fn: Variant; interval: Float): Variant; overload;
    function createThrottled(fn: Variant; interval: Float; scope: Variant): Variant; overload;
    function defer: Float; overload;
    function defer(fn: Variant): Float; overload;
    function defer(fn: Variant; millis: Float): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
    function flexSetter: Variant; overload;
    function flexSetter(setter: Variant): Variant; overload;
    function interceptAfter: Variant; overload;
    function interceptAfter(&object: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function interceptBefore: Variant; overload;
    function interceptBefore(&object: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function pass: Variant; overload;
    function pass(fn: Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
  end;

  JIFunctions = class external
  end;

//Ext.fx

type
  JIAnim = class external(JExt.IBase, JExt.util.IObservable)
    alternate: Boolean; // nullable
    callback: Variant; // nullable
    delay: Float; // nullable
    duration: Float; // nullable
    dynamic: Boolean; // nullable
    easing: String; // nullable
    from: Variant; // nullable
    iterations: Float; // nullable
    keyframes: Variant; // nullable
    reverse: Boolean; // nullable
    scope: Variant; // nullable
    target: Variant; // nullable
    to: Variant; // nullable
    currentIteration: Float; // nullable
    isAnimation: Boolean; // nullable
    paused: Boolean; // nullable
    running: Boolean; // nullable
    startTime: Variant; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure end;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.fx

type
  JIAnimator = class external(JExt.IBase, JExt.util.IObservable)
    delay: Float; // nullable
    duration: Float; // nullable
    dynamic: Boolean; // nullable
    easing: String; // nullable
    iterations: Float; // nullable
    keyframes: Variant; // nullable
    target: JExt.fx.target.ITarget; // nullable
    currentIteration: Float; // nullable
    isAnimator: Boolean; // nullable
    keyframeStep: Float; // nullable
    paused: Boolean; // nullable
    running: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure end;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.fx

type
  JCubicBezier = class external 'CubicBezier'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JICubicBezier = class external(JExt.IBase)
  end;

//Ext.fx

type
  JEasing = class external 'Easing'
  end;

  JIEasing = class external
  end;

//Ext.fx

type
  JManager = class external 'Manager'
    forceJS: Boolean;
    interval: Float;
    self: JExt.IClass;
    procedure addAnim; overload;
    procedure addAnim(anim: JExt.fx.IAnim); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure removeAnim; overload;
    procedure removeAnim(anim: JExt.fx.IAnim); overload;
    function statics: JExt.IClass;
  end;

  JIManager = class external(JExt.IBase, JExt.fx.IQueue)
  end;

//Ext.fx

type
  JIPropertyHandler = class external(JExt.IBase)
  end;

//Ext.fx

type
  JIQueue = class external(JExt.IBase)
  end;

//Ext.fx.target

type
  JIComponent = class external(JExt.fx.target.ITarget)
  end;

//Ext.fx.target

type
  JICompositeElement = class external(JExt.fx.target.IElement)
    isComposite: Boolean; // nullable
  end;

//Ext.fx.target

type
  JICompositeElementCSS = class external(JExt.fx.target.ICompositeElement)
  end;

//Ext.fx.target

type
  JICompositeSprite = class external(JExt.fx.target.ISprite)
  end;

//Ext.fx.target

type
  JIElement = class external(JExt.fx.target.ITarget)
  end;

//Ext.fx.target

type
  JIElementCSS = class external(JExt.fx.target.IElement)
  end;

//Ext.fx.target

type
  JISprite = class external(JExt.fx.target.ITarget)
  end;

//Ext.fx.target

type
  JITarget = class external(JExt.IBase)
  end;

//Ext.grid

type
  JICellContext = class external(JExt.IBase)
    isCellContext: Boolean; // nullable
  end;

//Ext.grid

type
  JICellEditor = class external(JExt.IEditor)
    alignment: String; // nullable
    cls: String; // nullable
    hideEl: Boolean; // nullable
    shadow: Variant; // nullable
  end;

//Ext.grid.column

type
  JIAction = class external(JExt.grid.column.IColumn)
    altText: String; // nullable
    disabled: Boolean; // nullable
    getClass: Variant; // nullable
    getTip: Variant; // nullable
    handler: Variant; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    items: array of Variant; // nullable
    menuText: String; // nullable
    scope: Variant; // nullable
    sortable: Boolean; // nullable
    stopSelection: Boolean; // nullable
    tooltip: String; // nullable
    function cascade: JExt.IContainer; overload;
    function cascade(fn: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant): JExt.IContainer; overload;
    procedure defaultRenderer; overload;
    procedure defaultRenderer(v: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant; store: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant; store: Variant; view: Variant); overload;
    procedure disableAction; overload;
    procedure disableAction(index: Variant); overload;
    procedure disableAction(index: Variant; silent: Boolean); overload;
    procedure enableAction; overload;
    procedure enableAction(index: Variant); overload;
    procedure enableAction(index: Variant; silent: Boolean); overload;
    procedure getRefItems;
  end;

//Ext.grid

type
  JIActionColumn = class external(JExt.grid.column.IColumn)
    altText: String; // nullable
    disabled: Boolean; // nullable
    getClass: Variant; // nullable
    getTip: Variant; // nullable
    handler: Variant; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    items: array of Variant; // nullable
    menuText: String; // nullable
    scope: Variant; // nullable
    sortable: Boolean; // nullable
    stopSelection: Boolean; // nullable
    tooltip: String; // nullable
    function cascade: JExt.IContainer; overload;
    function cascade(fn: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant): JExt.IContainer; overload;
    procedure defaultRenderer; overload;
    procedure defaultRenderer(v: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant; store: Variant); overload;
    procedure defaultRenderer(v: Variant; meta: Variant; record: Variant; rowIdx: Variant; colIdx: Variant; store: Variant; view: Variant); overload;
    procedure disableAction; overload;
    procedure disableAction(index: Variant); overload;
    procedure disableAction(index: Variant; silent: Boolean); overload;
    procedure enableAction; overload;
    procedure enableAction(index: Variant); overload;
    procedure enableAction(index: Variant; silent: Boolean); overload;
    procedure getRefItems;
  end;

//Ext.grid.column

type
  JIBoolean = class external(JExt.grid.column.IColumn)
    falseText: String; // nullable
    trueText: String; // nullable
    undefinedText: String; // nullable
  end;

//Ext.grid

type
  JIBooleanColumn = class external(JExt.grid.column.IColumn)
    falseText: String; // nullable
    trueText: String; // nullable
    undefinedText: String; // nullable
  end;

//Ext.grid.column

type
  JICheckColumn = class external(JExt.grid.column.IColumn)
    stopSelection: Boolean; // nullable
    tdCls: String; // nullable
    procedure onDisable; overload;
    procedure onDisable(silent: Boolean); overload;
    procedure onEnable; overload;
    procedure onEnable(silent: Boolean); overload;
  end;

//Ext.ux

type
  JICheckColumn = class external(JExt.grid.column.IColumn)
    stopSelection: Boolean; // nullable
    tdCls: String; // nullable
    procedure onDisable; overload;
    procedure onDisable(silent: Boolean); overload;
    procedure onEnable; overload;
    procedure onEnable(silent: Boolean); overload;
  end;

//Ext.grid.column

type
  JIColumn = class external(JExt.grid.header.IContainer)
    align: String; // nullable
    baseCls: String; // nullable
    columns: array of Variant; // nullable
    componentLayout: Variant; // nullable
    dataIndex: String; // nullable
    detachOnRemove: Boolean; // nullable
    draggable: Boolean; // nullable
    editRenderer: Variant; // nullable
    editor: Variant; // nullable
    emptyCellText: String; // nullable
    field: Variant; // nullable
    fixed: Boolean; // nullable
    groupable: Boolean; // nullable
    header: String; // nullable
    hideable: Boolean; // nullable
    lockable: Boolean; // nullable
    locked: Boolean; // nullable
    menuDisabled: Boolean; // nullable
    menuText: String; // nullable
    renderTpl: Variant; // nullable
    renderer: Variant; // nullable
    resizable: Boolean; // nullable
    scope: Variant; // nullable
    sortable: Boolean; // nullable
    stateId: String; // nullable
    tdCls: String; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    tooltipType: String; // nullable
    isColumn: Boolean; // nullable
    isHeader: Boolean; // nullable
    textEl: JExt.IElement; // nullable
    triggerEl: JExt.IElement; // nullable
    procedure afterComponentLayout; overload;
    procedure afterComponentLayout(width: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant; oldWidth: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant; oldWidth: Variant; oldHeight: Variant); overload;
    procedure afterRender;
    procedure autoSize; overload;
    procedure autoSize(The: Variant); overload;
    procedure defaultRenderer;
    function getEditor: Variant; overload;
    function getEditor(record: Variant): Variant; overload;
    function getEditor(record: Variant; defaultField: Variant): Variant; overload;
    function getIndex: Float;
    function getSortParam: String;
    function getVisibleIndex: Float;
    function hide: JExt.IComponent; overload;
    function hide(fromOwner: Variant): JExt.IComponent; overload;
    function initRenderData: Variant;
    procedure isHideable;
    procedure isLockable;
    procedure onAdd; overload;
    procedure onAdd(child: Variant); overload;
    procedure onDestroy;
    procedure onRemove; overload;
    procedure onRemove(child: Variant); overload;
    procedure setEditor; overload;
    procedure setEditor(field: Variant); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    function show: JExt.IComponent; overload;
    function show(fromOwner: Variant): JExt.IComponent; overload;
    function show(fromOwner: Variant; fromChild: Variant): JExt.IComponent; overload;
  end;

//Ext.grid

type
  JIColumn = class external(JExt.grid.header.IContainer)
    align: String; // nullable
    baseCls: String; // nullable
    columns: array of Variant; // nullable
    componentLayout: Variant; // nullable
    dataIndex: String; // nullable
    detachOnRemove: Boolean; // nullable
    draggable: Boolean; // nullable
    editRenderer: Variant; // nullable
    editor: Variant; // nullable
    emptyCellText: String; // nullable
    field: Variant; // nullable
    fixed: Boolean; // nullable
    groupable: Boolean; // nullable
    header: String; // nullable
    hideable: Boolean; // nullable
    lockable: Boolean; // nullable
    locked: Boolean; // nullable
    menuDisabled: Boolean; // nullable
    menuText: String; // nullable
    renderTpl: Variant; // nullable
    renderer: Variant; // nullable
    resizable: Boolean; // nullable
    scope: Variant; // nullable
    sortable: Boolean; // nullable
    stateId: String; // nullable
    tdCls: String; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    tooltipType: String; // nullable
    isColumn: Boolean; // nullable
    isHeader: Boolean; // nullable
    textEl: JExt.IElement; // nullable
    triggerEl: JExt.IElement; // nullable
    procedure afterComponentLayout; overload;
    procedure afterComponentLayout(width: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant; oldWidth: Variant); overload;
    procedure afterComponentLayout(width: Variant; height: Variant; oldWidth: Variant; oldHeight: Variant); overload;
    procedure afterRender;
    procedure autoSize; overload;
    procedure autoSize(The: Variant); overload;
    procedure defaultRenderer;
    function getEditor: Variant; overload;
    function getEditor(record: Variant): Variant; overload;
    function getEditor(record: Variant; defaultField: Variant): Variant; overload;
    function getIndex: Float;
    function getSortParam: String;
    function getVisibleIndex: Float;
    function hide: JExt.IComponent; overload;
    function hide(fromOwner: Variant): JExt.IComponent; overload;
    function initRenderData: Variant;
    procedure isHideable;
    procedure isLockable;
    procedure onAdd; overload;
    procedure onAdd(child: Variant); overload;
    procedure onDestroy;
    procedure onRemove; overload;
    procedure onRemove(child: Variant); overload;
    procedure setEditor; overload;
    procedure setEditor(field: Variant); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    function show: JExt.IComponent; overload;
    function show(fromOwner: Variant): JExt.IComponent; overload;
    function show(fromOwner: Variant; fromChild: Variant): JExt.IComponent; overload;
  end;

//Ext.grid.column

type
  JIDate = class external(JExt.grid.column.IColumn)
    format: String; // nullable
    procedure defaultRenderer; overload;
    procedure defaultRenderer(value: Variant); overload;
  end;

//Ext.grid

type
  JIDateColumn = class external(JExt.grid.column.IColumn)
    format: String; // nullable
    procedure defaultRenderer; overload;
    procedure defaultRenderer(value: Variant); overload;
  end;

//Ext.grid.column

type
  JINumber = class external(JExt.grid.column.IColumn)
    format: String; // nullable
  end;

//Ext.grid

type
  JINumberColumn = class external(JExt.grid.column.IColumn)
    format: String; // nullable
  end;

//Ext.grid.column

type
  JIRowNumberer = class external(JExt.grid.column.IColumn)
    align: String; // nullable
    cls: String; // nullable
    dataIndex: String; // nullable
    draggable: Boolean; // nullable
    hideable: Boolean; // nullable
    lockable: Boolean; // nullable
    menuDisabled: Boolean; // nullable
    resizable: Boolean; // nullable
    tdCls: String; // nullable
    text: String; // nullable
    width: Float; // nullable
  end;

//Ext.grid

type
  JIRowNumberer = class external(JExt.grid.column.IColumn)
    align: String; // nullable
    cls: String; // nullable
    dataIndex: String; // nullable
    draggable: Boolean; // nullable
    hideable: Boolean; // nullable
    lockable: Boolean; // nullable
    menuDisabled: Boolean; // nullable
    resizable: Boolean; // nullable
    tdCls: String; // nullable
    text: String; // nullable
    width: Float; // nullable
  end;

//Ext.grid.column

type
  JITemplate = class external(JExt.grid.column.IColumn)
    tpl: Variant; // nullable
    procedure defaultRenderer; overload;
    procedure defaultRenderer(value: Variant); overload;
    procedure defaultRenderer(value: Variant; meta: Variant); overload;
    procedure defaultRenderer(value: Variant; meta: Variant; record: Variant); overload;
  end;

//Ext.grid

type
  JITemplateColumn = class external(JExt.grid.column.IColumn)
    tpl: Variant; // nullable
    procedure defaultRenderer; overload;
    procedure defaultRenderer(value: Variant); overload;
    procedure defaultRenderer(value: Variant; meta: Variant); overload;
    procedure defaultRenderer(value: Variant; meta: Variant; record: Variant); overload;
  end;

//Ext.grid

type
  JIColumnComponentLayout = class external(JExt.layout.component.IAuto)
    setWidthInDom: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
  end;

//Ext.grid

type
  JIColumnLayout = class external(JExt.layout.container.IHBox)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure initLayout;
  end;

//Ext.grid

type
  JIColumnManager = class external(JExt.IBase)
    function getHeaderAtIndex: JExt.grid.column.IColumn; overload;
    function getHeaderAtIndex(index: Float): JExt.grid.column.IColumn; overload;
    function getHeaderById: JExt.grid.column.IColumn; overload;
    function getHeaderById(id: String): JExt.grid.column.IColumn; overload;
    function getHeaderIndex: Float; overload;
    function getHeaderIndex(header: JExt.grid.column.IColumn): Float; overload;
    procedure getVisibleHeaderClosestToIndex; overload;
    procedure getVisibleHeaderClosestToIndex(index: Float); overload;
  end;

//Ext.grid

type
  JIColumnModel = class external(JExt.IBase)
    function getHeaderAtIndex: JExt.grid.column.IColumn; overload;
    function getHeaderAtIndex(index: Float): JExt.grid.column.IColumn; overload;
    function getHeaderById: JExt.grid.column.IColumn; overload;
    function getHeaderById(id: String): JExt.grid.column.IColumn; overload;
    function getHeaderIndex: Float; overload;
    function getHeaderIndex(header: JExt.grid.column.IColumn): Float; overload;
    procedure getVisibleHeaderClosestToIndex; overload;
    procedure getVisibleHeaderClosestToIndex(index: Float); overload;
  end;

//Ext.grid.feature

type
  JIAbstractSummary = class external(JExt.grid.feature.IFeature)
    remoteRoot: String; // nullable
    showSummaryRow: Boolean; // nullable
    procedure toggleSummaryRow; overload;
    procedure toggleSummaryRow(visible: Boolean); overload;
  end;

//Ext.grid.feature

type
  JIFeature = class external(JExt.util.IObservable)
    disabled: Boolean; // nullable
    eventPrefix: String; // nullable
    eventSelector: String; // nullable
    grid: JExt.grid.IPanel; // nullable
    hasFeatureEvent: Boolean; // nullable
    view: JExt.view.ITable; // nullable
    procedure disable;
    procedure enable;
    procedure getFireEventArgs; overload;
    procedure getFireEventArgs(eventName: Variant); overload;
    procedure getFireEventArgs(eventName: Variant; view: Variant); overload;
    procedure getFireEventArgs(eventName: Variant; view: Variant; featureTarget: Variant); overload;
    procedure getFireEventArgs(eventName: Variant; view: Variant; featureTarget: Variant; e: Variant); overload;
  end;

//Ext.grid.feature

type
  JIGrouping = class external(JExt.grid.feature.IFeature, JExt.grid.feature.IAbstractSummary)
    collapsible: Boolean; // nullable
    depthToIndent: Float; // nullable
    enableGroupingMenu: Boolean; // nullable
    enableNoGroups: Boolean; // nullable
    groupByText: String; // nullable
    groupHeaderTpl: Variant; // nullable
    hideGroupedHeader: Boolean; // nullable
    showGroupsText: String; // nullable
    showSummaryRow: Boolean; // nullable
    startCollapsed: Boolean; // nullable
    eventPrefix: String; // nullable
    eventSelector: String; // nullable
    procedure collapse; overload;
    procedure collapse(groupName: String); overload;
    procedure collapse(groupName: String; focus: Boolean); overload;
    procedure collapseAll;
    procedure disable;
    procedure enable;
    procedure expand; overload;
    procedure expand(groupName: String); overload;
    procedure expand(groupName: String; focus: Boolean); overload;
    procedure expandAll;
    procedure getFireEventArgs; overload;
    procedure getFireEventArgs(&type: Variant); overload;
    procedure getFireEventArgs(&type: Variant; view: Variant); overload;
    procedure getFireEventArgs(&type: Variant; view: Variant; targetEl: Variant); overload;
    procedure getFireEventArgs(&type: Variant; view: Variant; targetEl: Variant; e: Variant); overload;
    function getRecordGroup: Variant; overload;
    function getRecordGroup(record: JExt.data.IModel): Variant; overload;
    function isExpanded: Boolean; overload;
    function isExpanded(groupName: String): Boolean; overload;
    procedure toggleSummaryRow; overload;
    procedure toggleSummaryRow(visible: Boolean); overload;
  end;

//Ext.grid.feature

type
  JIGroupingSummary = class external(JExt.grid.feature.IGrouping)
    showSummaryRow: Boolean; // nullable
  end;

//Ext.grid.feature

type
  JIGroupStore = class external(JExt.util.IObservable)
    function indexOfTotal: Float; overload;
    function indexOfTotal(record: JExt.data.IModel): Float; overload;
  end;

//Ext.grid.feature

type
  JIRowBody = class external(JExt.grid.feature.IFeature)
    eventPrefix: String; // nullable
    eventSelector: String; // nullable
    procedure getAdditionalData; overload;
    procedure getAdditionalData(data: Variant); overload;
    procedure getAdditionalData(data: Variant; idx: Float); overload;
    procedure getAdditionalData(data: Variant; idx: Float; record: JExt.data.IModel); overload;
    procedure getAdditionalData(data: Variant; idx: Float; record: JExt.data.IModel; orig: Variant); overload;
  end;

//Ext.grid.feature

type
  JIRowWrap = class external(JExt.grid.feature.IFeature)
    hasFeatureEvent: Boolean; // nullable
  end;

//Ext.grid.feature

type
  JISummary = class external(JExt.grid.feature.IAbstractSummary)
    dock: String; // nullable
  end;

//Ext.grid.header

type
  JIContainer = class external(JExt.container.IContainer)
    baseCls: String; // nullable
    border: Variant; // nullable
    defaultType: String; // nullable
    defaultWidth: Float; // nullable
    detachOnRemove: Boolean; // nullable
    enableColumnHide: Boolean; // nullable
    sealed: Boolean; // nullable
    sortable: Boolean; // nullable
    weight: Float; // nullable
    isGroupHeader: Boolean; // nullable
    procedure getColumnCount;
    procedure getColumnMenu; overload;
    procedure getColumnMenu(headerContainer: Variant); overload;
    procedure getFullWidth;
    function getGridColumns: array of Variant; overload;
    function getGridColumns(inResult: Variant): array of Variant; overload;
    function getGridColumns(inResult: Variant; hiddenAncestor: Variant): array of Variant; overload;
    procedure getHeaderAtIndex; overload;
    procedure getHeaderAtIndex(index: Float); overload;
    function getHeaderIndex: Float; overload;
    function getHeaderIndex(header: JExt.grid.column.IColumn): Float; overload;
    function getMenuItems: array of Variant;
    function getVisibleGridColumns: array of Variant;
    procedure getVisibleHeaderClosestToIndex; overload;
    procedure getVisibleHeaderClosestToIndex(index: Float); overload;
    procedure isLayoutRoot;
    procedure onAdd; overload;
    procedure onAdd(c: Variant); overload;
    procedure onDestroy;
    procedure onRemove; overload;
    procedure onRemove(c: Variant); overload;
    procedure onShow;
  end;

//Ext.grid.header

type
  JIDragZone = class external(JExt.dd.IDragZone)
    function getDragData: Variant; overload;
    function getDragData(e: Variant): Variant; overload;
    function getRepairXY: array of Float;
    function onBeforeDrag: Boolean;
    function onInitDrag: Boolean;
  end;

//Ext.grid.header

type
  JIDropZone = class external(JExt.dd.IDropZone)
    function getTargetFromEvent: Variant; overload;
    function getTargetFromEvent(e: Variant): Variant; overload;
    function onNodeDrop: Boolean; overload;
    function onNodeDrop(node: Variant): Boolean; overload;
    function onNodeDrop(node: Variant; dragZone: Variant): Boolean; overload;
    function onNodeDrop(node: Variant; dragZone: Variant; e: Variant): Boolean; overload;
    function onNodeDrop(node: Variant; dragZone: Variant; e: Variant; data: Variant): Boolean; overload;
    procedure onNodeOut;
    function onNodeOver: String; overload;
    function onNodeOver(node: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant; data: Variant): String; overload;
  end;

//Ext.grid.locking

type
  JIHeaderContainer = class external(JExt.grid.header.IContainer)
    function getGridColumns: array of Variant;
    procedure getRefItems;
  end;

//Ext.grid.locking

type
  JILockable = class external(JExt.IBase)
    lockedGridConfig: Variant; // nullable
    lockedViewConfig: Variant; // nullable
    normalGridConfig: Variant; // nullable
    normalViewConfig: Variant; // nullable
    scrollDelta: Float; // nullable
    subGridXType: String; // nullable
    syncRowHeight: Boolean; // nullable
    procedure syncRowHeights;
  end;

//Ext.grid

type
  JILockable = class external(JExt.IBase)
    lockedGridConfig: Variant; // nullable
    lockedViewConfig: Variant; // nullable
    normalGridConfig: Variant; // nullable
    normalViewConfig: Variant; // nullable
    scrollDelta: Float; // nullable
    subGridXType: String; // nullable
    syncRowHeight: Boolean; // nullable
    procedure syncRowHeights;
  end;

//Ext.grid.locking

type
  JIView = class external(JExt.IBase, JExt.util.IObservable)
    isLockingView: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.grid

type
  JILockingView = class external(JExt.IBase, JExt.util.IObservable)
    isLockingView: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.grid

type
  JIPanel = class external(JExt.panel.ITable)
    columns: Variant; // nullable
    rowLines: Boolean; // nullable
    viewType: String; // nullable
    procedure reconfigure; overload;
    procedure reconfigure(store: JExt.data.IStore); overload;
    procedure reconfigure(store: JExt.data.IStore; columns: array of Variant); overload;
  end;

//Ext.list

type
  JIListView = class external(JExt.panel.ITable)
    columns: Variant; // nullable
    rowLines: Boolean; // nullable
    viewType: String; // nullable
    procedure reconfigure; overload;
    procedure reconfigure(store: JExt.data.IStore); overload;
    procedure reconfigure(store: JExt.data.IStore; columns: array of Variant); overload;
  end;

//Ext

type
  JIListView = class external(JExt.panel.ITable)
    columns: Variant; // nullable
    rowLines: Boolean; // nullable
    viewType: String; // nullable
    procedure reconfigure; overload;
    procedure reconfigure(store: JExt.data.IStore); overload;
    procedure reconfigure(store: JExt.data.IStore; columns: array of Variant); overload;
  end;

//Ext.grid

type
  JIGridPanel = class external(JExt.panel.ITable)
    columns: Variant; // nullable
    rowLines: Boolean; // nullable
    viewType: String; // nullable
    procedure reconfigure; overload;
    procedure reconfigure(store: JExt.data.IStore); overload;
    procedure reconfigure(store: JExt.data.IStore; columns: array of Variant); overload;
  end;

//Ext.grid.plugin

type
  JIBufferedRenderer = class external(JExt.IAbstractPlugin)
    leadingBufferZone: Float; // nullable
    numFromEdge: Float; // nullable
    percentageFromEdge: Float; // nullable
    scrollToLoadBuffer: Float; // nullable
    synchronousRender: Boolean; // nullable
    trailingBufferZone: Float; // nullable
    variableRowHeight: Boolean; // nullable
    position: Float; // nullable
    procedure destroy;
    procedure init; overload;
    procedure init(grid: Variant); overload;
    procedure scrollTo; overload;
    procedure scrollTo(recordIdx: Float); overload;
    procedure scrollTo(recordIdx: Float; doSelect: Boolean); overload;
    procedure scrollTo(recordIdx: Float; doSelect: Boolean; callback: Variant); overload;
    procedure scrollTo(recordIdx: Float; doSelect: Boolean; callback: Variant; scope: Variant); overload;
  end;

//Ext.grid.plugin

type
  JICellEditing = class external(JExt.grid.plugin.IEditing)
    procedure cancelEdit;
    procedure completeEdit;
    function startEdit: Boolean; overload;
    function startEdit(record: Variant): Boolean; overload;
    function startEdit(record: Variant; columnHeader: Variant): Boolean; overload;
    procedure startEditByPosition; overload;
    procedure startEditByPosition(position: Variant); overload;
  end;

//Ext.grid.plugin

type
  JIDragDrop = class external(JExt.IAbstractPlugin)
    containerScroll: Variant; // nullable
    ddGroup: String; // nullable
    dragGroup: String; // nullable
    dragText: String; // nullable
    dropGroup: String; // nullable
    enableDrag: Boolean; // nullable
    enableDrop: Boolean; // nullable
    procedure disable;
    procedure enable;
    procedure init; overload;
    procedure init(view: Variant); overload;
  end;

//Ext.grid.plugin

type
  JIEditing = class external(JExt.IAbstractPlugin, JExt.util.IObservable)
    clicksToEdit: Float; // nullable
    triggerEvent: String; // nullable
    editing: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure cancelEdit;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure completeEdit;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure startEdit; overload;
    procedure startEdit(record: Variant); overload;
    procedure startEdit(record: Variant; columnHeader: Variant); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.grid.plugin

type
  JIHeaderReorderer = class external(JExt.IAbstractPlugin)
    procedure disable;
    procedure enable;
    procedure init; overload;
    procedure init(headerCt: Variant); overload;
  end;

//Ext.grid.plugin

type
  JIHeaderResizer = class external(JExt.IAbstractPlugin)
    dynamic: Boolean; // nullable
    procedure disable;
    procedure enable;
    function getDynamic: Boolean;
    procedure init; overload;
    procedure init(headerCt: Variant); overload;
    procedure setDynamic; overload;
    procedure setDynamic(dynamic: Boolean); overload;
  end;

//Ext.grid.plugin

type
  JIRowEditing = class external(JExt.grid.plugin.IEditing)
    autoCancel: Boolean; // nullable
    clicksToMoveEditor: Float; // nullable
    errorSummary: Boolean; // nullable
    function startEdit: Boolean; overload;
    function startEdit(record: JExt.data.IModel): Boolean; overload;
    function startEdit(record: JExt.data.IModel; columnHeader: JExt.data.IModel): Boolean; overload;
  end;

//Ext.grid.plugin

type
  JIRowExpander = class external(JExt.IAbstractPlugin)
    expandOnDblClick: Boolean; // nullable
    expandOnEnter: Boolean; // nullable
    selectRowOnExpand: Boolean; // nullable
    procedure init; overload;
    procedure init(grid: Variant); overload;
  end;

//Ext.grid.property

type
  JIGrid = class external(JExt.grid.IPanel)
    columnLines: Boolean; // nullable
    customEditors: Variant; // nullable
    customRenderers: Variant; // nullable
    enableColumnMove: Boolean; // nullable
    inferTypes: Boolean; // nullable
    nameColumnWidth: Variant; // nullable
    nameField: String; // nullable
    propertyNames: Variant; // nullable
    source: Variant; // nullable
    sourceConfig: Variant; // nullable
    valueField: String; // nullable
    function getSource: Variant;
    procedure removeProperty; overload;
    procedure removeProperty(prop: String); overload;
    procedure setProperty; overload;
    procedure setProperty(prop: String); overload;
    procedure setProperty(prop: String; value: Variant); overload;
    procedure setProperty(prop: String; value: Variant; create: Boolean); overload;
    procedure setSource; overload;
    procedure setSource(source: Variant); overload;
    procedure setSource(source: Variant; sourceConfig: Variant); overload;
  end;

//Ext.grid

type
  JIPropertyGrid = class external(JExt.grid.IPanel)
    columnLines: Boolean; // nullable
    customEditors: Variant; // nullable
    customRenderers: Variant; // nullable
    enableColumnMove: Boolean; // nullable
    inferTypes: Boolean; // nullable
    nameColumnWidth: Variant; // nullable
    nameField: String; // nullable
    propertyNames: Variant; // nullable
    source: Variant; // nullable
    sourceConfig: Variant; // nullable
    valueField: String; // nullable
    function getSource: Variant;
    procedure removeProperty; overload;
    procedure removeProperty(prop: String); overload;
    procedure setProperty; overload;
    procedure setProperty(prop: String); overload;
    procedure setProperty(prop: String; value: Variant); overload;
    procedure setProperty(prop: String; value: Variant; create: Boolean); overload;
    procedure setSource; overload;
    procedure setSource(source: Variant); overload;
    procedure setSource(source: Variant; sourceConfig: Variant); overload;
  end;

//Ext.grid.property

type
  JIHeaderContainer = class external(JExt.grid.header.IContainer)
  end;

//Ext.grid

type
  JIPropertyColumnModel = class external(JExt.grid.header.IContainer)
  end;

//Ext.grid.property

type
  JIProperty = class external(JExt.data.IModel)
    idProperty: Variant; // nullable
    fields: JExt.util.IMixedCollection; // nullable
  end;

//Ext

type
  JIPropGridProperty = class external(JExt.data.IModel)
    idProperty: Variant; // nullable
    fields: JExt.util.IMixedCollection; // nullable
  end;

//Ext.grid.property

type
  JIStore = class external(JExt.data.IStore)
    sortOnLoad: Boolean; // nullable
    function getProxy: JExt.data.proxy.IProxy;
  end;

//Ext.grid

type
  JIPropertyStore = class external(JExt.data.IStore)
    sortOnLoad: Boolean; // nullable
    function getProxy: JExt.data.proxy.IProxy;
  end;

//Ext.grid

type
  JIRowEditor = class external(JExt.form.IPanel)
    border: Variant; // nullable
    hideMode: String; // nullable
    procedure afterRender;
    procedure getRefItems;
    function isDirty: Boolean;
    function loadRecord: JExt.form.IBasic; overload;
    function loadRecord(record: Variant): JExt.form.IBasic; overload;
    procedure onHide;
    procedure onShow;
    procedure startEdit; overload;
    procedure startEdit(record: JExt.data.IModel); overload;
    procedure startEdit(record: JExt.data.IModel; columnHeader: JExt.data.IModel); overload;
  end;

//Ext.grid

type
  JIRowEditorButtons = class external(JExt.container.IContainer)
    frame: Boolean; // nullable
    shrinkWrap: Variant; // nullable
  end;

//Ext.grid

type
  JIView = class external(JExt.view.ITable)
    autoScroll: Boolean; // nullable
    stripeRows: Boolean; // nullable
  end;

//Ext.grid

type
  JIViewDropZone = class external(JExt.view.IDropZone)
  end;

//Ext

type
  JIImg = class external(JExt.IComponent)
    alt: String; // nullable
    autoEl: Variant; // nullable
    baseCls: String; // nullable
    glyph: Variant; // nullable
    imgCls: String; // nullable
    src: String; // nullable
    title: String; // nullable
    procedure onDestroy;
    procedure onRender;
    procedure setSrc; overload;
    procedure setSrc(src: String); overload;
  end;

//Ext

type
  JIs = class external 'Is'
    Android: Boolean;
    Blackberry: Boolean;
    Desktop: Boolean;
    Linux: Boolean;
    Mac: Boolean;
    Phone: Boolean;
    Standalone: Boolean;
    Tablet: Variant;
    Windows: Boolean;
    iOS: Boolean;
    iPad: Boolean;
    iPhone: Boolean;
    iPod: Boolean;
  end;

  JIIs = class external
  end;

//Ext

procedure addBehaviors; overload;
procedure addBehaviors(obj: Variant); overload;
procedure addNamespaces; overload;
procedure addNamespaces(namespace: Variant); overload;
procedure application; overload;
procedure application(config: Variant); overload;
function apply: Variant; overload;
function apply(&object: Variant): Variant; overload;
function apply(&object: Variant; config: Variant): Variant; overload;
function apply(&object: Variant; config: Variant; defaults: Variant): Variant; overload;
function applyIf: Variant; overload;
function applyIf(&object: Variant): Variant; overload;
function applyIf(&object: Variant; config: Variant): Variant; overload;
procedure batchLayouts; overload;
procedure batchLayouts(fn: Variant); overload;
procedure batchLayouts(fn: Variant; scope: Variant); overload;
function bind: Variant; overload;
function bind(fn: Variant): Variant; overload;
function bind(fn: Variant; scope: Variant): Variant; overload;
function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
function callback: Variant; overload;
function callback(callback: Variant): Variant; overload;
function callback(callback: Variant; scope: Variant): Variant; overload;
function callback(callback: Variant; scope: Variant; args: array of Variant): Variant; overload;
function callback(callback: Variant; scope: Variant; args: array of Variant; delay: Float): Variant; overload;
function clean: array of Variant; overload;
function clean(array: array of Variant): array of Variant; overload;
function clone: Variant; overload;
function clone(item: Variant): Variant; overload;
function coerce: Variant; overload;
function coerce(from: Variant): Variant; overload;
function coerce(from: Variant; to: Variant): Variant; overload;
function copyTo: Variant; overload;
function copyTo(dest: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant; names: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant; names: Variant; usePrototypeKeys: Boolean): Variant; overload;
function create(name: String; args: array of Variant): Variant;
function createByAlias(alias: String; args: array of Variant): Variant;
procedure createWidget;
function decode: Variant; overload;
function decode(json: String): Variant; overload;
function decode(json: String; safe: Boolean): Variant; overload;
function defer: Float; overload;
function defer(fn: Variant): Float; overload;
function defer(fn: Variant; millis: Float): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
function define: JExt.IBase; overload;
function define(className: String): JExt.IBase; overload;
function define(className: String; data: Variant): JExt.IBase; overload;
function define(className: String; data: Variant; createdFn: Variant): JExt.IBase; overload;
procedure deprecate; overload;
procedure deprecate(packageName: String); overload;
procedure deprecate(packageName: String; since: String); overload;
procedure deprecate(packageName: String; since: String; closure: Variant); overload;
procedure deprecate(packageName: String; since: String; closure: Variant; scope: Variant); overload;
procedure destroy; overload;
procedure destroy(args: Variant); overload;
procedure destroyMembers(o: Variant; args: array of Variant);
function each: Boolean; overload;
function each(iterable: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant; scope: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant; scope: Variant; reverse: Boolean): Boolean; overload;
function encode: String; overload;
function encode(o: Variant): String; overload;
function escapeRe: String; overload;
function escapeRe(str: String): String; overload;
function exclude: Variant; overload;
function exclude(excludes: array of Variant): Variant; overload;
function extend: Variant; overload;
function extend(superclass: Variant): Variant; overload;
function extend(superclass: Variant; overrides: Variant): Variant; overload;
function flatten: array of Variant; overload;
function flatten(array: array of Variant): array of Variant; overload;
function fly: JExt.dom.element.IFly; overload;
function fly(dom: Variant): JExt.dom.element.IFly; overload;
function fly(dom: Variant; named: String): JExt.dom.element.IFly; overload;
function get: JExt.dom.IElement; overload;
function get(el: Variant): JExt.dom.IElement; overload;
function getBody: JExt.IElement;
function getClass: JExt.IClass; overload;
function getClass(&object: Variant): JExt.IClass; overload;
function getClassName: String; overload;
function getClassName(&object: Variant): String; overload;
function getCmp: Variant; overload;
function getCmp(id: String): Variant; overload;
function getDoc: JExt.IElement;
function getDom: Variant; overload;
function getDom(el: Variant): Variant; overload;
function getHead: JExt.IElement;
function getNamespace: String; overload;
function getNamespace(className: String): String; overload;
function getOrientation: String;
function getScrollBarWidth: Float; overload;
function getScrollBarWidth(force: Boolean): Float; overload;
function getScrollbarSize: Variant; overload;
function getScrollbarSize(force: Boolean): Variant; overload;
function getStore: JExt.data.IStore; overload;
function getStore(store: Variant): JExt.data.IStore; overload;
function getVersion: JExt.IVersion; overload;
function getVersion(packageName: String): JExt.IVersion; overload;
function htmlDecode: String; overload;
function htmlDecode(value: String): String; overload;
function htmlEncode: String; overload;
function htmlEncode(value: String): String; overload;
function id: String; overload;
function id(el: Variant): String; overload;
function id(el: Variant; prefix: String): String; overload;
procedure identityFn; overload;
procedure identityFn(o: Variant); overload;
function invoke(arr: Variant; methodName: String; args: array of Variant): array of Variant;
function isArray: Boolean; overload;
function isArray(target: Variant): Boolean; overload;
function isBoolean: Boolean; overload;
function isBoolean(value: Variant): Boolean; overload;
function isDate: Boolean; overload;
function isDate(&object: Variant): Boolean; overload;
function isDefined: Boolean; overload;
function isDefined(value: Variant): Boolean; overload;
function isElement: Boolean; overload;
function isElement(value: Variant): Boolean; overload;
function isEmpty: Boolean; overload;
function isEmpty(value: Variant): Boolean; overload;
function isEmpty(value: Variant; allowEmptyString: Boolean): Boolean; overload;
function isFunction: Boolean; overload;
function isFunction(value: Variant): Boolean; overload;
function isIterable: Boolean; overload;
function isIterable(value: Variant): Boolean; overload;
function isNumber: Boolean; overload;
function isNumber(value: Variant): Boolean; overload;
function isNumeric: Boolean; overload;
function isNumeric(value: Variant): Boolean; overload;
function isObject: Boolean; overload;
function isObject(value: Variant): Boolean; overload;
function isPrimitive: Boolean; overload;
function isPrimitive(value: Variant): Boolean; overload;
function isString: Boolean; overload;
function isString(value: Variant): Boolean; overload;
function isTextNode: Boolean; overload;
function isTextNode(value: Variant): Boolean; overload;
procedure iterate; overload;
procedure iterate(&object: Variant); overload;
procedure iterate(&object: Variant; fn: Variant); overload;
procedure iterate(&object: Variant; fn: Variant; scope: Variant); overload;
procedure log(options: Variant; message: array of Variant);
function max: Variant; overload;
function max(array: Variant): Variant; overload;
function max(array: Variant; comparisonFn: Variant): Variant; overload;
function mean: Float; overload;
function mean(array: array of Variant): Float; overload;
function merge(destination: Variant; &object: array of Variant): Variant;
function min: Variant; overload;
function min(array: Variant): Variant; overload;
function min(array: Variant; comparisonFn: Variant): Variant; overload;
function namespace(namespaces: array of Variant): Variant;
function ns(namespaces: array of Variant): Variant;
function num: Float; overload;
function num(value: Variant): Float; overload;
function num(value: Variant; defaultValue: Float): Float; overload;
function on: Variant; overload;
function on(eventName: Variant): Variant; overload;
function on(eventName: Variant; fn: Variant): Variant; overload;
function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
procedure onDocumentReady; overload;
procedure onDocumentReady(fn: Variant); overload;
procedure onDocumentReady(fn: Variant; scope: Variant); overload;
procedure onDocumentReady(fn: Variant; scope: Variant; options: Variant); overload;
procedure onReady; overload;
procedure onReady(fn: Variant); overload;
procedure onReady(fn: Variant; scope: Variant); overload;
procedure onReady(fn: Variant; scope: Variant; options: Variant); overload;
procedure override; overload;
procedure override(target: Variant); overload;
procedure override(target: Variant; overrides: Variant); overload;
function partition: array of Variant; overload;
function partition(arr: Variant): array of Variant; overload;
function partition(arr: Variant; truth: Variant): array of Variant; overload;
function pass: Variant; overload;
function pass(fn: Variant): Variant; overload;
function pass(fn: Variant; args: array of Variant): Variant; overload;
function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
function pluck: array of Variant; overload;
function pluck(array: Variant): array of Variant; overload;
function pluck(array: Variant; propertyName: String): array of Variant; overload;
procedure preg; overload;
procedure preg(ptype: String); overload;
procedure preg(ptype: String; cls: Variant); overload;
function query: array of JHTMLElement; overload;
function query(path: String): array of JHTMLElement; overload;
function query(path: String; root: JHTMLElement): array of JHTMLElement; overload;
function query(path: String; root: JHTMLElement; &type: String): array of JHTMLElement; overload;
function query(path: String; root: JHTMLElement; &type: String; single: Boolean): array of JHTMLElement; overload;
function regModel: JExt.data.IModel; overload;
function regModel(name: String): JExt.data.IModel; overload;
function regModel(name: String; config: Variant): JExt.data.IModel; overload;
procedure regStore; overload;
procedure regStore(id: String); overload;
procedure regStore(id: String; config: Variant); overload;
procedure removeNode; overload;
procedure removeNode(node: JHTMLElement); overload;
procedure require; overload;
procedure require(expressions: Variant); overload;
procedure require(expressions: Variant; fn: Variant); overload;
procedure require(expressions: Variant; fn: Variant; scope: Variant); overload;
procedure require(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
procedure resumeLayouts; overload;
procedure resumeLayouts(flush: Variant); overload;
function select: JExt.ICompositeElement; overload;
function select(selector: String): JExt.ICompositeElement; overload;
function select(selector: String; unique: Boolean): JExt.ICompositeElement; overload;
procedure setGlyphFontFamily; overload;
procedure setGlyphFontFamily(fontFamily: String); overload;
function setVersion: Variant; overload;
function setVersion(packageName: String): Variant; overload;
function setVersion(packageName: String; version: Variant): Variant; overload;
function sum: Float; overload;
function sum(array: array of Variant): Float; overload;
procedure suspendLayouts;
procedure syncRequire; overload;
procedure syncRequire(expressions: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
function toArray: array of Variant; overload;
function toArray(iterable: Variant): array of Variant; overload;
function toArray(iterable: Variant; start: Float): array of Variant; overload;
function toArray(iterable: Variant; start: Float; &end: Float): array of Variant; overload;
function toSentence: String; overload;
function toSentence(items: array of String): String; overload;
function toSentence(items: array of String; connector: String): String; overload;
function type: String; overload;
function type(value: Variant): String; overload;
function typeOf: String; overload;
function typeOf(value: Variant): String; overload;
procedure un; overload;
procedure un(eventName: String); overload;
procedure un(eventName: String; fn: Variant); overload;
procedure un(eventName: String; fn: Variant; scope: Variant); overload;
function unique: array of Variant; overload;
function unique(array: array of Variant): array of Variant; overload;
function urlAppend: String; overload;
function urlAppend(url: String): String; overload;
function urlAppend(url: String; &string: String): String; overload;
function urlDecode: Variant; overload;
function urlDecode(queryString: String): Variant; overload;
function urlDecode(queryString: String; recursive: Boolean): Variant; overload;
function urlEncode: String; overload;
function urlEncode(&object: Variant): String; overload;
function urlEncode(&object: Variant; recursive: Boolean): String; overload;
function value: Variant; overload;
function value(value: Variant): Variant; overload;
function value(value: Variant; defaultValue: Variant): Variant; overload;
function value(value: Variant; defaultValue: Variant; allowBlank: Boolean): Variant; overload;
function valueFrom: Variant; overload;
function valueFrom(value: Variant): Variant; overload;
function valueFrom(value: Variant; defaultValue: Variant): Variant; overload;
function valueFrom(value: Variant; defaultValue: Variant; allowBlank: Boolean): Variant; overload;
function widget: Variant; overload;
function widget(name: String): Variant; overload;
function widget(name: String; config: Variant): Variant; overload;
function zip: array of Variant; overload;
function zip(arr: Variant): array of Variant; overload;
function zip(arr: Variant; zipper: Variant): array of Variant; overload;

var
  BLANK_IMAGE_URL: String;
  SSL_SECURE_URL: String;
  USE_NATIVE_JSON: Boolean;
  chromeVersion: Float;
  emptyFn: Variant;
  emptyString: Variant;
  enableFx: Boolean;
  enableGarbageCollector: Boolean;
  enableListenerCollection: Boolean;
  enableNestedListenerRemoval: Boolean;
  enumerables: array of String;
  firefoxVersion: Float;
  globalEvents: JExt.util.IObservable;
  ieVersion: Float;
  isChrome: Boolean;
  isFF10: Boolean;
  isFF3_0: Boolean;
  isFF3_5: Boolean;
  isFF3_6: Boolean;
  isFF4: Boolean;
  isFF5: Boolean;
  isGecko: Boolean;
  isGecko10: Boolean;
  isGecko3: Boolean;
  isGecko4: Boolean;
  isGecko5: Boolean;
  isIE: Boolean;
  isIE10: Boolean;
  isIE10m: Boolean;
  isIE10p: Boolean;
  isIE6: Boolean;
  isIE7: Boolean;
  isIE7m: Boolean;
  isIE7p: Boolean;
  isIE8: Boolean;
  isIE8m: Boolean;
  isIE8p: Boolean;
  isIE9: Boolean;
  isIE9m: Boolean;
  isIE9p: Boolean;
  isLinux: Boolean;
  isMac: Boolean;
  isOpera: Boolean;
  isOpera10_5: Boolean;
  isReady: Boolean;
  isSafari: Boolean;
  isSafari2: Boolean;
  isSafari3: Boolean;
  isSafari4: Boolean;
  isSafari5: Boolean;
  isSafari5_0: Boolean;
  isSecure: Boolean;
  isWebKit: Boolean;
  isWindows: Boolean;
  name: String;
  operaVersion: Float;
  safariVersion: Float;
  useShims: Boolean;
  webKitVersion: Float;

//Ext

type
  JJSON = class external 'JSON'
    function decode: Variant; overload;
    function decode(json: String): Variant; overload;
    function decode(json: String; safe: Boolean): Variant; overload;
    function encode: String; overload;
    function encode(o: Variant): String; overload;
    function encodeDate: String; overload;
    function encodeDate(d: Variant): String; overload;
    function encodeString: String; overload;
    function encodeString(s: String): String; overload;
    function encodeValue: String; overload;
    function encodeValue(o: Variant): String; overload;
  end;

  JIJSON = class external
  end;

//Ext.layout

type
  JIClassList = class external(JExt.IBase)
    procedure add; overload;
    procedure add(cls: Variant); overload;
    procedure addMany; overload;
    procedure addMany(classes: Variant); overload;
    procedure remove; overload;
    procedure remove(cls: Variant); overload;
    procedure removeMany; overload;
    procedure removeMany(classes: Variant); overload;
  end;

//Ext.layout.component

type
  JIAuto = class external(JExt.layout.component.IComponent)
    setHeightInDom: Boolean; // nullable
    setWidthInDom: Boolean; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
  end;

//Ext.layout.component

type
  JIBody = class external(JExt.layout.component.IAuto)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
  end;

//Ext.layout.component

type
  JIBoundList = class external(JExt.layout.component.IAuto)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    procedure getLayoutItems;
    procedure isValidParent;
  end;

//Ext.layout.component

type
  JIButton = class external(JExt.layout.component.IAuto)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
  end;

//Ext.layout.component

type
  JIComponent = class external(JExt.layout.ILayout)
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getRenderTarget: JExt.IElement;
    function getTarget: JExt.IElement;
    procedure notifyOwner; overload;
    procedure notifyOwner(ownerContext: Variant); overload;
  end;

//Ext.layout.component

type
  JIDock = class external(JExt.layout.component.IComponent)
    procedure afterRemove; overload;
    procedure afterRemove(item: Variant); overload;
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: JExt.IComponent); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(order: String): array of JExt.IComponent; overload;
    function getDockedItems(order: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    function getLayoutItems: array of Variant;
    procedure invalidateAxes; overload;
    procedure invalidateAxes(ownerContext: Variant); overload;
    procedure invalidateAxes(ownerContext: Variant; horz: Variant); overload;
    procedure invalidateAxes(ownerContext: Variant; horz: Variant; vert: Variant); overload;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
    procedure renderItems(items: Variant; target: Variant); overload;
  end;

//Ext.layout.component

type
  JIAbstractDock = class external(JExt.layout.component.IComponent)
    procedure afterRemove; overload;
    procedure afterRemove(item: Variant); overload;
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: JExt.IComponent); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(order: String): array of JExt.IComponent; overload;
    function getDockedItems(order: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    function getLayoutItems: array of Variant;
    procedure invalidateAxes; overload;
    procedure invalidateAxes(ownerContext: Variant); overload;
    procedure invalidateAxes(ownerContext: Variant; horz: Variant); overload;
    procedure invalidateAxes(ownerContext: Variant; horz: Variant; vert: Variant); overload;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
    procedure renderItems(items: Variant; target: Variant); overload;
  end;

//Ext.layout.component

type
  JIDraw = class external(JExt.layout.component.IAuto)
    setHeightInDom: Boolean; // nullable
    setWidthInDom: Boolean; // nullable
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
  end;

//Ext.layout.component.field

type
  JIComboBox = class external(JExt.layout.component.field.ITrigger)
  end;

//Ext.layout.component.field

type
  JField = class external 'Field'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure destroyTip;
    function getName: String;
    procedure implement;
    procedure initTip;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIField = class external(JExt.layout.component.IAuto)
    elementId: Variant; // nullable
    errorStrategies: Variant; // nullable
    labelStrategies: Variant; // nullable
    left: Variant; // nullable
    qtip: Variant; // nullable
    right: Variant; // nullable
    side: Variant; // nullable
    title: Variant; // nullable
    top: Variant; // nullable
    under: Variant; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    procedure getErrorStrategy;
    procedure getLabelStrategy;
  end;

//Ext.layout.component.field

type
  JIFieldContainer = class external(JExt.layout.component.field.IField)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
  end;

//Ext.layout.component.field

type
  JIHtmlEditor = class external(JExt.layout.component.field.IFieldContainer)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure finishedLayout;
  end;

//Ext.layout.component.field

type
  JISlider = class external(JExt.layout.component.field.IField)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
  end;

//Ext.layout.component.field

type
  JIText = class external(JExt.layout.component.field.IField)
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
  end;

//Ext.layout.component.field

type
  JITextArea = class external(JExt.layout.component.field.IText)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
  end;

//Ext.layout.component.field

type
  JITrigger = class external(JExt.layout.component.field.IField)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
  end;

//Ext.layout.component

type
  JIFieldSet = class external(JExt.layout.component.IBody)
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    procedure getLayoutItems;
  end;

//Ext.layout.component

type
  JIProgressBar = class external(JExt.layout.component.IAuto)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
  end;

//Ext.layout.container

type
  JIAbsolute = class external(JExt.layout.container.IAnchor)
    ignoreOnContentChange: Boolean; // nullable
    itemCls: String; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    function onContentChange: Boolean;
  end;

//Ext.layout

type
  JIAbsoluteLayout = class external(JExt.layout.container.IAnchor)
    ignoreOnContentChange: Boolean; // nullable
    itemCls: String; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    function onContentChange: Boolean;
  end;

//Ext.layout.container

type
  JIAccordion = class external(JExt.layout.container.IVBox)
    activeOnTop: Boolean; // nullable
    align: String; // nullable
    animate: Boolean; // nullable
    autoWidth: Boolean; // nullable
    collapseFirst: Boolean; // nullable
    fill: Boolean; // nullable
    hideCollapseTool: Boolean; // nullable
    itemCls: String; // nullable
    multi: Boolean; // nullable
    titleCollapse: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
    procedure renderItems(items: Variant; target: Variant); overload;
  end;

//Ext.layout

type
  JIAccordionLayout = class external(JExt.layout.container.IVBox)
    activeOnTop: Boolean; // nullable
    align: String; // nullable
    animate: Boolean; // nullable
    autoWidth: Boolean; // nullable
    collapseFirst: Boolean; // nullable
    fill: Boolean; // nullable
    hideCollapseTool: Boolean; // nullable
    itemCls: String; // nullable
    multi: Boolean; // nullable
    titleCollapse: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
    procedure renderItems(items: Variant; target: Variant); overload;
  end;

//Ext.layout.container

type
  JIAnchor = class external(JExt.layout.container.IAuto)
    anchor: String; // nullable
    defaultAnchor: String; // nullable
    manageOverflow: Boolean; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
  end;

//Ext.layout

type
  JIAnchorLayout = class external(JExt.layout.container.IAuto)
    anchor: String; // nullable
    defaultAnchor: String; // nullable
    manageOverflow: Boolean; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
  end;

//Ext.layout.container

type
  JIAuto = class external(JExt.layout.container.IContainer)
    reserveScrollbar: Boolean; // nullable
    manageOverflow: Boolean; // nullable
    managePadding: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure calculateOverflow; overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getContainerSize: Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean): Variant; overload;
    function getElementTarget: JExt.IElement;
    function getOverflowXStyle: String; overload;
    function getOverflowXStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getOverflowYStyle: String; overload;
    function getOverflowYStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getRenderTarget: JExt.IElement;
    procedure initLayout;
    procedure setCtSizeIfNeeded; overload;
    procedure setCtSizeIfNeeded(ownerContext: JExt.layout.IContextItem); overload;
    procedure setCtSizeIfNeeded(ownerContext: JExt.layout.IContextItem; containerSize: Variant); overload;
  end;

//Ext.layout.container

type
  JIBorder = class external(JExt.layout.container.IContainer)
    itemCls: String; // nullable
    padding: Variant; // nullable
    regionWeights: Variant; // nullable
    split: Boolean; // nullable
    splitterResize: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getLayoutItems: array of JExt.IComponent;
  end;

//Ext.layout

type
  JIBorderLayout = class external(JExt.layout.container.IContainer)
    itemCls: String; // nullable
    padding: Variant; // nullable
    regionWeights: Variant; // nullable
    split: Boolean; // nullable
    splitterResize: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getLayoutItems: array of JExt.IComponent;
  end;

//Ext.layout.container

type
  JIBox = class external(JExt.layout.container.IContainer)
    defaultMargins: Variant; // nullable
    flex: Float; // nullable
    itemCls: String; // nullable
    pack: String; // nullable
    padding: String; // nullable
    stretchMaxPartner: Variant; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure cacheFlexes; overload;
    procedure cacheFlexes(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getElementTarget: JExt.IElement;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    function getRenderTarget: JExt.IElement;
  end;

//Ext.layout

type
  JIBoxLayout = class external(JExt.layout.container.IContainer)
    defaultMargins: Variant; // nullable
    flex: Float; // nullable
    itemCls: String; // nullable
    pack: String; // nullable
    padding: String; // nullable
    stretchMaxPartner: Variant; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure cacheFlexes; overload;
    procedure cacheFlexes(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: Variant); overload;
    function getElementTarget: JExt.IElement;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    function getRenderTarget: JExt.IElement;
  end;

//Ext.layout.container.boxoverflow

type
  JIMenu = class external(JExt.layout.container.boxoverflow.INone)
    triggerButtonCls: String; // nullable
    menuItems: array of Variant; // nullable
    noItemsMenuText: String; // nullable
  end;

//Ext.layout.boxoverflow

type
  JIMenu = class external(JExt.layout.container.boxoverflow.INone)
    triggerButtonCls: String; // nullable
    menuItems: array of Variant; // nullable
    noItemsMenuText: String; // nullable
  end;

//Ext.layout.container.boxoverflow

type
  JINone = class external(JExt.IBase)
  end;

//Ext.layout.boxoverflow

type
  JINone = class external(JExt.IBase)
  end;

//Ext.layout.container.boxoverflow

type
  JIScroller = class external(JExt.layout.container.boxoverflow.INone, JExt.util.IObservable)
    afterCtCls: String; // nullable
    afterScrollerCls: String; // nullable
    animateScroll: Boolean; // nullable
    beforeCtCls: String; // nullable
    beforeScrollerCls: String; // nullable
    scrollDuration: Float; // nullable
    scrollIncrement: Float; // nullable
    scrollRepeatInterval: Float; // nullable
    scrollerCls: String; // nullable
    wheelIncrement: Float; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getScrollPosition: Float;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure scrollToItem; overload;
    procedure scrollToItem(item: Variant); overload;
    procedure scrollToItem(item: Variant; animate: Boolean); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.layout.boxoverflow

type
  JIScroller = class external(JExt.layout.container.boxoverflow.INone, JExt.util.IObservable)
    afterCtCls: String; // nullable
    afterScrollerCls: String; // nullable
    animateScroll: Boolean; // nullable
    beforeCtCls: String; // nullable
    beforeScrollerCls: String; // nullable
    scrollDuration: Float; // nullable
    scrollIncrement: Float; // nullable
    scrollRepeatInterval: Float; // nullable
    scrollerCls: String; // nullable
    wheelIncrement: Float; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getScrollPosition: Float;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure scrollToItem; overload;
    procedure scrollToItem(item: Variant); overload;
    procedure scrollToItem(item: Variant; animate: Boolean); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.layout.container

type
  JICard = class external(JExt.layout.container.IFit)
    deferredRender: Boolean; // nullable
    function getActiveItem: JExt.IComponent;
    function getNext: JExt.IComponent;
    function getPrev: JExt.IComponent;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; position: Variant); overload;
    function next: JExt.IComponent;
    function prev: JExt.IComponent;
    function setActiveItem: JExt.IComponent; overload;
    function setActiveItem(newCard: Variant): JExt.IComponent; overload;
  end;

//Ext.layout

type
  JICardLayout = class external(JExt.layout.container.IFit)
    deferredRender: Boolean; // nullable
    function getActiveItem: JExt.IComponent;
    function getNext: JExt.IComponent;
    function getPrev: JExt.IComponent;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; position: Variant); overload;
    function next: JExt.IComponent;
    function prev: JExt.IComponent;
    function setActiveItem: JExt.IComponent; overload;
    function setActiveItem(newCard: Variant): JExt.IComponent; overload;
  end;

//Ext.layout.container

type
  JICheckboxGroup = class external(JExt.layout.container.IContainer)
    autoFlex: Boolean; // nullable
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    procedure initLayout;
    procedure isValidParent;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
  end;

//Ext.layout.container

type
  JIColumn = class external(JExt.layout.container.IAuto)
    itemCls: String; // nullable
    manageOverflow: Boolean; // nullable
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    procedure setCtSizeIfNeeded; overload;
    procedure setCtSizeIfNeeded(ownerContext: Variant); overload;
    procedure setCtSizeIfNeeded(ownerContext: Variant; containerSize: Variant); overload;
  end;

//Ext.layout

type
  JIColumnLayout = class external(JExt.layout.container.IAuto)
    itemCls: String; // nullable
    manageOverflow: Boolean; // nullable
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
    procedure setCtSizeIfNeeded; overload;
    procedure setCtSizeIfNeeded(ownerContext: Variant); overload;
    procedure setCtSizeIfNeeded(ownerContext: Variant; containerSize: Variant); overload;
  end;

//Ext.layout.container

type
  JIContainer = class external(JExt.layout.ILayout, JExt.util.IElementContainer)
    itemCls: String; // nullable
    overflowPadderEl: JExt.IElement; // nullable
    procedure addChildEls;
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    function getContainerSize: Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean): Variant; overload;
    function getElementTarget: JExt.IElement;
    function getLayoutItems: array of JExt.IComponent;
    function getRenderTarget: JExt.IElement;
    function getRenderedItems: array of Variant;
    function getTarget: JExt.IElement;
    function getVisibleItems: array of Variant;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
  end;

//Ext.layout

type
  JIContainerLayout = class external(JExt.layout.ILayout, JExt.util.IElementContainer)
    itemCls: String; // nullable
    overflowPadderEl: JExt.IElement; // nullable
    procedure addChildEls;
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure configureItem; overload;
    procedure configureItem(item: Variant); overload;
    function getContainerSize: Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean): Variant; overload;
    function getElementTarget: JExt.IElement;
    function getLayoutItems: array of JExt.IComponent;
    function getRenderTarget: JExt.IElement;
    function getRenderedItems: array of Variant;
    function getTarget: JExt.IElement;
    function getVisibleItems: array of Variant;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
  end;

//Ext.layout.container

type
  JIEditor = class external(JExt.layout.container.IContainer)
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
  end;

//Ext.layout.container

type
  JIFit = class external(JExt.layout.container.IContainer)
    defaultMargins: Variant; // nullable
    itemCls: String; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
  end;

//Ext.layout

type
  JIFitLayout = class external(JExt.layout.container.IContainer)
    defaultMargins: Variant; // nullable
    itemCls: String; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant; ownerSizeModel: Variant): JExt.layout.ISizePolicy; overload;
  end;

//Ext.layout.container

type
  JIForm = class external(JExt.layout.container.IContainer)
    getScrollRangeFlags: Variant; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure calculateOverflow; overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem); overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem; containerSize: Variant); overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem; containerSize: Variant; dimensions: Float); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure doRenderPadder; overload;
    procedure doRenderPadder(out: Variant); overload;
    procedure doRenderPadder(out: Variant; renderData: Variant); overload;
    function getContainerSize: Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean; ignoreOverflow: Boolean): Variant; overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getOverflowXStyle: String; overload;
    function getOverflowXStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getOverflowYStyle: String; overload;
    function getOverflowYStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getRenderTarget: JExt.IElement;
    procedure initLayout;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; position: Variant); overload;
  end;

//Ext.layout

type
  JIFormLayout = class external(JExt.layout.container.IContainer)
    getScrollRangeFlags: Variant; // nullable
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: Variant); overload;
    procedure beginLayoutCycle(ownerContext: Variant; firstCycle: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure calculateOverflow; overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem); overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem; containerSize: Variant); overload;
    procedure calculateOverflow(ownerContext: JExt.layout.IContextItem; containerSize: Variant; dimensions: Float); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: Variant); overload;
    procedure doRenderPadder; overload;
    procedure doRenderPadder(out: Variant); overload;
    procedure doRenderPadder(out: Variant; renderData: Variant); overload;
    function getContainerSize: Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean): Variant; overload;
    function getContainerSize(ownerContext: JExt.layout.IContextItem; inDom: Boolean; ignoreOverflow: Boolean): Variant; overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: Variant): JExt.layout.ISizePolicy; overload;
    function getOverflowXStyle: String; overload;
    function getOverflowXStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getOverflowYStyle: String; overload;
    function getOverflowYStyle(ownerContext: JExt.layout.IContextItem): String; overload;
    function getRenderTarget: JExt.IElement;
    procedure initLayout;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; position: Variant); overload;
  end;

//Ext.layout.container

type
  JIHBox = class external(JExt.layout.container.IBox)
    align: String; // nullable
    alignRoundingMethod: Variant; // nullable
    constrainAlign: Boolean; // nullable
  end;

//Ext.layout

type
  JIHBoxLayout = class external(JExt.layout.container.IBox)
    align: String; // nullable
    alignRoundingMethod: Variant; // nullable
    constrainAlign: Boolean; // nullable
  end;

//Ext.layout.container

type
  JITable = class external(JExt.layout.container.IContainer)
    columns: Float; // nullable
    tableAttrs: Variant; // nullable
    tdAttrs: Variant; // nullable
    trAttrs: Variant; // nullable
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure finalizeLayout;
    function getLayoutItems: array of JExt.IComponent;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; rowIdx: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; rowIdx: Variant; cellIdx: Variant); overload;
  end;

//Ext.layout

type
  JITableLayout = class external(JExt.layout.container.IContainer)
    columns: Float; // nullable
    tableAttrs: Variant; // nullable
    tdAttrs: Variant; // nullable
    trAttrs: Variant; // nullable
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure finalizeLayout;
    function getLayoutItems: array of JExt.IComponent;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; rowIdx: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; rowIdx: Variant; cellIdx: Variant); overload;
  end;

//Ext.layout.container

type
  JIVBox = class external(JExt.layout.container.IBox)
    align: String; // nullable
    alignRoundingMethod: Variant; // nullable
    constrainAlign: Boolean; // nullable
  end;

//Ext.layout

type
  JIVBoxLayout = class external(JExt.layout.container.IBox)
    align: String; // nullable
    alignRoundingMethod: Variant; // nullable
    constrainAlign: Boolean; // nullable
  end;

//Ext.layout

type
  JIContext = class external(JExt.IBase)
    layoutQueue: JExt.util.IQueue; // nullable
    state: Float; // nullable
    procedure flush;
    procedure getCmp; overload;
    procedure getCmp(cmp: JExt.IComponent); overload;
    procedure getEl; overload;
    procedure getEl(parent: JExt.layout.IContextItem); overload;
    procedure getEl(parent: JExt.layout.IContextItem; el: JExt.dom.IElement); overload;
    procedure invalidate; overload;
    procedure invalidate(components: Variant); overload;
    procedure invalidate(components: Variant; full: Boolean); overload;
    procedure removeEl; overload;
    procedure removeEl(parent: JExt.layout.IContextItem); overload;
    procedure removeEl(parent: JExt.layout.IContextItem; el: JExt.dom.IElement); overload;
    procedure resetLayout; overload;
    procedure resetLayout(layout: Variant); overload;
    procedure resetLayout(layout: Variant; ownerContext: Variant); overload;
    procedure resetLayout(layout: Variant; ownerContext: Variant; firstTime: Variant); overload;
    function run: Boolean;
    function runCycle: Boolean;
    procedure setItemSize; overload;
    procedure setItemSize(items: Variant); overload;
    procedure setItemSize(items: Variant; width: Float); overload;
    procedure setItemSize(items: Variant; width: Float; height: Float); overload;
  end;

//Ext.layout

type
  JIContextItem = class external(JExt.IBase)
    state: Variant; // nullable
    wrapsComponent: Boolean; // nullable
    procedure addCls; overload;
    procedure addCls(newCls: Variant); overload;
    procedure block; overload;
    procedure block(layout: JExt.layout.ILayout); overload;
    procedure block(layout: JExt.layout.ILayout; propName: String); overload;
    procedure clearMarginCache;
    procedure domBlock; overload;
    procedure domBlock(layout: JExt.layout.ILayout); overload;
    procedure domBlock(layout: JExt.layout.ILayout; propName: String); overload;
    procedure flush;
    function getBorderInfo: Variant;
    procedure getClassList;
    function getDomProp: Variant; overload;
    function getDomProp(propName: String): Variant; overload;
    function getEl: JExt.layout.IContextItem; overload;
    function getEl(nameOrEl: Variant): JExt.layout.IContextItem; overload;
    function getEl(nameOrEl: Variant; owner: Variant): JExt.layout.IContextItem; overload;
    function getFrameInfo: Variant;
    function getMarginInfo: Variant;
    function getPaddingInfo: Variant;
    function getProp: Variant; overload;
    function getProp(propName: String): Variant; overload;
    function getStyle: Variant; overload;
    function getStyle(styleName: String): Variant; overload;
    function getStyles: Variant; overload;
    function getStyles(styleNames: array of String): Variant; overload;
    function getStyles(styleNames: array of String; altNames: array of String): Variant; overload;
    function hasDomProp: Boolean; overload;
    function hasDomProp(propName: String): Boolean; overload;
    function hasProp: Boolean; overload;
    function hasProp(propName: String): Boolean; overload;
    procedure invalidate; overload;
    procedure invalidate(options: Variant); overload;
    procedure recoverProp; overload;
    procedure recoverProp(propName: String); overload;
    procedure recoverProp(propName: String; oldProps: Variant); overload;
    procedure recoverProp(propName: String; oldProps: Variant; oldDirty: Variant); overload;
    procedure removeCls; overload;
    procedure removeCls(removeCls: Variant); overload;
    procedure removeEl; overload;
    procedure removeEl(nameOrEl: Variant); overload;
    procedure removeEl(nameOrEl: Variant; owner: Variant); overload;
    procedure setAttribute; overload;
    procedure setAttribute(name: Variant); overload;
    procedure setAttribute(name: Variant; value: Variant); overload;
    procedure setContentHeight; overload;
    procedure setContentHeight(height: Variant); overload;
    procedure setContentHeight(height: Variant; measured: Variant); overload;
    procedure setContentSize; overload;
    procedure setContentSize(width: Variant); overload;
    procedure setContentSize(width: Variant; height: Variant); overload;
    procedure setContentSize(width: Variant; height: Variant; measured: Variant); overload;
    procedure setContentWidth; overload;
    procedure setContentWidth(width: Variant); overload;
    procedure setContentWidth(width: Variant; measured: Variant); overload;
    function setHeight: Float; overload;
    function setHeight(height: Float): Float; overload;
    function setHeight(height: Float; dirty: Boolean): Float; overload;
    function setProp: Float; overload;
    function setProp(propName: String): Float; overload;
    function setProp(propName: String; value: Variant): Float; overload;
    function setProp(propName: String; value: Variant; dirty: Boolean): Float; overload;
    function setWidth: Float; overload;
    function setWidth(width: Float): Float; overload;
    function setWidth(width: Float; dirty: Boolean): Float; overload;
  end;

//Ext.layout

type
  JILayout = class external(JExt.IBase)
    done: Boolean; // nullable
    isLayout: Boolean; // nullable
    procedure afterRemove; overload;
    procedure afterRemove(item: Variant); overload;
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: JExt.layout.IContextItem); overload;
    procedure beginLayoutCycle; overload;
    procedure beginLayoutCycle(ownerContext: JExt.layout.IContextItem); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: JExt.layout.IContextItem); overload;
    procedure completeLayout; overload;
    procedure completeLayout(ownerContext: JExt.layout.IContextItem); overload;
    procedure configureItem; overload;
    procedure configureItem(item: JExt.IComponent); overload;
    procedure destroy;
    procedure finalizeLayout; overload;
    procedure finalizeLayout(ownerContext: JExt.layout.IContextItem); overload;
    procedure finishedLayout; overload;
    procedure finishedLayout(ownerContext: JExt.layout.IContextItem); overload;
    function getItemSizePolicy: JExt.layout.ISizePolicy; overload;
    function getItemSizePolicy(item: JExt.IComponent): JExt.layout.ISizePolicy; overload;
    procedure getLayoutItems;
    procedure initLayout;
    procedure isValidParent; overload;
    procedure isValidParent(item: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant); overload;
    procedure isValidParent(item: Variant; target: Variant; position: Variant); overload;
    procedure notifyOwner; overload;
    procedure notifyOwner(ownerContext: JExt.layout.IContextItem); overload;
    function onContentChange: Boolean; overload;
    function onContentChange(child: JExt.IComponent): Boolean; overload;
    procedure renderItems; overload;
    procedure renderItems(items: Variant); overload;
    procedure renderItems(items: Variant; target: Variant); overload;
  end;

//Ext.layout

type
  JISizeModel = class external(JExt.IBase)
    auto: Boolean; // nullable
    calculated: Boolean; // nullable
    calculatedFromConfigured: Boolean; // nullable
    calculatedFromNatural: Boolean; // nullable
    calculatedFromShrinkWrap: Boolean; // nullable
    configured: Boolean; // nullable
    constrainedMax: Boolean; // nullable
    constrainedMin: Boolean; // nullable
    fixed: Boolean; // nullable
    name: String; // nullable
    names: Variant; // nullable
    natural: Boolean; // nullable
    ordinal: Float; // nullable
    pairsByHeightOrdinal: array of Variant; // nullable
    shrinkWrap: Boolean; // nullable
  end;

//Ext.layout

type
  JISizePolicy = class external
    readsHeight: Boolean; // nullable
    readsWidth: Boolean; // nullable
    setsHeight: Boolean; // nullable
    setsWidth: Boolean; // nullable
  end;

//Ext

type
  JLoader = class external 'Loader'
    disableCaching: Boolean;
    disableCachingParam: String;
    enabled: Boolean;
    garbageCollect: Boolean;
    paths: Variant;
    preserveScripts: Boolean;
    scriptChainDelay: Boolean;
    scriptCharset: String;
    history: array of Variant;
    function addClassPathMappings: JExt.ILoader; overload;
    function addClassPathMappings(paths: JObject): JExt.ILoader; overload;
    function exclude: Variant; overload;
    function exclude(excludes: array of Variant): Variant; overload;
    function getConfig: Variant; overload;
    function getConfig(name: String): Variant; overload;
    function getPath: String; overload;
    function getPath(className: String): String; overload;
    procedure loadScript; overload;
    procedure loadScript(options: Variant); overload;
    procedure onReady; overload;
    procedure onReady(fn: Variant); overload;
    procedure onReady(fn: Variant; scope: Variant); overload;
    procedure onReady(fn: Variant; scope: Variant; withDomReady: Boolean); overload;
    procedure require; overload;
    procedure require(expressions: Variant); overload;
    procedure require(expressions: Variant; fn: Variant); overload;
    procedure require(expressions: Variant; fn: Variant; scope: Variant); overload;
    procedure require(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
    function setConfig: JExt.ILoader; overload;
    function setConfig(config: Variant): JExt.ILoader; overload;
    function setPath: JExt.ILoader; overload;
    function setPath(name: Variant): JExt.ILoader; overload;
    function setPath(name: Variant; path: String): JExt.ILoader; overload;
    procedure syncRequire; overload;
    procedure syncRequire(expressions: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
  end;

  JILoader = class external
  end;

//Ext

type
  JILoadMask = class external(JExt.IComponent, JExt.util.IFloating, JExt.util.IBindable)
    baseCls: String; // nullable
    maskCls: String; // nullable
    msg: String; // nullable
    msgCls: String; // nullable
    renderTpl: Variant; // nullable
    store: JExt.data.IStore; // nullable
    target: JExt.IComponent; // nullable
    useMsg: Boolean; // nullable
    useTargetEl: Boolean; // nullable
    procedure afterRender;
    procedure afterShow;
    procedure bindStore; overload;
    procedure bindStore(store: JExt.data.IStore); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    function center: JExt.IComponent;
    procedure doConstrain; overload;
    procedure doConstrain(constrainTo: Variant); overload;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant; overload;
    function getStoreListeners(store: Variant): Variant; overload;
    function hide: JExt.IComponent;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onDestroy;
    procedure onDisable;
    procedure onHide;
    procedure onShow;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActive(active: Boolean; newActive: JExt.IComponent); overload;
    function show: JExt.IComponent;
    function toBack: JExt.IComponent;
    function toFront: JExt.IComponent; overload;
    function toFront(preventFocus: Boolean): JExt.IComponent; overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.menu

type
  JICheckItem = class external(JExt.menu.IItem)
    checkChangeDisabled: Boolean; // nullable
    checkHandler: Variant; // nullable
    checked: Boolean; // nullable
    checkedCls: String; // nullable
    group: String; // nullable
    groupCls: String; // nullable
    hideOnClick: Boolean; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    uncheckedCls: String; // nullable
    procedure afterRender;
    procedure disableCheckChange;
    procedure enableCheckChange;
    procedure initComponent;
    procedure onDestroy;
    procedure setChecked; overload;
    procedure setChecked(checked: Boolean); overload;
    procedure setChecked(checked: Boolean; suppressEvents: Boolean); overload;
  end;

//Ext.menu

type
  JIColorPicker = class external(JExt.menu.IMenu)
    hideOnClick: Boolean; // nullable
    pickerId: String; // nullable
    picker: JExt.picker.IColor; // nullable
  end;

//Ext.menu

type
  JIDatePicker = class external(JExt.menu.IMenu)
    hideOnClick: Boolean; // nullable
    pickerId: String; // nullable
    picker: JExt.picker.IDate; // nullable
  end;

//Ext.menu

type
  JIItem = class external(JExt.IComponent, JExt.IQueryable)
    activeCls: String; // nullable
    canActivate: Boolean; // nullable
    clickHideDelay: Float; // nullable
    destroyMenu: Boolean; // nullable
    disabledCls: String; // nullable
    glyph: Variant; // nullable
    handler: Variant; // nullable
    hideOnClick: Boolean; // nullable
    href: String; // nullable
    hrefTarget: String; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    menu: Variant; // nullable
    menuAlign: String; // nullable
    menuExpandDelay: Float; // nullable
    menuHideDelay: Float; // nullable
    plain: Boolean; // nullable
    renderTpl: Variant; // nullable
    text: String; // nullable
    tooltip: Variant; // nullable
    tooltipType: String; // nullable
    activated: Boolean; // nullable
    maskOnDisable: Boolean; // nullable
    parentMenu: JExt.menu.IMenu; // nullable
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure initComponent;
    procedure onDestroy;
    procedure onRemoved;
    procedure onRender;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure setHandler; overload;
    procedure setHandler(fn: Variant); overload;
    procedure setHandler(fn: Variant; scope: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(iconCls: String); overload;
    procedure setMenu; overload;
    procedure setMenu(menu: Variant); overload;
    procedure setMenu(menu: Variant; destroyMenu: Boolean); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    function setTooltip: JExt.menu.IItem; overload;
    function setTooltip(tooltip: Variant): JExt.menu.IItem; overload;
  end;

//Ext.menu

type
  JITextItem = class external(JExt.IComponent, JExt.IQueryable)
    activeCls: String; // nullable
    canActivate: Boolean; // nullable
    clickHideDelay: Float; // nullable
    destroyMenu: Boolean; // nullable
    disabledCls: String; // nullable
    glyph: Variant; // nullable
    handler: Variant; // nullable
    hideOnClick: Boolean; // nullable
    href: String; // nullable
    hrefTarget: String; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    menu: Variant; // nullable
    menuAlign: String; // nullable
    menuExpandDelay: Float; // nullable
    menuHideDelay: Float; // nullable
    plain: Boolean; // nullable
    renderTpl: Variant; // nullable
    text: String; // nullable
    tooltip: Variant; // nullable
    tooltipType: String; // nullable
    activated: Boolean; // nullable
    maskOnDisable: Boolean; // nullable
    parentMenu: JExt.menu.IMenu; // nullable
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure initComponent;
    procedure onDestroy;
    procedure onRemoved;
    procedure onRender;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure setHandler; overload;
    procedure setHandler(fn: Variant); overload;
    procedure setHandler(fn: Variant; scope: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(iconCls: String); overload;
    procedure setMenu; overload;
    procedure setMenu(menu: Variant); overload;
    procedure setMenu(menu: Variant; destroyMenu: Boolean); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    function setTooltip: JExt.menu.IItem; overload;
    function setTooltip(tooltip: Variant): JExt.menu.IItem; overload;
  end;

//Ext.menu

type
  JIKeyNav = class external(JExt.util.IKeyNav)
  end;

//Ext.menu

type
  JManager = class external 'Manager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function get: JExt.menu.IMenu; overload;
    function get(menu: Variant): JExt.menu.IMenu; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function hideAll: Boolean;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIManager = class external(JExt.IBase)
  end;

//Ext.menu

type
  JMenuMgr = class external 'MenuMgr'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function get: JExt.menu.IMenu; overload;
    function get(menu: Variant): JExt.menu.IMenu; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function hideAll: Boolean;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIMenuMgr = class external(JExt.IBase)
  end;

//Ext.menu

type
  JIMenu = class external(JExt.panel.IPanel)
    allowOtherMenus: Boolean; // nullable
    enableKeyNav: Boolean; // nullable
    floating: Boolean; // nullable
    hidden: Boolean; // nullable
    hideMode: String; // nullable
    ignoreParentClicks: Boolean; // nullable
    minWidth: Float; // nullable
    plain: Boolean; // nullable
    showSeparator: Boolean; // nullable
    isMenu: Boolean; // nullable
    parentMenu: JExt.menu.IMenu; // nullable
    procedure afterShow;
    procedure beforeShow;
    function canActivateItem: Boolean; overload;
    function canActivateItem(item: Variant): Boolean; overload;
    procedure deactivateActiveItem; overload;
    procedure deactivateActiveItem(andBlurFocusedItem: Variant); overload;
    function hide: JExt.IComponent;
    function isVisible: Boolean;
    procedure onDestroy;
    function showBy: JExt.IComponent; overload;
    function showBy(cmp: Variant): JExt.IComponent; overload;
    function showBy(cmp: Variant; pos: Variant): JExt.IComponent; overload;
    function showBy(cmp: Variant; pos: Variant; off: Variant): JExt.IComponent; overload;
  end;

//Ext.menu

type
  JISeparator = class external(JExt.menu.IItem)
    separatorCls: String; // nullable
  end;

//Ext

type
  JMessageBox = class external 'MessageBox'
    CANCEL: Float;
    ERROR: String;
    INFO: String;
    NO: Float;
    OK: Float;
    OKCANCEL: Float;
    QUESTION: String;
    WARNING: String;
    YES: Float;
    YESNO: Float;
    YESNOCANCEL: Float;
    _isLayoutRoot: Boolean;
    body: JExt.dom.IElement;
    buttonText: Variant;
    contentPaddingProperty: String;
    dd: JExt.util.IComponentDragger;
    defaultTextHeight: Float;
    draggable: Boolean;
    floatParent: JExt.IContainer;
    frameSize: Variant;
    hasListeners: Variant;
    isComponent: Boolean;
    isObservable: Boolean;
    isPanel: Boolean;
    isWindow: Boolean;
    items: JExt.util.IAbstractMixedCollection;
    maskOnDisable: Boolean;
    minProgressWidth: Float;
    minPromptWidth: Float;
    ownerCt: JExt.IContainer;
    rendered: Boolean;
    scrollFlags: Variant;
    self: JExt.IClass;
    zIndexManager: JExt.IZIndexManager;
    zIndexParent: JExt.IContainer;
    function add: Variant; overload;
    function add(component: Variant): Variant; overload;
    function addBodyCls: JExt.panel.IPanel; overload;
    function addBodyCls(cls: String): JExt.panel.IPanel; overload;
    procedure addChildEls;
    function addClass: JExt.IComponent; overload;
    function addClass(cls: Variant): JExt.IComponent; overload;
    function addCls: JExt.IComponent; overload;
    function addCls(cls: Variant): JExt.IComponent; overload;
    procedure addClsWithUI; overload;
    procedure addClsWithUI(classes: Variant); overload;
    procedure addClsWithUI(classes: Variant; skip: Variant); overload;
    function addDocked: array of JExt.IComponent; overload;
    function addDocked(component: Variant): array of JExt.IComponent; overload;
    function addDocked(component: Variant; pos: Float): array of JExt.IComponent; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(element: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addPropertyToState: Boolean; overload;
    function addPropertyToState(state: Variant): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String; value: String): Boolean; overload;
    procedure addStateEvents; overload;
    procedure addStateEvents(events: Variant); overload;
    procedure addTool; overload;
    procedure addTool(tools: Variant); overload;
    procedure addUIClsToElement; overload;
    procedure addUIClsToElement(cls: Variant); overload;
    procedure afterCollapse;
    procedure afterComponentLayout;
    procedure afterExpand;
    procedure afterLayout; overload;
    procedure afterLayout(layout: JExt.layout.container.IContainer); overload;
    procedure afterSetPosition; overload;
    procedure afterSetPosition(ax: Variant); overload;
    procedure afterSetPosition(ax: Variant; ay: Variant); overload;
    procedure afterShow; overload;
    procedure afterShow(animateTarget: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant; scope: Variant); overload;
    function alert: JExt.window.IMessageBox; overload;
    function alert(title: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function alignTo: JExt.util.IPositionable; overload;
    function alignTo(element: Variant): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo: JExt.util.IPositionable; overload;
    function anchorTo(element: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant; callback: Variant): JExt.util.IPositionable; overload;
    function animate: Variant; overload;
    function animate(animObj: Variant): Variant; overload;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure beforeBlur; overload;
    procedure beforeBlur(e: JExt.IEventObject); overload;
    procedure beforeComponentLayout; overload;
    procedure beforeComponentLayout(adjWidth: Float); overload;
    procedure beforeComponentLayout(adjWidth: Float; adjHeight: Float); overload;
    procedure beforeFocus; overload;
    procedure beforeFocus(e: JExt.IEventObject); overload;
    procedure beforeLayout;
    procedure beforeShow;
    function bubble: JExt.IComponent; overload;
    function bubble(fn: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant; args: array of Variant): JExt.IComponent; overload;
    function calculateConstrainedPosition: array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean; proposedSize: array of Float): array of Float; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure cancelFocus;
    function cascade: JExt.IContainer; overload;
    function cascade(fn: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant; args: array of Variant): JExt.IContainer; overload;
    function center: JExt.IComponent;
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    function cloneConfig: JExt.IComponent; overload;
    function cloneConfig(overrides: Variant): JExt.IComponent; overload;
    procedure close;
    function collapse: JExt.panel.IPanel; overload;
    function collapse(direction: String): JExt.panel.IPanel; overload;
    function collapse(direction: String; animate: Boolean): JExt.panel.IPanel; overload;
    function confirm: JExt.window.IMessageBox; overload;
    function confirm(title: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function contains: Boolean; overload;
    function contains(comp: JExt.IComponent): Boolean; overload;
    function contains(comp: JExt.IComponent; deep: Boolean): Boolean; overload;
    procedure convertCollapseDir; overload;
    procedure convertCollapseDir(collapseDir: Variant); overload;
    function disable: JExt.container.IAbstractContainer;
    procedure doAutoRender;
    function doComponentLayout: JExt.container.IContainer;
    procedure doConstrain; overload;
    procedure doConstrain(constrainTo: Variant); overload;
    function doLayout: JExt.container.IContainer;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure ensureAttachedToBody; overload;
    procedure ensureAttachedToBody(runLayout: Boolean); overload;
    function expand: JExt.panel.IPanel; overload;
    function expand(animate: Boolean): JExt.panel.IPanel; overload;
    function findParentBy: JExt.container.IContainer; overload;
    function findParentBy(fn: Variant): JExt.container.IContainer; overload;
    function findParentByType: JExt.container.IContainer; overload;
    function findParentByType(xtype: Variant): JExt.container.IContainer; overload;
    function findPlugin: JExt.IAbstractPlugin; overload;
    function findPlugin(ptype: String): JExt.IAbstractPlugin; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Boolean): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant; scope: Variant): JExt.IComponent; overload;
    procedure forceComponentLayout;
    function getActiveAnimation: Variant;
    function getAlignToXY: array of Float; overload;
    function getAlignToXY(element: Variant): array of Float; overload;
    function getAlignToXY(element: Variant; position: String): array of Float; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Float): array of Float; overload;
    function getAnchorXY: array of Float; overload;
    function getAnchorXY(anchor: String): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Float; overload;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    procedure getBubbleTarget;
    function getChildByElement: JExt.IComponent; overload;
    function getChildByElement(el: Variant): JExt.IComponent; overload;
    function getChildByElement(el: Variant; deep: Boolean): JExt.IComponent; overload;
    function getCollapsed: Variant;
    function getComponent: JExt.IComponent; overload;
    function getComponent(comp: Variant): JExt.IComponent; overload;
    function getConstrainVector: Variant; overload;
    function getConstrainVector(constrainTo: Variant): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float; proposedSize: array of Float): Variant; overload;
    procedure getDefaultFocus;
    function getDockedComponent: JExt.IComponent; overload;
    function getDockedComponent(comp: Variant): JExt.IComponent; overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(selector: String): array of JExt.IComponent; overload;
    function getDockedItems(selector: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    function getEl: JExt.dom.IElement;
    procedure getHeader;
    function getHeight: Float;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getInsertPosition: JHTMLElement; overload;
    function getInsertPosition(position: Variant): JHTMLElement; overload;
    function getItemId: String;
    function getLayout: JExt.layout.container.IContainer;
    function getLoader: JExt.IComponentLoader;
    function getLocalX: Float;
    function getLocalXY: array of Float;
    function getLocalY: Float;
    function getOffsetsTo: array of Float; overload;
    function getOffsetsTo(offsetsTo: Variant): array of Float; overload;
    function getPlugin: JExt.IAbstractPlugin; overload;
    function getPlugin(pluginId: String): JExt.IAbstractPlugin; overload;
    function getPosition: array of Float; overload;
    function getPosition(local: Boolean): array of Float; overload;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function getRegion: JExt.util.IRegion;
    function getSize: Variant;
    function getSizeModel: Variant; overload;
    function getSizeModel(ownerCtSizeModel: Variant): Variant; overload;
    function getViewRegion: JExt.util.IRegion;
    function getWidth: Float;
    function getX: Float;
    function getXType: String;
    function getXTypes: String;
    function getXY: array of Float;
    function getY: Float;
    function hasActiveFx: Variant;
    function hasCls: Boolean; overload;
    function hasCls(className: String): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hasUICls; overload;
    procedure hasUICls(cls: String); overload;
    function hide: JExt.IComponent;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initEvents;
    function insert: JExt.IComponent; overload;
    function insert(index: Float): JExt.IComponent; overload;
    function insert(index: Float; component: Variant): JExt.IComponent; overload;
    procedure insertDocked; overload;
    procedure insertDocked(pos: Float); overload;
    procedure insertDocked(pos: Float; component: Variant); overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isAncestor; overload;
    procedure isAncestor(possibleDescendant: JExt.IComponent); overload;
    function isDescendantOf: Boolean; overload;
    function isDescendantOf(container: JExt.IContainer): Boolean; overload;
    function isDisabled: Boolean;
    function isDraggable: Boolean;
    function isDroppable: Boolean;
    function isFloating: Boolean;
    function isHidden: Boolean;
    procedure isLayoutRoot;
    function isLayoutSuspended: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Variant): Boolean; overload;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    function maximize: JExt.window.IWindow; overload;
    function maximize(animate: Boolean): JExt.window.IWindow; overload;
    function minimize: JExt.window.IWindow;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function move: JExt.IComponent; overload;
    function move(fromIdx: Variant): JExt.IComponent; overload;
    function move(fromIdx: Variant; toIdx: Float): JExt.IComponent; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function nextNode: JExt.IComponent; overload;
    function nextNode(selector: String): JExt.IComponent; overload;
    function nextSibling: JExt.IComponent; overload;
    function nextSibling(selector: String): JExt.IComponent; overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onAdd; overload;
    procedure onAdd(component: JExt.IComponent); overload;
    procedure onAdd(component: JExt.IComponent; position: Float); overload;
    procedure onAdded;
    procedure onBeforeAdd; overload;
    procedure onBeforeAdd(item: JExt.IComponent); overload;
    procedure onDestroy;
    procedure onDisable;
    procedure onDockedAdd; overload;
    procedure onDockedAdd(component: JExt.IComponent); overload;
    procedure onDockedRemove; overload;
    procedure onDockedRemove(component: JExt.IComponent); overload;
    procedure onEnable;
    procedure onHide;
    procedure onPosition;
    procedure onRemove; overload;
    procedure onRemove(component: JExt.IComponent); overload;
    procedure onRemove(component: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure onRemoved; overload;
    procedure onRemoved(destroying: Variant); overload;
    procedure onResize;
    procedure onShow;
    procedure onShowComplete; overload;
    procedure onShowComplete(callback: Variant); overload;
    procedure onShowComplete(callback: Variant; scope: Variant); overload;
    procedure postBlur; overload;
    procedure postBlur(e: JExt.IEventObject); overload;
    function previousNode: JExt.IComponent; overload;
    function previousNode(selector: String): JExt.IComponent; overload;
    function previousSibling: JExt.IComponent; overload;
    function previousSibling(selector: String): JExt.IComponent; overload;
    function progress: JExt.window.IMessageBox; overload;
    function progress(title: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String; progressText: String): JExt.window.IMessageBox; overload;
    function prompt: JExt.window.IMessageBox; overload;
    function prompt(title: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant; value: String): JExt.window.IMessageBox; overload;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure registerFloatingItem; overload;
    procedure registerFloatingItem(cmp: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: JExt.IComponent; overload;
    function remove(component: Variant): JExt.IComponent; overload;
    function remove(component: Variant; autoDestroy: Boolean): JExt.IComponent; overload;
    function removeAll: array of JExt.IComponent; overload;
    function removeAll(autoDestroy: Boolean): array of JExt.IComponent; overload;
    function removeAnchor: JExt.util.IPositionable;
    function removeBodyCls: JExt.panel.IPanel; overload;
    function removeBodyCls(cls: String): JExt.panel.IPanel; overload;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
    function removeCls: JExt.IComponent; overload;
    function removeCls(cls: Variant): JExt.IComponent; overload;
    procedure removeClsWithUI; overload;
    procedure removeClsWithUI(cls: Variant); overload;
    procedure removeDocked; overload;
    procedure removeDocked(item: JExt.IComponent); overload;
    procedure removeDocked(item: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure removeUIClsFromElement; overload;
    procedure removeUIClsFromElement(cls: Variant); overload;
    procedure render; overload;
    procedure render(container: Variant); overload;
    procedure render(container: Variant; position: Variant); overload;
    function restore: JExt.window.IWindow; overload;
    function restore(animate: Variant): JExt.window.IWindow; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function savePropToState: Boolean; overload;
    function savePropToState(propName: String): Boolean; overload;
    function savePropToState(propName: String; state: Variant): Boolean; overload;
    function savePropToState(propName: String; state: Variant; stateName: String): Boolean; overload;
    function savePropsToState: Variant; overload;
    function savePropsToState(propNames: Variant): Variant; overload;
    function savePropsToState(propNames: Variant; state: Variant): Variant; overload;
    procedure saveState;
    procedure scrollBy; overload;
    procedure scrollBy(deltaX: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant); overload;
    function sequenceFx: Variant;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActive(active: Boolean; newActive: JExt.IComponent); overload;
    function setAutoScroll: JExt.IComponent; overload;
    function setAutoScroll(scroll: Boolean): JExt.IComponent; overload;
    function setBodyStyle: JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant): JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant; value: String): JExt.panel.IPanel; overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBorder(border: Variant; targetEl: Variant); overload;
    function setBorderRegion: String; overload;
    function setBorderRegion(region: String): String; overload;
    function setBox: JExt.util.IPositionable; overload;
    function setBox(box: Variant): JExt.util.IPositionable; overload;
    function setBox(box: Variant; animate: Variant): JExt.util.IPositionable; overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    function setDocked: JExt.IComponent; overload;
    function setDocked(dock: Variant): JExt.IComponent; overload;
    function setDocked(dock: Variant; layoutParent: Boolean): JExt.IComponent; overload;
    procedure setGlyph; overload;
    procedure setGlyph(newGlyph: Variant); overload;
    function setHeight: JExt.IComponent; overload;
    function setHeight(height: Float): JExt.IComponent; overload;
    function setIcon: JExt.window.IMessageBox; overload;
    function setIcon(icon: String): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float; height: Float): JExt.window.IMessageBox; overload;
    procedure setIconCls; overload;
    procedure setIconCls(newIconCls: String); overload;
    function setLoading: JExt.ILoadMask; overload;
    function setLoading(load: Variant): JExt.ILoadMask; overload;
    function setLoading(load: Variant; targetEl: Boolean): JExt.ILoadMask; overload;
    function setLocalX: JExt.util.IPositionable; overload;
    function setLocalX(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY: JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant; y: Variant): JExt.util.IPositionable; overload;
    function setLocalY: JExt.util.IPositionable; overload;
    function setLocalY(y: Variant): JExt.util.IPositionable; overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    function setOverflowXY: JExt.IComponent; overload;
    function setOverflowXY(overflowX: String): JExt.IComponent; overload;
    function setOverflowXY(overflowX: String; overflowY: String): JExt.IComponent; overload;
    function setPagePosition: JExt.IComponent; overload;
    function setPagePosition(x: Variant): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setPosition: JExt.IComponent; overload;
    function setPosition(x: Variant): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setRegion: JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion): JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion; animate: Variant): JExt.util.IPositionable; overload;
    function setRegionWeight: Float; overload;
    function setRegionWeight(weight: Float): Float; overload;
    function setSize: JExt.IComponent; overload;
    function setSize(width: Variant): JExt.IComponent; overload;
    function setSize(width: Variant; height: Variant): JExt.IComponent; overload;
    procedure setTitle; overload;
    procedure setTitle(newTitle: String); overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    function setVisible: JExt.IComponent; overload;
    function setVisible(visible: Boolean): JExt.IComponent; overload;
    function setWidth: JExt.IComponent; overload;
    function setWidth(width: Float): JExt.IComponent; overload;
    function setX: JExt.util.IPositionable; overload;
    function setX(x: Variant): JExt.util.IPositionable; overload;
    function setX(x: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setXY: JExt.util.IPositionable; overload;
    function setXY(xy: Variant): JExt.util.IPositionable; overload;
    function setXY(xy: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setY: JExt.util.IPositionable; overload;
    function setY(y: Variant): JExt.util.IPositionable; overload;
    function setY(y: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function show: JExt.window.IMessageBox; overload;
    function show(config: Variant): JExt.window.IMessageBox; overload;
    function showAt: JExt.IComponent; overload;
    function showAt(x: Variant): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function showBy: JExt.IComponent; overload;
    function showBy(component: Variant): JExt.IComponent; overload;
    function showBy(component: Variant; position: String): JExt.IComponent; overload;
    function showBy(component: Variant; position: String; offsets: array of Float): JExt.IComponent; overload;
    function statics: JExt.IClass;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    function syncFx: Variant;
    function toBack: JExt.IComponent;
    function toFront: JExt.IComponent; overload;
    function toFront(preventFocus: Boolean): JExt.IComponent; overload;
    function toggleCollapse: JExt.panel.IPanel;
    function toggleMaximize: JExt.window.IWindow;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    function up: JExt.container.IContainer; overload;
    function up(selector: Variant): JExt.container.IContainer; overload;
    function up(selector: Variant; limit: Variant): JExt.container.IContainer; overload;
    procedure update; overload;
    procedure update(htmlOrData: Variant); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean; callback: Variant); overload;
    function updateBox: JExt.IComponent; overload;
    function updateBox(box: Variant): JExt.IComponent; overload;
    procedure updateLayout; overload;
    procedure updateLayout(options: Variant); overload;
    function updateProgress: JExt.window.IMessageBox; overload;
    function updateProgress(value: Float): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String; msg: String): JExt.window.IMessageBox; overload;
    function wait: JExt.window.IMessageBox; overload;
    function wait(msg: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String; config: Variant): JExt.window.IMessageBox; overload;
  end;

  JIMessageBox = class external(JExt.window.IMessageBox)
  end;

//Ext

type
  JMsg = class external 'Msg'
    CANCEL: Float;
    ERROR: String;
    INFO: String;
    NO: Float;
    OK: Float;
    OKCANCEL: Float;
    QUESTION: String;
    WARNING: String;
    YES: Float;
    YESNO: Float;
    YESNOCANCEL: Float;
    _isLayoutRoot: Boolean;
    body: JExt.dom.IElement;
    buttonText: Variant;
    contentPaddingProperty: String;
    dd: JExt.util.IComponentDragger;
    defaultTextHeight: Float;
    draggable: Boolean;
    floatParent: JExt.IContainer;
    frameSize: Variant;
    hasListeners: Variant;
    isComponent: Boolean;
    isObservable: Boolean;
    isPanel: Boolean;
    isWindow: Boolean;
    items: JExt.util.IAbstractMixedCollection;
    maskOnDisable: Boolean;
    minProgressWidth: Float;
    minPromptWidth: Float;
    ownerCt: JExt.IContainer;
    rendered: Boolean;
    scrollFlags: Variant;
    self: JExt.IClass;
    zIndexManager: JExt.IZIndexManager;
    zIndexParent: JExt.IContainer;
    function add: Variant; overload;
    function add(component: Variant): Variant; overload;
    function addBodyCls: JExt.panel.IPanel; overload;
    function addBodyCls(cls: String): JExt.panel.IPanel; overload;
    procedure addChildEls;
    function addClass: JExt.IComponent; overload;
    function addClass(cls: Variant): JExt.IComponent; overload;
    function addCls: JExt.IComponent; overload;
    function addCls(cls: Variant): JExt.IComponent; overload;
    procedure addClsWithUI; overload;
    procedure addClsWithUI(classes: Variant); overload;
    procedure addClsWithUI(classes: Variant; skip: Variant); overload;
    function addDocked: array of JExt.IComponent; overload;
    function addDocked(component: Variant): array of JExt.IComponent; overload;
    function addDocked(component: Variant; pos: Float): array of JExt.IComponent; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(element: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant): Variant; overload;
    function addListener(element: Variant; listeners: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addPropertyToState: Boolean; overload;
    function addPropertyToState(state: Variant): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String): Boolean; overload;
    function addPropertyToState(state: Variant; propName: String; value: String): Boolean; overload;
    procedure addStateEvents; overload;
    procedure addStateEvents(events: Variant); overload;
    procedure addTool; overload;
    procedure addTool(tools: Variant); overload;
    procedure addUIClsToElement; overload;
    procedure addUIClsToElement(cls: Variant); overload;
    procedure afterCollapse;
    procedure afterComponentLayout;
    procedure afterExpand;
    procedure afterLayout; overload;
    procedure afterLayout(layout: JExt.layout.container.IContainer); overload;
    procedure afterSetPosition; overload;
    procedure afterSetPosition(ax: Variant); overload;
    procedure afterSetPosition(ax: Variant; ay: Variant); overload;
    procedure afterShow; overload;
    procedure afterShow(animateTarget: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant); overload;
    procedure afterShow(animateTarget: Variant; callback: Variant; scope: Variant); overload;
    function alert: JExt.window.IMessageBox; overload;
    function alert(title: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function alignTo: JExt.util.IPositionable; overload;
    function alignTo(element: Variant): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo: JExt.util.IPositionable; overload;
    function anchorTo(element: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant; callback: Variant): JExt.util.IPositionable; overload;
    function animate: Variant; overload;
    function animate(animObj: Variant): Variant; overload;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure beforeBlur; overload;
    procedure beforeBlur(e: JExt.IEventObject); overload;
    procedure beforeComponentLayout; overload;
    procedure beforeComponentLayout(adjWidth: Float); overload;
    procedure beforeComponentLayout(adjWidth: Float; adjHeight: Float); overload;
    procedure beforeFocus; overload;
    procedure beforeFocus(e: JExt.IEventObject); overload;
    procedure beforeLayout;
    procedure beforeShow;
    function bubble: JExt.IComponent; overload;
    function bubble(fn: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant): JExt.IComponent; overload;
    function bubble(fn: Variant; scope: Variant; args: array of Variant): JExt.IComponent; overload;
    function calculateConstrainedPosition: array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean; proposedSize: array of Float): array of Float; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure cancelFocus;
    function cascade: JExt.IContainer; overload;
    function cascade(fn: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant): JExt.IContainer; overload;
    function cascade(fn: Variant; scope: Variant; args: array of Variant): JExt.IContainer; overload;
    function center: JExt.IComponent;
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    function cloneConfig: JExt.IComponent; overload;
    function cloneConfig(overrides: Variant): JExt.IComponent; overload;
    procedure close;
    function collapse: JExt.panel.IPanel; overload;
    function collapse(direction: String): JExt.panel.IPanel; overload;
    function collapse(direction: String; animate: Boolean): JExt.panel.IPanel; overload;
    function confirm: JExt.window.IMessageBox; overload;
    function confirm(title: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function contains: Boolean; overload;
    function contains(comp: JExt.IComponent): Boolean; overload;
    function contains(comp: JExt.IComponent; deep: Boolean): Boolean; overload;
    procedure convertCollapseDir; overload;
    procedure convertCollapseDir(collapseDir: Variant); overload;
    function disable: JExt.container.IAbstractContainer;
    procedure doAutoRender;
    function doComponentLayout: JExt.container.IContainer;
    procedure doConstrain; overload;
    procedure doConstrain(constrainTo: Variant); overload;
    function doLayout: JExt.container.IContainer;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    procedure ensureAttachedToBody; overload;
    procedure ensureAttachedToBody(runLayout: Boolean); overload;
    function expand: JExt.panel.IPanel; overload;
    function expand(animate: Boolean): JExt.panel.IPanel; overload;
    function findParentBy: JExt.container.IContainer; overload;
    function findParentBy(fn: Variant): JExt.container.IContainer; overload;
    function findParentByType: JExt.container.IContainer; overload;
    function findParentByType(xtype: Variant): JExt.container.IContainer; overload;
    function findPlugin: JExt.IAbstractPlugin; overload;
    function findPlugin(ptype: String): JExt.IAbstractPlugin; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Boolean): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant): JExt.IComponent; overload;
    function focus(selectText: Boolean; delay: Variant; callback: Variant; scope: Variant): JExt.IComponent; overload;
    procedure forceComponentLayout;
    function getActiveAnimation: Variant;
    function getAlignToXY: array of Float; overload;
    function getAlignToXY(element: Variant): array of Float; overload;
    function getAlignToXY(element: Variant; position: String): array of Float; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Float): array of Float; overload;
    function getAnchorXY: array of Float; overload;
    function getAnchorXY(anchor: String): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Float; overload;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    procedure getBubbleTarget;
    function getChildByElement: JExt.IComponent; overload;
    function getChildByElement(el: Variant): JExt.IComponent; overload;
    function getChildByElement(el: Variant; deep: Boolean): JExt.IComponent; overload;
    function getCollapsed: Variant;
    function getComponent: JExt.IComponent; overload;
    function getComponent(comp: Variant): JExt.IComponent; overload;
    function getConstrainVector: Variant; overload;
    function getConstrainVector(constrainTo: Variant): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float; proposedSize: array of Float): Variant; overload;
    procedure getDefaultFocus;
    function getDockedComponent: JExt.IComponent; overload;
    function getDockedComponent(comp: Variant): JExt.IComponent; overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(selector: String): array of JExt.IComponent; overload;
    function getDockedItems(selector: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    function getEl: JExt.dom.IElement;
    procedure getHeader;
    function getHeight: Float;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getInsertPosition: JHTMLElement; overload;
    function getInsertPosition(position: Variant): JHTMLElement; overload;
    function getItemId: String;
    function getLayout: JExt.layout.container.IContainer;
    function getLoader: JExt.IComponentLoader;
    function getLocalX: Float;
    function getLocalXY: array of Float;
    function getLocalY: Float;
    function getOffsetsTo: array of Float; overload;
    function getOffsetsTo(offsetsTo: Variant): array of Float; overload;
    function getPlugin: JExt.IAbstractPlugin; overload;
    function getPlugin(pluginId: String): JExt.IAbstractPlugin; overload;
    function getPosition: array of Float; overload;
    function getPosition(local: Boolean): array of Float; overload;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function getRegion: JExt.util.IRegion;
    function getSize: Variant;
    function getSizeModel: Variant; overload;
    function getSizeModel(ownerCtSizeModel: Variant): Variant; overload;
    function getViewRegion: JExt.util.IRegion;
    function getWidth: Float;
    function getX: Float;
    function getXType: String;
    function getXTypes: String;
    function getXY: array of Float;
    function getY: Float;
    function hasActiveFx: Variant;
    function hasCls: Boolean; overload;
    function hasCls(className: String): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hasUICls; overload;
    procedure hasUICls(cls: String); overload;
    function hide: JExt.IComponent;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure initEvents;
    function insert: JExt.IComponent; overload;
    function insert(index: Float): JExt.IComponent; overload;
    function insert(index: Float; component: Variant): JExt.IComponent; overload;
    procedure insertDocked; overload;
    procedure insertDocked(pos: Float); overload;
    procedure insertDocked(pos: Float; component: Variant); overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isAncestor; overload;
    procedure isAncestor(possibleDescendant: JExt.IComponent); overload;
    function isDescendantOf: Boolean; overload;
    function isDescendantOf(container: JExt.IContainer): Boolean; overload;
    function isDisabled: Boolean;
    function isDraggable: Boolean;
    function isDroppable: Boolean;
    function isFloating: Boolean;
    function isHidden: Boolean;
    procedure isLayoutRoot;
    function isLayoutSuspended: Boolean;
    function isVisible: Boolean; overload;
    function isVisible(deep: Variant): Boolean; overload;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    function maximize: JExt.window.IWindow; overload;
    function maximize(animate: Boolean): JExt.window.IWindow; overload;
    function minimize: JExt.window.IWindow;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function move: JExt.IComponent; overload;
    function move(fromIdx: Variant): JExt.IComponent; overload;
    function move(fromIdx: Variant; toIdx: Float): JExt.IComponent; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function nextNode: JExt.IComponent; overload;
    function nextNode(selector: String): JExt.IComponent; overload;
    function nextSibling: JExt.IComponent; overload;
    function nextSibling(selector: String): JExt.IComponent; overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure onAdd; overload;
    procedure onAdd(component: JExt.IComponent); overload;
    procedure onAdd(component: JExt.IComponent; position: Float); overload;
    procedure onAdded;
    procedure onBeforeAdd; overload;
    procedure onBeforeAdd(item: JExt.IComponent); overload;
    procedure onDestroy;
    procedure onDisable;
    procedure onDockedAdd; overload;
    procedure onDockedAdd(component: JExt.IComponent); overload;
    procedure onDockedRemove; overload;
    procedure onDockedRemove(component: JExt.IComponent); overload;
    procedure onEnable;
    procedure onHide;
    procedure onPosition;
    procedure onRemove; overload;
    procedure onRemove(component: JExt.IComponent); overload;
    procedure onRemove(component: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure onRemoved; overload;
    procedure onRemoved(destroying: Variant); overload;
    procedure onResize;
    procedure onShow;
    procedure onShowComplete; overload;
    procedure onShowComplete(callback: Variant); overload;
    procedure onShowComplete(callback: Variant; scope: Variant); overload;
    procedure postBlur; overload;
    procedure postBlur(e: JExt.IEventObject); overload;
    function previousNode: JExt.IComponent; overload;
    function previousNode(selector: String): JExt.IComponent; overload;
    function previousSibling: JExt.IComponent; overload;
    function previousSibling(selector: String): JExt.IComponent; overload;
    function progress: JExt.window.IMessageBox; overload;
    function progress(title: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String; progressText: String): JExt.window.IMessageBox; overload;
    function prompt: JExt.window.IMessageBox; overload;
    function prompt(title: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant; value: String): JExt.window.IMessageBox; overload;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure registerFloatingItem; overload;
    procedure registerFloatingItem(cmp: Variant); overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: JExt.IComponent; overload;
    function remove(component: Variant): JExt.IComponent; overload;
    function remove(component: Variant; autoDestroy: Boolean): JExt.IComponent; overload;
    function removeAll: array of JExt.IComponent; overload;
    function removeAll(autoDestroy: Boolean): array of JExt.IComponent; overload;
    function removeAnchor: JExt.util.IPositionable;
    function removeBodyCls: JExt.panel.IPanel; overload;
    function removeBodyCls(cls: String): JExt.panel.IPanel; overload;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
    function removeCls: JExt.IComponent; overload;
    function removeCls(cls: Variant): JExt.IComponent; overload;
    procedure removeClsWithUI; overload;
    procedure removeClsWithUI(cls: Variant); overload;
    procedure removeDocked; overload;
    procedure removeDocked(item: JExt.IComponent); overload;
    procedure removeDocked(item: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure removeUIClsFromElement; overload;
    procedure removeUIClsFromElement(cls: Variant); overload;
    procedure render; overload;
    procedure render(container: Variant); overload;
    procedure render(container: Variant; position: Variant); overload;
    function restore: JExt.window.IWindow; overload;
    function restore(animate: Variant): JExt.window.IWindow; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function savePropToState: Boolean; overload;
    function savePropToState(propName: String): Boolean; overload;
    function savePropToState(propName: String; state: Variant): Boolean; overload;
    function savePropToState(propName: String; state: Variant; stateName: String): Boolean; overload;
    function savePropsToState: Variant; overload;
    function savePropsToState(propNames: Variant): Variant; overload;
    function savePropsToState(propNames: Variant; state: Variant): Variant; overload;
    procedure saveState;
    procedure scrollBy; overload;
    procedure scrollBy(deltaX: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant); overload;
    procedure scrollBy(deltaX: Variant; deltaY: Variant; animate: Variant); overload;
    function sequenceFx: Variant;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActive(active: Boolean; newActive: JExt.IComponent); overload;
    function setAutoScroll: JExt.IComponent; overload;
    function setAutoScroll(scroll: Boolean): JExt.IComponent; overload;
    function setBodyStyle: JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant): JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant; value: String): JExt.panel.IPanel; overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBorder(border: Variant; targetEl: Variant); overload;
    function setBorderRegion: String; overload;
    function setBorderRegion(region: String): String; overload;
    function setBox: JExt.util.IPositionable; overload;
    function setBox(box: Variant): JExt.util.IPositionable; overload;
    function setBox(box: Variant; animate: Variant): JExt.util.IPositionable; overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    function setDocked: JExt.IComponent; overload;
    function setDocked(dock: Variant): JExt.IComponent; overload;
    function setDocked(dock: Variant; layoutParent: Boolean): JExt.IComponent; overload;
    procedure setGlyph; overload;
    procedure setGlyph(newGlyph: Variant); overload;
    function setHeight: JExt.IComponent; overload;
    function setHeight(height: Float): JExt.IComponent; overload;
    function setIcon: JExt.window.IMessageBox; overload;
    function setIcon(icon: String): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float; height: Float): JExt.window.IMessageBox; overload;
    procedure setIconCls; overload;
    procedure setIconCls(newIconCls: String); overload;
    function setLoading: JExt.ILoadMask; overload;
    function setLoading(load: Variant): JExt.ILoadMask; overload;
    function setLoading(load: Variant; targetEl: Boolean): JExt.ILoadMask; overload;
    function setLocalX: JExt.util.IPositionable; overload;
    function setLocalX(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY: JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant; y: Variant): JExt.util.IPositionable; overload;
    function setLocalY: JExt.util.IPositionable; overload;
    function setLocalY(y: Variant): JExt.util.IPositionable; overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    function setOverflowXY: JExt.IComponent; overload;
    function setOverflowXY(overflowX: String): JExt.IComponent; overload;
    function setOverflowXY(overflowX: String; overflowY: String): JExt.IComponent; overload;
    function setPagePosition: JExt.IComponent; overload;
    function setPagePosition(x: Variant): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPagePosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setPosition: JExt.IComponent; overload;
    function setPosition(x: Variant): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float): JExt.IComponent; overload;
    function setPosition(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function setRegion: JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion): JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion; animate: Variant): JExt.util.IPositionable; overload;
    function setRegionWeight: Float; overload;
    function setRegionWeight(weight: Float): Float; overload;
    function setSize: JExt.IComponent; overload;
    function setSize(width: Variant): JExt.IComponent; overload;
    function setSize(width: Variant; height: Variant): JExt.IComponent; overload;
    procedure setTitle; overload;
    procedure setTitle(newTitle: String); overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    function setVisible: JExt.IComponent; overload;
    function setVisible(visible: Boolean): JExt.IComponent; overload;
    function setWidth: JExt.IComponent; overload;
    function setWidth(width: Float): JExt.IComponent; overload;
    function setX: JExt.util.IPositionable; overload;
    function setX(x: Variant): JExt.util.IPositionable; overload;
    function setX(x: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setXY: JExt.util.IPositionable; overload;
    function setXY(xy: Variant): JExt.util.IPositionable; overload;
    function setXY(xy: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setY: JExt.util.IPositionable; overload;
    function setY(y: Variant): JExt.util.IPositionable; overload;
    function setY(y: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function show: JExt.window.IMessageBox; overload;
    function show(config: Variant): JExt.window.IMessageBox; overload;
    function showAt: JExt.IComponent; overload;
    function showAt(x: Variant): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float): JExt.IComponent; overload;
    function showAt(x: Variant; y: Float; animate: Variant): JExt.IComponent; overload;
    function showBy: JExt.IComponent; overload;
    function showBy(component: Variant): JExt.IComponent; overload;
    function showBy(component: Variant; position: String): JExt.IComponent; overload;
    function showBy(component: Variant; position: String; offsets: array of Float): JExt.IComponent; overload;
    function statics: JExt.IClass;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    function syncFx: Variant;
    function toBack: JExt.IComponent;
    function toFront: JExt.IComponent; overload;
    function toFront(preventFocus: Boolean): JExt.IComponent; overload;
    function toggleCollapse: JExt.panel.IPanel;
    function toggleMaximize: JExt.window.IWindow;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    function up: JExt.container.IContainer; overload;
    function up(selector: Variant): JExt.container.IContainer; overload;
    function up(selector: Variant; limit: Variant): JExt.container.IContainer; overload;
    procedure update; overload;
    procedure update(htmlOrData: Variant); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean); overload;
    procedure update(htmlOrData: Variant; loadScripts: Boolean; callback: Variant); overload;
    function updateBox: JExt.IComponent; overload;
    function updateBox(box: Variant): JExt.IComponent; overload;
    procedure updateLayout; overload;
    procedure updateLayout(options: Variant); overload;
    function updateProgress: JExt.window.IMessageBox; overload;
    function updateProgress(value: Float): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String; msg: String): JExt.window.IMessageBox; overload;
    function wait: JExt.window.IMessageBox; overload;
    function wait(msg: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String; config: Variant): JExt.window.IMessageBox; overload;
  end;

  JIMsg = class external(JExt.window.IMessageBox)
  end;

//Ext

type
  JModelManager = class external 'ModelManager'
    all: JExt.util.IHashMap;
    associationStack: array of JExt.data.association.IAssociation;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure create; overload;
    procedure create(data: Variant); overload;
    procedure create(data: Variant; name: String); overload;
    procedure create(data: Variant; name: String; id: Float); overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(id: Variant): JExt.data.IModel; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIModelManager = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JModelMgr = class external 'ModelMgr'
    all: JExt.util.IHashMap;
    associationStack: array of JExt.data.association.IAssociation;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure create; overload;
    procedure create(data: Variant); overload;
    procedure create(data: Variant; name: String); overload;
    procedure create(data: Variant; name: String; id: Float); overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(id: Variant): JExt.data.IModel; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIModelMgr = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JNumber = class external 'Number'
    function constrain: Float; overload;
    function constrain(number: Float): Float; overload;
    function constrain(number: Float; min: Float): Float; overload;
    function constrain(number: Float; min: Float; max: Float): Float; overload;
    function correctFloat: Float; overload;
    function correctFloat(The: Float): Float; overload;
    function from: Float; overload;
    function from(value: Variant): Float; overload;
    function from(value: Variant; defaultValue: Float): Float; overload;
    function randomInt: Float; overload;
    function randomInt(from: Float): Float; overload;
    function randomInt(from: Float; to: Float): Float; overload;
    function snap: Float; overload;
    function snap(value: Float): Float; overload;
    function snap(value: Float; increment: Float): Float; overload;
    function snap(value: Float; increment: Float; minValue: Float): Float; overload;
    function snap(value: Float; increment: Float; minValue: Float; maxValue: Float): Float; overload;
    function snapInRange: Float; overload;
    function snapInRange(value: Float): Float; overload;
    function snapInRange(value: Float; increment: Float): Float; overload;
    function snapInRange(value: Float; increment: Float; minValue: Float): Float; overload;
    function snapInRange(value: Float; increment: Float; minValue: Float; maxValue: Float): Float; overload;
    procedure toFixed; overload;
    procedure toFixed(value: Float); overload;
    procedure toFixed(value: Float; precision: Float); overload;
  end;

  JINumber = class external
  end;

//Ext

type
  JObject = class external 'Object'
    procedure chain; overload;
    procedure chain(&object: Variant); overload;
    procedure each; overload;
    procedure each(&object: Variant); overload;
    procedure each(&object: Variant; fn: Variant); overload;
    procedure each(&object: Variant; fn: Variant; scope: Variant); overload;
    function equals: Boolean; overload;
    function equals(object1: Variant): Boolean; overload;
    function equals(object1: Variant; object2: Variant): Boolean; overload;
    function fromQueryString: Variant; overload;
    function fromQueryString(queryString: String): Variant; overload;
    function fromQueryString(queryString: String; recursive: Boolean): Variant; overload;
    procedure getKey; overload;
    procedure getKey(&object: Variant); overload;
    procedure getKey(&object: Variant; value: Variant); overload;
    function getKeys: array of String; overload;
    function getKeys(&object: Variant): array of String; overload;
    function getSize: Float; overload;
    function getSize(&object: Variant): Float; overload;
    function getValues: array of Variant; overload;
    function getValues(&object: Variant): array of Variant; overload;
    function isEmpty: Boolean; overload;
    function isEmpty(&object: Variant): Boolean; overload;
    function merge(destination: Variant; &object: array of Variant): Variant;
    function toQueryObjects: array of Variant; overload;
    function toQueryObjects(name: String): array of Variant; overload;
    function toQueryObjects(name: String; value: Variant): array of Variant; overload;
    function toQueryObjects(name: String; value: Variant; recursive: Boolean): array of Variant; overload;
    function toQueryString: String; overload;
    function toQueryString(&object: Variant): String; overload;
    function toQueryString(&object: Variant; recursive: Boolean): String; overload;
  end;

  JIObject = class external
  end;

//Ext.panel

type
  JIAbstractPanel = class external(JExt.container.IContainer, JExt.container.IDockingContainer)
    baseCls: String; // nullable
    bodyBorder: Boolean; // nullable
    bodyCls: Variant; // nullable
    bodyPadding: Variant; // nullable
    bodyStyle: Variant; // nullable
    border: Variant; // nullable
    componentLayout: Variant; // nullable
    dockedItems: Variant; // nullable
    renderTpl: Variant; // nullable
    shrinkWrapDock: Variant; // nullable
    body: JExt.dom.IElement; // nullable
    contentPaddingProperty: String; // nullable
    isPanel: Boolean; // nullable
    function addBodyCls: JExt.panel.IPanel; overload;
    function addBodyCls(cls: String): JExt.panel.IPanel; overload;
    function addDocked: array of JExt.IComponent; overload;
    function addDocked(component: Variant): array of JExt.IComponent; overload;
    function addDocked(component: Variant; pos: Float): array of JExt.IComponent; overload;
    procedure addUIClsToElement; overload;
    procedure addUIClsToElement(cls: Variant); overload;
    function getComponent: JExt.IComponent; overload;
    function getComponent(comp: Variant): JExt.IComponent; overload;
    function getDockedComponent: JExt.IComponent; overload;
    function getDockedComponent(comp: Variant): JExt.IComponent; overload;
    function getDockedItems: array of JExt.IComponent; overload;
    function getDockedItems(selector: String): array of JExt.IComponent; overload;
    function getDockedItems(selector: String; beforeBody: Boolean): array of JExt.IComponent; overload;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    procedure insertDocked; overload;
    procedure insertDocked(pos: Float); overload;
    procedure insertDocked(pos: Float; component: Variant); overload;
    procedure onDockedAdd; overload;
    procedure onDockedAdd(component: JExt.IComponent); overload;
    procedure onDockedRemove; overload;
    procedure onDockedRemove(component: JExt.IComponent); overload;
    function removeBodyCls: JExt.panel.IPanel; overload;
    function removeBodyCls(cls: String): JExt.panel.IPanel; overload;
    procedure removeDocked; overload;
    procedure removeDocked(item: JExt.IComponent); overload;
    procedure removeDocked(item: JExt.IComponent; autoDestroy: Boolean); overload;
    procedure removeUIClsFromElement; overload;
    procedure removeUIClsFromElement(cls: Variant); overload;
    function setBodyStyle: JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant): JExt.panel.IPanel; overload;
    function setBodyStyle(style: Variant; value: String): JExt.panel.IPanel; overload;
  end;

//Ext.panel

type
  JIDD = class external(JExt.dd.IDragSource)
    procedure afterInvalidDrop; overload;
    procedure afterInvalidDrop(e: JEvent); overload;
    procedure afterInvalidDrop(e: JEvent; id: String); overload;
    procedure b4MouseDown; overload;
    procedure b4MouseDown(e: Variant); overload;
    procedure createFrame;
    function getDragEl: JHTMLElement; overload;
    function getDragEl(e: Variant): JHTMLElement; overload;
  end;

//Ext.panel

type
  JIHeader = class external(JExt.container.IContainer)
    componentLayout: Variant; // nullable
    defaultType: String; // nullable
    glyph: Variant; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    renderTpl: Variant; // nullable
    shrinkWrap: Variant; // nullable
    title: String; // nullable
    titleAlign: String; // nullable
    titlePosition: Float; // nullable
    isHeader: Boolean; // nullable
    procedure addTool; overload;
    procedure addTool(tool: Variant); overload;
    procedure addUIClsToElement; overload;
    procedure addUIClsToElement(cls: Variant); overload;
    procedure afterLayout;
    procedure beforeLayout;
    function getTools: array of JExt.panel.ITool;
    procedure onAdd; overload;
    procedure onAdd(component: Variant); overload;
    procedure onAdd(component: Variant; index: Variant); overload;
    procedure removeUIClsFromElement; overload;
    procedure removeUIClsFromElement(cls: Variant); overload;
    procedure setGlyph; overload;
    procedure setGlyph(glyph: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(cls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext.panel

type
  JIPanel = class external(JExt.panel.IAbstractPanel)
    animCollapse: Boolean; // nullable
    bbar: Variant; // nullable
    buttonAlign: String; // nullable
    buttons: Variant; // nullable
    closable: Boolean; // nullable
    closeAction: String; // nullable
    collapseDirection: String; // nullable
    collapseFirst: Boolean; // nullable
    collapseMode: String; // nullable
    collapsed: Boolean; // nullable
    collapsedCls: String; // nullable
    collapsible: Boolean; // nullable
    constrain: Boolean; // nullable
    constrainHeader: Boolean; // nullable
    dockedItems: Variant; // nullable
    fbar: Variant; // nullable
    floatable: Boolean; // nullable
    frame: Boolean; // nullable
    frameHeader: Boolean; // nullable
    glyph: Variant; // nullable
    header: Variant; // nullable
    headerOverCls: String; // nullable
    headerPosition: String; // nullable
    hideCollapseTool: Boolean; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    lbar: Variant; // nullable
    manageHeight: Boolean; // nullable
    minButtonWidth: Float; // nullable
    overlapHeader: Boolean; // nullable
    placeholder: Variant; // nullable
    placeholderCollapseHideMode: Float; // nullable
    preventHeader: Boolean; // nullable
    rbar: Variant; // nullable
    simpleDrag: Boolean; // nullable
    tbar: Variant; // nullable
    title: String; // nullable
    titleAlign: String; // nullable
    titleCollapse: Boolean; // nullable
    tools: Variant; // nullable
    dd: Variant; // nullable
    procedure addTool; overload;
    procedure addTool(tools: Variant); overload;
    procedure afterCollapse; overload;
    procedure afterCollapse(animated: Boolean); overload;
    procedure afterExpand; overload;
    procedure afterExpand(animated: Boolean); overload;
    procedure close;
    function collapse: JExt.panel.IPanel; overload;
    function collapse(direction: String): JExt.panel.IPanel; overload;
    function collapse(direction: String; animate: Boolean): JExt.panel.IPanel; overload;
    procedure convertCollapseDir; overload;
    procedure convertCollapseDir(collapseDir: Variant); overload;
    function expand: JExt.panel.IPanel; overload;
    function expand(animate: Boolean): JExt.panel.IPanel; overload;
    function getCollapsed: Variant;
    procedure getHeader;
    function getState: Variant;
    procedure isLayoutRoot;
    function isVisible: Boolean; overload;
    function isVisible(deep: Variant): Boolean; overload;
    procedure onHide;
    procedure onRemoved; overload;
    procedure onRemoved(destroying: Variant); overload;
    procedure onShow;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBorder(border: Variant; targetEl: Variant); overload;
    procedure setGlyph; overload;
    procedure setGlyph(newGlyph: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(newIcon: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(newIconCls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(newTitle: String); overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    function toggleCollapse: JExt.panel.IPanel;
  end;

//Ext

type
  JIPanel = class external(JExt.panel.IAbstractPanel)
    animCollapse: Boolean; // nullable
    bbar: Variant; // nullable
    buttonAlign: String; // nullable
    buttons: Variant; // nullable
    closable: Boolean; // nullable
    closeAction: String; // nullable
    collapseDirection: String; // nullable
    collapseFirst: Boolean; // nullable
    collapseMode: String; // nullable
    collapsed: Boolean; // nullable
    collapsedCls: String; // nullable
    collapsible: Boolean; // nullable
    constrain: Boolean; // nullable
    constrainHeader: Boolean; // nullable
    dockedItems: Variant; // nullable
    fbar: Variant; // nullable
    floatable: Boolean; // nullable
    frame: Boolean; // nullable
    frameHeader: Boolean; // nullable
    glyph: Variant; // nullable
    header: Variant; // nullable
    headerOverCls: String; // nullable
    headerPosition: String; // nullable
    hideCollapseTool: Boolean; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    lbar: Variant; // nullable
    manageHeight: Boolean; // nullable
    minButtonWidth: Float; // nullable
    overlapHeader: Boolean; // nullable
    placeholder: Variant; // nullable
    placeholderCollapseHideMode: Float; // nullable
    preventHeader: Boolean; // nullable
    rbar: Variant; // nullable
    simpleDrag: Boolean; // nullable
    tbar: Variant; // nullable
    title: String; // nullable
    titleAlign: String; // nullable
    titleCollapse: Boolean; // nullable
    tools: Variant; // nullable
    dd: Variant; // nullable
    procedure addTool; overload;
    procedure addTool(tools: Variant); overload;
    procedure afterCollapse; overload;
    procedure afterCollapse(animated: Boolean); overload;
    procedure afterExpand; overload;
    procedure afterExpand(animated: Boolean); overload;
    procedure close;
    function collapse: JExt.panel.IPanel; overload;
    function collapse(direction: String): JExt.panel.IPanel; overload;
    function collapse(direction: String; animate: Boolean): JExt.panel.IPanel; overload;
    procedure convertCollapseDir; overload;
    procedure convertCollapseDir(collapseDir: Variant); overload;
    function expand: JExt.panel.IPanel; overload;
    function expand(animate: Boolean): JExt.panel.IPanel; overload;
    function getCollapsed: Variant;
    procedure getHeader;
    function getState: Variant;
    procedure isLayoutRoot;
    function isVisible: Boolean; overload;
    function isVisible(deep: Variant): Boolean; overload;
    procedure onHide;
    procedure onRemoved; overload;
    procedure onRemoved(destroying: Variant); overload;
    procedure onShow;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBorder(border: Variant; targetEl: Variant); overload;
    procedure setGlyph; overload;
    procedure setGlyph(newGlyph: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(newIcon: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(newIconCls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(newTitle: String); overload;
    procedure setUI; overload;
    procedure setUI(ui: Variant); overload;
    function toggleCollapse: JExt.panel.IPanel;
  end;

//Ext.panel

type
  JIProxy = class external(JExt.IBase)
    insertProxy: Boolean; // nullable
    moveOnDrag: Boolean; // nullable
    panel: JExt.panel.IPanel; // nullable
    function getEl: JExt.IElement;
    function getGhost: JExt.panel.IPanel;
    function getProxy: JExt.IElement;
    procedure hide;
    procedure moveProxy; overload;
    procedure moveProxy(parentNode: JHTMLElement); overload;
    procedure moveProxy(parentNode: JHTMLElement; before: JHTMLElement); overload;
    procedure show;
  end;

//Ext.dd

type
  JIPanelProxy = class external(JExt.IBase)
    insertProxy: Boolean; // nullable
    moveOnDrag: Boolean; // nullable
    panel: JExt.panel.IPanel; // nullable
    function getEl: JExt.IElement;
    function getGhost: JExt.panel.IPanel;
    function getProxy: JExt.IElement;
    procedure hide;
    procedure moveProxy; overload;
    procedure moveProxy(parentNode: JHTMLElement); overload;
    procedure moveProxy(parentNode: JHTMLElement; before: JHTMLElement); overload;
    procedure show;
  end;

//Ext.panel

type
  JITable = class external(JExt.panel.IPanel, JExt.grid.locking.ILockable)
    allowDeselect: Boolean; // nullable
    columnLines: Boolean; // nullable
    columns: Variant; // nullable
    deferRowRender: Boolean; // nullable
    disableSelection: Boolean; // nullable
    emptyText: String; // nullable
    enableColumnHide: Boolean; // nullable
    enableColumnMove: Boolean; // nullable
    enableColumnResize: Boolean; // nullable
    enableLocking: Boolean; // nullable
    features: Variant; // nullable
    forceFit: Boolean; // nullable
    hideHeaders: Boolean; // nullable
    layout: Variant; // nullable
    multiSelect: Boolean; // nullable
    rowLines: Boolean; // nullable
    scroll: Variant; // nullable
    sealedColumns: Boolean; // nullable
    selModel: Variant; // nullable
    selType: String; // nullable
    simpleSelect: Boolean; // nullable
    sortableColumns: Boolean; // nullable
    store: JExt.data.IStore; // nullable
    verticalScroller: Variant; // nullable
    view: JExt.view.ITable; // nullable
    viewConfig: Variant; // nullable
    viewType: String; // nullable
    hasView: Boolean; // nullable
    optimizedColumnMove: Boolean; // nullable
    procedure afterCollapse;
    procedure afterExpand;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure determineScrollbars;
    function getSelectionModel: JExt.selection.IModel;
    function getState: Variant;
    function getStore: JExt.data.IStore;
    function getView: JExt.view.ITable;
    procedure invalidateScroller;
    procedure onDestroy;
    procedure syncRowHeights;
  end;

//Ext.panel

type
  JITool = class external(JExt.IComponent)
    baseCls: String; // nullable
    callback: Variant; // nullable
    disabledCls: String; // nullable
    handler: Variant; // nullable
    height: Float; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    stopEvent: Boolean; // nullable
    toolOwner: JExt.IComponent; // nullable
    tooltip: Variant; // nullable
    tooltipType: String; // nullable
    &type: String; // nullable
    width: Float; // nullable
    isTool: Boolean; // nullable
    procedure afterRender;
    procedure initComponent;
    procedure onDestroy;
    function setType: JExt.panel.ITool; overload;
    function setType(&type: String): JExt.panel.ITool; overload;
  end;

//Ext.perf

type
  JIAccumulator = class external(JExt.IBase)
  end;

//Ext.perf

type
  JMonitor = class external 'Monitor'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIMonitor = class external(JExt.IBase)
  end;

//Ext

type
  JPerf = class external 'Perf'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIPerf = class external(JExt.IBase)
  end;

//Ext.picker

type
  JIColor = class external(JExt.IComponent)
    allowReselect: Boolean; // nullable
    clickEvent: String; // nullable
    componentCls: String; // nullable
    handler: Variant; // nullable
    itemCls: String; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    selectedCls: String; // nullable
    value: String; // nullable
    colors: array of String; // nullable
    procedure clear;
    function getValue: String;
    procedure onRender;
    procedure select; overload;
    procedure select(color: String); overload;
    procedure select(color: String; suppressEvent: Boolean); overload;
  end;

//Ext

type
  JIColorPalette = class external(JExt.IComponent)
    allowReselect: Boolean; // nullable
    clickEvent: String; // nullable
    componentCls: String; // nullable
    handler: Variant; // nullable
    itemCls: String; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    selectedCls: String; // nullable
    value: String; // nullable
    colors: array of String; // nullable
    procedure clear;
    function getValue: String;
    procedure onRender;
    procedure select; overload;
    procedure select(color: String); overload;
    procedure select(color: String; suppressEvent: Boolean); overload;
  end;

//Ext.picker

type
  JIDate = class external(JExt.IComponent)
    ariaTitle: String; // nullable
    ariaTitleDateFormat: String; // nullable
    baseCls: String; // nullable
    border: Variant; // nullable
    dayNames: array of String; // nullable
    disableAnim: Boolean; // nullable
    disabledCellCls: String; // nullable
    disabledDates: array of String; // nullable
    disabledDatesRE: JRegExp; // nullable
    disabledDatesText: String; // nullable
    disabledDays: array of Float; // nullable
    disabledDaysText: String; // nullable
    focusOnShow: Boolean; // nullable
    format: String; // nullable
    handler: Variant; // nullable
    keyNavConfig: Variant; // nullable
    longDayFormat: String; // nullable
    maxDate: Variant; // nullable
    maxText: String; // nullable
    minDate: Variant; // nullable
    minText: String; // nullable
    monthNames: array of String; // nullable
    monthYearFormat: String; // nullable
    monthYearText: String; // nullable
    nextText: String; // nullable
    prevText: String; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    selectedCls: String; // nullable
    showToday: Boolean; // nullable
    startDay: Float; // nullable
    todayText: String; // nullable
    todayTip: String; // nullable
    function getDayInitial: String; overload;
    function getDayInitial(value: Variant): String; overload;
    function getValue: Variant;
    function hideMonthPicker: JExt.picker.IDate; overload;
    function hideMonthPicker(animate: Boolean): JExt.picker.IDate; overload;
    procedure initComponent;
    function selectToday: JExt.picker.IDate;
    function setDisabledDates: JExt.picker.IDate; overload;
    function setDisabledDates(disabledDates: Variant): JExt.picker.IDate; overload;
    function setDisabledDays: JExt.picker.IDate; overload;
    function setDisabledDays(disabledDays: array of Float): JExt.picker.IDate; overload;
    function setMaxDate: JExt.picker.IDate; overload;
    function setMaxDate(value: Variant): JExt.picker.IDate; overload;
    function setMinDate: JExt.picker.IDate; overload;
    function setMinDate(value: Variant): JExt.picker.IDate; overload;
    function setValue: JExt.picker.IDate; overload;
    function setValue(value: Variant): JExt.picker.IDate; overload;
    function showMonthPicker: JExt.picker.IDate; overload;
    function showMonthPicker(animate: Boolean): JExt.picker.IDate; overload;
    function showNextMonth: JExt.picker.IDate; overload;
    function showNextMonth(e: Variant): JExt.picker.IDate; overload;
    function showNextYear: JExt.picker.IDate;
    function showPrevMonth: JExt.picker.IDate; overload;
    function showPrevMonth(e: Variant): JExt.picker.IDate; overload;
    function showPrevYear: JExt.picker.IDate;
  end;

//Ext

type
  JIDatePicker = class external(JExt.IComponent)
    ariaTitle: String; // nullable
    ariaTitleDateFormat: String; // nullable
    baseCls: String; // nullable
    border: Variant; // nullable
    dayNames: array of String; // nullable
    disableAnim: Boolean; // nullable
    disabledCellCls: String; // nullable
    disabledDates: array of String; // nullable
    disabledDatesRE: JRegExp; // nullable
    disabledDatesText: String; // nullable
    disabledDays: array of Float; // nullable
    disabledDaysText: String; // nullable
    focusOnShow: Boolean; // nullable
    format: String; // nullable
    handler: Variant; // nullable
    keyNavConfig: Variant; // nullable
    longDayFormat: String; // nullable
    maxDate: Variant; // nullable
    maxText: String; // nullable
    minDate: Variant; // nullable
    minText: String; // nullable
    monthNames: array of String; // nullable
    monthYearFormat: String; // nullable
    monthYearText: String; // nullable
    nextText: String; // nullable
    prevText: String; // nullable
    renderTpl: Variant; // nullable
    scope: Variant; // nullable
    selectedCls: String; // nullable
    showToday: Boolean; // nullable
    startDay: Float; // nullable
    todayText: String; // nullable
    todayTip: String; // nullable
    function getDayInitial: String; overload;
    function getDayInitial(value: Variant): String; overload;
    function getValue: Variant;
    function hideMonthPicker: JExt.picker.IDate; overload;
    function hideMonthPicker(animate: Boolean): JExt.picker.IDate; overload;
    procedure initComponent;
    function selectToday: JExt.picker.IDate;
    function setDisabledDates: JExt.picker.IDate; overload;
    function setDisabledDates(disabledDates: Variant): JExt.picker.IDate; overload;
    function setDisabledDays: JExt.picker.IDate; overload;
    function setDisabledDays(disabledDays: array of Float): JExt.picker.IDate; overload;
    function setMaxDate: JExt.picker.IDate; overload;
    function setMaxDate(value: Variant): JExt.picker.IDate; overload;
    function setMinDate: JExt.picker.IDate; overload;
    function setMinDate(value: Variant): JExt.picker.IDate; overload;
    function setValue: JExt.picker.IDate; overload;
    function setValue(value: Variant): JExt.picker.IDate; overload;
    function showMonthPicker: JExt.picker.IDate; overload;
    function showMonthPicker(animate: Boolean): JExt.picker.IDate; overload;
    function showNextMonth: JExt.picker.IDate; overload;
    function showNextMonth(e: Variant): JExt.picker.IDate; overload;
    function showNextYear: JExt.picker.IDate;
    function showPrevMonth: JExt.picker.IDate; overload;
    function showPrevMonth(e: Variant): JExt.picker.IDate; overload;
    function showPrevYear: JExt.picker.IDate;
  end;

//Ext.picker

type
  JIMonth = class external(JExt.IComponent)
    baseCls: String; // nullable
    cancelText: String; // nullable
    okText: String; // nullable
    renderTpl: Variant; // nullable
    selectedCls: String; // nullable
    showButtons: Boolean; // nullable
    value: Variant; // nullable
    procedure adjustYear; overload;
    procedure adjustYear(offset: Float); overload;
    function getValue: array of Float;
    function hasSelection: Boolean;
    procedure onDestroy;
    function setValue: JExt.picker.IMonth; overload;
    function setValue(value: Variant): JExt.picker.IMonth; overload;
  end;

//Ext

type
  JIMonthPicker = class external(JExt.IComponent)
    baseCls: String; // nullable
    cancelText: String; // nullable
    okText: String; // nullable
    renderTpl: Variant; // nullable
    selectedCls: String; // nullable
    showButtons: Boolean; // nullable
    value: Variant; // nullable
    procedure adjustYear; overload;
    procedure adjustYear(offset: Float); overload;
    function getValue: array of Float;
    function hasSelection: Boolean;
    procedure onDestroy;
    function setValue: JExt.picker.IMonth; overload;
    function setValue(value: Variant): JExt.picker.IMonth; overload;
  end;

//Ext.picker

type
  JITime = class external(JExt.view.IBoundList)
    componentCls: String; // nullable
    format: String; // nullable
    increment: Float; // nullable
    maxValue: Variant; // nullable
    minValue: Variant; // nullable
    procedure focusNode; overload;
    procedure focusNode(rec: Variant); overload;
    procedure initComponent;
    procedure setMaxValue; overload;
    procedure setMaxValue(value: Variant); overload;
    procedure setMinValue; overload;
    procedure setMinValue(value: Variant); overload;
    procedure updateList;
  end;

//Ext

type
  JPluginManager = class external 'PluginManager'
    all: JExt.util.IHashMap;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(config: Variant): JExt.IComponent; overload;
    function create(config: Variant; defaultType: Variant): JExt.IComponent; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function findByType: array of JExt.IAbstractPlugin; overload;
    function findByType(&type: String): array of JExt.IAbstractPlugin; overload;
    function findByType(&type: String; defaultsOnly: Boolean): array of JExt.IAbstractPlugin; overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: String); overload;
    procedure registerType(&type: String; cls: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIPluginManager = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JPluginMgr = class external 'PluginMgr'
    all: JExt.util.IHashMap;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(config: Variant): JExt.IComponent; overload;
    function create(config: Variant; defaultType: Variant): JExt.IComponent; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function findByType: array of JExt.IAbstractPlugin; overload;
    function findByType(&type: String): array of JExt.IAbstractPlugin; overload;
    function findByType(&type: String; defaultsOnly: Boolean): array of JExt.IAbstractPlugin; overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: String); overload;
    procedure registerType(&type: String; cls: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIPluginMgr = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JIProgressBar = class external(JExt.IComponent)
    animate: Variant; // nullable
    baseCls: String; // nullable
    componentLayout: Variant; // nullable
    id: String; // nullable
    renderTpl: Variant; // nullable
    text: String; // nullable
    textEl: Variant; // nullable
    value: Float; // nullable
    procedure initComponent;
    function initRenderData: Variant;
    function isWaiting: Boolean;
    procedure onDestroy;
    procedure onRender;
    function reset: JExt.IProgressBar; overload;
    function reset(hide: Boolean): JExt.IProgressBar; overload;
    function updateProgress: JExt.IProgressBar; overload;
    function updateProgress(value: Float): JExt.IProgressBar; overload;
    function updateProgress(value: Float; text: String): JExt.IProgressBar; overload;
    function updateProgress(value: Float; text: String; animate: Boolean): JExt.IProgressBar; overload;
    function updateText: JExt.IProgressBar; overload;
    function updateText(text: String): JExt.IProgressBar; overload;
    function wait: JExt.IProgressBar; overload;
    function wait(config: Variant): JExt.IProgressBar; overload;
  end;

//Ext

type
  JIQueryable = class external(JExt.IBase)
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
  end;

//Ext.resizer

type
  JIBorderSplitter = class external(JExt.resizer.ISplitter)
    collapseTarget: Variant; // nullable
    procedure getTrackerConfig;
  end;

//Ext.resizer

type
  JIBorderSplitterTracker = class external(JExt.resizer.ISplitterTracker)
    procedure onBeforeStart; overload;
    procedure onBeforeStart(e: Variant); overload;
  end;

//Ext.resizer

type
  JIHandle = class external(JExt.IComponent)
    region: Variant; // nullable
  end;

//Ext.resizer

type
  JIResizer = class external(JExt.IBase, JExt.util.IObservable)
    constrainTo: Variant; // nullable
    dynamic: Boolean; // nullable
    handles: String; // nullable
    height: Float; // nullable
    heightIncrement: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    pinned: Boolean; // nullable
    preserveRatio: Boolean; // nullable
    target: Variant; // nullable
    transparent: Boolean; // nullable
    width: Float; // nullable
    widthIncrement: Float; // nullable
    el: JExt.IElement; // nullable
    originalTarget: Variant; // nullable
    resizeTracker: JExt.resizer.IResizeTracker; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getEl: JExt.IElement;
    function getTarget: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resizeTo; overload;
    procedure resizeTo(width: Float); overload;
    procedure resizeTo(width: Float; height: Float); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext

type
  JIResizable = class external(JExt.IBase, JExt.util.IObservable)
    constrainTo: Variant; // nullable
    dynamic: Boolean; // nullable
    handles: String; // nullable
    height: Float; // nullable
    heightIncrement: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    pinned: Boolean; // nullable
    preserveRatio: Boolean; // nullable
    target: Variant; // nullable
    transparent: Boolean; // nullable
    width: Float; // nullable
    widthIncrement: Float; // nullable
    el: JExt.IElement; // nullable
    originalTarget: Variant; // nullable
    resizeTracker: JExt.resizer.IResizeTracker; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getEl: JExt.IElement;
    function getTarget: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resizeTo; overload;
    procedure resizeTo(width: Float); overload;
    procedure resizeTo(width: Float; height: Float); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.resizer

type
  JIResizeTracker = class external(JExt.dd.IDragTracker)
    constrainTo: Variant; // nullable
    function createProxy: JExt.IElement; overload;
    function createProxy(target: Variant): JExt.IElement; overload;
    procedure onBeforeStart; overload;
    procedure onBeforeStart(e: Variant); overload;
    procedure onDrag; overload;
    procedure onDrag(e: Variant); overload;
    procedure onEnd; overload;
    procedure onEnd(e: Variant); overload;
    procedure onStart; overload;
    procedure onStart(e: Variant); overload;
  end;

//Ext.resizer

type
  JISplitter = class external(JExt.IComponent)
    baseCls: String; // nullable
    collapseOnDblClick: Boolean; // nullable
    collapseTarget: Variant; // nullable
    collapsedCls: String; // nullable
    collapsible: Boolean; // nullable
    defaultSplitMax: Float; // nullable
    defaultSplitMin: Float; // nullable
    performCollapse: Boolean; // nullable
    renderTpl: Variant; // nullable
    size: Float; // nullable
    orientation: String; // nullable
    procedure beforeDestroy;
    procedure getTrackerConfig;
    procedure onRender;
    function setSize: JExt.IComponent;
  end;

//Ext.resizer

type
  JISplitterTracker = class external(JExt.dd.IDragTracker)
    procedure onBeforeStart; overload;
    procedure onBeforeStart(e: Variant); overload;
    procedure onDrag; overload;
    procedure onDrag(e: Variant); overload;
    procedure onEnd; overload;
    procedure onEnd(e: Variant); overload;
    procedure onStart; overload;
    procedure onStart(e: Variant); overload;
  end;

//Ext.selection

type
  JICellModel = class external(JExt.selection.IModel)
    enableKeyNav: Boolean; // nullable
    mode: String; // nullable
    preventWrap: Boolean; // nullable
    procedure deselect; overload;
    procedure deselect(record: Variant); overload;
    procedure deselect(record: Variant; suppressEvent: Variant); overload;
    procedure getCurrentPosition;
    procedure select; overload;
    procedure select(pos: Variant); overload;
    procedure select(pos: Variant; keepExisting: Variant); overload;
    procedure select(pos: Variant; keepExisting: Variant; suppressEvent: Variant); overload;
    procedure setCurrentPosition; overload;
    procedure setCurrentPosition(position: Variant); overload;
    procedure setCurrentPosition(position: Variant; suppressEvent: Boolean); overload;
  end;

//Ext.selection

type
  JICheckboxModel = class external(JExt.selection.IRowModel)
    checkOnly: Boolean; // nullable
    checkSelector: String; // nullable
    injectCheckbox: Variant; // nullable
    mode: Variant; // nullable
    showHeaderCheckbox: Boolean; // nullable
    procedure getHeaderConfig;
    procedure onHeaderClick; overload;
    procedure onHeaderClick(headerCt: Variant); overload;
    procedure onHeaderClick(headerCt: Variant; header: Variant); overload;
    procedure onHeaderClick(headerCt: Variant; header: Variant; e: Variant); overload;
    procedure renderer; overload;
    procedure renderer(value: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant; record: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant; record: Variant; rowIndex: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant; record: Variant; rowIndex: Variant; colIndex: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant; record: Variant; rowIndex: Variant; colIndex: Variant; store: Variant); overload;
    procedure renderer(value: Variant; metaData: Variant; record: Variant; rowIndex: Variant; colIndex: Variant; store: Variant; view: Variant); overload;
  end;

//Ext.selection

type
  JIDataViewModel = class external(JExt.selection.IModel)
    enableKeyNav: Boolean; // nullable
  end;

//Ext.selection

type
  JIModel = class external(JExt.util.IObservable, JExt.util.IBindable)
    allowDeselect: Boolean; // nullable
    mode: Variant; // nullable
    pruneRemoved: Boolean; // nullable
    toggleOnClick: Boolean; // nullable
    selected: JExt.util.IMixedCollection; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    procedure deselectAll; overload;
    procedure deselectAll(suppressEvent: Boolean); overload;
    procedure deselectRange; overload;
    procedure deselectRange(startRow: Variant); overload;
    procedure deselectRange(startRow: Variant; endRow: Variant); overload;
    function getCount: Float;
    function getLastSelected: JExt.data.IModel;
    function getSelection: array of JExt.data.IModel;
    function getSelectionMode: String;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant;
    function hasSelection: Boolean;
    procedure isFocused; overload;
    procedure isFocused(record: JExt.data.IModel); overload;
    function isLocked: Boolean;
    function isRangeSelected: Boolean; overload;
    function isRangeSelected(from: Variant): Boolean; overload;
    function isRangeSelected(from: Variant; to: Variant): Boolean; overload;
    function isSelected: Boolean; overload;
    function isSelected(record: Variant): Boolean; overload;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure selectAll; overload;
    procedure selectAll(suppressEvent: Boolean); overload;
    procedure selectRange; overload;
    procedure selectRange(startRow: Variant); overload;
    procedure selectRange(startRow: Variant; endRow: Variant); overload;
    procedure selectRange(startRow: Variant; endRow: Variant; keepExisting: Boolean); overload;
    procedure setLastFocused; overload;
    procedure setLastFocused(record: JExt.data.IModel); overload;
    procedure setLocked; overload;
    procedure setLocked(locked: Boolean); overload;
    procedure setSelectionMode; overload;
    procedure setSelectionMode(selMode: String); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext

type
  JIAbstractSelectionModel = class external(JExt.util.IObservable, JExt.util.IBindable)
    allowDeselect: Boolean; // nullable
    mode: Variant; // nullable
    pruneRemoved: Boolean; // nullable
    toggleOnClick: Boolean; // nullable
    selected: JExt.util.IMixedCollection; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    procedure deselectAll; overload;
    procedure deselectAll(suppressEvent: Boolean); overload;
    procedure deselectRange; overload;
    procedure deselectRange(startRow: Variant); overload;
    procedure deselectRange(startRow: Variant; endRow: Variant); overload;
    function getCount: Float;
    function getLastSelected: JExt.data.IModel;
    function getSelection: array of JExt.data.IModel;
    function getSelectionMode: String;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant;
    function hasSelection: Boolean;
    procedure isFocused; overload;
    procedure isFocused(record: JExt.data.IModel); overload;
    function isLocked: Boolean;
    function isRangeSelected: Boolean; overload;
    function isRangeSelected(from: Variant): Boolean; overload;
    function isRangeSelected(from: Variant; to: Variant): Boolean; overload;
    function isSelected: Boolean; overload;
    function isSelected(record: Variant): Boolean; overload;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure selectAll; overload;
    procedure selectAll(suppressEvent: Boolean); overload;
    procedure selectRange; overload;
    procedure selectRange(startRow: Variant); overload;
    procedure selectRange(startRow: Variant; endRow: Variant); overload;
    procedure selectRange(startRow: Variant; endRow: Variant; keepExisting: Boolean); overload;
    procedure setLastFocused; overload;
    procedure setLastFocused(record: JExt.data.IModel); overload;
    procedure setLocked; overload;
    procedure setLocked(locked: Boolean); overload;
    procedure setSelectionMode; overload;
    procedure setSelectionMode(selMode: String); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.selection

type
  JIRowModel = class external(JExt.selection.IModel)
    enableKeyNav: Boolean; // nullable
    ignoreRightMouseSelection: Boolean; // nullable
    procedure getCurrentPosition;
    function selectNext: Boolean; overload;
    function selectNext(keepExisting: Boolean): Boolean; overload;
    function selectNext(keepExisting: Boolean; suppressEvent: Boolean): Boolean; overload;
    function selectPrevious: Boolean; overload;
    function selectPrevious(keepExisting: Boolean): Boolean; overload;
    function selectPrevious(keepExisting: Boolean; suppressEvent: Boolean): Boolean; overload;
  end;

//Ext.selection

type
  JITreeModel = class external(JExt.selection.IRowModel)
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
  end;

//Ext

type
  JIShadow = class external(JExt.IBase)
    mode: String; // nullable
    offset: Float; // nullable
    procedure hide;
    procedure isVisible;
    procedure realign; overload;
    procedure realign(left: Float); overload;
    procedure realign(left: Float; top: Float); overload;
    procedure realign(left: Float; top: Float; width: Float); overload;
    procedure realign(left: Float; top: Float; width: Float; height: Float); overload;
    procedure setOpacity; overload;
    procedure setOpacity(opacity: Float); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zindex: Float); overload;
    procedure show; overload;
    procedure show(targetEl: Variant); overload;
  end;

//Ext

type
  JShadowPool = class external 'ShadowPool'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function statics: JExt.IClass;
  end;

  JIShadowPool = class external(JExt.IBase)
  end;

//Ext.slider

type
  JIMulti = class external(JExt.form.field.IBase)
    animate: Boolean; // nullable
    clickToChange: Boolean; // nullable
    componentLayout: Variant; // nullable
    constrainThumbs: Boolean; // nullable
    decimalPrecision: Variant; // nullable
    increment: Float; // nullable
    keyIncrement: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    tipText: Variant; // nullable
    useTips: Variant; // nullable
    value: Float; // nullable
    values: array of Float; // nullable
    vertical: Boolean; // nullable
    zeroBasedSnapping: Boolean; // nullable
    dragging: Boolean; // nullable
    thumbs: array of Variant; // nullable
    function addThumb: Variant; overload;
    function addThumb(value: Float): Variant; overload;
    procedure beforeDestroy;
    function getSubTplData: Variant;
    function getSubmitValue: Variant;
    function getValue: Variant; overload;
    function getValue(index: Float): Variant; overload;
    function getValues: Variant;
    procedure initComponent;
    procedure initValue;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure reset;
    procedure setMaxValue; overload;
    procedure setMaxValue(val: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(val: Float); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Variant); overload;
    procedure syncThumbs;
  end;

//Ext.slider

type
  JIMultiSlider = class external(JExt.form.field.IBase)
    animate: Boolean; // nullable
    clickToChange: Boolean; // nullable
    componentLayout: Variant; // nullable
    constrainThumbs: Boolean; // nullable
    decimalPrecision: Variant; // nullable
    increment: Float; // nullable
    keyIncrement: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    tipText: Variant; // nullable
    useTips: Variant; // nullable
    value: Float; // nullable
    values: array of Float; // nullable
    vertical: Boolean; // nullable
    zeroBasedSnapping: Boolean; // nullable
    dragging: Boolean; // nullable
    thumbs: array of Variant; // nullable
    function addThumb: Variant; overload;
    function addThumb(value: Float): Variant; overload;
    procedure beforeDestroy;
    function getSubTplData: Variant;
    function getSubmitValue: Variant;
    function getValue: Variant; overload;
    function getValue(index: Float): Variant; overload;
    function getValues: Variant;
    procedure initComponent;
    procedure initValue;
    procedure onDisable;
    procedure onEnable;
    procedure onRender;
    procedure reset;
    procedure setMaxValue; overload;
    procedure setMaxValue(val: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(val: Float); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Variant); overload;
    procedure syncThumbs;
  end;

//Ext.slider

type
  JISingle = class external(JExt.slider.IMulti)
    function getValue: Variant;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; animate: Boolean); overload;
  end;

//Ext

type
  JISlider = class external(JExt.slider.IMulti)
    function getValue: Variant;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; animate: Boolean); overload;
  end;

//Ext.form

type
  JISliderField = class external(JExt.slider.IMulti)
    function getValue: Variant;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; animate: Boolean); overload;
  end;

//Ext.slider

type
  JISingleSlider = class external(JExt.slider.IMulti)
    function getValue: Variant;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; animate: Boolean); overload;
  end;

//Ext.slider

type
  JISlider = class external(JExt.slider.IMulti)
    function getValue: Variant;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; animate: Boolean); overload;
  end;

//Ext.slider

type
  JIThumb = class external(JExt.IBase)
    constrain: Boolean; // nullable
    slider: JExt.slider.IMultiSlider; // nullable
    procedure disable;
    procedure enable;
    procedure initEvents;
    procedure render;
  end;

//Ext.slider

type
  JITip = class external(JExt.tip.ITip)
    align: String; // nullable
    minWidth: Float; // nullable
    offsets: array of Variant; // nullable
    position: String; // nullable
    function getText: String; overload;
    function getText(thumb: JExt.slider.IThumb): String; overload;
  end;

//Ext.state

type
  JICookieProvider = class external(JExt.state.IProvider)
    domain: String; // nullable
    expires: Variant; // nullable
    path: String; // nullable
    secure: Boolean; // nullable
    procedure clear; overload;
    procedure clear(name: Variant); overload;
    procedure set; overload;
    procedure set(name: Variant); overload;
    procedure set(name: Variant; value: Variant); overload;
  end;

//Ext.state

type
  JILocalStorageProvider = class external(JExt.state.IProvider)
    procedure clear; overload;
    procedure clear(name: Variant); overload;
    procedure set; overload;
    procedure set(name: Variant); overload;
    procedure set(name: Variant; value: Variant); overload;
  end;

//Ext.state

type
  JManager = class external 'Manager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear; overload;
    procedure clear(name: String); overload;
    function get: Variant; overload;
    function get(name: String): Variant; overload;
    function get(name: String; defaultValue: Variant): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getProvider: JExt.state.IProvider;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure set; overload;
    procedure set(name: String); overload;
    procedure set(name: String; value: Variant); overload;
    procedure setProvider; overload;
    procedure setProvider(stateProvider: JExt.state.IProvider); overload;
    function statics: JExt.IClass;
  end;

  JIManager = class external(JExt.IBase)
  end;

//Ext.state

type
  JIProvider = class external(JExt.IBase, JExt.util.IObservable)
    prefix: String; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clear; overload;
    procedure clear(name: String); overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    function decodeValue: Variant; overload;
    function decodeValue(value: String): Variant; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function encodeValue: String; overload;
    function encodeValue(value: Variant): String; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function get: Variant; overload;
    function get(name: String): Variant; overload;
    function get(name: String; defaultValue: Variant): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure set; overload;
    procedure set(name: String); overload;
    procedure set(name: String; value: Variant); overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.state

type
  JIStateful = class external(JExt.IBase, JExt.util.IObservable)
    saveDelay: Float; // nullable
    stateEvents: array of String; // nullable
    stateId: String; // nullable
    stateful: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure addStateEvents; overload;
    procedure addStateEvents(events: Variant); overload;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function getState: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function savePropToState: Boolean; overload;
    function savePropToState(propName: String): Boolean; overload;
    function savePropToState(propName: String; state: Variant): Boolean; overload;
    function savePropToState(propName: String; state: Variant; stateName: String): Boolean; overload;
    function savePropsToState: Variant; overload;
    function savePropsToState(propNames: Variant): Variant; overload;
    function savePropsToState(propNames: Variant; state: Variant): Variant; overload;
    procedure saveState;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext

type
  JString = class external 'String'
    procedure addCharacterEntities; overload;
    procedure addCharacterEntities(entities: Variant); overload;
    function capitalize: String; overload;
    function capitalize(&string: String): String; overload;
    function createVarName: String; overload;
    function createVarName(s: String): String; overload;
    function ellipsis: String; overload;
    function ellipsis(value: String): String; overload;
    function ellipsis(value: String; _length: Float): String; overload;
    function ellipsis(value: String; _length: Float; word: Boolean): String; overload;
    procedure endsWith; overload;
    procedure endsWith(s: String); overload;
    procedure endsWith(s: String; start: String); overload;
    procedure endsWith(s: String; start: String; ignoreCase: Boolean); overload;
    function escape: String; overload;
    function escape(&string: String): String; overload;
    function escapeRegex: String; overload;
    function escapeRegex(&string: String): String; overload;
    function format(&string: String; values: array of Variant): String;
    function htmlDecode: String; overload;
    function htmlDecode(value: String): String; overload;
    function htmlEncode: String; overload;
    function htmlEncode(value: String): String; overload;
    function insert: String; overload;
    function insert(s: String): String; overload;
    function insert(s: String; value: String): String; overload;
    function insert(s: String; value: String; index: Float): String; overload;
    function leftPad: String; overload;
    function leftPad(&string: String): String; overload;
    function leftPad(&string: String; size: Float): String; overload;
    function leftPad(&string: String; size: Float; character: String): String; overload;
    procedure repeat; overload;
    procedure repeat(pattern: String); overload;
    procedure repeat(pattern: String; count: Float); overload;
    procedure repeat(pattern: String; count: Float; sep: String); overload;
    procedure resetCharacterEntities;
    procedure splitWords; overload;
    procedure splitWords(words: Variant); overload;
    procedure startsWith; overload;
    procedure startsWith(s: String); overload;
    procedure startsWith(s: String; start: String); overload;
    procedure startsWith(s: String; start: String; ignoreCase: Boolean); overload;
    function toggle: String; overload;
    function toggle(&string: String): String; overload;
    function toggle(&string: String; value: String): String; overload;
    function toggle(&string: String; value: String; other: String): String; overload;
    function trim: String; overload;
    function trim(&string: String): String; overload;
    function uncapitalize: String; overload;
    function uncapitalize(&string: String): String; overload;
    function urlAppend: String; overload;
    function urlAppend(url: String): String; overload;
    function urlAppend(url: String; &string: String): String; overload;
  end;

  JIString = class external
  end;

//Ext

type
  JSupports = class external 'Supports'
    ArraySort: Boolean;
    AudioTag: Boolean;
    BoundingClientRect: Boolean;
    CSS3BorderRadius: Boolean;
    CSS3BoxShadow: Boolean;
    CSS3DTransform: Boolean;
    CSS3LinearGradient: Boolean;
    Canvas: Boolean;
    ClassList: Boolean;
    ComputedStyle: Boolean;
    CreateContextualFragment: Boolean;
    DeviceMotion: Boolean;
    Direct2DBug: Boolean;
    DisplayChangeInputSelectionBug: Variant;
    DisplayChangeTextAreaSelectionBug: Variant;
    Float: Boolean;
    GeoLocation: Boolean;
    GetPositionPercentage: Boolean;
    History: Boolean;
    LocalStorage: Variant;
    MouseEnterLeave: Boolean;
    MouseWheel: Boolean;
    Opacity: Boolean;
    OrientationChange: Boolean;
    Placeholder: Boolean;
    PointerEvents: Boolean;
    Range: Boolean;
    RightMargin: Boolean;
    RotatedBoundingClientRect: Boolean;
    ScrollWidthInlinePaddingBug: Boolean;
    Svg: Boolean;
    TextAreaMaxLength: Boolean;
    TimeoutActualLateness: Boolean;
    Touch: Boolean;
    Transitions: Boolean;
    TransparentColor: Boolean;
    Vml: Boolean;
    WindowOnError: Boolean;
  end;

  JISupports = class external
  end;

//Ext.tab

type
  JIBar = class external(JExt.panel.IHeader)
    baseCls: String; // nullable
    maxTabWidth: Float; // nullable
    minTabWidth: Float; // nullable
    plain: Boolean; // nullable
    isTabBar: Boolean; // nullable
    procedure afterComponentLayout; overload;
    procedure afterComponentLayout(width: Variant); overload;
    procedure afterLayout;
    procedure afterRender;
    function getLayout: JExt.layout.container.IContainer;
    procedure onRemove; overload;
    procedure onRemove(tab: Variant); overload;
    procedure onRender;
  end;

//Ext.tab

type
  JIPanel = class external(JExt.panel.IPanel)
    activeItem: Variant; // nullable
    activeTab: Variant; // nullable
    deferredRender: Boolean; // nullable
    itemCls: String; // nullable
    layout: Variant; // nullable
    maxTabWidth: Float; // nullable
    minTabWidth: Float; // nullable
    plain: Boolean; // nullable
    removePanelHeader: Boolean; // nullable
    tabBar: Variant; // nullable
    tabPosition: Variant; // nullable
    function getActiveTab: JExt.IComponent;
    function getTabBar: JExt.tab.IBar;
    procedure onAdd; overload;
    procedure onAdd(item: Variant); overload;
    procedure onAdd(item: Variant; index: Variant); overload;
    function setActiveTab: JExt.IComponent; overload;
    function setActiveTab(card: Variant): JExt.IComponent; overload;
  end;

//Ext

type
  JITabPanel = class external(JExt.panel.IPanel)
    activeItem: Variant; // nullable
    activeTab: Variant; // nullable
    deferredRender: Boolean; // nullable
    itemCls: String; // nullable
    layout: Variant; // nullable
    maxTabWidth: Float; // nullable
    minTabWidth: Float; // nullable
    plain: Boolean; // nullable
    removePanelHeader: Boolean; // nullable
    tabBar: Variant; // nullable
    tabPosition: Variant; // nullable
    function getActiveTab: JExt.IComponent;
    function getTabBar: JExt.tab.IBar;
    procedure onAdd; overload;
    procedure onAdd(item: Variant); overload;
    procedure onAdd(item: Variant; index: Variant); overload;
    function setActiveTab: JExt.IComponent; overload;
    function setActiveTab(card: Variant): JExt.IComponent; overload;
  end;

//Ext.tab

type
  JITab = class external(JExt.button.IButton)
    activeCls: String; // nullable
    baseCls: String; // nullable
    closable: Boolean; // nullable
    closableCls: String; // nullable
    closeText: String; // nullable
    disabledCls: String; // nullable
    scale: Variant; // nullable
    active: Boolean; // nullable
    isTab: Boolean; // nullable
    procedure disable; overload;
    procedure disable(silent: Variant); overload;
    procedure enable; overload;
    procedure enable(silent: Variant); overload;
    function getTemplateArgs: Variant;
    procedure initComponent;
    procedure setCard; overload;
    procedure setCard(card: JExt.IComponent); overload;
    procedure setClosable; overload;
    procedure setClosable(closable: Boolean); overload;
  end;

//Ext

type
  JTemplate = class external 'Template'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.ITemplate; overload;
    function from(el: Variant): JExt.ITemplate; overload;
    function from(el: Variant; config: Variant): JExt.ITemplate; overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JITemplate = class external(JExt.IBase)
    compiled: Boolean; // nullable
    disableFormats: Boolean; // nullable
    isTemplate: Boolean; // nullable
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; values: Variant): Variant; overload;
    function append(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function apply: String; overload;
    function apply(values: Variant): String; overload;
    function applyOut: array of Variant; overload;
    function applyOut(values: Variant): array of Variant; overload;
    function applyOut(values: Variant; out: array of Variant): array of Variant; overload;
    function applyTemplate: String; overload;
    function applyTemplate(values: Variant): String; overload;
    function compile: JExt.ITemplate;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; values: Variant): Variant; overload;
    function insertAfter(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; values: Variant): Variant; overload;
    function insertBefore(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; values: Variant): Variant; overload;
    function insertFirst(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; values: Variant): Variant; overload;
    function overwrite(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function set: JExt.ITemplate; overload;
    function set(html: String): JExt.ITemplate; overload;
    function set(html: String; compile: Boolean): JExt.ITemplate; overload;
  end;

//Ext.tip

type
  JIQuickTip = class external(JExt.tip.IToolTip)
    interceptTitles: Boolean; // nullable
    target: Variant; // nullable
    title: String; // nullable
    procedure cancelShow; overload;
    procedure cancelShow(el: Variant); overload;
    procedure register; overload;
    procedure register(config: Variant); overload;
    procedure unregister; overload;
    procedure unregister(el: Variant); overload;
  end;

//Ext

type
  JIQuickTip = class external(JExt.tip.IToolTip)
    interceptTitles: Boolean; // nullable
    target: Variant; // nullable
    title: String; // nullable
    procedure cancelShow; overload;
    procedure cancelShow(el: Variant); overload;
    procedure register; overload;
    procedure register(config: Variant); overload;
    procedure unregister; overload;
    procedure unregister(el: Variant); overload;
  end;

//Ext.tip

type
  JQuickTipManager = class external 'QuickTipManager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    procedure disable;
    procedure enable;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getQuickTip: JExt.tip.IQuickTip;
    procedure init; overload;
    procedure init(autoRender: Boolean); overload;
    procedure init(autoRender: Boolean; config: Variant); overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isEnabled: Boolean;
    procedure register; overload;
    procedure register(config: Variant); overload;
    function statics: JExt.IClass;
    procedure tips; overload;
    procedure tips(config: Variant); overload;
    procedure unregister; overload;
    procedure unregister(el: Variant); overload;
  end;

  JIQuickTipManager = class external(JExt.IBase)
  end;

//Ext

type
  JQuickTips = class external 'QuickTips'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    procedure disable;
    procedure enable;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getQuickTip: JExt.tip.IQuickTip;
    procedure init; overload;
    procedure init(autoRender: Boolean); overload;
    procedure init(autoRender: Boolean; config: Variant); overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isEnabled: Boolean;
    procedure register; overload;
    procedure register(config: Variant); overload;
    function statics: JExt.IClass;
    procedure tips; overload;
    procedure tips(config: Variant); overload;
    procedure unregister; overload;
    procedure unregister(el: Variant); overload;
  end;

  JIQuickTips = class external(JExt.IBase)
  end;

//Ext.tip

type
  JITip = class external(JExt.panel.IPanel)
    autoRender: Variant; // nullable
    baseCls: String; // nullable
    closable: Boolean; // nullable
    closeAction: String; // nullable
    constrainPosition: Boolean; // nullable
    defaultAlign: String; // nullable
    floating: Boolean; // nullable
    focusOnToFront: Boolean; // nullable
    frameHeader: Boolean; // nullable
    hidden: Boolean; // nullable
    maxWidth: Float; // nullable
    minWidth: Float; // nullable
    shadow: Variant; // nullable
    width: Float; // nullable
  end;

//Ext

type
  JITip = class external(JExt.panel.IPanel)
    autoRender: Variant; // nullable
    baseCls: String; // nullable
    closable: Boolean; // nullable
    closeAction: String; // nullable
    constrainPosition: Boolean; // nullable
    defaultAlign: String; // nullable
    floating: Boolean; // nullable
    focusOnToFront: Boolean; // nullable
    frameHeader: Boolean; // nullable
    hidden: Boolean; // nullable
    maxWidth: Float; // nullable
    minWidth: Float; // nullable
    shadow: Variant; // nullable
    width: Float; // nullable
  end;

//Ext.tip

type
  JIToolTip = class external(JExt.tip.ITip)
    anchor: String; // nullable
    anchorOffset: Float; // nullable
    anchorToTarget: Boolean; // nullable
    autoHide: Boolean; // nullable
    delegate: String; // nullable
    dismissDelay: Float; // nullable
    hideDelay: Float; // nullable
    mouseOffset: array of Float; // nullable
    showDelay: Float; // nullable
    target: Variant; // nullable
    trackMouse: Boolean; // nullable
    triggerElement: JHTMLElement; // nullable
    procedure setTarget; overload;
    procedure setTarget(t: Variant); overload;
  end;

//Ext

type
  JIToolTip = class external(JExt.tip.ITip)
    anchor: String; // nullable
    anchorOffset: Float; // nullable
    anchorToTarget: Boolean; // nullable
    autoHide: Boolean; // nullable
    delegate: String; // nullable
    dismissDelay: Float; // nullable
    hideDelay: Float; // nullable
    mouseOffset: array of Float; // nullable
    showDelay: Float; // nullable
    target: Variant; // nullable
    trackMouse: Boolean; // nullable
    triggerElement: JHTMLElement; // nullable
    procedure setTarget; overload;
    procedure setTarget(t: Variant); overload;
  end;

//Ext.toolbar

type
  JIFill = class external(JExt.IComponent)
    isFill: Boolean; // nullable
  end;

//Ext.toolbar

type
  JIItem = class external(JExt.IComponent)
    overflowText: String; // nullable
    procedure disable;
    procedure enable;
    function focus: JExt.IComponent;
  end;

//Ext.toolbar

type
  JIPaging = class external(JExt.toolbar.IToolbar, JExt.util.IBindable)
    afterPageText: String; // nullable
    beforePageText: String; // nullable
    displayInfo: Boolean; // nullable
    displayMsg: String; // nullable
    emptyMsg: String; // nullable
    firstText: String; // nullable
    inputItemWidth: Float; // nullable
    lastText: String; // nullable
    nextText: String; // nullable
    prependButtons: Boolean; // nullable
    prevText: String; // nullable
    refreshText: String; // nullable
    store: JExt.data.IStore; // nullable
    procedure bind; overload;
    procedure bind(store: JExt.data.IStore); overload;
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure doRefresh;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant;
    procedure moveFirst;
    procedure moveLast;
    procedure moveNext;
    procedure movePrevious;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure unbind; overload;
    procedure unbind(store: JExt.data.IStore); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext

type
  JIPagingToolbar = class external(JExt.toolbar.IToolbar, JExt.util.IBindable)
    afterPageText: String; // nullable
    beforePageText: String; // nullable
    displayInfo: Boolean; // nullable
    displayMsg: String; // nullable
    emptyMsg: String; // nullable
    firstText: String; // nullable
    inputItemWidth: Float; // nullable
    lastText: String; // nullable
    nextText: String; // nullable
    prependButtons: Boolean; // nullable
    prevText: String; // nullable
    refreshText: String; // nullable
    store: JExt.data.IStore; // nullable
    procedure bind; overload;
    procedure bind(store: JExt.data.IStore); overload;
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure doRefresh;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant;
    procedure moveFirst;
    procedure moveLast;
    procedure moveNext;
    procedure movePrevious;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure unbind; overload;
    procedure unbind(store: JExt.data.IStore); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.toolbar

type
  JISeparator = class external(JExt.toolbar.IItem)
    baseCls: String; // nullable
  end;

//Ext.toolbar

type
  JISpacer = class external(JExt.IComponent)
    baseCls: String; // nullable
  end;

//Ext.toolbar

type
  JITextItem = class external(JExt.toolbar.IItem)
    baseCls: String; // nullable
    renderTpl: Variant; // nullable
    text: String; // nullable
    procedure setText; overload;
    procedure setText(text: String); overload;
  end;

//Ext.toolbar

type
  JIToolbar = class external(JExt.container.IContainer)
    baseCls: String; // nullable
    defaultButtonUI: String; // nullable
    defaultType: String; // nullable
    enableOverflow: Boolean; // nullable
    layout: Variant; // nullable
    menuTriggerCls: String; // nullable
    vertical: Boolean; // nullable
    isToolbar: Boolean; // nullable
    function add: Variant; overload;
    function add(args: Variant): Variant; overload;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function insert: JExt.IComponent; overload;
    function insert(index: Float): JExt.IComponent; overload;
    function insert(index: Float; component: Variant): JExt.IComponent; overload;
  end;

//Ext

type
  JIToolbar = class external(JExt.container.IContainer)
    baseCls: String; // nullable
    defaultButtonUI: String; // nullable
    defaultType: String; // nullable
    enableOverflow: Boolean; // nullable
    layout: Variant; // nullable
    menuTriggerCls: String; // nullable
    vertical: Boolean; // nullable
    isToolbar: Boolean; // nullable
    function add: Variant; overload;
    function add(args: Variant): Variant; overload;
    procedure getRefItems; overload;
    procedure getRefItems(deep: Variant); overload;
    function insert: JExt.IComponent; overload;
    function insert(index: Float): JExt.IComponent; overload;
    function insert(index: Float; component: Variant): JExt.IComponent; overload;
  end;

//Ext.tree

type
  JIColumn = class external(JExt.grid.column.IColumn)
    hideable: Boolean; // nullable
    lockable: Boolean; // nullable
    tdCls: String; // nullable
    draggable: Boolean; // nullable
  end;

//Ext.tree

type
  JIPanel = class external(JExt.panel.ITable)
    animate: Boolean; // nullable
    deferRowRender: Boolean; // nullable
    displayField: String; // nullable
    folderSort: Boolean; // nullable
    hideHeaders: Boolean; // nullable
    lines: Boolean; // nullable
    root: Variant; // nullable
    rootVisible: Boolean; // nullable
    rowLines: Boolean; // nullable
    selType: String; // nullable
    singleExpand: Boolean; // nullable
    store: JExt.data.ITreeStore; // nullable
    useArrows: Boolean; // nullable
    viewType: String; // nullable
    procedure collapseAll; overload;
    procedure collapseAll(callback: Variant); overload;
    procedure collapseAll(callback: Variant; scope: Variant); overload;
    procedure collapseNode; overload;
    procedure collapseNode(record: JExt.data.IModel); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandAll; overload;
    procedure expandAll(callback: Variant); overload;
    procedure expandAll(callback: Variant; scope: Variant); overload;
    procedure expandNode; overload;
    procedure expandNode(record: JExt.data.IModel); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandPath; overload;
    procedure expandPath(path: String); overload;
    procedure expandPath(path: String; field: String); overload;
    procedure expandPath(path: String; field: String; separator: String); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function getChecked: array of JExt.data.INodeInterface;
    function getRootNode: JExt.data.INodeInterface;
    procedure selectPath; overload;
    procedure selectPath(path: String); overload;
    procedure selectPath(path: String; field: String); overload;
    procedure selectPath(path: String; field: String; separator: String); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function setRootNode: JExt.data.INodeInterface; overload;
    function setRootNode(root: Variant): JExt.data.INodeInterface; overload;
  end;

//Ext.tree

type
  JITreePanel = class external(JExt.panel.ITable)
    animate: Boolean; // nullable
    deferRowRender: Boolean; // nullable
    displayField: String; // nullable
    folderSort: Boolean; // nullable
    hideHeaders: Boolean; // nullable
    lines: Boolean; // nullable
    root: Variant; // nullable
    rootVisible: Boolean; // nullable
    rowLines: Boolean; // nullable
    selType: String; // nullable
    singleExpand: Boolean; // nullable
    store: JExt.data.ITreeStore; // nullable
    useArrows: Boolean; // nullable
    viewType: String; // nullable
    procedure collapseAll; overload;
    procedure collapseAll(callback: Variant); overload;
    procedure collapseAll(callback: Variant; scope: Variant); overload;
    procedure collapseNode; overload;
    procedure collapseNode(record: JExt.data.IModel); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandAll; overload;
    procedure expandAll(callback: Variant); overload;
    procedure expandAll(callback: Variant; scope: Variant); overload;
    procedure expandNode; overload;
    procedure expandNode(record: JExt.data.IModel); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandPath; overload;
    procedure expandPath(path: String); overload;
    procedure expandPath(path: String; field: String); overload;
    procedure expandPath(path: String; field: String; separator: String); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function getChecked: array of JExt.data.INodeInterface;
    function getRootNode: JExt.data.INodeInterface;
    procedure selectPath; overload;
    procedure selectPath(path: String); overload;
    procedure selectPath(path: String; field: String); overload;
    procedure selectPath(path: String; field: String; separator: String); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function setRootNode: JExt.data.INodeInterface; overload;
    function setRootNode(root: Variant): JExt.data.INodeInterface; overload;
  end;

//Ext

type
  JITreePanel = class external(JExt.panel.ITable)
    animate: Boolean; // nullable
    deferRowRender: Boolean; // nullable
    displayField: String; // nullable
    folderSort: Boolean; // nullable
    hideHeaders: Boolean; // nullable
    lines: Boolean; // nullable
    root: Variant; // nullable
    rootVisible: Boolean; // nullable
    rowLines: Boolean; // nullable
    selType: String; // nullable
    singleExpand: Boolean; // nullable
    store: JExt.data.ITreeStore; // nullable
    useArrows: Boolean; // nullable
    viewType: String; // nullable
    procedure collapseAll; overload;
    procedure collapseAll(callback: Variant); overload;
    procedure collapseAll(callback: Variant; scope: Variant); overload;
    procedure collapseNode; overload;
    procedure collapseNode(record: JExt.data.IModel); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure collapseNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandAll; overload;
    procedure expandAll(callback: Variant); overload;
    procedure expandAll(callback: Variant; scope: Variant); overload;
    procedure expandNode; overload;
    procedure expandNode(record: JExt.data.IModel); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure expandNode(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expandPath; overload;
    procedure expandPath(path: String); overload;
    procedure expandPath(path: String; field: String); overload;
    procedure expandPath(path: String; field: String; separator: String); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure expandPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function getChecked: array of JExt.data.INodeInterface;
    function getRootNode: JExt.data.INodeInterface;
    procedure selectPath; overload;
    procedure selectPath(path: String); overload;
    procedure selectPath(path: String; field: String); overload;
    procedure selectPath(path: String; field: String; separator: String); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant); overload;
    procedure selectPath(path: String; field: String; separator: String; callback: Variant; scope: Variant); overload;
    function setRootNode: JExt.data.INodeInterface; overload;
    function setRootNode(root: Variant): JExt.data.INodeInterface; overload;
  end;

//Ext.tree.plugin

type
  JITreeViewDragDrop = class external(JExt.IAbstractPlugin)
    allowContainerDrops: Boolean; // nullable
    allowParentInserts: Boolean; // nullable
    appendOnly: Boolean; // nullable
    containerScroll: Variant; // nullable
    ddGroup: String; // nullable
    displayField: String; // nullable
    dragGroup: String; // nullable
    dragText: String; // nullable
    dropGroup: String; // nullable
    enableDrag: Boolean; // nullable
    enableDrop: Boolean; // nullable
    expandDelay: Float; // nullable
    nodeHighlightColor: String; // nullable
    nodeHighlightOnDrop: Boolean; // nullable
    nodeHighlightOnRepair: Boolean; // nullable
    sortOnDrop: Boolean; // nullable
    procedure init; overload;
    procedure init(view: Variant); overload;
  end;

//Ext.tree

type
  JIView = class external(JExt.view.ITable)
    animate: Boolean; // nullable
    blockRefresh: Boolean; // nullable
    deferInitialRefresh: Boolean; // nullable
    loadMask: Boolean; // nullable
    loadingCls: String; // nullable
    rootVisible: Boolean; // nullable
    stripeRows: Boolean; // nullable
    isTreeView: Boolean; // nullable
    procedure afterComponentLayout;
    procedure collapse; overload;
    procedure collapse(record: JExt.data.IModel); overload;
    procedure collapse(record: JExt.data.IModel; deep: Boolean); overload;
    procedure collapse(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure collapse(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    procedure expand; overload;
    procedure expand(record: JExt.data.IModel); overload;
    procedure expand(record: JExt.data.IModel; deep: Boolean); overload;
    procedure expand(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure expand(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
    function getStoreListeners: Variant;
    procedure getTreeStore;
    procedure initComponent;
    procedure onBindStore;
    procedure onUnbindStore;
    procedure toggle; overload;
    procedure toggle(record: JExt.data.IModel); overload;
    procedure toggle(record: JExt.data.IModel; deep: Boolean); overload;
    procedure toggle(record: JExt.data.IModel; deep: Boolean; callback: Variant); overload;
    procedure toggle(record: JExt.data.IModel; deep: Boolean; callback: Variant; scope: Variant); overload;
  end;

//Ext.tree

type
  JIViewDragZone = class external(JExt.view.IDragZone)
  end;

//Ext.tree

type
  JIViewDropZone = class external(JExt.view.IDropZone)
    allowContainerDrop: Boolean; // nullable
    allowParentInserts: Boolean; // nullable
    appendOnly: Boolean; // nullable
    expandDelay: Float; // nullable
    procedure notifyOut;
    function onContainerOver: String; overload;
    function onContainerOver(dd: Variant): String; overload;
    function onContainerOver(dd: Variant; e: Variant): String; overload;
    function onContainerOver(dd: Variant; e: Variant; data: Variant): String; overload;
    procedure onNodeOut; overload;
    procedure onNodeOut(n: Variant); overload;
    procedure onNodeOut(n: Variant; dd: Variant); overload;
    procedure onNodeOut(n: Variant; dd: Variant; e: Variant); overload;
    procedure onNodeOut(n: Variant; dd: Variant; e: Variant; data: Variant); overload;
    function onNodeOver: String; overload;
    function onNodeOver(node: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant; data: Variant): String; overload;
  end;

//Ext.util

type
  JIAbstractMixedCollection = class external(JExt.IBase, JExt.util.IObservable)
    allowFunctions: Boolean; // nullable
    isMixedCollection: Boolean; // nullable
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; obj: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clear;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowBlank: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure find;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(startIndex: Float): array of Variant; overload;
    function getRange(startIndex: Float; endIndex: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: Variant): Variant; overload;
    function insert(index: Float; key: Variant; o: Variant): Variant; overload;
    function last: Variant;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function removeRange: Variant; overload;
    function removeRange(index: Float): Variant; overload;
    function removeRange(index: Float; removeCount: Float): Variant; overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
    procedure updateKey; overload;
    procedure updateKey(oldKey: Variant); overload;
    procedure updateKey(oldKey: Variant; newKey: Variant); overload;
  end;

//Ext.util

type
  JIAnimate = class external(JExt.IBase)
    animate: Variant; // nullable
    function getActiveAnimation: Variant;
    function hasActiveFx: Variant;
    function sequenceFx: Variant;
    function stopAnimation: JExt.IElement;
    function stopFx: JExt.IElement;
    function syncFx: Variant;
  end;

//Ext.util

type
  JIBindable = class external(JExt.IBase)
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    function getStore: JExt.data.IAbstractStore;
    function getStoreListeners: Variant; overload;
    function getStoreListeners(store: JExt.data.IStore): Variant; overload;
    procedure onBindStore; overload;
    procedure onBindStore(store: JExt.data.IAbstractStore); overload;
    procedure onBindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore); overload;
    procedure onUnbindStore(store: JExt.data.IAbstractStore; initial: Boolean); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.util

type
  JIClickRepeater = class external(JExt.util.IObservable)
    accelerate: Boolean; // nullable
    delay: Float; // nullable
    el: Variant; // nullable
    interval: Float; // nullable
    pressedCls: String; // nullable
    preventDefault: Boolean; // nullable
    stopDefault: Boolean; // nullable
    procedure disable; overload;
    procedure disable(force: Variant); overload;
    procedure enable;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
  end;

//Ext.util

type
  JIComponentDragger = class external(JExt.dd.IDragTracker)
    constrain: Boolean; // nullable
    constrainDelegate: Boolean; // nullable
    procedure onDrag; overload;
    procedure onDrag(e: Variant); overload;
    procedure onEnd; overload;
    procedure onEnd(e: Variant); overload;
    procedure onStart; overload;
    procedure onStart(e: Variant); overload;
  end;

//Ext.util

type
  JCookies = class external 'Cookies'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear; overload;
    procedure clear(name: String); overload;
    procedure clear(name: String; path: String); overload;
    function get: Variant; overload;
    function get(name: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure set; overload;
    procedure set(name: String); overload;
    procedure set(name: String; value: Variant); overload;
    procedure set(name: String; value: Variant; expires: Variant); overload;
    procedure set(name: String; value: Variant; expires: Variant; path: String); overload;
    procedure set(name: String; value: Variant; expires: Variant; path: String; domain: String); overload;
    procedure set(name: String; value: Variant; expires: Variant; path: String; domain: String; secure: Boolean); overload;
    function statics: JExt.IClass;
  end;

  JICookies = class external(JExt.IBase)
  end;

//Ext.util

type
  JCSS = class external 'CSS'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function createRule: JCSSStyleRule; overload;
    function createRule(styleSheet: JCSSStyleSheet): JCSSStyleRule; overload;
    function createRule(styleSheet: JCSSStyleSheet; selector: String): JCSSStyleRule; overload;
    function createRule(styleSheet: JCSSStyleSheet; selector: String; &property: String): JCSSStyleRule; overload;
    function createStyleSheet: JCSSStyleSheet; overload;
    function createStyleSheet(cssText: String): JCSSStyleSheet; overload;
    function createStyleSheet(cssText: String; id: String): JCSSStyleSheet; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getRule: JCSSStyleRule; overload;
    function getRule(selector: Variant): JCSSStyleRule; overload;
    function getRule(selector: Variant; refreshCache: Boolean): JCSSStyleRule; overload;
    function getRules: Variant; overload;
    function getRules(refreshCache: Boolean): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function refreshCache: Variant;
    procedure removeStyleSheet; overload;
    procedure removeStyleSheet(id: String); overload;
    function statics: JExt.IClass;
    procedure swapStyleSheet; overload;
    procedure swapStyleSheet(id: String); overload;
    procedure swapStyleSheet(id: String; url: String); overload;
    function updateRule: Boolean; overload;
    function updateRule(selector: Variant): Boolean; overload;
    function updateRule(selector: Variant; &property: String): Boolean; overload;
    function updateRule(selector: Variant; &property: String; value: String): Boolean; overload;
  end;

  JICSS = class external(JExt.IBase)
  end;

//Ext.util

type
  JIDelayedTask = class external
    id: Float; // nullable
    procedure cancel;
    procedure delay; overload;
    procedure delay(newDelay: Float); overload;
    procedure delay(newDelay: Float; newFn: Variant); overload;
    procedure delay(newDelay: Float; newFn: Variant; newScope: Variant); overload;
    procedure delay(newDelay: Float; newFn: Variant; newScope: Variant; newArgs: array of Variant); overload;
  end;

//Ext.util

type
  JIElementContainer = class external(JExt.IBase)
    procedure addChildEls;
    procedure removeChildEls; overload;
    procedure removeChildEls(testFn: Variant); overload;
  end;

//Ext.util

type
  JIEvent = class external(JExt.IBase)
    isEvent: Boolean; // nullable
  end;

//Ext.util

type
  JFilter = class external 'Filter'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function createFilterFn: Variant; overload;
    function createFilterFn(filters: array of JExt.util.IFilter): Variant; overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIFilter = class external(JExt.IBase)
    anyMatch: Boolean; // nullable
    caseSensitive: Boolean; // nullable
    exactMatch: Boolean; // nullable
    filterFn: Variant; // nullable
    id: String; // nullable
    operator: String; // nullable
    &property: String; // nullable
    root: String; // nullable
    value: Variant; // nullable
    disabled: Boolean; // nullable
    procedure setFilterFn; overload;
    procedure setFilterFn(filterFn: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.util

type
  JIFloating = class external(JExt.IBase)
    constrain: Boolean; // nullable
    fixed: Boolean; // nullable
    focusOnToFront: Boolean; // nullable
    shadow: Variant; // nullable
    shadowOffset: Float; // nullable
    function center: JExt.IComponent;
    procedure doConstrain; overload;
    procedure doConstrain(constrainTo: Variant); overload;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActive(active: Boolean; newActive: JExt.IComponent); overload;
    function toBack: JExt.IComponent;
    function toFront: JExt.IComponent; overload;
    function toFront(preventFocus: Boolean): JExt.IComponent; overload;
  end;

//Ext.util

type
  JFormat = class external 'Format'
    currencyAtEnd: Boolean;
    currencyPrecision: Float;
    currencySign: String;
    decimalSeparator: String;
    thousandSeparator: String;
    procedure attributes; overload;
    procedure attributes(attributes: Variant); overload;
    function capitalize: String; overload;
    function capitalize(&string: String): String; overload;
    function currency: String; overload;
    function currency(value: Variant): String; overload;
    function currency(value: Variant; sign: String): String; overload;
    function currency(value: Variant; sign: String; decimals: Float): String; overload;
    function currency(value: Variant; sign: String; decimals: Float; &end: Boolean): String; overload;
    function date: String; overload;
    function date(value: Variant): String; overload;
    function date(value: Variant; format: String): String; overload;
    function dateRenderer: Variant; overload;
    function dateRenderer(format: String): Variant; overload;
    function defaultValue: String; overload;
    function defaultValue(value: Variant): String; overload;
    function defaultValue(value: Variant; defaultValue: String): String; overload;
    function ellipsis: String; overload;
    function ellipsis(value: String): String; overload;
    function ellipsis(value: String; _length: Float): String; overload;
    function ellipsis(value: String; _length: Float; word: Boolean): String; overload;
    function escapeRegex: String; overload;
    function escapeRegex(str: String): String; overload;
    function fileSize: String; overload;
    function fileSize(size: Variant): String; overload;
    function format(&string: String; values: array of Variant): String;
    function htmlDecode: String; overload;
    function htmlDecode(value: String): String; overload;
    function htmlEncode: String; overload;
    function htmlEncode(value: String): String; overload;
    function leftPad: String; overload;
    function leftPad(&string: String): String; overload;
    function leftPad(&string: String; size: Float): String; overload;
    function leftPad(&string: String; size: Float; character: String): String; overload;
    function lowercase: String; overload;
    function lowercase(value: String): String; overload;
    function math: Variant;
    function nl2br: String; overload;
    function nl2br(v: String): String; overload;
    function number: String; overload;
    function number(v: Float): String; overload;
    function number(v: Float; format: String): String; overload;
    function numberRenderer: Variant; overload;
    function numberRenderer(format: String): Variant; overload;
    function parseBox: Variant; overload;
    function parseBox(v: Variant): Variant; overload;
    procedure plural; overload;
    procedure plural(value: Float); overload;
    procedure plural(value: Float; singular: String); overload;
    procedure plural(value: Float; singular: String; plural: String); overload;
    function round: Float; overload;
    function round(value: Variant): Float; overload;
    function round(value: Variant; precision: Float): Float; overload;
    function stripScripts: String; overload;
    function stripScripts(value: Variant): String; overload;
    function stripTags: String; overload;
    function stripTags(value: Variant): String; overload;
    function substr: String; overload;
    function substr(value: String): String; overload;
    function substr(value: String; start: Float): String; overload;
    function substr(value: String; start: Float; _length: Float): String; overload;
    function trim: String; overload;
    function trim(&string: String): String; overload;
    function undef: Variant; overload;
    function undef(value: Variant): Variant; overload;
    function uppercase: String; overload;
    function uppercase(value: String): String; overload;
    function usMoney: String; overload;
    function usMoney(value: Variant): String; overload;
  end;

  JIFormat = class external
  end;

//Ext.util

type
  JIGrouper = class external(JExt.util.ISorter)
    function getGroupString: String; overload;
    function getGroupString(instance: JExt.data.IModel): String; overload;
  end;

//Ext.util

type
  JIHashMap = class external(JExt.IBase, JExt.util.IObservable)
    keyFn: Variant; // nullable
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; o: Variant): Variant; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function clear: JExt.util.IHashMap; overload;
    function clear(initial: Variant): JExt.util.IHashMap; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    function clone: JExt.util.IHashMap;
    function contains: Boolean; overload;
    function contains(value: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    function each: JExt.util.IHashMap; overload;
    function each(fn: Variant): JExt.util.IHashMap; overload;
    function each(fn: Variant; scope: Variant): JExt.util.IHashMap; overload;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function get: Variant; overload;
    function get(key: String): Variant; overload;
    function getCount: Float;
    function getKey: String; overload;
    function getKey(o: Variant): String; overload;
    function getKeys: array of Variant;
    function getValues: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    function remove: Boolean; overload;
    function remove(o: Variant): Boolean; overload;
    function removeAtKey: Boolean; overload;
    function removeAtKey(key: String): Boolean; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; value: Variant): Variant; overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.util

type
  JHistory = class external 'History'
    fieldId: String;
    hasListeners: Variant;
    iframeId: String;
    isObservable: Boolean;
    self: JExt.IClass;
    useTopWindow: Boolean;
    procedure add; overload;
    procedure add(token: String); overload;
    procedure add(token: String; preventDuplicates: Boolean); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure back;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    procedure forward;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getToken: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure init; overload;
    procedure init(onReady: Variant); overload;
    procedure init(onReady: Variant; scope: Variant); overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIHistory = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext

type
  JHistory = class external 'History'
    fieldId: String;
    hasListeners: Variant;
    iframeId: String;
    isObservable: Boolean;
    self: JExt.IClass;
    useTopWindow: Boolean;
    procedure add; overload;
    procedure add(token: String); overload;
    procedure add(token: String; preventDuplicates: Boolean); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure back;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    procedure forward;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getToken: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure init; overload;
    procedure init(onReady: Variant); overload;
    procedure init(onReady: Variant; scope: Variant); overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    function statics: JExt.IClass;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIHistory = class external(JExt.IBase, JExt.util.IObservable)
  end;

//Ext.util

type
  JInflector = class external 'Inflector'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function classify: String; overload;
    function classify(word: String): String; overload;
    procedure clearPlurals;
    procedure clearSingulars;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    function isTransnumeral: Boolean; overload;
    function isTransnumeral(word: String): Boolean; overload;
    function ordinalize: String; overload;
    function ordinalize(number: Float): String; overload;
    procedure plural; overload;
    procedure plural(matcher: JRegExp); overload;
    procedure plural(matcher: JRegExp; replacer: String); overload;
    function pluralize: String; overload;
    function pluralize(word: String): String; overload;
    procedure singular; overload;
    procedure singular(matcher: JRegExp); overload;
    procedure singular(matcher: JRegExp; replacer: String); overload;
    function singularize: String; overload;
    function singularize(word: String): String; overload;
    function statics: JExt.IClass;
  end;

  JIInflector = class external(JExt.IBase)
  end;

//Ext.util

type
  JIKeyMap = class external(JExt.IBase)
    binding: Variant; // nullable
    eventName: String; // nullable
    ignoreInputFields: Boolean; // nullable
    processEvent: Variant; // nullable
    processEventScope: Variant; // nullable
    target: Variant; // nullable
    procedure addBinding; overload;
    procedure addBinding(binding: Variant); overload;
    procedure destroy; overload;
    procedure destroy(removeTarget: Boolean); overload;
    procedure disable;
    procedure enable;
    function isEnabled: Boolean;
    procedure on; overload;
    procedure on(key: Variant); overload;
    procedure on(key: Variant; fn: Variant); overload;
    procedure on(key: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBinding; overload;
    procedure removeBinding(binding: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure un; overload;
    procedure un(key: Variant); overload;
    procedure un(key: Variant; fn: Variant); overload;
    procedure un(key: Variant; fn: Variant; scope: Variant); overload;
  end;

//Ext

type
  JIKeyMap = class external(JExt.IBase)
    binding: Variant; // nullable
    eventName: String; // nullable
    ignoreInputFields: Boolean; // nullable
    processEvent: Variant; // nullable
    processEventScope: Variant; // nullable
    target: Variant; // nullable
    procedure addBinding; overload;
    procedure addBinding(binding: Variant); overload;
    procedure destroy; overload;
    procedure destroy(removeTarget: Boolean); overload;
    procedure disable;
    procedure enable;
    function isEnabled: Boolean;
    procedure on; overload;
    procedure on(key: Variant); overload;
    procedure on(key: Variant; fn: Variant); overload;
    procedure on(key: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBinding; overload;
    procedure removeBinding(binding: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure un; overload;
    procedure un(key: Variant); overload;
    procedure un(key: Variant; fn: Variant); overload;
    procedure un(key: Variant; fn: Variant; scope: Variant); overload;
  end;

//Ext.util

type
  JIKeyNav = class external(JExt.IBase)
    defaultEventAction: String; // nullable
    disabled: Boolean; // nullable
    eventName: String; // nullable
    forceKeyDown: Boolean; // nullable
    ignoreInputFields: Boolean; // nullable
    keyMap: JExt.util.IKeyMap; // nullable
    processEvent: Variant; // nullable
    processEventScope: Variant; // nullable
    target: Variant; // nullable
    procedure destroy; overload;
    procedure destroy(removeEl: Boolean); overload;
    procedure disable;
    procedure enable;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
  end;

//Ext

type
  JIKeyNav = class external(JExt.IBase)
    defaultEventAction: String; // nullable
    disabled: Boolean; // nullable
    eventName: String; // nullable
    forceKeyDown: Boolean; // nullable
    ignoreInputFields: Boolean; // nullable
    keyMap: JExt.util.IKeyMap; // nullable
    processEvent: Variant; // nullable
    processEventScope: Variant; // nullable
    target: Variant; // nullable
    procedure destroy; overload;
    procedure destroy(removeEl: Boolean); overload;
    procedure disable;
    procedure enable;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
  end;

//Ext.util

type
  JILruCache = class external(JExt.util.IHashMap)
    maxSize: Float; // nullable
    function add: Variant; overload;
    function add(key: Variant): Variant; overload;
    function add(key: Variant; newValue: Variant): Variant; overload;
    function clear: JExt.util.IHashMap; overload;
    function clear(initial: Variant): JExt.util.IHashMap; overload;
    function clone: JExt.util.IHashMap;
    function each: JExt.util.ILruCache; overload;
    function each(fn: Variant): JExt.util.ILruCache; overload;
    function each(fn: Variant; scope: Variant): JExt.util.ILruCache; overload;
    function each(fn: Variant; scope: Variant; reverse: Boolean): JExt.util.ILruCache; overload;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    procedure prune;
  end;

//Ext.util

type
  JIMemento = class external(JExt.IBase)
    target: Variant; // nullable
    procedure capture; overload;
    procedure capture(props: Variant); overload;
    procedure capture(props: Variant; target: Variant); overload;
    procedure remove; overload;
    procedure remove(props: Variant); overload;
    procedure restore; overload;
    procedure restore(props: Variant); overload;
    procedure restore(props: Variant; clear: Boolean); overload;
    procedure restore(props: Variant; clear: Boolean; target: Variant); overload;
    procedure restoreAll; overload;
    procedure restoreAll(clear: Boolean); overload;
    procedure restoreAll(clear: Boolean; target: Variant); overload;
  end;

//Ext.util

type
  JIMixedCollection = class external(JExt.util.IAbstractMixedCollection, JExt.util.ISortable)
    allowFunctions: Boolean; // nullable
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(newItem: Variant): Float; overload;
    function findInsertionIndex(newItem: Variant; sorterFn: Variant): Float; overload;
    procedure generateComparator;
    function getFirstSorter: JExt.util.ISorter;
    procedure initSortable;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(direction: String); overload;
    procedure sortByKey(direction: String; fn: Variant); overload;
  end;

//Ext.util

type
  JObservable = class external 'Observable'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure capture; overload;
    procedure capture(o: JExt.util.IObservable); overload;
    procedure capture(o: JExt.util.IObservable; fn: Variant); overload;
    procedure capture(o: JExt.util.IObservable; fn: Variant; scope: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure implement;
    procedure observe; overload;
    procedure observe(c: Variant); overload;
    procedure observe(c: Variant; listeners: Variant); overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    procedure releaseCapture; overload;
    procedure releaseCapture(o: JExt.util.IObservable); overload;
  end;

  JIObservable = class external(JExt.IBase)
    listeners: Variant; // nullable
    hasListeners: Variant; // nullable
    isObservable: Boolean; // nullable
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    function addListener: Variant; overload;
    function addListener(eventName: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function addManagedListener: Variant; overload;
    function addManagedListener(item: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function addManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure clearListeners;
    procedure clearManagedListeners;
    procedure enableBubble; overload;
    procedure enableBubble(eventNames: Variant); overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function fireEventArgs: Boolean; overload;
    function fireEventArgs(eventName: String): Boolean; overload;
    function fireEventArgs(eventName: String; args: array of Variant): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function mon: Variant; overload;
    function mon(item: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant): Variant; overload;
    function mon(item: Variant; ename: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    procedure mun; overload;
    procedure mun(item: Variant); overload;
    procedure mun(item: Variant; ename: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant); overload;
    procedure mun(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    function on: Variant; overload;
    function on(eventName: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant): Variant; overload;
    function on(eventName: Variant; fn: Variant; scope: Variant; options: Variant): Variant; overload;
    function relayEvents: Variant; overload;
    function relayEvents(origin: Variant): Variant; overload;
    function relayEvents(origin: Variant; events: array of String): Variant; overload;
    function relayEvents(origin: Variant; events: array of String; prefix: String): Variant; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: String); overload;
    procedure removeListener(eventName: String; fn: Variant); overload;
    procedure removeListener(eventName: String; fn: Variant; scope: Variant); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(item: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant); overload;
    procedure removeManagedListener(item: Variant; ename: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvent(eventName: array of Variant);
    procedure resumeEvents;
    procedure suspendEvent(eventName: array of Variant);
    procedure suspendEvents; overload;
    procedure suspendEvents(queueSuspended: Boolean); overload;
    procedure un; overload;
    procedure un(eventName: String); overload;
    procedure un(eventName: String; fn: Variant); overload;
    procedure un(eventName: String; fn: Variant; scope: Variant); overload;
  end;

//Ext.util

type
  JIOffset = class external(JExt.IBase)
  end;

//Ext.util

type
  JPoint = class external 'Point'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fromEvent: JExt.util.IPoint; overload;
    function fromEvent(e: Variant): JExt.util.IPoint; overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIPoint = class external(JExt.util.IRegion)
    function equals: Boolean; overload;
    function equals(p: Variant): Boolean; overload;
    function isContainedBy: Boolean; overload;
    function isContainedBy(region: Variant): Boolean; overload;
    function isWithin: Boolean; overload;
    function isWithin(p: Variant): Boolean; overload;
    function isWithin(p: Variant; threshold: Variant): Boolean; overload;
    function roundedEquals: Boolean; overload;
    function roundedEquals(p: Variant): Boolean; overload;
    function toString: String;
    function translate: JExt.util.IRegion; overload;
    function translate(x: Variant): JExt.util.IRegion; overload;
    function translate(x: Variant; y: Float): JExt.util.IRegion; overload;
  end;

//Ext.util

type
  JIPositionable = class external(JExt.IBase)
    function alignTo: JExt.util.IPositionable; overload;
    function alignTo(element: Variant): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function alignTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo: JExt.util.IPositionable; overload;
    function anchorTo(element: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant): JExt.util.IPositionable; overload;
    function anchorTo(element: Variant; position: String; offsets: array of Float; animate: Variant; monitorScroll: Variant; callback: Variant): JExt.util.IPositionable; overload;
    function calculateConstrainedPosition: array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean): array of Float; overload;
    function calculateConstrainedPosition(constrainTo: Variant; proposedPosition: array of Float; local: Boolean; proposedSize: array of Float): array of Float; overload;
    function getAlignToXY: array of Float; overload;
    function getAlignToXY(element: Variant): array of Float; overload;
    function getAlignToXY(element: Variant; position: String): array of Float; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Float): array of Float; overload;
    function getAnchorXY: array of Float; overload;
    function getAnchorXY(anchor: String): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Float; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Float; overload;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getConstrainVector: Variant; overload;
    function getConstrainVector(constrainTo: Variant): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float): Variant; overload;
    function getConstrainVector(constrainTo: Variant; proposedPosition: array of Float; proposedSize: array of Float): Variant; overload;
    function getLocalX: Float;
    function getLocalXY: array of Float;
    function getLocalY: Float;
    function getOffsetsTo: array of Float; overload;
    function getOffsetsTo(offsetsTo: Variant): array of Float; overload;
    function getRegion: JExt.util.IRegion;
    function getViewRegion: JExt.util.IRegion;
    function getX: Float;
    function getXY: array of Float;
    function getY: Float;
    procedure move; overload;
    procedure move(direction: String); overload;
    procedure move(direction: String; distance: Float); overload;
    procedure move(direction: String; distance: Float; animate: Variant); overload;
    function removeAnchor: JExt.util.IPositionable;
    function setBox: JExt.util.IPositionable; overload;
    function setBox(box: Variant): JExt.util.IPositionable; overload;
    function setBox(box: Variant; animate: Variant): JExt.util.IPositionable; overload;
    function setLocalX: JExt.util.IPositionable; overload;
    function setLocalX(x: Float): JExt.util.IPositionable; overload;
    function setLocalXY: JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant): JExt.util.IPositionable; overload;
    function setLocalXY(x: Variant; y: Float): JExt.util.IPositionable; overload;
    function setLocalY: JExt.util.IPositionable; overload;
    function setLocalY(y: Float): JExt.util.IPositionable; overload;
    function setRegion: JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion): JExt.util.IPositionable; overload;
    function setRegion(region: JExt.util.IRegion; animate: Variant): JExt.util.IPositionable; overload;
    function setX: JExt.util.IPositionable; overload;
    function setX(The: Float): JExt.util.IPositionable; overload;
    function setX(The: Float; animate: Variant): JExt.util.IPositionable; overload;
    function setXY: JExt.util.IPositionable; overload;
    function setXY(pos: array of Float): JExt.util.IPositionable; overload;
    function setXY(pos: array of Float; animate: Variant): JExt.util.IPositionable; overload;
    function setY: JExt.util.IPositionable; overload;
    function setY(The: Float): JExt.util.IPositionable; overload;
    function setY(The: Float; animate: Variant): JExt.util.IPositionable; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
  end;

//Ext.util

type
  JIProtoElement = class external(JExt.IBase)
    clsProp: String; // nullable
    removedProp: String; // nullable
    styleIsText: Boolean; // nullable
    styleProp: String; // nullable
    function addCls: JExt.util.IProtoElement; overload;
    function addCls(cls: String): JExt.util.IProtoElement; overload;
    procedure flush;
    function hasCls: Boolean; overload;
    function hasCls(cls: String): Boolean; overload;
    function removeCls: JExt.util.IProtoElement; overload;
    function removeCls(cls: String): JExt.util.IProtoElement; overload;
    function setStyle: JExt.util.IProtoElement; overload;
    function setStyle(prop: Variant): JExt.util.IProtoElement; overload;
    function setStyle(prop: Variant; value: String): JExt.util.IProtoElement; overload;
    function writeTo: Variant; overload;
    function writeTo(to: Variant): Variant; overload;
  end;

//Ext.util

type
  JIQueue = class external(JExt.IBase)
    procedure clear;
    function getCount: Float;
    function remove: Variant; overload;
    function remove(obj: Variant): Variant; overload;
  end;

//Ext.util

type
  JRegion = class external 'Region'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.util.IRegion; overload;
    function from(o: Variant): JExt.util.IRegion; overload;
    function getName: String;
    function getRegion: JExt.util.IRegion; overload;
    function getRegion(el: Variant): JExt.util.IRegion; overload;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIRegion = class external(JExt.IBase)
    function adjust: JExt.util.IRegion; overload;
    function adjust(top: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float; bottom: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float; bottom: Float; left: Float): JExt.util.IRegion; overload;
    function constrainTo: JExt.util.IRegion; overload;
    function constrainTo(targetRegion: JExt.util.IRegion): JExt.util.IRegion; overload;
    function contains: Boolean; overload;
    function contains(region: JExt.util.IRegion): Boolean; overload;
    function copy: JExt.util.IRegion;
    function copyFrom: JExt.util.IRegion; overload;
    function copyFrom(p: JExt.util.IRegion): JExt.util.IRegion; overload;
    function equals: Boolean; overload;
    function equals(region: JExt.util.IRegion): Boolean; overload;
    function getOutOfBoundOffset: JExt.util.IOffset; overload;
    function getOutOfBoundOffset(axis: String): JExt.util.IOffset; overload;
    function getOutOfBoundOffset(axis: String; p: JExt.util.IPoint): JExt.util.IOffset; overload;
    function getOutOfBoundOffsetX: Float; overload;
    function getOutOfBoundOffsetX(p: Float): Float; overload;
    function getOutOfBoundOffsetY: Float; overload;
    function getOutOfBoundOffsetY(p: Float): Float; overload;
    function intersect: Variant; overload;
    function intersect(region: JExt.util.IRegion): Variant; overload;
    function isOutOfBound: Boolean; overload;
    function isOutOfBound(axis: String): Boolean; overload;
    function isOutOfBound(axis: String; p: Variant): Boolean; overload;
    function isOutOfBoundX: Boolean; overload;
    function isOutOfBoundX(p: Float): Boolean; overload;
    function isOutOfBoundY: Boolean; overload;
    function isOutOfBoundY(p: Float): Boolean; overload;
    function round: JExt.util.IRegion;
    function translateBy: JExt.util.IRegion; overload;
    function translateBy(x: Variant): JExt.util.IRegion; overload;
    function translateBy(x: Variant; y: Float): JExt.util.IRegion; overload;
    function union: JExt.util.IRegion; overload;
    function union(region: JExt.util.IRegion): JExt.util.IRegion; overload;
  end;

//Ext.util

type
  JIRenderable = class external(JExt.IBase)
    procedure afterRender;
    procedure doAutoRender;
    procedure ensureAttachedToBody; overload;
    procedure ensureAttachedToBody(runLayout: Boolean); overload;
    function getInsertPosition: JHTMLElement; overload;
    function getInsertPosition(position: Variant): JHTMLElement; overload;
    function initRenderData: Variant;
    procedure onRender; overload;
    procedure onRender(parentNode: JExt.core.IElement); overload;
    procedure onRender(parentNode: JExt.core.IElement; containerIdx: Float); overload;
    procedure render; overload;
    procedure render(container: Variant); overload;
    procedure render(container: Variant; position: Variant); overload;
  end;

//Ext.util

type
  JSortable = class external 'Sortable'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function createComparator: Variant; overload;
    function createComparator(sorters: array of JExt.util.ISorter): Variant; overload;
    function getName: String;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JISortable = class external(JExt.IBase)
    defaultSortDirection: String; // nullable
    sortRoot: String; // nullable
    sorters: Variant; // nullable
    isSortable: Boolean; // nullable
    procedure generateComparator;
    function getFirstSorter: JExt.util.ISorter;
    procedure initSortable;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
  end;

//Ext.util

type
  JISorter = class external(JExt.IBase)
    direction: String; // nullable
    &property: String; // nullable
    root: String; // nullable
    sorterFn: Variant; // nullable
    transform: Variant; // nullable
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure toggle;
    procedure updateSortFunction; overload;
    procedure updateSortFunction(fn: Variant); overload;
  end;

//Ext.util

type
  JTaskManager = class external 'TaskManager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure newTask; overload;
    procedure newTask(config: Variant); overload;
    function start: Variant; overload;
    function start(task: Variant): Variant; overload;
    function statics: JExt.IClass;
    function stop: Variant; overload;
    function stop(task: Variant): Variant; overload;
    procedure stopAll;
  end;

  JITaskManager = class external(JExt.util.ITaskRunner)
  end;

//Ext

type
  JTaskManager = class external 'TaskManager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure newTask; overload;
    procedure newTask(config: Variant); overload;
    function start: Variant; overload;
    function start(task: Variant): Variant; overload;
    function statics: JExt.IClass;
    function stop: Variant; overload;
    function stop(task: Variant): Variant; overload;
    procedure stopAll;
  end;

  JITaskManager = class external(JExt.util.ITaskRunner)
  end;

//Ext.util

type
  JITaskRunner = class external(JExt.IBase)
    fireIdleEvent: Boolean; // nullable
    interval: Float; // nullable
    procedure destroy;
    procedure newTask; overload;
    procedure newTask(config: Variant); overload;
    function start: Variant; overload;
    function start(task: Variant): Variant; overload;
    function stop: Variant; overload;
    function stop(task: Variant): Variant; overload;
    procedure stopAll;
  end;

//Ext.util.taskrunner

type
  JITask = class external
    fireOnStart: Boolean; // nullable
    procedure destroy;
    procedure restart; overload;
    procedure restart(interval: Float); overload;
    procedure start; overload;
    procedure start(interval: Float); overload;
    procedure stop;
  end;

//Ext.util

type
  JTextMetrics = class external 'TextMetrics'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure destroy;
    function getName: String;
    procedure implement;
    function measure: Variant; overload;
    function measure(el: Variant): Variant; overload;
    function measure(el: Variant; text: String): Variant; overload;
    function measure(el: Variant; text: String; fixedWidth: Float): Variant; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JITextMetrics = class external(JExt.IBase)
    procedure bind; overload;
    procedure bind(el: Variant); overload;
    procedure destroy;
    function getHeight: Float; overload;
    function getHeight(text: String): Float; overload;
    function getSize: Variant; overload;
    function getSize(text: String): Variant; overload;
    function getWidth: Float; overload;
    function getWidth(text: String): Float; overload;
    procedure setFixedWidth; overload;
    procedure setFixedWidth(width: Float); overload;
  end;

//Ext

type
  JVersion = class external 'Version'
    function compare: Float; overload;
    function compare(current: String): Float; overload;
    function compare(current: String; target: String): Float; overload;
    function getComponentValue: Variant; overload;
    function getComponentValue(value: Variant): Variant; overload;
  end;

  JIVersion = class external
    function equals: Boolean; overload;
    function equals(target: Variant): Boolean; overload;
    function getBuild: Float;
    function getMajor: Float;
    function getMinor: Float;
    function getPatch: Float;
    function getRelease: Float;
    function getShortVersion: String;
    function gt: Boolean; overload;
    function gt(target: Variant): Boolean; overload;
    function gtEq: Boolean; overload;
    function gtEq(target: Variant): Boolean; overload;
    function isGreaterThan: Boolean; overload;
    function isGreaterThan(target: Variant): Boolean; overload;
    function isGreaterThanOrEqual: Boolean; overload;
    function isGreaterThanOrEqual(target: Variant): Boolean; overload;
    function isLessThan: Boolean; overload;
    function isLessThan(target: Variant): Boolean; overload;
    function isLessThanOrEqual: Boolean; overload;
    function isLessThanOrEqual(target: Variant): Boolean; overload;
    function lt: Boolean; overload;
    function lt(target: Variant): Boolean; overload;
    function ltEq: Boolean; overload;
    function ltEq(target: Variant): Boolean; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function toArray: array of Float;
  end;

//Ext.view

type
  JIAbstractView = class external(JExt.IComponent, JExt.util.IBindable)
    blockRefresh: Boolean; // nullable
    deferEmptyText: Boolean; // nullable
    deferInitialRefresh: Boolean; // nullable
    disableSelection: Boolean; // nullable
    emptyText: String; // nullable
    itemCls: String; // nullable
    itemSelector: String; // nullable
    itemTpl: Variant; // nullable
    loadMask: Variant; // nullable
    loadingCls: String; // nullable
    loadingHeight: Float; // nullable
    loadingText: String; // nullable
    multiSelect: Boolean; // nullable
    overItemCls: String; // nullable
    preserveScrollOnRefresh: Boolean; // nullable
    selectedItemCls: String; // nullable
    simpleSelect: Boolean; // nullable
    singleSelect: Boolean; // nullable
    store: JExt.data.IStore; // nullable
    tpl: Variant; // nullable
    trackOver: Boolean; // nullable
    procedure afterRender;
    procedure bindStore; overload;
    procedure bindStore(store: JExt.data.IStore); overload;
    procedure bindStoreListeners; overload;
    procedure bindStoreListeners(store: JExt.data.IAbstractStore); overload;
    procedure clearSelections;
    function collectData: array of Variant; overload;
    function collectData(records: array of JExt.data.IModel): array of Variant; overload;
    function collectData(records: array of JExt.data.IModel; startIndex: Float): array of Variant; overload;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    function findItemByChild: JHTMLElement; overload;
    function findItemByChild(node: JHTMLElement): JHTMLElement; overload;
    procedure findTargetByEvent; overload;
    procedure findTargetByEvent(e: JExt.IEventObject); overload;
    function getNode: JHTMLElement; overload;
    function getNode(nodeInfo: Variant): JHTMLElement; overload;
    function getNodes: array of JHTMLElement; overload;
    function getNodes(start: Float): array of JHTMLElement; overload;
    function getNodes(start: Float; &end: Float): array of JHTMLElement; overload;
    function getRecord: JExt.data.IModel; overload;
    function getRecord(node: Variant): JExt.data.IModel; overload;
    function getRecords: array of JExt.data.IModel; overload;
    function getRecords(nodes: array of JHTMLElement): array of JExt.data.IModel; overload;
    function getSelectedNodes: array of JHTMLElement;
    function getSelectedRecords: array of JExt.data.IModel;
    function getSelectionCount: Float;
    function getSelectionModel: JExt.selection.IModel;
    function getStore: JExt.data.IStore;
    function getStoreListeners: Variant;
    function indexOf: Float; overload;
    function indexOf(nodeInfo: Variant): Float; overload;
    procedure initComponent;
    function isSelected: Boolean; overload;
    function isSelected(node: Variant): Boolean; overload;
    procedure onBindStore; overload;
    procedure onBindStore(store: Variant); overload;
    procedure onBindStore(store: Variant; initial: Variant); overload;
    procedure onBindStore(store: Variant; initial: Variant; propName: Variant); overload;
    procedure onDestroy;
    procedure onRender;
    procedure onUnbindStore; overload;
    procedure onUnbindStore(store: Variant); overload;
    function prepareData: Variant; overload;
    function prepareData(data: Variant): Variant; overload;
    function prepareData(data: Variant; recordIndex: Float): Variant; overload;
    function prepareData(data: Variant; recordIndex: Float; record: JExt.data.IModel): Variant; overload;
    procedure refresh;
    procedure refreshNode; overload;
    procedure refreshNode(index: Float); overload;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure unbindStoreListeners; overload;
    procedure unbindStoreListeners(store: JExt.data.IAbstractStore); overload;
  end;

//Ext.view

type
  JIBoundList = class external(JExt.view.IView, JExt.IQueryable)
    baseCls: String; // nullable
    componentLayout: Variant; // nullable
    deferInitialRefresh: Boolean; // nullable
    displayField: String; // nullable
    itemCls: String; // nullable
    pageSize: Float; // nullable
    renderTpl: Variant; // nullable
    shadow: Variant; // nullable
    tpl: Variant; // nullable
    trackOver: Boolean; // nullable
    pagingToolbar: JExt.toolbar.IPaging; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    function getInnerTpl: String; overload;
    function getInnerTpl(displayField: String): String; overload;
    procedure onDestroy;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure refresh;
  end;

//Ext

type
  JIBoundList = class external(JExt.view.IView, JExt.IQueryable)
    baseCls: String; // nullable
    componentLayout: Variant; // nullable
    deferInitialRefresh: Boolean; // nullable
    displayField: String; // nullable
    itemCls: String; // nullable
    pageSize: Float; // nullable
    renderTpl: Variant; // nullable
    shadow: Variant; // nullable
    tpl: Variant; // nullable
    trackOver: Boolean; // nullable
    pagingToolbar: JExt.toolbar.IPaging; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: Variant); overload;
    procedure bindStore(store: Variant; initial: Variant); overload;
    function child: Variant; overload;
    function child(selector: Variant): Variant; overload;
    function down: Variant; overload;
    function down(selector: Variant): Variant; overload;
    function getInnerTpl: String; overload;
    function getInnerTpl(displayField: String): String; overload;
    procedure onDestroy;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function queryBy: array of JExt.IComponent; overload;
    function queryBy(fn: Variant): array of JExt.IComponent; overload;
    function queryBy(fn: Variant; scope: Variant): array of JExt.IComponent; overload;
    function queryById: JExt.IComponent; overload;
    function queryById(id: String): JExt.IComponent; overload;
    procedure refresh;
  end;

//Ext.view

type
  JIBoundListKeyNav = class external(JExt.util.IKeyNav)
    boundList: JExt.view.IBoundList; // nullable
    procedure highlightAt; overload;
    procedure highlightAt(index: Float); overload;
    procedure selectHighlighted; overload;
    procedure selectHighlighted(e: Variant); overload;
  end;

//Ext.view

type
  JIDragZone = class external(JExt.dd.IDragZone)
    containerScroll: Variant; // nullable
    function getDragData: Variant; overload;
    function getDragData(e: Variant): Variant; overload;
    function getRepairXY: array of Float; overload;
    function getRepairXY(e: Variant): array of Float; overload;
    function getRepairXY(e: Variant; data: Variant): array of Float; overload;
    procedure init; overload;
    procedure init(id: Variant); overload;
    procedure init(id: Variant; sGroup: Variant); overload;
    procedure init(id: Variant; sGroup: Variant; config: Variant); overload;
    function onInitDrag: Boolean; overload;
    function onInitDrag(x: Variant): Boolean; overload;
    function onInitDrag(x: Variant; y: Variant): Boolean; overload;
  end;

//Ext.view

type
  JIDropZone = class external(JExt.dd.IDropZone)
    procedure destroy;
    function getTargetFromEvent: Variant; overload;
    function getTargetFromEvent(e: Variant): Variant; overload;
    procedure notifyOut; overload;
    procedure notifyOut(node: Variant); overload;
    procedure notifyOut(node: Variant; dragZone: Variant); overload;
    procedure notifyOut(node: Variant; dragZone: Variant; e: Variant); overload;
    procedure notifyOut(node: Variant; dragZone: Variant; e: Variant; data: Variant); overload;
    function onContainerDrop: Boolean; overload;
    function onContainerDrop(dd: Variant): Boolean; overload;
    function onContainerDrop(dd: Variant; e: Variant): Boolean; overload;
    function onContainerDrop(dd: Variant; e: Variant; data: Variant): Boolean; overload;
    function onContainerOver: String; overload;
    function onContainerOver(dd: Variant): String; overload;
    function onContainerOver(dd: Variant; e: Variant): String; overload;
    function onContainerOver(dd: Variant; e: Variant; data: Variant): String; overload;
    function onNodeDrop: Boolean; overload;
    function onNodeDrop(targetNode: Variant): Boolean; overload;
    function onNodeDrop(targetNode: Variant; dragZone: Variant): Boolean; overload;
    function onNodeDrop(targetNode: Variant; dragZone: Variant; e: Variant): Boolean; overload;
    function onNodeDrop(targetNode: Variant; dragZone: Variant; e: Variant; data: Variant): Boolean; overload;
    function onNodeOver: String; overload;
    function onNodeOver(node: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant): String; overload;
    function onNodeOver(node: Variant; dragZone: Variant; e: Variant; data: Variant): String; overload;
  end;

//Ext.view

type
  JINodeCache = class external(JExt.IBase)
    procedure clear; overload;
    procedure clear(removeDom: Boolean); overload;
    function fill: JExt.view.INodeCache; overload;
    function fill(els: array of JHTMLElement): JExt.view.INodeCache; overload;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    procedure removeElement; overload;
    procedure removeElement(el: Variant); overload;
    procedure removeElement(el: Variant; removeDom: Boolean); overload;
    function replaceElement: JExt.view.INodeCache; overload;
    function replaceElement(el: Variant): JExt.view.INodeCache; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.view.INodeCache; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.view.INodeCache; overload;
    procedure scroll; overload;
    procedure scroll(newRecords: array of JExt.data.IModel); overload;
    procedure scroll(newRecords: array of JExt.data.IModel; direction: Float); overload;
    procedure scroll(newRecords: array of JExt.data.IModel; direction: Float; removeCount: Float); overload;
  end;

//Ext.view

type
  JITable = class external(JExt.view.IView)
    baseCls: String; // nullable
    componentLayout: Variant; // nullable
    enableTextSelection: Boolean; // nullable
    firstCls: String; // nullable
    itemSelector: String; // nullable
    lastCls: String; // nullable
    markDirty: Boolean; // nullable
    overItemCls: String; // nullable
    selectedItemCls: String; // nullable
    stripeRows: Boolean; // nullable
    trackOver: Boolean; // nullable
    procedure addRowCls; overload;
    procedure addRowCls(rowInfo: Variant); overload;
    procedure addRowCls(rowInfo: Variant; cls: String); overload;
    procedure autoSizeColumn; overload;
    procedure autoSizeColumn(header: Variant); overload;
    procedure beforeDestroy;
    function collectData: array of Variant; overload;
    function collectData(records: Variant): array of Variant; overload;
    function collectData(records: Variant; startIndex: Variant): array of Variant; overload;
    procedure expandToFit; overload;
    procedure expandToFit(header: Variant); overload;
    function focus: JExt.IComponent; overload;
    function focus(selectText: Variant): JExt.IComponent; overload;
    function focus(selectText: Variant; delay: Variant): JExt.IComponent; overload;
    procedure focusRow; overload;
    procedure focusRow(row: Variant); overload;
    procedure focusRow(row: Variant; delay: Variant); overload;
    procedure getBodySelector;
    procedure getCellSelector; overload;
    procedure getCellSelector(header: JExt.grid.column.IColumn); overload;
    procedure getColumnSizerSelector; overload;
    procedure getColumnSizerSelector(header: Variant); overload;
    procedure getDataRowSelector;
    function getFeature: JExt.grid.feature.IFeature; overload;
    function getFeature(id: String): JExt.grid.feature.IFeature; overload;
    procedure getItemSelector;
    function getNode: JHTMLElement; overload;
    function getNode(nodeInfo: Variant): JHTMLElement; overload;
    function getNode(nodeInfo: Variant; dataRow: Boolean): JHTMLElement; overload;
    procedure getNodeContainerSelector;
    function getPosition: array of Float; overload;
    function getPosition(record: Variant): array of Float; overload;
    function getPosition(record: Variant; header: Variant): array of Float; overload;
    function getRecord: JExt.data.IModel; overload;
    function getRecord(node: Variant): JExt.data.IModel; overload;
    function getRowClass: String; overload;
    function getRowClass(record: JExt.data.IModel): String; overload;
    function getRowClass(record: JExt.data.IModel; index: Float): String; overload;
    function getRowClass(record: JExt.data.IModel; index: Float; rowParams: Variant): String; overload;
    function getRowClass(record: JExt.data.IModel; index: Float; rowParams: Variant; store: JExt.data.IStore): String; overload;
    function indexOf: Float; overload;
    function indexOf(node: Variant): Float; overload;
    procedure initComponent;
    procedure onDestroy;
    procedure refresh;
    procedure removeRowCls; overload;
    procedure removeRowCls(rowInfo: Variant); overload;
    procedure removeRowCls(rowInfo: Variant; cls: String); overload;
    procedure walkRecs; overload;
    procedure walkRecs(startRec: JExt.data.IModel); overload;
    procedure walkRecs(startRec: JExt.data.IModel; distance: Float); overload;
    procedure walkRows; overload;
    procedure walkRows(startRow: Float); overload;
    procedure walkRows(startRow: Float; distance: Float); overload;
  end;

//Ext.view

type
  JITableLayout = class external(JExt.layout.component.IAuto)
    procedure beginLayout; overload;
    procedure beginLayout(ownerContext: Variant); overload;
    procedure calculate; overload;
    procedure calculate(ownerContext: Variant); overload;
    procedure finishedLayout;
  end;

//Ext.view

type
  JIView = class external(JExt.view.IAbstractView)
    mouseOverOutBuffer: Float; // nullable
    procedure clearHighlight;
    procedure focusNode; overload;
    procedure focusNode(rec: JExt.data.IModel); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: JHTMLElement); overload;
    procedure initComponent;
    procedure refresh;
  end;

//Ext

type
  JIDataView = class external(JExt.view.IAbstractView)
    mouseOverOutBuffer: Float; // nullable
    procedure clearHighlight;
    procedure focusNode; overload;
    procedure focusNode(rec: JExt.data.IModel); overload;
    procedure highlightItem; overload;
    procedure highlightItem(item: JHTMLElement); overload;
    procedure initComponent;
    procedure refresh;
  end;

//Ext.window

type
  JIMessageBox = class external(JExt.window.IWindow)
    closeAction: String; // nullable
    cls: String; // nullable
    constrain: Boolean; // nullable
    hideMode: String; // nullable
    layout: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    resizable: Variant; // nullable
    shrinkWrapDock: Variant; // nullable
    title: String; // nullable
    CANCEL: Float; // nullable
    ERROR: String; // nullable
    INFO: String; // nullable
    NO: Float; // nullable
    OK: Float; // nullable
    OKCANCEL: Float; // nullable
    QUESTION: String; // nullable
    WARNING: String; // nullable
    YES: Float; // nullable
    YESNO: Float; // nullable
    YESNOCANCEL: Float; // nullable
    buttonText: Variant; // nullable
    defaultTextHeight: Float; // nullable
    minProgressWidth: Float; // nullable
    minPromptWidth: Float; // nullable
    function alert: JExt.window.IMessageBox; overload;
    function alert(title: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function alert(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function confirm: JExt.window.IMessageBox; overload;
    function confirm(title: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function confirm(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function hide: JExt.IComponent;
    procedure onShow;
    function progress: JExt.window.IMessageBox; overload;
    function progress(title: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String): JExt.window.IMessageBox; overload;
    function progress(title: String; msg: String; progressText: String): JExt.window.IMessageBox; overload;
    function prompt: JExt.window.IMessageBox; overload;
    function prompt(title: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant): JExt.window.IMessageBox; overload;
    function prompt(title: String; msg: String; fn: Variant; scope: Variant; multiline: Variant; value: String): JExt.window.IMessageBox; overload;
    function setIcon: JExt.window.IMessageBox; overload;
    function setIcon(icon: String): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float): JExt.window.IMessageBox; overload;
    function setIcon(icon: String; width: Float; height: Float): JExt.window.IMessageBox; overload;
    function show: JExt.window.IMessageBox; overload;
    function show(config: Variant): JExt.window.IMessageBox; overload;
    function updateProgress: JExt.window.IMessageBox; overload;
    function updateProgress(value: Float): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String): JExt.window.IMessageBox; overload;
    function updateProgress(value: Float; progressText: String; msg: String): JExt.window.IMessageBox; overload;
    function wait: JExt.window.IMessageBox; overload;
    function wait(msg: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String): JExt.window.IMessageBox; overload;
    function wait(msg: String; title: String; config: Variant): JExt.window.IMessageBox; overload;
  end;

//Ext.window

type
  JIWindow = class external(JExt.panel.IPanel)
    animateTarget: Variant; // nullable
    autoRender: Boolean; // nullable
    baseCls: String; // nullable
    closable: Boolean; // nullable
    collapsed: Boolean; // nullable
    collapsible: Boolean; // nullable
    constrain: Boolean; // nullable
    constrainHeader: Boolean; // nullable
    defaultFocus: Variant; // nullable
    draggable: Boolean; // nullable
    expandOnShow: Boolean; // nullable
    ghost: Variant; // nullable
    hidden: Boolean; // nullable
    hideMode: String; // nullable
    hideShadowOnDeactivate: Boolean; // nullable
    maximizable: Boolean; // nullable
    maximized: Boolean; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    minimizable: Boolean; // nullable
    modal: Boolean; // nullable
    onEsc: Variant; // nullable
    overlapHeader: Boolean; // nullable
    plain: Boolean; // nullable
    resizable: Variant; // nullable
    x: Float; // nullable
    y: Float; // nullable
    dd: JExt.util.IComponentDragger; // nullable
    isWindow: Boolean; // nullable
    procedure afterCollapse;
    procedure afterExpand;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure getDefaultFocus;
    function maximize: JExt.window.IWindow; overload;
    function maximize(animate: Boolean): JExt.window.IWindow; overload;
    function minimize: JExt.window.IWindow;
    procedure onShow;
    function restore: JExt.window.IWindow; overload;
    function restore(animate: Variant): JExt.window.IWindow; overload;
    function toggleMaximize: JExt.window.IWindow;
  end;

//Ext

type
  JIWindow = class external(JExt.panel.IPanel)
    animateTarget: Variant; // nullable
    autoRender: Boolean; // nullable
    baseCls: String; // nullable
    closable: Boolean; // nullable
    collapsed: Boolean; // nullable
    collapsible: Boolean; // nullable
    constrain: Boolean; // nullable
    constrainHeader: Boolean; // nullable
    defaultFocus: Variant; // nullable
    draggable: Boolean; // nullable
    expandOnShow: Boolean; // nullable
    ghost: Variant; // nullable
    hidden: Boolean; // nullable
    hideMode: String; // nullable
    hideShadowOnDeactivate: Boolean; // nullable
    maximizable: Boolean; // nullable
    maximized: Boolean; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    minimizable: Boolean; // nullable
    modal: Boolean; // nullable
    onEsc: Variant; // nullable
    overlapHeader: Boolean; // nullable
    plain: Boolean; // nullable
    resizable: Variant; // nullable
    x: Float; // nullable
    y: Float; // nullable
    dd: JExt.util.IComponentDragger; // nullable
    isWindow: Boolean; // nullable
    procedure afterCollapse;
    procedure afterExpand;
    procedure applyState; overload;
    procedure applyState(state: Variant); overload;
    procedure getDefaultFocus;
    function maximize: JExt.window.IWindow; overload;
    function maximize(animate: Boolean): JExt.window.IWindow; overload;
    function minimize: JExt.window.IWindow;
    procedure onShow;
    function restore: JExt.window.IWindow; overload;
    function restore(animate: Variant): JExt.window.IWindow; overload;
    function toggleMaximize: JExt.window.IWindow;
  end;

//Ext

type
  JWindowManager = class external 'WindowManager'
    self: JExt.IClass;
    function bringToFront: Boolean; overload;
    function bringToFront(comp: Variant): Boolean; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachBottomUp; overload;
    procedure eachBottomUp(fn: Variant); overload;
    procedure eachBottomUp(fn: Variant; scope: Variant); overload;
    procedure eachTopDown; overload;
    procedure eachTopDown(fn: Variant); overload;
    procedure eachTopDown(fn: Variant; scope: Variant); overload;
    function get: JExt.IComponent; overload;
    function get(id: Variant): JExt.IComponent; overload;
    function getActive: JExt.IComponent;
    function getBy: array of Variant; overload;
    function getBy(fn: Variant): array of Variant; overload;
    function getBy(fn: Variant; scope: Variant): array of Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    procedure hideAll;
    function initConfig: JExt.IBase; overload;
    function initConfig(config: Variant): JExt.IBase; overload;
    procedure register; overload;
    procedure register(comp: JExt.IComponent); overload;
    function sendToBack: JExt.IComponent; overload;
    function sendToBack(comp: Variant): JExt.IComponent; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(comp: JExt.IComponent); overload;
  end;

  JIWindowManager = class external(JExt.IZIndexManager)
  end;

//Ext

type
  JXTemplate = class external 'XTemplate'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.ITemplate; overload;
    function from(el: Variant): JExt.ITemplate; overload;
    function from(el: Variant; config: Variant): JExt.ITemplate; overload;
    function getName: String;
    function getTpl: JExt.IXTemplate; overload;
    function getTpl(instance: Variant): JExt.IXTemplate; overload;
    function getTpl(instance: Variant; name: String): JExt.IXTemplate; overload;
    procedure implement;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIXTemplate = class external(JExt.ITemplate)
    definitions: Variant; // nullable
    function applyOut: array of Variant; overload;
    function applyOut(values: Variant): array of Variant; overload;
    function applyOut(values: Variant; out: Variant): array of Variant; overload;
    function applyOut(values: Variant; out: Variant; parent: Variant): array of Variant; overload;
  end;

//Ext

type
  JIXTemplateCompiler = class external(JExt.IXTemplateParser)
    procedure doCase; overload;
    procedure doCase(action: Variant); overload;
    procedure doDefault;
    procedure doElse;
    procedure doElseIf; overload;
    procedure doElseIf(action: Variant); overload;
    procedure doElseIf(action: Variant; actions: Variant); overload;
    procedure doEnd; overload;
    procedure doEnd(&type: Variant); overload;
    procedure doEnd(&type: Variant; actions: Variant); overload;
    procedure doEval; overload;
    procedure doEval(text: Variant); overload;
    procedure doExec; overload;
    procedure doExec(action: Variant); overload;
    procedure doExec(action: Variant; actions: Variant); overload;
    procedure doExpr; overload;
    procedure doExpr(expr: Variant); overload;
    procedure doFor; overload;
    procedure doFor(action: Variant); overload;
    procedure doFor(action: Variant; actions: Variant); overload;
    procedure doForEach; overload;
    procedure doForEach(action: Variant); overload;
    procedure doForEach(action: Variant; actions: Variant); overload;
    procedure doIf; overload;
    procedure doIf(action: Variant); overload;
    procedure doIf(action: Variant; actions: Variant); overload;
    procedure doSwitch; overload;
    procedure doSwitch(action: Variant); overload;
    procedure doTag; overload;
    procedure doTag(tag: Variant); overload;
    procedure doText; overload;
    procedure doText(text: Variant); overload;
  end;

//Ext

type
  JIXTemplateParser = class external(JExt.IBase)
    level: Float; // nullable
    procedure doCase; overload;
    procedure doCase(action: String); overload;
    procedure doCase(action: String; actions: Variant); overload;
    procedure doDefault;
    procedure doElse;
    procedure doElseIf; overload;
    procedure doElseIf(action: String); overload;
    procedure doElseIf(action: String; actions: Variant); overload;
    procedure doEnd; overload;
    procedure doEnd(&type: String); overload;
    procedure doEnd(&type: String; actions: Variant); overload;
    procedure doEval; overload;
    procedure doEval(text: String); overload;
    procedure doExec; overload;
    procedure doExec(action: String); overload;
    procedure doExec(action: String; actions: Variant); overload;
    procedure doExpr; overload;
    procedure doExpr(expr: String); overload;
    procedure doFor; overload;
    procedure doFor(action: String); overload;
    procedure doFor(action: String; actions: Variant); overload;
    procedure doForEach; overload;
    procedure doForEach(action: String); overload;
    procedure doForEach(action: String; actions: Variant); overload;
    procedure doIf; overload;
    procedure doIf(action: String); overload;
    procedure doIf(action: String; actions: Variant); overload;
    procedure doSwitch; overload;
    procedure doSwitch(action: String); overload;
    procedure doSwitch(action: String; actions: Variant); overload;
    procedure doTag;
    procedure doText; overload;
    procedure doText(text: String); overload;
    procedure doTpl;
  end;

//Ext

type
  JIZIndexManager = class external(JExt.IBase)
    function bringToFront: Boolean; overload;
    function bringToFront(comp: Variant): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachBottomUp; overload;
    procedure eachBottomUp(fn: Variant); overload;
    procedure eachBottomUp(fn: Variant; scope: Variant); overload;
    procedure eachTopDown; overload;
    procedure eachTopDown(fn: Variant); overload;
    procedure eachTopDown(fn: Variant; scope: Variant); overload;
    function get: JExt.IComponent; overload;
    function get(id: Variant): JExt.IComponent; overload;
    function getActive: JExt.IComponent;
    function getBy: array of Variant; overload;
    function getBy(fn: Variant): array of Variant; overload;
    function getBy(fn: Variant; scope: Variant): array of Variant; overload;
    procedure hideAll;
    procedure register; overload;
    procedure register(comp: JExt.IComponent); overload;
    function sendToBack: JExt.IComponent; overload;
    function sendToBack(comp: Variant): JExt.IComponent; overload;
    procedure unregister; overload;
    procedure unregister(comp: JExt.IComponent); overload;
  end;

//Ext

type
  JIWindowGroup = class external(JExt.IBase)
    function bringToFront: Boolean; overload;
    function bringToFront(comp: Variant): Boolean; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachBottomUp; overload;
    procedure eachBottomUp(fn: Variant); overload;
    procedure eachBottomUp(fn: Variant; scope: Variant); overload;
    procedure eachTopDown; overload;
    procedure eachTopDown(fn: Variant); overload;
    procedure eachTopDown(fn: Variant; scope: Variant); overload;
    function get: JExt.IComponent; overload;
    function get(id: Variant): JExt.IComponent; overload;
    function getActive: JExt.IComponent;
    function getBy: array of Variant; overload;
    function getBy(fn: Variant): array of Variant; overload;
    function getBy(fn: Variant; scope: Variant): array of Variant; overload;
    procedure hideAll;
    procedure register; overload;
    procedure register(comp: JExt.IComponent); overload;
    function sendToBack: JExt.IComponent; overload;
    function sendToBack(comp: Variant): JExt.IComponent; overload;
    procedure unregister; overload;
    procedure unregister(comp: JExt.IComponent); overload;
  end;

