unit SenchaTouch;

interface

//Ext

type
  JIAbstractComponent = class external(JExt.IEvented)
  end;

//Ext

type
  JIAbstractManager = class external(JExt.IBase)
    all: JExt.util.IHashMap; // nullable
    function create: Variant; overload;
    function create(config: Variant): Variant; overload;
    function create(config: Variant; defaultType: String): Variant; overload;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    procedure registerType; overload;
    procedure registerType(&type: String); overload;
    procedure registerType(&type: String; cls: Variant); overload;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

//Ext

type
  JIAbstractPlugin = class external(JExt.IBase)
  end;

//Ext

type
  JIActionSheet = class external(JExt.ISheet)
    baseCls: String; // nullable
    bottom: Variant; // nullable
    defaultType: String; // nullable
    height: Variant; // nullable
    left: Variant; // nullable
    right: Variant; // nullable
    function getBaseCls: String;
    function getBottom: Float;
    function getDefaultType: String;
    function getHeight: String;
    function getLeft: Float;
    function getRight: Float;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Float); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setHeight; overload;
    procedure setHeight(height: String); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Float); overload;
    procedure setRight; overload;
    procedure setRight(right: Float); overload;
  end;

//Ext

type
  JAjax = class external 'Ajax'
    autoAbort: Boolean;
    self: JExt.IClass;
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    procedure abortAll;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getAsync: Boolean;
    function getAutoAbort: Boolean;
    function getBubbleEvents: Variant;
    function getDefaultHeaders: Variant;
    function getDefaultPostHeader: String;
    function getDefaultXhrHeader: String;
    function getDisableCaching: Boolean;
    function getDisableCachingParam: String;
    function getExtraParams: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getMethod: String;
    function getPassword: String;
    function getTimeout: Float;
    function getUrl: String;
    function getUseDefaultHeader: Boolean;
    function getUseDefaultXhrHeader: Boolean;
    function getUsername: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isLoading: Boolean; overload;
    function isLoading(request: Variant): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parseStatus: Variant; overload;
    function parseStatus(status: Float): Variant; overload;
    function parseStatus(status: Float; xhr: JXMLHttpRequest): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAsync; overload;
    procedure setAsync(async: Boolean); overload;
    procedure setAutoAbort; overload;
    procedure setAutoAbort(autoAbort: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setDefaultHeaders; overload;
    procedure setDefaultHeaders(defaultHeaders: Variant); overload;
    procedure setDefaultPostHeader; overload;
    procedure setDefaultPostHeader(defaultPostHeader: String); overload;
    procedure setDefaultXhrHeader; overload;
    procedure setDefaultXhrHeader(defaultXhrHeader: String); overload;
    procedure setDisableCaching; overload;
    procedure setDisableCaching(disableCaching: Boolean); overload;
    procedure setDisableCachingParam; overload;
    procedure setDisableCachingParam(disableCachingParam: String); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: String); overload;
    function setOptions: Variant; overload;
    function setOptions(options: Variant): Variant; overload;
    function setOptions(options: Variant; scope: Variant): Variant; overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure setUseDefaultHeader; overload;
    procedure setUseDefaultHeader(useDefaultHeader: Boolean); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Boolean); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure upload; overload;
    procedure upload(form: Variant); overload;
    procedure upload(form: Variant; url: String); overload;
    procedure upload(form: Variant; url: String; params: String); overload;
    procedure upload(form: Variant; url: String; params: String; options: Variant); overload;
  end;

  JIAjax = class external(JExt.data.IConnection)
  end;

//Ext

type
  JAnim = class external 'Anim'
    after: Variant;
    autoClear: Boolean;
    before: Variant;
    delay: Float;
    direction: String;
    disableAnimations: Boolean;
    duration: Float;
    easing: String;
    from: Variant;
    out: Boolean;
    reverse: Boolean;
    scope: Variant;
    to: Variant;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(el: Variant): Variant; overload;
    function initConfig(el: Variant; runConfig: Variant): Variant; overload;
    procedure run; overload;
    procedure run(el: Variant); overload;
    procedure run(el: Variant; anim: String); overload;
    procedure run(el: Variant; anim: String; config: Variant); overload;
    function statics: JExt.IClass;
  end;

  JIAnim = class external(JExt.IBase)
  end;

//Ext

type
  JAnimationQueue = class external 'AnimationQueue'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure start; overload;
    procedure start(fn: Variant); overload;
    procedure start(fn: Variant; scope: Variant); overload;
    procedure start(fn: Variant; scope: Variant; args: Variant); overload;
    function statics: JExt.IClass;
    procedure stop; overload;
    procedure stop(fn: Variant); overload;
    procedure stop(fn: Variant; scope: Variant); overload;
    procedure stop(fn: Variant; scope: Variant; args: Variant); overload;
  end;

  JIAnimationQueue = class external(JExt.IBase)
  end;

//Ext

type
  JAnims = class external 'Anims'
    cube: Variant;
    fade: Variant;
    flip: Variant;
    pop: Variant;
    slide: Variant;
    wipe: Variant;
  end;

  JIAnims = class external
  end;

//Ext.app

type
  JIAction = class external(JExt.IBase)
    action: String; // nullable
    application: JExt.app.IApplication; // nullable
    args: array of Variant; // nullable
    beforeFilters: array of Variant; // nullable
    controller: JExt.app.IController; // nullable
    scope: Variant; // nullable
    url: String; // nullable
    procedure execute;
    function getAction: String;
    function getApplication: JExt.app.IApplication;
    function getArgs: array of Variant;
    function getBeforeFilters: array of Variant;
    function getController: JExt.app.IController;
    function getData: Variant;
    function getScope: Variant;
    function getTitle: Variant;
    function getUrl: String;
    procedure resume;
    procedure setAction; overload;
    procedure setAction(action: String); overload;
    procedure setApplication; overload;
    procedure setApplication(application: JExt.app.IApplication); overload;
    procedure setArgs; overload;
    procedure setArgs(args: array of Variant); overload;
    procedure setBeforeFilters; overload;
    procedure setBeforeFilters(beforeFilters: array of Variant); overload;
    procedure setController; overload;
    procedure setController(controller: JExt.app.IController); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: Variant); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
  end;

//Ext.app

type
  JIApplication = class external(JExt.app.IController)
    appFolder: String; // nullable
    controllers: array of Variant; // nullable
    currentProfile: JExt.app.IProfile; // nullable
    glossOnIcon: Boolean; // nullable
    history: JExt.app.IHistory; // nullable
    icon: Variant; // nullable
    isIconPrecomposed: Boolean; // nullable
    launch: Variant; // nullable
    name: String; // nullable
    phoneIcon: String; // nullable
    phoneStartupScreen: String; // nullable
    profiles: array of Variant; // nullable
    requires: array of String; // nullable
    router: JExt.app.IRouter; // nullable
    startupImage: Variant; // nullable
    statusBarStyle: String; // nullable
    tabletIcon: String; // nullable
    tabletStartupScreen: String; // nullable
    themeVariation: Variant; // nullable
    themeVariationPrefix: String; // nullable
    themeVariationTransitionCls: String; // nullable
    procedure dispatch; overload;
    procedure dispatch(action: JExt.app.IAction); overload;
    procedure dispatch(action: JExt.app.IAction; addToHistory: Boolean); overload;
    function getAppFolder: String;
    function getController: JExt.app.IController; overload;
    function getController(name: String): JExt.app.IController; overload;
    function getController(name: String; profileName: String): JExt.app.IController; overload;
    function getControllers: array of Variant;
    function getCurrentProfile: JExt.app.IProfile;
    function getHistory: JExt.app.IHistory;
    function getLaunch: Variant;
    function getName: String;
    function getProfiles: array of Variant;
    function getRequires: array of String;
    function getRouter: JExt.app.IRouter;
    function getThemeVariation: Variant;
    function getThemeVariationPrefix: String;
    function getThemeVariationTransitionCls: String;
    procedure redirectTo; overload;
    procedure redirectTo(url: Variant); overload;
    procedure setAppFolder; overload;
    procedure setAppFolder(appFolder: String); overload;
    procedure setControllers; overload;
    procedure setControllers(controllers: array of Variant); overload;
    procedure setCurrentProfile; overload;
    procedure setCurrentProfile(currentProfile: JExt.app.IProfile); overload;
    procedure setHistory; overload;
    procedure setHistory(history: JExt.app.IHistory); overload;
    procedure setLaunch; overload;
    procedure setLaunch(launch: Variant); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setProfiles; overload;
    procedure setProfiles(profiles: array of Variant); overload;
    procedure setRequires; overload;
    procedure setRequires(requires: array of String); overload;
    procedure setRouter; overload;
    procedure setRouter(router: JExt.app.IRouter); overload;
    procedure setThemeVariation; overload;
    procedure setThemeVariation(themeVariation: Variant); overload;
    procedure setThemeVariationPrefix; overload;
    procedure setThemeVariationPrefix(themeVariationPrefix: String); overload;
    procedure setThemeVariationTransitionCls; overload;
    procedure setThemeVariationTransitionCls(themeVariationTransitionCls: String); overload;
  end;

//Ext.app

type
  JIController = class external(JExt.IBase, JExt.mixin.IObservable)
    application: JExt.app.IApplication; // nullable
    before: Variant; // nullable
    control: Variant; // nullable
    init: Variant; // nullable
    launch: Variant; // nullable
    models: array of String; // nullable
    refs: Variant; // nullable
    routes: Variant; // nullable
    stores: array of String; // nullable
    views: array of Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getApplication: JExt.app.IApplication;
    function getBefore: Variant;
    function getBubbleEvents: Variant;
    function getControl: Variant;
    function getController: Variant; overload;
    function getController(controllerName: String): Variant; overload;
    function getController(controllerName: String; profile: String): Variant; overload;
    function getListeners: Variant;
    function getModel: Variant; overload;
    function getModel(modelName: String): Variant; overload;
    function getModels: array of String;
    function getRefs: Variant;
    function getRoutes: Variant;
    function getStores: array of String;
    function getViews: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function redirectTo: Variant; overload;
    function redirectTo(place: Variant): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setApplication; overload;
    procedure setApplication(application: JExt.app.IApplication); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setControl; overload;
    procedure setControl(control: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setModels; overload;
    procedure setModels(models: array of String); overload;
    procedure setRefs; overload;
    procedure setRefs(refs: Variant); overload;
    procedure setRoutes; overload;
    procedure setRoutes(routes: Variant); overload;
    procedure setStores; overload;
    procedure setStores(stores: array of String); overload;
    procedure setViews; overload;
    procedure setViews(views: array of Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.app

type
  JIHistory = class external(JExt.IBase, JExt.mixin.IObservable)
    actions: array of Variant; // nullable
    token: String; // nullable
    updateUrl: Boolean; // nullable
    procedure add; overload;
    procedure add(action: JExt.app.IAction); overload;
    procedure add(action: JExt.app.IAction; silent: Boolean); overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure back;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getActions: array of Variant;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getToken: String;
    function getUpdateUrl: Boolean;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setActions; overload;
    procedure setActions(actions: array of Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setToken; overload;
    procedure setToken(token: String); overload;
    procedure setUpdateUrl; overload;
    procedure setUpdateUrl(updateUrl: Boolean); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.app

type
  JIProfile = class external(JExt.IBase, JExt.mixin.IObservable)
    application: JExt.app.IApplication; // nullable
    controllers: array of Variant; // nullable
    models: array of Variant; // nullable
    name: String; // nullable
    namespace: String; // nullable
    stores: array of Variant; // nullable
    views: array of Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getApplication: JExt.app.IApplication;
    function getBubbleEvents: Variant;
    function getControllers: array of Variant;
    function getListeners: Variant;
    function getModels: array of Variant;
    function getName: String;
    function getNamespace: String;
    function getStores: array of Variant;
    function getViews: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isActive: Boolean;
    procedure launch;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setApplication; overload;
    procedure setApplication(application: JExt.app.IApplication); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setControllers; overload;
    procedure setControllers(controllers: array of Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setModels; overload;
    procedure setModels(models: array of Variant); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setNamespace; overload;
    procedure setNamespace(namespace: String); overload;
    procedure setStores; overload;
    procedure setStores(stores: array of Variant); overload;
    procedure setViews; overload;
    procedure setViews(views: array of Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.app

type
  JIRoute = class external(JExt.IBase)
    action: String; // nullable
    conditions: Variant; // nullable
    controller: String; // nullable
    url: String; // nullable
    paramsInMatchString: Variant; // nullable
    function getAction: String;
    function getConditions: Variant;
    function getController: String;
    function getUrl: String;
    function recognize: Variant; overload;
    function recognize(url: String): Variant; overload;
    procedure setAction; overload;
    procedure setAction(action: String); overload;
    procedure setConditions; overload;
    procedure setConditions(conditions: Variant); overload;
    procedure setController; overload;
    procedure setController(controller: String); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
  end;

//Ext.app

type
  JIRouter = class external(JExt.IBase)
    defaults: Variant; // nullable
    routes: array of Variant; // nullable
    procedure connect; overload;
    procedure connect(url: String); overload;
    procedure connect(url: String; params: Variant); overload;
    procedure draw; overload;
    procedure draw(fn: Variant); overload;
    function getDefaults: Variant;
    function getRoutes: array of Variant;
    function recognize: Variant; overload;
    function recognize(url: String): Variant; overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setRoutes; overload;
    procedure setRoutes(routes: array of Variant); overload;
  end;

//Ext

type
  JArray = class external 'Array'
    function clean: array of Variant; overload;
    function clean(array: array of Variant): array of Variant; overload;
    function clone: array of Variant; overload;
    function clone(array: array of Variant): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(array: array of Variant): Boolean; overload;
    function contains(array: array of Variant; item: Variant): Boolean; overload;
    function difference: array of Variant; overload;
    function difference(arrayA: array of Variant): array of Variant; overload;
    function difference(arrayA: array of Variant; arrayB: array of Variant): array of Variant; overload;
    function each: Boolean; overload;
    function each(iterable: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant; scope: Variant): Boolean; overload;
    function each(iterable: Variant; fn: Variant; scope: Variant; reverse: Boolean): Boolean; overload;
    function erase: array of Variant; overload;
    function erase(array: array of Variant): array of Variant; overload;
    function erase(array: array of Variant; index: Float): array of Variant; overload;
    function erase(array: array of Variant; index: Float; removeCount: Float): array of Variant; overload;
    function every: Boolean; overload;
    function every(array: array of Variant): Boolean; overload;
    function every(array: array of Variant; fn: Variant): Boolean; overload;
    function every(array: array of Variant; fn: Variant; scope: Variant): Boolean; overload;
    function filter: array of Variant; overload;
    function filter(array: array of Variant): array of Variant; overload;
    function filter(array: array of Variant; fn: Variant): array of Variant; overload;
    function filter(array: array of Variant; fn: Variant; scope: Variant): array of Variant; overload;
    function flatten: array of Variant; overload;
    function flatten(array: array of Variant): array of Variant; overload;
    procedure forEach; overload;
    procedure forEach(array: array of Variant); overload;
    procedure forEach(array: array of Variant; fn: Variant); overload;
    procedure forEach(array: array of Variant; fn: Variant; scope: Variant); overload;
    function from: array of Variant; overload;
    function from(value: Variant): array of Variant; overload;
    function from(value: Variant; newReference: Boolean): array of Variant; overload;
    procedure include; overload;
    procedure include(array: array of Variant); overload;
    procedure include(array: array of Variant; item: Variant); overload;
    function indexOf: Float; overload;
    function indexOf(array: array of Variant): Float; overload;
    function indexOf(array: array of Variant; item: Variant): Float; overload;
    function indexOf(array: array of Variant; item: Variant; from: Float): Float; overload;
    function insert: array of Variant; overload;
    function insert(array: array of Variant): array of Variant; overload;
    function insert(array: array of Variant; index: Float): array of Variant; overload;
    function insert(array: array of Variant; index: Float; items: array of Variant): array of Variant; overload;
    function intersect: array of Variant; overload;
    function intersect(array1: array of Variant): array of Variant; overload;
    function intersect(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function intersect(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function map: array of Variant; overload;
    function map(array: array of Variant): array of Variant; overload;
    function map(array: array of Variant; fn: Variant): array of Variant; overload;
    function map(array: array of Variant; fn: Variant; scope: Variant): array of Variant; overload;
    function max: Variant; overload;
    function max(array: Variant): Variant; overload;
    function max(array: Variant; comparisonFn: Variant): Variant; overload;
    function mean: Float; overload;
    function mean(array: array of Variant): Float; overload;
    function merge: array of Variant; overload;
    function merge(array1: array of Variant): array of Variant; overload;
    function merge(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function merge(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function min: Variant; overload;
    function min(array: Variant): Variant; overload;
    function min(array: Variant; comparisonFn: Variant): Variant; overload;
    function pluck: array of Variant; overload;
    function pluck(array: Variant): array of Variant; overload;
    function pluck(array: Variant; propertyName: String): array of Variant; overload;
    function remove: array of Variant; overload;
    function remove(array: array of Variant): array of Variant; overload;
    function remove(array: array of Variant; item: Variant): array of Variant; overload;
    function replace: array of Variant; overload;
    function replace(array: array of Variant): array of Variant; overload;
    function replace(array: array of Variant; index: Float): array of Variant; overload;
    function replace(array: array of Variant; index: Float; removeCount: Float): array of Variant; overload;
    function replace(array: array of Variant; index: Float; removeCount: Float; insert: array of Variant): array of Variant; overload;
    function slice: array of Variant; overload;
    function slice(array: array of Variant): array of Variant; overload;
    function slice(array: array of Variant; begin: Float): array of Variant; overload;
    function slice(array: array of Variant; begin: Float; &end: Float): array of Variant; overload;
    function some: Boolean; overload;
    function some(array: array of Variant): Boolean; overload;
    function some(array: array of Variant; fn: Variant): Boolean; overload;
    function some(array: array of Variant; fn: Variant; scope: Variant): Boolean; overload;
    function sort: array of Variant; overload;
    function sort(array: array of Variant): array of Variant; overload;
    function sort(array: array of Variant; sortFn: Variant): array of Variant; overload;
    function splice: array of Variant; overload;
    function splice(array: array of Variant): array of Variant; overload;
    function splice(array: array of Variant; index: Float): array of Variant; overload;
    function splice(array: array of Variant; index: Float; removeCount: Float): array of Variant; overload;
    function sum: Float; overload;
    function sum(array: array of Variant): Float; overload;
    function toArray: array of Variant; overload;
    function toArray(iterable: Variant): array of Variant; overload;
    function toArray(iterable: Variant; start: Float): array of Variant; overload;
    function toArray(iterable: Variant; start: Float; &end: Float): array of Variant; overload;
    function union: array of Variant; overload;
    function union(array1: array of Variant): array of Variant; overload;
    function union(array1: array of Variant; array2: array of Variant): array of Variant; overload;
    function union(array1: array of Variant; array2: array of Variant; etc: array of Variant): array of Variant; overload;
    function unique: array of Variant; overload;
    function unique(array: array of Variant): array of Variant; overload;
  end;

  JIArray = class external
  end;

//Ext

type
  JIAudio = class external(JExt.IMedia)
    cls: Variant; // nullable
    url: String; // nullable
    function getCls: String;
    function getUrl: String;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
  end;

//Ext

type
  JBase = class external 'Base'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: Variant;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIBase = class external(JExt.IClass)
    self: JExt.IClass; // nullable
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
  end;

//Ext.behavior

type
  JIBehavior = class external(JExt.IBase)
  end;

//Ext.behavior

type
  JIDraggable = class external(JExt.behavior.IBehavior)
  end;

//Ext.behavior

type
  JIScrollable = class external(JExt.behavior.IBehavior)
  end;

//Ext.behavior

type
  JITranslatable = class external(JExt.behavior.IBehavior)
  end;

//Ext

type
  JBrowser = class external 'Browser'
    engineName: String;
    engineVersion: JExt.IVersion;
    isSecure: Boolean;
    isStrict: Boolean;
    name: String;
    self: JExt.IClass;
    userAgent: String;
    version: JExt.IVersion;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function is: Boolean; overload;
    function is(value: String): Boolean; overload;
    function statics: JExt.IClass;
  end;

  JIBrowser = class external(JExt.env.IBrowser)
  end;

//Ext

type
  JIButton = class external(JExt.IComponent)
    autoEvent: String; // nullable
    badge: String; // nullable
    badgeCls: String; // nullable
    badgeText: String; // nullable
    baseCls: String; // nullable
    handler: Variant; // nullable
    html: String; // nullable
    icon: String; // nullable
    iconAlign: String; // nullable
    iconCls: String; // nullable
    labelCls: String; // nullable
    pressedCls: String; // nullable
    pressedDelay: Variant; // nullable
    scope: Variant; // nullable
    text: String; // nullable
    ui: String; // nullable
    function getAutoEvent: String;
    function getBadgeCls: String;
    function getBadgeText: String;
    function getBaseCls: String;
    function getHandler: Variant;
    function getIcon: String;
    function getIconAlign: String;
    function getIconCls: String;
    function getLabelCls: String;
    function getPressedCls: String;
    function getPressedDelay: Variant;
    function getScope: Variant;
    function getText: String;
    function getUi: String;
    procedure initialize;
    procedure setAutoEvent; overload;
    procedure setAutoEvent(autoEvent: String); overload;
    procedure setBadge; overload;
    procedure setBadge(text: String); overload;
    procedure setBadgeCls; overload;
    procedure setBadgeCls(badgeCls: String); overload;
    procedure setBadgeText; overload;
    procedure setBadgeText(badgeText: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setHandler; overload;
    procedure setHandler(handler: Variant); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: String); overload;
    procedure setIconAlign; overload;
    procedure setIconAlign(iconAlign: String); overload;
    procedure setIconClass; overload;
    procedure setIconClass(iconClass: String); overload;
    procedure setIconCls; overload;
    procedure setIconCls(iconCls: String); overload;
    procedure setLabelCls; overload;
    procedure setLabelCls(labelCls: String); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
    procedure setPressedDelay; overload;
    procedure setPressedDelay(pressedDelay: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
    procedure setText; overload;
    procedure setText(text: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.carousel

type
  JICarousel = class external(JExt.IContainer)
    baseCls: String; // nullable
    direction: String; // nullable
    indicator: Boolean; // nullable
    ui: String; // nullable
    procedure destroy;
    function getActiveIndex: Float;
    function getAnimation: Variant;
    function getBaseCls: String;
    function getBufferSize: Float;
    function getDirection: String;
    function getDirectionLock: Boolean;
    function getIndicator: Variant;
    function getItemConfig: Variant;
    function getItemLength: Variant;
    function getUi: String;
    function isHorizontal: Boolean;
    function isVertical: Boolean;
    function next: JExt.carousel.ICarousel;
    function prev: JExt.carousel.ICarousel;
    function previous: JExt.carousel.ICarousel;
    procedure setAnimation; overload;
    procedure setAnimation(animation: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBufferSize; overload;
    procedure setBufferSize(bufferSize: Float); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDirectionLock; overload;
    procedure setDirectionLock(directionLock: Boolean); overload;
    procedure setIndicator; overload;
    procedure setIndicator(indicator: Boolean); overload;
    procedure setItemConfig; overload;
    procedure setItemConfig(itemConfig: Variant); overload;
    procedure setItemLength; overload;
    procedure setItemLength(itemLength: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext

type
  JICarousel = class external(JExt.IContainer)
    baseCls: String; // nullable
    direction: String; // nullable
    indicator: Boolean; // nullable
    ui: String; // nullable
    procedure destroy;
    function getActiveIndex: Float;
    function getAnimation: Variant;
    function getBaseCls: String;
    function getBufferSize: Float;
    function getDirection: String;
    function getDirectionLock: Boolean;
    function getIndicator: Variant;
    function getItemConfig: Variant;
    function getItemLength: Variant;
    function getUi: String;
    function isHorizontal: Boolean;
    function isVertical: Boolean;
    function next: JExt.carousel.ICarousel;
    function prev: JExt.carousel.ICarousel;
    function previous: JExt.carousel.ICarousel;
    procedure setAnimation; overload;
    procedure setAnimation(animation: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBufferSize; overload;
    procedure setBufferSize(bufferSize: Float); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDirectionLock; overload;
    procedure setDirectionLock(directionLock: Boolean); overload;
    procedure setIndicator; overload;
    procedure setIndicator(indicator: Boolean); overload;
    procedure setItemConfig; overload;
    procedure setItemConfig(itemConfig: Variant); overload;
    procedure setItemLength; overload;
    procedure setItemLength(itemLength: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.carousel

type
  JIIndicator = class external(JExt.IComponent)
    baseCls: String; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDirection: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
  end;

//Ext.carousel

type
  JIInfinite = class external(JExt.carousel.ICarousel)
    indicator: Boolean; // nullable
    function getIndicator: Variant;
    function getInnerItemConfig: Variant;
    function getMaxItemIndex: Variant;
    procedure setIndicator; overload;
    procedure setIndicator(indicator: Variant); overload;
    procedure setInnerItemConfig; overload;
    procedure setInnerItemConfig(innerItemConfig: Variant); overload;
    procedure setMaxItemIndex; overload;
    procedure setMaxItemIndex(maxItemIndex: Variant); overload;
  end;

//Ext.carousel

type
  JIItem = class external(JExt.IDecorator)
    baseCls: String; // nullable
    component: Variant; // nullable
    function getBaseCls: String;
    function getComponent: Variant;
    function getTranslatable: Boolean;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Boolean); overload;
  end;

//Ext.chart

type
  JIAbstractChart = class external(JExt.draw.IComponent)
    animate: Variant; // nullable
    axes: Variant; // nullable
    background: Variant; // nullable
    colors: Variant; // nullable
    highlightItem: Variant; // nullable
    innerPadding: Variant; // nullable
    insetPadding: Variant; // nullable
    interactions: array of Variant; // nullable
    legend: Variant; // nullable
    series: Variant; // nullable
    shadow: Variant; // nullable
    store: JExt.data.IStore; // nullable
    version: String; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: JExt.data.IStore); overload;
    procedure cancelLayout;
    function flatten: Variant; overload;
    function flatten(surfaces: array of Variant): Variant; overload;
    function flatten(surfaces: array of Variant; format: String): Variant; overload;
    function getAxes: Variant;
    function getBackground: Variant;
    function getColors: Variant;
    function getHighlightItem: Variant;
    function getInnerPadding: Variant;
    function getInsetPadding: Variant;
    function getInteractions: array of Variant;
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Float): Variant; overload;
    function getItemForPoint(x: Float; y: Float): Variant; overload;
    function getItemsForPoint: array of Variant; overload;
    function getItemsForPoint(x: Float): array of Variant; overload;
    function getItemsForPoint(x: Float; y: Float): array of Variant; overload;
    function getLegend: Variant;
    function getLegendStore: JExt.data.IStore;
    function getSeries: Variant;
    function getShadow: Variant;
    function getStore: JExt.data.IStore;
    function getSurface: JExt.draw.ISurface; overload;
    function getSurface(name: Variant): JExt.draw.ISurface; overload;
    function getSurface(name: Variant; &type: Variant): JExt.draw.ISurface; overload;
    procedure initialize;
    procedure redraw;
    procedure resumeThicknessChanged;
    procedure scheduleLayout;
    procedure setAnimate; overload;
    procedure setAnimate(animate: Variant); overload;
    procedure setAxes; overload;
    procedure setAxes(axes: Variant); overload;
    procedure setBackground; overload;
    procedure setBackground(background: Variant); overload;
    procedure setColors; overload;
    procedure setColors(colors: Variant); overload;
    procedure setHighlightItem; overload;
    procedure setHighlightItem(highlightItem: Variant); overload;
    procedure setInnerPadding; overload;
    procedure setInnerPadding(innerPadding: Variant); overload;
    procedure setInsetPadding; overload;
    procedure setInsetPadding(insetPadding: Variant); overload;
    procedure setInteractions; overload;
    procedure setInteractions(interactions: array of Variant); overload;
    procedure setLegend; overload;
    procedure setLegend(legend: Variant); overload;
    procedure setSeries; overload;
    procedure setSeries(series: Variant); overload;
    procedure setShadow; overload;
    procedure setShadow(shadow: Variant); overload;
    procedure setStore; overload;
    procedure setStore(store: JExt.data.IStore); overload;
    procedure suspendThicknessChanged;
  end;

//Ext.chart.axis

type
  JIAxis = class external(JExt.IBase, JExt.mixin.IObservable)
    background: Variant; // nullable
    chart: JExt.chart.IAbstractChart; // nullable
    fields: array of Variant; // nullable
    grid: Variant; // nullable
    hidden: Boolean; // nullable
    increment: Float; // nullable
    &label: Variant; // nullable
    labelInSpan: Boolean; // nullable
    layout: Variant; // nullable
    majorTickSteps: Float; // nullable
    maxZoom: Float; // nullable
    maximum: Float; // nullable
    minZoom: Float; // nullable
    minimum: Float; // nullable
    minorTickSteps: Float; // nullable
    needHighPrecision: Boolean; // nullable
    position: String; // nullable
    renderer: Variant; // nullable
    segmenter: Variant; // nullable
    style: Variant; // nullable
    title: Variant; // nullable
    titleMargin: Float; // nullable
    visibleRange: array of Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBackground: Variant;
    function getBubbleEvents: Variant;
    function getChart: JExt.chart.IAbstractChart;
    function getCoordFor: Float; overload;
    function getCoordFor(value: Variant): Float; overload;
    function getCoordFor(value: Variant; field: String): Float; overload;
    function getCoordFor(value: Variant; field: String; idx: Float): Float; overload;
    function getCoordFor(value: Variant; field: String; idx: Float; items: JExt.util.IMixedCollection): Float; overload;
    function getFields: array of Variant;
    function getGrid: Variant;
    function getHidden: Boolean;
    function getIncrement: Float;
    function getLabel: Variant;
    function getLabelInSpan: Boolean;
    function getLayout: Variant;
    function getListeners: Variant;
    function getMajorTickSteps: Float;
    function getMaxZoom: Float;
    function getMaximum: Float;
    function getMinZoom: Float;
    function getMinimum: Float;
    function getMinorTickSteps: Float;
    function getNeedHighPrecision: Boolean;
    function getPosition: String;
    function getRange: array of Variant;
    function getRenderer: Variant;
    function getSegmenter: Variant;
    function getStyle: Variant;
    function getTitle: Variant;
    function getTitleMargin: Float;
    function getVisibleRange: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure processData;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure renderFrame;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBackground; overload;
    procedure setBackground(background: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setChart; overload;
    procedure setChart(chart: JExt.chart.IAbstractChart); overload;
    procedure setFields; overload;
    procedure setFields(fields: array of Variant); overload;
    procedure setGrid; overload;
    procedure setGrid(grid: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setIncrement; overload;
    procedure setIncrement(increment: Float); overload;
    procedure setLabel; overload;
    procedure setLabel(&label: Variant); overload;
    procedure setLabelInSpan; overload;
    procedure setLabelInSpan(labelInSpan: Boolean); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMajorTickSteps; overload;
    procedure setMajorTickSteps(majorTickSteps: Float); overload;
    procedure setMaxZoom; overload;
    procedure setMaxZoom(maxZoom: Float); overload;
    procedure setMaximum; overload;
    procedure setMaximum(maximum: Float); overload;
    procedure setMinZoom; overload;
    procedure setMinZoom(minZoom: Float); overload;
    procedure setMinimum; overload;
    procedure setMinimum(minimum: Float); overload;
    procedure setMinorTickSteps; overload;
    procedure setMinorTickSteps(minorTickSteps: Float); overload;
    procedure setNeedHighPrecision; overload;
    procedure setNeedHighPrecision(needHighPrecision: Boolean); overload;
    procedure setPosition; overload;
    procedure setPosition(position: String); overload;
    function setRenderer: String; overload;
    function setRenderer(renderer: Variant): String; overload;
    procedure setSegmenter; overload;
    procedure setSegmenter(segmenter: Variant); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: Variant); overload;
    procedure setTitleMargin; overload;
    procedure setTitleMargin(titleMargin: Float); overload;
    procedure setVisibleRange; overload;
    procedure setVisibleRange(visibleRange: array of Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.chart.axis

type
  JICategory = class external(JExt.chart.axis.IAxis)
    layout: Variant; // nullable
    segmenter: Variant; // nullable
    function getLayout: String;
    function getSegmenter: String;
    procedure setLayout; overload;
    procedure setLayout(layout: String); overload;
    procedure setSegmenter; overload;
    procedure setSegmenter(segmenter: String); overload;
  end;

//Ext.chart.axis.layout

type
  JICombineDuplicate = class external(JExt.chart.axis.layout.IDiscrete)
  end;

//Ext.chart.axis.layout

type
  JIContinuous = class external(JExt.chart.axis.layout.ILayout)
    function getAdjustMaximumByMajorUnit: Boolean;
    function getAdjustMinimumByMajorUnit: Boolean;
    procedure setAdjustMaximumByMajorUnit; overload;
    procedure setAdjustMaximumByMajorUnit(adjustMaximumByMajorUnit: Boolean); overload;
    procedure setAdjustMinimumByMajorUnit; overload;
    procedure setAdjustMinimumByMajorUnit(adjustMinimumByMajorUnit: Boolean); overload;
    procedure snapEnds; overload;
    procedure snapEnds(context: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant; max: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant; max: Variant; estStepSize: Variant); overload;
  end;

//Ext.chart.axis.layout

type
  JIDiscrete = class external(JExt.chart.axis.layout.ILayout)
    function calculateLayout: Variant; overload;
    function calculateLayout(context: Variant): Variant; overload;
    procedure calculateMajorTicks; overload;
    procedure calculateMajorTicks(context: Variant); overload;
    procedure processData;
    procedure snapEnds; overload;
    procedure snapEnds(context: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant; max: Variant); overload;
    procedure snapEnds(context: Variant; min: Variant; max: Variant; estStepSize: Variant); overload;
    procedure trimByRange; overload;
    procedure trimByRange(context: Variant); overload;
    procedure trimByRange(context: Variant; out: Variant); overload;
    procedure trimByRange(context: Variant; out: Variant; trimMin: Variant); overload;
    procedure trimByRange(context: Variant; out: Variant; trimMin: Variant; trimMax: Variant); overload;
  end;

//Ext.chart.axis.layout

type
  JILayout = class external(JExt.IBase)
    axis: JExt.chart.axis.IAxis; // nullable
    function calculateLayout: Variant; overload;
    function calculateLayout(context: Variant): Variant; overload;
    procedure calculateMajorTicks; overload;
    procedure calculateMajorTicks(context: Variant); overload;
    procedure calculateMinorTicks; overload;
    procedure calculateMinorTicks(context: Variant); overload;
    function getAxis: JExt.chart.axis.IAxis;
    procedure processData; overload;
    procedure processData(series: JExt.chart.series.ISeries); overload;
    procedure setAxis; overload;
    procedure setAxis(axis: JExt.chart.axis.IAxis); overload;
    procedure snapEnds; overload;
    procedure snapEnds(context: Variant); overload;
    procedure snapEnds(context: Variant; min: Float); overload;
    procedure snapEnds(context: Variant; min: Float; max: Float); overload;
    procedure snapEnds(context: Variant; min: Float; max: Float; estStepSize: Float); overload;
    procedure trimByRange; overload;
    procedure trimByRange(context: Variant); overload;
    procedure trimByRange(context: Variant; out: Variant); overload;
    procedure trimByRange(context: Variant; out: Variant; trimMin: Float); overload;
    procedure trimByRange(context: Variant; out: Variant; trimMin: Float; trimMax: Float); overload;
  end;

//Ext.chart.axis

type
  JINumeric = class external(JExt.chart.axis.IAxis)
    layout: Variant; // nullable
    segmenter: Variant; // nullable
    function getAggregator: String;
    function getLayout: String;
    function getSegmenter: String;
    procedure setAggregator; overload;
    procedure setAggregator(aggregator: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: String); overload;
    procedure setSegmenter; overload;
    procedure setSegmenter(segmenter: String); overload;
  end;

//Ext.chart.axis.segmenter

type
  JINames = class external(JExt.chart.axis.segmenter.ISegmenter)
    procedure add; overload;
    procedure add(value: Variant); overload;
    procedure add(value: Variant; step: Variant); overload;
    procedure add(value: Variant; step: Variant; unit: Variant); overload;
    function align: Variant; overload;
    function align(value: Variant): Variant; overload;
    function align(value: Variant; step: Variant): Variant; overload;
    function align(value: Variant; step: Variant; unit: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: Variant): Float; overload;
    function preferredStep: Variant; overload;
    function preferredStep(min: Variant): Variant; overload;
    function preferredStep(min: Variant; estStepSize: Variant): Variant; overload;
    function preferredStep(min: Variant; estStepSize: Variant; minIdx: Variant): Variant; overload;
    function preferredStep(min: Variant; estStepSize: Variant; minIdx: Variant; data: Variant): Variant; overload;
    function renderer: String; overload;
    function renderer(value: Variant): String; overload;
    function renderer(value: Variant; context: Variant): String; overload;
  end;

//Ext.chart.axis.segmenter

type
  JINumeric = class external(JExt.chart.axis.segmenter.ISegmenter)
    procedure add; overload;
    procedure add(value: Variant); overload;
    procedure add(value: Variant; step: Variant); overload;
    procedure add(value: Variant; step: Variant; unit: Variant); overload;
    function align: Variant; overload;
    function align(value: Variant): Variant; overload;
    function align(value: Variant; step: Variant): Variant; overload;
    function align(value: Variant; step: Variant; unit: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: Variant): Float; overload;
    function exactStep: Variant; overload;
    function exactStep(start: Variant): Variant; overload;
    function exactStep(start: Variant; estStepSize: Variant): Variant; overload;
    function preferredStep: Variant; overload;
    function preferredStep(min: Variant): Variant; overload;
    function preferredStep(min: Variant; estStepSize: Variant): Variant; overload;
    function renderer: String; overload;
    function renderer(value: Variant): String; overload;
    function renderer(value: Variant; context: Variant): String; overload;
  end;

//Ext.chart.axis.segmenter

type
  JISegmenter = class external(JExt.IBase)
    axis: JExt.chart.axis.IAxis; // nullable
    procedure add; overload;
    procedure add(value: Variant); overload;
    procedure add(value: Variant; step: Float); overload;
    procedure add(value: Variant; step: Float; unit: Variant); overload;
    function align: Variant; overload;
    function align(value: Variant): Variant; overload;
    function align(value: Variant; step: Float): Variant; overload;
    function align(value: Variant; step: Float; unit: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: Variant): Float; overload;
    function from: Variant; overload;
    function from(value: Variant): Variant; overload;
    function getAxis: JExt.chart.axis.IAxis;
    function preferredStep: Variant; overload;
    function preferredStep(start: Variant): Variant; overload;
    function preferredStep(start: Variant; estStepSize: Variant): Variant; overload;
    function renderer: String; overload;
    function renderer(value: Variant): String; overload;
    function renderer(value: Variant; context: Variant): String; overload;
    procedure setAxis; overload;
    procedure setAxis(axis: JExt.chart.axis.IAxis); overload;
  end;

//Ext.chart.axis.segmenter

type
  JITime = class external(JExt.chart.axis.segmenter.ISegmenter)
    step: Variant; // nullable
    procedure add; overload;
    procedure add(value: Variant); overload;
    procedure add(value: Variant; step: Variant); overload;
    procedure add(value: Variant; step: Variant; unit: Variant); overload;
    function align: Variant; overload;
    function align(date: Variant): Variant; overload;
    function align(date: Variant; step: Variant): Variant; overload;
    function align(date: Variant; step: Variant; unit: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: Variant): Float; overload;
    function from: Variant; overload;
    function from(value: Variant): Variant; overload;
    function getStep: Variant;
    function preferredStep: Variant; overload;
    function preferredStep(min: Variant): Variant; overload;
    function preferredStep(min: Variant; estStepSize: Variant): Variant; overload;
    function renderer: String; overload;
    function renderer(value: Variant): String; overload;
    function renderer(value: Variant; context: Variant): String; overload;
    procedure setStep; overload;
    procedure setStep(step: Variant); overload;
  end;

//Ext.chart.axis.sprite

type
  JIAxis = class external(JExt.draw.sprite.ISprite, JExt.chart.IMarkerHolder)
    The: Float; // nullable
    axis: JExt.chart.axis.IAxis; // nullable
    axisLine: Boolean; // nullable
    centerX: Float; // nullable
    centerY: Float; // nullable
    dataMax: Float; // nullable
    dataMin: Float; // nullable
    enlargeEstStepSizeByText: Boolean; // nullable
    grid: Boolean; // nullable
    &label: Variant; // nullable
    layout: Variant; // nullable
    _length: Float; // nullable
    majorTickSize: Float; // nullable
    majorTicks: Boolean; // nullable
    max: Float; // nullable
    min: Float; // nullable
    minStepSize: Float; // nullable
    minorTickSize: Float; // nullable
    minorTricks: Boolean; // nullable
    position: String; // nullable
    renderer: Variant; // nullable
    segmenter: Variant; // nullable
    textPadding: Float; // nullable
    visibleMax: Float; // nullable
    visibleMin: Float; // nullable
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
    function getAxis: JExt.chart.axis.IAxis;
    procedure getBBox;
    function getLabel: Variant;
    function getLayout: Variant;
    function getRenderer: Variant;
    function getSegmenter: Variant;
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
    procedure setAxis; overload;
    procedure setAxis(axis: JExt.chart.axis.IAxis); overload;
    procedure setLabel; overload;
    procedure setLabel(&label: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setRenderer; overload;
    procedure setRenderer(renderer: Variant); overload;
    procedure setSegmenter; overload;
    procedure setSegmenter(segmenter: Variant); overload;
  end;

//Ext.chart.axis

type
  JITime = class external(JExt.chart.axis.INumeric)
    calculateByLabelSize: Boolean; // nullable
    dateFormat: Variant; // nullable
    fromDate: Variant; // nullable
    layout: Variant; // nullable
    segmenter: Variant; // nullable
    step: array of Variant; // nullable
    toDate: Variant; // nullable
    function getAggregator: String;
    function getCalculateByLabelSize: Boolean;
    function getCoordFor: Float; overload;
    function getCoordFor(value: Variant): Float; overload;
    function getDateFormat: Variant;
    function getFromDate: Variant;
    function getLayout: String;
    function getSegmenter: String;
    function getStep: array of Variant;
    function getToDate: Variant;
    procedure setAggregator; overload;
    procedure setAggregator(aggregator: String); overload;
    procedure setCalculateByLabelSize; overload;
    procedure setCalculateByLabelSize(calculateByLabelSize: Boolean); overload;
    procedure setDateFormat; overload;
    procedure setDateFormat(dateFormat: Variant); overload;
    procedure setFromDate; overload;
    procedure setFromDate(fromDate: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: String); overload;
    procedure setSegmenter; overload;
    procedure setSegmenter(segmenter: String); overload;
    procedure setStep; overload;
    procedure setStep(step: array of Variant); overload;
    procedure setToDate; overload;
    procedure setToDate(toDate: Variant); overload;
  end;

//Ext.chart

type
  JICartesianChart = class external(JExt.chart.IAbstractChart)
    flipXY: Boolean; // nullable
    function getFlipXY: Boolean;
    function getInnerRegion: array of Variant;
    procedure onPlaceWatermark;
    procedure performLayout;
    procedure redraw;
    procedure setFlipXY; overload;
    procedure setFlipXY(flipXY: Boolean); overload;
    procedure setInnerRegion; overload;
    procedure setInnerRegion(innerRegion: array of Variant); overload;
  end;

//Ext.chart

type
  JIChart = class external(JExt.chart.IAbstractChart)
    flipXY: Boolean; // nullable
    function getFlipXY: Boolean;
    function getInnerRegion: array of Variant;
    procedure onPlaceWatermark;
    procedure performLayout;
    procedure redraw;
    procedure setFlipXY; overload;
    procedure setFlipXY(flipXY: Boolean); overload;
    procedure setInnerRegion; overload;
    procedure setInnerRegion(innerRegion: array of Variant); overload;
  end;

//Ext.chart.grid

type
  JICircularGrid = class external(JExt.draw.sprite.ICircle)
  end;

//Ext.chart.grid

type
  JIHorizontalGrid = class external(JExt.draw.sprite.ISprite)
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
  end;

//Ext.chart.grid

type
  JIRadialGrid = class external(JExt.draw.sprite.IPath)
    function render: Variant;
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
  end;

//Ext.chart.grid

type
  JIVerticalGrid = class external(JExt.draw.sprite.ISprite)
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
  end;

//Ext.chart.interactions

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    chart: JExt.chart.IAbstractChart; // nullable
    enabled: Boolean; // nullable
    gesture: String; // nullable
    throttleGap: Float; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getChart: JExt.chart.IAbstractChart;
    function getEnabled: Boolean;
    function getGesture: String;
    function getItemForEvent: Variant; overload;
    function getItemForEvent(e: JEvent): Variant; overload;
    function getItemsForEvent: array of Variant; overload;
    function getItemsForEvent(e: JEvent): array of Variant; overload;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure initialize;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onGesture;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setChart; overload;
    procedure setChart(chart: JExt.chart.IAbstractChart); overload;
    procedure setEnabled; overload;
    procedure setEnabled(enabled: Boolean); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.chart.interactions

type
  JICrosshair = class external(JExt.chart.interactions.IAbstract)
    axes: Variant; // nullable
    gesture: String; // nullable
    lines: Variant; // nullable
    function getAxes: Variant;
    function getGesture: String;
    function getLines: Variant;
    procedure onGesture; overload;
    procedure onGesture(e: Variant); overload;
    procedure setAxes; overload;
    procedure setAxes(axes: Variant); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
    procedure setLines; overload;
    procedure setLines(lines: Variant); overload;
  end;

//Ext.chart.interactions

type
  JICrossZoom = class external(JExt.chart.interactions.IAbstract)
    axes: Variant; // nullable
    gesture: String; // nullable
    function getAxes: Variant;
    function getGesture: String;
    function getUndoButton: Variant;
    procedure onGesture; overload;
    procedure onGesture(e: Variant); overload;
    procedure setAxes; overload;
    procedure setAxes(axes: Variant); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
    procedure setUndoButton; overload;
    procedure setUndoButton(undoButton: Variant); overload;
  end;

//Ext.chart.interactions

type
  JIItemHighlight = class external(JExt.chart.interactions.IAbstract)
    gesture: String; // nullable
    function getGesture: String;
    procedure onGesture; overload;
    procedure onGesture(series: Variant); overload;
    procedure onGesture(series: Variant; item: Variant); overload;
    procedure onGesture(series: Variant; item: Variant; e: Variant); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
  end;

//Ext.chart.interactions

type
  JIItemInfo = class external(JExt.chart.interactions.IAbstract)
    gesture: String; // nullable
    panel: Variant; // nullable
    function getGesture: String;
    function getPanel: Variant;
    procedure onGesture; overload;
    procedure onGesture(series: Variant); overload;
    procedure onGesture(series: Variant; item: Variant); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
    procedure setPanel; overload;
    procedure setPanel(panel: Variant); overload;
  end;

//Ext.chart.interactions

type
  JIPanZoom = class external(JExt.chart.interactions.IAbstract)
    axes: Variant; // nullable
    overflowArrowOptions: Variant; // nullable
    showOverflowArrows: Boolean; // nullable
    procedure destroy;
    function getAxes: Variant;
    function getHideLabelInGesture: Boolean;
    function getMaxZoom: Variant;
    function getMinZoom: Variant;
    function getModeToggleButton: Variant;
    function getPanGesture: String;
    function getShowOverflowArrows: Boolean;
    function getZoomOnPanGesture: Boolean;
    procedure onGesture; overload;
    procedure onGesture(e: Variant); overload;
    procedure setAxes; overload;
    procedure setAxes(axes: Variant); overload;
    procedure setHideLabelInGesture; overload;
    procedure setHideLabelInGesture(hideLabelInGesture: Boolean); overload;
    procedure setMaxZoom; overload;
    procedure setMaxZoom(maxZoom: Variant); overload;
    procedure setMinZoom; overload;
    procedure setMinZoom(minZoom: Variant); overload;
    procedure setModeToggleButton; overload;
    procedure setModeToggleButton(modeToggleButton: Variant); overload;
    procedure setPanGesture; overload;
    procedure setPanGesture(panGesture: String); overload;
    procedure setShowOverflowArrows; overload;
    procedure setShowOverflowArrows(showOverflowArrows: Boolean); overload;
    procedure setZoomOnPanGesture; overload;
    procedure setZoomOnPanGesture(zoomOnPanGesture: Boolean); overload;
  end;

//Ext.chart.interactions

type
  JIRotate = class external(JExt.chart.interactions.IAbstract)
    gesture: String; // nullable
    function getGesture: String;
    procedure onGesture; overload;
    procedure onGesture(e: Variant); overload;
    procedure setGesture; overload;
    procedure setGesture(gesture: String); overload;
  end;

//Ext.chart.interactions

type
  JIRotatePie3D = class external(JExt.chart.interactions.IRotate)
  end;

//Ext.chart.label

type
  JICallout = class external(JExt.draw.modifier.IModifier)
    procedure popUp; overload;
    procedure popUp(attr: Variant); overload;
    procedure popUp(attr: Variant; changes: Variant); overload;
    procedure prepareAttributes; overload;
    procedure prepareAttributes(attr: Variant); overload;
    function pushDown: Variant; overload;
    function pushDown(attr: Variant): Variant; overload;
    function pushDown(attr: Variant; changes: Variant): Variant; overload;
  end;

//Ext.chart.label

type
  JILabel = class external(JExt.draw.sprite.IText)
    fx: Variant; // nullable
    function getField: Variant;
    function getFx: Variant;
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
    procedure setField; overload;
    procedure setField(field: Variant); overload;
    procedure setFx; overload;
    procedure setFx(fx: Variant); overload;
  end;

//Ext.chart

type
  JILegend = class external(JExt.dataview.IDataView)
    baseCls: String; // nullable
    disableSelection: Boolean; // nullable
    docked: String; // nullable
    inline: Variant; // nullable
    itemTpl: Variant; // nullable
    padding: Variant; // nullable
    position: String; // nullable
    toggleable: Boolean; // nullable
    function getBaseCls: String;
    function getDisableSelection: Boolean;
    function getDocked: String;
    function getHorizontalHeight: Float;
    function getInline: Boolean;
    function getItemTpl: array of Variant;
    function getPadding: Float;
    function getToggleable: Boolean;
    function getVerticalWidth: Float;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDisableSelection; overload;
    procedure setDisableSelection(disableSelection: Boolean); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setHorizontalHeight; overload;
    procedure setHorizontalHeight(horizontalHeight: Float); overload;
    procedure setInline; overload;
    procedure setInline(inline: Boolean); overload;
    procedure setItemTpl; overload;
    procedure setItemTpl(itemTpl: array of Variant); overload;
    procedure setPadding; overload;
    procedure setPadding(padding: Float); overload;
    procedure setToggleable; overload;
    procedure setToggleable(toggleable: Boolean); overload;
    procedure setVerticalWidth; overload;
    procedure setVerticalWidth(verticalWidth: Float); overload;
  end;

//Ext.chart

type
  JIMarkerHolder = class external(JExt.mixin.IMixin)
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
  end;

//Ext.chart

type
  JIMarkers = class external(JExt.draw.sprite.IInstancing)
    procedure clear; overload;
    procedure clear(category: String); overload;
    function getBBox: Variant;
    procedure getMarkerBBoxFor; overload;
    procedure getMarkerBBoxFor(category: String); overload;
    procedure getMarkerBBoxFor(category: String; index: Variant); overload;
    procedure getMarkerBBoxFor(category: String; index: Variant; isWithoutTransform: Boolean); overload;
    procedure putMarkerFor; overload;
    procedure putMarkerFor(category: String); overload;
    procedure putMarkerFor(category: String; markerAttr: Variant); overload;
    procedure putMarkerFor(category: String; markerAttr: Variant; index: Variant); overload;
    procedure putMarkerFor(category: String; markerAttr: Variant; index: Variant; canonical: Boolean); overload;
    procedure putMarkerFor(category: String; markerAttr: Variant; index: Variant; canonical: Boolean; keepRevision: Boolean); overload;
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
  end;

//Ext.chart

type
  JIPolarChart = class external(JExt.chart.IAbstractChart)
    center: array of Variant; // nullable
    radius: Float; // nullable
    function getCenter: array of Variant;
    function getRadius: Float;
    procedure redraw;
    procedure setCenter; overload;
    procedure setCenter(center: array of Variant); overload;
    procedure setRadius; overload;
    procedure setRadius(radius: Float); overload;
  end;

//Ext.chart.series

type
  JIArea = class external(JExt.chart.series.IStackedCartesian)
    seriesType: String; // nullable
    &type: String; // nullable
  end;

//Ext.chart.series

type
  JIBar = class external(JExt.chart.series.IStackedCartesian)
    seriesType: String; // nullable
    &type: String; // nullable
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Variant): Variant; overload;
    function getItemForPoint(x: Variant; y: Variant): Variant; overload;
  end;

//Ext.chart.series

type
  JICandleStick = class external(JExt.chart.series.ICartesian)
    closeField: String; // nullable
    highField: String; // nullable
    lowField: String; // nullable
    openField: String; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getCloseField: String;
    function getHighField: String;
    function getLowField: String;
    function getOpenField: String;
    procedure setCloseField; overload;
    procedure setCloseField(closeField: String); overload;
    procedure setHighField; overload;
    procedure setHighField(highField: String); overload;
    procedure setLowField; overload;
    procedure setLowField(lowField: String); overload;
    procedure setOpenField; overload;
    procedure setOpenField(openField: String); overload;
  end;

//Ext.chart.series

type
  JICartesian = class external(JExt.chart.series.ISeries)
    xAxis: JExt.chart.axis.IAxis; // nullable
    xField: String; // nullable
    yAxis: JExt.chart.axis.IAxis; // nullable
    yField: String; // nullable
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Variant): Variant; overload;
    function getItemForPoint(x: Variant; y: Variant): Variant; overload;
    procedure getSprites;
    function getXAxis: JExt.chart.axis.IAxis;
    function getXField: String;
    function getYAxis: JExt.chart.axis.IAxis;
    function getYField: String;
    procedure provideLegendInfo; overload;
    procedure provideLegendInfo(target: Variant); overload;
    procedure setXAxis; overload;
    procedure setXAxis(xAxis: JExt.chart.axis.IAxis); overload;
    procedure setXField; overload;
    procedure setXField(xField: String); overload;
    procedure setYAxis; overload;
    procedure setYAxis(yAxis: JExt.chart.axis.IAxis); overload;
    procedure setYField; overload;
    procedure setYField(yField: String); overload;
  end;

//Ext.chart.series

type
  JIGauge = class external(JExt.chart.series.ISeries)
    angleField: String; // nullable
    colors: array of Variant; // nullable
    donut: Float; // nullable
    field: String; // nullable
    maximum: Float; // nullable
    minimum: Float; // nullable
    needle: Boolean; // nullable
    needleLength: Float; // nullable
    needleLengthRatio: Float; // nullable
    needleWidth: Float; // nullable
    sectors: array of Variant; // nullable
    showInLegend: Boolean; // nullable
    value: Float; // nullable
    wholeDisk: Boolean; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getAngleField: String;
    function getCenter: array of Variant;
    function getColors: array of Variant;
    function getDonut: Float;
    function getField: String;
    function getMaximum: Float;
    function getMinimum: Float;
    function getNeedle: Boolean;
    function getNeedleLength: Float;
    function getNeedleLengthRatio: Float;
    function getNeedleWidth: Float;
    function getRadius: Float;
    function getRegion: array of Variant;
    function getRotation: Float;
    function getSectors: array of Variant;
    function getShowInLegend: Boolean;
    procedure getSprites;
    function getTotalAngle: Variant;
    function getValue: Float;
    function getWholeDisk: Boolean;
    procedure setAngleField; overload;
    procedure setAngleField(angleField: String); overload;
    procedure setCenter; overload;
    procedure setCenter(center: array of Variant); overload;
    procedure setColors; overload;
    procedure setColors(colors: array of Variant); overload;
    procedure setDonut; overload;
    procedure setDonut(donut: Float); overload;
    procedure setField; overload;
    procedure setField(field: String); overload;
    procedure setMaximum; overload;
    procedure setMaximum(maximum: Float); overload;
    procedure setMinimum; overload;
    procedure setMinimum(minimum: Float); overload;
    procedure setNeedle; overload;
    procedure setNeedle(needle: Boolean); overload;
    procedure setNeedleLength; overload;
    procedure setNeedleLength(needleLength: Float); overload;
    procedure setNeedleLengthRatio; overload;
    procedure setNeedleLengthRatio(needleLengthRatio: Float); overload;
    procedure setNeedleWidth; overload;
    procedure setNeedleWidth(needleWidth: Float); overload;
    procedure setRadius; overload;
    procedure setRadius(radius: Float); overload;
    procedure setRegion; overload;
    procedure setRegion(region: array of Variant); overload;
    procedure setRotation; overload;
    procedure setRotation(rotation: Float); overload;
    procedure setSectors; overload;
    procedure setSectors(sectors: array of Variant); overload;
    procedure setShowInLegend; overload;
    procedure setShowInLegend(showInLegend: Boolean); overload;
    procedure setTotalAngle; overload;
    procedure setTotalAngle(totalAngle: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Float); overload;
    procedure setWholeDisk; overload;
    procedure setWholeDisk(wholeDisk: Boolean); overload;
  end;

//Ext.chart.series

type
  JIItemPublisher = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.chart.series

type
  JILine = class external(JExt.chart.series.ICartesian)
    fill: Boolean; // nullable
    selectionTolerance: Float; // nullable
    smooth: Variant; // nullable
    step: Boolean; // nullable
    style: Variant; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getAggregator: Variant;
    function getFill: Boolean;
    function getSelectionTolerance: Float;
    function getSmooth: Variant;
    function getStep: Boolean;
    procedure setAggregator; overload;
    procedure setAggregator(aggregator: Variant); overload;
    procedure setFill; overload;
    procedure setFill(fill: Boolean); overload;
    procedure setSelectionTolerance; overload;
    procedure setSelectionTolerance(selectionTolerance: Float); overload;
    procedure setSmooth; overload;
    procedure setSmooth(smooth: Variant); overload;
    procedure setStep; overload;
    procedure setStep(step: Boolean); overload;
  end;

//Ext.chart.series

type
  JIPie = class external(JExt.chart.series.IPolar)
    Allows: Float; // nullable
    donut: Variant; // nullable
    field: String; // nullable
    hidden: array of Variant; // nullable
    labelField: String; // nullable
    rotation: Float; // nullable
    style: Variant; // nullable
    totalAngle: Float; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getDonut: Variant;
    function getItemForAngle: Variant; overload;
    function getItemForAngle(angle: Float): Variant; overload;
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Variant): Variant; overload;
    function getItemForPoint(x: Variant; y: Variant): Variant; overload;
    function getLabelField: String;
    function getRotation: Float;
    procedure getSprites;
    function getStyle: Variant;
    function getTotalAngle: Float;
    procedure provideLegendInfo; overload;
    procedure provideLegendInfo(target: Variant); overload;
    procedure setDonut; overload;
    procedure setDonut(donut: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: array of Variant); overload;
    procedure setLabelField; overload;
    procedure setLabelField(labelField: String); overload;
    procedure setRotation; overload;
    procedure setRotation(rotation: Float); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setTotalAngle; overload;
    procedure setTotalAngle(totalAngle: Float); overload;
  end;

//Ext.chart.series

type
  JIPie3D = class external(JExt.chart.series.IPolar)
    donut: Variant; // nullable
    field: String; // nullable
    rotation: Float; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getDistortion: Float;
    function getDonut: Variant;
    function getField: String;
    function getRegion: array of Variant;
    function getRotation: Float;
    procedure getSprites;
    function getThickness: Float;
    procedure setDistortion; overload;
    procedure setDistortion(distortion: Float); overload;
    procedure setDonut; overload;
    procedure setDonut(donut: Variant); overload;
    procedure setField; overload;
    procedure setField(field: String); overload;
    procedure setRegion; overload;
    procedure setRegion(region: array of Variant); overload;
    procedure setRotation; overload;
    procedure setRotation(rotation: Float); overload;
    procedure setThickness; overload;
    procedure setThickness(thickness: Float); overload;
  end;

//Ext.chart.series

type
  JIPolar = class external(JExt.chart.series.ISeries)
    center: array of Variant; // nullable
    offsetX: Float; // nullable
    offsetY: Float; // nullable
    radius: Float; // nullable
    rotation: Float; // nullable
    showInLegend: Boolean; // nullable
    xField: String; // nullable
    yField: String; // nullable
    function getCenter: array of Variant;
    function getOffsetX: Float;
    function getOffsetY: Float;
    function getRadius: Float;
    function getRotation: Float;
    function getShowInLegend: Boolean;
    function getXAxis: Variant;
    function getXField: String;
    function getYAxis: Variant;
    function getYField: String;
    procedure setCenter; overload;
    procedure setCenter(center: array of Variant); overload;
    procedure setOffsetX; overload;
    procedure setOffsetX(offsetX: Float); overload;
    procedure setOffsetY; overload;
    procedure setOffsetY(offsetY: Float); overload;
    procedure setRadius; overload;
    procedure setRadius(radius: Float); overload;
    procedure setRotation; overload;
    procedure setRotation(rotation: Float); overload;
    procedure setShowInLegend; overload;
    procedure setShowInLegend(showInLegend: Boolean); overload;
    procedure setXAxis; overload;
    procedure setXAxis(xAxis: Variant); overload;
    procedure setXField; overload;
    procedure setXField(xField: String); overload;
    procedure setYAxis; overload;
    procedure setYAxis(yAxis: Variant); overload;
    procedure setYField; overload;
    procedure setYField(yField: String); overload;
  end;

//Ext.chart.series

type
  JIRadar = class external(JExt.chart.series.IPolar)
    style: Variant; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Variant): Variant; overload;
    function getItemForPoint(x: Variant; y: Variant): Variant; overload;
  end;

//Ext.chart.series

type
  JIScatter = class external(JExt.chart.series.ICartesian)
    itemInstancing: Variant; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    function getItemInstancing: Variant;
    procedure provideLegendInfo; overload;
    procedure provideLegendInfo(target: Variant); overload;
    procedure setItemInstancing; overload;
    procedure setItemInstancing(itemInstancing: Variant); overload;
  end;

//Ext.chart.series

type
  JISeries = class external(JExt.IBase, JExt.mixin.IObservable)
    animate: Variant; // nullable
    background: Variant; // nullable
    colors: array of Variant; // nullable
    hidden: Variant; // nullable
    highlightCfg: Variant; // nullable
    highlightItem: Variant; // nullable
    itemInstancing: Variant; // nullable
    &label: Variant; // nullable
    labelField: Variant; // nullable
    labelOverflowPadding: Float; // nullable
    marker: Variant; // nullable
    markerSubStyle: Variant; // nullable
    overlaySurface: Variant; // nullable
    renderer: Variant; // nullable
    showInLegend: Boolean; // nullable
    store: Variant; // nullable
    style: Variant; // nullable
    subStyle: Variant; // nullable
    surface: Variant; // nullable
    title: String; // nullable
    seriesType: String; // nullable
    &type: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getAnimate: Variant;
    function getBackground: Variant;
    function getBubbleEvents: Variant;
    function getColors: array of Variant;
    function getHidden: Variant;
    function getHighlightCfg: Variant;
    function getHighlightItem: Variant;
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Float): Variant; overload;
    function getItemForPoint(x: Float; y: Float): Variant; overload;
    function getItemForPoint(x: Float; y: Float; target: Variant): Variant; overload;
    function getItemInstancing: Variant;
    function getLabel: Variant;
    function getLabelField: Variant;
    function getLabelOverflowPadding: Float;
    function getListeners: Variant;
    function getMarker: Variant;
    function getMarkerSubStyle: Variant;
    function getOverlaySurface: Variant;
    function getRenderer: Variant;
    function getShowInLegend: Boolean;
    procedure getSprites;
    function getStyle: Variant;
    function getSubStyle: Variant;
    function getSurface: Variant;
    function getTitle: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure provideLegendInfo; overload;
    procedure provideLegendInfo(target: array of Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAnimate; overload;
    procedure setAnimate(animate: Variant); overload;
    procedure setBackground; overload;
    procedure setBackground(background: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setColors; overload;
    procedure setColors(colors: array of Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Variant); overload;
    procedure setHiddenByIndex; overload;
    procedure setHiddenByIndex(index: Float); overload;
    procedure setHiddenByIndex(index: Float; value: Boolean); overload;
    procedure setHighlightCfg; overload;
    procedure setHighlightCfg(highlightCfg: Variant); overload;
    procedure setHighlightItem; overload;
    procedure setHighlightItem(highlightItem: Variant); overload;
    procedure setItemInstancing; overload;
    procedure setItemInstancing(itemInstancing: Variant); overload;
    function setLabel: Variant; overload;
    function setLabel(&label: Variant): Variant; overload;
    procedure setLabelField; overload;
    procedure setLabelField(labelField: Variant); overload;
    procedure setLabelOverflowPadding; overload;
    procedure setLabelOverflowPadding(labelOverflowPadding: Float); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMarker; overload;
    procedure setMarker(marker: Variant); overload;
    procedure setMarkerSubStyle; overload;
    procedure setMarkerSubStyle(markerSubStyle: Variant); overload;
    procedure setOverlaySurface; overload;
    procedure setOverlaySurface(overlaySurface: Variant); overload;
    function setRenderer: Variant; overload;
    function setRenderer(renderer: Variant): Variant; overload;
    procedure setShowInLegend; overload;
    procedure setShowInLegend(showInLegend: Boolean); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setSubStyle; overload;
    procedure setSubStyle(subStyle: Variant); overload;
    procedure setSurface; overload;
    procedure setSurface(surface: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIAggregative = class external(JExt.chart.series.sprite.ICartesian)
    dataClose: Variant; // nullable
    dataHigh: Variant; // nullable
    dataLow: Variant; // nullable
    dataOpen: Variant; // nullable
    function getAggregator: Variant;
    procedure renderClipped; overload;
    procedure renderClipped(surface: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant; region: Variant); overload;
    procedure setAggregator; overload;
    procedure setAggregator(aggregator: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIArea = class external(JExt.chart.series.sprite.IStackedCartesian)
    step: Boolean; // nullable
    procedure renderClipped; overload;
    procedure renderClipped(surface: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant; clipRegion: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIBar = class external(JExt.chart.series.sprite.IStackedCartesian)
    inGroupGapWidth: Float; // nullable
    maxBarWidth: Float; // nullable
    minBarWidth: Float; // nullable
    minGapWidth: Float; // nullable
    radius: Float; // nullable
    function getIndexNearPoint: Float; overload;
    function getIndexNearPoint(x: Variant): Float; overload;
    function getIndexNearPoint(x: Variant; y: Variant): Float; overload;
    procedure renderClipped; overload;
    procedure renderClipped(surface: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JICandleStick = class external(JExt.chart.series.sprite.IAggregative)
    barWidth: Float; // nullable
    ohlcType: String; // nullable
    padding: Float; // nullable
  end;

//Ext.chart.series.sprite

type
  JICartesian = class external(JExt.draw.sprite.ISprite, JExt.chart.IMarkerHolder)
    Data: array of Variant; // nullable
    If: Boolean; // nullable
    dataMaxX: Float; // nullable
    dataMaxY: Float; // nullable
    dataMinX: Float; // nullable
    dataMinY: Float; // nullable
    dataX: Variant; // nullable
    dataY: Variant; // nullable
    field: String; // nullable
    labelOverflowPadding: Float; // nullable
    labels: Variant; // nullable
    selectionTolerance: Float; // nullable
    function binarySearch: Variant; overload;
    function binarySearch(key: String): Variant; overload;
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
    function getField: String;
    function getIndexNearPoint: Float; overload;
    function getIndexNearPoint(x: Float): Float; overload;
    function getIndexNearPoint(x: Float; y: Float): Float; overload;
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; region: Variant): Variant; overload;
    procedure renderClipped; overload;
    procedure renderClipped(surface: JExt.draw.ISurface); overload;
    procedure renderClipped(surface: JExt.draw.ISurface; ctx: Variant); overload;
    procedure renderClipped(surface: JExt.draw.ISurface; ctx: Variant; clip: array of Variant); overload;
    procedure renderClipped(surface: JExt.draw.ISurface; ctx: Variant; clip: array of Variant; region: array of Variant); overload;
    procedure setField; overload;
    procedure setField(field: String); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JILine = class external(JExt.chart.series.sprite.IAggregative)
    fillArea: Boolean; // nullable
    preciseStroke: Boolean; // nullable
    smooth: Boolean; // nullable
    step: Boolean; // nullable
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIPie3DPart = class external(JExt.draw.sprite.IPath, JExt.chart.IMarkerHolder)
    baseColor: Variant; // nullable
    baseRotation: Float; // nullable
    centerX: Float; // nullable
    centerY: Float; // nullable
    distortion: Float; // nullable
    endAngle: Float; // nullable
    endRho: Float; // nullable
    margin: Float; // nullable
    part: String; // nullable
    startAngle: Float; // nullable
    startRho: Float; // nullable
    thickness: Float; // nullable
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIPieSlice = class external(JExt.draw.sprite.ISector, JExt.chart.IMarkerHolder)
    doCallout: Boolean; // nullable
    &label: String; // nullable
    labelOverflowPadding: Float; // nullable
    rotateLabels: Boolean; // nullable
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
    function getRendererIndex: Float;
    function render: Variant; overload;
    function render(ctx: Variant): Variant; overload;
    function render(ctx: Variant; surface: Variant): Variant; overload;
    function render(ctx: Variant; surface: Variant; clipRegion: Variant): Variant; overload;
    procedure setRendererIndex; overload;
    procedure setRendererIndex(rendererIndex: Float); overload;
  end;

//Ext.chart.series.sprite

type
  JIPolar = class external(JExt.draw.sprite.ISprite, JExt.chart.IMarkerHolder)
    Data: array of Variant; // nullable
    baseRotation: Float; // nullable
    centerX: Float; // nullable
    centerY: Float; // nullable
    dataMaxX: Float; // nullable
    dataMaxY: Float; // nullable
    dataMinX: Float; // nullable
    dataMinY: Float; // nullable
    dataX: Variant; // nullable
    dataY: Variant; // nullable
    endAngle: Float; // nullable
    endRho: Float; // nullable
    labelOverflowPadding: Float; // nullable
    labels: Variant; // nullable
    startAngle: Float; // nullable
    startRho: Float; // nullable
    procedure bindMarker; overload;
    procedure bindMarker(name: String); overload;
    procedure bindMarker(name: String; marker: JExt.chart.IMarkers); overload;
    function getField: Variant;
    procedure setField; overload;
    procedure setField(field: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIRadar = class external(JExt.chart.series.sprite.IPolar)
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
  end;

//Ext.chart.series.sprite

type
  JIScatter = class external(JExt.chart.series.sprite.ICartesian)
    procedure renderClipped; overload;
    procedure renderClipped(surface: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant); overload;
    procedure renderClipped(surface: Variant; ctx: Variant; clip: Variant; clipRegion: Variant); overload;
  end;

//Ext.chart.series.sprite

type
  JIStackedCartesian = class external(JExt.chart.series.sprite.ICartesian)
    function getIndexNearPoint: Float; overload;
    function getIndexNearPoint(x: Variant): Float; overload;
    function getIndexNearPoint(x: Variant; y: Variant): Float; overload;
  end;

//Ext.chart.series

type
  JIStackedCartesian = class external(JExt.chart.series.ICartesian)
    hidden: array of Variant; // nullable
    stacked: Boolean; // nullable
    function getItemForPoint: Variant; overload;
    function getItemForPoint(x: Variant): Variant; overload;
    function getItemForPoint(x: Variant; y: Variant): Variant; overload;
    procedure getSprites;
    function getStacked: Boolean;
    procedure provideLegendInfo; overload;
    procedure provideLegendInfo(target: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: array of Variant); overload;
    procedure setStacked; overload;
    procedure setStacked(stacked: Boolean); overload;
  end;

//Ext.chart

type
  JISpaceFillingChart = class external(JExt.chart.IAbstractChart)
    procedure redraw;
  end;

//Ext

type
  JIClass = class external
    alias: array of String; // nullable
    alternateClassName: Variant; // nullable
    config: Variant; // nullable
    extend: String; // nullable
    inheritableStatics: Variant; // nullable
    mixins: Variant; // nullable
    platformConfig: Variant; // nullable
    singleton: Boolean; // nullable
    statics: Variant; // nullable
    &uses: array of String; // nullable
  end;

//Ext

type
  JClassManager = class external 'ClassManager'
    function addNameAliasMappings: JExt.IClassManager; overload;
    function addNameAliasMappings(aliases: Variant): JExt.IClassManager; overload;
    function addNameAlternateMappings: JExt.IClassManager; overload;
    function addNameAlternateMappings(alternates: Variant): JExt.IClassManager; overload;
    function get: JExt.IClass; overload;
    function get(name: String): JExt.IClass; overload;
    function getAliasesByName: array of Variant; overload;
    function getAliasesByName(name: String): array of Variant; overload;
    function getByAlias: JExt.IClass; overload;
    function getByAlias(alias: String): JExt.IClass; overload;
    function getClass: JExt.IClass; overload;
    function getClass(&object: Variant): JExt.IClass; overload;
    function getName: String; overload;
    function getName(&object: Variant): String; overload;
    function getNameByAlias: String; overload;
    function getNameByAlias(alias: String): String; overload;
    function getNameByAlternate: String; overload;
    function getNameByAlternate(alternate: String): String; overload;
    function getNamesByExpression: array of Variant; overload;
    function getNamesByExpression(expression: String): array of Variant; overload;
    function instantiate: Variant; overload;
    function instantiate(name: String): Variant; overload;
    function instantiate(name: String; args: Variant): Variant; overload;
    function instantiateByAlias(alias: String; args: array of Variant): Variant;
    function isCreated: Boolean; overload;
    function isCreated(className: String): Boolean; overload;
    function set: JExt.IClassManager; overload;
    function set(name: String): JExt.IClassManager; overload;
    function set(name: String; value: Variant): JExt.IClassManager; overload;
    function setAlias: JExt.IClassManager; overload;
    function setAlias(cls: Variant): JExt.IClassManager; overload;
    function setAlias(cls: Variant; alias: String): JExt.IClassManager; overload;
    procedure setNamespace; overload;
    procedure setNamespace(name: String); overload;
    procedure setNamespace(name: String; value: Variant); overload;
  end;

  JIClassManager = class external
  end;

//Ext

type
  JIComponent = class external(JExt.IAbstractComponent, JExt.mixin.ITraversable)
    baseCls: String; // nullable
    border: Variant; // nullable
    bottom: Variant; // nullable
    centered: Boolean; // nullable
    cls: Variant; // nullable
    componentCls: String; // nullable
    contentEl: Variant; // nullable
    data: Variant; // nullable
    disabled: Boolean; // nullable
    disabledCls: String; // nullable
    dock: String; // nullable
    docked: String; // nullable
    enterAnimation: Variant; // nullable
    exitAnimation: Variant; // nullable
    flex: Float; // nullable
    floating: Boolean; // nullable
    floatingCls: String; // nullable
    fullscreen: Boolean; // nullable
    height: Variant; // nullable
    hidden: Boolean; // nullable
    hiddenCls: String; // nullable
    hideAnimation: Variant; // nullable
    hideOnMaskTap: Boolean; // nullable
    html: Variant; // nullable
    id: String; // nullable
    itemId: String; // nullable
    layoutOnOrientationChange: Boolean; // nullable
    left: Variant; // nullable
    margin: Variant; // nullable
    maxHeight: Variant; // nullable
    maxWidth: Variant; // nullable
    minHeight: Variant; // nullable
    minWidth: Variant; // nullable
    modal: Boolean; // nullable
    monitorOrientation: Boolean; // nullable
    padding: Variant; // nullable
    plugins: Variant; // nullable
    record: JExt.data.IModel; // nullable
    renderTo: JExt.IElement; // nullable
    right: Variant; // nullable
    scroll: Variant; // nullable
    showAnimation: Variant; // nullable
    stopMaskTapEvent: Boolean; // nullable
    style: Variant; // nullable
    styleHtmlCls: String; // nullable
    styleHtmlContent: Boolean; // nullable
    top: Variant; // nullable
    tpl: Variant; // nullable
    tplWriteMode: String; // nullable
    ui: String; // nullable
    width: Variant; // nullable
    xtype: String; // nullable
    zIndex: Float; // nullable
    procedure addCls; overload;
    procedure addCls(cls: String); overload;
    procedure addCls(cls: String; prefix: String); overload;
    procedure addCls(cls: String; prefix: String; suffix: String); overload;
    procedure destroy;
    procedure disable;
    procedure enable;
    procedure getAlignmentInfo; overload;
    procedure getAlignmentInfo(component: Variant); overload;
    procedure getAlignmentInfo(component: Variant; alignment: Variant); overload;
    function getBaseCls: String;
    function getBorder: Variant;
    function getBottom: Variant;
    function getCentered: Boolean;
    function getCls: Variant;
    function getContentEl: Variant;
    function getData: Variant;
    function getDisabled: Boolean;
    function getDisabledCls: String;
    function getDocked: String;
    function getEl: JExt.dom.IElement;
    function getEnterAnimation: Variant;
    function getExitAnimation: Variant;
    function getFlex: Float;
    function getFloatingCls: String;
    function getHeight: Variant;
    function getHidden: Boolean;
    function getHiddenCls: String;
    function getHideAnimation: Variant;
    function getHtml: Variant;
    function getItemId: String;
    function getLeft: Variant;
    function getMargin: Variant;
    function getMaxHeight: Variant;
    function getMaxWidth: Variant;
    function getMinHeight: Variant;
    function getMinWidth: Variant;
    function getPadding: Variant;
    function getParent: JExt.IComponent;
    function getPlugins: Variant;
    function getRecord: JExt.data.IModel;
    function getRenderTo: JExt.IElement;
    function getRight: Variant;
    function getShowAnimation: Variant;
    function getSize: Variant;
    function getStyle: Variant;
    function getStyleHtmlCls: String;
    function getStyleHtmlContent: Boolean;
    function getTop: Variant;
    function getTpl: Variant;
    function getTplWriteMode: String;
    function getUi: String;
    function getWidth: Variant;
    function getXTypes: String;
    function getZIndex: Float;
    function hasParent: Boolean;
    function hide: JExt.IComponent; overload;
    function hide(animation: Variant): JExt.IComponent; overload;
    procedure initialize;
    function isDisabled: Boolean;
    function isHidden: Boolean;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    procedure removeCls; overload;
    procedure removeCls(cls: String); overload;
    procedure removeCls(cls: String; prefix: String); overload;
    procedure removeCls(cls: String; prefix: String; suffix: String); overload;
    procedure replaceCls; overload;
    procedure replaceCls(oldCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String; suffix: String); overload;
    procedure resetFloating;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Variant); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: Variant); overload;
    procedure setContentEl; overload;
    procedure setContentEl(contentEl: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setDisabledCls; overload;
    procedure setDisabledCls(disabledCls: String); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setDraggable; overload;
    procedure setDraggable(draggable: Variant); overload;
    procedure setEnterAnimation; overload;
    procedure setEnterAnimation(enterAnimation: Variant); overload;
    procedure setExitAnimation; overload;
    procedure setExitAnimation(exitAnimation: Variant); overload;
    procedure setFlex; overload;
    procedure setFlex(flex: Float); overload;
    procedure setFloating; overload;
    procedure setFloating(floating: Boolean); overload;
    procedure setFloatingCls; overload;
    procedure setFloatingCls(floatingCls: String); overload;
    procedure setHeight; overload;
    procedure setHeight(height: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setHiddenCls; overload;
    procedure setHiddenCls(hiddenCls: String); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setHtml; overload;
    procedure setHtml(html: Variant); overload;
    procedure setItemId; overload;
    procedure setItemId(itemId: String); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Variant); overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    procedure setMaxHeight; overload;
    procedure setMaxHeight(maxHeight: Variant); overload;
    procedure setMaxWidth; overload;
    procedure setMaxWidth(maxWidth: Variant); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: Variant); overload;
    procedure setMinWidth; overload;
    procedure setMinWidth(minWidth: Variant); overload;
    procedure setPadding; overload;
    procedure setPadding(padding: Variant); overload;
    procedure setPlugins; overload;
    procedure setPlugins(plugins: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRenderTo; overload;
    procedure setRenderTo(renderTo: JExt.IElement); overload;
    procedure setRight; overload;
    procedure setRight(right: Variant); overload;
    procedure setScrollable;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Float); overload;
    procedure setSize(width: Float; height: Float); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setStyleHtmlCls; overload;
    procedure setStyleHtmlCls(styleHtmlCls: String); overload;
    procedure setStyleHtmlContent; overload;
    procedure setStyleHtmlContent(styleHtmlContent: Boolean); overload;
    procedure setTop; overload;
    procedure setTop(top: Variant); overload;
    procedure setTpl; overload;
    procedure setTpl(tpl: Variant); overload;
    procedure setTplWriteMode; overload;
    procedure setTplWriteMode(tplWriteMode: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setWidth; overload;
    procedure setWidth(width: Variant); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zIndex: Float); overload;
    function show: JExt.IComponent; overload;
    function show(animation: Variant): JExt.IComponent; overload;
    procedure showBy; overload;
    procedure showBy(component: JExt.IComponent); overload;
    procedure showBy(component: JExt.IComponent; alignment: String); overload;
    function up: JExt.IContainer; overload;
    function up(selector: String): JExt.IContainer; overload;
    procedure update;
    procedure updateStyleHtmlCls; overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant); overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant; oldHtmlCls: Variant); overload;
  end;

//Ext.lib

type
  JIComponent = class external(JExt.IAbstractComponent, JExt.mixin.ITraversable)
    baseCls: String; // nullable
    border: Variant; // nullable
    bottom: Variant; // nullable
    centered: Boolean; // nullable
    cls: Variant; // nullable
    componentCls: String; // nullable
    contentEl: Variant; // nullable
    data: Variant; // nullable
    disabled: Boolean; // nullable
    disabledCls: String; // nullable
    dock: String; // nullable
    docked: String; // nullable
    enterAnimation: Variant; // nullable
    exitAnimation: Variant; // nullable
    flex: Float; // nullable
    floating: Boolean; // nullable
    floatingCls: String; // nullable
    fullscreen: Boolean; // nullable
    height: Variant; // nullable
    hidden: Boolean; // nullable
    hiddenCls: String; // nullable
    hideAnimation: Variant; // nullable
    hideOnMaskTap: Boolean; // nullable
    html: Variant; // nullable
    id: String; // nullable
    itemId: String; // nullable
    layoutOnOrientationChange: Boolean; // nullable
    left: Variant; // nullable
    margin: Variant; // nullable
    maxHeight: Variant; // nullable
    maxWidth: Variant; // nullable
    minHeight: Variant; // nullable
    minWidth: Variant; // nullable
    modal: Boolean; // nullable
    monitorOrientation: Boolean; // nullable
    padding: Variant; // nullable
    plugins: Variant; // nullable
    record: JExt.data.IModel; // nullable
    renderTo: JExt.IElement; // nullable
    right: Variant; // nullable
    scroll: Variant; // nullable
    showAnimation: Variant; // nullable
    stopMaskTapEvent: Boolean; // nullable
    style: Variant; // nullable
    styleHtmlCls: String; // nullable
    styleHtmlContent: Boolean; // nullable
    top: Variant; // nullable
    tpl: Variant; // nullable
    tplWriteMode: String; // nullable
    ui: String; // nullable
    width: Variant; // nullable
    xtype: String; // nullable
    zIndex: Float; // nullable
    procedure addCls; overload;
    procedure addCls(cls: String); overload;
    procedure addCls(cls: String; prefix: String); overload;
    procedure addCls(cls: String; prefix: String; suffix: String); overload;
    procedure destroy;
    procedure disable;
    procedure enable;
    procedure getAlignmentInfo; overload;
    procedure getAlignmentInfo(component: Variant); overload;
    procedure getAlignmentInfo(component: Variant; alignment: Variant); overload;
    function getBaseCls: String;
    function getBorder: Variant;
    function getBottom: Variant;
    function getCentered: Boolean;
    function getCls: Variant;
    function getContentEl: Variant;
    function getData: Variant;
    function getDisabled: Boolean;
    function getDisabledCls: String;
    function getDocked: String;
    function getEl: JExt.dom.IElement;
    function getEnterAnimation: Variant;
    function getExitAnimation: Variant;
    function getFlex: Float;
    function getFloatingCls: String;
    function getHeight: Variant;
    function getHidden: Boolean;
    function getHiddenCls: String;
    function getHideAnimation: Variant;
    function getHtml: Variant;
    function getItemId: String;
    function getLeft: Variant;
    function getMargin: Variant;
    function getMaxHeight: Variant;
    function getMaxWidth: Variant;
    function getMinHeight: Variant;
    function getMinWidth: Variant;
    function getPadding: Variant;
    function getParent: JExt.IComponent;
    function getPlugins: Variant;
    function getRecord: JExt.data.IModel;
    function getRenderTo: JExt.IElement;
    function getRight: Variant;
    function getShowAnimation: Variant;
    function getSize: Variant;
    function getStyle: Variant;
    function getStyleHtmlCls: String;
    function getStyleHtmlContent: Boolean;
    function getTop: Variant;
    function getTpl: Variant;
    function getTplWriteMode: String;
    function getUi: String;
    function getWidth: Variant;
    function getXTypes: String;
    function getZIndex: Float;
    function hasParent: Boolean;
    function hide: JExt.IComponent; overload;
    function hide(animation: Variant): JExt.IComponent; overload;
    procedure initialize;
    function isDisabled: Boolean;
    function isHidden: Boolean;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    procedure removeCls; overload;
    procedure removeCls(cls: String); overload;
    procedure removeCls(cls: String; prefix: String); overload;
    procedure removeCls(cls: String; prefix: String; suffix: String); overload;
    procedure replaceCls; overload;
    procedure replaceCls(oldCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String; suffix: String); overload;
    procedure resetFloating;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Variant); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: Variant); overload;
    procedure setContentEl; overload;
    procedure setContentEl(contentEl: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setDisabledCls; overload;
    procedure setDisabledCls(disabledCls: String); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setDraggable; overload;
    procedure setDraggable(draggable: Variant); overload;
    procedure setEnterAnimation; overload;
    procedure setEnterAnimation(enterAnimation: Variant); overload;
    procedure setExitAnimation; overload;
    procedure setExitAnimation(exitAnimation: Variant); overload;
    procedure setFlex; overload;
    procedure setFlex(flex: Float); overload;
    procedure setFloating; overload;
    procedure setFloating(floating: Boolean); overload;
    procedure setFloatingCls; overload;
    procedure setFloatingCls(floatingCls: String); overload;
    procedure setHeight; overload;
    procedure setHeight(height: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setHiddenCls; overload;
    procedure setHiddenCls(hiddenCls: String); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setHtml; overload;
    procedure setHtml(html: Variant); overload;
    procedure setItemId; overload;
    procedure setItemId(itemId: String); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Variant); overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    procedure setMaxHeight; overload;
    procedure setMaxHeight(maxHeight: Variant); overload;
    procedure setMaxWidth; overload;
    procedure setMaxWidth(maxWidth: Variant); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: Variant); overload;
    procedure setMinWidth; overload;
    procedure setMinWidth(minWidth: Variant); overload;
    procedure setPadding; overload;
    procedure setPadding(padding: Variant); overload;
    procedure setPlugins; overload;
    procedure setPlugins(plugins: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRenderTo; overload;
    procedure setRenderTo(renderTo: JExt.IElement); overload;
    procedure setRight; overload;
    procedure setRight(right: Variant); overload;
    procedure setScrollable;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Float); overload;
    procedure setSize(width: Float; height: Float); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setStyleHtmlCls; overload;
    procedure setStyleHtmlCls(styleHtmlCls: String); overload;
    procedure setStyleHtmlContent; overload;
    procedure setStyleHtmlContent(styleHtmlContent: Boolean); overload;
    procedure setTop; overload;
    procedure setTop(top: Variant); overload;
    procedure setTpl; overload;
    procedure setTpl(tpl: Variant); overload;
    procedure setTplWriteMode; overload;
    procedure setTplWriteMode(tplWriteMode: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setWidth; overload;
    procedure setWidth(width: Variant); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zIndex: Float); overload;
    function show: JExt.IComponent; overload;
    function show(animation: Variant): JExt.IComponent; overload;
    procedure showBy; overload;
    procedure showBy(component: JExt.IComponent); overload;
    procedure showBy(component: JExt.IComponent; alignment: String); overload;
    function up: JExt.IContainer; overload;
    function up(selector: String): JExt.IContainer; overload;
    procedure update;
    procedure updateStyleHtmlCls; overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant); overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant; oldHtmlCls: Variant); overload;
  end;

//Ext

type
  JComponentManager = class external 'ComponentManager'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(component: Variant): JExt.IComponent; overload;
    function create(component: Variant; defaultType: Variant): JExt.IComponent; overload;
    procedure destroy;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(component: String): Boolean; overload;
    procedure register; overload;
    procedure register(component: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(component: Variant); overload;
  end;

  JIComponentManager = class external(JExt.IBase)
  end;

//Ext

type
  JComponentMgr = class external 'ComponentMgr'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: JExt.IComponent; overload;
    function create(component: Variant): JExt.IComponent; overload;
    function create(component: Variant; defaultType: Variant): JExt.IComponent; overload;
    procedure destroy;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(component: String): Boolean; overload;
    procedure register; overload;
    procedure register(component: Variant); overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(component: Variant); overload;
  end;

  JIComponentMgr = class external(JExt.IBase)
  end;

//Ext

type
  JComponentQuery = class external 'ComponentQuery'
    function is: Boolean; overload;
    function is(component: JExt.IComponent): Boolean; overload;
    function is(component: JExt.IComponent; selector: String): Boolean; overload;
    function query: array of JExt.IComponent; overload;
    function query(selector: String): array of JExt.IComponent; overload;
    function query(selector: String; root: JExt.IContainer): array of JExt.IComponent; overload;
  end;

  JIComponentQuery = class external
  end;

//Ext

type
  JIContainer = class external(JExt.IComponent)
    activeItem: Variant; // nullable
    autoDestroy: Boolean; // nullable
    cardSwitchAnimation: Variant; // nullable
    control: Variant; // nullable
    defaultType: String; // nullable
    defaults: Variant; // nullable
    hideOnMaskTap: Boolean; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    masked: Variant; // nullable
    modal: Boolean; // nullable
    scroll: Variant; // nullable
    scrollable: Variant; // nullable
    function add: JExt.IComponent; overload;
    function add(newItems: Variant): JExt.IComponent; overload;
    function addAll: array of Variant; overload;
    function addAll(items: array of Variant): array of Variant; overload;
    procedure animateActiveItem; overload;
    procedure animateActiveItem(activeItem: Variant); overload;
    procedure animateActiveItem(activeItem: Variant; animation: Variant); overload;
    function applyMasked: Variant; overload;
    function applyMasked(masked: Variant): Variant; overload;
    function child: JExt.IComponent; overload;
    function child(selector: String): JExt.IComponent; overload;
    procedure destroy;
    function down: JExt.IComponent; overload;
    function down(selector: String): JExt.IComponent; overload;
    function getActiveItem: Variant;
    function getAt: JExt.IComponent; overload;
    function getAt(index: Float): JExt.IComponent; overload;
    function getAutoDestroy: Boolean;
    function getComponent: JExt.IComponent; overload;
    function getComponent(component: Variant): JExt.IComponent; overload;
    function getControl: Variant;
    function getDefaultType: String;
    function getDefaults: Variant;
    function getDockedComponent: Variant; overload;
    function getDockedComponent(component: Variant): Variant; overload;
    function getDockedItems: array of Variant;
    function getHideOnMaskTap: Boolean;
    function getInnerItems: array of Variant;
    function getItems: Variant;
    function getMasked: Variant;
    function getModal: Boolean;
    function getScrollable: JExt.scroll.IView;
    function hide: JExt.IComponent;
    procedure insert; overload;
    procedure insert(index: Float); overload;
    procedure insert(index: Float; item: Variant); overload;
    procedure mask; overload;
    procedure mask(mask: Variant); overload;
    function query: array of Variant; overload;
    function query(selector: String): array of Variant; overload;
    function remove: JExt.IComponent; overload;
    function remove(item: Variant): JExt.IComponent; overload;
    function remove(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeAll: JExt.IComponent; overload;
    function removeAll(destroy: Boolean): JExt.IComponent; overload;
    function removeAll(destroy: Boolean; everything: Boolean): JExt.IComponent; overload;
    function removeAt: JExt.IContainer; overload;
    function removeAt(index: Float): JExt.IContainer; overload;
    function removeDocked: JExt.IComponent; overload;
    function removeDocked(item: Variant): JExt.IComponent; overload;
    function removeDocked(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeInnerAt: JExt.IContainer; overload;
    function removeInnerAt(index: Float): JExt.IContainer; overload;
    procedure setActiveItem; overload;
    procedure setActiveItem(activeItem: Variant); overload;
    procedure setAutoDestroy; overload;
    procedure setAutoDestroy(autoDestroy: Boolean); overload;
    procedure setControl; overload;
    procedure setControl(control: Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setHideOnMaskTap; overload;
    procedure setHideOnMaskTap(hideOnMaskTap: Boolean); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setMasked; overload;
    procedure setMasked(masked: Variant); overload;
    procedure setModal; overload;
    procedure setModal(modal: Boolean); overload;
    function setScrollable: JExt.scroll.IView; overload;
    function setScrollable(scrollable: Variant): JExt.scroll.IView; overload;
    function show: JExt.IComponent;
    procedure unmask;
  end;

//Ext.lib

type
  JIContainer = class external(JExt.IComponent)
    activeItem: Variant; // nullable
    autoDestroy: Boolean; // nullable
    cardSwitchAnimation: Variant; // nullable
    control: Variant; // nullable
    defaultType: String; // nullable
    defaults: Variant; // nullable
    hideOnMaskTap: Boolean; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    masked: Variant; // nullable
    modal: Boolean; // nullable
    scroll: Variant; // nullable
    scrollable: Variant; // nullable
    function add: JExt.IComponent; overload;
    function add(newItems: Variant): JExt.IComponent; overload;
    function addAll: array of Variant; overload;
    function addAll(items: array of Variant): array of Variant; overload;
    procedure animateActiveItem; overload;
    procedure animateActiveItem(activeItem: Variant); overload;
    procedure animateActiveItem(activeItem: Variant; animation: Variant); overload;
    function applyMasked: Variant; overload;
    function applyMasked(masked: Variant): Variant; overload;
    function child: JExt.IComponent; overload;
    function child(selector: String): JExt.IComponent; overload;
    procedure destroy;
    function down: JExt.IComponent; overload;
    function down(selector: String): JExt.IComponent; overload;
    function getActiveItem: Variant;
    function getAt: JExt.IComponent; overload;
    function getAt(index: Float): JExt.IComponent; overload;
    function getAutoDestroy: Boolean;
    function getComponent: JExt.IComponent; overload;
    function getComponent(component: Variant): JExt.IComponent; overload;
    function getControl: Variant;
    function getDefaultType: String;
    function getDefaults: Variant;
    function getDockedComponent: Variant; overload;
    function getDockedComponent(component: Variant): Variant; overload;
    function getDockedItems: array of Variant;
    function getHideOnMaskTap: Boolean;
    function getInnerItems: array of Variant;
    function getItems: Variant;
    function getMasked: Variant;
    function getModal: Boolean;
    function getScrollable: JExt.scroll.IView;
    function hide: JExt.IComponent;
    procedure insert; overload;
    procedure insert(index: Float); overload;
    procedure insert(index: Float; item: Variant); overload;
    procedure mask; overload;
    procedure mask(mask: Variant); overload;
    function query: array of Variant; overload;
    function query(selector: String): array of Variant; overload;
    function remove: JExt.IComponent; overload;
    function remove(item: Variant): JExt.IComponent; overload;
    function remove(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeAll: JExt.IComponent; overload;
    function removeAll(destroy: Boolean): JExt.IComponent; overload;
    function removeAll(destroy: Boolean; everything: Boolean): JExt.IComponent; overload;
    function removeAt: JExt.IContainer; overload;
    function removeAt(index: Float): JExt.IContainer; overload;
    function removeDocked: JExt.IComponent; overload;
    function removeDocked(item: Variant): JExt.IComponent; overload;
    function removeDocked(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeInnerAt: JExt.IContainer; overload;
    function removeInnerAt(index: Float): JExt.IContainer; overload;
    procedure setActiveItem; overload;
    procedure setActiveItem(activeItem: Variant); overload;
    procedure setAutoDestroy; overload;
    procedure setAutoDestroy(autoDestroy: Boolean); overload;
    procedure setControl; overload;
    procedure setControl(control: Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setHideOnMaskTap; overload;
    procedure setHideOnMaskTap(hideOnMaskTap: Boolean); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setMasked; overload;
    procedure setMasked(masked: Variant); overload;
    procedure setModal; overload;
    procedure setModal(modal: Boolean); overload;
    function setScrollable: JExt.scroll.IView; overload;
    function setScrollable(scrollable: Variant): JExt.scroll.IView; overload;
    function show: JExt.IComponent;
    procedure unmask;
  end;

//Ext.data

type
  JIArrayStore = class external(JExt.data.IStore)
    proxy: Variant; // nullable
    function getProxy: Variant;
    procedure loadData; overload;
    procedure loadData(data: Variant); overload;
    procedure loadData(data: Variant; append: Variant); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
  end;

//Ext.data.association

type
  JIAssociation = class external(JExt.IBase)
    associatedModel: String; // nullable
    associatedName: String; // nullable
    associationKey: String; // nullable
    ownerModel: Variant; // nullable
    primaryKey: String; // nullable
    reader: JExt.data.reader.IReader; // nullable
    &type: String; // nullable
    function getAssociatedModel: String;
    function getAssociatedName: String;
    function getAssociationKey: String;
    function getName: Variant;
    function getOwnerModel: Variant;
    function getOwnerName: String;
    function getPrimaryKey: String;
    function getReader: JExt.data.reader.IReader;
    function getType: String;
    procedure setAssociatedModel; overload;
    procedure setAssociatedModel(associatedModel: String); overload;
    procedure setAssociatedName; overload;
    procedure setAssociatedName(associatedName: String); overload;
    procedure setAssociationKey; overload;
    procedure setAssociationKey(associationKey: String); overload;
    procedure setName; overload;
    procedure setName(name: Variant); overload;
    procedure setOwnerModel; overload;
    procedure setOwnerModel(ownerModel: Variant); overload;
    procedure setOwnerName; overload;
    procedure setOwnerName(ownerName: String); overload;
    procedure setPrimaryKey; overload;
    procedure setPrimaryKey(primaryKey: String); overload;
    procedure setReader; overload;
    procedure setReader(reader: JExt.data.reader.IReader); overload;
    procedure setType; overload;
    procedure setType(&type: String); overload;
  end;

//Ext.data

type
  JIAssociation = class external(JExt.IBase)
    associatedModel: String; // nullable
    associatedName: String; // nullable
    associationKey: String; // nullable
    ownerModel: Variant; // nullable
    primaryKey: String; // nullable
    reader: JExt.data.reader.IReader; // nullable
    &type: String; // nullable
    function getAssociatedModel: String;
    function getAssociatedName: String;
    function getAssociationKey: String;
    function getName: Variant;
    function getOwnerModel: Variant;
    function getOwnerName: String;
    function getPrimaryKey: String;
    function getReader: JExt.data.reader.IReader;
    function getType: String;
    procedure setAssociatedModel; overload;
    procedure setAssociatedModel(associatedModel: String); overload;
    procedure setAssociatedName; overload;
    procedure setAssociatedName(associatedName: String); overload;
    procedure setAssociationKey; overload;
    procedure setAssociationKey(associationKey: String); overload;
    procedure setName; overload;
    procedure setName(name: Variant); overload;
    procedure setOwnerModel; overload;
    procedure setOwnerModel(ownerModel: Variant); overload;
    procedure setOwnerName; overload;
    procedure setOwnerName(ownerName: String); overload;
    procedure setPrimaryKey; overload;
    procedure setPrimaryKey(primaryKey: String); overload;
    procedure setReader; overload;
    procedure setReader(reader: JExt.data.reader.IReader); overload;
    procedure setType; overload;
    procedure setType(&type: String); overload;
  end;

//Ext.data.association

type
  JIBelongsTo = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    function getForeignKey: String;
    function getGetterName: String;
    function getInstanceName: Variant;
    function getSetterName: String;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setGetterName; overload;
    procedure setGetterName(getterName: String); overload;
    procedure setInstanceName; overload;
    procedure setInstanceName(instanceName: Variant); overload;
    procedure setSetterName; overload;
    procedure setSetterName(setterName: String); overload;
  end;

//Ext.data

type
  JIBelongsToAssociation = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    function getForeignKey: String;
    function getGetterName: String;
    function getInstanceName: Variant;
    function getSetterName: String;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setGetterName; overload;
    procedure setGetterName(getterName: String); overload;
    procedure setInstanceName; overload;
    procedure setInstanceName(instanceName: Variant); overload;
    procedure setSetterName; overload;
    procedure setSetterName(setterName: String); overload;
  end;

//Ext.data.association

type
  JIHasMany = class external(JExt.data.association.IAssociation)
    autoLoad: Boolean; // nullable
    autoSync: Boolean; // nullable
    filterProperty: String; // nullable
    foreignKey: String; // nullable
    name: String; // nullable
    store: Variant; // nullable
    storeConfig: Variant; // nullable
    storeName: String; // nullable
    function getAutoLoad: Boolean;
    function getAutoSync: Boolean;
    function getFilterProperty: String;
    function getForeignKey: String;
    function getStore: Variant;
    function getStoreName: String;
    procedure setAutoLoad; overload;
    procedure setAutoLoad(autoLoad: Boolean); overload;
    procedure setAutoSync; overload;
    procedure setAutoSync(autoSync: Boolean); overload;
    procedure setFilterProperty; overload;
    procedure setFilterProperty(filterProperty: String); overload;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setStoreName; overload;
    procedure setStoreName(storeName: String); overload;
  end;

//Ext.data

type
  JIHasManyAssociation = class external(JExt.data.association.IAssociation)
    autoLoad: Boolean; // nullable
    autoSync: Boolean; // nullable
    filterProperty: String; // nullable
    foreignKey: String; // nullable
    name: String; // nullable
    store: Variant; // nullable
    storeConfig: Variant; // nullable
    storeName: String; // nullable
    function getAutoLoad: Boolean;
    function getAutoSync: Boolean;
    function getFilterProperty: String;
    function getForeignKey: String;
    function getStore: Variant;
    function getStoreName: String;
    procedure setAutoLoad; overload;
    procedure setAutoLoad(autoLoad: Boolean); overload;
    procedure setAutoSync; overload;
    procedure setAutoSync(autoSync: Boolean); overload;
    procedure setFilterProperty; overload;
    procedure setFilterProperty(filterProperty: String); overload;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setStoreName; overload;
    procedure setStoreName(storeName: String); overload;
  end;

//Ext.data.association

type
  JIHasOne = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    function getForeignKey: String;
    function getGetterName: String;
    function getInstanceName: Variant;
    function getSetterName: String;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setGetterName; overload;
    procedure setGetterName(getterName: String); overload;
    procedure setInstanceName; overload;
    procedure setInstanceName(instanceName: Variant); overload;
    procedure setSetterName; overload;
    procedure setSetterName(setterName: String); overload;
  end;

//Ext.data

type
  JIHasOneAssociation = class external(JExt.data.association.IAssociation)
    foreignKey: String; // nullable
    getterName: String; // nullable
    setterName: String; // nullable
    function getForeignKey: String;
    function getGetterName: String;
    function getInstanceName: Variant;
    function getSetterName: String;
    procedure setForeignKey; overload;
    procedure setForeignKey(foreignKey: String); overload;
    procedure setGetterName; overload;
    procedure setGetterName(getterName: String); overload;
    procedure setInstanceName; overload;
    procedure setInstanceName(instanceName: Variant); overload;
    procedure setSetterName; overload;
    procedure setSetterName(setterName: String); overload;
  end;

//Ext.data

type
  JIBatch = class external(JExt.IBase, JExt.mixin.IObservable)
    autoStart: Boolean; // nullable
    pauseOnException: Boolean; // nullable
    proxy: JExt.data.IProxy; // nullable
    current: Float; // nullable
    hasException: Boolean; // nullable
    isComplete: Boolean; // nullable
    isRunning: Boolean; // nullable
    operations: array of JExt.data.IOperation; // nullable
    total: Float; // nullable
    procedure add; overload;
    procedure add(operation: Variant); overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getAutoStart: Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getPauseOnException: Boolean;
    function getProxy: JExt.data.IProxy;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure pause;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure runOperation; overload;
    procedure runOperation(index: Float); overload;
    procedure setAutoStart; overload;
    procedure setAutoStart(autoStart: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setPauseOnException; overload;
    procedure setPauseOnException(pauseOnException: Boolean); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: JExt.data.IProxy); overload;
    procedure start;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.data

type
  JIConnection = class external(JExt.IBase, JExt.mixin.IObservable)
    defaultHeaders: Variant; // nullable
    defaultXhrHeader: String; // nullable
    disableCaching: Boolean; // nullable
    disableCachingParam: String; // nullable
    extraParams: Variant; // nullable
    method: String; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    useDefaultXhrHeader: Boolean; // nullable
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    procedure abortAll;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getAsync: Boolean;
    function getAutoAbort: Boolean;
    function getBubbleEvents: Variant;
    function getDefaultHeaders: Variant;
    function getDefaultPostHeader: String;
    function getDefaultXhrHeader: String;
    function getDisableCaching: Boolean;
    function getDisableCachingParam: String;
    function getExtraParams: Variant;
    function getListeners: Variant;
    function getMethod: String;
    function getPassword: String;
    function getTimeout: Float;
    function getUrl: String;
    function getUseDefaultHeader: Boolean;
    function getUseDefaultXhrHeader: Boolean;
    function getUsername: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isLoading: Boolean; overload;
    function isLoading(request: Variant): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parseStatus: Variant; overload;
    function parseStatus(status: Float): Variant; overload;
    function parseStatus(status: Float; xhr: JXMLHttpRequest): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAsync; overload;
    procedure setAsync(async: Boolean); overload;
    procedure setAutoAbort; overload;
    procedure setAutoAbort(autoAbort: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setDefaultHeaders; overload;
    procedure setDefaultHeaders(defaultHeaders: Variant); overload;
    procedure setDefaultPostHeader; overload;
    procedure setDefaultPostHeader(defaultPostHeader: String); overload;
    procedure setDefaultXhrHeader; overload;
    procedure setDefaultXhrHeader(defaultXhrHeader: String); overload;
    procedure setDisableCaching; overload;
    procedure setDisableCaching(disableCaching: Boolean); overload;
    procedure setDisableCachingParam; overload;
    procedure setDisableCachingParam(disableCachingParam: String); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: String); overload;
    function setOptions: Variant; overload;
    function setOptions(options: Variant): Variant; overload;
    function setOptions(options: Variant; scope: Variant): Variant; overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure setUseDefaultHeader; overload;
    procedure setUseDefaultHeader(useDefaultHeader: Boolean); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Boolean); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure upload; overload;
    procedure upload(form: Variant); overload;
    procedure upload(form: Variant; url: String); overload;
    procedure upload(form: Variant; url: String; params: String); overload;
    procedure upload(form: Variant; url: String; params: String; options: Variant); overload;
  end;

//Ext.data

type
  JIDirectStore = class external(JExt.data.IStore)
    proxy: Variant; // nullable
    function getProxy: Variant;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
  end;

//Ext.data

type
  JIError = class external(JExt.IBase)
    field: String; // nullable
    message: String; // nullable
    function getField: String;
    function getMessage: String;
    procedure setField; overload;
    procedure setField(field: String); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
  end;

//Ext.data

type
  JIErrors = class external(JExt.util.ICollection)
    function add: Variant;
    function getByField: array of Variant; overload;
    function getByField(fieldName: String): array of Variant; overload;
    function isValid: Boolean;
  end;

//Ext.data

type
  JIField = class external(JExt.IBase)
    allowNull: Boolean; // nullable
    convert: Variant; // nullable
    dateFormat: String; // nullable
    defaultValue: Variant; // nullable
    mapping: Variant; // nullable
    name: String; // nullable
    persist: Boolean; // nullable
    sortDir: String; // nullable
    sortType: Variant; // nullable
    &type: Variant; // nullable
    useNull: Boolean; // nullable
    function getAllowNull: Boolean;
    function getBubbleEvents: String;
    function getConvert: Variant;
    function getDateFormat: String;
    function getDecode: Variant;
    function getDefaultValue: Variant;
    function getEncode: Variant;
    function getMapping: Variant;
    function getName: String;
    function getPersist: Boolean;
    function getSortDir: String;
    function getSortType: Variant;
    function getType: Variant;
    procedure setAllowNull; overload;
    procedure setAllowNull(allowNull: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: String); overload;
    procedure setConvert; overload;
    procedure setConvert(convert: Variant); overload;
    procedure setDateFormat; overload;
    procedure setDateFormat(dateFormat: String); overload;
    procedure setDecode; overload;
    procedure setDecode(decode: Variant); overload;
    procedure setDefaultValue; overload;
    procedure setDefaultValue(defaultValue: Variant); overload;
    procedure setEncode; overload;
    procedure setEncode(encode: Variant); overload;
    procedure setMapping; overload;
    procedure setMapping(mapping: Variant); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setPersist; overload;
    procedure setPersist(persist: Boolean); overload;
    procedure setSortDir; overload;
    procedure setSortDir(sortDir: String); overload;
    procedure setSortType; overload;
    procedure setSortType(sortType: Variant); overload;
    procedure setType; overload;
    procedure setType(&type: Variant); overload;
  end;

//Ext.data.identifier

type
  JISequential = class external(JExt.data.identifier.ISimple)
    prefix: String; // nullable
    seed: Float; // nullable
    function getPrefix: String;
    function getSeed: Float;
    procedure setPrefix; overload;
    procedure setPrefix(prefix: String); overload;
    procedure setSeed; overload;
    procedure setSeed(seed: Float); overload;
  end;

//Ext.data.identifier

type
  JISimple = class external(JExt.IBase)
    function getPrefix: String;
    procedure setPrefix; overload;
    procedure setPrefix(prefix: String); overload;
  end;

//Ext.data.identifier

type
  JIUuid = class external(JExt.data.identifier.ISimple)
    id: Variant; // nullable
    version: Float; // nullable
    salt: Variant; // nullable
    timestamp: Variant; // nullable
    function getId: Variant;
    function getVersion: Float;
    procedure reconfigure; overload;
    procedure reconfigure(config: Variant); overload;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    procedure setVersion; overload;
    procedure setVersion(version: Float); overload;
  end;

//Ext.data

type
  JJsonP = class external 'JsonP'
    callbackKey: String;
    disableCaching: Boolean;
    disableCachingParam: String;
    self: JExt.IClass;
    timeout: Float;
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIJsonP = class external(JExt.IBase)
  end;

//Ext.util

type
  JJSONP = class external 'JSONP'
    callbackKey: String;
    disableCaching: Boolean;
    disableCachingParam: String;
    self: JExt.IClass;
    timeout: Float;
    procedure abort; overload;
    procedure abort(request: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function request: Variant; overload;
    function request(options: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIJSONP = class external(JExt.IBase)
  end;

//Ext.data

type
  JIJsonStore = class external(JExt.data.IStore)
    proxy: Variant; // nullable
    function getProxy: Variant;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
  end;

//Ext.data

type
  JModel = class external 'Model'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure load; overload;
    procedure load(id: Float); overload;
    procedure load(id: Float; config: Variant); overload;
    procedure load(id: Float; config: Variant; scope: Variant); overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIModel = class external(JExt.IBase, JExt.mixin.IObservable)
    associations: array of Variant; // nullable
    belongsTo: Variant; // nullable
    clientIdProperty: String; // nullable
    fields: Variant; // nullable
    hasMany: Variant; // nullable
    hasOne: Variant; // nullable
    idProperty: String; // nullable
    identifier: Variant; // nullable
    proxy: Variant; // nullable
    useCache: Boolean; // nullable
    validations: array of Variant; // nullable
    dirty: Boolean; // nullable
    editing: Boolean; // nullable
    modified: Variant; // nullable
    phantom: Boolean; // nullable
    raw: Variant; // nullable
    stores: array of Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure beginEdit;
    procedure cancelEdit;
    procedure clearListeners;
    procedure commit; overload;
    procedure commit(silent: Boolean); overload;
    function copy: JExt.data.IModel; overload;
    function copy(id: String): JExt.data.IModel; overload;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    procedure endEdit; overload;
    procedure endEdit(silent: Boolean); overload;
    procedure endEdit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function erase: JExt.data.IModel; overload;
    function erase(options: Variant): JExt.data.IModel; overload;
    function erase(options: Variant; scope: Variant): JExt.data.IModel; overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function get: Variant; overload;
    function get(fieldName: String): Variant; overload;
    function getAssociatedData: Variant;
    function getAssociations: array of Variant;
    function getBelongsTo: Variant;
    function getBubbleEvents: Variant;
    function getChanges: Variant;
    function getClientIdProperty: String;
    function getData: Variant; overload;
    function getData(includeAssociated: Boolean): Variant; overload;
    function getFields: Variant;
    function getHasMany: Variant;
    function getHasOne: Variant;
    function getId: Variant;
    function getIdProperty: String;
    function getIdentifier: Variant;
    procedure getIsErased;
    function getListeners: Variant;
    function getProxy: Variant;
    function getUseCache: Boolean;
    function getValidations: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isModified: Boolean; overload;
    function isModified(fieldName: String): Boolean; overload;
    function isValid: Boolean;
    procedure join; overload;
    procedure join(store: JExt.data.IStore); overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure reject; overload;
    procedure reject(silent: Boolean); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    function save: JExt.data.IModel; overload;
    function save(options: Variant): JExt.data.IModel; overload;
    function save(options: Variant; scope: Variant): JExt.data.IModel; overload;
    procedure set; overload;
    procedure set(fieldName: Variant); overload;
    procedure set(fieldName: Variant; value: Variant); overload;
    procedure setAssociations; overload;
    procedure setAssociations(associations: array of Variant); overload;
    procedure setBelongsTo; overload;
    procedure setBelongsTo(belongsTo: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setClientIdProperty; overload;
    procedure setClientIdProperty(clientIdProperty: String); overload;
    function setConvertedData: JExt.data.IModel; overload;
    function setConvertedData(data: Variant): JExt.data.IModel; overload;
    function setData: JExt.data.IModel; overload;
    function setData(rawData: Variant): JExt.data.IModel; overload;
    procedure setDirty;
    function setFields: Variant; overload;
    function setFields(fields: array of Variant): Variant; overload;
    procedure setHasMany; overload;
    procedure setHasMany(hasMany: Variant); overload;
    procedure setHasOne; overload;
    procedure setHasOne(hasOne: Variant); overload;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    procedure setIdProperty; overload;
    procedure setIdProperty(idProperty: String); overload;
    procedure setIdentifier; overload;
    procedure setIdentifier(identifier: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
    procedure setUseCache; overload;
    procedure setUseCache(useCache: Boolean); overload;
    procedure setValidations; overload;
    procedure setValidations(validations: array of Variant); overload;
    procedure suspendEvents;
    function toUrl: String;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unjoin; overload;
    procedure unjoin(store: JExt.data.IStore); overload;
    function validate: JExt.data.IErrors;
  end;

//Ext.data

type
  JRecord = class external 'Record'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    procedure load; overload;
    procedure load(id: Float); overload;
    procedure load(id: Float; config: Variant); overload;
    procedure load(id: Float; config: Variant; scope: Variant); overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIRecord = class external(JExt.IBase, JExt.mixin.IObservable)
    associations: array of Variant; // nullable
    belongsTo: Variant; // nullable
    clientIdProperty: String; // nullable
    fields: Variant; // nullable
    hasMany: Variant; // nullable
    hasOne: Variant; // nullable
    idProperty: String; // nullable
    identifier: Variant; // nullable
    proxy: Variant; // nullable
    useCache: Boolean; // nullable
    validations: array of Variant; // nullable
    dirty: Boolean; // nullable
    editing: Boolean; // nullable
    modified: Variant; // nullable
    phantom: Boolean; // nullable
    raw: Variant; // nullable
    stores: array of Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure beginEdit;
    procedure cancelEdit;
    procedure clearListeners;
    procedure commit; overload;
    procedure commit(silent: Boolean); overload;
    function copy: JExt.data.IModel; overload;
    function copy(id: String): JExt.data.IModel; overload;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    procedure endEdit; overload;
    procedure endEdit(silent: Boolean); overload;
    procedure endEdit(silent: Boolean; modifiedFieldNames: array of String); overload;
    function erase: JExt.data.IModel; overload;
    function erase(options: Variant): JExt.data.IModel; overload;
    function erase(options: Variant; scope: Variant): JExt.data.IModel; overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function get: Variant; overload;
    function get(fieldName: String): Variant; overload;
    function getAssociatedData: Variant;
    function getAssociations: array of Variant;
    function getBelongsTo: Variant;
    function getBubbleEvents: Variant;
    function getChanges: Variant;
    function getClientIdProperty: String;
    function getData: Variant; overload;
    function getData(includeAssociated: Boolean): Variant; overload;
    function getFields: Variant;
    function getHasMany: Variant;
    function getHasOne: Variant;
    function getId: Variant;
    function getIdProperty: String;
    function getIdentifier: Variant;
    procedure getIsErased;
    function getListeners: Variant;
    function getProxy: Variant;
    function getUseCache: Boolean;
    function getValidations: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isModified: Boolean; overload;
    function isModified(fieldName: String): Boolean; overload;
    function isValid: Boolean;
    procedure join; overload;
    procedure join(store: JExt.data.IStore); overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure reject; overload;
    procedure reject(silent: Boolean); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    function save: JExt.data.IModel; overload;
    function save(options: Variant): JExt.data.IModel; overload;
    function save(options: Variant; scope: Variant): JExt.data.IModel; overload;
    procedure set; overload;
    procedure set(fieldName: Variant); overload;
    procedure set(fieldName: Variant; value: Variant); overload;
    procedure setAssociations; overload;
    procedure setAssociations(associations: array of Variant); overload;
    procedure setBelongsTo; overload;
    procedure setBelongsTo(belongsTo: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setClientIdProperty; overload;
    procedure setClientIdProperty(clientIdProperty: String); overload;
    function setConvertedData: JExt.data.IModel; overload;
    function setConvertedData(data: Variant): JExt.data.IModel; overload;
    function setData: JExt.data.IModel; overload;
    function setData(rawData: Variant): JExt.data.IModel; overload;
    procedure setDirty;
    function setFields: Variant; overload;
    function setFields(fields: array of Variant): Variant; overload;
    procedure setHasMany; overload;
    procedure setHasMany(hasMany: Variant); overload;
    procedure setHasOne; overload;
    procedure setHasOne(hasOne: Variant); overload;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    procedure setIdProperty; overload;
    procedure setIdProperty(idProperty: String); overload;
    procedure setIdentifier; overload;
    procedure setIdentifier(identifier: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
    procedure setUseCache; overload;
    procedure setUseCache(useCache: Boolean); overload;
    procedure setValidations; overload;
    procedure setValidations(validations: array of Variant); overload;
    procedure suspendEvents;
    function toUrl: String;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unjoin; overload;
    procedure unjoin(store: JExt.data.IStore); overload;
    function validate: JExt.data.IErrors;
  end;

//Ext.data

type
  JModelManager = class external 'ModelManager'
    all: JExt.util.IHashMap;
    associationStack: Variant;
    defaultProxyType: Variant;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: Variant; overload;
    function create(data: Variant): Variant; overload;
    function create(data: Variant; name: String): Variant; overload;
    function create(data: Variant; name: String; id: Float): Variant; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(id: Variant): JExt.data.IModel; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    function registerType: Variant; overload;
    function registerType(name: String): Variant; overload;
    function registerType(name: String; config: Variant): Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIModelManager = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JModelMgr = class external 'ModelMgr'
    all: JExt.util.IHashMap;
    associationStack: Variant;
    defaultProxyType: Variant;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: Variant; overload;
    function create(data: Variant): Variant; overload;
    function create(data: Variant; name: String): Variant; overload;
    function create(data: Variant; name: String; id: Float): Variant; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(id: Variant): JExt.data.IModel; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    function registerType: Variant; overload;
    function registerType(name: String): Variant; overload;
    function registerType(name: String; config: Variant): Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIModelMgr = class external(JExt.IAbstractManager)
  end;

//Ext

type
  JModelManager = class external 'ModelManager'
    all: JExt.util.IHashMap;
    associationStack: Variant;
    defaultProxyType: Variant;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function create: Variant; overload;
    function create(data: Variant): Variant; overload;
    function create(data: Variant; name: String): Variant; overload;
    function create(data: Variant; name: String; id: Float): Variant; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    function get: Variant; overload;
    function get(id: String): Variant; overload;
    function getCount: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getModel: JExt.data.IModel; overload;
    function getModel(id: Variant): JExt.data.IModel; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isRegistered: Boolean; overload;
    function isRegistered(&type: String): Boolean; overload;
    procedure onAvailable; overload;
    procedure onAvailable(id: String); overload;
    procedure onAvailable(id: String; fn: Variant); overload;
    procedure onAvailable(id: String; fn: Variant; scope: Variant); overload;
    procedure register; overload;
    procedure register(item: Variant); overload;
    function registerType: Variant; overload;
    function registerType(name: String): Variant; overload;
    function registerType(name: String; config: Variant): Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(item: Variant); overload;
  end;

  JIModelManager = class external(JExt.IAbstractManager)
  end;

//Ext.data

type
  JNodeInterface = class external 'NodeInterface'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure decorate; overload;
    procedure decorate(record: JExt.data.IModel); overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JINodeInterface = class external(JExt.IBase)
    childNodes: Variant; // nullable
    firstChild: Variant; // nullable
    lastChild: Variant; // nullable
    nextSibling: Variant; // nullable
    parentNode: Variant; // nullable
    previousSibling: Variant; // nullable
    function appendChild: JExt.data.INodeInterface; overload;
    function appendChild(node: Variant): JExt.data.INodeInterface; overload;
    procedure bubble; overload;
    procedure bubble(fn: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure cascadeBy; overload;
    procedure cascadeBy(fn: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure collapse; overload;
    procedure collapse(recursive: Variant); overload;
    procedure collapse(recursive: Variant; callback: Variant); overload;
    procedure collapse(recursive: Variant; callback: Variant; scope: Variant); overload;
    function contains: Boolean; overload;
    function contains(node: JExt.data.INodeInterface): Boolean; overload;
    function copy: JExt.data.INodeInterface; overload;
    function copy(newId: String): JExt.data.INodeInterface; overload;
    function copy(newId: String; deep: Boolean): JExt.data.INodeInterface; overload;
    procedure destroy; overload;
    procedure destroy(silent: Variant); overload;
    procedure eachChild; overload;
    procedure eachChild(fn: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure expand; overload;
    procedure expand(recursive: Variant); overload;
    procedure expand(recursive: Variant; callback: Variant); overload;
    procedure expand(recursive: Variant; callback: Variant; scope: Variant); overload;
    function findChild: JExt.data.INodeInterface; overload;
    function findChild(attribute: String): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function findChildBy: JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function getChildAt: JExt.data.INodeInterface; overload;
    function getChildAt(index: Float): JExt.data.INodeInterface; overload;
    function getDepth: Float;
    function getPath: String; overload;
    function getPath(field: String): String; overload;
    function getPath(field: String; separator: String): String; overload;
    function hasChildNodes: Boolean;
    function indexOf: Float; overload;
    function indexOf(child: JExt.data.INodeInterface): Float; overload;
    function insertBefore: JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface; refNode: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertChild: JExt.data.IModel; overload;
    function insertChild(index: Float): JExt.data.IModel; overload;
    function insertChild(index: Float; node: JExt.data.IModel): JExt.data.IModel; overload;
    function isAncestor: Boolean; overload;
    function isAncestor(node: JExt.data.INodeInterface): Boolean; overload;
    function isExpandable: Boolean;
    function isExpanded: Boolean;
    function isFirst: Boolean;
    function isLast: Boolean;
    function isLeaf: Boolean;
    function isLoaded: Boolean;
    function isLoading: Boolean;
    function isRoot: Boolean;
    function isVisible: Boolean;
    function remove: JExt.data.INodeInterface; overload;
    function remove(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeAll: JExt.data.INodeInterface; overload;
    function removeAll(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeChild: JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface; destroy: Boolean): JExt.data.INodeInterface; overload;
    function replaceChild: JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface; oldChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    procedure sort; overload;
    procedure sort(sortFn: Variant); overload;
    procedure sort(sortFn: Variant; recursive: Boolean); overload;
    procedure sort(sortFn: Variant; recursive: Boolean; suppressEvent: Boolean); overload;
    function updateInfo: Boolean; overload;
    function updateInfo(silent: Variant): Boolean; overload;
  end;

//Ext.data

type
  JNode = class external 'Node'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure decorate; overload;
    procedure decorate(record: JExt.data.IModel); overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JINode = class external(JExt.IBase)
    childNodes: Variant; // nullable
    firstChild: Variant; // nullable
    lastChild: Variant; // nullable
    nextSibling: Variant; // nullable
    parentNode: Variant; // nullable
    previousSibling: Variant; // nullable
    function appendChild: JExt.data.INodeInterface; overload;
    function appendChild(node: Variant): JExt.data.INodeInterface; overload;
    procedure bubble; overload;
    procedure bubble(fn: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant); overload;
    procedure bubble(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure cascadeBy; overload;
    procedure cascadeBy(fn: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant); overload;
    procedure cascadeBy(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure collapse; overload;
    procedure collapse(recursive: Variant); overload;
    procedure collapse(recursive: Variant; callback: Variant); overload;
    procedure collapse(recursive: Variant; callback: Variant; scope: Variant); overload;
    function contains: Boolean; overload;
    function contains(node: JExt.data.INodeInterface): Boolean; overload;
    function copy: JExt.data.INodeInterface; overload;
    function copy(newId: String): JExt.data.INodeInterface; overload;
    function copy(newId: String; deep: Boolean): JExt.data.INodeInterface; overload;
    procedure destroy; overload;
    procedure destroy(silent: Variant); overload;
    procedure eachChild; overload;
    procedure eachChild(fn: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant); overload;
    procedure eachChild(fn: Variant; scope: Variant; args: array of Variant); overload;
    procedure expand; overload;
    procedure expand(recursive: Variant); overload;
    procedure expand(recursive: Variant; callback: Variant); overload;
    procedure expand(recursive: Variant; callback: Variant; scope: Variant); overload;
    function findChild: JExt.data.INodeInterface; overload;
    function findChild(attribute: String): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant): JExt.data.INodeInterface; overload;
    function findChild(attribute: String; value: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function findChildBy: JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant): JExt.data.INodeInterface; overload;
    function findChildBy(fn: Variant; scope: Variant; deep: Boolean): JExt.data.INodeInterface; overload;
    function getChildAt: JExt.data.INodeInterface; overload;
    function getChildAt(index: Float): JExt.data.INodeInterface; overload;
    function getDepth: Float;
    function getPath: String; overload;
    function getPath(field: String): String; overload;
    function getPath(field: String; separator: String): String; overload;
    function hasChildNodes: Boolean;
    function indexOf: Float; overload;
    function indexOf(child: JExt.data.INodeInterface): Float; overload;
    function insertBefore: JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertBefore(node: JExt.data.INodeInterface; refNode: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function insertChild: JExt.data.IModel; overload;
    function insertChild(index: Float): JExt.data.IModel; overload;
    function insertChild(index: Float; node: JExt.data.IModel): JExt.data.IModel; overload;
    function isAncestor: Boolean; overload;
    function isAncestor(node: JExt.data.INodeInterface): Boolean; overload;
    function isExpandable: Boolean;
    function isExpanded: Boolean;
    function isFirst: Boolean;
    function isLast: Boolean;
    function isLeaf: Boolean;
    function isLoaded: Boolean;
    function isLoading: Boolean;
    function isRoot: Boolean;
    function isVisible: Boolean;
    function remove: JExt.data.INodeInterface; overload;
    function remove(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeAll: JExt.data.INodeInterface; overload;
    function removeAll(destroy: Boolean): JExt.data.INodeInterface; overload;
    function removeChild: JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function removeChild(node: JExt.data.INodeInterface; destroy: Boolean): JExt.data.INodeInterface; overload;
    function replaceChild: JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    function replaceChild(newChild: JExt.data.INodeInterface; oldChild: JExt.data.INodeInterface): JExt.data.INodeInterface; overload;
    procedure sort; overload;
    procedure sort(sortFn: Variant); overload;
    procedure sort(sortFn: Variant; recursive: Boolean); overload;
    procedure sort(sortFn: Variant; recursive: Boolean; suppressEvent: Boolean); overload;
    function updateInfo: Boolean; overload;
    function updateInfo(silent: Variant): Boolean; overload;
  end;

//Ext.data

type
  JINodeStore = class external(JExt.data.IStore)
    filters: array of Variant; // nullable
    folderSort: Boolean; // nullable
    node: JExt.data.IModel; // nullable
    recursive: Boolean; // nullable
    rootVisible: Boolean; // nullable
    sorters: array of Variant; // nullable
    function getFilters: Variant;
    function getFolderSort: Boolean;
    function getNode: JExt.data.IModel;
    function getRecursive: Boolean;
    function getRootVisible: Boolean;
    function getSorters: Variant;
    function isVisible: Boolean; overload;
    function isVisible(node: Variant): Boolean; overload;
    procedure setFilters; overload;
    procedure setFilters(filters: Variant); overload;
    procedure setFolderSort; overload;
    procedure setFolderSort(folderSort: Boolean); overload;
    procedure setNode; overload;
    procedure setNode(node: JExt.data.IModel); overload;
    procedure setRecursive; overload;
    procedure setRecursive(recursive: Boolean); overload;
    procedure setRootVisible; overload;
    procedure setRootVisible(rootVisible: Boolean); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: Variant); overload;
  end;

//Ext.data

type
  JIOperation = class external(JExt.IBase)
    action: String; // nullable
    batch: JExt.data.IBatch; // nullable
    callback: Variant; // nullable
    filters: array of JExt.util.IFilter; // nullable
    group: Boolean; // nullable
    grouper: JExt.util.IGrouper; // nullable
    limit: Float; // nullable
    model: JExt.data.IModel; // nullable
    params: Variant; // nullable
    records: array of Variant; // nullable
    request: JExt.data.IRequest; // nullable
    response: Variant; // nullable
    resultSet: JExt.data.IResultSet; // nullable
    scope: Variant; // nullable
    sorters: array of JExt.util.ISorter; // nullable
    start: Float; // nullable
    synchronous: Boolean; // nullable
    withCredentials: Boolean; // nullable
    function allowWrite: Boolean;
    function getAction: String;
    function getAddRecords: Boolean;
    function getBatch: JExt.data.IBatch;
    function getCallback: Variant;
    function getError: Variant;
    function getFilters: array of JExt.util.IFilter;
    function getGrouper: JExt.util.IGrouper;
    function getLimit: Float;
    function getModel: JExt.data.IModel;
    function getNode: Variant;
    function getPage: Variant;
    function getParams: Variant;
    function getRequest: JExt.data.IRequest;
    function getResponse: Variant;
    function getResultSet: JExt.data.IResultSet;
    function getScope: Variant;
    function getSorters: array of JExt.util.ISorter;
    function getStart: Float;
    function getSynchronous: Boolean;
    function getUrl: Variant;
    function getWithCredentials: Boolean;
    function hasException: Boolean;
    function isComplete: Boolean;
    function isRunning: Boolean;
    function isStarted: Boolean;
    procedure setAction; overload;
    procedure setAction(action: String); overload;
    procedure setAddRecords; overload;
    procedure setAddRecords(addRecords: Boolean); overload;
    procedure setBatch; overload;
    procedure setBatch(batch: JExt.data.IBatch); overload;
    procedure setCallback; overload;
    procedure setCallback(callback: Variant); overload;
    procedure setCompleted;
    procedure setException; overload;
    procedure setException(error: Variant); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of JExt.util.IFilter); overload;
    procedure setGrouper; overload;
    procedure setGrouper(grouper: JExt.util.IGrouper); overload;
    procedure setLimit; overload;
    procedure setLimit(limit: Float); overload;
    procedure setModel; overload;
    procedure setModel(model: JExt.data.IModel); overload;
    procedure setNode; overload;
    procedure setNode(node: Variant); overload;
    procedure setPage; overload;
    procedure setPage(page: Variant); overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
    procedure setRecords; overload;
    procedure setRecords(records: array of Variant); overload;
    procedure setRequest; overload;
    procedure setRequest(request: JExt.data.IRequest); overload;
    procedure setResponse; overload;
    procedure setResponse(response: Variant); overload;
    procedure setResultSet; overload;
    procedure setResultSet(resultSet: JExt.data.IResultSet); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of JExt.util.ISorter); overload;
    procedure setStart; overload;
    procedure setStart(start: Float); overload;
    procedure setStarted;
    procedure setSuccessful;
    procedure setSynchronous; overload;
    procedure setSynchronous(synchronous: Boolean); overload;
    procedure setUrl; overload;
    procedure setUrl(url: Variant); overload;
    procedure setWithCredentials; overload;
    procedure setWithCredentials(withCredentials: Boolean); overload;
    function wasSuccessful: Boolean;
  end;

//Ext.data.plugin

type
  JIBuffered = class external(JExt.IEvented)
    leadingBufferZone: Float; // nullable
    purgePageCount: Float; // nullable
    trailingBufferZone: Float; // nullable
    function getBufferedCollection: Variant;
    function getLeadingBufferZone: Float;
    function getPageFromRecordIndex: Float; overload;
    function getPageFromRecordIndex(index: Float): Float; overload;
    function getPurgePageCount: Float;
    function getStore: Variant;
    function getTrailingBufferZone: Float;
    function getViewSize: Float;
    procedure prefetch; overload;
    procedure prefetch(options: Variant); overload;
    procedure prefetchPage; overload;
    procedure prefetchPage(page: Float); overload;
    procedure prefetchPage(page: Float; options: Variant); overload;
    procedure setBufferedCollection; overload;
    procedure setBufferedCollection(bufferedCollection: Variant); overload;
    procedure setLeadingBufferZone; overload;
    procedure setLeadingBufferZone(leadingBufferZone: Float); overload;
    procedure setPurgePageCount; overload;
    procedure setPurgePageCount(purgePageCount: Float); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setTrailingBufferZone; overload;
    procedure setTrailingBufferZone(trailingBufferZone: Float); overload;
    procedure setViewSize; overload;
    procedure setViewSize(viewSize: Float); overload;
  end;

//Ext.data.proxy

type
  JIAjax = class external(JExt.data.proxy.IServer)
    headers: Variant; // nullable
    password: String; // nullable
    useDefaultXhrHeader: Boolean; // nullable
    username: String; // nullable
    withCredentials: Boolean; // nullable
    actionMethods: Variant; // nullable
    function doRequest: Variant; overload;
    function doRequest(operation: JExt.data.IOperation): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant): Variant; overload;
    function getHeaders: Variant;
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
    function getPassword: String;
    function getUseDefaultXhrHeader: Boolean;
    function getUsername: String;
    function getWithCredentials: Boolean;
    procedure setHeaders; overload;
    procedure setHeaders(headers: Variant); overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Boolean); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    procedure setWithCredentials; overload;
    procedure setWithCredentials(withCredentials: Boolean); overload;
  end;

//Ext.data

type
  JIHttpProxy = class external(JExt.data.proxy.IServer)
    headers: Variant; // nullable
    password: String; // nullable
    useDefaultXhrHeader: Boolean; // nullable
    username: String; // nullable
    withCredentials: Boolean; // nullable
    actionMethods: Variant; // nullable
    function doRequest: Variant; overload;
    function doRequest(operation: JExt.data.IOperation): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant): Variant; overload;
    function getHeaders: Variant;
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
    function getPassword: String;
    function getUseDefaultXhrHeader: Boolean;
    function getUsername: String;
    function getWithCredentials: Boolean;
    procedure setHeaders; overload;
    procedure setHeaders(headers: Variant); overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Boolean); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    procedure setWithCredentials; overload;
    procedure setWithCredentials(withCredentials: Boolean); overload;
  end;

//Ext.data

type
  JIAjaxProxy = class external(JExt.data.proxy.IServer)
    headers: Variant; // nullable
    password: String; // nullable
    useDefaultXhrHeader: Boolean; // nullable
    username: String; // nullable
    withCredentials: Boolean; // nullable
    actionMethods: Variant; // nullable
    function doRequest: Variant; overload;
    function doRequest(operation: JExt.data.IOperation): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant): Variant; overload;
    function getHeaders: Variant;
    function getMethod: String; overload;
    function getMethod(request: JExt.data.IRequest): String; overload;
    function getPassword: String;
    function getUseDefaultXhrHeader: Boolean;
    function getUsername: String;
    function getWithCredentials: Boolean;
    procedure setHeaders; overload;
    procedure setHeaders(headers: Variant); overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Boolean); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    procedure setWithCredentials; overload;
    procedure setWithCredentials(withCredentials: Boolean); overload;
  end;

//Ext.data.proxy

type
  JIClient = class external(JExt.data.proxy.IProxy)
    procedure clear;
  end;

//Ext.proxy

type
  JIClientProxy = class external(JExt.data.proxy.IProxy)
    procedure clear;
  end;

//Ext.data.proxy

type
  JIDirect = class external(JExt.data.proxy.IServer)
    api: Variant; // nullable
    directFn: Variant; // nullable
    extraParams: Variant; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    function buildUrl: String;
    procedure doRequest; overload;
    procedure doRequest(operation: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant; scope: Variant); overload;
    function getApi: Variant;
    function getDirectFn: Variant;
    function getExtraParams: Variant;
    function getParamOrder: Variant;
    function getParamsAsHash: Boolean;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setDirectFn; overload;
    procedure setDirectFn(directFn: Variant); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setParamOrder; overload;
    procedure setParamOrder(paramOrder: Variant); overload;
    procedure setParamsAsHash; overload;
    procedure setParamsAsHash(paramsAsHash: Boolean); overload;
  end;

//Ext.data

type
  JIDirectProxy = class external(JExt.data.proxy.IServer)
    api: Variant; // nullable
    directFn: Variant; // nullable
    extraParams: Variant; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    function buildUrl: String;
    procedure doRequest; overload;
    procedure doRequest(operation: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant); overload;
    procedure doRequest(operation: Variant; callback: Variant; scope: Variant); overload;
    function getApi: Variant;
    function getDirectFn: Variant;
    function getExtraParams: Variant;
    function getParamOrder: Variant;
    function getParamsAsHash: Boolean;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setDirectFn; overload;
    procedure setDirectFn(directFn: Variant); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setParamOrder; overload;
    procedure setParamOrder(paramOrder: Variant); overload;
    procedure setParamsAsHash; overload;
    procedure setParamsAsHash(paramsAsHash: Boolean); overload;
  end;

//Ext.data.proxy

type
  JIJsonP = class external(JExt.data.proxy.IServer)
    autoAppendParams: Boolean; // nullable
    callbackKey: String; // nullable
    recordParam: String; // nullable
    procedure abort;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure destroy;
    function doRequest: Variant; overload;
    function doRequest(operation: JExt.data.IOperation): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant): Variant; overload;
    function getAutoAppendParams: Boolean;
    function getCallbackKey: String;
    function getDefaultWriterType: String;
    function getRecordParam: String;
    procedure setAutoAppendParams; overload;
    procedure setAutoAppendParams(autoAppendParams: Boolean); overload;
    procedure setCallbackKey; overload;
    procedure setCallbackKey(callbackKey: String); overload;
    procedure setDefaultWriterType; overload;
    procedure setDefaultWriterType(defaultWriterType: String); overload;
    procedure setRecordParam; overload;
    procedure setRecordParam(recordParam: String); overload;
  end;

//Ext.data

type
  JIScriptTagProxy = class external(JExt.data.proxy.IServer)
    autoAppendParams: Boolean; // nullable
    callbackKey: String; // nullable
    recordParam: String; // nullable
    procedure abort;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure destroy;
    function doRequest: Variant; overload;
    function doRequest(operation: JExt.data.IOperation): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant): Variant; overload;
    function doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant): Variant; overload;
    function getAutoAppendParams: Boolean;
    function getCallbackKey: String;
    function getDefaultWriterType: String;
    function getRecordParam: String;
    procedure setAutoAppendParams; overload;
    procedure setAutoAppendParams(autoAppendParams: Boolean); overload;
    procedure setCallbackKey; overload;
    procedure setCallbackKey(callbackKey: String); overload;
    procedure setDefaultWriterType; overload;
    procedure setDefaultWriterType(defaultWriterType: String); overload;
    procedure setRecordParam; overload;
    procedure setRecordParam(recordParam: String); overload;
  end;

//Ext.data.proxy

type
  JILocalStorage = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data

type
  JILocalStorageProxy = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data.proxy

type
  JIMemory = class external(JExt.data.proxy.IClient)
    data: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function getData: Variant;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIMemoryProxy = class external(JExt.data.proxy.IClient)
    data: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function getData: Variant;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIProxy = class external(JExt.IEvented)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function getBatchActions: Boolean;
    function getBatchOrder: String;
    function getModel: Variant;
    function getReader: Variant;
    function getWriter: Variant;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure setBatchActions; overload;
    procedure setBatchActions(batchActions: Boolean); overload;
    procedure setBatchOrder; overload;
    procedure setBatchOrder(batchOrder: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setReader; overload;
    procedure setReader(reader: Variant); overload;
    procedure setWriter; overload;
    procedure setWriter(writer: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIDataProxy = class external(JExt.IEvented)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function getBatchActions: Boolean;
    function getBatchOrder: String;
    function getModel: Variant;
    function getReader: Variant;
    function getWriter: Variant;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure setBatchActions; overload;
    procedure setBatchActions(batchActions: Boolean); overload;
    procedure setBatchOrder; overload;
    procedure setBatchOrder(batchOrder: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setReader; overload;
    procedure setReader(reader: Variant); overload;
    procedure setWriter; overload;
    procedure setWriter(writer: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIProxy = class external(JExt.IEvented)
    batchActions: Boolean; // nullable
    batchOrder: String; // nullable
    model: Variant; // nullable
    reader: Variant; // nullable
    writer: Variant; // nullable
    function batch: JExt.data.IBatch; overload;
    function batch(options: Variant): JExt.data.IBatch; overload;
    procedure create; overload;
    procedure create(operation: JExt.data.IOperation); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure create(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: JExt.data.IOperation); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure destroy(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function getBatchActions: Boolean;
    function getBatchOrder: String;
    function getModel: Variant;
    function getReader: Variant;
    function getWriter: Variant;
    procedure read; overload;
    procedure read(operation: JExt.data.IOperation); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure read(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    procedure setBatchActions; overload;
    procedure setBatchActions(batchActions: Boolean); overload;
    procedure setBatchOrder; overload;
    procedure setBatchOrder(batchOrder: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setReader; overload;
    procedure setReader(reader: Variant); overload;
    procedure setWriter; overload;
    procedure setWriter(writer: Variant); overload;
    procedure update; overload;
    procedure update(operation: JExt.data.IOperation); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure update(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIRest = class external(JExt.data.proxy.IAjax)
    appendId: Boolean; // nullable
    batchActions: Boolean; // nullable
    format: String; // nullable
    function getActionMethods: Variant;
    function getAppendId: Boolean;
    function getBatchActions: Boolean;
    function getFormat: String;
    procedure setActionMethods; overload;
    procedure setActionMethods(actionMethods: Variant); overload;
    procedure setAppendId; overload;
    procedure setAppendId(appendId: Boolean); overload;
    procedure setBatchActions; overload;
    procedure setBatchActions(batchActions: Boolean); overload;
    procedure setFormat; overload;
    procedure setFormat(format: String); overload;
  end;

//Ext.data

type
  JIRestProxy = class external(JExt.data.proxy.IAjax)
    appendId: Boolean; // nullable
    batchActions: Boolean; // nullable
    format: String; // nullable
    function getActionMethods: Variant;
    function getAppendId: Boolean;
    function getBatchActions: Boolean;
    function getFormat: String;
    procedure setActionMethods; overload;
    procedure setActionMethods(actionMethods: Variant); overload;
    procedure setAppendId; overload;
    procedure setAppendId(appendId: Boolean); overload;
    procedure setBatchActions; overload;
    procedure setBatchActions(batchActions: Boolean); overload;
    procedure setFormat; overload;
    procedure setFormat(format: String); overload;
  end;

//Ext.data.proxy

type
  JIServer = class external(JExt.data.proxy.IProxy)
    api: Variant; // nullable
    cacheString: String; // nullable
    directionParam: String; // nullable
    enablePagingParams: Boolean; // nullable
    extraParams: Variant; // nullable
    filterParam: String; // nullable
    groupParam: String; // nullable
    limitParam: String; // nullable
    noCache: Boolean; // nullable
    pageParam: String; // nullable
    simpleSortMode: Boolean; // nullable
    sortParam: String; // nullable
    startParam: String; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure afterRequest; overload;
    procedure afterRequest(request: JExt.data.IRequest); overload;
    procedure afterRequest(request: JExt.data.IRequest; success: Boolean); overload;
    function buildRequest: JExt.data.IRequest; overload;
    function buildRequest(operation: JExt.data.IOperation): JExt.data.IRequest; overload;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure create;
    procedure destroy;
    procedure doRequest; overload;
    procedure doRequest(operation: JExt.data.IOperation); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function encodeFilters: String; overload;
    function encodeFilters(filters: array of JExt.util.IFilter): String; overload;
    function encodeSorters: String; overload;
    function encodeSorters(sorters: array of JExt.util.ISorter): String; overload;
    function getApi: Variant;
    function getCacheString: String;
    function getDirectionParam: String;
    function getEnablePagingParams: Boolean;
    function getExtraParams: Variant;
    function getFilterParam: String;
    function getGroupParam: String;
    function getLimitParam: String;
    function getNoCache: Boolean;
    function getPageParam: String;
    function getSimpleSortMode: Boolean;
    function getSortParam: String;
    function getStartParam: String;
    function getTimeout: Float;
    procedure processResponse; overload;
    procedure processResponse(success: Boolean); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant; callback: Variant); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant; callback: Variant; scope: Variant); overload;
    procedure read;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setCacheString; overload;
    procedure setCacheString(cacheString: String); overload;
    procedure setDirectionParam; overload;
    procedure setDirectionParam(directionParam: String); overload;
    procedure setEnablePagingParams; overload;
    procedure setEnablePagingParams(enablePagingParams: Boolean); overload;
    procedure setExtraParam; overload;
    procedure setExtraParam(name: String); overload;
    procedure setExtraParam(name: String; value: Variant); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setFilterParam; overload;
    procedure setFilterParam(filterParam: String); overload;
    procedure setGroupParam; overload;
    procedure setGroupParam(groupParam: String); overload;
    procedure setLimitParam; overload;
    procedure setLimitParam(limitParam: String); overload;
    procedure setNoCache; overload;
    procedure setNoCache(noCache: Boolean); overload;
    procedure setPageParam; overload;
    procedure setPageParam(pageParam: String); overload;
    procedure setSimpleSortMode; overload;
    procedure setSimpleSortMode(simpleSortMode: Boolean); overload;
    procedure setSortParam; overload;
    procedure setSortParam(sortParam: String); overload;
    procedure setStartParam; overload;
    procedure setStartParam(startParam: String); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure update;
  end;

//Ext.data

type
  JIServerProxy = class external(JExt.data.proxy.IProxy)
    api: Variant; // nullable
    cacheString: String; // nullable
    directionParam: String; // nullable
    enablePagingParams: Boolean; // nullable
    extraParams: Variant; // nullable
    filterParam: String; // nullable
    groupParam: String; // nullable
    limitParam: String; // nullable
    noCache: Boolean; // nullable
    pageParam: String; // nullable
    simpleSortMode: Boolean; // nullable
    sortParam: String; // nullable
    startParam: String; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure afterRequest; overload;
    procedure afterRequest(request: JExt.data.IRequest); overload;
    procedure afterRequest(request: JExt.data.IRequest; success: Boolean); overload;
    function buildRequest: JExt.data.IRequest; overload;
    function buildRequest(operation: JExt.data.IOperation): JExt.data.IRequest; overload;
    function buildUrl: String; overload;
    function buildUrl(request: JExt.data.IRequest): String; overload;
    procedure create;
    procedure destroy;
    procedure doRequest; overload;
    procedure doRequest(operation: JExt.data.IOperation); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant); overload;
    procedure doRequest(operation: JExt.data.IOperation; callback: Variant; scope: Variant); overload;
    function encodeFilters: String; overload;
    function encodeFilters(filters: array of JExt.util.IFilter): String; overload;
    function encodeSorters: String; overload;
    function encodeSorters(sorters: array of JExt.util.ISorter): String; overload;
    function getApi: Variant;
    function getCacheString: String;
    function getDirectionParam: String;
    function getEnablePagingParams: Boolean;
    function getExtraParams: Variant;
    function getFilterParam: String;
    function getGroupParam: String;
    function getLimitParam: String;
    function getNoCache: Boolean;
    function getPageParam: String;
    function getSimpleSortMode: Boolean;
    function getSortParam: String;
    function getStartParam: String;
    function getTimeout: Float;
    procedure processResponse; overload;
    procedure processResponse(success: Boolean); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant; callback: Variant); overload;
    procedure processResponse(success: Boolean; operation: JExt.data.IOperation; request: JExt.data.IRequest; response: Variant; callback: Variant; scope: Variant); overload;
    procedure read;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setCacheString; overload;
    procedure setCacheString(cacheString: String); overload;
    procedure setDirectionParam; overload;
    procedure setDirectionParam(directionParam: String); overload;
    procedure setEnablePagingParams; overload;
    procedure setEnablePagingParams(enablePagingParams: Boolean); overload;
    procedure setExtraParam; overload;
    procedure setExtraParam(name: String); overload;
    procedure setExtraParam(name: String; value: Variant); overload;
    procedure setExtraParams; overload;
    procedure setExtraParams(extraParams: Variant); overload;
    procedure setFilterParam; overload;
    procedure setFilterParam(filterParam: String); overload;
    procedure setGroupParam; overload;
    procedure setGroupParam(groupParam: String); overload;
    procedure setLimitParam; overload;
    procedure setLimitParam(limitParam: String); overload;
    procedure setNoCache; overload;
    procedure setNoCache(noCache: Boolean); overload;
    procedure setPageParam; overload;
    procedure setPageParam(pageParam: String); overload;
    procedure setSimpleSortMode; overload;
    procedure setSimpleSortMode(simpleSortMode: Boolean); overload;
    procedure setSortParam; overload;
    procedure setSortParam(sortParam: String); overload;
    procedure setStartParam; overload;
    procedure setStartParam(startParam: String); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure update;
  end;

//Ext.data.proxy

type
  JISessionStorage = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data

type
  JISessionStorageProxy = class external(JExt.data.proxy.IWebStorage)
  end;

//Ext.data.proxy

type
  JISql = class external(JExt.data.proxy.IClient)
    database: String; // nullable
    table: String; // nullable
    procedure create; overload;
    procedure create(operation: Variant); overload;
    procedure create(operation: Variant; callback: Variant); overload;
    procedure create(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant; scope: Variant); overload;
    function getColumns: String;
    function getDatabase: String;
    function getDefaultDateFormat: String;
    function getRecordData: Variant; overload;
    function getRecordData(record: Variant): Variant; overload;
    function getTable: String;
    function getTableExists: Boolean;
    function getUniqueIdStrategy: Boolean;
    procedure read; overload;
    procedure read(operation: Variant); overload;
    procedure read(operation: Variant; callback: Variant); overload;
    procedure read(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure setColumns; overload;
    procedure setColumns(columns: String); overload;
    procedure setDatabase; overload;
    procedure setDatabase(database: String); overload;
    procedure setDefaultDateFormat; overload;
    procedure setDefaultDateFormat(defaultDateFormat: String); overload;
    procedure setTable; overload;
    procedure setTable(table: String); overload;
    procedure setTableExists; overload;
    procedure setTableExists(tableExists: Boolean); overload;
    procedure setUniqueIdStrategy; overload;
    procedure setUniqueIdStrategy(uniqueIdStrategy: Boolean); overload;
    procedure update; overload;
    procedure update(operation: Variant); overload;
    procedure update(operation: Variant; callback: Variant); overload;
    procedure update(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.proxy

type
  JIWebStorage = class external(JExt.data.proxy.IClient)
    enablePagingParams: Boolean; // nullable
    id: String; // nullable
    cache: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: Variant); overload;
    procedure create(operation: Variant; callback: Variant); overload;
    procedure create(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant; scope: Variant); overload;
    function getDefaultDateFormat: String;
    function getEnablePagingParams: Boolean;
    function getId: String;
    procedure read; overload;
    procedure read(operation: Variant); overload;
    procedure read(operation: Variant; callback: Variant); overload;
    procedure read(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure setDefaultDateFormat; overload;
    procedure setDefaultDateFormat(defaultDateFormat: String); overload;
    procedure setEnablePagingParams; overload;
    procedure setEnablePagingParams(enablePagingParams: Boolean); overload;
    procedure setId; overload;
    procedure setId(id: String); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRecord(record: JExt.data.IModel; id: String); overload;
    procedure update; overload;
    procedure update(operation: Variant); overload;
    procedure update(operation: Variant; callback: Variant); overload;
    procedure update(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data

type
  JIWebStorageProxy = class external(JExt.data.proxy.IClient)
    enablePagingParams: Boolean; // nullable
    id: String; // nullable
    cache: Variant; // nullable
    procedure clear;
    procedure create; overload;
    procedure create(operation: Variant); overload;
    procedure create(operation: Variant; callback: Variant); overload;
    procedure create(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure destroy; overload;
    procedure destroy(operation: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant); overload;
    procedure destroy(operation: Variant; callback: Variant; scope: Variant); overload;
    function getDefaultDateFormat: String;
    function getEnablePagingParams: Boolean;
    function getId: String;
    procedure read; overload;
    procedure read(operation: Variant); overload;
    procedure read(operation: Variant; callback: Variant); overload;
    procedure read(operation: Variant; callback: Variant; scope: Variant); overload;
    procedure setDefaultDateFormat; overload;
    procedure setDefaultDateFormat(defaultDateFormat: String); overload;
    procedure setEnablePagingParams; overload;
    procedure setEnablePagingParams(enablePagingParams: Boolean); overload;
    procedure setId; overload;
    procedure setId(id: String); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRecord(record: JExt.data.IModel; id: String); overload;
    procedure update; overload;
    procedure update(operation: Variant); overload;
    procedure update(operation: Variant; callback: Variant); overload;
    procedure update(operation: Variant; callback: Variant; scope: Variant); overload;
  end;

//Ext.data.reader

type
  JIArray = class external(JExt.data.reader.IJson)
    successProperty: String; // nullable
    totalProperty: String; // nullable
    function getSuccessProperty: Variant;
    function getTotalProperty: Variant;
    procedure setSuccessProperty; overload;
    procedure setSuccessProperty(successProperty: Variant); overload;
    procedure setTotalProperty; overload;
    procedure setTotalProperty(totalProperty: Variant); overload;
  end;

//Ext.data

type
  JIArrayReader = class external(JExt.data.reader.IJson)
    successProperty: String; // nullable
    totalProperty: String; // nullable
    function getSuccessProperty: Variant;
    function getTotalProperty: Variant;
    procedure setSuccessProperty; overload;
    procedure setSuccessProperty(successProperty: Variant); overload;
    procedure setTotalProperty; overload;
    procedure setTotalProperty(totalProperty: Variant); overload;
  end;

//Ext.data.reader

type
  JIJson = class external(JExt.data.reader.IReader)
    record: String; // nullable
    useSimpleAccessors: Boolean; // nullable
    function getRecord: String;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function getUseSimpleAccessors: Boolean;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
    procedure setUseSimpleAccessors; overload;
    procedure setUseSimpleAccessors(useSimpleAccessors: Boolean); overload;
  end;

//Ext.data

type
  JIJsonReader = class external(JExt.data.reader.IReader)
    record: String; // nullable
    useSimpleAccessors: Boolean; // nullable
    function getRecord: String;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function getUseSimpleAccessors: Boolean;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
    procedure setUseSimpleAccessors; overload;
    procedure setUseSimpleAccessors(useSimpleAccessors: Boolean); overload;
  end;

//Ext.data.reader

type
  JIReader = class external(JExt.IBase, JExt.mixin.IObservable)
    clientIdProperty: String; // nullable
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    root: String; // nullable
    rootProperty: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getClientIdProperty: String;
    function getIdProperty: String;
    function getImplicitIncludes: Boolean;
    function getListeners: Variant;
    function getMessageProperty: String;
    function getModel: Variant;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function getRootProperty: String;
    function getSuccessProperty: Variant;
    function getTotalProperty: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setClientIdProperty; overload;
    procedure setClientIdProperty(clientIdProperty: String); overload;
    procedure setIdProperty; overload;
    procedure setIdProperty(idProperty: String); overload;
    procedure setImplicitIncludes; overload;
    procedure setImplicitIncludes(implicitIncludes: Boolean); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMessageProperty; overload;
    procedure setMessageProperty(messageProperty: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setRootProperty; overload;
    procedure setRootProperty(rootProperty: String); overload;
    procedure setSuccessProperty; overload;
    procedure setSuccessProperty(successProperty: String); overload;
    procedure setTotalProperty; overload;
    procedure setTotalProperty(totalProperty: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.data

type
  JIReader = class external(JExt.IBase, JExt.mixin.IObservable)
    clientIdProperty: String; // nullable
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    root: String; // nullable
    rootProperty: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getClientIdProperty: String;
    function getIdProperty: String;
    function getImplicitIncludes: Boolean;
    function getListeners: Variant;
    function getMessageProperty: String;
    function getModel: Variant;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function getRootProperty: String;
    function getSuccessProperty: Variant;
    function getTotalProperty: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setClientIdProperty; overload;
    procedure setClientIdProperty(clientIdProperty: String); overload;
    procedure setIdProperty; overload;
    procedure setIdProperty(idProperty: String); overload;
    procedure setImplicitIncludes; overload;
    procedure setImplicitIncludes(implicitIncludes: Boolean); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMessageProperty; overload;
    procedure setMessageProperty(messageProperty: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setRootProperty; overload;
    procedure setRootProperty(rootProperty: String); overload;
    procedure setSuccessProperty; overload;
    procedure setSuccessProperty(successProperty: String); overload;
    procedure setTotalProperty; overload;
    procedure setTotalProperty(totalProperty: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.data

type
  JIDataReader = class external(JExt.IBase, JExt.mixin.IObservable)
    clientIdProperty: String; // nullable
    idProperty: String; // nullable
    implicitIncludes: Boolean; // nullable
    messageProperty: String; // nullable
    root: String; // nullable
    rootProperty: String; // nullable
    successProperty: String; // nullable
    totalProperty: String; // nullable
    metaData: Variant; // nullable
    rawData: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getClientIdProperty: String;
    function getIdProperty: String;
    function getImplicitIncludes: Boolean;
    function getListeners: Variant;
    function getMessageProperty: String;
    function getModel: Variant;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function getRootProperty: String;
    function getSuccessProperty: Variant;
    function getTotalProperty: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function read: JExt.data.IResultSet; overload;
    function read(response: Variant): JExt.data.IResultSet; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(data: Variant): JExt.data.IResultSet; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setClientIdProperty; overload;
    procedure setClientIdProperty(clientIdProperty: String); overload;
    procedure setIdProperty; overload;
    procedure setIdProperty(idProperty: String); overload;
    procedure setImplicitIncludes; overload;
    procedure setImplicitIncludes(implicitIncludes: Boolean); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMessageProperty; overload;
    procedure setMessageProperty(messageProperty: String); overload;
    procedure setModel; overload;
    procedure setModel(model: Variant); overload;
    procedure setRootProperty; overload;
    procedure setRootProperty(rootProperty: String); overload;
    procedure setSuccessProperty; overload;
    procedure setSuccessProperty(successProperty: String); overload;
    procedure setTotalProperty; overload;
    procedure setTotalProperty(totalProperty: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.data.reader

type
  JIXml = class external(JExt.data.reader.IReader)
    record: String; // nullable
    function getData: Variant; overload;
    function getData(data: Variant): Variant; overload;
    function getRecord: String;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(doc: Variant): JExt.data.IResultSet; overload;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
  end;

//Ext.data

type
  JIXmlReader = class external(JExt.data.reader.IReader)
    record: String; // nullable
    function getData: Variant; overload;
    function getData(data: Variant): Variant; overload;
    function getRecord: String;
    function getResponseData: Variant; overload;
    function getResponseData(response: Variant): Variant; overload;
    function readRecords: JExt.data.IResultSet; overload;
    function readRecords(doc: Variant): JExt.data.IResultSet; overload;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
  end;

//Ext.data

type
  JIRequest = class external(JExt.IBase)
    action: String; // nullable
    callbackKey: String; // nullable
    disableCaching: Boolean; // nullable
    headers: Variant; // nullable
    jsonData: Variant; // nullable
    jsonp: JExt.data.IJsonP; // nullable
    method: String; // nullable
    operation: JExt.data.IOperation; // nullable
    params: Variant; // nullable
    password: String; // nullable
    proxy: JExt.data.proxy.IProxy; // nullable
    url: String; // nullable
    username: String; // nullable
    withCredentials: Boolean; // nullable
    xmlData: Variant; // nullable
    function getAction: String;
    function getArgs: Variant;
    function getCallback: Variant;
    function getCallbackKey: String;
    function getDirectFn: Variant;
    function getDisableCaching: Boolean;
    function getHeaders: Variant;
    function getJsonData: Variant;
    function getMethod: String;
    function getOperation: JExt.data.IOperation;
    function getParams: Variant;
    function getPassword: String;
    function getProxy: JExt.data.proxy.IProxy;
    function getRecords: Variant;
    function getScope: Variant;
    function getTimeout: Float;
    function getUrl: String;
    function getUseDefaultXhrHeader: Variant;
    function getUsername: String;
    function getWithCredentials: Boolean;
    function getXmlData: Variant;
    procedure setAction; overload;
    procedure setAction(action: String); overload;
    procedure setArgs; overload;
    procedure setArgs(args: Variant); overload;
    procedure setCallback; overload;
    procedure setCallback(callback: Variant); overload;
    procedure setCallbackKey; overload;
    procedure setCallbackKey(callbackKey: String); overload;
    procedure setDirectFn; overload;
    procedure setDirectFn(directFn: Variant); overload;
    procedure setDisableCaching; overload;
    procedure setDisableCaching(disableCaching: Boolean); overload;
    procedure setHeaders; overload;
    procedure setHeaders(headers: Variant); overload;
    procedure setJsonData; overload;
    procedure setJsonData(jsonData: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: String); overload;
    procedure setOperation; overload;
    procedure setOperation(operation: JExt.data.IOperation); overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
    procedure setPassword; overload;
    procedure setPassword(password: String); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: JExt.data.proxy.IProxy); overload;
    procedure setRecords; overload;
    procedure setRecords(records: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure setUseDefaultXhrHeader; overload;
    procedure setUseDefaultXhrHeader(useDefaultXhrHeader: Variant); overload;
    procedure setUsername; overload;
    procedure setUsername(username: String); overload;
    procedure setWithCredentials; overload;
    procedure setWithCredentials(withCredentials: Boolean); overload;
    procedure setXmlData; overload;
    procedure setXmlData(xmlData: Variant); overload;
  end;

//Ext.data

type
  JIResultSet = class external(JExt.IBase)
    count: Float; // nullable
    loaded: Boolean; // nullable
    message: String; // nullable
    records: array of JExt.data.IModel; // nullable
    success: Boolean; // nullable
    total: Float; // nullable
    function getCount: Float;
    function getLoaded: Boolean;
    function getMessage: String;
    function getRecords: array of JExt.data.IModel;
    function getSuccess: Boolean;
    function getTotal: Float;
    procedure setCount; overload;
    procedure setCount(count: Float); overload;
    procedure setLoaded; overload;
    procedure setLoaded(loaded: Boolean); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
    procedure setRecords; overload;
    procedure setRecords(records: array of JExt.data.IModel); overload;
    procedure setSuccess; overload;
    procedure setSuccess(success: Boolean); overload;
    procedure setTotal; overload;
    procedure setTotal(total: Float); overload;
  end;

//Ext.data

type
  JSortTypes = class external 'SortTypes'
    self: JExt.IClass;
    stripTagsRE: JRegExp;
    function asDate: Float; overload;
    function asDate(value: Variant): Float; overload;
    function asFloat: Float; overload;
    function asFloat(value: Variant): Float; overload;
    function asInt: Float; overload;
    function asInt(value: Variant): Float; overload;
    function asText: String; overload;
    function asText(value: Variant): String; overload;
    function asUCString: String; overload;
    function asUCString(value: Variant): String; overload;
    function asUCText: String; overload;
    function asUCText(value: Variant): String; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function none: Variant; overload;
    function none(value: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JISortTypes = class external(JExt.IBase)
  end;

//Ext.data

type
  JIStore = class external(JExt.IEvented)
    autoLoad: Variant; // nullable
    autoSync: Boolean; // nullable
    buffered: Boolean; // nullable
    clearOnPageLoad: Boolean; // nullable
    data: Variant; // nullable
    destroyRemovedRecords: Boolean; // nullable
    fields: Variant; // nullable
    filters: array of Variant; // nullable
    getGroupString: Variant; // nullable
    groupDir: String; // nullable
    groupField: String; // nullable
    grouper: Variant; // nullable
    model: String; // nullable
    pageSize: Float; // nullable
    params: Variant; // nullable
    plugins: Variant; // nullable
    proxy: Variant; // nullable
    remoteFilter: Boolean; // nullable
    remoteGroup: Boolean; // nullable
    remoteSort: Boolean; // nullable
    sorters: array of Variant; // nullable
    storeId: String; // nullable
    syncRemovedRecords: Boolean; // nullable
    totalCount: Float; // nullable
    currentPage: Float; // nullable
    function add: array of JExt.data.IModel; overload;
    function add(model: Variant): array of JExt.data.IModel; overload;
    procedure addData; overload;
    procedure addData(data: array of Variant); overload;
    procedure applyData; overload;
    procedure applyData(data: Variant); overload;
    function average: Float; overload;
    function average(field: String): Float; overload;
    procedure clearFilter; overload;
    procedure clearFilter(suppressEvent: Boolean); overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure filter; overload;
    procedure filter(filters: Variant); overload;
    procedure filter(filters: Variant; value: String); overload;
    procedure filter(filters: Variant; value: String; anyMatch: Boolean); overload;
    procedure filter(filters: Variant; value: String; anyMatch: Boolean; caseSensitive: Boolean); overload;
    procedure filterBy; overload;
    procedure filterBy(fn: Variant); overload;
    procedure filterBy(fn: Variant; scope: Variant); overload;
    function find: Float; overload;
    function find(fieldName: String): Float; overload;
    function find(fieldName: String; value: Variant): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function find(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean; exactMatch: Boolean): Float; overload;
    function findBy: Float; overload;
    function findBy(fn: Variant): Float; overload;
    function findBy(fn: Variant; scope: Variant): Float; overload;
    function findBy(fn: Variant; scope: Variant; startIndex: Float): Float; overload;
    function findExact: Float; overload;
    function findExact(fieldName: String): Float; overload;
    function findExact(fieldName: String; value: Variant): Float; overload;
    function findExact(fieldName: String; value: Variant; startIndex: Float): Float; overload;
    function findRecord: JExt.data.IModel; overload;
    function findRecord(fieldName: String): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean): JExt.data.IModel; overload;
    function findRecord(fieldName: String; value: Variant; startIndex: Float; anyMatch: Boolean; caseSensitive: Boolean; exactMatch: Boolean): JExt.data.IModel; overload;
    function first: Variant;
    function getAllCount: Float;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoLoad: Variant;
    function getAutoSync: Boolean;
    function getBuffered: Boolean;
    function getById: Variant; overload;
    function getById(id: String): Variant; overload;
    function getClearOnPageLoad: Boolean;
    function getCount: Float;
    function getData: Variant;
    function getDestroyRemovedRecords: Boolean;
    function getFields: Variant;
    function getGetGroupString: Variant;
    function getGroupDir: String;
    function getGroupField: String;
    function getGrouper: Variant;
    function getGroups: Variant; overload;
    function getGroups(groupName: String): Variant; overload;
    function getModel: String;
    function getModelDefaults: Variant;
    function getNewRecords: array of JExt.data.IModel;
    function getPageSize: Float;
    function getParams: Variant;
    function getPlugins: Variant;
    function getProxy: Variant;
    function getRange: array of JExt.data.IModel; overload;
    function getRange(startIndex: Float): array of JExt.data.IModel; overload;
    function getRange(startIndex: Float; endIndex: Float): array of JExt.data.IModel; overload;
    function getRemoteFilter: Boolean;
    function getRemoteGroup: Boolean;
    function getRemoteSort: Boolean;
    function getRemovedRecords: array of JExt.data.IModel;
    function getStoreId: String;
    function getSyncRemovedRecords: Boolean;
    function getTotalCount: Float;
    function getUpdatedRecords: array of JExt.data.IModel;
    function indexOf: Float; overload;
    function indexOf(record: JExt.data.IModel): Float; overload;
    function indexOfId: Float; overload;
    function indexOfId(id: String): Float; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; records: array of JExt.data.IModel): Variant; overload;
    function isAutoLoading: Boolean;
    function isFiltered: Boolean;
    function isGrouped: Boolean;
    function isLoaded: Boolean;
    function isLoading: Boolean;
    function isSorted: Boolean;
    function last: Variant;
    function load: Variant; overload;
    function load(options: Variant): Variant; overload;
    function load(options: Variant; scope: Variant): Variant; overload;
    procedure loadData; overload;
    procedure loadData(data: Variant); overload;
    procedure loadData(data: Variant; append: Boolean); overload;
    procedure loadPage; overload;
    procedure loadPage(page: Float); overload;
    procedure loadPage(page: Float; options: Variant); overload;
    procedure loadPage(page: Float; options: Variant; scope: Variant); overload;
    function loadRecords: array of JExt.data.IModel; overload;
    function loadRecords(model: Variant): array of JExt.data.IModel; overload;
    function max: Variant; overload;
    function max(field: String): Variant; overload;
    function min: Variant; overload;
    function min(field: String): Variant; overload;
    procedure nextPage; overload;
    procedure nextPage(options: Variant); overload;
    procedure previousPage; overload;
    procedure previousPage(options: Variant); overload;
    function queryBy: JExt.util.IMixedCollection; overload;
    function queryBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function queryBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    procedure remove; overload;
    procedure remove(records: Variant); overload;
    procedure removeAll; overload;
    procedure removeAll(silent: Boolean); overload;
    procedure removeAt; overload;
    procedure removeAt(index: Float); overload;
    procedure setAutoLoad; overload;
    procedure setAutoLoad(autoLoad: Variant); overload;
    procedure setAutoSync; overload;
    procedure setAutoSync(autoSync: Boolean); overload;
    procedure setBuffered; overload;
    procedure setBuffered(buffered: Boolean); overload;
    procedure setClearOnPageLoad; overload;
    procedure setClearOnPageLoad(clearOnPageLoad: Boolean); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setDestroyRemovedRecords; overload;
    procedure setDestroyRemovedRecords(destroyRemovedRecords: Boolean); overload;
    function setFields: Variant; overload;
    function setFields(fields: Variant): Variant; overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setGetGroupString; overload;
    procedure setGetGroupString(getGroupString: Variant); overload;
    procedure setGroupDir; overload;
    procedure setGroupDir(groupDir: String); overload;
    procedure setGroupField; overload;
    procedure setGroupField(groupField: String); overload;
    procedure setGrouper; overload;
    procedure setGrouper(grouper: Variant); overload;
    procedure setModel; overload;
    procedure setModel(model: String); overload;
    procedure setModelDefaults; overload;
    procedure setModelDefaults(modelDefaults: Variant); overload;
    procedure setPageSize; overload;
    procedure setPageSize(pageSize: Float); overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
    procedure setPlugins; overload;
    procedure setPlugins(plugins: Variant); overload;
    procedure setProxy; overload;
    procedure setProxy(proxy: Variant); overload;
    procedure setRemoteFilter; overload;
    procedure setRemoteFilter(remoteFilter: Boolean); overload;
    procedure setRemoteGroup; overload;
    procedure setRemoteGroup(remoteGroup: Boolean); overload;
    procedure setRemoteSort; overload;
    procedure setRemoteSort(remoteSort: Boolean); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    procedure setStoreId; overload;
    procedure setStoreId(storeId: String); overload;
    procedure setSyncRemovedRecords; overload;
    procedure setSyncRemovedRecords(syncRemovedRecords: Boolean); overload;
    procedure setTotalCount; overload;
    procedure setTotalCount(totalCount: Float); overload;
    procedure sort; overload;
    procedure sort(sorters: Variant); overload;
    procedure sort(sorters: Variant; defaultDirection: String); overload;
    procedure sort(sorters: Variant; defaultDirection: String; where: String); overload;
    function sum: Float; overload;
    function sum(field: String): Float; overload;
    function sync: Variant; overload;
    function sync(options: Variant): Variant; overload;
  end;

//Ext.data

type
  JStoreManager = class external 'StoreManager'
    all: array of Variant;
    currentSortFn: Variant;
    dirtyFilterFn: Boolean;
    dirtySortFn: Boolean;
    filtered: Boolean;
    indices: Variant;
    items: array of Variant;
    keys: array of Variant;
    _length: Float;
    map: Variant;
    self: JExt.IClass;
    sorted: Boolean;
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; item: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(addItems: Variant); overload;
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: Variant): Variant; overload;
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    function clone: JExt.util.IMixedCollection;
    function contains: Boolean; overload;
    function contains(item: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    function filter: array of Variant; overload;
    function filter(&property: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant; caseSensitive: Variant): array of Variant; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getDefaultSortDirection: String;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    function indexOf: Float; overload;
    function indexOf(item: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; item: Variant): Variant; overload;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    function insertSorters: JExt.util.ICollection;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    procedure register(stores: JExt.data.IStore);
    function remove: Variant; overload;
    function remove(item: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    function removeFilters: JExt.util.ICollection; overload;
    function removeFilters(filters: Variant): JExt.util.ICollection; overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    function removeSorters: JExt.util.ICollection; overload;
    function removeSorters(sorters: Variant): JExt.util.ICollection; overload;
    function replace: Variant; overload;
    function replace(oldKey: String): Variant; overload;
    function replace(oldKey: String; item: Variant): Variant; overload;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(sorters: Variant): array of Variant; overload;
    function sort(sorters: Variant; defaultDirection: Variant): array of Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
  end;

  JIStoreManager = class external(JExt.util.ICollection)
  end;

//Ext

type
  JStoreMgr = class external 'StoreMgr'
    all: array of Variant;
    currentSortFn: Variant;
    dirtyFilterFn: Boolean;
    dirtySortFn: Boolean;
    filtered: Boolean;
    indices: Variant;
    items: array of Variant;
    keys: array of Variant;
    _length: Float;
    map: Variant;
    self: JExt.IClass;
    sorted: Boolean;
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; item: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(addItems: Variant); overload;
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: Variant): Variant; overload;
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    function clone: JExt.util.IMixedCollection;
    function contains: Boolean; overload;
    function contains(item: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    function filter: array of Variant; overload;
    function filter(&property: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant; caseSensitive: Variant): array of Variant; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getDefaultSortDirection: String;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    function indexOf: Float; overload;
    function indexOf(item: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; item: Variant): Variant; overload;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    function insertSorters: JExt.util.ICollection;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    procedure register(stores: JExt.data.IStore);
    function remove: Variant; overload;
    function remove(item: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    function removeFilters: JExt.util.ICollection; overload;
    function removeFilters(filters: Variant): JExt.util.ICollection; overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    function removeSorters: JExt.util.ICollection; overload;
    function removeSorters(sorters: Variant): JExt.util.ICollection; overload;
    function replace: Variant; overload;
    function replace(oldKey: String): Variant; overload;
    function replace(oldKey: String; item: Variant): Variant; overload;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(sorters: Variant): array of Variant; overload;
    function sort(sorters: Variant; defaultDirection: Variant): array of Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
  end;

  JIStoreMgr = class external(JExt.util.ICollection)
  end;

//Ext.data

type
  JStoreMgr = class external 'StoreMgr'
    all: array of Variant;
    currentSortFn: Variant;
    dirtyFilterFn: Boolean;
    dirtySortFn: Boolean;
    filtered: Boolean;
    indices: Variant;
    items: array of Variant;
    keys: array of Variant;
    _length: Float;
    map: Variant;
    self: JExt.IClass;
    sorted: Boolean;
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; item: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(addItems: Variant); overload;
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: Variant): Variant; overload;
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    function clone: JExt.util.IMixedCollection;
    function contains: Boolean; overload;
    function contains(item: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    function filter: array of Variant; overload;
    function filter(&property: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant; caseSensitive: Variant): array of Variant; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getDefaultSortDirection: String;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    function indexOf: Float; overload;
    function indexOf(item: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; item: Variant): Variant; overload;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    function insertSorters: JExt.util.ICollection;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    procedure register(stores: JExt.data.IStore);
    function remove: Variant; overload;
    function remove(item: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    function removeFilters: JExt.util.ICollection; overload;
    function removeFilters(filters: Variant): JExt.util.ICollection; overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    function removeSorters: JExt.util.ICollection; overload;
    function removeSorters(sorters: Variant): JExt.util.ICollection; overload;
    function replace: Variant; overload;
    function replace(oldKey: String): Variant; overload;
    function replace(oldKey: String; item: Variant): Variant; overload;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(sorters: Variant): array of Variant; overload;
    function sort(sorters: Variant; defaultDirection: Variant): array of Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
  end;

  JIStoreMgr = class external(JExt.util.ICollection)
  end;

//Ext

type
  JStoreManager = class external 'StoreManager'
    all: array of Variant;
    currentSortFn: Variant;
    dirtyFilterFn: Boolean;
    dirtySortFn: Boolean;
    filtered: Boolean;
    indices: Variant;
    items: array of Variant;
    keys: array of Variant;
    _length: Float;
    map: Variant;
    self: JExt.IClass;
    sorted: Boolean;
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; item: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(addItems: Variant); overload;
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: Variant): Variant; overload;
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clear;
    function clone: JExt.util.IMixedCollection;
    function contains: Boolean; overload;
    function contains(item: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    function filter: array of Variant; overload;
    function filter(&property: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant; caseSensitive: Variant): array of Variant; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getDefaultSortDirection: String;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getKey: Variant; overload;
    function getKey(o: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    function indexOf: Float; overload;
    function indexOf(item: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; item: Variant): Variant; overload;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    function insertSorters: JExt.util.ICollection;
    function last: Variant;
    function lookup: JExt.data.IStore; overload;
    function lookup(store: Variant): JExt.data.IStore; overload;
    procedure register(stores: JExt.data.IStore);
    function remove: Variant; overload;
    function remove(item: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    function removeFilters: JExt.util.ICollection; overload;
    function removeFilters(filters: Variant): JExt.util.ICollection; overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    function removeSorters: JExt.util.ICollection; overload;
    function removeSorters(sorters: Variant): JExt.util.ICollection; overload;
    function replace: Variant; overload;
    function replace(oldKey: String): Variant; overload;
    function replace(oldKey: String; item: Variant): Variant; overload;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(sorters: Variant): array of Variant; overload;
    function sort(sorters: Variant; defaultDirection: Variant): array of Variant; overload;
    function statics: JExt.IClass;
    procedure unregister; overload;
    procedure unregister(stores: Variant); overload;
  end;

  JIStoreManager = class external(JExt.util.ICollection)
  end;

//Ext.data

type
  JITreeStore = class external(JExt.data.INodeStore)
    clearOnLoad: Boolean; // nullable
    defaultRootId: String; // nullable
    defaultRootProperty: String; // nullable
    nodeParam: String; // nullable
    root: Variant; // nullable
    function getById: Variant; overload;
    function getById(id: Variant): Variant; overload;
    function getClearOnLoad: Boolean;
    function getDefaultRootId: String;
    function getDefaultRootProperty: String;
    function getNodeById: JExt.data.INodeInterface; overload;
    function getNodeById(id: Variant): JExt.data.INodeInterface; overload;
    function getNodeParam: String;
    function getRoot: Variant;
    function getRootNode: JExt.data.IModel; overload;
    function getRootNode(node: Variant): JExt.data.IModel; overload;
    function load: Variant; overload;
    function load(options: Variant): Variant; overload;
    procedure onProxyLoad; overload;
    procedure onProxyLoad(operation: Variant); overload;
    procedure removeAll; overload;
    procedure removeAll(silent: Boolean); overload;
    procedure setClearOnLoad; overload;
    procedure setClearOnLoad(clearOnLoad: Boolean); overload;
    procedure setDefaultRootId; overload;
    procedure setDefaultRootId(defaultRootId: String); overload;
    procedure setDefaultRootProperty; overload;
    procedure setDefaultRootProperty(defaultRootProperty: String); overload;
    procedure setNodeParam; overload;
    procedure setNodeParam(nodeParam: String); overload;
    procedure setRoot; overload;
    procedure setRoot(root: Variant); overload;
    function setRootNode: JExt.data.IModel; overload;
    function setRootNode(node: JExt.data.IModel): JExt.data.IModel; overload;
  end;

//Ext.data

type
  JTypes = class external 'Types'
    AUTO: Variant;
    BOOL: Variant;
    BOOLEAN: Variant;
    DATE: Variant;
    FLOAT: Variant;
    INT: Variant;
    INTEGER: Variant;
    NUMBER: Variant;
    &STRING: Variant;
    self: JExt.IClass;
    stripRe: JRegExp;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JITypes = class external(JExt.IBase)
  end;

//Ext.data

type
  JValidations = class external 'Validations'
    emailMessage: String;
    emailRe: JRegExp;
    exclusionMessage: String;
    formatMessage: String;
    inclusionMessage: String;
    lengthMessage: String;
    presenceMessage: String;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function email: Boolean; overload;
    function email(config: Variant): Boolean; overload;
    function email(config: Variant; email: String): Boolean; overload;
    function exclusion: Boolean; overload;
    function exclusion(config: Variant): Boolean; overload;
    function exclusion(config: Variant; value: String): Boolean; overload;
    function format: Boolean; overload;
    function format(config: Variant): Boolean; overload;
    function format(config: Variant; value: String): Boolean; overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getMessage: Variant; overload;
    function getMessage(&type: String): Variant; overload;
    function inclusion: Boolean; overload;
    function inclusion(config: Variant): Boolean; overload;
    function inclusion(config: Variant; value: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function length: Boolean; overload;
    function length(config: Variant): Boolean; overload;
    function length(config: Variant; value: String): Boolean; overload;
    function presence: Boolean; overload;
    function presence(config: Variant): Boolean; overload;
    function presence(config: Variant; value: Variant): Boolean; overload;
    function statics: JExt.IClass;
  end;

  JIValidations = class external(JExt.IBase)
  end;

//Ext.data.writer

type
  JIJson = class external(JExt.data.writer.IWriter)
    allowSingle: Boolean; // nullable
    encode: Boolean; // nullable
    root: String; // nullable
    rootProperty: String; // nullable
    function getAllowSingle: Boolean;
    function getEncode: Boolean;
    function getEncodeRequest: Boolean;
    function getRootProperty: String;
    procedure setAllowSingle; overload;
    procedure setAllowSingle(allowSingle: Boolean); overload;
    procedure setEncode; overload;
    procedure setEncode(encode: Boolean); overload;
    procedure setEncodeRequest; overload;
    procedure setEncodeRequest(encodeRequest: Boolean); overload;
    procedure setRootProperty; overload;
    procedure setRootProperty(rootProperty: String); overload;
  end;

//Ext.data

type
  JIJsonWriter = class external(JExt.data.writer.IWriter)
    allowSingle: Boolean; // nullable
    encode: Boolean; // nullable
    root: String; // nullable
    rootProperty: String; // nullable
    function getAllowSingle: Boolean;
    function getEncode: Boolean;
    function getEncodeRequest: Boolean;
    function getRootProperty: String;
    procedure setAllowSingle; overload;
    procedure setAllowSingle(allowSingle: Boolean); overload;
    procedure setEncode; overload;
    procedure setEncode(encode: Boolean); overload;
    procedure setEncodeRequest; overload;
    procedure setEncodeRequest(encodeRequest: Boolean); overload;
    procedure setRootProperty; overload;
    procedure setRootProperty(rootProperty: String); overload;
  end;

//Ext.data.writer

type
  JIWriter = class external(JExt.IBase)
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    function getNameProperty: String;
    function getRecordData: Variant; overload;
    function getRecordData(record: Variant): Variant; overload;
    function getWriteAllFields: Boolean;
    procedure setNameProperty; overload;
    procedure setNameProperty(nameProperty: String); overload;
    procedure setWriteAllFields; overload;
    procedure setWriteAllFields(writeAllFields: Boolean); overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data

type
  JIDataWriter = class external(JExt.IBase)
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    function getNameProperty: String;
    function getRecordData: Variant; overload;
    function getRecordData(record: Variant): Variant; overload;
    function getWriteAllFields: Boolean;
    procedure setNameProperty; overload;
    procedure setNameProperty(nameProperty: String); overload;
    procedure setWriteAllFields; overload;
    procedure setWriteAllFields(writeAllFields: Boolean); overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data

type
  JIWriter = class external(JExt.IBase)
    nameProperty: String; // nullable
    writeAllFields: Boolean; // nullable
    function getNameProperty: String;
    function getRecordData: Variant; overload;
    function getRecordData(record: Variant): Variant; overload;
    function getWriteAllFields: Boolean;
    procedure setNameProperty; overload;
    procedure setNameProperty(nameProperty: String); overload;
    procedure setWriteAllFields; overload;
    procedure setWriteAllFields(writeAllFields: Boolean); overload;
    function write: JExt.data.IRequest; overload;
    function write(request: JExt.data.IRequest): JExt.data.IRequest; overload;
  end;

//Ext.data.writer

type
  JIXml = class external(JExt.data.writer.IWriter)
    defaultDocumentRoot: String; // nullable
    documentRoot: String; // nullable
    header: String; // nullable
    record: String; // nullable
    function getDefaultDocumentRoot: String;
    function getDocumentRoot: String;
    function getHeader: String;
    function getRecord: String;
    procedure setDefaultDocumentRoot; overload;
    procedure setDefaultDocumentRoot(defaultDocumentRoot: String); overload;
    procedure setDocumentRoot; overload;
    procedure setDocumentRoot(documentRoot: String); overload;
    procedure setHeader; overload;
    procedure setHeader(header: String); overload;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
    function writeRecords: Variant; overload;
    function writeRecords(request: Variant): Variant; overload;
    function writeRecords(request: Variant; data: array of Variant): Variant; overload;
  end;

//Ext.data

type
  JIXmlWriter = class external(JExt.data.writer.IWriter)
    defaultDocumentRoot: String; // nullable
    documentRoot: String; // nullable
    header: String; // nullable
    record: String; // nullable
    function getDefaultDocumentRoot: String;
    function getDocumentRoot: String;
    function getHeader: String;
    function getRecord: String;
    procedure setDefaultDocumentRoot; overload;
    procedure setDefaultDocumentRoot(defaultDocumentRoot: String); overload;
    procedure setDocumentRoot; overload;
    procedure setDocumentRoot(documentRoot: String); overload;
    procedure setHeader; overload;
    procedure setHeader(header: String); overload;
    procedure setRecord; overload;
    procedure setRecord(record: String); overload;
    function writeRecords: Variant; overload;
    function writeRecords(request: Variant): Variant; overload;
    function writeRecords(request: Variant; data: array of Variant): Variant; overload;
  end;

//Ext.dataview.component

type
  JIContainer = class external(JExt.IContainer)
    procedure destroy;
  end;

//Ext.dataview.component

type
  JIDataItem = class external(JExt.IContainer)
    baseCls: String; // nullable
    dataMap: Variant; // nullable
    defaultType: String; // nullable
    itemCls: String; // nullable
    items: Variant; // nullable
    record: JExt.data.IModel; // nullable
    width: Variant; // nullable
    function getBaseCls: String;
    function getDataMap: Variant;
    function getDefaultType: String;
    function getItemCls: String;
    function getItems: array of Variant;
    function getRecord: JExt.data.IModel;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDataMap; overload;
    procedure setDataMap(dataMap: Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setItemCls; overload;
    procedure setItemCls(itemCls: String); overload;
    procedure setItems; overload;
    procedure setItems(items: array of Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setWidth; overload;
    procedure setWidth(width: String); overload;
  end;

//Ext.dataview.component

type
  JIListItem = class external(JExt.dataview.component.IDataItem)
    baseCls: String; // nullable
    dataMap: Variant; // nullable
    items: Variant; // nullable
    tpl: Variant; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getBody: Variant;
    function getDataMap: Variant;
    function getDisclosure: Variant;
    function getHeader: Variant;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBody; overload;
    procedure setBody(body: Variant); overload;
    procedure setDataMap; overload;
    procedure setDataMap(dataMap: Variant); overload;
    procedure setDisclosure; overload;
    procedure setDisclosure(disclosure: Variant); overload;
    procedure setHeader; overload;
    procedure setHeader(header: Variant); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setTpl; overload;
    procedure setTpl(tpl: Variant); overload;
  end;

//Ext.dataview.component

type
  JISimpleListItem = class external(JExt.IComponent)
    baseCls: String; // nullable
    record: JExt.data.IModel; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDisclosure: Variant;
    function getHeader: Variant;
    function getRecord: JExt.data.IModel;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDisclosure; overload;
    procedure setDisclosure(disclosure: Variant); overload;
    procedure setHeader; overload;
    procedure setHeader(header: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
  end;

//Ext.dataview

type
  JIDataView = class external(JExt.IContainer, JExt.mixin.ISelectable)
    baseCls: String; // nullable
    blockRefresh: Boolean; // nullable
    data: array of Variant; // nullable
    defaultType: String; // nullable
    deferEmptyText: Boolean; // nullable
    deselectOnContainerClick: Boolean; // nullable
    emptyText: String; // nullable
    inline: Variant; // nullable
    itemCls: String; // nullable
    itemConfig: Variant; // nullable
    itemSelector: Boolean; // nullable
    itemTpl: Variant; // nullable
    loadingText: Variant; // nullable
    maxItemCache: Float; // nullable
    multiSelect: Boolean; // nullable
    overItemCls: Boolean; // nullable
    pressedCls: String; // nullable
    pressedDelay: Float; // nullable
    scrollToTopOnRefresh: Boolean; // nullable
    scrollable: Variant; // nullable
    selectedCls: String; // nullable
    selectedItemCls: Boolean; // nullable
    simpleSelect: Boolean; // nullable
    singleSelect: Boolean; // nullable
    store: Variant; // nullable
    trackOver: Boolean; // nullable
    triggerCtEvent: String; // nullable
    triggerEvent: String; // nullable
    useComponents: Boolean; // nullable
    procedure bindStore;
    procedure clearSelections;
    procedure collectData;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    procedure deselectAll; overload;
    procedure deselectAll(supress: Variant); overload;
    procedure destroy;
    procedure doDeselect; overload;
    procedure doDeselect(records: Variant); overload;
    procedure doDeselect(records: Variant; suppressEvent: Boolean); overload;
    procedure doSelect; overload;
    procedure doSelect(records: Variant); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure findItemByChild;
    procedure findTargetByEvent;
    function getAllowDeselect: Boolean;
    function getBaseCls: String;
    function getCount: Float;
    function getData: array of Variant;
    function getDefaultType: String;
    function getDeferEmptyText: Boolean;
    function getDeselectOnContainerClick: Boolean;
    function getDisableSelection: Boolean;
    function getEmptyText: String;
    function getInline: Variant;
    function getItemAt: Variant; overload;
    function getItemAt(index: Float): Variant; overload;
    function getItemCls: String;
    function getItemConfig: Variant;
    function getItemIndex: Float; overload;
    function getItemIndex(item: Float): Float; overload;
    function getItemTpl: Variant;
    function getLastSelected: array of Variant;
    function getLoadingText: Variant;
    function getMaxItemCache: Float;
    function getMode: String;
    procedure getNode;
    procedure getNodes;
    function getPressedCls: String;
    function getPressedDelay: Float;
    procedure getRecords;
    function getScrollToTopOnRefresh: Boolean;
    function getScrollable: Boolean;
    function getSelectedCls: String;
    procedure getSelectedNodes;
    procedure getSelectedRecords;
    function getSelection: array of Variant;
    function getSelectionCount: Float;
    function getSelectionMode: String;
    function getStore: Variant;
    function getTriggerCtEvent: String;
    function getTriggerEvent: String;
    function getUseComponents: Boolean;
    function getViewItems: Variant;
    procedure handleException;
    function hasSelection: Boolean;
    procedure indexOf;
    procedure initialize;
    function isLocked: Boolean;
    function isSelected: Boolean; overload;
    function isSelected(record: Variant): Boolean; overload;
    function prepareData: Variant; overload;
    function prepareData(data: Variant): Variant; overload;
    function prepareData(data: Variant; index: Float): Variant; overload;
    function prepareData(data: Variant; index: Float; record: JExt.data.IModel): Variant; overload;
    procedure refresh;
    procedure refreshNode;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure selectAll; overload;
    procedure selectAll(silent: Boolean); overload;
    procedure selectRange; overload;
    procedure selectRange(startRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float; keepExisting: Boolean); overload;
    procedure setAllowDeselect; overload;
    procedure setAllowDeselect(allowDeselect: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setData; overload;
    procedure setData(data: array of Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDeferEmptyText; overload;
    procedure setDeferEmptyText(deferEmptyText: Boolean); overload;
    procedure setDeselectOnContainerClick; overload;
    procedure setDeselectOnContainerClick(deselectOnContainerClick: Boolean); overload;
    procedure setDisableSelection; overload;
    procedure setDisableSelection(disableSelection: Boolean); overload;
    procedure setEmptyText; overload;
    procedure setEmptyText(emptyText: String); overload;
    procedure setInline; overload;
    procedure setInline(inline: Variant); overload;
    procedure setItemCls; overload;
    procedure setItemCls(itemCls: String); overload;
    procedure setItemConfig; overload;
    procedure setItemConfig(itemConfig: Variant); overload;
    procedure setItemTpl; overload;
    procedure setItemTpl(itemTpl: Variant); overload;
    procedure setLastFocused;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: Variant); overload;
    procedure setMaxItemCache; overload;
    procedure setMaxItemCache(maxItemCache: Float); overload;
    procedure setMode; overload;
    procedure setMode(mode: String); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
    procedure setPressedDelay; overload;
    procedure setPressedDelay(pressedDelay: Float); overload;
    procedure setScrollToTopOnRefresh; overload;
    procedure setScrollToTopOnRefresh(scrollToTopOnRefresh: Boolean); overload;
    procedure setSelectedCls; overload;
    procedure setSelectedCls(selectedCls: String); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setTriggerCtEvent; overload;
    procedure setTriggerCtEvent(triggerCtEvent: String); overload;
    procedure setTriggerEvent; overload;
    procedure setTriggerEvent(triggerEvent: String); overload;
    procedure setUseComponents; overload;
    procedure setUseComponents(useComponents: Boolean); overload;
    procedure updateLastFocused; overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord); overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord; oldRecord: JExt.data.IRecord); overload;
  end;

//Ext

type
  JIDataView = class external(JExt.IContainer, JExt.mixin.ISelectable)
    baseCls: String; // nullable
    blockRefresh: Boolean; // nullable
    data: array of Variant; // nullable
    defaultType: String; // nullable
    deferEmptyText: Boolean; // nullable
    deselectOnContainerClick: Boolean; // nullable
    emptyText: String; // nullable
    inline: Variant; // nullable
    itemCls: String; // nullable
    itemConfig: Variant; // nullable
    itemSelector: Boolean; // nullable
    itemTpl: Variant; // nullable
    loadingText: Variant; // nullable
    maxItemCache: Float; // nullable
    multiSelect: Boolean; // nullable
    overItemCls: Boolean; // nullable
    pressedCls: String; // nullable
    pressedDelay: Float; // nullable
    scrollToTopOnRefresh: Boolean; // nullable
    scrollable: Variant; // nullable
    selectedCls: String; // nullable
    selectedItemCls: Boolean; // nullable
    simpleSelect: Boolean; // nullable
    singleSelect: Boolean; // nullable
    store: Variant; // nullable
    trackOver: Boolean; // nullable
    triggerCtEvent: String; // nullable
    triggerEvent: String; // nullable
    useComponents: Boolean; // nullable
    procedure bindStore;
    procedure clearSelections;
    procedure collectData;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    procedure deselectAll; overload;
    procedure deselectAll(supress: Variant); overload;
    procedure destroy;
    procedure doDeselect; overload;
    procedure doDeselect(records: Variant); overload;
    procedure doDeselect(records: Variant; suppressEvent: Boolean); overload;
    procedure doSelect; overload;
    procedure doSelect(records: Variant); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure findItemByChild;
    procedure findTargetByEvent;
    function getAllowDeselect: Boolean;
    function getBaseCls: String;
    function getCount: Float;
    function getData: array of Variant;
    function getDefaultType: String;
    function getDeferEmptyText: Boolean;
    function getDeselectOnContainerClick: Boolean;
    function getDisableSelection: Boolean;
    function getEmptyText: String;
    function getInline: Variant;
    function getItemAt: Variant; overload;
    function getItemAt(index: Float): Variant; overload;
    function getItemCls: String;
    function getItemConfig: Variant;
    function getItemIndex: Float; overload;
    function getItemIndex(item: Float): Float; overload;
    function getItemTpl: Variant;
    function getLastSelected: array of Variant;
    function getLoadingText: Variant;
    function getMaxItemCache: Float;
    function getMode: String;
    procedure getNode;
    procedure getNodes;
    function getPressedCls: String;
    function getPressedDelay: Float;
    procedure getRecords;
    function getScrollToTopOnRefresh: Boolean;
    function getScrollable: Boolean;
    function getSelectedCls: String;
    procedure getSelectedNodes;
    procedure getSelectedRecords;
    function getSelection: array of Variant;
    function getSelectionCount: Float;
    function getSelectionMode: String;
    function getStore: Variant;
    function getTriggerCtEvent: String;
    function getTriggerEvent: String;
    function getUseComponents: Boolean;
    function getViewItems: Variant;
    procedure handleException;
    function hasSelection: Boolean;
    procedure indexOf;
    procedure initialize;
    function isLocked: Boolean;
    function isSelected: Boolean; overload;
    function isSelected(record: Variant): Boolean; overload;
    function prepareData: Variant; overload;
    function prepareData(data: Variant): Variant; overload;
    function prepareData(data: Variant; index: Float): Variant; overload;
    function prepareData(data: Variant; index: Float; record: JExt.data.IModel): Variant; overload;
    procedure refresh;
    procedure refreshNode;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure selectAll; overload;
    procedure selectAll(silent: Boolean); overload;
    procedure selectRange; overload;
    procedure selectRange(startRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float; keepExisting: Boolean); overload;
    procedure setAllowDeselect; overload;
    procedure setAllowDeselect(allowDeselect: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setData; overload;
    procedure setData(data: array of Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDeferEmptyText; overload;
    procedure setDeferEmptyText(deferEmptyText: Boolean); overload;
    procedure setDeselectOnContainerClick; overload;
    procedure setDeselectOnContainerClick(deselectOnContainerClick: Boolean); overload;
    procedure setDisableSelection; overload;
    procedure setDisableSelection(disableSelection: Boolean); overload;
    procedure setEmptyText; overload;
    procedure setEmptyText(emptyText: String); overload;
    procedure setInline; overload;
    procedure setInline(inline: Variant); overload;
    procedure setItemCls; overload;
    procedure setItemCls(itemCls: String); overload;
    procedure setItemConfig; overload;
    procedure setItemConfig(itemConfig: Variant); overload;
    procedure setItemTpl; overload;
    procedure setItemTpl(itemTpl: Variant); overload;
    procedure setLastFocused;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: Variant); overload;
    procedure setMaxItemCache; overload;
    procedure setMaxItemCache(maxItemCache: Float); overload;
    procedure setMode; overload;
    procedure setMode(mode: String); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
    procedure setPressedDelay; overload;
    procedure setPressedDelay(pressedDelay: Float); overload;
    procedure setScrollToTopOnRefresh; overload;
    procedure setScrollToTopOnRefresh(scrollToTopOnRefresh: Boolean); overload;
    procedure setSelectedCls; overload;
    procedure setSelectedCls(selectedCls: String); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setTriggerCtEvent; overload;
    procedure setTriggerCtEvent(triggerCtEvent: String); overload;
    procedure setTriggerEvent; overload;
    procedure setTriggerEvent(triggerEvent: String); overload;
    procedure setUseComponents; overload;
    procedure setUseComponents(useComponents: Boolean); overload;
    procedure updateLastFocused; overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord); overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord; oldRecord: JExt.data.IRecord); overload;
  end;

//Ext.dataview.element

type
  JIContainer = class external(JExt.IComponent)
    procedure destroy;
  end;

//Ext.dataview.element

type
  JIList = class external(JExt.dataview.element.IContainer)
    procedure destroy;
  end;

//Ext.dataview

type
  JIIndexBar = class external(JExt.IComponent)
    alphabet: Boolean; // nullable
    baseCls: String; // nullable
    direction: String; // nullable
    itemSelector: Boolean; // nullable
    letters: array of Variant; // nullable
    listPrefix: String; // nullable
    store: Boolean; // nullable
    ui: String; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDirection: String;
    function getLetters: array of Variant;
    function getListPrefix: String;
    function getUi: String;
    procedure isHorizontal;
    procedure isVertical;
    procedure refresh;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setLetters; overload;
    procedure setLetters(letters: array of Variant); overload;
    procedure setListPrefix; overload;
    procedure setListPrefix(listPrefix: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext

type
  JIIndexBar = class external(JExt.IComponent)
    alphabet: Boolean; // nullable
    baseCls: String; // nullable
    direction: String; // nullable
    itemSelector: Boolean; // nullable
    letters: array of Variant; // nullable
    listPrefix: String; // nullable
    store: Boolean; // nullable
    ui: String; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDirection: String;
    function getLetters: array of Variant;
    function getListPrefix: String;
    function getUi: String;
    procedure isHorizontal;
    procedure isVertical;
    procedure refresh;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setLetters; overload;
    procedure setLetters(letters: array of Variant); overload;
    procedure setListPrefix; overload;
    procedure setListPrefix(listPrefix: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.dataview

type
  JIList = class external(JExt.dataview.IDataView, JExt.mixin.IBindable)
    baseCls: String; // nullable
    defaultType: String; // nullable
    disclosureProperty: String; // nullable
    grouped: Boolean; // nullable
    indexBar: Variant; // nullable
    infinite: Boolean; // nullable
    itemHeight: Float; // nullable
    onItemDisclosure: Variant; // nullable
    pinHeaders: Boolean; // nullable
    preventSelectionOnDisclose: Boolean; // nullable
    refreshHeightOnUpdate: Boolean; // nullable
    striped: Boolean; // nullable
    ui: String; // nullable
    useSimpleItems: Boolean; // nullable
    variableHeights: Boolean; // nullable
    bufferSize: Float; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDefaultType: String;
    function getDisclosureProperty: String;
    function getGrouped: Boolean;
    function getIcon: Variant;
    function getIndexBar: Variant;
    function getInfinite: Boolean;
    function getItemAt: Variant; overload;
    function getItemAt(index: Float): Variant; overload;
    function getItemHeight: Float;
    function getItemIndex: Float; overload;
    function getItemIndex(item: Float): Float; overload;
    function getMinimumBufferDistance: Float;
    function getOnItemDisclosure: Variant;
    function getPinHeaders: Boolean;
    function getPreventSelectionOnDisclose: Boolean;
    function getRefreshHeightOnUpdate: Boolean;
    function getScrollDockedItems: array of Variant;
    function getStriped: Boolean;
    function getUi: String;
    function getUseHeaders: Boolean;
    function getUseSimpleItems: Boolean;
    function getVariableHeights: Boolean;
    function getViewItems: Variant;
    procedure initialize;
    procedure scrollToRecord; overload;
    procedure scrollToRecord(record: Variant); overload;
    procedure scrollToRecord(record: Variant; animate: Variant); overload;
    procedure scrollToRecord(record: Variant; animate: Variant; overscroll: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDisclosureProperty; overload;
    procedure setDisclosureProperty(disclosureProperty: String); overload;
    procedure setGrouped; overload;
    procedure setGrouped(grouped: Boolean); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: Variant); overload;
    procedure setIndexBar; overload;
    procedure setIndexBar(indexBar: Variant); overload;
    procedure setInfinite; overload;
    procedure setInfinite(infinite: Boolean); overload;
    procedure setItemHeight; overload;
    procedure setItemHeight(itemHeight: Float); overload;
    procedure setMinimumBufferDistance; overload;
    procedure setMinimumBufferDistance(minimumBufferDistance: Float); overload;
    procedure setOnItemDisclosure; overload;
    procedure setOnItemDisclosure(onItemDisclosure: Variant); overload;
    procedure setPinHeaders; overload;
    procedure setPinHeaders(pinHeaders: Boolean); overload;
    procedure setPreventSelectionOnDisclose; overload;
    procedure setPreventSelectionOnDisclose(preventSelectionOnDisclose: Boolean); overload;
    procedure setRefreshHeightOnUpdate; overload;
    procedure setRefreshHeightOnUpdate(refreshHeightOnUpdate: Boolean); overload;
    procedure setStriped; overload;
    procedure setStriped(striped: Boolean); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setUseHeaders; overload;
    procedure setUseHeaders(useHeaders: Boolean); overload;
    procedure setUseSimpleItems; overload;
    procedure setUseSimpleItems(useSimpleItems: Boolean); overload;
    procedure setVariableHeights; overload;
    procedure setVariableHeights(variableHeights: Boolean); overload;
  end;

//Ext

type
  JIList = class external(JExt.dataview.IDataView, JExt.mixin.IBindable)
    baseCls: String; // nullable
    defaultType: String; // nullable
    disclosureProperty: String; // nullable
    grouped: Boolean; // nullable
    indexBar: Variant; // nullable
    infinite: Boolean; // nullable
    itemHeight: Float; // nullable
    onItemDisclosure: Variant; // nullable
    pinHeaders: Boolean; // nullable
    preventSelectionOnDisclose: Boolean; // nullable
    refreshHeightOnUpdate: Boolean; // nullable
    striped: Boolean; // nullable
    ui: String; // nullable
    useSimpleItems: Boolean; // nullable
    variableHeights: Boolean; // nullable
    bufferSize: Float; // nullable
    procedure destroy;
    function getBaseCls: String;
    function getDefaultType: String;
    function getDisclosureProperty: String;
    function getGrouped: Boolean;
    function getIcon: Variant;
    function getIndexBar: Variant;
    function getInfinite: Boolean;
    function getItemAt: Variant; overload;
    function getItemAt(index: Float): Variant; overload;
    function getItemHeight: Float;
    function getItemIndex: Float; overload;
    function getItemIndex(item: Float): Float; overload;
    function getMinimumBufferDistance: Float;
    function getOnItemDisclosure: Variant;
    function getPinHeaders: Boolean;
    function getPreventSelectionOnDisclose: Boolean;
    function getRefreshHeightOnUpdate: Boolean;
    function getScrollDockedItems: array of Variant;
    function getStriped: Boolean;
    function getUi: String;
    function getUseHeaders: Boolean;
    function getUseSimpleItems: Boolean;
    function getVariableHeights: Boolean;
    function getViewItems: Variant;
    procedure initialize;
    procedure scrollToRecord; overload;
    procedure scrollToRecord(record: Variant); overload;
    procedure scrollToRecord(record: Variant; animate: Variant); overload;
    procedure scrollToRecord(record: Variant; animate: Variant; overscroll: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDisclosureProperty; overload;
    procedure setDisclosureProperty(disclosureProperty: String); overload;
    procedure setGrouped; overload;
    procedure setGrouped(grouped: Boolean); overload;
    procedure setIcon; overload;
    procedure setIcon(icon: Variant); overload;
    procedure setIndexBar; overload;
    procedure setIndexBar(indexBar: Variant); overload;
    procedure setInfinite; overload;
    procedure setInfinite(infinite: Boolean); overload;
    procedure setItemHeight; overload;
    procedure setItemHeight(itemHeight: Float); overload;
    procedure setMinimumBufferDistance; overload;
    procedure setMinimumBufferDistance(minimumBufferDistance: Float); overload;
    procedure setOnItemDisclosure; overload;
    procedure setOnItemDisclosure(onItemDisclosure: Variant); overload;
    procedure setPinHeaders; overload;
    procedure setPinHeaders(pinHeaders: Boolean); overload;
    procedure setPreventSelectionOnDisclose; overload;
    procedure setPreventSelectionOnDisclose(preventSelectionOnDisclose: Boolean); overload;
    procedure setRefreshHeightOnUpdate; overload;
    procedure setRefreshHeightOnUpdate(refreshHeightOnUpdate: Boolean); overload;
    procedure setStriped; overload;
    procedure setStriped(striped: Boolean); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setUseHeaders; overload;
    procedure setUseHeaders(useHeaders: Boolean); overload;
    procedure setUseSimpleItems; overload;
    procedure setUseSimpleItems(useSimpleItems: Boolean); overload;
    procedure setVariableHeights; overload;
    procedure setVariableHeights(variableHeights: Boolean); overload;
  end;

//Ext.dataview

type
  JIListItemHeader = class external(JExt.IComponent)
    baseCls: String; // nullable
    function getBaseCls: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
  end;

//Ext.dataview

type
  JINestedList = class external(JExt.IContainer)
    allowDeselect: Boolean; // nullable
    backButton: Variant; // nullable
    backText: String; // nullable
    baseCls: String; // nullable
    cardSwitchAnimation: Variant; // nullable
    clearSelectionDelay: Float; // nullable
    detailCard: JExt.IComponent; // nullable
    detailContainer: JExt.IContainer; // nullable
    displayField: String; // nullable
    emptyText: String; // nullable
    itemHeight: Float; // nullable
    listConfig: Variant; // nullable
    loadingText: String; // nullable
    onItemDisclosure: Variant; // nullable
    store: Variant; // nullable
    title: String; // nullable
    toolbar: Variant; // nullable
    ui: String; // nullable
    updateTitleText: Boolean; // nullable
    useSimpleItems: Boolean; // nullable
    useTitleAsBackText: Boolean; // nullable
    useToolbar: Boolean; // nullable
    variableHeights: Boolean; // nullable
    function getAllowDeselect: Boolean;
    function getBackButton: Variant;
    function getBackText: String;
    function getBaseCls: String;
    function getClearSelectionOnListChange: Boolean;
    function getDetailCard: JExt.IComponent;
    function getDetailContainer: JExt.IContainer;
    function getDisplayField: String;
    function getEmptyText: String;
    function getItemHeight: Float;
    function getItemTextTpl: String; overload;
    function getItemTextTpl(node: JExt.data.IRecord): String; overload;
    function getListConfig: Variant;
    function getLoadingText: String;
    function getOnItemDisclosure: Variant;
    function getStore: Variant;
    procedure getSubList;
    function getTitle: String;
    function getTitleTextTpl: String; overload;
    function getTitleTextTpl(node: JExt.data.IRecord): String; overload;
    function getToolbar: Variant;
    function getUpdateTitleText: Boolean;
    function getUseSimpleItems: Boolean;
    function getUseTitleAsBackText: Boolean;
    function getUseToolbar: Boolean;
    function getVariableHeights: Boolean;
    procedure goToLeaf; overload;
    procedure goToLeaf(node: JExt.data.INodeInterface); overload;
    procedure goToNode; overload;
    procedure goToNode(node: JExt.data.INodeInterface); overload;
    procedure onBackTap;
    procedure onItemTap; overload;
    procedure onItemTap(list: JExt.IList); overload;
    procedure onItemTap(list: JExt.IList; index: Float); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement; record: JExt.data.IRecord); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement; record: JExt.data.IRecord; e: JExt.event.IEvent); overload;
    procedure setAllowDeselect; overload;
    procedure setAllowDeselect(allowDeselect: Boolean); overload;
    procedure setBackButton; overload;
    procedure setBackButton(backButton: Variant); overload;
    procedure setBackText; overload;
    procedure setBackText(backText: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setClearSelectionOnListChange; overload;
    procedure setClearSelectionOnListChange(clearSelectionOnListChange: Boolean); overload;
    procedure setDetailCard; overload;
    procedure setDetailCard(detailCard: JExt.IComponent); overload;
    procedure setDetailContainer; overload;
    procedure setDetailContainer(detailContainer: JExt.IContainer); overload;
    procedure setDisplayField; overload;
    procedure setDisplayField(displayField: String); overload;
    procedure setEmptyText; overload;
    procedure setEmptyText(emptyText: String); overload;
    procedure setItemHeight; overload;
    procedure setItemHeight(itemHeight: Float); overload;
    procedure setListConfig; overload;
    procedure setListConfig(listConfig: Variant); overload;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: String); overload;
    procedure setOnItemDisclosure; overload;
    procedure setOnItemDisclosure(onItemDisclosure: Variant); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setToolbar; overload;
    procedure setToolbar(toolbar: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: Variant); overload;
    procedure setUpdateTitleText; overload;
    procedure setUpdateTitleText(updateTitleText: Boolean); overload;
    procedure setUseSimpleItems; overload;
    procedure setUseSimpleItems(useSimpleItems: Boolean); overload;
    procedure setUseTitleAsBackText; overload;
    procedure setUseTitleAsBackText(useTitleAsBackText: Boolean); overload;
    procedure setUseToolbar; overload;
    procedure setUseToolbar(useToolbar: Boolean); overload;
    procedure setVariableHeights; overload;
    procedure setVariableHeights(variableHeights: Boolean); overload;
  end;

//Ext

type
  JINestedList = class external(JExt.IContainer)
    allowDeselect: Boolean; // nullable
    backButton: Variant; // nullable
    backText: String; // nullable
    baseCls: String; // nullable
    cardSwitchAnimation: Variant; // nullable
    clearSelectionDelay: Float; // nullable
    detailCard: JExt.IComponent; // nullable
    detailContainer: JExt.IContainer; // nullable
    displayField: String; // nullable
    emptyText: String; // nullable
    itemHeight: Float; // nullable
    listConfig: Variant; // nullable
    loadingText: String; // nullable
    onItemDisclosure: Variant; // nullable
    store: Variant; // nullable
    title: String; // nullable
    toolbar: Variant; // nullable
    ui: String; // nullable
    updateTitleText: Boolean; // nullable
    useSimpleItems: Boolean; // nullable
    useTitleAsBackText: Boolean; // nullable
    useToolbar: Boolean; // nullable
    variableHeights: Boolean; // nullable
    function getAllowDeselect: Boolean;
    function getBackButton: Variant;
    function getBackText: String;
    function getBaseCls: String;
    function getClearSelectionOnListChange: Boolean;
    function getDetailCard: JExt.IComponent;
    function getDetailContainer: JExt.IContainer;
    function getDisplayField: String;
    function getEmptyText: String;
    function getItemHeight: Float;
    function getItemTextTpl: String; overload;
    function getItemTextTpl(node: JExt.data.IRecord): String; overload;
    function getListConfig: Variant;
    function getLoadingText: String;
    function getOnItemDisclosure: Variant;
    function getStore: Variant;
    procedure getSubList;
    function getTitle: String;
    function getTitleTextTpl: String; overload;
    function getTitleTextTpl(node: JExt.data.IRecord): String; overload;
    function getToolbar: Variant;
    function getUpdateTitleText: Boolean;
    function getUseSimpleItems: Boolean;
    function getUseTitleAsBackText: Boolean;
    function getUseToolbar: Boolean;
    function getVariableHeights: Boolean;
    procedure goToLeaf; overload;
    procedure goToLeaf(node: JExt.data.INodeInterface); overload;
    procedure goToNode; overload;
    procedure goToNode(node: JExt.data.INodeInterface); overload;
    procedure onBackTap;
    procedure onItemTap; overload;
    procedure onItemTap(list: JExt.IList); overload;
    procedure onItemTap(list: JExt.IList; index: Float); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement; record: JExt.data.IRecord); overload;
    procedure onItemTap(list: JExt.IList; index: Float; target: JExt.IElement; record: JExt.data.IRecord; e: JExt.event.IEvent); overload;
    procedure setAllowDeselect; overload;
    procedure setAllowDeselect(allowDeselect: Boolean); overload;
    procedure setBackButton; overload;
    procedure setBackButton(backButton: Variant); overload;
    procedure setBackText; overload;
    procedure setBackText(backText: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setClearSelectionOnListChange; overload;
    procedure setClearSelectionOnListChange(clearSelectionOnListChange: Boolean); overload;
    procedure setDetailCard; overload;
    procedure setDetailCard(detailCard: JExt.IComponent); overload;
    procedure setDetailContainer; overload;
    procedure setDetailContainer(detailContainer: JExt.IContainer); overload;
    procedure setDisplayField; overload;
    procedure setDisplayField(displayField: String); overload;
    procedure setEmptyText; overload;
    procedure setEmptyText(emptyText: String); overload;
    procedure setItemHeight; overload;
    procedure setItemHeight(itemHeight: Float); overload;
    procedure setListConfig; overload;
    procedure setListConfig(listConfig: Variant); overload;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: String); overload;
    procedure setOnItemDisclosure; overload;
    procedure setOnItemDisclosure(onItemDisclosure: Variant); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setToolbar; overload;
    procedure setToolbar(toolbar: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: Variant); overload;
    procedure setUpdateTitleText; overload;
    procedure setUpdateTitleText(updateTitleText: Boolean); overload;
    procedure setUseSimpleItems; overload;
    procedure setUseSimpleItems(useSimpleItems: Boolean); overload;
    procedure setUseTitleAsBackText; overload;
    procedure setUseTitleAsBackText(useTitleAsBackText: Boolean); overload;
    procedure setUseToolbar; overload;
    procedure setUseToolbar(useToolbar: Boolean); overload;
    procedure setVariableHeights; overload;
    procedure setVariableHeights(variableHeights: Boolean); overload;
  end;

//Ext

type
  JDate = class external 'Date'
    DAY: String;
    HOUR: String;
    MILLI: String;
    MINUTE: String;
    MONTH: String;
    SECOND: String;
    YEAR: String;
    dayNames: array of Variant;
    defaultFormat: String;
    defaults: Variant;
    formatCodes: Variant;
    formatFunctions: Variant;
    monthNames: array of Variant;
    monthNumbers: Variant;
    parseFunctions: Variant;
    useStrict: Boolean;
    function add: Variant; overload;
    function add(date: Variant): Variant; overload;
    function add(date: Variant; interval: String): Variant; overload;
    function add(date: Variant; interval: String; value: Float): Variant; overload;
    function align: Variant; overload;
    function align(date: Variant): Variant; overload;
    function align(date: Variant; unit: String): Variant; overload;
    function between: Boolean; overload;
    function between(date: Variant): Boolean; overload;
    function between(date: Variant; start: Variant): Boolean; overload;
    function between(date: Variant; start: Variant; &end: Variant): Boolean; overload;
    function clearTime: Variant; overload;
    function clearTime(date: Variant): Variant; overload;
    function clearTime(date: Variant; clone: Boolean): Variant; overload;
    function clone: Variant; overload;
    function clone(date: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: String): Float; overload;
    function format: String; overload;
    function format(date: Variant): String; overload;
    function format(date: Variant; format: String): String; overload;
    function getDayOfYear: Float; overload;
    function getDayOfYear(date: Variant): Float; overload;
    function getDaysInMonth: Float; overload;
    function getDaysInMonth(date: Variant): Float; overload;
    function getElapsed: Float; overload;
    function getElapsed(dateA: Variant): Float; overload;
    function getElapsed(dateA: Variant; dateB: Variant): Float; overload;
    function getFirstDateOfMonth: Variant; overload;
    function getFirstDateOfMonth(date: Variant): Variant; overload;
    function getFirstDayOfMonth: Float; overload;
    function getFirstDayOfMonth(date: Variant): Float; overload;
    function getGMTOffset: String; overload;
    function getGMTOffset(date: Variant): String; overload;
    function getGMTOffset(date: Variant; colon: Boolean): String; overload;
    function getLastDateOfMonth: Variant; overload;
    function getLastDateOfMonth(date: Variant): Variant; overload;
    function getLastDayOfMonth: Float; overload;
    function getLastDayOfMonth(date: Variant): Float; overload;
    function getMonthNumber: Float; overload;
    function getMonthNumber(name: String): Float; overload;
    function getShortDayName: String; overload;
    function getShortDayName(day: Float): String; overload;
    function getShortMonthName: String; overload;
    function getShortMonthName(month: Float): String; overload;
    function getSuffix: String; overload;
    function getSuffix(date: Variant): String; overload;
    function getTimezone: String; overload;
    function getTimezone(date: Variant): String; overload;
    function getWeekOfYear: Float; overload;
    function getWeekOfYear(date: Variant): Float; overload;
    function isDST: Boolean; overload;
    function isDST(date: Variant): Boolean; overload;
    function isLeapYear: Boolean; overload;
    function isLeapYear(date: Variant): Boolean; overload;
    function isValid: Boolean; overload;
    function isValid(year: Float): Boolean; overload;
    function isValid(year: Float; month: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float; millisecond: Float): Boolean; overload;
    function now: Float;
    function parse: Variant; overload;
    function parse(input: Variant): Variant; overload;
    function parse(input: Variant; format: String): Variant; overload;
    function parse(input: Variant; format: String; strict: Boolean): Variant; overload;
  end;

  JIDate = class external(JExt.IDateExtras)
  end;

//Ext

type
  JDateExtras = class external 'DateExtras'
    DAY: String;
    HOUR: String;
    MILLI: String;
    MINUTE: String;
    MONTH: String;
    SECOND: String;
    YEAR: String;
    dayNames: array of Variant;
    defaultFormat: String;
    defaults: Variant;
    formatCodes: Variant;
    formatFunctions: Variant;
    monthNames: array of Variant;
    monthNumbers: Variant;
    parseFunctions: Variant;
    useStrict: Boolean;
    function add: Variant; overload;
    function add(date: Variant): Variant; overload;
    function add(date: Variant; interval: String): Variant; overload;
    function add(date: Variant; interval: String; value: Float): Variant; overload;
    function align: Variant; overload;
    function align(date: Variant): Variant; overload;
    function align(date: Variant; unit: String): Variant; overload;
    function between: Boolean; overload;
    function between(date: Variant): Boolean; overload;
    function between(date: Variant; start: Variant): Boolean; overload;
    function between(date: Variant; start: Variant; &end: Variant): Boolean; overload;
    function clearTime: Variant; overload;
    function clearTime(date: Variant): Variant; overload;
    function clearTime(date: Variant; clone: Boolean): Variant; overload;
    function clone: Variant; overload;
    function clone(date: Variant): Variant; overload;
    function diff: Float; overload;
    function diff(min: Variant): Float; overload;
    function diff(min: Variant; max: Variant): Float; overload;
    function diff(min: Variant; max: Variant; unit: String): Float; overload;
    function format: String; overload;
    function format(date: Variant): String; overload;
    function format(date: Variant; format: String): String; overload;
    function getDayOfYear: Float; overload;
    function getDayOfYear(date: Variant): Float; overload;
    function getDaysInMonth: Float; overload;
    function getDaysInMonth(date: Variant): Float; overload;
    function getElapsed: Float; overload;
    function getElapsed(dateA: Variant): Float; overload;
    function getElapsed(dateA: Variant; dateB: Variant): Float; overload;
    function getFirstDateOfMonth: Variant; overload;
    function getFirstDateOfMonth(date: Variant): Variant; overload;
    function getFirstDayOfMonth: Float; overload;
    function getFirstDayOfMonth(date: Variant): Float; overload;
    function getGMTOffset: String; overload;
    function getGMTOffset(date: Variant): String; overload;
    function getGMTOffset(date: Variant; colon: Boolean): String; overload;
    function getLastDateOfMonth: Variant; overload;
    function getLastDateOfMonth(date: Variant): Variant; overload;
    function getLastDayOfMonth: Float; overload;
    function getLastDayOfMonth(date: Variant): Float; overload;
    function getMonthNumber: Float; overload;
    function getMonthNumber(name: String): Float; overload;
    function getShortDayName: String; overload;
    function getShortDayName(day: Float): String; overload;
    function getShortMonthName: String; overload;
    function getShortMonthName(month: Float): String; overload;
    function getSuffix: String; overload;
    function getSuffix(date: Variant): String; overload;
    function getTimezone: String; overload;
    function getTimezone(date: Variant): String; overload;
    function getWeekOfYear: Float; overload;
    function getWeekOfYear(date: Variant): Float; overload;
    function isDST: Boolean; overload;
    function isDST(date: Variant): Boolean; overload;
    function isLeapYear: Boolean; overload;
    function isLeapYear(date: Variant): Boolean; overload;
    function isValid: Boolean; overload;
    function isValid(year: Float): Boolean; overload;
    function isValid(year: Float; month: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float): Boolean; overload;
    function isValid(year: Float; month: Float; day: Float; hour: Float; minute: Float; second: Float; millisecond: Float): Boolean; overload;
    function now: Float;
    function parse: Variant; overload;
    function parse(input: Variant): Variant; overload;
    function parse(input: Variant; format: String): Variant; overload;
    function parse(input: Variant; format: String; strict: Boolean): Variant; overload;
  end;

  JIDateExtras = class external
  end;

//Ext

type
  JIDecorator = class external(JExt.IComponent)
    component: Variant; // nullable
    procedure destroy;
    function getComponent: Variant;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.device.accelerometer

type
  JIAbstract = class external(JExt.IBase)
    frequency: Float; // nullable
    function getFrequency: Float;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
  end;

//Ext.device.accelerometer

type
  JICordova = class external(JExt.device.accelerometer.IAbstract)
  end;

//Ext.device.accelerometer

type
  JIPhoneGap = class external(JExt.device.accelerometer.IAbstract)
  end;

//Ext.device

type
  JAccelerometer = class external 'Accelerometer'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getFrequency: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
    function statics: JExt.IClass;
  end;

  JIAccelerometer = class external(JExt.IBase, JExt.device.accelerometer.IAbstract)
  end;

//Ext.device.accelerometer

type
  JISimulator = class external(JExt.device.accelerometer.IAbstract)
  end;

//Ext.device.browser

type
  JIAbstract = class external(JExt.IBase)
    procedure close;
    procedure open; overload;
    procedure open(options: Variant); overload;
  end;

//Ext.device.browser

type
  JICordova = class external(JExt.device.browser.IAbstract)
    procedure close;
    procedure open; overload;
    procedure open(config: Variant); overload;
  end;

//Ext.device

type
  JBrowser = class external 'Browser'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure close;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure open; overload;
    procedure open(options: Variant); overload;
    function statics: JExt.IClass;
  end;

  JIBrowser = class external(JExt.IBase, JExt.device.browser.IAbstract)
  end;

//Ext.device.browser

type
  JISimulator = class external(JExt.IBase)
  end;

//Ext.device.browser

type
  JIWindow = class external(JExt.IEvented)
  end;

//Ext.device.camera

type
  JIAbstract = class external(JExt.IBase)
    procedure capture; overload;
    procedure capture(options: Variant); overload;
    procedure capture(options: Variant; scope: Variant); overload;
    procedure capture(options: Variant; scope: Variant; destination: String); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String; width: Float); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String; width: Float; height: Float); overload;
  end;

//Ext.device.camera

type
  JICordova = class external(JExt.device.camera.IAbstract)
    procedure capture; overload;
    procedure capture(args: Variant); overload;
  end;

//Ext.device.camera

type
  JIPhoneGap = class external(JExt.device.camera.IAbstract)
    procedure capture; overload;
    procedure capture(args: Variant); overload;
  end;

//Ext.device

type
  JCamera = class external 'Camera'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure capture; overload;
    procedure capture(options: Variant); overload;
    procedure capture(options: Variant; scope: Variant); overload;
    procedure capture(options: Variant; scope: Variant; destination: String); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String; width: Float); overload;
    procedure capture(options: Variant; scope: Variant; destination: String; encoding: String; width: Float; height: Float); overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JICamera = class external(JExt.IBase, JExt.device.camera.IAbstract)
  end;

//Ext.device.camera

type
  JISencha = class external(JExt.device.camera.IAbstract)
    procedure capture; overload;
    procedure capture(options: Variant); overload;
  end;

//Ext.device.camera

type
  JISimulator = class external(JExt.device.camera.IAbstract)
    procedure capture; overload;
    procedure capture(options: Variant); overload;
    function getSamples: array of Variant;
    procedure setSamples; overload;
    procedure setSamples(samples: array of Variant); overload;
  end;

//Ext.device.capture

type
  JIAbstract = class external(JExt.IBase)
    procedure captureAudio; overload;
    procedure captureAudio(config: Variant); overload;
    procedure captureVideo; overload;
    procedure captureVideo(config: Variant); overload;
  end;

//Ext.device.capture

type
  JISimulator = class external(JExt.IBase)
    procedure captureAudio; overload;
    procedure captureAudio(config: Variant); overload;
    procedure captureVideo; overload;
    procedure captureVideo(config: Variant); overload;
  end;

//Ext.device.capture

type
  JICordova = class external(JExt.IBase)
  end;

//Ext.device

type
  JCapture = class external 'Capture'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure captureAudio; overload;
    procedure captureAudio(config: Variant); overload;
    procedure captureVideo; overload;
    procedure captureVideo(config: Variant); overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JICapture = class external(JExt.IBase, JExt.device.capture.IAbstract)
  end;

//Ext.device.communicator

type
  JIAndroid = class external(JExt.device.communicator.IDefault)
  end;

//Ext.device.communicator

type
  JIDefault = class external(JExt.IBase)
  end;

//Ext.device

type
  JCommunicator = class external 'Communicator'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JICommunicator = class external(JExt.IBase)
  end;

//Ext.device.compass

type
  JIAbstract = class external(JExt.IBase)
    frequency: Float; // nullable
    function getFrequency: Float;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
  end;

//Ext.device.compass

type
  JICordova = class external(JExt.device.compass.IAbstract)
  end;

//Ext.device.compass

type
  JIPhoneGap = class external(JExt.device.compass.IAbstract)
  end;

//Ext.device

type
  JCompass = class external 'Compass'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getFrequency: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
    function statics: JExt.IClass;
  end;

  JICompass = class external(JExt.IBase, JExt.device.compass.IAbstract)
  end;

//Ext.device.compass

type
  JISimulator = class external(JExt.device.compass.IAbstract)
  end;

//Ext.device.connection

type
  JIAbstract = class external(JExt.IEvented, JExt.mixin.IObservable)
    CELL_2G: String; // nullable
    CELL_3G: String; // nullable
    CELL_4G: String; // nullable
    ETHERNET: String; // nullable
    NONE: String; // nullable
    UNKNOWN: String; // nullable
    WIFI: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getOnline: Boolean;
    function getType: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isOnline: Boolean;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setOnline; overload;
    procedure setOnline(online: Boolean); overload;
    procedure setType; overload;
    procedure setType(&type: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.connection

type
  JICordova = class external(JExt.device.connection.IAbstract)
    function getOnline: Boolean;
    function getType: String;
  end;

//Ext.device.connection

type
  JIPhoneGap = class external(JExt.device.connection.IAbstract)
    function getOnline: Boolean;
    function getType: String;
  end;

//Ext.device

type
  JConnection = class external 'Connection'
    CELL_2G: String;
    CELL_3G: String;
    CELL_4G: String;
    ETHERNET: String;
    NONE: String;
    UNKNOWN: String;
    WIFI: String;
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getOnline: Boolean;
    function getType: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isOnline: Boolean;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setOnline; overload;
    procedure setOnline(online: Boolean); overload;
    procedure setType; overload;
    procedure setType(&type: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIConnection = class external(JExt.IBase, JExt.device.connection.IAbstract)
  end;

//Ext.device.connection

type
  JISencha = class external(JExt.device.connection.IAbstract)
  end;

//Ext.device.connection

type
  JISimulator = class external(JExt.device.connection.IAbstract)
    function getOnline: Boolean;
  end;

//Ext.device.contacts

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    includeImages: Boolean; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getContacts: array of Variant; overload;
    function getContacts(config: Variant): array of Variant; overload;
    function getIncludeImages: Boolean;
    function getListeners: Variant;
    function getLocalizedLabel: String; overload;
    function getLocalizedLabel(config: Variant): String; overload;
    function getThumbnail: String; overload;
    function getThumbnail(config: Variant): String; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setIncludeImages; overload;
    procedure setIncludeImages(includeImages: Boolean); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.contacts

type
  JICordova = class external(JExt.device.contacts.IAbstract)
    function getContacts: array of Variant; overload;
    function getContacts(config: Variant): array of Variant; overload;
  end;

//Ext.device.contacts

type
  JIPhoneGap = class external(JExt.device.contacts.IAbstract)
    function getContacts: array of Variant; overload;
    function getContacts(config: Variant): array of Variant; overload;
  end;

//Ext.device

type
  JContacts = class external 'Contacts'
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getContacts: array of Variant; overload;
    function getContacts(config: Variant): array of Variant; overload;
    function getId: String;
    function getIncludeImages: Boolean;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getLocalizedLabel: String; overload;
    function getLocalizedLabel(config: Variant): String; overload;
    function getThumbnail: String; overload;
    function getThumbnail(config: Variant): String; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setIncludeImages; overload;
    procedure setIncludeImages(includeImages: Boolean); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIContacts = class external(JExt.IBase, JExt.device.contacts.IAbstract, JExt.device.contacts.ISencha, JExt.device.contacts.ICordova)
  end;

//Ext.device.contacts

type
  JISencha = class external(JExt.device.contacts.IAbstract)
    function getContacts: array of Variant; overload;
    function getContacts(config: Variant): array of Variant; overload;
    function getLocalizedLabel: String; overload;
    function getLocalizedLabel(config: Variant): String; overload;
    function getThumbnail: String; overload;
    function getThumbnail(config: Variant): String; overload;
  end;

//Ext.device.device

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    name: String; // nullable
    platform: String; // nullable
    scheme: Variant; // nullable
    uuid: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure openURL; overload;
    procedure openURL(url: String); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.device

type
  JICordova = class external(JExt.device.device.IAbstract)
    cordova: String; // nullable
    model: String; // nullable
    version: String; // nullable
  end;

//Ext.device.device

type
  JIPhoneGap = class external(JExt.device.device.IAbstract)
    cordova: String; // nullable
    model: String; // nullable
    version: String; // nullable
  end;

//Ext.device

type
  JDevice = class external 'Device'
    name: String;
    platform: String;
    scheme: Variant;
    self: JExt.IClass;
    uuid: String;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure openURL; overload;
    procedure openURL(url: String); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIDevice = class external(JExt.IBase, JExt.device.device.IAbstract)
  end;

//Ext.device.device

type
  JISencha = class external(JExt.device.device.IAbstract)
    procedure openURL; overload;
    procedure openURL(url: Variant); overload;
  end;

//Ext.device.device

type
  JISimulator = class external(JExt.device.device.IAbstract)
  end;

//Ext.device.filesystem

type
  JIAbstract = class external(JExt.IBase)
    function getFileSystemSize: Float;
    function getFileSystemType: Float;
    function getReaderType: String;
    function getStringEncoding: String;
    procedure setFileSystemSize; overload;
    procedure setFileSystemSize(fileSystemSize: Float); overload;
    procedure setFileSystemType; overload;
    procedure setFileSystemType(fileSystemType: Float); overload;
    procedure setReaderType; overload;
    procedure setReaderType(readerType: String); overload;
    procedure setStringEncoding; overload;
    procedure setStringEncoding(stringEncoding: String); overload;
  end;

//Ext.device.filesystem

type
  JIChrome = class external(JExt.device.filesystem.IHTML5)
    procedure requestFileSystem; overload;
    procedure requestFileSystem(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JICordova = class external(JExt.device.filesystem.IHTML5)
    function download: Variant; overload;
    function download(config: Variant): Variant; overload;
    procedure readMetadata; overload;
    procedure readMetadata(config: Variant); overload;
    function upload: Variant; overload;
    function upload(config: Variant): Variant; overload;
    procedure writeMetadata; overload;
    procedure writeMetadata(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JIPhoneGap = class external(JExt.device.filesystem.IHTML5)
    function download: Variant; overload;
    function download(config: Variant): Variant; overload;
    procedure readMetadata; overload;
    procedure readMetadata(config: Variant); overload;
    function upload: Variant; overload;
    function upload(config: Variant): Variant; overload;
    procedure writeMetadata; overload;
    procedure writeMetadata(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JIDirectoryEntry = class external(JExt.device.filesystem.IEntry)
    procedure getDirectory; overload;
    procedure getDirectory(config: Variant); overload;
    procedure getEntry; overload;
    procedure getEntry(config: Variant); overload;
    procedure getFile; overload;
    procedure getFile(config: Variant); overload;
    procedure readEntries; overload;
    procedure readEntries(config: Variant); overload;
    procedure removeRecursively; overload;
    procedure removeRecursively(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JIEntry = class external(JExt.IBase)
    procedure copyTo; overload;
    procedure copyTo(config: Variant); overload;
    function getFileSystem: JExt.device.filesystem.IFileSystem;
    function getFullPath: String;
    function getName: String;
    procedure getParent; overload;
    procedure getParent(config: Variant); overload;
    function isDirectory: Boolean;
    function isFile: Boolean;
    procedure moveTo; overload;
    procedure moveTo(config: Variant); overload;
    procedure remove; overload;
    procedure remove(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JIFileEntry = class external(JExt.device.filesystem.IEntry)
    procedure getEntry; overload;
    procedure getEntry(config: Variant); overload;
    function getOffset: Float;
    procedure read; overload;
    procedure read(config: Variant); overload;
    procedure seek; overload;
    procedure seek(config: Variant); overload;
    procedure truncate; overload;
    procedure truncate(config: Variant); overload;
    procedure write; overload;
    procedure write(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JIFileSystem = class external(JExt.IBase)
    function getRoot: JExt.device.filesystem.IDirectoryEntry;
  end;

//Ext.device.filesystem

type
  JIHTML5 = class external(JExt.device.filesystem.IAbstract)
    procedure requestFileSystem; overload;
    procedure requestFileSystem(config: Variant); overload;
  end;

//Ext.device

type
  JFileSystem = class external 'FileSystem'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getFileSystemSize: Float;
    function getFileSystemType: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getReaderType: String;
    function getStringEncoding: String;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure requestFileSystem; overload;
    procedure requestFileSystem(config: Variant); overload;
    procedure setFileSystemSize; overload;
    procedure setFileSystemSize(fileSystemSize: Float); overload;
    procedure setFileSystemType; overload;
    procedure setFileSystemType(fileSystemType: Float); overload;
    procedure setReaderType; overload;
    procedure setReaderType(readerType: String); overload;
    procedure setStringEncoding; overload;
    procedure setStringEncoding(stringEncoding: String); overload;
    function statics: JExt.IClass;
  end;

  JIFileSystem = class external(JExt.IBase, JExt.device.filesystem.ISencha)
  end;

//Ext.device.filesystem

type
  JISencha = class external(JExt.device.filesystem.IAbstract)
    procedure requestFileSystem; overload;
    procedure requestFileSystem(config: Variant); overload;
  end;

//Ext.device.filesystem

type
  JISimulator = class external(JExt.device.filesystem.IHTML5)
  end;

//Ext.device.geolocation

type
  JIAbstract = class external(JExt.IBase)
    allowHighAccuracy: Boolean; // nullable
    frequency: Float; // nullable
    maximumAge: Float; // nullable
    timeout: Float; // nullable
    procedure clearWatch;
    function getAllowHighAccuracy: Boolean;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    function getFrequency: Float;
    function getMaximumAge: Float;
    function getTimeout: Float;
    procedure setAllowHighAccuracy; overload;
    procedure setAllowHighAccuracy(allowHighAccuracy: Boolean); overload;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
    procedure setMaximumAge; overload;
    procedure setMaximumAge(maximumAge: Float); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

//Ext.device.geolocation

type
  JICordova = class external(JExt.device.geolocation.IAbstract)
    procedure clearWatch;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

//Ext.device.geolocation

type
  JIPhoneGap = class external(JExt.device.geolocation.IAbstract)
    procedure clearWatch;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

//Ext.device

type
  JGeolocation = class external 'Geolocation'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearWatch;
    procedure destroy;
    function getAllowHighAccuracy: Boolean;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    function getFrequency: Float;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getMaximumAge: Float;
    function getTimeout: Float;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure setAllowHighAccuracy; overload;
    procedure setAllowHighAccuracy(allowHighAccuracy: Boolean); overload;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
    procedure setMaximumAge; overload;
    procedure setMaximumAge(maximumAge: Float); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    function statics: JExt.IClass;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

  JIGeolocation = class external(JExt.IBase, JExt.device.geolocation.IAbstract)
  end;

//Ext.device.geolocation

type
  JISencha = class external(JExt.device.geolocation.IAbstract)
    procedure clearWatch;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

//Ext.device.geolocation

type
  JISimulator = class external(JExt.device.geolocation.IAbstract)
    procedure clearWatch;
    procedure getCurrentPosition; overload;
    procedure getCurrentPosition(config: Variant); overload;
    procedure watchPosition; overload;
    procedure watchPosition(config: Variant); overload;
  end;

//Ext.device.globalization

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getCurrencyCode: String;
    function getDateType: String;
    function getFormatLength: String;
    function getItems: String;
    function getListeners: Variant;
    function getNumberType: String;
    function getSelector: String;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCurrencyCode; overload;
    procedure setCurrencyCode(currencyCode: String); overload;
    procedure setDateType; overload;
    procedure setDateType(dateType: String); overload;
    procedure setFormatLength; overload;
    procedure setFormatLength(formatLength: String); overload;
    procedure setItems; overload;
    procedure setItems(items: String); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setNumberType; overload;
    procedure setNumberType(numberType: String); overload;
    procedure setSelector; overload;
    procedure setSelector(selector: String); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.globalization

type
  JICordova = class external(JExt.device.globalization.IAbstract)
  end;

//Ext.device.globalization

type
  JIPhoneGap = class external(JExt.device.globalization.IAbstract)
  end;

//Ext.device

type
  JGlobalization = class external 'Globalization'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIGlobalization = class external(JExt.IBase)
  end;

//Ext.device.globalization

type
  JISimulator = class external(JExt.device.globalization.IAbstract)
  end;

//Ext.device.media

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getSrc: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setSrc; overload;
    procedure setSrc(src: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.media

type
  JICordova = class external(JExt.device.media.IAbstract)
    src: String; // nullable
  end;

//Ext.device.media

type
  JIPhoneGap = class external(JExt.device.media.IAbstract)
    src: String; // nullable
  end;

//Ext.device

type
  JMedia = class external 'Media'
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getSrc: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setSrc; overload;
    procedure setSrc(src: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIMedia = class external(JExt.IBase, JExt.device.media.IAbstract)
  end;

//Ext.device.notification

type
  JIAbstract = class external(JExt.IBase)
    procedure show; overload;
    procedure show(config: Variant); overload;
    procedure vibrate;
  end;

//Ext.device.notification

type
  JICordova = class external(JExt.device.notification.IAbstract)
    procedure show; overload;
    procedure show(config: Variant); overload;
    procedure vibrate; overload;
    procedure vibrate(time: Variant); overload;
  end;

//Ext.device.notification

type
  JIPhoneGap = class external(JExt.device.notification.IAbstract)
    procedure show; overload;
    procedure show(config: Variant); overload;
    procedure vibrate; overload;
    procedure vibrate(time: Variant); overload;
  end;

//Ext.device

type
  JNotification = class external 'Notification'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure show; overload;
    procedure show(config: Variant); overload;
    function statics: JExt.IClass;
    procedure vibrate;
  end;

  JINotification = class external(JExt.IBase, JExt.device.notification.IAbstract)
  end;

//Ext.device.notification

type
  JISencha = class external(JExt.device.notification.IAbstract)
    procedure show;
    procedure vibrate;
  end;

//Ext.device.notification

type
  JISimulator = class external(JExt.device.notification.IAbstract)
    procedure show;
    procedure vibrate;
  end;

//Ext.device.orientation

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.device.orientation

type
  JIHTML5 = class external(JExt.device.orientation.IAbstract)
  end;

//Ext.device

type
  JOrientation = class external 'Orientation'
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIOrientation = class external(JExt.IBase, JExt.device.orientation.IAbstract)
  end;

//Ext.device.orientation

type
  JISencha = class external(JExt.device.orientation.IAbstract)
  end;

//Ext.device

type
  JPurchases = class external 'Purchases'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure canMakePayments; overload;
    procedure canMakePayments(config: Variant); overload;
    procedure destroy;
    procedure getCompletedPurchases; overload;
    procedure getCompletedPurchases(config: Variant); overload;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    procedure getProducts; overload;
    procedure getProducts(config: Variant); overload;
    procedure getPurchases; overload;
    procedure getPurchases(config: Variant); overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIPurchases = class external(JExt.IBase, JExt.device.purchases.ISencha)
  end;

//Ext.device.purchases

type
  JIProduct = class external(JExt.data.IModel)
    fields: Variant; // nullable
    function getFields: array of Variant;
    procedure purchase; overload;
    procedure purchase(config: Variant); overload;
    procedure setFields; overload;
    procedure setFields(fields: array of Variant); overload;
  end;

//Ext.device.purchases

type
  JIPurchase = class external(JExt.data.IModel)
    fields: Variant; // nullable
    procedure complete; overload;
    procedure complete(config: Variant); overload;
    function getFields: array of Variant;
    procedure setFields; overload;
    procedure setFields(fields: array of Variant); overload;
  end;

//Ext.device.purchases

type
  JISencha = class external(JExt.IBase)
    procedure canMakePayments; overload;
    procedure canMakePayments(config: Variant); overload;
    procedure getCompletedPurchases; overload;
    procedure getCompletedPurchases(config: Variant); overload;
    procedure getProducts; overload;
    procedure getProducts(config: Variant); overload;
    procedure getPurchases; overload;
    procedure getPurchases(config: Variant); overload;
  end;

//Ext.device.push

type
  JIAbstract = class external(JExt.IBase)
    ALERT: Float; // nullable
    BADGE: Float; // nullable
    SOUND: Float; // nullable
    procedure register; overload;
    procedure register(config: Variant); overload;
  end;

//Ext.device.push

type
  JICordova = class external(JExt.device.push.IAbstract)
    procedure register;
  end;

//Ext.device

type
  JPush = class external 'Push'
    ALERT: Float;
    BADGE: Float;
    SOUND: Float;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure register; overload;
    procedure register(config: Variant); overload;
    function statics: JExt.IClass;
  end;

  JIPush = class external(JExt.IBase, JExt.device.push.IAbstract)
  end;

//Ext.device.push

type
  JISencha = class external(JExt.device.push.IAbstract)
    procedure register;
  end;

//Ext.device.splashscreen

type
  JIAbstract = class external(JExt.IBase)
  end;

//Ext.device.splashscreen

type
  JICordova = class external(JExt.device.splashscreen.IAbstract)
  end;

//Ext.device.splashscreen

type
  JIPhoneGap = class external(JExt.device.splashscreen.IAbstract)
  end;

//Ext.device

type
  JSplashscreen = class external 'Splashscreen'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JISplashscreen = class external(JExt.IBase)
  end;

//Ext.device.splashscreen

type
  JISimulator = class external(JExt.device.splashscreen.IAbstract)
  end;

//Ext.device.sqlite

type
  JIDatabase = class external(JExt.IBase)
    procedure changeVersion; overload;
    procedure changeVersion(config: Variant); overload;
    function getVersion: String;
    procedure readTransaction; overload;
    procedure readTransaction(config: Variant); overload;
    procedure transaction; overload;
    procedure transaction(config: Variant); overload;
  end;

//Ext.device

type
  JSQLite = class external 'SQLite'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function openDatabase: JExt.device.sqlite.IDatabase; overload;
    function openDatabase(config: Variant): JExt.device.sqlite.IDatabase; overload;
    function statics: JExt.IClass;
  end;

  JISQLite = class external(JExt.IBase, JExt.device.sqlite.ISencha)
  end;

//Ext.device.sqlite

type
  JISencha = class external(JExt.IBase)
    function openDatabase: JExt.device.sqlite.IDatabase; overload;
    function openDatabase(config: Variant): JExt.device.sqlite.IDatabase; overload;
  end;

//Ext.device.sqlite

type
  JISQLResultSet = class external(JExt.IBase)
    function getInsertId: Float;
    function getRows: JExt.device.sqlite.ISQLResultSetRowList;
    function getRowsAffected: Float;
  end;

//Ext.device.sqlite

type
  JISQLResultSetRowList = class external(JExt.IBase)
    function getLength: Float;
    function item: Variant; overload;
    function item(index: Float): Variant; overload;
  end;

//Ext.device.sqlite

type
  JISQLTransaction = class external(JExt.IBase)
    procedure executeSql; overload;
    procedure executeSql(config: Variant); overload;
  end;

//Ext.device.storage

type
  JIAbstract = class external(JExt.IBase)
    function getDatabaseDisplayName: String;
    function getDatabaseName: String;
    function getDatabaseSize: Variant;
    function getDatabaseVersion: String;
    procedure setDatabaseDisplayName; overload;
    procedure setDatabaseDisplayName(databaseDisplayName: String); overload;
    procedure setDatabaseName; overload;
    procedure setDatabaseName(databaseName: String); overload;
    procedure setDatabaseSize; overload;
    procedure setDatabaseSize(databaseSize: Variant); overload;
    procedure setDatabaseVersion; overload;
    procedure setDatabaseVersion(databaseVersion: String); overload;
  end;

//Ext.device.storage

type
  JICordova = class external(JExt.device.storage.html5.IHTML5)
  end;

//Ext.device.storage

type
  JIPhoneGap = class external(JExt.device.storage.html5.IHTML5)
  end;

//Ext.device.storage.html5

type
  JIDatabase = class external(JExt.IBase)
    procedure transaction; overload;
    procedure transaction(sql: Variant); overload;
    procedure transaction(sql: Variant; success: Variant); overload;
    procedure transaction(sql: Variant; success: Variant; failure: Variant); overload;
  end;

//Ext.device.storage.html5

type
  JIHTML5 = class external(JExt.device.storage.IAbstract)
  end;

//Ext.device.storage.html5

type
  JISQLStatement = class external(JExt.IBase)
  end;

//Ext.device.storage

type
  JISimulator = class external(JExt.device.storage.html5.IHTML5)
  end;

//Ext.device.tunnel

type
  JIAbstract = class external(JExt.IBase)
    function broadcast: JExt.IPromise; overload;
    function broadcast(message: String): JExt.IPromise; overload;
    function connect: JExt.IPromise; overload;
    function connect(receiverId: String): JExt.IPromise; overload;
    procedure onConnect; overload;
    procedure onConnect(callback: Variant); overload;
    procedure onMessage; overload;
    procedure onMessage(callback: Variant); overload;
    function send: JExt.IPromise; overload;
    function send(receiverId: String): JExt.IPromise; overload;
    function send(receiverId: String; message: Variant): JExt.IPromise; overload;
    function send(receiverId: String; message: Variant; foreground: Boolean): JExt.IPromise; overload;
  end;

//Ext.direct

type
  JIEvent = class external(JExt.IBase)
    data: Variant; // nullable
    name: String; // nullable
    function getCode: Variant;
    function getData: Variant;
    function getMessage: String;
    function getName: String;
    function getResult: Variant;
    function getStatus: Boolean;
    function getTransaction: Variant;
    function getXhr: Variant;
    procedure setCode; overload;
    procedure setCode(code: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setResult; overload;
    procedure setResult(result: Variant); overload;
    procedure setStatus; overload;
    procedure setStatus(status: Boolean); overload;
    procedure setTransaction; overload;
    procedure setTransaction(transaction: Variant); overload;
    procedure setXhr; overload;
    procedure setXhr(xhr: Variant); overload;
  end;

//Ext.direct

type
  JIExceptionEvent = class external(JExt.direct.IRemotingEvent)
    name: String; // nullable
    function getError: Variant;
    function getName: String;
    function getStatus: Boolean;
    procedure setError; overload;
    procedure setError(error: Variant); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setStatus; overload;
    procedure setStatus(status: Boolean); overload;
  end;

//Ext.direct

type
  JIJsonProvider = class external(JExt.direct.IProvider)
    function createEvent: JExt.direct.IEvent; overload;
    function createEvent(response: Variant): JExt.direct.IEvent; overload;
  end;

//Ext.direct

type
  JManager = class external 'Manager'
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addProvider: Variant; overload;
    function addProvider(provider: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getProvider: Variant; overload;
    function getProvider(id: Variant): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parseMethod: Variant; overload;
    function parseMethod(fn: Variant): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function removeProvider: Variant; overload;
    function removeProvider(provider: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIManager = class external(JExt.IBase, JExt.mixin.IObservable)
  end;

//Ext

type
  JDirect = class external 'Direct'
    self: JExt.IClass;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addProvider: Variant; overload;
    function addProvider(provider: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getListeners: Variant;
    function getProvider: Variant; overload;
    function getProvider(id: Variant): Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parseMethod: Variant; overload;
    function parseMethod(fn: Variant): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function removeProvider: Variant; overload;
    function removeProvider(provider: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

  JIDirect = class external(JExt.IBase, JExt.mixin.IObservable)
  end;

//Ext.direct

type
  JIPollingProvider = class external(JExt.direct.IJsonProvider)
    baseParams: Variant; // nullable
    interval: Float; // nullable
    url: Variant; // nullable
    procedure connect;
    procedure disconnect;
    function getBaseParams: Variant;
    function getInterval: Float;
    function getUrl: Variant;
    function isConnected: Boolean;
    procedure setBaseParams; overload;
    procedure setBaseParams(baseParams: Variant); overload;
    procedure setInterval; overload;
    procedure setInterval(interval: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: Variant); overload;
  end;

//Ext.direct

type
  JIProvider = class external(JExt.IBase, JExt.mixin.IObservable)
    id: String; // nullable
    isProvider: Boolean; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure connect;
    procedure destroy;
    procedure disconnect;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: String;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isConnected: Boolean;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setId; overload;
    procedure setId(id: String); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.direct

type
  JIRemotingEvent = class external(JExt.direct.IEvent)
    name: String; // nullable
    function getName: String;
    function getTid: Variant;
    function getTransaction: JExt.direct.ITransaction;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setTid; overload;
    procedure setTid(tid: Variant); overload;
    procedure setTransaction; overload;
    procedure setTransaction(transaction: Variant); overload;
  end;

//Ext.direct

type
  JIRemotingMethod = class external(JExt.IBase)
    function getCallData: Variant; overload;
    function getCallData(args: array of Variant): Variant; overload;
    function getFormHandler: Variant;
    function getLen: Variant;
    function getName: Variant;
    function getOrdered: Boolean;
    function getParams: Variant;
    procedure setFormHandler; overload;
    procedure setFormHandler(formHandler: Variant); overload;
    procedure setLen; overload;
    procedure setLen(len: Variant); overload;
    procedure setName; overload;
    procedure setName(name: Variant); overload;
    procedure setOrdered; overload;
    procedure setOrdered(ordered: Boolean); overload;
    procedure setParams; overload;
    procedure setParams(params: Variant); overload;
  end;

//Ext.direct

type
  JIRemotingProvider = class external(JExt.direct.IJsonProvider)
    actions: Variant; // nullable
    enableBuffer: Variant; // nullable
    enableUrlEncode: String; // nullable
    maxRetries: Float; // nullable
    namespace: Variant; // nullable
    timeout: Float; // nullable
    url: String; // nullable
    procedure connect;
    procedure disconnect;
    function getActions: Variant;
    function getEnableBuffer: Variant;
    function getEnableUrlEncode: String;
    function getMaxRetries: Float;
    function getNamespace: Variant;
    function getTimeout: Float;
    function getUrl: String;
    function isConnected: Boolean;
    procedure setActions; overload;
    procedure setActions(actions: Variant); overload;
    procedure setEnableBuffer; overload;
    procedure setEnableBuffer(enableBuffer: Variant); overload;
    procedure setEnableUrlEncode; overload;
    procedure setEnableUrlEncode(enableUrlEncode: String); overload;
    procedure setMaxRetries; overload;
    procedure setMaxRetries(maxRetries: Float); overload;
    procedure setNamespace; overload;
    procedure setNamespace(namespace: Variant); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
  end;

//Ext.direct

type
  JITransaction = class external(JExt.IBase)
    function getAction: Variant;
    function getArgs: Variant;
    function getCallback: Variant;
    function getData: Variant;
    function getForm: Variant;
    function getId: Variant;
    function getMethod: Variant;
    function getProvider: Variant;
    function getRetryCount: Float;
    procedure setAction; overload;
    procedure setAction(action: Variant); overload;
    procedure setArgs; overload;
    procedure setArgs(args: Variant); overload;
    procedure setCallback; overload;
    procedure setCallback(callback: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setForm; overload;
    procedure setForm(form: Variant); overload;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: Variant); overload;
    procedure setProvider; overload;
    procedure setProvider(provider: Variant); overload;
    procedure setRetryCount; overload;
    procedure setRetryCount(retryCount: Float); overload;
  end;

//Ext.dom

type
  JICompositeElement = class external(JExt.dom.ICompositeElementLite)
  end;

//Ext

type
  JICompositeElement = class external(JExt.dom.ICompositeElementLite)
  end;

//Ext.dom

type
  JICompositeElementLite = class external(JExt.IBase, JExt.dom.IElement)
    elements: array of JHTMLElement; // nullable
    function add: JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant; root: Variant): JExt.dom.ICompositeElementLite; overload;
    function addCls: JExt.dom.IElement; overload;
    function addCls(names: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function addListener: JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant; opt: Variant): JExt.dom.ICompositeElementLite; overload;
    function appendChild: JExt.dom.IElement; overload;
    function appendChild(element: Variant): JExt.dom.IElement; overload;
    function appendTo: JExt.dom.IElement; overload;
    function appendTo(el: Variant): JExt.dom.IElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    procedure clear;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function createChild: JExt.dom.IElement; overload;
    function createChild(config: Variant): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IElement; overload;
    procedure cssTranslate;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    function each: JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant): JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function fill: JExt.dom.ICompositeElementLite; overload;
    function fill(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function filter: JExt.dom.ICompositeElementLite; overload;
    function filter(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function findParent: Variant; overload;
    function findParent(simpleSelector: String): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function findParentNode: Variant; overload;
    function findParentNode(simpleSelector: String): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function getAlignToXY: array of Variant; overload;
    function getAlignToXY(element: Variant): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Variant): array of Variant; overload;
    function getAnchorXY: array of Variant; overload;
    function getAnchorXY(anchor: String): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Variant; overload;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    function getBottom: Float;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getCount: Float;
    function getHTML: String;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getHtml: String;
    function getLeft: Float;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getOffsetsTo: array of Variant; overload;
    function getOffsetsTo(element: Variant): array of Variant; overload;
    procedure getOuterHeight;
    procedure getOuterWidth;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getRight: Float;
    procedure getScrollParent;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: String; overload;
    function getStyle(prop: String): String; overload;
    function getTop: Float;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function hasCls: Boolean; overload;
    function hasCls(name: String): Boolean; overload;
    procedure hide;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    function insertAfter: JExt.dom.IElement; overload;
    function insertAfter(el: Variant): JExt.dom.IElement; overload;
    function insertBefore: JExt.dom.IElement; overload;
    function insertBefore(el: Variant): JExt.dom.IElement; overload;
    function insertFirst: JExt.dom.IElement; overload;
    function insertFirst(element: Variant): JExt.dom.IElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IElement; overload;
    function insertSibling(el: Variant): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isDescendent;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function item: JExt.dom.IElement; overload;
    function item(index: Float): JExt.dom.IElement; overload;
    procedure mask;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    procedure purgeAllListeners;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    procedure remove;
    procedure removeAllListeners;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(names: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function removeElement: JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant; removeDom: Boolean): JExt.dom.ICompositeElementLite; overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IElement; overload;
    function replace(element: Variant): JExt.dom.IElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function replaceElement: JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.dom.ICompositeElementLite; overload;
    function replaceWith: JExt.dom.IElement; overload;
    function replaceWith(el: Variant): JExt.dom.IElement; overload;
    function select: JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(attributes: Variant): JExt.dom.IElement; overload;
    function set(attributes: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: String): JExt.dom.IElement; overload;
    function setBox: JExt.dom.IElement; overload;
    function setBox(box: Variant): JExt.dom.IElement; overload;
    procedure setCls; overload;
    procedure setCls(className: Variant); overload;
    procedure setHTML; overload;
    procedure setHTML(html: String); overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    procedure setHtml; overload;
    procedure setHtml(html: String); overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: String): JExt.dom.IElement; overload;
    function setMaxHeight: JExt.dom.IElement; overload;
    function setMaxHeight(height: Variant): JExt.dom.IElement; overload;
    function setMaxWidth: JExt.dom.IElement; overload;
    function setMaxWidth(width: Variant): JExt.dom.IElement; overload;
    function setMinHeight: JExt.dom.IElement; overload;
    function setMinHeight(height: Variant): JExt.dom.IElement; overload;
    function setMinWidth: JExt.dom.IElement; overload;
    function setMinWidth(width: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: String): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: String): JExt.dom.IElement; overload;
    procedure setTopLeft;
    function setVisibilityMode: JExt.dom.IElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.IElement; overload;
    function setVisible(visible: Boolean): JExt.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function setX: JExt.dom.IElement; overload;
    function setX(x: Float): JExt.dom.IElement; overload;
    function setXY: JExt.dom.IElement; overload;
    function setXY(pos: array of Float): JExt.dom.IElement; overload;
    function setY: JExt.dom.IElement; overload;
    function setY(y: Float): JExt.dom.IElement; overload;
    procedure show;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure unmask;
    function up: Variant; overload;
    function up(simpleSelector: String): Variant; overload;
    function up(simpleSelector: String; maxDepth: Variant): Variant; overload;
    procedure update; overload;
    procedure update(html: String); overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; domNode: Boolean): Variant; overload;
  end;

//Ext

type
  JICompositeElementLite = class external(JExt.IBase, JExt.dom.IElement)
    elements: array of JHTMLElement; // nullable
    function add: JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant; root: Variant): JExt.dom.ICompositeElementLite; overload;
    function addCls: JExt.dom.IElement; overload;
    function addCls(names: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function addListener: JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant; opt: Variant): JExt.dom.ICompositeElementLite; overload;
    function appendChild: JExt.dom.IElement; overload;
    function appendChild(element: Variant): JExt.dom.IElement; overload;
    function appendTo: JExt.dom.IElement; overload;
    function appendTo(el: Variant): JExt.dom.IElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    procedure clear;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function createChild: JExt.dom.IElement; overload;
    function createChild(config: Variant): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IElement; overload;
    procedure cssTranslate;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    function each: JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant): JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function fill: JExt.dom.ICompositeElementLite; overload;
    function fill(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function filter: JExt.dom.ICompositeElementLite; overload;
    function filter(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function findParent: Variant; overload;
    function findParent(simpleSelector: String): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function findParentNode: Variant; overload;
    function findParentNode(simpleSelector: String): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function getAlignToXY: array of Variant; overload;
    function getAlignToXY(element: Variant): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Variant): array of Variant; overload;
    function getAnchorXY: array of Variant; overload;
    function getAnchorXY(anchor: String): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Variant; overload;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    function getBottom: Float;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getCount: Float;
    function getHTML: String;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getHtml: String;
    function getLeft: Float;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getOffsetsTo: array of Variant; overload;
    function getOffsetsTo(element: Variant): array of Variant; overload;
    procedure getOuterHeight;
    procedure getOuterWidth;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getRight: Float;
    procedure getScrollParent;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: String; overload;
    function getStyle(prop: String): String; overload;
    function getTop: Float;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function hasCls: Boolean; overload;
    function hasCls(name: String): Boolean; overload;
    procedure hide;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    function insertAfter: JExt.dom.IElement; overload;
    function insertAfter(el: Variant): JExt.dom.IElement; overload;
    function insertBefore: JExt.dom.IElement; overload;
    function insertBefore(el: Variant): JExt.dom.IElement; overload;
    function insertFirst: JExt.dom.IElement; overload;
    function insertFirst(element: Variant): JExt.dom.IElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IElement; overload;
    function insertSibling(el: Variant): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isDescendent;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function item: JExt.dom.IElement; overload;
    function item(index: Float): JExt.dom.IElement; overload;
    procedure mask;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    procedure purgeAllListeners;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    procedure remove;
    procedure removeAllListeners;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(names: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function removeElement: JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant; removeDom: Boolean): JExt.dom.ICompositeElementLite; overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IElement; overload;
    function replace(element: Variant): JExt.dom.IElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function replaceElement: JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.dom.ICompositeElementLite; overload;
    function replaceWith: JExt.dom.IElement; overload;
    function replaceWith(el: Variant): JExt.dom.IElement; overload;
    function select: JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(attributes: Variant): JExt.dom.IElement; overload;
    function set(attributes: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: String): JExt.dom.IElement; overload;
    function setBox: JExt.dom.IElement; overload;
    function setBox(box: Variant): JExt.dom.IElement; overload;
    procedure setCls; overload;
    procedure setCls(className: Variant); overload;
    procedure setHTML; overload;
    procedure setHTML(html: String); overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    procedure setHtml; overload;
    procedure setHtml(html: String); overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: String): JExt.dom.IElement; overload;
    function setMaxHeight: JExt.dom.IElement; overload;
    function setMaxHeight(height: Variant): JExt.dom.IElement; overload;
    function setMaxWidth: JExt.dom.IElement; overload;
    function setMaxWidth(width: Variant): JExt.dom.IElement; overload;
    function setMinHeight: JExt.dom.IElement; overload;
    function setMinHeight(height: Variant): JExt.dom.IElement; overload;
    function setMinWidth: JExt.dom.IElement; overload;
    function setMinWidth(width: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: String): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: String): JExt.dom.IElement; overload;
    procedure setTopLeft;
    function setVisibilityMode: JExt.dom.IElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.IElement; overload;
    function setVisible(visible: Boolean): JExt.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function setX: JExt.dom.IElement; overload;
    function setX(x: Float): JExt.dom.IElement; overload;
    function setXY: JExt.dom.IElement; overload;
    function setXY(pos: array of Float): JExt.dom.IElement; overload;
    function setY: JExt.dom.IElement; overload;
    function setY(y: Float): JExt.dom.IElement; overload;
    procedure show;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure unmask;
    function up: Variant; overload;
    function up(simpleSelector: String): Variant; overload;
    function up(simpleSelector: String; maxDepth: Variant): Variant; overload;
    procedure update; overload;
    procedure update(html: String); overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; domNode: Boolean): Variant; overload;
  end;

//Ext

type
  JICompositeElement = class external(JExt.IBase, JExt.dom.IElement)
    elements: array of JHTMLElement; // nullable
    function add: JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function add(els: Variant; root: Variant): JExt.dom.ICompositeElementLite; overload;
    function addCls: JExt.dom.IElement; overload;
    function addCls(names: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function addListener: JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function addListener(eventName: Variant; handler: Variant; scope: Variant; opt: Variant): JExt.dom.ICompositeElementLite; overload;
    function appendChild: JExt.dom.IElement; overload;
    function appendChild(element: Variant): JExt.dom.IElement; overload;
    function appendTo: JExt.dom.IElement; overload;
    function appendTo(el: Variant): JExt.dom.IElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    procedure clear;
    function contains: Boolean; overload;
    function contains(el: Variant): Boolean; overload;
    function createChild: JExt.dom.IElement; overload;
    function createChild(config: Variant): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IElement; overload;
    procedure cssTranslate;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    function each: JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant): JExt.dom.ICompositeElementLite; overload;
    function each(fn: Variant; scope: Variant): JExt.dom.ICompositeElementLite; overload;
    function fill: JExt.dom.ICompositeElementLite; overload;
    function fill(els: Variant): JExt.dom.ICompositeElementLite; overload;
    function filter: JExt.dom.ICompositeElementLite; overload;
    function filter(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function findParent: Variant; overload;
    function findParent(simpleSelector: String): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function findParentNode: Variant; overload;
    function findParentNode(simpleSelector: String): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function getAlignToXY: array of Variant; overload;
    function getAlignToXY(element: Variant): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Variant): array of Variant; overload;
    function getAnchorXY: array of Variant; overload;
    function getAnchorXY(anchor: String): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Variant; overload;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    function getBottom: Float;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getCount: Float;
    function getHTML: String;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getHtml: String;
    function getLeft: Float;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getOffsetsTo: array of Variant; overload;
    function getOffsetsTo(element: Variant): array of Variant; overload;
    procedure getOuterHeight;
    procedure getOuterWidth;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getRight: Float;
    procedure getScrollParent;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: String; overload;
    function getStyle(prop: String): String; overload;
    function getTop: Float;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function hasCls: Boolean; overload;
    function hasCls(name: String): Boolean; overload;
    procedure hide;
    function indexOf: Float; overload;
    function indexOf(el: Variant): Float; overload;
    function insertAfter: JExt.dom.IElement; overload;
    function insertAfter(el: Variant): JExt.dom.IElement; overload;
    function insertBefore: JExt.dom.IElement; overload;
    function insertBefore(el: Variant): JExt.dom.IElement; overload;
    function insertFirst: JExt.dom.IElement; overload;
    function insertFirst(element: Variant): JExt.dom.IElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IElement; overload;
    function insertSibling(el: Variant): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isDescendent;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function item: JExt.dom.IElement; overload;
    function item(index: Float): JExt.dom.IElement; overload;
    procedure mask;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    procedure purgeAllListeners;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    procedure remove;
    procedure removeAllListeners;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(names: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function removeElement: JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function removeElement(el: Variant; removeDom: Boolean): JExt.dom.ICompositeElementLite; overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IElement; overload;
    function replace(element: Variant): JExt.dom.IElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function replaceElement: JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant): JExt.dom.ICompositeElementLite; overload;
    function replaceElement(el: Variant; replacement: Variant; domReplace: Boolean): JExt.dom.ICompositeElementLite; overload;
    function replaceWith: JExt.dom.IElement; overload;
    function replaceWith(el: Variant): JExt.dom.IElement; overload;
    function select: JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(attributes: Variant): JExt.dom.IElement; overload;
    function set(attributes: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: String): JExt.dom.IElement; overload;
    function setBox: JExt.dom.IElement; overload;
    function setBox(box: Variant): JExt.dom.IElement; overload;
    procedure setCls; overload;
    procedure setCls(className: Variant); overload;
    procedure setHTML; overload;
    procedure setHTML(html: String); overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    procedure setHtml; overload;
    procedure setHtml(html: String); overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: String): JExt.dom.IElement; overload;
    function setMaxHeight: JExt.dom.IElement; overload;
    function setMaxHeight(height: Variant): JExt.dom.IElement; overload;
    function setMaxWidth: JExt.dom.IElement; overload;
    function setMaxWidth(width: Variant): JExt.dom.IElement; overload;
    function setMinHeight: JExt.dom.IElement; overload;
    function setMinHeight(height: Variant): JExt.dom.IElement; overload;
    function setMinWidth: JExt.dom.IElement; overload;
    function setMinWidth(width: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: String): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: String): JExt.dom.IElement; overload;
    procedure setTopLeft;
    function setVisibilityMode: JExt.dom.IElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.IElement; overload;
    function setVisible(visible: Boolean): JExt.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function setX: JExt.dom.IElement; overload;
    function setX(x: Float): JExt.dom.IElement; overload;
    function setXY: JExt.dom.IElement; overload;
    function setXY(pos: array of Float): JExt.dom.IElement; overload;
    function setY: JExt.dom.IElement; overload;
    function setY(y: Float): JExt.dom.IElement; overload;
    procedure show;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure unmask;
    function up: Variant; overload;
    function up(simpleSelector: String): Variant; overload;
    function up(simpleSelector: String; maxDepth: Variant): Variant; overload;
    procedure update; overload;
    procedure update(html: String); overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; domNode: Boolean): Variant; overload;
  end;

//Ext.dom

type
  JElement = class external 'Element'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fly: JExt.dom.IElement; overload;
    function fly(element: Variant): JExt.dom.IElement; overload;
    function fly(element: Variant; named: String): JExt.dom.IElement; overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(element: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function select: JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean; root: Variant): JExt.dom.ICompositeElementLite; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function serializeNode: String; overload;
    function serializeNode(node: Variant): String; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIElement = class external(JExt.IBase, JExt.mixin.IObservable)
    DISPLAY: Float; // nullable
    OFFSETS: Float; // nullable
    VISIBILITY: Float; // nullable
    defaultUnit: String; // nullable
    dom: JHTMLElement; // nullable
    id: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addCls: JExt.dom.IElement; overload;
    function addCls(names: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function appendChild: JExt.dom.IElement; overload;
    function appendChild(element: Variant): JExt.dom.IElement; overload;
    function appendTo: JExt.dom.IElement; overload;
    function appendTo(el: Variant): JExt.dom.IElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    procedure clearListeners;
    function contains: Boolean; overload;
    function contains(element: Variant): Boolean; overload;
    function createChild: JExt.dom.IElement; overload;
    function createChild(config: Variant): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IElement; overload;
    procedure cssTranslate;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function findParent: Variant; overload;
    function findParent(simpleSelector: String): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function findParentNode: Variant; overload;
    function findParentNode(simpleSelector: String): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function first: Variant; overload;
    function first(selector: String): Variant; overload;
    function first(selector: String; returnDom: Boolean): Variant; overload;
    function getAlignToXY: array of Variant; overload;
    function getAlignToXY(element: Variant): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Variant): array of Variant; overload;
    function getAnchorXY: array of Variant; overload;
    function getAnchorXY(anchor: String): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Variant; overload;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    function getBottom: Float;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getBubbleEvents: Variant;
    function getHTML: String;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getHtml: String;
    function getLeft: Float;
    function getListeners: Variant;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getOffsetsTo: array of Variant; overload;
    function getOffsetsTo(element: Variant): array of Variant; overload;
    procedure getOuterHeight;
    procedure getOuterWidth;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getRight: Float;
    procedure getScrollParent;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: String; overload;
    function getStyle(prop: String): String; overload;
    function getTop: Float;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function hasCls: Boolean; overload;
    function hasCls(name: String): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hide;
    function insertAfter: JExt.dom.IElement; overload;
    function insertAfter(el: Variant): JExt.dom.IElement; overload;
    function insertBefore: JExt.dom.IElement; overload;
    function insertBefore(el: Variant): JExt.dom.IElement; overload;
    function insertFirst: JExt.dom.IElement; overload;
    function insertFirst(element: Variant): JExt.dom.IElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IElement; overload;
    function insertSibling(el: Variant): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isDescendent;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function last: Variant; overload;
    function last(selector: String): Variant; overload;
    function last(selector: String; returnDom: Boolean): Variant; overload;
    procedure mask;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    procedure purgeAllListeners;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure remove;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeAllListeners;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(names: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IElement; overload;
    function replace(element: Variant): JExt.dom.IElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function replaceWith: JExt.dom.IElement; overload;
    function replaceWith(el: Variant): JExt.dom.IElement; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(attributes: Variant): JExt.dom.IElement; overload;
    function set(attributes: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: String): JExt.dom.IElement; overload;
    function setBox: JExt.dom.IElement; overload;
    function setBox(box: Variant): JExt.dom.IElement; overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCls; overload;
    procedure setCls(className: Variant); overload;
    procedure setHTML; overload;
    procedure setHTML(html: String); overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    procedure setHtml; overload;
    procedure setHtml(html: String); overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: String): JExt.dom.IElement; overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function setMaxHeight: JExt.dom.IElement; overload;
    function setMaxHeight(height: Variant): JExt.dom.IElement; overload;
    function setMaxWidth: JExt.dom.IElement; overload;
    function setMaxWidth(width: Variant): JExt.dom.IElement; overload;
    function setMinHeight: JExt.dom.IElement; overload;
    function setMinHeight(height: Variant): JExt.dom.IElement; overload;
    function setMinWidth: JExt.dom.IElement; overload;
    function setMinWidth(width: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: String): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: String): JExt.dom.IElement; overload;
    procedure setTopLeft;
    function setVisibilityMode: JExt.dom.IElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.IElement; overload;
    function setVisible(visible: Boolean): JExt.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function setX: JExt.dom.IElement; overload;
    function setX(x: Float): JExt.dom.IElement; overload;
    function setXY: JExt.dom.IElement; overload;
    function setXY(pos: array of Float): JExt.dom.IElement; overload;
    function setY: JExt.dom.IElement; overload;
    function setY(y: Float): JExt.dom.IElement; overload;
    procedure show;
    procedure suspendEvents;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unmask;
    function up: Variant; overload;
    function up(simpleSelector: String): Variant; overload;
    function up(simpleSelector: String; maxDepth: Variant): Variant; overload;
    procedure update; overload;
    procedure update(html: String); overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; domNode: Boolean): Variant; overload;
  end;

//Ext

type
  JElement = class external 'Element'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fly: JExt.dom.IElement; overload;
    function fly(element: Variant): JExt.dom.IElement; overload;
    function fly(element: Variant; named: String): JExt.dom.IElement; overload;
    function fromPoint: String; overload;
    function fromPoint(x: Float): String; overload;
    function fromPoint(x: Float; y: Float): String; overload;
    function get: JExt.dom.IElement; overload;
    function get(element: Variant): JExt.dom.IElement; overload;
    function getDocumentHeight: Float;
    function getDocumentWidth: Float;
    function getName: String;
    function getOrientation: String;
    function getViewSize: Variant;
    function getViewportHeight: Float;
    function getViewportWidth: Float;
    function normalize: String; overload;
    function normalize(prop: String): String; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    function parseBox: Variant; overload;
    function parseBox(box: Variant): Variant; overload;
    function parseStyles: Variant; overload;
    function parseStyles(styles: String): Variant; overload;
    function select: JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
    function select(selector: Variant; composite: Boolean; root: Variant): JExt.dom.ICompositeElementLite; overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function serializeNode: String; overload;
    function serializeNode(node: Variant): String; overload;
    function unitizeBox: String; overload;
    function unitizeBox(box: Variant): String; overload;
    function unitizeBox(box: Variant; units: String): String; overload;
  end;

  JIElement = class external(JExt.IBase, JExt.mixin.IObservable)
    DISPLAY: Float; // nullable
    OFFSETS: Float; // nullable
    VISIBILITY: Float; // nullable
    defaultUnit: String; // nullable
    dom: JHTMLElement; // nullable
    id: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addCls: JExt.dom.IElement; overload;
    function addCls(names: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function addCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function appendChild: JExt.dom.IElement; overload;
    function appendChild(element: Variant): JExt.dom.IElement; overload;
    function appendTo: JExt.dom.IElement; overload;
    function appendTo(el: Variant): JExt.dom.IElement; overload;
    function applyStyles: JExt.dom.IElement; overload;
    function applyStyles(styles: Variant): JExt.dom.IElement; overload;
    function child: Variant; overload;
    function child(selector: String): Variant; overload;
    function child(selector: String; returnDom: Boolean): Variant; overload;
    procedure clearListeners;
    function contains: Boolean; overload;
    function contains(element: Variant): Boolean; overload;
    function createChild: JExt.dom.IElement; overload;
    function createChild(config: Variant): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement): JExt.dom.IElement; overload;
    function createChild(config: Variant; insertBefore: JHTMLElement; returnDom: Boolean): JExt.dom.IElement; overload;
    procedure cssTranslate;
    procedure destroy;
    function down: Variant; overload;
    function down(selector: String): Variant; overload;
    function down(selector: String; returnDom: Boolean): Variant; overload;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function findParent: Variant; overload;
    function findParent(simpleSelector: String): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParent(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function findParentNode: Variant; overload;
    function findParentNode(simpleSelector: String): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant): Variant; overload;
    function findParentNode(simpleSelector: String; maxDepth: Variant; returnEl: Boolean): Variant; overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function first: Variant; overload;
    function first(selector: String): Variant; overload;
    function first(selector: String; returnDom: Boolean): Variant; overload;
    function getAlignToXY: array of Variant; overload;
    function getAlignToXY(element: Variant): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String): array of Variant; overload;
    function getAlignToXY(element: Variant; position: String; offsets: array of Variant): array of Variant; overload;
    function getAnchorXY: array of Variant; overload;
    function getAnchorXY(anchor: String): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean): array of Variant; overload;
    function getAnchorXY(anchor: String; local: Boolean; size: Variant): array of Variant; overload;
    function getAttribute: String; overload;
    function getAttribute(name: String): String; overload;
    function getAttribute(name: String; namespace: String): String; overload;
    function getBorderWidth: Float; overload;
    function getBorderWidth(side: String): Float; overload;
    function getBottom: Float;
    function getBox: Variant; overload;
    function getBox(contentBox: Boolean): Variant; overload;
    function getBox(contentBox: Boolean; local: Boolean): Variant; overload;
    function getBubbleEvents: Variant;
    function getHTML: String;
    function getHeight: Float; overload;
    function getHeight(contentHeight: Boolean): Float; overload;
    function getHtml: String;
    function getLeft: Float;
    function getListeners: Variant;
    function getMargin: Variant; overload;
    function getMargin(sides: String): Variant; overload;
    function getOffsetsTo: array of Variant; overload;
    function getOffsetsTo(element: Variant): array of Variant; overload;
    procedure getOuterHeight;
    procedure getOuterWidth;
    function getPadding: Float; overload;
    function getPadding(side: String): Float; overload;
    function getPageBox: Variant; overload;
    function getPageBox(asRegion: Boolean): Variant; overload;
    function getRight: Float;
    procedure getScrollParent;
    function getSize: Variant; overload;
    function getSize(contentSize: Boolean): Variant; overload;
    function getStyle: String; overload;
    function getStyle(prop: String): String; overload;
    function getTop: Float;
    function getValue: Variant; overload;
    function getValue(asNumber: Boolean): Variant; overload;
    function getViewSize: Variant;
    function getWidth: Float; overload;
    function getWidth(contentWidth: Boolean): Float; overload;
    function getX: Float;
    function getXY: array of Variant;
    function getY: Float;
    function hasCls: Boolean; overload;
    function hasCls(name: String): Boolean; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hide;
    function insertAfter: JExt.dom.IElement; overload;
    function insertAfter(el: Variant): JExt.dom.IElement; overload;
    function insertBefore: JExt.dom.IElement; overload;
    function insertBefore(el: Variant): JExt.dom.IElement; overload;
    function insertFirst: JExt.dom.IElement; overload;
    function insertFirst(element: Variant): JExt.dom.IElement; overload;
    function insertHtml: Variant; overload;
    function insertHtml(where: String): Variant; overload;
    function insertHtml(where: String; html: String): Variant; overload;
    function insertHtml(where: String; html: String; returnEl: Boolean): Variant; overload;
    function insertSibling: JExt.dom.IElement; overload;
    function insertSibling(el: Variant): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String): JExt.dom.IElement; overload;
    function insertSibling(el: Variant; where: String; returnDom: Boolean): JExt.dom.IElement; overload;
    function is: Boolean; overload;
    function is(selector: String): Boolean; overload;
    procedure isDescendent;
    function isStyle: Boolean; overload;
    function isStyle(style: String): Boolean; overload;
    function isStyle(style: String; value: String): Boolean; overload;
    function isTransparent: Boolean; overload;
    function isTransparent(prop: String): Boolean; overload;
    function last: Variant; overload;
    function last(selector: String): Variant; overload;
    function last(selector: String; returnDom: Boolean): Variant; overload;
    procedure mask;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function next: Variant; overload;
    function next(selector: String): Variant; overload;
    function next(selector: String; returnDom: Boolean): Variant; overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function parent: Variant; overload;
    function parent(selector: String): Variant; overload;
    function parent(selector: String; returnDom: Boolean): Variant; overload;
    function prev: Variant; overload;
    function prev(selector: String): Variant; overload;
    function prev(selector: String; returnDom: Boolean): Variant; overload;
    procedure purgeAllListeners;
    function query: array of JHTMLElement; overload;
    function query(selector: String): array of JHTMLElement; overload;
    function radioCls: JExt.dom.IElement; overload;
    function radioCls(className: Variant): JExt.dom.IElement; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure remove;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeAllListeners;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeCls: JExt.dom.IElement; overload;
    function removeCls(names: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String): JExt.dom.IElement; overload;
    function removeCls(names: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function repaint: JExt.dom.IElement;
    function replace: JExt.dom.IElement; overload;
    function replace(element: Variant): JExt.dom.IElement; overload;
    function replaceCls: JExt.dom.IElement; overload;
    function replaceCls(oldName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String): JExt.dom.IElement; overload;
    function replaceCls(oldName: String; newName: String; prefix: String; suffix: String): JExt.dom.IElement; overload;
    function replaceWith: JExt.dom.IElement; overload;
    function replaceWith(el: Variant): JExt.dom.IElement; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    function serializeForm: String; overload;
    function serializeForm(form: Variant): String; overload;
    function set: JExt.dom.IElement; overload;
    function set(attributes: Variant): JExt.dom.IElement; overload;
    function set(attributes: Variant; useSet: Boolean): JExt.dom.IElement; overload;
    function setBottom: JExt.dom.IElement; overload;
    function setBottom(bottom: String): JExt.dom.IElement; overload;
    function setBox: JExt.dom.IElement; overload;
    function setBox(box: Variant): JExt.dom.IElement; overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCls; overload;
    procedure setCls(className: Variant); overload;
    procedure setHTML; overload;
    procedure setHTML(html: String); overload;
    function setHeight: JExt.dom.IElement; overload;
    function setHeight(height: Variant): JExt.dom.IElement; overload;
    procedure setHtml; overload;
    procedure setHtml(html: String); overload;
    function setLeft: JExt.dom.IElement; overload;
    function setLeft(left: String): JExt.dom.IElement; overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function setMaxHeight: JExt.dom.IElement; overload;
    function setMaxHeight(height: Variant): JExt.dom.IElement; overload;
    function setMaxWidth: JExt.dom.IElement; overload;
    function setMaxWidth(width: Variant): JExt.dom.IElement; overload;
    function setMinHeight: JExt.dom.IElement; overload;
    function setMinHeight(height: Variant): JExt.dom.IElement; overload;
    function setMinWidth: JExt.dom.IElement; overload;
    function setMinWidth(width: Variant): JExt.dom.IElement; overload;
    function setRight: JExt.dom.IElement; overload;
    function setRight(right: String): JExt.dom.IElement; overload;
    function setSize: JExt.dom.IElement; overload;
    function setSize(width: Variant): JExt.dom.IElement; overload;
    function setSize(width: Variant; height: Variant): JExt.dom.IElement; overload;
    function setStyle: JExt.dom.IElement; overload;
    function setStyle(&property: Variant): JExt.dom.IElement; overload;
    function setStyle(&property: Variant; value: String): JExt.dom.IElement; overload;
    function setTop: JExt.dom.IElement; overload;
    function setTop(top: String): JExt.dom.IElement; overload;
    procedure setTopLeft;
    function setVisibilityMode: JExt.dom.IElement; overload;
    function setVisibilityMode(mode: Variant): JExt.dom.IElement; overload;
    function setVisible: JExt.IElement; overload;
    function setVisible(visible: Boolean): JExt.IElement; overload;
    function setWidth: JExt.dom.IElement; overload;
    function setWidth(width: Variant): JExt.dom.IElement; overload;
    function setX: JExt.dom.IElement; overload;
    function setX(x: Float): JExt.dom.IElement; overload;
    function setXY: JExt.dom.IElement; overload;
    function setXY(pos: array of Float): JExt.dom.IElement; overload;
    function setY: JExt.dom.IElement; overload;
    function setY(y: Float): JExt.dom.IElement; overload;
    procedure show;
    procedure suspendEvents;
    function toggleCls: JExt.dom.IElement; overload;
    function toggleCls(className: String): JExt.dom.IElement; overload;
    function translatePoints: Variant; overload;
    function translatePoints(x: Variant): Variant; overload;
    function translatePoints(x: Variant; y: Float): Variant; overload;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unmask;
    function up: Variant; overload;
    function up(simpleSelector: String): Variant; overload;
    function up(simpleSelector: String; maxDepth: Variant): Variant; overload;
    procedure update; overload;
    procedure update(html: String); overload;
    function wrap: Variant; overload;
    function wrap(config: Variant): Variant; overload;
    function wrap(config: Variant; domNode: Boolean): Variant; overload;
  end;

//Ext.dom

type
  JIQuery = class external(JExt.IBase)
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function select: array of JHTMLElement; overload;
    function select(selector: String): array of JHTMLElement; overload;
    function select(selector: String; root: Variant): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: Variant): JHTMLElement; overload;
  end;

//Ext

type
  JIDomHelper = class external
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; o: Variant): Variant; overload;
    function append(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    procedure applyStyles; overload;
    procedure applyStyles(el: Variant); overload;
    procedure applyStyles(el: Variant; styles: Variant); overload;
    function createTemplate: JExt.ITemplate; overload;
    function createTemplate(o: Variant): JExt.ITemplate; overload;
    function generateStyles: Variant; overload;
    function generateStyles(styles: Variant): Variant; overload;
    function generateStyles(styles: Variant; buffer: array of String): Variant; overload;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertHtml: JHTMLElement; overload;
    function insertHtml(where: String): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant; html: String): JHTMLElement; overload;
    function markup: String; overload;
    function markup(spec: Variant): String; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
  end;

//Ext.dom

type
  JIHelper = class external
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; o: Variant): Variant; overload;
    function append(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    procedure applyStyles; overload;
    procedure applyStyles(el: Variant); overload;
    procedure applyStyles(el: Variant; styles: Variant); overload;
    function createTemplate: JExt.ITemplate; overload;
    function createTemplate(o: Variant): JExt.ITemplate; overload;
    function generateStyles: Variant; overload;
    function generateStyles(styles: Variant): Variant; overload;
    function generateStyles(styles: Variant; buffer: array of String): Variant; overload;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant): Variant; overload;
    function insertAfter(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant): Variant; overload;
    function insertBefore(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant): Variant; overload;
    function insertFirst(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
    function insertHtml: JHTMLElement; overload;
    function insertHtml(where: String): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant): JHTMLElement; overload;
    function insertHtml(where: String; el: Variant; html: String): JHTMLElement; overload;
    function markup: String; overload;
    function markup(spec: Variant): String; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant): Variant; overload;
    function overwrite(el: Variant; o: Variant; returnElement: Boolean): Variant; overload;
  end;

//Ext

type
  JDomQuery = class external 'DomQuery'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function select: array of JHTMLElement; overload;
    function select(selector: String): array of JHTMLElement; overload;
    function select(selector: String; root: Variant): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: Variant): JHTMLElement; overload;
    function statics: JExt.IClass;
  end;

  JIDomQuery = class external(JExt.dom.IQuery)
  end;

//Ext.core

type
  JDomQuery = class external 'DomQuery'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function is: Boolean; overload;
    function is(el: Variant): Boolean; overload;
    function is(el: Variant; selector: String): Boolean; overload;
    function select: array of JHTMLElement; overload;
    function select(selector: String): array of JHTMLElement; overload;
    function select(selector: String; root: Variant): array of JHTMLElement; overload;
    function selectNode: JHTMLElement; overload;
    function selectNode(selector: String): JHTMLElement; overload;
    function selectNode(selector: String; root: Variant): JHTMLElement; overload;
    function statics: JExt.IClass;
  end;

  JIDomQuery = class external(JExt.dom.IQuery)
  end;

//Ext.draw

type
  JAnimator = class external 'Animator'
    self: JExt.IClass;
    procedure add; overload;
    procedure add(animation: Variant); overload;
    function addFrameCallback: String; overload;
    function addFrameCallback(callback: Variant): String; overload;
    function addFrameCallback(callback: Variant; scope: Variant): String; overload;
    function animationTime: Float;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure cancel; overload;
    procedure cancel(id: String); overload;
    function contains: Boolean; overload;
    function contains(animation: Variant): Boolean; overload;
    procedure destroy;
    function empty: Boolean;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure remove; overload;
    procedure remove(animation: Variant); overload;
    procedure removeFrameCallback; overload;
    procedure removeFrameCallback(id: String); overload;
    function schedule: String; overload;
    function schedule(callback: Variant): String; overload;
    function schedule(callback: Variant; scope: Variant): String; overload;
    function statics: JExt.IClass;
    procedure step; overload;
    procedure step(frameTime: Float); overload;
  end;

  JIAnimator = class external(JExt.IBase)
  end;

//Ext.draw

type
  JColor = class external 'Color'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: JExt.draw.IColor; overload;
    function create(red: Variant): JExt.draw.IColor; overload;
    function create(red: Variant; green: Float): JExt.draw.IColor; overload;
    function create(red: Variant; green: Float; blue: Float): JExt.draw.IColor; overload;
    function create(red: Variant; green: Float; blue: Float; alpha: Float): JExt.draw.IColor; overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function fly: JExt.draw.IColor; overload;
    function fly(red: Variant): JExt.draw.IColor; overload;
    function fly(red: Variant; green: Float): JExt.draw.IColor; overload;
    function fly(red: Variant; green: Float; blue: Float): JExt.draw.IColor; overload;
    function fly(red: Variant; green: Float; blue: Float; alpha: Float): JExt.draw.IColor; overload;
    function fromHSL: JExt.draw.IColor; overload;
    function fromHSL(h: Float): JExt.draw.IColor; overload;
    function fromHSL(h: Float; s: Float): JExt.draw.IColor; overload;
    function fromHSL(h: Float; s: Float; l: Float): JExt.draw.IColor; overload;
    function fromString: JExt.draw.IColor; overload;
    function fromString(&string: String): JExt.draw.IColor; overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIColor = class external(JExt.IBase)
    lightnessFactor: Float; // nullable
    function createDarker: JExt.draw.IColor; overload;
    function createDarker(factor: Float): JExt.draw.IColor; overload;
    function createLighter: JExt.draw.IColor; overload;
    function createLighter(factor: Float): JExt.draw.IColor; overload;
    function getGrayscale: Float;
    function getHSL: array of Variant; overload;
    function getHSL(target: array of Variant): array of Variant; overload;
    function setFromString: Variant; overload;
    function setFromString(str: String): Variant; overload;
    function setHSL: Variant; overload;
    function setHSL(h: Float): Variant; overload;
    function setHSL(h: Float; s: Float): Variant; overload;
    function setHSL(h: Float; s: Float; l: Float): Variant; overload;
    function toHex: String; overload;
    function toHex(color: Variant): String; overload;
    function toString: String;
  end;

//Ext.draw

type
  JIComponent = class external(JExt.IContainer)
    autoSize: Boolean; // nullable
    cls: Variant; // nullable
    defaultType: String; // nullable
    fitSurface: Boolean; // nullable
    gradients: array of Variant; // nullable
    resizeHandler: Variant; // nullable
    viewBox: Boolean; // nullable
    procedure destroy;
    function getAutoSize: Boolean;
    function getBackground: Variant;
    function getCls: String;
    function getFitSurface: Boolean;
    function getGradients: array of Variant;
    function getResizeHandler: Variant;
    function getSprites: Variant;
    function getSurface: JExt.draw.ISurface; overload;
    function getSurface(id: String): JExt.draw.ISurface; overload;
    function getViewBox: Boolean;
    procedure initialize;
    procedure onPlaceWatermark;
    procedure renderFrame;
    procedure setAutoSize; overload;
    procedure setAutoSize(autoSize: Boolean); overload;
    procedure setBackground; overload;
    procedure setBackground(background: Variant); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setFitSurface; overload;
    procedure setFitSurface(fitSurface: Boolean); overload;
    procedure setGradients; overload;
    procedure setGradients(gradients: array of Variant); overload;
    procedure setResizeHandler; overload;
    procedure setResizeHandler(resizeHandler: Variant); overload;
    procedure setSprites; overload;
    procedure setSprites(sprites: Variant); overload;
    procedure setViewBox; overload;
    procedure setViewBox(viewBox: Boolean); overload;
  end;

//Ext.draw

type
  JDraw = class external 'Draw'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function degrees: Float; overload;
    function degrees(radian: Float): Float; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isBBoxIntersect: Boolean; overload;
    function isBBoxIntersect(bbox1: Variant): Boolean; overload;
    function isBBoxIntersect(bbox1: Variant; bbox2: Variant): Boolean; overload;
    function isBBoxIntersect(bbox1: Variant; bbox2: Variant; padding: Float): Boolean; overload;
    function rad: Float; overload;
    function rad(degrees: Float): Float; overload;
    function reflectFn: Variant; overload;
    function reflectFn(a: Variant): Variant; overload;
    function smooth: Variant; overload;
    function smooth(dataX: Variant): Variant; overload;
    function smooth(dataX: Variant; dataY: Variant): Variant; overload;
    function smooth(dataX: Variant; dataY: Variant; value: Variant): Variant; overload;
    procedure spline; overload;
    procedure spline(points: array of Variant); overload;
    function statics: JExt.IClass;
  end;

  JIDraw = class external(JExt.IBase)
  end;

//Ext.draw.engine

type
  JICanvas = class external(JExt.draw.ISurface)
    highPrecision: Boolean; // nullable
    procedure clear;
    procedure clearTransform;
    procedure destroy;
    function getHighPrecision: Boolean;
    procedure initElement;
    procedure setHighPrecision; overload;
    procedure setHighPrecision(highPrecision: Boolean); overload;
  end;

//Ext.draw.engine

type
  JISvg = class external(JExt.draw.ISurface)
    highPrecision: Boolean; // nullable
    procedure clear;
    procedure clearTransform;
    function createSvgNode: Variant; overload;
    function createSvgNode(&type: String): Variant; overload;
    procedure destroy; overload;
    procedure destroy(path: Variant); overload;
    procedure destroy(path: Variant; matrix: Variant); overload;
    procedure destroy(path: Variant; matrix: Variant; band: Variant); overload;
    function getHighPrecision: Boolean;
    procedure remove; overload;
    procedure remove(sprite: Variant); overload;
    procedure remove(sprite: Variant; destroySprite: Variant); overload;
    function renderSprite: Boolean; overload;
    function renderSprite(sprite: JExt.draw.sprite.ISprite): Boolean; overload;
    procedure setHighPrecision; overload;
    procedure setHighPrecision(highPrecision: Boolean); overload;
  end;

//Ext.draw.engine.svgcontext

type
  JIGradient = class external(JExt.IBase)
    procedure addColorStop; overload;
    procedure addColorStop(offset: Float); overload;
    procedure addColorStop(offset: Float; color: String); overload;
  end;

//Ext.draw.engine

type
  JISvgContext = class external(JExt.IBase)
    procedure arc; overload;
    procedure arc(x: Float); overload;
    procedure arc(x: Float; y: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float; anticlockwise: Float); overload;
    procedure arcSvg; overload;
    procedure arcSvg(r1: Float); overload;
    procedure arcSvg(r1: Float; r2: Float); overload;
    procedure arcSvg(r1: Float; r2: Float; rotation: Float); overload;
    procedure arcSvg(r1: Float; r2: Float; rotation: Float; large: Float); overload;
    procedure arcSvg(r1: Float; r2: Float; rotation: Float; large: Float; swipe: Float); overload;
    procedure arcSvg(r1: Float; r2: Float; rotation: Float; large: Float; swipe: Float; x2: Float); overload;
    procedure arcSvg(r1: Float; r2: Float; rotation: Float; large: Float; swipe: Float; x2: Float; y2: Float); overload;
    procedure arcTo; overload;
    procedure arcTo(x1: Float); overload;
    procedure arcTo(x1: Float; y1: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; radiusX: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; radiusX: Float; radiusY: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; radiusX: Float; radiusY: Float; rotation: Float); overload;
    procedure beginPath;
    procedure bezierCurveTo; overload;
    procedure bezierCurveTo(x1: Float); overload;
    procedure bezierCurveTo(x1: Float; y1: Float); overload;
    procedure bezierCurveTo(x1: Float; y1: Float; x2: Float); overload;
    procedure bezierCurveTo(x1: Float; y1: Float; x2: Float; y2: Float); overload;
    procedure bezierCurveTo(x1: Float; y1: Float; x2: Float; y2: Float; x3: Float); overload;
    procedure bezierCurveTo(x1: Float; y1: Float; x2: Float; y2: Float; x3: Float; y3: Float); overload;
    procedure clear;
    procedure closePath;
    function createLinearGradient: JExt.draw.engine.svgcontext.IGradient; overload;
    function createLinearGradient(x0: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createLinearGradient(x0: Float; y0: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createLinearGradient(x0: Float; y0: Float; x1: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createLinearGradient(x0: Float; y0: Float; x1: Float; y1: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient: JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float; y0: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float; y0: Float; r0: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float; y0: Float; r0: Float; x1: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float; y0: Float; r0: Float; x1: Float; y1: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    function createRadialGradient(x0: Float; y0: Float; r0: Float; x1: Float; y1: Float; r1: Float): JExt.draw.engine.svgcontext.IGradient; overload;
    procedure drawImage; overload;
    procedure drawImage(image: JHTMLElement); overload;
    procedure drawImage(image: JHTMLElement; sx: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float; sh: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float; sh: Float; dx: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float; sh: Float; dx: Float; dy: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float; sh: Float; dx: Float; dy: Float; dw: Float); overload;
    procedure drawImage(image: JHTMLElement; sx: Float; sy: Float; sw: Float; sh: Float; dx: Float; dy: Float; dw: Float; dh: Float); overload;
    procedure ellipse; overload;
    procedure ellipse(x: Float); overload;
    procedure ellipse(x: Float; y: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float; radiusY: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float; radiusY: Float; rotation: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float; endAngle: Float); overload;
    procedure ellipse(x: Float; y: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float; endAngle: Float; anticlockwise: Float); overload;
    procedure fill;
    procedure fillRect; overload;
    procedure fillRect(x: Float); overload;
    procedure fillRect(x: Float; y: Float); overload;
    procedure fillRect(x: Float; y: Float; width: Float); overload;
    procedure fillRect(x: Float; y: Float; width: Float; height: Float); overload;
    procedure fillStroke; overload;
    procedure fillStroke(attr: Variant); overload;
    procedure fillStroke(attr: Variant; transformFillStroke: Boolean); overload;
    procedure fillText; overload;
    procedure fillText(text: String); overload;
    procedure fillText(text: String; x: Float); overload;
    procedure fillText(text: String; x: Float; y: Float); overload;
    procedure lineTo; overload;
    procedure lineTo(x: Float); overload;
    procedure lineTo(x: Float; y: Float); overload;
    procedure moveTo; overload;
    procedure moveTo(x: Float); overload;
    procedure moveTo(x: Float; y: Float); overload;
    procedure rect; overload;
    procedure rect(x: Float); overload;
    procedure rect(x: Float; y: Float); overload;
    procedure rect(x: Float; y: Float; width: Float); overload;
    procedure rect(x: Float; y: Float; width: Float; height: Float); overload;
    procedure restore;
    procedure save;
    procedure setTransform; overload;
    procedure setTransform(xx: Float); overload;
    procedure setTransform(xx: Float; yx: Float); overload;
    procedure setTransform(xx: Float; yx: Float; xy: Float); overload;
    procedure setTransform(xx: Float; yx: Float; xy: Float; yy: Float); overload;
    procedure setTransform(xx: Float; yx: Float; xy: Float; yy: Float; dx: Float); overload;
    procedure setTransform(xx: Float; yx: Float; xy: Float; yy: Float; dx: Float; dy: Float); overload;
    procedure stroke;
    procedure strokeRect; overload;
    procedure strokeRect(x: Float); overload;
    procedure strokeRect(x: Float; y: Float); overload;
    procedure strokeRect(x: Float; y: Float; width: Float); overload;
    procedure strokeRect(x: Float; y: Float; width: Float; height: Float); overload;
    procedure strokeText; overload;
    procedure strokeText(text: String); overload;
    procedure strokeText(text: String; x: Float); overload;
    procedure strokeText(text: String; x: Float; y: Float); overload;
    procedure transform; overload;
    procedure transform(xx: Float); overload;
    procedure transform(xx: Float; yx: Float); overload;
    procedure transform(xx: Float; yx: Float; xy: Float); overload;
    procedure transform(xx: Float; yx: Float; xy: Float; yy: Float); overload;
    procedure transform(xx: Float; yx: Float; xy: Float; yy: Float; dx: Float); overload;
    procedure transform(xx: Float; yx: Float; xy: Float; yy: Float; dx: Float; dy: Float); overload;
  end;

//Ext.draw.gradient

type
  JIGradient = class external(JExt.IBase, JExt.mixin.IIdentifiable)
    Defines: Variant; // nullable
    function generateGradient: Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext): Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext; bbox: Variant): Variant; overload;
    function getId: String;
  end;

//Ext.draw.gradient

type
  JILinear = class external(JExt.draw.gradient.IGradient)
    The: Float; // nullable
    function generateGradient: Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext): Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext; bbox: Variant): Variant; overload;
  end;

//Ext.draw.gradient

type
  JIRadial = class external(JExt.draw.gradient.IGradient)
    &end: Variant; // nullable
    start: Variant; // nullable
    function generateGradient: Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext): Variant; overload;
    function generateGradient(ctx: JExt.draw.engine.ISvgContext; bbox: Variant): Variant; overload;
    function getEnd: Variant;
    function getStart: Variant;
    procedure setEnd; overload;
    procedure setEnd(&end: Variant); overload;
    procedure setStart; overload;
    procedure setStart(start: Variant); overload;
  end;

//Ext.draw

type
  JIGroup = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure add; overload;
    procedure add(sprite: JExt.draw.sprite.ISprite); overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addAll; overload;
    procedure addAll(sprites: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clear; overload;
    procedure clear(destroySprite: Boolean); overload;
    procedure clearListeners;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function get: JExt.draw.sprite.ISprite; overload;
    function get(id: Variant): JExt.draw.sprite.ISprite; overload;
    function getAt: JExt.draw.sprite.ISprite; overload;
    function getAt(index: Float): JExt.draw.sprite.ISprite; overload;
    procedure getBBox; overload;
    procedure getBBox(isWithTransform: Variant); overload;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getSurface: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure hide; overload;
    procedure hide(o: Boolean); overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure remove; overload;
    procedure remove(sprite: JExt.draw.sprite.ISprite); overload;
    procedure remove(sprite: JExt.draw.sprite.ISprite; destroySprite: Boolean); overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAttributes; overload;
    procedure setAttributes(o: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setDirty;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setSurface; overload;
    procedure setSurface(surface: Variant); overload;
    procedure show; overload;
    procedure show(o: Boolean); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.draw

type
  JILimitedCache = class external(JExt.IBase)
    feeder: Variant; // nullable
    limit: Float; // nullable
    scope: Variant; // nullable
    procedure clear;
    function get(id: String; args: array of Variant): Variant;
    function getFeeder: Variant;
    function getLimit: Float;
    function getScope: Variant;
    function setFeeder: Float; overload;
    function setFeeder(feeder: Variant): Float; overload;
    procedure setLimit; overload;
    procedure setLimit(limit: Float); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
  end;

//Ext.draw

type
  JMatrix = class external 'Matrix'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: JExt.draw.IMatrix; overload;
    function create(mat: Variant): JExt.draw.IMatrix; overload;
    procedure createAffineMatrixFromTwoPair; overload;
    procedure createAffineMatrixFromTwoPair(x0: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float; x1p: Float); overload;
    procedure createAffineMatrixFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float; x1p: Float; y1p: Float); overload;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    procedure createPanZoomFromTwoPair; overload;
    procedure createPanZoomFromTwoPair(x0: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float; x1p: Float); overload;
    procedure createPanZoomFromTwoPair(x0: Float; y0: Float; x1: Float; y1: Float; x0p: Float; y0p: Float; x1p: Float; y1p: Float); overload;
    function fly: JExt.draw.IMatrix; overload;
    function fly(elements: array of Variant): JExt.draw.IMatrix; overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIMatrix = class external(JExt.IBase)
    a: Float; // nullable
    function append: JExt.draw.IMatrix; overload;
    function append(xx: Float): JExt.draw.IMatrix; overload;
    function append(xx: Float; xy: Float): JExt.draw.IMatrix; overload;
    function append(xx: Float; xy: Float; yx: Float): JExt.draw.IMatrix; overload;
    function append(xx: Float; xy: Float; yx: Float; yy: Float): JExt.draw.IMatrix; overload;
    function append(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float): JExt.draw.IMatrix; overload;
    function append(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float; dy: Float): JExt.draw.IMatrix; overload;
    function appendMatrix: JExt.draw.IMatrix; overload;
    function appendMatrix(matrix: JExt.draw.IMatrix): JExt.draw.IMatrix; overload;
    function clone: JExt.draw.IMatrix;
    function equals: Boolean; overload;
    function equals(matrix: JExt.draw.IMatrix): Boolean; overload;
    function flipX: JExt.draw.IMatrix;
    function flipY: JExt.draw.IMatrix;
    function getDX: Float;
    function getDY: Float;
    function getScaleX: Float;
    function getScaleY: Float;
    function getXX: Float;
    function getXY: Float;
    function getYX: Float;
    function getYY: Float;
    function inverse: JExt.draw.IMatrix; overload;
    function inverse(target: JExt.draw.IMatrix): JExt.draw.IMatrix; overload;
    function isIdentity: Boolean;
    function multiply: JExt.draw.IMatrix; overload;
    function multiply(matrix: JExt.draw.IMatrix): JExt.draw.IMatrix; overload;
    function prepend: JExt.draw.IMatrix; overload;
    function prepend(xx: Float): JExt.draw.IMatrix; overload;
    function prepend(xx: Float; xy: Float): JExt.draw.IMatrix; overload;
    function prepend(xx: Float; xy: Float; yx: Float): JExt.draw.IMatrix; overload;
    function prepend(xx: Float; xy: Float; yx: Float; yy: Float): JExt.draw.IMatrix; overload;
    function prepend(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float): JExt.draw.IMatrix; overload;
    function prepend(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float; dy: Float): JExt.draw.IMatrix; overload;
    function prependMatrix: JExt.draw.IMatrix; overload;
    function prependMatrix(matrix: JExt.draw.IMatrix): JExt.draw.IMatrix; overload;
    function reset: JExt.draw.IMatrix;
    function rotate: JExt.draw.IMatrix; overload;
    function rotate(angle: Float): JExt.draw.IMatrix; overload;
    function rotate(angle: Float; rcx: Variant): JExt.draw.IMatrix; overload;
    function rotate(angle: Float; rcx: Variant; rcy: Variant): JExt.draw.IMatrix; overload;
    function rotate(angle: Float; rcx: Variant; rcy: Variant; prepend: Boolean): JExt.draw.IMatrix; overload;
    function rotateFromVector: JExt.draw.IMatrix; overload;
    function rotateFromVector(x: Float): JExt.draw.IMatrix; overload;
    function rotateFromVector(x: Float; y: Float): JExt.draw.IMatrix; overload;
    function rotateFromVector(x: Float; y: Float; prepend: Boolean): JExt.draw.IMatrix; overload;
    function scale: JExt.draw.IMatrix; overload;
    function scale(sx: Float): JExt.draw.IMatrix; overload;
    function scale(sx: Float; sy: Float): JExt.draw.IMatrix; overload;
    function scale(sx: Float; sy: Float; scx: Float): JExt.draw.IMatrix; overload;
    function scale(sx: Float; sy: Float; scx: Float; scy: Float): JExt.draw.IMatrix; overload;
    function scale(sx: Float; sy: Float; scx: Float; scy: Float; prepend: Boolean): JExt.draw.IMatrix; overload;
    function set: JExt.draw.IMatrix; overload;
    function set(xx: Float): JExt.draw.IMatrix; overload;
    function set(xx: Float; xy: Float): JExt.draw.IMatrix; overload;
    function set(xx: Float; xy: Float; yx: Float): JExt.draw.IMatrix; overload;
    function set(xx: Float; xy: Float; yx: Float; yy: Float): JExt.draw.IMatrix; overload;
    function set(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float): JExt.draw.IMatrix; overload;
    function set(xx: Float; xy: Float; yx: Float; yy: Float; dx: Float; dy: Float): JExt.draw.IMatrix; overload;
    function skewX: JExt.draw.IMatrix; overload;
    function skewX(angle: Float): JExt.draw.IMatrix; overload;
    function skewY: JExt.draw.IMatrix; overload;
    function skewY(angle: Float): JExt.draw.IMatrix; overload;
    function split: Variant;
    function toArray: array of Variant;
    function toContext: JExt.draw.IMatrix; overload;
    function toContext(ctx: Variant): JExt.draw.IMatrix; overload;
    function toString: array of Variant;
    function toSvg: String;
    function toVerticalArray: Variant;
    function transformBBox: Variant; overload;
    function transformBBox(bbox: Variant): Variant; overload;
    function transformBBox(bbox: Variant; radius: Float): Variant; overload;
    function transformBBox(bbox: Variant; radius: Float; target: Variant): Variant; overload;
    function transformList: array of Variant; overload;
    function transformList(list: array of Variant): array of Variant; overload;
    function transformPoint: array of Variant; overload;
    function transformPoint(point: array of Variant): array of Variant; overload;
    function translate: JExt.draw.IMatrix; overload;
    function translate(x: Float): JExt.draw.IMatrix; overload;
    function translate(x: Float; y: Float): JExt.draw.IMatrix; overload;
    function translate(x: Float; y: Float; prepend: Boolean): JExt.draw.IMatrix; overload;
    function x: Float; overload;
    function x(x: Float): Float; overload;
    function x(x: Float; y: Float): Float; overload;
    function y: Float; overload;
    function y(x: Float): Float; overload;
    function y(x: Float; y: Float): Float; overload;
  end;

//Ext.draw.modifier

type
  JIAnimation = class external(JExt.draw.modifier.IModifier, JExt.mixin.IObservable)
    customDuration: Variant; // nullable
    customEasings: Variant; // nullable
    duration: Float; // nullable
    easing: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearDurationOn; overload;
    procedure clearDurationOn(attrs: Variant); overload;
    procedure clearEasingOn; overload;
    procedure clearEasingOn(attrs: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getCustomDuration: Variant;
    function getCustomEasings: Variant;
    function getDuration: Float;
    function getEasing: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure popUp; overload;
    procedure popUp(attributes: Variant); overload;
    procedure popUp(attributes: Variant; changes: Variant); overload;
    procedure prepareAttributes; overload;
    procedure prepareAttributes(attr: Variant); overload;
    function pushDown: Variant; overload;
    function pushDown(attr: Variant): Variant; overload;
    function pushDown(attr: Variant; changes: Variant): Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCustomDuration; overload;
    procedure setCustomDuration(customDuration: Variant); overload;
    procedure setCustomEasings; overload;
    procedure setCustomEasings(customEasings: Variant); overload;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setDurationOn; overload;
    procedure setDurationOn(attrs: Variant); overload;
    procedure setDurationOn(attrs: Variant; duration: Float); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: Variant); overload;
    procedure setEasingOn; overload;
    procedure setEasingOn(attrs: Variant); overload;
    procedure setEasingOn(attrs: Variant; easing: String); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure stop;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.draw.modifier

type
  JIHighlight = class external(JExt.draw.modifier.IModifier)
    enabled: Boolean; // nullable
    highlightStyle: Variant; // nullable
    function filterChanges: Variant; overload;
    function filterChanges(attr: Variant): Variant; overload;
    function filterChanges(attr: Variant; changes: Variant): Variant; overload;
    function getEnabled: Boolean;
    function getHighlightStyle: Variant;
    procedure popUp; overload;
    procedure popUp(attributes: Variant); overload;
    procedure popUp(attributes: Variant; changes: Variant); overload;
    procedure prepareAttributes; overload;
    procedure prepareAttributes(attr: Variant); overload;
    function pushDown: Variant; overload;
    function pushDown(attr: Variant): Variant; overload;
    function pushDown(attr: Variant; changes: Variant): Variant; overload;
    procedure setEnabled; overload;
    procedure setEnabled(enabled: Boolean); overload;
    procedure setHighlightStyle; overload;
    procedure setHighlightStyle(highlightStyle: Variant); overload;
  end;

//Ext.draw.modifier

type
  JIModifier = class external(JExt.IBase)
    next: JExt.draw.modifier.IModifier; // nullable
    previous: JExt.draw.modifier.IModifier; // nullable
    sprite: JExt.draw.sprite.ISprite; // nullable
    function getNext: JExt.draw.modifier.IModifier;
    function getPrevious: JExt.draw.modifier.IModifier;
    function getSprite: JExt.draw.sprite.ISprite;
    procedure popUp; overload;
    procedure popUp(attributes: Variant); overload;
    procedure popUp(attributes: Variant; changes: Variant); overload;
    procedure prepareAttributes; overload;
    procedure prepareAttributes(attr: Variant); overload;
    function pushDown: Variant; overload;
    function pushDown(attr: Variant): Variant; overload;
    function pushDown(attr: Variant; changes: Variant): Variant; overload;
    procedure setNext; overload;
    procedure setNext(next: JExt.draw.modifier.IModifier); overload;
    procedure setPrevious; overload;
    procedure setPrevious(previous: JExt.draw.modifier.IModifier); overload;
    procedure setSprite; overload;
    procedure setSprite(sprite: JExt.draw.sprite.ISprite); overload;
  end;

//Ext.draw.modifier

type
  JITarget = class external(JExt.draw.modifier.IModifier)
    procedure popUp; overload;
    procedure popUp(attributes: Variant); overload;
    procedure popUp(attributes: Variant; changes: Variant); overload;
    procedure prepareAttributes; overload;
    procedure prepareAttributes(attr: Variant); overload;
    function pushDown: Variant; overload;
    function pushDown(attr: Variant): Variant; overload;
    function pushDown(attr: Variant; changes: Variant): Variant; overload;
  end;

//Ext.draw

type
  JIPath = class external(JExt.IBase)
    procedure arc; overload;
    procedure arc(x: Float); overload;
    procedure arc(x: Float; y: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float); overload;
    procedure arc(x: Float; y: Float; radius: Float; startAngle: Float; endAngle: Float; anticlockwise: Float); overload;
    procedure arcSvg; overload;
    procedure arcSvg(rx: Float); overload;
    procedure arcSvg(rx: Float; ry: Float); overload;
    procedure arcSvg(rx: Float; ry: Float; rotation: Float); overload;
    procedure arcSvg(rx: Float; ry: Float; rotation: Float; fA: Float); overload;
    procedure arcSvg(rx: Float; ry: Float; rotation: Float; fA: Float; fS: Float); overload;
    procedure arcSvg(rx: Float; ry: Float; rotation: Float; fA: Float; fS: Float; x2: Float); overload;
    procedure arcSvg(rx: Float; ry: Float; rotation: Float; fA: Float; fS: Float; x2: Float; y2: Float); overload;
    procedure arcTo; overload;
    procedure arcTo(x1: Float); overload;
    procedure arcTo(x1: Float; y1: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; rx: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; rx: Float; ry: Float); overload;
    procedure arcTo(x1: Float; y1: Float; x2: Float; y2: Float; rx: Float; ry: Float; rotation: Float); overload;
    procedure bezierCurveTo; overload;
    procedure bezierCurveTo(cx1: Float); overload;
    procedure bezierCurveTo(cx1: Float; cy1: Float); overload;
    procedure bezierCurveTo(cx1: Float; cy1: Float; cx2: Float); overload;
    procedure bezierCurveTo(cx1: Float; cy1: Float; cx2: Float; cy2: Float); overload;
    procedure bezierCurveTo(cx1: Float; cy1: Float; cx2: Float; cy2: Float; x: Float); overload;
    procedure bezierCurveTo(cx1: Float; cy1: Float; cx2: Float; cy2: Float; x: Float; y: Float); overload;
    procedure clear;
    function clone: JExt.draw.IPath;
    procedure closePath;
    procedure ellipse; overload;
    procedure ellipse(cx: Float); overload;
    procedure ellipse(cx: Float; cy: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float; radiusY: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float; radiusY: Float; rotation: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float; endAngle: Float); overload;
    procedure ellipse(cx: Float; cy: Float; radiusX: Float; radiusY: Float; rotation: Float; startAngle: Float; endAngle: Float; anticlockwise: Float); overload;
    procedure fromStripes; overload;
    procedure fromStripes(stripes: array of Variant); overload;
    procedure fromSvgString; overload;
    procedure fromSvgString(pathString: String); overload;
    function getDimension: Variant; overload;
    function getDimension(target: Variant): Variant; overload;
    function getDimensionWithTransform: Variant; overload;
    function getDimensionWithTransform(matrix: JExt.draw.IMatrix): Variant; overload;
    function getDimensionWithTransform(matrix: JExt.draw.IMatrix; target: Variant): Variant; overload;
    function isPointInPath: Boolean; overload;
    function isPointInPath(x: Float): Boolean; overload;
    function isPointInPath(x: Float; y: Float): Boolean; overload;
    procedure lineTo; overload;
    procedure lineTo(x: Float); overload;
    procedure lineTo(x: Float; y: Float); overload;
    procedure moveTo; overload;
    procedure moveTo(x: Float); overload;
    procedure moveTo(x: Float; y: Float); overload;
    procedure quadraticCurveTo; overload;
    procedure quadraticCurveTo(cx: Float); overload;
    procedure quadraticCurveTo(cx: Float; cy: Float); overload;
    procedure quadraticCurveTo(cx: Float; cy: Float; x: Float); overload;
    procedure quadraticCurveTo(cx: Float; cy: Float; x: Float; y: Float); overload;
    procedure rect; overload;
    procedure rect(x: Float); overload;
    procedure rect(x: Float; y: Float); overload;
    procedure rect(x: Float; y: Float; width: Float); overload;
    procedure rect(x: Float; y: Float; width: Float; height: Float); overload;
    function toString: String;
    function toStripes: array of Variant; overload;
    function toStripes(target: array of Variant): array of Variant; overload;
    procedure transform; overload;
    procedure transform(matrix: JExt.draw.IMatrix); overload;
  end;

//Ext.draw

type
  JISegmentTree = class external(JExt.IBase)
    function getAggregation: Variant; overload;
    function getAggregation(min: Float): Variant; overload;
    function getAggregation(min: Float; max: Float): Variant; overload;
    function getAggregation(min: Float; max: Float; estStep: Float): Variant; overload;
    function getStrategy: String;
    procedure setData; overload;
    procedure setData(dataX: Float); overload;
    procedure setData(dataX: Float; dataOpen: Float); overload;
    procedure setData(dataX: Float; dataOpen: Float; dataHigh: Float); overload;
    procedure setData(dataX: Float; dataOpen: Float; dataHigh: Float; dataLow: Float); overload;
    procedure setData(dataX: Float; dataOpen: Float; dataHigh: Float; dataLow: Float; dataClose: Float); overload;
    procedure setStrategy; overload;
    procedure setStrategy(strategy: String); overload;
  end;

//Ext.draw

type
  JSolver = class external 'Solver'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure cubicFunction; overload;
    procedure cubicFunction(a: Float); overload;
    procedure cubicFunction(a: Float; b: Float); overload;
    procedure cubicFunction(a: Float; b: Float; c: Float); overload;
    procedure cubicFunction(a: Float; b: Float; c: Float; d: Float); overload;
    procedure cubicRoot; overload;
    procedure cubicRoot(number: Float); overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure linearFunction; overload;
    procedure linearFunction(a: Float); overload;
    procedure linearFunction(a: Float; b: Float); overload;
    procedure quadraticFunction; overload;
    procedure quadraticFunction(a: Float); overload;
    procedure quadraticFunction(a: Float; b: Float); overload;
    procedure quadraticFunction(a: Float; b: Float; c: Float); overload;
    function statics: JExt.IClass;
  end;

  JISolver = class external(JExt.IBase)
  end;

//Ext.draw.sprite

type
  JAnimationParser = class external 'AnimationParser'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIAnimationParser = class external(JExt.IBase)
  end;

//Ext.draw.sprite

type
  JIArc = class external(JExt.draw.sprite.ICircle)
    anticlockwise: Boolean; // nullable
    endAngle: Float; // nullable
    startAngle: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIAttributeDefinition = class external(JExt.IBase)
    aliases: Variant; // nullable
    animationProcessors: Variant; // nullable
    defaults: Variant; // nullable
    dirty: Variant; // nullable
    processors: Variant; // nullable
    updaters: Variant; // nullable
    function getAliases: Variant;
    function getAnimationProcessors: Variant;
    function getDefaults: Variant;
    function getProcessors: Variant;
    function getUpdaters: Variant;
    function normalize: Variant; overload;
    function normalize(changes: Variant): Variant; overload;
    procedure setAliases; overload;
    procedure setAliases(aliases: Variant); overload;
    procedure setAnimationProcessors; overload;
    procedure setAnimationProcessors(animationProcessors: Variant); overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setProcessors; overload;
    procedure setProcessors(processors: Variant); overload;
    procedure setUpdaters; overload;
    procedure setUpdaters(updaters: Variant); overload;
  end;

//Ext.draw.sprite

type
  JAttributeParser = class external 'AttributeParser'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIAttributeParser = class external(JExt.IBase)
  end;

//Ext.draw.sprite

type
  JICircle = class external(JExt.draw.sprite.IPath)
    cx: Float; // nullable
    cy: Float; // nullable
    r: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIComposite = class external(JExt.draw.sprite.ISprite)
    procedure add; overload;
    procedure add(sprite: Variant); overload;
    procedure render; overload;
    procedure render(surface: Variant); overload;
    procedure render(surface: Variant; ctx: Variant); overload;
    procedure render(surface: Variant; ctx: Variant; region: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIEllipse = class external(JExt.draw.sprite.IPath)
    axisRotation: Float; // nullable
    cx: Float; // nullable
    cy: Float; // nullable
    rx: Float; // nullable
    ry: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIEllipticalArc = class external(JExt.draw.sprite.IEllipse)
    anticlockwise: Boolean; // nullable
    endAngle: Float; // nullable
    startAngle: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIImage = class external(JExt.draw.sprite.IRect)
    src: String; // nullable
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
  end;

//Ext.draw.sprite

type
  JIInstancing = class external(JExt.draw.sprite.ISprite)
    template: Variant; // nullable
    function createInstance: Variant; overload;
    function createInstance(config: Variant): Variant; overload;
    function createInstance(config: Variant; data: Variant): Variant; overload;
    function createInstance(config: Variant; data: Variant; bypassNormalization: Boolean): Variant; overload;
    function createInstance(config: Variant; data: Variant; bypassNormalization: Boolean; avoidCopy: Boolean): Variant; overload;
    procedure destroy;
    function getBBox: Variant;
    function getBBoxFor: Variant; overload;
    function getBBoxFor(index: Float): Variant; overload;
    function getBBoxFor(index: Float; isWithoutTransform: Boolean): Variant; overload;
    function getTemplate: Variant;
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant; clipRegion: Variant; region: Variant): Variant; overload;
    procedure setAttributesFor; overload;
    procedure setAttributesFor(index: Float); overload;
    procedure setAttributesFor(index: Float; changes: Variant); overload;
    procedure setAttributesFor(index: Float; changes: Variant; bypassNormalization: Boolean); overload;
    procedure setTemplate; overload;
    procedure setTemplate(template: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIPath = class external(JExt.draw.sprite.ISprite)
    path: String; // nullable
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    procedure updatePath; overload;
    procedure updatePath(path: JExt.draw.IPath); overload;
    procedure updatePath(path: JExt.draw.IPath; attr: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
  end;

//Ext.draw.sprite

type
  JIRect = class external(JExt.draw.sprite.IPath)
    height: Float; // nullable
    radius: Float; // nullable
    width: Float; // nullable
    x: Float; // nullable
    y: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
    procedure updateTransformedBBox(transform: Variant; plain: Variant); overload;
  end;

//Ext.draw.sprite

type
  JISector = class external(JExt.draw.sprite.IPath)
    centerX: Float; // nullable
    centerY: Float; // nullable
    endAngle: Float; // nullable
    endRho: Float; // nullable
    margin: Float; // nullable
    startAngle: Float; // nullable
    startRho: Float; // nullable
    procedure updatePath; overload;
    procedure updatePath(path: Variant); overload;
    procedure updatePath(path: Variant; attr: Variant); overload;
  end;

//Ext.draw.sprite

type
  JISprite = class external(JExt.IBase, JExt.mixin.IObservable)
    A: Float; // nullable
    An: array of Variant; // nullable
    fillOpacity: Float; // nullable
    fillStyle: String; // nullable
    globalAlpha: Float; // nullable
    hidden: Boolean; // nullable
    lineCap: String; // nullable
    lineJoin: String; // nullable
    lineWidth: Float; // nullable
    miterLimit: Float; // nullable
    rotationCenterX: Float; // nullable
    rotationCenterY: Float; // nullable
    rotationRads: Float; // nullable
    scalingCenterX: Float; // nullable
    scalingCenterY: Float; // nullable
    scalingX: Float; // nullable
    scalingY: Float; // nullable
    shadowBlur: Float; // nullable
    shadowColor: String; // nullable
    shadowOffsetX: Float; // nullable
    shadowOffsetY: Float; // nullable
    strokeOpacity: Float; // nullable
    strokeStyle: String; // nullable
    transformFillStroke: Boolean; // nullable
    translationX: Float; // nullable
    translationY: Float; // nullable
    zIndex: Float; // nullable
    attr: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    procedure getBBox; overload;
    procedure getBBox(isWithoutTransform: Boolean); overload;
    function getBBoxCenter: array of Variant; overload;
    function getBBoxCenter(isWithoutTransform: Boolean): array of Variant; overload;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function getParent: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function hide: JExt.draw.sprite.ISprite;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure preRender;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function render: Variant; overload;
    function render(surface: JExt.draw.ISurface): Variant; overload;
    function render(surface: JExt.draw.ISurface; ctx: Variant): Variant; overload;
    function render(surface: JExt.draw.ISurface; ctx: Variant; region: array of Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAttributes; overload;
    procedure setAttributes(changes: Variant); overload;
    procedure setAttributes(changes: Variant; bypassNormalization: Boolean); overload;
    procedure setAttributes(changes: Variant; bypassNormalization: Boolean; avoidCopy: Boolean); overload;
    procedure setAttributesBypassingNormalization; overload;
    procedure setAttributesBypassingNormalization(changes: Variant); overload;
    procedure setAttributesBypassingNormalization(changes: Variant; avoidCopy: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setParent; overload;
    procedure setParent(parent: Variant); overload;
    function show: JExt.draw.sprite.ISprite;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
    procedure updateTransformedBBox; overload;
    procedure updateTransformedBBox(transform: Variant); overload;
    procedure updateTransformedBBox(transform: Variant; plain: Variant); overload;
    procedure useAttributes; overload;
    procedure useAttributes(ctx: Variant); overload;
    procedure useAttributes(ctx: Variant; region: array of Variant); overload;
  end;

//Ext.draw.sprite

type
  JIText = class external(JExt.draw.sprite.ISprite)
    font: String; // nullable
    fontFamily: String; // nullable
    fontSize: Variant; // nullable
    fontStyle: String; // nullable
    fontVariant: String; // nullable
    fontWeight: String; // nullable
    text: String; // nullable
    textAlign: String; // nullable
    textBaseline: String; // nullable
    x: Float; // nullable
    y: Float; // nullable
    function render: Variant; overload;
    function render(surface: Variant): Variant; overload;
    function render(surface: Variant; ctx: Variant): Variant; overload;
    procedure updatePlainBBox; overload;
    procedure updatePlainBBox(plain: Variant); overload;
  end;

//Ext.draw

type
  JSurface = class external 'Surface'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
    procedure stableSort; overload;
    procedure stableSort(list: array of Variant); overload;
  end;

  JISurface = class external(JExt.IComponent)
    background: Variant; // nullable
    dirty: Boolean; // nullable
    groups: array of Variant; // nullable
    items: JExt.draw.IGroup; // nullable
    region: array of Variant; // nullable
    devicePixelRatio: Variant; // nullable
    procedure add;
    procedure clear;
    procedure destroy;
    function getBBox: Variant; overload;
    function getBBox(sprite: JExt.draw.sprite.ISprite): Variant; overload;
    function getBBox(sprite: JExt.draw.sprite.ISprite; isWithoutTransform: Boolean): Variant; overload;
    function getBackground: Variant;
    function getDirty: Boolean;
    function getGroup: JExt.draw.IGroup; overload;
    function getGroup(id: String): JExt.draw.IGroup; overload;
    function getGroups: array of Variant;
    function getItems: JExt.draw.IGroup;
    function getRegion: array of Variant;
    procedure onAdd; overload;
    procedure onAdd(sprite: JExt.draw.sprite.ISprite); overload;
    procedure remove; overload;
    procedure remove(sprite: JExt.draw.sprite.ISprite); overload;
    procedure remove(sprite: JExt.draw.sprite.ISprite; destroySprite: Boolean); overload;
    procedure removeAll;
    procedure renderFrame;
    procedure repaint;
    procedure resetTransform;
    function roundPixel: Float; overload;
    function roundPixel(num: Float): Float; overload;
    procedure setBackground; overload;
    procedure setBackground(background: Variant); overload;
    procedure setGroups; overload;
    procedure setGroups(groups: array of Variant); overload;
    procedure setItems; overload;
    procedure setItems(items: JExt.draw.IGroup); overload;
    procedure setRegion; overload;
    procedure setRegion(region: array of Variant); overload;
    procedure waitFor; overload;
    procedure waitFor(surface: JExt.draw.ISurface); overload;
  end;

//Ext.draw

type
  JTextMeasurer = class external 'TextMeasurer'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function measureText: Variant; overload;
    function measureText(text: String): Variant; overload;
    function measureText(text: String; font: String): Variant; overload;
    function measureTextSingleLine: Variant; overload;
    function measureTextSingleLine(text: String): Variant; overload;
    function measureTextSingleLine(text: String; font: String): Variant; overload;
    function statics: JExt.IClass;
  end;

  JITextMeasurer = class external(JExt.IBase)
  end;

//Ext.draw

type
  JTimingFunctions = class external 'TimingFunctions'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JITimingFunctions = class external(JExt.IBase)
  end;

//Ext.env

type
  JIBrowser = class external(JExt.IBase)
    engineName: String; // nullable
    engineVersion: JExt.IVersion; // nullable
    isSecure: Boolean; // nullable
    isStrict: Boolean; // nullable
    name: String; // nullable
    userAgent: String; // nullable
    version: JExt.IVersion; // nullable
    function is: Boolean; overload;
    function is(value: String): Boolean; overload;
  end;

//Ext.env

type
  JIFeature = class external(JExt.IBase)
  end;

//Ext.env

type
  JIOS = class external(JExt.IBase)
    name: String; // nullable
    version: JExt.IVersion; // nullable
    function is: Boolean; overload;
    function is(value: String): Boolean; overload;
  end;

//Ext.event

type
  JIController = class external(JExt.IBase)
  end;

//Ext.event

type
  JIDispatcher = class external(JExt.IBase)
    function getPublishers: Variant;
    procedure setPublishers; overload;
    procedure setPublishers(publishers: Variant); overload;
  end;

//Ext.event

type
  JIDom = class external
    distance: Float; // nullable
    pageX: Float; // nullable
    pageY: Float; // nullable
    target: JHTMLElement; // nullable
    function getPageX: Float;
    function getPageY: Float;
    function getTarget: JHTMLElement; overload;
    function getTarget(selector: String): JHTMLElement; overload;
    function getTarget(selector: String; maxDepth: Variant): JHTMLElement; overload;
    function getTarget(selector: String; maxDepth: Variant; returnEl: Boolean): JHTMLElement; overload;
    function getTime: Variant;
    function getXY: array of Variant;
    procedure preventDefault;
  end;

//Ext.event

type
  JIEvent = class external(JExt.IBase, JExt.event.ITouch)
    angle: Float; // nullable
    direction: Float; // nullable
    duration: Float; // nullable
    rotation: Float; // nullable
    scale: Float; // nullable
    function stopEvent: JExt.event.IEvent;
    function stopPropagation: JExt.event.IEvent;
  end;

//Ext

type
  JIEventObject = class external(JExt.IBase, JExt.event.ITouch)
    angle: Float; // nullable
    direction: Float; // nullable
    duration: Float; // nullable
    rotation: Float; // nullable
    scale: Float; // nullable
    function stopEvent: JExt.event.IEvent;
    function stopPropagation: JExt.event.IEvent;
  end;

//Ext.event

type
  JIListenerStack = class external(JExt.IBase)
  end;

//Ext.event.publisher

type
  JIComponentDelegation = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIComponentPaint = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIComponentSize = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIDom = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIElementPaint = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIElementSize = class external(JExt.event.publisher.IPublisher)
  end;

//Ext.event.publisher

type
  JIPublisher = class external(JExt.IBase)
  end;

//Ext.event.publisher

type
  JITouchGesture = class external(JExt.event.publisher.IDom)
    function getMoveThrottle: Float;
    function getRecognizers: Variant;
    procedure setMoveThrottle; overload;
    procedure setMoveThrottle(moveThrottle: Float); overload;
    procedure setRecognizers; overload;
    procedure setRecognizers(recognizers: Variant); overload;
  end;

//Ext.event.recognizer

type
  JIDoubleTap = class external(JExt.event.recognizer.ISingleTouch)
    function getMaxDuration: Float;
    procedure setMaxDuration; overload;
    procedure setMaxDuration(maxDuration: Float); overload;
  end;

//Ext.event.recognizer

type
  JIDrag = class external(JExt.event.recognizer.ISingleTouch)
    minDistance: Float; // nullable
    function getMinDistance: Float;
    procedure setMinDistance; overload;
    procedure setMinDistance(minDistance: Float); overload;
  end;

//Ext.event.recognizer

type
  JIEdgeSwipe = class external(JExt.event.recognizer.ISwipe)
    function getMinDistance: Float;
    procedure setMinDistance; overload;
    procedure setMinDistance(minDistance: Float); overload;
  end;

//Ext.event.recognizer

type
  JIHorizontalSwipe = class external(JExt.event.recognizer.ISwipe)
  end;

//Ext.event.recognizer

type
  JILongPress = class external(JExt.event.recognizer.ISingleTouch)
    function getMinDuration: Float;
    procedure setMinDuration; overload;
    procedure setMinDuration(minDuration: Float); overload;
  end;

//Ext.event.recognizer

type
  JIMultiTouch = class external(JExt.event.recognizer.ITouch)
  end;

//Ext.event.recognizer

type
  JIPinch = class external(JExt.event.recognizer.IMultiTouch)
  end;

//Ext.event.recognizer

type
  JIRecognizer = class external(JExt.IBase, JExt.mixin.IIdentifiable)
    function getCallbackScope: Variant;
    function getId: String;
    function getOnFailed: Variant;
    function getOnRecognized: Variant;
    procedure setCallbackScope; overload;
    procedure setCallbackScope(callbackScope: Variant); overload;
    procedure setOnFailed; overload;
    procedure setOnFailed(onFailed: Variant); overload;
    procedure setOnRecognized; overload;
    procedure setOnRecognized(onRecognized: Variant); overload;
  end;

//Ext.event.recognizer

type
  JIRotate = class external(JExt.event.recognizer.IMultiTouch)
  end;

//Ext.event.recognizer

type
  JISingleTouch = class external(JExt.event.recognizer.ITouch)
  end;

//Ext.event.recognizer

type
  JISwipe = class external(JExt.event.recognizer.ISingleTouch)
    function getMaxDuration: Float;
    function getMaxOffset: Float;
    function getMinDistance: Float;
    procedure setMaxDuration; overload;
    procedure setMaxDuration(maxDuration: Float); overload;
    procedure setMaxOffset; overload;
    procedure setMaxOffset(maxOffset: Float); overload;
    procedure setMinDistance; overload;
    procedure setMinDistance(minDistance: Float); overload;
  end;

//Ext.event.recognizer

type
  JITap = class external(JExt.event.recognizer.ISingleTouch)
    moveDistance: Float; // nullable
    function getMoveDistance: Float;
    procedure setMoveDistance; overload;
    procedure setMoveDistance(moveDistance: Float); overload;
  end;

//Ext.event.recognizer

type
  JITouch = class external(JExt.event.recognizer.IRecognizer)
  end;

//Ext.event.recognizer

type
  JIVerticalSwipe = class external(JExt.event.recognizer.ISwipe)
  end;

//Ext.event

type
  JITouch = class external(JExt.event.IDom)
  end;

//Ext

type
  JIEvented = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext

type
  JIEventedBase = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext

type
  JEventManager = class external 'EventManager'
    procedure addListener; overload;
    procedure addListener(el: Variant); overload;
    procedure addListener(el: Variant; eventName: String); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant; scope: Variant); overload;
    procedure addListener(el: Variant; eventName: String; handler: Variant; scope: Variant; options: Variant); overload;
    procedure on; overload;
    procedure on(el: Variant); overload;
    procedure on(el: Variant; eventName: String); overload;
    procedure on(el: Variant; eventName: String; handler: Variant); overload;
    procedure on(el: Variant; eventName: String; handler: Variant; scope: Variant); overload;
    procedure on(el: Variant; eventName: String; handler: Variant; scope: Variant; options: Variant); overload;
    procedure onDocumentReady;
    procedure onWindowResize; overload;
    procedure onWindowResize(fn: Variant); overload;
    procedure onWindowResize(fn: Variant; scope: Variant); overload;
    procedure onWindowResize(fn: Variant; scope: Variant; options: Boolean); overload;
    procedure removeAll; overload;
    procedure removeAll(el: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(el: Variant); overload;
    procedure removeListener(el: Variant; eventName: String); overload;
    procedure removeListener(el: Variant; eventName: String; fn: Variant); overload;
    procedure removeListener(el: Variant; eventName: String; fn: Variant; scope: Variant); overload;
    procedure un; overload;
    procedure un(el: Variant); overload;
    procedure un(el: Variant; eventName: String); overload;
    procedure un(el: Variant; eventName: String; fn: Variant); overload;
    procedure un(el: Variant; eventName: String; fn: Variant; scope: Variant); overload;
  end;

  JIEventManager = class external
  end;

//Ext

type
  JFeature = class external 'Feature'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function has: Boolean; overload;
    function has(value: String): Boolean; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIFeature = class external(JExt.env.IFeature)
  end;

//Ext.field

type
  JICheckbox = class external(JExt.field.IField)
    checked: Boolean; // nullable
    component: Variant; // nullable
    ui: String; // nullable
    value: String; // nullable
    function check: JExt.field.ICheckbox;
    procedure doChecked;
    procedure doUnChecked;
    function getChecked: Variant;
    function getComponent: Variant;
    function getGroupValues: array of Variant;
    function getSubmitValue: Variant;
    function getUi: String;
    function getValue: String;
    function isChecked: Boolean;
    function reset: JExt.field.IField;
    function resetGroupValues: JExt.field.ICheckbox;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    function setGroupValues: JExt.field.ICheckbox; overload;
    function setGroupValues(values: array of Variant): JExt.field.ICheckbox; overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setValue; overload;
    procedure setValue(value: String); overload;
    function uncheck: JExt.field.ICheckbox;
  end;

//Ext.form

type
  JICheckbox = class external(JExt.field.IField)
    checked: Boolean; // nullable
    component: Variant; // nullable
    ui: String; // nullable
    value: String; // nullable
    function check: JExt.field.ICheckbox;
    procedure doChecked;
    procedure doUnChecked;
    function getChecked: Variant;
    function getComponent: Variant;
    function getGroupValues: array of Variant;
    function getSubmitValue: Variant;
    function getUi: String;
    function getValue: String;
    function isChecked: Boolean;
    function reset: JExt.field.IField;
    function resetGroupValues: JExt.field.ICheckbox;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    function setGroupValues: JExt.field.ICheckbox; overload;
    function setGroupValues(values: array of Variant): JExt.field.ICheckbox; overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setValue; overload;
    procedure setValue(value: String); overload;
    function uncheck: JExt.field.ICheckbox;
  end;

//Ext.field

type
  JIDatePicker = class external(JExt.field.ISelect)
    dateFormat: String; // nullable
    destroyPickerOnHide: Boolean; // nullable
    picker: Variant; // nullable
    ui: String; // nullable
    value: Variant; // nullable
    function getDateFormat: String;
    procedure getDatePicker;
    function getDestroyPickerOnHide: Boolean;
    function getFormattedValue: String; overload;
    function getFormattedValue(format: String): String; overload;
    function getUi: String;
    function getValue: Variant;
    procedure onChange;
    function reset: JExt.field.ISelect;
    procedure setDateFormat; overload;
    procedure setDateFormat(dateFormat: String); overload;
    procedure setDestroyPickerOnHide; overload;
    procedure setDestroyPickerOnHide(destroyPickerOnHide: Boolean); overload;
    procedure setPicker; overload;
    procedure setPicker(picker: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.form

type
  JIDatePicker = class external(JExt.field.ISelect)
    dateFormat: String; // nullable
    destroyPickerOnHide: Boolean; // nullable
    picker: Variant; // nullable
    ui: String; // nullable
    value: Variant; // nullable
    function getDateFormat: String;
    procedure getDatePicker;
    function getDestroyPickerOnHide: Boolean;
    function getFormattedValue: String; overload;
    function getFormattedValue(format: String): String; overload;
    function getUi: String;
    function getValue: Variant;
    procedure onChange;
    function reset: JExt.field.ISelect;
    procedure setDateFormat; overload;
    procedure setDateFormat(dateFormat: String); overload;
    procedure setDestroyPickerOnHide; overload;
    procedure setDestroyPickerOnHide(destroyPickerOnHide: Boolean); overload;
    procedure setPicker; overload;
    procedure setPicker(picker: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.field

type
  JIEmail = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.form

type
  JIEmail = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.field

type
  JIField = class external(JExt.IDecorator)
    baseCls: String; // nullable
    clearIcon: Boolean; // nullable
    component: Variant; // nullable
    fieldCls: String; // nullable
    fieldLabel: String; // nullable
    inputCls: String; // nullable
    inputType: String; // nullable
    &label: String; // nullable
    labelAlign: String; // nullable
    labelCls: String; // nullable
    labelWidth: Variant; // nullable
    labelWrap: Boolean; // nullable
    name: String; // nullable
    required: Boolean; // nullable
    requiredCls: String; // nullable
    tabIndex: Float; // nullable
    useClearIcon: String; // nullable
    value: Variant; // nullable
    isField: Boolean; // nullable
    labelEl: JExt.IElement; // nullable
    originalValue: Variant; // nullable
    function getBaseCls: String;
    function getClearIcon: Boolean;
    function getInputCls: String;
    function getInputType: String;
    function getLabel: String;
    function getLabelAlign: String;
    function getLabelCls: String;
    function getLabelWidth: Variant;
    function getLabelWrap: Boolean;
    function getName: String;
    function getRequired: Boolean;
    function getRequiredCls: String;
    function getTabIndex: Float;
    function getValue: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure resetOriginalValue;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setClearIcon; overload;
    procedure setClearIcon(clearIcon: Boolean); overload;
    procedure setInputCls; overload;
    procedure setInputCls(inputCls: String); overload;
    procedure setInputType; overload;
    procedure setInputType(inputType: String); overload;
    procedure setLabel; overload;
    procedure setLabel(&label: String); overload;
    procedure setLabelAlign; overload;
    procedure setLabelAlign(labelAlign: String); overload;
    procedure setLabelCls; overload;
    procedure setLabelCls(labelCls: String); overload;
    procedure setLabelWidth; overload;
    procedure setLabelWidth(labelWidth: Variant); overload;
    procedure setLabelWrap; overload;
    procedure setLabelWrap(labelWrap: Boolean); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setRequired; overload;
    procedure setRequired(required: Boolean); overload;
    procedure setRequiredCls; overload;
    procedure setRequiredCls(requiredCls: String); overload;
    procedure setTabIndex; overload;
    procedure setTabIndex(tabIndex: Float); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.form

type
  JIField = class external(JExt.IDecorator)
    baseCls: String; // nullable
    clearIcon: Boolean; // nullable
    component: Variant; // nullable
    fieldCls: String; // nullable
    fieldLabel: String; // nullable
    inputCls: String; // nullable
    inputType: String; // nullable
    &label: String; // nullable
    labelAlign: String; // nullable
    labelCls: String; // nullable
    labelWidth: Variant; // nullable
    labelWrap: Boolean; // nullable
    name: String; // nullable
    required: Boolean; // nullable
    requiredCls: String; // nullable
    tabIndex: Float; // nullable
    useClearIcon: String; // nullable
    value: Variant; // nullable
    isField: Boolean; // nullable
    labelEl: JExt.IElement; // nullable
    originalValue: Variant; // nullable
    function getBaseCls: String;
    function getClearIcon: Boolean;
    function getInputCls: String;
    function getInputType: String;
    function getLabel: String;
    function getLabelAlign: String;
    function getLabelCls: String;
    function getLabelWidth: Variant;
    function getLabelWrap: Boolean;
    function getName: String;
    function getRequired: Boolean;
    function getRequiredCls: String;
    function getTabIndex: Float;
    function getValue: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure resetOriginalValue;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setClearIcon; overload;
    procedure setClearIcon(clearIcon: Boolean); overload;
    procedure setInputCls; overload;
    procedure setInputCls(inputCls: String); overload;
    procedure setInputType; overload;
    procedure setInputType(inputType: String); overload;
    procedure setLabel; overload;
    procedure setLabel(&label: String); overload;
    procedure setLabelAlign; overload;
    procedure setLabelAlign(labelAlign: String); overload;
    procedure setLabelCls; overload;
    procedure setLabelCls(labelCls: String); overload;
    procedure setLabelWidth; overload;
    procedure setLabelWidth(labelWidth: Variant); overload;
    procedure setLabelWrap; overload;
    procedure setLabelWrap(labelWrap: Boolean); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setRequired; overload;
    procedure setRequired(required: Boolean); overload;
    procedure setRequiredCls; overload;
    procedure setRequiredCls(requiredCls: String); overload;
    procedure setTabIndex; overload;
    procedure setTabIndex(tabIndex: Float); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.field

type
  JIFile = class external(JExt.field.IField)
    accept: String; // nullable
    capture: String; // nullable
    component: Variant; // nullable
    multiple: Boolean; // nullable
    function getAccept: String;
    function getCapture: String;
    function getComponent: Variant;
    function getMultiple: Boolean;
    procedure setAccept; overload;
    procedure setAccept(accept: String); overload;
    procedure setCapture; overload;
    procedure setCapture(capture: String); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMultiple; overload;
    procedure setMultiple(multiple: Boolean); overload;
  end;

//Ext.field

type
  JIFileInput = class external(JExt.field.IInput)
    me: Variant; // nullable
    name: String; // nullable
    newValue: Variant; // nullable
    &type: String; // nullable
    value: Variant; // nullable
    procedure applyCapture; overload;
    procedure applyCapture(value: Variant); overload;
    function getAccept: Variant;
    function getCapture: Variant;
    function getFiles: JFileList;
    function getMultiple: Boolean;
    function getType: String;
    function getValue: String;
    procedure setAccept; overload;
    procedure setAccept(accept: Variant); overload;
    procedure setCapture; overload;
    procedure setCapture(capture: Variant); overload;
    procedure setMultiple; overload;
    procedure setMultiple(multiple: Boolean); overload;
    procedure setName; overload;
    procedure setName(name: Variant); overload;
    procedure setType; overload;
    procedure setType(&type: String); overload;
    procedure updateMultiple;
  end;

//Ext.field

type
  JIHidden = class external(JExt.field.IText)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getUi: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.form

type
  JIHidden = class external(JExt.field.IText)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getUi: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.field

type
  JIInput = class external(JExt.IComponent)
    autoCapitalize: Boolean; // nullable
    autoComplete: Boolean; // nullable
    autoCorrect: Boolean; // nullable
    baseCls: String; // nullable
    checked: Boolean; // nullable
    cls: String; // nullable
    disabled: Boolean; // nullable
    fastFocus: Boolean; // nullable
    focusCls: String; // nullable
    maxLength: Float; // nullable
    maxRows: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    name: String; // nullable
    pattern: String; // nullable
    placeHolder: String; // nullable
    readOnly: Boolean; // nullable
    startValue: Variant; // nullable
    stepValue: Float; // nullable
    tabIndex: Float; // nullable
    &type: String; // nullable
    value: Variant; // nullable
    isFocused: Boolean; // nullable
    function blur: JExt.field.IInput;
    function focus: JExt.field.IInput;
    function getAutoCapitalize: Boolean;
    function getAutoComplete: Boolean;
    function getAutoCorrect: Boolean;
    function getBaseCls: String;
    function getChecked: Variant;
    function getCls: String;
    function getDisabled: Boolean;
    function getFastFocus: Boolean;
    function getFocusCls: String;
    function getMaxLength: Float;
    function getMaxRows: Float;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getName: String;
    function getPattern: String;
    function getPlaceHolder: String;
    function getReadOnly: Boolean;
    function getStartValue: Variant;
    function getStepValue: Float;
    function getTabIndex: Float;
    function getType: String;
    function getValue: Variant;
    function isDirty: Boolean;
    procedure reset;
    function select: JExt.field.IInput;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setAutoComplete; overload;
    procedure setAutoComplete(autoComplete: Boolean); overload;
    procedure setAutoCorrect; overload;
    procedure setAutoCorrect(autoCorrect: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setFastFocus; overload;
    procedure setFastFocus(fastFocus: Boolean); overload;
    procedure setFocusCls; overload;
    procedure setFocusCls(focusCls: String); overload;
    procedure setMaxLength; overload;
    procedure setMaxLength(maxLength: Float); overload;
    procedure setMaxRows; overload;
    procedure setMaxRows(maxRows: Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setPattern; overload;
    procedure setPattern(pattern: String); overload;
    procedure setPlaceHolder; overload;
    procedure setPlaceHolder(placeHolder: String); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setStartValue; overload;
    procedure setStartValue(startValue: Variant); overload;
    procedure setStepValue; overload;
    procedure setStepValue(stepValue: Float); overload;
    procedure setTabIndex; overload;
    procedure setTabIndex(tabIndex: Float); overload;
    procedure setType; overload;
    procedure setType(&type: String); overload;
    procedure updateCls; overload;
    procedure updateCls(newCls: Variant); overload;
    procedure updateCls(newCls: Variant; oldCls: Variant); overload;
    procedure updateUseMask; overload;
    procedure updateUseMask(newUseMask: Variant); overload;
  end;

//Ext.field

type
  JINumber = class external(JExt.field.IText)
    component: Variant; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    stepValue: Float; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getStepValue: Float;
    function getUi: String;
    function getValue: Variant;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setStepValue; overload;
    procedure setStepValue(stepValue: Float); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.form

type
  JINumber = class external(JExt.field.IText)
    component: Variant; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    stepValue: Float; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getStepValue: Float;
    function getUi: String;
    function getValue: Variant;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setStepValue; overload;
    procedure setStepValue(stepValue: Float); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.field

type
  JIPassword = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.form

type
  JIPassword = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.field

type
  JIRadio = class external(JExt.field.ICheckbox)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getGroupValue: String;
    function getSubmitValue: Variant;
    function getUi: String;
    function getValue: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    function setGroupValue: JExt.field.IRadio; overload;
    function setGroupValue(value: String): JExt.field.IRadio; overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    function setValue: JExt.field.IRadio; overload;
    function setValue(value: Variant): JExt.field.IRadio; overload;
  end;

//Ext.form

type
  JIRadio = class external(JExt.field.ICheckbox)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getGroupValue: String;
    function getSubmitValue: Variant;
    function getUi: String;
    function getValue: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    function setGroupValue: JExt.field.IRadio; overload;
    function setGroupValue(value: String): JExt.field.IRadio; overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    function setValue: JExt.field.IRadio; overload;
    function setValue(value: Variant): JExt.field.IRadio; overload;
  end;

//Ext.field

type
  JISearch = class external(JExt.field.IText)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getUi: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.form

type
  JISearch = class external(JExt.field.IText)
    component: Variant; // nullable
    ui: String; // nullable
    function getComponent: Variant;
    function getUi: String;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.field

type
  JISelect = class external(JExt.field.IText)
    autoSelect: Boolean; // nullable
    defaultPhonePickerConfig: Variant; // nullable
    defaultTabletPickerConfig: Variant; // nullable
    displayField: Variant; // nullable
    hiddenName: String; // nullable
    name: String; // nullable
    options: array of Variant; // nullable
    store: Variant; // nullable
    ui: String; // nullable
    usePicker: Variant; // nullable
    valueField: Variant; // nullable
    procedure destroy;
    function getAutoSelect: Boolean;
    function getDefaultPhonePickerConfig: Variant;
    function getDefaultTabletPickerConfig: Variant;
    function getDisplayField: Variant;
    function getHiddenName: String;
    function getName: String;
    function getOptions: array of Variant;
    function getRecord: JExt.data.IModel;
    function getStore: Variant;
    function getUi: String;
    function getUsePicker: Variant;
    function getValue: Variant;
    function getValueField: Variant;
    procedure onStoreDataChanged; overload;
    procedure onStoreDataChanged(store: Variant); overload;
    function reset: JExt.field.ISelect;
    procedure setAutoSelect; overload;
    procedure setAutoSelect(autoSelect: Boolean); overload;
    procedure setDefaultPhonePickerConfig; overload;
    procedure setDefaultPhonePickerConfig(defaultPhonePickerConfig: Variant); overload;
    procedure setDefaultTabletPickerConfig; overload;
    procedure setDefaultTabletPickerConfig(defaultTabletPickerConfig: Variant); overload;
    procedure setDisplayField; overload;
    procedure setDisplayField(displayField: Variant); overload;
    procedure setHiddenName; overload;
    procedure setHiddenName(hiddenName: String); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setOptions; overload;
    procedure setOptions(options: array of Variant); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setUsePicker; overload;
    procedure setUsePicker(usePicker: Variant); overload;
    procedure setValueField; overload;
    procedure setValueField(valueField: Variant); overload;
    procedure showPicker;
    function updateOptions: JExt.field.ISelect; overload;
    function updateOptions(newOptions: array of Variant): JExt.field.ISelect; overload;
  end;

//Ext.form

type
  JISelect = class external(JExt.field.IText)
    autoSelect: Boolean; // nullable
    defaultPhonePickerConfig: Variant; // nullable
    defaultTabletPickerConfig: Variant; // nullable
    displayField: Variant; // nullable
    hiddenName: String; // nullable
    name: String; // nullable
    options: array of Variant; // nullable
    store: Variant; // nullable
    ui: String; // nullable
    usePicker: Variant; // nullable
    valueField: Variant; // nullable
    procedure destroy;
    function getAutoSelect: Boolean;
    function getDefaultPhonePickerConfig: Variant;
    function getDefaultTabletPickerConfig: Variant;
    function getDisplayField: Variant;
    function getHiddenName: String;
    function getName: String;
    function getOptions: array of Variant;
    function getRecord: JExt.data.IModel;
    function getStore: Variant;
    function getUi: String;
    function getUsePicker: Variant;
    function getValue: Variant;
    function getValueField: Variant;
    procedure onStoreDataChanged; overload;
    procedure onStoreDataChanged(store: Variant); overload;
    function reset: JExt.field.ISelect;
    procedure setAutoSelect; overload;
    procedure setAutoSelect(autoSelect: Boolean); overload;
    procedure setDefaultPhonePickerConfig; overload;
    procedure setDefaultPhonePickerConfig(defaultPhonePickerConfig: Variant); overload;
    procedure setDefaultTabletPickerConfig; overload;
    procedure setDefaultTabletPickerConfig(defaultTabletPickerConfig: Variant); overload;
    procedure setDisplayField; overload;
    procedure setDisplayField(displayField: Variant); overload;
    procedure setHiddenName; overload;
    procedure setHiddenName(hiddenName: String); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setOptions; overload;
    procedure setOptions(options: array of Variant); overload;
    procedure setStore; overload;
    procedure setStore(store: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setUsePicker; overload;
    procedure setUsePicker(usePicker: Variant); overload;
    procedure setValueField; overload;
    procedure setValueField(valueField: Variant); overload;
    procedure showPicker;
    function updateOptions: JExt.field.ISelect; overload;
    function updateOptions(newOptions: array of Variant): JExt.field.ISelect; overload;
  end;

//Ext.field

type
  JISlider = class external(JExt.field.IField)
    cls: Variant; // nullable
    increment: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    readOnly: Boolean; // nullable
    tabIndex: Float; // nullable
    value: Variant; // nullable
    values: Variant; // nullable
    function getCls: String;
    function getIncrement: Float;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getReadOnly: Boolean;
    function getValue: Variant;
    function getValues: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setIncrement; overload;
    procedure setIncrement(increment: Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setTabIndex; overload;
    procedure setTabIndex(tabIndex: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
    procedure setValues; overload;
    procedure setValues(value: Variant); overload;
  end;

//Ext.form

type
  JISlider = class external(JExt.field.IField)
    cls: Variant; // nullable
    increment: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    readOnly: Boolean; // nullable
    tabIndex: Float; // nullable
    value: Variant; // nullable
    values: Variant; // nullable
    function getCls: String;
    function getIncrement: Float;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getReadOnly: Boolean;
    function getValue: Variant;
    function getValues: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setIncrement; overload;
    procedure setIncrement(increment: Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setTabIndex; overload;
    procedure setTabIndex(tabIndex: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
    procedure setValues; overload;
    procedure setValues(value: Variant); overload;
  end;

//Ext.field

type
  JISpinner = class external(JExt.field.INumber)
    accelerateOnTapHold: Boolean; // nullable
    cls: Variant; // nullable
    component: Variant; // nullable
    cycle: Boolean; // nullable
    defaultValue: Float; // nullable
    groupButtons: Boolean; // nullable
    increment: String; // nullable
    incrementValue: String; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    stepValue: Float; // nullable
    function getAccelerateOnTapHold: Boolean;
    function getCls: String;
    function getComponent: Variant;
    function getCycle: Boolean;
    function getDefaultValue: Float;
    function getGroupButtons: Boolean;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getStepValue: Float;
    function reset: JExt.field.IField;
    procedure setAccelerateOnTapHold; overload;
    procedure setAccelerateOnTapHold(accelerateOnTapHold: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setCycle; overload;
    procedure setCycle(cycle: Boolean); overload;
    procedure setDefaultValue; overload;
    procedure setDefaultValue(defaultValue: Float); overload;
    procedure setGroupButtons; overload;
    procedure setGroupButtons(groupButtons: Boolean); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setStepValue; overload;
    procedure setStepValue(stepValue: Float); overload;
    procedure updateComponent; overload;
    procedure updateComponent(newComponent: Variant); overload;
  end;

//Ext.form

type
  JISpinner = class external(JExt.field.INumber)
    accelerateOnTapHold: Boolean; // nullable
    cls: Variant; // nullable
    component: Variant; // nullable
    cycle: Boolean; // nullable
    defaultValue: Float; // nullable
    groupButtons: Boolean; // nullable
    increment: String; // nullable
    incrementValue: String; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    stepValue: Float; // nullable
    function getAccelerateOnTapHold: Boolean;
    function getCls: String;
    function getComponent: Variant;
    function getCycle: Boolean;
    function getDefaultValue: Float;
    function getGroupButtons: Boolean;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getStepValue: Float;
    function reset: JExt.field.IField;
    procedure setAccelerateOnTapHold; overload;
    procedure setAccelerateOnTapHold(accelerateOnTapHold: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setCycle; overload;
    procedure setCycle(cycle: Boolean); overload;
    procedure setDefaultValue; overload;
    procedure setDefaultValue(defaultValue: Float); overload;
    procedure setGroupButtons; overload;
    procedure setGroupButtons(groupButtons: Boolean); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setStepValue; overload;
    procedure setStepValue(stepValue: Float); overload;
    procedure updateComponent; overload;
    procedure updateComponent(newComponent: Variant); overload;
  end;

//Ext.field

type
  JIText = class external(JExt.field.IField)
    autoCapitalize: Boolean; // nullable
    autoComplete: Boolean; // nullable
    autoCorrect: Boolean; // nullable
    bubbleEvents: Variant; // nullable
    clearIcon: Boolean; // nullable
    component: Variant; // nullable
    maxLength: Float; // nullable
    placeHolder: String; // nullable
    readOnly: Boolean; // nullable
    ui: String; // nullable
    startValue: Variant; // nullable
    function blur: JExt.field.IText;
    function focus: JExt.field.IText;
    function getAutoCapitalize: Boolean;
    function getAutoComplete: Boolean;
    function getAutoCorrect: Boolean;
    function getClearIcon: Boolean;
    function getComponent: Variant;
    function getMaxLength: Float;
    function getPlaceHolder: String;
    function getReadOnly: Boolean;
    function getUi: String;
    function getValue: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure resetOriginalValue;
    function select: JExt.field.IText;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setAutoComplete; overload;
    procedure setAutoComplete(autoComplete: Boolean); overload;
    procedure setAutoCorrect; overload;
    procedure setAutoCorrect(autoCorrect: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: array of Variant); overload;
    procedure setClearIcon; overload;
    procedure setClearIcon(clearIcon: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxLength; overload;
    procedure setMaxLength(maxLength: Float); overload;
    procedure setPlaceHolder; overload;
    procedure setPlaceHolder(placeHolder: String); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.form

type
  JIText = class external(JExt.field.IField)
    autoCapitalize: Boolean; // nullable
    autoComplete: Boolean; // nullable
    autoCorrect: Boolean; // nullable
    bubbleEvents: Variant; // nullable
    clearIcon: Boolean; // nullable
    component: Variant; // nullable
    maxLength: Float; // nullable
    placeHolder: String; // nullable
    readOnly: Boolean; // nullable
    ui: String; // nullable
    startValue: Variant; // nullable
    function blur: JExt.field.IText;
    function focus: JExt.field.IText;
    function getAutoCapitalize: Boolean;
    function getAutoComplete: Boolean;
    function getAutoCorrect: Boolean;
    function getClearIcon: Boolean;
    function getComponent: Variant;
    function getMaxLength: Float;
    function getPlaceHolder: String;
    function getReadOnly: Boolean;
    function getUi: String;
    function getValue: Variant;
    function isDirty: Boolean;
    function reset: JExt.field.IField;
    procedure resetOriginalValue;
    function select: JExt.field.IText;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setAutoComplete; overload;
    procedure setAutoComplete(autoComplete: Boolean); overload;
    procedure setAutoCorrect; overload;
    procedure setAutoCorrect(autoCorrect: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: array of Variant); overload;
    procedure setClearIcon; overload;
    procedure setClearIcon(clearIcon: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxLength; overload;
    procedure setMaxLength(maxLength: Float); overload;
    procedure setPlaceHolder; overload;
    procedure setPlaceHolder(placeHolder: String); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.field

type
  JITextArea = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    maxRows: Float; // nullable
    ui: String; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    function getMaxRows: Float;
    function getUi: String;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxRows; overload;
    procedure setMaxRows(maxRows: Float); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.form

type
  JITextArea = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    maxRows: Float; // nullable
    ui: String; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    function getMaxRows: Float;
    function getUi: String;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
    procedure setMaxRows; overload;
    procedure setMaxRows(maxRows: Float); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.field

type
  JITextAreaInput = class external(JExt.field.IInput)
  end;

//Ext.field

type
  JIToggle = class external(JExt.field.ISlider)
    activeLabel: String; // nullable
    cls: String; // nullable
    inactiveLabel: String; // nullable
    labelAlign: String; // nullable
    maxValueCls: String; // nullable
    minValueCls: String; // nullable
    function getActiveLabel: String;
    function getCls: String;
    function getInactiveLabel: String;
    function getLabelAlign: String;
    function getMaxValueCls: String;
    function getMinValueCls: String;
    function getValue: Variant;
    procedure setActiveLabel; overload;
    procedure setActiveLabel(activeLabel: String); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setInactiveLabel; overload;
    procedure setInactiveLabel(inactiveLabel: String); overload;
    procedure setLabelAlign; overload;
    procedure setLabelAlign(labelAlign: String); overload;
    procedure setMaxValueCls; overload;
    procedure setMaxValueCls(maxValueCls: String); overload;
    procedure setMinValueCls; overload;
    procedure setMinValueCls(minValueCls: String); overload;
    function setValue: Variant; overload;
    function setValue(newValue: Float): Variant; overload;
    function toggle: Variant;
  end;

//Ext.form

type
  JIToggle = class external(JExt.field.ISlider)
    activeLabel: String; // nullable
    cls: String; // nullable
    inactiveLabel: String; // nullable
    labelAlign: String; // nullable
    maxValueCls: String; // nullable
    minValueCls: String; // nullable
    function getActiveLabel: String;
    function getCls: String;
    function getInactiveLabel: String;
    function getLabelAlign: String;
    function getMaxValueCls: String;
    function getMinValueCls: String;
    function getValue: Variant;
    procedure setActiveLabel; overload;
    procedure setActiveLabel(activeLabel: String); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setInactiveLabel; overload;
    procedure setInactiveLabel(inactiveLabel: String); overload;
    procedure setLabelAlign; overload;
    procedure setLabelAlign(labelAlign: String); overload;
    procedure setMaxValueCls; overload;
    procedure setMaxValueCls(maxValueCls: String); overload;
    procedure setMinValueCls; overload;
    procedure setMinValueCls(minValueCls: String); overload;
    function setValue: Variant; overload;
    function setValue(newValue: Float): Variant; overload;
    function toggle: Variant;
  end;

//Ext.field

type
  JIUrl = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.form

type
  JIUrl = class external(JExt.field.IText)
    autoCapitalize: Boolean; // nullable
    component: Variant; // nullable
    function getAutoCapitalize: Boolean;
    function getComponent: Variant;
    procedure setAutoCapitalize; overload;
    procedure setAutoCapitalize(autoCapitalize: Boolean); overload;
    procedure setComponent; overload;
    procedure setComponent(component: Variant); overload;
  end;

//Ext.form

type
  JIFieldSet = class external(JExt.IContainer)
    baseCls: String; // nullable
    instructions: String; // nullable
    title: String; // nullable
    function doSetDisabled: JExt.form.IFieldSet; overload;
    function doSetDisabled(newDisabled: Variant): JExt.form.IFieldSet; overload;
    function getBaseCls: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setInstructions; overload;
    procedure setInstructions(instructions: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext.form

type
  JIPanel = class external(JExt.IPanel)
    api: Variant; // nullable
    baseCls: String; // nullable
    baseParams: Variant; // nullable
    enableSubmissionForm: Boolean; // nullable
    enctype: Variant; // nullable
    method: String; // nullable
    multipartDetection: Boolean; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    record: JExt.data.IModel; // nullable
    scrollable: Variant; // nullable
    standardSubmit: Boolean; // nullable
    submitOnAction: Variant; // nullable
    timeout: Float; // nullable
    trackResetOnLoad: Boolean; // nullable
    url: String; // nullable
    waitMsgTarget: JExt.dom.IElement; // nullable
    waitTpl: Variant; // nullable
    function doSetDisabled: JExt.form.IPanel; overload;
    function doSetDisabled(newDisabled: Variant): JExt.form.IPanel; overload;
    function getApi: Variant;
    function getBaseCls: String;
    function getBaseParams: Variant;
    function getEnableSubmissionForm: Boolean;
    function getEnctype: Variant;
    function getMethod: String;
    function getMultipartDetection: Boolean;
    function getParamOrder: Variant;
    function getParamsAsHash: Boolean;
    function getRecord: JExt.data.IModel;
    function getStandardSubmit: Boolean;
    function getSubmitOnAction: Variant;
    function getTimeout: Float;
    function getTrackResetOnLoad: Boolean;
    function getUrl: String;
    function getValues: Variant; overload;
    function getValues(enabled: Boolean): Variant; overload;
    function getValues(enabled: Boolean; all: Boolean): Variant; overload;
    function hideMask: JExt.form.IPanel;
    function load: JExt.data.IConnection; overload;
    function load(options: Variant): JExt.data.IConnection; overload;
    function loadModel: JExt.form.IPanel; overload;
    function loadModel(record: JExt.data.IModel): JExt.form.IPanel; overload;
    function loadRecord: JExt.form.IPanel; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IPanel; overload;
    function reset: JExt.form.IPanel;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBaseParams; overload;
    procedure setBaseParams(baseParams: Variant); overload;
    procedure setEnableSubmissionForm; overload;
    procedure setEnableSubmissionForm(enableSubmissionForm: Boolean); overload;
    procedure setEnctype; overload;
    procedure setEnctype(enctype: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: String); overload;
    procedure setMultipartDetection; overload;
    procedure setMultipartDetection(multipartDetection: Boolean); overload;
    procedure setParamOrder; overload;
    procedure setParamOrder(paramOrder: Variant); overload;
    procedure setParamsAsHash; overload;
    procedure setParamsAsHash(paramsAsHash: Boolean); overload;
    function setRecord: JExt.form.IPanel; overload;
    function setRecord(record: JExt.data.IModel): JExt.form.IPanel; overload;
    procedure setStandardSubmit; overload;
    procedure setStandardSubmit(standardSubmit: Boolean); overload;
    procedure setSubmitOnAction; overload;
    procedure setSubmitOnAction(submitOnAction: Variant); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setTrackResetOnLoad; overload;
    procedure setTrackResetOnLoad(trackResetOnLoad: Boolean); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    function setValues: JExt.form.IPanel; overload;
    function setValues(values: Variant): JExt.form.IPanel; overload;
    function showMask: JExt.form.IPanel; overload;
    function showMask(cfg: Variant): JExt.form.IPanel; overload;
    function showMask(cfg: Variant; target: Variant): JExt.form.IPanel; overload;
    function submit: JExt.data.IConnection; overload;
    function submit(options: Variant): JExt.data.IConnection; overload;
  end;

//Ext.form

type
  JIFormPanel = class external(JExt.IPanel)
    api: Variant; // nullable
    baseCls: String; // nullable
    baseParams: Variant; // nullable
    enableSubmissionForm: Boolean; // nullable
    enctype: Variant; // nullable
    method: String; // nullable
    multipartDetection: Boolean; // nullable
    paramOrder: Variant; // nullable
    paramsAsHash: Boolean; // nullable
    record: JExt.data.IModel; // nullable
    scrollable: Variant; // nullable
    standardSubmit: Boolean; // nullable
    submitOnAction: Variant; // nullable
    timeout: Float; // nullable
    trackResetOnLoad: Boolean; // nullable
    url: String; // nullable
    waitMsgTarget: JExt.dom.IElement; // nullable
    waitTpl: Variant; // nullable
    function doSetDisabled: JExt.form.IPanel; overload;
    function doSetDisabled(newDisabled: Variant): JExt.form.IPanel; overload;
    function getApi: Variant;
    function getBaseCls: String;
    function getBaseParams: Variant;
    function getEnableSubmissionForm: Boolean;
    function getEnctype: Variant;
    function getMethod: String;
    function getMultipartDetection: Boolean;
    function getParamOrder: Variant;
    function getParamsAsHash: Boolean;
    function getRecord: JExt.data.IModel;
    function getStandardSubmit: Boolean;
    function getSubmitOnAction: Variant;
    function getTimeout: Float;
    function getTrackResetOnLoad: Boolean;
    function getUrl: String;
    function getValues: Variant; overload;
    function getValues(enabled: Boolean): Variant; overload;
    function getValues(enabled: Boolean; all: Boolean): Variant; overload;
    function hideMask: JExt.form.IPanel;
    function load: JExt.data.IConnection; overload;
    function load(options: Variant): JExt.data.IConnection; overload;
    function loadModel: JExt.form.IPanel; overload;
    function loadModel(record: JExt.data.IModel): JExt.form.IPanel; overload;
    function loadRecord: JExt.form.IPanel; overload;
    function loadRecord(record: JExt.data.IModel): JExt.form.IPanel; overload;
    function reset: JExt.form.IPanel;
    procedure setApi; overload;
    procedure setApi(api: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBaseParams; overload;
    procedure setBaseParams(baseParams: Variant); overload;
    procedure setEnableSubmissionForm; overload;
    procedure setEnableSubmissionForm(enableSubmissionForm: Boolean); overload;
    procedure setEnctype; overload;
    procedure setEnctype(enctype: Variant); overload;
    procedure setMethod; overload;
    procedure setMethod(method: String); overload;
    procedure setMultipartDetection; overload;
    procedure setMultipartDetection(multipartDetection: Boolean); overload;
    procedure setParamOrder; overload;
    procedure setParamOrder(paramOrder: Variant); overload;
    procedure setParamsAsHash; overload;
    procedure setParamsAsHash(paramsAsHash: Boolean); overload;
    function setRecord: JExt.form.IPanel; overload;
    function setRecord(record: JExt.data.IModel): JExt.form.IPanel; overload;
    procedure setStandardSubmit; overload;
    procedure setStandardSubmit(standardSubmit: Boolean); overload;
    procedure setSubmitOnAction; overload;
    procedure setSubmitOnAction(submitOnAction: Variant); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure setTrackResetOnLoad; overload;
    procedure setTrackResetOnLoad(trackResetOnLoad: Boolean); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    function setValues: JExt.form.IPanel; overload;
    function setValues(values: Variant): JExt.form.IPanel; overload;
    function showMask: JExt.form.IPanel; overload;
    function showMask(cfg: Variant): JExt.form.IPanel; overload;
    function showMask(cfg: Variant; target: Variant): JExt.form.IPanel; overload;
    function submit: JExt.data.IConnection; overload;
    function submit(options: Variant): JExt.data.IConnection; overload;
  end;

//Ext

type
  JFunction = class external 'Function'
    function alias: Variant; overload;
    function alias(&object: Variant): Variant; overload;
    function alias(&object: Variant; methodName: String): Variant; overload;
    function bind: Variant; overload;
    function bind(fn: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function clone: Variant; overload;
    function clone(method: Variant): Variant; overload;
    function createBuffered: Variant; overload;
    function createBuffered(fn: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed: Variant; overload;
    function createDelayed(fn: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createDelegate: Variant; overload;
    function createDelegate(fn: Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createInterceptor: Variant; overload;
    function createInterceptor(origFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant; returnValue: Variant): Variant; overload;
    function createSequence: Variant; overload;
    function createSequence(originalFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createThrottled: Variant; overload;
    function createThrottled(fn: Variant): Variant; overload;
    function createThrottled(fn: Variant; interval: Float): Variant; overload;
    function createThrottled(fn: Variant; interval: Float; scope: Variant): Variant; overload;
    function defer: Float; overload;
    function defer(fn: Variant): Float; overload;
    function defer(fn: Variant; millis: Float): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
    function flexSetter: Variant; overload;
    function flexSetter(fn: Variant): Variant; overload;
    function interceptAfter: Variant; overload;
    function interceptAfter(&object: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function interceptBefore: Variant; overload;
    function interceptBefore(&object: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function pass: Variant; overload;
    function pass(fn: Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
  end;

  JIFunction = class external
  end;

//Ext.util

type
  JFunctions = class external 'Functions'
    function alias: Variant; overload;
    function alias(&object: Variant): Variant; overload;
    function alias(&object: Variant; methodName: String): Variant; overload;
    function bind: Variant; overload;
    function bind(fn: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function clone: Variant; overload;
    function clone(method: Variant): Variant; overload;
    function createBuffered: Variant; overload;
    function createBuffered(fn: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant): Variant; overload;
    function createBuffered(fn: Variant; buffer: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed: Variant; overload;
    function createDelayed(fn: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant): Variant; overload;
    function createDelayed(fn: Variant; delay: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createDelegate: Variant; overload;
    function createDelegate(fn: Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
    function createDelegate(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
    function createInterceptor: Variant; overload;
    function createInterceptor(origFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant; returnValue: Variant): Variant; overload;
    function createSequence: Variant; overload;
    function createSequence(originalFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant): Variant; overload;
    function createSequence(originalFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
    function createThrottled: Variant; overload;
    function createThrottled(fn: Variant): Variant; overload;
    function createThrottled(fn: Variant; interval: Float): Variant; overload;
    function createThrottled(fn: Variant; interval: Float; scope: Variant): Variant; overload;
    function defer: Float; overload;
    function defer(fn: Variant): Float; overload;
    function defer(fn: Variant; millis: Float): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
    function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
    function flexSetter: Variant; overload;
    function flexSetter(fn: Variant): Variant; overload;
    function interceptAfter: Variant; overload;
    function interceptAfter(&object: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptAfter(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function interceptBefore: Variant; overload;
    function interceptBefore(&object: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant): Variant; overload;
    function interceptBefore(&object: Variant; methodName: String; fn: Variant; scope: Variant): Variant; overload;
    function pass: Variant; overload;
    function pass(fn: Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant): Variant; overload;
    function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
  end;

  JIFunctions = class external
  end;

//Ext.fx.animation

type
  JIAbstract = class external(JExt.IEvented)
    before: Variant; // nullable
    easing: String; // nullable
    procedure destroy;
    function getAfter: Variant;
    function getBefore: Variant;
    function getDelay: Float;
    function getDirection: String;
    function getDuration: Float;
    function getEasing: String;
    function getElement: Variant;
    function getIteration: Float;
    function getName: String;
    function getOnBeforeEnd: Variant;
    function getOnBeforeStart: Variant;
    function getOnEnd: Variant;
    function getPreserveEndState: Boolean;
    function getReplacePrevious: Boolean;
    function getReverse: Variant;
    function getScope: Variant;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setDelay; overload;
    procedure setDelay(delay: Float); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setIteration; overload;
    procedure setIteration(iteration: Float); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setOnBeforeEnd; overload;
    procedure setOnBeforeEnd(onBeforeEnd: Variant); overload;
    procedure setOnBeforeStart; overload;
    procedure setOnBeforeStart(onBeforeStart: Variant); overload;
    procedure setOnEnd; overload;
    procedure setOnEnd(onEnd: Variant); overload;
    procedure setPreserveEndState; overload;
    procedure setPreserveEndState(preserveEndState: Boolean); overload;
    procedure setReplacePrevious; overload;
    procedure setReplacePrevious(replacePrevious: Boolean); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
  end;

//Ext.fx.animation

type
  JICube = class external(JExt.fx.animation.IAbstract)
    before: Variant; // nullable
    direction: String; // nullable
    function getAfter: Variant;
    function getBefore: Variant;
    function getDirection: String;
    function getOut: Boolean;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
  end;

//Ext.fx.animation

type
  JIFade = class external(JExt.fx.animation.IAbstract)
    before: Variant; // nullable
    out: Boolean; // nullable
    function getAfter: Variant;
    function getBefore: Variant;
    function getOut: Boolean;
    function getReverse: Variant;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.animation

type
  JIFadeIn = class external(JExt.fx.animation.IAbstract)
    before: Variant; // nullable
    out: Boolean; // nullable
    function getAfter: Variant;
    function getBefore: Variant;
    function getOut: Boolean;
    function getReverse: Variant;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.animation

type
  JIFadeOut = class external(JExt.fx.animation.IFade)
    before: Variant; // nullable
    function getBefore: Variant;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
  end;

//Ext.fx.animation

type
  JIFlip = class external(JExt.fx.animation.IAbstract)
    direction: String; // nullable
    easing: String; // nullable
    function getDirection: String;
    function getEasing: String;
    function getHalf: Boolean;
    function getOut: Variant;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setHalf; overload;
    procedure setHalf(half: Boolean); overload;
    procedure setOut; overload;
    procedure setOut(out: Variant); overload;
  end;

//Ext.fx

type
  JIAnimation = class external(JExt.IBase)
    &type: String; // nullable
  end;

//Ext.fx.animation

type
  JIPop = class external(JExt.fx.animation.IAbstract)
    before: Variant; // nullable
    out: Boolean; // nullable
    function getAfter: Variant;
    function getBefore: Variant;
    function getOut: Boolean;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
  end;

//Ext.fx.animation

type
  JIPopIn = class external(JExt.fx.animation.IAbstract)
    before: Variant; // nullable
    out: Boolean; // nullable
    function getAfter: Variant;
    function getBefore: Variant;
    function getOut: Boolean;
    procedure setAfter; overload;
    procedure setAfter(after: Variant); overload;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
  end;

//Ext.fx.animation

type
  JIPopOut = class external(JExt.fx.animation.IPop)
    before: Variant; // nullable
    function getBefore: Variant;
    procedure setBefore; overload;
    procedure setBefore(before: Variant); overload;
  end;

//Ext.fx.animation

type
  JISlide = class external(JExt.fx.animation.IAbstract)
    direction: String; // nullable
    easing: String; // nullable
    offset: Float; // nullable
    out: Boolean; // nullable
    function getDirection: String;
    function getEasing: String;
    function getIsElementBoxFit: Boolean;
    function getOffset: Float;
    function getOut: Boolean;
    function getUseCssTransform: Boolean;
    procedure setContainerBox; overload;
    procedure setContainerBox(containerBox: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setElementBox; overload;
    procedure setElementBox(elementBox: String); overload;
    procedure setIsElementBoxFit; overload;
    procedure setIsElementBoxFit(isElementBoxFit: Boolean); overload;
    procedure setOffset; overload;
    procedure setOffset(offset: Float); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
    procedure setUseCssTransform; overload;
    procedure setUseCssTransform(useCssTransform: Boolean); overload;
  end;

//Ext.fx.animation

type
  JISlideIn = class external(JExt.fx.animation.IAbstract)
    direction: String; // nullable
    easing: String; // nullable
    offset: Float; // nullable
    out: Boolean; // nullable
    function getDirection: String;
    function getEasing: String;
    function getIsElementBoxFit: Boolean;
    function getOffset: Float;
    function getOut: Boolean;
    function getUseCssTransform: Boolean;
    procedure setContainerBox; overload;
    procedure setContainerBox(containerBox: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setElementBox; overload;
    procedure setElementBox(elementBox: String); overload;
    procedure setIsElementBoxFit; overload;
    procedure setIsElementBoxFit(isElementBoxFit: Boolean); overload;
    procedure setOffset; overload;
    procedure setOffset(offset: Float); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
    procedure setUseCssTransform; overload;
    procedure setUseCssTransform(useCssTransform: Boolean); overload;
  end;

//Ext.fx.animation

type
  JISlideOut = class external(JExt.fx.animation.ISlide)
  end;

//Ext.fx.animation

type
  JIWipe = class external(JExt.fx.IAnimation)
    direction: String; // nullable
    easing: String; // nullable
    out: Boolean; // nullable
    function getDirection: String;
    function getEasing: String;
    function getOut: Boolean;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
  end;

//Ext.fx.animation

type
  JIWipeIn = class external(JExt.fx.IAnimation)
    direction: String; // nullable
    easing: String; // nullable
    out: Boolean; // nullable
    function getDirection: String;
    function getEasing: String;
    function getOut: Boolean;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setEasing; overload;
    procedure setEasing(easing: String); overload;
    procedure setOut; overload;
    procedure setOut(out: Boolean); overload;
  end;

//Ext.fx.animation

type
  JIWipeOut = class external(JExt.fx.animation.IWipe)
  end;

//Ext.fx.easing

type
  JIAbstract = class external(JExt.IBase)
    function getStartTime: Float;
    function getStartValue: Float;
    procedure setStartTime; overload;
    procedure setStartTime(startTime: Float); overload;
    procedure setStartValue; overload;
    procedure setStartValue(startValue: Float); overload;
  end;

//Ext.fx.easing

type
  JIBounce = class external(JExt.fx.easing.IAbstract)
    function getAcceleration: Float;
    function getSpringTension: Float;
    function getStartVelocity: Float;
    procedure setAcceleration; overload;
    procedure setAcceleration(acceleration: Float); overload;
    procedure setSpringTension; overload;
    procedure setSpringTension(springTension: Float); overload;
    procedure setStartVelocity; overload;
    procedure setStartVelocity(startVelocity: Float); overload;
  end;

//Ext.fx.easing

type
  JIBoundMomentum = class external(JExt.fx.easing.IAbstract)
    bounce: Variant; // nullable
    minVelocity: Float; // nullable
    momentum: Variant; // nullable
    startVelocity: Float; // nullable
    function getBounce: Variant;
    function getMaxMomentumValue: Float;
    function getMinMomentumValue: Float;
    function getMinVelocity: Float;
    function getMomentum: Variant;
    function getStartVelocity: Float;
    procedure setBounce; overload;
    procedure setBounce(bounce: Variant); overload;
    procedure setMaxMomentumValue; overload;
    procedure setMaxMomentumValue(maxMomentumValue: Float); overload;
    procedure setMinMomentumValue; overload;
    procedure setMinMomentumValue(minMomentumValue: Float); overload;
    procedure setMinVelocity; overload;
    procedure setMinVelocity(minVelocity: Float); overload;
    procedure setMomentum; overload;
    procedure setMomentum(momentum: Variant); overload;
    procedure setStartVelocity; overload;
    procedure setStartVelocity(startVelocity: Float); overload;
  end;

//Ext.fx.easing

type
  JIEaseIn = class external(JExt.fx.easing.ILinear)
    function getDuration: Float;
    function getExponent: Float;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setExponent; overload;
    procedure setExponent(exponent: Float); overload;
  end;

//Ext.fx.easing

type
  JIEaseOut = class external(JExt.fx.easing.ILinear)
    function getDuration: Float;
    function getExponent: Float;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setExponent; overload;
    procedure setExponent(exponent: Float); overload;
  end;

//Ext.fx

type
  JIEasing = class external(JExt.IBase)
  end;

//Ext.fx.easing

type
  JILinear = class external(JExt.fx.easing.IAbstract)
    function getDuration: Float;
    function getEndValue: Float;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setEndValue; overload;
    procedure setEndValue(endValue: Float); overload;
  end;

//Ext.fx.easing

type
  JIMomentum = class external(JExt.fx.easing.IAbstract)
    function getAcceleration: Float;
    function getFriction: Float;
    function getStartVelocity: Float;
    procedure setAcceleration; overload;
    procedure setAcceleration(acceleration: Float); overload;
    procedure setFriction; overload;
    procedure setFriction(friction: Float); overload;
    procedure setStartVelocity; overload;
    procedure setStartVelocity(startVelocity: Float); overload;
  end;

//Ext.fx.layout.card

type
  JIAbstract = class external(JExt.IEvented)
    procedure destroy;
    function getDirection: String;
    function getDuration: Variant;
    function getLayout: Variant;
    function getReverse: Variant;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDuration; overload;
    procedure setDuration(duration: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JICover = class external(JExt.fx.layout.card.IStyle)
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    function getReverse: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JICube = class external(JExt.fx.layout.card.IStyle)
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    function getReverse: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JIFade = class external(JExt.fx.layout.card.IStyle)
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    function getReverse: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
    procedure setReverse; overload;
    procedure setReverse(reverse: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JIFlip = class external(JExt.fx.layout.card.IStyle)
    function getDuration: Float;
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
  end;

//Ext.fx.layout

type
  JICard = class external(JExt.IBase)
  end;

//Ext.fx.layout.card

type
  JIPop = class external(JExt.fx.layout.card.IStyle)
    function getDuration: Float;
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JIReveal = class external(JExt.fx.layout.card.IStyle)
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JIScroll = class external(JExt.fx.layout.card.IAbstract)
    function getDuration: Float;
    procedure setDuration; overload;
    procedure setDuration(duration: Float); overload;
  end;

//Ext.fx.layout.card

type
  JIScrollCover = class external(JExt.fx.layout.card.IScroll)
  end;

//Ext.fx.layout.card

type
  JIScrollReveal = class external(JExt.fx.layout.card.IScroll)
  end;

//Ext.fx.layout.card

type
  JISlide = class external(JExt.fx.layout.card.IStyle)
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
  end;

//Ext.fx.layout.card

type
  JIStyle = class external(JExt.fx.layout.card.IAbstract)
    procedure destroy;
    function getInAnimation: Variant;
    function getOutAnimation: Variant;
    procedure setInAnimation; overload;
    procedure setInAnimation(inAnimation: Variant); overload;
    procedure setOutAnimation; overload;
    procedure setOutAnimation(outAnimation: Variant); overload;
  end;

//Ext.fx.runner

type
  JICss = class external(JExt.IEvented)
  end;

//Ext.fx.runner

type
  JICssAnimation = class external(JExt.fx.runner.ICss)
  end;

//Ext.fx.runner

type
  JICssTransition = class external(JExt.fx.runner.ICss)
  end;

//Ext.fx

type
  JIRunner = class external(JExt.IBase)
  end;

//Ext.fx

type
  JIState = class external(JExt.IBase)
  end;

//Ext

type
  JIImg = class external(JExt.IComponent)
    backgroundCls: String; // nullable
    baseCls: String; // nullable
    imageCls: String; // nullable
    mode: String; // nullable
    src: String; // nullable
    procedure destroy;
    function getBackgroundCls: String;
    function getBaseCls: String;
    function getImageCls: String;
    function getMode: String;
    function getSrc: String;
    function hide: JExt.IComponent;
    procedure initialize;
    procedure setBackgroundCls; overload;
    procedure setBackgroundCls(backgroundCls: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setImageCls; overload;
    procedure setImageCls(imageCls: String); overload;
    procedure setMode; overload;
    procedure setMode(mode: String); overload;
    procedure setSrc; overload;
    procedure setSrc(src: String); overload;
    function show: JExt.IComponent;
  end;

//Ext

type
  JIIs = class external
  end;

//Ext

type
  JIItemCollection = class external(JExt.util.IMixedCollection)
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
  end;

//Ext

procedure application; overload;
procedure application(config: Variant); overload;
function apply: Variant; overload;
function apply(&object: Variant): Variant; overload;
function apply(&object: Variant; config: Variant): Variant; overload;
function apply(&object: Variant; config: Variant; defaults: Variant): Variant; overload;
function applyIf: Variant; overload;
function applyIf(&object: Variant): Variant; overload;
function applyIf(&object: Variant; config: Variant): Variant; overload;
function bind: Variant; overload;
function bind(fn: Variant): Variant; overload;
function bind(fn: Variant; scope: Variant): Variant; overload;
function bind(fn: Variant; scope: Variant; args: array of Variant): Variant; overload;
function bind(fn: Variant; scope: Variant; args: array of Variant; appendArgs: Variant): Variant; overload;
procedure callback; overload;
procedure callback(callback: Variant); overload;
procedure callback(callback: Variant; scope: Variant); overload;
procedure callback(callback: Variant; scope: Variant; args: array of Variant); overload;
procedure callback(callback: Variant; scope: Variant; args: array of Variant; delay: Float); overload;
function clean: array of Variant; overload;
function clean(array: array of Variant): array of Variant; overload;
function clone: Variant; overload;
function clone(item: Variant): Variant; overload;
function copyTo: Variant; overload;
function copyTo(dest: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant; names: Variant): Variant; overload;
function copyTo(dest: Variant; source: Variant; names: Variant; usePrototypeKeys: Boolean): Variant; overload;
function create: Variant; overload;
function create(name: String): Variant; overload;
function create(name: String; args: Variant): Variant; overload;
function createByAlias(alias: String; args: array of Variant): Variant;
function createInterceptor: Variant; overload;
function createInterceptor(origFn: Variant): Variant; overload;
function createInterceptor(origFn: Variant; newFn: Variant): Variant; overload;
function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant): Variant; overload;
function createInterceptor(origFn: Variant; newFn: Variant; scope: Variant; returnValue: Variant): Variant; overload;
procedure createWidget;
function decode: Variant; overload;
function decode(json: String): Variant; overload;
function decode(json: String; safe: Boolean): Variant; overload;
function defer: Float; overload;
function defer(fn: Variant): Float; overload;
function defer(fn: Variant; millis: Float): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant): Float; overload;
function defer(fn: Variant; millis: Float; scope: Variant; args: array of Variant; appendArgs: Variant): Float; overload;
function define: JExt.IBase; overload;
function define(className: String): JExt.IBase; overload;
function define(className: String; data: Variant): JExt.IBase; overload;
function define(className: String; data: Variant; createdFn: Variant): JExt.IBase; overload;
procedure destroy(args: array of Variant);
procedure dispatch;
function each: Boolean; overload;
function each(iterable: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant; scope: Variant): Boolean; overload;
function each(iterable: Variant; fn: Variant; scope: Variant; reverse: Boolean): Boolean; overload;
function encode: String; overload;
function encode(o: Variant): String; overload;
function exclude: Variant; overload;
function exclude(excludes: array of Variant): Variant; overload;
function extend: Variant; overload;
function extend(superclass: Variant): Variant; overload;
function extend(superclass: Variant; overrides: Variant): Variant; overload;
procedure factory; overload;
procedure factory(config: Variant); overload;
procedure factory(config: Variant; classReference: String); overload;
procedure factory(config: Variant; classReference: String; instance: Variant); overload;
procedure factory(config: Variant; classReference: String; instance: Variant; aliasNamespace: String); overload;
function flatten: array of Variant; overload;
function flatten(array: array of Variant): array of Variant; overload;
function fly: JExt.dom.IElement; overload;
function fly(element: Variant): JExt.dom.IElement; overload;
function fly(element: Variant; named: String): JExt.dom.IElement; overload;
function get: JExt.dom.IElement; overload;
function get(element: Variant): JExt.dom.IElement; overload;
function getBody: JExt.IElement;
procedure getClass;
function getClassName: String; overload;
function getClassName(&object: Variant): String; overload;
function getCmp: JExt.IComponent; overload;
function getCmp(id: String): JExt.IComponent; overload;
function getDisplayName: String; overload;
function getDisplayName(&object: Variant): String; overload;
function getDoc: JExt.IElement;
function getDom: JHTMLElement; overload;
function getDom(el: Variant): JHTMLElement; overload;
function getHead: JExt.IElement;
procedure getOrientation;
function getStore: JExt.data.IStore; overload;
function getStore(store: Variant): JExt.data.IStore; overload;
function htmlDecode: String; overload;
function htmlDecode(value: String): String; overload;
function htmlEncode: String; overload;
function htmlEncode(value: String): String; overload;
function id: String; overload;
function id(el: Variant): String; overload;
function id(el: Variant; prefix: String): String; overload;
function isArray: Boolean; overload;
function isArray(target: Variant): Boolean; overload;
function isBoolean: Boolean; overload;
function isBoolean(value: Variant): Boolean; overload;
function isDate: Boolean; overload;
function isDate(&object: Variant): Boolean; overload;
function isDefined: Boolean; overload;
function isDefined(value: Variant): Boolean; overload;
function isElement: Boolean; overload;
function isElement(value: Variant): Boolean; overload;
function isEmpty: Boolean; overload;
function isEmpty(value: Variant): Boolean; overload;
function isEmpty(value: Variant; allowEmptyString: Boolean): Boolean; overload;
function isFunction: Boolean; overload;
function isFunction(value: Variant): Boolean; overload;
function isIterable: Boolean; overload;
function isIterable(value: Variant): Boolean; overload;
function isMSDate: Boolean; overload;
function isMSDate(value: String): Boolean; overload;
function isNumber: Boolean; overload;
function isNumber(value: Variant): Boolean; overload;
function isNumeric: Boolean; overload;
function isNumeric(value: Variant): Boolean; overload;
function isObject: Boolean; overload;
function isObject(value: Variant): Boolean; overload;
function isPrimitive: Boolean; overload;
function isPrimitive(value: Variant): Boolean; overload;
function isString: Boolean; overload;
function isString(value: Variant): Boolean; overload;
function isTextNode: Boolean; overload;
function isTextNode(value: Variant): Boolean; overload;
procedure iterate; overload;
procedure iterate(&object: Variant); overload;
procedure iterate(&object: Variant; fn: Variant); overload;
procedure iterate(&object: Variant; fn: Variant; scope: Variant); overload;
function max: Variant; overload;
function max(array: Variant): Variant; overload;
function max(array: Variant; comparisonFn: Variant): Variant; overload;
function mean: Float; overload;
function mean(array: array of Variant): Float; overload;
procedure merge;
function min: Variant; overload;
function min(array: Variant): Variant; overload;
function min(array: Variant; comparisonFn: Variant): Variant; overload;
function namespace: Variant; overload;
function namespace(namespace1: String): Variant; overload;
function namespace(namespace1: String; namespace2: String): Variant; overload;
function namespace(namespace1: String; namespace2: String; etc: String): Variant; overload;
procedure ns;
procedure num;
procedure onReady; overload;
procedure onReady(fn: Variant); overload;
procedure onReady(fn: Variant; scope: Variant); overload;
procedure onReady(fn: Variant; scope: Variant; options: Boolean); overload;
procedure override; overload;
procedure override(cls: Variant); overload;
procedure override(cls: Variant; overrides: Variant); overload;
function pass: Variant; overload;
function pass(fn: Variant): Variant; overload;
function pass(fn: Variant; args: array of Variant): Variant; overload;
function pass(fn: Variant; args: array of Variant; scope: Variant): Variant; overload;
function pluck: array of Variant; overload;
function pluck(array: Variant): array of Variant; overload;
function pluck(array: Variant; propertyName: String): array of Variant; overload;
procedure preg;
function query: array of JHTMLElement; overload;
function query(selector: String): array of JHTMLElement; overload;
function query(selector: String; root: Variant): array of JHTMLElement; overload;
procedure redirect;
procedure reg;
procedure regApplication;
procedure regController;
procedure regLayout;
function regModel: JExt.data.IModel; overload;
function regModel(name: String): JExt.data.IModel; overload;
function regModel(name: String; config: Variant): JExt.data.IModel; overload;
procedure regStore; overload;
procedure regStore(id: String); overload;
procedure regStore(id: String; config: Variant); overload;
procedure removeNode; overload;
procedure removeNode(node: JHTMLElement); overload;
procedure repaint;
procedure require; overload;
procedure require(expressions: Variant); overload;
procedure require(expressions: Variant; fn: Variant); overload;
procedure require(expressions: Variant; fn: Variant; scope: Variant); overload;
procedure require(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
function select: JExt.dom.ICompositeElementLite; overload;
function select(selector: Variant): JExt.dom.ICompositeElementLite; overload;
function select(selector: Variant; composite: Boolean): JExt.dom.ICompositeElementLite; overload;
procedure setup; overload;
procedure setup(config: Variant); overload;
function sum: Float; overload;
function sum(array: array of Variant): Float; overload;
procedure syncRequire; overload;
procedure syncRequire(expressions: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant); overload;
procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
function toArray: array of Variant; overload;
function toArray(iterable: Variant): array of Variant; overload;
function toArray(iterable: Variant; start: Float): array of Variant; overload;
function toArray(iterable: Variant; start: Float; &end: Float): array of Variant; overload;
function type: String; overload;
function type(value: Variant): String; overload;
function typeOf: String; overload;
function typeOf(value: Variant): String; overload;
function unique: array of Variant; overload;
function unique(array: array of Variant): array of Variant; overload;
function urlAppend: String; overload;
function urlAppend(url: String): String; overload;
function urlAppend(url: String; &string: String): String; overload;
procedure urlDecode;
procedure urlEncode;
function valueFrom: Variant; overload;
function valueFrom(value: Variant): Variant; overload;
function valueFrom(value: Variant; defaultValue: Variant): Variant; overload;
function valueFrom(value: Variant; defaultValue: Variant; allowBlank: Boolean): Variant; overload;
function widget: Variant; overload;
function widget(name: String): Variant; overload;

var
  SSL_SECURE_URL: Boolean;
  emptyFn: Variant;
  enableGarbageCollector: Boolean;
  enableListenerCollection: Boolean;
  enumerables: array of String;
  frameStartTime: Variant;
  isSecure: Boolean;
  version: String;

//Ext

type
  JJSON = class external 'JSON'
    function decode: Variant; overload;
    function decode(json: String): Variant; overload;
    function decode(json: String; safe: Boolean): Variant; overload;
    function encode: String; overload;
    function encode(o: Variant): String; overload;
    function encodeDate: String; overload;
    function encodeDate(d: Variant): String; overload;
  end;

  JIJSON = class external
  end;

//Ext

type
  JILabel = class external(JExt.IComponent)
    baseCls: String; // nullable
    html: String; // nullable
    function getBaseCls: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
  end;

//Ext.layout

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.layout

type
  JIBox = class external(JExt.layout.IDefault)
    align: String; // nullable
    pack: String; // nullable
    function getAlign: String;
    function getOrient: String;
    function getPack: String;
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant); overload;
    procedure setAlign; overload;
    procedure setAlign(align: String); overload;
    procedure setOrient; overload;
    procedure setOrient(orient: String); overload;
    procedure setPack; overload;
    procedure setPack(pack: String); overload;
  end;

//Ext.layout

type
  JICard = class external(JExt.layout.IDefault)
    procedure destroy;
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant; destroying: Variant); overload;
  end;

//Ext.layout

type
  JIDefault = class external(JExt.layout.IAbstract)
    animation: JExt.fx.layout.ICard; // nullable
    procedure destroy;
    function getAnimation: JExt.fx.layout.ICard;
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: JExt.IComponent); overload;
    procedure onItemInnerStateChange(item: JExt.IComponent; isInner: Boolean); overload;
    procedure onItemInnerStateChange(item: JExt.IComponent; isInner: Boolean; destroying: Boolean); overload;
    procedure setAnimation; overload;
    procedure setAnimation(animation: JExt.fx.layout.ICard); overload;
  end;

//Ext.layout

type
  JIFit = class external(JExt.layout.IDefault)
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant); overload;
  end;

//Ext.layout

type
  JIFlexBox = class external(JExt.layout.IBox)
    align: String; // nullable
    function getAlign: String;
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant); overload;
    procedure setAlign; overload;
    procedure setAlign(align: String); overload;
    procedure setItemFlex; overload;
    procedure setItemFlex(item: JExt.IComponent); overload;
    procedure setItemFlex(item: JExt.IComponent; flex: Float); overload;
  end;

//Ext.layout

type
  JIFloat = class external(JExt.layout.IDefault)
    function getDirection: String;
    procedure onItemInnerStateChange; overload;
    procedure onItemInnerStateChange(item: Variant); overload;
    procedure onItemInnerStateChange(item: Variant; isInner: Variant); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
  end;

//Ext.layout

type
  JIHBox = class external(JExt.layout.IFlexBox)
  end;

//Ext.layout

type
  JIVBox = class external(JExt.layout.IFlexBox)
    function getOrient: String;
    procedure setOrient; overload;
    procedure setOrient(orient: String); overload;
  end;

//Ext.layout.wrapper

type
  JIBoxDock = class external(JExt.IBase)
    procedure destroy;
    function getBodyElement: Variant;
    function getContainer: Variant;
    function getDirection: String;
    function getElement: Variant;
    function getInnerWrapper: Variant;
    function getSizeState: Boolean;
    procedure setBodyElement; overload;
    procedure setBodyElement(bodyElement: Variant); overload;
    procedure setContainer; overload;
    procedure setContainer(container: Variant); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setInnerWrapper; overload;
    procedure setInnerWrapper(innerWrapper: Variant); overload;
    procedure setSizeState; overload;
    procedure setSizeState(sizeState: Boolean); overload;
  end;

//Ext.layout.wrapper

type
  JIDock = class external(JExt.IBase)
    procedure destroy;
    function getBodyElement: Variant;
    function getContainer: Variant;
    function getDirection: String;
    function getElement: Variant;
    function getInnerWrapper: Variant;
    function getSizeState: Boolean;
    procedure setBodyElement; overload;
    procedure setBodyElement(bodyElement: Variant); overload;
    procedure setContainer; overload;
    procedure setContainer(container: Variant); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setInnerWrapper; overload;
    procedure setInnerWrapper(innerWrapper: Variant); overload;
    procedure setSizeState; overload;
    procedure setSizeState(sizeState: Boolean); overload;
  end;

//Ext.layout.wrapper

type
  JIInner = class external(JExt.IBase)
    function getContainer: Variant;
    function getSizeState: Variant;
    procedure setContainer; overload;
    procedure setContainer(container: Variant); overload;
    procedure setSizeState; overload;
    procedure setSizeState(sizeState: Variant); overload;
  end;

//Ext

type
  JLoader = class external 'Loader'
    disableCaching: Boolean;
    disableCachingParam: String;
    enabled: Boolean;
    paths: Variant;
    history: array of Variant;
    function addClassPathMappings: JExt.ILoader; overload;
    function addClassPathMappings(paths: JObject): JExt.ILoader; overload;
    function exclude: Variant; overload;
    function exclude(excludes: array of Variant): Variant; overload;
    function getConfig: Variant; overload;
    function getConfig(name: String): Variant; overload;
    function getPath: String; overload;
    function getPath(className: String): String; overload;
    procedure onReady; overload;
    procedure onReady(fn: Variant); overload;
    procedure onReady(fn: Variant; scope: Variant); overload;
    procedure onReady(fn: Variant; scope: Variant; withDomReady: Boolean); overload;
    procedure require; overload;
    procedure require(expressions: Variant); overload;
    procedure require(expressions: Variant; fn: Variant); overload;
    procedure require(expressions: Variant; fn: Variant; scope: Variant); overload;
    procedure require(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
    function setConfig: JExt.ILoader; overload;
    function setConfig(name: Variant): JExt.ILoader; overload;
    function setConfig(name: Variant; value: Variant): JExt.ILoader; overload;
    function setPath: JExt.ILoader; overload;
    function setPath(name: Variant): JExt.ILoader; overload;
    function setPath(name: Variant; path: String): JExt.ILoader; overload;
    procedure syncRequire; overload;
    procedure syncRequire(expressions: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant); overload;
    procedure syncRequire(expressions: Variant; fn: Variant; scope: Variant; excludes: Variant); overload;
  end;

  JILoader = class external
  end;

//Ext

type
  JILoadMask = class external(JExt.IMask)
    cls: String; // nullable
    indicator: Boolean; // nullable
    message: String; // nullable
    messageCls: String; // nullable
    msg: String; // nullable
    msgCls: String; // nullable
    store: JExt.data.IStore; // nullable
    procedure bindStore; overload;
    procedure bindStore(store: JExt.data.IStore); overload;
    function getCls: String;
    function getIndicator: Boolean;
    function getMessage: String;
    function getMessageCls: String;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setIndicator; overload;
    procedure setIndicator(indicator: Boolean); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
    procedure setMessageCls; overload;
    procedure setMessageCls(messageCls: String); overload;
  end;

//Ext

type
  JLogger = class external 'Logger'
    procedure deprecate;
    procedure error;
    procedure info;
    function log: JExt.ILogger; overload;
    function log(message: String): JExt.ILogger; overload;
    function log(message: String; priority: Float): JExt.ILogger; overload;
    procedure verbose;
    procedure warn;
  end;

  JILogger = class external
  end;

//Ext

type
  JIMap = class external(JExt.IContainer)
    baseCls: String; // nullable
    geo: JExt.util.IGeolocation; // nullable
    map: Variant; // nullable
    mapListeners: Variant; // nullable
    mapOptions: Variant; // nullable
    maskMap: Boolean; // nullable
    maskMapCls: String; // nullable
    useCurrentLocation: Variant; // nullable
    function getBaseCls: String;
    function getGeo: JExt.util.IGeolocation;
    function getMap: Variant;
    function getMapListeners: Variant;
    function getState: Variant;
    function getUseCurrentLocation: Variant;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setGeo; overload;
    procedure setGeo(geo: JExt.util.IGeolocation); overload;
    procedure setMap; overload;
    procedure setMap(map: Variant); overload;
    procedure setMapCenter; overload;
    procedure setMapCenter(coordinates: Variant); overload;
    procedure setMapListeners; overload;
    procedure setMapListeners(mapListeners: Variant); overload;
    procedure setMapOptions; overload;
    procedure setMapOptions(mapOptions: Variant); overload;
    procedure setUseCurrentLocation; overload;
    procedure setUseCurrentLocation(useCurrentLocation: Variant); overload;
    procedure update; overload;
    procedure update(coordinates: Variant); overload;
  end;

//Ext

type
  JIMask = class external(JExt.IComponent)
    baseCls: String; // nullable
    transparent: Boolean; // nullable
    function getBaseCls: String;
    function getTransparent: Boolean;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setTransparent; overload;
    procedure setTransparent(transparent: Boolean); overload;
  end;

//Ext

type
  JIMedia = class external(JExt.IComponent)
    autoPause: Boolean; // nullable
    autoResume: Boolean; // nullable
    enableControls: Boolean; // nullable
    loop: Boolean; // nullable
    media: JExt.IElement; // nullable
    muted: Boolean; // nullable
    preload: Boolean; // nullable
    url: String; // nullable
    volume: Float; // nullable
    procedure destroy;
    function getAutoPause: Boolean;
    function getAutoResume: Boolean;
    function getCurrentTime: Float;
    function getDuration: Float;
    function getEnableControls: Boolean;
    function getLoop: Boolean;
    function getMedia: JExt.IElement;
    function getMuted: Boolean;
    function getPreload: Boolean;
    function getUrl: String;
    function getVolume: Float;
    procedure initialize;
    function isPlaying: Boolean;
    procedure pause;
    procedure play;
    procedure setAutoPause; overload;
    procedure setAutoPause(autoPause: Boolean); overload;
    procedure setAutoResume; overload;
    procedure setAutoResume(autoResume: Boolean); overload;
    procedure setEnableControls; overload;
    procedure setEnableControls(enableControls: Boolean); overload;
    procedure setLoop; overload;
    procedure setLoop(loop: Boolean); overload;
    procedure setMedia; overload;
    procedure setMedia(media: JExt.IElement); overload;
    procedure setMuted; overload;
    procedure setMuted(muted: Boolean); overload;
    procedure setPreload; overload;
    procedure setPreload(preload: Boolean); overload;
    procedure setUrl; overload;
    procedure setUrl(url: String); overload;
    procedure setVolume; overload;
    procedure setVolume(volume: Float); overload;
    procedure stop;
    procedure toggle;
    procedure updateEnableControls; overload;
    procedure updateEnableControls(enableControls: Variant); overload;
    procedure updateLoop; overload;
    procedure updateLoop(loop: Variant); overload;
    procedure updateUrl; overload;
    procedure updateUrl(newUrl: Variant); overload;
  end;

//Ext

type
  JIMenu = class external(JExt.ISheet)
    baseCls: String; // nullable
    bottom: Variant; // nullable
    defaultType: String; // nullable
    height: Variant; // nullable
    left: Variant; // nullable
    right: Variant; // nullable
    width: Variant; // nullable
    procedure doSetHidden;
    function getBaseCls: String;
    function getBottom: Float;
    function getDefaultType: String;
    function getHeight: String;
    function getLeft: Float;
    function getRight: Float;
    function getWidth: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Float); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setHeight; overload;
    procedure setHeight(height: String); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Float); overload;
    procedure setRight; overload;
    procedure setRight(right: Float); overload;
    procedure setWidth; overload;
    procedure setWidth(width: String); overload;
  end;

//Ext

type
  JIMessageBox = class external(JExt.ISheet)
    baseCls: String; // nullable
    buttons: Variant; // nullable
    defaultTextHeight: Float; // nullable
    hideAnimation: Variant; // nullable
    icon: String; // nullable
    iconCls: String; // nullable
    layout: Variant; // nullable
    message: String; // nullable
    msg: String; // nullable
    prompt: Variant; // nullable
    showAnimation: Variant; // nullable
    title: String; // nullable
    ui: String; // nullable
    zIndex: Float; // nullable
    function alert: JExt.IMessageBox; overload;
    function alert(title: String): JExt.IMessageBox; overload;
    function alert(title: String; message: String): JExt.IMessageBox; overload;
    function alert(title: String; message: String; fn: Variant): JExt.IMessageBox; overload;
    function alert(title: String; message: String; fn: Variant; scope: Variant): JExt.IMessageBox; overload;
    function confirm: JExt.IMessageBox; overload;
    function confirm(title: String): JExt.IMessageBox; overload;
    function confirm(title: String; message: String): JExt.IMessageBox; overload;
    function confirm(title: String; message: String; fn: Variant): JExt.IMessageBox; overload;
    function confirm(title: String; message: String; fn: Variant; scope: Variant): JExt.IMessageBox; overload;
    function getBaseCls: String;
    function getButtons: Variant;
    function getDefaultTextHeight: Float;
    function getLayout: Variant;
    function getPrompt: Variant;
    function getTitle: String;
    function getUi: String;
    function getZIndex: Float;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setButtons; overload;
    procedure setButtons(buttons: Variant); overload;
    procedure setDefaultTextHeight; overload;
    procedure setDefaultTextHeight(defaultTextHeight: Float); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    function setIcon: JExt.IMessageBox; overload;
    function setIcon(iconCls: String): JExt.IMessageBox; overload;
    procedure setIconCls; overload;
    procedure setIconCls(iconCls: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
    procedure setPrompt; overload;
    procedure setPrompt(prompt: Variant); overload;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zIndex: Float); overload;
    function show: JExt.IMessageBox; overload;
    function show(config: Variant): JExt.IMessageBox; overload;
    function updateText: JExt.IMessageBox; overload;
    function updateText(message: String): JExt.IMessageBox; overload;
  end;

//Ext.mixin

type
  JIBindable = class external(JExt.mixin.IMixin)
  end;

//Ext.mixin

type
  JIFilterable = class external(JExt.mixin.IMixin)
    filterRoot: String; // nullable
    filters: array of Variant; // nullable
    currentSortFn: Variant; // nullable
    dirtyFilterFn: Boolean; // nullable
    filtered: Boolean; // nullable
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: array of Variant): Variant; overload;
    function filter: array of Variant; overload;
    function filter(data: array of Variant): array of Variant; overload;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure removeFilters; overload;
    procedure removeFilters(filters: array of Variant); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
  end;

//Ext.mixin

type
  JIIdentifiable = class external(JExt.IBase)
    function getId: Variant;
  end;

//Ext.mixin

type
  JIMixin = class external(JExt.IBase)
  end;

//Ext.mixin

type
  JIObservable = class external(JExt.mixin.IMixin, JExt.mixin.IIdentifiable)
    bubbleEvents: Variant; // nullable
    listeners: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util

type
  JIObservable = class external(JExt.mixin.IMixin, JExt.mixin.IIdentifiable)
    bubbleEvents: Variant; // nullable
    listeners: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getId: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.mixin

type
  JIProgressable = class external(JExt.mixin.IMixin)
    dynamic: Boolean; // nullable
    maxProgressInput: Float; // nullable
    maxProgressOutput: Float; // nullable
    minProgressInput: Float; // nullable
    minProgressOutput: Float; // nullable
    state: String; // nullable
    function getDynamic: Boolean;
    function getMaxProgressInput: Float;
    function getMaxProgressOutput: Float;
    function getMinProgressInput: Float;
    function getMinProgressOutput: Float;
    function getState: String;
    procedure setDynamic; overload;
    procedure setDynamic(dynamic: Boolean); overload;
    procedure setMaxProgressInput; overload;
    procedure setMaxProgressInput(maxProgressInput: Float); overload;
    procedure setMaxProgressOutput; overload;
    procedure setMaxProgressOutput(maxProgressOutput: Float); overload;
    procedure setMinProgressInput; overload;
    procedure setMinProgressInput(minProgressInput: Float); overload;
    procedure setMinProgressOutput; overload;
    procedure setMinProgressOutput(minProgressOutput: Float); overload;
    procedure setState; overload;
    procedure setState(state: String); overload;
  end;

//Ext.mixin

type
  JISelectable = class external(JExt.mixin.IMixin)
    allowDeselect: Boolean; // nullable
    deselectOnContainerClick: Boolean; // nullable
    disableSelection: Boolean; // nullable
    locked: Boolean; // nullable
    mode: String; // nullable
    procedure clearSelections;
    procedure deselect; overload;
    procedure deselect(records: Variant); overload;
    procedure deselect(records: Variant; suppressEvent: Boolean); overload;
    procedure deselectAll; overload;
    procedure deselectAll(supress: Variant); overload;
    procedure doDeselect; overload;
    procedure doDeselect(records: Variant); overload;
    procedure doDeselect(records: Variant; suppressEvent: Boolean); overload;
    procedure doSelect; overload;
    procedure doSelect(records: Variant); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean); overload;
    procedure doSelect(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    function getAllowDeselect: Boolean;
    function getCount: Float;
    function getDeselectOnContainerClick: Boolean;
    function getDisableSelection: Boolean;
    function getLastSelected: array of Variant;
    function getMode: String;
    function getSelection: array of Variant;
    function getSelectionCount: Float;
    function getSelectionMode: String;
    function hasSelection: Boolean;
    function isLocked: Boolean;
    function isSelected: Boolean; overload;
    function isSelected(record: Variant): Boolean; overload;
    procedure select; overload;
    procedure select(records: Variant); overload;
    procedure select(records: Variant; keepExisting: Boolean); overload;
    procedure select(records: Variant; keepExisting: Boolean; suppressEvent: Boolean); overload;
    procedure selectAll; overload;
    procedure selectAll(silent: Boolean); overload;
    procedure selectRange; overload;
    procedure selectRange(startRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float); overload;
    procedure selectRange(startRecord: Float; endRecord: Float; keepExisting: Boolean); overload;
    procedure setAllowDeselect; overload;
    procedure setAllowDeselect(allowDeselect: Boolean); overload;
    procedure setDeselectOnContainerClick; overload;
    procedure setDeselectOnContainerClick(deselectOnContainerClick: Boolean); overload;
    procedure setDisableSelection; overload;
    procedure setDisableSelection(disableSelection: Boolean); overload;
    procedure setLastFocused;
    procedure setMode; overload;
    procedure setMode(mode: String); overload;
    procedure updateLastFocused; overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord); overload;
    procedure updateLastFocused(newRecord: JExt.data.IRecord; oldRecord: JExt.data.IRecord); overload;
  end;

//Ext.mixin

type
  JISortable = class external(JExt.mixin.IMixin)
    defaultSortDirection: String; // nullable
    sortRoot: String; // nullable
    sorters: array of Variant; // nullable
    currentSortFn: Variant; // nullable
    dirtySortFn: Boolean; // nullable
    sorted: Boolean; // nullable
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function getDefaultSortDirection: String;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    procedure insertSorters; overload;
    procedure insertSorters(index: Float); overload;
    procedure insertSorters(index: Float; sorters: array of Variant); overload;
    procedure insertSorters(index: Float; sorters: array of Variant; defaultDirection: String); overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    procedure removeSorters; overload;
    procedure removeSorters(sorters: array of Variant); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(data: array of Variant): array of Variant; overload;
  end;

//Ext.mixin

type
  JITemplatable = class external(JExt.mixin.IMixin)
  end;

//Ext.mixin

type
  JITraversable = class external(JExt.mixin.IMixin)
  end;

//Ext

type
  JMsg = class external 'Msg'
    items: JExt.util.IMixedCollection;
    self: JExt.IClass;
    function add: JExt.IComponent; overload;
    function add(newItems: Variant): JExt.IComponent; overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addAll: array of Variant; overload;
    function addAll(items: array of Variant): array of Variant; overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addCls; overload;
    procedure addCls(cls: String); overload;
    procedure addCls(cls: String; prefix: String); overload;
    procedure addCls(cls: String; prefix: String; suffix: String); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function alert: JExt.IMessageBox; overload;
    function alert(title: String): JExt.IMessageBox; overload;
    function alert(title: String; message: String): JExt.IMessageBox; overload;
    function alert(title: String; message: String; fn: Variant): JExt.IMessageBox; overload;
    function alert(title: String; message: String; fn: Variant; scope: Variant): JExt.IMessageBox; overload;
    procedure animateActiveItem; overload;
    procedure animateActiveItem(activeItem: Variant); overload;
    procedure animateActiveItem(activeItem: Variant; animation: Variant); overload;
    function applyMasked: Variant; overload;
    function applyMasked(masked: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function child: JExt.IComponent; overload;
    function child(selector: String): JExt.IComponent; overload;
    procedure clearListeners;
    function confirm: JExt.IMessageBox; overload;
    function confirm(title: String): JExt.IMessageBox; overload;
    function confirm(title: String; message: String): JExt.IMessageBox; overload;
    function confirm(title: String; message: String; fn: Variant): JExt.IMessageBox; overload;
    function confirm(title: String; message: String; fn: Variant; scope: Variant): JExt.IMessageBox; overload;
    procedure destroy;
    procedure disable;
    function down: JExt.IComponent; overload;
    function down(selector: String): JExt.IComponent; overload;
    procedure enable;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getActiveItem: Variant;
    procedure getAlignmentInfo; overload;
    procedure getAlignmentInfo(component: Variant); overload;
    procedure getAlignmentInfo(component: Variant; alignment: Variant); overload;
    function getAt: JExt.IComponent; overload;
    function getAt(index: Float): JExt.IComponent; overload;
    function getAutoDestroy: Boolean;
    function getBaseCls: String;
    function getBodyBorder: Variant;
    function getBodyMargin: Variant;
    function getBodyPadding: Variant;
    function getBorder: Variant;
    function getBottom: Variant;
    function getBubbleEvents: Variant;
    function getButtons: Variant;
    function getCentered: Boolean;
    function getCls: Variant;
    function getComponent: JExt.IComponent; overload;
    function getComponent(component: Variant): JExt.IComponent; overload;
    function getContentEl: Variant;
    function getControl: Variant;
    function getData: Variant;
    function getDefaultTextHeight: Float;
    function getDefaultType: String;
    function getDefaults: Variant;
    function getDisabled: Boolean;
    function getDisabledCls: String;
    function getDocked: String;
    function getDockedComponent: Variant; overload;
    function getDockedComponent(component: Variant): Variant; overload;
    function getDockedItems: array of Variant;
    function getEl: JExt.dom.IElement;
    function getEnter: String;
    function getEnterAnimation: Variant;
    function getExit: String;
    function getExitAnimation: Variant;
    function getFlex: Float;
    function getFloatingCls: String;
    function getHeight: Variant;
    function getHidden: Boolean;
    function getHiddenCls: String;
    function getHideAnimation: Variant;
    function getHideOnMaskTap: Boolean;
    function getHtml: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getInnerItems: array of Variant;
    function getItemId: String;
    function getItems: Variant;
    function getLayout: Variant;
    function getLeft: Variant;
    function getListeners: Variant;
    function getMargin: Variant;
    function getMasked: Variant;
    function getMaxHeight: Variant;
    function getMaxWidth: Variant;
    function getMinHeight: Variant;
    function getMinWidth: Variant;
    function getPadding: Variant;
    function getParent: JExt.IComponent;
    function getPlugins: Variant;
    function getPrompt: Variant;
    function getRecord: JExt.data.IModel;
    function getRenderTo: JExt.IElement;
    function getRight: Variant;
    function getScrollable: JExt.scroll.IView;
    function getShowAnimation: Variant;
    function getSize: Variant;
    function getStretchX: Boolean;
    function getStretchY: Boolean;
    function getStyle: Variant;
    function getStyleHtmlCls: String;
    function getStyleHtmlContent: Boolean;
    function getTitle: String;
    function getTop: Variant;
    function getTpl: Variant;
    function getTplWriteMode: String;
    function getUi: String;
    function getWidth: Variant;
    function getXTypes: String;
    function getZIndex: Float;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function hasParent: Boolean;
    function hide: JExt.IComponent;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure initialize;
    procedure insert; overload;
    procedure insert(index: Float); overload;
    procedure insert(index: Float; item: Variant); overload;
    function isDisabled: Boolean;
    function isHidden: Boolean;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    procedure mask; overload;
    procedure mask(mask: Variant); overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function prompt: JExt.IMessageBox; overload;
    function prompt(title: String): JExt.IMessageBox; overload;
    function prompt(title: String; message: String): JExt.IMessageBox; overload;
    function prompt(title: String; message: String; fn: Variant): JExt.IMessageBox; overload;
    function prompt(title: String; message: String; fn: Variant; scope: Variant): JExt.IMessageBox; overload;
    function prompt(title: String; message: String; fn: Variant; scope: Variant; multiLine: Variant): JExt.IMessageBox; overload;
    function prompt(title: String; message: String; fn: Variant; scope: Variant; multiLine: Variant; value: String): JExt.IMessageBox; overload;
    function prompt(title: String; message: String; fn: Variant; scope: Variant; multiLine: Variant; value: String; prompt: Variant): JExt.IMessageBox; overload;
    function query: array of Variant; overload;
    function query(selector: String): array of Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    function remove: JExt.IComponent; overload;
    function remove(item: Variant): JExt.IComponent; overload;
    function remove(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeAll: JExt.IComponent; overload;
    function removeAll(destroy: Boolean): JExt.IComponent; overload;
    function removeAll(destroy: Boolean; everything: Boolean): JExt.IComponent; overload;
    function removeAt: JExt.IContainer; overload;
    function removeAt(index: Float): JExt.IContainer; overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeCls; overload;
    procedure removeCls(cls: String); overload;
    procedure removeCls(cls: String; prefix: String); overload;
    procedure removeCls(cls: String; prefix: String; suffix: String); overload;
    function removeDocked: JExt.IComponent; overload;
    function removeDocked(item: Variant): JExt.IComponent; overload;
    function removeDocked(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeInnerAt: JExt.IContainer; overload;
    function removeInnerAt(index: Float): JExt.IContainer; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure replaceCls; overload;
    procedure replaceCls(oldCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String; suffix: String); overload;
    procedure resetFloating;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setActiveItem; overload;
    procedure setActiveItem(activeItem: Variant); overload;
    procedure setAutoDestroy; overload;
    procedure setAutoDestroy(autoDestroy: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBodyBorder; overload;
    procedure setBodyBorder(bodyBorder: Variant); overload;
    procedure setBodyMargin; overload;
    procedure setBodyMargin(bodyMargin: Variant); overload;
    procedure setBodyPadding; overload;
    procedure setBodyPadding(bodyPadding: Variant); overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setButtons; overload;
    procedure setButtons(buttons: Variant); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: Variant); overload;
    procedure setContentEl; overload;
    procedure setContentEl(contentEl: Variant); overload;
    procedure setControl; overload;
    procedure setControl(control: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setDefaultTextHeight; overload;
    procedure setDefaultTextHeight(defaultTextHeight: Float); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setDisabledCls; overload;
    procedure setDisabledCls(disabledCls: String); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setDraggable; overload;
    procedure setDraggable(draggable: Variant); overload;
    procedure setEnter; overload;
    procedure setEnter(enter: String); overload;
    procedure setEnterAnimation; overload;
    procedure setEnterAnimation(enterAnimation: Variant); overload;
    procedure setExit; overload;
    procedure setExit(exit: String); overload;
    procedure setExitAnimation; overload;
    procedure setExitAnimation(exitAnimation: Variant); overload;
    procedure setFlex; overload;
    procedure setFlex(flex: Float); overload;
    procedure setFloating; overload;
    procedure setFloating(floating: Boolean); overload;
    procedure setFloatingCls; overload;
    procedure setFloatingCls(floatingCls: String); overload;
    procedure setHeight; overload;
    procedure setHeight(height: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setHiddenCls; overload;
    procedure setHiddenCls(hiddenCls: String); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setHideOnMaskTap; overload;
    procedure setHideOnMaskTap(hideOnMaskTap: Boolean); overload;
    procedure setHtml; overload;
    procedure setHtml(html: Variant); overload;
    function setIcon: JExt.IMessageBox; overload;
    function setIcon(iconCls: String): JExt.IMessageBox; overload;
    procedure setIconCls; overload;
    procedure setIconCls(iconCls: String); overload;
    procedure setItemId; overload;
    procedure setItemId(itemId: String); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    procedure setMasked; overload;
    procedure setMasked(masked: Variant); overload;
    procedure setMaxHeight; overload;
    procedure setMaxHeight(maxHeight: Variant); overload;
    procedure setMaxWidth; overload;
    procedure setMaxWidth(maxWidth: Variant); overload;
    procedure setMessage; overload;
    procedure setMessage(message: String); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: Variant); overload;
    procedure setMinWidth; overload;
    procedure setMinWidth(minWidth: Variant); overload;
    procedure setPadding; overload;
    procedure setPadding(padding: Variant); overload;
    procedure setPlugins; overload;
    procedure setPlugins(plugins: Variant); overload;
    procedure setPrompt; overload;
    procedure setPrompt(prompt: Variant); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRenderTo; overload;
    procedure setRenderTo(renderTo: JExt.IElement); overload;
    procedure setRight; overload;
    procedure setRight(right: Variant); overload;
    function setScrollable: JExt.scroll.IView; overload;
    function setScrollable(scrollable: Variant): JExt.scroll.IView; overload;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Float); overload;
    procedure setSize(width: Float; height: Float); overload;
    procedure setStretchX; overload;
    procedure setStretchX(stretchX: Boolean); overload;
    procedure setStretchY; overload;
    procedure setStretchY(stretchY: Boolean); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setStyleHtmlCls; overload;
    procedure setStyleHtmlCls(styleHtmlCls: String); overload;
    procedure setStyleHtmlContent; overload;
    procedure setStyleHtmlContent(styleHtmlContent: Boolean); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setTop; overload;
    procedure setTop(top: Variant); overload;
    procedure setTpl; overload;
    procedure setTpl(tpl: Variant); overload;
    procedure setTplWriteMode; overload;
    procedure setTplWriteMode(tplWriteMode: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setWidth; overload;
    procedure setWidth(width: Variant); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zIndex: Float); overload;
    function show: JExt.IMessageBox; overload;
    function show(config: Variant): JExt.IMessageBox; overload;
    procedure showBy; overload;
    procedure showBy(component: JExt.IComponent); overload;
    procedure showBy(component: JExt.IComponent; alignment: String); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unmask;
    function up: JExt.IContainer; overload;
    function up(selector: String): JExt.IContainer; overload;
    procedure update;
    procedure updateStyleHtmlCls; overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant); overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant; oldHtmlCls: Variant); overload;
    function updateText: JExt.IMessageBox; overload;
    function updateText(message: String): JExt.IMessageBox; overload;
  end;

  JIMsg = class external(JExt.IMessageBox)
  end;

//Ext.navigation

type
  JIBar = class external(JExt.ITitleBar)
    androidAnimation: Boolean; // nullable
    baseCls: String; // nullable
    cls: String; // nullable
    ui: String; // nullable
    function getAndroidAnimation: Boolean;
    function getBaseCls: String;
    function getCls: String;
    function getUi: String;
    procedure setAndroidAnimation; overload;
    procedure setAndroidAnimation(androidAnimation: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext.navigation

type
  JIView = class external(JExt.IContainer)
    baseCls: String; // nullable
    defaultBackButtonText: String; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    navigationBar: Variant; // nullable
    useTitleForBackButtonText: Boolean; // nullable
    function getBaseCls: String;
    function getDefaultBackButtonText: String;
    function getItems: Variant;
    function getLayout: Variant;
    function getNavigationBar: Variant;
    function getPreviousItem: Variant;
    function getUseTitleForBackButtonText: Boolean;
    function pop: JExt.IComponent; overload;
    function pop(count: Variant): JExt.IComponent; overload;
    function push: JExt.IComponent; overload;
    function push(view: Variant): JExt.IComponent; overload;
    function reset: JExt.IComponent;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultBackButtonText; overload;
    procedure setDefaultBackButtonText(defaultBackButtonText: String); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setNavigationBar; overload;
    procedure setNavigationBar(navigationBar: Variant); overload;
    procedure setUseTitleForBackButtonText; overload;
    procedure setUseTitleForBackButtonText(useTitleForBackButtonText: Boolean); overload;
  end;

//Ext

type
  JINavigationView = class external(JExt.IContainer)
    baseCls: String; // nullable
    defaultBackButtonText: String; // nullable
    items: Variant; // nullable
    layout: Variant; // nullable
    navigationBar: Variant; // nullable
    useTitleForBackButtonText: Boolean; // nullable
    function getBaseCls: String;
    function getDefaultBackButtonText: String;
    function getItems: Variant;
    function getLayout: Variant;
    function getNavigationBar: Variant;
    function getPreviousItem: Variant;
    function getUseTitleForBackButtonText: Boolean;
    function pop: JExt.IComponent; overload;
    function pop(count: Variant): JExt.IComponent; overload;
    function push: JExt.IComponent; overload;
    function push(view: Variant): JExt.IComponent; overload;
    function reset: JExt.IComponent;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultBackButtonText; overload;
    procedure setDefaultBackButtonText(defaultBackButtonText: String); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setNavigationBar; overload;
    procedure setNavigationBar(navigationBar: Variant); overload;
    procedure setUseTitleForBackButtonText; overload;
    procedure setUseTitleForBackButtonText(useTitleForBackButtonText: Boolean); overload;
  end;

//Ext

type
  JNumber = class external 'Number'
    function constrain: Float; overload;
    function constrain(number: Float): Float; overload;
    function constrain(number: Float; min: Float): Float; overload;
    function constrain(number: Float; min: Float; max: Float): Float; overload;
    function from: Float; overload;
    function from(value: Variant): Float; overload;
    function from(value: Variant; defaultValue: Float): Float; overload;
    function snap: Float; overload;
    function snap(value: Float): Float; overload;
    function snap(value: Float; increment: Float): Float; overload;
    function snap(value: Float; increment: Float; minValue: Float): Float; overload;
    function snap(value: Float; increment: Float; minValue: Float; maxValue: Float): Float; overload;
    procedure toFixed; overload;
    procedure toFixed(value: Float); overload;
    procedure toFixed(value: Float; precision: Float); overload;
  end;

  JINumber = class external
  end;

//Ext

type
  JObject = class external 'Object'
    procedure chain; overload;
    procedure chain(&object: Variant); overload;
    procedure each; overload;
    procedure each(&object: Variant); overload;
    procedure each(&object: Variant; fn: Variant); overload;
    procedure each(&object: Variant; fn: Variant; scope: Variant); overload;
    function fromQueryString: Variant; overload;
    function fromQueryString(queryString: String): Variant; overload;
    function fromQueryString(queryString: String; recursive: Boolean): Variant; overload;
    procedure getKey; overload;
    procedure getKey(&object: Variant); overload;
    procedure getKey(&object: Variant; value: Variant); overload;
    function getKeys: array of String; overload;
    function getKeys(&object: Variant): array of String; overload;
    function getSize: Float; overload;
    function getSize(&object: Variant): Float; overload;
    function getValues: array of Variant; overload;
    function getValues(&object: Variant): array of Variant; overload;
    function merge(source: Variant; objs: array of Variant): Variant;
    procedure mergeIf; overload;
    procedure mergeIf(source: Variant); overload;
    function toQueryObjects: array of Variant; overload;
    function toQueryObjects(name: String): array of Variant; overload;
    function toQueryObjects(name: String; value: Variant): array of Variant; overload;
    function toQueryObjects(name: String; value: Variant; recursive: Boolean): array of Variant; overload;
    function toQueryString: String; overload;
    function toQueryString(&object: Variant): String; overload;
    function toQueryString(&object: Variant; recursive: Boolean): String; overload;
  end;

  JIObject = class external
  end;

//Ext

type
  JOs = class external 'Os'
    deviceType: String;
    name: String;
    self: JExt.IClass;
    version: JExt.IVersion;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function is: Boolean; overload;
    function is(value: String): Boolean; overload;
    function statics: JExt.IClass;
  end;

  JIOs = class external(JExt.env.IOS)
  end;

//Ext

type
  JIPanel = class external(JExt.IContainer)
    baseCls: String; // nullable
    bodyBorder: Variant; // nullable
    bodyMargin: Variant; // nullable
    bodyPadding: Variant; // nullable
    function getBaseCls: String;
    function getBodyBorder: Variant;
    function getBodyMargin: Variant;
    function getBodyPadding: Variant;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBodyBorder; overload;
    procedure setBodyBorder(bodyBorder: Variant); overload;
    procedure setBodyMargin; overload;
    procedure setBodyMargin(bodyMargin: Variant); overload;
    procedure setBodyPadding; overload;
    procedure setBodyPadding(bodyPadding: Variant); overload;
  end;

//Ext.lib

type
  JIPanel = class external(JExt.IContainer)
    baseCls: String; // nullable
    bodyBorder: Variant; // nullable
    bodyMargin: Variant; // nullable
    bodyPadding: Variant; // nullable
    function getBaseCls: String;
    function getBodyBorder: Variant;
    function getBodyMargin: Variant;
    function getBodyPadding: Variant;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBodyBorder; overload;
    procedure setBodyBorder(bodyBorder: Variant); overload;
    procedure setBodyMargin; overload;
    procedure setBodyMargin(bodyMargin: Variant); overload;
    procedure setBodyPadding; overload;
    procedure setBodyPadding(bodyPadding: Variant); overload;
  end;

//Ext.picker

type
  JIDate = class external(JExt.picker.IPicker)
    dayText: String; // nullable
    doneButton: Variant; // nullable
    monthText: String; // nullable
    slotOrder: array of Variant; // nullable
    value: Variant; // nullable
    yearFrom: Float; // nullable
    yearText: String; // nullable
    yearTo: Float; // nullable
    function getDayText: String;
    function getDoneButton: Variant;
    function getMonthText: String;
    function getSlotOrder: array of Variant;
    function getValue: Variant; overload;
    function getValue(useDom: Variant): Variant; overload;
    function getYearFrom: Float;
    function getYearText: String;
    function getYearTo: Float;
    procedure initialize;
    procedure setDayText; overload;
    procedure setDayText(dayText: String); overload;
    procedure setDoneButton; overload;
    procedure setDoneButton(doneButton: Variant); overload;
    procedure setMonthText; overload;
    procedure setMonthText(monthText: String); overload;
    procedure setSlotOrder; overload;
    procedure setSlotOrder(slotOrder: array of Variant); overload;
    function setValue: JExt.IPicker; overload;
    function setValue(value: Variant): JExt.IPicker; overload;
    function setValue(value: Variant; animated: Variant): JExt.IPicker; overload;
    procedure setYearFrom; overload;
    procedure setYearFrom(yearFrom: Float); overload;
    procedure setYearText; overload;
    procedure setYearText(yearText: String); overload;
    procedure setYearTo; overload;
    procedure setYearTo(yearTo: Float); overload;
    procedure updateDayText; overload;
    procedure updateDayText(newDayText: Variant); overload;
    procedure updateDayText(newDayText: Variant; oldDayText: Variant); overload;
    procedure updateMonthText; overload;
    procedure updateMonthText(newMonthText: Variant); overload;
    procedure updateMonthText(newMonthText: Variant; oldMonthText: Variant); overload;
    procedure updateYearFrom;
    procedure updateYearText; overload;
    procedure updateYearText(yearText: Variant); overload;
    procedure updateYearTo;
  end;

//Ext

type
  JIDatePicker = class external(JExt.picker.IPicker)
    dayText: String; // nullable
    doneButton: Variant; // nullable
    monthText: String; // nullable
    slotOrder: array of Variant; // nullable
    value: Variant; // nullable
    yearFrom: Float; // nullable
    yearText: String; // nullable
    yearTo: Float; // nullable
    function getDayText: String;
    function getDoneButton: Variant;
    function getMonthText: String;
    function getSlotOrder: array of Variant;
    function getValue: Variant; overload;
    function getValue(useDom: Variant): Variant; overload;
    function getYearFrom: Float;
    function getYearText: String;
    function getYearTo: Float;
    procedure initialize;
    procedure setDayText; overload;
    procedure setDayText(dayText: String); overload;
    procedure setDoneButton; overload;
    procedure setDoneButton(doneButton: Variant); overload;
    procedure setMonthText; overload;
    procedure setMonthText(monthText: String); overload;
    procedure setSlotOrder; overload;
    procedure setSlotOrder(slotOrder: array of Variant); overload;
    function setValue: JExt.IPicker; overload;
    function setValue(value: Variant): JExt.IPicker; overload;
    function setValue(value: Variant; animated: Variant): JExt.IPicker; overload;
    procedure setYearFrom; overload;
    procedure setYearFrom(yearFrom: Float); overload;
    procedure setYearText; overload;
    procedure setYearText(yearText: String); overload;
    procedure setYearTo; overload;
    procedure setYearTo(yearTo: Float); overload;
    procedure updateDayText; overload;
    procedure updateDayText(newDayText: Variant); overload;
    procedure updateDayText(newDayText: Variant; oldDayText: Variant); overload;
    procedure updateMonthText; overload;
    procedure updateMonthText(newMonthText: Variant); overload;
    procedure updateMonthText(newMonthText: Variant; oldMonthText: Variant); overload;
    procedure updateYearFrom;
    procedure updateYearText; overload;
    procedure updateYearText(yearText: Variant); overload;
    procedure updateYearTo;
  end;

//Ext.picker

type
  JIPicker = class external(JExt.ISheet)
    activeCls: String; // nullable
    baseCls: String; // nullable
    bottom: Variant; // nullable
    cancelButton: Variant; // nullable
    doneButton: Variant; // nullable
    height: Float; // nullable
    layout: Variant; // nullable
    left: Variant; // nullable
    right: Variant; // nullable
    slots: array of Variant; // nullable
    toolbar: Variant; // nullable
    useTitles: Boolean; // nullable
    value: Variant; // nullable
    function applyCancelButton: Variant; overload;
    function applyCancelButton(config: Variant): Variant; overload;
    function applyDoneButton: Variant; overload;
    function applyDoneButton(config: Variant): Variant; overload;
    procedure destroy;
    function getBaseCls: String;
    function getBottom: Float;
    function getCancelButton: Variant;
    function getCard: Variant;
    function getDoneButton: Variant;
    function getLayout: Variant;
    function getSlots: array of Variant;
    function getToolbar: Variant;
    function getToolbarPosition: String;
    function getUseTitles: Boolean;
    function getValue: Variant; overload;
    function getValue(useDom: Variant): Variant; overload;
    function getValues: Variant;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Float); overload;
    procedure setCancelButton; overload;
    procedure setCancelButton(cancelButton: Variant); overload;
    procedure setCard; overload;
    procedure setCard(activeItem: Variant); overload;
    procedure setDoneButton; overload;
    procedure setDoneButton(doneButton: Variant); overload;
    procedure setHeight; overload;
    procedure setHeight(height: Float); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Float); overload;
    procedure setRight; overload;
    procedure setRight(right: Float); overload;
    procedure setSlots; overload;
    procedure setSlots(slots: array of Variant); overload;
    procedure setToolbar; overload;
    procedure setToolbar(toolbar: Variant); overload;
    procedure setToolbarPosition; overload;
    procedure setToolbarPosition(toolbarPosition: String); overload;
    procedure setUseTitles; overload;
    procedure setUseTitles(useTitles: Boolean); overload;
    function setValue: JExt.IPicker; overload;
    function setValue(values: Variant): JExt.IPicker; overload;
    function setValue(values: Variant; animated: Boolean): JExt.IPicker; overload;
    function show: JExt.IComponent;
  end;

//Ext

type
  JIPicker = class external(JExt.ISheet)
    activeCls: String; // nullable
    baseCls: String; // nullable
    bottom: Variant; // nullable
    cancelButton: Variant; // nullable
    doneButton: Variant; // nullable
    height: Float; // nullable
    layout: Variant; // nullable
    left: Variant; // nullable
    right: Variant; // nullable
    slots: array of Variant; // nullable
    toolbar: Variant; // nullable
    useTitles: Boolean; // nullable
    value: Variant; // nullable
    function applyCancelButton: Variant; overload;
    function applyCancelButton(config: Variant): Variant; overload;
    function applyDoneButton: Variant; overload;
    function applyDoneButton(config: Variant): Variant; overload;
    procedure destroy;
    function getBaseCls: String;
    function getBottom: Float;
    function getCancelButton: Variant;
    function getCard: Variant;
    function getDoneButton: Variant;
    function getLayout: Variant;
    function getSlots: array of Variant;
    function getToolbar: Variant;
    function getToolbarPosition: String;
    function getUseTitles: Boolean;
    function getValue: Variant; overload;
    function getValue(useDom: Variant): Variant; overload;
    function getValues: Variant;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Float); overload;
    procedure setCancelButton; overload;
    procedure setCancelButton(cancelButton: Variant); overload;
    procedure setCard; overload;
    procedure setCard(activeItem: Variant); overload;
    procedure setDoneButton; overload;
    procedure setDoneButton(doneButton: Variant); overload;
    procedure setHeight; overload;
    procedure setHeight(height: Float); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Float); overload;
    procedure setRight; overload;
    procedure setRight(right: Float); overload;
    procedure setSlots; overload;
    procedure setSlots(slots: array of Variant); overload;
    procedure setToolbar; overload;
    procedure setToolbar(toolbar: Variant); overload;
    procedure setToolbarPosition; overload;
    procedure setToolbarPosition(toolbarPosition: String); overload;
    procedure setUseTitles; overload;
    procedure setUseTitles(useTitles: Boolean); overload;
    function setValue: JExt.IPicker; overload;
    function setValue(values: Variant): JExt.IPicker; overload;
    function setValue(values: Variant; animated: Boolean): JExt.IPicker; overload;
    function show: JExt.IComponent;
  end;

//Ext.picker

type
  JISlot = class external(JExt.dataview.IDataView)
    align: String; // nullable
    displayField: String; // nullable
    itemTpl: String; // nullable
    name: String; // nullable
    title: String; // nullable
    value: Float; // nullable
    valueField: String; // nullable
    function applyData: Variant; overload;
    function applyData(data: Variant): Variant; overload;
    function applyTitle: String; overload;
    function applyTitle(title: String): String; overload;
    function getAlign: String;
    function getDisplayField: String;
    function getName: String;
    function getTitle: String;
    function getValueField: String;
    procedure setAlign; overload;
    procedure setAlign(align: String); overload;
    procedure setDisplayField; overload;
    procedure setDisplayField(displayField: String); overload;
    procedure setItemTpl; overload;
    procedure setItemTpl(itemTpl: String); overload;
    procedure setName; overload;
    procedure setName(name: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setValueField; overload;
    procedure setValueField(valueField: String); overload;
    procedure updateAlign; overload;
    procedure updateAlign(newAlign: Variant); overload;
    procedure updateAlign(newAlign: Variant; oldAlign: Variant); overload;
  end;

//Ext.plugin

type
  JIBufferedList = class external(JExt.IBase, JExt.mixin.IBindable)
    function getList: Variant;
    procedure setList; overload;
    procedure setList(list: Variant); overload;
  end;

//Ext.plugin

type
  JIListPaging = class external(JExt.IComponent)
    autoPaging: Boolean; // nullable
    loadMoreText: String; // nullable
    noMoreRecordsText: String; // nullable
    function getAutoPaging: Boolean;
    function getLoadMoreText: String;
    function getNoMoreRecordsText: String;
    procedure setAutoPaging; overload;
    procedure setAutoPaging(autoPaging: Boolean); overload;
    procedure setLoadMoreText; overload;
    procedure setLoadMoreText(loadMoreText: String); overload;
    procedure setNoMoreRecordsText; overload;
    procedure setNoMoreRecordsText(noMoreRecordsText: String); overload;
  end;

//Ext.plugin

type
  JIPullRefresh = class external(JExt.IComponent)
    autoSnapBack: Boolean; // nullable
    lastUpdatedDateFormat: String; // nullable
    lastUpdatedText: String; // nullable
    list: JExt.dataview.IList; // nullable
    loadedText: String; // nullable
    loadingText: String; // nullable
    overpullSnapBackDuration: Float; // nullable
    pullRefreshText: String; // nullable
    pullReleaseText: String; // nullable
    pullText: String; // nullable
    pullTpl: Variant; // nullable
    releaseText: String; // nullable
    scrollerAutoRefresh: Boolean; // nullable
    snappingAnimationDuration: Float; // nullable
    function getAutoSnapBack: Boolean;
    function getLastUpdatedDateFormat: String;
    function getLastUpdatedText: String;
    function getList: JExt.dataview.IList;
    function getLoadedText: String;
    function getLoadingText: String;
    function getOverpullSnapBackDuration: Float;
    function getPullText: String;
    function getPullTpl: Variant;
    function getReleaseText: String;
    function getScrollerAutoRefresh: Boolean;
    function getSnappingAnimationDuration: Float;
    function getTranslatable: Boolean;
    procedure setAutoSnapBack; overload;
    procedure setAutoSnapBack(autoSnapBack: Boolean); overload;
    procedure setLastUpdatedDateFormat; overload;
    procedure setLastUpdatedDateFormat(lastUpdatedDateFormat: String); overload;
    procedure setLastUpdatedText; overload;
    procedure setLastUpdatedText(lastUpdatedText: String); overload;
    procedure setList; overload;
    procedure setList(list: JExt.dataview.IList); overload;
    procedure setLoadedText; overload;
    procedure setLoadedText(loadedText: String); overload;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: String); overload;
    procedure setOverpullSnapBackDuration; overload;
    procedure setOverpullSnapBackDuration(overpullSnapBackDuration: Float); overload;
    procedure setPullRefreshText; overload;
    procedure setPullRefreshText(text: String); overload;
    procedure setPullText; overload;
    procedure setPullText(pullText: String); overload;
    procedure setPullTpl; overload;
    procedure setPullTpl(pullTpl: Variant); overload;
    procedure setReleaseRefreshText; overload;
    procedure setReleaseRefreshText(text: String); overload;
    procedure setReleaseText; overload;
    procedure setReleaseText(releaseText: String); overload;
    procedure setScrollerAutoRefresh; overload;
    procedure setScrollerAutoRefresh(scrollerAutoRefresh: Boolean); overload;
    procedure setSnappingAnimationDuration; overload;
    procedure setSnappingAnimationDuration(snappingAnimationDuration: Float); overload;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Boolean); overload;
    procedure snapBack; overload;
    procedure snapBack(force: Boolean); overload;
  end;

//Ext.plugin

type
  JISortableList = class external(JExt.IComponent, JExt.mixin.IBindable)
    function getHandleSelector: String;
    function getList: Variant;
    procedure setHandleSelector; overload;
    procedure setHandleSelector(handleSelector: String); overload;
    procedure setList; overload;
    procedure setList(list: Variant); overload;
  end;

//Ext

type
  JIProgressIndicator = class external(JExt.IContainer, JExt.mixin.IProgressable)
    baseCls: String; // nullable
    centered: Boolean; // nullable
    fallbackText: Variant; // nullable
    hidden: Boolean; // nullable
    hideAnimation: Variant; // nullable
    loadingText: Variant; // nullable
    modal: Boolean; // nullable
    monitoredStates: Variant; // nullable
    showAnimation: Variant; // nullable
    function getBaseCls: String;
    function getCentered: Boolean;
    function getDynamic: Boolean;
    function getHidden: Boolean;
    function getHideAnimation: Variant;
    function getMaxProgressInput: Float;
    function getMinProgressInput: Float;
    function getModal: Boolean;
    function getMonitoredStates: Variant;
    function getShowAnimation: Variant;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setDynamic; overload;
    procedure setDynamic(dynamic: Boolean); overload;
    procedure setFallbackText; overload;
    procedure setFallbackText(fallbackText: Variant); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setLoadingText; overload;
    procedure setLoadingText(loadingText: Variant); overload;
    procedure setMaxProgressInput; overload;
    procedure setMaxProgressInput(maxProgressInput: Float); overload;
    procedure setMinProgressInput; overload;
    procedure setMinProgressInput(minProgressInput: Float); overload;
    procedure setModal; overload;
    procedure setModal(modal: Boolean); overload;
    procedure setMonitoredStates; overload;
    procedure setMonitoredStates(monitoredStates: Variant); overload;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
  end;

//Ext

type
  JIPromise = class external(JExt.IBase)
  end;

//Ext

type
  JRouter = class external 'Router'
    procedure setAppInstance; overload;
    procedure setAppInstance(app: Variant); overload;
  end;

  JIRouter = class external
  end;

//Ext.scroll.indicator

type
  JIAbstract = class external(JExt.IComponent)
    autoHide: Boolean; // nullable
    baseCls: String; // nullable
    hidden: Boolean; // nullable
    ui: String; // nullable
    function getActive: Boolean;
    function getAutoHide: Boolean;
    function getAxis: String;
    function getBarCls: String;
    function getBaseCls: String;
    function getHidden: Boolean;
    function getLength: Variant;
    function getMinLength: Float;
    function getRatio: Float;
    function getUi: String;
    function getValue: Variant;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setAutoHide; overload;
    procedure setAutoHide(autoHide: Boolean); overload;
    procedure setAxis; overload;
    procedure setAxis(axis: String); overload;
    procedure setBarCls; overload;
    procedure setBarCls(barCls: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setLength; overload;
    procedure setLength(_length: Variant); overload;
    procedure setMinLength; overload;
    procedure setMinLength(minLength: Float); overload;
    procedure setRatio; overload;
    procedure setRatio(ratio: Float); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.scroll.indicator

type
  JICssTransform = class external(JExt.scroll.indicator.IAbstract)
    cls: Variant; // nullable
    function getCls: String;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
  end;

//Ext.scroll

type
  JIIndicator = class external(JExt.IBase)
  end;

//Ext.util

type
  JIIndicator = class external(JExt.IBase)
  end;

//Ext.scroll.indicator

type
  JIRounded = class external(JExt.scroll.indicator.IAbstract)
    cls: Variant; // nullable
    function getCls: String;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
  end;

//Ext.scroll.indicator

type
  JIScrollPosition = class external(JExt.scroll.indicator.IAbstract)
    cls: Variant; // nullable
    function getCls: String;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
  end;

//Ext.scroll

type
  JIScroller = class external(JExt.IEvented)
    acceleration: Float; // nullable
    direction: String; // nullable
    directionLock: Boolean; // nullable
    disabled: Boolean; // nullable
    friction: Float; // nullable
    initialOffset: Variant; // nullable
    momentumEasing: Variant; // nullable
    slotSnapSize: Variant; // nullable
    procedure destroy;
    function getDirection: String;
    function getDirectionLock: Boolean;
    function getDisabled: Boolean;
    function getInitialOffset: Variant;
    function getMomentumEasing: Variant;
    function getSlotSnapEasing: Variant;
    function getSlotSnapSize: Variant;
    function getTranslatable: Variant;
    function isAxisEnabled: Boolean; overload;
    function isAxisEnabled(axis: String): Boolean; overload;
    function scrollBy: JExt.scroll.IScroller; overload;
    function scrollBy(x: Float): JExt.scroll.IScroller; overload;
    function scrollBy(x: Float; y: Float): JExt.scroll.IScroller; overload;
    function scrollBy(x: Float; y: Float; animation: Variant): JExt.scroll.IScroller; overload;
    function scrollTo: JExt.scroll.IScroller; overload;
    function scrollTo(x: Float): JExt.scroll.IScroller; overload;
    function scrollTo(x: Float; y: Float): JExt.scroll.IScroller; overload;
    function scrollTo(x: Float; y: Float; animation: Variant): JExt.scroll.IScroller; overload;
    function scrollToEnd: JExt.scroll.IScroller; overload;
    function scrollToEnd(animation: Variant): JExt.scroll.IScroller; overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDirectionLock; overload;
    procedure setDirectionLock(directionLock: Boolean); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setInitialOffset; overload;
    procedure setInitialOffset(initialOffset: Variant); overload;
    procedure setMomentumEasing; overload;
    procedure setMomentumEasing(momentumEasing: Variant); overload;
    function setOffset: JExt.scroll.IScroller; overload;
    function setOffset(offset: Variant): JExt.scroll.IScroller; overload;
    procedure setSlotSnapEasing; overload;
    procedure setSlotSnapEasing(slotSnapEasing: Variant); overload;
    procedure setSlotSnapSize; overload;
    procedure setSlotSnapSize(slotSnapSize: Variant); overload;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Variant); overload;
    function updateBoundary: JExt.scroll.IScroller;
  end;

//Ext.scroll

type
  JIView = class external(JExt.IEvented)
    indicatorsUi: String; // nullable
    procedure destroy;
    function getCls: String;
    function getElement: Variant;
    function getIndicators: Variant;
    function getIndicatorsHidingDelay: Float;
    function getIndicatorsUi: String;
    function getScroller: JExt.scroll.IView;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setIndicators; overload;
    procedure setIndicators(indicators: Variant); overload;
    procedure setIndicatorsHidingDelay; overload;
    procedure setIndicatorsHidingDelay(indicatorsHidingDelay: Float); overload;
    procedure setIndicatorsUi; overload;
    procedure setIndicatorsUi(indicatorsUi: String); overload;
    procedure setScroller; overload;
    procedure setScroller(scroller: Variant); overload;
  end;

//Ext.util

type
  JIScrollView = class external(JExt.IEvented)
    indicatorsUi: String; // nullable
    procedure destroy;
    function getCls: String;
    function getElement: Variant;
    function getIndicators: Variant;
    function getIndicatorsHidingDelay: Float;
    function getIndicatorsUi: String;
    function getScroller: JExt.scroll.IView;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setIndicators; overload;
    procedure setIndicators(indicators: Variant); overload;
    procedure setIndicatorsHidingDelay; overload;
    procedure setIndicatorsHidingDelay(indicatorsHidingDelay: Float); overload;
    procedure setIndicatorsUi; overload;
    procedure setIndicatorsUi(indicatorsUi: String); overload;
    procedure setScroller; overload;
    procedure setScroller(scroller: Variant); overload;
  end;

//Ext

type
  JISegmentedButton = class external(JExt.IContainer)
    allowDepress: Boolean; // nullable
    allowMultiple: Boolean; // nullable
    allowToggle: Boolean; // nullable
    baseCls: String; // nullable
    defaultType: String; // nullable
    layout: Variant; // nullable
    pressedButtons: array of Variant; // nullable
    pressedCls: String; // nullable
    procedure applyItems;
    function getAllowDepress: Boolean;
    function getAllowMultiple: Boolean;
    function getAllowToggle: Boolean;
    function getBaseCls: String;
    function getDefaultType: String;
    function getLayout: Variant;
    procedure getPressed;
    function getPressedButtons: array of Variant;
    function getPressedCls: String;
    function isPressed: Boolean; overload;
    function isPressed(button: JExt.IButton): Boolean; overload;
    procedure setAllowDepress; overload;
    procedure setAllowDepress(allowDepress: Boolean); overload;
    procedure setAllowMultiple; overload;
    procedure setAllowMultiple(allowMultiple: Boolean); overload;
    procedure setAllowToggle; overload;
    procedure setAllowToggle(allowToggle: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setPressed; overload;
    procedure setPressed(button: Variant); overload;
    procedure setPressed(button: Variant; pressed: Boolean); overload;
    procedure setPressed(button: Variant; pressed: Boolean; suppressEvents: Boolean); overload;
    procedure setPressedButtons; overload;
    procedure setPressedButtons(pressedButtons: array of Variant); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
  end;

//Ext

type
  JISheet = class external(JExt.IPanel)
    baseCls: String; // nullable
    centered: Boolean; // nullable
    enter: String; // nullable
    exit: String; // nullable
    hideAnimation: Variant; // nullable
    modal: Boolean; // nullable
    showAnimation: Variant; // nullable
    stretchX: Boolean; // nullable
    stretchY: Boolean; // nullable
    function getBaseCls: String;
    function getCentered: Boolean;
    function getEnter: String;
    function getExit: String;
    function getModal: Boolean;
    function getStretchX: Boolean;
    function getStretchY: Boolean;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setEnter; overload;
    procedure setEnter(enter: String); overload;
    procedure setExit; overload;
    procedure setExit(exit: String); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setModal; overload;
    procedure setModal(modal: Boolean); overload;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setStretchX; overload;
    procedure setStretchX(stretchX: Boolean); overload;
    procedure setStretchY; overload;
    procedure setStretchY(stretchY: Boolean); overload;
  end;

//Ext.slider

type
  JISlider = class external(JExt.IContainer)
    allowThumbsOverlapping: Boolean; // nullable
    animation: Variant; // nullable
    animationDuration: Boolean; // nullable
    baseCls: String; // nullable
    increment: Float; // nullable
    maxValue: Float; // nullable
    minValue: Float; // nullable
    readOnly: Boolean; // nullable
    thumbConfig: Variant; // nullable
    value: Variant; // nullable
    values: Variant; // nullable
    function applyIncrement: Float; overload;
    function applyIncrement(increment: Float): Float; overload;
    function getAllowThumbsOverlapping: Boolean;
    function getAnimation: Variant;
    function getBaseCls: String;
    function getIncrement: Float;
    function getMaxValue: Float;
    function getMinValue: Float;
    function getReadOnly: Boolean;
    function getThumb: JExt.slider.IThumb; overload;
    function getThumb(index: Float): JExt.slider.IThumb; overload;
    function getThumbConfig: Variant;
    function getThumbs: array of JExt.slider.IThumb;
    function getValue: Variant;
    function getValues: Variant;
    procedure setAllowThumbsOverlapping; overload;
    procedure setAllowThumbsOverlapping(allowThumbsOverlapping: Boolean); overload;
    procedure setAnimation; overload;
    procedure setAnimation(animation: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setIncrement; overload;
    procedure setIncrement(increment: Float); overload;
    procedure setMaxValue; overload;
    procedure setMaxValue(maxValue: Float); overload;
    procedure setMinValue; overload;
    procedure setMinValue(minValue: Float); overload;
    procedure setReadOnly; overload;
    procedure setReadOnly(readOnly: Boolean); overload;
    procedure setThumbConfig; overload;
    procedure setThumbConfig(thumbConfig: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
    procedure setValues; overload;
    procedure setValues(value: Variant); overload;
    procedure updateValue; overload;
    procedure updateValue(newValue: Variant); overload;
    procedure updateValue(newValue: Variant; oldValue: Variant); overload;
  end;

//Ext.slider

type
  JIThumb = class external(JExt.IComponent)
    baseCls: String; // nullable
    draggable: Variant; // nullable
    function getBaseCls: String;
    function getDraggable: Variant;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDraggable; overload;
    procedure setDraggable(draggable: Variant); overload;
  end;

//Ext.slider

type
  JIToggle = class external(JExt.slider.ISlider)
    baseCls: String; // nullable
    maxValueCls: String; // nullable
    minValueCls: String; // nullable
    function applyIncrement: Float;
    function getBaseCls: String;
    function getMaxValueCls: String;
    function getMinValueCls: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setMaxValueCls; overload;
    procedure setMaxValueCls(maxValueCls: String); overload;
    procedure setMinValueCls; overload;
    procedure setMinValueCls(minValueCls: String); overload;
    procedure setValue; overload;
    procedure setValue(newValue: Variant); overload;
    procedure setValue(newValue: Variant; oldValue: Variant); overload;
  end;

//Ext

type
  JISpacer = class external(JExt.IComponent)
    flex: Float; // nullable
    width: Float; // nullable
    function getFlex: Float;
    procedure setFlex; overload;
    procedure setFlex(flex: Float); overload;
    procedure setWidth; overload;
    procedure setWidth(width: Float); overload;
  end;

//Ext

type
  JString = class external 'String'
    function capitalize: String; overload;
    function capitalize(&string: String): String; overload;
    function ellipsis: String; overload;
    function ellipsis(value: String): String; overload;
    function ellipsis(value: String; _length: Float): String; overload;
    function ellipsis(value: String; _length: Float; word: Boolean): String; overload;
    function escape: String; overload;
    function escape(&string: String): String; overload;
    function escapeRegex: String; overload;
    function escapeRegex(&string: String): String; overload;
    function format(&string: String; values: array of Variant): String;
    function htmlDecode: String; overload;
    function htmlDecode(value: String): String; overload;
    function htmlEncode: String; overload;
    function htmlEncode(value: String): String; overload;
    function leftPad: String; overload;
    function leftPad(&string: String): String; overload;
    function leftPad(&string: String; size: Float): String; overload;
    function leftPad(&string: String; size: Float; character: String): String; overload;
    procedure repeat; overload;
    procedure repeat(pattern: String); overload;
    procedure repeat(pattern: String; count: Float); overload;
    procedure repeat(pattern: String; count: Float; sep: String); overload;
    function toggle: String; overload;
    function toggle(&string: String): String; overload;
    function toggle(&string: String; value: String): String; overload;
    function toggle(&string: String; value: String; other: String): String; overload;
    function trim: String; overload;
    function trim(&string: String): String; overload;
    function urlAppend: String; overload;
    function urlAppend(url: String): String; overload;
    function urlAppend(url: String; &string: String): String; overload;
  end;

  JIString = class external
  end;

//Ext

type
  JISupports = class external
    AudioTag: Variant; // nullable
    GeoLocation: Variant; // nullable
    SVG: Variant; // nullable
    Transitions: Variant; // nullable
    VML: Variant; // nullable
  end;

//Ext.tab

type
  JIBar = class external(JExt.IToolbar)
    activeTab: Variant; // nullable
    baseCls: String; // nullable
    function getActiveTab: Variant;
    function getBaseCls: String;
    procedure initialize;
    procedure setActiveTab; overload;
    procedure setActiveTab(activeTab: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
  end;

//Ext

type
  JITabBar = class external(JExt.IToolbar)
    activeTab: Variant; // nullable
    baseCls: String; // nullable
    function getActiveTab: Variant;
    function getBaseCls: String;
    procedure initialize;
    procedure setActiveTab; overload;
    procedure setActiveTab(activeTab: Variant); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
  end;

//Ext.tab

type
  JIPanel = class external(JExt.IContainer)
    cls: Variant; // nullable
    layout: Variant; // nullable
    tabBar: Variant; // nullable
    tabBarDock: Boolean; // nullable
    tabBarPosition: String; // nullable
    ui: String; // nullable
    function doTabChange: Boolean; overload;
    function doTabChange(tabBar: Variant): Boolean; overload;
    function doTabChange(tabBar: Variant; newTab: Variant): Boolean; overload;
    function getCls: String;
    function getLayout: Variant;
    function getTabBar: Variant;
    function getTabBarPosition: String;
    function getUi: String;
    procedure initialize;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setTabBar; overload;
    procedure setTabBar(tabBar: Variant); overload;
    procedure setTabBarPosition; overload;
    procedure setTabBarPosition(tabBarPosition: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure updateUi; overload;
    procedure updateUi(newUi: Variant); overload;
    procedure updateUi(newUi: Variant; oldUi: Variant); overload;
  end;

//Ext

type
  JITabPanel = class external(JExt.IContainer)
    cls: Variant; // nullable
    layout: Variant; // nullable
    tabBar: Variant; // nullable
    tabBarDock: Boolean; // nullable
    tabBarPosition: String; // nullable
    ui: String; // nullable
    function doTabChange: Boolean; overload;
    function doTabChange(tabBar: Variant): Boolean; overload;
    function doTabChange(tabBar: Variant; newTab: Variant): Boolean; overload;
    function getCls: String;
    function getLayout: Variant;
    function getTabBar: Variant;
    function getTabBarPosition: String;
    function getUi: String;
    procedure initialize;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setTabBar; overload;
    procedure setTabBar(tabBar: Variant); overload;
    procedure setTabBarPosition; overload;
    procedure setTabBarPosition(tabBarPosition: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure updateUi; overload;
    procedure updateUi(newUi: Variant); overload;
    procedure updateUi(newUi: Variant; oldUi: Variant); overload;
  end;

//Ext.tab

type
  JITab = class external(JExt.IButton)
    active: Boolean; // nullable
    activeCls: String; // nullable
    baseCls: String; // nullable
    pressedCls: String; // nullable
    title: String; // nullable
    function getActive: Boolean;
    function getActiveCls: String;
    function getBaseCls: String;
    function getPressedCls: String;
    function getTitle: String;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActiveCls; overload;
    procedure setActiveCls(activeCls: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext

type
  JITab = class external(JExt.IButton)
    active: Boolean; // nullable
    activeCls: String; // nullable
    baseCls: String; // nullable
    pressedCls: String; // nullable
    title: String; // nullable
    function getActive: Boolean;
    function getActiveCls: String;
    function getBaseCls: String;
    function getPressedCls: String;
    function getTitle: String;
    procedure setActive; overload;
    procedure setActive(active: Boolean); overload;
    procedure setActiveCls; overload;
    procedure setActiveCls(activeCls: String); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setPressedCls; overload;
    procedure setPressedCls(pressedCls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext

type
  JTaskQueue = class external 'TaskQueue'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JITaskQueue = class external(JExt.IBase)
  end;

//Ext

type
  JTemplate = class external 'Template'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.ITemplate; overload;
    function from(el: Variant): JExt.ITemplate; overload;
    function from(el: Variant; config: Variant): JExt.ITemplate; overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JITemplate = class external(JExt.IBase)
    compiled: Boolean; // nullable
    disableFormats: Boolean; // nullable
    isTemplate: Boolean; // nullable
    function append: Variant; overload;
    function append(el: Variant): Variant; overload;
    function append(el: Variant; values: Variant): Variant; overload;
    function append(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function apply: String; overload;
    function apply(values: Variant): String; overload;
    function applyOut: array of Variant; overload;
    function applyOut(values: Variant): array of Variant; overload;
    function applyOut(values: Variant; out: array of Variant): array of Variant; overload;
    function applyTemplate: String; overload;
    function applyTemplate(values: Variant): String; overload;
    function compile: JExt.ITemplate;
    function insertAfter: Variant; overload;
    function insertAfter(el: Variant): Variant; overload;
    function insertAfter(el: Variant; values: Variant): Variant; overload;
    function insertAfter(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function insertBefore: Variant; overload;
    function insertBefore(el: Variant): Variant; overload;
    function insertBefore(el: Variant; values: Variant): Variant; overload;
    function insertBefore(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function insertFirst: Variant; overload;
    function insertFirst(el: Variant): Variant; overload;
    function insertFirst(el: Variant; values: Variant): Variant; overload;
    function insertFirst(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function overwrite: Variant; overload;
    function overwrite(el: Variant): Variant; overload;
    function overwrite(el: Variant; values: Variant): Variant; overload;
    function overwrite(el: Variant; values: Variant; returnElement: Boolean): Variant; overload;
    function set: JExt.ITemplate; overload;
    function set(html: String): JExt.ITemplate; overload;
    function set(html: String; compile: Boolean): JExt.ITemplate; overload;
  end;

//Ext

type
  JITitle = class external(JExt.IComponent)
    baseCls: String; // nullable
    title: String; // nullable
    function getBaseCls: String;
    function getTitle: String;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
  end;

//Ext

type
  JITitleBar = class external(JExt.IContainer)
    baseCls: String; // nullable
    cls: Variant; // nullable
    defaultType: String; // nullable
    items: Variant; // nullable
    maxButtonWidth: String; // nullable
    minHeight: String; // nullable
    title: String; // nullable
    titleAlign: String; // nullable
    ui: String; // nullable
    function getBaseCls: String;
    function getCls: String;
    function getDefaultType: String;
    function getItems: Variant;
    function getMaxButtonWidth: String;
    function getTitle: String;
    function getTitleAlign: String;
    function getUi: String;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setMaxButtonWidth; overload;
    procedure setMaxButtonWidth(maxButtonWidth: String); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: String); overload;
    procedure setTitleAlign; overload;
    procedure setTitleAlign(titleAlign: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
  end;

//Ext

type
  JIToolbar = class external(JExt.IContainer)
    baseCls: String; // nullable
    defaultType: String; // nullable
    docked: String; // nullable
    layout: Variant; // nullable
    minHeight: String; // nullable
    title: Variant; // nullable
    titleCls: Boolean; // nullable
    ui: String; // nullable
    function getBaseCls: String;
    function getDefaultType: String;
    function getDocked: String;
    function getLayout: Variant;
    function getTitle: JExt.ITitle;
    function getUi: String;
    procedure hideTitle;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: String); overload;
    procedure setTitle; overload;
    procedure setTitle(title: Variant); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure showTitle;
  end;

//Ext.util

type
  JIAbstractMixedCollection = class external(JExt.IBase, JExt.mixin.IObservable)
    allowFunctions: Boolean; // nullable
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; obj: Variant): Variant; overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addAll; overload;
    procedure addAll(objs: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clear;
    procedure clearListeners;
    function clone: JExt.util.IMixedCollection;
    function collect: array of Variant; overload;
    function collect(&property: String): array of Variant; overload;
    function collect(&property: String; root: String): array of Variant; overload;
    function collect(&property: String; root: String; allowNull: Boolean): array of Variant; overload;
    function contains: Boolean; overload;
    function contains(o: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function filter: JExt.util.IMixedCollection; overload;
    function filter(&property: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean): JExt.util.IMixedCollection; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Boolean; caseSensitive: Boolean): JExt.util.IMixedCollection; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndex: Float; overload;
    function findIndex(&property: String): Float; overload;
    function findIndex(&property: String; value: Variant): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean): Float; overload;
    function findIndex(&property: String; value: Variant; start: Float; anyMatch: Boolean; caseSensitive: Boolean): Float; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getBubbleEvents: Variant;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
    function getListeners: Variant;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function indexOf: Float; overload;
    function indexOf(o: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; obj: Variant): Variant; overload;
    function last: Variant;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    function remove: Variant; overload;
    function remove(o: Variant): Variant; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; o: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    function sum: Float; overload;
    function sum(&property: String): Float; overload;
    function sum(&property: String; root: String): Float; overload;
    function sum(&property: String; root: String; start: Float): Float; overload;
    function sum(&property: String; root: String; start: Float; &end: Float): Float; overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util

type
  JAudio = class external 'Audio'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIAudio = class external(JExt.IBase)
  end;

//Ext.util

type
  JIBufferedCollection = class external(JExt.util.ICollection, JExt.util.IObservable)
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getPageSize: Float;
    function getTotalCount: Float;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setPageSize; overload;
    procedure setPageSize(pageSize: Float); overload;
    procedure setTotalCount; overload;
    procedure setTotalCount(totalCount: Float); overload;
  end;

//Ext.util

type
  JICollection = class external(JExt.IBase, JExt.mixin.ISortable, JExt.mixin.IFilterable)
    filters: array of Variant; // nullable
    sorters: array of Variant; // nullable
    all: array of Variant; // nullable
    indices: Variant; // nullable
    items: array of Variant; // nullable
    keys: array of Variant; // nullable
    _length: Float; // nullable
    map: Variant; // nullable
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; item: Variant): Variant; overload;
    procedure addAll; overload;
    procedure addAll(addItems: Variant); overload;
    procedure addFilter; overload;
    procedure addFilter(filter: Variant); overload;
    function addFilters: Variant; overload;
    function addFilters(filters: Variant): Variant; overload;
    procedure addSorter; overload;
    procedure addSorter(sorter: Variant); overload;
    procedure addSorter(sorter: Variant; defaultDirection: String); overload;
    procedure addSorters; overload;
    procedure addSorters(sorters: array of Variant); overload;
    procedure addSorters(sorters: array of Variant; defaultDirection: String); overload;
    procedure clear;
    function clone: JExt.util.IMixedCollection;
    function contains: Boolean; overload;
    function contains(item: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    procedure each; overload;
    procedure each(fn: Variant); overload;
    procedure each(fn: Variant; scope: Variant); overload;
    procedure eachKey; overload;
    procedure eachKey(fn: Variant); overload;
    procedure eachKey(fn: Variant; scope: Variant); overload;
    function filter: array of Variant; overload;
    function filter(&property: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant): array of Variant; overload;
    function filter(&property: Variant; value: Variant; anyMatch: Variant; caseSensitive: Variant): array of Variant; overload;
    function filterBy: JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant): JExt.util.IMixedCollection; overload;
    function filterBy(fn: Variant; scope: Variant): JExt.util.IMixedCollection; overload;
    function findBy: Variant; overload;
    function findBy(fn: Variant): Variant; overload;
    function findBy(fn: Variant; scope: Variant): Variant; overload;
    function findIndexBy: Float; overload;
    function findIndexBy(fn: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant): Float; overload;
    function findIndexBy(fn: Variant; scope: Variant; start: Float): Float; overload;
    function findInsertionIndex: Float; overload;
    function findInsertionIndex(items: array of Variant): Float; overload;
    function findInsertionIndex(items: array of Variant; item: Variant): Float; overload;
    function first: Variant;
    function get: Variant; overload;
    function get(key: Variant): Variant; overload;
    function getAt: Variant; overload;
    function getAt(index: Float): Variant; overload;
    function getAutoFilter: Boolean;
    function getAutoSort: Boolean;
    function getByKey: Variant; overload;
    function getByKey(key: Variant): Variant; overload;
    function getCount: Float;
    function getDefaultSortDirection: String;
    function getFilterFn: Variant;
    function getFilterRoot: String;
    function getFilters: array of Variant;
    function getKey: Variant; overload;
    function getKey(item: Variant): Variant; overload;
    function getRange: array of Variant; overload;
    function getRange(start: Float): array of Variant; overload;
    function getRange(start: Float; &end: Float): array of Variant; overload;
    function getSortFn: Variant;
    function getSortRoot: String;
    function getSorters: array of Variant;
    function indexOf: Float; overload;
    function indexOf(item: Variant): Float; overload;
    function indexOfKey: Float; overload;
    function indexOfKey(key: String): Float; overload;
    function insert: Variant; overload;
    function insert(index: Float): Variant; overload;
    function insert(index: Float; key: String): Variant; overload;
    function insert(index: Float; key: String; item: Variant): Variant; overload;
    function insertFilter: Variant; overload;
    function insertFilter(index: Float): Variant; overload;
    function insertFilter(index: Float; filter: Variant): Variant; overload;
    function insertFilters: array of Variant; overload;
    function insertFilters(index: Float): array of Variant; overload;
    function insertFilters(index: Float; filters: array of Variant): array of Variant; overload;
    procedure insertSorter; overload;
    procedure insertSorter(index: Float); overload;
    procedure insertSorter(index: Float; sorter: Variant); overload;
    procedure insertSorter(index: Float; sorter: Variant; defaultDirection: String); overload;
    function insertSorters: JExt.util.ICollection;
    function last: Variant;
    function remove: Variant; overload;
    function remove(item: Variant): Variant; overload;
    function removeAll: JExt.util.IMixedCollection; overload;
    function removeAll(items: array of Variant): JExt.util.IMixedCollection; overload;
    function removeAt: Variant; overload;
    function removeAt(index: Float): Variant; overload;
    function removeAtKey: Variant; overload;
    function removeAtKey(key: String): Variant; overload;
    function removeFilters: JExt.util.ICollection; overload;
    function removeFilters(filters: Variant): JExt.util.ICollection; overload;
    procedure removeSorter; overload;
    procedure removeSorter(sorter: Variant); overload;
    function removeSorters: JExt.util.ICollection; overload;
    function removeSorters(sorters: Variant): JExt.util.ICollection; overload;
    function replace: Variant; overload;
    function replace(oldKey: String): Variant; overload;
    function replace(oldKey: String; item: Variant): Variant; overload;
    procedure setAutoFilter; overload;
    procedure setAutoFilter(autoFilter: Boolean); overload;
    procedure setAutoSort; overload;
    procedure setAutoSort(autoSort: Boolean); overload;
    procedure setDefaultSortDirection; overload;
    procedure setDefaultSortDirection(defaultSortDirection: String); overload;
    procedure setFilterRoot; overload;
    procedure setFilterRoot(filterRoot: String); overload;
    procedure setFilters; overload;
    procedure setFilters(filters: array of Variant); overload;
    procedure setSortRoot; overload;
    procedure setSortRoot(sortRoot: String); overload;
    procedure setSorters; overload;
    procedure setSorters(sorters: array of Variant); overload;
    function sort: array of Variant; overload;
    function sort(sorters: Variant): array of Variant; overload;
    function sort(sorters: Variant; defaultDirection: Variant): array of Variant; overload;
  end;

//Ext.util

type
  JIDelayedTask = class external(JExt.IBase)
    procedure cancel;
    procedure delay; overload;
    procedure delay(delay: Float); overload;
    procedure delay(delay: Float; newFn: Variant); overload;
    procedure delay(delay: Float; newFn: Variant; newScope: Variant); overload;
    procedure delay(delay: Float; newFn: Variant; newScope: Variant; newArgs: array of Variant); overload;
    function getArgs: Variant;
    function getDelay: Variant;
    function getFn: Variant;
    function getInterval: Variant;
    function getScope: Variant;
    procedure setArgs; overload;
    procedure setArgs(args: Variant); overload;
    procedure setDelay; overload;
    procedure setDelay(delay: Variant); overload;
    procedure setFn; overload;
    procedure setFn(fn: Variant); overload;
    procedure setInterval; overload;
    procedure setInterval(interval: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
  end;

//Ext.util

type
  JIDraggable = class external(JExt.IBase, JExt.mixin.IObservable)
    direction: String; // nullable
    initialOffset: Variant; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    function disable: JExt.util.IDraggable;
    function enable: JExt.util.IDraggable;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBubbleEvents: Variant;
    function getCls: String;
    function getConstraint: String;
    function getDirection: String;
    function getDisabled: Variant;
    function getDraggingCls: String;
    function getElement: Variant;
    function getInitialOffset: Variant;
    function getListeners: Variant;
    function getTranslatable: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCls; overload;
    procedure setCls(cls: String); overload;
    procedure setConstraint; overload;
    procedure setConstraint(constraint: String); overload;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Variant); overload;
    procedure setDraggingCls; overload;
    procedure setDraggingCls(draggingCls: String); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setInitialOffset; overload;
    procedure setInitialOffset(initialOffset: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util

type
  JIDroppable = class external(JExt.IBase, JExt.mixin.IObservable)
    activeCls: String; // nullable
    baseCls: String; // nullable
    disabled: Boolean; // nullable
    group: String; // nullable
    hoverCls: String; // nullable
    invalidCls: String; // nullable
    validDropMode: String; // nullable
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure destroy;
    procedure disable;
    procedure enable;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getBaseCls: String;
    function getBubbleEvents: Variant;
    function getListeners: Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function isDisabled: Boolean;
    function isMonitoring: Boolean;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util

type
  JIFilter = class external(JExt.IBase)
    anyMatch: Boolean; // nullable
    caseSensitive: Boolean; // nullable
    exactMatch: Boolean; // nullable
    filterFn: Variant; // nullable
    id: String; // nullable
    &property: String; // nullable
    root: String; // nullable
    scope: Variant; // nullable
    value: Variant; // nullable
    function getAnyMatch: Boolean;
    function getCaseSensitive: Boolean;
    function getExactMatch: Boolean;
    function getFilterFn: Variant;
    function getId: String;
    function getProperty: String;
    function getRoot: String;
    function getScope: Variant;
    function getValue: Variant;
    procedure setAnyMatch; overload;
    procedure setAnyMatch(anyMatch: Boolean); overload;
    procedure setCaseSensitive; overload;
    procedure setCaseSensitive(caseSensitive: Boolean); overload;
    procedure setExactMatch; overload;
    procedure setExactMatch(exactMatch: Boolean); overload;
    procedure setFilterFn; overload;
    procedure setFilterFn(filterFn: Variant); overload;
    procedure setId; overload;
    procedure setId(id: String); overload;
    procedure setProperty; overload;
    procedure setProperty(&property: String); overload;
    procedure setRoot; overload;
    procedure setRoot(root: String); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
    procedure setValue; overload;
    procedure setValue(value: Variant); overload;
  end;

//Ext.util

type
  JFormat = class external 'Format'
    defaultDateFormat: String;
    potentialUndefinedKeys: array of Variant;
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function date: String; overload;
    function date(value: Variant): String; overload;
    function date(value: Variant; format: String): String; overload;
    procedure destroy;
    function ellipsis: String; overload;
    function ellipsis(value: String): String; overload;
    function ellipsis(value: String; _length: Float): String; overload;
    function ellipsis(value: String; _length: Float; word: Boolean): String; overload;
    function escape: String; overload;
    function escape(&string: String): String; overload;
    function escapeRegex: String; overload;
    function escapeRegex(str: String): String; overload;
    function format(&string: String; values: array of Variant): String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function htmlDecode: String; overload;
    function htmlDecode(value: String): String; overload;
    function htmlEncode: String; overload;
    function htmlEncode(value: String): String; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function leftPad: String; overload;
    function leftPad(&string: String): String; overload;
    function leftPad(&string: String; size: Float): String; overload;
    function leftPad(&string: String; size: Float; char: String): String; overload;
    function statics: JExt.IClass;
    function toggle: String; overload;
    function toggle(&string: String): String; overload;
    function toggle(&string: String; value: String): String; overload;
    function toggle(&string: String; value: String; other: String): String; overload;
    function trim: String; overload;
    function trim(&string: String): String; overload;
  end;

  JIFormat = class external(JExt.IBase)
  end;

//Ext.util

type
  JIGeolocation = class external(JExt.IEvented)
    allowHighAccuracy: Boolean; // nullable
    autoUpdate: Boolean; // nullable
    frequency: Float; // nullable
    maximumAge: Float; // nullable
    timeout: Float; // nullable
    accuracy: Float; // nullable
    altitude: Float; // nullable
    altitudeAccuracy: Float; // nullable
    heading: Float; // nullable
    latitude: Float; // nullable
    longitude: Float; // nullable
    speed: Float; // nullable
    timestamp: Variant; // nullable
    procedure destroy;
    function getAllowHighAccuracy: Boolean;
    function getAutoUpdate: Boolean;
    function getFrequency: Float;
    function getMaximumAge: Float;
    function getTimeout: Float;
    procedure setAllowHighAccuracy; overload;
    procedure setAllowHighAccuracy(allowHighAccuracy: Boolean); overload;
    procedure setAutoUpdate; overload;
    procedure setAutoUpdate(autoUpdate: Boolean); overload;
    procedure setFrequency; overload;
    procedure setFrequency(frequency: Float); overload;
    procedure setMaximumAge; overload;
    procedure setMaximumAge(maximumAge: Float); overload;
    procedure setTimeout; overload;
    procedure setTimeout(timeout: Float); overload;
    procedure updateLocation; overload;
    procedure updateLocation(callback: Variant); overload;
    procedure updateLocation(callback: Variant; scope: Variant); overload;
  end;

//Ext.util

type
  JIGrouper = class external(JExt.util.ISorter)
    groupFn: Variant; // nullable
    sortProperty: String; // nullable
    sorterFn: Variant; // nullable
    function getGroupFn: Variant;
    function getSortProperty: String;
    function getSorterFn: Variant;
    procedure setGroupFn; overload;
    procedure setGroupFn(groupFn: Variant); overload;
    procedure setSortProperty; overload;
    procedure setSortProperty(sortProperty: String); overload;
    procedure setSorterFn; overload;
    procedure setSorterFn(sorterFn: Variant); overload;
  end;

//Ext.util

type
  JIHashMap = class external(JExt.IBase, JExt.mixin.IObservable)
    keyFn: Variant; // nullable
    function add: Variant; overload;
    function add(key: String): Variant; overload;
    function add(key: String; value: Variant): Variant; overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function clear: JExt.util.IHashMap; overload;
    function clear(initial: Variant): JExt.util.IHashMap; overload;
    procedure clearListeners;
    function clone: JExt.util.IHashMap;
    function contains: Boolean; overload;
    function contains(value: Variant): Boolean; overload;
    function containsKey: Boolean; overload;
    function containsKey(key: String): Boolean; overload;
    procedure destroy;
    function each: JExt.util.IHashMap; overload;
    function each(fn: Variant): JExt.util.IHashMap; overload;
    function each(fn: Variant; scope: Variant): JExt.util.IHashMap; overload;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function get: Variant; overload;
    function get(key: String): Variant; overload;
    function getBubbleEvents: Variant;
    function getCount: Float;
    function getKeys: array of Variant;
    function getListeners: Variant;
    function getValues: array of Variant;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    function remove: Boolean; overload;
    function remove(o: Variant): Boolean; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeByKey: Boolean; overload;
    function removeByKey(key: String): Boolean; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    function replace: Variant; overload;
    function replace(key: String): Variant; overload;
    function replace(key: String; value: Variant): Variant; overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util

type
  JInflector = class external 'Inflector'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function classify: String; overload;
    function classify(word: String): String; overload;
    procedure clearPlurals;
    procedure clearSingulars;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function isTransnumeral: Boolean; overload;
    function isTransnumeral(word: String): Boolean; overload;
    function ordinalize: String; overload;
    function ordinalize(number: Float): String; overload;
    procedure plural; overload;
    procedure plural(matcher: JRegExp); overload;
    procedure plural(matcher: JRegExp; replacer: String); overload;
    function pluralize: String; overload;
    function pluralize(word: String): String; overload;
    procedure singular; overload;
    procedure singular(matcher: JRegExp); overload;
    procedure singular(matcher: JRegExp; replacer: String); overload;
    function singularize: String; overload;
    function singularize(word: String): String; overload;
    function statics: JExt.IClass;
  end;

  JIInflector = class external(JExt.IBase)
  end;

//Ext.util

type
  JInputBlocker = class external 'InputBlocker'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JIInputBlocker = class external(JExt.IBase)
  end;

//Ext.util

type
  JILineSegment = class external(JExt.IBase)
    function intersects: JExt.util.IPoint; overload;
    function intersects(lineSegment: JExt.util.ILineSegment): JExt.util.IPoint; overload;
    function toString: String;
  end;

//Ext.util

type
  JIMixedCollection = class external(JExt.util.IAbstractMixedCollection, JExt.util.ISortable)
    procedure destroy;
    procedure initSortable;
    procedure reorder; overload;
    procedure reorder(mapping: Variant); overload;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String; where: String): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String; where: String; doSort: Boolean): array of JExt.util.ISorter; overload;
    procedure sortBy; overload;
    procedure sortBy(sorterFn: Variant); overload;
    procedure sortByKey; overload;
    procedure sortByKey(dir: String); overload;
    procedure sortByKey(dir: String; fn: Variant); overload;
  end;

//Ext.util

type
  JIOffset = class external(JExt.IBase)
  end;

//Ext.util.paintmonitor

type
  JIAbstract = class external(JExt.IBase)
    procedure destroy;
    function getArgs: array of Variant;
    function getCallback: Variant;
    function getElement: Variant;
    function getScope: Variant;
    procedure setArgs; overload;
    procedure setArgs(args: array of Variant); overload;
    procedure setCallback; overload;
    procedure setCallback(callback: Variant); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
  end;

//Ext.util.paintmonitor

type
  JICssAnimation = class external(JExt.util.paintmonitor.IAbstract)
  end;

//Ext.util

type
  JIPaintMonitor = class external(JExt.IBase)
  end;

//Ext.util.paintmonitor

type
  JIOverflowChange = class external(JExt.util.paintmonitor.IAbstract)
  end;

//Ext.util

type
  JPoint = class external 'Point'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.util.IPoint; overload;
    function from(&object: Variant): JExt.util.IPoint; overload;
    function fromEvent: JExt.util.IPoint; overload;
    function fromEvent(e: JEvent): JExt.util.IPoint; overload;
    function fromTouch: JExt.util.IPoint; overload;
    function fromTouch(touch: JEvent): JExt.util.IPoint; overload;
    function getName: String;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIPoint = class external(JExt.IBase)
    function clone: JExt.util.IPoint;
    function copy: JExt.util.IPoint;
    function copyFrom: JExt.util.IPoint; overload;
    function copyFrom(point: Variant): JExt.util.IPoint; overload;
    function equals: Boolean; overload;
    function equals(point: Variant): Boolean; overload;
    function isCloseTo: Boolean; overload;
    function isCloseTo(point: Variant): Boolean; overload;
    function isCloseTo(point: Variant; threshold: Variant): Boolean; overload;
    function isWithin: Boolean;
    function roundedEquals: Boolean; overload;
    function roundedEquals(point: Variant): Boolean; overload;
    function toString: String;
    function translate: Boolean; overload;
    function translate(x: Float): Boolean; overload;
    function translate(x: Float; y: Float): Boolean; overload;
  end;

//Ext.util

type
  JIPositionMap = class external(JExt.IBase)
    function getMinimumHeight: Float;
    procedure setMinimumHeight; overload;
    procedure setMinimumHeight(minimumHeight: Float); overload;
  end;

//Ext.util

type
  JRegion = class external 'Region'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.util.IRegion; overload;
    function from(o: Variant): JExt.util.IRegion; overload;
    function getName: String;
    function getRegion: JExt.util.IRegion; overload;
    function getRegion(el: Variant): JExt.util.IRegion; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIRegion = class external(JExt.IBase)
    function adjust: JExt.util.IRegion; overload;
    function adjust(top: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float; bottom: Float): JExt.util.IRegion; overload;
    function adjust(top: Float; right: Float; bottom: Float; left: Float): JExt.util.IRegion; overload;
    function constrainTo: JExt.util.IRegion; overload;
    function constrainTo(targetRegion: JExt.util.IRegion): JExt.util.IRegion; overload;
    function contains: Boolean; overload;
    function contains(region: JExt.util.IRegion): Boolean; overload;
    function copy: JExt.util.IRegion;
    function equals: Boolean; overload;
    function equals(region: JExt.util.IRegion): Boolean; overload;
    function getOutOfBoundOffset: JExt.util.IRegion; overload;
    function getOutOfBoundOffset(axis: Variant): JExt.util.IRegion; overload;
    function getOutOfBoundOffset(axis: Variant; p: JExt.util.IPoint): JExt.util.IRegion; overload;
    function getOutOfBoundOffsetX: Float; overload;
    function getOutOfBoundOffsetX(p: Float): Float; overload;
    function getOutOfBoundOffsetY: Float; overload;
    function getOutOfBoundOffsetY(p: Float): Float; overload;
    function intersect: Variant; overload;
    function intersect(region: JExt.util.IRegion): Variant; overload;
    function isOutOfBound: Boolean; overload;
    function isOutOfBound(axis: String): Boolean; overload;
    function isOutOfBound(axis: String; p: Variant): Boolean; overload;
    function isOutOfBoundX: Boolean; overload;
    function isOutOfBoundX(p: Float): Boolean; overload;
    function isOutOfBoundY: Boolean; overload;
    function isOutOfBoundY(p: Float): Boolean; overload;
    function round: JExt.util.IRegion;
    function toString: String;
    function translateBy: JExt.util.IRegion; overload;
    function translateBy(offset: Variant): JExt.util.IRegion; overload;
    function union: JExt.util.IRegion; overload;
    function union(region: JExt.util.IRegion): JExt.util.IRegion; overload;
  end;

//Ext.util.sizemonitor

type
  JIAbstract = class external(JExt.IBase, JExt.mixin.ITemplatable)
    procedure destroy;
    function getArgs: array of Variant;
    function getCallback: Variant;
    function getElement: Variant;
    function getScope: Variant;
    procedure setArgs; overload;
    procedure setArgs(args: array of Variant); overload;
    procedure setCallback; overload;
    procedure setCallback(callback: Variant); overload;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
    procedure setScope; overload;
    procedure setScope(scope: Variant); overload;
  end;

//Ext.util.sizemonitor

type
  JIDefault = class external(JExt.util.sizemonitor.IAbstract)
  end;

//Ext.util

type
  JISizeMonitor = class external(JExt.IBase)
  end;

//Ext.util.sizemonitor

type
  JIOverflowChange = class external(JExt.util.sizemonitor.IAbstract)
  end;

//Ext.util.sizemonitor

type
  JIScroll = class external(JExt.util.sizemonitor.IAbstract)
  end;

//Ext.util

type
  JISortable = class external(JExt.mixin.IMixin)
    defaultSortDirection: String; // nullable
    isSortable: Boolean; // nullable
    sortRoot: String; // nullable
    sorters: JExt.util.IMixedCollection; // nullable
    procedure destroy;
    procedure initSortable;
    function sort: array of JExt.util.ISorter; overload;
    function sort(sorters: Variant): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String; where: String): array of JExt.util.ISorter; overload;
    function sort(sorters: Variant; direction: String; where: String; doSort: Boolean): array of JExt.util.ISorter; overload;
  end;

//Ext.util

type
  JISorter = class external(JExt.IBase)
    direction: String; // nullable
    id: Variant; // nullable
    &property: String; // nullable
    root: String; // nullable
    sorterFn: Variant; // nullable
    transform: Variant; // nullable
    function getDirection: String;
    function getId: Variant;
    function getProperty: String;
    function getRoot: String;
    function getSorterFn: Variant;
    function getTransform: Variant;
    procedure setDirection; overload;
    procedure setDirection(direction: String); overload;
    procedure setId; overload;
    procedure setId(id: Variant); overload;
    procedure setProperty; overload;
    procedure setProperty(&property: String); overload;
    procedure setRoot; overload;
    procedure setRoot(root: String); overload;
    procedure setSorterFn; overload;
    procedure setSorterFn(sorterFn: Variant); overload;
    procedure setTransform; overload;
    procedure setTransform(transform: Variant); overload;
    procedure toggle;
  end;

//Ext.util

type
  JITapRepeater = class external(JExt.IBase, JExt.mixin.IObservable)
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure clearListeners;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getAccelerate: Boolean;
    function getBubbleEvents: Variant;
    function getDelay: Float;
    function getEl: Variant;
    function getInterval: Float;
    function getListeners: Variant;
    function getPressCls: Variant;
    function getPreventDefault: Boolean;
    function getStopDefault: Boolean;
    function getTimer: Float;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setAccelerate; overload;
    procedure setAccelerate(accelerate: Boolean); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setDelay; overload;
    procedure setDelay(delay: Float); overload;
    procedure setEl; overload;
    procedure setEl(el: Variant); overload;
    procedure setInterval; overload;
    procedure setInterval(interval: Float); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setPressCls; overload;
    procedure setPressCls(pressCls: Variant); overload;
    procedure setPreventDefault; overload;
    procedure setPreventDefault(preventDefault: Boolean); overload;
    procedure setStopDefault; overload;
    procedure setStopDefault(stopDefault: Boolean); overload;
    procedure setTimer; overload;
    procedure setTimer(timer: Float); overload;
    procedure suspendEvents;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
  end;

//Ext.util.translatable

type
  JIAbstract = class external(JExt.IEvented)
    procedure destroy;
    function getEasing: Variant;
    function getEasingX: Variant;
    function getEasingY: Variant;
    function getUseWrapper: Variant;
    procedure setEasing; overload;
    procedure setEasing(easing: Variant); overload;
    procedure setEasingX; overload;
    procedure setEasingX(easingX: Variant); overload;
    procedure setEasingY; overload;
    procedure setEasingY(easingY: Variant); overload;
    procedure setUseWrapper; overload;
    procedure setUseWrapper(useWrapper: Variant); overload;
  end;

//Ext.util.translatable

type
  JICssPosition = class external(JExt.util.translatable.IDom)
    procedure destroy;
  end;

//Ext.util.translatable

type
  JICssTransform = class external(JExt.util.translatable.IDom)
    procedure destroy;
  end;

//Ext.util.translatable

type
  JIDom = class external(JExt.util.translatable.IAbstract)
    function getElement: Variant;
    procedure setElement; overload;
    procedure setElement(element: Variant); overload;
  end;

//Ext.util

type
  JITranslatable = class external(JExt.IBase)
  end;

//Ext.util.translatable

type
  JIScrollPosition = class external(JExt.util.translatable.IDom)
    procedure destroy;
    function getUseWrapper: Boolean;
    procedure setUseWrapper; overload;
    procedure setUseWrapper(useWrapper: Boolean); overload;
  end;

//Ext.util

type
  JITranslatableGroup = class external(JExt.util.translatable.IAbstract)
    function getActiveIndex: Float;
    function getItemLength: Variant;
    function getItems: array of Variant;
    procedure setActiveIndex; overload;
    procedure setActiveIndex(activeIndex: Float); overload;
    procedure setItemLength; overload;
    procedure setItemLength(itemLength: Variant); overload;
    procedure setItems; overload;
    procedure setItems(items: array of Variant); overload;
  end;

//Ext.util

type
  JITranslatableList = class external(JExt.util.translatable.IAbstract)
    function getItems: array of Variant;
    procedure setItems; overload;
    procedure setItems(items: array of Variant); overload;
  end;

//Ext.util

type
  JIWrapper = class external(JExt.IBase, JExt.mixin.IBindable)
    procedure destroy;
  end;

//Ext.ux

type
  JIActionOverFlowMenuButton = class external(JExt.ux.IMenuButton)
    menuItems: Variant; // nullable
  end;

//Ext.ux

type
  JIApplicationMenu = class external(JExt.IMenu)
    defaults: Variant; // nullable
    function getDefaults: Variant;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
  end;

//Ext.ux

type
  JIContextMenu = class external(JExt.IMenu)
  end;

//Ext.ux.device.analytics

type
  JIAbstract = class external(JExt.IBase)
    function getAccountID: Variant;
    procedure registerAccount; overload;
    procedure registerAccount(accountID: String); overload;
    procedure setAccountID; overload;
    procedure setAccountID(accountID: Variant); overload;
    procedure trackEvent; overload;
    procedure trackEvent(config: Variant); overload;
    procedure trackPageview; overload;
    procedure trackPageview(config: String); overload;
  end;

//Ext.ux.device.analytics

type
  JICordova = class external(JExt.ux.device.analytics.IAbstract)
    procedure trackEvent; overload;
    procedure trackEvent(config: Variant); overload;
    procedure trackPageview; overload;
    procedure trackPageview(page: Variant); overload;
  end;

//Ext.ux.device

type
  JAnalytics = class external 'Analytics'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure destroy;
    function getAccountID: Variant;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure registerAccount; overload;
    procedure registerAccount(accountID: String); overload;
    procedure setAccountID; overload;
    procedure setAccountID(accountID: Variant); overload;
    function statics: JExt.IClass;
    procedure trackEvent; overload;
    procedure trackEvent(config: Variant); overload;
    procedure trackPageview; overload;
    procedure trackPageview(config: String); overload;
  end;

  JIAnalytics = class external(JExt.IBase, JExt.ux.device.analytics.IAbstract)
  end;

//Ext.ux.device.twitter

type
  JIAbstract = class external(JExt.IBase)
    procedure compose; overload;
    procedure compose(config: Variant); overload;
    procedure getMentions; overload;
    procedure getMentions(config: Variant); overload;
    procedure getPublicTimeline; overload;
    procedure getPublicTimeline(config: Variant); overload;
    procedure getTwitterRequest; overload;
    procedure getTwitterRequest(config: Variant); overload;
    procedure getTwitterUsername; overload;
    procedure getTwitterUsername(config: Variant); overload;
  end;

//Ext.ux.device.twitter

type
  JICordova = class external(JExt.IBase)
  end;

//Ext.ux.device

type
  JTwitter = class external 'Twitter'
    self: JExt.IClass;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    procedure compose; overload;
    procedure compose(config: Variant); overload;
    procedure destroy;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    procedure getMentions; overload;
    procedure getMentions(config: Variant); overload;
    procedure getPublicTimeline; overload;
    procedure getPublicTimeline(config: Variant); overload;
    procedure getTwitterRequest; overload;
    procedure getTwitterRequest(config: Variant); overload;
    procedure getTwitterUsername; overload;
    procedure getTwitterUsername(config: Variant); overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    function statics: JExt.IClass;
  end;

  JITwitter = class external(JExt.IBase, JExt.ux.device.twitter.IAbstract)
  end;

//Ext.ux

type
  JIMenuButton = class external(JExt.IButton)
    function getMenuItems: array of Variant;
    procedure setMenuItems; overload;
    procedure setMenuItems(menuItems: array of Variant); overload;
  end;

//Ext.ux

type
  JITabMenuButton = class external(JExt.ux.IMenuButton)
    menuItems: Variant; // nullable
  end;

//Ext

type
  JVersion = class external 'Version'
    function compare: Float; overload;
    function compare(current: String): Float; overload;
    function compare(current: String; target: String): Float; overload;
    function getComponentValue: Variant; overload;
    function getComponentValue(value: Variant): Variant; overload;
  end;

  JIVersion = class external
    procedure deprecate; overload;
    procedure deprecate(packageName: String); overload;
    procedure deprecate(packageName: String; since: String); overload;
    procedure deprecate(packageName: String; since: String; closure: Variant); overload;
    procedure deprecate(packageName: String; since: String; closure: Variant; scope: Variant); overload;
    function equals: Boolean; overload;
    function equals(target: Variant): Boolean; overload;
    function getBuild: Float;
    function getMajor: Float;
    function getMinor: Float;
    function getPatch: Float;
    function getRelease: Float;
    function getShortVersion: String;
    function getVersion: JExt.IVersion; overload;
    function getVersion(packageName: String): JExt.IVersion; overload;
    function gt: Boolean; overload;
    function gt(target: Variant): Boolean; overload;
    function gtEq: Boolean; overload;
    function gtEq(target: Variant): Boolean; overload;
    function isGreaterThan: Boolean; overload;
    function isGreaterThan(target: Variant): Boolean; overload;
    function isGreaterThanOrEqual: Boolean; overload;
    function isGreaterThanOrEqual(target: Variant): Boolean; overload;
    function isLessThan: Boolean; overload;
    function isLessThan(target: Variant): Boolean; overload;
    function isLessThanOrEqual: Boolean; overload;
    function isLessThanOrEqual(target: Variant): Boolean; overload;
    function lt: Boolean; overload;
    function lt(target: Variant): Boolean; overload;
    function ltEq: Boolean; overload;
    function ltEq(target: Variant): Boolean; overload;
    function match: Boolean; overload;
    function match(target: Variant): Boolean; overload;
    function setVersion: Variant; overload;
    function setVersion(packageName: String): Variant; overload;
    function setVersion(packageName: String; version: Variant): Variant; overload;
    function toArray: array of Float;
    function toNumber: Float; overload;
    function toNumber(value: Float): Float; overload;
  end;

//Ext

type
  JIVideo = class external(JExt.IMedia)
    baseCls: String; // nullable
    posterUrl: String; // nullable
    function getBaseCls: String;
    function getPosterUrl: String;
    function getUrl: String;
    procedure initialize;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setPosterUrl; overload;
    procedure setPosterUrl(posterUrl: String); overload;
    procedure setUrl; overload;
    procedure setUrl(url: Variant); overload;
    procedure updatePosterUrl; overload;
    procedure updatePosterUrl(newUrl: Variant); overload;
    procedure updateUrl; overload;
    procedure updateUrl(newUrl: Variant); overload;
  end;

//Ext.viewport

type
  JIAndroid = class external(JExt.viewport.IDefault)
    function getTranslatable: Variant;
    function getWindowHeight: Float;
    function getWindowWidth: Float;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Variant); overload;
  end;

//Ext.viewport

type
  JIDefault = class external(JExt.IContainer)
    autoMaximize: Boolean; // nullable
    id: String; // nullable
    layout: Variant; // nullable
    preventPanning: Boolean; // nullable
    preventZooming: Boolean; // nullable
    isReady: Boolean; // nullable
    function getAutoMaximize: Boolean;
    function getLayout: Variant;
    function getOrientation: String;
    function getPreventPanning: Boolean;
    function getPreventZooming: Boolean;
    function getSize: Variant;
    function getUseBodyElement: Boolean;
    function getWindowHeight: Float;
    function getWindowWidth: Float;
    procedure hideAllMenus; overload;
    procedure hideAllMenus(animation: Variant); overload;
    procedure hideMenu; overload;
    procedure hideMenu(side: String); overload;
    procedure hideOtherMenus; overload;
    procedure hideOtherMenus(side: String); overload;
    procedure hideOtherMenus(side: String; animation: String); overload;
    procedure removeMenu; overload;
    procedure removeMenu(side: String); overload;
    procedure setAutoMaximize; overload;
    procedure setAutoMaximize(autoMaximize: Boolean); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setMenu; overload;
    procedure setMenu(menu: JExt.IMenu); overload;
    procedure setMenu(menu: JExt.IMenu; config: Variant); overload;
    procedure setPreventPanning; overload;
    procedure setPreventPanning(preventPanning: Boolean); overload;
    procedure setPreventZooming; overload;
    procedure setPreventZooming(preventZooming: Boolean); overload;
    procedure setUseBodyElement; overload;
    procedure setUseBodyElement(useBodyElement: Boolean); overload;
    procedure showMenu; overload;
    procedure showMenu(side: String); overload;
    procedure toggleMenu; overload;
    procedure toggleMenu(side: String); overload;
  end;

//Ext.viewport

type
  JIIos = class external(JExt.viewport.IDefault)
  end;

//Ext

type
  JViewport = class external 'Viewport'
    isReady: Boolean;
    items: JExt.util.IMixedCollection;
    self: JExt.IClass;
    function add: JExt.IComponent; overload;
    function add(newItems: Variant): JExt.IComponent; overload;
    procedure addAfterListener; overload;
    procedure addAfterListener(eventName: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function addAll: array of Variant; overload;
    function addAll(items: array of Variant): array of Variant; overload;
    procedure addBeforeListener; overload;
    procedure addBeforeListener(eventName: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addCls; overload;
    procedure addCls(cls: String); overload;
    procedure addCls(cls: String; prefix: String); overload;
    procedure addCls(cls: String; prefix: String; suffix: String); overload;
    procedure addEvents; overload;
    procedure addEvents(eventNames: Variant); overload;
    procedure addListener; overload;
    procedure addListener(eventName: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure addListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure addManagedListener; overload;
    procedure addManagedListener(&object: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure addManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure animateActiveItem; overload;
    procedure animateActiveItem(activeItem: Variant); overload;
    procedure animateActiveItem(activeItem: Variant; animation: Variant); overload;
    function applyMasked: Variant; overload;
    function applyMasked(masked: Variant): Variant; overload;
    function callOverridden: Variant; overload;
    function callOverridden(args: Variant): Variant; overload;
    function callParent: Variant; overload;
    function callParent(args: Variant): Variant; overload;
    function callSuper: Variant; overload;
    function callSuper(args: Variant): Variant; overload;
    function child: JExt.IComponent; overload;
    function child(selector: String): JExt.IComponent; overload;
    procedure clearListeners;
    procedure destroy;
    procedure disable;
    function down: JExt.IComponent; overload;
    function down(selector: String): JExt.IComponent; overload;
    procedure enable;
    procedure enableBubble; overload;
    procedure enableBubble(events: Variant); overload;
    function fireAction: Variant; overload;
    function fireAction(eventName: String): Variant; overload;
    function fireAction(eventName: String; args: array of Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant): Variant; overload;
    function fireAction(eventName: String; args: array of Variant; fn: Variant; scope: Variant): Variant; overload;
    function fireEvent(eventName: String; args: array of Variant): Boolean;
    function getActiveItem: Variant;
    procedure getAlignmentInfo; overload;
    procedure getAlignmentInfo(component: Variant); overload;
    procedure getAlignmentInfo(component: Variant; alignment: Variant); overload;
    function getAt: JExt.IComponent; overload;
    function getAt(index: Float): JExt.IComponent; overload;
    function getAutoDestroy: Boolean;
    function getAutoMaximize: Boolean;
    function getBaseCls: String;
    function getBorder: Variant;
    function getBottom: Variant;
    function getBubbleEvents: Variant;
    function getCentered: Boolean;
    function getCls: Variant;
    function getComponent: JExt.IComponent; overload;
    function getComponent(component: Variant): JExt.IComponent; overload;
    function getContentEl: Variant;
    function getControl: Variant;
    function getData: Variant;
    function getDefaultType: String;
    function getDefaults: Variant;
    function getDisabled: Boolean;
    function getDisabledCls: String;
    function getDocked: String;
    function getDockedComponent: Variant; overload;
    function getDockedComponent(component: Variant): Variant; overload;
    function getDockedItems: array of Variant;
    function getEl: JExt.dom.IElement;
    function getEnterAnimation: Variant;
    function getExitAnimation: Variant;
    function getFlex: Float;
    function getFloatingCls: String;
    function getHidden: Boolean;
    function getHiddenCls: String;
    function getHideAnimation: Variant;
    function getHideOnMaskTap: Boolean;
    function getHtml: Variant;
    function getId: String;
    function getInitialConfig: Variant; overload;
    function getInitialConfig(name: String): Variant; overload;
    function getInnerItems: array of Variant;
    function getItemId: String;
    function getItems: Variant;
    function getLayout: Variant;
    function getLeft: Variant;
    function getListeners: Variant;
    function getMargin: Variant;
    function getMasked: Variant;
    function getMaxHeight: Variant;
    function getMaxWidth: Variant;
    function getMinHeight: Variant;
    function getMinWidth: Variant;
    function getModal: Boolean;
    function getOrientation: String;
    function getPadding: Variant;
    function getParent: JExt.IComponent;
    function getPlugins: Variant;
    function getPreventPanning: Boolean;
    function getPreventZooming: Boolean;
    function getRecord: JExt.data.IModel;
    function getRenderTo: JExt.IElement;
    function getRight: Variant;
    function getScrollable: JExt.scroll.IView;
    function getShowAnimation: Variant;
    function getSize: Variant;
    function getStyle: Variant;
    function getStyleHtmlCls: String;
    function getStyleHtmlContent: Boolean;
    function getTop: Variant;
    function getTpl: Variant;
    function getTplWriteMode: String;
    function getUi: String;
    function getUseBodyElement: Boolean;
    function getWindowHeight: Float;
    function getWindowWidth: Float;
    function getXTypes: String;
    function getZIndex: Float;
    function hasListener: Boolean; overload;
    function hasListener(eventName: String): Boolean; overload;
    function hasParent: Boolean;
    function hide: JExt.IComponent;
    procedure hideAllMenus; overload;
    procedure hideAllMenus(animation: Variant); overload;
    procedure hideMenu; overload;
    procedure hideMenu(side: String); overload;
    procedure hideOtherMenus; overload;
    procedure hideOtherMenus(side: String); overload;
    procedure hideOtherMenus(side: String; animation: String); overload;
    function initConfig: Variant; overload;
    function initConfig(instanceConfig: Variant): Variant; overload;
    procedure initialize;
    procedure insert; overload;
    procedure insert(index: Float); overload;
    procedure insert(index: Float; item: Variant); overload;
    function isDisabled: Boolean;
    function isHidden: Boolean;
    function isXType: Boolean; overload;
    function isXType(xtype: String): Boolean; overload;
    function isXType(xtype: String; shallow: Boolean): Boolean; overload;
    procedure mask; overload;
    procedure mask(mask: Variant); overload;
    procedure mon; overload;
    procedure mon(&object: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure mon(&object: Variant; eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure mun; overload;
    procedure mun(&object: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure mun(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on; overload;
    procedure on(eventName: Variant); overload;
    procedure on(eventName: Variant; fn: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure on(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure onAfter; overload;
    procedure onAfter(eventName: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure onBefore; overload;
    procedure onBefore(eventName: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure onBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function query: array of Variant; overload;
    function query(selector: String): array of Variant; overload;
    function relayEvents: JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant): JExt.mixin.IObservable; overload;
    function relayEvents(&object: Variant; events: Variant): JExt.mixin.IObservable; overload;
    function remove: JExt.IComponent; overload;
    function remove(item: Variant): JExt.IComponent; overload;
    function remove(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    procedure removeAfterListener; overload;
    procedure removeAfterListener(eventName: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeAfterListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    function removeAll: JExt.IComponent; overload;
    function removeAll(destroy: Boolean): JExt.IComponent; overload;
    function removeAll(destroy: Boolean; everything: Boolean): JExt.IComponent; overload;
    function removeAt: JExt.IContainer; overload;
    function removeAt(index: Float): JExt.IContainer; overload;
    procedure removeBeforeListener; overload;
    procedure removeBeforeListener(eventName: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeBeforeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeCls; overload;
    procedure removeCls(cls: String); overload;
    procedure removeCls(cls: String; prefix: String); overload;
    procedure removeCls(cls: String; prefix: String; suffix: String); overload;
    function removeDocked: JExt.IComponent; overload;
    function removeDocked(item: Variant): JExt.IComponent; overload;
    function removeDocked(item: Variant; destroy: Boolean): JExt.IComponent; overload;
    function removeInnerAt: JExt.IContainer; overload;
    function removeInnerAt(index: Float): JExt.IContainer; overload;
    procedure removeListener; overload;
    procedure removeListener(eventName: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure removeListener(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure removeManagedListener; overload;
    procedure removeManagedListener(&object: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant); overload;
    procedure removeManagedListener(&object: Variant; eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure removeMenu; overload;
    procedure removeMenu(side: String); overload;
    procedure replaceCls; overload;
    procedure replaceCls(oldCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String); overload;
    procedure replaceCls(oldCls: String; newCls: String; prefix: String; suffix: String); overload;
    procedure resetFloating;
    procedure resumeEvents; overload;
    procedure resumeEvents(discardQueuedEvents: Boolean); overload;
    procedure setActiveItem; overload;
    procedure setActiveItem(activeItem: Variant); overload;
    procedure setAutoDestroy; overload;
    procedure setAutoDestroy(autoDestroy: Boolean); overload;
    procedure setAutoMaximize; overload;
    procedure setAutoMaximize(autoMaximize: Boolean); overload;
    procedure setBaseCls; overload;
    procedure setBaseCls(baseCls: String); overload;
    procedure setBorder; overload;
    procedure setBorder(border: Variant); overload;
    procedure setBottom; overload;
    procedure setBottom(bottom: Variant); overload;
    procedure setBubbleEvents; overload;
    procedure setBubbleEvents(bubbleEvents: Variant); overload;
    procedure setCentered; overload;
    procedure setCentered(centered: Boolean); overload;
    procedure setCls; overload;
    procedure setCls(cls: Variant); overload;
    procedure setContentEl; overload;
    procedure setContentEl(contentEl: Variant); overload;
    procedure setControl; overload;
    procedure setControl(control: Variant); overload;
    procedure setData; overload;
    procedure setData(data: Variant); overload;
    procedure setDefaultType; overload;
    procedure setDefaultType(defaultType: String); overload;
    procedure setDefaults; overload;
    procedure setDefaults(defaults: Variant); overload;
    procedure setDisabled; overload;
    procedure setDisabled(disabled: Boolean); overload;
    procedure setDisabledCls; overload;
    procedure setDisabledCls(disabledCls: String); overload;
    procedure setDocked; overload;
    procedure setDocked(docked: String); overload;
    procedure setDraggable; overload;
    procedure setDraggable(draggable: Variant); overload;
    procedure setEnterAnimation; overload;
    procedure setEnterAnimation(enterAnimation: Variant); overload;
    procedure setExitAnimation; overload;
    procedure setExitAnimation(exitAnimation: Variant); overload;
    procedure setFlex; overload;
    procedure setFlex(flex: Float); overload;
    procedure setFloating; overload;
    procedure setFloating(floating: Boolean); overload;
    procedure setFloatingCls; overload;
    procedure setFloatingCls(floatingCls: String); overload;
    procedure setHidden; overload;
    procedure setHidden(hidden: Boolean); overload;
    procedure setHiddenCls; overload;
    procedure setHiddenCls(hiddenCls: String); overload;
    procedure setHideAnimation; overload;
    procedure setHideAnimation(hideAnimation: Variant); overload;
    procedure setHideOnMaskTap; overload;
    procedure setHideOnMaskTap(hideOnMaskTap: Boolean); overload;
    procedure setHtml; overload;
    procedure setHtml(html: Variant); overload;
    procedure setItemId; overload;
    procedure setItemId(itemId: String); overload;
    procedure setItems; overload;
    procedure setItems(items: Variant); overload;
    procedure setLayout; overload;
    procedure setLayout(layout: Variant); overload;
    procedure setLeft; overload;
    procedure setLeft(left: Variant); overload;
    procedure setListeners; overload;
    procedure setListeners(listeners: Variant); overload;
    procedure setMargin; overload;
    procedure setMargin(margin: Variant); overload;
    procedure setMasked; overload;
    procedure setMasked(masked: Variant); overload;
    procedure setMaxHeight; overload;
    procedure setMaxHeight(maxHeight: Variant); overload;
    procedure setMaxWidth; overload;
    procedure setMaxWidth(maxWidth: Variant); overload;
    procedure setMenu; overload;
    procedure setMenu(menu: JExt.IMenu); overload;
    procedure setMenu(menu: JExt.IMenu; config: Variant); overload;
    procedure setMinHeight; overload;
    procedure setMinHeight(minHeight: Variant); overload;
    procedure setMinWidth; overload;
    procedure setMinWidth(minWidth: Variant); overload;
    procedure setModal; overload;
    procedure setModal(modal: Boolean); overload;
    procedure setPadding; overload;
    procedure setPadding(padding: Variant); overload;
    procedure setPlugins; overload;
    procedure setPlugins(plugins: Variant); overload;
    procedure setPreventPanning; overload;
    procedure setPreventPanning(preventPanning: Boolean); overload;
    procedure setPreventZooming; overload;
    procedure setPreventZooming(preventZooming: Boolean); overload;
    procedure setRecord; overload;
    procedure setRecord(record: JExt.data.IModel); overload;
    procedure setRenderTo; overload;
    procedure setRenderTo(renderTo: JExt.IElement); overload;
    procedure setRight; overload;
    procedure setRight(right: Variant); overload;
    function setScrollable: JExt.scroll.IView; overload;
    function setScrollable(scrollable: Variant): JExt.scroll.IView; overload;
    procedure setShowAnimation; overload;
    procedure setShowAnimation(showAnimation: Variant); overload;
    procedure setSize; overload;
    procedure setSize(width: Float); overload;
    procedure setSize(width: Float; height: Float); overload;
    procedure setStyle; overload;
    procedure setStyle(style: Variant); overload;
    procedure setStyleHtmlCls; overload;
    procedure setStyleHtmlCls(styleHtmlCls: String); overload;
    procedure setStyleHtmlContent; overload;
    procedure setStyleHtmlContent(styleHtmlContent: Boolean); overload;
    procedure setTop; overload;
    procedure setTop(top: Variant); overload;
    procedure setTpl; overload;
    procedure setTpl(tpl: Variant); overload;
    procedure setTplWriteMode; overload;
    procedure setTplWriteMode(tplWriteMode: String); overload;
    procedure setUi; overload;
    procedure setUi(ui: String); overload;
    procedure setUseBodyElement; overload;
    procedure setUseBodyElement(useBodyElement: Boolean); overload;
    procedure setZIndex; overload;
    procedure setZIndex(zIndex: Float); overload;
    function show: JExt.IComponent;
    procedure showBy; overload;
    procedure showBy(component: JExt.IComponent); overload;
    procedure showBy(component: JExt.IComponent; alignment: String); overload;
    procedure showMenu; overload;
    procedure showMenu(side: String); overload;
    function statics: JExt.IClass;
    procedure suspendEvents;
    procedure toggleMenu; overload;
    procedure toggleMenu(side: String); overload;
    procedure un; overload;
    procedure un(eventName: Variant); overload;
    procedure un(eventName: Variant; fn: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure un(eventName: Variant; fn: Variant; scope: Variant; options: Variant; order: String); overload;
    procedure unAfter; overload;
    procedure unAfter(eventName: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unAfter(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unBefore; overload;
    procedure unBefore(eventName: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant); overload;
    procedure unBefore(eventName: Variant; fn: Variant; scope: Variant; options: Variant); overload;
    procedure unmask;
    function up: JExt.IContainer; overload;
    function up(selector: String): JExt.IContainer; overload;
    procedure update;
    procedure updateStyleHtmlCls; overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant); overload;
    procedure updateStyleHtmlCls(newHtmlCls: Variant; oldHtmlCls: Variant); overload;
  end;

  JIViewport = class external(JExt.viewport.IDefault)
  end;

//Ext.viewport

type
  JIViewport = class external(JExt.IBase)
  end;

//Ext.viewport

type
  JIWindowsPhone = class external(JExt.viewport.IDefault)
    function getTranslatable: Variant;
    procedure initialize;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Variant); overload;
  end;

//Ext.viewport

type
  JIWP = class external(JExt.viewport.IDefault)
    function getTranslatable: Variant;
    procedure initialize;
    procedure setTranslatable; overload;
    procedure setTranslatable(translatable: Variant); overload;
  end;

//Ext

type
  JXTemplate = class external 'XTemplate'
    procedure addMembers; overload;
    procedure addMembers(members: Variant); overload;
    function addStatics: JExt.IBase; overload;
    function addStatics(members: Variant): JExt.IBase; overload;
    procedure callParent; overload;
    procedure callParent(args: Variant); overload;
    function create: Variant;
    procedure createAlias; overload;
    procedure createAlias(alias: Variant); overload;
    procedure createAlias(alias: Variant; origin: Variant); overload;
    function from: JExt.ITemplate; overload;
    function from(el: Variant): JExt.ITemplate; overload;
    function from(el: Variant; config: Variant): JExt.ITemplate; overload;
    function getName: String;
    function getTpl: JExt.IXTemplate; overload;
    function getTpl(instance: Variant): JExt.IXTemplate; overload;
    function getTpl(instance: Variant; name: String): JExt.IXTemplate; overload;
    function override: JExt.IBase; overload;
    function override(members: Variant): JExt.IBase; overload;
  end;

  JIXTemplate = class external(JExt.ITemplate)
    function applyOut: array of Variant; overload;
    function applyOut(values: Variant): array of Variant; overload;
    function applyOut(values: Variant; out: array of Variant): array of Variant; overload;
    function applyOut(values: Variant; out: array of Variant; parent: Variant): array of Variant; overload;
  end;

//Ext

type
  JIXTemplateCompiler = class external(JExt.IXTemplateParser)
    procedure doCase; overload;
    procedure doCase(action: Variant); overload;
    procedure doDefault;
    procedure doElse;
    procedure doElseIf; overload;
    procedure doElseIf(action: Variant); overload;
    procedure doElseIf(action: Variant; actions: Variant); overload;
    procedure doEnd; overload;
    procedure doEnd(&type: Variant); overload;
    procedure doEnd(&type: Variant; actions: Variant); overload;
    procedure doEval; overload;
    procedure doEval(text: Variant); overload;
    procedure doExec; overload;
    procedure doExec(action: Variant); overload;
    procedure doExec(action: Variant; actions: Variant); overload;
    procedure doExpr; overload;
    procedure doExpr(expr: Variant); overload;
    procedure doFor; overload;
    procedure doFor(action: Variant); overload;
    procedure doFor(action: Variant; actions: Variant); overload;
    procedure doIf; overload;
    procedure doIf(action: Variant); overload;
    procedure doIf(action: Variant; actions: Variant); overload;
    procedure doSwitch; overload;
    procedure doSwitch(action: Variant); overload;
    procedure doTag; overload;
    procedure doTag(tag: Variant); overload;
    procedure doText; overload;
    procedure doText(text: Variant); overload;
  end;

//Ext

type
  JIXTemplateParser = class external(JExt.IBase)
    level: Float; // nullable
    procedure doCase; overload;
    procedure doCase(action: String); overload;
    procedure doCase(action: String; actions: Variant); overload;
    procedure doDefault;
    procedure doElse;
    procedure doElseIf; overload;
    procedure doElseIf(action: String); overload;
    procedure doElseIf(action: String; actions: Variant); overload;
    procedure doEnd; overload;
    procedure doEnd(&type: String); overload;
    procedure doEnd(&type: String; actions: Variant); overload;
    procedure doEval; overload;
    procedure doEval(text: String); overload;
    procedure doExec; overload;
    procedure doExec(action: String); overload;
    procedure doExec(action: String; actions: Variant); overload;
    procedure doExpr; overload;
    procedure doExpr(expr: String); overload;
    procedure doFor; overload;
    procedure doFor(action: String); overload;
    procedure doFor(action: String; actions: Variant); overload;
    procedure doIf; overload;
    procedure doIf(action: String); overload;
    procedure doIf(action: String; actions: Variant); overload;
    procedure doSwitch; overload;
    procedure doSwitch(action: String); overload;
    procedure doSwitch(action: String; actions: Variant); overload;
    procedure doTag; overload;
    procedure doTag(tag: String); overload;
    procedure doText; overload;
    procedure doText(text: String); overload;
    procedure doTpl;
  end;

