unit Babylon;

interface

type
  JWindow = class external
    function mozIndexedDB(func: Variant): Variant;
    function webkitIndexedDB(func: Variant): Variant;
    function IDBTransaction(func: Variant): Variant;
    function webkitIDBTransaction(func: Variant): Variant;
    function msIDBTransaction(func: Variant): Variant;
    function IDBKeyRange(func: Variant): Variant;
    function webkitIDBKeyRange(func: Variant): Variant;
    function msIDBKeyRange(func: Variant): Variant;
    webkitURL: JHTMLURL;
    function webkitRequestAnimationFrame(func: Variant): Variant;
    function mozRequestAnimationFrame(func: Variant): Variant;
    function oRequestAnimationFrame(func: Variant): Variant;
    WebGLRenderingContext: JWebGLRenderingContext;
    MSGesture: JMSGesture;
    CANNON: Variant;
    SIMD: Variant;
    AudioContext: JAudioContext;
    webkitAudioContext: JAudioContext;
  end;

  JHTMLURL = class external
    function createObjectURL(param1: Variant): Variant; overload;
    function createObjectURL(param1: Variant; param2: Variant): Variant; overload;
  end;

  JDocument = class external
    procedure exitFullscreen;
    procedure webkitCancelFullScreen;
    procedure mozCancelFullScreen;
    procedure msCancelFullScreen;
    mozFullScreen: Boolean;
    msIsFullScreen: Boolean;
    fullscreen: Boolean;
    mozPointerLockElement: JHTMLElement;
    msPointerLockElement: JHTMLElement;
    webkitPointerLockElement: JHTMLElement;
  end;

  JHTMLCanvasElement = class external
    procedure requestPointerLock;
    procedure msRequestPointerLock;
    procedure mozRequestPointerLock;
    procedure webkitRequestPointerLock;
  end;

  JCanvasRenderingContext2D = class external
    imageSmoothingEnabled: Boolean;
    mozImageSmoothingEnabled: Boolean;
    oImageSmoothingEnabled: Boolean;
    webkitImageSmoothingEnabled: Boolean;
  end;

  JWebGLTexture = class external
    isReady: Boolean;
    isCube: Boolean;
    url: String;
    noMipmap: Boolean;
    samplingMode: Float;
    references: Float;
    generateMipMaps: Boolean;
    _size: Float;
    _baseWidth: Float;
    _baseHeight: Float;
    _width: Float;
    _height: Float;
    _workingCanvas: JHTMLCanvasElement;
    _workingContext: JCanvasRenderingContext2D;
    _framebuffer: JWebGLFramebuffer;
    _depthBuffer: JWebGLRenderbuffer;
    _cachedCoordinatesMode: Float;
    _cachedWrapU: Float;
    _cachedWrapV: Float;
    _isDisabled: Boolean;
  end;

  JWebGLBuffer = class external
    references: Float;
    capacity: Float;
    is32Bits: Boolean;
  end;

  JMouseEvent = class external
    mozMovementX: Float;
    mozMovementY: Float;
    webkitMovementX: Float;
    webkitMovementY: Float;
    msMovementX: Float;
    msMovementY: Float;
  end;

  JMSStyleCSSProperties = class external
    webkitTransform: String;
    webkitTransition: String;
  end;

  JNavigator = class external
    getVRDevices: : Variant;
    mozGetVRDevices: (any: Variant): Variant;
    isCocoonJS: Boolean;
  end;

  JScreen = class external
    orientation: String;
    mozOrientation: String;
  end;

  JNavigator = class external
    function getGamepads: Variant; overload;
    function getGamepads(func: Variant): Variant; overload;
    function webkitGetGamepads: Variant; overload;
    function webkitGetGamepads(func: Variant): Variant; overload;
    function msGetGamepads: Variant; overload;
    function msGetGamepads(func: Variant): Variant; overload;
    function webkitGamepads: Variant; overload;
    function webkitGamepads(func: Variant): Variant; overload;
  end;

//BABYLON

type
  J_DepthCullingState = class external '_DepthCullingState'
    _isDepthTestDirty: Variant;
    _isDepthMaskDirty: Variant;
    _isDepthFuncDirty: Variant;
    _isCullFaceDirty: Variant;
    _isCullDirty: Variant;
    _isZOffsetDirty: Variant;
    _depthTest: Variant;
    _depthMask: Variant;
    _depthFunc: Variant;
    _cull: Variant;
    _cullFace: Variant;
    _zOffset: Variant;
    isDirty: Boolean;
    zOffset: Float;
    cullFace: Float;
    cull: Boolean;
    depthFunc: Float;
    depthMask: Boolean;
    depthTest: Boolean;
    procedure reset;
    procedure apply(gl: JWebGLRenderingContext);
  end;

  J_AlphaState = class external '_AlphaState'
    _isAlphaBlendDirty: Variant;
    _isBlendFunctionParametersDirty: Variant;
    _alphaBlend: Variant;
    _blendFunctionParameters: Variant;
    isDirty: Boolean;
    alphaBlend: Boolean;
    procedure setAlphaBlendFunctionParameters(value0: Float; value1: Float; value2: Float; value3: Float);
    procedure reset;
    procedure apply(gl: JWebGLRenderingContext);
  end;

  JEngineCapabilities = class external 'EngineCapabilities'
    maxTexturesImageUnits: Float;
    maxTextureSize: Float;
    maxCubemapTextureSize: Float;
    maxRenderTextureSize: Float;
    standardDerivatives: Boolean;
    s3tc: Variant;
    textureFloat: Boolean;
    textureAnisotropicFilterExtension: Variant;
    maxAnisotropy: Float;
    instancedArrays: Variant;
    uintIndices: Boolean;
    highPrecisionShaderSupported: Boolean;
  end;

  JEngine = class external 'Engine'
    _ALPHA_DISABLE: Variant;
    _ALPHA_ADD: Variant;
    _ALPHA_COMBINE: Variant;
    _ALPHA_SUBTRACT: Variant;
    _ALPHA_MULTIPLY: Variant;
    _ALPHA_MAXIMIZED: Variant;
    _ALPHA_ONEONE: Variant;
    _DELAYLOADSTATE_NONE: Variant;
    _DELAYLOADSTATE_LOADED: Variant;
    _DELAYLOADSTATE_LOADING: Variant;
    _DELAYLOADSTATE_NOTLOADED: Variant;
    _TEXTUREFORMAT_ALPHA: Variant;
    _TEXTUREFORMAT_LUMINANCE: Variant;
    _TEXTUREFORMAT_LUMINANCE_ALPHA: Variant;
    _TEXTUREFORMAT_RGB: Variant;
    _TEXTUREFORMAT_RGBA: Variant;
    _TEXTURETYPE_UNSIGNED_INT: Variant;
    _TEXTURETYPE_FLOAT: Variant;
    ALPHA_DISABLE: Float;
    ALPHA_ONEONE: Float;
    ALPHA_ADD: Float;
    ALPHA_COMBINE: Float;
    ALPHA_SUBTRACT: Float;
    ALPHA_MULTIPLY: Float;
    ALPHA_MAXIMIZED: Float;
    DELAYLOADSTATE_NONE: Float;
    DELAYLOADSTATE_LOADED: Float;
    DELAYLOADSTATE_LOADING: Float;
    DELAYLOADSTATE_NOTLOADED: Float;
    TEXTUREFORMAT_ALPHA: Float;
    TEXTUREFORMAT_LUMINANCE: Float;
    TEXTUREFORMAT_LUMINANCE_ALPHA: Float;
    TEXTUREFORMAT_RGB: Float;
    TEXTUREFORMAT_RGBA: Float;
    TEXTURETYPE_UNSIGNED_INT: Float;
    TEXTURETYPE_FLOAT: Float;
    Version: String;
    Epsilon: Float;
    CollisionsEpsilon: Float;
    CodeRepository: String;
    ShadersRepository: String;
    isFullscreen: Boolean;
    isPointerLock: Boolean;
    cullBackFaces: Boolean;
    renderEvenInBackground: Boolean;
    enableOfflineSupport: Boolean;
    scenes: array of JScene;
    _gl: JWebGLRenderingContext;
    _renderingCanvas: Variant;
    _windowIsBackground: Variant;
    audioEngine: JAudioEngine;
    _onBlur: Variant;
    _onFocus: Variant;
    _onFullscreenChange: Variant;
    _onPointerLockChange: Variant;
    _hardwareScalingLevel: Variant;
    _caps: Variant;
    _pointerLockRequested: Variant;
    _alphaTest: Variant;
    _resizeLoadingUI: Variant;
    _loadingDiv: Variant;
    _loadingTextDiv: Variant;
    _loadingDivBackgroundColor: Variant;
    _drawCalls: Variant;
    _glVersion: Variant;
    _glRenderer: Variant;
    _glVendor: Variant;
    _videoTextureSupported: Variant;
    _renderingQueueLaunched: Variant;
    _activeRenderLoops: Variant;
    fpsRange: Variant;
    previousFramesDuration: Variant;
    fps: Variant;
    deltaTime: Variant;
    _depthCullingState: Variant;
    _alphaState: Variant;
    _alphaMode: Variant;
    _loadedTexturesCache: Variant;
    _activeTexturesCache: array of JBaseTexture;
    _currentEffect: Variant;
    _compiledEffects: Variant;
    _vertexAttribArrays: Variant;
    _cachedViewport: Variant;
    _cachedVertexBuffers: Variant;
    _cachedIndexBuffer: Variant;
    _cachedEffectForVertexBuffers: Variant;
    _currentRenderTarget: Variant;
    _uintIndicesCurrentlySet: Variant;
    _workingCanvas: Variant;
    _workingContext: Variant;
    constructor Create(canvas: JHTMLCanvasElement; antialias: Boolean; options: Variant);
    procedure _prepareWorkingCanvas;
    function getGlInfo:       vendor: String;
      renderer: String;
      version: String;
    end;;
    function getAspectRatio(camera: JCamera): Float;
    function getRenderWidth: Float;
    function getRenderHeight: Float;
    function getRenderingCanvas: JHTMLCanvasElement;
    function getRenderingCanvasClientRect: JClientRect;
    procedure setHardwareScalingLevel(level: Float);
    function getHardwareScalingLevel: Float;
    function getLoadedTexturesCache: array of JWebGLTexture;
    function getCaps: JEngineCapabilities;
    drawCalls: Float;
    procedure resetDrawCalls;
    procedure setDepthFunctionToGreater;
    procedure setDepthFunctionToGreaterOrEqual;
    procedure setDepthFunctionToLess;
    procedure setDepthFunctionToLessOrEqual;
    procedure stopRenderLoop; overload;
    procedure stopRenderLoop(renderFunction: ); overload;
    procedure _renderLoop;
    procedure runRenderLoop(renderFunction: );
    procedure switchFullscreen(requestPointerLock: Boolean);
    procedure clear(color: Variant; backBuffer: Boolean; depthStencil: Boolean);
    procedure setViewport(viewport: JViewport); overload;
    procedure setViewport(viewport: JViewport; requiredWidth: Float); overload;
    procedure setViewport(viewport: JViewport; requiredWidth: Float; requiredHeight: Float); overload;
    procedure setDirectViewport(x: Float; y: Float; width: Float; height: Float);
    procedure beginFrame;
    procedure endFrame;
    procedure resize;
    procedure setSize(width: Float; height: Float);
    procedure bindFramebuffer(texture: JWebGLTexture);
    procedure unBindFramebuffer(texture: JWebGLTexture);
    procedure flushFramebuffer;
    procedure restoreDefaultFramebuffer;
    procedure _resetVertexBufferBinding;
    function createVertexBuffer(vertices: array of Float): JWebGLBuffer;
    function createDynamicVertexBuffer(capacity: Float): JWebGLBuffer;
    procedure updateDynamicVertexBuffer(vertexBuffer: JWebGLBuffer; vertices: Variant); overload;
    procedure updateDynamicVertexBuffer(vertexBuffer: JWebGLBuffer; vertices: Variant; offset: Float); overload;
    procedure _resetIndexBufferBinding;
    function createIndexBuffer(indices: array of Float): JWebGLBuffer;
    procedure bindBuffers(vertexBuffer: JWebGLBuffer; indexBuffer: JWebGLBuffer; vertexDeclaration: array of Float; vertexStrideSize: Float; effect: JEffect);
    procedure bindMultiBuffers(vertexBuffers: array of JVertexBuffer; indexBuffer: JWebGLBuffer; effect: JEffect);
    function _releaseBuffer(buffer: JWebGLBuffer): Boolean;
    function createInstancesBuffer(capacity: Float): JWebGLBuffer;
    procedure deleteInstancesBuffer(buffer: JWebGLBuffer);
    procedure updateAndBindInstancesBuffer(instancesBuffer: JWebGLBuffer; data: JFloat32Array; offsetLocations: array of Float);
    procedure unBindInstancesBuffer(instancesBuffer: JWebGLBuffer; offsetLocations: array of Float);
    procedure applyStates;
    procedure draw(useTriangles: Boolean; indexStart: Float; indexCount: Float); overload;
    procedure draw(useTriangles: Boolean; indexStart: Float; indexCount: Float; instancesCount: Float); overload;
    procedure drawPointClouds(verticesStart: Float; verticesCount: Float); overload;
    procedure drawPointClouds(verticesStart: Float; verticesCount: Float; instancesCount: Float); overload;
    procedure _releaseEffect(effect: JEffect);
    function createEffect(baseName: Variant; attributesNames: array of String; uniformsNames: array of String; samplers: array of String; defines: String): JEffect; overload;
    function createEffect(baseName: Variant; attributesNames: array of String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks): JEffect; overload;
    function createEffect(baseName: Variant; attributesNames: array of String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks; onCompiled: (effect: JEffect)): JEffect; overload;
    function createEffect(baseName: Variant; attributesNames: array of String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks; onCompiled: (effect: JEffect); onError: (effect: JEffect; errors: String)): JEffect; overload;
    function createEffectForParticles(fragmentName: String): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String; samplers: array of String): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String; samplers: array of String; defines: String): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks; onCompiled: (effect: JEffect)): JEffect; overload;
    function createEffectForParticles(fragmentName: String; uniformsNames: array of String; samplers: array of String; defines: String; fallbacks: JEffectFallbacks; onCompiled: (effect: JEffect); onError: (effect: JEffect; errors: String)): JEffect; overload;
    function createShaderProgram(vertexCode: String; fragmentCode: String; defines: String): JWebGLProgram;
    function getUniforms(shaderProgram: JWebGLProgram; uniformsNames: array of String): array of JWebGLUniformLocation;
    function getAttributes(shaderProgram: JWebGLProgram; attributesNames: array of String): array of Float;
    procedure enableEffect(effect: JEffect);
    procedure setArray(uniform: JWebGLUniformLocation; array: array of Float);
    procedure setArray2(uniform: JWebGLUniformLocation; array: array of Float);
    procedure setArray3(uniform: JWebGLUniformLocation; array: array of Float);
    procedure setArray4(uniform: JWebGLUniformLocation; array: array of Float);
    procedure setMatrices(uniform: JWebGLUniformLocation; matrices: JFloat32Array);
    procedure setMatrix(uniform: JWebGLUniformLocation; matrix: JMatrix);
    procedure setMatrix3x3(uniform: JWebGLUniformLocation; matrix: JFloat32Array);
    procedure setMatrix2x2(uniform: JWebGLUniformLocation; matrix: JFloat32Array);
    procedure setFloat(uniform: JWebGLUniformLocation; value: Float);
    procedure setFloat2(uniform: JWebGLUniformLocation; x: Float; y: Float);
    procedure setFloat3(uniform: JWebGLUniformLocation; x: Float; y: Float; z: Float);
    procedure setBool(uniform: JWebGLUniformLocation; bool: Float);
    procedure setFloat4(uniform: JWebGLUniformLocation; x: Float; y: Float; z: Float; w: Float);
    procedure setColor3(uniform: JWebGLUniformLocation; color3: JColor3);
    procedure setColor4(uniform: JWebGLUniformLocation; color3: JColor3; alpha: Float);
    procedure setState(culling: Boolean); overload;
    procedure setState(culling: Boolean; zOffset: Float); overload;
    procedure setState(culling: Boolean; zOffset: Float; force: Boolean); overload;
    procedure setDepthBuffer(enable: Boolean);
    function getDepthWrite: Boolean;
    procedure setDepthWrite(enable: Boolean);
    procedure setColorWrite(enable: Boolean);
    procedure setAlphaMode(mode: Float);
    function getAlphaMode: Float;
    procedure setAlphaTesting(enable: Boolean);
    function getAlphaTesting: Boolean;
    procedure wipeCaches;
    procedure setSamplingMode(texture: JWebGLTexture; samplingMode: Float);
    function createTexture(url: String; noMipmap: Boolean; invertY: Boolean; scene: JScene): JWebGLTexture; overload;
    function createTexture(url: String; noMipmap: Boolean; invertY: Boolean; scene: JScene; samplingMode: Float): JWebGLTexture; overload;
    function createTexture(url: String; noMipmap: Boolean; invertY: Boolean; scene: JScene; samplingMode: Float; onLoad: ): JWebGLTexture; overload;
    function createTexture(url: String; noMipmap: Boolean; invertY: Boolean; scene: JScene; samplingMode: Float; onLoad: ; onError: ): JWebGLTexture; overload;
    function createTexture(url: String; noMipmap: Boolean; invertY: Boolean; scene: JScene; samplingMode: Float; onLoad: ; onError: ; buffer: Variant): JWebGLTexture; overload;
    procedure updateRawTexture(texture: JWebGLTexture; data: JArrayBufferView; format: Float; invertY: Boolean); overload;
    procedure updateRawTexture(texture: JWebGLTexture; data: JArrayBufferView; format: Float; invertY: Boolean; compression: String); overload;
    function createRawTexture(data: JArrayBufferView; width: Float; height: Float; format: Float; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JWebGLTexture; overload;
    function createRawTexture(data: JArrayBufferView; width: Float; height: Float; format: Float; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float; compression: String): JWebGLTexture; overload;
    function createDynamicTexture(width: Float; height: Float; generateMipMaps: Boolean; samplingMode: Float): JWebGLTexture; overload;
    function createDynamicTexture(width: Float; height: Float; generateMipMaps: Boolean; samplingMode: Float; forceExponantOfTwo: Boolean): JWebGLTexture; overload;
    procedure updateTextureSamplingMode(samplingMode: Float; texture: JWebGLTexture);
    procedure updateDynamicTexture(texture: JWebGLTexture; canvas: JHTMLCanvasElement; invertY: Boolean);
    procedure updateVideoTexture(texture: JWebGLTexture; video: JHTMLVideoElement; invertY: Boolean);
    function createRenderTargetTexture(size: Variant; options: Variant): JWebGLTexture;
    function createCubeTexture(rootUrl: String; scene: JScene; extensions: array of String): JWebGLTexture; overload;
    function createCubeTexture(rootUrl: String; scene: JScene; extensions: array of String; noMipmap: Boolean): JWebGLTexture; overload;
    procedure _releaseTexture(texture: JWebGLTexture);
    procedure bindSamplers(effect: JEffect);
    procedure _bindTexture(channel: Float; texture: JWebGLTexture);
    procedure setTextureFromPostProcess(channel: Float; postProcess: JPostProcess);
    procedure setTexture(channel: Float; texture: JBaseTexture);
    procedure _setAnisotropicLevel(key: Float; texture: JBaseTexture);
    function readPixels(x: Float; y: Float; width: Float; height: Float): JUint8Array;
    procedure dispose;
    procedure displayLoadingUI;
    loadingUIText: String;
    loadingUIBackgroundColor: String;
    procedure hideLoadingUI;
    function getFps: Float;
    function getDeltaTime: Float;
    procedure _measureFps;
    function isSupported: Boolean;
  end;

//BABYLON

type
  JNode = class external 'Node'
    parent: JNode;
    name: String;
    id: String;
    uniqueId: Float;
    state: String;
    animations: array of JAnimation;
    onReady: (node: JNode);
    _childrenFlag: Variant;
    _isEnabled: Variant;
    _isReady: Variant;
    _currentRenderId: Float;
    _parentRenderId: Variant;
    _waitingParentId: String;
    _scene: Variant;
    _cache: Variant;
    constructor Create(name: String; scene: JScene);
    function getScene: JScene;
    function getEngine: JEngine;
    function getWorldMatrix: JMatrix;
    procedure _initCache;
    procedure updateCache; overload;
    procedure updateCache(force: Boolean); overload;
    procedure _updateCache; overload;
    procedure _updateCache(ignoreParentClass: Boolean); overload;
    function _isSynchronized: Boolean;
    procedure _markSyncedWithParent;
    function isSynchronizedWithParent: Boolean;
    function isSynchronized: Boolean; overload;
    function isSynchronized(updateCache: Boolean): Boolean; overload;
    function hasNewParent: Boolean; overload;
    function hasNewParent(update: Boolean): Boolean; overload;
    function isReady: Boolean;
    function isEnabled: Boolean;
    procedure setEnabled(value: Boolean);
    function isDescendantOf(ancestor: JNode): Boolean;
    procedure _getDescendants(list: array of JNode; results: array of JNode);
    function getDescendants: array of JNode;
    procedure _setReady(state: Boolean);
  end;

//BABYLON

type
  JScene = class external 'Scene'
    _FOGMODE_NONE: Variant;
    _FOGMODE_EXP: Variant;
    _FOGMODE_EXP2: Variant;
    _FOGMODE_LINEAR: Variant;
    MinDeltaTime: Float;
    MaxDeltaTime: Float;
    FOGMODE_NONE: Float;
    FOGMODE_EXP: Float;
    FOGMODE_EXP2: Float;
    FOGMODE_LINEAR: Float;
    autoClear: Boolean;
    clearColor: Variant;
    ambientColor: JColor3;
    beforeRender: ;
    afterRender: ;
    onDispose: ;
    beforeCameraRender: (camera: JCamera);
    afterCameraRender: (camera: JCamera);
    forceWireframe: Boolean;
    forcePointsCloud: Boolean;
    forceShowBoundingBoxes: Boolean;
    clipPlane: JPlane;
    animationsEnabled: Boolean;
    _onPointerMove: Variant;
    _onPointerDown: Variant;
    _onPointerUp: Variant;
    onPointerDown: (evt: JPointerEvent; pickInfo: JPickingInfo);
    onPointerUp: (evt: JPointerEvent; pickInfo: JPickingInfo);
    cameraToUseForPointers: JCamera;
    _pointerX: Variant;
    _pointerY: Variant;
    _meshUnderPointer: Variant;
    _onKeyDown: Variant;
    _onKeyUp: Variant;
    fogEnabled: Boolean;
    fogMode: Float;
    fogColor: JColor3;
    fogDensity: Float;
    fogStart: Float;
    fogEnd: Float;
    shadowsEnabled: Boolean;
    lightsEnabled: Boolean;
    lights: array of JLight;
    onNewLightAdded: (newLight: JLight; positionInArray: Float; scene: JScene);
    onLightRemoved: (removedLight: JLight);
    cameras: array of JCamera;
    onNewCameraAdded: (newCamera: JCamera; positionInArray: Float; scene: JScene);
    onCameraRemoved: (removedCamera: JCamera);
    activeCameras: array of JCamera;
    activeCamera: JCamera;
    meshes: array of JAbstractMesh;
    onNewMeshAdded: (newMesh: JAbstractMesh; positionInArray: Float; scene: JScene);
    onMeshRemoved: (removedMesh: JAbstractMesh);
    _geometries: Variant;
    onGeometryAdded: (newGeometry: JGeometry);
    onGeometryRemoved: (removedGeometry: JGeometry);
    materials: array of JMaterial;
    multiMaterials: array of JMultiMaterial;
    defaultMaterial: JStandardMaterial;
    texturesEnabled: Boolean;
    textures: array of JBaseTexture;
    particlesEnabled: Boolean;
    particleSystems: array of JParticleSystem;
    spritesEnabled: Boolean;
    spriteManagers: array of JSpriteManager;
    layers: array of JLayer;
    skeletonsEnabled: Boolean;
    skeletons: array of JSkeleton;
    lensFlaresEnabled: Boolean;
    lensFlareSystems: array of JLensFlareSystem;
    collisionsEnabled: Boolean;
    _workerCollisions: Variant;
    collisionCoordinator: JICollisionCoordinator;
    gravity: JVector3;
    postProcessesEnabled: Boolean;
    postProcessManager: JPostProcessManager;
    postProcessRenderPipelineManager: JPostProcessRenderPipelineManager;
    renderTargetsEnabled: Boolean;
    dumpNextRenderTargets: Boolean;
    customRenderTargets: array of JRenderTargetTexture;
    useDelayedTextureLoading: Boolean;
    importedMeshesFiles: array of JString;
    database: Variant;
    actionManager: JActionManager;
    _actionManagers: array of JActionManager;
    _meshesForIntersections: Variant;
    proceduralTexturesEnabled: Boolean;
    _proceduralTextures: array of JProceduralTexture;
    mainSoundTrack: JSoundTrack;
    soundTracks: array of JSoundTrack;
    _audioEnabled: Variant;
    _headphone: Variant;
    simplificationQueue: JSimplificationQueue;
    _engine: Variant;
    _totalVertices: Variant;
    _activeIndices: Float;
    _activeParticles: Float;
    _lastFrameDuration: Variant;
    _evaluateActiveMeshesDuration: Variant;
    _renderTargetsDuration: Variant;
    _particlesDuration: Float;
    _renderDuration: Variant;
    _spritesDuration: Float;
    _animationRatio: Variant;
    _animationStartDate: Variant;
    _cachedMaterial: JMaterial;
    _renderId: Variant;
    _executeWhenReadyTimeoutId: Variant;
    _toBeDisposed: JSmartArray{<JIDisposable>};
    _onReadyCallbacks: Variant;
    _pendingData: Variant;
    _onBeforeRenderCallbacks: Variant;
    _onAfterRenderCallbacks: Variant;
    _activeMeshes: Variant;
    _processedMaterials: Variant;
    _renderTargets: Variant;
    _activeParticleSystems: JSmartArray{<JParticleSystem>};
    _activeSkeletons: Variant;
    _softwareSkinnedMeshes: Variant;
    _activeBones: Float;
    _renderingManager: Variant;
    _physicsEngine: Variant;
    _activeAnimatables: array of JAnimatable;
    _transformMatrix: Variant;
    _pickWithRayInverseMatrix: Variant;
    _edgesRenderers: Variant;
    _boundingBoxRenderer: Variant;
    _outlineRenderer: Variant;
    _viewMatrix: Variant;
    _projectionMatrix: Variant;
    _frustumPlanes: Variant;
    _selectionOctree: Variant;
    _pointerOverMesh: Variant;
    _debugLayer: Variant;
    _depthRenderer: Variant;
    _uniqueIdCounter: Variant;
    constructor Create(engine: JEngine);
    debugLayer: JDebugLayer;
    workerCollisions: Boolean;
    SelectionOctree: JOctree{<JAbstractMesh>};
    meshUnderPointer: JAbstractMesh;
    pointerX: Float;
    pointerY: Float;
    function getCachedMaterial: JMaterial;
    function getBoundingBoxRenderer: JBoundingBoxRenderer;
    function getOutlineRenderer: JOutlineRenderer;
    function getEngine: JEngine;
    function getTotalVertices: Float;
    function getActiveIndices: Float;
    function getActiveParticles: Float;
    function getActiveBones: Float;
    function getLastFrameDuration: Float;
    function getEvaluateActiveMeshesDuration: Float;
    function getActiveMeshes: JSmartArray{<JMesh>};
    function getRenderTargetsDuration: Float;
    function getRenderDuration: Float;
    function getParticlesDuration: Float;
    function getSpritesDuration: Float;
    function getAnimationRatio: Float;
    function getRenderId: Float;
    procedure incrementRenderId;
    procedure _updatePointerPosition(evt: Variant);
    procedure attachControl;
    procedure detachControl;
    function isReady: Boolean;
    procedure resetCachedMaterial;
    procedure registerBeforeRender(func: );
    procedure unregisterBeforeRender(func: );
    procedure registerAfterRender(func: );
    procedure unregisterAfterRender(func: );
    procedure _addPendingData(data: Variant);
    procedure _removePendingData(data: Variant);
    function getWaitingItemsCount: Float;
    procedure executeWhenReady(func: );
    procedure _checkIsReady;
    function beginAnimation(target: Variant; from: Float; to: Float): JAnimatable; overload;
    function beginAnimation(target: Variant; from: Float; to: Float; loop: Boolean): JAnimatable; overload;
    function beginAnimation(target: Variant; from: Float; to: Float; loop: Boolean; speedRatio: Float): JAnimatable; overload;
    function beginAnimation(target: Variant; from: Float; to: Float; loop: Boolean; speedRatio: Float; onAnimationEnd: ): JAnimatable; overload;
    function beginAnimation(target: Variant; from: Float; to: Float; loop: Boolean; speedRatio: Float; onAnimationEnd: ; animatable: JAnimatable): JAnimatable; overload;
    function beginDirectAnimation(target: Variant; animations: array of JAnimation; from: Float; to: Float): JAnimatable; overload;
    function beginDirectAnimation(target: Variant; animations: array of JAnimation; from: Float; to: Float; loop: Boolean): JAnimatable; overload;
    function beginDirectAnimation(target: Variant; animations: array of JAnimation; from: Float; to: Float; loop: Boolean; speedRatio: Float): JAnimatable; overload;
    function beginDirectAnimation(target: Variant; animations: array of JAnimation; from: Float; to: Float; loop: Boolean; speedRatio: Float; onAnimationEnd: ): JAnimatable; overload;
    function getAnimatableByTarget(target: Variant): JAnimatable;
    procedure stopAnimation(target: Variant);
    procedure _animate;
    function getViewMatrix: JMatrix;
    function getProjectionMatrix: JMatrix;
    function getTransformMatrix: JMatrix;
    procedure setTransformMatrix(view: JMatrix; projection: JMatrix);
    procedure addMesh(newMesh: JAbstractMesh);
    function removeMesh(toRemove: JAbstractMesh): Float;
    function removeLight(toRemove: JLight): Float;
    function removeCamera(toRemove: JCamera): Float;
    procedure addLight(newLight: JLight);
    procedure addCamera(newCamera: JCamera);
    function setActiveCameraByID(id: String): JCamera;
    function setActiveCameraByName(name: String): JCamera;
    function getMaterialByID(id: String): JMaterial;
    function getMaterialByName(name: String): JMaterial;
    function getLensFlareSystemByName(name: String): JLensFlareSystem;
    function getCameraByID(id: String): JCamera;
    function getCameraByUniqueID(uniqueId: Float): JCamera;
    function getCameraByName(name: String): JCamera;
    function getLightByName(name: String): JLight;
    function getLightByID(id: String): JLight;
    function getLightByUniqueID(uniqueId: Float): JLight;
    function getGeometryByID(id: String): JGeometry;
    function pushGeometry(geometry: JGeometry): Boolean; overload;
    function pushGeometry(geometry: JGeometry; force: Boolean): Boolean; overload;
    function removeGeometry(geometry: JGeometry): Boolean;
    function getGeometries: array of JGeometry;
    function getMeshByID(id: String): JAbstractMesh;
    function getMeshByUniqueID(uniqueId: Float): JAbstractMesh;
    function getLastMeshByID(id: String): JAbstractMesh;
    function getLastEntryByID(id: String): JNode;
    function getNodeByID(id: String): JNode;
    function getNodeByName(name: String): JNode;
    function getMeshByName(name: String): JAbstractMesh;
    function getSoundByName(name: String): JSound;
    function getLastSkeletonByID(id: String): JSkeleton;
    function getSkeletonById(id: String): JSkeleton;
    function getSkeletonByName(name: String): JSkeleton;
    function isActiveMesh(mesh: JMesh): Boolean;
    procedure _evaluateSubMesh(subMesh: Variant; mesh: Variant);
    procedure _evaluateActiveMeshes;
    procedure _activeMesh(mesh: Variant);
    procedure updateTransformMatrix; overload;
    procedure updateTransformMatrix(force: Boolean); overload;
    procedure _renderForCamera(camera: Variant);
    procedure _processSubCameras(camera: Variant);
    procedure _checkIntersections;
    procedure render;
    procedure _updateAudioParameters;
    audioEnabled: Boolean;
    procedure _disableAudio;
    procedure _enableAudio;
    headphone: Boolean;
    procedure _switchAudioModeForHeadphones;
    procedure _switchAudioModeForNormalSpeakers;
    function enableDepthRenderer: JDepthRenderer;
    procedure disableDepthRenderer;
    procedure dispose;
    procedure disposeSounds;
    function getWorldExtends:       min: JVector3;
      max: JVector3;
    end;;
    function createOrUpdateSelectionOctree: JOctree{<JAbstractMesh>}; overload;
    function createOrUpdateSelectionOctree(maxCapacity: Float): JOctree{<JAbstractMesh>}; overload;
    function createOrUpdateSelectionOctree(maxCapacity: Float; maxDepth: Float): JOctree{<JAbstractMesh>}; overload;
    function createPickingRay(x: Float; y: Float; world: JMatrix; camera: JCamera): JRay;
    procedure _internalPick(rayFunction: Variant; predicate: Variant); overload;
    procedure _internalPick(rayFunction: Variant; predicate: Variant; fastCheck: Variant); overload;
    function pick(x: Float; y: Float): JPickingInfo; overload;
    function pick(x: Float; y: Float; predicate: (mesh: JAbstractMesh): Boolean): JPickingInfo; overload;
    function pick(x: Float; y: Float; predicate: (mesh: JAbstractMesh): Boolean; fastCheck: Boolean): JPickingInfo; overload;
    function pick(x: Float; y: Float; predicate: (mesh: JAbstractMesh): Boolean; fastCheck: Boolean; camera: JCamera): JPickingInfo; overload;
    function pickWithRay(ray: JRay; predicate: (mesh: JMesh): Boolean): JPickingInfo; overload;
    function pickWithRay(ray: JRay; predicate: (mesh: JMesh): Boolean; fastCheck: Boolean): JPickingInfo; overload;
    procedure setPointerOverMesh(mesh: JAbstractMesh);
    function getPointerOverMesh: JAbstractMesh;
    function getPhysicsEngine: JPhysicsEngine;
    function enablePhysics(gravity: JVector3): Boolean; overload;
    function enablePhysics(gravity: JVector3; plugin: JIPhysicsEnginePlugin): Boolean; overload;
    procedure disablePhysicsEngine;
    function isPhysicsEnabled: Boolean;
    procedure setGravity(gravity: JVector3);
    function createCompoundImpostor(parts: Variant; options: JPhysicsBodyCreationOptions): Variant;
    procedure deleteCompoundImpostor(compound: Variant);
    procedure createDefaultCameraOrLight;
    procedure _getByTags(list: Variant; tagsQuery: Variant); overload;
    procedure _getByTags(list: Variant; tagsQuery: Variant; forEach: Variant); overload;
    function getMeshesByTags(tagsQuery: String): array of JMesh; overload;
    function getMeshesByTags(tagsQuery: String; forEach: (mesh: JAbstractMesh)): array of JMesh; overload;
    function getCamerasByTags(tagsQuery: String): array of JCamera; overload;
    function getCamerasByTags(tagsQuery: String; forEach: (camera: JCamera)): array of JCamera; overload;
    function getLightsByTags(tagsQuery: String): array of JLight; overload;
    function getLightsByTags(tagsQuery: String; forEach: (light: JLight)): array of JLight; overload;
    function getMaterialByTags(tagsQuery: String): array of JMaterial; overload;
    function getMaterialByTags(tagsQuery: String; forEach: (material: JMaterial)): array of JMaterial; overload;
  end;

  JIDisposable = class external
    procedure dispose;
  end;

//BABYLON

type
  JAction = class external 'Action'
    triggerOptions: Variant;
    trigger: Float;
    _actionManager: JActionManager;
    _nextActiveAction: Variant;
    _child: Variant;
    _condition: Variant;
    _triggerParameter: Variant;
    constructor Create(triggerOptions: Variant; condition: JCondition);
    procedure _prepare;
    function getTriggerParameter: Variant;
    procedure _executeCurrent(evt: JActionEvent);
    procedure execute(evt: JActionEvent);
    function then(action: JAction): JAction;
    function _getProperty(propertyPath: String): String;
    function _getEffectiveTarget(target: Variant; propertyPath: String): Variant;
  end;

//BABYLON

type
  JActionEvent = class external 'ActionEvent'
    source: JAbstractMesh;
    pointerX: Float;
    pointerY: Float;
    meshUnderPointer: JAbstractMesh;
    sourceEvent: Variant;
    additionalData: Variant;
    constructor Create(source: JAbstractMesh; pointerX: Float; pointerY: Float; meshUnderPointer: JAbstractMesh; sourceEvent: Variant; additionalData: Variant);
    function CreateNew(source: JAbstractMesh): JActionEvent; overload;
    function CreateNew(source: JAbstractMesh; evt: JEvent): JActionEvent; overload;
    function CreateNew(source: JAbstractMesh; evt: JEvent; additionalData: Variant): JActionEvent; overload;
    function CreateNewFromScene(scene: JScene; evt: JEvent): JActionEvent;
  end;

  JActionManager = class external 'ActionManager'
    _NothingTrigger: Variant;
    _OnPickTrigger: Variant;
    _OnLeftPickTrigger: Variant;
    _OnRightPickTrigger: Variant;
    _OnCenterPickTrigger: Variant;
    _OnPointerOverTrigger: Variant;
    _OnPointerOutTrigger: Variant;
    _OnEveryFrameTrigger: Variant;
    _OnIntersectionEnterTrigger: Variant;
    _OnIntersectionExitTrigger: Variant;
    _OnKeyDownTrigger: Variant;
    _OnKeyUpTrigger: Variant;
    _OnPickUpTrigger: Variant;
    NothingTrigger: Float;
    OnPickTrigger: Float;
    OnLeftPickTrigger: Float;
    OnRightPickTrigger: Float;
    OnCenterPickTrigger: Float;
    OnPointerOverTrigger: Float;
    OnPointerOutTrigger: Float;
    OnEveryFrameTrigger: Float;
    OnIntersectionEnterTrigger: Float;
    OnIntersectionExitTrigger: Float;
    OnKeyDownTrigger: Float;
    OnKeyUpTrigger: Float;
    OnPickUpTrigger: Float;
    actions: array of JAction;
    _scene: Variant;
    constructor Create(scene: JScene);
    procedure dispose;
    function getScene: JScene;
    function hasSpecificTriggers(triggers: array of Float): Boolean;
    function hasSpecificTrigger(trigger: Float): Boolean;
    hasPointerTriggers: Boolean;
    hasPickTriggers: Boolean;
    function registerAction(action: JAction): JAction;
    procedure processTrigger(trigger: Float; evt: JActionEvent);
    function _getEffectiveTarget(target: Variant; propertyPath: String): Variant;
    function _getProperty(propertyPath: String): String;
  end;

//BABYLON

type
  JCondition = class external 'Condition'
    _actionManager: JActionManager;
    _evaluationId: Float;
    _currentResult: Boolean;
    constructor Create(actionManager: JActionManager);
    function isValid: Boolean;
    function _getProperty(propertyPath: String): String;
    function _getEffectiveTarget(target: Variant; propertyPath: String): Variant;
  end;

  JValueCondition = class external 'ValueCondition'(JCondition)
    propertyPath: String;
    value: Variant;
    operator: Float;
    _IsEqual: Variant;
    _IsDifferent: Variant;
    _IsGreater: Variant;
    _IsLesser: Variant;
    IsEqual: Float;
    IsDifferent: Float;
    IsGreater: Float;
    IsLesser: Float;
    _actionManager: JActionManager;
    _target: Variant;
    _property: Variant;
    constructor Create(actionManager: JActionManager; target: Variant; propertyPath: String; value: Variant; operator: Float);
    function isValid: Boolean;
  end;

  JPredicateCondition = class external 'PredicateCondition'(JCondition)
    predicate: : Boolean;
    _actionManager: JActionManager;
    constructor Create(actionManager: JActionManager; predicate: : Boolean);
    function isValid: Boolean;
  end;

  JStateCondition = class external 'StateCondition'(JCondition)
    value: String;
    _actionManager: JActionManager;
    _target: Variant;
    constructor Create(actionManager: JActionManager; target: Variant; value: String);
    function isValid: Boolean;
  end;

//BABYLON

type
  JSwitchBooleanAction = class external 'SwitchBooleanAction'(JAction)
    propertyPath: String;
    _target: Variant;
    _property: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; propertyPath: String; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JSetStateAction = class external 'SetStateAction'(JAction)
    value: String;
    _target: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; value: String; condition: JCondition);
    procedure execute;
  end;

  JSetValueAction = class external 'SetValueAction'(JAction)
    propertyPath: String;
    value: Variant;
    _target: Variant;
    _property: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; propertyPath: String; value: Variant; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JIncrementValueAction = class external 'IncrementValueAction'(JAction)
    propertyPath: String;
    value: Variant;
    _target: Variant;
    _property: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; propertyPath: String; value: Variant; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JPlayAnimationAction = class external 'PlayAnimationAction'(JAction)
    from: Float;
    to: Float;
    loop: Boolean;
    _target: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; from: Float; to: Float; loop: Boolean; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JStopAnimationAction = class external 'StopAnimationAction'(JAction)
    _target: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JDoNothingAction = class external 'DoNothingAction'(JAction)
    constructor Create(triggerOptions: Variant; condition: JCondition);
    procedure execute;
  end;

  JCombineAction = class external 'CombineAction'(JAction)
    children: array of JAction;
    constructor Create(triggerOptions: Variant; children: array of JAction; condition: JCondition);
    procedure _prepare;
    procedure execute(evt: JActionEvent);
  end;

  JExecuteCodeAction = class external 'ExecuteCodeAction'(JAction)
    func: (evt: JActionEvent);
    constructor Create(triggerOptions: Variant; func: (evt: JActionEvent); condition: JCondition);
    procedure execute(evt: JActionEvent);
  end;

  JSetParentAction = class external 'SetParentAction'(JAction)
    _parent: Variant;
    _target: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; parent: Variant; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JPlaySoundAction = class external 'PlaySoundAction'(JAction)
    _sound: Variant;
    constructor Create(triggerOptions: Variant; sound: JSound; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

  JStopSoundAction = class external 'StopSoundAction'(JAction)
    _sound: Variant;
    constructor Create(triggerOptions: Variant; sound: JSound; condition: JCondition);
    procedure _prepare;
    procedure execute;
  end;

//BABYLON

type
  JInterpolateValueAction = class external 'InterpolateValueAction'(JAction)
    propertyPath: String;
    value: Variant;
    duration: Float;
    stopOtherAnimations: Boolean;
    _target: Variant;
    _property: Variant;
    constructor Create(triggerOptions: Variant; target: Variant; propertyPath: String; value: Variant; duration: Float; condition: JCondition; stopOtherAnimations: Boolean);
    procedure _prepare;
    procedure execute;
  end;

//BABYLON

type
  JAnimatable = class external 'Animatable'
    target: Variant;
    fromFrame: Float;
    toFrame: Float;
    loopAnimation: Boolean;
    speedRatio: Float;
    onAnimationEnd: Variant;
    _localDelayOffset: Variant;
    _pausedDelay: Variant;
    _animations: Variant;
    _paused: Variant;
    _scene: Variant;
    animationStarted: Boolean;
    constructor Create(scene: JScene; target: Variant; fromFrame: Float; toFrame: Float; loopAnimation: Boolean; speedRatio: Float; onAnimationEnd: Variant; animations: Variant);
    procedure appendAnimations(target: Variant; animations: array of JAnimation);
    function getAnimationByTargetProperty(&property: String): JAnimation;
    procedure reset;
    procedure pause;
    procedure restart;
    procedure stop;
    function _animate(delay: Float): Boolean;
  end;

//BABYLON

type
  JAnimation = class external 'Animation'
    name: String;
    targetProperty: String;
    framePerSecond: Float;
    dataType: Float;
    loopMode: Float;
    _keys: Variant;
    _offsetsCache: Variant;
    _highLimitsCache: Variant;
    _stopped: Variant;
    _target: Variant;
    _easingFunction: Variant;
    targetPropertyPath: array of String;
    currentFrame: Float;
    allowMatricesInterpolation: Boolean;
    function CreateAndStartAnimation(name: String; mesh: JAbstractMesh; targetProperty: String; framePerSecond: Float; totalFrame: Float; from: Variant; to: Variant): JAnimatable; overload;
    function CreateAndStartAnimation(name: String; mesh: JAbstractMesh; targetProperty: String; framePerSecond: Float; totalFrame: Float; from: Variant; to: Variant; loopMode: Float): JAnimatable; overload;
    function CreateAndStartAnimation(name: String; mesh: JAbstractMesh; targetProperty: String; framePerSecond: Float; totalFrame: Float; from: Variant; to: Variant; loopMode: Float; easingFunction: JEasingFunction): JAnimatable; overload;
    constructor Create(name: String; targetProperty: String; framePerSecond: Float; dataType: Float; loopMode: Float);
    procedure reset;
    function isStopped: Boolean;
    function getKeys: array of Variant;
    function getEasingFunction: JIEasingFunction;
    procedure setEasingFunction(easingFunction: JEasingFunction);
    function floatInterpolateFunction(startValue: Float; endValue: Float; gradient: Float): Float;
    function quaternionInterpolateFunction(startValue: JQuaternion; endValue: JQuaternion; gradient: Float): JQuaternion;
    function vector3InterpolateFunction(startValue: JVector3; endValue: JVector3; gradient: Float): JVector3;
    function vector2InterpolateFunction(startValue: JVector2; endValue: JVector2; gradient: Float): JVector2;
    function color3InterpolateFunction(startValue: JColor3; endValue: JColor3; gradient: Float): JColor3;
    function matrixInterpolateFunction(startValue: JMatrix; endValue: JMatrix; gradient: Float): JMatrix;
    function clone: JAnimation;
    procedure setKeys(values: JArray{<Variant>});
    procedure _getKeyValue(value: Variant);
    procedure _interpolate(currentFrame: Variant; repeatCount: Variant; loopMode: Variant); overload;
    procedure _interpolate(currentFrame: Variant; repeatCount: Variant; loopMode: Variant; offsetValue: Variant); overload;
    procedure _interpolate(currentFrame: Variant; repeatCount: Variant; loopMode: Variant; offsetValue: Variant; highLimitValue: Variant); overload;
    function animate(delay: Float; from: Float; to: Float; loop: Boolean; speedRatio: Float): Boolean;
    _ANIMATIONTYPE_FLOAT: Variant;
    _ANIMATIONTYPE_VECTOR3: Variant;
    _ANIMATIONTYPE_QUATERNION: Variant;
    _ANIMATIONTYPE_MATRIX: Variant;
    _ANIMATIONTYPE_COLOR3: Variant;
    _ANIMATIONTYPE_VECTOR2: Variant;
    _ANIMATIONLOOPMODE_RELATIVE: Variant;
    _ANIMATIONLOOPMODE_CYCLE: Variant;
    _ANIMATIONLOOPMODE_CONSTANT: Variant;
    ANIMATIONTYPE_FLOAT: Float;
    ANIMATIONTYPE_VECTOR3: Float;
    ANIMATIONTYPE_VECTOR2: Float;
    ANIMATIONTYPE_QUATERNION: Float;
    ANIMATIONTYPE_MATRIX: Float;
    ANIMATIONTYPE_COLOR3: Float;
    ANIMATIONLOOPMODE_RELATIVE: Float;
    ANIMATIONLOOPMODE_CYCLE: Float;
    ANIMATIONLOOPMODE_CONSTANT: Float;
  end;

//BABYLON

type
  JEasingFunction = class external 'EasingFunction'
    _EASINGMODE_EASEIN: Variant;
    _EASINGMODE_EASEOUT: Variant;
    _EASINGMODE_EASEINOUT: Variant;
    EASINGMODE_EASEIN: Float;
    EASINGMODE_EASEOUT: Float;
    EASINGMODE_EASEINOUT: Float;
    _easingMode: Variant;
    procedure setEasingMode(easingMode: Float);
    function getEasingMode: Float;
    function easeInCore(gradient: Float): Float;
    function ease(gradient: Float): Float;
  end;

  JCircleEase = class external 'CircleEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JBackEase = class external 'BackEase'(JEasingFunction)
    amplitude: Float;
    constructor Create(amplitude: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JBounceEase = class external 'BounceEase'(JEasingFunction)
    bounces: Float;
    bounciness: Float;
    constructor Create(bounces: Float; bounciness: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JCubicEase = class external 'CubicEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JElasticEase = class external 'ElasticEase'(JEasingFunction)
    oscillations: Float;
    springiness: Float;
    constructor Create(oscillations: Float; springiness: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JExponentialEase = class external 'ExponentialEase'(JEasingFunction)
    exponent: Float;
    constructor Create(exponent: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JPowerEase = class external 'PowerEase'(JEasingFunction)
    power: Float;
    constructor Create(power: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JQuadraticEase = class external 'QuadraticEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JQuarticEase = class external 'QuarticEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JQuinticEase = class external 'QuinticEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JSineEase = class external 'SineEase'(JEasingFunction)
    function easeInCore(gradient: Float): Float;
  end;

  JBezierCurveEase = class external 'BezierCurveEase'(JEasingFunction)
    x1: Float;
    y1: Float;
    x2: Float;
    y2: Float;
    constructor Create(x1: Float; y1: Float; x2: Float; y2: Float);
    function easeInCore(gradient: Float): Float;
  end;

  JIEasingFunction = class external
    function ease(gradient: Float): Float;
  end;

//BABYLON

type
  JAnalyser = class external 'Analyser'
    SMOOTHING: Float;
    FFT_SIZE: Float;
    BARGRAPHAMPLITUDE: Float;
    DEBUGCANVASPOS:       x: Float;
      y: Float;
    end;;
    DEBUGCANVASSIZE:       width: Float;
      height: Float;
    end;;
    _byteFreqs: Variant;
    _byteTime: Variant;
    _floatFreqs: Variant;
    _webAudioAnalyser: Variant;
    _debugCanvas: Variant;
    _debugCanvasContext: Variant;
    _scene: Variant;
    _registerFunc: Variant;
    _audioEngine: Variant;
    constructor Create(scene: JScene);
    function getFrequencyBinCount: Float;
    function getByteFrequencyData: JUint8Array;
    function getByteTimeDomainData: JUint8Array;
    function getFloatFrequencyData: JUint8Array;
    procedure drawDebugCanvas;
    procedure stopDebugCanvas;
    procedure connectAudioNodes(inputAudioNode: JAudioNode; outputAudioNode: JAudioNode);
    procedure dispose;
  end;

//BABYLON

type
  JAudioEngine = class external 'AudioEngine'
    _audioContext: Variant;
    _audioContextInitialized: Variant;
    canUseWebAudio: Boolean;
    masterGain: JGainNode;
    _connectedAnalyser: Variant;
    WarnedWebAudioUnsupported: Boolean;
    audioContext: JAudioContext;
    constructor Create;
    procedure _initializeAudioContext;
    procedure dispose;
    function getGlobalVolume: Float;
    procedure setGlobalVolume(newVolume: Float);
    procedure connectToAnalyser(analyser: JAnalyser);
  end;

//BABYLON

type
  JSound = class external 'Sound'
    name: String;
    autoplay: Boolean;
    loop: Boolean;
    useCustomAttenuation: Boolean;
    soundTrackId: Float;
    spatialSound: Boolean;
    refDistance: Float;
    rolloffFactor: Float;
    maxDistance: Float;
    distanceModel: String;
    _panningModel: Variant;
    onended: : Variant;
    _playbackRate: Variant;
    _startTime: Variant;
    _startOffset: Variant;
    _position: Variant;
    _localDirection: Variant;
    _volume: Variant;
    _isLoaded: Variant;
    _isReadyToPlay: Variant;
    isPlaying: Boolean;
    isPaused: Boolean;
    _isDirectional: Variant;
    _readyToPlayCallback: Variant;
    _audioBuffer: Variant;
    _soundSource: Variant;
    _soundPanner: Variant;
    _soundGain: Variant;
    _inputAudioNode: Variant;
    _ouputAudioNode: Variant;
    _coneInnerAngle: Variant;
    _coneOuterAngle: Variant;
    _coneOuterGain: Variant;
    _scene: Variant;
    _connectedMesh: Variant;
    _customAttenuationFunction: Variant;
    _registerFunc: Variant;
    _isOutputConnected: Variant;
    constructor Create(name: String; urlOrArrayBuffer: Variant; scene: JScene; readyToPlayCallback: ; options: Variant);
    procedure dispose;
    procedure _soundLoaded(audioData: Variant);
    procedure setAudioBuffer(audioBuffer: JAudioBuffer);
    procedure updateOptions(options: Variant);
    procedure _createSpatialParameters;
    procedure _updateSpatialParameters;
    procedure switchPanningModelToHRTF;
    procedure switchPanningModelToEqualPower;
    procedure _switchPanningModel;
    procedure connectToSoundTrackAudioNode(soundTrackAudioNode: JAudioNode);
    procedure setDirectionalCone(coneInnerAngle: Float; coneOuterAngle: Float; coneOuterGain: Float);
    procedure setPosition(newPosition: JVector3);
    procedure setLocalDirectionToMesh(newLocalDirection: JVector3);
    procedure _updateDirection;
    procedure updateDistanceFromListener;
    procedure setAttenuationFunction(callback: (currentVolume: Float; currentDistance: Float; maxDistance: Float; refDistance: Float; rolloffFactor: Float): Float);
    procedure play; overload;
    procedure play(time: Float); overload;
    procedure _onended;
    procedure stop; overload;
    procedure stop(time: Float); overload;
    procedure pause;
    procedure setVolume(newVolume: Float); overload;
    procedure setVolume(newVolume: Float; time: Float); overload;
    procedure setPlaybackRate(newPlaybackRate: Float);
    function getVolume: Float;
    procedure attachToMesh(meshToConnectTo: JAbstractMesh);
    procedure _onRegisterAfterWorldMatrixUpdate(connectedMesh: Variant);
  end;

//BABYLON

type
  JSoundTrack = class external 'SoundTrack'
    _audioEngine: Variant;
    _outputAudioNode: Variant;
    _inputAudioNode: Variant;
    _trackConvolver: Variant;
    _scene: Variant;
    id: Float;
    soundCollection: JArray{<JSound>};
    _isMainTrack: Variant;
    _connectedAnalyser: Variant;
    constructor Create(scene: JScene; options: Variant);
    procedure dispose;
    procedure AddSound(sound: JSound);
    procedure RemoveSound(sound: JSound);
    procedure setVolume(newVolume: Float);
    procedure switchPanningModelToHRTF;
    procedure switchPanningModelToEqualPower;
    procedure connectToAnalyser(analyser: JAnalyser);
  end;

//BABYLON

type
  JBone = class external 'Bone'(JNode)
    name: String;
    children: array of JBone;
    animations: array of JAnimation;
    _skeleton: Variant;
    _matrix: Variant;
    _baseMatrix: Variant;
    _worldTransform: Variant;
    _absoluteTransform: Variant;
    _invertedAbsoluteTransform: Variant;
    _parent: Variant;
    constructor Create(name: String; skeleton: JSkeleton; parentBone: JBone; matrix: JMatrix);
    function getParent: JBone;
    function getLocalMatrix: JMatrix;
    function getBaseMatrix: JMatrix;
    function getWorldMatrix: JMatrix;
    function getInvertedAbsoluteTransform: JMatrix;
    function getAbsoluteMatrix: JMatrix;
    procedure updateMatrix(matrix: JMatrix);
    procedure _updateDifferenceMatrix;
    procedure markAsDirty;
  end;

//BABYLON

type
  JSkeleton = class external 'Skeleton'
    name: String;
    id: String;
    bones: array of JBone;
    _scene: Variant;
    _isDirty: Variant;
    _transformMatrices: Variant;
    _animatables: Variant;
    _identity: Variant;
    constructor Create(name: String; id: String; scene: JScene);
    function getTransformMatrices: JFloat32Array;
    function getScene: JScene;
    procedure _markAsDirty;
    procedure prepare;
    function getAnimatables: array of JIAnimatable;
    function clone(name: String; id: String): JSkeleton;
  end;

//BABYLON

type
  JArcRotateCamera = class external 'ArcRotateCamera'(JTargetCamera)
    alpha: Float;
    beta: Float;
    radius: Float;
    target: Variant;
    inertialAlphaOffset: Float;
    inertialBetaOffset: Float;
    inertialRadiusOffset: Float;
    lowerAlphaLimit: Variant;
    upperAlphaLimit: Variant;
    lowerBetaLimit: Float;
    upperBetaLimit: Float;
    lowerRadiusLimit: Variant;
    upperRadiusLimit: Variant;
    angularSensibilityX: Float;
    angularSensibilityY: Float;
    wheelPrecision: Float;
    pinchPrecision: Float;
    panningSensibility: Float;
    inertialPanningX: Float;
    inertialPanningY: Float;
    keysUp: array of Float;
    keysDown: array of Float;
    keysLeft: array of Float;
    keysRight: array of Float;
    zoomOnFactor: Float;
    targetScreenOffset: JVector2;
    pinchInwards: Boolean;
    allowUpsideDown: Boolean;
    _keys: Variant;
    _viewMatrix: JMatrix;
    _attachedElement: Variant;
    _onContextMenu: Variant;
    _onPointerDown: Variant;
    _onPointerUp: Variant;
    _onPointerMove: Variant;
    _wheel: Variant;
    _onMouseMove: Variant;
    _onKeyDown: Variant;
    _onKeyUp: Variant;
    _onLostFocus: Variant;
    _reset: ;
    _onGestureStart: Variant;
    _onGesture: Variant;
    _MSGestureHandler: Variant;
    _localDirection: Variant;
    _transformedDirection: Variant;
    _isRightClick: Variant;
    _isCtrlPushed: Variant;
    onCollide: (collidedMesh: JAbstractMesh);
    checkCollisions: Boolean;
    collisionRadius: JVector3;
    _collider: Variant;
    _previousPosition: Variant;
    _collisionVelocity: Variant;
    _newPosition: Variant;
    _previousAlpha: Variant;
    _previousBeta: Variant;
    _previousRadius: Variant;
    _collisionTriggered: Variant;
    angularSensibility: Float;
    constructor Create(name: String; alpha: Float; beta: Float; radius: Float; target: Variant; scene: JScene);
    function _getTargetPosition: JVector3;
    procedure _initCache;
    procedure _updateCache; overload;
    procedure _updateCache(ignoreParentClass: Boolean); overload;
    function _isSynchronizedViewMatrix: Boolean;
    procedure attachControl(element: JHTMLElement); overload;
    procedure attachControl(element: JHTMLElement; noPreventDefault: Boolean); overload;
    procedure attachControl(element: JHTMLElement; noPreventDefault: Boolean; useCtrlForPanning: Boolean); overload;
    procedure detachControl(element: JHTMLElement);
    procedure _checkInputs;
    procedure _checkLimits;
    procedure setPosition(position: JVector3);
    procedure setTarget(target: JVector3);
    function _getViewMatrix: JMatrix;
    _onCollisionPositionChange: Variant;
    procedure zoomOn; overload;
    procedure zoomOn(meshes: array of JAbstractMesh); overload;
    procedure zoomOn(meshes: array of JAbstractMesh; doNotUpdateMaxZ: Boolean); overload;
    procedure focusOn(meshesOrMinMaxVectorAndDistance: Variant); overload;
    procedure focusOn(meshesOrMinMaxVectorAndDistance: Variant; doNotUpdateMaxZ: Boolean); overload;
    function createRigCamera(name: String; cameraIndex: Float): JCamera;
    procedure _updateRigCameras;
  end;

//BABYLON

type
  JVRCameraMetrics = class external 'VRCameraMetrics'
    hResolution: Float;
    vResolution: Float;
    hScreenSize: Float;
    vScreenSize: Float;
    vScreenCenter: Float;
    eyeToScreenDistance: Float;
    lensSeparationDistance: Float;
    interpupillaryDistance: Float;
    distortionK: array of Float;
    chromaAbCorrection: array of Float;
    postProcessScaleFactor: Float;
    lensCenterOffset: Float;
    compensateDistorsion: Boolean;
    aspectRatio: Float;
    aspectRatioFov: Float;
    leftHMatrix: JMatrix;
    rightHMatrix: JMatrix;
    leftPreViewMatrix: JMatrix;
    rightPreViewMatrix: JMatrix;
    function GetDefault: JVRCameraMetrics;
  end;

  JCamera = class external 'Camera'(JNode)
    position: JVector3;
    _PERSPECTIVE_CAMERA: Variant;
    _ORTHOGRAPHIC_CAMERA: Variant;
    _FOVMODE_VERTICAL_FIXED: Variant;
    _FOVMODE_HORIZONTAL_FIXED: Variant;
    _RIG_MODE_NONE: Variant;
    _RIG_MODE_STEREOSCOPIC_ANAGLYPH: Variant;
    _RIG_MODE_STEREOSCOPIC_SIDEBYSIDE_PARALLEL: Variant;
    _RIG_MODE_STEREOSCOPIC_SIDEBYSIDE_CROSSEYED: Variant;
    _RIG_MODE_STEREOSCOPIC_OVERUNDER: Variant;
    _RIG_MODE_VR: Variant;
    PERSPECTIVE_CAMERA: Float;
    ORTHOGRAPHIC_CAMERA: Float;
    FOVMODE_VERTICAL_FIXED: Float;
    FOVMODE_HORIZONTAL_FIXED: Float;
    RIG_MODE_NONE: Float;
    RIG_MODE_STEREOSCOPIC_ANAGLYPH: Float;
    RIG_MODE_STEREOSCOPIC_SIDEBYSIDE_PARALLEL: Float;
    RIG_MODE_STEREOSCOPIC_SIDEBYSIDE_CROSSEYED: Float;
    RIG_MODE_STEREOSCOPIC_OVERUNDER: Float;
    RIG_MODE_VR: Float;
    upVector: JVector3;
    orthoLeft: Variant;
    orthoRight: Variant;
    orthoBottom: Variant;
    orthoTop: Variant;
    fov: Float;
    minZ: Float;
    maxZ: Float;
    inertia: Float;
    mode: Float;
    isIntermediate: Boolean;
    viewport: JViewport;
    layerMask: Float;
    fovMode: Float;
    cameraRigMode: Float;
    _cameraRigParams: Variant;
    _rigCameras: array of JCamera;
    _computedViewMatrix: Variant;
    _projectionMatrix: JMatrix;
    _worldMatrix: Variant;
    _postProcesses: array of JPostProcess;
    _postProcessesTakenIndices: array of Variant;
    _activeMeshes: JSmartArray{<JMesh>};
    _globalPosition: Variant;
    constructor Create(name: String; position: JVector3; scene: JScene);
    globalPosition: JVector3;
    function getActiveMeshes: JSmartArray{<JMesh>};
    function isActiveMesh(mesh: JMesh): Boolean;
    procedure _initCache;
    procedure _updateCache; overload;
    procedure _updateCache(ignoreParentClass: Boolean); overload;
    procedure _updateFromScene;
    function _isSynchronized: Boolean;
    function _isSynchronizedViewMatrix: Boolean;
    function _isSynchronizedProjectionMatrix: Boolean;
    procedure attachControl(element: JHTMLElement);
    procedure detachControl(element: JHTMLElement);
    procedure _update;
    procedure _checkInputs;
    function attachPostProcess(postProcess: JPostProcess): Float; overload;
    function attachPostProcess(postProcess: JPostProcess; insertAt: Float): Float; overload;
    function detachPostProcess(postProcess: JPostProcess): array of Float; overload;
    function detachPostProcess(postProcess: JPostProcess; atIndices: Variant): array of Float; overload;
    function getWorldMatrix: JMatrix;
    function _getViewMatrix: JMatrix;
    function getViewMatrix: JMatrix; overload;
    function getViewMatrix(force: Boolean): JMatrix; overload;
    function _computeViewMatrix: JMatrix; overload;
    function _computeViewMatrix(force: Boolean): JMatrix; overload;
    function getProjectionMatrix: JMatrix; overload;
    function getProjectionMatrix(force: Boolean): JMatrix; overload;
    procedure dispose;
    procedure setCameraRigMode(mode: Float; rigParams: Variant);
    procedure _getVRProjectionMatrix;
    procedure setCameraRigParameter(name: String; value: Variant);
    function createRigCamera(name: String; cameraIndex: Float): JCamera;
    procedure _updateRigCameras;
  end;

//BABYLON

type
  JDeviceOrientationCamera = class external 'DeviceOrientationCamera'(JFreeCamera)
    _offsetX: Variant;
    _offsetY: Variant;
    _orientationGamma: Variant;
    _orientationBeta: Variant;
    _initialOrientationGamma: Variant;
    _initialOrientationBeta: Variant;
    _attachedCanvas: Variant;
    _orientationChanged: Variant;
    angularSensibility: Float;
    moveSensibility: Float;
    constructor Create(name: String; position: JVector3; scene: JScene);
    procedure attachControl(canvas: JHTMLCanvasElement; noPreventDefault: Boolean);
    procedure detachControl(canvas: JHTMLCanvasElement);
    procedure _checkInputs;
  end;

//BABYLON

type
  JFollowCamera = class external 'FollowCamera'(JTargetCamera)
    radius: Float;
    rotationOffset: Float;
    heightOffset: Float;
    cameraAcceleration: Float;
    maxCameraSpeed: Float;
    target: JAbstractMesh;
    constructor Create(name: String; position: JVector3; scene: JScene);
    procedure getRadians(degrees: Variant);
    procedure follow(cameraTarget: Variant);
    procedure _checkInputs;
  end;

  JArcFollowCamera = class external 'ArcFollowCamera'(JTargetCamera)
    alpha: Float;
    beta: Float;
    radius: Float;
    target: JAbstractMesh;
    _cartesianCoordinates: Variant;
    constructor Create(name: String; alpha: Float; beta: Float; radius: Float; target: JAbstractMesh; scene: JScene);
    procedure follow;
    procedure _checkInputs;
  end;

//BABYLON

type
  JFreeCamera = class external 'FreeCamera'(JTargetCamera)
    ellipsoid: JVector3;
    keysUp: array of Float;
    keysDown: array of Float;
    keysLeft: array of Float;
    keysRight: array of Float;
    checkCollisions: Boolean;
    applyGravity: Boolean;
    angularSensibility: Float;
    onCollide: (collidedMesh: JAbstractMesh);
    _keys: Variant;
    _collider: Variant;
    _needMoveForGravity: Variant;
    _oldPosition: Variant;
    _diffPosition: Variant;
    _newPosition: Variant;
    _attachedElement: Variant;
    _localDirection: Variant;
    _transformedDirection: Variant;
    _onMouseDown: Variant;
    _onMouseUp: Variant;
    _onMouseOut: Variant;
    _onMouseMove: Variant;
    _onKeyDown: Variant;
    _onKeyUp: Variant;
    _onLostFocus: (e: JFocusEvent): Variant;
    _waitingLockedTargetId: String;
    constructor Create(name: String; position: JVector3; scene: JScene);
    procedure attachControl(element: JHTMLElement); overload;
    procedure attachControl(element: JHTMLElement; noPreventDefault: Boolean); overload;
    procedure detachControl(element: JHTMLElement);
    procedure _collideWithWorld(velocity: JVector3);
    _onCollisionPositionChange: Variant;
    procedure _checkInputs;
    function _decideIfNeedsToMove: Boolean;
    procedure _updatePosition;
  end;

//BABYLON

type
  JGamepadCamera = class external 'GamepadCamera'(JFreeCamera)
    _gamepad: Variant;
    _gamepads: Variant;
    angularSensibility: Float;
    moveSensibility: Float;
    constructor Create(name: String; position: JVector3; scene: JScene);
    procedure _onNewGameConnected(gamepad: Variant);
    procedure _checkInputs;
    procedure dispose;
  end;

//BABYLON

type
  JAnaglyphFreeCamera = class external 'AnaglyphFreeCamera'(JFreeCamera)
    constructor Create(name: String; position: JVector3; interaxialDistance: Float; scene: JScene);
  end;

  JAnaglyphArcRotateCamera = class external 'AnaglyphArcRotateCamera'(JArcRotateCamera)
    constructor Create(name: String; alpha: Float; beta: Float; radius: Float; target: Variant; interaxialDistance: Float; scene: JScene);
  end;

  JAnaglyphGamepadCamera = class external 'AnaglyphGamepadCamera'(JGamepadCamera)
    constructor Create(name: String; position: JVector3; interaxialDistance: Float; scene: JScene);
  end;

  JStereoscopicFreeCamera = class external 'StereoscopicFreeCamera'(JFreeCamera)
    constructor Create(name: String; position: JVector3; interaxialDistance: Float; isSideBySide: Boolean; scene: JScene);
  end;

  JStereoscopicArcRotateCamera = class external 'StereoscopicArcRotateCamera'(JArcRotateCamera)
    constructor Create(name: String; alpha: Float; beta: Float; radius: Float; target: Variant; interaxialDistance: Float; isSideBySide: Boolean; scene: JScene);
  end;

  JStereoscopicGamepadCamera = class external 'StereoscopicGamepadCamera'(JGamepadCamera)
    constructor Create(name: String; position: JVector3; interaxialDistance: Float; isSideBySide: Boolean; scene: JScene);
  end;

//BABYLON

type
  JTargetCamera = class external 'TargetCamera'(JCamera)
    cameraDirection: JVector3;
    cameraRotation: JVector2;
    rotation: JVector3;
    speed: Float;
    noRotationConstraint: Boolean;
    lockedTarget: Variant;
    _currentTarget: JVector3;
    _viewMatrix: JMatrix;
    _camMatrix: JMatrix;
    _cameraTransformMatrix: JMatrix;
    _cameraRotationMatrix: JMatrix;
    _rigCamTransformMatrix: Variant;
    _referencePoint: JVector3;
    _transformedReferencePoint: JVector3;
    _lookAtTemp: JMatrix;
    _tempMatrix: JMatrix;
    _reset: ;
    _waitingLockedTargetId: String;
    constructor Create(name: String; position: JVector3; scene: JScene);
    function getFrontPosition(distance: Float): JVector3;
    function _getLockedTargetPosition: JVector3;
    procedure _initCache;
    procedure _updateCache; overload;
    procedure _updateCache(ignoreParentClass: Boolean); overload;
    function _isSynchronizedViewMatrix: Boolean;
    function _computeLocalCameraSpeed: Float;
    procedure setTarget(target: JVector3);
    function getTarget: JVector3;
    function _decideIfNeedsToMove: Boolean;
    procedure _updatePosition;
    procedure _checkInputs;
    function _getViewMatrix: JMatrix;
    function _getVRViewMatrix: JMatrix;
    function createRigCamera(name: String; cameraIndex: Float): JCamera;
    procedure _updateRigCameras;
    procedure _getRigCamPosition(halfSpace: Variant; result: Variant);
  end;

//BABYLON

type
  JTouchCamera = class external 'TouchCamera'(JFreeCamera)
    _offsetX: Variant;
    _offsetY: Variant;
    _pointerCount: Variant;
    _pointerPressed: Variant;
    _attachedCanvas: Variant;
    _onPointerDown: Variant;
    _onPointerUp: Variant;
    _onPointerMove: Variant;
    angularSensibility: Float;
    moveSensibility: Float;
    constructor Create(name: String; position: JVector3; scene: JScene);
    procedure attachControl(canvas: JHTMLCanvasElement; noPreventDefault: Boolean);
    procedure detachControl(canvas: JHTMLCanvasElement);
    procedure _checkInputs;
  end;

//BABYLON

type
  JVirtualJoysticksCamera = class external 'VirtualJoysticksCamera'(JFreeCamera)
    _leftjoystick: Variant;
    _rightjoystick: Variant;
    constructor Create(name: String; position: JVector3; scene: JScene);
    function getLeftJoystick: JVirtualJoystick;
    function getRightJoystick: JVirtualJoystick;
    procedure _checkInputs;
    procedure dispose;
  end;

//BABYLON

type
  JCollider = class external 'Collider'
    radius: JVector3;
    retry: Float;
    velocity: JVector3;
    basePoint: JVector3;
    epsilon: Float;
    collisionFound: Boolean;
    velocityWorldLength: Float;
    basePointWorld: JVector3;
    velocityWorld: JVector3;
    normalizedVelocity: JVector3;
    initialVelocity: JVector3;
    initialPosition: JVector3;
    nearestDistance: Float;
    intersectionPoint: JVector3;
    collidedMesh: JAbstractMesh;
    _collisionPoint: Variant;
    _planeIntersectionPoint: Variant;
    _tempVector: Variant;
    _tempVector2: Variant;
    _tempVector3: Variant;
    _tempVector4: Variant;
    _edge: Variant;
    _baseToVertex: Variant;
    _destinationPoint: Variant;
    _slidePlaneNormal: Variant;
    _displacementVector: Variant;
    procedure _initialize(source: JVector3; dir: JVector3; e: Float);
    function _checkPointInTriangle(point: JVector3; pa: JVector3; pb: JVector3; pc: JVector3; n: JVector3): Boolean;
    function _canDoCollision(sphereCenter: JVector3; sphereRadius: Float; vecMin: JVector3; vecMax: JVector3): Boolean;
    procedure _testTriangle(faceIndex: Float; trianglePlaneArray: JArray{<JPlane>}; p1: JVector3; p2: JVector3; p3: JVector3; hasMaterial: Boolean);
    procedure _collide(trianglePlaneArray: JArray{<JPlane>}; pts: array of JVector3; indices: array of Float; indexStart: Float; indexEnd: Float; decal: Float; hasMaterial: Boolean);
    procedure _getResponse(pos: JVector3; vel: JVector3);
  end;

//BABYLON

type
  JCollisionCoordinatorWorker = class external 'CollisionCoordinatorWorker'
    _scene: Variant;
    _scaledPosition: Variant;
    _scaledVelocity: Variant;
    _collisionsCallbackArray: Variant;
    _init: Variant;
    _runningUpdated: Variant;
    _runningCollisionTask: Variant;
    _worker: Variant;
    _addUpdateMeshesList: Variant;
    _addUpdateGeometriesList: Variant;
    _toRemoveMeshesArray: Variant;
    _toRemoveGeometryArray: Variant;
    constructor Create;
    SerializeMesh: (mesh: JAbstractMesh): JSerializedMesh;
    SerializeGeometry: (geometry: JGeometry): JSerializedGeometry;
    procedure getNewPosition(position: JVector3; velocity: JVector3; collider: JCollider; maximumRetry: Float; excludedMesh: JAbstractMesh; onNewPosition: (collisionIndex: Float; newPosition: JVector3; collidedMesh: JAbstractMesh); collisionIndex: Float);
    procedure init(scene: JScene);
    procedure destroy;
    procedure onMeshAdded(mesh: JAbstractMesh);
    onMeshUpdated: (mesh: JAbstractMesh);
    procedure onMeshRemoved(mesh: JAbstractMesh);
    procedure onGeometryAdded(geometry: JGeometry);
    onGeometryUpdated: (geometry: JGeometry);
    procedure onGeometryDeleted(geometry: JGeometry);
    _afterRender: Variant;
    _onMessageFromWorker: Variant;
  end;

  JCollisionCoordinatorLegacy = class external 'CollisionCoordinatorLegacy'
    _scene: Variant;
    _scaledPosition: Variant;
    _scaledVelocity: Variant;
    _finalPosition: Variant;
    procedure getNewPosition(position: JVector3; velocity: JVector3; collider: JCollider; maximumRetry: Float; excludedMesh: JAbstractMesh; onNewPosition: (collisionIndex: Float; newPosition: JVector3; collidedMesh: JAbstractMesh); collisionIndex: Float);
    procedure init(scene: JScene);
    procedure destroy;
    procedure onMeshAdded(mesh: JAbstractMesh);
    procedure onMeshUpdated(mesh: JAbstractMesh);
    procedure onMeshRemoved(mesh: JAbstractMesh);
    procedure onGeometryAdded(geometry: JGeometry);
    procedure onGeometryUpdated(geometry: JGeometry);
    procedure onGeometryDeleted(geometry: JGeometry);
    procedure _collideWithWorld(position: Variant; velocity: Variant; collider: Variant; maximumRetry: Variant; finalPosition: Variant); overload;
    procedure _collideWithWorld(position: Variant; velocity: Variant; collider: Variant; maximumRetry: Variant; finalPosition: Variant; excludedMesh: Variant); overload;
  end;

  JICollisionCoordinator = class external
    procedure getNewPosition(position: JVector3; velocity: JVector3; collider: JCollider; maximumRetry: Float; excludedMesh: JAbstractMesh; onNewPosition: (collisionIndex: Float; newPosition: JVector3; collidedMesh: JAbstractMesh); collisionIndex: Float);
    procedure init(scene: JScene);
    procedure destroy;
    function onMeshAdded(mesh: JAbstractMesh): Variant;
    function onMeshUpdated(mesh: JAbstractMesh): Variant;
    function onMeshRemoved(mesh: JAbstractMesh): Variant;
    function onGeometryAdded(geometry: JGeometry): Variant;
    function onGeometryUpdated(geometry: JGeometry): Variant;
    function onGeometryDeleted(geometry: JGeometry): Variant;
  end;

  JSerializedMesh = class external
    id: String;
    name: String;
    uniqueId: Float;
    geometryId: String;
    sphereCenter: JArray{<Float>};
    sphereRadius: Float;
    boxMinimum: JArray{<Float>};
    boxMaximum: JArray{<Float>};
    worldMatrixFromCache: Variant;
    subMeshes: JArray{<JSerializedSubMesh>};
    checkCollisions: Boolean;
  end;

  JSerializedSubMesh = class external
    position: Float;
    verticesStart: Float;
    verticesCount: Float;
    indexStart: Float;
    indexCount: Float;
    hasMaterial: Boolean;
    sphereCenter: JArray{<Float>};
    sphereRadius: Float;
    boxMinimum: JArray{<Float>};
    boxMaximum: JArray{<Float>};
  end;

  JSerializedGeometry = class external
    id: String;
    positions: JFloat32Array;
    indices: JInt32Array;
    normals: JFloat32Array;
  end;

  JBabylonMessage = class external
    taskType: JWorkerTaskType;
    payload: Variant {JInitPayload or JCollidePayload or JUpdatePayload};
  end;

  JSerializedColliderToWorker = class external
    position: JArray{<Float>};
    velocity: JArray{<Float>};
    radius: JArray{<Float>};
  end;

  JWorkerReply = class external
    error: JWorkerReplyType;
    taskType: JWorkerTaskType;
    payload: Variant; // nullable
  end;

  JCollisionReplyPayload = class external
    newPosition: JArray{<Float>};
    collisionId: Float;
    collidedMeshUniqueId: Float;
  end;

  JInitPayload = class external
  end;

  JCollidePayload = class external
    collisionId: Float;
    collider: JSerializedColliderToWorker;
    maximumRetry: Float;
    excludedMeshUniqueId: Float; // nullable
  end;

  JUpdatePayload = class external
    updatedMeshes:       // property Item[n: Integer]: JSerializedMesh;
    end;;
    updatedGeometries:       // property Item[s: String]: JSerializedGeometry;
    end;;
    removedMeshes: JArray{<Float>};
    removedGeometries: JArray{<String>};
  end;

var
  CollisionWorker: String;

//BABYLON

type
  JCollisionCache = class external 'CollisionCache'
    _meshes: Variant;
    _geometries: Variant;
    function getMeshes:       // property Item[n: Integer]: JSerializedMesh;
    end;;
    function getGeometries:       // property Item[s: Integer]: JSerializedGeometry;
    end;;
    function getMesh(id: Variant): JSerializedMesh;
    procedure addMesh(mesh: JSerializedMesh);
    function getGeometry(id: String): JSerializedGeometry;
    procedure addGeometry(geometry: JSerializedGeometry);
  end;

  JCollideWorker = class external 'CollideWorker'
    collider: JCollider;
    _collisionCache: Variant;
    finalPosition: Variant;
    collisionsScalingMatrix: Variant;
    collisionTranformationMatrix: Variant;
    constructor Create(collider: JCollider; _collisionCache: JCollisionCache; finalPosition: JVector3);
    procedure collideWithWorld(position: JVector3; velocity: JVector3; maximumRetry: Float); overload;
    procedure collideWithWorld(position: JVector3; velocity: JVector3; maximumRetry: Float; excludedMeshUniqueId: Float); overload;
    procedure checkCollision(mesh: Variant);
    procedure processCollisionsForSubMeshes(transformMatrix: Variant; mesh: Variant);
    procedure collideForSubMesh(subMesh: Variant; transformMatrix: Variant; meshGeometry: Variant);
    procedure checkSubmeshCollision(subMesh: Variant);
  end;

  JCollisionDetectorTransferable = class external 'CollisionDetectorTransferable'
    _collisionCache: Variant;
    procedure onInit(payload: JInitPayload);
    procedure onUpdate(payload: JUpdatePayload);
    procedure onCollision(payload: JCollidePayload);
  end;

  JICollisionDetector = class external
    procedure onInit(payload: JInitPayload);
    procedure onUpdate(payload: JUpdatePayload);
    procedure onCollision(payload: JCollidePayload);
  end;

var
  WorkerIncluded: Boolean;

//BABYLON

type
  JIntersectionInfo = class external 'IntersectionInfo'
    bu: Float;
    bv: Float;
    distance: Float;
    faceId: Float;
    subMeshId: Float;
    constructor Create(bu: Float; bv: Float; distance: Float);
  end;

  JPickingInfo = class external 'PickingInfo'
    hit: Boolean;
    distance: Float;
    pickedPoint: JVector3;
    pickedMesh: JAbstractMesh;
    bu: Float;
    bv: Float;
    faceId: Float;
    subMeshId: Float;
    function getNormal: JVector3; overload;
    function getNormal(useWorldCoordinates: Boolean): JVector3; overload;
    function getNormal(useWorldCoordinates: Boolean; useVerticesNormals: Boolean): JVector3; overload;
    function getTextureCoordinates: JVector2;
  end;

//BABYLON

type
  JBoundingBox = class external 'BoundingBox'
    minimum: JVector3;
    maximum: JVector3;
    vectors: array of JVector3;
    center: JVector3;
    extendSize: JVector3;
    directions: array of JVector3;
    vectorsWorld: array of JVector3;
    minimumWorld: JVector3;
    maximumWorld: JVector3;
    _worldMatrix: Variant;
    constructor Create(minimum: JVector3; maximum: JVector3);
    function getWorldMatrix: JMatrix;
    procedure _update(world: JMatrix);
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    function isCompletelyInFrustum(frustumPlanes: array of JPlane): Boolean;
    function intersectsPoint(point: JVector3): Boolean;
    function intersectsSphere(sphere: JBoundingSphere): Boolean;
    function intersectsMinMax(min: JVector3; max: JVector3): Boolean;
    function Intersects(box0: JBoundingBox; box1: JBoundingBox): Boolean;
    function IntersectsSphere(minPoint: JVector3; maxPoint: JVector3; sphereCenter: JVector3; sphereRadius: Float): Boolean;
    function IsCompletelyInFrustum(boundingVectors: array of JVector3; frustumPlanes: array of JPlane): Boolean;
    function IsInFrustum(boundingVectors: array of JVector3; frustumPlanes: array of JPlane): Boolean;
  end;

//BABYLON

type
  JBoundingInfo = class external 'BoundingInfo'
    minimum: JVector3;
    maximum: JVector3;
    boundingBox: JBoundingBox;
    boundingSphere: JBoundingSphere;
    constructor Create(minimum: JVector3; maximum: JVector3);
    procedure _update(world: JMatrix);
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    function isCompletelyInFrustum(frustumPlanes: array of JPlane): Boolean;
    function _checkCollision(collider: JCollider): Boolean;
    function intersectsPoint(point: JVector3): Boolean;
    function intersects(boundingInfo: JBoundingInfo; precise: Boolean): Boolean;
  end;

//BABYLON

type
  JBoundingSphere = class external 'BoundingSphere'
    minimum: JVector3;
    maximum: JVector3;
    center: JVector3;
    radius: Float;
    centerWorld: JVector3;
    radiusWorld: Float;
    _tempRadiusVector: Variant;
    constructor Create(minimum: JVector3; maximum: JVector3);
    procedure _update(world: JMatrix);
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    function intersectsPoint(point: JVector3): Boolean;
    function Intersects(sphere0: JBoundingSphere; sphere1: JBoundingSphere): Boolean;
  end;

//BABYLON

type
  JDebugLayer = class external 'DebugLayer'
    _scene: Variant;
    _camera: Variant;
    _transformationMatrix: Variant;
    _enabled: Variant;
    _labelsEnabled: Variant;
    _displayStatistics: Variant;
    _displayTree: Variant;
    _displayLogs: Variant;
    _globalDiv: Variant;
    _statsDiv: Variant;
    _statsSubsetDiv: Variant;
    _optionsDiv: Variant;
    _optionsSubsetDiv: Variant;
    _logDiv: Variant;
    _logSubsetDiv: Variant;
    _treeDiv: Variant;
    _treeSubsetDiv: Variant;
    _drawingCanvas: Variant;
    _drawingContext: Variant;
    _syncPositions: Variant;
    _syncData: Variant;
    _syncUI: Variant;
    _onCanvasClick: Variant;
    _clickPosition: Variant;
    _ratio: Variant;
    _identityMatrix: Variant;
    _showUI: Variant;
    _needToRefreshMeshesTree: Variant;
    shouldDisplayLabel: (node: JNode): Boolean;
    shouldDisplayAxis: (mesh: JMesh): Boolean;
    axisRatio: Float;
    accentColor: String;
    customStatsFunction: : String;
    constructor Create(scene: JScene);
    procedure _refreshMeshesTreeContent;
    procedure _renderSingleAxis(zero: Variant; unit: Variant; unitText: Variant; &label: Variant; color: Variant);
    procedure _renderAxis(projectedPosition: Variant; mesh: Variant; globalViewport: Variant);
    procedure _renderLabel(text: Variant; projectedPosition: Variant; labelOffset: Variant; onClick: Variant; getFillStyle: Variant);
    procedure _isClickInsideRect(x: Variant; y: Variant; width: Variant; height: Variant);
    function isVisible: Boolean;
    procedure hide;
    procedure show; overload;
    procedure show(showUI: Boolean); overload;
    procedure show(showUI: Boolean; camera: JCamera); overload;
    procedure _clearLabels;
    procedure _generateheader(root: Variant; text: Variant);
    procedure _generateTexBox(root: Variant; title: Variant; color: Variant);
    procedure _generateAdvancedCheckBox(root: Variant; leftTitle: Variant; rightTitle: Variant; initialState: Variant; task: Variant); overload;
    procedure _generateAdvancedCheckBox(root: Variant; leftTitle: Variant; rightTitle: Variant; initialState: Variant; task: Variant; tag: Variant); overload;
    procedure _generateCheckBox(root: Variant; title: Variant; initialState: Variant; task: Variant); overload;
    procedure _generateCheckBox(root: Variant; title: Variant; initialState: Variant; task: Variant; tag: Variant); overload;
    procedure _generateButton(root: Variant; title: Variant; task: Variant); overload;
    procedure _generateButton(root: Variant; title: Variant; task: Variant; tag: Variant); overload;
    procedure _generateRadio(root: Variant; title: Variant; name: Variant; initialState: Variant; task: Variant); overload;
    procedure _generateRadio(root: Variant; title: Variant; name: Variant; initialState: Variant; task: Variant; tag: Variant); overload;
    procedure _generateDOMelements;
    procedure _displayStats;
  end;

//BABYLON

type
  JLayer = class external 'Layer'
    name: String;
    texture: JTexture;
    isBackground: Boolean;
    color: JColor4;
    onDispose: ;
    _scene: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _vertexBuffer: Variant;
    _indexBuffer: Variant;
    _effect: Variant;
    constructor Create(name: String; imgUrl: String; scene: JScene; isBackground: Boolean; color: JColor4);
    procedure render;
    procedure dispose;
  end;

//BABYLON

type
  JLensFlare = class external 'LensFlare'
    size: Float;
    position: Float;
    color: JColor3;
    texture: JTexture;
    _system: Variant;
    constructor Create(size: Float; position: Float; color: Variant; imgUrl: String; system: JLensFlareSystem);
    dispose: ;
  end;

//BABYLON

type
  JLensFlareSystem = class external 'LensFlareSystem'
    name: String;
    lensFlares: array of JLensFlare;
    borderLimit: Float;
    meshesSelectionPredicate: (mesh: JMesh): Boolean;
    layerMask: Float;
    _scene: Variant;
    _emitter: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _vertexBuffer: Variant;
    _indexBuffer: Variant;
    _effect: Variant;
    _positionX: Variant;
    _positionY: Variant;
    _isEnabled: Variant;
    constructor Create(name: String; emitter: Variant; scene: JScene);
    isEnabled: Boolean;
    function getScene: JScene;
    function getEmitter: Variant;
    procedure setEmitter(newEmitter: Variant);
    function getEmitterPosition: JVector3;
    function computeEffectivePosition(globalViewport: JViewport): Boolean;
    function _isVisible: Boolean;
    function render: Boolean;
    procedure dispose;
  end;

//BABYLON

type
  JDirectionalLight = class external 'DirectionalLight'(JLight)
    direction: JVector3;
    position: JVector3;
    _transformedDirection: Variant;
    transformedPosition: JVector3;
    _worldMatrix: Variant;
    shadowOrthoScale: Float;
    constructor Create(name: String; direction: JVector3; scene: JScene);
    function getAbsolutePosition: JVector3;
    function setDirectionToTarget(target: JVector3): JVector3;
    procedure setShadowProjectionMatrix(matrix: JMatrix; viewMatrix: JMatrix; renderList: JArray{<JAbstractMesh>});
    function supportsVSM: Boolean;
    function needRefreshPerFrame: Boolean;
    function computeTransformedPosition: Boolean;
    procedure transferToEffect(effect: JEffect; directionUniformName: String);
    function _getWorldMatrix: JMatrix;
  end;

//BABYLON

type
  JHemisphericLight = class external 'HemisphericLight'(JLight)
    direction: JVector3;
    groundColor: JColor3;
    _worldMatrix: Variant;
    constructor Create(name: String; direction: JVector3; scene: JScene);
    function setDirectionToTarget(target: JVector3): JVector3;
    function getShadowGenerator: JShadowGenerator;
    procedure transferToEffect(effect: JEffect; directionUniformName: String; groundColorUniformName: String);
    function _getWorldMatrix: JMatrix;
  end;

//BABYLON

type
  JLight = class external 'Light'(JNode)
    diffuse: JColor3;
    specular: JColor3;
    intensity: Float;
    range: Float;
    includeOnlyWithLayerMask: Float;
    includedOnlyMeshes: array of JAbstractMesh;
    excludedMeshes: array of JAbstractMesh;
    excludeWithLayerMask: Float;
    _shadowGenerator: JShadowGenerator;
    _parentedWorldMatrix: Variant;
    _excludedMeshesIds: array of String;
    _includedOnlyMeshesIds: array of String;
    constructor Create(name: String; scene: JScene);
    function getShadowGenerator: JShadowGenerator;
    function getAbsolutePosition: JVector3;
    procedure transferToEffect(effect: JEffect); overload;
    procedure transferToEffect(effect: JEffect; uniformName0: String); overload;
    procedure transferToEffect(effect: JEffect; uniformName0: String; uniformName1: String); overload;
    function _getWorldMatrix: JMatrix;
    function canAffectMesh(mesh: JAbstractMesh): Boolean;
    function getWorldMatrix: JMatrix;
    procedure dispose;
  end;

  JIShadowLight = class external
    position: JVector3;
    direction: JVector3;
    transformedPosition: JVector3;
    name: String;
    function computeTransformedPosition: Boolean;
    function getScene: JScene;
    procedure setShadowProjectionMatrix(matrix: JMatrix; viewMatrix: JMatrix; renderList: JArray{<JAbstractMesh>});
    function supportsVSM: Boolean;
    function needRefreshPerFrame: Boolean;
    _shadowGenerator: JShadowGenerator;
  end;

//BABYLON

type
  JPointLight = class external 'PointLight'(JLight)
    position: JVector3;
    _worldMatrix: Variant;
    _transformedPosition: Variant;
    constructor Create(name: String; position: JVector3; scene: JScene);
    function getAbsolutePosition: JVector3;
    procedure transferToEffect(effect: JEffect; positionUniformName: String);
    function getShadowGenerator: JShadowGenerator;
    function _getWorldMatrix: JMatrix;
  end;

//BABYLON

type
  JSpotLight = class external 'SpotLight'(JLight)
    position: JVector3;
    direction: JVector3;
    angle: Float;
    exponent: Float;
    transformedPosition: JVector3;
    _transformedDirection: Variant;
    _worldMatrix: Variant;
    constructor Create(name: String; position: JVector3; direction: JVector3; angle: Float; exponent: Float; scene: JScene);
    function getAbsolutePosition: JVector3;
    procedure setShadowProjectionMatrix(matrix: JMatrix; viewMatrix: JMatrix; renderList: JArray{<JAbstractMesh>});
    function supportsVSM: Boolean;
    function needRefreshPerFrame: Boolean;
    function setDirectionToTarget(target: JVector3): JVector3;
    function computeTransformedPosition: Boolean;
    procedure transferToEffect(effect: JEffect; positionUniformName: String; directionUniformName: String);
    function _getWorldMatrix: JMatrix;
  end;

//BABYLON

type
  JSceneLoader = class external 'SceneLoader'
    _ForceFullSceneLoadingForIncremental: Variant;
    _ShowLoadingScreen: Variant;
    ForceFullSceneLoadingForIncremental: Boolean;
    ShowLoadingScreen: Boolean;
    _registeredPlugins: Variant;
    procedure _getPluginForFilename(sceneFilename: Variant);
    procedure RegisterPlugin(plugin: JISceneLoaderPlugin);
    procedure ImportMesh(meshesNames: Variant; rootUrl: String; sceneFilename: String; scene: JScene); overload;
    procedure ImportMesh(meshesNames: Variant; rootUrl: String; sceneFilename: String; scene: JScene; onsuccess: (meshes: array of JAbstractMesh; particleSystems: array of JParticleSystem; skeletons: array of JSkeleton)); overload;
    procedure ImportMesh(meshesNames: Variant; rootUrl: String; sceneFilename: String; scene: JScene; onsuccess: (meshes: array of JAbstractMesh; particleSystems: array of JParticleSystem; skeletons: array of JSkeleton); progressCallBack: ); overload;
    procedure ImportMesh(meshesNames: Variant; rootUrl: String; sceneFilename: String; scene: JScene; onsuccess: (meshes: array of JAbstractMesh; particleSystems: array of JParticleSystem; skeletons: array of JSkeleton); progressCallBack: ; onerror: (scene: JScene; e: Variant)); overload;
    procedure Load(rootUrl: String; sceneFilename: Variant; engine: JEngine); overload;
    procedure Load(rootUrl: String; sceneFilename: Variant; engine: JEngine; onsuccess: (scene: JScene)); overload;
    procedure Load(rootUrl: String; sceneFilename: Variant; engine: JEngine; onsuccess: (scene: JScene); progressCallBack: Variant); overload;
    procedure Load(rootUrl: String; sceneFilename: Variant; engine: JEngine; onsuccess: (scene: JScene); progressCallBack: Variant; onerror: (scene: JScene)); overload;
    procedure Append(rootUrl: String; sceneFilename: Variant; scene: JScene); overload;
    procedure Append(rootUrl: String; sceneFilename: Variant; scene: JScene; onsuccess: (scene: JScene)); overload;
    procedure Append(rootUrl: String; sceneFilename: Variant; scene: JScene; onsuccess: (scene: JScene); progressCallBack: Variant); overload;
    procedure Append(rootUrl: String; sceneFilename: Variant; scene: JScene; onsuccess: (scene: JScene); progressCallBack: Variant; onerror: (scene: JScene)); overload;
  end;

  JISceneLoaderPlugin = class external
    extensions: String;
    importMesh: (meshesNames: Variant; scene: JScene; data: Variant; rootUrl: String; meshes: array of JAbstractMesh; particleSystems: array of JParticleSystem; skeletons: array of JSkeleton): Boolean;
    load: (scene: JScene; data: String; rootUrl: String): Boolean;
  end;

//BABYLON

type
  JEffectFallbacks = class external 'EffectFallbacks'
    _defines: Variant;
    _currentRank: Variant;
    _maxRank: Variant;
    procedure addFallback(rank: Float; define: String);
    isMoreFallbacks: Boolean;
    function reduce(currentDefines: String): String;
  end;

  JEffect = class external 'Effect'
    name: Variant;
    defines: String;
    onCompiled: (effect: JEffect);
    onError: (effect: JEffect; errors: String);
    onBind: (effect: JEffect);
    _engine: Variant;
    _uniformsNames: Variant;
    _samplers: Variant;
    _isReady: Variant;
    _compilationError: Variant;
    _attributesNames: Variant;
    _attributes: Variant;
    _uniforms: Variant;
    _key: String;
    _program: Variant;
    _valueCache: Variant;
    constructor Create(baseName: Variant; attributesNames: array of String; uniformsNames: array of String; samplers: array of String; engine: Variant; defines: String; fallbacks: JEffectFallbacks; onCompiled: (effect: JEffect); onError: (effect: JEffect; errors: String));
    function isReady: Boolean;
    function getProgram: JWebGLProgram;
    function getAttributesNames: array of String;
    function getAttributeLocation(index: Float): Float;
    function getAttributeLocationByName(name: String): Float;
    function getAttributesCount: Float;
    function getUniformIndex(uniformName: String): Float;
    function getUniform(uniformName: String): JWebGLUniformLocation;
    function getSamplers: array of String;
    function getCompilationError: String;
    procedure _loadVertexShader(vertex: Variant; callback: (data: Variant));
    procedure _loadFragmentShader(fragment: Variant; callback: (data: Variant));
    procedure _prepareEffect(vertexSourceCode: Variant; fragmentSourceCode: Variant; attributesNames: Variant; defines: Variant); overload;
    procedure _prepareEffect(vertexSourceCode: Variant; fragmentSourceCode: Variant; attributesNames: Variant; defines: Variant; fallbacks: Variant); overload;
    procedure _bindTexture(channel: String; texture: JWebGLTexture);
    procedure setTexture(channel: String; texture: JBaseTexture);
    procedure setTextureFromPostProcess(channel: String; postProcess: JPostProcess);
    procedure _cacheFloat2(uniformName: String; x: Float; y: Float);
    procedure _cacheFloat3(uniformName: String; x: Float; y: Float; z: Float);
    procedure _cacheFloat4(uniformName: String; x: Float; y: Float; z: Float; w: Float);
    function setArray(uniformName: String; array: array of Float): JEffect;
    function setArray2(uniformName: String; array: array of Float): JEffect;
    function setArray3(uniformName: String; array: array of Float): JEffect;
    function setArray4(uniformName: String; array: array of Float): JEffect;
    function setMatrices(uniformName: String; matrices: JFloat32Array): JEffect;
    function setMatrix(uniformName: String; matrix: JMatrix): JEffect;
    function setMatrix3x3(uniformName: String; matrix: JFloat32Array): JEffect;
    function setMatrix2x2(uniformname: String; matrix: JFloat32Array): JEffect;
    function setFloat(uniformName: String; value: Float): JEffect;
    function setBool(uniformName: String; bool: Boolean): JEffect;
    function setVector2(uniformName: String; vector2: JVector2): JEffect;
    function setFloat2(uniformName: String; x: Float; y: Float): JEffect;
    function setVector3(uniformName: String; vector3: JVector3): JEffect;
    function setFloat3(uniformName: String; x: Float; y: Float; z: Float): JEffect;
    function setVector4(uniformName: String; vector4: JVector4): JEffect;
    function setFloat4(uniformName: String; x: Float; y: Float; z: Float; w: Float): JEffect;
    function setColor3(uniformName: String; color3: JColor3): JEffect;
    function setColor4(uniformName: String; color3: JColor3; alpha: Float): JEffect;
    ShadersStore:     end;;
  end;

//BABYLON

type
  JMaterial = class external 'Material'
    name: String;
    _TriangleFillMode: Variant;
    _WireFrameFillMode: Variant;
    _PointFillMode: Variant;
    TriangleFillMode: Float;
    WireFrameFillMode: Float;
    PointFillMode: Float;
    id: String;
    checkReadyOnEveryCall: Boolean;
    checkReadyOnlyOnce: Boolean;
    state: String;
    alpha: Float;
    backFaceCulling: Boolean;
    onCompiled: (effect: JEffect);
    onError: (effect: JEffect; errors: String);
    onDispose: ;
    onBind: (material: JMaterial; mesh: JMesh);
    getRenderTargetTextures: : JSmartArray{<JRenderTargetTexture>};
    alphaMode: Float;
    disableDepthWrite: Boolean;
    _effect: JEffect;
    _wasPreviouslyReady: Boolean;
    _scene: Variant;
    _fillMode: Variant;
    _cachedDepthWriteState: Variant;
    pointSize: Float;
    zOffset: Float;
    wireframe: Boolean;
    pointsCloud: Boolean;
    fillMode: Float;
    constructor Create(name: String; scene: JScene; doNotAdd: Boolean);
    function isReady: Boolean; overload;
    function isReady(mesh: JAbstractMesh): Boolean; overload;
    function isReady(mesh: JAbstractMesh; useInstances: Boolean): Boolean; overload;
    function getEffect: JEffect;
    function getScene: JScene;
    function needAlphaBlending: Boolean;
    function needAlphaTesting: Boolean;
    function getAlphaTestTexture: JBaseTexture;
    procedure trackCreation(onCompiled: (effect: JEffect); onError: (effect: JEffect; errors: String));
    procedure _preBind;
    procedure bind(world: JMatrix); overload;
    procedure bind(world: JMatrix; mesh: JMesh); overload;
    procedure bindOnlyWorldMatrix(world: JMatrix);
    procedure unbind;
    function clone(name: String): JMaterial;
    procedure dispose; overload;
    procedure dispose(forceDisposeEffect: Boolean); overload;
  end;

//BABYLON

type
  JMultiMaterial = class external 'MultiMaterial'(JMaterial)
    subMaterials: array of JMaterial;
    constructor Create(name: String; scene: JScene);
    function getSubMaterial(index: Variant): JMaterial;
    function isReady: Boolean; overload;
    function isReady(mesh: JAbstractMesh): Boolean; overload;
    function clone(name: String): JMultiMaterial;
  end;

//BABYLON

type
  JShaderMaterial = class external 'ShaderMaterial'(JMaterial)
    _shaderPath: Variant;
    _options: Variant;
    _textures: Variant;
    _floats: Variant;
    _floatsArrays: Variant;
    _colors3: Variant;
    _colors4: Variant;
    _vectors2: Variant;
    _vectors3: Variant;
    _vectors4: Variant;
    _matrices: Variant;
    _matrices3x3: Variant;
    _matrices2x2: Variant;
    _cachedWorldViewMatrix: Variant;
    _renderId: Variant;
    constructor Create(name: String; scene: JScene; shaderPath: Variant; options: Variant);
    function needAlphaBlending: Boolean;
    function needAlphaTesting: Boolean;
    procedure _checkUniform(uniformName: Variant);
    function setTexture(name: String; texture: JTexture): JShaderMaterial;
    function setFloat(name: String; value: Float): JShaderMaterial;
    function setFloats(name: String; value: array of Float): JShaderMaterial;
    function setColor3(name: String; value: JColor3): JShaderMaterial;
    function setColor4(name: String; value: JColor4): JShaderMaterial;
    function setVector2(name: String; value: JVector2): JShaderMaterial;
    function setVector3(name: String; value: JVector3): JShaderMaterial;
    function setVector4(name: String; value: JVector4): JShaderMaterial;
    function setMatrix(name: String; value: JMatrix): JShaderMaterial;
    function setMatrix3x3(name: String; value: JFloat32Array): JShaderMaterial;
    function setMatrix2x2(name: String; value: JFloat32Array): JShaderMaterial;
    function isReady: Boolean; overload;
    function isReady(mesh: JAbstractMesh): Boolean; overload;
    function isReady(mesh: JAbstractMesh; useInstances: Boolean): Boolean; overload;
    procedure bindOnlyWorldMatrix(world: JMatrix);
    procedure bind(world: JMatrix); overload;
    procedure bind(world: JMatrix; mesh: JMesh); overload;
    function clone(name: String): JShaderMaterial;
    procedure dispose; overload;
    procedure dispose(forceDisposeEffect: Boolean); overload;
  end;

//BABYLON

type
  JFresnelParameters = class external 'FresnelParameters'
    isEnabled: Boolean;
    leftColor: JColor3;
    rightColor: JColor3;
    bias: Float;
    power: Float;
  end;

  JStandardMaterial = class external 'StandardMaterial'(JMaterial)
    diffuseTexture: JBaseTexture;
    ambientTexture: JBaseTexture;
    opacityTexture: JBaseTexture;
    reflectionTexture: JBaseTexture;
    emissiveTexture: JBaseTexture;
    specularTexture: JBaseTexture;
    bumpTexture: JBaseTexture;
    ambientColor: JColor3;
    diffuseColor: JColor3;
    specularColor: JColor3;
    specularPower: Float;
    emissiveColor: JColor3;
    useAlphaFromDiffuseTexture: Boolean;
    useEmissiveAsIllumination: Boolean;
    useReflectionFresnelFromSpecular: Boolean;
    useSpecularOverAlpha: Boolean;
    fogEnabled: Boolean;
    roughness: Float;
    diffuseFresnelParameters: JFresnelParameters;
    opacityFresnelParameters: JFresnelParameters;
    reflectionFresnelParameters: JFresnelParameters;
    emissiveFresnelParameters: JFresnelParameters;
    useGlossinessFromSpecularMapAlpha: Boolean;
    _renderTargets: Variant;
    _worldViewProjectionMatrix: Variant;
    _globalAmbientColor: Variant;
    _scaledDiffuse: Variant;
    _scaledSpecular: Variant;
    _renderId: Variant;
    _defines: Variant;
    _cachedDefines: Variant;
    constructor Create(name: String; scene: JScene);
    function needAlphaBlending: Boolean;
    function needAlphaTesting: Boolean;
    procedure _shouldUseAlphaFromDiffuseTexture;
    function getAlphaTestTexture: JBaseTexture;
    function isReady: Boolean; overload;
    function isReady(mesh: JAbstractMesh): Boolean; overload;
    function isReady(mesh: JAbstractMesh; useInstances: Boolean): Boolean; overload;
    procedure unbind;
    procedure bindOnlyWorldMatrix(world: JMatrix);
    procedure bind(world: JMatrix); overload;
    procedure bind(world: JMatrix; mesh: JMesh); overload;
    function getAnimatables: array of JIAnimatable;
    procedure dispose; overload;
    procedure dispose(forceDisposeEffect: Boolean); overload;
    function clone(name: String): JStandardMaterial;
    DiffuseTextureEnabled: Boolean;
    AmbientTextureEnabled: Boolean;
    OpacityTextureEnabled: Boolean;
    ReflectionTextureEnabled: Boolean;
    EmissiveTextureEnabled: Boolean;
    SpecularTextureEnabled: Boolean;
    BumpTextureEnabled: Boolean;
    FresnelEnabled: Boolean;
  end;

//BABYLON

type
  JColor3 = class external 'Color3'
    r: Float;
    g: Float;
    b: Float;
    constructor Create(r: Float; g: Float; b: Float);
    function toString: String;
    function toArray(array: array of Float): JColor3; overload;
    function toArray(array: array of Float; index: Float): JColor3; overload;
    function toColor4: JColor4; overload;
    function toColor4(alpha: Float): JColor4; overload;
    function asArray: array of Float;
    function toLuminance: Float;
    function multiply(otherColor: JColor3): JColor3;
    function multiplyToRef(otherColor: JColor3; result: JColor3): JColor3;
    function equals(otherColor: JColor3): Boolean;
    function equalsFloats(r: Float; g: Float; b: Float): Boolean;
    function scale(scale: Float): JColor3;
    function scaleToRef(scale: Float; result: JColor3): JColor3;
    function add(otherColor: JColor3): JColor3;
    function addToRef(otherColor: JColor3; result: JColor3): JColor3;
    function subtract(otherColor: JColor3): JColor3;
    function subtractToRef(otherColor: JColor3; result: JColor3): JColor3;
    function clone: JColor3;
    function copyFrom(source: JColor3): JColor3;
    function copyFromFloats(r: Float; g: Float; b: Float): JColor3;
    function toHexString: String;
    function FromHexString(hex: String): JColor3;
    function FromArray(array: array of Float): JColor3; overload;
    function FromArray(array: array of Float; offset: Float): JColor3; overload;
    function FromInts(r: Float; g: Float; b: Float): JColor3;
    function Lerp(start: JColor3; &end: JColor3; amount: Float): JColor3;
    function Red: JColor3;
    function Green: JColor3;
    function Blue: JColor3;
    function Black: JColor3;
    function White: JColor3;
    function Purple: JColor3;
    function Magenta: JColor3;
    function Yellow: JColor3;
    function Gray: JColor3;
  end;

  JColor4 = class external 'Color4'
    r: Float;
    g: Float;
    b: Float;
    a: Float;
    constructor Create(r: Float; g: Float; b: Float; a: Float);
    function addInPlace(right: Variant): JColor4;
    function asArray: array of Float;
    function toArray(array: array of Float): JColor4; overload;
    function toArray(array: array of Float; index: Float): JColor4; overload;
    function add(right: JColor4): JColor4;
    function subtract(right: JColor4): JColor4;
    function subtractToRef(right: JColor4; result: JColor4): JColor4;
    function scale(scale: Float): JColor4;
    function scaleToRef(scale: Float; result: JColor4): JColor4;
    function toString: String;
    function clone: JColor4;
    function copyFrom(source: JColor4): JColor4;
    function toHexString: String;
    function FromHexString(hex: String): JColor4;
    function Lerp(left: JColor4; right: JColor4; amount: Float): JColor4;
    procedure LerpToRef(left: JColor4; right: JColor4; amount: Float; result: JColor4);
    function FromArray(array: array of Float): JColor4; overload;
    function FromArray(array: array of Float; offset: Float): JColor4; overload;
    function FromInts(r: Float; g: Float; b: Float; a: Float): JColor4;
  end;

  JVector2 = class external 'Vector2'
    x: Float;
    y: Float;
    constructor Create(x: Float; y: Float);
    function toString: String;
    function toArray(array: array of Float): JVector2; overload;
    function toArray(array: array of Float; index: Float): JVector2; overload;
    function asArray: array of Float;
    function copyFrom(source: JVector2): JVector2;
    function copyFromFloats(x: Float; y: Float): JVector2;
    function add(otherVector: JVector2): JVector2;
    function addVector3(otherVector: JVector3): JVector2;
    function subtract(otherVector: JVector2): JVector2;
    function subtractInPlace(otherVector: JVector2): JVector2;
    function multiplyInPlace(otherVector: JVector2): JVector2;
    function multiply(otherVector: JVector2): JVector2;
    function multiplyToRef(otherVector: JVector2; result: JVector2): JVector2;
    function multiplyByFloats(x: Float; y: Float): JVector2;
    function divide(otherVector: JVector2): JVector2;
    function divideToRef(otherVector: JVector2; result: JVector2): JVector2;
    function negate: JVector2;
    function scaleInPlace(scale: Float): JVector2;
    function scale(scale: Float): JVector2;
    function equals(otherVector: JVector2): Boolean;
    function equalsWithEpsilon(otherVector: JVector2): Boolean; overload;
    function equalsWithEpsilon(otherVector: JVector2; epsilon: Float): Boolean; overload;
    function length: Float;
    function lengthSquared: Float;
    function normalize: JVector2;
    function clone: JVector2;
    function Zero: JVector2;
    function FromArray(array: array of Float): JVector2; overload;
    function FromArray(array: array of Float; offset: Float): JVector2; overload;
    procedure FromArrayToRef(array: array of Float; offset: Float; result: JVector2);
    function CatmullRom(value1: JVector2; value2: JVector2; value3: JVector2; value4: JVector2; amount: Float): JVector2;
    function Clamp(value: JVector2; min: JVector2; max: JVector2): JVector2;
    function Hermite(value1: JVector2; tangent1: JVector2; value2: JVector2; tangent2: JVector2; amount: Float): JVector2;
    function Lerp(start: JVector2; &end: JVector2; amount: Float): JVector2;
    function Dot(left: JVector2; right: JVector2): Float;
    function Normalize(vector: JVector2): JVector2;
    function Minimize(left: JVector2; right: JVector2): JVector2;
    function Maximize(left: JVector2; right: JVector2): JVector2;
    function Transform(vector: JVector2; transformation: JMatrix): JVector2;
    function Distance(value1: JVector2; value2: JVector2): Float;
    function DistanceSquared(value1: JVector2; value2: JVector2): Float;
  end;

  JVector3 = class external 'Vector3'
    x: Float;
    y: Float;
    z: Float;
    constructor Create(x: Float; y: Float; z: Float);
    function toString: String;
    function asArray: array of Float;
    function toArray(array: array of Float): JVector3; overload;
    function toArray(array: array of Float; index: Float): JVector3; overload;
    function toQuaternion: JQuaternion;
    function addInPlace(otherVector: JVector3): JVector3;
    function add(otherVector: JVector3): JVector3;
    function addToRef(otherVector: JVector3; result: JVector3): JVector3;
    function subtractInPlace(otherVector: JVector3): JVector3;
    function subtract(otherVector: JVector3): JVector3;
    function subtractToRef(otherVector: JVector3; result: JVector3): JVector3;
    function subtractFromFloats(x: Float; y: Float; z: Float): JVector3;
    function subtractFromFloatsToRef(x: Float; y: Float; z: Float; result: JVector3): JVector3;
    function negate: JVector3;
    function scaleInPlace(scale: Float): JVector3;
    function scale(scale: Float): JVector3;
    procedure scaleToRef(scale: Float; result: JVector3);
    function equals(otherVector: JVector3): Boolean;
    function equalsWithEpsilon(otherVector: JVector3): Boolean; overload;
    function equalsWithEpsilon(otherVector: JVector3; epsilon: Float): Boolean; overload;
    function equalsToFloats(x: Float; y: Float; z: Float): Boolean;
    function multiplyInPlace(otherVector: JVector3): JVector3;
    function multiply(otherVector: JVector3): JVector3;
    function multiplyToRef(otherVector: JVector3; result: JVector3): JVector3;
    function multiplyByFloats(x: Float; y: Float; z: Float): JVector3;
    function divide(otherVector: JVector3): JVector3;
    function divideToRef(otherVector: JVector3; result: JVector3): JVector3;
    function MinimizeInPlace(other: JVector3): JVector3;
    function MaximizeInPlace(other: JVector3): JVector3;
    function length: Float;
    function lengthSquared: Float;
    function normalize: JVector3;
    function clone: JVector3;
    function copyFrom(source: JVector3): JVector3;
    function copyFromFloats(x: Float; y: Float; z: Float): JVector3;
    function GetClipFactor(vector0: JVector3; vector1: JVector3; axis: JVector3; size: Variant): Float;
    function FromArray(array: array of Float): JVector3; overload;
    function FromArray(array: array of Float; offset: Float): JVector3; overload;
    function FromFloatArray(array: JFloat32Array): JVector3; overload;
    function FromFloatArray(array: JFloat32Array; offset: Float): JVector3; overload;
    procedure FromArrayToRef(array: array of Float; offset: Float; result: JVector3);
    procedure FromFloatArrayToRef(array: JFloat32Array; offset: Float; result: JVector3);
    procedure FromFloatsToRef(x: Float; y: Float; z: Float; result: JVector3);
    function Zero: JVector3;
    function Up: JVector3;
    function TransformCoordinates(vector: JVector3; transformation: JMatrix): JVector3;
    procedure TransformCoordinatesToRef(vector: JVector3; transformation: JMatrix; result: JVector3);
    procedure TransformCoordinatesFromFloatsToRef(x: Float; y: Float; z: Float; transformation: JMatrix; result: JVector3);
    procedure TransformCoordinatesToRefSIMD(vector: JVector3; transformation: JMatrix; result: JVector3);
    procedure TransformCoordinatesFromFloatsToRefSIMD(x: Float; y: Float; z: Float; transformation: JMatrix; result: JVector3);
    function TransformNormal(vector: JVector3; transformation: JMatrix): JVector3;
    procedure TransformNormalToRef(vector: JVector3; transformation: JMatrix; result: JVector3);
    procedure TransformNormalFromFloatsToRef(x: Float; y: Float; z: Float; transformation: JMatrix; result: JVector3);
    function CatmullRom(value1: JVector3; value2: JVector3; value3: JVector3; value4: JVector3; amount: Float): JVector3;
    function Clamp(value: JVector3; min: JVector3; max: JVector3): JVector3;
    function Hermite(value1: JVector3; tangent1: JVector3; value2: JVector3; tangent2: JVector3; amount: Float): JVector3;
    function Lerp(start: JVector3; &end: JVector3; amount: Float): JVector3;
    function Dot(left: JVector3; right: JVector3): Float;
    function Cross(left: JVector3; right: JVector3): JVector3;
    procedure CrossToRef(left: JVector3; right: JVector3; result: JVector3);
    function Normalize(vector: JVector3): JVector3;
    procedure NormalizeToRef(vector: JVector3; result: JVector3);
    function Project(vector: JVector3; world: JMatrix; transform: JMatrix; viewport: JViewport): JVector3;
    function UnprojectFromTransform(source: JVector3; viewportWidth: Float; viewportHeight: Float; world: JMatrix; transform: JMatrix): JVector3;
    function Unproject(source: JVector3; viewportWidth: Float; viewportHeight: Float; world: JMatrix; view: JMatrix; projection: JMatrix): JVector3;
    function Minimize(left: JVector3; right: JVector3): JVector3;
    function Maximize(left: JVector3; right: JVector3): JVector3;
    function Distance(value1: JVector3; value2: JVector3): Float;
    function DistanceSquared(value1: JVector3; value2: JVector3): Float;
    function Center(value1: JVector3; value2: JVector3): JVector3;
    function RotationFromAxis(axis1: JVector3; axis2: JVector3; axis3: JVector3): JVector3;
    procedure RotationFromAxisToRef(axis1: JVector3; axis2: JVector3; axis3: JVector3; ref: JVector3);
  end;

  JVector4 = class external 'Vector4'
    x: Float;
    y: Float;
    z: Float;
    w: Float;
    constructor Create(x: Float; y: Float; z: Float; w: Float);
    function toString: String;
    function asArray: array of Float;
    function toArray(array: array of Float): JVector4; overload;
    function toArray(array: array of Float; index: Float): JVector4; overload;
    function addInPlace(otherVector: JVector4): JVector4;
    function add(otherVector: JVector4): JVector4;
    function addToRef(otherVector: JVector4; result: JVector4): JVector4;
    function subtractInPlace(otherVector: JVector4): JVector4;
    function subtract(otherVector: JVector4): JVector4;
    function subtractToRef(otherVector: JVector4; result: JVector4): JVector4;
    function subtractFromFloats(x: Float; y: Float; z: Float; w: Float): JVector4;
    function subtractFromFloatsToRef(x: Float; y: Float; z: Float; w: Float; result: JVector4): JVector4;
    function negate: JVector4;
    function scaleInPlace(scale: Float): JVector4;
    function scale(scale: Float): JVector4;
    procedure scaleToRef(scale: Float; result: JVector4);
    function equals(otherVector: JVector4): Boolean;
    function equalsWithEpsilon(otherVector: JVector4): Boolean; overload;
    function equalsWithEpsilon(otherVector: JVector4; epsilon: Float): Boolean; overload;
    function equalsToFloats(x: Float; y: Float; z: Float; w: Float): Boolean;
    function multiplyInPlace(otherVector: JVector4): JVector4;
    function multiply(otherVector: JVector4): JVector4;
    function multiplyToRef(otherVector: JVector4; result: JVector4): JVector4;
    function multiplyByFloats(x: Float; y: Float; z: Float; w: Float): JVector4;
    function divide(otherVector: JVector4): JVector4;
    function divideToRef(otherVector: JVector4; result: JVector4): JVector4;
    function MinimizeInPlace(other: JVector4): JVector4;
    function MaximizeInPlace(other: JVector4): JVector4;
    function length: Float;
    function lengthSquared: Float;
    function normalize: JVector4;
    function clone: JVector4;
    function copyFrom(source: JVector4): JVector4;
    function copyFromFloats(x: Float; y: Float; z: Float; w: Float): JVector4;
    function FromArray(array: array of Float): JVector4; overload;
    function FromArray(array: array of Float; offset: Float): JVector4; overload;
    procedure FromArrayToRef(array: array of Float; offset: Float; result: JVector4);
    procedure FromFloatArrayToRef(array: JFloat32Array; offset: Float; result: JVector4);
    procedure FromFloatsToRef(x: Float; y: Float; z: Float; w: Float; result: JVector4);
    function Zero: JVector4;
    function Normalize(vector: JVector4): JVector4;
    procedure NormalizeToRef(vector: JVector4; result: JVector4);
    function Minimize(left: JVector4; right: JVector4): JVector4;
    function Maximize(left: JVector4; right: JVector4): JVector4;
    function Distance(value1: JVector4; value2: JVector4): Float;
    function DistanceSquared(value1: JVector4; value2: JVector4): Float;
    function Center(value1: JVector4; value2: JVector4): JVector4;
  end;

  JQuaternion = class external 'Quaternion'
    x: Float;
    y: Float;
    z: Float;
    w: Float;
    constructor Create(x: Float; y: Float; z: Float; w: Float);
    function toString: String;
    function asArray: array of Float;
    function equals(otherQuaternion: JQuaternion): Boolean;
    function clone: JQuaternion;
    function copyFrom(other: JQuaternion): JQuaternion;
    function copyFromFloats(x: Float; y: Float; z: Float; w: Float): JQuaternion;
    function add(other: JQuaternion): JQuaternion;
    function subtract(other: JQuaternion): JQuaternion;
    function scale(value: Float): JQuaternion;
    function multiply(q1: JQuaternion): JQuaternion;
    function multiplyToRef(q1: JQuaternion; result: JQuaternion): JQuaternion;
    function length: Float;
    function normalize: JQuaternion;
    function toEulerAngles: JVector3;
    function toEulerAnglesToRef(result: JVector3): JQuaternion;
    function toRotationMatrix(result: JMatrix): JQuaternion;
    function fromRotationMatrix(matrix: JMatrix): JQuaternion;
    function FromRotationMatrix(matrix: JMatrix): JQuaternion;
    procedure FromRotationMatrixToRef(matrix: JMatrix; result: JQuaternion);
    function Inverse(q: JQuaternion): JQuaternion;
    function Identity: JQuaternion;
    function RotationAxis(axis: JVector3; angle: Float): JQuaternion;
    function FromArray(array: array of Float): JQuaternion; overload;
    function FromArray(array: array of Float; offset: Float): JQuaternion; overload;
    function RotationYawPitchRoll(yaw: Float; pitch: Float; roll: Float): JQuaternion;
    procedure RotationYawPitchRollToRef(yaw: Float; pitch: Float; roll: Float; result: JQuaternion);
    function RotationAlphaBetaGamma(alpha: Float; beta: Float; gamma: Float): JQuaternion;
    procedure RotationAlphaBetaGammaToRef(alpha: Float; beta: Float; gamma: Float; result: JQuaternion);
    function Slerp(left: JQuaternion; right: JQuaternion; amount: Float): JQuaternion;
  end;

  JMatrix = class external 'Matrix'
    _tempQuaternion: Variant;
    _xAxis: Variant;
    _yAxis: Variant;
    _zAxis: Variant;
    m: JFloat32Array;
    function isIdentity: Boolean;
    function determinant: Float;
    function toArray: JFloat32Array;
    function asArray: JFloat32Array;
    function invert: JMatrix;
    function reset: JMatrix;
    function add(other: JMatrix): JMatrix;
    function addToRef(other: JMatrix; result: JMatrix): JMatrix;
    function addToSelf(other: JMatrix): JMatrix;
    function invertToRef(other: JMatrix): JMatrix;
    function invertToRefSIMD(other: JMatrix): JMatrix;
    function setTranslation(vector3: JVector3): JMatrix;
    function multiply(other: JMatrix): JMatrix;
    function copyFrom(other: JMatrix): JMatrix;
    function copyToArray(array: JFloat32Array): JMatrix; overload;
    function copyToArray(array: JFloat32Array; offset: Float): JMatrix; overload;
    function multiplyToRef(other: JMatrix; result: JMatrix): JMatrix;
    function multiplyToArray(other: JMatrix; result: JFloat32Array; offset: Float): JMatrix;
    procedure multiplyToArraySIMD(other: JMatrix; result: JMatrix); overload;
    procedure multiplyToArraySIMD(other: JMatrix; result: JMatrix; offset: Float); overload;
    function equals(value: JMatrix): Boolean;
    function clone: JMatrix;
    function decompose(scale: JVector3; rotation: JQuaternion; translation: JVector3): Boolean;
    function FromArray(array: array of Float): JMatrix; overload;
    function FromArray(array: array of Float; offset: Float): JMatrix; overload;
    procedure FromArrayToRef(array: array of Float; offset: Float; result: JMatrix);
    procedure FromFloat32ArrayToRefScaled(array: JFloat32Array; offset: Float; scale: Float; result: JMatrix);
    procedure FromValuesToRef(initialM11: Float; initialM12: Float; initialM13: Float; initialM14: Float; initialM21: Float; initialM22: Float; initialM23: Float; initialM24: Float; initialM31: Float; initialM32: Float; initialM33: Float; initialM34: Float; initialM41: Float; initialM42: Float; initialM43: Float; initialM44: Float; result: JMatrix);
    function FromValues(initialM11: Float; initialM12: Float; initialM13: Float; initialM14: Float; initialM21: Float; initialM22: Float; initialM23: Float; initialM24: Float; initialM31: Float; initialM32: Float; initialM33: Float; initialM34: Float; initialM41: Float; initialM42: Float; initialM43: Float; initialM44: Float): JMatrix;
    function Compose(scale: JVector3; rotation: JQuaternion; translation: JVector3): JMatrix;
    function Identity: JMatrix;
    procedure IdentityToRef(result: JMatrix);
    function Zero: JMatrix;
    function RotationX(angle: Float): JMatrix;
    function Invert(source: JMatrix): JMatrix;
    procedure RotationXToRef(angle: Float; result: JMatrix);
    function RotationY(angle: Float): JMatrix;
    procedure RotationYToRef(angle: Float; result: JMatrix);
    function RotationZ(angle: Float): JMatrix;
    procedure RotationZToRef(angle: Float; result: JMatrix);
    function RotationAxis(axis: JVector3; angle: Float): JMatrix;
    function RotationYawPitchRoll(yaw: Float; pitch: Float; roll: Float): JMatrix;
    procedure RotationYawPitchRollToRef(yaw: Float; pitch: Float; roll: Float; result: JMatrix);
    function Scaling(x: Float; y: Float; z: Float): JMatrix;
    procedure ScalingToRef(x: Float; y: Float; z: Float; result: JMatrix);
    function Translation(x: Float; y: Float; z: Float): JMatrix;
    procedure TranslationToRef(x: Float; y: Float; z: Float; result: JMatrix);
    function LookAtLH(eye: JVector3; target: JVector3; up: JVector3): JMatrix;
    procedure LookAtLHToRef(eye: JVector3; target: JVector3; up: JVector3; result: JMatrix);
    procedure LookAtLHToRefSIMD(eyeRef: JVector3; targetRef: JVector3; upRef: JVector3; result: JMatrix);
    function OrthoLH(width: Float; height: Float; znear: Float; zfar: Float): JMatrix;
    procedure OrthoLHToRef(width: Float; height: Float; znear: Float; zfar: Float; result: JMatrix);
    function OrthoOffCenterLH(left: Float; right: Float; bottom: Float; top: Float; znear: Float; zfar: Float): JMatrix;
    procedure OrthoOffCenterLHToRef(left: Float; right: Variant; bottom: Float; top: Float; znear: Float; zfar: Float; result: JMatrix);
    function PerspectiveLH(width: Float; height: Float; znear: Float; zfar: Float): JMatrix;
    function PerspectiveFovLH(fov: Float; aspect: Float; znear: Float; zfar: Float): JMatrix;
    procedure PerspectiveFovLHToRef(fov: Float; aspect: Float; znear: Float; zfar: Float; result: JMatrix); overload;
    procedure PerspectiveFovLHToRef(fov: Float; aspect: Float; znear: Float; zfar: Float; result: JMatrix; fovMode: Float); overload;
    function GetFinalMatrix(viewport: JViewport; world: JMatrix; view: JMatrix; projection: JMatrix; zmin: Float; zmax: Float): JMatrix;
    function GetAsMatrix2x2(matrix: JMatrix): JFloat32Array;
    function GetAsMatrix3x3(matrix: JMatrix): JFloat32Array;
    function Transpose(matrix: JMatrix): JMatrix;
    function Reflection(plane: JPlane): JMatrix;
    procedure ReflectionToRef(plane: JPlane; result: JMatrix);
  end;

  JPlane = class external 'Plane'
    normal: JVector3;
    d: Float;
    constructor Create(a: Float; b: Float; c: Float; d: Float);
    function asArray: array of Float;
    function clone: JPlane;
    function normalize: JPlane;
    function transform(transformation: JMatrix): JPlane;
    function dotCoordinate(point: Variant): Float;
    function copyFromPoints(point1: JVector3; point2: JVector3; point3: JVector3): JPlane;
    function isFrontFacingTo(direction: JVector3; epsilon: Float): Boolean;
    function signedDistanceTo(point: JVector3): Float;
    function FromArray(array: array of Float): JPlane;
    function FromPoints(point1: Variant; point2: Variant; point3: Variant): JPlane;
    function FromPositionAndNormal(origin: JVector3; normal: JVector3): JPlane;
    function SignedDistanceToPlaneFromPositionAndNormal(origin: JVector3; normal: JVector3; point: JVector3): Float;
  end;

  JViewport = class external 'Viewport'
    x: Float;
    y: Float;
    width: Float;
    height: Float;
    constructor Create(x: Float; y: Float; width: Float; height: Float);
    function toGlobal(engine: Variant): JViewport;
  end;

  JFrustum = class external 'Frustum'
    function GetPlanes(transform: JMatrix): array of JPlane;
    procedure GetPlanesToRef(transform: JMatrix; frustumPlanes: array of JPlane);
  end;

  JRay = class external 'Ray'
    origin: JVector3;
    direction: JVector3;
    _length: Float;
    _edge1: Variant;
    _edge2: Variant;
    _pvec: Variant;
    _tvec: Variant;
    _qvec: Variant;
    constructor Create(origin: JVector3; direction: JVector3; _length: Float);
    function intersectsBoxMinMax(minimum: JVector3; maximum: JVector3): Boolean;
    function intersectsBox(box: JBoundingBox): Boolean;
    function intersectsSphere(sphere: Variant): Boolean;
    function intersectsTriangle(vertex0: JVector3; vertex1: JVector3; vertex2: JVector3): JIntersectionInfo;
    function CreateNew(x: Float; y: Float; viewportWidth: Float; viewportHeight: Float; world: JMatrix; view: JMatrix; projection: JMatrix): JRay;
    function CreateNewFromTo(origin: JVector3; &end: JVector3): JRay; overload;
    function CreateNewFromTo(origin: JVector3; &end: JVector3; world: JMatrix): JRay; overload;
    function Transform(ray: JRay; matrix: JMatrix): JRay;
  end;

  JAxis = class external 'Axis'
    X: JVector3;
    Y: JVector3;
    Z: JVector3;
  end;

  JBezierCurve = class external 'BezierCurve'
    function interpolate(t: Float; x1: Float; y1: Float; x2: Float; y2: Float): Float;
  end;

  JAngle = class external 'Angle'
    _radians: Variant;
    constructor Create(radians: Float);
    degrees: : Float;
    radians: : Float;
    function BetweenTwoPoints(a: JVector2; b: JVector2): JAngle;
    function FromRadians(radians: Float): JAngle;
    function FromDegrees(degrees: Float): JAngle;
  end;

  JArc2 = class external 'Arc2'
    startPoint: JVector2;
    midPoint: JVector2;
    endPoint: JVector2;
    centerPoint: JVector2;
    radius: Float;
    angle: JAngle;
    startAngle: JAngle;
    orientation: JOrientation;
    constructor Create(startPoint: JVector2; midPoint: JVector2; endPoint: JVector2);
  end;

  JPathCursor = class external 'PathCursor'
    path: Variant;
    _onchange: Variant;
    value: Float;
    animations: array of JAnimation;
    constructor Create(path: JPath2);
    function getPoint: JVector3;
    function moveAhead: JPathCursor; overload;
    function moveAhead(step: Float): JPathCursor; overload;
    function moveBack: JPathCursor; overload;
    function moveBack(step: Float): JPathCursor; overload;
    function move(step: Float): JPathCursor;
    procedure ensureLimits;
    procedure markAsDirty(propertyName: Variant);
    procedure raiseOnChange;
    function onchange(f: (cursor: JPathCursor)): JPathCursor;
  end;

  JPath2 = class external 'Path2'
    _points: Variant;
    _length: Variant;
    closed: Boolean;
    constructor Create(x: Float; y: Float);
    function addLineTo(x: Float; y: Float): JPath2;
    function addArcTo(midX: Float; midY: Float; endX: Float; endY: Float): JPath2; overload;
    function addArcTo(midX: Float; midY: Float; endX: Float; endY: Float; numberOfSegments: Float): JPath2; overload;
    function close: JPath2;
    function length: Float;
    function getPoints: array of JVector2;
    function getPointAtLengthPosition(normalizedLengthPosition: Float): JVector2;
    function StartingAt(x: Float; y: Float): JPath2;
  end;

  JPath3D = class external 'Path3D'
    path: array of JVector3;
    _curve: Variant;
    _distances: Variant;
    _tangents: Variant;
    _normals: Variant;
    _binormals: Variant;
    _raw: Variant;
    constructor Create(path: array of JVector3; firstNormal: JVector3; raw: Boolean);
    function getCurve: array of JVector3;
    function getTangents: array of JVector3;
    function getNormals: array of JVector3;
    function getBinormals: array of JVector3;
    function getDistances: array of Float;
    function update(path: array of JVector3): JPath3D; overload;
    function update(path: array of JVector3; firstNormal: JVector3): JPath3D; overload;
    procedure _compute(firstNormal: Variant);
    procedure _getFirstNonNullVector(index: Variant);
    procedure _getLastNonNullVector(index: Variant);
    procedure _normalVector(v0: Variant; vt: Variant; va: Variant);
  end;

  JCurve3 = class external 'Curve3'
    _points: Variant;
    _length: Variant;
    function CreateQuadraticBezier(v0: JVector3; v1: JVector3; v2: JVector3; nbPoints: Float): JCurve3;
    function CreateCubicBezier(v0: JVector3; v1: JVector3; v2: JVector3; v3: JVector3; nbPoints: Float): JCurve3;
    function CreateHermiteSpline(p1: JVector3; t1: JVector3; p2: JVector3; t2: JVector3; nbPoints: Float): JCurve3;
    constructor Create(points: array of JVector3);
    function getPoints: array of JVector3;
    function length: Float;
    function continue(curve: JCurve3): JCurve3;
    procedure _computeLength(path: Variant);
  end;

  JPositionNormalVertex = class external 'PositionNormalVertex'
    position: JVector3;
    normal: JVector3;
    constructor Create(position: JVector3; normal: JVector3);
    function clone: JPositionNormalVertex;
  end;

  JPositionNormalTextureVertex = class external 'PositionNormalTextureVertex'
    position: JVector3;
    normal: JVector3;
    uv: JVector2;
    constructor Create(position: JVector3; normal: JVector3; uv: JVector2);
    function clone: JPositionNormalTextureVertex;
  end;

  JSIMDHelper = class external 'SIMDHelper'
    _isEnabled: Variant;
    IsEnabled: Boolean;
    procedure DisableSIMD;
    procedure EnableSIMD;
  end;

//BABYLON

type
  JAbstractMesh = class external 'AbstractMesh'(JNode)
    _BILLBOARDMODE_NONE: Variant;
    _BILLBOARDMODE_X: Variant;
    _BILLBOARDMODE_Y: Variant;
    _BILLBOARDMODE_Z: Variant;
    _BILLBOARDMODE_ALL: Variant;
    BILLBOARDMODE_NONE: Float;
    BILLBOARDMODE_X: Float;
    BILLBOARDMODE_Y: Float;
    BILLBOARDMODE_Z: Float;
    BILLBOARDMODE_ALL: Float;
    definedFacingForward: Boolean;
    position: JVector3;
    rotation: JVector3;
    rotationQuaternion: JQuaternion;
    scaling: JVector3;
    billboardMode: Float;
    visibility: Float;
    alphaIndex: Float;
    infiniteDistance: Boolean;
    isVisible: Boolean;
    isPickable: Boolean;
    showBoundingBox: Boolean;
    showSubMeshesBoundingBox: Boolean;
    onDispose: Variant;
    isBlocker: Boolean;
    skeleton: JSkeleton;
    renderingGroupId: Float;
    material: JMaterial;
    receiveShadows: Boolean;
    actionManager: JActionManager;
    renderOutline: Boolean;
    outlineColor: JColor3;
    outlineWidth: Float;
    renderOverlay: Boolean;
    overlayColor: JColor3;
    overlayAlpha: Float;
    hasVertexAlpha: Boolean;
    useVertexColors: Boolean;
    applyFog: Boolean;
    computeBonesUsingShaders: Boolean;
    useOctreeForRenderingSelection: Boolean;
    useOctreeForPicking: Boolean;
    useOctreeForCollisions: Boolean;
    layerMask: Float;
    alwaysSelectAsActiveMesh: Boolean;
    _physicImpostor: Float;
    _physicsMass: Float;
    _physicsFriction: Float;
    _physicRestitution: Float;
    _checkCollisions: Variant;
    ellipsoid: JVector3;
    ellipsoidOffset: JVector3;
    _collider: Variant;
    _oldPositionForCollisions: Variant;
    _diffPositionForCollisions: Variant;
    _newPositionForCollisions: Variant;
    onCollide: (collidedMesh: JAbstractMesh);
    _meshToBoneReferal: Variant;
    edgesWidth: Float;
    edgesColor: JColor4;
    _edgesRenderer: JEdgesRenderer;
    _localScaling: Variant;
    _localRotation: Variant;
    _localTranslation: Variant;
    _localBillboard: Variant;
    _localPivotScaling: Variant;
    _localPivotScalingRotation: Variant;
    _localMeshReferalTransform: Variant;
    _localWorld: Variant;
    _worldMatrix: JMatrix;
    _rotateYByPI: Variant;
    _absolutePosition: Variant;
    _collisionsTransformMatrix: Variant;
    _collisionsScalingMatrix: Variant;
    _positions: array of JVector3;
    _isDirty: Variant;
    _masterMesh: JAbstractMesh;
    _boundingInfo: JBoundingInfo;
    _pivotMatrix: Variant;
    _isDisposed: Boolean;
    _renderId: Float;
    subMeshes: array of JSubMesh;
    _submeshesOctree: JOctree{<JSubMesh>};
    _intersectionsInProgress: array of JAbstractMesh;
    _onAfterWorldMatrixUpdate: Variant;
    _isWorldMatrixFrozen: Variant;
    _waitingActions: Variant;
    _waitingFreezeWorldMatrix: Boolean;
    constructor Create(name: String; scene: JScene);
    procedure disableEdgesRendering;
    procedure enableEdgesRendering; overload;
    procedure enableEdgesRendering(epsilon: Float); overload;
    procedure enableEdgesRendering(epsilon: Float; checkVerticesInsteadOfIndices: Boolean); overload;
    isBlocked: Boolean;
    function getLOD(camera: JCamera): JAbstractMesh;
    function getTotalVertices: Float;
    function getIndices: array of Float;
    function getVerticesData(kind: String): array of Float;
    function isVerticesDataPresent(kind: String): Boolean;
    function getBoundingInfo: JBoundingInfo;
    useBones: Boolean;
    procedure _preActivate;
    procedure _activate(renderId: Float);
    function getWorldMatrix: JMatrix;
    worldMatrixFromCache: JMatrix;
    absolutePosition: JVector3;
    procedure freezeWorldMatrix;
    procedure unfreezeWorldMatrix;
    isWorldMatrixFrozen: Boolean;
    procedure rotate(axis: JVector3; amount: Float; space: JSpace);
    procedure translate(axis: JVector3; distance: Float; space: JSpace);
    function getAbsolutePosition: JVector3;
    procedure setAbsolutePosition(absolutePosition: JVector3);
    procedure movePOV(amountRight: Float; amountUp: Float; amountForward: Float);
    function calcMovePOV(amountRight: Float; amountUp: Float; amountForward: Float): JVector3;
    procedure rotatePOV(flipBack: Float; twirlClockwise: Float; tiltRight: Float);
    function calcRotatePOV(flipBack: Float; twirlClockwise: Float; tiltRight: Float): JVector3;
    procedure setPivotMatrix(matrix: JMatrix);
    function getPivotMatrix: JMatrix;
    function _isSynchronized: Boolean;
    procedure _initCache;
    procedure markAsDirty(&property: String);
    procedure _updateBoundingInfo;
    procedure _updateSubMeshesBoundingInfo(matrix: JMatrix);
    function computeWorldMatrix: JMatrix; overload;
    function computeWorldMatrix(force: Boolean): JMatrix; overload;
    procedure registerAfterWorldMatrixUpdate(func: (mesh: JAbstractMesh));
    procedure unregisterAfterWorldMatrixUpdate(func: (mesh: JAbstractMesh));
    procedure setPositionWithLocalVector(vector3: JVector3);
    function getPositionExpressedInLocalSpace: JVector3;
    procedure locallyTranslate(vector3: JVector3);
    procedure lookAt(targetPoint: JVector3; yawCor: Float; pitchCor: Float; rollCor: Float);
    procedure attachToBone(bone: JBone; affectedMesh: JAbstractMesh);
    procedure detachFromBone;
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    function isCompletelyInFrustum: Boolean; overload;
    function isCompletelyInFrustum(camera: JCamera): Boolean; overload;
    function intersectsMesh(mesh: JAbstractMesh): Boolean; overload;
    function intersectsMesh(mesh: JAbstractMesh; precise: Boolean): Boolean; overload;
    function intersectsPoint(point: JVector3): Boolean;
    function setPhysicsState: Variant; overload;
    function setPhysicsState(impostor: Variant): Variant; overload;
    function setPhysicsState(impostor: Variant; options: JPhysicsBodyCreationOptions): Variant; overload;
    function getPhysicsImpostor: Float;
    function getPhysicsMass: Float;
    function getPhysicsFriction: Float;
    function getPhysicsRestitution: Float;
    function getPositionInCameraSpace: JVector3; overload;
    function getPositionInCameraSpace(camera: JCamera): JVector3; overload;
    function getDistanceToCamera: Float; overload;
    function getDistanceToCamera(camera: JCamera): Float; overload;
    procedure applyImpulse(force: JVector3; contactPoint: JVector3);
    procedure setPhysicsLinkWith(otherMesh: JMesh; pivot1: JVector3; pivot2: JVector3); overload;
    procedure setPhysicsLinkWith(otherMesh: JMesh; pivot1: JVector3; pivot2: JVector3; options: Variant); overload;
    procedure updatePhysicsBodyPosition;
    checkCollisions: Boolean;
    procedure moveWithCollisions(velocity: JVector3);
    _onCollisionPositionChange: Variant;
    function createOrUpdateSubmeshesOctree: JOctree{<JSubMesh>}; overload;
    function createOrUpdateSubmeshesOctree(maxCapacity: Float): JOctree{<JSubMesh>}; overload;
    function createOrUpdateSubmeshesOctree(maxCapacity: Float; maxDepth: Float): JOctree{<JSubMesh>}; overload;
    procedure _collideForSubMesh(subMesh: JSubMesh; transformMatrix: JMatrix; collider: JCollider);
    procedure _processCollisionsForSubMeshes(collider: JCollider; transformMatrix: JMatrix);
    procedure _checkCollision(collider: JCollider);
    function _generatePointsArray: Boolean;
    function intersects(ray: JRay): JPickingInfo; overload;
    function intersects(ray: JRay; fastCheck: Boolean): JPickingInfo; overload;
    function clone(name: String; newParent: JNode): JAbstractMesh; overload;
    function clone(name: String; newParent: JNode; doNotCloneChildren: Boolean): JAbstractMesh; overload;
    procedure releaseSubMeshes;
    procedure dispose; overload;
    procedure dispose(doNotRecurse: Boolean); overload;
  end;

//BABYLON

type
  JCSG = class external 'CSG'
    polygons: Variant;
    matrix: JMatrix;
    position: JVector3;
    rotation: JVector3;
    rotationQuaternion: JQuaternion;
    scaling: JVector3;
    function FromMesh(mesh: JMesh): JCSG;
    procedure FromPolygons(polygons: Variant);
    function clone: JCSG;
    procedure toPolygons;
    function union(csg: JCSG): JCSG;
    procedure unionInPlace(csg: JCSG);
    function subtract(csg: JCSG): JCSG;
    procedure subtractInPlace(csg: JCSG);
    function intersect(csg: JCSG): JCSG;
    procedure intersectInPlace(csg: JCSG);
    function inverse: JCSG;
    procedure inverseInPlace;
    function copyTransformAttributes(csg: JCSG): JCSG;
    function buildMeshGeometry(name: String; scene: JScene; keepSubMeshes: Boolean): JMesh;
    function toMesh(name: String; material: JMaterial; scene: JScene; keepSubMeshes: Boolean): JMesh;
  end;

//BABYLON

type
  JGeometry = class external 'Geometry'
    id: String;
    delayLoadState: Float;
    delayLoadingFile: String;
    onGeometryUpdated: (geometry: JGeometry; kind: String);
    _scene: Variant;
    _engine: Variant;
    _meshes: Variant;
    _totalVertices: Variant;
    _indices: Variant;
    _vertexBuffers: Variant;
    _isDisposed: Variant;
    _delayInfo: Variant;
    _indexBuffer: Variant;
    _boundingInfo: JBoundingInfo;
    _delayLoadingFunction: (any: Variant; geometry: JGeometry);
    constructor Create(id: String; scene: JScene; vertexData: JVertexData; updatable: Boolean; mesh: JMesh);
    function getScene: JScene;
    function getEngine: JEngine;
    function isReady: Boolean;
    procedure setAllVerticesData(vertexData: JVertexData); overload;
    procedure setAllVerticesData(vertexData: JVertexData; updatable: Boolean); overload;
    procedure setVerticesData(kind: String; data: array of Float); overload;
    procedure setVerticesData(kind: String; data: array of Float; updatable: Boolean); overload;
    procedure setVerticesData(kind: String; data: array of Float; updatable: Boolean; stride: Float); overload;
    procedure updateVerticesDataDirectly(kind: String; data: JFloat32Array; offset: Float);
    procedure updateVerticesData(kind: String; data: array of Float); overload;
    procedure updateVerticesData(kind: String; data: array of Float; updateExtends: Boolean); overload;
    function getTotalVertices: Float;
    function getVerticesData(kind: String): array of Float; overload;
    function getVerticesData(kind: String; copyWhenShared: Boolean): array of Float; overload;
    function getVertexBuffer(kind: String): JVertexBuffer;
    function getVertexBuffers: array of JVertexBuffer;
    function isVerticesDataPresent(kind: String): Boolean;
    function getVerticesDataKinds: array of String;
    procedure setIndices(indices: array of Float); overload;
    procedure setIndices(indices: array of Float; totalVertices: Float); overload;
    function getTotalIndices: Float;
    function getIndices: array of Float; overload;
    function getIndices(copyWhenShared: Boolean): array of Float; overload;
    function getIndexBuffer: Variant;
    procedure releaseForMesh(mesh: JMesh); overload;
    procedure releaseForMesh(mesh: JMesh; shouldDispose: Boolean); overload;
    procedure applyToMesh(mesh: JMesh);
    procedure _applyToMesh(mesh: Variant);
    procedure notifyUpdate; overload;
    procedure notifyUpdate(kind: Variant); overload;
    procedure load(scene: JScene); overload;
    procedure load(scene: JScene; onLoaded: ); overload;
    function isDisposed: Boolean;
    procedure dispose;
    function copy(id: String): JGeometry;
    function ExtractFromMesh(mesh: JMesh; id: String): JGeometry;
    function RandomId: String;
  end;

//Geometry.Primitives

type
  J_Primitive = class external '_Primitive'(JGeometry)
    _beingRegenerated: Variant;
    _canBeRegenerated: Variant;
    constructor Create(id: String; scene: JScene; vertexData: JVertexData; canBeRegenerated: Boolean; mesh: JMesh);
    function canBeRegenerated: Boolean;
    procedure regenerate;
    function asNewGeometry(id: String): JGeometry;
    procedure setAllVerticesData(vertexData: JVertexData); overload;
    procedure setAllVerticesData(vertexData: JVertexData; updatable: Boolean); overload;
    procedure setVerticesData(kind: String; data: array of Float); overload;
    procedure setVerticesData(kind: String; data: array of Float; updatable: Boolean); overload;
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JRibbon = class external 'Ribbon'(J_Primitive)
    pathArray: array of array of JVector3;
    closeArray: Boolean;
    closePath: Boolean;
    offset: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JBox = class external 'Box'(J_Primitive)
    size: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; size: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JSphere = class external 'Sphere'(J_Primitive)
    segments: Float;
    diameter: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; segments: Float; diameter: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JCylinder = class external 'Cylinder'(J_Primitive)
    height: Float;
    diameterTop: Float;
    diameterBottom: Float;
    tessellation: Float;
    subdivisions: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JTorus = class external 'Torus'(J_Primitive)
    diameter: Float;
    thickness: Float;
    tessellation: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; diameter: Float; thickness: Float; tessellation: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JGround = class external 'Ground'(J_Primitive)
    width: Float;
    height: Float;
    subdivisions: Float;
    constructor Create(id: String; scene: JScene; width: Float; height: Float; subdivisions: Float; canBeRegenerated: Boolean; mesh: JMesh);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JTiledGround = class external 'TiledGround'(J_Primitive)
    xmin: Float;
    zmin: Float;
    xmax: Float;
    zmax: Float;
    subdivisions:       w: Float;
      h: Float;
    end;;
    precision:       w: Float;
      h: Float;
    end;;
    constructor Create(id: String; scene: JScene; xmin: Float; zmin: Float; xmax: Float; zmax: Float; subdivisions:       w: Float;
      h: Float;
    end;; precision:       w: Float;
      h: Float;
    end;; canBeRegenerated: Boolean; mesh: JMesh);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JPlane = class external 'Plane'(J_Primitive)
    size: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; size: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

  JTorusKnot = class external 'TorusKnot'(J_Primitive)
    radius: Float;
    tube: Float;
    radialSegments: Float;
    tubularSegments: Float;
    p: Float;
    q: Float;
    side: Float;
    constructor Create(id: String; scene: JScene; radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float; canBeRegenerated: Boolean; mesh: JMesh; side: Float);
    function _regenerateVertexData: JVertexData;
    function copy(id: String): JGeometry;
  end;

//BABYLON

type
  JGroundMesh = class external 'GroundMesh'(JMesh)
    generateOctree: Boolean;
    _worldInverse: Variant;
    _subdivisions: Float;
    constructor Create(name: String; scene: JScene);
    subdivisions: Float;
    procedure optimize(chunksCount: Float); overload;
    procedure optimize(chunksCount: Float; octreeBlocksSize: Float); overload;
    function getHeightAtCoordinates(x: Float; z: Float): Float;
  end;

//BABYLON

type
  JInstancedMesh = class external 'InstancedMesh'(JAbstractMesh)
    _sourceMesh: Variant;
    _currentLOD: Variant;
    constructor Create(name: String; source: JMesh);
    receiveShadows: Boolean;
    material: JMaterial;
    visibility: Float;
    skeleton: JSkeleton;
    function getTotalVertices: Float;
    sourceMesh: JMesh;
    function getVerticesData(kind: String): array of Float;
    function isVerticesDataPresent(kind: String): Boolean;
    function getIndices: array of Float;
    _positions: array of JVector3;
    procedure refreshBoundingInfo;
    procedure _preActivate;
    procedure _activate(renderId: Float);
    function getLOD(camera: JCamera): JAbstractMesh;
    procedure _syncSubMeshes;
    function _generatePointsArray: Boolean;
    function clone(name: String; newParent: JNode): JInstancedMesh; overload;
    function clone(name: String; newParent: JNode; doNotCloneChildren: Boolean): JInstancedMesh; overload;
    procedure dispose; overload;
    procedure dispose(doNotRecurse: Boolean); overload;
  end;

//BABYLON

type
  JLinesMesh = class external 'LinesMesh'(JMesh)
    color: JColor3;
    alpha: Float;
    _colorShader: Variant;
    constructor Create(name: String; scene: JScene; parent: JNode; source: JMesh; doNotCloneChildren: Boolean);
    material: JMaterial;
    isPickable: Boolean;
    checkCollisions: Boolean;
    procedure _bind(subMesh: JSubMesh; effect: JEffect; fillMode: Float);
    procedure _draw(subMesh: JSubMesh; fillMode: Float); overload;
    procedure _draw(subMesh: JSubMesh; fillMode: Float; instancesCount: Float); overload;
    function intersects(ray: JRay): Variant; overload;
    function intersects(ray: JRay; fastCheck: Boolean): Variant; overload;
    procedure dispose; overload;
    procedure dispose(doNotRecurse: Boolean); overload;
    function clone(name: String): JLinesMesh; overload;
    function clone(name: String; newParent: JNode): JLinesMesh; overload;
    function clone(name: String; newParent: JNode; doNotCloneChildren: Boolean): JLinesMesh; overload;
  end;

//BABYLON

type
  J_InstancesBatch = class external '_InstancesBatch'
    mustReturn: Boolean;
    visibleInstances: array of array of JInstancedMesh;
    renderSelf: array of Boolean;
  end;

  JMesh = class external 'Mesh'(JAbstractMesh)
    _FRONTSIDE: Float;
    _BACKSIDE: Float;
    _DOUBLESIDE: Float;
    _DEFAULTSIDE: Float;
    _NO_CAP: Float;
    _CAP_START: Float;
    _CAP_END: Float;
    _CAP_ALL: Float;
    FRONTSIDE: Float;
    BACKSIDE: Float;
    DOUBLESIDE: Float;
    DEFAULTSIDE: Float;
    NO_CAP: Float;
    CAP_START: Float;
    CAP_END: Float;
    CAP_ALL: Float;
    delayLoadState: Float;
    instances: array of JInstancedMesh;
    delayLoadingFile: String;
    _binaryInfo: Variant;
    _LODLevels: Variant;
    onLODLevelSelection: (distance: Float; mesh: JMesh; selectedLevel: JMesh);
    _geometry: JGeometry;
    _onBeforeRenderCallbacks: Variant;
    _onAfterRenderCallbacks: Variant;
    _delayInfo: Variant;
    _delayLoadingFunction: (any: Variant; mesh: JMesh);
    _visibleInstances: Variant;
    _renderIdForInstances: Variant;
    _batchCache: Variant;
    _worldMatricesInstancesBuffer: Variant;
    _worldMatricesInstancesArray: Variant;
    _instancesBufferSize: Variant;
    _shouldGenerateFlatShading: Boolean;
    _preActivateId: Variant;
    _sideOrientation: Variant;
    _areNormalsFrozen: Variant;
    _sourcePositions: Variant;
    _sourceNormals: Variant;
    constructor Create(name: String; scene: JScene; parent: JNode; source: JMesh; doNotCloneChildren: Boolean);
    hasLODLevels: Boolean;
    procedure _sortLODLevels;
    function addLODLevel(distance: Float; mesh: JMesh): JMesh;
    function getLODLevelAtDistance(distance: Float): JMesh;
    function removeLODLevel(mesh: JMesh): JMesh;
    function getLOD(camera: JCamera): JAbstractMesh; overload;
    function getLOD(camera: JCamera; boundingSphere: JBoundingSphere): JAbstractMesh; overload;
    geometry: JGeometry;
    function getTotalVertices: Float;
    function getVerticesData(kind: String): array of Float; overload;
    function getVerticesData(kind: String; copyWhenShared: Boolean): array of Float; overload;
    function getVertexBuffer(kind: Variant): JVertexBuffer;
    function isVerticesDataPresent(kind: String): Boolean;
    function getVerticesDataKinds: array of String;
    function getTotalIndices: Float;
    function getIndices: array of Float; overload;
    function getIndices(copyWhenShared: Boolean): array of Float; overload;
    isBlocked: Boolean;
    function isReady: Boolean;
    function isDisposed: Boolean;
    sideOrientation: Float;
    areNormalsFrozen: Boolean;
    procedure freezeNormals;
    procedure unfreezeNormals;
    procedure _preActivate;
    procedure _registerInstanceForRenderId(instance: JInstancedMesh; renderId: Float);
    procedure refreshBoundingInfo;
    function _createGlobalSubMesh: JSubMesh;
    procedure subdivide(count: Float);
    procedure setVerticesData(kind: Variant; data: Variant); overload;
    procedure setVerticesData(kind: Variant; data: Variant; updatable: Boolean); overload;
    procedure setVerticesData(kind: Variant; data: Variant; updatable: Boolean; stride: Float); overload;
    procedure updateVerticesData(kind: String; data: array of Float); overload;
    procedure updateVerticesData(kind: String; data: array of Float; updateExtends: Boolean); overload;
    procedure updateVerticesData(kind: String; data: array of Float; updateExtends: Boolean; makeItUnique: Boolean); overload;
    procedure updateVerticesDataDirectly(kind: String; data: JFloat32Array); overload;
    procedure updateVerticesDataDirectly(kind: String; data: JFloat32Array; offset: Float); overload;
    procedure updateVerticesDataDirectly(kind: String; data: JFloat32Array; offset: Float; makeItUnique: Boolean); overload;
    procedure updateMeshPositions(positionFunction: Variant); overload;
    procedure updateMeshPositions(positionFunction: Variant; computeNormals: Boolean); overload;
    procedure makeGeometryUnique;
    procedure setIndices(indices: array of Float); overload;
    procedure setIndices(indices: array of Float; totalVertices: Float); overload;
    procedure _bind(subMesh: JSubMesh; effect: JEffect; fillMode: Float);
    procedure _draw(subMesh: JSubMesh; fillMode: Float); overload;
    procedure _draw(subMesh: JSubMesh; fillMode: Float; instancesCount: Float); overload;
    procedure registerBeforeRender(func: (mesh: JAbstractMesh));
    procedure unregisterBeforeRender(func: (mesh: JAbstractMesh));
    procedure registerAfterRender(func: (mesh: JAbstractMesh));
    procedure unregisterAfterRender(func: (mesh: JAbstractMesh));
    function _getInstancesRenderList(subMeshId: Float): J_InstancesBatch;
    procedure _renderWithInstances(subMesh: JSubMesh; fillMode: Float; batch: J_InstancesBatch; effect: JEffect; engine: JEngine);
    procedure _processRendering(subMesh: JSubMesh; effect: JEffect; fillMode: Float; batch: J_InstancesBatch; hardwareInstancedRendering: Boolean; onBeforeDraw: (isInstance: Boolean; world: JMatrix));
    procedure render(subMesh: JSubMesh; enableAlphaMode: Boolean);
    function getEmittedParticleSystems: array of JParticleSystem;
    function getHierarchyEmittedParticleSystems: array of JParticleSystem;
    function getChildren: array of JNode;
    procedure _checkDelayState;
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    procedure setMaterialByID(id: String);
    function getAnimatables: array of JIAnimatable;
    procedure bakeTransformIntoVertices(transform: JMatrix);
    procedure bakeCurrentTransformIntoVertices;
    procedure _resetPointsArrayCache;
    function _generatePointsArray: Boolean;
    function clone(name: String): JMesh; overload;
    function clone(name: String; newParent: JNode): JMesh; overload;
    function clone(name: String; newParent: JNode; doNotCloneChildren: Boolean): JMesh; overload;
    procedure dispose; overload;
    procedure dispose(doNotRecurse: Boolean); overload;
    procedure applyDisplacementMap(url: String; minHeight: Float; maxHeight: Float); overload;
    procedure applyDisplacementMap(url: String; minHeight: Float; maxHeight: Float; onSuccess: (mesh: JMesh)); overload;
    procedure applyDisplacementMapFromBuffer(buffer: JUint8Array; heightMapWidth: Float; heightMapHeight: Float; minHeight: Float; maxHeight: Float);
    procedure convertToFlatShadedMesh;
    procedure flipFaces; overload;
    procedure flipFaces(flipNormals: Boolean); overload;
    function createInstance(name: String): JInstancedMesh;
    procedure synchronizeInstances;
    procedure simplify(settings: JArray{<JISimplificationSettings>}); overload;
    procedure simplify(settings: JArray{<JISimplificationSettings>}; parallelProcessing: Boolean); overload;
    procedure simplify(settings: JArray{<JISimplificationSettings>}; parallelProcessing: Boolean; simplificationType: JSimplificationType); overload;
    procedure simplify(settings: JArray{<JISimplificationSettings>}; parallelProcessing: Boolean; simplificationType: JSimplificationType; successCallback: (mesh: JMesh; submeshIndex: Float)); overload;
    procedure optimizeIndices; overload;
    procedure optimizeIndices(successCallback: (mesh: JMesh)); overload;
    function CreateRibbon(name: String; pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; scene: JScene): JMesh; overload;
    function CreateRibbon(name: String; pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateRibbon(name: String; pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateRibbon(name: String; pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; scene: JScene; updatable: Boolean; sideOrientation: Float; ribbonInstance: JMesh): JMesh; overload;
    function CreateDisc(name: String; radius: Float; tessellation: Float; scene: JScene): JMesh; overload;
    function CreateDisc(name: String; radius: Float; tessellation: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateDisc(name: String; radius: Float; tessellation: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateBox(name: String; size: Float; scene: JScene): JMesh; overload;
    function CreateBox(name: String; size: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateBox(name: String; size: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateBox(name: String; options:       width: Float; // nullable
      height: Float; // nullable
      depth: Float; // nullable
      faceUV: array of JVector4; // nullable
      faceColors: array of JColor4; // nullable
      sideOrientation: Float; // nullable
      updatable: Boolean; // nullable
    end;; scene: JScene): JMesh;
    function CreateSphere(name: String; segments: Float; diameter: Float): JMesh; overload;
    function CreateSphere(name: String; segments: Float; diameter: Float; scene: JScene): JMesh; overload;
    function CreateSphere(name: String; segments: Float; diameter: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateSphere(name: String; segments: Float; diameter: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateSphere(name: String; options:       segments: Float; // nullable
      diameterX: Float; // nullable
      diameterY: Float; // nullable
      diameterZ: Float; // nullable
      sideOrientation: Float; // nullable
      updatable: Boolean; // nullable
    end;; scene: Variant): JMesh;
    function CreateCylinder(name: String; height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Variant; scene: JScene): JMesh; overload;
    function CreateCylinder(name: String; height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Variant; scene: JScene; updatable: Variant): JMesh; overload;
    function CreateCylinder(name: String; height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Variant; scene: JScene; updatable: Variant; sideOrientation: Float): JMesh; overload;
    function CreateTorus(name: String; diameter: Float; thickness: Float; tessellation: Float; scene: JScene): JMesh; overload;
    function CreateTorus(name: String; diameter: Float; thickness: Float; tessellation: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateTorus(name: String; diameter: Float; thickness: Float; tessellation: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateTorusKnot(name: String; radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float; scene: JScene): JMesh; overload;
    function CreateTorusKnot(name: String; radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateTorusKnot(name: String; radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateLines(name: String; points: array of JVector3; scene: JScene): JLinesMesh; overload;
    function CreateLines(name: String; points: array of JVector3; scene: JScene; updatable: Boolean): JLinesMesh; overload;
    function CreateLines(name: String; points: array of JVector3; scene: JScene; updatable: Boolean; linesInstance: JLinesMesh): JLinesMesh; overload;
    function CreateDashedLines(name: String; points: array of JVector3; dashSize: Float; gapSize: Float; dashNb: Float; scene: JScene): JLinesMesh; overload;
    function CreateDashedLines(name: String; points: array of JVector3; dashSize: Float; gapSize: Float; dashNb: Float; scene: JScene; updatable: Boolean): JLinesMesh; overload;
    function CreateDashedLines(name: String; points: array of JVector3; dashSize: Float; gapSize: Float; dashNb: Float; scene: JScene; updatable: Boolean; linesInstance: JLinesMesh): JLinesMesh; overload;
    function ExtrudeShape(name: String; shape: array of JVector3; path: array of JVector3; scale: Float; rotation: Float; cap: Float; scene: JScene): JMesh; overload;
    function ExtrudeShape(name: String; shape: array of JVector3; path: array of JVector3; scale: Float; rotation: Float; cap: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function ExtrudeShape(name: String; shape: array of JVector3; path: array of JVector3; scale: Float; rotation: Float; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function ExtrudeShape(name: String; shape: array of JVector3; path: array of JVector3; scale: Float; rotation: Float; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float; extrudedInstance: JMesh): JMesh; overload;
    function ExtrudeShapeCustom(name: String; shape: array of JVector3; path: array of JVector3; scaleFunction: Variant; rotationFunction: Variant; ribbonCloseArray: Boolean; ribbonClosePath: Boolean; cap: Float; scene: JScene): JMesh; overload;
    function ExtrudeShapeCustom(name: String; shape: array of JVector3; path: array of JVector3; scaleFunction: Variant; rotationFunction: Variant; ribbonCloseArray: Boolean; ribbonClosePath: Boolean; cap: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function ExtrudeShapeCustom(name: String; shape: array of JVector3; path: array of JVector3; scaleFunction: Variant; rotationFunction: Variant; ribbonCloseArray: Boolean; ribbonClosePath: Boolean; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function ExtrudeShapeCustom(name: String; shape: array of JVector3; path: array of JVector3; scaleFunction: Variant; rotationFunction: Variant; ribbonCloseArray: Boolean; ribbonClosePath: Boolean; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float; extrudedInstance: JMesh): JMesh; overload;
    procedure _ExtrudeShapeGeneric(name: Variant; shape: Variant; curve: Variant; scale: Variant; rotation: Variant; scaleFunction: Variant; rotateFunction: Variant; rbCA: Variant; rbCP: Variant; cap: Variant; custom: Variant; scene: Variant; updtbl: Variant; side: Variant; instance: Variant);
    function CreateLathe(name: String; shape: array of JVector3; radius: Float; tessellation: Float; scene: JScene): JMesh; overload;
    function CreateLathe(name: String; shape: array of JVector3; radius: Float; tessellation: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateLathe(name: String; shape: array of JVector3; radius: Float; tessellation: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreatePlane(name: String; size: Float; scene: JScene): JMesh; overload;
    function CreatePlane(name: String; size: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreatePlane(name: String; size: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreatePlane(name: String; options:       width: Float; // nullable
      height: Float; // nullable
      sideOrientation: Float; // nullable
      updatable: Boolean; // nullable
    end;; scene: JScene): JMesh;
    function CreateGround(name: String; width: Float; height: Float; subdivisions: Float; scene: JScene): JMesh; overload;
    function CreateGround(name: String; width: Float; height: Float; subdivisions: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateGround(name: String; options:       width: Float; // nullable
      height: Float; // nullable
      subdivisions: Float; // nullable
      sideOrientation: Float; // nullable
      updatable: Boolean; // nullable
    end;; scene: Variant): JMesh;
    function CreateTiledGround(name: String; xmin: Float; zmin: Float; xmax: Float; zmax: Float; subdivisions:       w: Float;
      h: Float;
    end;; precision:       w: Float;
      h: Float;
    end;; scene: JScene): JMesh; overload;
    function CreateTiledGround(name: String; xmin: Float; zmin: Float; xmax: Float; zmax: Float; subdivisions:       w: Float;
      h: Float;
    end;; precision:       w: Float;
      h: Float;
    end;; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateGroundFromHeightMap(name: String; url: String; width: Float; height: Float; subdivisions: Float; minHeight: Float; maxHeight: Float; scene: JScene): JGroundMesh; overload;
    function CreateGroundFromHeightMap(name: String; url: String; width: Float; height: Float; subdivisions: Float; minHeight: Float; maxHeight: Float; scene: JScene; updatable: Boolean): JGroundMesh; overload;
    function CreateGroundFromHeightMap(name: String; url: String; width: Float; height: Float; subdivisions: Float; minHeight: Float; maxHeight: Float; scene: JScene; updatable: Boolean; onReady: (mesh: JGroundMesh)): JGroundMesh; overload;
    function CreateTube(name: String; path: array of JVector3; radius: Float; tessellation: Float; radiusFunction: (i: Float; distance: Float): Float    end;; cap: Float; scene: JScene): JMesh; overload;
    function CreateTube(name: String; path: array of JVector3; radius: Float; tessellation: Float; radiusFunction: (i: Float; distance: Float): Float    end;; cap: Float; scene: JScene; updatable: Boolean): JMesh; overload;
    function CreateTube(name: String; path: array of JVector3; radius: Float; tessellation: Float; radiusFunction: (i: Float; distance: Float): Float    end;; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float): JMesh; overload;
    function CreateTube(name: String; path: array of JVector3; radius: Float; tessellation: Float; radiusFunction: (i: Float; distance: Float): Float    end;; cap: Float; scene: JScene; updatable: Boolean; sideOrientation: Float; tubeInstance: JMesh): JMesh; overload;
    function CreateDecal(name: String; sourceMesh: JAbstractMesh; position: JVector3; normal: JVector3; size: JVector3): JMesh; overload;
    function CreateDecal(name: String; sourceMesh: JAbstractMesh; position: JVector3; normal: JVector3; size: JVector3; angle: Float): JMesh; overload;
    function applySkeleton(skeleton: JSkeleton): JMesh;
    function MinMax(meshes: array of JAbstractMesh):       min: JVector3;
      max: JVector3;
    end;;
    function Center(meshesOrMinMaxVector: Variant): JVector3;
    function MergeMeshes(meshes: JArray{<JMesh>}): JMesh; overload;
    function MergeMeshes(meshes: JArray{<JMesh>}; disposeSource: Boolean): JMesh; overload;
    function MergeMeshes(meshes: JArray{<JMesh>}; disposeSource: Boolean; allow32BitsIndices: Boolean): JMesh; overload;
    function MergeMeshes(meshes: JArray{<JMesh>}; disposeSource: Boolean; allow32BitsIndices: Boolean; meshSubclass: JMesh): JMesh; overload;
  end;

//BABYLON

type
  JVertexData = class external 'VertexData'
    positions: array of Float;
    normals: array of Float;
    uvs: array of Float;
    uvs2: array of Float;
    uvs3: array of Float;
    uvs4: array of Float;
    uvs5: array of Float;
    uvs6: array of Float;
    colors: array of Float;
    matricesIndices: array of Float;
    matricesWeights: array of Float;
    indices: array of Float;
    procedure set(data: array of Float; kind: String);
    procedure applyToMesh(mesh: JMesh); overload;
    procedure applyToMesh(mesh: JMesh; updatable: Boolean); overload;
    procedure applyToGeometry(geometry: JGeometry); overload;
    procedure applyToGeometry(geometry: JGeometry; updatable: Boolean); overload;
    procedure updateMesh(mesh: JMesh); overload;
    procedure updateMesh(mesh: JMesh; updateExtends: Boolean); overload;
    procedure updateMesh(mesh: JMesh; updateExtends: Boolean; makeItUnique: Boolean); overload;
    procedure updateGeometry(geometry: JGeometry); overload;
    procedure updateGeometry(geometry: JGeometry; updateExtends: Boolean); overload;
    procedure updateGeometry(geometry: JGeometry; updateExtends: Boolean; makeItUnique: Boolean); overload;
    procedure _applyTo(meshOrGeometry: Variant); overload;
    procedure _applyTo(meshOrGeometry: Variant; updatable: Variant); overload;
    procedure _update(meshOrGeometry: Variant); overload;
    procedure _update(meshOrGeometry: Variant; updateExtends: Variant); overload;
    procedure _update(meshOrGeometry: Variant; updateExtends: Variant; makeItUnique: Variant); overload;
    procedure transform(matrix: JMatrix);
    procedure merge(other: JVertexData);
    function ExtractFromMesh(mesh: JMesh): JVertexData; overload;
    function ExtractFromMesh(mesh: JMesh; copyWhenShared: Boolean): JVertexData; overload;
    function ExtractFromGeometry(geometry: JGeometry): JVertexData; overload;
    function ExtractFromGeometry(geometry: JGeometry; copyWhenShared: Boolean): JVertexData; overload;
    procedure _ExtractFrom(meshOrGeometry: Variant); overload;
    procedure _ExtractFrom(meshOrGeometry: Variant; copyWhenShared: Variant); overload;
    function CreateRibbon(pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float): JVertexData; overload;
    function CreateRibbon(pathArray: array of array of JVector3; closeArray: Boolean; closePath: Boolean; offset: Float; sideOrientation: Float): JVertexData; overload;
    function CreateBox(options:       width: Float; // nullable
      height: Float; // nullable
      depth: Float; // nullable
      faceUV: array of JVector4; // nullable
      faceColors: array of JColor4; // nullable
      sideOrientation: Float; // nullable
    end;): JVertexData;
    function CreateBox(size: Float): JVertexData; overload;
    function CreateBox(size: Float; sideOrientation: Float): JVertexData; overload;
    function CreateSphere(options:       segments: Float; // nullable
      diameterX: Float; // nullable
      diameterY: Float; // nullable
      diameterZ: Float; // nullable
      sideOrientation: Float; // nullable
    end;): JVertexData;
    function CreateSphere(segments: Float): JVertexData; overload;
    function CreateSphere(segments: Float; diameter: Float): JVertexData; overload;
    function CreateSphere(segments: Float; diameter: Float; sideOrientation: Float): JVertexData; overload;
    function CreateCylinder(height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float): JVertexData; overload;
    function CreateCylinder(height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Float): JVertexData; overload;
    function CreateCylinder(height: Float; diameterTop: Float; diameterBottom: Float; tessellation: Float; subdivisions: Float; sideOrientation: Float): JVertexData; overload;
    function CreateTorus(diameter: Variant; thickness: Variant; tessellation: Variant): JVertexData; overload;
    function CreateTorus(diameter: Variant; thickness: Variant; tessellation: Variant; sideOrientation: Float): JVertexData; overload;
    function CreateLines(points: array of JVector3): JVertexData;
    function CreateDashedLines(points: array of JVector3; dashSize: Float; gapSize: Float; dashNb: Float): JVertexData;
    function CreateGround(options:       width: Float; // nullable
      height: Float; // nullable
      subdivisions: Float; // nullable
      sideOrientation: Float; // nullable
    end;): JVertexData;
    function CreateGround(width: Float; height: Float): JVertexData; overload;
    function CreateGround(width: Float; height: Float; subdivisions: Float): JVertexData; overload;
    function CreateTiledGround(xmin: Float; zmin: Float; xmax: Float; zmax: Float): JVertexData; overload;
    function CreateTiledGround(xmin: Float; zmin: Float; xmax: Float; zmax: Float; subdivisions:       w: Float;
      h: Float;
    end;): JVertexData; overload;
    function CreateTiledGround(xmin: Float; zmin: Float; xmax: Float; zmax: Float; subdivisions:       w: Float;
      h: Float;
    end;; precision:       w: Float;
      h: Float;
    end;): JVertexData; overload;
    function CreateGroundFromHeightMap(width: Float; height: Float; subdivisions: Float; minHeight: Float; maxHeight: Float; buffer: JUint8Array; bufferWidth: Float; bufferHeight: Float): JVertexData;
    function CreatePlane(options:       width: Float; // nullable
      height: Float; // nullable
      sideOrientation: Float; // nullable
    end;): JVertexData;
    function CreatePlane(size: Float): JVertexData; overload;
    function CreatePlane(size: Float; sideOrientation: Float): JVertexData; overload;
    function CreateDisc(radius: Float; tessellation: Float): JVertexData; overload;
    function CreateDisc(radius: Float; tessellation: Float; sideOrientation: Float): JVertexData; overload;
    function CreateTorusKnot(radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float): JVertexData; overload;
    function CreateTorusKnot(radius: Float; tube: Float; radialSegments: Float; tubularSegments: Float; p: Float; q: Float; sideOrientation: Float): JVertexData; overload;
    procedure ComputeNormals(positions: Variant; indices: Variant; normals: Variant);
    procedure _ComputeSides(sideOrientation: Variant; positions: Variant; indices: Variant; normals: Variant; uvs: Variant);
  end;

  JIGetSetVerticesData = class external
    function isVerticesDataPresent(kind: String): Boolean;
    function getVerticesData(kind: String): array of Float; overload;
    function getVerticesData(kind: String; copyWhenShared: Boolean): array of Float; overload;
    function getIndices: array of Float; overload;
    function getIndices(copyWhenShared: Boolean): array of Float; overload;
    procedure setVerticesData(kind: String; data: array of Float); overload;
    procedure setVerticesData(kind: String; data: array of Float; updatable: Boolean); overload;
    procedure updateVerticesData(kind: String; data: array of Float); overload;
    procedure updateVerticesData(kind: String; data: array of Float; updateExtends: Boolean); overload;
    procedure updateVerticesData(kind: String; data: array of Float; updateExtends: Boolean; makeItUnique: Boolean); overload;
    procedure setIndices(indices: array of Float);
  end;

//BABYLON.Internals

type
  JMeshLODLevel = class external 'MeshLODLevel'
    distance: Float;
    mesh: JMesh;
    constructor Create(distance: Float; mesh: JMesh);
  end;

//BABYLON

type
  JSimplificationSettings = class external 'SimplificationSettings'
    quality: Float;
    distance: Float;
    optimizeMesh: Boolean;
    constructor Create(quality: Float; distance: Float; optimizeMesh: Boolean);
  end;

  JSimplificationQueue = class external 'SimplificationQueue'
    _simplificationArray: Variant;
    running: Variant;
    constructor Create;
    procedure addTask(task: JISimplificationTask);
    procedure executeNext;
    procedure runSimplification(task: JISimplificationTask);
    procedure getSimplifier(task: Variant);
  end;

  JDecimationTriangle = class external 'DecimationTriangle'
    vertices: JArray{<JDecimationVertex>};
    normal: JVector3;
    error: JArray{<Float>};
    deleted: Boolean;
    isDirty: Boolean;
    borderFactor: Float;
    deletePending: Boolean;
    originalOffset: Float;
    constructor Create(vertices: JArray{<JDecimationVertex>});
  end;

  JDecimationVertex = class external 'DecimationVertex'
    position: JVector3;
    id: Variant;
    q: JQuadraticMatrix;
    isBorder: Boolean;
    triangleStart: Float;
    triangleCount: Float;
    originalOffsets: JArray{<Float>};
    constructor Create(position: JVector3; id: Variant);
    procedure updatePosition(newPosition: JVector3);
  end;

  JQuadraticMatrix = class external 'QuadraticMatrix'
    data: JArray{<Float>};
    constructor Create(data: JArray{<Float>});
    function det(a11: Variant; a12: Variant; a13: Variant; a21: Variant; a22: Variant; a23: Variant; a31: Variant; a32: Variant; a33: Variant): Float;
    procedure addInPlace(matrix: JQuadraticMatrix);
    procedure addArrayInPlace(data: JArray{<Float>});
    function add(matrix: JQuadraticMatrix): JQuadraticMatrix;
    function FromData(a: Float; b: Float; c: Float; d: Float): JQuadraticMatrix;
    function DataFromNumbers(a: Float; b: Float; c: Float; d: Float): array of Float;
  end;

  JReference = class external 'Reference'
    vertexId: Float;
    triangleId: Float;
    constructor Create(vertexId: Float; triangleId: Float);
  end;

  JQuadraticErrorSimplification = class external 'QuadraticErrorSimplification'
    _mesh: Variant;
    triangles: Variant;
    vertices: Variant;
    references: Variant;
    initialized: Variant;
    _reconstructedMesh: Variant;
    syncIterations: Float;
    aggressiveness: Float;
    decimationIterations: Float;
    boundingBoxEpsilon: Float;
    constructor Create(_mesh: JMesh);
    procedure simplify(settings: JISimplificationSettings; successCallback: (simplifiedMesh: JMesh));
    procedure isTriangleOnBoundingBox(triangle: Variant);
    procedure runDecimation(settings: Variant; submeshIndex: Variant; successCallback: Variant);
    procedure initWithMesh(submeshIndex: Variant; callback: Variant); overload;
    procedure initWithMesh(submeshIndex: Variant; callback: Variant; optimizeMesh: Variant); overload;
    procedure init(callback: Variant);
    procedure reconstructMesh(submeshIndex: Variant);
    procedure initDecimatedMesh;
    procedure isFlipped(vertex1: Variant; vertex2: Variant; point: Variant; deletedArray: Variant; borderFactor: Variant; delTr: Variant);
    procedure updateTriangles(origVertex: Variant; vertex: Variant; deletedArray: Variant; deletedTriangles: Variant);
    procedure identifyBorder;
    procedure updateMesh; overload;
    procedure updateMesh(identifyBorders: Variant); overload;
    procedure vertexError(q: Variant; point: Variant);
    procedure calculateError(vertex1: Variant; vertex2: Variant); overload;
    procedure calculateError(vertex1: Variant; vertex2: Variant; pointResult: Variant); overload;
    procedure calculateError(vertex1: Variant; vertex2: Variant; pointResult: Variant; normalResult: Variant); overload;
    procedure calculateError(vertex1: Variant; vertex2: Variant; pointResult: Variant; normalResult: Variant; uvResult: Variant); overload;
    procedure calculateError(vertex1: Variant; vertex2: Variant; pointResult: Variant; normalResult: Variant; uvResult: Variant; colorResult: Variant); overload;
  end;

  JISimplifier = class external
    procedure simplify(settings: JISimplificationSettings; successCallback: (simplifiedMeshes: JMesh)); overload;
    procedure simplify(settings: JISimplificationSettings; successCallback: (simplifiedMeshes: JMesh); errorCallback: ); overload;
  end;

  JISimplificationSettings = class external
    quality: Float;
    distance: Float;
    optimizeMesh: Boolean; // nullable
  end;

  JISimplificationTask = class external
    settings: JArray{<JISimplificationSettings>};
    simplificationType: JSimplificationType;
    mesh: JMesh;
    successCallback: ; // nullable
    parallelProcessing: Boolean;
  end;

//BABYLON

type
  JPolygon = class external 'Polygon'
    function Rectangle(xmin: Float; ymin: Float; xmax: Float; ymax: Float): array of JVector2;
    function Circle(radius: Float): array of JVector2; overload;
    function Circle(radius: Float; cx: Float): array of JVector2; overload;
    function Circle(radius: Float; cx: Float; cy: Float): array of JVector2; overload;
    function Circle(radius: Float; cx: Float; cy: Float; numberOfSides: Float): array of JVector2; overload;
    function Parse(input: String): array of JVector2;
    function StartingAt(x: Float; y: Float): JPath2;
  end;

  JPolygonMeshBuilder = class external 'PolygonMeshBuilder'
    _swctx: Variant;
    _points: Variant;
    _outlinepoints: Variant;
    _holes: Variant;
    _name: Variant;
    _scene: Variant;
    constructor Create(name: String; contours: JPath2; scene: JScene);
    constructor Create(name: String; contours: array of JVector2; scene: JScene);
    function addHole(hole: array of JVector2): JPolygonMeshBuilder;
    function build: JMesh; overload;
    function build(updatable: Boolean): JMesh; overload;
    function build(updatable: Boolean; depth: Float): JMesh; overload;
    procedure addSide(positions: Variant; normals: Variant; uvs: Variant; indices: Variant; bounds: Variant; points: Variant; depth: Variant; flip: Variant);
  end;

//BABYLON

type
  JSubMesh = class external 'SubMesh'
    materialIndex: Float;
    verticesStart: Float;
    verticesCount: Float;
    indexStart: Variant;
    indexCount: Float;
    linesIndexCount: Float;
    _mesh: Variant;
    _renderingMesh: Variant;
    _boundingInfo: Variant;
    _linesIndexBuffer: Variant;
    _lastColliderWorldVertices: array of JVector3;
    _trianglePlanes: array of JPlane;
    _lastColliderTransformMatrix: JMatrix;
    _renderId: Float;
    _alphaIndex: Float;
    _distanceToCamera: Float;
    _id: Float;
    constructor Create(materialIndex: Float; verticesStart: Float; verticesCount: Float; indexStart: Variant; indexCount: Float; mesh: JAbstractMesh; renderingMesh: JMesh; createBoundingBox: Boolean);
    function getBoundingInfo: JBoundingInfo;
    function getMesh: JAbstractMesh;
    function getRenderingMesh: JMesh;
    function getMaterial: JMaterial;
    procedure refreshBoundingInfo;
    function _checkCollision(collider: JCollider): Boolean;
    procedure updateBoundingInfo(world: JMatrix);
    function isInFrustum(frustumPlanes: array of JPlane): Boolean;
    procedure render(enableAlphaMode: Boolean);
    function getLinesIndexBuffer(indices: array of Float; engine: Variant): JWebGLBuffer;
    function canIntersects(ray: JRay): Boolean;
    function intersects(ray: JRay; positions: array of JVector3; indices: array of Float): JIntersectionInfo; overload;
    function intersects(ray: JRay; positions: array of JVector3; indices: array of Float; fastCheck: Boolean): JIntersectionInfo; overload;
    function clone(newMesh: JAbstractMesh): JSubMesh; overload;
    function clone(newMesh: JAbstractMesh; newRenderingMesh: JMesh): JSubMesh; overload;
    procedure dispose;
    function CreateFromIndices(materialIndex: Float; startIndex: Float; indexCount: Float; mesh: JAbstractMesh): JSubMesh; overload;
    function CreateFromIndices(materialIndex: Float; startIndex: Float; indexCount: Float; mesh: JAbstractMesh; renderingMesh: JMesh): JSubMesh; overload;
  end;

//BABYLON

type
  JVertexBuffer = class external 'VertexBuffer'
    _mesh: Variant;
    _engine: Variant;
    _buffer: Variant;
    _data: Variant;
    _updatable: Variant;
    _kind: Variant;
    _strideSize: Variant;
    constructor Create(engine: Variant; data: array of Float; kind: String; updatable: Boolean; postponeInternalCreation: Boolean; stride: Float);
    function isUpdatable: Boolean;
    function getData: array of Float;
    function getBuffer: JWebGLBuffer;
    function getStrideSize: Float;
    procedure create; overload;
    procedure create(data: array of Float); overload;
    procedure update(data: array of Float);
    procedure updateDirectly(data: JFloat32Array; offset: Float);
    procedure dispose;
    _PositionKind: Variant;
    _NormalKind: Variant;
    _UVKind: Variant;
    _UV2Kind: Variant;
    _UV3Kind: Variant;
    _UV4Kind: Variant;
    _UV5Kind: Variant;
    _UV6Kind: Variant;
    _ColorKind: Variant;
    _MatricesIndicesKind: Variant;
    _MatricesWeightsKind: Variant;
    PositionKind: String;
    NormalKind: String;
    UVKind: String;
    UV2Kind: String;
    UV3Kind: String;
    UV4Kind: String;
    UV5Kind: String;
    UV6Kind: String;
    ColorKind: String;
    MatricesIndicesKind: String;
    MatricesWeightsKind: String;
  end;

//BABYLON

type
  JParticle = class external 'Particle'
    position: JVector3;
    direction: JVector3;
    color: JColor4;
    colorStep: JColor4;
    lifeTime: Float;
    age: Float;
    size: Float;
    angle: Float;
    angularSpeed: Float;
    procedure copyTo(other: JParticle);
  end;

//BABYLON

type
  JParticleSystem = class external 'ParticleSystem'
    name: String;
    BLENDMODE_ONEONE: Float;
    BLENDMODE_STANDARD: Float;
    id: String;
    renderingGroupId: Float;
    emitter: Variant;
    emitRate: Float;
    manualEmitCount: Float;
    updateSpeed: Float;
    targetStopDuration: Float;
    disposeOnStop: Boolean;
    minEmitPower: Float;
    maxEmitPower: Float;
    minLifeTime: Float;
    maxLifeTime: Float;
    minSize: Float;
    maxSize: Float;
    minAngularSpeed: Float;
    maxAngularSpeed: Float;
    particleTexture: JTexture;
    layerMask: Float;
    onDispose: ;
    updateFunction: (particles: array of JParticle);
    blendMode: Float;
    forceDepthWrite: Boolean;
    gravity: JVector3;
    direction1: JVector3;
    direction2: JVector3;
    minEmitBox: JVector3;
    maxEmitBox: JVector3;
    color1: JColor4;
    color2: JColor4;
    colorDead: JColor4;
    textureMask: JColor4;
    startDirectionFunction: (emitPower: Float; worldMatrix: JMatrix; directionToUpdate: JVector3);
    startPositionFunction: (worldMatrix: JMatrix; positionToUpdate: JVector3);
    particles: Variant;
    _capacity: Variant;
    _scene: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _stockParticles: Variant;
    _newPartsExcess: Variant;
    _vertexBuffer: Variant;
    _indexBuffer: Variant;
    _vertices: Variant;
    _effect: Variant;
    _customEffect: Variant;
    _cachedDefines: Variant;
    _scaledColorStep: Variant;
    _colorDiff: Variant;
    _scaledDirection: Variant;
    _scaledGravity: Variant;
    _currentRenderId: Variant;
    _alive: Variant;
    _started: Variant;
    _stopped: Variant;
    _actualFrame: Variant;
    _scaledUpdateSpeed: Variant;
    constructor Create(name: String; capacity: Float; scene: JScene; customEffect: JEffect);
    procedure recycleParticle(particle: JParticle);
    function getCapacity: Float;
    function isAlive: Boolean;
    function isStarted: Boolean;
    procedure start;
    procedure stop;
    procedure _appendParticleVertex(index: Float; particle: JParticle; offsetX: Float; offsetY: Float);
    procedure _update(newParticles: Variant);
    procedure _getEffect;
    procedure animate;
    function render: Float;
    procedure dispose;
    function clone(name: String; newEmitter: Variant): JParticleSystem;
  end;

//BABYLON

type
  JPhysicsEngine = class external 'PhysicsEngine'
    gravity: JVector3;
    _currentPlugin: Variant;
    constructor Create(plugin: JIPhysicsEnginePlugin);
    procedure _initialize; overload;
    procedure _initialize(gravity: JVector3); overload;
    procedure _runOneStep(delta: Float);
    procedure _setGravity(gravity: JVector3);
    function _registerMesh(mesh: JAbstractMesh; impostor: Float; options: JPhysicsBodyCreationOptions): Variant;
    function _registerMeshesAsCompound(parts: array of JPhysicsCompoundBodyPart; options: JPhysicsBodyCreationOptions): Variant;
    procedure _unregisterMesh(mesh: JAbstractMesh);
    procedure _applyImpulse(mesh: JAbstractMesh; force: JVector3; contactPoint: JVector3);
    function _createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3): Boolean; overload;
    function _createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3; options: Variant): Boolean; overload;
    procedure _updateBodyPosition(mesh: JAbstractMesh);
    procedure dispose;
    function isSupported: Boolean;
    NoImpostor: Float;
    SphereImpostor: Float;
    BoxImpostor: Float;
    PlaneImpostor: Float;
    MeshImpostor: Float;
    CapsuleImpostor: Float;
    ConeImpostor: Float;
    CylinderImpostor: Float;
    ConvexHullImpostor: Float;
    Epsilon: Float;
  end;

  JIPhysicsEnginePlugin = class external
    function initialize: Variant; overload;
    function initialize(iterations: Float): Variant; overload;
    procedure setGravity(gravity: JVector3);
    procedure runOneStep(delta: Float);
    function registerMesh(mesh: JAbstractMesh; impostor: Float; options: JPhysicsBodyCreationOptions): Variant;
    function registerMeshesAsCompound(parts: array of JPhysicsCompoundBodyPart; options: JPhysicsBodyCreationOptions): Variant;
    function unregisterMesh(mesh: JAbstractMesh): Variant;
    procedure applyImpulse(mesh: JAbstractMesh; force: JVector3; contactPoint: JVector3);
    function createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3): Boolean; overload;
    function createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3; options: Variant): Boolean; overload;
    procedure dispose;
    function isSupported: Boolean;
    procedure updateBodyPosition(mesh: JAbstractMesh);
  end;

  JPhysicsBodyCreationOptions = class external
    mass: Float;
    friction: Float;
    restitution: Float;
  end;

  JPhysicsCompoundBodyPart = class external
    mesh: JMesh;
    impostor: Float;
  end;

//BABYLON

type
  JBoundingBoxRenderer = class external 'BoundingBoxRenderer'
    frontColor: JColor3;
    backColor: JColor3;
    showBackLines: Boolean;
    renderList: JSmartArray{<JBoundingBox>};
    _scene: Variant;
    _colorShader: Variant;
    _vb: Variant;
    _ib: Variant;
    constructor Create(scene: JScene);
    procedure _prepareRessources;
    procedure reset;
    procedure render;
    procedure dispose;
  end;

//BABYLON

type
  JDepthRenderer = class external 'DepthRenderer'
    _scene: Variant;
    _depthMap: Variant;
    _effect: Variant;
    _viewMatrix: Variant;
    _projectionMatrix: Variant;
    _transformMatrix: Variant;
    _worldViewProjection: Variant;
    _cachedDefines: Variant;
    constructor Create(scene: JScene; &type: Float);
    function isReady(subMesh: JSubMesh; useInstances: Boolean): Boolean;
    function getDepthMap: JRenderTargetTexture;
    procedure dispose;
  end;

//BABYLON

type
  JEdgesRenderer = class external 'EdgesRenderer'
    _source: Variant;
    _linesPositions: Variant;
    _linesNormals: Variant;
    _linesIndices: Variant;
    _epsilon: Variant;
    _indicesCount: Variant;
    _lineShader: Variant;
    _vb0: Variant;
    _vb1: Variant;
    _ib: Variant;
    _buffers: Variant;
    _checkVerticesInsteadOfIndices: Variant;
    constructor Create(source: JAbstractMesh; epsilon: Float; checkVerticesInsteadOfIndices: Boolean);
    procedure _prepareRessources;
    procedure dispose;
    procedure _processEdgeForAdjacencies(pa: Variant; pb: Variant; p0: Variant; p1: Variant; p2: Variant);
    procedure _processEdgeForAdjacenciesWithVertices(pa: Variant; pb: Variant; p0: Variant; p1: Variant; p2: Variant);
    procedure _checkEdge(faceIndex: Variant; edge: Variant; faceNormals: Variant; p0: Variant; p1: Variant);
    procedure _generateEdgesLines;
    procedure render;
  end;

//BABYLON

type
  JOutlineRenderer = class external 'OutlineRenderer'
    _scene: Variant;
    _effect: Variant;
    _cachedDefines: Variant;
    constructor Create(scene: JScene);
    procedure render(subMesh: JSubMesh; batch: J_InstancesBatch); overload;
    procedure render(subMesh: JSubMesh; batch: J_InstancesBatch; useOverlay: Boolean); overload;
    function isReady(subMesh: JSubMesh; useInstances: Boolean): Boolean;
  end;

//BABYLON

type
  JRenderingGroup = class external 'RenderingGroup'
    index: Float;
    _scene: Variant;
    _opaqueSubMeshes: Variant;
    _transparentSubMeshes: Variant;
    _alphaTestSubMeshes: Variant;
    _activeVertices: Variant;
    constructor Create(index: Float; scene: JScene);
    function render(customRenderFunction: (opaqueSubMeshes: JSmartArray{<JSubMesh>}; transparentSubMeshes: JSmartArray{<JSubMesh>}; alphaTestSubMeshes: JSmartArray{<JSubMesh>})): Boolean;
    procedure prepare;
    procedure dispatch(subMesh: JSubMesh);
  end;

//BABYLON

type
  JRenderingManager = class external 'RenderingManager'
    MAX_RENDERINGGROUPS: Float;
    _scene: Variant;
    _renderingGroups: Variant;
    _depthBufferAlreadyCleaned: Variant;
    constructor Create(scene: JScene);
    procedure _renderParticles(index: Variant; activeMeshes: Variant);
    procedure _renderSprites(index: Variant);
    procedure _clearDepthBuffer;
    procedure render(customRenderFunction: (opaqueSubMeshes: JSmartArray{<JSubMesh>}; transparentSubMeshes: JSmartArray{<JSubMesh>}; alphaTestSubMeshes: JSmartArray{<JSubMesh>}); activeMeshes: array of JAbstractMesh; renderParticles: Boolean; renderSprites: Boolean);
    procedure reset;
    procedure dispatch(subMesh: JSubMesh);
  end;

//BABYLON

type
  JAnaglyphPostProcess = class external 'AnaglyphPostProcess'(JPostProcess)
    constructor Create(name: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JBlackAndWhitePostProcess = class external 'BlackAndWhitePostProcess'(JPostProcess)
    constructor Create(name: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JBlurPostProcess = class external 'BlurPostProcess'(JPostProcess)
    direction: JVector2;
    blurWidth: Float;
    constructor Create(name: String; direction: JVector2; blurWidth: Float; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JColorCorrectionPostProcess = class external 'ColorCorrectionPostProcess'(JPostProcess)
    _colorTableTexture: Variant;
    constructor Create(name: String; colorTableUrl: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JConvolutionPostProcess = class external 'ConvolutionPostProcess'(JPostProcess)
    kernel: array of Float;
    constructor Create(name: String; kernel: array of Float; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
    EdgeDetect0Kernel: array of Float;
    EdgeDetect1Kernel: array of Float;
    EdgeDetect2Kernel: array of Float;
    SharpenKernel: array of Float;
    EmbossKernel: array of Float;
    GaussianKernel: array of Float;
  end;

//BABYLON

type
  JDisplayPassPostProcess = class external 'DisplayPassPostProcess'(JPostProcess)
    constructor Create(name: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JFilterPostProcess = class external 'FilterPostProcess'(JPostProcess)
    kernelMatrix: JMatrix;
    constructor Create(name: String; kernelMatrix: JMatrix; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JFxaaPostProcess = class external 'FxaaPostProcess'(JPostProcess)
    texelWidth: Float;
    texelHeight: Float;
    constructor Create(name: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JHDRRenderingPipeline = class external 'HDRRenderingPipeline'(JPostProcessRenderPipeline)
    gaussCoeff: Float;
    gaussMean: Float;
    gaussStandDev: Float;
    exposure: Float;
    minimumLuminance: Float;
    maximumLuminance: Float;
    luminanceIncreaserate: Float;
    luminanceDecreaseRate: Float;
    brightThreshold: Float;
    _guassianBlurHPostProcess: Variant;
    _guassianBlurVPostProcess: Variant;
    _brightPassPostProcess: Variant;
    _textureAdderPostProcess: Variant;
    _downSampleX4PostProcess: Variant;
    _originalPostProcess: Variant;
    _hdrPostProcess: Variant;
    _hdrCurrentLuminance: Variant;
    _hdrOutputLuminance: Variant;
    LUM_STEPS: Float;
    _downSamplePostProcesses: Variant;
    _scene: Variant;
    _needUpdate: Variant;
    constructor Create(name: String; scene: JScene; ratio: Float; originalPostProcess: JPostProcess; cameras: array of JCamera);
    procedure update;
    function getCurrentLuminance: Float;
    function getOutputLuminance: Float;
    procedure dispose;
    procedure _createHDRPostProcess(scene: Variant; ratio: Variant);
    procedure _createTextureAdderPostProcess(scene: Variant; ratio: Variant);
    procedure _createDownSampleX4PostProcess(scene: Variant; ratio: Variant);
    procedure _createBrightPassPostProcess(scene: Variant; ratio: Variant);
    procedure _createLuminanceGeneratorPostProcess(scene: Variant);
    procedure _createGaussianBlurPostProcess(scene: Variant; ratio: Variant);
  end;

//BABYLON

type
  JLensRenderingPipeline = class external 'LensRenderingPipeline'(JPostProcessRenderPipeline)
    LensChromaticAberrationEffect: String;
    HighlightsEnhancingEffect: String;
    LensDepthOfFieldEffect: String;
    _scene: Variant;
    _depthTexture: Variant;
    _grainTexture: Variant;
    _chromaticAberrationPostProcess: Variant;
    _highlightsPostProcess: Variant;
    _depthOfFieldPostProcess: Variant;
    _edgeBlur: Variant;
    _grainAmount: Variant;
    _chromaticAberration: Variant;
    _distortion: Variant;
    _highlightsGain: Variant;
    _highlightsThreshold: Variant;
    _dofDistance: Variant;
    _dofAperture: Variant;
    _dofDarken: Variant;
    _dofPentagon: Variant;
    _blurNoise: Variant;
    constructor Create(name: String; parameters: Variant; scene: JScene; ratio: Float; cameras: array of JCamera);
    procedure setEdgeBlur(amount: Float);
    procedure disableEdgeBlur;
    procedure setGrainAmount(amount: Float);
    procedure disableGrain;
    procedure setChromaticAberration(amount: Float);
    procedure disableChromaticAberration;
    procedure setEdgeDistortion(amount: Float);
    procedure disableEdgeDistortion;
    procedure setFocusDistance(amount: Float);
    procedure disableDepthOfField;
    procedure setAperture(amount: Float);
    procedure setDarkenOutOfFocus(amount: Float);
    procedure enablePentagonBokeh;
    procedure disablePentagonBokeh;
    procedure enableNoiseBlur;
    procedure disableNoiseBlur;
    procedure setHighlightsGain(amount: Float);
    procedure setHighlightsThreshold(amount: Float);
    procedure disableHighlights;
    procedure dispose; overload;
    procedure dispose(disableDepthRender: Boolean); overload;
    procedure _createChromaticAberrationPostProcess(ratio: Variant);
    procedure _createHighlightsPostProcess(ratio: Variant);
    procedure _createDepthOfFieldPostProcess(ratio: Variant);
    procedure _createGrainTexture;
  end;

//BABYLON

type
  JPassPostProcess = class external 'PassPostProcess'(JPostProcess)
    constructor Create(name: String; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
  end;

//BABYLON

type
  JPostProcess = class external 'PostProcess'
    name: String;
    onApply: (effect: JEffect);
    onBeforeRender: (effect: JEffect);
    onAfterRender: (effect: JEffect);
    onSizeChanged: ;
    onActivate: (camera: JCamera);
    width: Float;
    height: Float;
    renderTargetSamplingMode: Float;
    clearColor: JColor4;
    _camera: Variant;
    _scene: Variant;
    _engine: Variant;
    _renderRatio: Variant;
    _reusable: Variant;
    _textureType: Variant;
    _textures: JSmartArray{<JWebGLTexture>};
    _currentRenderTextureInd: Float;
    _effect: Variant;
    constructor Create(name: String; fragmentUrl: String; parameters: array of String; samplers: array of String; ratio: Variant {Float or Variant}; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean; defines: String; textureType: Float);
    function isReusable: Boolean;
    procedure activate(camera: JCamera); overload;
    procedure activate(camera: JCamera; sourceTexture: JWebGLTexture); overload;
    function apply: JEffect;
    procedure dispose; overload;
    procedure dispose(camera: JCamera); overload;
  end;

//BABYLON

type
  JPostProcessManager = class external 'PostProcessManager'
    _scene: Variant;
    _indexBuffer: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _vertexBuffer: Variant;
    constructor Create(scene: JScene);
    procedure _prepareBuffers;
    function _prepareFrame: Boolean; overload;
    function _prepareFrame(sourceTexture: JWebGLTexture): Boolean; overload;
    procedure directRender(postProcesses: array of JPostProcess); overload;
    procedure directRender(postProcesses: array of JPostProcess; targetTexture: JWebGLTexture); overload;
    procedure _finalizeFrame; overload;
    procedure _finalizeFrame(doNotPresent: Boolean); overload;
    procedure _finalizeFrame(doNotPresent: Boolean; targetTexture: JWebGLTexture); overload;
    procedure _finalizeFrame(doNotPresent: Boolean; targetTexture: JWebGLTexture; postProcesses: array of JPostProcess); overload;
    procedure dispose;
  end;

//BABYLON

type
  JRefractionPostProcess = class external 'RefractionPostProcess'(JPostProcess)
    color: JColor3;
    depth: Float;
    colorLevel: Float;
    _refRexture: Variant;
    constructor Create(name: String; refractionTextureUrl: String; color: JColor3; depth: Float; colorLevel: Float; ratio: Float; camera: JCamera; samplingMode: Float; engine: JEngine; reusable: Boolean);
    procedure dispose(camera: JCamera);
  end;

//BABYLON

type
  JSSAORenderingPipeline = class external 'SSAORenderingPipeline'(JPostProcessRenderPipeline)
    SSAOOriginalSceneColorEffect: String;
    SSAORenderEffect: String;
    SSAOBlurHRenderEffect: String;
    SSAOBlurVRenderEffect: String;
    SSAOCombineRenderEffect: String;
    totalStrength: Float;
    radius: Float;
    area: Float;
    fallOff: Float;
    _scene: Variant;
    _depthTexture: Variant;
    _randomTexture: Variant;
    _originalColorPostProcess: Variant;
    _ssaoPostProcess: Variant;
    _blurHPostProcess: Variant;
    _blurVPostProcess: Variant;
    _ssaoCombinePostProcess: Variant;
    _firstUpdate: Variant;
    constructor Create(name: String; scene: JScene; ratio: Variant; cameras: array of JCamera);
    function getBlurHPostProcess: JBlurPostProcess;
    function getBlurVPostProcess: JBlurPostProcess;
    procedure dispose; overload;
    procedure dispose(disableDepthRender: Boolean); overload;
    procedure _createSSAOPostProcess(ratio: Variant);
    procedure _createSSAOCombinePostProcess(ratio: Variant);
    procedure _createRandomTexture;
  end;

//BABYLON

type
  JStereoscopicInterlacePostProcess = class external 'StereoscopicInterlacePostProcess'(JPostProcess)
    _stepSize: Variant;
    constructor Create(name: String; camB: JCamera; postProcessA: JPostProcess; isStereoscopicHoriz: Boolean; samplingMode: Float);
  end;

//BABYLON

type
  JTonemapPostProcess = class external 'TonemapPostProcess'(JPostProcess)
    _operator: Variant;
    _exposureAdjustment: Variant;
    constructor Create(name: String; operator: JTonemappingOperator; exposureAdjustment: Float; camera: JCamera; samplingMode: Float; engine: JEngine; textureFormat: Float);
  end;

//BABYLON

type
  JVolumetricLightScatteringPostProcess = class external 'VolumetricLightScatteringPostProcess'(JPostProcess)
    _volumetricLightScatteringPass: Variant;
    _volumetricLightScatteringRTT: Variant;
    _viewPort: Variant;
    _screenCoordinates: Variant;
    _cachedDefines: Variant;
    _customMeshPosition: Variant;
    useCustomMeshPosition: Boolean;
    invert: Boolean;
    mesh: JMesh;
    useDiffuseColor: Boolean;
    excludedMeshes: array of JAbstractMesh;
    exposure: Float;
    decay: Float;
    weight: Float;
    density: Float;
    constructor Create(name: String; ratio: Variant; camera: JCamera; mesh: JMesh; samples: Float; samplingMode: Float; engine: JEngine; reusable: Boolean; scene: JScene);
    function isReady(subMesh: JSubMesh; useInstances: Boolean): Boolean;
    procedure setCustomMeshPosition(position: JVector3);
    function getCustomMeshPosition: JVector3;
    procedure dispose(camera: JCamera);
    function getPass: JRenderTargetTexture;
    procedure _meshExcluded(mesh: Variant);
    procedure _createPass(scene: Variant; ratio: Variant);
    procedure _updateMeshScreenCoordinates(scene: Variant);
    function CreateDefaultMesh(name: String; scene: JScene): JMesh;
  end;

//BABYLON

type
  JVRDistortionCorrectionPostProcess = class external 'VRDistortionCorrectionPostProcess'(JPostProcess)
    aspectRatio: Float;
    _isRightEye: Variant;
    _distortionFactors: Variant;
    _postProcessScaleFactor: Variant;
    _lensCenterOffset: Variant;
    _scaleIn: Variant;
    _scaleFactor: Variant;
    _lensCenter: Variant;
    constructor Create(name: String; camera: JCamera; isRightEye: Boolean; vrMetrics: JVRCameraMetrics);
  end;

//BABYLON

type
  JSprite = class external 'Sprite'
    name: String;
    position: JVector3;
    color: JColor4;
    width: Float;
    height: Float;
    angle: Float;
    cellIndex: Float;
    invertU: Float;
    invertV: Float;
    disposeWhenFinishedAnimating: Boolean;
    animations: array of JAnimation;
    _animationStarted: Variant;
    _loopAnimation: Variant;
    _fromIndex: Variant;
    _toIndex: Variant;
    _delay: Variant;
    _direction: Variant;
    _frameCount: Variant;
    _manager: Variant;
    _time: Variant;
    size: Float;
    constructor Create(name: String; manager: JSpriteManager);
    procedure playAnimation(from: Float; to: Float; loop: Boolean; delay: Float);
    procedure stopAnimation;
    procedure _animate(deltaTime: Float);
    procedure dispose;
  end;

//BABYLON

type
  JSpriteManager = class external 'SpriteManager'
    name: String;
    cellSize: Float;
    sprites: array of JSprite;
    renderingGroupId: Float;
    layerMask: Float;
    onDispose: ;
    fogEnabled: Boolean;
    _capacity: Variant;
    _spriteTexture: Variant;
    _epsilon: Variant;
    _scene: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _vertexBuffer: Variant;
    _indexBuffer: Variant;
    _vertices: Variant;
    _effectBase: Variant;
    _effectFog: Variant;
    constructor Create(name: String; imgUrl: String; capacity: Float; cellSize: Float; scene: JScene; epsilon: Float; samplingMode: Float);
    procedure _appendSpriteVertex(index: Variant; sprite: Variant; offsetX: Variant; offsetY: Variant; rowSize: Variant);
    procedure render;
    procedure dispose;
  end;

//BABYLON.Internals

type
  JAndOrNotEvaluator = class external 'AndOrNotEvaluator'
    function Eval(query: String; evaluateCallback: (val: Variant): Boolean): Boolean;
    procedure _HandleParenthesisContent(parenthesisContent: Variant; evaluateCallback: Variant);
    procedure _SimplifyNegation(booleanString: Variant);
  end;

//BABYLON

type
  JMeshAssetTask = class external 'MeshAssetTask'
    name: String;
    meshesNames: Variant;
    rootUrl: String;
    sceneFilename: String;
    loadedMeshes: JArray{<JAbstractMesh>};
    loadedParticleSystems: JArray{<JParticleSystem>};
    loadedSkeletons: JArray{<JSkeleton>};
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    constructor Create(name: String; meshesNames: Variant; rootUrl: String; sceneFilename: String);
    procedure run(scene: JScene; onSuccess: ; onError: );
  end;

  JTextFileAssetTask = class external 'TextFileAssetTask'
    name: String;
    url: String;
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    text: String;
    constructor Create(name: String; url: String);
    procedure run(scene: JScene; onSuccess: ; onError: );
  end;

  JBinaryFileAssetTask = class external 'BinaryFileAssetTask'
    name: String;
    url: String;
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    data: JArrayBuffer;
    constructor Create(name: String; url: String);
    procedure run(scene: JScene; onSuccess: ; onError: );
  end;

  JImageAssetTask = class external 'ImageAssetTask'
    name: String;
    url: String;
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    image: JHTMLImageElement;
    constructor Create(name: String; url: String);
    procedure run(scene: JScene; onSuccess: ; onError: );
  end;

  JTextureAssetTask = class external 'TextureAssetTask'
    name: String;
    url: String;
    noMipmap: Boolean;
    invertY: Boolean;
    samplingMode: Float;
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    texture: JTexture;
    constructor Create(name: String; url: String; noMipmap: Boolean; invertY: Boolean; samplingMode: Float);
    procedure run(scene: JScene; onSuccess: ; onError: );
  end;

  JAssetsManager = class external 'AssetsManager'
    _tasks: Variant;
    _scene: Variant;
    _waitingTasksCount: Variant;
    onFinish: (tasks: array of JIAssetTask);
    onTaskSuccess: (task: JIAssetTask);
    onTaskError: (task: JIAssetTask);
    useDefaultLoadingScreen: Boolean;
    constructor Create(scene: JScene);
    function addMeshTask(taskName: String; meshesNames: Variant; rootUrl: String; sceneFilename: String): JIAssetTask;
    function addTextFileTask(taskName: String; url: String): JIAssetTask;
    function addBinaryFileTask(taskName: String; url: String): JIAssetTask;
    function addImageTask(taskName: String; url: String): JIAssetTask;
    function addTextureTask(taskName: String; url: String): JIAssetTask; overload;
    function addTextureTask(taskName: String; url: String; noMipmap: Boolean): JIAssetTask; overload;
    function addTextureTask(taskName: String; url: String; noMipmap: Boolean; invertY: Boolean): JIAssetTask; overload;
    function addTextureTask(taskName: String; url: String; noMipmap: Boolean; invertY: Boolean; samplingMode: Float): JIAssetTask; overload;
    procedure _decreaseWaitingTasksCount;
    procedure _runTask(task: Variant);
    function reset: JAssetsManager;
    function load: JAssetsManager;
  end;

  JIAssetTask = class external
    onSuccess: (task: JIAssetTask);
    onError: (task: JIAssetTask);
    isCompleted: Boolean;
    function run(scene: JScene; onSuccess: ; onError: ): Variant;
  end;

//BABYLON

type
  JDatabase = class external 'Database'
    callbackManifestChecked: Variant;
    currentSceneUrl: Variant;
    db: Variant;
    enableSceneOffline: Variant;
    enableTexturesOffline: Variant;
    manifestVersionFound: Variant;
    mustUpdateRessources: Variant;
    hasReachedQuota: Variant;
    isSupported: Variant;
    idbFactory: Variant;
    IsUASupportingBlobStorage: Boolean;
    IDBStorageEnabled: Boolean;
    constructor Create(urlToScene: String; callbackManifestChecked: (checked: Boolean): Variant);
    parseURL: (url: String): String;
    ReturnFullUrlLocation: (url: String): String;
    procedure checkManifestFile;
    procedure openAsync(successCallback: Variant; errorCallback: Variant);
    procedure loadImageFromDB(url: String; image: JHTMLImageElement);
    procedure _loadImageFromDBAsync(url: Variant; image: Variant; notInDBCallback: Variant);
    procedure _saveImageIntoDBAsync(url: Variant; image: Variant);
    procedure _checkVersionFromDB(url: Variant; versionLoaded: Variant);
    procedure _loadVersionFromDBAsync(url: Variant; callback: Variant; updateInDBCallback: Variant);
    procedure _saveVersionIntoDBAsync(url: Variant; callback: Variant);
    procedure loadFileFromDB(url: Variant; sceneLoaded: Variant; progressCallBack: Variant; errorCallback: Variant); overload;
    procedure loadFileFromDB(url: Variant; sceneLoaded: Variant; progressCallBack: Variant; errorCallback: Variant; useArrayBuffer: Variant); overload;
    procedure _loadFileFromDBAsync(url: Variant; callback: Variant; notInDBCallback: Variant); overload;
    procedure _loadFileFromDBAsync(url: Variant; callback: Variant; notInDBCallback: Variant; useArrayBuffer: Variant); overload;
    procedure _saveFileIntoDBAsync(url: Variant; callback: Variant; progressCallback: Variant); overload;
    procedure _saveFileIntoDBAsync(url: Variant; callback: Variant; progressCallback: Variant; useArrayBuffer: Variant); overload;
  end;

//BABYLON

type
  JFilesInput = class external 'FilesInput'
    _engine: Variant;
    _currentScene: Variant;
    _canvas: Variant;
    _sceneLoadedCallback: Variant;
    _progressCallback: Variant;
    _additionnalRenderLoopLogicCallback: Variant;
    _textureLoadingCallback: Variant;
    _startingProcessingFilesCallback: Variant;
    _elementToMonitor: Variant;
    FilesTextures: array of Variant;
    FilesToLoad: array of Variant;
    _sceneFileToLoad: Variant;
    _filesToLoad: Variant;
    constructor Create(p_engine: JEngine; p_scene: JScene; p_canvas: JHTMLCanvasElement; p_sceneLoadedCallback: Variant; p_progressCallback: Variant; p_additionnalRenderLoopLogicCallback: Variant; p_textureLoadingCallback: Variant; p_startingProcessingFilesCallback: Variant);
    procedure monitorElementForDragNDrop(p_elementToMonitor: JHTMLElement);
    procedure renderFunction;
    procedure drag(e: Variant);
    procedure drop(eventDrop: Variant);
    procedure loadFiles(event: Variant);
    procedure reload;
  end;

//BABYLON

type
  JGamepads = class external 'Gamepads'
    babylonGamepads: Variant;
    oneGamepadConnected: Variant;
    isMonitoring: Variant;
    gamepadEventSupported: Variant;
    gamepadSupportAvailable: Variant;
    _callbackGamepadConnected: Variant;
    buttonADataURL: Variant;
    gamepadDOMInfo: Variant;
    constructor Create(ongamedpadconnected: (gamepad: JGamepad));
    procedure _insertGamepadDOMInstructions;
    procedure _insertGamepadDOMNotSupported;
    procedure dispose;
    procedure _onGamepadConnected(evt: Variant);
    procedure _addNewGamepad(gamepad: Variant);
    procedure _onGamepadDisconnected(evt: Variant);
    procedure _startMonitoringGamepads;
    procedure _stopMonitoringGamepads;
    procedure _checkGamepadsStatus;
    procedure _updateGamepadObjects;
  end;

  JStickValues = class external 'StickValues'
    x: Variant;
    y: Variant;
    constructor Create(x: Variant; y: Variant);
  end;

  JGamepad = class external 'Gamepad'
    id: String;
    index: Float;
    browserGamepad: Variant;
    _leftStick: Variant;
    _rightStick: Variant;
    _onleftstickchanged: Variant;
    _onrightstickchanged: Variant;
    constructor Create(id: String; index: Float; browserGamepad: Variant);
    procedure onleftstickchanged(callback: (values: JStickValues));
    procedure onrightstickchanged(callback: (values: JStickValues));
    leftStick: JStickValues;
    rightStick: JStickValues;
    procedure update;
  end;

  JGenericPad = class external 'GenericPad'(JGamepad)
    id: String;
    index: Float;
    gamepad: Variant;
    _buttons: Variant;
    _onbuttondown: Variant;
    _onbuttonup: Variant;
    procedure onbuttondown(callback: (buttonPressed: Float));
    procedure onbuttonup(callback: (buttonReleased: Float));
    constructor Create(id: String; index: Float; gamepad: Variant);
    procedure _setButtonValue(newValue: Variant; currentValue: Variant; buttonIndex: Variant);
    procedure update;
  end;

  JXbox360Pad = class external 'Xbox360Pad'(JGamepad)
    _leftTrigger: Variant;
    _rightTrigger: Variant;
    _onlefttriggerchanged: Variant;
    _onrighttriggerchanged: Variant;
    _onbuttondown: Variant;
    _onbuttonup: Variant;
    _ondpaddown: Variant;
    _ondpadup: Variant;
    _buttonA: Variant;
    _buttonB: Variant;
    _buttonX: Variant;
    _buttonY: Variant;
    _buttonBack: Variant;
    _buttonStart: Variant;
    _buttonLB: Variant;
    _buttonRB: Variant;
    _buttonLeftStick: Variant;
    _buttonRightStick: Variant;
    _dPadUp: Variant;
    _dPadDown: Variant;
    _dPadLeft: Variant;
    _dPadRight: Variant;
    procedure onlefttriggerchanged(callback: (value: Float));
    procedure onrighttriggerchanged(callback: (value: Float));
    leftTrigger: Float;
    rightTrigger: Float;
    procedure onbuttondown(callback: (buttonPressed: JXbox360Button));
    procedure onbuttonup(callback: (buttonReleased: JXbox360Button));
    procedure ondpaddown(callback: (dPadPressed: JXbox360Dpad));
    procedure ondpadup(callback: (dPadReleased: JXbox360Dpad));
    procedure _setButtonValue(newValue: Variant; currentValue: Variant; buttonType: Variant);
    procedure _setDPadValue(newValue: Variant; currentValue: Variant; buttonType: Variant);
    buttonA: Float;
    buttonB: Float;
    buttonX: Float;
    buttonY: Float;
    buttonStart: Float;
    buttonBack: Float;
    buttonLB: Float;
    buttonRB: Float;
    buttonLeftStick: Float;
    buttonRightStick: Float;
    dPadUp: Float;
    dPadDown: Float;
    dPadLeft: Float;
    dPadRight: Float;
    procedure update;
  end;

//BABYLON

type
  JSceneOptimization = class external 'SceneOptimization'
    priority: Float;
    apply: (scene: JScene): Boolean;
    constructor Create(priority: Float);
  end;

  JTextureOptimization = class external 'TextureOptimization'(JSceneOptimization)
    priority: Float;
    maximumSize: Float;
    constructor Create(priority: Float; maximumSize: Float);
    apply: (scene: JScene): Boolean;
  end;

  JHardwareScalingOptimization = class external 'HardwareScalingOptimization'(JSceneOptimization)
    priority: Float;
    maximumScale: Float;
    _currentScale: Variant;
    constructor Create(priority: Float; maximumScale: Float);
    apply: (scene: JScene): Boolean;
  end;

  JShadowsOptimization = class external 'ShadowsOptimization'(JSceneOptimization)
    apply: (scene: JScene): Boolean;
  end;

  JPostProcessesOptimization = class external 'PostProcessesOptimization'(JSceneOptimization)
    apply: (scene: JScene): Boolean;
  end;

  JLensFlaresOptimization = class external 'LensFlaresOptimization'(JSceneOptimization)
    apply: (scene: JScene): Boolean;
  end;

  JParticlesOptimization = class external 'ParticlesOptimization'(JSceneOptimization)
    apply: (scene: JScene): Boolean;
  end;

  JRenderTargetsOptimization = class external 'RenderTargetsOptimization'(JSceneOptimization)
    apply: (scene: JScene): Boolean;
  end;

  JMergeMeshesOptimization = class external 'MergeMeshesOptimization'(JSceneOptimization)
    _UpdateSelectionTree: Boolean;
    UpdateSelectionTree: Boolean;
    _canBeMerged: Variant;
    apply: (scene: JScene; updateSelectionTree: Boolean): Boolean;
  end;

  JSceneOptimizerOptions = class external 'SceneOptimizerOptions'
    targetFrameRate: Float;
    trackerDuration: Float;
    optimizations: array of JSceneOptimization;
    constructor Create(targetFrameRate: Float; trackerDuration: Float);
    function LowDegradationAllowed: JSceneOptimizerOptions; overload;
    function LowDegradationAllowed(targetFrameRate: Float): JSceneOptimizerOptions; overload;
    function ModerateDegradationAllowed: JSceneOptimizerOptions; overload;
    function ModerateDegradationAllowed(targetFrameRate: Float): JSceneOptimizerOptions; overload;
    function HighDegradationAllowed: JSceneOptimizerOptions; overload;
    function HighDegradationAllowed(targetFrameRate: Float): JSceneOptimizerOptions; overload;
  end;

  JSceneOptimizer = class external 'SceneOptimizer'
    procedure _CheckCurrentState(scene: JScene; options: JSceneOptimizerOptions; currentPriorityLevel: Float); overload;
    procedure _CheckCurrentState(scene: JScene; options: JSceneOptimizerOptions; currentPriorityLevel: Float; onSuccess: ); overload;
    procedure _CheckCurrentState(scene: JScene; options: JSceneOptimizerOptions; currentPriorityLevel: Float; onSuccess: ; onFailure: ); overload;
    procedure OptimizeAsync(scene: JScene); overload;
    procedure OptimizeAsync(scene: JScene; options: JSceneOptimizerOptions); overload;
    procedure OptimizeAsync(scene: JScene; options: JSceneOptimizerOptions; onSuccess: ); overload;
    procedure OptimizeAsync(scene: JScene; options: JSceneOptimizerOptions; onSuccess: ; onFailure: ); overload;
  end;

//BABYLON

type
  JSceneSerializer = class external 'SceneSerializer'
    function Serialize(scene: JScene): Variant;
    function SerializeMesh(toSerialize: Variant): Variant; overload;
    function SerializeMesh(toSerialize: Variant; withParents: Boolean): Variant; overload;
    function SerializeMesh(toSerialize: Variant; withParents: Boolean; withChildren: Boolean): Variant; overload;
  end;

//BABYLON

type
  JSmartArray = class external 'SmartArray'
    data: JArray{<JT>};
    _length: Float;
    _id: Variant;
    _duplicateId: Variant;
    constructor Create(capacity: Float);
    procedure push(value: Variant);
    procedure pushNoDuplicate(value: Variant);
    procedure sort(compareFn: Variant);
    procedure reset;
    procedure concat(array: Variant);
    procedure concatWithNoDuplicate(array: Variant);
    function indexOf(value: Variant): Float;
    _GlobalId: Variant;
  end;

//BABYLON

type
  JSmartCollection = class external 'SmartCollection'
    count: Float;
    items: Variant;
    _keys: Variant;
    _initialCapacity: Variant;
    constructor Create(capacity: Float);
    function add(key: Variant; item: Variant): Float;
    function remove(key: Variant): Float;
    function removeItemOfIndex(index: Float): Float;
    function indexOf(key: Variant): Float;
    function item(key: Variant): Variant;
    function getAllKeys: array of Variant;
    function getKeyByIndex(index: Float): Variant;
    function getItemByIndex(index: Float): Variant;
    procedure empty;
    procedure forEach(block: (item: Variant));
  end;

//BABYLON

type
  JTags = class external 'Tags'
    procedure EnableFor(obj: Variant);
    procedure DisableFor(obj: Variant);
    function HasTags(obj: Variant): Boolean;
    function GetTags(obj: Variant): Variant;
    procedure AddTagsTo(obj: Variant; tagsString: String);
    procedure _AddTagTo(obj: Variant; tag: String);
    procedure RemoveTagsFrom(obj: Variant; tagsString: String);
    procedure _RemoveTagFrom(obj: Variant; tag: String);
    function MatchesQuery(obj: Variant; tagsQuery: String): Boolean;
  end;

//BABYLON.Internals

type
  JDDSTools = class external 'DDSTools'
    function GetDDSInfo(arrayBuffer: Variant): JDDSInfo;
    procedure GetRGBAArrayBuffer(width: Variant; height: Variant; dataOffset: Variant; dataLength: Variant; arrayBuffer: Variant);
    procedure GetRGBArrayBuffer(width: Variant; height: Variant; dataOffset: Variant; dataLength: Variant; arrayBuffer: Variant);
    procedure GetLuminanceArrayBuffer(width: Variant; height: Variant; dataOffset: Variant; dataLength: Variant; arrayBuffer: Variant);
    procedure UploadDDSLevels(gl: JWebGLRenderingContext; ext: Variant; arrayBuffer: Variant; info: JDDSInfo; loadMipmaps: Boolean; faces: Float);
  end;

  JDDSInfo = class external
    width: Float;
    height: Float;
    mipmapCount: Float;
    isFourCC: Boolean;
    isRGB: Boolean;
    isLuminance: Boolean;
    isCube: Boolean;
  end;

//BABYLON.Internals

type
  JTGATools = class external 'TGATools'
    _TYPE_NO_DATA: Variant;
    _TYPE_INDEXED: Variant;
    _TYPE_RGB: Variant;
    _TYPE_GREY: Variant;
    _TYPE_RLE_INDEXED: Variant;
    _TYPE_RLE_RGB: Variant;
    _TYPE_RLE_GREY: Variant;
    _ORIGIN_MASK: Variant;
    _ORIGIN_SHIFT: Variant;
    _ORIGIN_BL: Variant;
    _ORIGIN_BR: Variant;
    _ORIGIN_UL: Variant;
    _ORIGIN_UR: Variant;
    function GetTGAHeader(data: JUint8Array): Variant;
    procedure UploadContent(gl: JWebGLRenderingContext; data: JUint8Array);
    function _getImageData8bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
    function _getImageData16bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
    function _getImageData24bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
    function _getImageData32bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
    function _getImageDataGrey8bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
    function _getImageDataGrey16bits(header: Variant; palettes: JUint8Array; pixel_data: JUint8Array; y_start: Float; y_step: Float; y_end: Float; x_start: Float; x_step: Float; x_end: Float): JUint8Array;
  end;

//BABYLON

type
  JTools = class external 'Tools'
    BaseUrl: String;
    function ToHex(i: Float): String;
    procedure SetImmediate(action: );
    function IsExponantOfTwo(value: Float): Boolean;
    function GetExponantOfTwo(value: Float; max: Float): Float;
    function GetFilename(path: String): String;
    function GetDOMTextContent(element: JHTMLElement): String;
    function ToDegrees(angle: Float): Float;
    function ToRadians(angle: Float): Float;
    function ExtractMinAndMaxIndexed(positions: array of Float; indices: array of Float; indexStart: Float; indexCount: Float):       minimum: JVector3;
      maximum: JVector3;
    end;;
    function ExtractMinAndMax(positions: array of Float; start: Float; count: Float):       minimum: JVector3;
      maximum: JVector3;
    end;;
    function MakeArray(obj: Variant): JArray{<Variant>}; overload;
    function MakeArray(obj: Variant; allowsNullUndefined: Boolean): JArray{<Variant>}; overload;
    function GetPointerPrefix: String;
    procedure QueueNewFrame(func: Variant);
    procedure RequestFullscreen(element: Variant);
    procedure ExitFullscreen;
    function CleanUrl(url: String): String;
    function LoadImage(url: String; onload: Variant; onerror: Variant; database: Variant): JHTMLImageElement;
    procedure LoadFile(url: String; callback: (data: Variant)); overload;
    procedure LoadFile(url: String; callback: (data: Variant); progressCallBack: ); overload;
    procedure LoadFile(url: String; callback: (data: Variant); progressCallBack: ; database: Variant); overload;
    procedure LoadFile(url: String; callback: (data: Variant); progressCallBack: ; database: Variant; useArrayBuffer: Boolean); overload;
    procedure LoadFile(url: String; callback: (data: Variant); progressCallBack: ; database: Variant; useArrayBuffer: Boolean; onError: ); overload;
    procedure ReadFileAsDataURL(fileToLoad: Variant; callback: Variant; progressCallback: Variant);
    procedure ReadFile(fileToLoad: Variant; callback: Variant; progressCallBack: Variant); overload;
    procedure ReadFile(fileToLoad: Variant; callback: Variant; progressCallBack: Variant; useArrayBuffer: Boolean); overload;
    function Clamp(value: Float): Float; overload;
    function Clamp(value: Float; min: Float): Float; overload;
    function Clamp(value: Float; min: Float; max: Float): Float; overload;
    function Sign(value: Float): Float;
    function Format(value: Float): String; overload;
    function Format(value: Float; decimals: Float): String; overload;
    procedure CheckExtends(v: JVector3; min: JVector3; max: JVector3);
    function WithinEpsilon(a: Float; b: Float): Boolean; overload;
    function WithinEpsilon(a: Float; b: Float; epsilon: Float): Boolean; overload;
    procedure DeepCopy(source: Variant; destination: Variant); overload;
    procedure DeepCopy(source: Variant; destination: Variant; doNotCopyList: array of String); overload;
    procedure DeepCopy(source: Variant; destination: Variant; doNotCopyList: array of String; mustCopyList: array of String); overload;
    function IsEmpty(obj: Variant): Boolean;
    procedure RegisterTopRootEvents(events: array of       name: String;
      handler: JEventListener;
    end;);
    procedure UnregisterTopRootEvents(events: array of       name: String;
      handler: JEventListener;
    end;);
    procedure DumpFramebuffer(width: Float; height: Float; engine: JEngine); overload;
    procedure DumpFramebuffer(width: Float; height: Float; engine: JEngine; successCallback: (data: JString)); overload;
    procedure CreateScreenshot(engine: JEngine; camera: JCamera; size: Variant); overload;
    procedure CreateScreenshot(engine: JEngine; camera: JCamera; size: Variant; successCallback: (data: JString)); overload;
    function ValidateXHRData(xhr: JXMLHttpRequest): Boolean; overload;
    function ValidateXHRData(xhr: JXMLHttpRequest; dataType: Float): Boolean; overload;
    _NoneLogLevel: Variant;
    _MessageLogLevel: Variant;
    _WarningLogLevel: Variant;
    _ErrorLogLevel: Variant;
    _LogCache: Variant;
    errorsCount: Float;
    OnNewCacheEntry: (entry: String);
    NoneLogLevel: Float;
    MessageLogLevel: Float;
    WarningLogLevel: Float;
    ErrorLogLevel: Float;
    AllLogLevel: Float;
    procedure _AddLogEntry(entry: Variant);
    procedure _FormatMessage(message: Variant);
    Log: (message: String);
    procedure _LogDisabled(message: Variant);
    procedure _LogEnabled(message: Variant);
    Warn: (message: String);
    procedure _WarnDisabled(message: Variant);
    procedure _WarnEnabled(message: Variant);
    Error: (message: String);
    procedure _ErrorDisabled(message: Variant);
    procedure _ErrorEnabled(message: Variant);
    LogCache: String;
    procedure ClearLogCache;
    LogLevels: Float;
    _PerformanceNoneLogLevel: Variant;
    _PerformanceUserMarkLogLevel: Variant;
    _PerformanceConsoleLogLevel: Variant;
    _performance: Variant;
    PerformanceNoneLogLevel: Float;
    PerformanceUserMarkLogLevel: Float;
    PerformanceConsoleLogLevel: Float;
    PerformanceLogLevel: Float;
    procedure _StartPerformanceCounterDisabled(counterName: String); overload;
    procedure _StartPerformanceCounterDisabled(counterName: String; condition: Boolean); overload;
    procedure _EndPerformanceCounterDisabled(counterName: String); overload;
    procedure _EndPerformanceCounterDisabled(counterName: String; condition: Boolean); overload;
    procedure _StartUserMark(counterName: String); overload;
    procedure _StartUserMark(counterName: String; condition: Boolean); overload;
    procedure _EndUserMark(counterName: String); overload;
    procedure _EndUserMark(counterName: String; condition: Boolean); overload;
    procedure _StartPerformanceConsole(counterName: String); overload;
    procedure _StartPerformanceConsole(counterName: String; condition: Boolean); overload;
    procedure _EndPerformanceConsole(counterName: String); overload;
    procedure _EndPerformanceConsole(counterName: String; condition: Boolean); overload;
    StartPerformanceCounter: (counterName: String; condition: Boolean);
    EndPerformanceCounter: (counterName: String; condition: Boolean);
    Now: Float;
    function GetFps: Float;
  end;

  JAsyncLoop = class external 'AsyncLoop'
    iterations: Float;
    _fn: Variant;
    _successCallback: Variant;
    index: Float;
    _done: Variant;
    constructor Create(iterations: Float; _fn: (asyncLoop: JAsyncLoop); _successCallback: ; offset: Float);
    procedure executeNext;
    procedure breakLoop;
    function Run(iterations: Float; _fn: (asyncLoop: JAsyncLoop); _successCallback: ): JAsyncLoop; overload;
    function Run(iterations: Float; _fn: (asyncLoop: JAsyncLoop); _successCallback: ; offset: Float): JAsyncLoop; overload;
    procedure SyncAsyncForLoop(iterations: Float; syncedIterations: Float; fn: (iteration: Float); callback: ); overload;
    procedure SyncAsyncForLoop(iterations: Float; syncedIterations: Float; fn: (iteration: Float); callback: ; breakFunction: : Boolean); overload;
    procedure SyncAsyncForLoop(iterations: Float; syncedIterations: Float; fn: (iteration: Float); callback: ; breakFunction: : Boolean; timeout: Float); overload;
  end;

  JIAnimatable = class external
    animations: JArray{<JAnimation>};
  end;

  JISize = class external
    width: Float;
    height: Float;
  end;

//BABYLON

type
  JVirtualJoystick = class external 'VirtualJoystick'
    reverseLeftRight: Boolean;
    reverseUpDown: Boolean;
    deltaPosition: JVector3;
    pressed: Boolean;
    _globalJoystickIndex: Variant;
    vjCanvas: Variant;
    vjCanvasContext: Variant;
    vjCanvasWidth: Variant;
    vjCanvasHeight: Variant;
    halfWidth: Variant;
    halfHeight: Variant;
    _action: Variant;
    _axisTargetedByLeftAndRight: Variant;
    _axisTargetedByUpAndDown: Variant;
    _joystickSensibility: Variant;
    _inversedSensibility: Variant;
    _rotationSpeed: Variant;
    _inverseRotationSpeed: Variant;
    _rotateOnAxisRelativeToMesh: Variant;
    _joystickPointerID: Variant;
    _joystickColor: Variant;
    _joystickPointerPos: Variant;
    _joystickPreviousPointerPos: Variant;
    _joystickPointerStartPos: Variant;
    _deltaJoystickVector: Variant;
    _leftJoystick: Variant;
    _joystickIndex: Variant;
    _touches: Variant;
    _onPointerDownHandlerRef: Variant;
    _onPointerMoveHandlerRef: Variant;
    _onPointerUpHandlerRef: Variant;
    _onPointerOutHandlerRef: Variant;
    _onResize: Variant;
    constructor Create(leftJoystick: Boolean);
    procedure setJoystickSensibility(newJoystickSensibility: Float);
    procedure _onPointerDown(e: Variant);
    procedure _onPointerMove(e: Variant);
    procedure _onPointerUp(e: Variant);
    procedure setJoystickColor(newColor: String);
    procedure setActionOnTouch(action: : Variant);
    procedure setAxisForLeftRight(axis: JJoystickAxis);
    procedure setAxisForUpDown(axis: JJoystickAxis);
    procedure _clearCanvas;
    procedure _drawVirtualJoystick;
    procedure releaseCanvas;
  end;

//BABYLON

type
  JVRDeviceOrientationFreeCamera = class external 'VRDeviceOrientationFreeCamera'(JFreeCamera)
    _alpha: Float;
    _beta: Float;
    _gamma: Float;
    _offsetOrientation: Variant;
    _deviceOrientationHandler: Variant;
    constructor Create(name: String; position: JVector3; scene: JScene; compensateDistorsion: Boolean);
    procedure _onOrientationEvent(evt: JDeviceOrientationEvent);
    procedure attachControl(element: JHTMLElement); overload;
    procedure attachControl(element: JHTMLElement; noPreventDefault: Boolean); overload;
    procedure detachControl(element: JHTMLElement);
  end;

HMDVRDevice: Variant;
PositionSensorVRDevice: Variant;
//BABYLON

type
  JWebVRFreeCamera = class external 'WebVRFreeCamera'(JFreeCamera)
    _hmdDevice: Variant;
    _sensorDevice: Variant;
    _cacheState: Variant;
    _cacheQuaternion: JQuaternion;
    _cacheRotation: JVector3;
    _vrEnabled: Boolean;
    constructor Create(name: String; position: JVector3; scene: JScene; compensateDistorsion: Boolean);
    procedure _getWebVRDevices(devices: Variant);
    procedure _checkInputs;
    procedure attachControl(element: JHTMLElement); overload;
    procedure attachControl(element: JHTMLElement; noPreventDefault: Boolean); overload;
    procedure detachControl(element: JHTMLElement);
  end;

//BABYLON

type
  JOctree = class external 'Octree'
    maxDepth: Float;
    blocks: JArray{<JOctreeBlock{<JT>}>};
    dynamicContent: array of JT;
    _maxBlockCapacity: Variant;
    _selectionContent: Variant;
    _creationFunc: Variant;
    constructor Create(creationFunc: (entry: JT; block: JOctreeBlock{<JT>}); maxBlockCapacity: Float; maxDepth: Float);
    procedure update(worldMin: JVector3; worldMax: JVector3; entries: array of JT);
    procedure addMesh(entry: JT);
    function select(frustumPlanes: array of JPlane): JSmartArray{<JT>}; overload;
    function select(frustumPlanes: array of JPlane; allowDuplicate: Boolean): JSmartArray{<JT>}; overload;
    function intersects(sphereCenter: JVector3; sphereRadius: Float): JSmartArray{<JT>}; overload;
    function intersects(sphereCenter: JVector3; sphereRadius: Float; allowDuplicate: Boolean): JSmartArray{<JT>}; overload;
    function intersectsRay(ray: JRay): JSmartArray{<JT>};
    procedure _CreateBlocks(worldMin: JVector3; worldMax: JVector3; entries: array of JT; maxBlockCapacity: Float; currentDepth: Float; maxDepth: Float; target: JIOctreeContainer{<JT>}; creationFunc: (entry: JT; block: JOctreeBlock{<JT>}));
    CreationFuncForMeshes: (entry: JAbstractMesh; block: JOctreeBlock{<JAbstractMesh>});
    CreationFuncForSubMeshes: (entry: JSubMesh; block: JOctreeBlock{<JSubMesh>});
  end;

  JIOctreeContainer{<T>} = class external
    blocks: JArray{<JOctreeBlock{<JT>}>};
  end;

//BABYLON

type
  JOctreeBlock = class external 'OctreeBlock'
    entries: array of JT;
    blocks: JArray{<JOctreeBlock{<JT>}>};
    _depth: Variant;
    _maxDepth: Variant;
    _capacity: Variant;
    _minPoint: Variant;
    _maxPoint: Variant;
    _boundingVectors: Variant;
    _creationFunc: Variant;
    constructor Create(minPoint: JVector3; maxPoint: JVector3; capacity: Float; depth: Float; maxDepth: Float; creationFunc: (entry: JT; block: JOctreeBlock{<JT>}));
    capacity: Float;
    minPoint: JVector3;
    maxPoint: JVector3;
    procedure addEntry(entry: JT);
    procedure addEntries(entries: array of JT);
    procedure select(frustumPlanes: array of JPlane; selection: JSmartArray{<JT>}); overload;
    procedure select(frustumPlanes: array of JPlane; selection: JSmartArray{<JT>}; allowDuplicate: Boolean); overload;
    procedure intersects(sphereCenter: JVector3; sphereRadius: Float; selection: JSmartArray{<JT>}); overload;
    procedure intersects(sphereCenter: JVector3; sphereRadius: Float; selection: JSmartArray{<JT>}; allowDuplicate: Boolean); overload;
    procedure intersectsRay(ray: JRay; selection: JSmartArray{<JT>});
    procedure createInnerBlocks;
  end;

//BABYLON

type
  JShadowGenerator = class external 'ShadowGenerator'
    _FILTER_NONE: Variant;
    _FILTER_VARIANCESHADOWMAP: Variant;
    _FILTER_POISSONSAMPLING: Variant;
    _FILTER_BLURVARIANCESHADOWMAP: Variant;
    FILTER_NONE: Float;
    FILTER_VARIANCESHADOWMAP: Float;
    FILTER_POISSONSAMPLING: Float;
    FILTER_BLURVARIANCESHADOWMAP: Float;
    _filter: Variant;
    blurScale: Float;
    _blurBoxOffset: Variant;
    _bias: Variant;
    _lightDirection: Variant;
    bias: Float;
    blurBoxOffset: Float;
    filter: Float;
    useVarianceShadowMap: Boolean;
    usePoissonSampling: Boolean;
    useBlurVarianceShadowMap: Boolean;
    _light: Variant;
    _scene: Variant;
    _shadowMap: Variant;
    _shadowMap2: Variant;
    _darkness: Variant;
    _transparencyShadow: Variant;
    _effect: Variant;
    _viewMatrix: Variant;
    _projectionMatrix: Variant;
    _transformMatrix: Variant;
    _worldViewProjection: Variant;
    _cachedPosition: Variant;
    _cachedDirection: Variant;
    _cachedDefines: Variant;
    _currentRenderID: Variant;
    _downSamplePostprocess: Variant;
    _boxBlurPostprocess: Variant;
    _mapSize: Variant;
    constructor Create(mapSize: Float; light: JIShadowLight);
    function isReady(subMesh: JSubMesh; useInstances: Boolean): Boolean;
    function getShadowMap: JRenderTargetTexture;
    function getShadowMapForRendering: JRenderTargetTexture;
    function getLight: JIShadowLight;
    function getTransformMatrix: JMatrix;
    function getDarkness: Float;
    procedure setDarkness(darkness: Float);
    procedure setTransparencyShadow(hasShadow: Boolean);
    procedure _packHalf(depth: Variant);
    procedure dispose;
  end;

//BABYLON.Internals

//BABYLON

type
  JBaseTexture = class external 'BaseTexture'
    name: String;
    delayLoadState: Float;
    hasAlpha: Boolean;
    getAlphaFromRGB: Boolean;
    level: Float;
    isCube: Boolean;
    isRenderTarget: Boolean;
    animations: array of JAnimation;
    onDispose: ;
    coordinatesIndex: Float;
    coordinatesMode: Float;
    wrapU: Float;
    wrapV: Float;
    uScale: Float;
    vScale: Float;
    anisotropicFilteringLevel: Float;
    _cachedAnisotropicFilteringLevel: Float;
    _scene: Variant;
    _texture: JWebGLTexture;
    constructor Create(scene: JScene);
    function getScene: JScene;
    function getTextureMatrix: JMatrix;
    function getReflectionTextureMatrix: JMatrix;
    function getInternalTexture: JWebGLTexture;
    function isReady: Boolean;
    function getSize: JISize;
    function getBaseSize: JISize;
    procedure scale(ratio: Float);
    canRescale: Boolean;
    procedure _removeFromCache(url: String; noMipmap: Boolean);
    function _getFromCache(url: String; noMipmap: Boolean): JWebGLTexture; overload;
    function _getFromCache(url: String; noMipmap: Boolean; sampling: Float): JWebGLTexture; overload;
    procedure delayLoad;
    procedure releaseInternalTexture;
    function clone: JBaseTexture;
    procedure dispose;
  end;

//BABYLON

type
  JCubeTexture = class external 'CubeTexture'(JBaseTexture)
    url: String;
    coordinatesMode: Float;
    _noMipmap: Variant;
    _extensions: Variant;
    _textureMatrix: Variant;
    constructor Create(rootUrl: String; scene: JScene; extensions: array of String; noMipmap: Boolean);
    function clone: JCubeTexture;
    procedure delayLoad;
    function getReflectionTextureMatrix: JMatrix;
  end;

//BABYLON

type
  JDynamicTexture = class external 'DynamicTexture'(JTexture)
    _generateMipMaps: Variant;
    _canvas: Variant;
    _context: Variant;
    constructor Create(name: String; options: Variant; scene: JScene; generateMipMaps: Boolean; samplingMode: Float);
    canRescale: Boolean;
    procedure scale(ratio: Float);
    function getContext: JCanvasRenderingContext2D;
    procedure clear;
    procedure update; overload;
    procedure update(invertY: Boolean); overload;
    procedure drawText(text: String; x: Float; y: Float; font: String; color: String; clearColor: String); overload;
    procedure drawText(text: String; x: Float; y: Float; font: String; color: String; clearColor: String; invertY: Boolean); overload;
    procedure drawText(text: String; x: Float; y: Float; font: String; color: String; clearColor: String; invertY: Boolean; update: Boolean); overload;
    function clone: JDynamicTexture;
  end;

//BABYLON

type
  JMirrorTexture = class external 'MirrorTexture'(JRenderTargetTexture)
    mirrorPlane: JPlane;
    _transformMatrix: Variant;
    _mirrorMatrix: Variant;
    _savedViewMatrix: Variant;
    constructor Create(name: String; size: Float; scene: JScene; generateMipMaps: Boolean);
    function clone: JMirrorTexture;
  end;

//BABYLON

type
  JRawTexture = class external 'RawTexture'(JTexture)
    format: Float;
    constructor Create(data: JArrayBufferView; width: Float; height: Float; format: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float);
    procedure update(data: JArrayBufferView);
    function CreateLuminanceTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene): JRawTexture; overload;
    function CreateLuminanceTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean): JRawTexture; overload;
    function CreateLuminanceTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean): JRawTexture; overload;
    function CreateLuminanceTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JRawTexture; overload;
    function CreateLuminanceAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene): JRawTexture; overload;
    function CreateLuminanceAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean): JRawTexture; overload;
    function CreateLuminanceAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean): JRawTexture; overload;
    function CreateLuminanceAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JRawTexture; overload;
    function CreateAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene): JRawTexture; overload;
    function CreateAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean): JRawTexture; overload;
    function CreateAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean): JRawTexture; overload;
    function CreateAlphaTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JRawTexture; overload;
    function CreateRGBTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene): JRawTexture; overload;
    function CreateRGBTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean): JRawTexture; overload;
    function CreateRGBTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean): JRawTexture; overload;
    function CreateRGBTexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JRawTexture; overload;
    function CreateRGBATexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene): JRawTexture; overload;
    function CreateRGBATexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean): JRawTexture; overload;
    function CreateRGBATexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean): JRawTexture; overload;
    function CreateRGBATexture(data: JArrayBufferView; width: Float; height: Float; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float): JRawTexture; overload;
  end;

//BABYLON

type
  JRenderTargetTexture = class external 'RenderTargetTexture'(JTexture)
    renderList: array of JAbstractMesh;
    renderParticles: Boolean;
    renderSprites: Boolean;
    coordinatesMode: Float;
    onBeforeRender: ;
    onAfterRender: ;
    onAfterUnbind: ;
    onClear: (engine: JEngine);
    activeCamera: JCamera;
    customRenderFunction: (opaqueSubMeshes: JSmartArray{<JSubMesh>}; transparentSubMeshes: JSmartArray{<JSubMesh>}; alphaTestSubMeshes: JSmartArray{<JSubMesh>}; beforeTransparents: );
    _size: Variant;
    _generateMipMaps: Boolean;
    _renderingManager: Variant;
    _waitingRenderList: array of String;
    _doNotChangeAspectRatio: Variant;
    _currentRefreshId: Variant;
    _refreshRate: Variant;
    constructor Create(name: String; size: Variant; scene: JScene; generateMipMaps: Boolean; doNotChangeAspectRatio: Boolean; &type: Float);
    procedure resetRefreshCounter;
    refreshRate: Float;
    function _shouldRender: Boolean;
    function isReady: Boolean;
    function getRenderSize: Float;
    canRescale: Boolean;
    procedure scale(ratio: Float);
    procedure resize(size: Variant); overload;
    procedure resize(size: Variant; generateMipMaps: Boolean); overload;
    procedure render; overload;
    procedure render(useCameraPostProcess: Boolean); overload;
    procedure render(useCameraPostProcess: Boolean; dumpForDebug: Boolean); overload;
    function clone: JRenderTargetTexture;
  end;

//BABYLON

type
  JTexture = class external 'Texture'(JBaseTexture)
    NEAREST_SAMPLINGMODE: Float;
    BILINEAR_SAMPLINGMODE: Float;
    TRILINEAR_SAMPLINGMODE: Float;
    EXPLICIT_MODE: Float;
    SPHERICAL_MODE: Float;
    PLANAR_MODE: Float;
    CUBIC_MODE: Float;
    PROJECTION_MODE: Float;
    SKYBOX_MODE: Float;
    CLAMP_ADDRESSMODE: Float;
    WRAP_ADDRESSMODE: Float;
    MIRROR_ADDRESSMODE: Float;
    url: String;
    uOffset: Float;
    vOffset: Float;
    uScale: Float;
    vScale: Float;
    uAng: Float;
    vAng: Float;
    wAng: Float;
    _noMipmap: Variant;
    _invertY: Boolean;
    _rowGenerationMatrix: Variant;
    _cachedTextureMatrix: Variant;
    _projectionModeMatrix: Variant;
    _t0: Variant;
    _t1: Variant;
    _t2: Variant;
    _cachedUOffset: Variant;
    _cachedVOffset: Variant;
    _cachedUScale: Variant;
    _cachedVScale: Variant;
    _cachedUAng: Variant;
    _cachedVAng: Variant;
    _cachedWAng: Variant;
    _cachedCoordinatesMode: Variant;
    _samplingMode: Float;
    _buffer: Variant;
    _deleteBuffer: Variant;
    constructor Create(url: String; scene: JScene; noMipmap: Boolean; invertY: Boolean; samplingMode: Float; onLoad: ; onError: ; buffer: Variant; deleteBuffer: Boolean);
    procedure delayLoad;
    procedure updateSamplingMode(samplingMode: Float);
    procedure _prepareRowForTextureGeneration(x: Variant; y: Variant; z: Variant; t: Variant);
    function getTextureMatrix: JMatrix;
    function getReflectionTextureMatrix: JMatrix;
    function clone: JTexture;
    function CreateFromBase64String(data: String; name: String; scene: JScene): JTexture; overload;
    function CreateFromBase64String(data: String; name: String; scene: JScene; noMipmap: Boolean): JTexture; overload;
    function CreateFromBase64String(data: String; name: String; scene: JScene; noMipmap: Boolean; invertY: Boolean): JTexture; overload;
    function CreateFromBase64String(data: String; name: String; scene: JScene; noMipmap: Boolean; invertY: Boolean; samplingMode: Float): JTexture; overload;
    function CreateFromBase64String(data: String; name: String; scene: JScene; noMipmap: Boolean; invertY: Boolean; samplingMode: Float; onLoad: ): JTexture; overload;
    function CreateFromBase64String(data: String; name: String; scene: JScene; noMipmap: Boolean; invertY: Boolean; samplingMode: Float; onLoad: ; onError: ): JTexture; overload;
  end;

//BABYLON

type
  JVideoTexture = class external 'VideoTexture'(JTexture)
    video: JHTMLVideoElement;
    _autoLaunch: Variant;
    _lastUpdate: Variant;
    constructor Create(name: String; urls: array of String; scene: JScene; generateMipMaps: Boolean; invertY: Boolean; samplingMode: Float);
    function update: Boolean;
  end;

//BABYLON

type
  JCannonJSPlugin = class external 'CannonJSPlugin'
    checkWithEpsilon: (value: Float): Float;
    _world: Variant;
    _registeredMeshes: Variant;
    _physicsMaterials: Variant;
    procedure initialize; overload;
    procedure initialize(iterations: Float); overload;
    procedure _checkWithEpsilon(value: Variant);
    procedure runOneStep(delta: Float);
    procedure setGravity(gravity: JVector3);
    function registerMesh(mesh: JAbstractMesh; impostor: Float): Variant; overload;
    function registerMesh(mesh: JAbstractMesh; impostor: Float; options: JPhysicsBodyCreationOptions): Variant; overload;
    procedure _createSphere(radius: Variant; mesh: Variant); overload;
    procedure _createSphere(radius: Variant; mesh: Variant; options: Variant); overload;
    procedure _createBox(x: Variant; y: Variant; z: Variant; mesh: Variant); overload;
    procedure _createBox(x: Variant; y: Variant; z: Variant; mesh: Variant; options: Variant); overload;
    procedure _createPlane(mesh: Variant); overload;
    procedure _createPlane(mesh: Variant; options: Variant); overload;
    procedure _createConvexPolyhedron(rawVerts: Variant; rawFaces: Variant; mesh: Variant); overload;
    procedure _createConvexPolyhedron(rawVerts: Variant; rawFaces: Variant; mesh: Variant; options: Variant); overload;
    procedure _addMaterial(friction: Variant; restitution: Variant);
    procedure _createRigidBodyFromShape(shape: Variant; mesh: Variant; mass: Variant; friction: Variant; restitution: Variant);
    function registerMeshesAsCompound(parts: array of JPhysicsCompoundBodyPart; options: JPhysicsBodyCreationOptions): Variant;
    procedure _unbindBody(body: Variant);
    procedure unregisterMesh(mesh: JAbstractMesh);
    procedure applyImpulse(mesh: JAbstractMesh; force: JVector3; contactPoint: JVector3);
    updateBodyPosition: (mesh: JAbstractMesh);
    function createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3): Boolean;
    procedure dispose;
    function isSupported: Boolean;
  end;

//BABYLON

type
  JOimoJSPlugin = class external 'OimoJSPlugin'
    _world: Variant;
    _registeredMeshes: Variant;
    procedure _checkWithEpsilon(value: Variant);
    procedure initialize; overload;
    procedure initialize(iterations: Float); overload;
    procedure setGravity(gravity: JVector3);
    function registerMesh(mesh: JAbstractMesh; impostor: Float; options: JPhysicsBodyCreationOptions): Variant;
    function registerMeshesAsCompound(parts: array of JPhysicsCompoundBodyPart; options: JPhysicsBodyCreationOptions): Variant;
    procedure _createBodyAsCompound(part: Variant; options: Variant; initialMesh: Variant);
    procedure unregisterMesh(mesh: JAbstractMesh);
    procedure _unbindBody(body: Variant);
    updateBodyPosition: (mesh: JAbstractMesh);
    procedure applyImpulse(mesh: JAbstractMesh; force: JVector3; contactPoint: JVector3);
    function createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3): Boolean; overload;
    function createLink(mesh1: JAbstractMesh; mesh2: JAbstractMesh; pivot1: JVector3; pivot2: JVector3; options: Variant): Boolean; overload;
    procedure dispose;
    function isSupported: Boolean;
    procedure _getLastShape(body: Variant);
    procedure runOneStep(time: Float);
  end;

//BABYLON

type
  JPostProcessRenderEffect = class external 'PostProcessRenderEffect'
    _engine: Variant;
    _postProcesses: Variant;
    _getPostProcess: Variant;
    _singleInstance: Variant;
    _cameras: Variant;
    _indicesForCamera: Variant;
    _renderPasses: Variant;
    _renderEffectAsPasses: Variant;
    _name: String;
    applyParameters: (postProcess: JPostProcess);
    constructor Create(engine: JEngine; name: String; getPostProcess: : JPostProcess; singleInstance: Boolean);
    procedure _update;
    procedure addPass(renderPass: JPostProcessRenderPass);
    procedure removePass(renderPass: JPostProcessRenderPass);
    procedure addRenderEffectAsPass(renderEffect: JPostProcessRenderEffect);
    procedure getPass(passName: String);
    procedure emptyPasses;
    function _attachCameras(cameras: JCamera): Variant;
    function _attachCameras(cameras: array of JCamera): Variant;
    function _detachCameras(cameras: JCamera): Variant;
    function _detachCameras(cameras: array of JCamera): Variant;
    function _enable(cameras: JCamera): Variant;
    function _enable(cameras: array of JCamera): Variant;
    function _disable(cameras: JCamera): Variant;
    function _disable(cameras: array of JCamera): Variant;
    function getPostProcess: JPostProcess; overload;
    function getPostProcess(camera: JCamera): JPostProcess; overload;
    procedure _linkParameters;
    procedure _linkTextures(effect: Variant);
  end;

//BABYLON

type
  JPostProcessRenderPass = class external 'PostProcessRenderPass'
    _enabled: Variant;
    _renderList: Variant;
    _renderTexture: Variant;
    _scene: Variant;
    _refCount: Variant;
    _name: String;
    constructor Create(scene: JScene; name: String; size: Float; renderList: array of JMesh; beforeRender: ; afterRender: );
    function _incRefCount: Float;
    function _decRefCount: Float;
    procedure _update;
    procedure setRenderList(renderList: array of JMesh);
    function getRenderTexture: JRenderTargetTexture;
  end;

//BABYLON

type
  JPostProcessRenderPipeline = class external 'PostProcessRenderPipeline'
    _engine: Variant;
    _renderEffects: Variant;
    _renderEffectsForIsolatedPass: Variant;
    _cameras: Variant;
    _name: String;
    PASS_EFFECT_NAME: Variant;
    PASS_SAMPLER_NAME: Variant;
    constructor Create(engine: JEngine; name: String);
    procedure addEffect(renderEffect: JPostProcessRenderEffect);
    function _enableEffect(renderEffectName: String; cameras: JCamera): Variant;
    function _enableEffect(renderEffectName: String; cameras: array of JCamera): Variant;
    function _disableEffect(renderEffectName: String; cameras: JCamera): Variant;
    function _disableEffect(renderEffectName: String; cameras: array of JCamera): Variant;
    function _attachCameras(cameras: JCamera; unique: Boolean): Variant;
    function _attachCameras(cameras: array of JCamera; unique: Boolean): Variant;
    function _detachCameras(cameras: JCamera): Variant;
    function _detachCameras(cameras: array of JCamera): Variant;
    function _enableDisplayOnlyPass(passName: Variant; cameras: JCamera): Variant;
    function _enableDisplayOnlyPass(passName: Variant; cameras: array of JCamera): Variant;
    function _disableDisplayOnlyPass(cameras: JCamera): Variant;
    function _disableDisplayOnlyPass(cameras: array of JCamera): Variant;
    procedure _update;
  end;

//BABYLON

type
  JPostProcessRenderPipelineManager = class external 'PostProcessRenderPipelineManager'
    _renderPipelines: Variant;
    constructor Create;
    procedure addPipeline(renderPipeline: JPostProcessRenderPipeline);
    function attachCamerasToRenderPipeline(renderPipelineName: String; cameras: JCamera): Variant; overload;
    function attachCamerasToRenderPipeline(renderPipelineName: String; cameras: JCamera; unique: Boolean): Variant; overload;
    function attachCamerasToRenderPipeline(renderPipelineName: String; cameras: array of JCamera): Variant; overload;
    function attachCamerasToRenderPipeline(renderPipelineName: String; cameras: array of JCamera; unique: Boolean): Variant; overload;
    function detachCamerasFromRenderPipeline(renderPipelineName: String; cameras: JCamera): Variant;
    function detachCamerasFromRenderPipeline(renderPipelineName: String; cameras: array of JCamera): Variant;
    function enableEffectInPipeline(renderPipelineName: String; renderEffectName: String; cameras: JCamera): Variant;
    function enableEffectInPipeline(renderPipelineName: String; renderEffectName: String; cameras: array of JCamera): Variant;
    function disableEffectInPipeline(renderPipelineName: String; renderEffectName: String; cameras: JCamera): Variant;
    function disableEffectInPipeline(renderPipelineName: String; renderEffectName: String; cameras: array of JCamera): Variant;
    function enableDisplayOnlyPassInPipeline(renderPipelineName: String; passName: String; cameras: JCamera): Variant;
    function enableDisplayOnlyPassInPipeline(renderPipelineName: String; passName: String; cameras: array of JCamera): Variant;
    function disableDisplayOnlyPassInPipeline(renderPipelineName: String; cameras: JCamera): Variant;
    function disableDisplayOnlyPassInPipeline(renderPipelineName: String; cameras: array of JCamera): Variant;
    procedure update;
  end;

//BABYLON

type
  JCustomProceduralTexture = class external 'CustomProceduralTexture'(JProceduralTexture)
    _animate: Variant;
    _time: Variant;
    _config: Variant;
    _texturePath: Variant;
    constructor Create(name: String; texturePath: Variant; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure loadJson(jsonUrl: Variant);
    function isReady: Boolean;
    procedure render; overload;
    procedure render(useCameraPostProcess: Boolean); overload;
    procedure updateTextures;
    procedure updateShaderUniforms;
    animate: Boolean;
  end;

//BABYLON

type
  JProceduralTexture = class external 'ProceduralTexture'(JTexture)
    _size: Variant;
    _generateMipMaps: Boolean;
    isEnabled: Boolean;
    _doNotChangeAspectRatio: Variant;
    _currentRefreshId: Variant;
    _refreshRate: Variant;
    _vertexBuffer: Variant;
    _indexBuffer: Variant;
    _effect: Variant;
    _vertexDeclaration: Variant;
    _vertexStrideSize: Variant;
    _uniforms: Variant;
    _samplers: Variant;
    _fragment: Variant;
    _textures: array of JTexture;
    _floats: Variant;
    _floatsArrays: Variant;
    _colors3: Variant;
    _colors4: Variant;
    _vectors2: Variant;
    _vectors3: Variant;
    _matrices: Variant;
    _fallbackTexture: Variant;
    _fallbackTextureUsed: Variant;
    constructor Create(name: String; size: Variant; fragment: Variant; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure reset;
    function isReady: Boolean;
    procedure resetRefreshCounter;
    procedure setFragment(fragment: Variant);
    refreshRate: Float;
    function _shouldRender: Boolean;
    function getRenderSize: Float;
    procedure resize(size: Variant; generateMipMaps: Variant);
    procedure _checkUniform(uniformName: Variant);
    function setTexture(name: String; texture: JTexture): JProceduralTexture;
    function setFloat(name: String; value: Float): JProceduralTexture;
    function setFloats(name: String; value: array of Float): JProceduralTexture;
    function setColor3(name: String; value: JColor3): JProceduralTexture;
    function setColor4(name: String; value: JColor4): JProceduralTexture;
    function setVector2(name: String; value: JVector2): JProceduralTexture;
    function setVector3(name: String; value: JVector3): JProceduralTexture;
    function setMatrix(name: String; value: JMatrix): JProceduralTexture;
    procedure render; overload;
    procedure render(useCameraPostProcess: Boolean); overload;
    function clone: JProceduralTexture;
    procedure dispose;
  end;

//BABYLON

type
  JWoodProceduralTexture = class external 'WoodProceduralTexture'(JProceduralTexture)
    _ampScale: Variant;
    _woodColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    ampScale: Float;
    woodColor: JColor3;
  end;

  JFireProceduralTexture = class external 'FireProceduralTexture'(JProceduralTexture)
    _time: Variant;
    _speed: Variant;
    _autoGenerateTime: Variant;
    _fireColors: Variant;
    _alphaThreshold: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    procedure render; overload;
    procedure render(useCameraPostProcess: Boolean); overload;
    PurpleFireColors: array of JColor3;
    GreenFireColors: array of JColor3;
    RedFireColors: array of JColor3;
    BlueFireColors: array of JColor3;
    fireColors: array of JColor3;
    time: Float;
    speed: JVector2;
    alphaThreshold: Float;
  end;

  JCloudProceduralTexture = class external 'CloudProceduralTexture'(JProceduralTexture)
    _skyColor: Variant;
    _cloudColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    skyColor: JColor4;
    cloudColor: JColor4;
  end;

  JGrassProceduralTexture = class external 'GrassProceduralTexture'(JProceduralTexture)
    _grassColors: Variant;
    _herb1: Variant;
    _herb2: Variant;
    _herb3: Variant;
    _groundColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    grassColors: array of JColor3;
    groundColor: JColor3;
  end;

  JRoadProceduralTexture = class external 'RoadProceduralTexture'(JProceduralTexture)
    _roadColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    roadColor: JColor3;
  end;

  JBrickProceduralTexture = class external 'BrickProceduralTexture'(JProceduralTexture)
    _numberOfBricksHeight: Variant;
    _numberOfBricksWidth: Variant;
    _jointColor: Variant;
    _brickColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    numberOfBricksHeight: Float;
    numberOfBricksWidth: Float;
    jointColor: JColor3;
    brickColor: JColor3;
  end;

  JMarbleProceduralTexture = class external 'MarbleProceduralTexture'(JProceduralTexture)
    _numberOfTilesHeight: Variant;
    _numberOfTilesWidth: Variant;
    _amplitude: Variant;
    _marbleColor: Variant;
    _jointColor: Variant;
    constructor Create(name: String; size: Float; scene: JScene; fallbackTexture: JTexture; generateMipMaps: Boolean);
    procedure updateShaderUniforms;
    numberOfTilesHeight: Float;
    numberOfTilesWidth: Float;
    jointColor: JColor3;
    marbleColor: JColor3;
  end;

