unit Dijit;

interface

//dijit

type
  J_AttachMixin = class external '_AttachMixin'
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    "searchContainerNode": Boolean;
    procedure buildRendering;
    procedure destroyRendering;
  end;

  J_Container = class external '_Container'
    constructor Create;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    procedure buildRendering;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function hasChildren: Boolean;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
  end;

  J_Contained = class external '_Contained'
    constructor Create;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getPreviousSibling: Variant;
  end;

  J_DialogMixin = class external '_DialogMixin'
    constructor Create;
    procedure execute(formContents: JObject);
    procedure onCancel;
    procedure onExecute;
  end;

  J_CssStateMixin = class external '_CssStateMixin'
    constructor Create;
    "active": Boolean;
    "cssStateNodes": JObject;
    "hovering": Boolean;
  end;

  J_FocusMixin = class external '_FocusMixin'
    constructor Create;
  end;

  J_HasDropDown = class external '_HasDropDown'(Jdijit._FocusMixin)
    constructor Create;
    "autoWidth": Boolean;
    "dropDown": JObject;
    "dropDownPosition": JObject;
    "forceWidth": Boolean;
    "maxHeight": Float;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    procedure destroy;
    function isLoaded: Boolean;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function openDropDown: Variant;
    procedure postCreate;
    procedure toggleDropDown;
  end;

  J_KeyNavMixin = class external '_KeyNavMixin'(Jdijit._FocusMixin)
    constructor Create;
    "childSelector": Variant;
    "focusedChild": JObject;
    "multiCharSearchDuration": Float;
    "tabIndex": String;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure postCreate;
    procedure onKeyboardSearch(item: Jdijit._WidgetBase; evt: JEvent; searchString: JString; numMatches: Float);
  end;

  J_KeyNavContainer = class external '_KeyNavContainer'(Jdijit._FocusMixin)
    constructor Create;
    "focusedChild": JObject;
    "multiCharSearchDuration": Float;
    "tabIndex": String;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function hasChildren: Boolean;
    procedure postCreate;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure startup;
    procedure startupKeyNavChildren;
    procedure onKeyboardSearch(item: Jdijit._WidgetBase; evt: JEvent; searchString: JString; numMatches: Float);
  end;

  J_OnDijitClickMixin = class external '_OnDijitClickMixin'
    constructor Create;
    "a11yclick": JObject;
    function connect(obj: Variant; event: Variant; method: Variant): Variant;
  end;

  J_PaletteMixin = class external '_PaletteMixin'(Jdijit._CssStateMixin)
    constructor Create;
    "active": Boolean;
    "cellClass": String;
    "cssStateNodes": JObject;
    "defaultTimeout": Float;
    "dyeClass": JObject;
    "hovering": Boolean;
    "tabIndex": String;
    "timeoutChangeRate": Float;
    "value": String;
    procedure focus;
    procedure postCreate;
    procedure onChange(value: JString);
  end;

  J_TemplatedMixin = class external '_TemplatedMixin'(Jdijit._AttachMixin)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    "searchContainerNode": Boolean;
    "templatePath": String;
    "templateString": String;
    procedure buildRendering;
    procedure destroyRendering;
    function getCachedTemplate(templateString: JString; alwaysUseString: Boolean): Variant; overload;
    function getCachedTemplate(templateString: JString; alwaysUseString: Boolean; doc: JHTMLDocument): Variant; overload;
  end;

  J_Templated = class external '_Templated'(Jdijit._TemplatedMixin)
    constructor Create;
    "attachScope": JObject;
    "contextRequire": JFunction;
    "searchContainerNode": Boolean;
    "templatePath": String;
    "templateString": String;
    "widgetsInTemplate": Boolean;
    procedure buildRendering;
    procedure destroyRendering;
    procedure startup;
    function getCachedTemplate: Variant;
  end;

  J_MenuBase = class external '_MenuBase'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "activated": Boolean;
    procedure set(&property: Jactivated; value: Boolean);
    function get(&property: Jactivated): Boolean;
    function watch(&property: Jactivated; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoFocus": Boolean;
    procedure set(&property: JautoFocus; value: Boolean);
    function get(&property: JautoFocus): Boolean;
    function watch(&property: JautoFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parentMenu": JObject;
    procedure set(&property: JparentMenu; value: JObject);
    function get(&property: JparentMenu): JObject;
    function watch(&property: JparentMenu; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "passivePopupDelay": Float;
    procedure set(&property: JpassivePopupDelay; value: Float);
    function get(&property: JpassivePopupDelay): Float;
    function watch(&property: JpassivePopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "popupDelay": Float;
    procedure set(&property: JpopupDelay; value: Float);
    function get(&property: JpopupDelay): Float;
    function watch(&property: JpopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JObject;
    procedure set(&property: Jselected; value: JObject);
    function get(&property: Jselected): JObject;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel(closeAll: Boolean);
    procedure onClick(event: Variant);
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onItemHover(item: Jdijit.MenuItem);
    procedure onItemUnhover(item: Jdijit.MenuItem);
    procedure onKeyboardSearch(item: Jdijit.MenuItem; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_WidgetsInTemplateMixin = class external '_WidgetsInTemplateMixin'
    constructor Create;
    "contextRequire": JFunction;
    "widgetsInTemplate": Boolean;
    procedure startup;
  end;

  J_WidgetBase = class external '_WidgetBase'(Jdojo.Stateful)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": JObject;
    procedure set(&property: Jstyle; value: JObject);
    function get(&property: Jstyle): JObject;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: Variant;
    function on(&type: JString; func: JFunction):       remove:       end;;
    end;;
    function on(&type: JFunction; func: JFunction):       remove:       end;;
    end;;
    function own(handle: Variant): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onFocus;
  end;

  J_Widget = class external '_Widget'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "a11yclick": JObject;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dndType": String;
    procedure set(&property: JdndType; value: String);
    function get(&property: JdndType): String;
    function watch(&property: JdndType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "observer": String;
    procedure set(&property: Jobserver; value: String);
    function get(&property: Jobserver): String;
    function watch(&property: Jobserver; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "slideFrom": String;
    procedure set(&property: JslideFrom; value: String);
    function get(&property: JslideFrom): String;
    function watch(&property: JslideFrom; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": JObject;
    procedure set(&property: Jstyle; value: JObject);
    function get(&property: Jstyle): JObject;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_TimePicker = class external '_TimePicker'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "clickableIncrement": String;
    procedure set(&property: JclickableIncrement; value: String);
    function get(&property: JclickableIncrement): String;
    function watch(&property: JclickableIncrement; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "filterString": String;
    procedure set(&property: JfilterString; value: String);
    function get(&property: JfilterString): String;
    function watch(&property: JfilterString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "selected": JHTMLElement;
    procedure set(&property: Jselected; value: JHTMLElement);
    function get(&property: Jselected): JHTMLElement;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "visibleIncrement": String;
    procedure set(&property: JvisibleIncrement; value: String);
    function get(&property: JvisibleIncrement): String;
    function watch(&property: JvisibleIncrement; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getParent: Variant;
    function handleKey(e: JEvent): Variant;
    function isDisabledDate(dateObject: JDate): Boolean; overload;
    function isDisabledDate(dateObject: JDate; locale: JString): Boolean; overload;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure selectFirstNode;
    procedure selectLastNode;
    procedure selectNextNode;
    procedure selectPreviousNode;
    function serialize(dateObject: JDate): Variant; overload;
    function serialize(dateObject: JDate; options: JObject): Variant; overload;
    function set(name: Variant; value: Variant): Variant;
    procedure setValue(value: JDate);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onChange(time: JDate);
    procedure onClick(node: JHTMLElement);
    procedure onDeselect(node: JHTMLElement);
    procedure onFocus;
    procedure onHover(node: JHTMLElement);
    procedure onOpen;
    procedure onSelect(node: JHTMLElement);
    procedure onUnhover(node: JHTMLElement);
  end;

  JDestroyable = class external 'Destroyable'
    constructor Create;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    function own(handle: Variant): Variant;
  end;

  JCalendarLite = class external 'CalendarLite'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "currentFocus": JDate;
    procedure set(&property: JcurrentFocus; value: JDate);
    function get(&property: JcurrentFocus): JDate;
    function watch(&property: JcurrentFocus; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dateTemplateString": String;
    procedure set(&property: JdateTemplateString; value: String);
    function get(&property: JdateTemplateString): String;
    function watch(&property: JdateTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dayWidth": String;
    procedure set(&property: JdayWidth; value: String);
    function get(&property: JdayWidth): String;
    function watch(&property: JdayWidth; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dowTemplateString": String;
    procedure set(&property: JdowTemplateString; value: String);
    function get(&property: JdowTemplateString): String;
    function watch(&property: JdowTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "weekTemplateString": String;
    procedure set(&property: JweekTemplateString; value: String);
    function get(&property: JweekTemplateString): String;
    function watch(&property: JweekTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getClassForDate(dateObject: JDate): JString; overload;
    function getClassForDate(dateObject: JDate; locale: JString): JString; overload;
    function getParent: Variant;
    procedure goToToday;
    function isDisabledDate(dateObject: JDate): Boolean; overload;
    function isDisabledDate(dateObject: JDate; locale: JString): Boolean; overload;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onChange(date: JDate);
  end;

  JDeclaration = class external 'Declaration'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "defaults": JObject;
    procedure set(&property: Jdefaults; value: JObject);
    function get(&property: Jdefaults): JObject;
    function watch(&property: Jdefaults; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "mixins": JObject;
    procedure set(&property: Jmixins; value: JObject);
    function get(&property: Jmixins): JObject;
    function watch(&property: Jmixins; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "widgetClass": String;
    procedure set(&property: JwidgetClass; value: String);
    function get(&property: JwidgetClass): String;
    function watch(&property: JwidgetClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JCalendar = class external 'Calendar'(Jdijit.CalendarLite)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "a11yclick": JObject;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "currentFocus": JDate;
    procedure set(&property: JcurrentFocus; value: JDate);
    function get(&property: JcurrentFocus): JDate;
    function watch(&property: JcurrentFocus; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dateTemplateString": String;
    procedure set(&property: JdateTemplateString; value: String);
    function get(&property: JdateTemplateString): String;
    function watch(&property: JdateTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dayWidth": String;
    procedure set(&property: JdayWidth; value: String);
    function get(&property: JdayWidth): String;
    function watch(&property: JdayWidth; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dowTemplateString": String;
    procedure set(&property: JdowTemplateString; value: String);
    function get(&property: JdowTemplateString): String;
    function watch(&property: JdowTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dndType": String;
    procedure set(&property: JdndType; value: String);
    function get(&property: JdndType): String;
    function watch(&property: JdndType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "observer": String;
    procedure set(&property: Jobserver; value: String);
    function get(&property: Jobserver): String;
    function watch(&property: Jobserver; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "slideFrom": String;
    procedure set(&property: JslideFrom; value: String);
    function get(&property: JslideFrom): String;
    function watch(&property: JslideFrom; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "weekTemplateString": String;
    procedure set(&property: JweekTemplateString; value: String);
    function get(&property: JweekTemplateString): String;
    function watch(&property: JweekTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getClassForDate(dateObject: JDate; locale: JString): JString;
    function getDescendants: array of Variant;
    function getParent: Variant;
    procedure goToToday;
    function handleKey(evt: JEvent): Variant;
    function isDisabledDate(dateObject: JDate): Boolean; overload;
    function isDisabledDate(dateObject: JDate; locale: JString): Boolean; overload;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setValue(value: JDate);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(value: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onValueSelected(date: JDate);
  end;

  JCheckedMenuItem = class external 'CheckedMenuItem'(Jdijit.MenuItem)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "checkedChar": String;
    procedure set(&property: JcheckedChar; value: String);
    function get(&property: JcheckedChar): String;
    function watch(&property: JcheckedChar; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "role": String;
    procedure set(&property: Jrole; value: String);
    function get(&property: Jrole): String;
    function watch(&property: Jrole; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(checked: Boolean);
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JDialogUnderlay = class external 'DialogUnderlay'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dialogId": String;
    procedure set(&property: JdialogId; value: String);
    function get(&property: JdialogId): String;
    function watch(&property: JdialogId; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    procedure hide;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure show;
    procedure show(attrs: JObject; zIndex: Float);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_ConfirmDialogMixin = class external '_ConfirmDialogMixin'(Jdijit._WidgetsInTemplateMixin)
    constructor Create;
    "actionBarTemplate": JObject;
    "buttonCancel": String;
    "buttonOk": String;
    "contextRequire": JFunction;
    "widgetsInTemplate": Boolean;
    procedure startup;
  end;

  JConfirmDialog = class external 'ConfirmDialog'(Jdijit.Dialog)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    okButton: Jdijit.form.Button;
    cancelButon: Jdijit.form.Button;
    "actionBarTemplate": String;
    procedure set(&property: JactionBarTemplate; value: String);
    function get(&property: JactionBarTemplate): String;
    function watch(&property: JactionBarTemplate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autofocus": Boolean;
    procedure set(&property: Jautofocus; value: Boolean);
    function get(&property: Jautofocus): Boolean;
    function watch(&property: Jautofocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonCancel": String;
    procedure set(&property: JbuttonCancel; value: String);
    function get(&property: JbuttonCancel): String;
    function watch(&property: JbuttonCancel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonOk": String;
    procedure set(&property: JbuttonOk; value: String);
    function get(&property: JbuttonOk): String;
    function watch(&property: JbuttonOk; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "closable": Boolean;
    procedure set(&property: Jclosable; value: Boolean);
    function get(&property: Jclosable): Boolean;
    function watch(&property: Jclosable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "contextRequire": JFunction;
    procedure set(&property: JcontextRequire; value: JFunction);
    function get(&property: JcontextRequire): JFunction;
    function watch(&property: JcontextRequire; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "draggable": Boolean;
    procedure set(&property: Jdraggable; value: Boolean);
    function get(&property: Jdraggable): Boolean;
    function watch(&property: Jdraggable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maxRatio": Float;
    procedure set(&property: JmaxRatio; value: Float);
    function get(&property: JmaxRatio): Float;
    function watch(&property: JmaxRatio; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "open": Boolean;
    procedure set(&property: Jopen; value: Boolean);
    function get(&property: Jopen): Boolean;
    function watch(&property: Jopen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refocus": Boolean;
    procedure set(&property: Jrefocus; value: Boolean);
    function get(&property: Jrefocus): Boolean;
    function watch(&property: Jrefocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectChildren(inStartup: Boolean);
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants(preserveDom: Boolean);
    procedure destroyRecursive(preserveDom: Boolean);
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure disconnectChildren;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure execute(formContents: JObject);
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValues: Variant;
    function hasChildren: Boolean;
    function hide: Variant;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: : Boolean    end;;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure reset;
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    function setValues(val: Variant): Variant;
    function show: Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
    procedure onValidStateChange(isValid: Boolean);
  end;

  JDialog = class external 'Dialog'(Jdijit.layout.ContentPane)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autofocus": Boolean;
    procedure set(&property: Jautofocus; value: Boolean);
    function get(&property: Jautofocus): Boolean;
    function watch(&property: Jautofocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "closable": Boolean;
    procedure set(&property: Jclosable; value: Boolean);
    function get(&property: Jclosable): Boolean;
    function watch(&property: Jclosable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "draggable": Boolean;
    procedure set(&property: Jdraggable; value: Boolean);
    function get(&property: Jdraggable): Boolean;
    function watch(&property: Jdraggable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maxRatio": Float;
    procedure set(&property: JmaxRatio; value: Float);
    function get(&property: JmaxRatio): Float;
    function watch(&property: JmaxRatio; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "open": Boolean;
    procedure set(&property: Jopen; value: Boolean);
    function get(&property: Jopen): Boolean;
    function watch(&property: Jopen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refocus": Boolean;
    procedure set(&property: Jrefocus; value: Boolean);
    function get(&property: Jrefocus): Boolean;
    function watch(&property: Jrefocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectChildren(inStartup: Boolean);
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure disconnectChildren;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure execute(formContents: JObject);
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValues: Variant;
    function hasChildren: Boolean;
    function hide: Variant;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: : Boolean    end;;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure reset;
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    function setValues(val: Variant): Variant;
    function show: Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
    procedure onValidStateChange(isValid: Boolean);
  end;

  JColorPalette = class external 'ColorPalette'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cellClass": String;
    procedure set(&property: JcellClass; value: String);
    function get(&property: JcellClass): String;
    function watch(&property: JcellClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "defaultTimeout": Float;
    procedure set(&property: JdefaultTimeout; value: Float);
    function get(&property: JdefaultTimeout): Float;
    function watch(&property: JdefaultTimeout; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dyeClass": JFunction;
    procedure set(&property: JdyeClass; value: JFunction);
    function get(&property: JdyeClass): JFunction;
    function watch(&property: JdyeClass; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "palette": String;
    procedure set(&property: Jpalette; value: String);
    function get(&property: Jpalette): String;
    function watch(&property: Jpalette; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "timeoutChangeRate": Float;
    procedure set(&property: JtimeoutChangeRate; value: Float);
    function get(&property: JtimeoutChangeRate): Float;
    function watch(&property: JtimeoutChangeRate; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(value: JString);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JFieldset = class external 'Fieldset'(Jdijit.TitlePane)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "open": Boolean;
    procedure set(&property: Jopen; value: Boolean);
    function get(&property: Jopen): Boolean;
    function watch(&property: Jopen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "toggleable": Boolean;
    procedure set(&property: Jtoggleable; value: Boolean);
    function get(&property: Jtoggleable): Boolean;
    function watch(&property: Jtoggleable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    procedure setTitle(title: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
  end;

  JDropDownMenu = class external 'DropDownMenu'(Jdijit._MenuBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "activated": Boolean;
    procedure set(&property: Jactivated; value: Boolean);
    function get(&property: Jactivated): Boolean;
    function watch(&property: Jactivated; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoFocus": Boolean;
    procedure set(&property: JautoFocus; value: Boolean);
    function get(&property: JautoFocus): Boolean;
    function watch(&property: JautoFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parentMenu": JObject;
    procedure set(&property: JparentMenu; value: JObject);
    function get(&property: JparentMenu): JObject;
    function watch(&property: JparentMenu; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "passivePopupDelay": Float;
    procedure set(&property: JpassivePopupDelay; value: Float);
    function get(&property: JpassivePopupDelay): Float;
    function watch(&property: JpassivePopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "popupDelay": Float;
    procedure set(&property: JpopupDelay; value: Float);
    function get(&property: JpopupDelay): Float;
    function watch(&property: JpopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JObject;
    procedure set(&property: Jselected; value: JObject);
    function get(&property: Jselected): JObject;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel(closeAll: Boolean);
    procedure onClick(event: Variant);
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onItemHover(item: Jdijit.MenuItem);
    procedure onItemUnhover(item: Jdijit.MenuItem);
    procedure onKeyboardSearch(item: Jdijit.MenuItem; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JEditor = class external 'Editor'(Jdijit._editor.RichText)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "captureEvents": JObject;
    procedure set(&property: JcaptureEvents; value: JObject);
    function get(&property: JcaptureEvents): JObject;
    function watch(&property: JcaptureEvents; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "customUndo": Boolean;
    procedure set(&property: JcustomUndo; value: Boolean);
    function get(&property: JcustomUndo): Boolean;
    function watch(&property: JcustomUndo; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "disableSpellCheck": Boolean;
    procedure set(&property: JdisableSpellCheck; value: Boolean);
    function get(&property: JdisableSpellCheck): Boolean;
    function watch(&property: JdisableSpellCheck; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "editActionInterval": Float;
    procedure set(&property: JeditActionInterval; value: Float);
    function get(&property: JeditActionInterval): Float;
    function watch(&property: JeditActionInterval; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "extraPlugins": JObject;
    procedure set(&property: JextraPlugins; value: JObject);
    function get(&property: JextraPlugins): JObject;
    function watch(&property: JextraPlugins; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusOnLoad": Boolean;
    procedure set(&property: JfocusOnLoad; value: Boolean);
    function get(&property: JfocusOnLoad): Boolean;
    function watch(&property: JfocusOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "height": String;
    procedure set(&property: Jheight; value: String);
    function get(&property: Jheight): String;
    function watch(&property: Jheight; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "inheritWidth": Boolean;
    procedure set(&property: JinheritWidth; value: Boolean);
    function get(&property: JinheritWidth): Boolean;
    function watch(&property: JinheritWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isClosed": Boolean;
    procedure set(&property: JisClosed; value: Boolean);
    function get(&property: JisClosed): Boolean;
    function watch(&property: JisClosed; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isTabIndent": Boolean;
    procedure set(&property: JisTabIndent; value: Boolean);
    function get(&property: JisTabIndent): Boolean;
    function watch(&property: JisTabIndent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "minHeight": String;
    procedure set(&property: JminHeight; value: String);
    function get(&property: JminHeight): String;
    function watch(&property: JminHeight; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": JObject;
    procedure set(&property: Jname; value: JObject);
    function get(&property: Jname): JObject;
    function watch(&property: Jname; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "plugins": JObject;
    procedure set(&property: Jplugins; value: JObject);
    function get(&property: Jplugins): JObject;
    function watch(&property: Jplugins; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "styleSheets": String;
    procedure set(&property: JstyleSheets; value: String);
    function get(&property: JstyleSheets): String;
    function watch(&property: JstyleSheets; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "updateInterval": Float;
    procedure set(&property: JupdateInterval; value: Float);
    function get(&property: JupdateInterval): Float;
    function watch(&property: JupdateInterval; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    procedure addKeyHandler(key: JString; ctrl: Boolean; shift: Boolean; handler: JFunction);
    procedure addKeyHandler(key: Float; ctrl: Boolean; shift: Boolean; handler: JFunction);
    procedure addPlugin(plugin: JString); overload;
    procedure addPlugin(plugin: JString; index: Float); overload;
    procedure addPlugin(plugin: JObject); overload;
    procedure addPlugin(plugin: JObject; index: Float); overload;
    procedure addPlugin(plugin: JFunction); overload;
    procedure addPlugin(plugin: JFunction; index: Float); overload;
    procedure addStyleSheet(uri: Jdojo._base.url);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure blur;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function execCommand(cmd: Variant): Variant;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getFooterHeight: Variant;
    function getHeaderHeight: Variant;
    function getNodeChildrenHtml(dom: JHTMLElement): Variant;
    function getNodeHtml(node: JHTMLElement): Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function queryCommandEnabled(cmd: Variant): Variant;
    function queryCommandState(command: Variant): Variant;
    function queryCommandValue(command: Variant): Variant;
    procedure removeStyleSheet(uri: Jdojo._base.url);
    procedure replaceValue(html: JString);
    procedure resize(size: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setupDefaultShortcuts;
    procedure setValue(html: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBeforeActivate;
    procedure onBlur;
    procedure onChange(newContent: Variant);
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(e: Variant);
    procedure onLoad(html: JString);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JInlineEditBox = class external 'InlineEditBox'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoSave": Boolean;
    procedure set(&property: JautoSave; value: Boolean);
    function get(&property: JautoSave): Boolean;
    function watch(&property: JautoSave; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonCancel": String;
    procedure set(&property: JbuttonCancel; value: String);
    function get(&property: JbuttonCancel): String;
    function watch(&property: JbuttonCancel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonSave": String;
    procedure set(&property: JbuttonSave; value: String);
    function get(&property: JbuttonSave): String;
    function watch(&property: JbuttonSave; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "editing": Boolean;
    procedure set(&property: Jediting; value: Boolean);
    function get(&property: Jediting): Boolean;
    function watch(&property: Jediting; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "editorParams": JObject;
    procedure set(&property: JeditorParams; value: JObject);
    function get(&property: JeditorParams): JObject;
    function watch(&property: JeditorParams; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "noValueIndicator": String;
    procedure set(&property: JnoValueIndicator; value: String);
    function get(&property: JnoValueIndicator): String;
    function watch(&property: JnoValueIndicator; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "renderAsHtml": Boolean;
    procedure set(&property: JrenderAsHtml; value: Boolean);
    function get(&property: JrenderAsHtml): Boolean;
    function watch(&property: JrenderAsHtml; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "width": String;
    procedure set(&property: Jwidth; value: String);
    function get(&property: Jwidth): String;
    function watch(&property: Jwidth; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure editor;
    procedure editorWrapper;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    function setValue(val: JString): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onCancel;
    procedure onChange(value: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMenuSeparator = class external 'MenuSeparator'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Boolean;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onFocus;
  end;

  JMenuBar = class external 'MenuBar'(Jdijit._MenuBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "activated": Boolean;
    procedure set(&property: Jactivated; value: Boolean);
    function get(&property: Jactivated): Boolean;
    function watch(&property: Jactivated; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoFocus": Boolean;
    procedure set(&property: JautoFocus; value: Boolean);
    function get(&property: JautoFocus): Boolean;
    function watch(&property: JautoFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parentMenu": JObject;
    procedure set(&property: JparentMenu; value: JObject);
    function get(&property: JparentMenu): JObject;
    function watch(&property: JparentMenu; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "passivePopupDelay": Float;
    procedure set(&property: JpassivePopupDelay; value: Float);
    function get(&property: JpassivePopupDelay): Float;
    function watch(&property: JpassivePopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "popupDelay": Float;
    procedure set(&property: JpopupDelay; value: Float);
    function get(&property: JpopupDelay): Float;
    function watch(&property: JpopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JObject;
    procedure set(&property: Jselected; value: JObject);
    function get(&property: Jselected): JObject;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(item: Variant);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel(closeAll: Boolean);
    procedure onClick(event: Variant);
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onItemHover(item: Jdijit.MenuItem);
    procedure onItemUnhover(item: Jdijit.MenuItem);
    procedure onKeyboardSearch(item: Jdijit.MenuItem; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMenu = class external 'Menu'(Jdijit.DropDownMenu)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "activated": Boolean;
    procedure set(&property: Jactivated; value: Boolean);
    function get(&property: Jactivated): Boolean;
    function watch(&property: Jactivated; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoFocus": Boolean;
    procedure set(&property: JautoFocus; value: Boolean);
    function get(&property: JautoFocus): Boolean;
    function watch(&property: JautoFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "contextMenuForWindow": Boolean;
    procedure set(&property: JcontextMenuForWindow; value: Boolean);
    function get(&property: JcontextMenuForWindow): Boolean;
    function watch(&property: JcontextMenuForWindow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "currentTarget": JHTMLElement;
    procedure set(&property: JcurrentTarget; value: JHTMLElement);
    function get(&property: JcurrentTarget): JHTMLElement;
    function watch(&property: JcurrentTarget; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "leftClickToOpen": Boolean;
    procedure set(&property: JleftClickToOpen; value: Boolean);
    function get(&property: JleftClickToOpen): Boolean;
    function watch(&property: JleftClickToOpen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parentMenu": JObject;
    procedure set(&property: JparentMenu; value: JObject);
    function get(&property: JparentMenu): JObject;
    function watch(&property: JparentMenu; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "passivePopupDelay": Float;
    procedure set(&property: JpassivePopupDelay; value: Float);
    function get(&property: JpassivePopupDelay): Float;
    function watch(&property: JpassivePopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "popupDelay": Float;
    procedure set(&property: JpopupDelay; value: Float);
    function get(&property: JpopupDelay): Float;
    function watch(&property: JpopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "refocus": Boolean;
    procedure set(&property: Jrefocus; value: Boolean);
    function get(&property: Jrefocus): Boolean;
    function watch(&property: Jrefocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JObject;
    procedure set(&property: Jselected; value: JObject);
    function get(&property: Jselected): JObject;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "selector": JObject;
    procedure set(&property: Jselector; value: JObject);
    function get(&property: Jselector): JObject;
    function watch(&property: Jselector; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "targetNodeIds": JObject;
    procedure set(&property: JtargetNodeIds; value: JObject);
    function get(&property: JtargetNodeIds): JObject;
    function watch(&property: JtargetNodeIds; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure bindDomNode(node: JString);
    procedure bindDomNode(node: JHTMLElement);
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getPlaceholders(&label: JString): Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure unBindDomNode(nodeName: JString);
    procedure unBindDomNode(nodeName: JHTMLElement);
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel(closeAll: Boolean);
    procedure onClick(event: Variant);
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onItemHover(item: Jdijit.MenuItem);
    procedure onItemUnhover(item: Jdijit.MenuItem);
    procedure onKeyboardSearch(item: Jdijit.MenuItem; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMenuItem = class external 'MenuItem'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMenuBarItem = class external 'MenuBarItem'(Jdijit.MenuItem)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JPopupMenuBarItem = class external 'PopupMenuBarItem'(Jdijit.PopupMenuItem)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JPopupMenuItem = class external 'PopupMenuItem'(Jdijit.MenuItem)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JProgressBar = class external 'ProgressBar'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "indeterminate": Boolean;
    procedure set(&property: Jindeterminate; value: Boolean);
    function get(&property: Jindeterminate): Boolean;
    function watch(&property: Jindeterminate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": JObject;
    procedure set(&property: Jlabel; value: JObject);
    function get(&property: Jlabel): JObject;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maximum": Float;
    procedure set(&property: Jmaximum; value: Float);
    function get(&property: Jmaximum): Float;
    function watch(&property: Jmaximum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "places": Float;
    procedure set(&property: Jplaces; value: Float);
    function get(&property: Jplaces): Float;
    function watch(&property: Jplaces; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "progress": String;
    procedure set(&property: Jprogress; value: String);
    function get(&property: Jprogress): String;
    function watch(&property: Jprogress; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function report(percent: Float): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JRadioMenuItem = class external 'RadioMenuItem'(Jdijit.CheckedMenuItem)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accelKey": String;
    procedure set(&property: JaccelKey; value: String);
    function get(&property: JaccelKey): String;
    function watch(&property: JaccelKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "checkedChar": String;
    procedure set(&property: JcheckedChar; value: String);
    function get(&property: JcheckedChar): String;
    function watch(&property: JcheckedChar; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "group": String;
    procedure set(&property: Jgroup; value: String);
    function get(&property: Jgroup): String;
    function watch(&property: Jgroup; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "role": String;
    procedure set(&property: Jrole; value: String);
    function get(&property: Jrole): String;
    function watch(&property: Jrole; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "shortcutKey": String;
    procedure set(&property: JshortcutKey; value: String);
    function get(&property: JshortcutKey): String;
    function watch(&property: JshortcutKey; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(checked: Boolean);
    procedure onClick;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JToolbar = class external 'Toolbar'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyboardSearch(item: Jdijit._WidgetBase; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTooltip = class external 'Tooltip'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "connectId": String;
    procedure set(&property: JconnectId; value: String);
    function get(&property: JconnectId): String;
    function watch(&property: JconnectId; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "defaultPosition": JObject;
    procedure set(&property: JdefaultPosition; value: JObject);
    function get(&property: JdefaultPosition): JObject;
    function watch(&property: JdefaultPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "position": JObject;
    procedure set(&property: Jposition; value: JObject);
    function get(&property: Jposition): JObject;
    function watch(&property: Jposition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "selector": JObject;
    procedure set(&property: Jselector; value: JObject);
    function get(&property: Jselector): JObject;
    function watch(&property: Jselector; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "showDelay": Float;
    procedure set(&property: JshowDelay; value: Float);
    function get(&property: JshowDelay): Float;
    function watch(&property: JshowDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addTarget(node: JHTMLElement);
    procedure addTarget(node: JString);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getContent(node: JHTMLElement): Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function hide(aroundNode: Variant): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeTarget(node: JHTMLElement);
    procedure removeTarget(node: JString);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    function show(innerHTML: JString; aroundNode: JObject; position: array of JString; rtl: Boolean; textDir: JString): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow; overload;
    procedure onShow(target: Variant); overload;
    procedure onShow(target: Variant; position: Variant); overload;
  end;

  JToolbarSeparator = class external 'ToolbarSeparator'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Boolean;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTitlePane = class external 'TitlePane'(Jdijit.layout.ContentPane)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "open": Boolean;
    procedure set(&property: Jopen; value: Boolean);
    function get(&property: Jopen): Boolean;
    function watch(&property: Jopen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "toggleable": Boolean;
    procedure set(&property: Jtoggleable; value: Boolean);
    function get(&property: Jtoggleable): Boolean;
    function watch(&property: Jtoggleable; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    procedure setTitle(title: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
  end;

  JTooltipDialog = class external 'TooltipDialog'(Jdijit.layout.ContentPane)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autofocus": Boolean;
    procedure set(&property: Jautofocus; value: Boolean);
    function get(&property: Jautofocus): Boolean;
    function watch(&property: Jautofocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectChildren(inStartup: Boolean);
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure disconnectChildren;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure execute(formContents: JObject);
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValues: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: : Boolean    end;;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    procedure orient(node: JHTMLElement; aroundCorner: JString; tooltipCorner: JString);
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure reset;
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    function setValues(val: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onOpen(pos: JObject);
    procedure onShow;
    procedure onUnload;
    procedure onValidStateChange(isValid: Boolean);
  end;

  JWidgetSet = class external 'WidgetSet'
    constructor Create;
    procedure add(widget: Jdijit._WidgetBase);
    function byClass(cls: JString): Variant;
    function byId(id: JString): Jdijit._WidgetBase;
    function every(func: JFunction; thisObj: JObject): Boolean;
    function filter(filter: JFunction; thisObj: JObject): Variant;
    function forEach(func: JFunction; thisObj: JObject): Variant;
    function map(func: JFunction; thisObj: JObject): Variant;
    procedure remove(id: JString);
    function some(func: JFunction; thisObj: JObject): Boolean;
    function toArray: array of Variant;
  end;

  JTree = class external 'Tree'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoExpand": Boolean;
    procedure set(&property: JautoExpand; value: Boolean);
    function get(&property: JautoExpand): Boolean;
    function watch(&property: JautoExpand; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "betweenThreshold": Float;
    procedure set(&property: JbetweenThreshold; value: Float);
    function get(&property: JbetweenThreshold): Float;
    function watch(&property: JbetweenThreshold; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "checkAcceptance": JObject;
    procedure set(&property: JcheckAcceptance; value: JObject);
    function get(&property: JcheckAcceptance): JObject;
    function watch(&property: JcheckAcceptance; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "checkItemAcceptance": JObject;
    procedure set(&property: JcheckItemAcceptance; value: JObject);
    function get(&property: JcheckItemAcceptance): JObject;
    function watch(&property: JcheckItemAcceptance; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "childrenAttr": JObject;
    procedure set(&property: JchildrenAttr; value: JObject);
    function get(&property: JchildrenAttr): JObject;
    function watch(&property: JchildrenAttr; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "childSelector": String;
    procedure set(&property: JchildSelector; value: String);
    function get(&property: JchildSelector): String;
    function watch(&property: JchildSelector; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dndParams": array of Variant;
    procedure set(&property: JdndParams; value: array of Variant);
    function get(&property: JdndParams): array of Variant;
    function watch(&property: JdndParams; callback: (&property: String; oldValue: array of Variant; newValue: array of Variant)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dragThreshold": Float;
    procedure set(&property: JdragThreshold; value: Float);
    function get(&property: JdragThreshold): Float;
    function watch(&property: JdragThreshold; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "model": JObject;
    procedure set(&property: Jmodel; value: JObject);
    function get(&property: Jmodel): JObject;
    function watch(&property: Jmodel; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "onDndCancel": JFunction;
    procedure set(&property: JonDndCancel; value: JFunction);
    function get(&property: JonDndCancel): JFunction;
    function watch(&property: JonDndCancel; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "onDndDrop": JFunction;
    procedure set(&property: JonDndDrop; value: JFunction);
    function get(&property: JonDndDrop): JFunction;
    function watch(&property: JonDndDrop; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "openOnClick": Boolean;
    procedure set(&property: JopenOnClick; value: Boolean);
    function get(&property: JopenOnClick): Boolean;
    function watch(&property: JopenOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "openOnDblClick": Boolean;
    procedure set(&property: JopenOnDblClick; value: Boolean);
    function get(&property: JopenOnDblClick): Boolean;
    function watch(&property: JopenOnDblClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "path": array of Variant;
    procedure set(&property: Jpath; value: array of Variant);
    function get(&property: Jpath): array of Variant;
    function watch(&property: Jpath; callback: (&property: String; oldValue: array of Variant; newValue: array of Variant)    end;):       procedure unwatch;
    end;;
    "PathError": JObject;
    procedure set(&property: JPathError; value: JObject);
    function get(&property: JPathError): JObject;
    function watch(&property: JPathError; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "paths": array of Variant;
    procedure set(&property: Jpaths; value: array of Variant);
    function get(&property: Jpaths): array of Variant;
    function watch(&property: Jpaths; callback: (&property: String; oldValue: array of Variant; newValue: array of Variant)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "query": JObject;
    procedure set(&property: Jquery; value: JObject);
    function get(&property: Jquery): JObject;
    function watch(&property: Jquery; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectedItem": JObject;
    procedure set(&property: JselectedItem; value: JObject);
    function get(&property: JselectedItem): JObject;
    function watch(&property: JselectedItem; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "selectedItems": JObject;
    procedure set(&property: JselectedItems; value: JObject);
    function get(&property: JselectedItems): JObject;
    function watch(&property: JselectedItems; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "showRoot": Boolean;
    procedure set(&property: JshowRoot; value: Boolean);
    function get(&property: JshowRoot): Boolean;
    function watch(&property: JshowRoot; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "store": String;
    procedure set(&property: Jstore; value: String);
    function get(&property: Jstore): String;
    function watch(&property: Jstore; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function collapseAll: Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure dndController;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function expandAll: Variant;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNode(node: Jdijit.Tree._TreeNode);
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIconClass(item: Jdojo.data.api.Item; opened: Boolean): JString;
    function getIconStyle(item: Jdojo.data.api.Item; opened: Boolean): JObject;
    procedure getItemChildren(parentItem: Variant; onComplete: Variant);
    function getLabel(item: Jdojo.data.api.Item): Variant;
    function getLabelClass(item: Jdojo.data.api.Item; opened: Boolean): JString;
    function getLabelStyle(item: Jdojo.data.api.Item; opened: Boolean): Variant;
    function getNodesByItem(item: Variant): Variant;
    function getNodesByItem(item: Float): Variant;
    function getParent: Variant;
    function getRowClass(item: Jdojo.data.api.Item; opened: Boolean): JString;
    function getRowStyle(item: Jdojo.data.api.Item; opened: Boolean): Variant;
    function getTooltip(item: Jdojo.data.api.Item): JString;
    function isExpandoNode(node: Variant; widget: Variant): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function itemCreator(nodes: array of JHTMLElement; target: JHTMLElement; source: Jdojo.dnd.Source): Variant;
    procedure mayHaveChildren(item: Jdojo.data.api.Item);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure resize(changeSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(item: Variant); overload;
    procedure onClick(item: Variant; node: JObject); overload;
    procedure onClick(item: Variant; node: JObject; evt: JEvent); overload;
    function onClose: Boolean; overload;
    function onClose(item: JObject): Boolean; overload;
    function onClose(item: JObject; node: JObject): Boolean; overload;
    procedure onDblClick(item: Variant); overload;
    procedure onDblClick(item: Variant; node: JObject); overload;
    procedure onDblClick(item: Variant; node: JObject; evt: JEvent); overload;
    procedure onFocus;
    procedure onHide;
    procedure onKeyboardSearch(item: Jdijit._WidgetBase; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad;
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onOpen(item: Jdojo.data.api.Item; node: JObject);
    procedure onShow;
  end;

  J_BidiSupport = class external
  end;

  JBackgroundIframe = class external
(node: JHTMLElement)  end;

  Jhccss = class external
  end;

  J_base = class external
  end;

  J_BidiMixin = class external
    textDir: String;
    procedure applyTextDir(element: JHTMLElement; text: JString);
    function enforceTextDirWithUcc(option: Variant; text: Variant): JString;
    function getTextDir(text: JString): Variant;
    function restoreOriginalText(origObj: Variant): Variant;
  end;

  J_Calendar = class external
  end;

  Ja11yclick = class external
    procedure click(node: Variant; listener: Variant);
    procedure move(node: Variant; listener: Variant);
    procedure press(node: Variant; listener: Variant);
    procedure release(node: Variant; listener: Variant);
  end;

  Ja11y = class external
    function effectiveTabIndex(elem: JHTMLElement): Variant;
    function getFirstInTabbingOrder(root: JString; doc: JHTMLDocument): Variant;
    function getFirstInTabbingOrder(root: JHTMLElement; doc: JHTMLDocument): Variant;
    function getLastInTabbingOrder(root: JString; doc: JHTMLDocument): Variant;
    function getLastInTabbingOrder(root: JHTMLElement; doc: JHTMLDocument): Variant;
    function hasDefaultTabStop(elem: JHTMLElement): Variant;
    function isFocusable(elem: JHTMLElement): Boolean;
    function isTabNavigable(elem: JHTMLElement): Boolean;
  end;

  Jdijit = class external
  end;

  Jdijit_all = class external
  end;

  Jmain = class external
    defaultDuration: Float;
    place: JObject;
    popup: JObject;
    registry: JObject;
    typematic: JObject;
    procedure BackgroundIframe(node: JHTMLElement);
    function effectiveTabIndex(elem: JHTMLElement): Variant;
    procedure focus(node: Variant);
    function getBookmark: Variant;
    procedure getDocumentWindow(doc: Variant);
    function getFirstInTabbingOrder(root: JString; doc: JHTMLDocument): Variant;
    function getFirstInTabbingOrder(root: JHTMLElement; doc: JHTMLDocument): Variant;
    function getFocus(menu: Jdijit._WidgetBase; openedForWindow: JWindow): Variant;
    function getLastInTabbingOrder(root: JString; doc: JHTMLDocument): Variant;
    function getLastInTabbingOrder(root: JHTMLElement; doc: JHTMLDocument): Variant;
    procedure getPopupAroundAlignment(position: array of JString; leftToRight: Boolean);
    procedure getViewport;
    function getWaiRole(elem: JHTMLElement): Variant;
    function getWaiState(elem: JHTMLElement; state: JString): Variant;
    function hasDefaultTabStop(elem: JHTMLElement): Variant;
    function hasWaiRole(elem: JHTMLElement; role: JString): Variant;
    function hasWaiState(elem: JHTMLElement; state: JString): Variant;
    function hideTooltip(aroundNode: Variant): Variant;
    function isCollapsed: Variant;
    function isFocusable(elem: JHTMLElement): Boolean;
    function isTabNavigable(elem: JHTMLElement): Boolean;
    function moveToBookmark(bookmark: JObject): Variant;
    function placeOnScreen(node: JHTMLElement; pos: Jdijit.place.__Position; corners: array of JString; padding: Jdijit.place.__Position; layoutNode: Variant): Variant;
    procedure placeOnScreenAroundElement(node: Variant; aroundNode: Variant; aroundCorners: Variant; layoutNode: Variant);
    procedure placeOnScreenAroundNode(node: Variant; aroundNode: Variant; aroundCorners: Variant; layoutNode: Variant);
    procedure placeOnScreenAroundRectangle(node: Variant; aroundRect: Variant; aroundCorners: Variant; layoutNode: Variant);
    function registerIframe(iframe: JHTMLElement): Variant;
    function registerWin(targetWindow: JWindow; effectiveNode: JHTMLElement): Variant;
    procedure removeWaiRole(elem: JHTMLElement; role: JString);
    procedure removeWaiState(elem: JHTMLElement; state: JString);
    procedure scrollIntoView(node: JHTMLElement; pos: JObject);
    procedure selectInputText(element: JHTMLElement; start: Float; stop: Float);
    procedure setWaiRole(elem: JHTMLElement; role: JString);
    procedure setWaiState(elem: JHTMLElement; state: JString; value: JString);
    function showTooltip(innerHTML: JString; aroundNode: JObject; position: array of JString; rtl: Boolean; textDir: JString): Variant;
    procedure unregisterIframe(handle: JObject);
    procedure unregisterWin(handle: JObject);
  end;

  Jplace = class external
    function around(node: JHTMLElement; anchor: JHTMLElement; positions: array of JString; leftToRight: Boolean; layoutNode: JFunction): Variant;
    function around(node: JHTMLElement; anchor: Jdijit.place.__Rectangle; positions: array of JString; leftToRight: Boolean; layoutNode: JFunction): Variant;
    function at(node: JHTMLElement; pos: Jdijit.place.__Position; corners: array of JString; padding: Jdijit.place.__Position; layoutNode: Variant): Variant;
  end;

  Jregistry = class external
    _length: Float;
    procedure add(widget: Jdijit._WidgetBase);
    function byId(id: JString): Jdijit._WidgetBase;
    function byId(id: Jdijit._WidgetBase): Jdijit._WidgetBase;
    function byNode(node: JHTMLElement): Variant;
    function findWidgets(root: JHTMLElement; skipNode: JHTMLElement): array of Variant;
    function getEnclosingWidget(node: JHTMLElement): Variant;
    function getUniqueId(widgetType: JString): JString;
    procedure remove(id: JString);
    function toArray: array of Variant;
  end;

  Jtypematic = class external
    function addKeyListener(node: JHTMLElement; keyObject: JObject; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    function addListener(mouseNode: JHTMLElement; keyNode: JHTMLElement; keyObject: JObject; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    function addMouseListener(node: JHTMLElement; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    procedure stop;
    procedure trigger(evt: JEvent; _this: JObject; node: JHTMLElement; callback: JFunction; obj: JObject; subsequentDelay: Float; initialDelay: Float; minDelay: Float);
  end;

  JViewport = class external
  end;

//BackgroundIframe

type
  Jdestroy = class external
  end;

  Jresize = class external
(node: Variant)  end;

//_OnDijitClickMixin

type
  Ja11yclick = class external
    procedure click(node: Variant; listener: Variant);
    procedure move(node: Variant; listener: Variant);
    procedure press(node: Variant; listener: Variant);
    procedure release(node: Variant; listener: Variant);
  end;

//_PaletteMixin

type
  J__Dye = class external '__Dye'
    constructor Create(alias: JString; row: Variant; col: Variant);
    procedure fillCell(cell: JHTMLElement; blankGif: JString);
    procedure getValue;
  end;

//_TemplatedMixin

type
  J_templateCache = class external
  end;

//_TimePicker

type
  J__Constraints = class external '__Constraints'
    constructor Create;
    "am": String;
    "clickableIncrement": String;
    "datePattern": String;
    "formatLength": String;
    "fullYear": Boolean;
    "locale": String;
    "pm": String;
    "selector": String;
    "strict": Boolean;
    "timePattern": String;
  end;

//CalendarLite

type
  J_MonthWidget = class external '_MonthWidget'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
  end;

//Calendar

type
  J_MonthDropDown = class external '_MonthDropDown'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "months": JObject;
    procedure set(&property: Jmonths; value: JObject);
    function get(&property: Jmonths): JObject;
    function watch(&property: Jmonths; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(month: Float);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_MonthDropDownButton = class external '_MonthDropDownButton'(Jdijit.form.DropDownButton)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(callback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: Variant): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMonthSelect;
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//Dialog

type
  J_DialogBase = class external '_DialogBase'(Jdijit._TemplatedMixin)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    "attachScope": JObject;
    "autofocus": Boolean;
    "baseClass": String;
    "closable": Boolean;
    "cssStateNodes": JObject;
    "doLayout": Boolean;
    "draggable": Boolean;
    "duration": Float;
    "hovering": Boolean;
    "maxRatio": Float;
    "open": Boolean;
    "refocus": Boolean;
    "searchContainerNode": Boolean;
    "state": String;
    "templatePath": String;
    "templateString": String;
    procedure buildRendering;
    procedure connectChildren(inStartup: Boolean);
    procedure destroy;
    procedure destroyRendering;
    procedure disconnectChildren;
    procedure execute(formContents: JObject);
    procedure focus;
    function getValues: Variant;
    function hide: Variant;
    isValid: : Boolean    end;;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function setValues(val: Variant): Variant;
    function show: Variant;
    procedure startup;
    function validate: Variant;
    function getCachedTemplate: Variant;
    procedure onCancel;
    procedure onExecute;
    procedure onLoad;
    procedure onValidStateChange(isValid: Boolean);
  end;

  J_DialogLevelManager = class external
    procedure hide(dialog: Jdijit._WidgetBase);
    function isTop(dialog: Jdijit._WidgetBase): Boolean;
    procedure show(dialog: Jdijit._WidgetBase; underlayAttrs: JObject);
  end;

//ColorPalette

type
  J_Color = class external '_Color'(Jdojo._base.Color)
    constructor Create(alias: JString; row: Float; col: Variant; title: JString);
    "a": Float;
    "b": Float;
    "g": Float;
    "hcTemplate": String;
    "r": Float;
    "template": String;
    procedure fillCell(cell: JHTMLElement; blankGif: JString);
    function getValue: Variant;
    procedure sanitize;
    function setColor(color: array of Variant): JFunction;
    function setColor(color: JString): JFunction;
    function setColor(color: JObject): JFunction;
    function toCss(includeAlpha: Boolean): JString;
    function toHex: JString;
    function toRgb: array of Variant;
    function toRgba: array of Variant;
    function toString: Variant;
  end;

//InlineEditBox

type
  J_InlineEditor = class external '_InlineEditor'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": JObject;
    procedure set(&property: Jstyle; value: JObject);
    function get(&property: Jstyle): JObject;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure contextRequire;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function enableSave: Boolean;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//MenuBarItem

type
  J_MenuBarItemMixin = class external '_MenuBarItemMixin'
    constructor Create;
    "templateString": String;
  end;

//Tooltip

type
  J_MasterTooltip = class external '_MasterTooltip'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    procedure hide(aroundNode: Variant);
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function orient(node: JHTMLElement; aroundCorner: JString; tooltipCorner: JString; spaceAvailable: JObject; aroundNodeCoords: JObject): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure show(innerHTML: JString; aroundNode: JHTMLElement; position: array of JString; rtl: Boolean; textDir: JString);
    procedure show(innerHTML: JString; aroundNode: Jdijit.place.__Rectangle; position: array of JString; rtl: Boolean; textDir: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//Tree

type
  J_TreeNode = class external '_TreeNode'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "indent": Float;
    procedure set(&property: Jindent; value: Float);
    function get(&property: Jindent): Float;
    function watch(&property: Jindent; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "isExpanded": Boolean;
    procedure set(&property: JisExpanded; value: Boolean);
    function get(&property: JisExpanded): Boolean;
    function watch(&property: JisExpanded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isTreeNode": Boolean;
    procedure set(&property: JisTreeNode; value: Boolean);
    function get(&property: JisTreeNode): Boolean;
    function watch(&property: JisTreeNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "item": JObject;
    procedure set(&property: Jitem; value: JObject);
    function get(&property: Jitem): JObject;
    function watch(&property: Jitem; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "labelType": String;
    procedure set(&property: JlabelType; value: String);
    function get(&property: JlabelType): String;
    function watch(&property: JlabelType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function collapse: Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function expand: Variant;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIdentity: Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function getTreePath: array of Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure makeExpandable;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(node: Jdijit.Tree._TreeNode);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    function setChildItems(items: array of JObject): Variant;
    procedure setSelected(selected: Boolean);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//_editor

type
  J_Plugin = class external '_Plugin'(Jdijit.Destroyable)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "registry": JObject;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JRichText = class external 'RichText'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "captureEvents": JObject;
    procedure set(&property: JcaptureEvents; value: JObject);
    function get(&property: JcaptureEvents): JObject;
    function watch(&property: JcaptureEvents; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "disableSpellCheck": Boolean;
    procedure set(&property: JdisableSpellCheck; value: Boolean);
    function get(&property: JdisableSpellCheck): Boolean;
    function watch(&property: JdisableSpellCheck; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusOnLoad": Boolean;
    procedure set(&property: JfocusOnLoad; value: Boolean);
    function get(&property: JfocusOnLoad): Boolean;
    function watch(&property: JfocusOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "height": String;
    procedure set(&property: Jheight; value: String);
    function get(&property: Jheight): String;
    function watch(&property: Jheight; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "inheritWidth": Boolean;
    procedure set(&property: JinheritWidth; value: Boolean);
    function get(&property: JinheritWidth): Boolean;
    function watch(&property: JinheritWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isClosed": Boolean;
    procedure set(&property: JisClosed; value: Boolean);
    function get(&property: JisClosed): Boolean;
    function watch(&property: JisClosed; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isTabIndent": Boolean;
    procedure set(&property: JisTabIndent; value: Boolean);
    function get(&property: JisTabIndent): Boolean;
    function watch(&property: JisTabIndent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "minHeight": String;
    procedure set(&property: JminHeight; value: String);
    function get(&property: JminHeight): String;
    function watch(&property: JminHeight; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": JObject;
    procedure set(&property: Jname; value: JObject);
    function get(&property: Jname): JObject;
    function watch(&property: Jname; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "styleSheets": String;
    procedure set(&property: JstyleSheets; value: String);
    function get(&property: JstyleSheets): String;
    function watch(&property: JstyleSheets; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "updateInterval": Float;
    procedure set(&property: JupdateInterval; value: Float);
    function get(&property: JupdateInterval): Float;
    function watch(&property: JupdateInterval; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    procedure addKeyHandler(key: JString; ctrl: Boolean; shift: Boolean; handler: JFunction);
    procedure addKeyHandler(key: Float; ctrl: Boolean; shift: Boolean; handler: JFunction);
    procedure addStyleSheet(uri: Jdojo._base.url);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure blur;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function execCommand(command: JString; argument: Variant): Variant;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getFooterHeight: Variant;
    function getHeaderHeight: Variant;
    function getNodeChildrenHtml(dom: JHTMLElement): Variant;
    function getNodeHtml(node: JHTMLElement): Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function queryCommandEnabled(command: JString): Variant;
    function queryCommandState(command: Variant): Variant;
    function queryCommandValue(command: Variant): Variant;
    procedure removeStyleSheet(uri: Jdojo._base.url);
    procedure replaceValue(html: JString);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setupDefaultShortcuts;
    procedure setValue(html: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onChange(newContent: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    function onKeyDown(e: JEvent): Boolean;
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(e: Variant);
    procedure onLoad(html: JString);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  Jhtml = class external
    function escapeXml(str: JString; noSingleQuotes: Boolean): Variant;
    function getChildrenHtml(node: JHTMLElement): Variant;
    procedure getChildrenHtmlHelper(dom: JHTMLElement; output: array of JString);
    function getNodeHtml(node: JHTMLElement): Variant;
    function getNodeHtmlHelper(node: JHTMLElement; output: array of JString): JString;
  end;

  Jrange = class external
    BlockTagNames: JRegExp;
    ie: JObject;
    function adjacentNoneTextNode(startnode: Variant; next: Variant): array of Variant;
    function atBeginningOfContainer(container: JHTMLElement; node: JHTMLElement; offset: Float): Boolean;
    function atEndOfContainer(container: JHTMLElement; node: JHTMLElement; offset: Float): Boolean;
    function create(win: JWindow): Variant;
    function getAncestor(node: JHTMLElement; regex: JRegExp; root: JHTMLElement): JHTMLElement;
    function getBlockAncestor(node: JHTMLElement; regex: JRegExp; root: JHTMLElement): JObject;
    function getCommonAncestor(n1: Variant; n2: Variant; root: Variant): Variant;
    function getIndex(node: JHTMLElement; parent: JHTMLElement): JObject;
    function getNode(index: array of Variant; parent: JHTMLElement): JHTMLElement;
    function getSelection(window: JWindow; ignoreUpdate: Boolean): Variant;
    procedure W3CRange;
  end;

  Jselection = class external
    procedure collapse(beginning: Boolean);
    function getAncestorElement(tagName: JString): Variant;
    function getParentElement: Variant;
    function getParentOfType(node: JHTMLElement; tags: array of JString): JHTMLElement;
    function getSelectedElement: Variant;
    function getSelectedHtml: JString;
    function getSelectedText: JString;
    function getType: JString;
    function hasAncestorElement(tagName: JString): Boolean;
    function inSelection(node: Variant): Boolean;
    function isTag(node: JHTMLElement; tags: array of JString): Variant;
    function remove: Variant;
    procedure selectElement(element: JHTMLElement; nochangefocus: Boolean);
    procedure selectElementChildren(element: JHTMLElement; nochangefocus: Boolean);
  end;

//_Plugin

type
  Jregistry = class external
    function bold(args: Variant): Variant;
    procedure colorTableCell(args: Variant);
    function copy(args: Variant): Variant;
    procedure createLink;
    function cut(args: Variant): Variant;
    function delete(args: Variant): Variant;
    function deleteTableColumn(args: Variant): Variant;
    function deleteTableRow(args: Variant): Variant;
    procedure foreColor;
    procedure fullScreen(args: Variant);
    procedure fullscreen(args: Variant);
    procedure hiliteColor;
    function indent(args: Variant): Variant;
    function insertHorizontalRule(args: Variant): Variant;
    procedure insertImage;
    function insertOrderedList(args: Variant): Variant;
    procedure insertTable(args: Variant);
    function insertTableColumnAfter(args: Variant): Variant;
    function insertTableColumnBefore(args: Variant): Variant;
    function insertTableRowAfter(args: Variant): Variant;
    function insertTableRowBefore(args: Variant): Variant;
    function insertUnorderedList(args: Variant): Variant;
    function italic(args: Variant): Variant;
    function justifyCenter(args: Variant): Variant;
    function justifyFull(args: Variant): Variant;
    function justifyLeft(args: Variant): Variant;
    function justifyRight(args: Variant): Variant;
    function LocalImage(args: Variant): Variant;
    function localImage(args: Variant): Variant;
    function localimage(args: Variant): Variant;
    procedure modifyTable(args: Variant);
    procedure newPage(args: Variant);
    procedure newpage(args: Variant);
    function outdent(args: Variant): Variant;
    function paste(args: Variant): Variant;
    procedure print;
    function redo(args: Variant): Variant;
    function removeFormat(args: Variant): Variant;
    function selectAll(args: Variant): Variant;
    function strikethrough(args: Variant): Variant;
    function subscript(args: Variant): Variant;
    function superscript(args: Variant): Variant;
    procedure tabIndent;
    procedure tableContextMenu(args: Variant);
    procedure toggleDir;
    function underline(args: Variant): Variant;
    function undo(args: Variant): Variant;
    function unlink(args: Variant): Variant;
    procedure viewSource(args: Variant);
    procedure viewsource(args: Variant);
  end;

//plugins

type
  JAlwaysShowToolbar = class external 'AlwaysShowToolbar'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(e: Variant);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JFontChoice = class external 'FontChoice'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JFullScreen = class external 'FullScreen'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "isFullscreen": Boolean;
    "useDefaultCommand": Boolean;
    "zIndex": Float;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure toggle;
    procedure updateState;
  end;

  JEnterKeyHandling = class external 'EnterKeyHandling'(Jdijit._editor._Plugin)
    constructor Create(args: Variant);
    "blockNodeForEnter": String;
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Variant);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JLinkDialog = class external 'LinkDialog'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "emailRegExp": String;
    "htmlTemplate": String;
    "iconClassPrefix": String;
    "linkDialogTemplate": String;
    "tag": String;
    "urlRegExp": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    procedure ImgLinkDialog;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JTextColor = class external 'TextColor'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JNewPage = class external 'NewPage'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "content": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JPrint = class external 'Print'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JTabIndent = class external 'TabIndent'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JToggleDir = class external 'ToggleDir'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

  JViewSource = class external 'ViewSource'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "iconClassPrefix": String;
    "readOnly": Boolean;
    "stripComments": Boolean;
    "stripIFrames": Boolean;
    "stripScripts": Boolean;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setSourceAreaCaret;
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure toggle;
    procedure updateState;
  end;

//FontChoice

type
  J_FontDropDown = class external '_FontDropDown'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "plainText": Boolean;
    procedure set(&property: JplainText; value: Boolean);
    function get(&property: JplainText): Boolean;
    function watch(&property: JplainText; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure contextRequire;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_FontNameDropDown = class external '_FontNameDropDown'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "comboClass": String;
    procedure set(&property: JcomboClass; value: String);
    function get(&property: JcomboClass): String;
    function watch(&property: JcomboClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "command": String;
    procedure set(&property: Jcommand; value: String);
    function get(&property: Jcommand): String;
    function watch(&property: Jcommand; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "generic": Boolean;
    procedure set(&property: Jgeneric; value: Boolean);
    function get(&property: Jgeneric): Boolean;
    function watch(&property: Jgeneric; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "plainText": Boolean;
    procedure set(&property: JplainText; value: Boolean);
    function get(&property: JplainText): Boolean;
    function watch(&property: JplainText; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure contextRequire;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getLabel(value: JString; name: JString): Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_FontSizeDropDown = class external '_FontSizeDropDown'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "comboClass": String;
    procedure set(&property: JcomboClass; value: String);
    function get(&property: JcomboClass): String;
    function watch(&property: JcomboClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "command": String;
    procedure set(&property: Jcommand; value: String);
    function get(&property: Jcommand): String;
    function watch(&property: Jcommand; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "plainText": Boolean;
    procedure set(&property: JplainText; value: Boolean);
    function get(&property: JplainText): Boolean;
    function watch(&property: JplainText; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "values": JObject;
    procedure set(&property: Jvalues; value: JObject);
    function get(&property: Jvalues): JObject;
    function watch(&property: Jvalues; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure contextRequire;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getLabel(value: JString; name: JString): Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_FormatBlockDropDown = class external '_FormatBlockDropDown'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "comboClass": String;
    procedure set(&property: JcomboClass; value: String);
    function get(&property: JcomboClass): String;
    function watch(&property: JcomboClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "command": String;
    procedure set(&property: Jcommand; value: String);
    function get(&property: Jcommand): String;
    function watch(&property: Jcommand; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "plainText": Boolean;
    procedure set(&property: JplainText; value: Boolean);
    function get(&property: JplainText): Boolean;
    function watch(&property: JplainText; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "values": array of Variant;
    procedure set(&property: Jvalues; value: array of Variant);
    function get(&property: Jvalues): array of Variant;
    function watch(&property: Jvalues; callback: (&property: String; oldValue: array of Variant; newValue: array of Variant)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure contextRequire;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getLabel(value: JString; name: JString): Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//LinkDialog

type
  JImgLinkDialog = class external 'ImgLinkDialog'(Jdijit._editor._Plugin)
    constructor Create(args: JObject);
    "button": JObject;
    "command": String;
    "disabled": Boolean;
    "editor": JObject;
    "emailRegExp": String;
    "htmlTemplate": String;
    "iconClassPrefix": String;
    "linkDialogTemplate": String;
    "tag": String;
    "urlRegExp": String;
    "useDefaultCommand": Boolean;
    procedure buttonClass;
    procedure connect(o: Variant; f: Variant; tf: Variant);
    procedure destroy;
    function get(name: Variant): Variant;
    function own: Variant;
    function set(name: JAttr; value: Variant): Variant;
    procedure setEditor(editor: Jdijit.Editor);
    procedure setToolbar(toolbar: Jdijit.Toolbar);
    procedure updateState;
  end;

//range

type
  JW3CRange = class external 'W3CRange'
    constructor Create;
    function cloneRange: Variant;
    procedure deleteContents;
    procedure detach;
    function getBookmark: Variant;
    procedure setEnd(node: Variant; offset: Variant);
    procedure setEndAfter(node: Variant; offset: Variant);
    procedure setEndBefore(node: Variant; offset: Variant);
    procedure setStart(node: Variant; offset: Variant);
    procedure setStartAfter(node: Variant; offset: Variant);
    procedure setStartBefore(node: Variant; offset: Variant);
  end;

  Jie = class external
    cachedSelection: JObject;
    function decomposeControlRange(range: Variant): array of Variant;
    function decomposeTextRange(range: Variant): array of Variant;
    function getEndPoint(range: Variant; &end: Variant): array of Variant;
    procedure selection(window: Variant);
    function setEndPoint(range: Variant; container: Variant; offset: Variant): Variant;
    function setRange(range: Variant; startContainer: Variant; startOffset: Variant; endContainer: Variant; endOffset: Variant; collapsed: Variant): Variant;
  end;

//_tree

type
  JdndSource = class external
  end;

//form

type
  J_ButtonMixin = class external '_ButtonMixin'
    constructor Create;
    "label": String;
    "type": String;
    procedure postCreate;
    function onClick(e: JEvent): Boolean;
  end;

  J_CheckBoxMixin = class external '_CheckBoxMixin'
    constructor Create;
    "readOnly": Boolean;
    "value": String;
    procedure reset;
  end;

  J_AutoCompleterMixin = class external '_AutoCompleterMixin'(Jdijit.form._SearchMixin)
    constructor Create;
    "autoComplete": Boolean;
    "fetchProperties": JObject;
    "highlightMatch": String;
    "ignoreCase": Boolean;
    "item": JObject;
    "labelAttr": JObject;
    "labelType": String;
    "maxHeight": Float;
    "pageSize": Float;
    "query": JObject;
    "queryExpr": String;
    "searchAttr": String;
    "searchDelay": Float;
    "store": JObject;
    procedure closeDropDown;
    function doHighlight(&label: JString; find: JString): Variant;
    function isLoaded: Boolean;
    procedure loadDropDown(callback: JFunction);
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    procedure onSearch(results: JObject; query: JObject; options: JObject);
  end;

  J_ExpandingTextAreaMixin = class external '_ExpandingTextAreaMixin'
    constructor Create;
    procedure postCreate;
    procedure resize;
    procedure startup;
  end;

  J_ComboBoxMenuMixin = class external '_ComboBoxMenuMixin'
    constructor Create;
    procedure buildRendering;
    procedure clearResultList;
    procedure createOptions(results: Variant; options: Variant; labelFunc: Variant);
    function getHighlightedOption: Variant;
    procedure highlightFirstOption;
    procedure highlightLastOption;
    procedure postMixInProperties;
    procedure selectFirstNode;
    procedure selectLastNode;
    procedure onChange(direction: Float);
    procedure onClick(node: JHTMLElement);
    procedure onPage(direction: Float);
  end;

  J_FormMixin = class external '_FormMixin'
    constructor Create;
    "state": String;
    procedure connectChildren(inStartup: Boolean);
    procedure destroy;
    procedure disconnectChildren;
    function getValues: Variant;
    isValid: : Boolean    end;;
    procedure reset;
    function setValues(val: Variant): Variant;
    procedure startup;
    function validate: Variant;
    procedure onValidStateChange(isValid: Boolean);
  end;

  J_FormValueMixin = class external '_FormValueMixin'(Jdijit.form._FormWidgetMixin)
    constructor Create;
    "alt": String;
    "aria-label": String;
    "disabled": Boolean;
    "intermediateChanges": Boolean;
    "name": String;
    "readOnly": Boolean;
    "scrollOnFocus": Boolean;
    "tabIndex": String;
    "type": String;
    "value": JObject;
    function compare(val1: Variant; val2: Variant): Float;
    procedure create;
    procedure destroy;
    procedure focus;
    function isFocusable: Variant;
    procedure postCreate;
    procedure reset;
    procedure undo;
    procedure onChange(newValue: Variant);
  end;

  J_ComboBoxMenu = class external '_ComboBoxMenu'(Jdijit._WidgetBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JHTMLElement;
    procedure set(&property: Jselected; value: JHTMLElement);
    function get(&property: Jselected): JHTMLElement;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure buildRendering;
    procedure clearResultList;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure createOptions(results: Variant; options: Variant; labelFunc: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getHighlightedOption: Variant;
    function getParent: Variant;
    function handleKey(evt: Variant): Boolean;
    procedure highlightFirstOption;
    procedure highlightLastOption;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure selectFirstNode;
    procedure selectLastNode;
    procedure selectNextNode;
    procedure selectPreviousNode;
    function set(name: Variant; value: Variant): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(direction: Float);
    procedure onClick(node: JHTMLElement);
    procedure onDeselect(node: JHTMLElement);
    procedure onFocus;
    procedure onHover(node: JHTMLElement);
    procedure onPage(direction: Float);
    procedure onSelect(node: JHTMLElement);
    procedure onUnhover(node: JHTMLElement);
  end;

  J_FormWidgetMixin = class external '_FormWidgetMixin'
    constructor Create;
    "alt": String;
    "aria-label": String;
    "disabled": Boolean;
    "intermediateChanges": Boolean;
    "name": String;
    "scrollOnFocus": Boolean;
    "tabIndex": String;
    "type": String;
    "value": JObject;
    function compare(val1: Variant; val2: Variant): Float;
    procedure create;
    procedure destroy;
    procedure focus;
    function isFocusable: Variant;
    procedure onChange(newValue: Variant);
  end;

  J_DateTimeTextBox = class external '_DateTimeTextBox'(Jdijit.form.RangeBoundTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownDefaultValue": JDate;
    procedure set(&property: JdropDownDefaultValue; value: JDate);
    function get(&property: JdropDownDefaultValue): JDate;
    function watch(&property: JdropDownDefaultValue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hasDownArrow": Boolean;
    procedure set(&property: JhasDownArrow; value: Boolean);
    function get(&property: JhasDownArrow): Boolean;
    function watch(&property: JhasDownArrow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "popupClass": Variant;
    procedure set(&property: JpopupClass; value: Variant);
    function get(&property: JpopupClass): Variant;
    function watch(&property: JpopupClass; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: JDate; val2: JDate): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JDate; constraints: JObject): Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    isValid: (isFocused: Boolean): Variant    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    procedure openDropDown; overload;
    procedure openDropDown(callback: JFunction); overload;
    function own: Variant;
    function parse(value: JString; constraints: JObject): Variant;
    pattern: (options: JObject): Variant    end;;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_FormSelectWidget = class external '_FormSelectWidget'(Jdijit.form._FormValueWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "labelAttr": JObject;
    procedure set(&property: JlabelAttr; value: JObject);
    function get(&property: JlabelAttr): JObject;
    function watch(&property: JlabelAttr; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadChildrenOnOpen": Boolean;
    procedure set(&property: JloadChildrenOnOpen; value: Boolean);
    function get(&property: JloadChildrenOnOpen): Boolean;
    function watch(&property: JloadChildrenOnOpen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "multiple": Boolean;
    procedure set(&property: Jmultiple; value: Boolean);
    function get(&property: Jmultiple): Boolean;
    function watch(&property: Jmultiple; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onFetch": JFunction;
    procedure set(&property: JonFetch; value: JFunction);
    function get(&property: JonFetch): JFunction;
    function watch(&property: JonFetch; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "options": JObject;
    procedure set(&property: Joptions; value: JObject);
    function get(&property: Joptions): JObject;
    function watch(&property: Joptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "query": JObject;
    procedure set(&property: Jquery; value: JObject);
    function get(&property: Jquery): JObject;
    function watch(&property: Jquery; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "queryOptions": JObject;
    procedure set(&property: JqueryOptions; value: JObject);
    function get(&property: JqueryOptions): JObject;
    function watch(&property: JqueryOptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "sortByLabel": Boolean;
    procedure set(&property: JsortByLabel; value: Boolean);
    function get(&property: JsortByLabel): Boolean;
    function watch(&property: JsortByLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "store": JObject;
    procedure set(&property: Jstore; value: JObject);
    function get(&property: Jstore): JObject;
    function watch(&property: Jstore; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addOption(option: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure addOption(option: array of Jdijit.form._FormSelectWidget.__SelectOption);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getOptions(valueOrIdx: Variant): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeOption(valueOrIdx: JString);
    procedure removeOption(valueOrIdx: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure removeOption(valueOrIdx: Float);
    procedure removeOption(valueOrIdx: array of Variant);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    function setStore(store: Jdojo.store.api.Store; selectedValue: Variant; fetchArgs: JObject): Variant;
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    procedure updateOption(newOption: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure updateOption(newOption: array of Jdijit.form._FormSelectWidget.__SelectOption);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onSetStore;
    procedure onShow;
  end;

  J_FormValueWidget = class external '_FormValueWidget'(Jdijit.form._FormWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": Variant;
    procedure set(&property: Jvalue; value: Variant);
    function get(&property: Jvalue): Variant;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_FormWidget = class external '_FormWidget'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": JObject;
    procedure set(&property: Jvalue; value: JObject);
    function get(&property: Jvalue): JObject;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_ListBase = class external '_ListBase'
    constructor Create;
    "selected": JHTMLElement;
    procedure selectFirstNode;
    procedure selectLastNode;
    procedure selectNextNode;
    procedure selectPreviousNode;
  end;

  J_RadioButtonMixin = class external '_RadioButtonMixin'
    constructor Create;
  end;

  J_ListMouseMixin = class external '_ListMouseMixin'(Jdijit.form._ListBase)
    constructor Create;
    "selected": JHTMLElement;
    procedure postCreate;
    procedure selectFirstNode;
    procedure selectLastNode;
    procedure selectNextNode;
    procedure selectPreviousNode;
  end;

  J_ToggleButtonMixin = class external '_ToggleButtonMixin'
    constructor Create;
    "checked": Boolean;
    procedure postCreate;
    procedure reset;
  end;

  J_SearchMixin = class external '_SearchMixin'
    constructor Create;
    "fetchProperties": JObject;
    "ignoreCase": Boolean;
    "pageSize": Float;
    "query": JObject;
    "queryExpr": String;
    "searchAttr": String;
    "searchDelay": Float;
    "store": JObject;
    procedure postMixInProperties;
    procedure onSearch(results: JObject; query: JObject; options: JObject);
  end;

  J_TextBoxMixin = class external '_TextBoxMixin'
    constructor Create;
    "displayedValue": String;
    "lowercase": Boolean;
    "maxLength": String;
    "placeHolder": String;
    "propercase": Boolean;
    "selectOnClick": Boolean;
    "trim": Boolean;
    "uppercase": Boolean;
    function filter(val: Variant): Variant;
    function format(value: JString; constraints: JObject): JString;
    function parse(value: JString; constraints: JObject): JString;
    procedure postCreate;
    procedure reset;
    procedure selectInputText(element: JHTMLElement; start: Float; stop: Float);
    procedure onInput(event: Variant);
  end;

  JComboBoxMixin = class external 'ComboBoxMixin'(Jdijit._HasDropDown)
    constructor Create;
    "autoComplete": Boolean;
    "autoWidth": Boolean;
    "baseClass": String;
    "cssStateNodes": JObject;
    "dropDown": JObject;
    "dropDownPosition": JObject;
    "fetchProperties": JObject;
    "forceWidth": Boolean;
    "hasDownArrow": Boolean;
    "highlightMatch": String;
    "ignoreCase": Boolean;
    "item": JObject;
    "labelAttr": JObject;
    "labelType": String;
    "maxHeight": Float;
    "pageSize": Float;
    "query": JObject;
    "queryExpr": String;
    "searchAttr": String;
    "searchDelay": Float;
    "store": JObject;
    "templateString": String;
    procedure buildRendering;
    procedure closeDropDown; overload;
    procedure closeDropDown(focus: Boolean); overload;
    procedure destroy;
    function doHighlight(&label: JString; find: JString): Variant;
    procedure dropDownClass;
    function isLoaded: Boolean;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function openDropDown: Variant;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    procedure toggleDropDown;
    procedure onSearch(results: JObject; query: JObject; options: JObject);
  end;

  JButton = class external 'Button'(Jdijit.form._FormWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JDataList = class external 'DataList'(Jdojo.store.Memory)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "data": array of Variant;
    "idProperty": String;
    "index": JObject;
    function add(&object: JObject; options: Jdojo.store.api.Store.PutDirectives): Variant;
    procedure destroy;
    function fetchSelectedItem: Variant;
    function get(id: Float): Variant;
    function getChildren(parent: JObject; options: Jdojo.store.api.Store.QueryOptions): Jdojo.store.api.Store.QueryResults;
    function getIdentity(&object: JObject): Variant;
    function getMetadata(&object: JObject): JObject;
    function put(&object: JObject; options: Jdojo.store.api.Store.PutDirectives): Variant;
    function query(query: JObject; options: Jdojo.store.api.Store.QueryOptions): Variant;
    function queryEngine(query: JObject; options: Jdojo.store.api.Store.QueryOptions): Variant;
    function remove(id: Float): Variant;
    procedure setData(data: array of JObject);
    function transaction: Jdojo.store.api.Store.Transaction;
  end;

  J_Spinner = class external '_Spinner'(Jdijit.form.RangeBoundTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "defaultTimeout": Float;
    procedure set(&property: JdefaultTimeout; value: Float);
    function get(&property: JdefaultTimeout): Float;
    function watch(&property: JdefaultTimeout; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "largeDelta": Float;
    procedure set(&property: JlargeDelta; value: Float);
    function get(&property: JlargeDelta): Float;
    function watch(&property: JlargeDelta; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "minimumTimeout": Float;
    procedure set(&property: JminimumTimeout; value: Float);
    function get(&property: JminimumTimeout): Float;
    function watch(&property: JminimumTimeout; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "smallDelta": Float;
    procedure set(&property: JsmallDelta; value: Float);
    function get(&property: JsmallDelta): Float;
    function watch(&property: JsmallDelta; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "timeoutChangeRate": Float;
    procedure set(&property: JtimeoutChangeRate; value: Float);
    function get(&property: JtimeoutChangeRate): Float;
    function watch(&property: JtimeoutChangeRate; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function adjust(val: JObject; delta: Float): JObject;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    isValid: (isFocused: Boolean): Variant    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JCheckBox = class external 'CheckBox'(Jdijit.form.ToggleButton)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setChecked(checked: Boolean);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JComboButton = class external 'ComboButton'(Jdijit.form.DropDownButton)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "optionsTitle": String;
    procedure set(&property: JoptionsTitle; value: String);
    function get(&property: JoptionsTitle): String;
    function watch(&property: JoptionsTitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus; overload;
    procedure focus(position: JString); overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(callback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: Variant): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JComboBox = class external 'ComboBox'(Jdijit.form.ValidationTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoComplete": Boolean;
    procedure set(&property: JautoComplete; value: Boolean);
    function get(&property: JautoComplete): Boolean;
    function watch(&property: JautoComplete; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "fetchProperties": JObject;
    procedure set(&property: JfetchProperties; value: JObject);
    function get(&property: JfetchProperties): JObject;
    function watch(&property: JfetchProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hasDownArrow": Boolean;
    procedure set(&property: JhasDownArrow; value: Boolean);
    function get(&property: JhasDownArrow): Boolean;
    function watch(&property: JhasDownArrow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "highlightMatch": String;
    procedure set(&property: JhighlightMatch; value: String);
    function get(&property: JhighlightMatch): String;
    function watch(&property: JhighlightMatch; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ignoreCase": Boolean;
    procedure set(&property: JignoreCase; value: Boolean);
    function get(&property: JignoreCase): Boolean;
    function watch(&property: JignoreCase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "item": JObject;
    procedure set(&property: Jitem; value: JObject);
    function get(&property: Jitem): JObject;
    function watch(&property: Jitem; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelAttr": JObject;
    procedure set(&property: JlabelAttr; value: JObject);
    function get(&property: JlabelAttr): JObject;
    function watch(&property: JlabelAttr; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelType": String;
    procedure set(&property: JlabelType; value: String);
    function get(&property: JlabelType): String;
    function watch(&property: JlabelType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pageSize": Float;
    procedure set(&property: JpageSize; value: Float);
    function get(&property: JpageSize): Float;
    function watch(&property: JpageSize; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "query": JObject;
    procedure set(&property: Jquery; value: JObject);
    function get(&property: Jquery): JObject;
    function watch(&property: Jquery; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "queryExpr": String;
    procedure set(&property: JqueryExpr; value: String);
    function get(&property: JqueryExpr): String;
    function watch(&property: JqueryExpr; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchAttr": String;
    procedure set(&property: JsearchAttr; value: String);
    function get(&property: JsearchAttr): String;
    function watch(&property: JsearchAttr; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchDelay": Float;
    procedure set(&property: JsearchDelay; value: Float);
    function get(&property: JsearchDelay): Float;
    function watch(&property: JsearchDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "store": JObject;
    procedure set(&property: Jstore; value: JObject);
    function get(&property: Jstore): JObject;
    function watch(&property: Jstore; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function doHighlight(&label: JString; find: JString): Variant;
    procedure dropDownClass;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    isValid: (isFocused: Boolean): Boolean    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate(isFocused: Boolean): Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onSearch(results: JObject; query: JObject; options: JObject);
    procedure onShow;
  end;

  JCurrencyTextBox = class external 'CurrencyTextBox'(Jdijit.form.NumberTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "currency": String;
    procedure set(&property: Jcurrency; value: String);
    function get(&property: Jcurrency): String;
    function watch(&property: Jcurrency; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "editOptions": JObject;
    procedure set(&property: JeditOptions; value: JObject);
    function get(&property: JeditOptions): JObject;
    function watch(&property: JeditOptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    isValid: (isFocused: Boolean): Boolean    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JForm = class external 'Form'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "accept": JObject;
    procedure set(&property: Jaccept; value: JObject);
    function get(&property: Jaccept): JObject;
    function watch(&property: Jaccept; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "accept-charset": String;
    procedure set(&property: Jaccept-charset; value: String);
    function get(&property: Jaccept-charset): String;
    function watch(&property: Jaccept-charset; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "action": JObject;
    procedure set(&property: Jaction; value: JObject);
    function get(&property: Jaction): JObject;
    function watch(&property: Jaction; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "encType": JObject;
    procedure set(&property: JencType; value: JObject);
    function get(&property: JencType): JObject;
    function watch(&property: JencType; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "method": JObject;
    procedure set(&property: Jmethod; value: JObject);
    function get(&property: Jmethod): JObject;
    function watch(&property: Jmethod; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "name": JObject;
    procedure set(&property: Jname; value: JObject);
    function get(&property: Jname): JObject;
    function watch(&property: Jname; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "target": JObject;
    procedure set(&property: Jtarget; value: JObject);
    function get(&property: Jtarget): JObject;
    function watch(&property: Jtarget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectChildren(inStartup: Boolean);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure disconnectChildren;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure execute(formContents: JObject);
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValues: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: : Boolean    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset; overload;
    procedure reset(e: JEvent); overload;
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    function setValues(val: Variant): Variant;
    procedure startup;
    procedure submit;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    function onReset(e: JEvent): Boolean;
    procedure onShow;
    function onSubmit(e: JEvent): Variant;
    procedure onValidStateChange(isValid: Boolean);
  end;

  JDropDownButton = class external 'DropDownButton'(Jdijit.form.Button)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(callback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: Variant): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JDateTextBox = class external 'DateTextBox'(Jdijit.form._DateTimeTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownDefaultValue": JDate;
    procedure set(&property: JdropDownDefaultValue; value: JDate);
    function get(&property: JdropDownDefaultValue): JDate;
    function watch(&property: JdropDownDefaultValue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hasDownArrow": Boolean;
    procedure set(&property: JhasDownArrow; value: Boolean);
    function get(&property: JhasDownArrow): Boolean;
    function watch(&property: JhasDownArrow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: JDate; val2: JDate): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JDate; constraints: JObject): Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    isValid: (isFocused: Boolean): Variant    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    procedure openDropDown(callback: JFunction);
    function own: Variant;
    function parse(value: JString; constraints: JObject): Variant;
    pattern: (options: JObject): Variant    end;;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JHorizontalRule = class external 'HorizontalRule'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "container": String;
    procedure set(&property: Jcontainer; value: String);
    function get(&property: Jcontainer): String;
    function watch(&property: Jcontainer; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "count": Float;
    procedure set(&property: Jcount; value: Float);
    function get(&property: Jcount): Float;
    function watch(&property: Jcount; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ruleStyle": String;
    procedure set(&property: JruleStyle; value: String);
    function get(&property: JruleStyle): String;
    function watch(&property: JruleStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JFilteringSelect = class external 'FilteringSelect'(Jdijit.form.MappedTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoComplete": Boolean;
    procedure set(&property: JautoComplete; value: Boolean);
    function get(&property: JautoComplete): Boolean;
    function watch(&property: JautoComplete; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "fetchProperties": JObject;
    procedure set(&property: JfetchProperties; value: JObject);
    function get(&property: JfetchProperties): JObject;
    function watch(&property: JfetchProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hasDownArrow": Boolean;
    procedure set(&property: JhasDownArrow; value: Boolean);
    function get(&property: JhasDownArrow): Boolean;
    function watch(&property: JhasDownArrow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "highlightMatch": String;
    procedure set(&property: JhighlightMatch; value: String);
    function get(&property: JhighlightMatch): String;
    function watch(&property: JhighlightMatch; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ignoreCase": Boolean;
    procedure set(&property: JignoreCase; value: Boolean);
    function get(&property: JignoreCase): Boolean;
    function watch(&property: JignoreCase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "item": JObject;
    procedure set(&property: Jitem; value: JObject);
    function get(&property: Jitem): JObject;
    function watch(&property: Jitem; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelAttr": JObject;
    procedure set(&property: JlabelAttr; value: JObject);
    function get(&property: JlabelAttr): JObject;
    function watch(&property: JlabelAttr; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelType": String;
    procedure set(&property: JlabelType; value: String);
    function get(&property: JlabelType): String;
    function watch(&property: JlabelType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pageSize": Float;
    procedure set(&property: JpageSize; value: Float);
    function get(&property: JpageSize): Float;
    function watch(&property: JpageSize; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "query": JObject;
    procedure set(&property: Jquery; value: JObject);
    function get(&property: Jquery): JObject;
    function watch(&property: Jquery; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "queryExpr": String;
    procedure set(&property: JqueryExpr; value: String);
    function get(&property: JqueryExpr): String;
    function watch(&property: JqueryExpr; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchAttr": String;
    procedure set(&property: JsearchAttr; value: String);
    function get(&property: JsearchAttr): String;
    function watch(&property: JsearchAttr; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchDelay": Float;
    procedure set(&property: JsearchDelay; value: Float);
    function get(&property: JsearchDelay): Float;
    function watch(&property: JsearchDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "store": JObject;
    procedure set(&property: Jstore; value: JObject);
    function get(&property: Jstore): JObject;
    function watch(&property: Jstore; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function doHighlight(&label: JString; find: JString): Variant;
    procedure dropDownClass;
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    isValid: : Boolean    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onSearch(results: JObject; query: JObject; options: JObject);
    procedure onShow;
  end;

  JHorizontalRuleLabels = class external 'HorizontalRuleLabels'(Jdijit.form.HorizontalRule)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "container": String;
    procedure set(&property: Jcontainer; value: String);
    function get(&property: Jcontainer): String;
    function watch(&property: Jcontainer; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "count": Float;
    procedure set(&property: Jcount; value: Float);
    function get(&property: Jcount): Float;
    function watch(&property: Jcount; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "labels": JObject;
    procedure set(&property: Jlabels; value: JObject);
    function get(&property: Jlabels): JObject;
    function watch(&property: Jlabels; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelStyle": String;
    procedure set(&property: JlabelStyle; value: String);
    function get(&property: JlabelStyle): String;
    function watch(&property: JlabelStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maximum": Float;
    procedure set(&property: Jmaximum; value: Float);
    function get(&property: Jmaximum): Float;
    function watch(&property: Jmaximum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "minimum": Float;
    procedure set(&property: Jminimum; value: Float);
    function get(&property: Jminimum): Float;
    function watch(&property: Jminimum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "numericMargin": Float;
    procedure set(&property: JnumericMargin; value: Float);
    function get(&property: JnumericMargin): Float;
    function watch(&property: JnumericMargin; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ruleStyle": String;
    procedure set(&property: JruleStyle; value: String);
    function get(&property: JruleStyle): String;
    function watch(&property: JruleStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getLabels: Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMappedTextBox = class external 'MappedTextBox'(Jdijit.form.ValidationTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JObject;
    procedure set(&property: Jvalue; value: JObject);
    function get(&property: Jvalue): JObject;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    isValid: (isFocused: Boolean): Variant    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString): Variant; overload;
    function parse(value: JString; constraints: JObject): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JMultiSelect = class external 'MultiSelect'(Jdijit.form._FormValueWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiple": Boolean;
    procedure set(&property: Jmultiple; value: Boolean);
    function get(&property: Jmultiple): Boolean;
    function watch(&property: Jmultiple; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "size": Float;
    procedure set(&property: Jsize; value: Float);
    function get(&property: Jsize): Float;
    function watch(&property: Jsize; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addSelected(select: Jdijit.form.MultiSelect);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getSelected: Variant;
    function getValue: Variant;
    procedure invertSelection(onChange: Boolean);
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    procedure resize(size: JObject);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JHorizontalSlider = class external 'HorizontalSlider'(Jdijit.form._FormValueWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "clickSelect": Boolean;
    procedure set(&property: JclickSelect; value: Boolean);
    function get(&property: JclickSelect): Boolean;
    function watch(&property: JclickSelect; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "discreteValues": Float;
    procedure set(&property: JdiscreteValues; value: Float);
    function get(&property: JdiscreteValues): Float;
    function watch(&property: JdiscreteValues; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maximum": Float;
    procedure set(&property: Jmaximum; value: Float);
    function get(&property: Jmaximum): Float;
    function watch(&property: Jmaximum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "minimum": Float;
    procedure set(&property: Jminimum; value: Float);
    function get(&property: Jminimum): Float;
    function watch(&property: Jminimum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pageIncrement": Float;
    procedure set(&property: JpageIncrement; value: Float);
    function get(&property: JpageIncrement): Float;
    function watch(&property: JpageIncrement; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showButtons": Boolean;
    procedure set(&property: JshowButtons; value: Boolean);
    function get(&property: JshowButtons): Boolean;
    function watch(&property: JshowButtons; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "slideDuration": Float;
    procedure set(&property: JslideDuration; value: Float);
    function get(&property: JslideDuration): Float;
    function watch(&property: JslideDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": Float;
    procedure set(&property: Jvalue; value: Float);
    function get(&property: Jvalue): Float;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JNumberTextBox = class external 'NumberTextBox'(Jdijit.form.RangeBoundTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "editOptions": JObject;
    procedure set(&property: JeditOptions; value: JObject);
    function get(&property: JeditOptions): JObject;
    function watch(&property: JeditOptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isValid": Variant;
    procedure set(&property: JisValid; value: Variant);
    function get(&property: JisValid): Variant;
    function watch(&property: JisValid; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    procedure Mixin;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JNumberSpinner = class external 'NumberSpinner'(Jdijit.form._Spinner)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "defaultTimeout": Float;
    procedure set(&property: JdefaultTimeout; value: Float);
    function get(&property: JdefaultTimeout): Float;
    function watch(&property: JdefaultTimeout; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "editOptions": JObject;
    procedure set(&property: JeditOptions; value: JObject);
    function get(&property: JeditOptions): JObject;
    function watch(&property: JeditOptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "largeDelta": Float;
    procedure set(&property: JlargeDelta; value: Float);
    function get(&property: JlargeDelta): Float;
    function watch(&property: JlargeDelta; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "minimumTimeout": Float;
    procedure set(&property: JminimumTimeout; value: Float);
    function get(&property: JminimumTimeout): Float;
    function watch(&property: JminimumTimeout; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "smallDelta": Float;
    procedure set(&property: JsmallDelta; value: Float);
    function get(&property: JsmallDelta): Float;
    function watch(&property: JsmallDelta; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "timeoutChangeRate": Float;
    procedure set(&property: JtimeoutChangeRate; value: Float);
    function get(&property: JtimeoutChangeRate): Float;
    function watch(&property: JtimeoutChangeRate; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function adjust(val: JObject; delta: Float): Variant;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    isValid: (isFocused: Boolean): Variant    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JRadioButton = class external 'RadioButton'(Jdijit.form.CheckBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setChecked(checked: Boolean);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JSimpleTextarea = class external 'SimpleTextarea'(Jdijit.form.TextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cols": String;
    procedure set(&property: Jcols; value: String);
    function get(&property: Jcols): String;
    function watch(&property: Jcols; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rows": Float;
    procedure set(&property: Jrows; value: Float);
    function get(&property: Jrows): Float;
    function watch(&property: Jrows; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(value: JString): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JRangeBoundTextBox = class external 'RangeBoundTextBox'(Jdijit.form.MappedTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": Variant;
    procedure set(&property: Jpattern; value: Variant);
    function get(&property: Jpattern): Variant;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JObject;
    procedure set(&property: Jvalue; value: JObject);
    function get(&property: Jvalue): JObject;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JObject; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    isValid: (isFocused: Boolean): Variant    end;;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): JString;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTextarea = class external 'Textarea'(Jdijit.form.SimpleTextarea)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "cols": String;
    procedure set(&property: Jcols; value: String);
    function get(&property: Jcols): String;
    function watch(&property: Jcols; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rows": Float;
    procedure set(&property: Jrows; value: Float);
    function get(&property: Jrows): Float;
    function watch(&property: Jrows; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(value: JString): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    procedure resize;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JSelect = class external 'Select'(Jdijit.form._FormSelectWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "emptyLabel": String;
    procedure set(&property: JemptyLabel; value: String);
    function get(&property: JemptyLabel): String;
    function watch(&property: JemptyLabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "labelAttr": JObject;
    procedure set(&property: JlabelAttr; value: JObject);
    function get(&property: JlabelAttr): JObject;
    function watch(&property: JlabelAttr; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadChildrenOnOpen": Boolean;
    procedure set(&property: JloadChildrenOnOpen; value: Boolean);
    function get(&property: JloadChildrenOnOpen): Boolean;
    function watch(&property: JloadChildrenOnOpen; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "multiple": Boolean;
    procedure set(&property: Jmultiple; value: Boolean);
    function get(&property: Jmultiple): Boolean;
    function watch(&property: Jmultiple; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onFetch": JFunction;
    procedure set(&property: JonFetch; value: JFunction);
    function get(&property: JonFetch): JFunction;
    function watch(&property: JonFetch; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "options": JObject;
    procedure set(&property: Joptions; value: JObject);
    function get(&property: Joptions): JObject;
    function watch(&property: Joptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "query": JObject;
    procedure set(&property: Jquery; value: JObject);
    function get(&property: Jquery): JObject;
    function watch(&property: Jquery; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "queryOptions": JObject;
    procedure set(&property: JqueryOptions; value: JObject);
    function get(&property: JqueryOptions): JObject;
    function watch(&property: JqueryOptions; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "sortByLabel": Boolean;
    procedure set(&property: JsortByLabel; value: Boolean);
    function get(&property: JsortByLabel): Boolean;
    function watch(&property: JsortByLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "store": JObject;
    procedure set(&property: Jstore; value: JObject);
    function get(&property: Jstore): JObject;
    function watch(&property: Jstore; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addOption(option: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure addOption(option: array of Jdijit.form._FormSelectWidget.__SelectOption);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase);
    procedure focusFirstChild;
    procedure focusLastChild;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getOptions(valueOrIdx: Variant): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function isLoaded: Variant;
    isValid: (isFocused: Boolean): Boolean    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function openDropDown: Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeOption(valueOrIdx: JString);
    procedure removeOption(valueOrIdx: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure removeOption(valueOrIdx: Float);
    procedure removeOption(valueOrIdx: array of Variant);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    function setStore(store: Jdojo.store.api.Store; selectedValue: Variant; fetchArgs: JObject): Variant;
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    procedure updateOption(newOption: Jdijit.form._FormSelectWidget.__SelectOption);
    procedure updateOption(newOption: array of Jdijit.form._FormSelectWidget.__SelectOption);
    function validate(isFocused: Boolean): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyboardSearch(item: Jdijit._WidgetBase; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onSetStore;
    procedure onShow;
  end;

  JTextBox = class external 'TextBox'(Jdijit.form._FormValueWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JObject;
    procedure set(&property: Jvalue; value: JObject);
    function get(&property: Jvalue): JObject;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    procedure selectInputText(element: JHTMLElement; start: Float; stop: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTimeTextBox = class external 'TimeTextBox'(Jdijit.form._DateTimeTextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoWidth": Boolean;
    procedure set(&property: JautoWidth; value: Boolean);
    function get(&property: JautoWidth): Boolean;
    function watch(&property: JautoWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dropDown": JObject;
    procedure set(&property: JdropDown; value: JObject);
    function get(&property: JdropDown): JObject;
    function watch(&property: JdropDown; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dropDownDefaultValue": JDate;
    procedure set(&property: JdropDownDefaultValue; value: JDate);
    function get(&property: JdropDownDefaultValue): JDate;
    function watch(&property: JdropDownDefaultValue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "dropDownPosition": JObject;
    procedure set(&property: JdropDownPosition; value: JObject);
    function get(&property: JdropDownPosition): JObject;
    function watch(&property: JdropDownPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "forceWidth": Boolean;
    procedure set(&property: JforceWidth; value: Boolean);
    function get(&property: JforceWidth): Boolean;
    function watch(&property: JforceWidth; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hasDownArrow": Boolean;
    procedure set(&property: JhasDownArrow; value: Boolean);
    function get(&property: JhasDownArrow): Boolean;
    function watch(&property: JhasDownArrow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxHeight": Float;
    procedure set(&property: JmaxHeight; value: Float);
    function get(&property: JmaxHeight): Float;
    function watch(&property: JmaxHeight; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "rangeMessage": String;
    procedure set(&property: JrangeMessage; value: String);
    function get(&property: JrangeMessage): String;
    function watch(&property: JrangeMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure closeDropDown(focus: Boolean);
    function compare(val1: JDate; val2: JDate): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JDate; constraints: JObject): Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isInRange(isFocused: Boolean): Variant;
    function isLeftToRight: Variant;
    function isLoaded: Boolean;
    isValid: (isFocused: Boolean): Variant    end;;
    function loadAndOpenDropDown: Variant;
    procedure loadDropDown(loadCallback: JFunction);
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    procedure openDropDown(callback: JFunction);
    function own: Variant;
    function parse(value: JString; constraints: JObject): Variant;
    pattern: (options: JObject): Variant    end;;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    popupClass:     end;;
    procedure postCreate;
    procedure postMixInProperties;
    function rangeCheck(primitive: Float; constraints: Jdijit.form.RangeBoundTextBox.__Constraints): Boolean;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function serialize(val: Variant; options: JObject): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure toggleDropDown;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate: Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JToggleButton = class external 'ToggleButton'(Jdijit.form.Button)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setChecked(checked: Boolean);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JVerticalRule = class external 'VerticalRule'(Jdijit.form.HorizontalRule)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "container": String;
    procedure set(&property: Jcontainer; value: String);
    function get(&property: Jcontainer): String;
    function watch(&property: Jcontainer; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "count": Float;
    procedure set(&property: Jcount; value: Float);
    function get(&property: Jcount): Float;
    function watch(&property: Jcount; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ruleStyle": String;
    procedure set(&property: JruleStyle; value: String);
    function get(&property: JruleStyle): String;
    function watch(&property: JruleStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JVerticalRuleLabels = class external 'VerticalRuleLabels'(Jdijit.form.HorizontalRuleLabels)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "container": String;
    procedure set(&property: Jcontainer; value: String);
    function get(&property: Jcontainer): String;
    function watch(&property: Jcontainer; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "count": Float;
    procedure set(&property: Jcount; value: Float);
    function get(&property: Jcount): Float;
    function watch(&property: Jcount; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "labels": JObject;
    procedure set(&property: Jlabels; value: JObject);
    function get(&property: Jlabels): JObject;
    function watch(&property: Jlabels; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "labelStyle": String;
    procedure set(&property: JlabelStyle; value: String);
    function get(&property: JlabelStyle): String;
    function watch(&property: JlabelStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maximum": Float;
    procedure set(&property: Jmaximum; value: Float);
    function get(&property: Jmaximum): Float;
    function watch(&property: Jmaximum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "minimum": Float;
    procedure set(&property: Jminimum; value: Float);
    function get(&property: Jminimum): Float;
    function watch(&property: Jminimum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "numericMargin": Float;
    procedure set(&property: JnumericMargin; value: Float);
    function get(&property: JnumericMargin): Float;
    function watch(&property: JnumericMargin; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ruleStyle": String;
    procedure set(&property: JruleStyle; value: String);
    function get(&property: JruleStyle): String;
    function watch(&property: JruleStyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getLabels: Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JValidationTextBox = class external 'ValidationTextBox'(Jdijit.form.TextBox)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "constraints": JObject;
    procedure set(&property: Jconstraints; value: JObject);
    function get(&property: Jconstraints): JObject;
    function watch(&property: Jconstraints; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "displayedValue": String;
    procedure set(&property: JdisplayedValue; value: String);
    function get(&property: JdisplayedValue): String;
    function watch(&property: JdisplayedValue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "invalidMessage": String;
    procedure set(&property: JinvalidMessage; value: String);
    function get(&property: JinvalidMessage): String;
    function watch(&property: JinvalidMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isValid": Variant;
    procedure set(&property: JisValid; value: Variant);
    function get(&property: JisValid): Variant;
    function watch(&property: JisValid; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lowercase": Boolean;
    procedure set(&property: Jlowercase; value: Boolean);
    function get(&property: Jlowercase): Boolean;
    function watch(&property: Jlowercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "maxLength": String;
    procedure set(&property: JmaxLength; value: String);
    function get(&property: JmaxLength): String;
    function watch(&property: JmaxLength; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "message": String;
    procedure set(&property: Jmessage; value: String);
    function get(&property: Jmessage): String;
    function watch(&property: Jmessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "missingMessage": String;
    procedure set(&property: JmissingMessage; value: String);
    function get(&property: JmissingMessage): String;
    function watch(&property: JmissingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pattern": String;
    procedure set(&property: Jpattern; value: String);
    function get(&property: Jpattern): String;
    function watch(&property: Jpattern; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "placeHolder": String;
    procedure set(&property: JplaceHolder; value: String);
    function get(&property: JplaceHolder): String;
    function watch(&property: JplaceHolder; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "promptMessage": String;
    procedure set(&property: JpromptMessage; value: String);
    function get(&property: JpromptMessage): String;
    function watch(&property: JpromptMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "propercase": Boolean;
    procedure set(&property: Jpropercase; value: Boolean);
    function get(&property: Jpropercase): Boolean;
    function watch(&property: Jpropercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "regExp": String;
    procedure set(&property: JregExp; value: String);
    function get(&property: JregExp): String;
    function watch(&property: JregExp; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "required": Boolean;
    procedure set(&property: Jrequired; value: Boolean);
    function get(&property: Jrequired): Boolean;
    function watch(&property: Jrequired; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectOnClick": Boolean;
    procedure set(&property: JselectOnClick; value: Boolean);
    function get(&property: JselectOnClick): Boolean;
    function watch(&property: JselectOnClick; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "state": String;
    procedure set(&property: Jstate; value: String);
    function get(&property: Jstate): String;
    function watch(&property: Jstate; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltipPosition": JObject;
    procedure set(&property: JtooltipPosition; value: JObject);
    function get(&property: JtooltipPosition): JObject;
    function watch(&property: JtooltipPosition; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "trim": Boolean;
    procedure set(&property: Jtrim; value: Boolean);
    function get(&property: Jtrim): Boolean;
    function watch(&property: Jtrim; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "uppercase": Boolean;
    procedure set(&property: Juppercase; value: Boolean);
    function get(&property: Juppercase): Boolean;
    function watch(&property: Juppercase; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "value": JObject;
    procedure set(&property: Jvalue; value: JObject);
    function get(&property: Jvalue): JObject;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure displayMessage(message: JString);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function filter(val: Variant): Variant;
    procedure focus;
    function format(value: JString; constraints: JObject): JString;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getDisplayedValue: Variant;
    function getErrorMessage(isFocused: Boolean): Variant;
    function getParent: Variant;
    function getPromptMessage(isFocused: Boolean): Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function parse(value: JString; constraints: JObject): JString;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure regExpGen(constraints: JObject);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setDisplayedValue(value: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function validate(isFocused: Boolean): Variant;
    function validator(value: Variant; constraints: JObject): Variant;
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onInput(event: Variant);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JVerticalSlider = class external 'VerticalSlider'(Jdijit.form.HorizontalSlider)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "clickSelect": Boolean;
    procedure set(&property: JclickSelect; value: Boolean);
    function get(&property: JclickSelect): Boolean;
    function watch(&property: JclickSelect; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "discreteValues": Float;
    procedure set(&property: JdiscreteValues; value: Float);
    function get(&property: JdiscreteValues): Float;
    function watch(&property: JdiscreteValues; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "maximum": Float;
    procedure set(&property: Jmaximum; value: Float);
    function get(&property: Jmaximum): Float;
    function watch(&property: Jmaximum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "minimum": Float;
    procedure set(&property: Jminimum; value: Float);
    function get(&property: Jminimum): Float;
    function watch(&property: Jminimum; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "pageIncrement": Float;
    procedure set(&property: JpageIncrement; value: Float);
    function get(&property: JpageIncrement): Float;
    function watch(&property: JpageIncrement; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "readOnly": Boolean;
    procedure set(&property: JreadOnly; value: Boolean);
    function get(&property: JreadOnly): Boolean;
    function watch(&property: JreadOnly; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showButtons": Boolean;
    procedure set(&property: JshowButtons; value: Boolean);
    function get(&property: JshowButtons): Boolean;
    function watch(&property: JshowButtons; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "slideDuration": Float;
    procedure set(&property: JslideDuration; value: Float);
    function get(&property: JslideDuration): Float;
    function watch(&property: JslideDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": Float;
    procedure set(&property: Jvalue; value: Float);
    function get(&property: Jvalue): Float;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function getValue: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setDisabled(disabled: Boolean);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    procedure undo;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JSlider = class external
  end;

//_DateTimeTextBox

type
  J__Constraints = class external '__Constraints'
    constructor Create;
    "am": String;
    "datePattern": String;
    "formatLength": String;
    "fullYear": Boolean;
    "locale": String;
    "max": Float;
    "min": Float;
    "pm": String;
    "selector": String;
    "strict": Boolean;
    "timePattern": String;
  end;

//_FormSelectWidget

type
  J__SelectOption = class external
    disabled: Boolean; // nullable
    &label: String;
    selected: Boolean; // nullable
    value: String;
  end;

//HorizontalSlider

type
  J_Mover = class external '_Mover'(Jdojo.dnd.Mover)
    constructor Create(node: JHTMLElement; e: JEvent; host: JObject);
    procedure destroy; overload;
    procedure destroy(e: Variant); overload;
    function emit(&type: Variant; event: Variant): Variant;
    function on(&type: Variant; listener: Variant): Variant;
    procedure onFirstMove(e: Variant);
    procedure onMouseMove(e: Variant);
    procedure onMouseUp(e: Variant);
  end;

//NumberTextBox

type
  J__Constraints = class external '__Constraints'
    constructor Create;
    "fractional": Boolean;
    "locale": String;
    "max": Float;
    "min": Float;
    "pattern": String;
    "places": Float;
    "round": Float;
    "strict": Boolean;
    "type": String;
  end;

  JMixin = class external 'Mixin'
    constructor Create;
    "constraints": JObject;
    "editOptions": JObject;
    "value": Float;
    function filter(value: Float): Float;
    function format(value: Float; constraints: JObject): Variant;
    isValid: (isFocused: Boolean): Variant    end;;
    function parse(value: JString; constraints: JObject): Variant;
    function pattern(constraints: Variant): JString;
    procedure postMixInProperties;
    function serialize(value: Float; options: JObject): JString;
  end;

//RangeBoundTextBox

type
  J__Constraints = class external '__Constraints'
    constructor Create;
    "max": Float;
    "min": Float;
  end;

//Select

type
  J_Menu = class external '_Menu'(Jdijit.DropDownMenu)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "activated": Boolean;
    procedure set(&property: Jactivated; value: Boolean);
    function get(&property: Jactivated): Boolean;
    function watch(&property: Jactivated; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "autoFocus": Boolean;
    procedure set(&property: JautoFocus; value: Boolean);
    function get(&property: JautoFocus): Boolean;
    function watch(&property: JautoFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focusedChild": JObject;
    procedure set(&property: JfocusedChild; value: JObject);
    function get(&property: JfocusedChild): JObject;
    function watch(&property: JfocusedChild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "multiCharSearchDuration": Float;
    procedure set(&property: JmultiCharSearchDuration; value: Float);
    function get(&property: JmultiCharSearchDuration): Float;
    function watch(&property: JmultiCharSearchDuration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parentMenu": JObject;
    procedure set(&property: JparentMenu; value: JObject);
    function get(&property: JparentMenu): JObject;
    function watch(&property: JparentMenu; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "passivePopupDelay": Float;
    procedure set(&property: JpassivePopupDelay; value: Float);
    function get(&property: JpassivePopupDelay): Float;
    function watch(&property: JpassivePopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "popupDelay": Float;
    procedure set(&property: JpopupDelay; value: Float);
    function get(&property: JpopupDelay): Float;
    function watch(&property: JpopupDelay; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selected": JObject;
    procedure set(&property: Jselected; value: JObject);
    function get(&property: Jselected): JObject;
    function watch(&property: Jselected; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function childSelector(node: JHTMLElement): Variant;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure connectKeyNavHandlers(prevKeyCodes: Jdojo.keys; nextKeyCodes: Jdojo.keys);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    procedure focusChild(widget: Jdijit._WidgetBase; last: Boolean);
    procedure focusFirstChild;
    procedure focusLastChild;
    procedure focusNext;
    procedure focusPrev;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    procedure startupKeyNavChildren;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onCancel(closeAll: Boolean);
    procedure onClick(event: Variant);
    procedure onDblClick(event: Variant);
    procedure onExecute;
    procedure onFocus;
    procedure onHide;
    procedure onItemHover(item: Jdijit.MenuItem);
    procedure onItemUnhover(item: Jdijit.MenuItem);
    procedure onKeyboardSearch(item: Jdijit.MenuItem; evt: JEvent; searchString: JString; numMatches: Float);
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//layout

type
  J_ContentPaneResizeMixin = class external '_ContentPaneResizeMixin'
    constructor Create;
    "doLayout": Boolean;
    "isLayoutContainer": Boolean;
    procedure resize(changeSize: Variant; resultSize: Variant);
    procedure startup;
  end;

  J_LayoutWidget = class external '_LayoutWidget'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: JObject; resultSize: JObject);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JAccordionContainer = class external 'AccordionContainer'(Jdijit.layout.StackContainer)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "duration": Float;
    procedure set(&property: Jduration; value: Float);
    function get(&property: Jduration): Float;
    function watch(&property: Jduration; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectedChildWidget": JObject;
    procedure set(&property: JselectedChildWidget; value: JObject);
    function get(&property: JselectedChildWidget): JObject;
    function watch(&property: JselectedChildWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    function back: Variant;
    procedure buildRendering;
    procedure buttonWidget;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function forward: Variant;
    function get(name: Variant): Variant;
    function getChildren: Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(child: Variant);
    procedure resize;
    function selectChild(page: Jdijit._WidgetBase; animate: Boolean): Variant;
    function selectChild(page: JString; animate: Boolean): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_TabContainerBase = class external '_TabContainerBase'(Jdijit.layout.StackContainer)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "nested": Boolean;
    procedure set(&property: Jnested; value: Boolean);
    function get(&property: Jnested): Boolean;
    function watch(&property: Jnested; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectedChildWidget": JObject;
    procedure set(&property: JselectedChildWidget; value: JObject);
    function get(&property: JselectedChildWidget): JObject;
    function watch(&property: JselectedChildWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabPosition": String;
    procedure set(&property: JtabPosition; value: String);
    function get(&property: JtabPosition): String;
    function watch(&property: JtabPosition; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabStrip": Boolean;
    procedure set(&property: JtabStrip; value: Boolean);
    function get(&property: JtabStrip): Boolean;
    function watch(&property: JtabStrip; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    function back: Variant;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function forward: Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize;
    function selectChild(page: Jdijit._WidgetBase; animate: Boolean): Variant;
    function selectChild(page: JString; animate: Boolean): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JBorderContainer = class external 'BorderContainer'(Jdijit.layout.LayoutContainer)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ChildWidgetProperties": JObject;
    procedure set(&property: JChildWidgetProperties; value: JObject);
    function get(&property: JChildWidgetProperties): JObject;
    function watch(&property: JChildWidgetProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "design": String;
    procedure set(&property: Jdesign; value: String);
    function get(&property: Jdesign): String;
    function watch(&property: Jdesign; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "gutters": Boolean;
    procedure set(&property: Jgutters; value: Boolean);
    function get(&property: Jgutters): Boolean;
    function watch(&property: Jgutters; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "liveSplitters": Boolean;
    procedure set(&property: JliveSplitters; value: Boolean);
    function get(&property: JliveSplitters): Boolean;
    function watch(&property: JliveSplitters; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function getSplitter(region: JString): Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(newSize: Variant; currentSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JAccordionPane = class external 'AccordionPane'(Jdijit.layout.ContentPane)
    constructor Create;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onSelected;
    procedure onShow;
    procedure onUnload;
  end;

  JLayoutContainer = class external 'LayoutContainer'(Jdijit.layout._LayoutWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ChildWidgetProperties": JObject;
    procedure set(&property: JChildWidgetProperties; value: JObject);
    function get(&property: JChildWidgetProperties): JObject;
    function watch(&property: JChildWidgetProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "design": String;
    procedure set(&property: Jdesign; value: String);
    function get(&property: Jdesign): String;
    function watch(&property: Jdesign; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: JObject; resultSize: JObject);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JContentPane = class external 'ContentPane'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
  end;

  JLinkPane = class external 'LinkPane'(Jdijit.layout.ContentPane)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "content": String;
    procedure set(&property: Jcontent; value: String);
    function get(&property: Jcontent): String;
    function watch(&property: Jcontent; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "errorMessage": String;
    procedure set(&property: JerrorMessage; value: String);
    function get(&property: JerrorMessage): String;
    function watch(&property: JerrorMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "extractContent": Boolean;
    procedure set(&property: JextractContent; value: Boolean);
    function get(&property: JextractContent): Boolean;
    function watch(&property: JextractContent; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "href": String;
    procedure set(&property: Jhref; value: String);
    function get(&property: Jhref): String;
    function watch(&property: Jhref; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ioArgs": JObject;
    procedure set(&property: JioArgs; value: JObject);
    function get(&property: JioArgs): JObject;
    function watch(&property: JioArgs; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "isLoaded": Boolean;
    procedure set(&property: JisLoaded; value: Boolean);
    function get(&property: JisLoaded): Boolean;
    function watch(&property: JisLoaded; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "loadingMessage": String;
    procedure set(&property: JloadingMessage; value: String);
    function get(&property: JloadingMessage): String;
    function watch(&property: JloadingMessage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "onLoadDeferred": JObject;
    procedure set(&property: JonLoadDeferred; value: JObject);
    function get(&property: JonLoadDeferred): JObject;
    function watch(&property: JonLoadDeferred; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "parseOnLoad": Boolean;
    procedure set(&property: JparseOnLoad; value: Boolean);
    function get(&property: JparseOnLoad): Boolean;
    function watch(&property: JparseOnLoad; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "parserScope": String;
    procedure set(&property: JparserScope; value: String);
    function get(&property: JparserScope): String;
    function watch(&property: JparserScope; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "preload": Boolean;
    procedure set(&property: Jpreload; value: Boolean);
    function get(&property: Jpreload): Boolean;
    function watch(&property: Jpreload; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "preventCache": Boolean;
    procedure set(&property: JpreventCache; value: Boolean);
    function get(&property: JpreventCache): Boolean;
    function watch(&property: JpreventCache; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "refreshOnShow": Boolean;
    procedure set(&property: JrefreshOnShow; value: Boolean);
    function get(&property: JrefreshOnShow): Boolean;
    function watch(&property: JrefreshOnShow; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "stopParser": Boolean;
    procedure set(&property: JstopParser; value: Boolean);
    function get(&property: JstopParser): Boolean;
    function watch(&property: JstopParser; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure cancel;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    procedure create(params: Variant; srcNodeRef: Variant);
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function ioMethod(args: JObject): Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function markupFactory(params: Variant; node: Variant; ctor: Variant): Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function refresh: Variant;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize(changeSize: Variant; resultSize: Variant);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setContent(data: JString);
    procedure setContent(data: JHTMLElement);
    procedure setContent(data: JNodeList);
    function setHref(href: JString): Variant;
    function setHref(href: JURL): Variant;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onContentError(error: JError);
    procedure onDblClick(event: Variant);
    procedure onDownloadEnd;
    function onDownloadError(error: JError): Variant;
    function onDownloadStart: Variant;
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onLoad(data: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onUnload;
  end;

  JScrollingTabController = class external 'ScrollingTabController'(Jdijit.layout.TabController)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonWidgetCloseClass": String;
    procedure set(&property: JbuttonWidgetCloseClass; value: String);
    function get(&property: JbuttonWidgetCloseClass): String;
    function watch(&property: JbuttonWidgetCloseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerId": String;
    procedure set(&property: JcontainerId; value: String);
    function get(&property: JcontainerId): String;
    function watch(&property: JcontainerId; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "contextRequire": JFunction;
    procedure set(&property: JcontextRequire; value: JFunction);
    function get(&property: JcontextRequire): JFunction;
    function watch(&property: JcontextRequire; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabPosition": String;
    procedure set(&property: JtabPosition; value: String);
    function get(&property: JtabPosition): String;
    function watch(&property: JtabPosition; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabStripClass": String;
    procedure set(&property: JtabStripClass; value: String);
    function get(&property: JtabStripClass): String;
    function watch(&property: JtabStripClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "useMenu": Boolean;
    procedure set(&property: JuseMenu; value: Boolean);
    function get(&property: JuseMenu): Boolean;
    function watch(&property: JuseMenu; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "useSlider": Boolean;
    procedure set(&property: JuseSlider; value: Boolean);
    function get(&property: JuseSlider): Boolean;
    function watch(&property: JuseSlider; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "widgetsInTemplate": Boolean;
    procedure set(&property: JwidgetsInTemplate; value: Boolean);
    function get(&property: JwidgetsInTemplate): Boolean;
    function watch(&property: JwidgetsInTemplate; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure buttonWidget;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function createSmoothScroll(x: Float): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    procedure doSlide(direction: Float; node: JHTMLElement);
    procedure doSlideLeft(e: JEvent);
    procedure doSlideRight(e: JEvent);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function pane2button(id: JString): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function resize(dim: Variant): JObject;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onAddChild(page: Variant; insertIndex: Variant);
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onRemoveChild(page: Variant; insertIndex: Variant);
    procedure onSelectChild(page: Jdijit._WidgetBase);
    procedure onShow;
    procedure onStartup;
  end;

  JSplitContainer = class external 'SplitContainer'(Jdijit.layout._LayoutWidget)
    constructor Create;
    "activeSizing": Boolean;
    procedure set(&property: JactiveSizing; value: Boolean);
    function get(&property: JactiveSizing): Boolean;
    function watch(&property: JactiveSizing; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ChildWidgetProperties": JObject;
    procedure set(&property: JChildWidgetProperties; value: JObject);
    function get(&property: JChildWidgetProperties): JObject;
    function watch(&property: JChildWidgetProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "orientation": String;
    procedure set(&property: Jorientation; value: String);
    function get(&property: Jorientation): String;
    function watch(&property: Jorientation; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "sizerWidth": Float;
    procedure set(&property: JsizerWidth; value: Float);
    function get(&property: JsizerWidth): Float;
    function watch(&property: JsizerWidth; callback: (&property: String; oldValue: Float; newValue: Float)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure beginSizing(e: Variant; i: Variant);
    procedure buildRendering;
    procedure changeSizing(e: Variant);
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure endSizing;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Variant);
    procedure resize(changeSize: JObject; resultSize: JObject);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JStackContainer = class external 'StackContainer'(Jdijit.layout._LayoutWidget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ChildWidgetProperties": JObject;
    procedure set(&property: JChildWidgetProperties; value: JObject);
    function get(&property: JChildWidgetProperties): JObject;
    function watch(&property: JChildWidgetProperties; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectedChildWidget": JObject;
    procedure set(&property: JselectedChildWidget; value: JObject);
    function get(&property: JselectedChildWidget): JObject;
    function watch(&property: JselectedChildWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    function back: Variant;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function forward: Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize;
    function selectChild(page: Jdijit._WidgetBase; animate: Boolean): Variant;
    function selectChild(page: JString; animate: Boolean): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JStackController = class external 'StackController'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonWidgetCloseClass": String;
    procedure set(&property: JbuttonWidgetCloseClass; value: String);
    function get(&property: JbuttonWidgetCloseClass): String;
    function watch(&property: JbuttonWidgetCloseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerId": String;
    procedure set(&property: JcontainerId; value: String);
    function get(&property: JcontainerId): String;
    function watch(&property: JcontainerId; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure buttonWidget;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function pane2button(id: JString): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure StackButton;
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTabContainer = class external 'TabContainer'(Jdijit.layout._TabContainerBase)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "controllerWidget": JObject;
    procedure set(&property: JcontrollerWidget; value: JObject);
    function get(&property: JcontrollerWidget): JObject;
    function watch(&property: JcontrollerWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "doLayout": Boolean;
    procedure set(&property: JdoLayout; value: Boolean);
    function get(&property: JdoLayout): Boolean;
    function watch(&property: JdoLayout; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "nested": Boolean;
    procedure set(&property: Jnested; value: Boolean);
    function get(&property: Jnested): Boolean;
    function watch(&property: Jnested; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "persist": Boolean;
    procedure set(&property: Jpersist; value: Boolean);
    function get(&property: Jpersist): Boolean;
    function watch(&property: Jpersist; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "selectedChildWidget": JObject;
    procedure set(&property: JselectedChildWidget; value: JObject);
    function get(&property: JselectedChildWidget): JObject;
    function watch(&property: JselectedChildWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabPosition": String;
    procedure set(&property: JtabPosition; value: String);
    function get(&property: JtabPosition): String;
    function watch(&property: JtabPosition; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabStrip": Boolean;
    procedure set(&property: JtabStrip; value: Boolean);
    function get(&property: JtabStrip): Boolean;
    function watch(&property: JtabStrip; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "useMenu": Boolean;
    procedure set(&property: JuseMenu; value: Boolean);
    function get(&property: JuseMenu): Boolean;
    function watch(&property: JuseMenu; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "useSlider": Boolean;
    procedure set(&property: JuseSlider; value: Boolean);
    function get(&property: JuseSlider): Boolean;
    function watch(&property: JuseSlider; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    procedure addChild(child: Jdijit._WidgetBase; insertIndex: Float);
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    function back: Variant;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function forward: Variant;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexInParent: Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getNextSibling: Variant;
    function getParent: Variant;
    function getPreviousSibling: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    procedure layout;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    procedure resize;
    function selectChild(page: Jdijit._WidgetBase; animate: Boolean): Variant;
    function selectChild(page: JString; animate: Boolean): Variant;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JTabController = class external 'TabController'(Jdijit.layout.StackController)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonWidgetCloseClass": String;
    procedure set(&property: JbuttonWidgetCloseClass; value: String);
    function get(&property: JbuttonWidgetCloseClass): String;
    function watch(&property: JbuttonWidgetCloseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerId": String;
    procedure set(&property: JcontainerId; value: String);
    function get(&property: JcontainerId): String;
    function watch(&property: JcontainerId; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabPosition": String;
    procedure set(&property: JtabPosition; value: String);
    function get(&property: JtabPosition): String;
    function watch(&property: JtabPosition; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    procedure addChild(widget: Jdijit._WidgetBase); overload;
    procedure addChild(widget: Jdijit._WidgetBase; insertIndex: Float); overload;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    procedure buttonWidget;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Variant); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getIndexOfChild(child: Jdijit._WidgetBase): Variant;
    function getParent: Variant;
    function hasChildren: Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function pane2button(id: JString): Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure removeChild(widget: Jdijit._WidgetBase);
    procedure removeChild(widget: Float);
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    procedure TabButton;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  Jutils = class external
    procedure layoutChildren(container: JHTMLElement; dim: JObject; children: array of Jdijit._WidgetBase; changedRegionId: JString; changedRegionSize: Float);
    function marginBox2contentBox(node: JHTMLElement; mb: JObject): JObject;
  end;

//AccordionContainer

type
  J_InnerContainer = class external '_InnerContainer'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "buttonWidget": JFunction;
    procedure set(&property: JbuttonWidget; value: JFunction);
    function get(&property: JbuttonWidget): JFunction;
    function watch(&property: JbuttonWidget; callback: (&property: String; oldValue: JFunction; newValue: JFunction)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "contentWidget": JObject;
    procedure set(&property: JcontentWidget; value: JObject);
    function get(&property: JcontentWidget): JObject;
    function watch(&property: JcontentWidget; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "isLayoutContainer": Boolean;
    procedure set(&property: JisLayoutContainer; value: Boolean);
    function get(&property: JisLayoutContainer): Boolean;
    function watch(&property: JisLayoutContainer; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_Button = class external '_Button'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClassAttr": String;
    procedure set(&property: JiconClassAttr; value: String);
    function get(&property: JiconClassAttr): String;
    function watch(&property: JiconClassAttr; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getTitleHeight: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//BorderContainer

type
  J_Gutter = class external '_Gutter'(Jdijit._Widget)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  J_Splitter = class external '_Splitter'(Jdijit._Widget)
    constructor Create;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "child": JObject;
    procedure set(&property: Jchild; value: JObject);
    function get(&property: Jchild): JObject;
    function watch(&property: Jchild; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "container": JObject;
    procedure set(&property: Jcontainer; value: JObject);
    function get(&property: Jcontainer): JObject;
    function watch(&property: Jcontainer; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "live": Boolean;
    procedure set(&property: Jlive; value: Boolean);
    function get(&property: Jlive): Boolean;
    function watch(&property: Jlive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "region": String;
    procedure set(&property: Jregion; value: String);
    function get(&property: Jregion): String;
    function watch(&property: Jregion; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

  JChildWidgetProperties = class external
    layoutAlign: String;
    layoutPriority: Float;
    maxSize: Float;
    minSize: Float;
    region: String;
    splitter: Boolean;
  end;

//LayoutContainer

type
  JChildWidgetProperties = class external
    layoutAlign: String;
    layoutPriority: Float;
    region: String;
  end;

//SplitContainer

type
  JChildWidgetProperties = class external
    sizeMin: Float;
    sizeShare: Float;
  end;

//StackContainer

type
  JChildWidgetProperties = class external
    closable: Boolean;
    disabled: Boolean;
    iconClass: String;
    selected: Boolean;
    showTitle: Boolean;
  end;

//StackController

type
  JStackButton = class external 'StackButton'(Jdijit.form.ToggleButton)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "closeButton": Boolean;
    procedure set(&property: JcloseButton; value: Boolean);
    function get(&property: JcloseButton): Boolean;
    function watch(&property: JcloseButton; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering; overload;
    procedure buildRendering(evt: JEvent); overload;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setChecked(checked: Boolean);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//TabController

type
  JTabButton = class external 'TabButton'(Jdijit.form.ToggleButton)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "alt": String;
    procedure set(&property: Jalt; value: String);
    function get(&property: Jalt): String;
    function watch(&property: Jalt; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "aria-label": String;
    procedure set(&property: Jaria-label; value: String);
    function get(&property: Jaria-label): String;
    function watch(&property: Jaria-label; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "checked": Boolean;
    procedure set(&property: Jchecked; value: Boolean);
    function get(&property: Jchecked): Boolean;
    function watch(&property: Jchecked; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "closeButton": Boolean;
    procedure set(&property: JcloseButton; value: Boolean);
    function get(&property: JcloseButton): Boolean;
    function watch(&property: JcloseButton; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "disabled": Boolean;
    procedure set(&property: Jdisabled; value: Boolean);
    function get(&property: Jdisabled): Boolean;
    function watch(&property: Jdisabled; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "iconClass": String;
    procedure set(&property: JiconClass; value: String);
    function get(&property: JiconClass): String;
    function watch(&property: JiconClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "intermediateChanges": Boolean;
    procedure set(&property: JintermediateChanges; value: Boolean);
    function get(&property: JintermediateChanges): Boolean;
    function watch(&property: JintermediateChanges; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "label": String;
    procedure set(&property: Jlabel; value: String);
    function get(&property: Jlabel): String;
    function watch(&property: Jlabel; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "name": String;
    procedure set(&property: Jname; value: String);
    function get(&property: Jname): String;
    function watch(&property: Jname; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "scrollOnFocus": Boolean;
    procedure set(&property: JscrollOnFocus; value: Boolean);
    function get(&property: JscrollOnFocus): Boolean;
    function watch(&property: JscrollOnFocus; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "showLabel": Boolean;
    procedure set(&property: JshowLabel; value: Boolean);
    function get(&property: JshowLabel): Boolean;
    function watch(&property: JshowLabel; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "type": String;
    procedure set(&property: Jtype; value: String);
    function get(&property: Jtype): String;
    function watch(&property: Jtype; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": String;
    procedure set(&property: Jvalue; value: String);
    function get(&property: Jvalue): String;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function compare(val1: Variant; val2: Variant): Float;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getDescendants: array of Variant;
    function getParent: Variant;
    function getValue: Variant;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    procedure reset;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setChecked(checked: Boolean);
    procedure setDisabled(disabled: Boolean);
    procedure setLabel(content: JString);
    procedure setValue(value: JString);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(newValue: Variant);
    function onClick(event: JEvent): Boolean;
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
  end;

//robot

//robotx

//tree

type
  J_dndContainer = class external '_dndContainer'
    constructor Create(tree: JHTMLElement; params: JObject);
    "current": JObject;
    procedure destroy;
    procedure onMouseOut(widget: Jdijit.Tree._TreeNode; evt: JEvent);
    procedure onMouseOver(widget: Jdijit.Tree._TreeNode; evt: JEvent);
    procedure onOutEvent;
    procedure onOverEvent;
  end;

  J_dndSelector = class external '_dndSelector'(Jdijit.tree._dndContainer)
    constructor Create;
    "current": JObject;
    "selection": JObject;
    "singular": Boolean;
    function addTreeNode(node: JHTMLElement; isAnchor: Boolean): JHTMLElement;
    procedure destroy;
    procedure forInSelectedItems(f: JFunction; o: JObject);
    function getItem(key: JString): JObject;
    function getSelectedTreeNodes: array of Variant;
    function isTreeNodeSelected(node: JHTMLElement): Variant;
    function removeTreeNode(node: JHTMLElement): JHTMLElement;
    procedure setSelection(newSelection: array of JHTMLElement);
    procedure userSelect(node: Variant; multi: Boolean; range: Boolean);
    procedure onClickPress(e: JEvent);
    procedure onClickRelease(e: JEvent);
    procedure onMouseDown;
    procedure onMouseMove(e: JEvent);
    procedure onMouseOut(widget: Jdijit.Tree._TreeNode; evt: JEvent);
    procedure onMouseOver(widget: Jdijit.Tree._TreeNode; evt: JEvent);
    procedure onMouseUp;
    procedure onOutEvent;
    procedure onOverEvent;
  end;

  JdndSource = class external 'dndSource'(Jdijit.tree._dndSelector)
    constructor Create(tree: Jdijit.Tree; params: Jdijit.tree.dndSource);
    "accept": JObject;
    "betweenThreshold": Float;
    "current": JObject;
    "dragThreshold": Float;
    "generateText": Boolean;
    "isSource": Boolean;
    "selection": JObject;
    "singular": Boolean;
    function addTreeNode(node: JHTMLElement; isAnchor: Boolean): JHTMLElement;
    function checkAcceptance(source: Jdijit.tree.dndSource; nodes: array of JHTMLElement): Boolean;
    function checkItemAcceptance(target: JHTMLElement; source: Jdijit.tree.dndSource; position: JString): Boolean;
    function copyState(keyPressed: Boolean): Variant;
    procedure destroy;
    procedure forInSelectedItems(f: JFunction; o: JObject);
    function getItem(key: JString): JObject;
    function getSelectedTreeNodes: array of Variant;
    function isTreeNodeSelected(node: JHTMLElement): Variant;
    function itemCreator(nodes: array of JHTMLElement; target: JHTMLElement; source: Jdojo.dnd.Source): Variant;
    function removeTreeNode(node: JHTMLElement): JHTMLElement;
    procedure setSelection(newSelection: array of JHTMLElement);
    procedure userSelect(node: Variant; multi: Boolean; range: Boolean);
    procedure onClickPress(e: JEvent);
    procedure onClickRelease(e: JEvent);
    procedure onDndDrop(source: JObject; nodes: array of JHTMLElement; copy: Boolean);
    procedure onMouseOver(widget: Jdijit.Tree._TreeNode; evt: JEvent);
  end;

  Jmodel = class external 'model'
    constructor Create;
    procedure destroy;
    procedure getChildren(parentItem: Jdojo.data.api.Item; onComplete: Variant);
    procedure getIdentity(item: Variant);
    procedure getLabel(item: Variant);
    procedure getRoot(onItem: Variant);
    procedure isItem(something: Variant);
    procedure mayHaveChildren(item: Jdojo.data.api.Item);
    procedure newItem(args: Jdijit.tree.dndSource.__Item; parent: Variant; insertIndex: Float; before: Variant);
    procedure pasteItem(childItem: Variant; oldParentItem: Variant; newParentItem: Variant; bCopy: Boolean; insertIndex: Float; before: Variant);
    procedure onChange(item: Jdojo.data.api.Item);
    procedure onChildrenChange(parent: Jdojo.data.api.Item; newChildrenList: array of Jdojo.data.api.Item);
  end;

  JForestStoreModel = class external 'ForestStoreModel'(Jdijit.tree.TreeStoreModel)
    constructor Create(params: Variant);
    "childrenAttrs": JObject;
    "deferItemLoadingUntilExpand": Boolean;
    "labelAttr": String;
    "newItemIdAttr": String;
    "query": String;
    "root": JObject;
    "rootId": String;
    "rootLabel": String;
    "store": JObject;
    procedure destroy;
    procedure fetchItemByIdentity(keywordArgs: JObject);
    procedure getChildren(parentItem: Jdojo.data.api.Item; callback: (items: array of Variant): Variant    end;; onError: JFunction);
    function getIdentity(item: Variant): Variant;
    function getLabel(item: Variant): Variant;
    procedure getRoot(onItem: Variant; onError: Variant);
    function isItem(something: Variant): Boolean;
    function mayHaveChildren(item: Jdojo.data.api.Item): Boolean;
    function newItem(args: Jdijit.tree.dndSource.__Item; parent: Variant; insertIndex: Float): Variant;
    procedure pasteItem(childItem: Variant; oldParentItem: Variant; newParentItem: Variant; bCopy: Boolean; insertIndex: Float);
    procedure onAddToRoot(item: Variant);
    procedure onChange(item: Jdojo.data.api.Item);
    procedure onChildrenChange(parent: Jdojo.data.api.Item; newChildrenList: array of Jdojo.data.api.Item);
    procedure onDelete(item: Jdojo.data.api.Item);
    procedure onDeleteItem(item: JObject);
    procedure onLeaveRoot(item: Variant);
    procedure onNewItem(item: Jdojo.data.api.Item; parentInfo: JObject);
    procedure onNewRootItem(args: Jdijit.tree.dndSource.__Item);
    procedure onSetItem(item: Variant; attribute: JString; oldValue: JObject; newValue: JObject);
    procedure onSetItem(item: Variant; attribute: JString; oldValue: array of Variant; newValue: JObject);
    procedure onSetItem(item: Variant; attribute: JString; oldValue: JObject; newValue: array of Variant);
    procedure onSetItem(item: Variant; attribute: JString; oldValue: array of Variant; newValue: array of Variant);
  end;

  JObjectStoreModel = class external 'ObjectStoreModel'
    constructor Create(args: JObject);
    "labelAttr": String;
    "labelType": String;
    "query": JObject;
    "root": JObject;
    "store": JObject;
    procedure destroy;
    procedure getChildren(parentItem: JObject; onComplete: (items: array of Variant): Variant    end;; onError: JFunction);
    function getIdentity(item: Variant): Variant;
    function getLabel(item: Jdojo.data.api.Item): Variant;
    procedure getRoot(onItem: Variant; onError: Variant);
    function isItem(something: Variant): Boolean;
    function mayHaveChildren(item: JObject): Boolean;
    function newItem(args: Jdijit.tree.dndSource.__Item; parent: Variant; insertIndex: Float; before: Variant): Variant;
    function pasteItem(childItem: Variant; oldParentItem: Variant; newParentItem: Variant; bCopy: Boolean; insertIndex: Float; before: Variant): Variant;
    procedure onChange(item: Jdojo.data.api.Item);
    procedure onChildrenChange(parent: Jdojo.data.api.Item; newChildrenList: array of JObject);
    procedure onDelete(item: Jdojo.data.api.Item);
  end;

  JTreeStoreModel = class external 'TreeStoreModel'
    constructor Create(args: JObject);
    "childrenAttrs": JObject;
    "deferItemLoadingUntilExpand": Boolean;
    "labelAttr": String;
    "newItemIdAttr": String;
    "query": JObject;
    "root": JObject;
    "store": JObject;
    procedure destroy;
    procedure fetchItemByIdentity(keywordArgs: JObject);
    procedure getChildren(parentItem: Jdojo.data.api.Item; onComplete: (items: array of Variant): Variant    end;; onError: JFunction);
    function getIdentity(item: Variant): Variant;
    function getLabel(item: Jdojo.data.api.Item): Variant;
    procedure getRoot(onItem: Variant; onError: Variant);
    function isItem(something: Variant): Variant;
    function mayHaveChildren(item: Jdojo.data.api.Item): Variant;
    procedure newItem(args: Jdijit.tree.dndSource.__Item; parent: Jdojo.data.api.Item; insertIndex: Float);
    procedure pasteItem(childItem: Variant; oldParentItem: Variant; newParentItem: Variant; bCopy: Boolean; insertIndex: Float);
    procedure onChange(item: Jdojo.data.api.Item);
    procedure onChildrenChange(parent: Jdojo.data.api.Item; newChildrenList: array of Jdojo.data.api.Item);
    procedure onDelete(item: Jdojo.data.api.Item);
    procedure onDeleteItem(item: JObject);
    procedure onNewItem(item: Jdojo.data.api.Item; parentInfo: JObject);
    procedure onSetItem(item: Variant; attribute: Variant; oldValue: JObject; newValue: JObject);
    procedure onSetItem(item: Variant; attribute: Variant; oldValue: array of Variant; newValue: JObject);
    procedure onSetItem(item: Variant; attribute: Variant; oldValue: JObject; newValue: array of Variant);
    procedure onSetItem(item: Variant; attribute: Variant; oldValue: array of Variant; newValue: array of Variant);
  end;

//dndSource

type
  J__Item = class external
    id: JObject;
    name: String;
  end;

//_base

type
  Jfocus = class external
    function getBookmark: Variant;
    function getFocus(menu: Jdijit._WidgetBase; openedForWindow: JWindow): Variant;
    function isCollapsed: Variant;
    function moveToBookmark(bookmark: JObject): Variant;
    function registerIframe(iframe: JHTMLElement): Variant;
    function registerWin(targetWindow: JWindow; effectiveNode: JHTMLElement): Variant;
    procedure unregisterIframe(handle: JObject);
    procedure unregisterWin(handle: JObject);
  end;

  Jmanager = class external
    defaultDuration: Float;
  end;

  Jpopup = class external
  end;

  Jplace = class external
    procedure getPopupAroundAlignment(position: array of JString; leftToRight: Boolean);
    procedure getViewport;
    function placeOnScreen(node: JHTMLElement; pos: Jdijit.place.__Position; corners: array of JString; padding: Jdijit.place.__Position; layoutNode: Variant): Variant;
    procedure placeOnScreenAroundElement(node: Variant; aroundNode: Variant; aroundCorners: Variant; layoutNode: Variant);
    procedure placeOnScreenAroundNode(node: Variant; aroundNode: Variant; aroundCorners: Variant; layoutNode: Variant);
    procedure placeOnScreenAroundRectangle(node: Variant; aroundRect: Variant; aroundCorners: Variant; layoutNode: Variant);
  end;

  Jscroll = class external
  end;

  Jwai = class external
    function getWaiRole(elem: JHTMLElement): Variant;
    function getWaiState(elem: JHTMLElement; state: JString): Variant;
    function hasWaiRole(elem: JHTMLElement; role: JString): Variant;
    function hasWaiState(elem: JHTMLElement; state: JString): Variant;
    procedure removeWaiRole(elem: JHTMLElement; role: JString);
    procedure removeWaiState(elem: JHTMLElement; state: JString);
    procedure setWaiRole(elem: JHTMLElement; role: JString);
    procedure setWaiState(elem: JHTMLElement; state: JString; value: JString);
  end;

  Jtypematic = class external
  end;

  Jwindow = class external
  end;

  Jsniff = class external
  end;

//main

type
  J_Calendar = class external '_Calendar'(Jdijit.CalendarLite)
    constructor Create(params: JObject; srcNodeRef: JHTMLElement);
    "a11yclick": JObject;
    "active": Boolean;
    procedure set(&property: Jactive; value: Boolean);
    function get(&property: Jactive): Boolean;
    function watch(&property: Jactive; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "attachScope": JObject;
    procedure set(&property: JattachScope; value: JObject);
    function get(&property: JattachScope): JObject;
    function watch(&property: JattachScope; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "attributeMap": JObject;
    procedure set(&property: JattributeMap; value: JObject);
    function get(&property: JattributeMap): JObject;
    function watch(&property: JattributeMap; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "baseClass": String;
    procedure set(&property: JbaseClass; value: String);
    function get(&property: JbaseClass): String;
    function watch(&property: JbaseClass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "class": String;
    procedure set(&property: Jclass; value: String);
    function get(&property: Jclass): String;
    function watch(&property: Jclass; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "containerNode": JHTMLElement;
    procedure set(&property: JcontainerNode; value: JHTMLElement);
    function get(&property: JcontainerNode): JHTMLElement;
    function watch(&property: JcontainerNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "cssStateNodes": JObject;
    procedure set(&property: JcssStateNodes; value: JObject);
    function get(&property: JcssStateNodes): JObject;
    function watch(&property: JcssStateNodes; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "currentFocus": JDate;
    procedure set(&property: JcurrentFocus; value: JDate);
    function get(&property: JcurrentFocus): JDate;
    function watch(&property: JcurrentFocus; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "datePackage": String;
    procedure set(&property: JdatePackage; value: String);
    function get(&property: JdatePackage): String;
    function watch(&property: JdatePackage; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dateTemplateString": String;
    procedure set(&property: JdateTemplateString; value: String);
    function get(&property: JdateTemplateString): String;
    function watch(&property: JdateTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dayWidth": String;
    procedure set(&property: JdayWidth; value: String);
    function get(&property: JdayWidth): String;
    function watch(&property: JdayWidth; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dir": String;
    procedure set(&property: Jdir; value: String);
    function get(&property: Jdir): String;
    function watch(&property: Jdir; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "dndType": String;
    procedure set(&property: JdndType; value: String);
    function get(&property: JdndType): String;
    function watch(&property: JdndType; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "domNode": JHTMLElement;
    procedure set(&property: JdomNode; value: JHTMLElement);
    function get(&property: JdomNode): JHTMLElement;
    function watch(&property: JdomNode; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "dowTemplateString": String;
    procedure set(&property: JdowTemplateString; value: String);
    function get(&property: JdowTemplateString): String;
    function watch(&property: JdowTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "focused": Boolean;
    procedure set(&property: Jfocused; value: Boolean);
    function get(&property: Jfocused): Boolean;
    function watch(&property: Jfocused; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "hovering": Boolean;
    procedure set(&property: Jhovering; value: Boolean);
    function get(&property: Jhovering): Boolean;
    function watch(&property: Jhovering; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "id": String;
    procedure set(&property: Jid; value: String);
    function get(&property: Jid): String;
    function watch(&property: Jid; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "lang": String;
    procedure set(&property: Jlang; value: String);
    function get(&property: Jlang): String;
    function watch(&property: Jlang; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "observer": String;
    procedure set(&property: Jobserver; value: String);
    function get(&property: Jobserver): String;
    function watch(&property: Jobserver; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "ownerDocument": JObject;
    procedure set(&property: JownerDocument; value: JObject);
    function get(&property: JownerDocument): JObject;
    function watch(&property: JownerDocument; callback: (&property: String; oldValue: JObject; newValue: JObject)    end;):       procedure unwatch;
    end;;
    "searchContainerNode": Boolean;
    procedure set(&property: JsearchContainerNode; value: Boolean);
    function get(&property: JsearchContainerNode): Boolean;
    function watch(&property: JsearchContainerNode; callback: (&property: String; oldValue: Boolean; newValue: Boolean)    end;):       procedure unwatch;
    end;;
    "slideFrom": String;
    procedure set(&property: JslideFrom; value: String);
    function get(&property: JslideFrom): String;
    function watch(&property: JslideFrom; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "srcNodeRef": JHTMLElement;
    procedure set(&property: JsrcNodeRef; value: JHTMLElement);
    function get(&property: JsrcNodeRef): JHTMLElement;
    function watch(&property: JsrcNodeRef; callback: (&property: String; oldValue: JHTMLElement; newValue: JHTMLElement)    end;):       procedure unwatch;
    end;;
    "style": String;
    procedure set(&property: Jstyle; value: String);
    function get(&property: Jstyle): String;
    function watch(&property: Jstyle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tabIndex": String;
    procedure set(&property: JtabIndex; value: String);
    function get(&property: JtabIndex): String;
    function watch(&property: JtabIndex; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templatePath": String;
    procedure set(&property: JtemplatePath; value: String);
    function get(&property: JtemplatePath): String;
    function watch(&property: JtemplatePath; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "templateString": String;
    procedure set(&property: JtemplateString; value: String);
    function get(&property: JtemplateString): String;
    function watch(&property: JtemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "title": String;
    procedure set(&property: Jtitle; value: String);
    function get(&property: Jtitle): String;
    function watch(&property: Jtitle; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "tooltip": String;
    procedure set(&property: Jtooltip; value: String);
    function get(&property: Jtooltip): String;
    function watch(&property: Jtooltip; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    "value": JDate;
    procedure set(&property: Jvalue; value: JDate);
    function get(&property: Jvalue): JDate;
    function watch(&property: Jvalue; callback: (&property: String; oldValue: JDate; newValue: JDate)    end;):       procedure unwatch;
    end;;
    "weekTemplateString": String;
    procedure set(&property: JweekTemplateString; value: String);
    function get(&property: JweekTemplateString): String;
    function watch(&property: JweekTemplateString; callback: (&property: String; oldValue: String; newValue: String)    end;):       procedure unwatch;
    end;;
    function attr(name: JString): Variant; overload;
    function attr(name: JString; value: JObject): Variant; overload;
    function attr(name: JObject): Variant; overload;
    function attr(name: JObject; value: JObject): Variant; overload;
    procedure buildRendering;
    function connect(obj: JObject; event: JString; method: JString): Variant;
    function connect(obj: Variant; event: JString; method: JString): Variant;
    function connect(obj: JObject; event: JFunction; method: JString): Variant;
    function connect(obj: Variant; event: JFunction; method: JString): Variant;
    function connect(obj: JObject; event: JString; method: JFunction): Variant;
    function connect(obj: Variant; event: JString; method: JFunction): Variant;
    function connect(obj: JObject; event: JFunction; method: JFunction): Variant;
    function connect(obj: Variant; event: JFunction; method: JFunction): Variant;
    function defer(fcn: JFunction): JObject; overload;
    function defer(fcn: JFunction; delay: Float): JObject; overload;
    procedure destroy; overload;
    procedure destroy(preserveDom: Boolean); overload;
    procedure destroyDescendants; overload;
    procedure destroyDescendants(preserveDom: Boolean); overload;
    procedure destroyRecursive; overload;
    procedure destroyRecursive(preserveDom: Boolean); overload;
    procedure destroyRendering; overload;
    procedure destroyRendering(preserveDom: Boolean); overload;
    procedure disconnect(handle: Variant);
    function emit(&type: JString): Variant; overload;
    function emit(&type: JString; eventObj: JObject): Variant; overload;
    function emit(&type: JString; eventObj: JObject; callbackArgs: array of Variant): Variant; overload;
    procedure focus;
    function get(name: Variant): Variant;
    function getChildren: array of Variant;
    function getClassForDate(dateObject: JDate; locale: JString): JString;
    function getDescendants: array of Variant;
    function getParent: Variant;
    procedure goToToday;
    function handleKey(evt: JEvent): Variant;
    function isDisabledDate(dateObject: JDate; locale: JString): Boolean;
    function isFocusable: Variant;
    function isLeftToRight: Variant;
    function on(&type: JString; func: JFunction): Variant;
    function on(&type: JFunction; func: JFunction): Variant;
    function own: Variant;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: JString): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: JString): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: JString): Variant; overload;
    function placeAt(reference: JString): Variant; overload;
    function placeAt(reference: JString; position: Float): Variant; overload;
    function placeAt(reference: JHTMLElement): Variant; overload;
    function placeAt(reference: JHTMLElement; position: Float): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase): Variant; overload;
    function placeAt(reference: Jdijit._WidgetBase; position: Float): Variant; overload;
    procedure postCreate;
    procedure postMixInProperties;
    function set(name: Variant; value: Variant): Variant;
    procedure setAttribute(attr: JString; value: Variant);
    procedure setValue(value: JDate);
    procedure startup;
    function subscribe(t: JString; method: JFunction): Variant;
    function toString: String;
    function uninitialize: Boolean;
    procedure unsubscribe(handle: JObject);
    function watch(&property: String; callback: (&property: String; oldValue: Variant; newValue: Variant)    end;):       procedure unwatch;
    end;;
    function getCachedTemplate: Variant;
    procedure onBlur;
    procedure onChange(value: Variant);
    procedure onClick(event: Variant);
    function onClose: Boolean;
    procedure onDblClick(event: Variant);
    procedure onFocus;
    procedure onHide;
    procedure onKeyDown(event: Variant);
    procedure onKeyPress(event: Variant);
    procedure onKeyUp(event: Variant);
    procedure onMouseDown(event: Variant);
    procedure onMouseEnter(event: Variant);
    procedure onMouseLeave(event: Variant);
    procedure onMouseMove(event: Variant);
    procedure onMouseOut(event: Variant);
    procedure onMouseOver(event: Variant);
    procedure onMouseUp(event: Variant);
    procedure onShow;
    procedure onValueSelected(date: JDate);
  end;

  Jplace = class external
    function around(node: JHTMLElement; anchor: JHTMLElement; positions: array of JString; leftToRight: Boolean; layoutNode: JFunction): Variant;
    function around(node: JHTMLElement; anchor: Jdijit.place.__Rectangle; positions: array of JString; leftToRight: Boolean; layoutNode: JFunction): Variant;
    function at(node: JHTMLElement; pos: Jdijit.place.__Position; corners: array of JString; padding: Jdijit.place.__Position; layoutNode: Variant): Variant;
  end;

  Jregistry = class external
    _length: Float;
    procedure add(widget: Jdijit._WidgetBase);
    function byId(id: JString): Jdijit._WidgetBase;
    function byId(id: Jdijit._WidgetBase): Jdijit._WidgetBase;
    function byNode(node: JHTMLElement): Variant;
    function findWidgets(root: JHTMLElement; skipNode: JHTMLElement): array of Variant;
    function getEnclosingWidget(node: JHTMLElement): Variant;
    function getUniqueId(widgetType: JString): JString;
    procedure remove(id: JString);
    function toArray: array of Variant;
  end;

  Jtypematic = class external
    function addKeyListener(node: JHTMLElement; keyObject: JObject; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    function addListener(mouseNode: JHTMLElement; keyNode: JHTMLElement; keyObject: JObject; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    function addMouseListener(node: JHTMLElement; _this: JObject; callback: JFunction; subsequentDelay: Float; initialDelay: Float; minDelay: Float): Variant;
    procedure stop;
    procedure trigger(evt: JEvent; _this: JObject; node: JHTMLElement; callback: JFunction; obj: JObject; subsequentDelay: Float; initialDelay: Float; minDelay: Float);
  end;

//place

type
  J__Position = class external
    x: Float;
    y: Float;
  end;

  J__Rectangle = class external
    h: Float;
    w: Float;
    x: Float;
    y: Float;
  end;

//registry

type
  J_hash = class external
  end;

//"dijit/_BidiSupport"

var
  exp: Jdijit._BidiSupport;

//"dijit/BackgroundIframe"

var
  exp: Jdijit.BackgroundIframe;

//"dijit/hccss"

var
  exp: Jdijit.hccss;

//"dijit/_base"

var
  exp: Jdijit._base;

//"dijit/_base/popup"

var
  exp: Jdijit._base.popup;

//"dijit/_base/manager"

var
  exp: Jdijit._base.manager;

//"dijit/_base/place"

var
  exp: Jdijit._base.place;

//"dijit/_base/focus"

var
  exp: Jdijit._base.focus;

//"dijit/_base/scroll"

var
  exp: Jdijit._base.scroll;

//"dijit/_base/sniff"

var
  exp: Jdijit._base.sniff;

//"dijit/_base/typematic"

var
  exp: Jdijit._base.typematic;

//"dijit/_base/window"

var
  exp: Jdijit._base.window;

//"dijit/_base/wai"

var
  exp: Jdijit._base.wai;

//"dijit/_BidiMixin"

var
  exp: Jdijit._BidiMixin;

//"dijit/_Calendar"

var
  exp: Jdijit._Calendar;

//"dijit/a11y"

var
  exp: Jdijit.a11y;

//"dijit/a11yclick"

var
  exp: Jdijit.a11yclick;

//"dijit/dijit"

var
  exp: Jdijit.dijit;

//"dijit/dijit-all"

var
  exp: Jdijit.dijit_all;

//"dijit/main"

var
  exp: Jdijit.main;

//"dijit/main._Calendar"

var
  exp: Jdijit.main._Calendar;

//"dijit/main.place"

var
  exp: Jdijit.main.place;

//"dijit/main.typematic"

var
  exp: Jdijit.main.typematic;

//"dijit/main.registry"

var
  exp: Jdijit.main.registry;

//"dijit/place"

var
  exp: Jdijit.place;

//"dijit/place.__Rectangle"

var
  exp: Jdijit.place.__Rectangle;

//"dijit/place.__Position"

var
  exp: Jdijit.place.__Position;

//"dijit/registry"

var
  exp: Jdijit.registry;

//"dijit/registry._hash"

var
  exp: Jdijit.registry._hash;

//"dijit/typematic"

var
  exp: Jdijit.typematic;

//"dijit/Viewport"

var
  exp: Jdijit.Viewport;

//"dijit/_AttachMixin"

var
  exp: Jtype of;

//"dijit/_Contained"

var
  exp: Jtype of;

//"dijit/_Container"

var
  exp: Jtype of;

//"dijit/_DialogMixin"

var
  exp: Jtype of;

//"dijit/_CssStateMixin"

var
  exp: Jtype of;

//"dijit/_FocusMixin"

var
  exp: Jtype of;

//"dijit/_HasDropDown"

var
  exp: Jtype of;

//"dijit/_KeyNavMixin"

var
  exp: Jtype of;

//"dijit/_KeyNavContainer"

var
  exp: Jtype of;

//"dijit/_OnDijitClickMixin"

var
  exp: Jtype of;

//"dijit/_OnDijitClickMixin.a11yclick"

var
  exp: Jdijit._OnDijitClickMixin.a11yclick;

//"dijit/_Templated"

var
  exp: Jtype of;

//"dijit/_TemplatedMixin"

var
  exp: Jtype of;

//"dijit/_TemplatedMixin._templateCache"

var
  exp: Jdijit._TemplatedMixin._templateCache;

//"dijit/_PaletteMixin"

var
  exp: Jtype of;

//"dijit/_PaletteMixin.__Dye"

var
  exp: Jtype of;

//"dijit/_MenuBase"

var
  exp: Jtype of;

//"dijit/_TimePicker"

var
  exp: Jtype of;

//"dijit/_TimePicker.__Constraints"

var
  exp: Jtype of;

//"dijit/_WidgetsInTemplateMixin"

var
  exp: Jtype of;

//"dijit/_WidgetBase"

var
  exp: Jtype of;

//"dijit/_Widget"

var
  exp: Jtype of;

//"dijit/Destroyable"

var
  exp: Jtype of;

//"dijit/Calendar"

var
  exp: Jtype of;

//"dijit/Calendar._MonthDropDown"

var
  exp: Jtype of;

//"dijit/Calendar._MonthDropDownButton"

var
  exp: Jtype of;

//"dijit/CalendarLite"

var
  exp: Jtype of;

//"dijit/CalendarLite._MonthWidget"

var
  exp: Jtype of;

//"dijit/CheckedMenuItem"

var
  exp: Jtype of;

//"dijit/ColorPalette"

var
  exp: Jtype of;

//"dijit/ColorPalette._Color"

var
  exp: Jtype of;

//"dijit/Declaration"

var
  exp: Jtype of;

//"dijit/DialogUnderlay"

var
  exp: Jtype of;

//"dijit/DropDownMenu"

var
  exp: Jtype of;

//"dijit/Dialog"

var
  exp: Jtype of;

//"dijit/Dialog._DialogBase"

var
  exp: Jtype of;

//"dijit/Dialog._DialogLevelManager"

var
  exp: Jdijit.Dialog._DialogLevelManager;

//"dijit/Editor"

var
  exp: Jtype of;

//"dijit/Fieldset"

var
  exp: Jtype of;

//"dijit/InlineEditBox"

var
  exp: Jtype of;

//"dijit/InlineEditBox._InlineEditor"

var
  exp: Jtype of;

//"dijit/Menu"

var
  exp: Jtype of;

//"dijit/MenuBarItem"

var
  exp: Jtype of;

//"dijit/MenuBarItem._MenuBarItemMixin"

var
  exp: Jtype of;

//"dijit/MenuSeparator"

var
  exp: Jtype of;

//"dijit/MenuItem"

var
  exp: Jtype of;

//"dijit/MenuBar"

var
  exp: Jtype of;

//"dijit/PopupMenuBarItem"

var
  exp: Jtype of;

//"dijit/ProgressBar"

var
  exp: Jtype of;

//"dijit/RadioMenuItem"

var
  exp: Jtype of;

//"dijit/PopupMenuItem"

var
  exp: Jtype of;

//"dijit/TitlePane"

var
  exp: Jtype of;

//"dijit/Toolbar"

var
  exp: Jtype of;

//"dijit/Tooltip"

var
  exp: Jtype of;

//"dijit/Tooltip._MasterTooltip"

var
  exp: Jtype of;

//"dijit/ToolbarSeparator"

var
  exp: Jtype of;

//"dijit/WidgetSet"

var
  exp: Jtype of;

//"dijit/TooltipDialog"

var
  exp: Jtype of;

//"dijit/Tree"

var
  exp: Jtype of;

//"dijit/Tree._TreeNode"

var
  exp: Jtype of;

//"dijit/_editor/html"

var
  exp: Jdijit._editor.html;

//"dijit/_editor/range"

var
  exp: Jdijit._editor.range;

//"dijit/_editor/range.W3CRange"

var
  exp: Jtype of;

//"dijit/_editor/range.ie"

var
  exp: Jdijit._editor.range.ie;

//"dijit/_editor/selection"

var
  exp: Jdijit._editor.selection;

//"dijit/_editor/_Plugin"

var
  exp: Jtype of;

//"dijit/_editor/_Plugin.registry"

var
  exp: Jdijit._editor._Plugin.registry;

//"dijit/_editor/RichText"

var
  exp: Jtype of;

//"dijit/_editor/plugins/AlwaysShowToolbar"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FontChoice"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FontChoice._FontDropDown"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FontChoice._FontSizeDropDown"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FontChoice._FontNameDropDown"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FontChoice._FormatBlockDropDown"

var
  exp: Jtype of;

//"dijit/_editor/plugins/EnterKeyHandling"

var
  exp: Jtype of;

//"dijit/_editor/plugins/LinkDialog"

var
  exp: Jtype of;

//"dijit/_editor/plugins/LinkDialog.ImgLinkDialog"

var
  exp: Jtype of;

//"dijit/_editor/plugins/FullScreen"

var
  exp: Jtype of;

//"dijit/_editor/plugins/NewPage"

var
  exp: Jtype of;

//"dijit/_editor/plugins/Print"

var
  exp: Jtype of;

//"dijit/_editor/plugins/TabIndent"

var
  exp: Jtype of;

//"dijit/_editor/plugins/TextColor"

var
  exp: Jtype of;

//"dijit/_editor/plugins/ToggleDir"

var
  exp: Jtype of;

//"dijit/_editor/plugins/ViewSource"

var
  exp: Jtype of;

//"dijit/_tree/dndSource"

var
  exp: Jdijit._tree.dndSource;

//"dijit/form/Slider"

var
  exp: Jdijit.form.Slider;

//"dijit/form/_ButtonMixin"

var
  exp: Jtype of;

//"dijit/form/_AutoCompleterMixin"

var
  exp: Jtype of;

//"dijit/form/_CheckBoxMixin"

var
  exp: Jtype of;

//"dijit/form/_ComboBoxMenuMixin"

var
  exp: Jtype of;

//"dijit/form/_ExpandingTextAreaMixin"

var
  exp: Jtype of;

//"dijit/form/_FormMixin"

var
  exp: Jtype of;

//"dijit/form/_FormValueMixin"

var
  exp: Jtype of;

//"dijit/form/_FormWidgetMixin"

var
  exp: Jtype of;

//"dijit/form/_ListBase"

var
  exp: Jtype of;

//"dijit/form/_ComboBoxMenu"

var
  exp: Jtype of;

//"dijit/form/_RadioButtonMixin"

var
  exp: Jtype of;

//"dijit/form/_SearchMixin"

var
  exp: Jtype of;

//"dijit/form/_ListMouseMixin"

var
  exp: Jtype of;

//"dijit/form/_FormSelectWidget"

var
  exp: Jtype of;

//"dijit/form/_FormSelectWidget.__SelectOption"

var
  exp: Jdijit.form._FormSelectWidget.__SelectOption;

//"dijit/form/_TextBoxMixin"

var
  exp: Jtype of;

//"dijit/form/_FormWidget"

var
  exp: Jtype of;

//"dijit/form/_ToggleButtonMixin"

var
  exp: Jtype of;

//"dijit/form/_FormValueWidget"

var
  exp: Jtype of;

//"dijit/form/_DateTimeTextBox"

var
  exp: Jtype of;

//"dijit/form/_DateTimeTextBox.__Constraints"

var
  exp: Jtype of;

//"dijit/form/ComboBoxMixin"

var
  exp: Jtype of;

//"dijit/form/_Spinner"

var
  exp: Jtype of;

//"dijit/form/DataList"

var
  exp: Jtype of;

//"dijit/form/Button"

var
  exp: Jtype of;

//"dijit/form/CheckBox"

var
  exp: Jtype of;

//"dijit/form/ComboButton"

var
  exp: Jtype of;

//"dijit/form/ComboBox"

var
  exp: Jtype of;

//"dijit/form/CurrencyTextBox"

var
  exp: Jtype of;

//"dijit/form/DropDownButton"

var
  exp: Jtype of;

//"dijit/form/Form"

var
  exp: Jtype of;

//"dijit/form/DateTextBox"

var
  exp: Jtype of;

//"dijit/form/HorizontalRule"

var
  exp: Jtype of;

//"dijit/form/FilteringSelect"

var
  exp: Jtype of;

//"dijit/form/HorizontalRuleLabels"

var
  exp: Jtype of;

//"dijit/form/HorizontalSlider"

var
  exp: Jtype of;

//"dijit/form/HorizontalSlider._Mover"

var
  exp: Jtype of;

//"dijit/form/MultiSelect"

var
  exp: Jtype of;

//"dijit/form/MappedTextBox"

var
  exp: Jtype of;

//"dijit/form/NumberSpinner"

var
  exp: Jtype of;

//"dijit/form/RangeBoundTextBox"

var
  exp: Jtype of;

//"dijit/form/RangeBoundTextBox.__Constraints"

var
  exp: Jtype of;

//"dijit/form/RadioButton"

var
  exp: Jtype of;

//"dijit/form/NumberTextBox"

var
  exp: Jtype of;

//"dijit/form/NumberTextBox.__Constraints"

var
  exp: Jtype of;

//"dijit/form/NumberTextBox.Mixin"

var
  exp: Jtype of;

//"dijit/form/SimpleTextarea"

var
  exp: Jtype of;

//"dijit/form/Textarea"

var
  exp: Jtype of;

//"dijit/form/Select"

var
  exp: Jtype of;

//"dijit/form/Select._Menu"

var
  exp: Jtype of;

//"dijit/form/TextBox"

var
  exp: Jtype of;

//"dijit/form/VerticalRule"

var
  exp: Jtype of;

//"dijit/form/ToggleButton"

var
  exp: Jtype of;

//"dijit/form/TimeTextBox"

var
  exp: Jtype of;

//"dijit/form/ValidationTextBox"

var
  exp: Jtype of;

//"dijit/form/VerticalRuleLabels"

var
  exp: Jtype of;

//"dijit/form/VerticalSlider"

var
  exp: Jtype of;

//"dijit/layout/utils"

var
  exp: Jdijit.layout.utils;

//"dijit/layout/_ContentPaneResizeMixin"

var
  exp: Jtype of;

//"dijit/layout/_LayoutWidget"

var
  exp: Jtype of;

//"dijit/layout/AccordionContainer"

var
  exp: Jtype of;

//"dijit/layout/AccordionContainer._Button"

var
  exp: Jtype of;

//"dijit/layout/AccordionContainer._InnerContainer"

var
  exp: Jtype of;

//"dijit/layout/_TabContainerBase"

var
  exp: Jtype of;

//"dijit/layout/AccordionPane"

var
  exp: Jtype of;

//"dijit/layout/BorderContainer"

var
  exp: Jtype of;

//"dijit/layout/BorderContainer._Gutter"

var
  exp: Jtype of;

//"dijit/layout/BorderContainer._Splitter"

var
  exp: Jtype of;

//"dijit/layout/BorderContainer.ChildWidgetProperties"

var
  exp: Jdijit.layout.BorderContainer.ChildWidgetProperties;

//"dijit/layout/LayoutContainer"

var
  exp: Jtype of;

//"dijit/layout/LayoutContainer.ChildWidgetProperties"

var
  exp: Jdijit.layout.LayoutContainer.ChildWidgetProperties;

//"dijit/layout/ContentPane"

var
  exp: Jtype of;

//"dijit/layout/LinkPane"

var
  exp: Jtype of;

//"dijit/layout/SplitContainer"

var
  exp: Jtype of;

//"dijit/layout/SplitContainer.ChildWidgetProperties"

var
  exp: Jdijit.layout.SplitContainer.ChildWidgetProperties;

//"dijit/layout/ScrollingTabController"

var
  exp: Jtype of;

//"dijit/layout/StackController"

var
  exp: Jtype of;

//"dijit/layout/StackController.StackButton"

var
  exp: Jtype of;

//"dijit/layout/StackContainer"

var
  exp: Jtype of;

//"dijit/layout/StackContainer.ChildWidgetProperties"

var
  exp: Jdijit.layout.StackContainer.ChildWidgetProperties;

//"dijit/layout/TabContainer"

var
  exp: Jtype of;

//"dijit/layout/TabController"

var
  exp: Jtype of;

//"dijit/layout/TabController.TabButton"

var
  exp: Jtype of;

//"dijit/tree/_dndContainer"

var
  exp: Jdijit.tree._dndContainer;

//"dijit/tree/ForestStoreModel"

var
  exp: Jtype of;

//"dijit/tree/dndSource"

var
  exp: Jdijit.tree.dndSource;

//"dijit/tree/dndSource.__Item"

var
  exp: Jdijit.tree.dndSource.__Item;

//"dijit/tree/model"

var
  exp: Jdijit.tree.model;

//"dijit/tree/_dndSelector"

var
  exp: Jdijit.tree._dndSelector;

//"dijit/tree/ObjectStoreModel"

var
  exp: Jtype of;

//"dijit/tree/TreeStoreModel"

var
  exp: Jtype of;

//"dijit/ConfirmDialog"

var
  exp: Jtype of;

//"dijit/_ConfirmDialogMixin"

var
  exp: Jtype of;

