unit Titanium;

interface

//Ti

type
  JIOStream = class external(JTi.Proxy)
    procedure close;
    function isReadable: Boolean;
    function isWriteable: Boolean;
    function read(buffer: JTi.Buffer): Float; overload;
    function read(buffer: JTi.Buffer; offset: Float): Float; overload;
    function read(buffer: JTi.Buffer; offset: Float; _length: Float): Float; overload;
    function write(buffer: JTi.Buffer): Float; overload;
    function write(buffer: JTi.Buffer; offset: Float): Float; overload;
    function write(buffer: JTi.Buffer; offset: Float; _length: Float): Float; overload;
  end;

  JAPI = class external
    procedure debug(message: JArray{<JString>});
    procedure debug(message: String);
    procedure error(message: JArray{<JString>});
    procedure error(message: String);
    procedure info(message: JArray{<JString>});
    procedure info(message: String);
    procedure log(level: String; message: JArray{<JString>});
    procedure log(level: String; message: String);
    procedure timestamp(message: JArray{<JString>});
    procedure timestamp(message: String);
    procedure trace(message: JArray{<JString>});
    procedure trace(message: String);
    procedure warn(message: JArray{<JString>});
    procedure warn(message: String);
  end;

  JProxy = class external
    apiName: String;
    bubbleParent: Boolean;
    procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
    procedure applyProperties(props: JDictionary{<JObject>});
    procedure fireEvent(name: String; event: JDictionary{<JObject>});
    function getApiName: String;
    function getBubbleParent: Boolean;
    procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
    procedure setBubbleParent(bubbleParent: Boolean);
  end;

  JBlob = class external(JTi.Proxy)
    file: JTi.Filesystem.File;
    height: Float;
    _length: Float;
    mimeType: String;
    nativePath: String;
    size: Float;
    text: String;
    width: Float;
    procedure append(blob: JTi.Blob);
    function getFile: JTi.Filesystem.File;
    function getHeight: Float;
    function getLength: Float;
    function getMimeType: String;
    function getNativePath: String;
    function getSize: Float;
    function getText: String;
    function getWidth: Float;
    function imageAsCropped(options: JDictionary{<JImageAsCroppedDict>}): JTi.Blob;
    function imageAsResized(width: Float; height: Float): JTi.Blob;
    function imageAsThumbnail(size: Float): JTi.Blob; overload;
    function imageAsThumbnail(size: Float; borderSize: Float): JTi.Blob; overload;
    function imageAsThumbnail(size: Float; borderSize: Float; cornerRadius: Float): JTi.Blob; overload;
    function imageWithAlpha: JTi.Blob;
    function imageWithRoundedCorner(cornerSize: Float): JTi.Blob; overload;
    function imageWithRoundedCorner(cornerSize: Float; borderSize: Float): JTi.Blob; overload;
    function imageWithTransparentBorder(size: Float): JTi.Blob;
    function toString: String;
  end;

  JCodec = class external
    BIG_ENDIAN: Float;
    CHARSET_ASCII: String;
    CHARSET_ISO_LATIN_1: String;
    CHARSET_UTF16: String;
    CHARSET_UTF16BE: String;
    CHARSET_UTF16LE: String;
    CHARSET_UTF8: String;
    LITTLE_ENDIAN: Float;
    TYPE_BYTE: String;
    TYPE_DOUBLE: String;
    TYPE_FLOAT: String;
    TYPE_INT: String;
    TYPE_LONG: String;
    TYPE_SHORT: String;
    function decodeNumber(options: JDecodeNumberDict): Float;
    function decodeString(options: JDecodeStringDict): String;
    function encodeNumber(options: JEncodeNumberDict): Float;
    function encodeString(options: JDictionary{<JEncodeStringDict>}): Float;
    function getNativeByteOrder: Float;
  end;

  JLocale = class external
    currentCountry: String;
    currentLanguage: String;
    currentLocale: String;
    function formatTelephoneNumber(number: String): String;
    function getCurrencyCode(locale: String): String;
    function getCurrencySymbol(currencyCode: String): String;
    function getCurrentCountry: String;
    function getCurrentLanguage: String;
    function getCurrentLocale: String;
    function getLocaleCurrencySymbol(locale: String): String;
    function getString(key: String): String; overload;
    function getString(key: String; hint: String): String; overload;
  end;

  JCloudPush = class external
    SERVICE_DISABLED: Float;
    SERVICE_INVALID: Float;
    SERVICE_MISSING: Float;
    SERVICE_VERSION_UPDATE_REQUIRED: Float;
    SUCCESS: Float;
    enabled: Boolean;
    focusAppOnPush: Boolean;
    showAppOnTrayClick: Boolean;
    showTrayNotification: Boolean;
    showTrayNotificationsWhenFocused: Boolean;
    singleCallback: Boolean;
    procedure clearStatus;
    function getEnabled: Boolean;
    function getFocusAppOnPush: Boolean;
    function getShowAppOnTrayClick: Boolean;
    function getShowTrayNotification: Boolean;
    function getShowTrayNotificationsWhenFocused: Boolean;
    function getSingleCallback: Boolean;
    function isGooglePlayServicesAvailable: Float;
    procedure retrieveDeviceToken(config: JCloudPushNotificationConfig);
    procedure setEnabled(enabled: Boolean);
    procedure setFocusAppOnPush(focusAppOnPush: Boolean);
    procedure setShowAppOnTrayClick(showAppOnTrayClick: Boolean);
    procedure setShowTrayNotification(showTrayNotification: Boolean);
    procedure setShowTrayNotificationsWhenFocused(showTrayNotificationsWhenFocused: Boolean);
    procedure setSingleCallback(singleCallback: Boolean);
  end;

  JBuffer = class external(JTi.Proxy)
    byteOrder: Float;
    _length: Float;
    &type: String;
    value: Variant;
    function append(sourceBuffer: JTi.Buffer): Float; overload;
    function append(sourceBuffer: JTi.Buffer; sourceOffset: Float): Float; overload;
    function append(sourceBuffer: JTi.Buffer; sourceOffset: Float; sourceLength: Float): Float; overload;
    procedure clear;
    function clone: JTi.Buffer; overload;
    function clone(offset: Float): JTi.Buffer; overload;
    function clone(offset: Float; _length: Float): JTi.Buffer; overload;
    function copy(sourceBuffer: JTi.Buffer; offset: Float): Float; overload;
    function copy(sourceBuffer: JTi.Buffer; offset: Float; sourceOffset: Float): Float; overload;
    function copy(sourceBuffer: JTi.Buffer; offset: Float; sourceOffset: Float; sourceLength: Float): Float; overload;
    procedure fill(fillByte: Float); overload;
    procedure fill(fillByte: Float; offset: Float); overload;
    procedure fill(fillByte: Float; offset: Float; _length: Float); overload;
    function getByteOrder: Float;
    function getLength: Float;
    function getType: String;
    function getValue: Variant;
    function insert(sourceBuffer: JTi.Buffer; offset: Float): Float; overload;
    function insert(sourceBuffer: JTi.Buffer; offset: Float; sourceOffset: Float): Float; overload;
    function insert(sourceBuffer: JTi.Buffer; offset: Float; sourceOffset: Float; sourceLength: Float): Float; overload;
    procedure release;
    procedure setLength(_length: Float);
    function toBlob: JTi.Blob;
    function toString: String;
  end;

  JYahoo = class external
    procedure yql(yql: String; callback: (args: array of Variant): Variant);
  end;

  JGesture = class external
    landscape: Boolean;
    orientation: Float;
    portrait: Boolean;
    function getLandscape: Boolean;
    function getOrientation: Float;
    function getPortrait: Boolean;
    function isFaceDown: Boolean;
    function isFaceUp: Boolean;
    function isLandscape: Boolean;
    function isPortrait: Boolean;
  end;

  JAnalytics = class external
    lastEvent: String;
    procedure addEvent(&type: String; name: String); overload;
    procedure addEvent(&type: String; name: String; data: Variant); overload;
    procedure featureEvent(name: String); overload;
    procedure featureEvent(name: String; data: Variant); overload;
    function getLastEvent: String;
    procedure navEvent(from: String; to: String); overload;
    procedure navEvent(from: String; to: String; name: String); overload;
    procedure navEvent(from: String; to: String; name: String; data: Variant); overload;
    procedure settingsEvent(name: String); overload;
    procedure settingsEvent(name: String; data: Variant); overload;
    procedure timedEvent(name: String; start: JDate; stop: JDate; duration: Float); overload;
    procedure timedEvent(name: String; start: JDate; stop: JDate; duration: Float; data: Variant); overload;
    procedure userEvent(name: String); overload;
    procedure userEvent(name: String; data: Variant); overload;
  end;

  JUtils = class external
    function base64decode(obj: String): JTi.Blob;
    function base64decode(obj: JTi.Blob): JTi.Blob;
    function base64encode(obj: String): JTi.Blob;
    function base64encode(obj: JTi.Blob): JTi.Blob;
    function base64encode(obj: JTi.Filesystem.File): JTi.Blob;
    function md5HexDigest(obj: String): String;
    function md5HexDigest(obj: JTi.Blob): String;
    function sha1(obj: String): String;
    function sha1(obj: JTi.Blob): String;
    function sha256(obj: String): String;
    function sha256(obj: JTi.Blob): String;
  end;

  JEvent = class external
    bubbles: Boolean;
    cancelBubble: Boolean;
    source: Variant;
    &type: String;
  end;

  JStream = class external
    MODE_APPEND: Float;
    MODE_READ: Float;
    MODE_WRITE: Float;
    function createStream(params: JCreateStreamArgs): JTi.IOStream;
    procedure pump(inputStream: JTi.IOStream; handler: (args: array of Variant): Variant; maxChunkSize: Float); overload;
    procedure pump(inputStream: JTi.IOStream; handler: (args: array of Variant): Variant; maxChunkSize: Float; isAsync: Boolean); overload;
    procedure read(sourceStream: JTi.IOStream; buffer: JTi.Buffer); overload;
    procedure read(sourceStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float); overload;
    procedure read(sourceStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float; _length: Float); overload;
    procedure read(sourceStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float; _length: Float; resultsCallback: (args: array of Variant): Variant); overload;
    function readAll(sourceStream: JTi.IOStream): Variant; overload;
    function readAll(sourceStream: JTi.IOStream; buffer: JTi.Buffer): Variant; overload;
    function readAll(sourceStream: JTi.IOStream; buffer: JTi.Buffer; resultsCallback: (args: array of Variant): Variant): Variant; overload;
    procedure write(outputStream: JTi.IOStream; buffer: JTi.Buffer); overload;
    procedure write(outputStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float); overload;
    procedure write(outputStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float; _length: Float); overload;
    procedure write(outputStream: JTi.IOStream; buffer: JTi.Buffer; offset: Float; _length: Float; resultsCallback: (args: array of Variant): Variant); overload;
    procedure writeStream(inputStream: JTi.IOStream; outputStream: JTi.IOStream; maxChunkSize: Float); overload;
    procedure writeStream(inputStream: JTi.IOStream; outputStream: JTi.IOStream; maxChunkSize: Float; resultsCallback: (args: array of Variant): Variant); overload;
  end;

//XML

type
  JEntity = class external(JTi.XML.Node)
    notationName: String;
    publicId: String;
    systemId: String;
    function getNotationName: String;
    function getPublicId: String;
    function getSystemId: String;
  end;

  JNode = class external(JTi.Proxy)
    ATTRIBUTE_NODE: Float;
    CDATA_SECTION_NODE: Float;
    COMMENT_NODE: Float;
    DOCUMENT_FRAGMENT_NODE: Float;
    DOCUMENT_NODE: Float;
    DOCUMENT_TYPE_NODE: Float;
    ELEMENT_NODE: Float;
    ENTITY_NODE: Float;
    ENTITY_REFERENCE_NODE: Float;
    NOTATION_NODE: Float;
    PROCESSING_INSTRUCTION_NODE: Float;
    TEXT_NODE: Float;
    attributes: JTi.XML.NamedNodeMap;
    childNodes: JTi.XML.NodeList;
    firstChild: JTi.XML.Node;
    lastChild: JTi.XML.Node;
    localName: String;
    namespaceURI: String;
    nextSibling: JTi.XML.Node;
    nodeName: String;
    nodeType: Float;
    nodeValue: String;
    ownerDocument: JTi.XML.Document;
    parentNode: JTi.XML.Node;
    prefix: String;
    previousSibling: JTi.XML.Node;
    text: String;
    textContent: String;
    function appendChild(newChild: JTi.XML.Node): JTi.XML.Node;
    function cloneNode(deep: Boolean): JTi.XML.Node;
    function getAttributes: JTi.XML.NamedNodeMap;
    function getChildNodes: JTi.XML.NodeList;
    function getFirstChild: JTi.XML.Node;
    function getLastChild: JTi.XML.Node;
    function getLocalName: String;
    function getNamespaceURI: String;
    function getNextSibling: JTi.XML.Node;
    function getNodeName: String;
    function getNodeType: Float;
    function getNodeValue: String;
    function getOwnerDocument: JTi.XML.Document;
    function getParentNode: JTi.XML.Node;
    function getPrefix: String;
    function getPreviousSibling: JTi.XML.Node;
    function getText: String;
    function getTextContent: String;
    function hasAttributes: Boolean;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JTi.XML.Node; refChild: JTi.XML.Node): JTi.XML.Node;
    function isSupported(feature: String; version: String): Boolean;
    procedure normalize;
    function removeChild(oldChild: JTi.XML.Node): JTi.XML.Node;
    function replaceChild(newChild: JTi.XML.Node; oldChild: JTi.XML.Node): JTi.XML.Node;
    procedure setLocalName(localName: String);
    procedure setNodeValue(nodeValue: String);
    procedure setPrefix(prefix: String);
  end;

  JCharacterData = class external(JTi.XML.Node)
    data: String;
    _length: Float;
    procedure appendData(arg: String);
    procedure deleteData(offset: Float; count: Float);
    function getData: String;
    function getLength: Float;
    procedure insertData(offset: Float; arg: String);
    procedure replaceData(offset: Float; count: Float; arg: String);
    procedure setData(data: String);
    function substringData(offset: Float; count: Float): String;
  end;

  JDOMImplementation = class external(JTi.Proxy)
    function createDocument(namespaceURI: String; qualifiedName: String; doctype: JTi.XML.DocumentType): JTi.XML.Document;
    function createDocumentType(qualifiedName: String; publicId: String; systemId: String): JTi.XML.DocumentType;
    function hasFeature(feature: String; version: String): Boolean;
  end;

  JDocument = class external(JTi.XML.Node)
    doctype: JTi.XML.DocumentType;
    documentElement: JTi.XML.Element;
    implementation: JTi.XML.DOMImplementation;
    function createAttribute(name: String): JTi.XML.Attr;
    function createAttributeNS(namespaceURI: String; name: String): JTi.XML.Attr;
    function createCDATASection(data: String): JTi.XML.CDATASection;
    function createComment(data: String): JTi.XML.Comment;
    function createDocumentFragment: JTi.XML.DocumentFragment;
    function createElement(tagName: String): JTi.XML.Element;
    function createElementNS(namespaceURI: String; name: String): JTi.XML.Element;
    function createEntityReference(name: String): JTi.XML.EntityReference;
    function createProcessingInstruction(target: String; data: String): JTi.XML.ProcessingInstruction;
    function createTextNode(data: String): JTi.XML.Text;
    function getDoctype: JTi.XML.DocumentType;
    function getDocumentElement: JTi.XML.Element;
    function getElementById(elementId: String): JTi.XML.Element;
    function getElementsByTagName(tagname: String): JTi.XML.NodeList;
    function getElementsByTagNameNS(namespaceURI: String; localname: String): JTi.XML.NodeList;
    function getImplementation: JTi.XML.DOMImplementation;
    function importNode(importedNode: JTi.XML.Node; deep: Boolean): JTi.XML.Node;
  end;

  JAttr = class external(JTi.XML.Node)
    name: String;
    ownerElement: JTi.XML.Element;
    specified: Boolean;
    value: String;
    function getName: String;
    function getOwnerElement: JTi.XML.Element;
    function getSpecified: Boolean;
    function getValue: String;
    procedure setValue(value: String);
  end;

  JProcessingInstruction = class external(JTi.Proxy)
    data: String;
    target: String;
    function getData: String;
    function getTarget: String;
    procedure setData(data: String);
  end;

  JNamedNodeMap = class external(JTi.Proxy)
    _length: Float;
    function getLength: Float;
    function getNamedItem(name: String): JTi.XML.Node;
    function getNamedItemNS(namespaceURI: String; localName: String): JTi.XML.Node;
    function item(index: Float): JTi.XML.Node;
    function removeNamedItem(name: String): JTi.XML.Node;
    function removeNamedItemNS(namespaceURI: String; localName: String): JTi.XML.Node;
    function setNamedItem(node: JTi.XML.Node): JTi.XML.Node;
    function setNamedItemNS(node: JTi.XML.Node): JTi.XML.Node;
  end;

  JText = class external(JTi.XML.CharacterData)
    function splitText(offset: Float): JTi.XML.Text;
  end;

  JNotation = class external(JTi.Proxy)
    publicId: String;
    systemId: String;
    function getPublicId: String;
    function getSystemId: String;
  end;

  JNodeList = class external(JTi.Proxy)
    _length: Float;
    function getLength: Float;
    function item(index: Float): JTi.XML.Node;
  end;

  JDocumentType = class external(JTi.XML.Node)
    entities: JTi.XML.NamedNodeMap;
    internalSubset: String;
    name: String;
    notations: JTi.XML.NamedNodeMap;
    publicId: String;
    systemId: String;
    function getEntities: JTi.XML.NamedNodeMap;
    function getInternalSubset: String;
    function getName: String;
    function getNotations: JTi.XML.NamedNodeMap;
    function getPublicId: String;
    function getSystemId: String;
  end;

  JElement = class external(JTi.XML.Node)
    tagName: String;
    function getAttribute(name: String): String;
    function getAttributeNS(namespaceURI: String; localName: String): String;
    function getAttributeNode(name: String): JTi.XML.Attr;
    function getAttributeNodeNS(namespaceURI: String; localName: String): JTi.XML.Attr;
    function getElementsByTagName(name: String): JTi.XML.NodeList;
    function getElementsByTagNameNS(namespaceURI: String; localName: String): JTi.XML.NodeList;
    function getTagName: String;
    function hasAttribute(name: String): Boolean;
    function hasAttributeNS(namespaceURI: String; localName: String): Boolean;
    procedure removeAttribute(name: String);
    procedure removeAttributeNS(namespaceURI: String; localName: String);
    procedure removeAttributeNode(oldAttr: JTi.XML.Attr);
    procedure setAttribute(name: String; value: String);
    procedure setAttributeNS(namespaceURI: String; qualifiedName: String; value: String);
    function setAttributeNode(newAttr: JTi.XML.Attr): JTi.XML.Attr;
    function setAttributeNodeNS(newAttr: JTi.XML.Attr): JTi.XML.Attr;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
function parseString(xml: String): JTi.XML.Document;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
function serializeToString(node: JTi.XML.Node): String;
procedure setBubbleParent(bubbleParent: Boolean);

var
  apiName: String;
  bubbleParent: Boolean;

//UI

type
  JTextArea = class external(JTi.UI.View)
    appearance: Float;
    attributedString: JTi.UI.iOS.AttributedString;
    autoLink: Float;
    autocapitalization: Float;
    autocorrect: Boolean;
    clearOnEdit: Boolean;
    color: String;
    editable: Boolean;
    ellipsize: Boolean;
    enableReturnKey: Boolean;
    font: JFont;
    handleLinks: Boolean;
    hintText: String;
    keyboardToolbar: Variant;
    keyboardToolbarColor: String;
    keyboardToolbarHeight: Float;
    keyboardType: Float;
    maxLength: Float;
    returnKeyType: Float;
    scrollable: Boolean;
    scrollsToTop: Boolean;
    selection: JtextAreaSelectedParams;
    suppressReturn: Boolean;
    textAlign: Variant;
    value: String;
    verticalAlign: Variant;
    procedure blur;
    procedure focus;
    function getAppearance: Float;
    function getAttributedString: JTi.UI.iOS.AttributedString;
    function getAutoLink: Float;
    function getAutocapitalization: Float;
    function getAutocorrect: Boolean;
    function getClearOnEdit: Boolean;
    function getColor: String;
    function getEditable: Boolean;
    function getEllipsize: Boolean;
    function getEnableReturnKey: Boolean;
    function getFont: JFont;
    function getHandleLinks: Boolean;
    function getHintText: String;
    function getKeyboardToolbar: Variant;
    function getKeyboardToolbarColor: String;
    function getKeyboardToolbarHeight: Float;
    function getKeyboardType: Float;
    function getMaxLength: Float;
    function getReturnKeyType: Float;
    function getScrollable: Boolean;
    function getScrollsToTop: Boolean;
    function getSelection: JtextAreaSelectedParams;
    function getSuppressReturn: Boolean;
    function getTextAlign: Variant;
    function getValue: String;
    function getVerticalAlign: Variant;
    function hasText: Boolean;
    procedure setAppearance(appearance: Float);
    procedure setAttributedString(attributedString: JTi.UI.iOS.AttributedString);
    procedure setAutoLink(autoLink: Float);
    procedure setAutocapitalization(autocapitalization: Float);
    procedure setAutocorrect(autocorrect: Boolean);
    procedure setClearOnEdit(clearOnEdit: Boolean);
    procedure setColor(color: String);
    procedure setEditable(editable: Boolean);
    procedure setEllipsize(ellipsize: Boolean);
    procedure setEnableReturnKey(enableReturnKey: Boolean);
    procedure setFont(font: JFont);
    procedure setHandleLinks(handleLinks: Boolean);
    procedure setHintText(hintText: String);
    procedure setKeyboardToolbar(keyboardToolbar: JArray{<JTi.UI.View>});
    procedure setKeyboardToolbar(keyboardToolbar: JTi.UI.iOS.Toolbar);
    procedure setKeyboardToolbarColor(keyboardToolbarColor: String);
    procedure setKeyboardToolbarHeight(keyboardToolbarHeight: Float);
    procedure setKeyboardType(keyboardType: Float);
    procedure setMaxLength(maxLength: Float);
    procedure setReturnKeyType(returnKeyType: Float);
    procedure setScrollable(scrollable: Boolean);
    procedure setScrollsToTop(scrollsToTop: Boolean);
    procedure setSelection(start: Float; &end: Float);
    procedure setSuppressReturn(suppressReturn: Boolean);
    procedure setTextAlign(textAlign: String);
    procedure setTextAlign(textAlign: Float);
    procedure setValue(value: String);
    procedure setVerticalAlign(verticalAlign: Float);
    procedure setVerticalAlign(verticalAlign: String);
  end;

  JView = class external(JTi.Proxy)
    accessibilityHidden: Boolean;
    accessibilityHint: String;
    accessibilityLabel: String;
    accessibilityValue: String;
    anchorPoint: JPoint;
    animatedCenter: JPoint;
    backgroundColor: String;
    backgroundDisabledColor: String;
    backgroundDisabledImage: String;
    backgroundFocusedColor: String;
    backgroundFocusedImage: String;
    backgroundGradient: JGradient;
    backgroundImage: String;
    backgroundLeftCap: Float;
    backgroundRepeat: Boolean;
    backgroundSelectedColor: String;
    backgroundSelectedImage: String;
    backgroundTopCap: Float;
    borderColor: String;
    borderRadius: Float;
    borderWidth: Float;
    bottom: Variant;
    center: JPoint;
    children: JArray{<JTi.UI.View>};
    clipMode: Float;
    enabled: Boolean;
    focusable: Boolean;
    height: Variant;
    horizontalWrap: Boolean;
    keepScreenOn: Boolean;
    layout: String;
    left: Variant;
    opacity: Float;
    overrideCurrentAnimation: Boolean;
    pullBackgroundColor: String;
    rect: JDimension;
    right: Variant;
    size: JDimension;
    softKeyboardOnFocus: Float;
    tintColor: Variant;
    top: Variant;
    touchEnabled: Boolean;
    transform: Variant;
    viewShadowColor: String;
    viewShadowOffset: JPoint;
    viewShadowRadius: Float;
    visible: Boolean;
    width: Variant;
    zIndex: Float;
    procedure add(view: JTi.UI.View);
    procedure animate(animation: JTi.UI.Animation; callback: (args: array of Variant): Variant);
    procedure animate(animation: JDictionary{<JTi.UI.Animation>}; callback: (args: array of Variant): Variant);
    function convertPointToView(point: JPoint; destinationView: JTi.UI.View): JPoint;
    procedure finishLayout;
    function getAccessibilityHidden: Boolean;
    function getAccessibilityHint: String;
    function getAccessibilityLabel: String;
    function getAccessibilityValue: String;
    function getAnchorPoint: JPoint;
    function getAnimatedCenter: JPoint;
    function getBackgroundColor: String;
    function getBackgroundDisabledColor: String;
    function getBackgroundDisabledImage: String;
    function getBackgroundFocusedColor: String;
    function getBackgroundFocusedImage: String;
    function getBackgroundGradient: JGradient;
    function getBackgroundImage: String;
    function getBackgroundLeftCap: Float;
    function getBackgroundRepeat: Boolean;
    function getBackgroundSelectedColor: String;
    function getBackgroundSelectedImage: String;
    function getBackgroundTopCap: Float;
    function getBorderColor: String;
    function getBorderRadius: Float;
    function getBorderWidth: Float;
    function getBottom: Variant;
    function getCenter: JPoint;
    function getChildren: JArray{<JTi.UI.View>};
    function getClipMode: Float;
    function getEnabled: Boolean;
    function getFocusable: Boolean;
    function getHeight: Variant;
    function getHorizontalWrap: Boolean;
    function getKeepScreenOn: Boolean;
    function getLayout: String;
    function getLeft: Variant;
    function getOpacity: Float;
    function getOverrideCurrentAnimation: Boolean;
    function getPullBackgroundColor: String;
    function getRect: JDimension;
    function getRight: Variant;
    function getSize: JDimension;
    function getSoftKeyboardOnFocus: Float;
    function getTintColor: String;
    function getTop: Variant;
    function getTouchEnabled: Boolean;
    function getTransform: Variant;
    function getViewShadowColor: String;
    function getViewShadowOffset: JPoint;
    function getViewShadowRadius: Float;
    function getVisible: Boolean;
    function getWidth: Variant;
    function getZIndex: Float;
    procedure hide;
    procedure remove(view: JTi.UI.View);
    procedure removeAllChildren;
    procedure setAccessibilityHidden(accessibilityHidden: Boolean);
    procedure setAccessibilityHint(accessibilityHint: String);
    procedure setAccessibilityLabel(accessibilityLabel: String);
    procedure setAccessibilityValue(accessibilityValue: String);
    procedure setAnchorPoint(anchorPoint: JPoint);
    procedure setBackgroundColor(backgroundColor: String);
    procedure setBackgroundDisabledColor(backgroundDisabledColor: String);
    procedure setBackgroundDisabledImage(backgroundDisabledImage: String);
    procedure setBackgroundFocusedColor(backgroundFocusedColor: String);
    procedure setBackgroundFocusedImage(backgroundFocusedImage: String);
    procedure setBackgroundGradient(backgroundGradient: JGradient);
    procedure setBackgroundImage(backgroundImage: String);
    procedure setBackgroundLeftCap(backgroundLeftCap: Float);
    procedure setBackgroundRepeat(backgroundRepeat: Boolean);
    procedure setBackgroundSelectedColor(backgroundSelectedColor: String);
    procedure setBackgroundSelectedImage(backgroundSelectedImage: String);
    procedure setBackgroundTopCap(backgroundTopCap: Float);
    procedure setBorderColor(borderColor: String);
    procedure setBorderRadius(borderRadius: Float);
    procedure setBorderWidth(borderWidth: Float);
    procedure setBottom(bottom: Float);
    procedure setBottom(bottom: String);
    procedure setCenter(center: JPoint);
    procedure setClipMode(clipMode: Float);
    procedure setEnabled(enabled: Boolean);
    procedure setFocusable(focusable: Boolean);
    procedure setHeight(height: Float);
    procedure setHeight(height: String);
    procedure setHorizontalWrap(horizontalWrap: Boolean);
    procedure setKeepScreenOn(keepScreenOn: Boolean);
    procedure setLayout(layout: String);
    procedure setLeft(left: Float);
    procedure setLeft(left: String);
    procedure setOpacity(opacity: Float);
    procedure setPullBackgroundColor(pullBackgroundColor: String);
    procedure setRight(right: Float);
    procedure setRight(right: String);
    procedure setSoftKeyboardOnFocus(softKeyboardOnFocus: Float);
    procedure setTintColor(tintColor: String);
    procedure setTop(top: Float);
    procedure setTop(top: String);
    procedure setTouchEnabled(touchEnabled: Boolean);
    procedure setTransform(transform: JTi.UI._2DMatrix);
    procedure setTransform(transform: JTi.UI._3DMatrix);
    procedure setViewShadowColor(viewShadowColor: String);
    procedure setViewShadowOffset(viewShadowOffset: JPoint);
    procedure setViewShadowRadius(viewShadowRadius: Float);
    procedure setVisible(visible: Boolean);
    procedure setWidth(width: Float);
    procedure setWidth(width: String);
    procedure setZIndex(zIndex: Float);
    procedure show;
    procedure startLayout;
    function toImage: JTi.Blob; overload;
    function toImage(callback: (args: array of Variant): Variant): JTi.Blob; overload;
    function toImage(callback: (args: array of Variant): Variant; honorScaleFactor: Boolean): JTi.Blob; overload;
    procedure updateLayout(params: JDictionary{<JObject>});
  end;

  JSwitch = class external(JTi.UI.View)
    color: String;
    font: JFont;
    onTintColor: String;
    style: Float;
    textAlign: Variant;
    thumbTintColor: String;
    tintColor: String;
    title: String;
    titleOff: String;
    titleOn: String;
    value: Boolean;
    verticalAlign: Variant;
    function getColor: String;
    function getFont: JFont;
    function getOnTintColor: String;
    function getStyle: Float;
    function getTextAlign: Variant;
    function getThumbTintColor: String;
    function getTitle: String;
    function getTitleOff: String;
    function getTitleOn: String;
    function getValue: Boolean;
    function getVerticalAlign: Variant;
    procedure setColor(color: String);
    procedure setFont(font: JFont);
    procedure setOnTintColor(onTintColor: String);
    procedure setStyle(style: Float);
    procedure setTextAlign(textAlign: String);
    procedure setTextAlign(textAlign: Float);
    procedure setThumbTintColor(thumbTintColor: String);
    procedure setTitle(title: String);
    procedure setTitleOff(titleOff: String);
    procedure setTitleOn(titleOn: String);
    procedure setValue(value: Boolean);
    procedure setVerticalAlign(verticalAlign: Float);
    procedure setVerticalAlign(verticalAlign: String);
  end;

  JDashboardItem = class external(JTi.Proxy)
    badge: Float;
    canDelete: Boolean;
    image: Variant;
    selectedImage: Variant;
    function getBadge: Float;
    function getCanDelete: Boolean;
    function getImage: Variant;
    function getSelectedImage: Variant;
    procedure setBadge(badge: Float);
    procedure setCanDelete(canDelete: Boolean);
    procedure setImage(image: String);
    procedure setImage(image: JTi.Blob);
    procedure setSelectedImage(selectedImage: String);
    procedure setSelectedImage(selectedImage: JTi.Blob);
  end;

  JTab = class external(JTi.UI.View)
    active: Boolean;
    activeIcon: String;
    activeIconIsMask: Variant;
    badge: String;
    icon: String;
    iconIsmask: Variant;
    title: String;
    titleid: String;
    window: JTi.UI.Window;
    procedure close(window: JTi.UI.Window); overload;
    procedure close(window: JTi.UI.Window; options: Variant); overload;
    function getActive: Boolean;
    function getActiveIcon: String;
    function getActiveIconIsMask: Boolean;
    function getBadge: String;
    function getIcon: String;
    function getIconIsmask: Boolean;
    function getTitle: String;
    function getTitleid: String;
    function getWindow: JTi.UI.Window;
    procedure open(window: JTi.UI.Window; options: Variant);
    procedure setActive(active: Boolean);
    procedure setActiveIcon(activeIcon: String);
    procedure setActiveIconIsMask(activeIconIsMask: Boolean);
    procedure setBadge(badge: String);
    procedure setIcon(icon: String);
    procedure setIconIsmask(iconIsmask: Boolean);
    procedure setTitle(title: String);
    procedure setTitleid(titleid: String);
    procedure setWindow(window: JTi.UI.Window);
  end;

  JTableViewRow = class external(JTi.UI.View)
    className: String;
    color: String;
    editable: Boolean;
    font: JFont;
    hasCheck: Boolean;
    hasChild: Boolean;
    hasDetail: Boolean;
    indentionLevel: Float;
    leftImage: String;
    moveable: Boolean;
    rightImage: String;
    selectedBackgroundColor: String;
    selectedBackgroundImage: String;
    selectedColor: String;
    selectionStyle: Float;
    title: String;
    function getClassName: String;
    function getColor: String;
    function getEditable: Boolean;
    function getFont: JFont;
    function getHasCheck: Boolean;
    function getHasChild: Boolean;
    function getHasDetail: Boolean;
    function getIndentionLevel: Float;
    function getLeftImage: String;
    function getMoveable: Boolean;
    function getRightImage: String;
    function getSelectedBackgroundColor: String;
    function getSelectedBackgroundImage: String;
    function getSelectedColor: String;
    function getSelectionStyle: Float;
    function getTitle: String;
    procedure setClassName(className: String);
    procedure setColor(color: String);
    procedure setEditable(editable: Boolean);
    procedure setFont(font: JFont);
    procedure setHasCheck(hasCheck: Boolean);
    procedure setHasChild(hasChild: Boolean);
    procedure setHasDetail(hasDetail: Boolean);
    procedure setIndentionLevel(indentionLevel: Float);
    procedure setLeftImage(leftImage: String);
    procedure setMoveable(moveable: Boolean);
    procedure setRightImage(rightImage: String);
    procedure setSelectedBackgroundColor(selectedBackgroundColor: String);
    procedure setSelectedBackgroundImage(selectedBackgroundImage: String);
    procedure setSelectedColor(selectedColor: String);
    procedure setSelectionStyle(selectionStyle: Float);
    procedure setTitle(title: String);
  end;

  JPickerRow = class external(JTi.UI.View)
    color: String;
    font: JFont;
    fontSize: Float;
    title: String;
    function getColor: String;
    function getFont: JFont;
    function getFontSize: Float;
    function getTitle: String;
    procedure setColor(color: String);
    procedure setFont(font: JFont);
    procedure setFontSize(fontSize: Float);
    procedure setTitle(title: String);
  end;

  JButtonBar = class external(JTi.UI.View)
    index: Float;
    labels: Variant;
    style: Float;
    function getIndex: Float;
    function getLabels: Variant;
    function getStyle: Float;
    procedure setIndex(index: Float);
    procedure setLabels(labels: JArray{<JString>});
    procedure setLabels(labels: JArray{<JBarItemType>});
    procedure setStyle(style: Float);
  end;

  JSlider = class external(JTi.UI.View)
    disabledLeftTrackImage: String;
    disabledRightTrackImage: String;
    disabledThumbImage: String;
    highlightedLeftTrackImage: String;
    highlightedRightTrackImage: String;
    highlightedThumbImage: String;
    leftTrackImage: String;
    leftTrackLeftCap: Float;
    leftTrackTopCap: Float;
    max: Float;
    maxRange: Float;
    min: Float;
    minRange: Float;
    rightTrackImage: String;
    rightTrackLeftCap: Float;
    rightTrackTopCap: Float;
    selectedLeftTrackImage: String;
    selectedRightTrackImage: String;
    selectedThumbImage: String;
    thumbImage: Variant;
    value: String;
    function getDisabledLeftTrackImage: String;
    function getDisabledRightTrackImage: String;
    function getDisabledThumbImage: String;
    function getHighlightedLeftTrackImage: String;
    function getHighlightedRightTrackImage: String;
    function getHighlightedThumbImage: String;
    function getLeftTrackImage: String;
    function getLeftTrackLeftCap: Float;
    function getLeftTrackTopCap: Float;
    function getMax: Float;
    function getMaxRange: Float;
    function getMin: Float;
    function getMinRange: Float;
    function getRightTrackImage: String;
    function getRightTrackLeftCap: Float;
    function getRightTrackTopCap: Float;
    function getSelectedLeftTrackImage: String;
    function getSelectedRightTrackImage: String;
    function getSelectedThumbImage: String;
    function getThumbImage: Variant;
    function getValue: String;
    procedure setDisabledLeftTrackImage(disabledLeftTrackImage: String);
    procedure setDisabledRightTrackImage(disabledRightTrackImage: String);
    procedure setDisabledThumbImage(disabledThumbImage: String);
    procedure setHighlightedLeftTrackImage(highlightedLeftTrackImage: String);
    procedure setHighlightedRightTrackImage(highlightedRightTrackImage: String);
    procedure setHighlightedThumbImage(highlightedThumbImage: String);
    procedure setLeftTrackImage(leftTrackImage: String);
    procedure setLeftTrackLeftCap(leftTrackLeftCap: Float);
    procedure setLeftTrackTopCap(leftTrackTopCap: Float);
    procedure setMax(max: Float);
    procedure setMaxRange(maxRange: Float);
    procedure setMin(min: Float);
    procedure setMinRange(minRange: Float);
    procedure setRightTrackImage(rightTrackImage: String);
    procedure setRightTrackLeftCap(rightTrackLeftCap: Float);
    procedure setRightTrackTopCap(rightTrackTopCap: Float);
    procedure setSelectedLeftTrackImage(selectedLeftTrackImage: String);
    procedure setSelectedRightTrackImage(selectedRightTrackImage: String);
    procedure setSelectedThumbImage(selectedThumbImage: String);
    procedure setThumbImage(thumbImage: String);
    procedure setThumbImage(thumbImage: JTi.Blob);
    procedure setValue(value: Float); overload;
    procedure setValue(value: Float; options: JDictionary{<JObject>}); overload;
  end;

  JDashboardView = class external(JTi.UI.View)
    columnCount: Float;
    data: JArray{<JTi.UI.DashboardItem>};
    editable: Boolean;
    rowCount: Float;
    wobble: Boolean;
    function getColumnCount: Float;
    function getData: JArray{<JTi.UI.DashboardItem>};
    function getEditable: Boolean;
    function getRowCount: Float;
    function getWobble: Boolean;
    procedure setData(data: JArray{<JTi.UI.DashboardItem>});
    procedure setEditable(editable: Boolean);
    procedure setWobble(wobble: Boolean);
    procedure startEditing;
    procedure stopEditing;
  end;

  JListItem = class external(JTi.Proxy)
    accessoryType: Float;
    backgroundColor: String;
    backgroundGradient: JGradient;
    backgroundImage: String;
    canEdit: Boolean;
    canMove: Boolean;
    color: String;
    font: JFont;
    height: Variant;
    image: String;
    itemId: String;
    searchableText: String;
    selectedBackgroundColor: String;
    selectedBackgroundGradient: JGradient;
    selectedBackgroundImage: String;
    selectionStyle: Float;
    subtitle: String;
    title: String;
  end;

  JAlertDialog = class external(JTi.Proxy)
    androidView: JTi.UI.View;
    buttonNames: JArray{<JString>};
    cancel: Float;
    message: String;
    messageid: String;
    ok: String;
    okid: String;
    persistent: Boolean;
    style: Float;
    title: String;
    titleid: String;
    function getAndroidView: JTi.UI.View;
    function getButtonNames: JArray{<JString>};
    function getCancel: Float;
    function getMessage: String;
    function getOk: String;
    function getPersistent: Boolean;
    function getStyle: Float;
    function getTitle: String;
    procedure hide;
    procedure setAndroidView(androidView: JTi.UI.View);
    procedure setCancel(cancel: Float);
    procedure setMessage(message: String);
    procedure setOk(ok: String);
    procedure setPersistent(persistent: Boolean);
    procedure setStyle(style: Float);
    procedure setTitle(title: String);
    procedure show;
  end;

  J_2DMatrix = class external(JTi.Proxy)
    a: Float;
    b: Float;
    c: Float;
    d: Float;
    tx: Float;
    ty: Float;
    function getA: Float;
    function getB: Float;
    function getC: Float;
    function getD: Float;
    function getTx: Float;
    function getTy: Float;
    function invert: JTi.UI._2DMatrix;
    function multiply(t2: JTi.UI._2DMatrix): JTi.UI._2DMatrix;
    function rotate(angle: Float): JTi.UI._2DMatrix; overload;
    function rotate(angle: Float; toAngle: Float): JTi.UI._2DMatrix; overload;
    function scale(sx: Float; sy: Float): JTi.UI._2DMatrix; overload;
    function scale(sx: Float; sy: Float; toSx: Float): JTi.UI._2DMatrix; overload;
    function scale(sx: Float; sy: Float; toSx: Float; toSy: Float): JTi.UI._2DMatrix; overload;
    procedure setA(a: Float);
    procedure setB(b: Float);
    procedure setC(c: Float);
    procedure setD(d: Float);
    procedure setTx(tx: Float);
    procedure setTy(ty: Float);
    function translate(tx: Float; ty: Float): JTi.UI._2DMatrix;
  end;

  JTabbedBar = class external(JTi.UI.View)
    index: Float;
    labels: Variant;
    style: Float;
    function getIndex: Float;
    function getLabels: Variant;
    function getStyle: Float;
    procedure setIndex(index: Float);
    procedure setLabels(labels: JArray{<JString>});
    procedure setLabels(labels: JArray{<JBarItemType>});
    procedure setStyle(style: Float);
  end;

  JWindow = class external(JTi.UI.View)
    activity: JTi.Android.Activity;
    autoAdjustScrollViewInsets: Boolean;
    backButtonTitle: String;
    backButtonTitleImage: Variant;
    barColor: String;
    barImage: String;
    exitOnClose: Boolean;
    extendEdges: JArray{<JNumber>};
    flagSecure: Boolean;
    fullscreen: Boolean;
    hideShadow: Boolean;
    includeOpaqueBars: Boolean;
    leftNavButton: JTi.UI.View;
    leftNavButtons: JArray{<JTi.UI.View>};
    modal: Boolean;
    navBarHidden: Boolean;
    navTintColor: Variant;
    orientation: Float;
    orientationModes: JArray{<JNumber>};
    rightNavButton: JTi.UI.View;
    rightNavButtons: JArray{<JTi.UI.View>};
    shadowImage: String;
    statusBarStyle: Variant;
    tabBarHidden: Boolean;
    theme: String;
    title: String;
    titleAttributes: JtitleAttributesParams;
    titleControl: JTi.UI.View;
    titleImage: String;
    titlePrompt: String;
    titleid: String;
    titlepromptid: String;
    toolbar: JArray{<JObject>};
    transitionAnimation: JTi.Proxy;
    translucent: Boolean;
    url: String;
    windowFlags: Float;
    windowPixelFormat: Float;
    windowSoftInputMode: Float;
    procedure close; overload;
    procedure close(params: JDictionary{<JTi.UI.Animation>}); overload;
    procedure close; overload;
    procedure close(params: JcloseWindowParams); overload;
    function getActivity: JTi.Android.Activity;
    function getAutoAdjustScrollViewInsets: Boolean;
    function getBackButtonTitle: String;
    function getBackButtonTitleImage: Variant;
    function getBarColor: String;
    function getBarImage: String;
    function getExitOnClose: Boolean;
    function getExtendEdges: JArray{<JNumber>};
    function getFlagSecure: Boolean;
    function getFullscreen: Boolean;
    function getHideShadow: Boolean;
    function getIncludeOpaqueBars: Boolean;
    function getLeftNavButton: JTi.UI.View;
    function getLeftNavButtons: JArray{<JTi.UI.View>};
    function getModal: Boolean;
    function getNavBarHidden: Boolean;
    function getNavTintColor: String;
    function getOrientation: Float;
    function getOrientationModes: JArray{<JNumber>};
    function getRightNavButton: JTi.UI.View;
    function getRightNavButtons: JArray{<JTi.UI.View>};
    function getShadowImage: String;
    function getStatusBarStyle: Float;
    function getTabBarHidden: Boolean;
    function getTheme: String;
    function getTitle: String;
    function getTitleAttributes: JtitleAttributesParams;
    function getTitleControl: JTi.UI.View;
    function getTitleImage: String;
    function getTitlePrompt: String;
    function getTitleid: String;
    function getTitlepromptid: String;
    function getToolbar: JArray{<JObject>};
    function getTransitionAnimation: JTi.Proxy;
    function getTranslucent: Boolean;
    function getUrl: String;
    function getWindowFlags: Float;
    function getWindowPixelFormat: Float;
    function getWindowSoftInputMode: Float;
    procedure hideNavBar; overload;
    procedure hideNavBar(options: JDictionary{<JObject>}); overload;
    procedure hideTabBar;
    procedure open; overload;
    procedure open(params: JopenWindowParams); overload;
    procedure setAutoAdjustScrollViewInsets(autoAdjustScrollViewInsets: Boolean);
    procedure setBackButtonTitle(backButtonTitle: String);
    procedure setBackButtonTitleImage(backButtonTitleImage: String);
    procedure setBackButtonTitleImage(backButtonTitleImage: JTi.Blob);
    procedure setBarColor(barColor: String);
    procedure setBarImage(barImage: String);
    procedure setExitOnClose(exitOnClose: Boolean);
    procedure setExtendEdges(extendEdges: JArray{<JNumber>});
    procedure setFullscreen(fullscreen: Boolean);
    procedure setHideShadow(hideShadow: Boolean);
    procedure setIncludeOpaqueBars(includeOpaqueBars: Boolean);
    procedure setLeftNavButton(leftNavButton: JTi.UI.View);
    procedure setLeftNavButtons(leftNavButtons: JArray{<JTi.UI.View>});
    procedure setModal(modal: Boolean);
    procedure setNavBarHidden(navBarHidden: Boolean);
    procedure setNavTintColor(navTintColor: String);
    procedure setOrientationModes(orientationModes: JArray{<JNumber>});
    procedure setRightNavButton(rightNavButton: JTi.UI.View);
    procedure setRightNavButtons(rightNavButtons: JArray{<JTi.UI.View>});
    procedure setShadowImage(shadowImage: String);
    procedure setStatusBarStyle(statusBarStyle: Float);
    procedure setTabBarHidden(tabBarHidden: Boolean);
    procedure setTitle(title: String);
    procedure setTitleAttributes(titleAttributes: JtitleAttributesParams);
    procedure setTitleControl(titleControl: JTi.UI.View);
    procedure setTitleImage(titleImage: String);
    procedure setTitlePrompt(titlePrompt: String);
    procedure setTitleid(titleid: String);
    procedure setTitlepromptid(titlepromptid: String);
    procedure setToolbar(items: JArray{<JObject>}); overload;
    procedure setToolbar(items: JArray{<JObject>}; params: JwindowToolbarParam); overload;
    procedure setTransitionAnimation(transitionAnimation: JTi.Proxy);
    procedure setTranslucent(translucent: Boolean);
    procedure setWindowPixelFormat(windowPixelFormat: Float);
    procedure showNavBar; overload;
    procedure showNavBar(options: JDictionary{<JObject>}); overload;
  end;

  JTextField = class external(JTi.UI.View)
    appearance: Float;
    attributedHintText: JTi.UI.iOS.AttributedString;
    attributedString: JTi.UI.iOS.AttributedString;
    autoLink: Float;
    autocapitalization: Float;
    autocorrect: Boolean;
    borderStyle: Float;
    clearButtonMode: Float;
    clearOnEdit: Boolean;
    color: String;
    editable: Boolean;
    ellipsize: Boolean;
    enableReturnKey: Boolean;
    font: JFont;
    hintText: String;
    keyboardToolbar: Variant;
    keyboardToolbarColor: String;
    keyboardToolbarHeight: Float;
    keyboardType: Float;
    leftButton: Variant;
    leftButtonMode: Float;
    leftButtonPadding: Float;
    maxLength: Float;
    minimumFontSize: Float;
    paddingLeft: Float;
    paddingRight: Float;
    passwordMask: Boolean;
    returnKeyType: Float;
    rightButton: Variant;
    rightButtonMode: Float;
    rightButtonPadding: Float;
    selection: JtextFieldSelectedParams;
    suppressReturn: Boolean;
    textAlign: Variant;
    value: String;
    verticalAlign: Variant;
    procedure blur;
    procedure focus;
    function getAppearance: Float;
    function getAttributedHintText: JTi.UI.iOS.AttributedString;
    function getAttributedString: JTi.UI.iOS.AttributedString;
    function getAutoLink: Float;
    function getAutocapitalization: Float;
    function getAutocorrect: Boolean;
    function getBorderStyle: Float;
    function getClearButtonMode: Float;
    function getClearOnEdit: Boolean;
    function getColor: String;
    function getEditable: Boolean;
    function getEllipsize: Boolean;
    function getEnableReturnKey: Boolean;
    function getFont: JFont;
    function getHintText: String;
    function getKeyboardToolbar: Variant;
    function getKeyboardToolbarColor: String;
    function getKeyboardToolbarHeight: Float;
    function getKeyboardType: Float;
    function getLeftButton: Variant;
    function getLeftButtonMode: Float;
    function getLeftButtonPadding: Float;
    function getMaxLength: Float;
    function getMinimumFontSize: Float;
    function getPaddingLeft: Float;
    function getPaddingRight: Float;
    function getPasswordMask: Boolean;
    function getReturnKeyType: Float;
    function getRightButton: Variant;
    function getRightButtonMode: Float;
    function getRightButtonPadding: Float;
    function getSelection: JtextFieldSelectedParams;
    function getSuppressReturn: Boolean;
    function getTextAlign: Variant;
    function getValue: String;
    function getVerticalAlign: Variant;
    function hasText: Boolean;
    procedure setAppearance(appearance: Float);
    procedure setAttributedHintText(attributedHintText: JTi.UI.iOS.AttributedString);
    procedure setAttributedString(attributedString: JTi.UI.iOS.AttributedString);
    procedure setAutoLink(autoLink: Float);
    procedure setAutocapitalization(autocapitalization: Float);
    procedure setAutocorrect(autocorrect: Boolean);
    procedure setBorderStyle(borderStyle: Float);
    procedure setClearButtonMode(clearButtonMode: Float);
    procedure setClearOnEdit(clearOnEdit: Boolean);
    procedure setColor(color: String);
    procedure setEditable(editable: Boolean);
    procedure setEllipsize(ellipsize: Boolean);
    procedure setEnableReturnKey(enableReturnKey: Boolean);
    procedure setFont(font: JFont);
    procedure setHintText(hintText: String);
    procedure setKeyboardToolbar(keyboardToolbar: JArray{<JTi.UI.View>});
    procedure setKeyboardToolbar(keyboardToolbar: JTi.UI.iOS.Toolbar);
    procedure setKeyboardToolbarColor(keyboardToolbarColor: String);
    procedure setKeyboardToolbarHeight(keyboardToolbarHeight: Float);
    procedure setKeyboardType(keyboardType: Float);
    procedure setLeftButton(leftButton: Variant);
    procedure setLeftButtonMode(leftButtonMode: Float);
    procedure setLeftButtonPadding(leftButtonPadding: Float);
    procedure setMaxLength(maxLength: Float);
    procedure setMinimumFontSize(minimumFontSize: Float);
    procedure setPaddingLeft(paddingLeft: Float);
    procedure setPaddingRight(paddingRight: Float);
    procedure setPasswordMask(passwordMask: Boolean);
    procedure setReturnKeyType(returnKeyType: Float);
    procedure setRightButton(rightButton: Variant);
    procedure setRightButtonMode(rightButtonMode: Float);
    procedure setRightButtonPadding(rightButtonPadding: Float);
    procedure setSelection(start: Float; &end: Float);
    procedure setSuppressReturn(suppressReturn: Boolean);
    procedure setTextAlign(textAlign: String);
    procedure setTextAlign(textAlign: Float);
    procedure setValue(value: String);
    procedure setVerticalAlign(verticalAlign: Float);
    procedure setVerticalAlign(verticalAlign: String);
  end;

  J_3DMatrix = class external(JTi.Proxy)
    m11: Float;
    m12: Float;
    m13: Float;
    m14: Float;
    m21: Float;
    m22: Float;
    m23: Float;
    m24: Float;
    m31: Float;
    m32: Float;
    m33: Float;
    m34: Float;
    m41: Float;
    m42: Float;
    m43: Float;
    m44: Float;
    function getM11: Float;
    function getM12: Float;
    function getM13: Float;
    function getM14: Float;
    function getM21: Float;
    function getM22: Float;
    function getM23: Float;
    function getM24: Float;
    function getM31: Float;
    function getM32: Float;
    function getM33: Float;
    function getM34: Float;
    function getM41: Float;
    function getM42: Float;
    function getM43: Float;
    function getM44: Float;
    function invert: JTi.UI._3DMatrix;
    function multiply(t2: JTi.UI._3DMatrix): JTi.UI._3DMatrix;
    function rotate(angle: Float; x: Float; y: Float; z: Float): JTi.UI._3DMatrix;
    function scale(sx: Float; sy: Float; sz: Float): JTi.UI._3DMatrix;
    procedure setM11(m11: Float);
    procedure setM12(m12: Float);
    procedure setM13(m13: Float);
    procedure setM14(m14: Float);
    procedure setM21(m21: Float);
    procedure setM22(m22: Float);
    procedure setM23(m23: Float);
    procedure setM24(m24: Float);
    procedure setM31(m31: Float);
    procedure setM32(m32: Float);
    procedure setM33(m33: Float);
    procedure setM34(m34: Float);
    procedure setM41(m41: Float);
    procedure setM42(m42: Float);
    procedure setM43(m43: Float);
    procedure setM44(m44: Float);
    function translate(tx: Float; ty: Float; tz: Float): JTi.UI._3DMatrix;
  end;

  JWebView = class external(JTi.UI.View)
    cacheMode: Float;
    data: Variant;
    disableBounce: Boolean;
    enableZoomControls: Boolean;
    handlePlatformUrl: Boolean;
    hideLoadIndicator: Boolean;
    html: String;
    ignoreSslError: Boolean;
    lightTouchEnabled: Boolean;
    loading: Boolean;
    onCreateWindow: (args: array of Variant): Variant;
    overScrollMode: Float;
    pluginState: Float;
    scalesPageToFit: Boolean;
    scrollsToTop: Boolean;
    showScrollbars: Boolean;
    url: String;
    userAgent: String;
    willHandleTouches: Boolean;
    function canGoBack: Boolean;
    function canGoForward: Boolean;
    function evalJS(code: String): String;
    function getCacheMode: Float;
    function getData: Variant;
    function getDisableBounce: Boolean;
    function getEnableZoomControls: Boolean;
    function getHandlePlatformUrl: Boolean;
    function getHideLoadIndicator: Boolean;
    function getHtml: String;
    function getIgnoreSslError: Boolean;
    function getLightTouchEnabled: Boolean;
    function getLoading: Boolean;
    function getOnCreateWindow: (args: array of Variant): Variant;
    function getOverScrollMode: Float;
    function getPluginState: Float;
    function getScalesPageToFit: Boolean;
    function getScrollsToTop: Boolean;
    function getShowScrollbars: Boolean;
    function getUrl: String;
    function getUserAgent: String;
    function getWillHandleTouches: Boolean;
    procedure goBack;
    procedure goForward;
    procedure pause;
    procedure release;
    procedure reload;
    procedure repaint;
    procedure resume;
    procedure setBasicAuthentication(username: String; password: String);
    procedure setCacheMode(cacheMode: Float);
    procedure setData(data: JTi.Blob);
    procedure setData(data: JTi.Filesystem.File);
    procedure setDisableBounce(disableBounce: Boolean);
    procedure setEnableZoomControls(enableZoomControls: Boolean);
    procedure setHandlePlatformUrl(handlePlatformUrl: Boolean);
    procedure setHideLoadIndicator(hideLoadIndicator: Boolean);
    procedure setHtml(html: Variant); overload;
    procedure setHtml(html: Variant; options: JDictionary{<JObject>}); overload;
    procedure setIgnoreSslError(ignoreSslError: Boolean);
    procedure setLightTouchEnabled(lightTouchEnabled: Boolean);
    procedure setLoading(loading: Boolean);
    procedure setOnCreateWindow(onCreateWindow: (args: array of Variant): Variant);
    procedure setOverScrollMode(overScrollMode: Float);
    procedure setPluginState(pluginState: Float);
    procedure setScalesPageToFit(scalesPageToFit: Boolean);
    procedure setScrollsToTop(scrollsToTop: Boolean);
    procedure setShowScrollbars(showScrollbars: Boolean);
    procedure setUrl(url: String);
    procedure setUserAgent(userAgent: String);
    procedure setWillHandleTouches(willHandleTouches: Boolean);
    procedure stopLoading(hardStop: Boolean);
  end;

  JClipboard = class external
    procedure clearData; overload;
    procedure clearData(&type: String); overload;
    procedure clearText;
    function getData(&type: String): Variant;
    function getText: String;
    function hasData(&type: String): Boolean;
    function hasText: Variant;
    procedure setData(&type: String; data: Variant);
    procedure setText(text: String);
  end;

  JScrollableView = class external(JTi.UI.View)
    cacheSize: Float;
    clipViews: Boolean;
    currentPage: Float;
    disableBounce: Boolean;
    hitRect: JDimension;
    overScrollMode: Float;
    overlayEnabled: Boolean;
    pagingControlAlpha: Float;
    pagingControlColor: String;
    pagingControlHeight: Float;
    pagingControlOnTop: Boolean;
    pagingControlTimeout: Float;
    scrollingEnabled: Boolean;
    showPagingControl: Boolean;
    views: JArray{<JTi.UI.View>};
    procedure addView(view: JTi.UI.View);
    function getCacheSize: Float;
    function getClipViews: Boolean;
    function getCurrentPage: Float;
    function getDisableBounce: Boolean;
    function getHitRect: JDimension;
    function getOverScrollMode: Float;
    function getOverlayEnabled: Boolean;
    function getPagingControlAlpha: Float;
    function getPagingControlColor: String;
    function getPagingControlHeight: Float;
    function getPagingControlOnTop: Boolean;
    function getPagingControlTimeout: Float;
    function getScrollingEnabled: Boolean;
    function getShowPagingControl: Boolean;
    function getViews: JArray{<JTi.UI.View>};
    procedure moveNext;
    procedure movePrevious;
    procedure removeView(view: Float);
    procedure removeView(view: JTi.UI.View);
    procedure scrollToView(view: Float);
    procedure scrollToView(view: JTi.UI.View);
    procedure setCacheSize(cacheSize: Float);
    procedure setCurrentPage(currentPage: Float);
    procedure setDisableBounce(disableBounce: Boolean);
    procedure setHitRect(hitRect: JDimension);
    procedure setOverScrollMode(overScrollMode: Float);
    procedure setOverlayEnabled(overlayEnabled: Boolean);
    procedure setPagingControlAlpha(pagingControlAlpha: Float);
    procedure setPagingControlColor(pagingControlColor: String);
    procedure setPagingControlHeight(pagingControlHeight: Float);
    procedure setPagingControlOnTop(pagingControlOnTop: Boolean);
    procedure setScrollingEnabled(scrollingEnabled: Boolean);
    procedure setShowPagingControl(showPagingControl: Boolean);
    procedure setViews(views: JArray{<JTi.UI.View>});
  end;

  JListSection = class external(JTi.Proxy)
    footerTitle: String;
    footerView: JTi.UI.View;
    headerTitle: String;
    headerView: JTi.UI.View;
    items: JArray{<JListDataItem>};
    procedure appendItems(dataItems: JArray{<JListDataItem>}); overload;
    procedure appendItems(dataItems: JArray{<JListDataItem>}; animation: JListViewAnimationProperties); overload;
    procedure deleteItemsAt(itemIndex: Float; count: Float); overload;
    procedure deleteItemsAt(itemIndex: Float; count: Float; animation: JListViewAnimationProperties); overload;
    function getFooterTitle: String;
    function getFooterView: JTi.UI.View;
    function getHeaderTitle: String;
    function getHeaderView: JTi.UI.View;
    function getItemAt(itemIndex: Float): JListDataItem;
    function getItems: JArray{<JListDataItem>};
    procedure insertItemsAt(itemIndex: Float; dataItems: JArray{<JListDataItem>}); overload;
    procedure insertItemsAt(itemIndex: Float; dataItems: JArray{<JListDataItem>}; animation: JListViewAnimationProperties); overload;
    procedure replaceItemsAt(index: Float; count: Float; dataItems: JArray{<JListDataItem>}); overload;
    procedure replaceItemsAt(index: Float; count: Float; dataItems: JArray{<JListDataItem>}; animation: JListViewAnimationProperties); overload;
    procedure setFooterTitle(footerTitle: String);
    procedure setFooterView(footerView: JTi.UI.View);
    procedure setHeaderTitle(headerTitle: String);
    procedure setHeaderView(headerView: JTi.UI.View);
    procedure setItems(dataItems: JArray{<JListDataItem>}); overload;
    procedure setItems(dataItems: JArray{<JListDataItem>}; animation: JListViewAnimationProperties); overload;
    procedure updateItemAt(index: Float; dataItem: JListDataItem); overload;
    procedure updateItemAt(index: Float; dataItem: JListDataItem; animation: JListViewAnimationProperties); overload;
  end;

  JScrollView = class external(JTi.UI.View)
    canCancelEvents: Boolean;
    contentHeight: Variant;
    contentOffset: JDictionary{<JObject>};
    contentWidth: Variant;
    decelerationRate: Float;
    disableBounce: Boolean;
    horizontalBounce: Boolean;
    maxZoomScale: Float;
    minZoomScale: Float;
    overScrollMode: Float;
    scrollIndicatorStyle: Float;
    scrollType: String;
    scrollingEnabled: Boolean;
    scrollsToTop: Boolean;
    showHorizontalScrollIndicator: Boolean;
    showVerticalScrollIndicator: Boolean;
    verticalBounce: Boolean;
    zoomScale: Float;
    function getCanCancelEvents: Boolean;
    function getContentHeight: Variant;
    function getContentOffset: JDictionary{<JObject>};
    function getContentWidth: Variant;
    function getDecelerationRate: Float;
    function getDisableBounce: Boolean;
    function getHorizontalBounce: Boolean;
    function getMaxZoomScale: Float;
    function getMinZoomScale: Float;
    function getOverScrollMode: Float;
    function getScrollIndicatorStyle: Float;
    function getScrollType: String;
    function getScrollingEnabled: Boolean;
    function getScrollsToTop: Boolean;
    function getShowHorizontalScrollIndicator: Boolean;
    function getShowVerticalScrollIndicator: Boolean;
    function getVerticalBounce: Boolean;
    function getZoomScale: Float;
    procedure scrollTo(x: Float; y: Float);
    procedure scrollToBottom;
    procedure setCanCancelEvents(canCancelEvents: Boolean);
    procedure setContentHeight(contentHeight: Float);
    procedure setContentHeight(contentHeight: String);
    procedure setContentOffset(contentOffset: JDictionary{<JObject>}); overload;
    procedure setContentOffset(contentOffset: JDictionary{<JObject>}; animated: JcontentOffsetOption); overload;
    procedure setContentWidth(contentWidth: Float);
    procedure setContentWidth(contentWidth: String);
    procedure setDecelerationRate(decelerationRate: Float);
    procedure setDisableBounce(disableBounce: Boolean);
    procedure setHorizontalBounce(horizontalBounce: Boolean);
    procedure setMaxZoomScale(maxZoomScale: Float);
    procedure setMinZoomScale(minZoomScale: Float);
    procedure setOverScrollMode(overScrollMode: Float);
    procedure setScrollIndicatorStyle(scrollIndicatorStyle: Float);
    procedure setScrollingEnabled(scrollingEnabled: Boolean);
    procedure setScrollsToTop(scrollsToTop: Boolean);
    procedure setShowHorizontalScrollIndicator(showHorizontalScrollIndicator: Boolean);
    procedure setShowVerticalScrollIndicator(showVerticalScrollIndicator: Boolean);
    procedure setVerticalBounce(verticalBounce: Boolean);
    procedure setZoomScale(zoomScale: Float); overload;
    procedure setZoomScale(zoomScale: Float; animated: JzoomScaleOption); overload;
  end;

  JListView = class external(JTi.UI.View)
    allowsSelection: Boolean;
    canScroll: Boolean;
    caseInsensitiveSearch: Boolean;
    defaultItemTemplate: Variant;
    editing: Boolean;
    footerDividersEnabled: Boolean;
    footerTitle: String;
    footerView: JTi.UI.View;
    headerDividersEnabled: Boolean;
    headerTitle: String;
    headerView: JTi.UI.View;
    keepSectionsInSearch: Boolean;
    pruneSectionsOnEdit: Boolean;
    pullView: JTi.UI.View;
    refreshControl: JTi.UI.RefreshControl;
    scrollIndicatorStyle: Float;
    searchText: String;
    searchView: Variant;
    sectionCount: Float;
    sectionIndexTitles: JArray{<JListViewIndexEntry>};
    sections: JArray{<JTi.UI.ListSection>};
    separatorColor: String;
    separatorInsets: JDictionary{<JObject>};
    separatorStyle: Float;
    showVerticalScrollIndicator: Boolean;
    style: Float;
    templates: JDictionary{<JObject>};
    willScrollOnStatusTap: Boolean;
    procedure appendSection(section: JTi.UI.ListSection); overload;
    procedure appendSection(section: JTi.UI.ListSection; animation: JListViewAnimationProperties); overload;
    procedure appendSection(section: JArray{<JTi.UI.ListSection>}); overload;
    procedure appendSection(section: JArray{<JTi.UI.ListSection>}; animation: JListViewAnimationProperties); overload;
    procedure deleteSectionAt(sectionIndex: Float); overload;
    procedure deleteSectionAt(sectionIndex: Float; animation: JListViewAnimationProperties); overload;
    procedure deselectItem(sectionIndex: Float; itemIndex: Float);
    function getAllowsSelection: Boolean;
    function getCanScroll: Boolean;
    function getCaseInsensitiveSearch: Boolean;
    function getDefaultItemTemplate: Variant;
    function getEditing: Boolean;
    function getFooterDividersEnabled: Boolean;
    function getFooterTitle: String;
    function getFooterView: JTi.UI.View;
    function getHeaderDividersEnabled: Boolean;
    function getHeaderTitle: String;
    function getHeaderView: JTi.UI.View;
    function getKeepSectionsInSearch: Boolean;
    function getPruneSectionsOnEdit: Boolean;
    function getPullView: JTi.UI.View;
    function getRefreshControl: JTi.UI.RefreshControl;
    function getScrollIndicatorStyle: Float;
    function getSearchText: String;
    function getSearchView: Variant;
    function getSectionCount: Float;
    function getSectionIndexTitles: JArray{<JListViewIndexEntry>};
    function getSections: JArray{<JTi.UI.ListSection>};
    function getSeparatorColor: String;
    function getSeparatorInsets: JDictionary{<JObject>};
    function getSeparatorStyle: Float;
    function getShowVerticalScrollIndicator: Boolean;
    function getStyle: Float;
    function getTemplates: JDictionary{<JObject>};
    function getWillScrollOnStatusTap: Boolean;
    procedure insertSectionAt(sectionIndex: Float; section: JTi.UI.ListSection); overload;
    procedure insertSectionAt(sectionIndex: Float; section: JTi.UI.ListSection; animation: JListViewAnimationProperties); overload;
    procedure insertSectionAt(sectionIndex: Float; section: JArray{<JTi.UI.ListSection>}); overload;
    procedure insertSectionAt(sectionIndex: Float; section: JArray{<JTi.UI.ListSection>}; animation: JListViewAnimationProperties); overload;
    procedure replaceSectionAt(sectionIndex: Float; section: JTi.UI.ListSection; animation: JListViewAnimationProperties);
    procedure scrollToItem(sectionIndex: Float; itemIndex: Float); overload;
    procedure scrollToItem(sectionIndex: Float; itemIndex: Float; animation: JListViewAnimationProperties); overload;
    procedure selectItem(sectionIndex: Float; itemIndex: Float);
    procedure setAllowsSelection(allowsSelection: Boolean);
    procedure setCanScroll(canScroll: Boolean);
    procedure setCaseInsensitiveSearch(caseInsensitiveSearch: Boolean);
    procedure setContentInsets(edgeInsets: JListViewEdgeInsets); overload;
    procedure setContentInsets(edgeInsets: JListViewEdgeInsets; animated: JListViewContentInsetOption); overload;
    procedure setDefaultItemTemplate(defaultItemTemplate: String);
    procedure setDefaultItemTemplate(defaultItemTemplate: Float);
    procedure setEditing(editing: Boolean);
    procedure setFooterTitle(footerTitle: String);
    procedure setFooterView(footerView: JTi.UI.View);
    procedure setHeaderTitle(headerTitle: String);
    procedure setHeaderView(headerView: JTi.UI.View);
    procedure setKeepSectionsInSearch(keepSectionsInSearch: Boolean);
    procedure setMarker(markerProps: JListViewMarkerProps);
    procedure setPruneSectionsOnEdit(pruneSectionsOnEdit: Boolean);
    procedure setPullView(pullView: JTi.UI.View);
    procedure setRefreshControl(refreshControl: JTi.UI.RefreshControl);
    procedure setScrollIndicatorStyle(scrollIndicatorStyle: Float);
    procedure setSearchText(searchText: String);
    procedure setSearchView(searchView: JTi.UI.SearchBar);
    procedure setSearchView(searchView: JTi.UI.Android.SearchView);
    procedure setSectionIndexTitles(sectionIndexTitles: JArray{<JListViewIndexEntry>});
    procedure setSections(sections: JArray{<JTi.UI.ListSection>});
    procedure setSeparatorColor(separatorColor: String);
    procedure setSeparatorInsets(separatorInsets: JDictionary{<JObject>});
    procedure setSeparatorStyle(separatorStyle: Float);
    procedure setShowVerticalScrollIndicator(showVerticalScrollIndicator: Boolean);
    procedure setWillScrollOnStatusTap(willScrollOnStatusTap: Boolean);
  end;

  JTabGroup = class external(JTi.UI.View)
    activeTab: JTi.UI.Tab;
    activeTabBackgroundColor: String;
    activeTabBackgroundDisabledColor: String;
    activeTabBackgroundDisabledImage: String;
    activeTabBackgroundFocusedColor: String;
    activeTabBackgroundFocusedImage: String;
    activeTabBackgroundImage: String;
    activeTabBackgroundSelectedColor: String;
    activeTabBackgroundSelectedImage: String;
    activeTabIconTint: String;
    activity: JTi.Android.Activity;
    allowUserCustomization: Boolean;
    barColor: String;
    editButtonTitle: String;
    exitOnClose: Boolean;
    navBarHidden: Boolean;
    navTintColor: Variant;
    shadowImage: String;
    tabDividerColor: String;
    tabDividerWidth: Variant;
    tabHeight: Variant;
    tabs: JArray{<JTi.UI.Tab>};
    tabsAtBottom: Boolean;
    tabsBackgroundColor: String;
    tabsBackgroundDisabledColor: String;
    tabsBackgroundDisabledImage: String;
    tabsBackgroundFocusedColor: String;
    tabsBackgroundFocusedImage: String;
    tabsBackgroundImage: String;
    tabsBackgroundSelectedColor: String;
    tabsBackgroundSelectedImage: String;
    tabsTintColor: Variant;
    title: String;
    titleAttributes: JtitleAttributesParams;
    translucent: Boolean;
    windowSoftInputMode: Float;
    procedure addTab(tab: JTi.UI.Tab);
    procedure close;
    function getActiveTab: JTi.UI.Tab;
    function getActiveTabBackgroundColor: String;
    function getActiveTabBackgroundDisabledColor: String;
    function getActiveTabBackgroundDisabledImage: String;
    function getActiveTabBackgroundFocusedColor: String;
    function getActiveTabBackgroundFocusedImage: String;
    function getActiveTabBackgroundImage: String;
    function getActiveTabBackgroundSelectedColor: String;
    function getActiveTabBackgroundSelectedImage: String;
    function getActiveTabIconTint: String;
    function getActivity: JTi.Android.Activity;
    function getAllowUserCustomization: Boolean;
    function getBarColor: String;
    function getEditButtonTitle: String;
    function getExitOnClose: Boolean;
    function getNavBarHidden: Boolean;
    function getNavTintColor: String;
    function getShadowImage: String;
    function getTabDividerColor: String;
    function getTabDividerWidth: Variant;
    function getTabHeight: Variant;
    function getTabs: JArray{<JTi.UI.Tab>};
    function getTabsAtBottom: Boolean;
    function getTabsBackgroundColor: String;
    function getTabsBackgroundDisabledColor: String;
    function getTabsBackgroundDisabledImage: String;
    function getTabsBackgroundFocusedColor: String;
    function getTabsBackgroundFocusedImage: String;
    function getTabsBackgroundImage: String;
    function getTabsBackgroundSelectedColor: String;
    function getTabsBackgroundSelectedImage: String;
    function getTabsTintColor: String;
    function getTitle: String;
    function getTitleAttributes: JtitleAttributesParams;
    function getTranslucent: Boolean;
    function getWindowSoftInputMode: Float;
    procedure open;
    procedure removeTab(tab: JTi.UI.Tab);
    procedure setActiveTab(indexOrObject: Float);
    procedure setActiveTab(indexOrObject: JTi.UI.Tab);
    procedure setActiveTabBackgroundColor(activeTabBackgroundColor: String);
    procedure setActiveTabBackgroundDisabledColor(activeTabBackgroundDisabledColor: String);
    procedure setActiveTabBackgroundDisabledImage(activeTabBackgroundDisabledImage: String);
    procedure setActiveTabBackgroundFocusedColor(activeTabBackgroundFocusedColor: String);
    procedure setActiveTabBackgroundFocusedImage(activeTabBackgroundFocusedImage: String);
    procedure setActiveTabBackgroundImage(activeTabBackgroundImage: String);
    procedure setActiveTabBackgroundSelectedColor(activeTabBackgroundSelectedColor: String);
    procedure setActiveTabBackgroundSelectedImage(activeTabBackgroundSelectedImage: String);
    procedure setActiveTabIconTint(activeTabIconTint: String);
    procedure setAllowUserCustomization(allowUserCustomization: Boolean);
    procedure setBarColor(barColor: String);
    procedure setEditButtonTitle(editButtonTitle: String);
    procedure setExitOnClose(exitOnClose: Boolean);
    procedure setNavBarHidden(navBarHidden: Boolean);
    procedure setNavTintColor(navTintColor: String);
    procedure setShadowImage(shadowImage: String);
    procedure setTabDividerColor(tabDividerColor: String);
    procedure setTabDividerWidth(tabDividerWidth: Float);
    procedure setTabDividerWidth(tabDividerWidth: String);
    procedure setTabHeight(tabHeight: Float);
    procedure setTabHeight(tabHeight: String);
    procedure setTabs(tabs: JArray{<JTi.UI.Tab>});
    procedure setTabsAtBottom(tabsAtBottom: Boolean);
    procedure setTabsBackgroundColor(tabsBackgroundColor: String);
    procedure setTabsBackgroundDisabledColor(tabsBackgroundDisabledColor: String);
    procedure setTabsBackgroundDisabledImage(tabsBackgroundDisabledImage: String);
    procedure setTabsBackgroundFocusedColor(tabsBackgroundFocusedColor: String);
    procedure setTabsBackgroundFocusedImage(tabsBackgroundFocusedImage: String);
    procedure setTabsBackgroundImage(tabsBackgroundImage: String);
    procedure setTabsBackgroundSelectedColor(tabsBackgroundSelectedColor: String);
    procedure setTabsBackgroundSelectedImage(tabsBackgroundSelectedImage: String);
    procedure setTabsTintColor(tabsTintColor: String);
    procedure setTitle(title: String);
    procedure setTitleAttributes(titleAttributes: JtitleAttributesParams);
    procedure setTranslucent(translucent: Boolean);
  end;

  JTableView = class external(JTi.UI.View)
    allowsSelection: Boolean;
    allowsSelectionDuringEditing: Boolean;
    data: Variant;
    editable: Boolean;
    editing: Boolean;
    filterAnchored: Boolean;
    filterAttribute: String;
    filterCaseInsensitive: Boolean;
    footerDividersEnabled: Boolean;
    footerTitle: String;
    footerView: JTi.UI.View;
    headerDividersEnabled: Boolean;
    headerPullView: JTi.UI.View;
    headerTitle: String;
    headerView: JTi.UI.View;
    hideSearchOnSelection: Boolean;
    index: JArray{<JTableViewIndexEntry>};
    maxRowHeight: Float;
    minRowHeight: Float;
    moveable: Boolean;
    moving: Boolean;
    overScrollMode: Float;
    refreshControl: JTi.UI.RefreshControl;
    rowHeight: Float;
    scrollIndicatorStyle: Float;
    scrollable: Boolean;
    scrollsToTop: Boolean;
    search: Variant;
    searchAsChild: Boolean;
    searchHidden: Boolean;
    sectionCount: Float;
    sections: JArray{<JTi.UI.TableViewSection>};
    separatorColor: String;
    separatorInsets: JDictionary{<JObject>};
    separatorStyle: Float;
    showVerticalScrollIndicator: Boolean;
    style: Float;
    procedure appendRow(row: JTi.UI.TableViewRow); overload;
    procedure appendRow(row: JTi.UI.TableViewRow; animation: JTableViewAnimationProperties); overload;
    procedure appendRow(row: JDictionary{<JTi.UI.TableViewRow>}); overload;
    procedure appendRow(row: JDictionary{<JTi.UI.TableViewRow>}; animation: JTableViewAnimationProperties); overload;
    procedure appendRow(row: JArray{<JTi.UI.TableViewRow>}); overload;
    procedure appendRow(row: JArray{<JTi.UI.TableViewRow>}; animation: JTableViewAnimationProperties); overload;
    procedure appendRow(row: JArray{<JDictionary{<JTi.UI.TableViewRow>}>}); overload;
    procedure appendRow(row: JArray{<JDictionary{<JTi.UI.TableViewRow>}>}; animation: JTableViewAnimationProperties); overload;
    procedure appendSection(section: JTi.UI.TableViewSection); overload;
    procedure appendSection(section: JTi.UI.TableViewSection; animation: JTableViewAnimationProperties); overload;
    procedure appendSection(section: JDictionary{<JTi.UI.TableViewSection>}); overload;
    procedure appendSection(section: JDictionary{<JTi.UI.TableViewSection>}; animation: JTableViewAnimationProperties); overload;
    procedure appendSection(section: JArray{<JTi.UI.TableViewSection>}); overload;
    procedure appendSection(section: JArray{<JTi.UI.TableViewSection>}; animation: JTableViewAnimationProperties); overload;
    procedure appendSection(section: JArray{<JDictionary{<JTi.UI.TableViewSection>}>}); overload;
    procedure appendSection(section: JArray{<JDictionary{<JTi.UI.TableViewSection>}>}; animation: JTableViewAnimationProperties); overload;
    procedure deleteRow(row: Float); overload;
    procedure deleteRow(row: Float; animation: JTableViewAnimationProperties); overload;
    procedure deleteRow(row: JTi.UI.TableViewRow); overload;
    procedure deleteRow(row: JTi.UI.TableViewRow; animation: JTableViewAnimationProperties); overload;
    procedure deleteSection(section: Float); overload;
    procedure deleteSection(section: Float; animation: JTableViewAnimationProperties); overload;
    procedure deselectRow(row: Float);
    function getAllowsSelection: Boolean;
    function getAllowsSelectionDuringEditing: Boolean;
    function getData: Variant;
    function getEditable: Boolean;
    function getEditing: Boolean;
    function getFilterAnchored: Boolean;
    function getFilterAttribute: String;
    function getFilterCaseInsensitive: Boolean;
    function getFooterDividersEnabled: Boolean;
    function getFooterTitle: String;
    function getFooterView: JTi.UI.View;
    function getHeaderDividersEnabled: Boolean;
    function getHeaderPullView: JTi.UI.View;
    function getHeaderTitle: String;
    function getHeaderView: JTi.UI.View;
    function getHideSearchOnSelection: Boolean;
    function getIndex: JArray{<JTableViewIndexEntry>};
    function getMaxRowHeight: Float;
    function getMinRowHeight: Float;
    function getMoveable: Boolean;
    function getMoving: Boolean;
    function getOverScrollMode: Float;
    function getRefreshControl: JTi.UI.RefreshControl;
    function getRowHeight: Float;
    function getScrollIndicatorStyle: Float;
    function getScrollable: Boolean;
    function getScrollsToTop: Boolean;
    function getSearch: Variant;
    function getSearchAsChild: Boolean;
    function getSearchHidden: Boolean;
    function getSectionCount: Float;
    function getSections: JArray{<JTi.UI.TableViewSection>};
    function getSeparatorColor: String;
    function getSeparatorInsets: JDictionary{<JObject>};
    function getSeparatorStyle: Float;
    function getShowVerticalScrollIndicator: Boolean;
    function getStyle: Float;
    procedure insertRowAfter(index: Float; row: JTi.UI.TableViewRow); overload;
    procedure insertRowAfter(index: Float; row: JTi.UI.TableViewRow; animation: JTableViewAnimationProperties); overload;
    procedure insertRowAfter(index: Float; row: JDictionary{<JTi.UI.TableViewRow>}); overload;
    procedure insertRowAfter(index: Float; row: JDictionary{<JTi.UI.TableViewRow>}; animation: JTableViewAnimationProperties); overload;
    procedure insertRowBefore(index: Float; row: JTi.UI.TableViewRow); overload;
    procedure insertRowBefore(index: Float; row: JTi.UI.TableViewRow; animation: JTableViewAnimationProperties); overload;
    procedure insertRowBefore(index: Float; row: JDictionary{<JTi.UI.TableViewRow>}); overload;
    procedure insertRowBefore(index: Float; row: JDictionary{<JTi.UI.TableViewRow>}; animation: JTableViewAnimationProperties); overload;
    procedure insertSectionAfter(index: Float; section: JTi.UI.TableViewSection); overload;
    procedure insertSectionAfter(index: Float; section: JTi.UI.TableViewSection; animation: JTableViewAnimationProperties); overload;
    procedure insertSectionAfter(index: Float; section: JDictionary{<JTi.UI.TableViewSection>}); overload;
    procedure insertSectionAfter(index: Float; section: JDictionary{<JTi.UI.TableViewSection>}; animation: JTableViewAnimationProperties); overload;
    procedure insertSectionBefore(index: Float; section: JTi.UI.TableViewSection); overload;
    procedure insertSectionBefore(index: Float; section: JTi.UI.TableViewSection; animation: JTableViewAnimationProperties); overload;
    procedure insertSectionBefore(index: Float; section: JDictionary{<JTi.UI.TableViewSection>}); overload;
    procedure insertSectionBefore(index: Float; section: JDictionary{<JTi.UI.TableViewSection>}; animation: JTableViewAnimationProperties); overload;
    procedure scrollToIndex(index: Float); overload;
    procedure scrollToIndex(index: Float; animation: JTableViewAnimationProperties); overload;
    procedure scrollToTop(top: Float); overload;
    procedure scrollToTop(top: Float; animation: JTableViewAnimationProperties); overload;
    procedure selectRow(row: Float);
    procedure setAllowsSelection(allowsSelection: Boolean);
    procedure setAllowsSelectionDuringEditing(allowsSelectionDuringEditing: Boolean);
    procedure setContentInsets(edgeInsets: JTableViewEdgeInsets); overload;
    procedure setContentInsets(edgeInsets: JTableViewEdgeInsets; animated: JTableViewContentInsetOption); overload;
    procedure setData(data: JArray{<JTi.UI.TableViewRow>}; animation: JTableViewAnimationProperties);
    procedure setData(data: JArray{<JDictionary{<JTi.UI.TableViewRow>}>}; animation: JTableViewAnimationProperties);
    procedure setData(data: JArray{<JTi.UI.TableViewSection>}; animation: JTableViewAnimationProperties);
    procedure setEditable(editable: Boolean);
    procedure setEditing(editing: Boolean);
    procedure setFilterAnchored(filterAnchored: Boolean);
    procedure setFilterAttribute(filterAttribute: String);
    procedure setFilterCaseInsensitive(filterCaseInsensitive: Boolean);
    procedure setFooterTitle(footerTitle: String);
    procedure setFooterView(footerView: JTi.UI.View);
    procedure setHeaderPullView(view: JTi.UI.View);
    procedure setHeaderTitle(headerTitle: String);
    procedure setHeaderView(headerView: JTi.UI.View);
    procedure setHideSearchOnSelection(hideSearchOnSelection: Boolean);
    procedure setIndex(index: JArray{<JTableViewIndexEntry>});
    procedure setMaxRowHeight(maxRowHeight: Float);
    procedure setMinRowHeight(minRowHeight: Float);
    procedure setMoveable(moveable: Boolean);
    procedure setMoving(moving: Boolean);
    procedure setOverScrollMode(overScrollMode: Float);
    procedure setRefreshControl(refreshControl: JTi.UI.RefreshControl);
    procedure setRowHeight(rowHeight: Float);
    procedure setScrollIndicatorStyle(scrollIndicatorStyle: Float);
    procedure setScrollable(scrollable: Boolean);
    procedure setScrollsToTop(scrollsToTop: Boolean);
    procedure setSearch(search: JTi.UI.SearchBar);
    procedure setSearch(search: JTi.UI.Android.SearchView);
    procedure setSearchAsChild(searchAsChild: Boolean);
    procedure setSearchHidden(searchHidden: Boolean);
    procedure setSections(sections: JArray{<JTi.UI.TableViewSection>});
    procedure setSeparatorColor(separatorColor: String);
    procedure setSeparatorInsets(separatorInsets: JDictionary{<JObject>});
    procedure setSeparatorStyle(separatorStyle: Float);
    procedure setShowVerticalScrollIndicator(showVerticalScrollIndicator: Boolean);
    procedure setStyle(style: Float);
    procedure updateRow(index: Float; row: JTi.UI.TableViewRow; animation: JTableViewAnimationProperties);
    procedure updateSection(index: Float; section: JTi.UI.TableViewSection; animation: JTableViewAnimationProperties);
  end;

  JButton = class external(JTi.UI.View)
    color: String;
    disabledColor: String;
    font: JFont;
    image: Variant;
    selectedColor: String;
    shadowColor: String;
    shadowOffset: JDictionary{<JObject>};
    shadowRadius: Float;
    style: Float;
    systemButton: Float;
    textAlign: Variant;
    title: String;
    titleid: String;
    verticalAlign: Variant;
    function getColor: String;
    function getDisabledColor: String;
    function getFont: JFont;
    function getImage: Variant;
    function getSelectedColor: String;
    function getShadowColor: String;
    function getShadowOffset: JDictionary{<JObject>};
    function getShadowRadius: Float;
    function getStyle: Float;
    function getSystemButton: Float;
    function getTextAlign: Variant;
    function getTitle: String;
    function getTitleid: String;
    function getVerticalAlign: Variant;
    procedure setColor(color: String);
    procedure setDisabledColor(disabledColor: String);
    procedure setFont(font: JFont);
    procedure setImage(image: String);
    procedure setImage(image: JTi.Blob);
    procedure setSelectedColor(selectedColor: String);
    procedure setShadowColor(shadowColor: String);
    procedure setShadowOffset(shadowOffset: JDictionary{<JObject>});
    procedure setShadowRadius(shadowRadius: Float);
    procedure setStyle(style: Float);
    procedure setSystemButton(systemButton: Float);
    procedure setTextAlign(textAlign: String);
    procedure setTextAlign(textAlign: Float);
    procedure setTitle(title: String);
    procedure setTitleid(titleid: String);
    procedure setVerticalAlign(verticalAlign: Float);
    procedure setVerticalAlign(verticalAlign: String);
  end;

  JOptionDialog = class external(JTi.Proxy)
    androidView: JTi.UI.View;
    buttonNames: JArray{<JString>};
    cancel: Float;
    destructive: Float;
    opaquebackground: Boolean;
    options: JArray{<JString>};
    persistent: Boolean;
    selectedIndex: Float;
    title: String;
    titleid: String;
    function getAndroidView: JTi.UI.View;
    function getButtonNames: JArray{<JString>};
    function getCancel: Float;
    function getDestructive: Float;
    function getOpaquebackground: Boolean;
    function getOptions: JArray{<JString>};
    function getPersistent: Boolean;
    function getSelectedIndex: Float;
    function getTitle: String;
    function getTitleid: String;
    procedure hide; overload;
    procedure hide(params: JhideParams); overload;
    procedure setAndroidView(androidView: JTi.UI.View);
    procedure setCancel(cancel: Float);
    procedure setOpaquebackground(opaquebackground: Boolean);
    procedure setPersistent(persistent: Boolean);
    procedure setTitle(title: String);
    procedure setTitleid(titleid: String);
    procedure show; overload;
    procedure show(params: JshowParams); overload;
  end;

  JRefreshControl = class external(JTi.Proxy)
    tintColor: String;
    title: JTi.UI.iOS.AttributedString;
    procedure beginRefreshing;
    procedure endRefreshing;
    function getTintColor: String;
    function getTitle: JTi.UI.iOS.AttributedString;
    procedure setTintColor(tintColor: String);
    procedure setTitle(title: JTi.UI.iOS.AttributedString);
  end;

  JEmailDialog = class external(JTi.Proxy)
    CANCELLED: Float;
    FAILED: Float;
    SAVED: Float;
    SENT: Float;
    barColor: String;
    bccRecipients: JArray{<JString>};
    ccRecipients: JArray{<JString>};
    html: Boolean;
    messageBody: String;
    subject: String;
    toRecipients: JArray{<JString>};
    procedure addAttachment(attachment: JTi.Blob);
    procedure addAttachment(attachment: JTi.Filesystem.File);
    function getBarColor: String;
    function getBccRecipients: JArray{<JString>};
    function getCcRecipients: JArray{<JString>};
    function getHtml: Boolean;
    function getMessageBody: String;
    function getSubject: String;
    function getToRecipients: JArray{<JString>};
    function isSupported: Boolean;
    procedure open(properties: Variant);
    procedure setBarColor(barColor: String);
    procedure setBccRecipients(bccRecipients: JArray{<JString>});
    procedure setCcRecipients(ccRecipients: JArray{<JString>});
    procedure setHtml(html: Boolean);
    procedure setMessageBody(messageBody: String);
    procedure setSubject(subject: String);
    procedure setToRecipients(toRecipients: JArray{<JString>});
  end;

  JCoverFlowView = class external(JTi.UI.View)
    images: Variant;
    selected: Float;
    function getImages: Variant;
    function getSelected: Float;
    procedure setImage(index: Float; image: String);
    procedure setImage(image: JTi.Blob);
    procedure setImage(image: JTi.Filesystem.File);
    procedure setImage(index: Float; image: JCoverFlowImageType);
    procedure setImages(images: JArray{<JString>});
    procedure setImages(images: JArray{<JTi.Blob>});
    procedure setImages(images: JArray{<JTi.Filesystem.File>});
    procedure setImages(images: JArray{<JCoverFlowImageType>});
    procedure setSelected(selected: Float);
  end;

  JImageView = class external(JTi.UI.View)
    animating: Boolean;
    autorotate: Boolean;
    decodeRetries: Float;
    defaultImage: String;
    duration: Float;
    enableZoomControls: Boolean;
    hires: Boolean;
    image: Variant;
    images: Variant;
    paused: Boolean;
    preventDefaultImage: Boolean;
    repeatCount: Float;
    reverse: Boolean;
    url: String;
    function getAnimating: Boolean;
    function getAutorotate: Boolean;
    function getDecodeRetries: Float;
    function getDefaultImage: String;
    function getDuration: Float;
    function getEnableZoomControls: Boolean;
    function getHires: Boolean;
    function getImage: Variant;
    function getImages: Variant;
    function getPaused: Boolean;
    function getPreventDefaultImage: Boolean;
    function getRepeatCount: Float;
    function getReverse: Boolean;
    function getUrl: String;
    procedure pause;
    procedure resume;
    procedure setDecodeRetries(decodeRetries: Float);
    procedure setDefaultImage(defaultImage: String);
    procedure setDuration(duration: Float);
    procedure setEnableZoomControls(enableZoomControls: Boolean);
    procedure setHires(hires: Boolean);
    procedure setImage(image: String);
    procedure setImage(image: JTi.Blob);
    procedure setImage(image: JTi.Filesystem.File);
    procedure setImages(images: JArray{<JString>});
    procedure setImages(images: JArray{<JTi.Blob>});
    procedure setImages(images: JArray{<JTi.Filesystem.File>});
    procedure setPreventDefaultImage(preventDefaultImage: Boolean);
    procedure setRepeatCount(repeatCount: Float);
    procedure setReverse(reverse: Boolean);
    procedure setUrl(url: String);
    procedure start;
    procedure stop;
    procedure toBlob;
  end;

  JMaskedImage = class external(JTi.UI.View)
    image: String;
    mask: String;
    mode: Float;
    tint: String;
    function getImage: String;
    function getMask: String;
    function getMode: Float;
    function getTint: String;
    procedure setImage(image: String);
    procedure setMask(mask: String);
    procedure setMode(mode: Float);
    procedure setTint(tint: String);
  end;

  JProgressBar = class external(JTi.UI.View)
    color: String;
    font: JFont;
    max: Float;
    message: String;
    min: Float;
    style: Float;
    value: Float;
    function getColor: String;
    function getFont: JFont;
    function getMax: Float;
    function getMessage: String;
    function getMin: Float;
    function getStyle: Float;
    function getValue: Float;
    procedure setColor(color: String);
    procedure setFont(font: JFont);
    procedure setMax(max: Float);
    procedure setMessage(message: String);
    procedure setMin(min: Float);
    procedure setStyle(style: Float);
    procedure setValue(value: Float);
  end;

  JLabel = class external(JTi.UI.View)
    attributedString: JTi.UI.iOS.AttributedString;
    autoLink: Float;
    backgroundPaddingBottom: Float;
    backgroundPaddingLeft: Float;
    backgroundPaddingRight: Float;
    backgroundPaddingTop: Float;
    color: String;
    ellipsize: Boolean;
    font: JFont;
    highlightedColor: String;
    html: String;
    includeFontPadding: Boolean;
    minimumFontSize: Float;
    shadowColor: String;
    shadowOffset: JDictionary{<JObject>};
    shadowRadius: Float;
    text: String;
    textAlign: Variant;
    textid: String;
    verticalAlign: Variant;
    wordWrap: Boolean;
    function getAttributedString: JTi.UI.iOS.AttributedString;
    function getAutoLink: Float;
    function getBackgroundPaddingBottom: Float;
    function getBackgroundPaddingLeft: Float;
    function getBackgroundPaddingRight: Float;
    function getBackgroundPaddingTop: Float;
    function getColor: String;
    function getEllipsize: Boolean;
    function getFont: JFont;
    function getHighlightedColor: String;
    function getHtml: String;
    function getIncludeFontPadding: Boolean;
    function getMinimumFontSize: Float;
    function getShadowColor: String;
    function getShadowOffset: JDictionary{<JObject>};
    function getShadowRadius: Float;
    function getText: String;
    function getTextAlign: Variant;
    function getTextid: String;
    function getVerticalAlign: Variant;
    function getWordWrap: Boolean;
    procedure setAttributedString(attributedString: JTi.UI.iOS.AttributedString);
    procedure setAutoLink(autoLink: Float);
    procedure setBackgroundPaddingBottom(backgroundPaddingBottom: Float);
    procedure setBackgroundPaddingLeft(backgroundPaddingLeft: Float);
    procedure setBackgroundPaddingRight(backgroundPaddingRight: Float);
    procedure setBackgroundPaddingTop(backgroundPaddingTop: Float);
    procedure setColor(color: String);
    procedure setEllipsize(ellipsize: Boolean);
    procedure setFont(font: JFont);
    procedure setHighlightedColor(highlightedColor: String);
    procedure setHtml(html: String);
    procedure setIncludeFontPadding(includeFontPadding: Boolean);
    procedure setMinimumFontSize(minimumFontSize: Float);
    procedure setShadowColor(shadowColor: String);
    procedure setShadowOffset(shadowOffset: JDictionary{<JObject>});
    procedure setShadowRadius(shadowRadius: Float);
    procedure setText(text: String);
    procedure setTextAlign(textAlign: String);
    procedure setTextAlign(textAlign: Float);
    procedure setTextid(textid: String);
    procedure setVerticalAlign(verticalAlign: Float);
    procedure setVerticalAlign(verticalAlign: String);
    procedure setWordWrap(wordWrap: Boolean);
  end;

  JSearchBar = class external(JTi.UI.View)
    autocapitalization: Float;
    autocorrect: Boolean;
    barColor: String;
    hintText: String;
    hinttextid: String;
    keyboardType: Float;
    prompt: String;
    promptid: String;
    showBookmark: Boolean;
    showCancel: Boolean;
    value: String;
    procedure blur;
    procedure focus;
    function getAutocapitalization: Float;
    function getAutocorrect: Boolean;
    function getBarColor: String;
    function getHintText: String;
    function getHinttextid: String;
    function getKeyboardType: Float;
    function getPrompt: String;
    function getPromptid: String;
    function getShowBookmark: Boolean;
    function getShowCancel: Boolean;
    function getValue: String;
    procedure setAutocapitalization(autocapitalization: Float);
    procedure setAutocorrect(autocorrect: Boolean);
    procedure setBarColor(barColor: String);
    procedure setHintText(hintText: String);
    procedure setHinttextid(hinttextid: String);
    procedure setKeyboardType(keyboardType: Float);
    procedure setPrompt(prompt: String);
    procedure setPromptid(promptid: String);
    procedure setShowBookmark(showBookmark: Boolean);
    procedure setShowCancel(showCancel: Boolean); overload;
    procedure setShowCancel(showCancel: Boolean; animated: JDictionary{<JObject>}); overload;
    procedure setValue(value: String);
  end;

  JSMSDialog = class external(JTi.Proxy)
    CANCELLED: Float;
    FAILED: Float;
    SENT: Float;
    messageBody: String;
    toRecipients: JArray{<JString>};
    function getMessageBody: String;
    function getToRecipients: JArray{<JString>};
    function isSupported: Boolean;
    procedure open;
    procedure setMessageBody(messageBody: String);
    procedure setToRecipients(toRecipients: JArray{<JString>});
  end;

  JTableViewSection = class external(JTi.Proxy)
    footerTitle: String;
    footerView: JTi.UI.View;
    headerTitle: String;
    headerView: JTi.UI.View;
    rowCount: Float;
    rows: JArray{<JTi.UI.TableViewRow>};
    procedure add(row: JTi.UI.TableViewRow);
    function getFooterTitle: String;
    function getFooterView: JTi.UI.View;
    function getHeaderTitle: String;
    function getHeaderView: JTi.UI.View;
    function getRowCount: Float;
    function getRows: JArray{<JTi.UI.TableViewRow>};
    procedure remove(row: JTi.UI.TableViewRow);
    function rowAtIndex(index: Float): JTi.UI.TableViewRow;
    procedure setFooterTitle(footerTitle: String);
    procedure setFooterView(footerView: JTi.UI.View);
    procedure setHeaderTitle(headerTitle: String);
    procedure setHeaderView(headerView: JTi.UI.View);
  end;

  JAnimation = class external(JTi.Proxy)
    anchorPoint: JPoint;
    autoreverse: Boolean;
    backgroundColor: String;
    bottom: Float;
    center: Variant;
    color: String;
    curve: Float;
    delay: Float;
    duration: Float;
    height: Float;
    left: Float;
    opacity: Float;
    opaque: Boolean;
    repeat: Float;
    right: Float;
    top: Float;
    transform: Variant;
    transition: Float;
    view: JTi.UI.View;
    visible: Boolean;
    width: Float;
    zIndex: Float;
    function getAnchorPoint: JPoint;
    function getAutoreverse: Boolean;
    function getBackgroundColor: String;
    function getBottom: Float;
    function getCenter: Variant;
    function getColor: String;
    function getCurve: Float;
    function getDelay: Float;
    function getDuration: Float;
    function getHeight: Float;
    function getLeft: Float;
    function getOpacity: Float;
    function getOpaque: Boolean;
    function getRepeat: Float;
    function getRight: Float;
    function getTop: Float;
    function getTransform: Variant;
    function getTransition: Float;
    function getView: JTi.UI.View;
    function getVisible: Boolean;
    function getWidth: Float;
    function getZIndex: Float;
    procedure setAnchorPoint(anchorPoint: JPoint);
    procedure setAutoreverse(autoreverse: Boolean);
    procedure setBackgroundColor(backgroundColor: String);
    procedure setBottom(bottom: Float);
    procedure setCenter(center: Variant);
    procedure setColor(color: String);
    procedure setCurve(curve: Float);
    procedure setDelay(delay: Float);
    procedure setDuration(duration: Float);
    procedure setHeight(height: Float);
    procedure setLeft(left: Float);
    procedure setOpacity(opacity: Float);
    procedure setOpaque(opaque: Boolean);
    procedure setRepeat(repeat: Float);
    procedure setRight(right: Float);
    procedure setTop(top: Float);
    procedure setTransform(transform: JTi.UI._2DMatrix);
    procedure setTransform(transform: JTi.UI._3DMatrix);
    procedure setTransition(transition: Float);
    procedure setView(view: JTi.UI.View);
    procedure setVisible(visible: Boolean);
    procedure setWidth(width: Float);
    procedure setZIndex(zIndex: Float);
  end;

  JToolbar = class external(JTi.UI.View)
    barColor: String;
    borderBottom: Boolean;
    borderTop: Boolean;
    items: JArray{<JTi.UI.View>};
    translucent: Boolean;
    function getBarColor: String;
    function getBorderBottom: Boolean;
    function getBorderTop: Boolean;
    function getItems: JArray{<JTi.UI.View>};
    function getTranslucent: Boolean;
    procedure setBarColor(barColor: String);
    procedure setBorderBottom(borderBottom: Boolean);
    procedure setBorderTop(borderTop: Boolean);
    procedure setItems(items: JArray{<JTi.UI.View>});
    procedure setTranslucent(translucent: Boolean);
  end;

  JNotification = class external(JTi.UI.View)
    duration: Float;
    horizontalMargin: Float;
    message: String;
    verticalMargin: Float;
    xOffset: Float;
    yOffset: Float;
    function getDuration: Float;
    function getHorizontalMargin: Float;
    function getMessage: String;
    function getVerticalMargin: Float;
    function getXOffset: Float;
    function getYOffset: Float;
    procedure setDuration(duration: Float);
    procedure setHorizontalMargin(horizontalMargin: Float);
    procedure setMessage(message: String);
    procedure setVerticalMargin(verticalMargin: Float);
    procedure setXOffset(xOffset: Float);
    procedure setYOffset(yOffset: Float);
  end;

  JPickerColumn = class external(JTi.UI.View)
    font: JFont;
    rowCount: Float;
    rows: JArray{<JTi.UI.PickerRow>};
    selectedRow: JTi.UI.PickerRow;
    procedure addRow(row: JTi.UI.PickerRow);
    function getFont: JFont;
    function getRowCount: Float;
    function getRows: JArray{<JTi.UI.PickerRow>};
    function getSelectedRow: JTi.UI.PickerRow;
    procedure removeRow(row: JTi.UI.PickerRow);
    procedure setFont(font: JFont);
    procedure setSelectedRow(selectedRow: JTi.UI.PickerRow);
  end;

  JActivityIndicator = class external(JTi.Proxy)
    bottom: Variant;
    color: String;
    font: JFont;
    height: String;
    indicatorColor: String;
    indicatorDiameter: String;
    left: Variant;
    message: String;
    messageid: String;
    right: Variant;
    style: Float;
    top: Variant;
    width: String;
    procedure add;
    function getBottom: Variant;
    function getColor: String;
    function getFont: JFont;
    function getHeight: String;
    function getIndicatorColor: String;
    function getIndicatorDiameter: String;
    function getLeft: Variant;
    function getMessage: String;
    function getMessageid: String;
    function getRight: Variant;
    function getStyle: Float;
    function getTop: Variant;
    function getWidth: String;
    procedure hide;
    procedure remove;
    procedure setBottom(bottom: Float);
    procedure setBottom(bottom: String);
    procedure setColor(color: String);
    procedure setFont(font: JFont);
    procedure setHeight(height: String);
    procedure setIndicatorColor(indicatorColor: String);
    procedure setIndicatorDiameter(indicatorDiameter: String);
    procedure setLeft(left: Float);
    procedure setLeft(left: String);
    procedure setMessage(message: String);
    procedure setMessageid(messageid: String);
    procedure setRight(right: Float);
    procedure setRight(right: String);
    procedure setStyle(style: Float);
    procedure setTop(top: Float);
    procedure setTop(top: String);
    procedure setWidth(width: String);
    procedure show;
  end;

  JPicker = class external(JTi.UI.View)
    calendarViewShown: Boolean;
    columns: JArray{<JTi.UI.PickerColumn>};
    countDownDuration: Float;
    font: JFont;
    format24: Boolean;
    locale: String;
    maxDate: JDate;
    minDate: JDate;
    minuteInterval: Float;
    selectionIndicator: Boolean;
    &type: Float;
    useSpinner: Boolean;
    value: JDate;
    visibleItems: Float;
    procedure add(data: JArray{<JTi.UI.PickerRow>});
    procedure add(data: JTi.UI.PickerRow);
    procedure add(data: JArray{<JTi.UI.PickerColumn>});
    procedure add(data: JTi.UI.PickerColumn);
    function getCalendarViewShown: Boolean;
    function getColumns: JArray{<JTi.UI.PickerColumn>};
    function getCountDownDuration: Float;
    function getFont: JFont;
    function getFormat24: Boolean;
    function getLocale: String;
    function getMaxDate: JDate;
    function getMinDate: JDate;
    function getMinuteInterval: Float;
    function getSelectedRow(index: Float): JTi.UI.PickerRow;
    function getSelectionIndicator: Boolean;
    function getType: Float;
    function getUseSpinner: Boolean;
    function getValue: JDate;
    function getVisibleItems: Float;
    procedure reloadColumn(column: JTi.UI.PickerColumn);
    procedure setCalendarViewShown(calendarViewShown: Boolean);
    procedure setColumns(columns: JArray{<JTi.UI.PickerColumn>});
    procedure setCountDownDuration(countDownDuration: Float);
    procedure setFont(font: JFont);
    procedure setFormat24(format24: Boolean);
    procedure setLocale(locale: String);
    procedure setMaxDate(maxDate: JDate);
    procedure setMinDate(minDate: JDate);
    procedure setMinuteInterval(minuteInterval: Float);
    procedure setSelectedRow(column: Float; row: Float); overload;
    procedure setSelectedRow(column: Float; row: Float; animated: Boolean); overload;
    procedure setSelectionIndicator(selectionIndicator: Boolean);
    procedure setType(&type: Float);
    procedure setUseSpinner(useSpinner: Boolean);
    function setValue(date: Variant; suppressEvent: Boolean): JTi.UI.PickerRow;
    procedure setVisibleItems(visibleItems: Float);
    procedure showDatePickerDialog(dictObj: Variant);
    procedure showTimePickerDialog(dictObj: Variant);
  end;

//iPad

type
  JSplitWindow = class external(JTi.UI.Window)
    detailView: JTi.UI.View;
    masterView: JTi.UI.View;
    showMasterInPortrait: Boolean;
    function getDetailView: JTi.UI.View;
    function getMasterView: JTi.UI.View;
    function getShowMasterInPortrait: Boolean;
    procedure setShowMasterInPortrait(showMasterInPortrait: Boolean);
  end;

  JDocumentViewer = class external(JTi.UI.View)
    procedure setUrl(url: String);
    procedure show;
  end;

  JPopover = class external(JTi.Proxy)
    arrowDirection: Float;
    contentView: JTi.UI.View;
    height: Variant;
    leftNavButton: Variant;
    passthroughViews: JArray{<JTi.UI.View>};
    rightNavButton: Variant;
    title: String;
    width: Variant;
    procedure add;
    function getArrowDirection: Float;
    function getContentView: JTi.UI.View;
    function getHeight: Variant;
    function getLeftNavButton: Variant;
    function getPassthroughViews: JArray{<JTi.UI.View>};
    function getRightNavButton: Variant;
    function getTitle: String;
    function getWidth: Variant;
    procedure hide(options: JPopoverParams);
    procedure remove;
    procedure setArrowDirection(arrowDirection: Float);
    procedure setContentView(contentView: JTi.UI.View);
    procedure setHeight(height: Float);
    procedure setHeight(height: String);
    procedure setLeftNavButton(leftNavButton: Variant);
    procedure setPassthroughViews(passthroughViews: JArray{<JTi.UI.View>});
    procedure setRightNavButton(rightNavButton: Variant);
    procedure setTitle(title: String);
    procedure setWidth(width: Float);
    procedure setWidth(width: String);
    procedure show(params: JPopoverParams);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createDocumentViewer: JTi.UI.iPad.DocumentViewer; overload;
function createDocumentViewer(parameters: JDictionary{<JTi.UI.iPad.DocumentViewer>}): JTi.UI.iPad.DocumentViewer; overload;
function createPopover: JTi.UI.iPad.Popover; overload;
function createPopover(parameters: JDictionary{<JTi.UI.iPad.Popover>}): JTi.UI.iPad.Popover; overload;
function createSplitWindow: JTi.UI.iPad.SplitWindow; overload;
function createSplitWindow(parameters: JDictionary{<JTi.UI.iPad.SplitWindow>}): JTi.UI.iPad.SplitWindow; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  POPOVER_ARROW_DIRECTION_ANY: Float;
  POPOVER_ARROW_DIRECTION_DOWN: Float;
  POPOVER_ARROW_DIRECTION_LEFT: Float;
  POPOVER_ARROW_DIRECTION_RIGHT: Float;
  POPOVER_ARROW_DIRECTION_UNKNOWN: Float;
  POPOVER_ARROW_DIRECTION_UP: Float;
  apiName: String;
  bubbleParent: Boolean;

//iOS

type
  JAnimator = class external(JTi.Proxy)
    behaviors: JArray{<JTi.Proxy>};
    referenceView: JTi.UI.View;
    running: Boolean;
    procedure addBehavior(behavior: JTi.Proxy);
    function getBehaviors: JArray{<JTi.Proxy>};
    function getReferenceView: JTi.UI.View;
    function getRunning: Boolean;
    procedure removeAllBehaviors;
    procedure removeBehavior(behavior: JTi.Proxy);
    procedure setBehaviors(behaviors: JArray{<JTi.Proxy>});
    procedure setReferenceView(referenceView: JTi.UI.View);
    procedure startAnimator;
    procedure stopAnimator;
    procedure updateItemUsingCurrentState(item: JTi.UI.View);
  end;

  JDynamicItemBehavior = class external(JTi.Proxy)
    allowsRotation: Boolean;
    angularResistance: Float;
    density: Float;
    elasticity: Float;
    friction: Float;
    items: JArray{<JTi.UI.View>};
    resistance: Float;
    procedure addAngularVelocityForItem(item: JTi.UI.View; velocity: Float);
    procedure addItem(item: JTi.UI.View);
    procedure addLinearVelocityForItem(item: JTi.UI.View; velocity: JPoint);
    function angularVelocityForItem(item: JTi.UI.View): Float;
    function getAllowsRotation: Boolean;
    function getAngularResistance: Float;
    function getDensity: Float;
    function getElasticity: Float;
    function getFriction: Float;
    function getItems: JArray{<JTi.UI.View>};
    function getResistance: Float;
    function linearVelocityForItem(item: JTi.UI.View): JPoint;
    procedure removeItem(item: JTi.UI.View);
    procedure setAllowsRotation(allowsRotation: Boolean);
    procedure setAngularResistance(angularResistance: Float);
    procedure setDensity(density: Float);
    procedure setElasticity(elasticity: Float);
    procedure setFriction(friction: Float);
    procedure setResistance(resistance: Float);
  end;

  JSnapBehavior = class external(JTi.Proxy)
    damping: Float;
    item: JTi.UI.View;
    snapPoint: JPoint;
    function getDamping: Float;
    function getItem: JTi.UI.View;
    function getSnapPoint: JPoint;
    procedure setDamping(damping: Float);
    procedure setItem(item: JTi.UI.View);
    procedure setSnapPoint(snapPoint: JPoint);
  end;

  JGravityBehavior = class external(JTi.Proxy)
    angle: Float;
    gravityDirection: JPoint;
    items: JArray{<JTi.UI.View>};
    magnitude: Float;
    procedure addItem(item: JTi.UI.View);
    function getAngle: Float;
    function getGravityDirection: JPoint;
    function getItems: JArray{<JTi.UI.View>};
    function getMagnitude: Float;
    procedure removeItem(item: JTi.UI.View);
    procedure setAngle(angle: Float);
    procedure setGravityDirection(gravityDirection: JPoint);
    procedure setMagnitude(magnitude: Float);
  end;

  JCollisionBehavior = class external(JTi.Proxy)
    boundaryIdentifiers: JArray{<JBoundaryIdentifier>};
    collisionMode: Float;
    items: JArray{<JTi.UI.View>};
    referenceInsets: JReferenceInsets;
    treatReferenceAsBoundary: Boolean;
    procedure addBoundary(boundary: JBoundaryIdentifier);
    procedure addItem(item: JTi.UI.View);
    function getBoundaryIdentifiers: JArray{<JBoundaryIdentifier>};
    function getCollisionMode: Float;
    function getItems: JArray{<JTi.UI.View>};
    function getReferenceInsets: JReferenceInsets;
    function getTreatReferenceAsBoundary: Boolean;
    procedure removeAllBoundaries;
    procedure removeBoundary(boundary: JBoundaryIdentifier);
    procedure removeItem(item: JTi.UI.View);
    procedure setCollisionMode(collisionMode: Float);
    procedure setReferenceInsets(referenceInsets: JReferenceInsets);
    procedure setTreatReferenceAsBoundary(treatReferenceAsBoundary: Boolean);
  end;

  JToolbar = class external(JTi.UI.View)
    barColor: String;
    borderBottom: Boolean;
    borderTop: Boolean;
    extendBackground: Boolean;
    items: JArray{<JTi.UI.View>};
    translucent: Boolean;
    function getBarColor: String;
    function getBorderBottom: Boolean;
    function getBorderTop: Boolean;
    function getExtendBackground: Boolean;
    function getItems: JArray{<JTi.UI.View>};
    function getTranslucent: Boolean;
    procedure setBarColor(barColor: String);
    procedure setBorderBottom(borderBottom: Boolean);
    procedure setBorderTop(borderTop: Boolean);
    procedure setItems(items: JArray{<JTi.UI.View>});
    procedure setTranslucent(translucent: Boolean);
  end;

  JViewAttachmentBehavior = class external(JTi.Proxy)
    anchorItem: JTi.UI.View;
    anchorOffset: JPoint;
    damping: Float;
    distance: Float;
    frequency: Float;
    item: JTi.UI.View;
    itemOffset: JPoint;
    function getAnchorItem: JTi.UI.View;
    function getAnchorOffset: JPoint;
    function getDamping: Float;
    function getDistance: Float;
    function getFrequency: Float;
    function getItem: JTi.UI.View;
    function getItemOffset: JPoint;
    procedure setAnchorItem(anchorItem: JTi.UI.View);
    procedure setAnchorOffset(anchorOffset: JPoint);
    procedure setDamping(damping: Float);
    procedure setDistance(distance: Float);
    procedure setFrequency(frequency: Float);
    procedure setItem(item: JTi.UI.View);
    procedure setItemOffset(itemOffset: JPoint);
  end;

  JPushBehavior = class external(JTi.Proxy)
    active: Boolean;
    angle: Float;
    items: JArray{<JTi.UI.View>};
    magnitude: Float;
    pushDirection: JPoint;
    pushMode: Float;
    procedure addItem(item: JTi.UI.View);
    function getActive: Boolean;
    function getAngle: Float;
    function getItems: JArray{<JTi.UI.View>};
    function getMagnitude: Float;
    function getPushDirection: JPoint;
    function getPushMode: Float;
    procedure removeItem(item: JTi.UI.View);
    procedure setActive(active: Boolean);
    procedure setAngle(angle: Float);
    procedure setMagnitude(magnitude: Float);
    procedure setPushDirection(pushDirection: JPoint);
    procedure setPushMode(pushMode: Float);
  end;

  JCoverFlowView = class external(JTi.UI.View)
    images: Variant;
    selected: Float;
    function getImages: Variant;
    function getSelected: Float;
    procedure setImage(index: Float; image: String);
    procedure setImage(image: JTi.Blob);
    procedure setImage(image: JTi.Filesystem.File);
    procedure setImage(index: Float; image: JCoverFlowImageType);
    procedure setImages(images: JArray{<JString>});
    procedure setImages(images: JArray{<JTi.Blob>});
    procedure setImages(images: JArray{<JTi.Filesystem.File>});
    procedure setImages(images: JArray{<JCoverFlowImageType>});
    procedure setSelected(selected: Float);
  end;

  JDocumentViewer = class external(JTi.UI.View)
    name: String;
    url: String;
    function getName: String;
    function getUrl: String;
    procedure hide; overload;
    procedure hide(options: JDocumentViewerOptions); overload;
    procedure setUrl(url: String);
    procedure show; overload;
    procedure show(options: JDocumentViewerOptions); overload;
  end;

  JNavigationWindow = class external(JTi.UI.Window)
    window: JTi.UI.Window;
    procedure closeWindow(window: JTi.UI.Window; options: JDictionary{<JObject>});
    function getWindow: JTi.UI.Window;
    procedure openWindow(window: JTi.UI.Window; options: JDictionary{<JObject>});
  end;

  JAttributedString = class external(JTi.Proxy)
    attributes: JArray{<JAttribute>};
    text: String;
    procedure addAttribute(attribute: JAttribute);
    function getAttributes: JArray{<JAttribute>};
    function getText: String;
    procedure setAttributes(attributes: JArray{<JAttribute>});
    procedure setText(text: String);
  end;

  JAnchorAttachmentBehavior = class external(JTi.Proxy)
    anchor: JPoint;
    damping: Float;
    distance: Float;
    frequency: Float;
    item: JTi.UI.View;
    offset: JPoint;
    function getAnchor: JPoint;
    function getDamping: Float;
    function getDistance: Float;
    function getFrequency: Float;
    function getItem: JTi.UI.View;
    function getOffset: JPoint;
    procedure setAnchor(anchor: JPoint);
    procedure setDamping(damping: Float);
    procedure setDistance(distance: Float);
    procedure setFrequency(frequency: Float);
    procedure setItem(item: JTi.UI.View);
    procedure setOffset(offset: JPoint);
  end;

  JTabbedBar = class external(JTi.UI.View)
    index: Float;
    labels: Variant;
    style: Float;
    function getIndex: Float;
    function getLabels: Variant;
    function getStyle: Float;
    procedure setIndex(index: Float);
    procedure setLabels(labels: JArray{<JString>});
    procedure setLabels(labels: JArray{<JBarItemType>});
    procedure setStyle(style: Float);
  end;

  J_3DMatrix = class external(JTi.Proxy)
    m11: Float;
    m12: Float;
    m13: Float;
    m14: Float;
    m21: Float;
    m22: Float;
    m23: Float;
    m24: Float;
    m31: Float;
    m32: Float;
    m33: Float;
    m34: Float;
    m41: Float;
    m42: Float;
    m43: Float;
    m44: Float;
    function getM11: Float;
    function getM12: Float;
    function getM13: Float;
    function getM14: Float;
    function getM21: Float;
    function getM22: Float;
    function getM23: Float;
    function getM24: Float;
    function getM31: Float;
    function getM32: Float;
    function getM33: Float;
    function getM34: Float;
    function getM41: Float;
    function getM42: Float;
    function getM43: Float;
    function getM44: Float;
    function invert: JTi.UI._3DMatrix;
    function multiply(t2: JTi.UI._3DMatrix): JTi.UI._3DMatrix;
    function rotate(angle: Float; x: Float; y: Float; z: Float): JTi.UI._3DMatrix;
    function scale(sx: Float; sy: Float; sz: Float): JTi.UI._3DMatrix;
    procedure setM11(m11: Float);
    procedure setM12(m12: Float);
    procedure setM13(m13: Float);
    procedure setM14(m14: Float);
    procedure setM21(m21: Float);
    procedure setM22(m22: Float);
    procedure setM23(m23: Float);
    procedure setM24(m24: Float);
    procedure setM31(m31: Float);
    procedure setM32(m32: Float);
    procedure setM33(m33: Float);
    procedure setM34(m34: Float);
    procedure setM41(m41: Float);
    procedure setM42(m42: Float);
    procedure setM43(m43: Float);
    procedure setM44(m44: Float);
    function translate(tx: Float; ty: Float; tz: Float): JTi.UI._3DMatrix;
  end;

  JAdView = class external(JTi.UI.View)
    adSize: String;
    procedure cancelAction;
    function getAdSize: String;
    procedure setAdSize(adSize: String);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function create3DMatrix: JTi.UI.iOS._3DMatrix; overload;
function create3DMatrix(parameters: JDictionary{<JTi.UI.iOS._3DMatrix>}): JTi.UI.iOS._3DMatrix; overload;
function createAdView: JTi.UI.iOS.AdView; overload;
function createAdView(parameters: JDictionary{<JTi.UI.iOS.AdView>}): JTi.UI.iOS.AdView; overload;
function createAnchorAttachmentBehavior: JTi.UI.iOS.AnchorAttachmentBehavior; overload;
function createAnchorAttachmentBehavior(parameters: JDictionary{<JTi.UI.iOS.AnchorAttachmentBehavior>}): JTi.UI.iOS.AnchorAttachmentBehavior; overload;
function createAnimator: JTi.UI.iOS.Animator; overload;
function createAnimator(parameters: JDictionary{<JTi.UI.iOS.Animator>}): JTi.UI.iOS.Animator; overload;
function createAttributedString: JTi.UI.iOS.AttributedString; overload;
function createAttributedString(parameters: JDictionary{<JTi.UI.iOS.AttributedString>}): JTi.UI.iOS.AttributedString; overload;
function createCollisionBehavior: JTi.UI.iOS.CollisionBehavior; overload;
function createCollisionBehavior(parameters: JDictionary{<JTi.UI.iOS.CollisionBehavior>}): JTi.UI.iOS.CollisionBehavior; overload;
function createCoverFlowView: JTi.UI.iOS.CoverFlowView; overload;
function createCoverFlowView(parameters: JDictionary{<JTi.UI.iOS.CoverFlowView>}): JTi.UI.iOS.CoverFlowView; overload;
function createDocumentViewer: JTi.UI.iOS.DocumentViewer; overload;
function createDocumentViewer(parameters: JDictionary{<JTi.UI.iOS.DocumentViewer>}): JTi.UI.iOS.DocumentViewer; overload;
function createDynamicItemBehavior: JTi.UI.iOS.DynamicItemBehavior; overload;
function createDynamicItemBehavior(parameters: JDictionary{<JTi.UI.iOS.DynamicItemBehavior>}): JTi.UI.iOS.DynamicItemBehavior; overload;
function createGravityBehavior: JTi.UI.iOS.GravityBehavior; overload;
function createGravityBehavior(parameters: JDictionary{<JTi.UI.iOS.GravityBehavior>}): JTi.UI.iOS.GravityBehavior; overload;
function createNavigationWindow: JTi.UI.iOS.NavigationWindow; overload;
function createNavigationWindow(parameters: JDictionary{<JTi.UI.iOS.NavigationWindow>}): JTi.UI.iOS.NavigationWindow; overload;
function createPushBehavior: JTi.UI.iOS.PushBehavior; overload;
function createPushBehavior(parameters: JDictionary{<JTi.UI.iOS.PushBehavior>}): JTi.UI.iOS.PushBehavior; overload;
function createSnapBehavior: JTi.UI.iOS.SnapBehavior; overload;
function createSnapBehavior(parameters: JDictionary{<JTi.UI.iOS.SnapBehavior>}): JTi.UI.iOS.SnapBehavior; overload;
function createTabbedBar: JTi.UI.iOS.TabbedBar; overload;
function createTabbedBar(parameters: JDictionary{<JTi.UI.iOS.TabbedBar>}): JTi.UI.iOS.TabbedBar; overload;
function createToolbar: JTi.UI.iOS.Toolbar; overload;
function createToolbar(parameters: JDictionary{<JTi.UI.iOS.Toolbar>}): JTi.UI.iOS.Toolbar; overload;
function createTransitionAnimation(transition: JtransitionAnimationParam): JTi.Proxy;
function createViewAttachmentBehavior: JTi.UI.iOS.ViewAttachmentBehavior; overload;
function createViewAttachmentBehavior(parameters: JDictionary{<JTi.UI.iOS.ViewAttachmentBehavior>}): JTi.UI.iOS.ViewAttachmentBehavior; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  AD_SIZE_LANDSCAPE: String;
  AD_SIZE_PORTRAIT: String;
  ANIMATION_CURVE_EASE_IN: Float;
  ANIMATION_CURVE_EASE_IN_OUT: Float;
  ANIMATION_CURVE_EASE_OUT: Float;
  ANIMATION_CURVE_LINEAR: Float;
  ATTRIBUTE_BACKGROUND_COLOR: Float;
  ATTRIBUTE_BASELINE_OFFSET: Float;
  ATTRIBUTE_EXPANSION: Float;
  ATTRIBUTE_FONT: Float;
  ATTRIBUTE_FOREGROUND_COLOR: Float;
  ATTRIBUTE_KERN: Float;
  ATTRIBUTE_LETTERPRESS_STYLE: Float;
  ATTRIBUTE_LIGATURE: Float;
  ATTRIBUTE_LINK: Float;
  ATTRIBUTE_OBLIQUENESS: Float;
  ATTRIBUTE_SHADOW: Float;
  ATTRIBUTE_STRIKETHROUGH_COLOR: Float;
  ATTRIBUTE_STRIKETHROUGH_STYLE: Float;
  ATTRIBUTE_STROKE_COLOR: Float;
  ATTRIBUTE_STROKE_WIDTH: Float;
  ATTRIBUTE_TEXT_EFFECT: Float;
  ATTRIBUTE_UNDERLINES_STYLE: Float;
  ATTRIBUTE_UNDERLINE_BY_WORD: Float;
  ATTRIBUTE_UNDERLINE_COLOR: Float;
  ATTRIBUTE_UNDERLINE_PATTERN_DASH: Float;
  ATTRIBUTE_UNDERLINE_PATTERN_DASH_DOT: Float;
  ATTRIBUTE_UNDERLINE_PATTERN_DASH_DOT_DOT: Float;
  ATTRIBUTE_UNDERLINE_PATTERN_DOT: Float;
  ATTRIBUTE_UNDERLINE_PATTERN_SOLID: Float;
  ATTRIBUTE_UNDERLINE_STYLE_DOUBLE: Float;
  ATTRIBUTE_UNDERLINE_STYLE_NONE: Float;
  ATTRIBUTE_UNDERLINE_STYLE_SINGLE: Float;
  ATTRIBUTE_UNDERLINE_STYLE_THICK: Float;
  ATTRIBUTE_WRITING_DIRECTION: Float;
  ATTRIBUTE_WRITING_DIRECTION_EMBEDDING: Float;
  ATTRIBUTE_WRITING_DIRECTION_LEFT_TO_RIGHT: Float;
  ATTRIBUTE_WRITING_DIRECTION_NATURAL: Float;
  ATTRIBUTE_WRITING_DIRECTION_OVERRIDE: Float;
  ATTRIBUTE_WRITING_DIRECTION_RIGHT_TO_LEFT: Float;
  AUTODETECT_ADDRESS: Float;
  AUTODETECT_ALL: Float;
  AUTODETECT_CALENDAR: Float;
  AUTODETECT_LINK: Float;
  AUTODETECT_NONE: Float;
  AUTODETECT_PHONE: Float;
  BLEND_MODE_CLEAR: Float;
  BLEND_MODE_COLOR: Float;
  BLEND_MODE_COLOR_BURN: Float;
  BLEND_MODE_COLOR_DODGE: Float;
  BLEND_MODE_COPY: Float;
  BLEND_MODE_DARKEN: Float;
  BLEND_MODE_DESTINATION_ATOP: Float;
  BLEND_MODE_DESTINATION_IN: Float;
  BLEND_MODE_DESTINATION_OUT: Float;
  BLEND_MODE_DESTINATION_OVER: Float;
  BLEND_MODE_DIFFERENCE: Float;
  BLEND_MODE_EXCLUSION: Float;
  BLEND_MODE_HARD_LIGHT: Float;
  BLEND_MODE_HUE: Float;
  BLEND_MODE_LIGHTEN: Float;
  BLEND_MODE_LUMINOSITY: Float;
  BLEND_MODE_MULTIPLY: Float;
  BLEND_MODE_NORMAL: Float;
  BLEND_MODE_OVERLAY: Float;
  BLEND_MODE_PLUS_DARKER: Float;
  BLEND_MODE_PLUS_LIGHTER: Float;
  BLEND_MODE_SATURATION: Float;
  BLEND_MODE_SCREEN: Float;
  BLEND_MODE_SOFT_LIGHT: Float;
  BLEND_MODE_SOURCE_ATOP: Float;
  BLEND_MODE_SOURCE_IN: Float;
  BLEND_MODE_SOURCE_OUT: Float;
  BLEND_MODE_XOR: Float;
  CLIP_MODE_DEFAULT: Float;
  CLIP_MODE_DISABLED: Float;
  CLIP_MODE_ENABLED: Float;
  COLLISION_MODE_ALL: Float;
  COLLISION_MODE_BOUNDARY: Float;
  COLLISION_MODE_ITEM: Float;
  COLOR_GROUP_TABLEVIEW_BACKGROUND: String;
  COLOR_SCROLLVIEW_BACKGROUND: String;
  COLOR_UNDER_PAGE_BACKGROUND: String;
  COLOR_VIEW_FLIPSIDE_BACKGROUND: String;
  PUSH_MODE_CONTINUOUS: Float;
  PUSH_MODE_INSTANTANEOUS: Float;
  SCROLL_DECELERATION_RATE_FAST: Float;
  SCROLL_DECELERATION_RATE_NORMAL: Float;
  WEBVIEW_NAVIGATIONTYPE_BACK_FORWARD: Float;
  WEBVIEW_NAVIGATIONTYPE_FORM_RESUBMITTED: Float;
  WEBVIEW_NAVIGATIONTYPE_FORM_SUBMITTED: Float;
  WEBVIEW_NAVIGATIONTYPE_LINK_CLICKED: Float;
  WEBVIEW_NAVIGATIONTYPE_OTHER: Float;
  WEBVIEW_NAVIGATIONTYPE_RELOAD: Float;
  apiName: String;
  bubbleParent: Boolean;

//iPhone

type
  JNavigationGroup = class external(JTi.UI.View)
    window: JTi.UI.Window;
    procedure close(window: JTi.UI.Window; options: JDictionary{<JObject>});
    function getWindow: JTi.UI.Window;
    procedure open(window: JTi.UI.Window; options: JDictionary{<JObject>});
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createNavigationGroup: JTi.UI.iPhone.NavigationGroup; overload;
function createNavigationGroup(parameters: JDictionary{<JTi.UI.iPhone.NavigationGroup>}): JTi.UI.iPhone.NavigationGroup; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getAppBadge: Float;
function getAppSupportsShakeToEdit: Boolean;
function getBubbleParent: Boolean;
function getStatusBarHidden: Boolean;
function getStatusBarStyle: Float;
procedure hideStatusBar; overload;
procedure hideStatusBar(params: JhideStatusBarParams); overload;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setAppBadge(appBadge: Float);
procedure setAppSupportsShakeToEdit(appSupportsShakeToEdit: Boolean);
procedure setBubbleParent(bubbleParent: Boolean);
procedure showStatusBar; overload;
procedure showStatusBar(params: JshowStatusBarParams); overload;

var
  MODAL_PRESENTATION_CURRENT_CONTEXT: Float;
  MODAL_PRESENTATION_FORMSHEET: Float;
  MODAL_PRESENTATION_FULLSCREEN: Float;
  MODAL_PRESENTATION_PAGESHEET: Float;
  MODAL_TRANSITION_STYLE_COVER_VERTICAL: Float;
  MODAL_TRANSITION_STYLE_CROSS_DISSOLVE: Float;
  MODAL_TRANSITION_STYLE_FLIP_HORIZONTAL: Float;
  MODAL_TRANSITION_STYLE_PARTIAL_CURL: Float;
  apiName: String;
  appBadge: Float;
  appSupportsShakeToEdit: Boolean;
  bubbleParent: Boolean;
  statusBarHidden: Boolean;
  statusBarStyle: Float;

//Android

type
  JSearchView = class external(JTi.UI.View)
    hintText: String;
    iconified: Boolean;
    iconifiedByDefault: Boolean;
    submitEnabled: Boolean;
    value: String;
    procedure blur;
    procedure focus;
    function getHintText: String;
    function getIconified: Boolean;
    function getIconifiedByDefault: Boolean;
    function getSubmitEnabled: Boolean;
    function getValue: String;
    procedure setHintText(hintText: String);
    procedure setIconified(iconified: Boolean);
    procedure setIconifiedByDefault(iconifiedByDefault: Boolean);
    procedure setSubmitEnabled(submitEnabled: Boolean);
    procedure setValue(value: String);
  end;

  JProgressIndicator = class external(JTi.Proxy)
    cancelable: Boolean;
    location: Float;
    max: Float;
    message: String;
    messageid: String;
    min: Float;
    &type: Float;
    function getCancelable: Boolean;
    function getLocation: Float;
    function getMax: Float;
    function getMessage: String;
    function getMessageid: String;
    function getMin: Float;
    function getType: Float;
    procedure hide;
    procedure setCancelable(cancelable: Boolean);
    procedure setLocation(location: Float);
    procedure setMax(max: Float);
    procedure setMessage(message: String);
    procedure setMessageid(messageid: String);
    procedure setMin(min: Float);
    procedure setType(&type: Float);
    procedure show;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createProgressIndicator: JTi.UI.Android.ProgressIndicator; overload;
function createProgressIndicator(parameters: JDictionary{<JTi.UI.Android.ProgressIndicator>}): JTi.UI.Android.ProgressIndicator; overload;
function createSearchView: JTi.UI.Android.SearchView; overload;
function createSearchView(parameters: JDictionary{<JTi.UI.Android.SearchView>}): JTi.UI.Android.SearchView; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
procedure hideSoftKeyboard;
procedure openPreferences;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  LINKIFY_ALL: Float;
  LINKIFY_EMAIL_ADDRESSES: Float;
  LINKIFY_MAP_ADDRESSES: Float;
  LINKIFY_PHONE_NUMBERS: Float;
  LINKIFY_WEB_URLS: Float;
  OVER_SCROLL_ALWAYS: Float;
  OVER_SCROLL_IF_CONTENT_SCROLLS: Float;
  OVER_SCROLL_NEVER: Float;
  PIXEL_FORMAT_A_8: Float;
  PIXEL_FORMAT_LA_88: Float;
  PIXEL_FORMAT_L_8: Float;
  PIXEL_FORMAT_OPAQUE: Float;
  PIXEL_FORMAT_RGBA_4444: Float;
  PIXEL_FORMAT_RGBA_5551: Float;
  PIXEL_FORMAT_RGBA_8888: Float;
  PIXEL_FORMAT_RGBX_8888: Float;
  PIXEL_FORMAT_RGB_332: Float;
  PIXEL_FORMAT_RGB_565: Float;
  PIXEL_FORMAT_RGB_888: Float;
  PIXEL_FORMAT_TRANSLUCENT: Float;
  PIXEL_FORMAT_TRANSPARENT: Float;
  PIXEL_FORMAT_UNKNOWN: Float;
  PROGRESS_INDICATOR_DETERMINANT: Float;
  PROGRESS_INDICATOR_DIALOG: Float;
  PROGRESS_INDICATOR_INDETERMINANT: Float;
  PROGRESS_INDICATOR_STATUS_BAR: Float;
  SOFT_INPUT_ADJUST_PAN: Float;
  SOFT_INPUT_ADJUST_RESIZE: Float;
  SOFT_INPUT_ADJUST_UNSPECIFIED: Float;
  SOFT_INPUT_STATE_ALWAYS_HIDDEN: Float;
  SOFT_INPUT_STATE_ALWAYS_VISIBLE: Float;
  SOFT_INPUT_STATE_HIDDEN: Float;
  SOFT_INPUT_STATE_UNSPECIFIED: Float;
  SOFT_INPUT_STATE_VISIBLE: Float;
  SOFT_KEYBOARD_DEFAULT_ON_FOCUS: Float;
  SOFT_KEYBOARD_HIDE_ON_FOCUS: Float;
  SOFT_KEYBOARD_SHOW_ON_FOCUS: Float;
  SWITCH_STYLE_CHECKBOX: Float;
  SWITCH_STYLE_TOGGLEBUTTON: Float;
  WEBVIEW_LOAD_CACHE_ELSE_NETWORK: Float;
  WEBVIEW_LOAD_CACHE_ONLY: Float;
  WEBVIEW_LOAD_DEFAULT: Float;
  WEBVIEW_LOAD_NO_CACHE: Float;
  WEBVIEW_PLUGINS_OFF: Float;
  WEBVIEW_PLUGINS_ON: Float;
  WEBVIEW_PLUGINS_ON_DEMAND: Float;
  apiName: String;
  bubbleParent: Boolean;

//MobileWeb

type
  JNavigationGroup = class external(JTi.UI.View)
    navBarAtTop: Boolean;
    window: JTi.UI.Window;
    procedure close(window: JTi.UI.Window; options: JDictionary{<JObject>});
    function getNavBarAtTop: Boolean;
    function getWindow: JTi.UI.Window;
    procedure open(window: JTi.UI.Window; options: JDictionary{<JObject>});
    procedure setNavBarAtTop(navBarAtTop: Boolean);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createNavigationGroup: JTi.UI.MobileWeb.NavigationGroup; overload;
function createNavigationGroup(parameters: JDictionary{<JTi.UI.MobileWeb.NavigationGroup>}): JTi.UI.MobileWeb.NavigationGroup; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);

var
  apiName: String;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function convertUnits(convertFromValue: String; convertToUnits: Float): Float;
function create2DMatrix: JTi.UI._2DMatrix; overload;
function create2DMatrix(parameters: JMatrixCreationDict): JTi.UI._2DMatrix; overload;
function create3DMatrix: JTi.UI._3DMatrix; overload;
function create3DMatrix(parameters: JDictionary{<JTi.UI._3DMatrix>}): JTi.UI._3DMatrix; overload;
function createActivityIndicator: JTi.UI.ActivityIndicator; overload;
function createActivityIndicator(parameters: JDictionary{<JTi.UI.ActivityIndicator>}): JTi.UI.ActivityIndicator; overload;
function createAlertDialog: JTi.UI.AlertDialog; overload;
function createAlertDialog(parameters: JDictionary{<JTi.UI.AlertDialog>}): JTi.UI.AlertDialog; overload;
function createAnimation: JTi.UI.Animation; overload;
function createAnimation(parameters: JDictionary{<JTi.UI.Animation>}): JTi.UI.Animation; overload;
function createButton: JTi.UI.Button; overload;
function createButton(parameters: JDictionary{<JTi.UI.Button>}): JTi.UI.Button; overload;
function createButtonBar: JTi.UI.ButtonBar; overload;
function createButtonBar(parameters: JDictionary{<JTi.UI.ButtonBar>}): JTi.UI.ButtonBar; overload;
function createCoverFlowView: JTi.UI.CoverFlowView; overload;
function createCoverFlowView(parameters: JDictionary{<JTi.UI.CoverFlowView>}): JTi.UI.CoverFlowView; overload;
function createDashboardItem: JTi.UI.DashboardItem; overload;
function createDashboardItem(parameters: JDictionary{<JTi.UI.DashboardItem>}): JTi.UI.DashboardItem; overload;
function createDashboardView: JTi.UI.DashboardView; overload;
function createDashboardView(parameters: JDictionary{<JTi.UI.DashboardView>}): JTi.UI.DashboardView; overload;
function createEmailDialog: JTi.UI.EmailDialog; overload;
function createEmailDialog(parameters: JDictionary{<JTi.UI.EmailDialog>}): JTi.UI.EmailDialog; overload;
function createImageView: JTi.UI.ImageView; overload;
function createImageView(parameters: JDictionary{<JTi.UI.ImageView>}): JTi.UI.ImageView; overload;
function createLabel: JTi.UI.Label; overload;
function createLabel(parameters: JDictionary{<JTi.UI.Label>}): JTi.UI.Label; overload;
function createListSection: JTi.UI.ListSection; overload;
function createListSection(parameters: JDictionary{<JTi.UI.ListSection>}): JTi.UI.ListSection; overload;
function createListView: JTi.UI.ListView; overload;
function createListView(parameters: JDictionary{<JTi.UI.ListView>}): JTi.UI.ListView; overload;
function createMaskedImage: JTi.UI.MaskedImage; overload;
function createMaskedImage(parameters: JDictionary{<JTi.UI.MaskedImage>}): JTi.UI.MaskedImage; overload;
function createNotification: JTi.UI.Notification; overload;
function createNotification(parameters: JDictionary{<JTi.UI.Notification>}): JTi.UI.Notification; overload;
function createOptionDialog: JTi.UI.OptionDialog; overload;
function createOptionDialog(parameters: JDictionary{<JTi.UI.OptionDialog>}): JTi.UI.OptionDialog; overload;
function createPicker: JTi.UI.Picker; overload;
function createPicker(parameters: JDictionary{<JTi.UI.Picker>}): JTi.UI.Picker; overload;
function createPickerColumn: JTi.UI.PickerColumn; overload;
function createPickerColumn(parameters: JDictionary{<JTi.UI.PickerColumn>}): JTi.UI.PickerColumn; overload;
function createPickerRow: JTi.UI.PickerRow; overload;
function createPickerRow(parameters: JDictionary{<JTi.UI.PickerRow>}): JTi.UI.PickerRow; overload;
function createProgressBar: JTi.UI.ProgressBar; overload;
function createProgressBar(parameters: JDictionary{<JTi.UI.ProgressBar>}): JTi.UI.ProgressBar; overload;
function createRefreshControl: JTi.UI.RefreshControl; overload;
function createRefreshControl(parameters: JDictionary{<JTi.UI.RefreshControl>}): JTi.UI.RefreshControl; overload;
function createSMSDialog: JTi.UI.SMSDialog; overload;
function createSMSDialog(parameters: JDictionary{<JTi.UI.SMSDialog>}): JTi.UI.SMSDialog; overload;
function createScrollView: JTi.UI.ScrollView; overload;
function createScrollView(parameters: JDictionary{<JTi.UI.ScrollView>}): JTi.UI.ScrollView; overload;
function createScrollableView: JTi.UI.ScrollableView; overload;
function createScrollableView(parameters: JDictionary{<JTi.UI.ScrollableView>}): JTi.UI.ScrollableView; overload;
function createSearchBar: JTi.UI.SearchBar; overload;
function createSearchBar(parameters: JDictionary{<JTi.UI.SearchBar>}): JTi.UI.SearchBar; overload;
function createSlider: JTi.UI.Slider; overload;
function createSlider(parameters: JDictionary{<JTi.UI.Slider>}): JTi.UI.Slider; overload;
function createSwitch: JTi.UI.Switch; overload;
function createSwitch(parameters: JDictionary{<JTi.UI.Switch>}): JTi.UI.Switch; overload;
function createTab: JTi.UI.Tab; overload;
function createTab(parameters: JDictionary{<JTi.UI.Tab>}): JTi.UI.Tab; overload;
function createTabGroup: JTi.UI.TabGroup; overload;
function createTabGroup(parameters: JDictionary{<JTi.UI.TabGroup>}): JTi.UI.TabGroup; overload;
function createTabbedBar: JTi.UI.TabbedBar; overload;
function createTabbedBar(parameters: JDictionary{<JTi.UI.TabbedBar>}): JTi.UI.TabbedBar; overload;
function createTableView: JTi.UI.TableView; overload;
function createTableView(parameters: JDictionary{<JTi.UI.TableView>}): JTi.UI.TableView; overload;
function createTableViewRow: JTi.UI.TableViewRow; overload;
function createTableViewRow(parameters: JDictionary{<JTi.UI.TableViewRow>}): JTi.UI.TableViewRow; overload;
function createTableViewSection: JTi.UI.TableViewSection; overload;
function createTableViewSection(parameters: JDictionary{<JTi.UI.TableViewSection>}): JTi.UI.TableViewSection; overload;
function createTextArea: JTi.UI.TextArea; overload;
function createTextArea(parameters: JDictionary{<JTi.UI.TextArea>}): JTi.UI.TextArea; overload;
function createTextField: JTi.UI.TextField; overload;
function createTextField(parameters: JDictionary{<JTi.UI.TextField>}): JTi.UI.TextField; overload;
function createToolbar: JTi.UI.Toolbar; overload;
function createToolbar(parameters: JDictionary{<JTi.UI.Toolbar>}): JTi.UI.Toolbar; overload;
function createView: JTi.UI.View; overload;
function createView(parameters: JDictionary{<JTi.UI.View>}): JTi.UI.View; overload;
function createWebView: JTi.UI.WebView; overload;
function createWebView(parameters: JDictionary{<JTi.UI.WebView>}): JTi.UI.WebView; overload;
function createWindow: JTi.UI.Window; overload;
function createWindow(parameters: JDictionary{<JTi.UI.Window>}): JTi.UI.Window; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBackgroundColor: String;
function getBackgroundImage: String;
function getBubbleParent: Boolean;
function getCurrentTab: JTi.UI.Tab;
function getCurrentWindow: JTi.UI.Window;
function getOrientation: Float;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBackgroundColor(backgroundColor: String);
procedure setBackgroundImage(backgroundImage: String);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setCurrentTab(currentTab: JTi.UI.Tab);
procedure setOrientation(orientation: Float);

var
  ANIMATION_CURVE_EASE_IN: Float;
  ANIMATION_CURVE_EASE_IN_OUT: Float;
  ANIMATION_CURVE_EASE_OUT: Float;
  ANIMATION_CURVE_LINEAR: Float;
  AUTODETECT_ADDRESS: Float;
  AUTODETECT_ALL: Float;
  AUTODETECT_CALENDAR: Float;
  AUTODETECT_LINK: Float;
  AUTODETECT_NONE: Float;
  AUTODETECT_PHONE: Float;
  AUTOLINK_ALL: Float;
  AUTOLINK_CALENDAR: Float;
  AUTOLINK_EMAIL_ADDRESSES: Float;
  AUTOLINK_MAP_ADDRESSES: Float;
  AUTOLINK_NONE: Float;
  AUTOLINK_PHONE_NUMBERS: Float;
  AUTOLINK_URLS: Float;
  BLEND_MODE_CLEAR: Float;
  BLEND_MODE_COLOR: Float;
  BLEND_MODE_COLOR_BURN: Float;
  BLEND_MODE_COLOR_DODGE: Float;
  BLEND_MODE_COPY: Float;
  BLEND_MODE_DARKEN: Float;
  BLEND_MODE_DESTINATION_ATOP: Float;
  BLEND_MODE_DESTINATION_IN: Float;
  BLEND_MODE_DESTINATION_OUT: Float;
  BLEND_MODE_DESTINATION_OVER: Float;
  BLEND_MODE_DIFFERENCE: Float;
  BLEND_MODE_EXCLUSION: Float;
  BLEND_MODE_HARD_LIGHT: Float;
  BLEND_MODE_HUE: Float;
  BLEND_MODE_LIGHTEN: Float;
  BLEND_MODE_LUMINOSITY: Float;
  BLEND_MODE_MULTIPLY: Float;
  BLEND_MODE_NORMAL: Float;
  BLEND_MODE_OVERLAY: Float;
  BLEND_MODE_PLUS_DARKER: Float;
  BLEND_MODE_PLUS_LIGHTER: Float;
  BLEND_MODE_SATURATION: Float;
  BLEND_MODE_SCREEN: Float;
  BLEND_MODE_SOFT_LIGHT: Float;
  BLEND_MODE_SOURCE_ATOP: Float;
  BLEND_MODE_SOURCE_IN: Float;
  BLEND_MODE_SOURCE_OUT: Float;
  BLEND_MODE_XOR: Float;
  EXTEND_EDGE_ALL: Float;
  EXTEND_EDGE_BOTTOM: Float;
  EXTEND_EDGE_LEFT: Float;
  EXTEND_EDGE_NONE: Float;
  EXTEND_EDGE_RIGHT: Float;
  EXTEND_EDGE_TOP: Float;
  FACE_DOWN: Float;
  FACE_UP: Float;
  FILL: String;
  INHERIT: String;
  INPUT_BORDERSTYLE_BEZEL: Float;
  INPUT_BORDERSTYLE_LINE: Float;
  INPUT_BORDERSTYLE_NONE: Float;
  INPUT_BORDERSTYLE_ROUNDED: Float;
  INPUT_BUTTONMODE_ALWAYS: Float;
  INPUT_BUTTONMODE_NEVER: Float;
  INPUT_BUTTONMODE_ONBLUR: Float;
  INPUT_BUTTONMODE_ONFOCUS: Float;
  KEYBOARD_APPEARANCE_ALERT: Float;
  KEYBOARD_APPEARANCE_DEFAULT: Float;
  KEYBOARD_ASCII: Float;
  KEYBOARD_DECIMAL_PAD: Float;
  KEYBOARD_DEFAULT: Float;
  KEYBOARD_EMAIL: Float;
  KEYBOARD_NAMEPHONE_PAD: Float;
  KEYBOARD_NUMBERS_PUNCTUATION: Float;
  KEYBOARD_NUMBER_PAD: Float;
  KEYBOARD_PHONE_PAD: Float;
  KEYBOARD_URL: Float;
  LANDSCAPE_LEFT: Float;
  LANDSCAPE_RIGHT: Float;
  LIST_ACCESSORY_TYPE_CHECKMARK: Float;
  LIST_ACCESSORY_TYPE_DETAIL: Float;
  LIST_ACCESSORY_TYPE_DISCLOSURE: Float;
  LIST_ACCESSORY_TYPE_NONE: Float;
  LIST_ITEM_TEMPLATE_CONTACTS: Float;
  LIST_ITEM_TEMPLATE_DEFAULT: Float;
  LIST_ITEM_TEMPLATE_SETTINGS: Float;
  LIST_ITEM_TEMPLATE_SUBTITLE: Float;
  NOTIFICATION_DURATION_LONG: Float;
  NOTIFICATION_DURATION_SHORT: Float;
  PICKER_TYPE_COUNT_DOWN_TIMER: Float;
  PICKER_TYPE_DATE: Float;
  PICKER_TYPE_DATE_AND_TIME: Float;
  PICKER_TYPE_PLAIN: Float;
  PICKER_TYPE_TIME: Float;
  PORTRAIT: Float;
  RETURNKEY_DEFAULT: Float;
  RETURNKEY_DONE: Float;
  RETURNKEY_EMERGENCY_CALL: Float;
  RETURNKEY_GO: Float;
  RETURNKEY_GOOGLE: Float;
  RETURNKEY_JOIN: Float;
  RETURNKEY_NEXT: Float;
  RETURNKEY_ROUTE: Float;
  RETURNKEY_SEARCH: Float;
  RETURNKEY_SEND: Float;
  RETURNKEY_YAHOO: Float;
  SIZE: String;
  TEXT_ALIGNMENT_CENTER: Variant;
  TEXT_ALIGNMENT_LEFT: Variant;
  TEXT_ALIGNMENT_RIGHT: Variant;
  TEXT_AUTOCAPITALIZATION_ALL: Float;
  TEXT_AUTOCAPITALIZATION_NONE: Float;
  TEXT_AUTOCAPITALIZATION_SENTENCES: Float;
  TEXT_AUTOCAPITALIZATION_WORDS: Float;
  TEXT_STYLE_BODY: String;
  TEXT_STYLE_CAPTION1: String;
  TEXT_STYLE_CAPTION2: String;
  TEXT_STYLE_FOOTNOTE: String;
  TEXT_STYLE_HEADLINE: String;
  TEXT_STYLE_SUBHEADLINE: String;
  TEXT_VERTICAL_ALIGNMENT_BOTTOM: Variant;
  TEXT_VERTICAL_ALIGNMENT_CENTER: Variant;
  TEXT_VERTICAL_ALIGNMENT_TOP: Variant;
  UNIT_CM: String;
  UNIT_DIP: String;
  UNIT_IN: String;
  UNIT_MM: String;
  UNIT_PX: String;
  UNKNOWN: Float;
  UPSIDE_PORTRAIT: Float;
  URL_ERROR_AUTHENTICATION: Float;
  URL_ERROR_BAD_URL: Float;
  URL_ERROR_CONNECT: Float;
  URL_ERROR_FILE: Float;
  URL_ERROR_FILE_NOT_FOUND: Float;
  URL_ERROR_HOST_LOOKUP: Float;
  URL_ERROR_REDIRECT_LOOP: Float;
  URL_ERROR_SSL_FAILED: Float;
  URL_ERROR_TIMEOUT: Float;
  URL_ERROR_UNKNOWN: Float;
  URL_ERROR_UNSUPPORTED_SCHEME: Float;
  apiName: String;
  backgroundColor: String;
  backgroundImage: String;
  bubbleParent: Boolean;
  currentTab: JTi.UI.Tab;
  currentWindow: JTi.UI.Window;
  orientation: Float;

//Geolocation

type
  JMobileWeb = class external
    forwardGeocoderTimeout: Float;
    locationTimeout: Float;
    maximumHeadingAge: Float;
    maximumLocationAge: Float;
    reverseGeocoderTimeout: Float;
    function getForwardGeocoderTimeout: Float;
    function getLocationTimeout: Float;
    function getMaximumHeadingAge: Float;
    function getMaximumLocationAge: Float;
    function getReverseGeocoderTimeout: Float;
    procedure setForwardGeocoderTimeout(forwardGeocoderTimeout: Float);
    procedure setLocationTimeout(locationTimeout: Float);
    procedure setMaximumHeadingAge(maximumHeadingAge: Float);
    procedure setMaximumLocationAge(maximumLocationAge: Float);
    procedure setReverseGeocoderTimeout(reverseGeocoderTimeout: Float);
  end;

//Android

type
  JLocationProvider = class external(JTi.Proxy)
    minUpdateDistance: Float;
    minUpdateTime: Float;
    name: String;
    function getMinUpdateDistance: Float;
    function getMinUpdateTime: Float;
    function getName: String;
    procedure setMinUpdateDistance(minUpdateDistance: Float);
    procedure setMinUpdateTime(minUpdateTime: Float);
    procedure setName(name: String);
  end;

  JLocationRule = class external(JTi.Proxy)
    accuracy: Float;
    maxAge: Float;
    minAge: Float;
    name: String;
    function getAccuracy: Float;
    function getMaxAge: Float;
    function getMinAge: Float;
    function getName: String;
    procedure setAccuracy(accuracy: Float);
    procedure setMaxAge(maxAge: Float);
    procedure setMinAge(minAge: Float);
    procedure setName(name: String);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure addLocationProvider(provider: JTi.Geolocation.Android.LocationProvider);
procedure addLocationRule(rule: JTi.Geolocation.Android.LocationRule);
procedure applyProperties(props: JDictionary{<JObject>});
function createLocationProvider: JTi.Geolocation.Android.LocationProvider; overload;
function createLocationProvider(parameters: JDictionary{<JTi.Geolocation.Android.LocationProvider>}): JTi.Geolocation.Android.LocationProvider; overload;
function createLocationRule: JTi.Geolocation.Android.LocationRule; overload;
function createLocationRule(parameters: JDictionary{<JTi.Geolocation.Android.LocationRule>}): JTi.Geolocation.Android.LocationRule; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
function getManualMode: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure removeLocationProvider(provider: JTi.Geolocation.Android.LocationProvider);
procedure removeLocationRule(rule: JTi.Geolocation.Android.LocationRule);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setManualMode(manualMode: Boolean);

var
  apiName: String;
  bubbleParent: Boolean;
  manualMode: Boolean;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
procedure forwardGeocoder(address: String; callback: (args: array of Variant): Variant);
function getAccuracy: Float;
function getActivityType: Float;
function getApiName: String;
function getBubbleParent: Boolean;
procedure getCurrentHeading(callback: (args: array of Variant): Variant);
procedure getCurrentPosition(callback: (args: array of Variant): Variant);
function getDistanceFilter: Float;
function getFrequency: Float;
function getHasCompass: Boolean;
function getHeadingFilter: Float;
function getLastGeolocation: String;
function getLocationServicesAuthorization: Float;
function getLocationServicesEnabled: Boolean;
function getPauseLocationUpdateAutomatically: Boolean;
function getPreferredProvider: String;
function getPurpose: String;
function getShowCalibration: Boolean;
function getTrackSignificantLocationChange: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure reverseGeocoder(latitude: Float; longitude: Float; callback: (args: array of Variant): Variant);
procedure setAccuracy(accuracy: Float);
procedure setActivityType(activityType: Float);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setDistanceFilter(distanceFilter: Float);
procedure setFrequency(frequency: Float);
procedure setHeadingFilter(headingFilter: Float);
procedure setLocationServicesAuthorization(locationServicesAuthorization: Float);
procedure setPauseLocationUpdateAutomatically(pauseLocationUpdateAutomatically: Boolean);
procedure setPreferredProvider(preferredProvider: String);
procedure setPurpose(purpose: String);
procedure setShowCalibration(showCalibration: Boolean);
procedure setTrackSignificantLocationChange(trackSignificantLocationChange: Boolean);

var
  ACCURACY_BEST: Float;
  ACCURACY_BEST_FOR_NAVIGATION: Float;
  ACCURACY_HIGH: Float;
  ACCURACY_HUNDRED_METERS: Float;
  ACCURACY_KILOMETER: Float;
  ACCURACY_LOW: Float;
  ACCURACY_NEAREST_TEN_METERS: Float;
  ACCURACY_THREE_KILOMETERS: Float;
  ACTIVITYTYPE_AUTOMOTIVE_NAVIGATION: String;
  ACTIVITYTYPE_FITNESS: String;
  ACTIVITYTYPE_OTHER: String;
  ACTIVITYTYPE_OTHER_NAVIGATION: String;
  AUTHORIZATION_ALWAYS: Float;
  AUTHORIZATION_AUTHORIZED: Float;
  AUTHORIZATION_DENIED: Float;
  AUTHORIZATION_RESTRICTED: Float;
  AUTHORIZATION_UNKNOWN: Float;
  AUTHORIZATION_WHEN_IN_USE: Float;
  ERROR_DENIED: Float;
  ERROR_HEADING_FAILURE: Float;
  ERROR_LOCATION_UNKNOWN: Float;
  ERROR_NETWORK: Float;
  ERROR_REGION_MONITORING_DELAYED: Float;
  ERROR_REGION_MONITORING_DENIED: Float;
  ERROR_REGION_MONITORING_FAILURE: Float;
  ERROR_TIMEOUT: Float;
  PROVIDER_GPS: String;
  PROVIDER_NETWORK: String;
  PROVIDER_PASSIVE: String;
  accuracy: Float;
  activityType: Float;
  apiName: String;
  bubbleParent: Boolean;
  distanceFilter: Float;
  frequency: Float;
  hasCompass: Boolean;
  headingFilter: Float;
  lastGeolocation: String;
  locationServicesAuthorization: Float;
  locationServicesEnabled: Boolean;
  pauseLocationUpdateAutomatically: Boolean;
  preferredProvider: String;
  purpose: String;
  showCalibration: Boolean;
  trackSignificantLocationChange: Boolean;

//Map

type
  JView = class external(JTi.UI.View)
    animated: Boolean;
    annotations: JArray{<JTi.Map.Annotation>};
    hideAnnotationWhenTouchMap: Boolean;
    latitudeDelta: Float;
    longitudeDelta: Float;
    mapType: Float;
    region: JMapRegionType;
    regionFit: Boolean;
    userLocation: Boolean;
    procedure addAnnotation(annotation: JDictionary{<JTi.Map.Annotation>});
    procedure addAnnotation(annotation: JTi.Map.Annotation);
    procedure addAnnotations(annotations: JArray{<JTi.Map.Annotation>});
    procedure addAnnotations(annotations: JArray{<JDictionary{<JTi.Map.Annotation>}>});
    procedure addRoute(route: JMapRouteType);
    procedure deselectAnnotation(annotation: String);
    procedure deselectAnnotation(annotation: JTi.Map.Annotation);
    function getAnimate: Boolean;
    function getAnimated: Boolean;
    function getAnnotations: JArray{<JTi.Map.Annotation>};
    function getHideAnnotationWhenTouchMap: Boolean;
    function getLatitudeDelta: Float;
    function getLongitudeDelta: Float;
    function getMapType: Float;
    function getRegion: JMapRegionType;
    function getRegionFit: Boolean;
    function getUserLocation: Boolean;
    procedure removeAllAnnotations;
    procedure removeAnnotation(annotation: String);
    procedure removeAnnotation(annotation: JTi.Map.Annotation);
    procedure removeAnnotations(annotations: JArray{<JString>});
    procedure removeAnnotations(annotations: JArray{<JTi.Map.Annotation>});
    procedure removeRoute(route: JMapRouteType);
    procedure selectAnnotation(annotation: String);
    procedure selectAnnotation(annotation: JTi.Map.Annotation);
    procedure setAnimate(animate: Boolean);
    procedure setAnimated(animated: Boolean);
    procedure setAnnotations(annotations: JArray{<JTi.Map.Annotation>});
    procedure setHideAnnotationWhenTouchMap(hideAnnotationWhenTouchMap: Boolean);
    procedure setLocation(location: JMapLocationType);
    procedure setMapType(mapType: Float);
    procedure setRegion(region: JMapRegionType);
    procedure setRegionFit(regionFit: Boolean);
    procedure setUserLocation(userLocation: Boolean);
    procedure zoom(level: Float);
  end;

  JAnnotation = class external(JTi.Proxy)
    animate: Boolean;
    canShowCallout: Boolean;
    centerOffset: JPoint;
    customView: JTi.UI.View;
    draggable: Boolean;
    image: Variant;
    latitude: Float;
    leftButton: Variant;
    leftView: JTi.UI.View;
    longitude: Float;
    pinImage: String;
    pincolor: Float;
    rightButton: Variant;
    rightView: JTi.UI.View;
    subtitle: String;
    subtitleid: String;
    title: String;
    titleid: String;
    function getAnimate: Boolean;
    function getCanShowCallout: Boolean;
    function getCenterOffset: JPoint;
    function getCustomView: JTi.UI.View;
    function getDraggable: Boolean;
    function getImage: Variant;
    function getLatitude: Float;
    function getLeftButton: Variant;
    function getLeftView: JTi.UI.View;
    function getLongitude: Float;
    function getPinImage: String;
    function getPincolor: Float;
    function getRightButton: Variant;
    function getRightView: JTi.UI.View;
    function getSubtitle: String;
    function getSubtitleid: String;
    function getTitle: String;
    function getTitleid: String;
    procedure setAnimate(animate: Boolean);
    procedure setCanShowCallout(canShowCallout: Boolean);
    procedure setCenterOffset(centerOffset: JPoint);
    procedure setCustomView(customView: JTi.UI.View);
    procedure setDraggable(draggable: Boolean);
    procedure setImage(image: String);
    procedure setImage(image: JTi.Blob);
    procedure setLatitude(latitude: Float);
    procedure setLeftButton(leftButton: Float);
    procedure setLeftButton(leftButton: String);
    procedure setLeftView(leftView: JTi.UI.View);
    procedure setLongitude(longitude: Float);
    procedure setPinImage(pinImage: String);
    procedure setPincolor(pincolor: Float);
    procedure setRightButton(rightButton: Float);
    procedure setRightButton(rightButton: String);
    procedure setRightView(rightView: JTi.UI.View);
    procedure setSubtitle(subtitle: String);
    procedure setSubtitleid(subtitleid: String);
    procedure setTitle(title: String);
    procedure setTitleid(titleid: String);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createAnnotation: JTi.Map.Annotation; overload;
function createAnnotation(parameters: JDictionary{<JTi.Map.Annotation>}): JTi.Map.Annotation; overload;
function createView: JTi.Map.View; overload;
function createView(parameters: JDictionary{<JTi.Map.View>}): JTi.Map.View; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  ANNOTATION_DRAG_STATE_CANCEL: Float;
  ANNOTATION_DRAG_STATE_DRAG: Float;
  ANNOTATION_DRAG_STATE_END: Float;
  ANNOTATION_DRAG_STATE_NONE: Float;
  ANNOTATION_DRAG_STATE_START: Float;
  ANNOTATION_GREEN: Float;
  ANNOTATION_PURPLE: Float;
  ANNOTATION_RED: Float;
  HYBRID_TYPE: Float;
  SATELLITE_TYPE: Float;
  STANDARD_TYPE: Float;
  TERRAIN_TYPE: Float;
  apiName: String;
  bubbleParent: Boolean;

//Cloud

type
  JObjects = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show; overload;
    procedure show(parameters: JDictionary{<JObject>}); overload;
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JSocialIntegrations = class external
    procedure externalAccountLink(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure externalAccountLogin(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure externalAccountUnlink(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure searchFacebookFriends(callback: (args: array of Variant): Variant);
  end;

  JPushNotifications = class external
    procedure notify(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure notifyTokens(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure queryChannels(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure resetBadge(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure setBadge(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showChannels(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure subscribe(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure subscribeToken(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure unsubscribe(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure unsubscribeToken(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure updateSubscription(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JClients = class external
    procedure geolocate; overload;
    procedure geolocate(parameters: JDictionary{<JObject>}); overload;
    procedure geolocate(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
  end;

  JACLs = class external
    procedure addUser(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure checkUser(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure removeUser(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update; overload;
    procedure update(parameters: JDictionary{<JObject>}); overload;
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
  end;

  JUsers = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure login(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure logout(callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure requestResetPassword(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure resendConfirmation(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search; overload;
    procedure search(parameters: JDictionary{<JObject>}); overload;
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure secureCreate; overload;
    procedure secureCreate(parameters: JDictionary{<JCloudUsersSecureDialog>}); overload;
    procedure secureCreate(parameters: JDictionary{<JCloudUsersSecureDialog>}; callback: (args: array of Variant): Variant); overload;
    procedure secureLogin; overload;
    procedure secureLogin(parameters: JDictionary{<JCloudUsersSecureDialog>}); overload;
    procedure secureLogin(parameters: JDictionary{<JCloudUsersSecureDialog>}; callback: (args: array of Variant): Variant); overload;
    function secureStatus: Boolean;
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showMe(callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JMessages = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure removeThread(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure reply; overload;
    procedure reply(parameters: JDictionary{<JObject>}); overload;
    procedure reply(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showInbox(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showSent(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showThread(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showThreads(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JEvents = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure queryOccurrences; overload;
    procedure queryOccurrences(parameters: JDictionary{<JObject>}); overload;
    procedure queryOccurrences(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search; overload;
    procedure search(parameters: JDictionary{<JObject>}); overload;
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure searchOccurrences; overload;
    procedure searchOccurrences(parameters: JDictionary{<JObject>}); overload;
    procedure searchOccurrences(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure show; overload;
    procedure show(parameters: JDictionary{<JObject>}); overload;
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure showOccurrences; overload;
    procedure showOccurrences(parameters: JDictionary{<JObject>}); overload;
    procedure showOccurrences(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JReviews = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JChats = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure getChatGroups; overload;
    procedure getChatGroups(parameters: JDictionary{<JObject>}); overload;
    procedure getChatGroups(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure queryChatGroups; overload;
    procedure queryChatGroups(parameters: JDictionary{<JObject>}); overload;
    procedure queryChatGroups(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JKeyValues = class external
    procedure append(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure get(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure increment(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure set(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JGeoFences = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JCheckins = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JFriends = class external
    procedure add(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure approve(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure requests(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JFiles = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JPushSchedules = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JLikes = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JPhotos = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JStatuses = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure delete(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JPhotoCollections = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showPhotos(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure showSubCollections(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JPosts = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JEmails = class external
    procedure send(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

  JPlaces = class external
    procedure create(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure query; overload;
    procedure query(parameters: JDictionary{<JObject>}); overload;
    procedure query(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure remove(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure search; overload;
    procedure search(parameters: JDictionary{<JObject>}); overload;
    procedure search(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant); overload;
    procedure show(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
    procedure update(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
  end;

procedure applyProperties(props: JDictionary{<JObject>});
function getAccessToken: String;
function getApiName: String;
function getBubbleParent: Boolean;
function getDebug: Boolean;
function getExpiresIn: Float;
function getOndatastream: (args: array of Variant): Variant;
function getOnsendstream: (args: array of Variant): Variant;
function getSessionId: String;
function getUseSecure: Boolean;
function hasStoredSession: Boolean;
function retrieveStoredSession: String;
procedure sendRequest(parameters: JDictionary{<JObject>}; callback: (args: array of Variant): Variant);
procedure setAccessToken(accessToken: String);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setDebug(debug: Boolean);
procedure setOndatastream(ondatastream: (args: array of Variant): Variant);
procedure setOnsendstream(onsendstream: (args: array of Variant): Variant);
procedure setSessionId(sessionId: String);
procedure setUseSecure(useSecure: Boolean);

var
  accessToken: String;
  apiName: String;
  bubbleParent: Boolean;
  debug: Boolean;
  expiresIn: Float;
  ondatastream: (args: array of Variant): Variant;
  onsendstream: (args: array of Variant): Variant;
  sessionId: String;
  useSecure: Boolean;

//App

type
  JProperties = class external
    function getBool(&property: String): Boolean; overload;
    function getBool(&property: String; _default: Boolean): Boolean; overload;
    function getDouble(&property: String): Float; overload;
    function getDouble(&property: String; _default: Float): Float; overload;
    function getInt(&property: String): Float; overload;
    function getInt(&property: String; _default: Float): Float; overload;
    function getList(&property: String): JArray{<JObject>}; overload;
    function getList(&property: String; _default: JArray{<JObject>}): JArray{<JObject>}; overload;
    function getObject(&property: String): Variant; overload;
    function getObject(&property: String; _default: Variant): Variant; overload;
    function getString(&property: String): String; overload;
    function getString(&property: String; _default: String): String; overload;
    function hasProperty(&property: String): Boolean;
    function listProperties: JArray{<JObject>};
    procedure removeProperty(&property: String);
    procedure setBool(&property: String; value: Boolean);
    procedure setDouble(&property: String; value: Float);
    procedure setInt(&property: String; value: Float);
    procedure setList(&property: String; value: JArray{<JObject>});
    procedure setObject(&property: String; value: Variant);
    procedure setString(&property: String; value: String);
  end;

  JTizen = class external
    categories: JArray{<JString>};
    iconPath: String;
    id: String;
    installDate: JDate;
    name: String;
    show: Boolean;
    size: Float;
    procedure exit;
    function getCategories: JArray{<JString>};
    function getIconPath: String;
    function getId: String;
    function getInstallDate: JDate;
    function getName: String;
    function getShow: Boolean;
    function getSize: Float;
    procedure hide;
  end;

//Android

type
  JR = class external
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getAppVersionCode: Float;
function getAppVersionName: String;
function getBubbleParent: Boolean;
function getLaunchIntent: JTi.Android.Intent;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  R: JTi.App.Android.R;
  apiName: String;
  appVersionCode: Float;
  appVersionName: String;
  bubbleParent: Boolean;
  launchIntent: JTi.Android.Intent;

//iOS

type
  JUserNotificationAction = class external(JTi.Proxy)
    activationMode: Float;
    authenticationRequired: Boolean;
    destructive: Boolean;
    identifier: String;
    title: String;
    function getActivationMode: Float;
    function getAuthenticationRequired: Boolean;
    function getDestructive: Boolean;
    function getIdentifier: String;
    function getTitle: String;
  end;

  JLocalNotification = class external(JTi.Proxy)
    procedure cancel;
  end;

  JUserNotificationCategory = class external(JTi.Proxy)
    actionsForDefaultContext: JArray{<JTi.App.iOS.UserNotificationAction>};
    actionsForMinimalContext: JArray{<JTi.App.iOS.UserNotificationAction>};
    identifier: String;
    function getActionsForDefaultContext: JArray{<JTi.App.iOS.UserNotificationAction>};
    function getActionsForMinimalContext: JArray{<JTi.App.iOS.UserNotificationAction>};
    function getIdentifier: String;
  end;

  JBackgroundService = class external(JTi.Proxy)
    url: String;
    function getUrl: String;
    procedure stop;
    procedure unregister;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure cancelAllLocalNotifications;
procedure cancelLocalNotification(id: Float);
procedure cancelLocalNotification(id: String);
function createUserNotificationAction: JTi.App.iOS.UserNotificationAction; overload;
function createUserNotificationAction(parameters: JDictionary{<JTi.App.iOS.UserNotificationAction>}): JTi.App.iOS.UserNotificationAction; overload;
function createUserNotificationCategory: JTi.App.iOS.UserNotificationCategory; overload;
function createUserNotificationCategory(parameters: JDictionary{<JTi.App.iOS.UserNotificationCategory>}): JTi.App.iOS.UserNotificationCategory; overload;
procedure endBackgroundHandler(handlerID: String);
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getApplicationOpenSettingsURL: String;
function getBubbleParent: Boolean;
function getCurrentUserNotificationSettings: JUserNotificationSettings;
function registerBackgroundService(params: JDictionary{<JObject>}): JTi.App.iOS.BackgroundService;
procedure registerUserNotificationSettings(params: JUserNotificationSettings);
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
function scheduleLocalNotification(params: JNotificationParams): JTi.App.iOS.LocalNotification;
procedure setBubbleParent(bubbleParent: Boolean);
procedure setMinimumBackgroundFetchInterval(fetchInterval: Float);

var
  BACKGROUNDFETCHINTERVAL_MIN: Float;
  BACKGROUNDFETCHINTERVAL_NEVER: Float;
  EVENT_ACCESSIBILITY_LAYOUT_CHANGED: String;
  EVENT_ACCESSIBILITY_SCREEN_CHANGED: String;
  USER_NOTIFICATION_ACTIVATION_MODE_BACKGROUND: Float;
  USER_NOTIFICATION_ACTIVATION_MODE_FOREGROUND: Float;
  USER_NOTIFICATION_TYPE_ALERT: Float;
  USER_NOTIFICATION_TYPE_BADGE: Float;
  USER_NOTIFICATION_TYPE_NONE: Float;
  USER_NOTIFICATION_TYPE_SOUND: Float;
  apiName: String;
  applicationOpenSettingsURL: String;
  bubbleParent: Boolean;
  currentUserNotificationSettings: JUserNotificationSettings;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
procedure fireSystemEvent(eventName: String); overload;
procedure fireSystemEvent(eventName: String; param: Variant); overload;
function getAccessibilityEnabled: Boolean;
function getAnalytics: Boolean;
function getApiName: String;
function getArguments: JlaunchOptions;
function getBubbleParent: Boolean;
function getCopyright: String;
function getDeployType: String;
function getDescription: String;
function getDisableNetworkActivityIndicator: Boolean;
function getForceSplashAsSnapshot: Boolean;
function getGuid: String;
function getId: String;
function getIdleTimerDisabled: Boolean;
function getInstallId: String;
function getKeyboardVisible: Boolean;
function getName: String;
function getProximityDetection: Boolean;
function getProximityState: Boolean;
function getPublisher: String;
function getSessionId: String;
function getUrl: String;
function getVersion: String;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setDisableNetworkActivityIndicator(disableNetworkActivityIndicator: Boolean);
procedure setForceSplashAsSnapshot(forceSplashAsSnapshot: Boolean);
procedure setIdleTimerDisabled(idleTimerDisabled: Boolean);
procedure setProximityDetection(proximityDetection: Boolean);

var
  EVENT_ACCESSIBILITY_ANNOUNCEMENT: String;
  EVENT_ACCESSIBILITY_CHANGED: String;
  accessibilityEnabled: Boolean;
  analytics: Boolean;
  apiName: String;
  bubbleParent: Boolean;
  copyright: String;
  deployType: String;
  description: String;
  disableNetworkActivityIndicator: Boolean;
  forceSplashAsSnapshot: Boolean;
  guid: String;
  id: String;
  idleTimerDisabled: Boolean;
  installId: String;
  keyboardVisible: Boolean;
  name: String;
  proximityDetection: Boolean;
  proximityState: Boolean;
  publisher: String;
  sessionId: String;
  url: String;
  version: String;

//Android

type
  JIntent = class external(JTi.Proxy)
    action: String;
    className: String;
    data: String;
    flags: Float;
    packageName: String;
    &type: String;
    url: String;
    procedure addCategory(name: String);
    procedure addFlags(flags: Float);
    function getAction: String;
    function getBlobExtra(name: String): JTi.Blob;
    function getBooleanExtra(name: String): Boolean;
    function getClassName: String;
    function getData: String;
    function getDoubleExtra(name: String): Float;
    function getFlags: Float;
    function getIntExtra(name: String): Float;
    function getLongExtra(name: String): Float;
    function getPackageName: String;
    function getStringExtra(name: String): String;
    function getType: String;
    function getUrl: String;
    function hasExtra(name: String): Boolean;
    procedure putExtra(name: String; value: Variant);
    procedure putExtraUri(name: String; value: String);
    procedure setFlags(flags: Float);
  end;

  JNotification = class external(JTi.Proxy)
    audioStreamType: Float;
    contentIntent: JTi.Android.PendingIntent;
    contentText: String;
    contentTitle: String;
    contentView: JTi.Android.RemoteViews;
    defaults: Float;
    deleteIntent: JTi.Android.PendingIntent;
    flags: Float;
    icon: Variant;
    ledARGB: Float;
    ledOffMS: Float;
    ledOnMS: Float;
    number: Float;
    sound: String;
    tickerText: String;
    when: Variant;
    function getAudioStreamType: Float;
    function getContentIntent: JTi.Android.PendingIntent;
    function getContentText: String;
    function getContentTitle: String;
    function getDefaults: Float;
    function getDeleteIntent: JTi.Android.PendingIntent;
    function getFlags: Float;
    function getIcon: Variant;
    function getLedARGB: Float;
    function getLedOffMS: Float;
    function getLedOnMS: Float;
    function getNumber: Float;
    function getSound: String;
    function getTickerText: String;
    function getWhen: Variant;
    procedure setAudioStreamType(audioStreamType: Float);
    procedure setContentIntent(contentIntent: JTi.Android.PendingIntent);
    procedure setContentText(contentText: String);
    procedure setContentTitle(contentTitle: String);
    procedure setContentView(contentView: JTi.Android.RemoteViews);
    procedure setDefaults(defaults: Float);
    procedure setDeleteIntent(deleteIntent: JTi.Android.PendingIntent);
    procedure setFlags(flags: Float);
    procedure setIcon(icon: Float);
    procedure setIcon(icon: String);
    procedure setLatestEventInfo(contentTitle: String; contentText: String; contentIntent: JTi.Android.PendingIntent);
    procedure setLedARGB(ledARGB: Float);
    procedure setLedOffMS(ledOffMS: Float);
    procedure setLedOnMS(ledOnMS: Float);
    procedure setNumber(number: Float);
    procedure setSound(sound: String);
    procedure setTickerText(tickerText: String);
    procedure setWhen(when: JDate);
    procedure setWhen(when: Float);
  end;

  JMenuItem = class external(JTi.Proxy)
    actionView: JTi.UI.View;
    actionViewExpanded: Boolean;
    checkable: Boolean;
    checked: Boolean;
    enabled: Boolean;
    groupId: Float;
    icon: Variant;
    itemId: Float;
    order: Float;
    showAsAction: Float;
    title: String;
    titleCondensed: String;
    visible: Boolean;
    procedure collapseActionView;
    procedure expandActionView;
    function getActionView: JTi.UI.View;
    function getGroupId: Float;
    function getItemId: Float;
    function getOrder: Float;
    function getTitle: String;
    function getTitleCondensed: String;
    function isActionViewExpanded: Boolean;
    function isCheckable: Boolean;
    function isChecked: Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure setActionView(actionView: JTi.UI.View);
    procedure setCheckable(checkable: Boolean);
    procedure setChecked(enabled: Boolean);
    procedure setEnabled(enabled: Boolean);
    procedure setIcon(icon: Float);
    procedure setIcon(icon: String);
    procedure setShowAsAction(showAsAction: Float);
    procedure setTitle(title: String);
    procedure setTitleCondensed(titleCondensed: String);
    procedure setVisible(visible: Boolean);
  end;

  JNotificationManager = class external
    DEFAULT_ALL: Float;
    DEFAULT_LIGHTS: Float;
    DEFAULT_SOUND: Float;
    DEFAULT_VIBRATE: Float;
    FLAG_AUTO_CANCEL: Float;
    FLAG_INSISTENT: Float;
    FLAG_NO_CLEAR: Float;
    FLAG_ONGOING_EVENT: Float;
    FLAG_ONLY_ALERT_ONCE: Float;
    FLAG_SHOW_LIGHTS: Float;
    STREAM_DEFAULT: Float;
    procedure cancel(id: Float);
    procedure cancelAll;
    procedure notify(id: Float; notification: JTi.Android.Notification);
  end;

  JR = class external(JTi.Proxy)
    anim: Variant;
    array: Variant;
    attr: Variant;
    color: Variant;
    dimen: Variant;
    drawable: Variant;
    id: Variant;
    integer: Variant;
    layout: Variant;
    &string: Variant;
    style: Variant;
    styleable: Variant;
  end;

  JActionBar = class external(JTi.Proxy)
    backgroundImage: String;
    displayHomeAsUp: Boolean;
    homeButtonEnabled: Boolean;
    icon: String;
    logo: String;
    navigationMode: Float;
    onHomeIconItemSelected: (args: array of Variant): Variant;
    subtitle: String;
    title: String;
    function getNavigationMode: Float;
    function getSubtitle: String;
    function getTitle: String;
    procedure hide;
    procedure setBackgroundImage(backgroundImage: String);
    procedure setDisplayHomeAsUp(displayHomeAsUp: Boolean);
    procedure setDisplayShowHomeEnabled(show: Boolean);
    procedure setDisplayShowTitleEnabled(show: Boolean);
    procedure setHomeButtonEnabled(homeButtonEnabled: Boolean);
    procedure setIcon(icon: String);
    procedure setLogo(logo: String);
    procedure setNavigationMode(navigationMode: Float);
    procedure setOnHomeIconItemSelected(onHomeIconItemSelected: (args: array of Variant): Variant);
    procedure setSubtitle(subtitle: String);
    procedure setTitle(title: String);
    procedure show;
  end;

  JBroadcastReceiver = class external(JTi.Proxy)
    onReceived: (args: array of Variant): Variant;
    url: String;
    function getOnReceived: (args: array of Variant): Variant;
    function getUrl: String;
    procedure setOnReceived(onReceived: (args: array of Variant): Variant);
    procedure setUrl(url: String);
  end;

  JMenu = class external(JTi.Proxy)
    items: JArray{<JTi.Android.MenuItem>};
    function add(options: Variant): JTi.Android.MenuItem;
    procedure clear;
    procedure close;
    function findItem(item: Float): JTi.Android.MenuItem;
    function findItem(item: JTi.Android.MenuItem): JTi.Android.MenuItem;
    function getItem(index: Float): JTi.Android.MenuItem;
    function getItems: JArray{<JTi.Android.MenuItem>};
    function hasVisibleItems: Boolean;
    procedure removeGroup(groupId: Float);
    procedure removeItem(itemId: Float);
    procedure setGroupEnabled(groupId: Float; enabled: Boolean);
    procedure setGroupVisible(groupId: Float; visible: Boolean);
    function size: Float;
  end;

  JActivity = class external(JTi.Proxy)
    actionBar: JTi.Android.ActionBar;
    intent: JTi.Android.Intent;
    onCreate: (args: array of Variant): Variant;
    onCreateOptionsMenu: (args: array of Variant): Variant;
    onDestroy: (args: array of Variant): Variant;
    onPause: (args: array of Variant): Variant;
    onPrepareOptionsMenu: (args: array of Variant): Variant;
    onRestart: (args: array of Variant): Variant;
    onResume: (args: array of Variant): Variant;
    onStart: (args: array of Variant): Variant;
    onStop: (args: array of Variant): Variant;
    requestedOrientation: Float;
    procedure finish;
    function getActionBar: JTi.Android.ActionBar;
    function getIntent: JTi.Android.Intent;
    function getOnCreate: (args: array of Variant): Variant;
    function getOnCreateOptionsMenu: (args: array of Variant): Variant;
    function getOnDestroy: (args: array of Variant): Variant;
    function getOnPause: (args: array of Variant): Variant;
    function getOnPrepareOptionsMenu: (args: array of Variant): Variant;
    function getOnRestart: (args: array of Variant): Variant;
    function getOnResume: (args: array of Variant): Variant;
    function getOnStart: (args: array of Variant): Variant;
    function getOnStop: (args: array of Variant): Variant;
    function getString(resourceId: Float; format: Variant): String;
    procedure invalidateOptionsMenu;
    procedure openOptionsMenu;
    procedure sendBroadcast(intent: JTi.Android.Intent);
    procedure sendBroadcastWithPermission(intent: JTi.Android.Intent); overload;
    procedure sendBroadcastWithPermission(intent: JTi.Android.Intent; receiverPermission: String); overload;
    procedure setOnCreate(onCreate: (args: array of Variant): Variant);
    procedure setOnCreateOptionsMenu(onCreateOptionsMenu: (args: array of Variant): Variant);
    procedure setOnDestroy(onDestroy: (args: array of Variant): Variant);
    procedure setOnPause(onPause: (args: array of Variant): Variant);
    procedure setOnPrepareOptionsMenu(onPrepareOptionsMenu: (args: array of Variant): Variant);
    procedure setOnRestart(onRestart: (args: array of Variant): Variant);
    procedure setOnResume(onResume: (args: array of Variant): Variant);
    procedure setOnStart(onStart: (args: array of Variant): Variant);
    procedure setOnStop(onStop: (args: array of Variant): Variant);
    procedure setRequestedOrientation(orientation: Float);
    procedure setResult(resultCode: Float); overload;
    procedure setResult(resultCode: Float; intent: JTi.Android.Intent); overload;
    procedure startActivity(intent: JTi.Android.Intent);
    procedure startActivityForResult(intent: JTi.Android.Intent; callback: (args: array of Variant): Variant);
  end;

  JService = class external(JTi.Proxy)
    intent: JTi.Android.Intent;
    serviceInstanceId: Float;
    function getIntent: JTi.Android.Intent;
    function getServiceInstanceId: Float;
    procedure start;
    procedure stop;
  end;

  JRemoteViews = class external(JTi.Proxy)
    layoutId: Float;
    packageName: String;
    function getLayoutId: Float;
    function getPackageName: String;
    procedure setBoolean(viewId: Float; methodName: String; value: Boolean);
    procedure setChronometer(viewId: Float; base: JDate; format: String; started: Boolean);
    procedure setDouble(viewId: Float; methodName: String; value: Float);
    procedure setImageViewResource(viewId: Float; srcId: Float);
    procedure setImageViewUri(viewId: Float; uri: String);
    procedure setInt(viewId: Float; methodName: String; value: Float);
    procedure setOnClickPendingIntent(viewId: Float; pendingIntent: JTi.Android.PendingIntent);
    procedure setProgressBar(viewId: Float; max: Float; progress: Float; indeterminate: Boolean);
    procedure setString(viewId: Float; methodName: String; value: String);
    procedure setTextColor(viewId: Float; color: Float);
    procedure setTextViewText(viewId: Float; text: String);
    procedure setUri(viewId: Float; methodName: String; value: String);
    procedure setViewVisibility(viewId: Float; visibility: Float);
  end;

  JPendingIntent = class external(JTi.Proxy)
    flags: Float;
    intent: JTi.Android.Intent;
    updateCurrentIntent: Boolean;
    function getFlags: Float;
    function getIntent: JTi.Android.Intent;
    function getUpdateCurrentIntent: Boolean;
  end;

//Calendar

type
  JEvent = class external(JTi.Proxy)
    alerts: JArray{<JTi.Android.Calendar.Alert>};
    allDay: Boolean;
    begin: JDate;
    description: String;
    &end: JDate;
    extendedProperties: JDictionary{<JObject>};
    hasAlarm: Boolean;
    hasExtendedProperties: Boolean;
    id: String;
    location: String;
    reminders: JArray{<JTi.Android.Calendar.Reminder>};
    status: Float;
    title: String;
    visibility: Float;
    function createAlert(data: JDictionary{<JTi.Android.Calendar.Alert>}): JTi.Android.Calendar.Alert;
    function createReminder(data: JDictionary{<JTi.Android.Calendar.Reminder>}): JTi.Android.Calendar.Reminder;
    function getAlerts: JArray{<JTi.Android.Calendar.Alert>};
    function getAllDay: Boolean;
    function getBegin: JDate;
    function getDescription: String;
    function getEnd: JDate;
    function getExtendedProperties: JDictionary{<JObject>};
    function getExtendedProperty(name: String): String;
    function getHasAlarm: Boolean;
    function getHasExtendedProperties: Boolean;
    function getId: String;
    function getLocation: String;
    function getReminders: JArray{<JTi.Android.Calendar.Reminder>};
    function getStatus: Float;
    function getTitle: String;
    function getVisibility: Float;
    procedure setExtendedProperty(name: String; value: String);
  end;

  JReminder = class external(JTi.Proxy)
    id: String;
    method: Float;
    minutes: Float;
    function getId: String;
    function getMethod: Float;
    function getMinutes: Float;
  end;

  JCalendar = class external(JTi.Proxy)
    hidden: Boolean;
    id: String;
    name: String;
    selected: Boolean;
    function createEvent(properties: JDictionary{<JTi.Android.Calendar.Event>}): JTi.Android.Calendar.Event;
    function getEventById(id: Float): JTi.Android.Calendar.Event;
    function getEventsBetweenDates(date1: JDate; date2: JDate): JArray{<JTi.Android.Calendar.Event>};
    function getEventsInDate(year: Float; month: Float; day: Float): JArray{<JTi.Android.Calendar.Event>};
    function getEventsInMonth(year: Float; month: Float): JArray{<JTi.Android.Calendar.Event>};
    function getEventsInYear(year: Float): JArray{<JTi.Android.Calendar.Event>};
    function getHidden: Boolean;
    function getId: String;
    function getName: String;
    function getSelected: Boolean;
  end;

  JAlert = class external(JTi.Proxy)
    alarmTime: JDate;
    begin: JDate;
    &end: JDate;
    eventId: Float;
    id: String;
    minutes: Float;
    state: Float;
    function getAlarmTime: JDate;
    function getBegin: JDate;
    function getEnd: JDate;
    function getEventId: Float;
    function getId: String;
    function getMinutes: Float;
    function getState: Float;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAllAlerts: JArray{<JTi.Android.Calendar.Alert>};
function getAllCalendars: JArray{<JTi.Android.Calendar.Calendar>};
function getApiName: String;
function getBubbleParent: Boolean;
function getCalendarById(id: Float): JTi.Android.Calendar.Calendar;
function getSelectableCalendars: JArray{<JTi.Android.Calendar.Calendar>};
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  METHOD_ALERT: Float;
  METHOD_DEFAULT: Float;
  METHOD_EMAIL: Float;
  METHOD_SMS: Float;
  STATE_DISMISSED: Float;
  STATE_FIRED: Float;
  STATE_SCHEDULED: Float;
  STATUS_CANCELED: Float;
  STATUS_CONFIRMED: Float;
  STATUS_TENTATIVE: Float;
  VISIBILITY_CONFIDENTIAL: Float;
  VISIBILITY_DEFAULT: Float;
  VISIBILITY_PRIVATE: Float;
  VISIBILITY_PUBLIC: Float;
  allAlerts: JArray{<JTi.Android.Calendar.Alert>};
  allCalendars: JArray{<JTi.Android.Calendar.Calendar>};
  apiName: String;
  bubbleParent: Boolean;
  selectableCalendars: JArray{<JTi.Android.Calendar.Calendar>};

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createBroadcastIntent(options: JBroadcastIntentOptions): JTi.Android.Intent;
function createBroadcastReceiver: JTi.Android.BroadcastReceiver; overload;
function createBroadcastReceiver(parameters: JDictionary{<JTi.Android.BroadcastReceiver>}): JTi.Android.BroadcastReceiver; overload;
function createIntent: JTi.Android.Intent; overload;
function createIntent(parameters: JDictionary{<JTi.Android.Intent>}): JTi.Android.Intent; overload;
function createIntentChooser(intent: JTi.Android.Intent; title: String): JTi.Android.Intent;
function createNotification: JTi.Android.Notification; overload;
function createNotification(parameters: JDictionary{<JTi.Android.Notification>}): JTi.Android.Notification; overload;
function createPendingIntent: JTi.Android.PendingIntent; overload;
function createPendingIntent(parameters: JDictionary{<JTi.Android.PendingIntent>}): JTi.Android.PendingIntent; overload;
function createRemoteViews: JTi.Android.RemoteViews; overload;
function createRemoteViews(parameters: JDictionary{<JTi.Android.RemoteViews>}): JTi.Android.RemoteViews; overload;
function createService(intent: JTi.Android.Intent): JTi.Android.Service;
function createServiceIntent(options: JServiceIntentOptions): JTi.Android.Intent;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
function getCurrentActivity: JTi.Android.Activity;
function getCurrentService: JTi.Android.Service;
function isServiceRunning(intent: JTi.Android.Intent): Boolean;
procedure registerBroadcastReceiver(broadcastReceiver: JTi.Android.BroadcastReceiver; actions: JArray{<JString>});
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);
procedure startService(intent: JTi.Android.Intent);
procedure stopService(intent: JTi.Android.Intent);
procedure unregisterBroadcastReceiver(broadcastReceiver: JTi.Android.BroadcastReceiver);

var
  ACTION_AIRPLANE_MODE_CHANGED: String;
  ACTION_ALL_APPS: String;
  ACTION_ANSWER: String;
  ACTION_ATTACH_DATA: String;
  ACTION_BATTERY_CHANGED: String;
  ACTION_BATTERY_LOW: String;
  ACTION_BATTERY_OKAY: String;
  ACTION_BOOT_COMPLETED: String;
  ACTION_BUG_REPORT: String;
  ACTION_CALL: String;
  ACTION_CALL_BUTTON: String;
  ACTION_CAMERA_BUTTON: String;
  ACTION_CHOOSER: String;
  ACTION_CLOSE_SYSTEM_DIALOGS: String;
  ACTION_CONFIGURATION_CHANGED: String;
  ACTION_CREATE_SHORTCUT: String;
  ACTION_DATE_CHANGED: String;
  ACTION_DEFAULT: String;
  ACTION_DELETE: String;
  ACTION_DEVICE_STORAGE_LOW: String;
  ACTION_DIAL: String;
  ACTION_EDIT: String;
  ACTION_GET_CONTENT: String;
  ACTION_GTALK_SERVICE_CONNECTED: String;
  ACTION_GTALK_SERVICE_DISCONNECTED: String;
  ACTION_HEADSET_PLUG: String;
  ACTION_INPUT_METHOD_CHANGED: String;
  ACTION_INSERT: String;
  ACTION_INSERT_OR_EDIT: String;
  ACTION_MAIN: String;
  ACTION_MANAGE_PACKAGE_STORAGE: String;
  ACTION_MEDIA_BAD_REMOVAL: String;
  ACTION_MEDIA_BUTTON: String;
  ACTION_MEDIA_CHECKING: String;
  ACTION_MEDIA_EJECT: String;
  ACTION_MEDIA_MOUNTED: String;
  ACTION_MEDIA_NOFS: String;
  ACTION_MEDIA_REMOVED: String;
  ACTION_MEDIA_SCANNER_FINISHED: String;
  ACTION_MEDIA_SCANNER_SCAN_FILE: String;
  ACTION_MEDIA_SCANNER_STARTED: String;
  ACTION_MEDIA_SHARED: String;
  ACTION_MEDIA_UNMOUNTABLE: String;
  ACTION_MEDIA_UNMOUNTED: String;
  ACTION_NEW_OUTGOING_CALL: String;
  ACTION_PACKAGE_ADDED: String;
  ACTION_PACKAGE_CHANGED: String;
  ACTION_PACKAGE_DATA_CLEARED: String;
  ACTION_PACKAGE_INSTALL: String;
  ACTION_PACKAGE_REMOVED: String;
  ACTION_PACKAGE_REPLACED: String;
  ACTION_PACKAGE_RESTARTED: String;
  ACTION_PICK: String;
  ACTION_PICK_ACTIVITY: String;
  ACTION_POWER_CONNECTED: String;
  ACTION_POWER_DISCONNECTED: String;
  ACTION_POWER_USAGE_SUMMARY: String;
  ACTION_PROVIDER_CHANGED: String;
  ACTION_REBOOT: String;
  ACTION_RUN: String;
  ACTION_SCREEN_OFF: String;
  ACTION_SCREEN_ON: String;
  ACTION_SEARCH: String;
  ACTION_SEARCH_LONG_PRESS: String;
  ACTION_SEND: String;
  ACTION_SENDTO: String;
  ACTION_SEND_MULTIPLE: String;
  ACTION_SET_WALLPAPER: String;
  ACTION_SHUTDOWN: String;
  ACTION_SYNC: String;
  ACTION_SYSTEM_TUTORIAL: String;
  ACTION_TIME_CHANGED: String;
  ACTION_TIME_TICK: String;
  ACTION_UID_REMOVED: String;
  ACTION_UMS_CONNECTED: String;
  ACTION_UMS_DISCONNECTED: String;
  ACTION_USER_PRESENT: String;
  ACTION_VIEW: String;
  ACTION_VOICE_COMMAND: String;
  ACTION_WALLPAPER_CHANGED: String;
  ACTION_WEB_SEARCH: String;
  CATEGORY_ALTERNATIVE: String;
  CATEGORY_BROWSABLE: String;
  CATEGORY_DEFAULT: String;
  CATEGORY_DEVELOPMENT_PREFERENCE: String;
  CATEGORY_EMBED: String;
  CATEGORY_FRAMEWORK_INSTRUMENTATION_TEST: String;
  CATEGORY_HOME: String;
  CATEGORY_INFO: String;
  CATEGORY_LAUNCHER: String;
  CATEGORY_MONKEY: String;
  CATEGORY_OPENABLE: String;
  CATEGORY_PREFERENCE: String;
  CATEGORY_SAMPLE_CODE: String;
  CATEGORY_SELECTED_ALTERNATIVE: String;
  CATEGORY_TAB: String;
  CATEGORY_TEST: String;
  CATEGORY_UNIT_TEST: String;
  DEFAULT_ALL: Float;
  DEFAULT_LIGHTS: Float;
  DEFAULT_SOUND: Float;
  DEFAULT_VIBRATE: Float;
  EXTRA_ALARM_COUNT: String;
  EXTRA_BCC: String;
  EXTRA_CC: String;
  EXTRA_DATA_REMOVED: String;
  EXTRA_DONT_KILL_APP: String;
  EXTRA_EMAIL: String;
  EXTRA_INTENT: String;
  EXTRA_KEY_EVENT: String;
  EXTRA_PHONE_NUMBER: String;
  EXTRA_REPLACING: String;
  EXTRA_SHORTCUT_ICON: String;
  EXTRA_SHORTCUT_ICON_RESOURCE: String;
  EXTRA_SHORTCUT_INTENT: String;
  EXTRA_SHORTCUT_NAME: String;
  EXTRA_STREAM: String;
  EXTRA_SUBJECT: String;
  EXTRA_TEMPLATE: String;
  EXTRA_TEXT: String;
  EXTRA_TITLE: String;
  EXTRA_UID: String;
  FILL_IN_ACTION: Float;
  FILL_IN_CATEGORIES: Float;
  FILL_IN_COMPONENT: Float;
  FILL_IN_DATA: Float;
  FILL_IN_PACKAGE: Float;
  FLAG_ACTIVITY_BROUGHT_TO_FRONT: Float;
  FLAG_ACTIVITY_CLEAR_TOP: Float;
  FLAG_ACTIVITY_CLEAR_WHEN_TASK_RESET: Float;
  FLAG_ACTIVITY_EXCLUDE_FROM_RECENTS: Float;
  FLAG_ACTIVITY_FORWARD_RESULT: Float;
  FLAG_ACTIVITY_LAUNCHED_FROM_HISTORY: Float;
  FLAG_ACTIVITY_MULTIPLE_TASK: Float;
  FLAG_ACTIVITY_NEW_TASK: Float;
  FLAG_ACTIVITY_NO_ANIMATION: Float;
  FLAG_ACTIVITY_NO_HISTORY: Float;
  FLAG_ACTIVITY_NO_USER_ACTION: Float;
  FLAG_ACTIVITY_PREVIOUS_IS_TOP: Float;
  FLAG_ACTIVITY_REORDER_TO_FRONT: Float;
  FLAG_ACTIVITY_RESET_TASK_IF_NEEDED: Float;
  FLAG_ACTIVITY_SINGLE_TOP: Float;
  FLAG_AUTO_CANCEL: Float;
  FLAG_CANCEL_CURRENT: Float;
  FLAG_DEBUG_LOG_RESOLUTION: Float;
  FLAG_FROM_BACKGROUND: Float;
  FLAG_GRANT_READ_URI_PERMISSION: Float;
  FLAG_GRANT_WRITE_URI_PERMISSION: Float;
  FLAG_INSISTENT: Float;
  FLAG_NO_CLEAR: Float;
  FLAG_NO_CREATE: Float;
  FLAG_ONE_SHOT: Float;
  FLAG_ONGOING_EVENT: Float;
  FLAG_ONLY_ALERT_ONCE: Float;
  FLAG_RECEIVER_REGISTERED_ONLY: Float;
  FLAG_SHOW_LIGHTS: Float;
  FLAG_UPDATE_CURRENT: Float;
  NAVIGATION_MODE_STANDARD: Float;
  NAVIGATION_MODE_TABS: Float;
  PENDING_INTENT_FOR_ACTIVITY: Float;
  PENDING_INTENT_FOR_BROADCAST: Float;
  PENDING_INTENT_FOR_SERVICE: Float;
  PENDING_INTENT_MAX_VALUE: Float;
  R: JTi.Android.R;
  RESULT_CANCELED: Float;
  RESULT_FIRST_USER: Float;
  RESULT_OK: Float;
  SCREEN_ORIENTATION_BEHIND: Float;
  SCREEN_ORIENTATION_LANDSCAPE: Float;
  SCREEN_ORIENTATION_NOSENSOR: Float;
  SCREEN_ORIENTATION_PORTRAIT: Float;
  SCREEN_ORIENTATION_SENSOR: Float;
  SCREEN_ORIENTATION_UNSPECIFIED: Float;
  SCREEN_ORIENTATION_USER: Float;
  SHOW_AS_ACTION_ALWAYS: Float;
  SHOW_AS_ACTION_COLLAPSE_ACTION_VIEW: Float;
  SHOW_AS_ACTION_IF_ROOM: Float;
  SHOW_AS_ACTION_NEVER: Float;
  SHOW_AS_ACTION_WITH_TEXT: Float;
  START_NOT_STICKY: Float;
  START_REDELIVER_INTENT: Float;
  STREAM_ALARM: Float;
  STREAM_DEFAULT: Float;
  STREAM_MUSIC: Float;
  STREAM_NOTIFICATION: Float;
  STREAM_RING: Float;
  STREAM_SYSTEM: Float;
  STREAM_VOICE_CALL: Float;
  URI_INTENT_SCHEME: Float;
  apiName: String;
  bubbleParent: Boolean;
  currentActivity: JTi.Android.Activity;
  currentService: JTi.Android.Service;

//Database

type
  JResultSet = class external(JTi.Proxy)
    rowCount: Float;
    validRow: Boolean;
    procedure close;
    function field(index: Float): Variant; overload;
    function field(index: Float; &type: Float): Variant; overload;
    function fieldByName(name: String): Variant; overload;
    function fieldByName(name: String; &type: Float): Variant; overload;
    function fieldCount: Float;
    function fieldName(index: Float): String;
    function getFieldCount: Float;
    function getFieldName(index: Float): String;
    function getRowCount: Float;
    function getValidRow: Boolean;
    function isValidRow: Boolean;
    function next: Boolean;
  end;

  JDB = class external(JTi.Proxy)
    file: JTi.Filesystem.File;
    lastInsertRowId: Float;
    name: String;
    rowsAffected: Float;
    procedure close;
    function execute(sql: String): JTi.Database.ResultSet; overload;
    function execute(sql: String; vararg: String): JTi.Database.ResultSet; overload;
    function execute: JTi.Database.ResultSet; overload;
    function execute(vararg: JArray{<JString>}): JTi.Database.ResultSet; overload;
    function execute: JTi.Database.ResultSet; overload;
    function execute(vararg: Variant): JTi.Database.ResultSet; overload;
    function execute(sql: String): JTi.Database.ResultSet; overload;
    function execute(sql: String; vararg: JArray{<JObject>}): JTi.Database.ResultSet; overload;
    function getFile: JTi.Filesystem.File;
    function getLastInsertRowId: Float;
    function getName: String;
    function getRowsAffected: Float;
    procedure remove;
    procedure setLastInsertRowId(lastInsertRowId: Float);
    procedure setName(name: String);
    procedure setRowsAffected(rowsAffected: Float);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
function install(path: String; dbName: String): JTi.Database.DB;
function open(dbName: String): JTi.Database.DB;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  FIELD_TYPE_DOUBLE: Float;
  FIELD_TYPE_FLOAT: Float;
  FIELD_TYPE_INT: Float;
  FIELD_TYPE_STRING: Float;
  apiName: String;
  bubbleParent: Boolean;

//Contacts

type
  JGroup = class external(JTi.Proxy)
    name: String;
    recordId: Float;
    procedure add(person: JTi.Contacts.Person);
    function getName: String;
    function getRecordId: Float;
    function members: JArray{<JTi.Contacts.Person>};
    procedure remove(person: JTi.Contacts.Person);
    procedure setName(name: String);
    procedure setRecordId(recordId: Float);
    function sortedMembers(sortBy: Float): JArray{<JTi.Contacts.Person>};
  end;

  JPerson = class external(JTi.Proxy)
    address: JDictionary{<JObject>};
    birthday: String;
    created: String;
    date: JDictionary{<JObject>};
    department: String;
    email: JDictionary{<JObject>};
    firstName: String;
    firstPhonetic: String;
    fullName: String;
    id: Float;
    image: JTi.Blob;
    instantMessage: JDictionary{<JObject>};
    jobTitle: String;
    kind: Float;
    lastName: String;
    lastPhonetic: String;
    middleName: String;
    middlePhonetic: String;
    modified: String;
    nickname: String;
    note: String;
    organization: String;
    phone: JDictionary{<JObject>};
    prefix: String;
    recordId: Float;
    relatedNames: JDictionary{<JObject>};
    suffix: String;
    url: JDictionary{<JObject>};
    function getAddress: JDictionary{<JObject>};
    function getBirthday: String;
    function getCreated: String;
    function getDate: JDictionary{<JObject>};
    function getDepartment: String;
    function getEmail: JDictionary{<JObject>};
    function getFirstName: String;
    function getFirstPhonetic: String;
    function getFullName: String;
    function getId: Float;
    function getImage: JTi.Blob;
    function getInstantMessage: JDictionary{<JObject>};
    function getJobTitle: String;
    function getKind: Float;
    function getLastName: String;
    function getLastPhonetic: String;
    function getMiddleName: String;
    function getMiddlePhonetic: String;
    function getModified: String;
    function getNickname: String;
    function getNote: String;
    function getOrganization: String;
    function getPhone: JDictionary{<JObject>};
    function getPrefix: String;
    function getRecordId: Float;
    function getRelatedNames: JDictionary{<JObject>};
    function getSuffix: String;
    function getUrl: JDictionary{<JObject>};
    procedure setAddress(address: JDictionary{<JObject>});
    procedure setBirthday(birthday: String);
    procedure setDate(date: JDictionary{<JObject>});
    procedure setDepartment(department: String);
    procedure setEmail(email: JDictionary{<JObject>});
    procedure setFirstName(firstName: String);
    procedure setFirstPhonetic(firstPhonetic: String);
    procedure setImage(image: JTi.Blob);
    procedure setInstantMessage(instantMessage: JDictionary{<JObject>});
    procedure setJobTitle(jobTitle: String);
    procedure setKind(kind: Float);
    procedure setLastName(lastName: String);
    procedure setLastPhonetic(lastPhonetic: String);
    procedure setMiddleName(middleName: String);
    procedure setMiddlePhonetic(middlePhonetic: String);
    procedure setNickname(nickname: String);
    procedure setNote(note: String);
    procedure setOrganization(organization: String);
    procedure setPhone(phone: JDictionary{<JObject>});
    procedure setRecordId(recordId: Float);
    procedure setRelatedNames(relatedNames: JDictionary{<JObject>});
    procedure setUrl(url: JDictionary{<JObject>});
  end;

//Tizen

type
  JGroup = class external
    procedure members(group: JTi.Contacts.Group; callback: (args: array of Variant): Variant);
    procedure sortedMembers(sortBy: Float; group: JTi.Contacts.Group; callback: (args: array of Variant): Variant);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
procedure getAllPeople(callback: (args: array of Variant): Variant);
function getApiName: String;
procedure getPeopleWithName(name: String; callback: (args: array of Variant): Variant);
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);

var
  apiName: String;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createGroup: JTi.Contacts.Group; overload;
function createGroup(parameters: JDictionary{<JTi.Contacts.Group>}): JTi.Contacts.Group; overload;
function createPerson: JTi.Contacts.Person; overload;
function createPerson(parameters: JDictionary{<JTi.Contacts.Person>}): JTi.Contacts.Person; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAllGroups: JArray{<JTi.Contacts.Group>};
function getAllPeople(limit: Float): JArray{<JTi.Contacts.Person>};
function getApiName: String;
function getBubbleParent: Boolean;
function getContactsAuthorization: Float;
function getGroupByID(id: Float): JTi.Contacts.Group;
function getPeopleWithName(name: String): JArray{<JTi.Contacts.Person>};
function getPersonByID(id: Float): JTi.Contacts.Person;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure removeGroup(group: JTi.Contacts.Group);
procedure removePerson(person: JTi.Contacts.Person);
procedure requestAuthorization(callback: (args: array of Variant): Variant);
procedure revert;
procedure save(contacts: JArray{<JTi.Contacts.Person>});
procedure setBubbleParent(bubbleParent: Boolean);
procedure showContacts(params: JshowContactsParams);

var
  AUTHORIZATION_AUTHORIZED: Float;
  AUTHORIZATION_DENIED: Float;
  AUTHORIZATION_RESTRICTED: Float;
  AUTHORIZATION_UNKNOWN: Float;
  CONTACTS_KIND_ORGANIZATION: Float;
  CONTACTS_KIND_PERSON: Float;
  CONTACTS_SORT_FIRST_NAME: Float;
  CONTACTS_SORT_LAST_NAME: Float;
  apiName: String;
  bubbleParent: Boolean;
  contactsAuthorization: Float;

//Media

type
  JSound = class external(JTi.Proxy)
    STATE_BUFFERING: Float;
    STATE_INITIALIZED: Float;
    STATE_PAUSED: Float;
    STATE_PLAYING: Float;
    STATE_STARTING: Float;
    STATE_STOPPED: Float;
    STATE_STOPPING: Float;
    STATE_WAITING_FOR_DATA: Float;
    STATE_WAITING_FOR_QUEUE: Float;
    allowBackground: Boolean;
    duration: Float;
    looping: Boolean;
    paused: Boolean;
    playing: Boolean;
    time: Float;
    url: String;
    volume: Float;
    function getDuration: Float;
    function getTime: Float;
    function getUrl: String;
    function getVolume: Float;
    function isLooping: Boolean;
    function isPaused: Boolean;
    function isPlaying: Boolean;
    procedure pause;
    procedure play;
    procedure release;
    procedure reset;
    procedure setLooping(looping: Boolean);
    procedure setPaused(paused: Boolean);
    procedure setTime(time: Float);
    procedure setUrl(url: String);
    procedure setVolume(volume: Float);
    procedure stop;
  end;

  JVideoPlayer = class external(JTi.UI.View)
    allowsAirPlay: Boolean;
    autoplay: Boolean;
    contentURL: String;
    currentPlaybackTime: Float;
    duration: Float;
    endPlaybackTime: Float;
    fullscreen: Boolean;
    initialPlaybackTime: Float;
    loadState: Float;
    media: Variant;
    mediaControlStyle: Float;
    mediaTypes: Float;
    movieControlMode: Float;
    naturalSize: JMovieSize;
    playableDuration: Float;
    playbackState: Float;
    playing: Boolean;
    repeatMode: Float;
    scalingMode: Float;
    sourceType: Float;
    url: Variant;
    useApplicationAudioSession: Boolean;
    volume: Float;
    procedure cancelAllThumbnailImageRequests;
    function getAllowsAirPlay: Boolean;
    function getAutoplay: Boolean;
    function getContentURL: String;
    function getCurrentPlaybackTime: Float;
    function getDuration: Float;
    function getEndPlaybackTime: Float;
    function getFullscreen: Boolean;
    function getInitialPlaybackTime: Float;
    function getLoadState: Float;
    function getMediaControlStyle: Float;
    function getMediaTypes: Float;
    function getMovieControlMode: Float;
    function getNaturalSize: JMovieSize;
    function getPlayableDuration: Float;
    function getPlaybackState: Float;
    function getPlaying: Boolean;
    function getRepeatMode: Float;
    function getScalingMode: Float;
    function getSourceType: Float;
    function getUrl: Variant;
    function getUseApplicationAudioSession: Boolean;
    function getVolume: Float;
    procedure pause;
    procedure play;
    procedure release;
    procedure requestThumbnailImagesAtTimes(times: JArray{<JNumber>}; option: Float; callback: (args: array of Variant): Variant);
    procedure setAllowsAirPlay(allowsAirPlay: Boolean);
    procedure setAutoplay(autoplay: Boolean);
    procedure setBackgroundView(view: JTi.UI.View);
    procedure setContentURL(contentURL: String);
    procedure setCurrentPlaybackTime(currentPlaybackTime: Float);
    procedure setDuration(duration: Float);
    procedure setEndPlaybackTime(endPlaybackTime: Float);
    procedure setFullscreen(fullscreen: Boolean);
    procedure setInitialPlaybackTime(initialPlaybackTime: Float);
    procedure setMedia(media: JTi.Blob);
    procedure setMedia(media: JTi.Filesystem.File);
    procedure setMedia(media: String);
    procedure setMediaControlStyle(mediaControlStyle: Float);
    procedure setMediaTypes(mediaTypes: Float);
    procedure setMovieControlMode(movieControlMode: Float);
    procedure setNaturalSize(naturalSize: JMovieSize);
    procedure setRepeatMode(repeatMode: Float);
    procedure setScalingMode(scalingMode: Float);
    procedure setSourceType(sourceType: Float);
    procedure setUrl(url: String);
    procedure setUrl(url: JArray{<JString>});
    procedure setUseApplicationAudioSession(useApplicationAudioSession: Boolean);
    procedure setVolume(volume: Float);
    procedure stop;
    function thumbnailImageAtTime(time: Float; option: Float): JTi.Blob;
  end;

  JAudioRecorder = class external(JTi.Proxy)
    compression: Float;
    format: Float;
    paused: Boolean;
    recording: Boolean;
    stopped: Boolean;
    function getCompression: Float;
    function getFormat: Float;
    function getPaused: Boolean;
    function getRecording: Boolean;
    function getStopped: Boolean;
    procedure pause;
    procedure resume;
    procedure setCompression(compression: Float);
    procedure setFormat(format: Float);
    procedure start;
    function stop: JTi.Filesystem.File;
  end;

  JItem = class external(JTi.Proxy)
    albumArtist: String;
    albumTitle: String;
    albumTrackCount: Float;
    albumTrackNumber: Float;
    artist: String;
    artwork: JTi.Blob;
    composer: String;
    discCount: Float;
    discNumber: Float;
    genre: String;
    isCompilation: Boolean;
    lyrics: String;
    mediaType: Float;
    playCount: Float;
    playbackDuration: Float;
    podcastTitle: String;
    rating: Float;
    skipCount: Float;
    title: String;
    function getAlbumArtist: String;
    function getAlbumTitle: String;
    function getAlbumTrackCount: Float;
    function getAlbumTrackNumber: Float;
    function getArtist: String;
    function getArtwork: JTi.Blob;
    function getComposer: String;
    function getDiscCount: Float;
    function getDiscNumber: Float;
    function getGenre: String;
    function getIsCompilation: Boolean;
    function getLyrics: String;
    function getMediaType: Float;
    function getPlayCount: Float;
    function getPlaybackDuration: Float;
    function getPodcastTitle: String;
    function getRating: Float;
    function getSkipCount: Float;
    function getTitle: String;
  end;

  JMusicPlayer = class external(JTi.Proxy)
    currentPlaybackTime: Float;
    nowPlaying: JTi.Media.Item;
    playbackState: Float;
    repeatMode: Float;
    shuffleMode: Float;
    volume: Float;
    function getCurrentPlaybackTime: Float;
    function getNowPlaying: JTi.Media.Item;
    function getPlaybackState: Float;
    function getRepeatMode: Float;
    function getShuffleMode: Float;
    function getVolume: Float;
    procedure pause;
    procedure play;
    procedure seekBackward;
    procedure seekForward;
    procedure setCurrentPlaybackTime(currentPlaybackTime: Float);
    procedure setQueue(queue: JTi.Media.Item);
    procedure setQueue(queue: JArray{<JTi.Media.Item>});
    procedure setQueue(queue: JPlayerQueue);
    procedure setRepeatMode(repeatMode: Float);
    procedure setShuffleMode(shuffleMode: Float);
    procedure setVolume(volume: Float);
    procedure skipToBeginning;
    procedure skipToNext;
    procedure skipToPrevious;
    procedure stop;
    procedure stopSeeking;
  end;

  JAudioPlayer = class external(JTi.Proxy)
    STATE_BUFFERING: Float;
    STATE_INITIALIZED: Float;
    STATE_PAUSED: Float;
    STATE_PLAYING: Float;
    STATE_STARTING: Float;
    STATE_STOPPED: Float;
    STATE_STOPPING: Float;
    STATE_WAITING_FOR_DATA: Float;
    STATE_WAITING_FOR_QUEUE: Float;
    allowBackground: Boolean;
    autoplay: Boolean;
    bitRate: Float;
    bufferSize: Float;
    duration: Float;
    idle: Boolean;
    paused: Boolean;
    playing: Boolean;
    progress: Float;
    state: Float;
    time: Float;
    url: String;
    volume: Float;
    waiting: Boolean;
    function getAllowBackground: Boolean;
    function getAutoplay: Boolean;
    function getBitRate: Float;
    function getBufferSize: Float;
    function getDuration: Float;
    function getIdle: Boolean;
    function getPaused: Boolean;
    function getPlaying: Boolean;
    function getProgress: Float;
    function getState: Float;
    function getTime: Float;
    function getUrl: String;
    function getVolume: Float;
    function getWaiting: Boolean;
    function isPaused: Boolean;
    function isPlaying: Boolean;
    procedure pause;
    procedure play;
    procedure release;
    procedure setBitRate(bitRate: Float);
    procedure setBufferSize(bufferSize: Float);
    procedure setPaused(paused: Boolean);
    procedure setTime(time: Float);
    procedure setUrl(url: String);
    procedure setVolume(volume: Float);
    procedure start;
    function stateDescription(state: Float): String;
    procedure stop;
  end;

  JAndroid = class external
    procedure scanMediaFiles(paths: JArray{<JString>}; mimeTypes: JArray{<JString>}; callback: (args: array of Variant): Variant);
    procedure setSystemWallpaper(image: JTi.Blob; scale: Boolean);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure beep;
function createAudioPlayer: JTi.Media.AudioPlayer; overload;
function createAudioPlayer(parameters: JDictionary{<JTi.Media.AudioPlayer>}): JTi.Media.AudioPlayer; overload;
function createAudioRecorder: JTi.Media.AudioRecorder; overload;
function createAudioRecorder(parameters: JDictionary{<JTi.Media.AudioRecorder>}): JTi.Media.AudioRecorder; overload;
function createItem: JTi.Media.Item; overload;
function createItem(parameters: JDictionary{<JTi.Media.Item>}): JTi.Media.Item; overload;
function createMusicPlayer: JTi.Media.MusicPlayer; overload;
function createMusicPlayer(parameters: JDictionary{<JTi.Media.MusicPlayer>}): JTi.Media.MusicPlayer; overload;
function createSound: JTi.Media.Sound; overload;
function createSound(parameters: JDictionary{<JTi.Media.Sound>}): JTi.Media.Sound; overload;
function createVideoPlayer: JTi.Media.VideoPlayer; overload;
function createVideoPlayer(parameters: JDictionary{<JTi.Media.VideoPlayer>}): JTi.Media.VideoPlayer; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getAppMusicPlayer: JTi.Media.MusicPlayer;
function getAudioLineType: Float;
function getAudioPlaying: Boolean;
function getAudioSessionCategory: Float;
function getAudioSessionMode: Float;
function getAvailableCameraMediaTypes: JArray{<JObject>};
function getAvailableCameras: JArray{<JNumber>};
function getAvailablePhotoGalleryMediaTypes: JArray{<JObject>};
function getAvailablePhotoMediaTypes: JArray{<JObject>};
function getAverageMicrophonePower: Float;
function getBubbleParent: Boolean;
function getCameraFlashMode: Float;
function getCanRecord: Boolean;
function getCurrentRoute: JRouteDescription;
function getIsCameraSupported: Boolean;
function getPeakMicrophonePower: Float;
function getSystemMusicPlayer: JTi.Media.MusicPlayer;
function getVolume: Float;
procedure hideCamera;
procedure hideMusicLibrary;
function isMediaTypeSupported(source: String; &type: String): Boolean;
procedure openMusicLibrary(options: JMusicLibraryOptionsType);
procedure openPhotoGallery(options: JPhotoGalleryOptionsType);
procedure previewImage(options: JDictionary{<JPreviewImageOptions>});
function queryMusicLibrary(query: JMediaQueryType): JArray{<JTi.Media.Item>};
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure requestAuthorization(callback: (args: array of Variant): Variant);
procedure saveToPhotoGallery(media: JTi.Blob; callbacks: Variant);
procedure saveToPhotoGallery(media: JTi.Filesystem.File; callbacks: Variant);
procedure setAudioSessionCategory(audioSessionCategory: Float);
procedure setAudioSessionMode(audioSessionMode: Float);
procedure setAvailableCameraMediaTypes(availableCameraMediaTypes: JArray{<JObject>});
procedure setAvailablePhotoGalleryMediaTypes(availablePhotoGalleryMediaTypes: JArray{<JObject>});
procedure setAvailablePhotoMediaTypes(availablePhotoMediaTypes: JArray{<JObject>});
procedure setAverageMicrophonePower(averageMicrophonePower: Float);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setCameraFlashMode(cameraFlashMode: Float);
procedure setOverrideAudioRoute(route: Float);
procedure showCamera(options: JCameraOptionsType);
procedure startMicrophoneMonitor;
procedure stopMicrophoneMonitor;
procedure switchCamera(camera: Float);
procedure takePicture;
procedure takeScreenshot(callback: (args: array of Variant): Variant);
procedure vibrate; overload;
procedure vibrate(pattern: JArray{<JNumber>}); overload;

var
  AUDIO_FILEFORMAT_3GP2: Float;
  AUDIO_FILEFORMAT_3GPP: Float;
  AUDIO_FILEFORMAT_AIFF: Float;
  AUDIO_FILEFORMAT_AMR: Float;
  AUDIO_FILEFORMAT_CAF: Float;
  AUDIO_FILEFORMAT_MP3: Float;
  AUDIO_FILEFORMAT_MP4: Float;
  AUDIO_FILEFORMAT_MP4A: Float;
  AUDIO_FILEFORMAT_WAVE: Float;
  AUDIO_FORMAT_AAC: Float;
  AUDIO_FORMAT_ALAW: Float;
  AUDIO_FORMAT_APPLE_LOSSLESS: Float;
  AUDIO_FORMAT_ILBC: Float;
  AUDIO_FORMAT_IMA4: Float;
  AUDIO_FORMAT_LINEAR_PCM: Float;
  AUDIO_FORMAT_ULAW: Float;
  AUDIO_HEADPHONES: Float;
  AUDIO_HEADPHONES_AND_MIC: Float;
  AUDIO_HEADSET_INOUT: Float;
  AUDIO_LINEOUT: Float;
  AUDIO_MICROPHONE: Float;
  AUDIO_MUTED: Float;
  AUDIO_RECEIVER_AND_MIC: Float;
  AUDIO_SESSION_CATEGORY_AMBIENT: String;
  AUDIO_SESSION_CATEGORY_PLAYBACK: String;
  AUDIO_SESSION_CATEGORY_PLAY_AND_RECORD: String;
  AUDIO_SESSION_CATEGORY_RECORD: String;
  AUDIO_SESSION_CATEGORY_SOLO_AMBIENT: String;
  AUDIO_SESSION_MODE_AMBIENT: Float;
  AUDIO_SESSION_MODE_PLAYBACK: Float;
  AUDIO_SESSION_MODE_PLAY_AND_RECORD: Float;
  AUDIO_SESSION_MODE_RECORD: Float;
  AUDIO_SESSION_MODE_SOLO_AMBIENT: Float;
  AUDIO_SESSION_OVERRIDE_ROUTE_NONE: Float;
  AUDIO_SESSION_OVERRIDE_ROUTE_SPEAKER: Float;
  AUDIO_SESSION_PORT_AIRPLAY: String;
  AUDIO_SESSION_PORT_BLUETOOTHA2DP: String;
  AUDIO_SESSION_PORT_BLUETOOTHHFP: String;
  AUDIO_SESSION_PORT_BLUETOOTHLE: String;
  AUDIO_SESSION_PORT_BUILTINMIC: String;
  AUDIO_SESSION_PORT_BUILTINRECEIVER: String;
  AUDIO_SESSION_PORT_BUILTINSPEAKER: String;
  AUDIO_SESSION_PORT_CARAUDIO: String;
  AUDIO_SESSION_PORT_HDMI: String;
  AUDIO_SESSION_PORT_HEADPHONES: String;
  AUDIO_SESSION_PORT_HEADSETMIC: String;
  AUDIO_SESSION_PORT_LINEIN: String;
  AUDIO_SESSION_PORT_LINEOUT: String;
  AUDIO_SESSION_PORT_USBAUDIO: String;
  AUDIO_SPEAKER: Float;
  AUDIO_UNAVAILABLE: Float;
  AUDIO_UNKNOWN: Float;
  CAMERA_FLASH_AUTO: Float;
  CAMERA_FLASH_OFF: Float;
  CAMERA_FLASH_ON: Float;
  CAMERA_FRONT: Float;
  CAMERA_REAR: Float;
  DEVICE_BUSY: Float;
  MEDIA_TYPE_PHOTO: String;
  MEDIA_TYPE_VIDEO: String;
  MUSIC_MEDIA_GROUP_ALBUM: Float;
  MUSIC_MEDIA_GROUP_ALBUM_ARTIST: Float;
  MUSIC_MEDIA_GROUP_ARTIST: Float;
  MUSIC_MEDIA_GROUP_COMPOSER: Float;
  MUSIC_MEDIA_GROUP_GENRE: Float;
  MUSIC_MEDIA_GROUP_PLAYLIST: Float;
  MUSIC_MEDIA_GROUP_PODCAST_TITLE: Float;
  MUSIC_MEDIA_GROUP_TITLE: Float;
  MUSIC_MEDIA_TYPE_ALL: Float;
  MUSIC_MEDIA_TYPE_ANY_AUDIO: Float;
  MUSIC_MEDIA_TYPE_AUDIOBOOK: Float;
  MUSIC_MEDIA_TYPE_MUSIC: Float;
  MUSIC_MEDIA_TYPE_PODCAST: Float;
  MUSIC_PLAYER_REPEAT_ALL: Float;
  MUSIC_PLAYER_REPEAT_DEFAULT: Float;
  MUSIC_PLAYER_REPEAT_NONE: Float;
  MUSIC_PLAYER_REPEAT_ONE: Float;
  MUSIC_PLAYER_SHUFFLE_ALBUMS: Float;
  MUSIC_PLAYER_SHUFFLE_DEFAULT: Float;
  MUSIC_PLAYER_SHUFFLE_NONE: Float;
  MUSIC_PLAYER_SHUFFLE_SONGS: Float;
  MUSIC_PLAYER_STATE_INTERRUPTED: Float;
  MUSIC_PLAYER_STATE_PAUSED: Float;
  MUSIC_PLAYER_STATE_PLAYING: Float;
  MUSIC_PLAYER_STATE_SEEK_BACKWARD: Float;
  MUSIC_PLAYER_STATE_SEEK_FORWARD: Float;
  MUSIC_PLAYER_STATE_STOPPED: Float;
  NO_CAMERA: Float;
  NO_VIDEO: Float;
  QUALITY_HIGH: Float;
  QUALITY_LOW: Float;
  QUALITY_MEDIUM: Float;
  UNKNOWN_ERROR: Float;
  VIDEO_CONTROL_DEFAULT: Float;
  VIDEO_CONTROL_EMBEDDED: Float;
  VIDEO_CONTROL_FULLSCREEN: Float;
  VIDEO_CONTROL_HIDDEN: Float;
  VIDEO_CONTROL_NONE: Float;
  VIDEO_CONTROL_VOLUME_ONLY: Float;
  VIDEO_FINISH_REASON_PLAYBACK_ENDED: Float;
  VIDEO_FINISH_REASON_PLAYBACK_ERROR: Float;
  VIDEO_FINISH_REASON_USER_EXITED: Float;
  VIDEO_LOAD_STATE_PLAYABLE: Float;
  VIDEO_LOAD_STATE_PLAYTHROUGH_OK: Float;
  VIDEO_LOAD_STATE_STALLED: Float;
  VIDEO_LOAD_STATE_UNKNOWN: Float;
  VIDEO_MEDIA_TYPE_AUDIO: Float;
  VIDEO_MEDIA_TYPE_NONE: Float;
  VIDEO_MEDIA_TYPE_VIDEO: Float;
  VIDEO_PLAYBACK_STATE_INTERRUPTED: Float;
  VIDEO_PLAYBACK_STATE_PAUSED: Float;
  VIDEO_PLAYBACK_STATE_PLAYING: Float;
  VIDEO_PLAYBACK_STATE_SEEKING_BACKWARD: Float;
  VIDEO_PLAYBACK_STATE_SEEKING_FORWARD: Float;
  VIDEO_PLAYBACK_STATE_STOPPED: Float;
  VIDEO_REPEAT_MODE_NONE: Float;
  VIDEO_REPEAT_MODE_ONE: Float;
  VIDEO_SCALING_ASPECT_FILL: Float;
  VIDEO_SCALING_ASPECT_FIT: Float;
  VIDEO_SCALING_MODE_FILL: Float;
  VIDEO_SCALING_NONE: Float;
  VIDEO_SOURCE_TYPE_FILE: Float;
  VIDEO_SOURCE_TYPE_STREAMING: Float;
  VIDEO_SOURCE_TYPE_UNKNOWN: Float;
  VIDEO_TIME_OPTION_EXACT: Float;
  VIDEO_TIME_OPTION_NEAREST_KEYFRAME: Float;
  apiName: String;
  appMusicPlayer: JTi.Media.MusicPlayer;
  audioLineType: Float;
  audioPlaying: Boolean;
  audioSessionCategory: Float;
  audioSessionMode: Float;
  availableCameraMediaTypes: JArray{<JObject>};
  availableCameras: JArray{<JNumber>};
  availablePhotoGalleryMediaTypes: JArray{<JObject>};
  availablePhotoMediaTypes: JArray{<JObject>};
  averageMicrophonePower: Float;
  bubbleParent: Boolean;
  cameraFlashMode: Float;
  canRecord: Boolean;
  currentRoute: JRouteDescription;
  isCameraSupported: Boolean;
  peakMicrophonePower: Float;
  systemMusicPlayer: JTi.Media.MusicPlayer;
  volume: Float;

//Platform

type
  JDisplayCaps = class external(JTi.Proxy)
    density: String;
    dpi: Float;
    logicalDensityFactor: Float;
    platformHeight: Float;
    platformWidth: Float;
    xdpi: Float;
    ydpi: Float;
    function getDensity: String;
    function getDpi: Float;
    function getLogicalDensityFactor: Float;
    function getPlatformHeight: Float;
    function getPlatformWidth: Float;
    function getXdpi: Float;
    function getYdpi: Float;
  end;

  JAndroid = class external
    API_LEVEL: Float;
    PHYSICAL_SIZE_CATEGORY_LARGE: Float;
    PHYSICAL_SIZE_CATEGORY_NORMAL: Float;
    PHYSICAL_SIZE_CATEGORY_SMALL: Float;
    PHYSICAL_SIZE_CATEGORY_UNDEFINED: Float;
    PHYSICAL_SIZE_CATEGORY_XLARGE: Float;
    physicalSizeCategory: Float;
    function getPhysicalSizeCategory: Float;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function canOpenURL(url: String): Boolean;
function createUUID: String;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAddress: String;
function getApiName: String;
function getArchitecture: String;
function getAvailableMemory: Float;
function getBatteryLevel: Float;
function getBatteryMonitoring: Boolean;
function getBatteryState: Float;
function getBubbleParent: Boolean;
function getDisplayCaps: JTi.Platform.DisplayCaps;
function getId: String;
function getLocale: String;
function getMacaddress: String;
function getManufacturer: String;
function getModel: String;
function getName: String;
function getNetmask: String;
function getOsname: String;
function getOstype: String;
function getProcessorCount: Float;
function getRuntime: String;
function getUsername: String;
function getVersion: String;
function is24HourTimeFormat: Boolean;
function openURL(url: String): Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBatteryMonitoring(batteryMonitoring: Boolean);
procedure setBubbleParent(bubbleParent: Boolean);

var
  BATTERY_STATE_CHARGING: Float;
  BATTERY_STATE_FULL: Float;
  BATTERY_STATE_UNKNOWN: Float;
  BATTERY_STATE_UNPLUGGED: Float;
  address: String;
  apiName: String;
  architecture: String;
  availableMemory: Float;
  batteryLevel: Float;
  batteryMonitoring: Boolean;
  batteryState: Float;
  bubbleParent: Boolean;
  displayCaps: JTi.Platform.DisplayCaps;
  id: String;
  locale: String;
  macaddress: String;
  manufacturer: String;
  model: String;
  name: String;
  netmask: String;
  osname: String;
  ostype: String;
  processorCount: Float;
  runtime: String;
  username: String;
  version: String;

//Calendar

type
  JCalendar = class external(JTi.Proxy)
    hidden: Boolean;
    id: String;
    name: String;
    selected: Boolean;
    function createEvent(properties: JDictionary{<JTi.Calendar.Event>}): JTi.Calendar.Event;
    function getEventById(id: Float): JTi.Calendar.Event;
    function getEventsBetweenDates(date1: JDate; date2: JDate): JArray{<JTi.Calendar.Event>};
    function getEventsInDate(year: Float; month: Float; day: Float): JArray{<JTi.Calendar.Event>};
    function getEventsInMonth(year: Float; month: Float): JArray{<JTi.Calendar.Event>};
    function getEventsInYear(year: Float): JArray{<JTi.Calendar.Event>};
    function getHidden: Boolean;
    function getId: String;
    function getName: String;
    function getSelected: Boolean;
  end;

  JReminder = class external(JTi.Proxy)
    id: String;
    method: Float;
    minutes: Float;
    function getId: String;
    function getMethod: Float;
    function getMinutes: Float;
  end;

  JEvent = class external(JTi.Proxy)
    alerts: JArray{<JTi.Calendar.Alert>};
    allDay: Boolean;
    availability: Float;
    begin: JDate;
    description: String;
    &end: JDate;
    extendedProperties: JDictionary{<JObject>};
    hasAlarm: Boolean;
    id: String;
    isDetached: Boolean;
    location: String;
    notes: String;
    recurenceRule: JTi.Calendar.RecurrenceRule;
    recurenceRules: JArray{<JTi.Calendar.RecurrenceRule>};
    reminders: JArray{<JTi.Calendar.Reminder>};
    status: Float;
    title: String;
    visibility: Float;
    procedure addRecurrenceRule(rule: JTi.Calendar.RecurrenceRule);
    function createAlert(data: JDictionary{<JTi.Calendar.Alert>}): JTi.Calendar.Alert;
    function createRecurenceRule(data: JDictionary{<JTi.Calendar.RecurrenceRule>}): JTi.Calendar.RecurrenceRule;
    function createReminder(data: JDictionary{<JTi.Calendar.Reminder>}): JTi.Calendar.Reminder;
    function getAlerts: JArray{<JTi.Calendar.Alert>};
    function getAllDay: Boolean;
    function getAvailability: Float;
    function getBegin: JDate;
    function getDescription: String;
    function getEnd: JDate;
    function getExtendedProperties: JDictionary{<JObject>};
    function getExtendedProperty(name: String): String;
    function getHasAlarm: Boolean;
    function getId: String;
    function getIsDetached: Boolean;
    function getLocation: String;
    function getNotes: String;
    function getRecurenceRule: JTi.Calendar.RecurrenceRule;
    function getRecurenceRules: JArray{<JTi.Calendar.RecurrenceRule>};
    function getReminders: JArray{<JTi.Calendar.Reminder>};
    function getStatus: Float;
    function getTitle: String;
    function getVisibility: Float;
    function refresh: Boolean;
    function remove(span: Float): Boolean;
    procedure removeRecurenceRule(rule: JTi.Calendar.RecurrenceRule);
    function save(span: Float): Boolean;
    procedure setAlerts(alerts: JArray{<JTi.Calendar.Alert>});
    procedure setAllDay(allDay: Boolean);
    procedure setBegin(begin: JDate);
    procedure setEnd(&end: JDate);
    procedure setExtendedProperty(name: String; value: String);
    procedure setLocation(location: String);
    procedure setNotes(notes: String);
    procedure setRecurenceRule(recurenceRule: JTi.Calendar.RecurrenceRule);
    procedure setRecurenceRules(recurenceRules: JArray{<JTi.Calendar.RecurrenceRule>});
    procedure setTitle(title: String);
  end;

  JRecurrenceRule = class external(JTi.Proxy)
    calendarID: String;
    daysOfTheMonth: JArray{<JNumber>};
    daysOfTheWeek: JdaysOfTheWeekDictionary;
    daysOfTheYear: JArray{<JNumber>};
    &end: JrecurrenceEndDictionary;
    frequency: Float;
    interval: Float;
    monthsOfTheYear: JArray{<JNumber>};
    setPositions: JArray{<JNumber>};
    weeksOfTheYear: JArray{<JNumber>};
    function getCalendarID: String;
    function getDaysOfTheMonth: JArray{<JNumber>};
    function getDaysOfTheWeek: JdaysOfTheWeekDictionary;
    function getDaysOfTheYear: JArray{<JNumber>};
    function getEnd: JrecurrenceEndDictionary;
    function getFrequency: Float;
    function getInterval: Float;
    function getMonthsOfTheYear: JArray{<JNumber>};
    function getSetPositions: JArray{<JNumber>};
    function getWeeksOfTheYear: JArray{<JNumber>};
  end;

  JAlert = class external(JTi.Proxy)
    absoluteDate: JDate;
    alarmTime: JDate;
    begin: JDate;
    &end: JDate;
    eventId: Float;
    id: String;
    minutes: Float;
    relativeOffset: Float;
    state: Float;
    function getAbsoluteDate: JDate;
    function getAlarmTime: JDate;
    function getBegin: JDate;
    function getEnd: JDate;
    function getEventId: Float;
    function getId: String;
    function getMinutes: Float;
    function getRelativeOffset: Float;
    function getState: Float;
    procedure setAbsoluteDate(absoluteDate: JDate);
    procedure setRelativeOffset(relativeOffset: Float);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAllAlerts: JArray{<JTi.Calendar.Alert>};
function getAllCalendars: JArray{<JTi.Calendar.Calendar>};
function getAllEditableCalendars: JArray{<JTi.Calendar.Calendar>};
function getApiName: String;
function getBubbleParent: Boolean;
function getCalendarById(id: String): JTi.Calendar.Calendar;
function getDefaultCalendar: JTi.Calendar.Calendar;
function getEventsAuthorization: Float;
function getSelectableCalendars: JArray{<JTi.Calendar.Calendar>};
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure requestEventsAuthorization(callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  AUTHORIZATION_AUTHORIZED: Float;
  AUTHORIZATION_DENIED: Float;
  AUTHORIZATION_RESTRICTED: Float;
  AUTHORIZATION_UNKNOWN: Float;
  AVAILABILITY_BUSY: Float;
  AVAILABILITY_FREE: Float;
  AVAILABILITY_NOTSUPPORTED: Float;
  AVAILABILITY_TENTATIVE: Float;
  AVAILABILITY_UNAVAILABLE: Float;
  METHOD_ALERT: Float;
  METHOD_DEFAULT: Float;
  METHOD_EMAIL: Float;
  METHOD_SMS: Float;
  RECURRENCEFREQUENCY_DAILY: Float;
  RECURRENCEFREQUENCY_MONTHLY: Float;
  RECURRENCEFREQUENCY_WEEKLY: Float;
  RECURRENCEFREQUENCY_YEARLY: Float;
  SPAN_FUTUREEVENTS: Float;
  SPAN_THISEVENT: Float;
  STATE_DISMISSED: Float;
  STATE_FIRED: Float;
  STATE_SCHEDULED: Float;
  STATUS_CANCELED: Float;
  STATUS_CONFIRMED: Float;
  STATUS_NONE: Float;
  STATUS_TENTATIVE: Float;
  VISIBILITY_CONFIDENTIAL: Float;
  VISIBILITY_DEFAULT: Float;
  VISIBILITY_PRIVATE: Float;
  VISIBILITY_PUBLIC: Float;
  allAlerts: JArray{<JTi.Calendar.Alert>};
  allCalendars: JArray{<JTi.Calendar.Calendar>};
  allEditableCalendars: JArray{<JTi.Calendar.Calendar>};
  apiName: String;
  bubbleParent: Boolean;
  defaultCalendar: JTi.Calendar.Calendar;
  eventsAuthorization: Float;
  selectableCalendars: JArray{<JTi.Calendar.Calendar>};

//Filesystem

type
  JFile = class external(JTi.Proxy)
    executable: Boolean;
    hidden: Boolean;
    name: String;
    nativePath: String;
    parent: JTi.Filesystem.File;
    readonly: Boolean;
    remoteBackup: Boolean;
    size: Float;
    symbolicLink: Boolean;
    writable: Boolean;
    writeable: Boolean;
    function append(data: String): Boolean;
    function append(data: JTi.Blob): Boolean;
    function append(data: JTi.Filesystem.File): Boolean;
    function copy(destinationPath: String): Boolean;
    function createDirectory: Boolean;
    function createFile: Boolean;
    function createTimestamp: Float;
    function deleteDirectory: Boolean; overload;
    function deleteDirectory(recursive: Boolean): Boolean; overload;
    function deleteFile: Boolean;
    function exists: Boolean;
    function extension: String;
    function getDirectoryListing: JArray{<JString>};
    function getExecutable: Boolean;
    function getHidden: Boolean;
    function getName: String;
    function getNativePath: String;
    function getParent: Variant;
    function getReadonly: Boolean;
    function getRemoteBackup: Boolean;
    function getSize: Float;
    function getSymbolicLink: Boolean;
    function getWritable: Boolean;
    function getWriteable: Boolean;
    function isDirectory: Boolean;
    function isFile: Boolean;
    function modificationTimestamp: Float;
    function move(newpath: String): Boolean;
    function open(mode: Float): JTi.Filesystem.FileStream;
    function read: JTi.Blob;
    function rename(newname: String): Boolean;
    function resolve: String;
    procedure setHidden(hidden: Boolean);
    procedure setRemoteBackup(remoteBackup: Boolean);
    function spaceAvailable: Float;
    function write(data: String): Boolean; overload;
    function write(data: String; append: Boolean): Boolean; overload;
    function write(data: JTi.Filesystem.File): Boolean; overload;
    function write(data: JTi.Filesystem.File; append: Boolean): Boolean; overload;
    function write(data: JTi.Blob): Boolean; overload;
    function write(data: JTi.Blob; append: Boolean): Boolean; overload;
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createTempDirectory: JTi.Filesystem.File;
function createTempFile: JTi.Filesystem.File;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getApplicationCacheDirectory: String;
function getApplicationDataDirectory: String;
function getApplicationDirectory: String;
function getApplicationSupportDirectory: String;
function getBubbleParent: Boolean;
function getExternalStorageDirectory: String;
function getFile(path: String; extraPaths: array of String): JTi.Filesystem.File;
function getLineEnding: String;
function getResRawDirectory: String;
function getResourcesDirectory: String;
function getSeparator: String;
function getTempDirectory: String;
function isExternalStoragePresent: Boolean;
function openStream(mode: Float; path: String; extraPaths: array of String): JTi.Filesystem.FileStream;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  MODE_APPEND: Float;
  MODE_READ: Float;
  MODE_WRITE: Float;
  apiName: String;
  applicationCacheDirectory: String;
  applicationDataDirectory: String;
  applicationDirectory: String;
  applicationSupportDirectory: String;
  bubbleParent: Boolean;
  externalStorageDirectory: String;
  lineEnding: String;
  resRawDirectory: String;
  resourcesDirectory: String;
  separator: String;
  tempDirectory: String;

//Network

type
  JTCPSocket = class external(JTi.Proxy)
    hostName: String;
    isValid: Boolean;
    mode: Float;
    port: Float;
    stripTerminator: Boolean;
    procedure close;
    procedure connect;
    function getHostName: String;
    function getIsValid: Boolean;
    function getMode: Float;
    function getPort: Float;
    function getStripTerminator: Boolean;
    procedure listen;
    procedure setHostName(hostName: String);
    procedure setIsValid(isValid: Boolean);
    procedure setMode(mode: Float);
    procedure setPort(port: Float);
    procedure setStripTerminator(stripTerminator: Boolean);
    procedure write(data: Variant; sendTo: Float);
    procedure write(data: String; sendTo: Float);
  end;

  JBonjourService = class external(JTi.Proxy)
    domain: String;
    isLocal: Boolean;
    name: String;
    socket: Variant;
    &type: String;
    function getDomain: String;
    function getIsLocal: Boolean;
    function getName: String;
    function getSocket: Variant;
    function getType: String;
    procedure publish(socket: Variant);
    procedure resolve(timeout: Float);
    procedure setDomain(domain: String);
    procedure setIsLocal(isLocal: Boolean);
    procedure setName(name: String);
    procedure setSocket(socket: Variant);
    procedure setType(&type: String);
    procedure stop;
  end;

  JHTTPClient = class external(JTi.Proxy)
    DONE: Float;
    HEADERS_RECEIVED: Float;
    LOADING: Float;
    OPENED: Float;
    UNSENT: Float;
    allResponseHeaders: String;
    autoEncodeUrl: Boolean;
    autoRedirect: Boolean;
    cache: Boolean;
    connected: Boolean;
    connectionType: String;
    domain: String;
    enableKeepAlive: Boolean;
    file: String;
    location: String;
    ondatastream: (args: array of Variant): Variant;
    onerror: (args: array of Variant): Variant;
    onload: (args: array of Variant): Variant;
    onreadystatechange: (args: array of Variant): Variant;
    onsendstream: (args: array of Variant): Variant;
    password: String;
    readyState: Float;
    responseData: JTi.Blob;
    responseText: String;
    responseXML: JTi.XML.Document;
    securityManager: JSecurityManagerProtocol;
    status: Float;
    statusText: String;
    timeout: Float;
    tlsVersion: Float;
    username: String;
    validatesSecureCertificate: Boolean;
    withCredentials: Boolean;
    procedure abort;
    procedure addAuthFactory(scheme: String; factory: Variant);
    procedure addKeyManager(X509KeyManager: Variant);
    procedure addTrustManager(X509TrustManager: Variant);
    procedure clearCookies(host: String);
    function getAllResponseHeaders: String;
    function getAutoEncodeUrl: Boolean;
    function getAutoRedirect: Boolean;
    function getCache: Boolean;
    function getConnected: Boolean;
    function getConnectionType: String;
    function getDomain: String;
    function getEnableKeepAlive: Boolean;
    function getFile: String;
    function getLocation: String;
    function getOndatastream: (args: array of Variant): Variant;
    function getOnerror: (args: array of Variant): Variant;
    function getOnload: (args: array of Variant): Variant;
    function getOnreadystatechange: (args: array of Variant): Variant;
    function getOnsendstream: (args: array of Variant): Variant;
    function getPassword: String;
    function getReadyState: Float;
    function getResponseData: JTi.Blob;
    function getResponseHeader(name: String): String;
    function getResponseText: String;
    function getResponseXML: JTi.XML.Document;
    function getSecurityManager: JSecurityManagerProtocol;
    function getStatus: Float;
    function getStatusText: String;
    function getTimeout: Float;
    function getTlsVersion: Float;
    function getUsername: String;
    function getValidatesSecureCertificate: Boolean;
    function getWithCredentials: Boolean;
    procedure open(method: String; url: String); overload;
    procedure open(method: String; url: String; async: Boolean); overload;
    procedure send; overload;
    procedure send(data: Variant); overload;
    procedure send; overload;
    procedure send(data: String); overload;
    procedure send; overload;
    procedure send(data: JTi.Filesystem.File); overload;
    procedure send; overload;
    procedure send(data: JTi.Blob); overload;
    procedure setAutoEncodeUrl(autoEncodeUrl: Boolean);
    procedure setAutoRedirect(autoRedirect: Boolean);
    procedure setCache(cache: Boolean);
    procedure setDomain(domain: String);
    procedure setEnableKeepAlive(enableKeepAlive: Boolean);
    procedure setFile(file: String);
    procedure setOndatastream(ondatastream: (args: array of Variant): Variant);
    procedure setOnerror(onerror: (args: array of Variant): Variant);
    procedure setOnload(onload: (args: array of Variant): Variant);
    procedure setOnreadystatechange(onreadystatechange: (args: array of Variant): Variant);
    procedure setOnsendstream(onsendstream: (args: array of Variant): Variant);
    procedure setPassword(password: String);
    procedure setRequestHeader(name: String; value: String);
    procedure setTimeout(timeout: Float);
    procedure setTlsVersion(tlsVersion: Float);
    procedure setUsername(username: String);
    procedure setValidatesSecureCertificate(validatesSecureCertificate: Boolean);
    procedure setWithCredentials(withCredentials: Boolean);
  end;

  JBonjourBrowser = class external(JTi.Proxy)
    domain: String;
    isSearching: Boolean;
    serviceType: String;
    function getDomain: String;
    function getIsSearching: Boolean;
    function getServiceType: String;
    procedure search;
    procedure setDomain(domain: String);
    procedure setIsSearching(isSearching: Boolean);
    procedure setServiceType(serviceType: String);
    procedure stopSearch;
  end;

  JCookie = class external(JTi.Proxy)
    comment: String;
    domain: String;
    expiryDate: String;
    httponly: Boolean;
    name: String;
    originalUrl: String;
    path: String;
    secure: Boolean;
    value: String;
    version: Float;
    function getComment: String;
    function getDomain: String;
    function getExpiryDate: String;
    function getHttponly: Boolean;
    function getName: String;
    function getOriginalUrl: String;
    function getPath: String;
    function getSecure: Boolean;
    function getValue: String;
    function getVersion: Float;
    function isValid: Boolean;
    procedure setComment(comment: String);
    procedure setDomain(domain: String);
    procedure setExpiryDate(expiryDate: String);
    procedure setHttponly(httponly: Boolean);
    procedure setOriginalUrl(originalUrl: String);
    procedure setPath(path: String);
    procedure setSecure(secure: Boolean);
    procedure setValue(value: String);
    procedure setVersion(version: Float);
  end;

//Socket

type
  JUDP = class external(JTi.IOStream)
    data: (args: array of Variant): Variant;
    error: (args: array of Variant): Variant;
    port: Float;
    started: (args: array of Variant): Variant;
    function getData: (args: array of Variant): Variant;
    function getError: (args: array of Variant): Variant;
    function getPort: Float;
    function getStarted: (args: array of Variant): Variant;
    procedure sendBytes(port: Float; host: String; data: JArray{<JNumber>});
    procedure sendString(port: Float; host: String; data: String);
    procedure setData(data: (args: array of Variant): Variant);
    procedure setError(error: (args: array of Variant): Variant);
    procedure setPort(port: Float);
    procedure setStarted(started: (args: array of Variant): Variant);
    procedure start(port: Float);
    procedure stop;
  end;

  JTCP = class external(JTi.IOStream)
    accepted: (args: array of Variant): Variant;
    connected: (args: array of Variant): Variant;
    error: (args: array of Variant): Variant;
    host: String;
    listenQueueSize: Float;
    port: Float;
    state: Float;
    timeout: Float;
    procedure accept(options: JAcceptDict);
    procedure connect;
    function getAccepted: (args: array of Variant): Variant;
    function getConnected: (args: array of Variant): Variant;
    function getError: (args: array of Variant): Variant;
    function getHost: String;
    function getListenQueueSize: Float;
    function getPort: Float;
    function getState: Float;
    function getTimeout: Float;
    procedure listen;
    procedure setAccepted(accepted: (args: array of Variant): Variant);
    procedure setConnected(connected: (args: array of Variant): Variant);
    procedure setError(error: (args: array of Variant): Variant);
    procedure setHost(host: String);
    procedure setListenQueueSize(listenQueueSize: Float);
    procedure setPort(port: Float);
    procedure setTimeout(timeout: Float);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createTCP: JTi.Network.Socket.TCP; overload;
function createTCP(params: JDictionary{<JTi.Network.Socket.TCP>}): JTi.Network.Socket.TCP; overload;
function createUDP: JTi.Network.Socket.UDP; overload;
function createUDP(params: JDictionary{<JTi.Network.Socket.UDP>}): JTi.Network.Socket.UDP; overload;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);

var
  CLOSED: Float;
  CONNECTED: Float;
  ERROR: Float;
  INITIALIZED: Float;
  LISTENING: Float;
  apiName: String;
  bubbleParent: Boolean;

procedure addConnectivityListener(callback: (args: array of Variant): Variant);
procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure addHTTPCookie(cookie: JTi.Network.Cookie);
procedure addSystemCookie(cookie: JTi.Network.Cookie);
procedure applyProperties(props: JDictionary{<JObject>});
function createBonjourBrowser(serviceType: String; domain: String): JTi.Network.BonjourBrowser; overload;
function createBonjourBrowser(serviceType: String; domain: String; parameters: JDictionary{<JTi.Network.BonjourBrowser>}): JTi.Network.BonjourBrowser; overload;
function createBonjourService(name: String; &type: String; domain: String): JTi.Network.BonjourService; overload;
function createBonjourService(name: String; &type: String; domain: String; parameters: JDictionary{<JTi.Network.BonjourService>}): JTi.Network.BonjourService; overload;
function createCookie: JTi.Network.Cookie; overload;
function createCookie(parameters: JDictionary{<JTi.Network.Cookie>}): JTi.Network.Cookie; overload;
function createHTTPClient: JTi.Network.HTTPClient; overload;
function createHTTPClient(parameters: JDictionary{<JTi.Network.HTTPClient>}): JTi.Network.HTTPClient; overload;
function createTCPSocket(hostName: String; port: Float; mode: Float; parameters: JDictionary{<JTi.Network.TCPSocket>}): JTi.Network.TCPSocket;
function decodeURIComponent(value: String): String;
function encodeURIComponent(value: String): String;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAllHTTPCookies: JArray{<JTi.Network.Cookie>};
function getApiName: String;
function getBubbleParent: Boolean;
function getHTTPCookies(domain: String; path: String; name: String): JArray{<JTi.Network.Cookie>};
function getHTTPCookiesForDomain(domain: String): JArray{<JTi.Network.Cookie>};
function getHttpURLFormatter: (args: array of Variant): Variant;
function getNetworkType: Float;
function getNetworkTypeName: String;
function getOnline: Boolean;
function getRemoteDeviceUUID: String;
function getRemoteNotificationTypes: JArray{<JNumber>};
function getRemoteNotificationsEnabled: Boolean;
function getSystemCookies(domain: String; path: String; name: String): JArray{<JTi.Network.Cookie>};
procedure registerForPushNotifications(config: JPushNotificationConfig);
procedure removeAllHTTPCookies;
procedure removeAllSystemCookies;
procedure removeConnectivityListener(callback: (args: array of Variant): Variant);
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure removeHTTPCookie(domain: String; path: String; name: String);
procedure removeHTTPCookiesForDomain(domain: String);
procedure removeSystemCookie(domain: String; path: String; name: String);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setHttpURLFormatter(httpURLFormatter: (args: array of Variant): Variant);
procedure unregisterForPushNotifications;

var
  INADDR_ANY: String;
  NETWORK_LAN: Float;
  NETWORK_MOBILE: Float;
  NETWORK_NONE: Float;
  NETWORK_UNKNOWN: Float;
  NETWORK_WIFI: Float;
  NOTIFICATION_TYPE_ALERT: Float;
  NOTIFICATION_TYPE_BADGE: Float;
  NOTIFICATION_TYPE_NEWSSTAND: Float;
  NOTIFICATION_TYPE_SOUND: Float;
  PROGRESS_UNKNOWN: Float;
  READ_MODE: Float;
  READ_WRITE_MODE: Float;
  SOCKET_CLOSED: Float;
  SOCKET_CONNECTED: Float;
  SOCKET_ERROR: Float;
  SOCKET_INITIALIZED: Float;
  SOCKET_LISTENING: Float;
  TLS_VERSION_1_0: Float;
  TLS_VERSION_1_1: Float;
  TLS_VERSION_1_2: Float;
  WRITE_MODE: Float;
  allHTTPCookies: JArray{<JTi.Network.Cookie>};
  apiName: String;
  bubbleParent: Boolean;
  httpURLFormatter: (args: array of Variant): Variant;
  networkType: Float;
  networkTypeName: String;
  online: Boolean;
  remoteDeviceUUID: String;
  remoteNotificationTypes: JArray{<JNumber>};
  remoteNotificationsEnabled: Boolean;

//Facebook

type
  JLoginButton = class external(JTi.UI.View)
    style: String;
    function getStyle: String;
    procedure setStyle(style: String);
  end;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
procedure authorize;
function createLoginButton: JTi.Facebook.LoginButton; overload;
function createLoginButton(parameters: JDictionary{<JTi.Facebook.LoginButton>}): JTi.Facebook.LoginButton; overload;
procedure dialog(action: String; params: Variant; callback: (args: array of Variant): Variant);
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getAccessToken: String;
function getApiName: String;
function getAppid: String;
function getBubbleParent: Boolean;
function getExpirationDate: JDate;
function getForceDialogAuth: Boolean;
function getLoggedIn: Boolean;
function getPermissions: JArray{<JString>};
function getUid: String;
procedure logout;
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure request(method: String; params: Variant; callback: (args: array of Variant): Variant);
procedure requestWithGraphPath(path: String; params: JDictionary{<JObject>}; httpMethod: String; callback: (args: array of Variant): Variant);
procedure setAccessToken(accessToken: String);
procedure setAppid(appid: String);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setExpirationDate(expirationDate: JDate);
procedure setForceDialogAuth(forceDialogAuth: Boolean);
procedure setLoggedIn(loggedIn: Boolean);
procedure setPermissions(permissions: JArray{<JString>});
procedure setUid(uid: String);

var
  BUTTON_STYLE_NORMAL: Float;
  BUTTON_STYLE_WIDE: Float;
  accessToken: String;
  apiName: String;
  appid: String;
  bubbleParent: Boolean;
  expirationDate: JDate;
  forceDialogAuth: Boolean;
  loggedIn: Boolean;
  permissions: JArray{<JString>};
  uid: String;

procedure addEventListener(name: String; callback: (args: array of Variant): Variant);
procedure applyProperties(props: JDictionary{<JObject>});
function createBuffer(params: JCreateBufferArgs): JTi.Buffer;
procedure fireEvent(name: String; event: JDictionary{<JObject>});
function getApiName: String;
function getBubbleParent: Boolean;
function getBuildDate: String;
function getBuildHash: String;
function getUserAgent: String;
function getVersion: String;
procedure include(name: String);
procedure removeEventListener(name: String; callback: (args: array of Variant): Variant);
procedure setBubbleParent(bubbleParent: Boolean);
procedure setUserAgent(userAgent: String);

var
  apiName: String;
  bubbleParent: Boolean;
  buildDate: String;
  buildHash: String;
  userAgent: String;
  version: String;

