unit Webix;

interface

//webix

type
  JPromisedData = class external
    function then(handler: (data: Variant): Variant): JPromisedData;
  end;

  J_ajax = class external
    function bind(master: Variant): Jwebix._ajax;
    function del(url: String): JPromisedData; overload;
    function del(url: String; params: Variant): JPromisedData; overload;
    function del(url: String; params: Variant; callback: JWebixCallback): JPromisedData; overload;
    function get(url: String): JPromisedData; overload;
    function get(url: String; params: Variant): JPromisedData; overload;
    function get(url: String; params: Variant; callback: JWebixCallback): JPromisedData; overload;
    function getXHR: Variant;
    function headers(values: Variant): Jwebix._ajax;
    function post(url: String): JPromisedData; overload;
    function post(url: String; params: Variant): JPromisedData; overload;
    function post(url: String; params: Variant; callback: JWebixCallback): JPromisedData; overload;
    function put(url: String): JPromisedData; overload;
    function put(url: String; params: Variant): JPromisedData; overload;
    function put(url: String; params: Variant; callback: JWebixCallback): JPromisedData; overload;
    procedure response(&type: String);
    function stringify(data: Variant): String;
    function sync: Jwebix._ajax;
    master: Variant;
  end;

  Jclipbuffer = class external
    procedure destructor;
    procedure focus;
    procedure init;
    procedure set(text: String);
  end;

  Jcolor = class external
    function hexToDec(hex: String): Float;
    function hsvToRgb(h: Float; s: Float; v: Float): array of Variant;
    function rgbToHsv(r: Float; g: Float; b: Float): array of Variant;
    function toHex(number: Float): String; overload;
    function toHex(number: Float; _length: Float): String; overload;
    function toRgb(rgb: String): array of Variant;
  end;

  Jcsv = class external
    function parse(text: String): array of Variant; overload;
    function parse(text: String; delimiter: Variant): array of Variant; overload;
    function stringify(data: array of Variant): String; overload;
    function stringify(data: array of Variant; delimiter: Variant): String; overload;
    delimiter: Variant;
    escape: Boolean;
  end;

  Jeditors = class external
    $popup: Variant;
    checkbox: String;
    color: String;
    combo: String;
    date: String;
    "inline-checkbox": String;
    "inline-text": String;
    multiselect: String;
    password: String;
    popup: String;
    richselect: String;
    select: String;
    text: String;
  end;

  Jenv = class external
    cssPrefix: String;
    isFF: Boolean;
    isIE: Boolean;
    isSafari: Boolean;
    isWebKit: Boolean;
    jsPrefix: String;
    mouse: Variant;
    strict: Boolean;
    svg: Boolean;
    transform: Boolean;
    transition: Boolean;
    transitionDuration: String;
    transitionEnd: String;
    translate: String;
  end;

  Jhistory = class external
    procedure push(view: String; url: String; value: Variant);
    procedure track(view: String; url: String);
  end;

  Jhtml = class external
    procedure addCss(node: JHTMLElement; name: String);
    procedure addMeta(name: String; value: String);
    procedure addStyle(css: String);
    procedure allowSelect;
    function create(name: String; attrs: Variant): JHTMLElement; overload;
    function create(name: String; attrs: Variant; html: String): JHTMLElement; overload;
    function createCss(data: Variant): String;
    procedure denySelect;
    function getValue(node: JHTMLElement): String;
    function index(node: JHTMLElement): Float;
    procedure insertBefore(node: JHTMLElement; before: JHTMLElement); overload;
    procedure insertBefore(node: JHTMLElement; before: JHTMLElement; rescue: JHTMLElement); overload;
    function locate(ev: Variant {JEvent or JHTMLElement}; name: String): String;
    function offset(node: JHTMLElement): Variant;
    function pos(ev: JEvent): Variant;
    function posRelative(ev: JEvent): Variant;
    function preventEvent(ev: JEvent): Boolean;
    procedure remove(node: Variant {JHTMLElement or array of JHTMLElement});
    procedure removeCss(node: JHTMLElement; name: String);
    function stopEvent(ev: JEvent): Boolean;
  end;

  Ji18n = class external
    function dateFormatDate(date: String): Variant;
    function dateFormatStr(date: Variant): String;
    function fullDateFormatDate(date: String): Variant;
    function fullDateFormatStr(date: JDate): String;
    function intFormat(num: Float): String;
    function longDateFormatDate(date: String): Variant;
    function longDateFormatStr(date: Variant): String;
    function numberFormat(number: Float): String;
    function parseFormatDate(date: String): Variant;
    function parseFormatStr(date: Variant): String;
    function parseTimeFormatDate(date: String): Variant;
    function parseTimeFormatStr(date: Variant): String;
    function priceFormat(number: Float): String;
    procedure setLocale(name: String);
    function timeFormatDate(time: String): Variant;
    function timeFormatStr(date: Variant): String;
    calendar: Variant;
    controls: Variant;
    dateFormat: String;
    decimalDelimiter: String;
    decimalSize: Float;
    fileSize: array of Variant;
    fullDateFormat: String;
    groupDelimiter: String;
    groupSize: Float;
    locales: Variant;
    longDateFormat: String;
    parseFormat: String;
    parseTimeFormat: String;
    price: String;
    priceSettings: Variant;
    timeFormat: String;
  end;

  Jlocale = class external
    pager: Variant;
  end;

  Jmarkup = class external
    function init(node: String; target: String): Jwebix.ui.baseview;
    procedure parse(data: Variant; datatype: String);
    attribute: Variant;
    dataTag: Variant;
    namespace: Variant;
  end;

  Jpromise = class external
    procedure all(promise: JPromisedData); overload;
    procedure all(promise: JPromisedData; morepromises: JPromisedData); overload;
    function defer: JPromisedData;
    function fcall: JPromisedData;
    function nfcall: JPromisedData;
  end;

  Jrules = class external
    function isChecked: Boolean;
    function isEmail: Boolean;
    function isNotEmpty: Boolean;
    function isNumber: Boolean;
  end;

  Jcookie = class external
    procedure clear;
    function get(name: String): Variant;
    procedure put(name: String; value: Variant);
    procedure remove(name: String);
  end;

  Jlocal = class external
    procedure clear;
    function get(name: String): Variant;
    procedure put(name: String; value: Variant);
    procedure remove(name: String);
  end;

  Jsession = class external
    procedure clear;
    function get(name: String): Variant;
    procedure put(name: String; value: Variant);
    procedure remove(name: String);
  end;

  Jstorage = class external
    cookie: Jwebix.cookie;
    local: Jwebix.local;
    session: Jwebix.session;
  end;

  JActiveContent = class external
  end;

  JAtomDataLoader = class external
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure parse(data: Variant; &type: String);
  end;

  JAtomRender = class external
    procedure render(id: String; data: Variant; &type: String);
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
  end;

  JAutoTooltip = class external
  end;

  JBaseBind = class external
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure unbind;
  end;

  JBindSource = class external
    procedure addBind(source: Variant; rule: String; format: String);
    procedure getBindData(key: String; update: Boolean);
    procedure removeBind(source: Variant);
    procedure saveBatch(func: JWebixCallback);
    procedure setBindData(data: Variant; key: String);
  end;

  JCanvas = class external
    procedure clearCanvas;
    function getCanvas(context: String): Variant;
    procedure hideCanvas;
    procedure renderText(x: Float; y: Float; text: String; css: String; w: Float);
    procedure renderTextAt(valign: String; align: String; x: Float; y: Float; t: String; c: String; w: Float);
    procedure showCanvas;
    procedure toggleCanvas;
  end;

  JCollectionBind = class external
    function getCursor: Float;
    procedure refreshCursor;
    procedure setCursor(cursor: String);
  end;

  JContextHelper = class external
    procedure attachTo(view: Variant);
    function getContext: Variant;
  end;

  JCopyPaste = class external
  end;

  JCustomScroll = class external
    procedure enable(html_node: Variant {JHTMLElement or Jwebix.ui.baseview});
    procedure init;
    scrollStep: Float;
  end;

  JDataCollection = class external
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addBind(source: Variant; rule: String; format: String);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearValidation;
    function count: Float;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    procedure getBindData(key: String; update: Boolean);
    function getCursor: Float;
    function getFirstId: String;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getPrevId(id: String; step: Float): String;
    function hasEvent(name: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure refreshCursor;
    procedure remove(id: String);
    procedure removeBind(source: Variant);
    procedure saveBatch(func: JWebixCallback);
    function serialize: Variant;
    procedure setBindData(data: Variant; key: String);
    procedure setCursor(cursor: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    config:       // property Item[key: String]: Variant;
    end;;
    name: String;
  end;

  JDataCollectionFactory = class external
    constructor CreateJDataCollection;
  end;

  JDataDriver = class external
    csv: Variant;
    html: Variant;
    htmltable: Variant;
    jsarray: Variant;
    json: Variant;
    xml: Variant;
  end;

  JDataLoader = class external
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure clearAll;
    function count: Float;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getFirstId: String;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getPrevId(id: String; step: Float): String;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    function serialize: Variant;
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure updateItem(id: String; data: Variant);
  end;

  JDataMarks = class external
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    function hasCss(id: String; css: String): Boolean;
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
  end;

  JDataMove = class external
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
  end;

  JDataProcessor = class external
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure attachProgress(start: JWebixCallback; &end: JWebixCallback; error: JWebixCallback);
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearValidation;
    procedure define(&property: String; value: Variant);
    procedure detachEvent(id: String);
    function escape(value: String): String;
    function getItemState(itemId: String): Variant;
    function getState: Variant {String or Boolean};
    function hasEvent(name: String): Boolean;
    procedure ignore(code: JWebixCallback; master: Variant);
    procedure mapEvent(map: Variant);
    procedure off;
    procedure on;
    procedure processResult(data: Variant);
    procedure reset;
    procedure save(id: String; operation: String);
    procedure send;
    procedure setItemState(itemId: String; state: Boolean);
    procedure unblockEvent;
    function validate: Boolean;
    config:       // property Item[key: String]: Variant;
    end;;
    name: String;
  end;

  JDataRecord = class external
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure detachEvent(id: String);
    function getValues: Variant;
    function hasEvent(name: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    config:       // property Item[key: String]: Variant;
    end;;
    name: String;
  end;

  JDataState = class external
    function getState: Variant;
    procedure setState(state: Variant);
  end;

  JDataStore = class external
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    function addMark(id: String; name: String): Variant; overload;
    function addMark(id: String; name: String; css: Boolean): Variant; overload;
    function addMark(id: String; name: String; css: Boolean; value: Variant): Variant; overload;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure changeId(old: String; newid: String);
    procedure clearAll;
    procedure clearMark(name: String);
    function count: Float;
    procedure destructor;
    procedure detachEvent(id: String);
    procedure each(method: JWebixCallback); overload;
    procedure each(method: JWebixCallback; master: Variant); overload;
    procedure each(method: JWebixCallback; master: Variant; all: Boolean); overload;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getFirstId: String;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getIndexRange(from: String; to: String): array of Variant;
    function getItem(id: String): Variant;
    function getLastId: String;
    function getMark(id: String; mark_name: String): Variant;
    function getNextId(id: String; step: Float): String;
    function getPrevId(id: String; step: Float): String;
    function getRange(from: String; to: String): array of Variant;
    function hasEvent(name: String): Boolean;
    function id(item: Variant): String;
    procedure importData(source: Jwebix.ui.baseview);
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure provideApi(target: Variant; eventable: Boolean);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeMark(id: String; name: String; css: Boolean);
    procedure scheme(config: Variant);
    function serialize: Variant;
    procedure setDriver(&type: String);
    procedure silent(code: JWebixCallback);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unblockEvent;
    procedure unsync;
    procedure updateItem(id: String; data: Variant);
    driver: Variant;
    name: String;
    order: array of Variant;
    pull: Variant;
  end;

  JDataValue = class external
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure detachEvent(id: String);
    function getValue: String;
    function hasEvent(name: String): Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure setValue(value: String);
    procedure unbind;
    procedure unblockEvent;
    name: String;
  end;

  JDate = class external
    function add(date: Variant; inc: Float; mode: String): Variant;
    function copy(date: Variant): Variant;
    function datePart(date: Variant): Variant;
    function dateToStr(format: String; utc: Boolean): JWebixCallback;
    function dayStart(date: Variant): Variant;
    function equal(datea: Variant; dateb: Variant): Boolean;
    function getISOWeek(date: Variant): Float;
    function getUTCISOWeek(data: Variant): Float;
    function isHoliday(date: Variant): Boolean;
    function monthStart(date: Variant): Variant;
    function strToDate(format: String; utc: Boolean): JWebixCallback;
    function timePart(date: Variant): Float;
    function toFixed(num: Float): Float;
    function weekStart(date: Variant): Variant;
    function yearStart(date: Variant): Variant;
    startOnMonday: Boolean;
  end;

  JDestruction = class external
    procedure destructor;
  end;

  JDragControl = class external
    procedure addDrag(node: Variant {String or JHTMLElement}; ctrl: Variant);
    procedure addDrop(node: Variant {String or JHTMLElement}; ctrl: Variant; master_mode: Boolean);
    procedure createDrag(event: JEvent);
    procedure destroyDrag;
    function getContext: Variant;
    function getMaster(target: Variant): Variant;
    function getNode: JHTMLElement;
    procedure sendSignal(signal: String);
    function $drag(s: Variant; e: JEvent): JHTMLElement;
    procedure $dragIn(s: Variant; t: Variant; e: JEvent);
    procedure $dragOut(s: Variant; t: Variant; n: Variant; e: JEvent);
    $dragPos: JWebixCallback;
    procedure $drop(s: Variant; t: Variant; d: Variant; e: JEvent);
    left: Float;
    top: Float;
  end;

  JDragItem = class external
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
  end;

  JDragOrder = class external
    function $drag(source: JHTMLElement; ev: JEvent): String;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    $dragPos: JWebixCallback;
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
  end;

  JEditAbility = class external
    procedure edit(id: Variant);
    procedure editCancel;
    function editNext: Boolean;
    procedure editStop;
    procedure focusEditor;
    function getEditState: Variant;
    function getEditor: Variant; overload;
    function getEditor(id: String): Variant; overload;
    function getEditorValue: String;
    function validateEditor: Boolean; overload;
    function validateEditor(id: String): Boolean; overload;
  end;

  JEventSystem = class external
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure detachEvent(id: String);
    function hasEvent(name: String): Boolean;
    procedure mapEvent(map: Variant);
    procedure unblockEvent;
  end;

  JGroup = class external
    procedure group(config: Variant; mode: Boolean);
    procedure ungroup(mode: Boolean);
  end;

  JGroupMethods = class external
    procedure any(&property: String; data: Variant);
    procedure count(&property: String; data: Variant);
    procedure max(&property: String; data: Variant);
    procedure min(&property: String; data: Variant);
    procedure string(&property: String; data: Variant);
    procedure sum(&property: String; data: Variant);
  end;

  JGroupStore = class external
    procedure group(stats: Variant);
    procedure ungroup;
  end;

  JHtmlMap = class external
    procedure addPoly(id: String; points: array of Variant);
    procedure addRect(id: String; points: array of Variant); overload;
    procedure addRect(id: String; points: array of Variant; userdata: String); overload;
    procedure addSector(id: String; aplha0: Float; aplha1: Float; x: Float; y: Float; R: Float; ky: Float);
    procedure render(html: JHTMLElement);
  end;

  JIdSpace = class external
    function innerId(id: String): String;
    function ui(view: Variant): Jwebix.ui.baseview;
    $$: Variant;
  end;

  JKeysNavigation = class external
    procedure moveSelection(direction: String);
  end;

  JMapCollection = class external
  end;

  JModality = class external
  end;

  JMouseEvents = class external
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
  end;

  JMovable = class external
  end;

  JNavigationButtons = class external
  end;

  JNumber = class external
    function format(value: Float; config: Variant): String;
    function numToStr(config: Variant): JWebixCallback;
  end;

  JOverlayBox = class external
    procedure hideOverlay;
    procedure showOverlay;
  end;

  JPagingAbility = class external
    function getPage: Float;
    function getPager: Variant;
    procedure setPage(page: Float);
  end;

  JPowerArray = class external
    procedure each(functor: JWebixCallback; master: Variant);
    function filter(functor: JWebixCallback; master: Variant): array of Variant;
    function find(data: Variant): Float;
    procedure insertAt(data: Variant; pos: Float);
    function map(functor: JWebixCallback; master: Variant): array of Variant;
    procedure remove(value: Variant);
    procedure removeAt(pos: Float; len: Float);
  end;

  JProgressBar = class external
    procedure hideProgress;
    procedure showProgress; overload;
    procedure showProgress(config: Variant); overload;
  end;

  JRecordBind = class external
  end;

  JRenderStack = class external
    procedure customize(obj: Variant);
    procedure getItemNode(id: String);
    function locate(e: JEvent): String;
    procedure render(id: String; data: Variant; &type: String);
    procedure showItem(id: String);
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JScrollable = class external
    function getScrollState: Variant;
    procedure scrollTo(x: Float; y: Float);
  end;

  JSelectionModel = class external
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function isSelected(id: String): Boolean;
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
  end;

  JSettings = class external
    procedure define(&property: String; value: Variant);
    config:       // property Item[key: String]: Variant;
    end;;
    name: String;
  end;

  JSingleRender = class external
    procedure customize(obj: Variant);
    procedure render(id: String; data: Variant; &type: String);
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    &type:       // property Item[key: String]: Variant;
    end;;
  end;

  JTablePaste = class external
  end;

  JTouch = class external
    procedure disable;
    procedure enable;
    procedure limit(mode: Boolean);
    procedure scrollTo(node: JHTMLElement; x: Float; y: Float; speed: String);
    config: Variant;
  end;

  JTreeAPI = class external
    procedure close(id: String);
    procedure closeAll;
    function getOpenItems: array of Variant;
    function getState: Variant;
    function isBranchOpen(id: String): Boolean;
    procedure open(id: String);
    procedure openAll;
    procedure setState(state: Variant);
  end;

  JTreeClick = class external
    function webix_tree_checkbox(obj: Variant; common:       // property Item[key: String]: Variant;
    end;): String;
    function webix_tree_close(obj: Variant; common:       // property Item[key: String]: Variant;
    end;): String;
    function webix_tree_open(obj: Variant; common:       // property Item[key: String]: Variant;
    end;): String;
  end;

  JTreeCollection = class external
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    function add(obj: Variant; index: Float; parentId: String): String; overload;
    procedure addBind(source: Variant; rule: String; format: String);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearValidation;
    function count: Float;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    procedure getBindData(key: String; update: Boolean);
    function getBranchIndex(id: String): Float; overload;
    function getBranchIndex(id: String; parent: String): Float; overload;
    function getCursor: Float;
    function getFirstChildId(id: String): String;
    function getFirstId: String;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNextSiblingId(id: Variant): String;
    function getParentId(id: String): String;
    function getPrevId(id: String; step: Float): String;
    function getPrevSiblingId(id: Variant): String;
    function hasEvent(name: String): Boolean;
    function isBranch(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadBranch(id: String; callback: JWebixCallback; url: String);
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure refreshCursor;
    procedure remove(id: String);
    procedure removeBind(source: Variant);
    procedure saveBatch(func: JWebixCallback);
    function serialize: Variant;
    procedure setBindData(data: Variant; key: String);
    procedure setCursor(cursor: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    config:       // property Item[key: String]: Variant;
    end;;
    name: String;
  end;

  JTreeDataLoader = class external
    procedure loadBranch(id: String; callback: JWebixCallback; url: String);
  end;

  JTreeDataMove = class external
    function copy(sid: String; tindex: Float): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview; details: Variant): String; overload;
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Jwebix.ui.baseview): String; overload;
    function move(sid: String; tindex: Float; tobj: Jwebix.ui.baseview; details: Variant): String; overload;
    $dropAllow: JWebixCallback;
  end;

  JTreeRenderStack = class external
    procedure getItemNode(id: String);
    function getItemNode(id: String): JHTMLElement;
  end;

  JTreeStateCheckbox = class external
    procedure checkAll; overload;
    procedure checkAll(id: String); overload;
    procedure checkItem(id: String);
    function getChecked: array of Variant;
    function isChecked(id: String): Boolean;
    procedure uncheckAll; overload;
    procedure uncheckAll(id: String); overload;
    procedure uncheckItem(id: String);
  end;

  JTreeStore = class external
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    function add(obj: Variant; index: Float; parentId: String): String; overload;
    procedure changeId(old: String; newid: String);
    procedure clearAll;
    function count: Float;
    procedure each(code: JWebixCallback; master: Variant; all: Boolean; pid: String);
    procedure eachChild(pid: String; code: JWebixCallback); overload;
    procedure eachChild(pid: String; code: JWebixCallback; master: Variant); overload;
    procedure eachChild(pid: String; code: JWebixCallback; master: Variant; all: Boolean); overload;
    procedure eachOpen(code: JWebixCallback); overload;
    procedure eachOpen(code: JWebixCallback; master: Variant); overload;
    procedure eachOpen(code: JWebixCallback; master: Variant; pid: String); overload;
    procedure eachSubItem(pid: String; code: JWebixCallback);
    function getBranch(id: String): array of Variant;
    function getBranchIndex(id: String): Float; overload;
    function getBranchIndex(id: String; parent: String): Float; overload;
    function getFirstChildId(id: String): String;
    function getNextSiblingId(id: Variant): String;
    function getParentId(id: String): String;
    function getPrevSiblingId(id: Variant): String;
    function getTopRange: array of Variant;
    function isBranch(id: String): Boolean;
    procedure provideApi(target: Variant; eventable: Boolean);
    procedure remove(id: String);
    function serialize: Variant;
    name: String;
  end;

  JTreeTableClick = class external
  end;

  JTreeTablePaste = class external
    procedure insert(data: array of Variant);
  end;

  JTreeType = class external
    function checkbox(obj: Variant; common: Variant): String;
    function folder(obj: Variant; common: Variant): String;
    function icon(obj: Variant; common: Variant): String;
    function space(obj: Variant; common: Variant): String;
  end;

  JUIExtension = class external
  end;

  JUIManager = class external
    procedure addHotKey(key: String; handler: JWebixCallback); overload;
    procedure addHotKey(key: String; handler: JWebixCallback; obj: Variant); overload;
    function canFocus(id: String): Boolean;
    procedure destructor;
    function getFocus: Jwebix.ui.baseview;
    function getNext(view: Variant): Variant;
    function getPrev(view: Variant): Variant;
    function getState(id: String; childs: Boolean): Variant;
    function getTop(id: String): Variant;
    function hasFocus(id: String): Boolean;
    procedure removeHotKey(key: String); overload;
    procedure removeHotKey(key: String; handler: JWebixCallback); overload;
    procedure removeHotKey(key: String; handler: JWebixCallback; obj: Variant); overload;
    procedure setFocus(id: String);
    procedure setState(state: Variant);
  end;

  JUploadDriver = class external
    flash: Variant;
    html5: Variant;
  end;

  JValidateCollection = class external
    procedure clearValidation;
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
  end;

  JValidateData = class external
    procedure clearValidation;
    function validate: Boolean;
  end;

  JValueBind = class external
  end;

  JValues = class external
    procedure clear;
    procedure focus(item: String);
    function getCleanValues: Variant;
    function getDirtyValues: Variant;
    function getValues:       // property Item[key: String]: Variant;
    end;; overload;
    function getValues(details: Variant):       // property Item[key: String]: Variant;
    end;; overload;
    function isDirty: Boolean;
    procedure setDirty; overload;
    procedure setDirty(mark: Boolean); overload;
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
  end;

  JVirtualRenderStack = class external
    procedure getItemNode(id: String);
    procedure render(id: String; data: Variant; &type: String);
    procedure showItem(id: String);
  end;

WebixTemplate = (args: array of Variant): StringWebixCallback = (args: array of Variant): Variant//ui

type
  JbaselayoutConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jbaselayout = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JbaselayoutConfig;
    name: String;
  end;

  JbaseviewConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    width: Float; // nullable
  end;

  Jbaseview = class external
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JbaseviewConfig;
    name: String;
  end;

  JprotoConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jproto = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getTopParentView: Jwebix.ui.baseview;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JprotoConfig;
    name: String;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JresizeareaConfig = class external
    border: Boolean; // nullable
    container: Variant {String or JHTMLElement}; // nullable
    cursor: String; // nullable
    dir: String; // nullable
    eventPos: Float; // nullable
    height: Float; // nullable
    id: String; // nullable
    on: Variant; // nullable
    start: Float; // nullable
    width: Float; // nullable
  end;

  Jresizearea = class external
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure detachEvent(id: String);
    function hasEvent(name: String): Boolean;
    procedure mapEvent(map: Variant);
    procedure unblockEvent;
    config: JresizeareaConfig;
    name: String;
  end;

  JviewConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    width: Float; // nullable
  end;

  Jview = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JviewConfig;
    name: String;
  end;

  JvscrollConfig = class external
    container: JHTMLElement; // nullable
    id: String; // nullable
    on: Variant; // nullable
    scroll: String; // nullable
    scrollHeight: Float; // nullable
    scrollPos: Float; // nullable
    scrollSize: Float; // nullable
    scrollStep: Float; // nullable
    scrollVisible: Boolean; // nullable
    scrollWidth: Float; // nullable
    zoom: Float; // nullable
  end;

  Jvscroll = class external(Jwebix.ui.baseview)
    procedure activeArea(node: JHTMLElement);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure detachEvent(id: String);
    function getScroll: Float;
    function getSize: Float;
    function hasEvent(name: String): Boolean;
    procedure mapEvent(map: Variant);
    procedure scrollTo(pos: Float);
    procedure sizeTo(size: Float);
    procedure unblockEvent;
    config: JvscrollConfig;
    name: String;
  end;

  JaccordionConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    collapsed: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    multi: Variant {Boolean or String}; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    panelClass: String; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    &type: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jaccordion = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JaccordionConfig;
    name: String;
  end;

  JaccordionitemConfig = class external
    animate: Variant; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    collapsed: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    header: Variant {Boolean or String or JWebixCallback}; // nullable
    headerAlt: Variant {String or JWebixCallback}; // nullable
    headerAltHeight: Float; // nullable
    headerHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    width: Float; // nullable
  end;

  Jaccordionitem = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure collapse;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure expand;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JaccordionitemConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
  end;

  JbarcodeConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    color: String; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    textHeight: Float; // nullable
    &type: Variant; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jbarcode = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure render;
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JbarcodeConfig;
    name: String;
    types: array of Variant;
  end;

  JbuttonConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputWidth: Float; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jbutton = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JbuttonConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JcalendarConfig = class external
    animate: Variant; // nullable
    blockDates: JWebixCallback; // nullable
    borderless: Boolean; // nullable
    calendarHeader: String; // nullable
    calendarTime: String; // nullable
    calendarWeekHeader: String; // nullable
    cellHeight: Float; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    date: Variant; // nullable
    dayTemplate: JWebixCallback; // nullable
    disabled: Boolean; // nullable
    events: JWebixCallback; // nullable
    gravity: Float; // nullable
    headerHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    icons: Variant; // nullable
    id: String; // nullable
    maxDate: Variant {JDate or String}; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minDate: Variant {JDate or String}; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    minuteStep: Float; // nullable
    monthSelect: Boolean; // nullable
    mouseEventDelay: Float; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    select: Boolean; // nullable
    skipEmptyWeeks: Boolean; // nullable
    timepicker: Boolean; // nullable
    timepickerHeight: Float; // nullable
    &type: String; // nullable
    weekHeader: Boolean; // nullable
    weekNumber: Boolean; // nullable
    width: Float; // nullable
  end;

  Jcalendar = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getSelectedDate: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Variant;
    function getVisibleDate: Variant;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure selectDate(date: Variant);
    procedure setValue(date: Variant);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showCalendar(date: Variant);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcalendarConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
  end;

  JcarouselConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    navigation: Variant; // nullable
    on: Variant; // nullable
    rows: array of Variant; // nullable
    scrollSpeed: String; // nullable
    &type: String; // nullable
    width: Float; // nullable
  end;

  Jcarousel = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure adjustScroll(matrix: Variant);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getActiveId: String;
    function getActiveIndex: Float;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getLayout: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure setActive(id: String);
    procedure setActiveIndex(index: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showNext;
    procedure showPrev;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcarouselConfig;
    name: String;
  end;

  JchartConfig = class external
    alpha: Float; // nullable
    animate: Variant; // nullable
    barWidth: Float; // nullable
    border: Boolean; // nullable
    borderColor: String; // nullable
    borderless: Boolean; // nullable
    cant: Float; // nullable
    color: Variant {String or JWebixCallback}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disableLines: Boolean; // nullable
    disabled: Boolean; // nullable
    eventRadius: Float; // nullable
    fill: String; // nullable
    fixOverflow: Boolean; // nullable
    gradient: Variant {Boolean or String or JWebixCallback}; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    item: Variant; // nullable
    &label: Variant {String or JWebixCallback}; // nullable
    labelOffset: Float; // nullable
    legend: Variant; // nullable
    line: Variant; // nullable
    lineColor: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    offset: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    origin: Float; // nullable
    padding: Variant; // nullable
    pieHeight: Float; // nullable
    pieInnerText: Variant {String or JWebixCallback}; // nullable
    preset: String; // nullable
    radius: Float; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    save: String; // nullable
    scale: String; // nullable
    scheme: Variant; // nullable
    series: array of Variant; // nullable
    shadow: Boolean; // nullable
    tooltip: Variant; // nullable
    &type: String; // nullable
    url: String; // nullable
    value: Variant {String or JWebixTemplate}; // nullable
    width: Float; // nullable
    x: Float; // nullable
    xAxis: Variant; // nullable
    xValue: String; // nullable
    y: Float; // nullable
    yAxis: Variant; // nullable
    yValue: String; // nullable
  end;

  Jchart = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addSeries(obj: Variant);
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCanvas;
    function count: Float;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getTopParentView: Jwebix.ui.baseview;
    procedure group(config: Variant; mode: Boolean);
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideSeries(series: String);
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeAllSeries;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    function serialize: Variant;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showSeries(series: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure ungroup(mode: Boolean);
    procedure updateItem(id: String; data: Variant);
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    colormap:       // property Item[key: String]: Variant;
    end;;
    config: JchartConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    presets:       // property Item[key: String]: Variant;
    end;;
  end;

  JcheckboxConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    checkValue: String; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    customCheckbox: Boolean; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    uncheckValue: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jcheckbox = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure toggle;
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcheckboxConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JcolorboardConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cols: Float; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxLightness: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minLightness: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    palette: array of Variant; // nullable
    rows: Float; // nullable
    template: JWebixCallback; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jcolorboard = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    function setValue(value: String): String;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcolorboardConfig;
    name: String;
  end;

  JcolorpickerConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    editable: Boolean; // nullable
    format: String; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    icons: Boolean; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    stringResult: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    timeIcon: String; // nullable
    timepicker: Boolean; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jcolorpicker = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcolorpickerConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JcomboConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    popupWidth: Float; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jcombo = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcomboConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JcontextConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    left: Float; // nullable
    master: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    top: Float; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jcontext = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure attachTo(view: Variant);
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getContext: Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setPosition(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcontextConfig;
    name: String;
  end;

  JcontextmenuConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    left: Float; // nullable
    master: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    mouseEventDelay: Float; // nullable
    move: Boolean; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    padding: Variant; // nullable
    pager: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    ready: JWebixCallback; // nullable
    relative: String; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    subMenuPos: String; // nullable
    submenu: Variant; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    tooltip: Variant; // nullable
    top: Float; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jcontextmenu = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure attachTo(view: Variant);
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure close;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure disableItem(id: String);
    procedure enable;
    procedure enableItem(id: String);
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getContext: Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getMenu(id: Variant {String or Float}): Variant;
    function getMenuItem(id: String): Variant;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getSubMenu(id: Variant {String or Float}): Variant;
    function getTopMenu: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideItem(id: String);
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure resizeChildren;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure setPosition(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcontextmenuConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JcounterConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    max: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    min: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    step: Float; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jcounter = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Float;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure next; overload;
    procedure next(step: Float); overload;
    procedure prev; overload;
    procedure prev(step: Float); overload;
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: Float);
    procedure shift; overload;
    procedure shift(value: Float); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JcounterConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JdatasuggestConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    filter: JWebixCallback; // nullable
    fitMaster: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    input: Variant; // nullable
    keyPressTimeout: Float; // nullable
    left: Float; // nullable
    master: Jwebix.ui.baseview; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    template: Variant {String or JWebixTemplate}; // nullable
    textValue: String; // nullable
    top: Float; // nullable
    &type: String; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jdatasuggest = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getItemText(id: String): String;
    function getList: Jwebix.ui.baseview;
    function getMasterValue: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getSuggestion: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Variant {String or Float};
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure linkInput(input: JHTMLElement);
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setMasterValue(value: Variant);
    procedure setPosition(x: Float; y: Float);
    procedure setValue(value: Variant {String or Float});
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JdatasuggestConfig;
    name: String;
  end;

  JdatatableConfig = class external
    animate: Variant; // nullable
    autoConfig: Boolean; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    blockselect: Boolean; // nullable
    borderless: Boolean; // nullable
    checkboxRefresh: Boolean; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    columnWidth: Float; // nullable
    columns: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datafetch: Float; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    delimiter: Variant; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragColumn: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    editMath: Boolean; // nullable
    editValue: String; // nullable
    editable: Boolean; // nullable
    editaction: String; // nullable
    externalData: JWebixCallback; // nullable
    filterMode: Variant; // nullable
    fixedRowHeight: Boolean; // nullable
    footer: Boolean; // nullable
    form: String; // nullable
    gravity: Float; // nullable
    header: Boolean; // nullable
    headerRowHeight: Float; // nullable
    headermenu: Variant; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hover: String; // nullable
    id: String; // nullable
    leftSplit: Float; // nullable
    liveValidation: Boolean; // nullable
    loadahead: Float; // nullable
    math: Boolean; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minColumnHeight: Float; // nullable
    minColumnWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Boolean; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    prerender: Boolean; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    resizeColumn: Boolean; // nullable
    resizeRow: Boolean; // nullable
    rightSplit: Float; // nullable
    rowHeight: Float; // nullable
    rowLineHeight: Float; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Boolean; // nullable
    scrollAlignY: Boolean; // nullable
    scrollX: Boolean; // nullable
    scrollY: Boolean; // nullable
    select: Variant {Boolean or String}; // nullable
    spans: array of Variant; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    yCount: Float; // nullable
  end;

  Jdatatable = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCellCss(id: String; name: String; css: String);
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure addRowCss(id: String; css: String);
    procedure addSpan(id: Variant; column: String; width: Float; height: Float); overload;
    procedure addSpan(id: Variant; column: String; width: Float; height: Float; value: String); overload;
    procedure addSpan(id: Variant; column: String; width: Float; height: Float; value: String; css: String); overload;
    procedure adjust;
    procedure adjustColumn(id: Variant {String or Float}); overload;
    procedure adjustColumn(id: Variant {String or Float}; header: String); overload;
    procedure adjustRowHeight(columnId: String; silent: Boolean);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearSelection;
    procedure clearValidation;
    function collectValues(id: String): array of Variant;
    function columnId(index: Float): String;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure eachColumn(handler: JWebixCallback); overload;
    procedure eachColumn(handler: JWebixCallback; all: Boolean); overload;
    procedure eachRow(handler: JWebixCallback); overload;
    procedure eachRow(handler: JWebixCallback; all: Boolean); overload;
    procedure edit(id: Variant);
    procedure editCancel;
    procedure editCell(row: String; col: String); overload;
    procedure editCell(row: String; col: String; preserve: Boolean); overload;
    procedure editCell(row: String; col: String; preserve: Boolean; show: Boolean); overload;
    procedure editColumn(id: String);
    function editNext: Boolean;
    procedure editRow(id: String);
    procedure editStop;
    procedure enable;
    function exists(id: String): Boolean;
    procedure exportToExcel; overload;
    procedure exportToExcel(url: String); overload;
    procedure exportToPDF; overload;
    procedure exportToPDF(url: String); overload;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    procedure filterByAll;
    function find(criterion: JWebixCallback): Variant; overload;
    function find(criterion: JWebixCallback; first: Boolean): Variant; overload;
    procedure focusEditor;
    function getChildViews: array of Variant;
    function getColumnConfig(id: String): Variant;
    function getColumnIndex(id: String): Float;
    function getEditState: Variant;
    function getEditor: Variant; overload;
    function getEditor(row: Variant): Variant; overload;
    function getEditor(row: Variant; column: Variant {String or Float}): Variant; overload;
    function getEditorValue: String;
    function getFilter(columnID: String): Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getHeaderContent(id: String):       // property Item[key: String]: Variant;
    end;;
    function getHeaderNode(columnId: String): JHTMLElement; overload;
    function getHeaderNode(columnId: String; rowIndex: Float): JHTMLElement; overload;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId: Variant; overload;
    function getSelectedId(asArray: Boolean): Variant; overload;
    function getSelectedId(asArray: Boolean; asString: Boolean): Variant; overload;
    procedure getSelectedItem; overload;
    procedure getSelectedItem(mode: Boolean); overload;
    function getState: Variant;
    function getText(rowid: String; colid: String): String;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    procedure group(config: Variant; mode: Boolean);
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideColumn(id: String);
    procedure hideOverlay;
    function isColumnVisible(id: String): Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(node: Variant {JHTMLElement or JEvent}): Variant;
    procedure mapCells(startrow: Float; startcol: String; numrows: Float; numcols: Float; callback: JWebixCallback);
    procedure mapEvent(map: Variant);
    procedure mapSelection(callback: JWebixCallback);
    procedure markSorting(column_id: String; dir: String);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveColumn(id: String; index: Float);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure refreshColumns; overload;
    procedure refreshColumns(config: array of Variant); overload;
    procedure refreshFilter(id: String);
    procedure refreshHeaderContent;
    procedure registerFilter(node: JHTMLElement; config: Variant; obj: Variant);
    procedure remove(id: String);
    procedure removeCellCss(id: String; name: String; css_name: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure removeRowCss(id: String; css_name: String);
    procedure removeSpan(id: Variant {String or Float}; column: String);
    procedure render(id: String; data: Variant; operation: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(row_id: String; preserve: Boolean);
    procedure selectRange(row_id: Variant; end_row_id: Variant);
    function serialize: Variant;
    procedure setColumnWidth(id: String; width: Float);
    procedure setPage(page: Float);
    procedure setRowHeight(id: String; height: Float);
    procedure setState(state: Variant);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showCell(row: String; column: String);
    procedure showColumn(id: String);
    procedure showColumnBatch(batch: Variant {String or Float});
    procedure showItem(id: String);
    procedure showItemByIndex(index: Float);
    procedure showOverlay(message: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure ungroup(mode: Boolean);
    procedure unselect(row_id: String);
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function validateEditor: Boolean; overload;
    function validateEditor(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JdatatableConfig;
    headerContent: Variant;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    waitData: JPromisedData;
  end;

  JdataviewConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datafetch: Float; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    loadahead: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
  end;

  Jdataview = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getTopParentView: Jwebix.ui.baseview;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JdataviewConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
    waitData: JPromisedData;
  end;

  JdatepickerConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    editable: Boolean; // nullable
    format: String; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    icons: Boolean; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    stringResult: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    text: String; // nullable
    timeIcon: String; // nullable
    timepicker: Boolean; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jdatepicker = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JdatepickerConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JfieldsetConfig = class external
    animate: Variant; // nullable
    body: Jwebix.ui.baseview; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    &label: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    width: Float; // nullable
  end;

  Jfieldset = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JfieldsetConfig;
    name: String;
  end;

  JformConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    elements: array of Variant; // nullable
    elementsConfig:       // property Item[key: String]: Variant;
    end;; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    rules: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    &type: String; // nullable
    url: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jform = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clear;
    procedure clearValidation;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus(item: String);
    function getChildViews: array of Variant;
    function getCleanValues: Variant;
    function getDirtyValues: Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValues:       // property Item[key: String]: Variant;
    end;; overload;
    function getValues(details: Variant):       // property Item[key: String]: Variant;
    end;; overload;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isDirty: Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure reconstruct;
    procedure refresh;
    procedure removeView(id: String);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure resizeChildren;
    procedure scrollTo(x: Float; y: Float);
    procedure setDirty; overload;
    procedure setDirty(mark: Boolean); overload;
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JformConfig;
    name: String;
  end;

  JgridsuggestConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    filter: JWebixCallback; // nullable
    fitMaster: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    input: Variant; // nullable
    keyPressTimeout: Float; // nullable
    left: Float; // nullable
    master: Jwebix.ui.baseview; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    template: Variant {String or JWebixTemplate}; // nullable
    textValue: String; // nullable
    top: Float; // nullable
    &type: String; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jgridsuggest = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getItemText(id: String): String;
    function getList: Jwebix.ui.baseview;
    function getMasterValue: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getSuggestion: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Variant {String or Float};
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure linkInput(input: JHTMLElement);
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setMasterValue(value: Variant);
    procedure setPosition(x: Float; y: Float);
    procedure setValue(value: Variant {String or Float});
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JgridsuggestConfig;
    name: String;
  end;

  JgrouplistConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateBack: Variant {String or JWebixTemplate}; // nullable
    templateCopy: JWebixCallback; // nullable
    templateGroup: Variant {String or JWebixTemplate}; // nullable
    templateItem: Variant {String or JWebixTemplate}; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
  end;

  Jgrouplist = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getOpenState: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    procedure group(config: Variant; mode: Boolean);
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure ungroup(mode: Boolean);
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JgrouplistConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JheaderlayoutConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    collapsed: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    multi: Variant {Boolean or String}; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    panelClass: String; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    &type: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jheaderlayout = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JheaderlayoutConfig;
    name: String;
  end;

  JhtmlformConfig = class external
    animate: Variant; // nullable
    autoheight: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    src: String; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    &type: String; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jhtmlform = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clear; overload;
    procedure clear(all: Boolean); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus(item: String);
    function getChildViews: array of Variant;
    function getCleanValues: Variant;
    function getDirtyValues: Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValues:       // property Item[key: String]: Variant;
    end;; overload;
    function getValues(details: Variant):       // property Item[key: String]: Variant;
    end;; overload;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isDirty: Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure setContent(node: Variant);
    procedure setDirty; overload;
    procedure setDirty(mark: Boolean); overload;
    procedure setHTML(html: String);
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JhtmlformConfig;
    name: String;
  end;

  JiconConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputWidth: Float; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jicon = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JiconConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JiframeConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    src: String; // nullable
    width: Float; // nullable
  end;

  Jiframe = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getIframe: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getWindow: JHTMLElement;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure load(value: String);
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JiframeConfig;
    name: String;
  end;

  JlabelConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputWidth: Float; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jlabel = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setHTML(html: String);
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JlabelConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JlayoutConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    &type: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jlayout = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JlayoutConfig;
    name: String;
  end;

  JlistConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
  end;

  Jlist = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JlistConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JmenuConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    subMenuPos: String; // nullable
    submenu: Variant; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
  end;

  Jmenu = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure disableItem(id: String);
    procedure enable;
    procedure enableItem(id: String);
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getMenu(id: Variant {String or Float}): Variant;
    function getMenuItem(id: String): Variant;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getSubMenu(id: Variant {String or Float}): Variant;
    function getTopMenu: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideItem(id: String);
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmenuConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JmulticomboConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    iconWidth: Variant; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    master: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    optionWidth: Float; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    popupWidth: Float; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    separator: String; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jmulticombo = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    $cssName: String;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmulticomboConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JmultiselectConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    master: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    optionWidth: Float; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    popupWidth: Float; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    separator: String; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jmultiselect = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    $cssName: String;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmultiselectConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JmultisuggestConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    button: Boolean; // nullable
    buttonText: String; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    filter: JWebixCallback; // nullable
    fitMaster: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    input: Variant; // nullable
    keyPressTimeout: Float; // nullable
    left: Float; // nullable
    master: Jwebix.ui.baseview; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    separator: String; // nullable
    template: Variant {String or JWebixTemplate}; // nullable
    textValue: String; // nullable
    top: Float; // nullable
    &type: String; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jmultisuggest = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getButton: Jwebix.ui.baseview;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getItemText(id: String): String;
    function getList: Jwebix.ui.baseview;
    function getMasterValue: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getSuggestion: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Variant {String or Float};
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure linkInput(input: JHTMLElement);
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setMasterValue(value: Variant);
    procedure setPosition(x: Float; y: Float);
    procedure setValue(value: Variant {String or Float});
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmultisuggestConfig;
    name: String;
  end;

  JmultitextConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    iconWidth: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    separator: String; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jmultitext = class external(Jwebix.ui.baseview)
    function addSection: Variant {String or Float};
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function getValueHere: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure removeSection; overload;
    procedure removeSection(id: Variant {String or Float}); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure setValueHere(value: Variant {String or Float});
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    $cssName: String;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmultitextConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JmultiviewConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cells: Variant; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    fitBiggest: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    keepViews: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jmultiview = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure back(step: Float);
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure getActiveId;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure setValue(toshow: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JmultiviewConfig;
    name: String;
  end;

  JorganogramConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    filterMode: Variant; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    threeState: Boolean; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jorganogram = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure close(id: String);
    procedure closeAll;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getBranchIndex(id: String): Float; overload;
    function getBranchIndex(id: String; parent: String): Float; overload;
    function getChildViews: array of Variant;
    function getFirstChildId(id: String): String;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNextSiblingId(id: Variant): String;
    function getNode: Variant;
    function getOpenItems: array of Variant;
    function getParentId(id: String): String;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getPrevSiblingId(id: Variant): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure group(config: Variant; mode: Boolean);
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isBranch(id: String): Boolean;
    function isBranchOpen(id: String): Boolean;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadBranch(id: String; callback: JWebixCallback; url: String);
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    procedure open(id: String);
    procedure openAll;
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setState(state: Variant);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure ungroup(mode: Boolean);
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JorganogramConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JpagerConfig = class external
    animate: Variant; // nullable
    apiOnly: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    count: Float; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    group: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    limit: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    page: Float; // nullable
    size: Float; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    width: Float; // nullable
  end;

  Jpager = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    function clone(config: Variant): Variant;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure select(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JpagerConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
  end;

  JpopupConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    left: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    top: Float; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jpopup = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setPosition(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JpopupConfig;
    name: String;
  end;

  JportletConfig = class external
    animate: Variant; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    layoutType: String; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    &type: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jportlet = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure markDropArea(target: String; mode: String);
    procedure movePortlet(target: String; mode: String);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JportletConfig;
    name: String;
  end;

  JpropertyConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    editValue: String; // nullable
    editable: Boolean; // nullable
    editaction: String; // nullable
    elements: Variant; // nullable
    form: String; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    nameWidth: Float; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jproperty = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure edit(id: Variant);
    procedure editCancel;
    function editNext: Boolean;
    procedure editStop;
    procedure enable;
    procedure focusEditor;
    function getChildViews: array of Variant;
    function getEditState: Variant;
    function getEditor: Variant; overload;
    function getEditor(id: String): Variant; overload;
    function getEditorValue: String;
    function getFormView: Jwebix.ui.baseview;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValues:       // property Item[key: String]: Variant;
    end;;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure registerType(name: String; data: Variant);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure updateItem;
    function validateEditor: Boolean; overload;
    function validateEditor(id: String): Boolean; overload;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JpropertyConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_edit:       // property Item[key: String]: Variant;
    end;;
    on_mouse_move: JWebixCallback;
    on_render:       // property Item[key: String]: Variant;
    end;;
    &type:       // property Item[key: String]: Variant;
    end;;
  end;

  JradioConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    customRadio: Boolean; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    optionHeight: Float; // nullable
    options: array of Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    vertical: Boolean; // nullable
    width: Float; // nullable
  end;

  Jradio = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JradioConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JrangesliderConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    max: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    min: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    separator: String; // nullable
    step: Float; // nullable
    stringResult: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    title: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jrangeslider = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    $cssName: String;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $touchCapture: Boolean;
    $view: JHTMLElement;
    $width: Float;
    config: JrangesliderConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JresizerConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    width: Float; // nullable
  end;

  Jresizer = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JresizerConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
  end;

  JrichselectConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    popupWidth: Float; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    text: String; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jrichselect = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getText: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JrichselectConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JscrollviewConfig = class external
    animate: Variant; // nullable
    body: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    width: Float; // nullable
  end;

  Jscrollview = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure resizeChildren;
    procedure scrollTo(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showView(id: String);
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JscrollviewConfig;
    name: String;
  end;

  JsearchConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    icon: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jsearch = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JsearchConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JsegmentedConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    multiview: Boolean; // nullable
    name: String; // nullable
    on: Variant; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jsegmented = class external(Jwebix.ui.baseview)
    procedure addOption(id: String; value: Variant); overload;
    procedure addOption(id: String; value: Variant; show: Boolean); overload;
    procedure addOption(id: String; value: Variant; show: Boolean; index: Float); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    function optionIndex(ID: String): Float;
    procedure refresh;
    procedure removeOption(id: String);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JsegmentedConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JselectConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    options: Variant {array of Variant or String}; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jselect = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JselectConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JsliderConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    max: Variant; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    min: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    step: Float; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    title: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jslider = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $touchCapture: Boolean;
    $view: JHTMLElement;
    $width: Float;
    config: JsliderConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JspacerConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    width: Float; // nullable
  end;

  Jspacer = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JspacerConfig;
    name: String;
  end;

  JsubmenuConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    left: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    mouseEventDelay: Float; // nullable
    move: Boolean; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    padding: Variant; // nullable
    pager: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    ready: JWebixCallback; // nullable
    relative: String; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    subMenuPos: String; // nullable
    submenu: Variant; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    tooltip: Variant; // nullable
    top: Float; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jsubmenu = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure close;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure disableItem(id: String);
    procedure enable;
    procedure enableItem(id: String);
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getMenu(id: Variant {String or Float}): Variant;
    function getMenuItem(id: String): Variant;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getSubMenu(id: Variant {String or Float}): Variant;
    function getTopMenu: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideItem(id: String);
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure resizeChildren;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure setPosition(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JsubmenuConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JsuggestConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    filter: JWebixCallback; // nullable
    fitMaster: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    input: Variant; // nullable
    keyPressTimeout: Float; // nullable
    left: Float; // nullable
    master: Jwebix.ui.baseview; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    template: Variant {String or JWebixTemplate}; // nullable
    textValue: String; // nullable
    top: Float; // nullable
    &type: String; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jsuggest = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getItemText(id: String): String;
    function getList: Jwebix.ui.baseview;
    function getMasterValue: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getSuggestion: String;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: Variant {String or Float};
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure linkInput(input: JHTMLElement);
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setMasterValue(value: Variant);
    procedure setPosition(x: Float; y: Float);
    procedure setValue(value: Variant {String or Float});
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JsuggestConfig;
    name: String;
  end;

  JtabbarConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomOffset: Float; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    moreTemplate: JWebixCallback; // nullable
    multiview: Boolean; // nullable
    name: String; // nullable
    on: Variant; // nullable
    options: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    popupTemplate: JWebixCallback; // nullable
    popupWidth: Float; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    tabMargin: Float; // nullable
    tabMinWidth: Float; // nullable
    tabMoreWidth: Float; // nullable
    tabOffset: Float; // nullable
    tabbarPopup: Jwebix.ui.baseview; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    topOffset: Float; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
    yCount: Float; // nullable
  end;

  Jtabbar = class external(Jwebix.ui.baseview)
    procedure addOption(id: String; value: Variant); overload;
    procedure addOption(id: String; value: Variant; show: Boolean); overload;
    procedure addOption(id: String; value: Variant; show: Boolean; index: Float); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getPopup: Jwebix.ui.baseview;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    function optionIndex(ID: String): Float;
    procedure refresh;
    procedure removeOption(id: String);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtabbarConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JtabviewConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cells: array of Variant; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    multiview: Variant; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    tabbar: Variant; // nullable
    &type: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jtabview = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getMultiview: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getTabbar: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure reconstruct;
    procedure removeView(id: String);
    procedure resize;
    procedure resizeChildren;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtabviewConfig;
    name: String;
  end;

  JtemplateConfig = class external
    animate: Variant; // nullable
    autoheight: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    src: String; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    &type: String; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jtemplate = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure setContent(node: Variant);
    procedure setHTML(html: String);
    procedure setValues(obj: Variant); overload;
    procedure setValues(obj: Variant; update: Boolean); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtemplateConfig;
    name: String;
  end;

  JtextConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jtext = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtextConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JtextareaConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    attributes:       // property Item[key: String]: Variant;
    end;; // nullable
    borderless: Boolean; // nullable
    bottomLabel: Variant; // nullable
    bottomPadding: Variant; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputPadding: Float; // nullable
    inputWidth: Float; // nullable
    invalidMessage: Variant; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    labelWidth: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    readonly: Boolean; // nullable
    relatedAction: String; // nullable
    relatedView: String; // nullable
    required: Boolean; // nullable
    suggest: Variant {String or Jwebix.ui.baseview}; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    validate: Boolean; // nullable
    validateEvent: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jtextarea = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $render: JWebixCallback;
    $renderIcon: JWebixCallback;
    function $renderInput(obj: Variant; html: String; id: String): String;
    function $renderLabel(config: Variant; id: String): String;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtextareaConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JtoggleConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputWidth: Float; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Jtoggle = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure toggle;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtoggleConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JtoolbarConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    cols: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    elements: array of Variant; // nullable
    elementsConfig:       // property Item[key: String]: Variant;
    end;; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    isolate: Boolean; // nullable
    margin: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    padding: Float; // nullable
    paddingX: Float; // nullable
    paddingY: Float; // nullable
    responsive: String; // nullable
    rows: array of Variant; // nullable
    rules: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    &type: String; // nullable
    url: String; // nullable
    visibleBatch: String; // nullable
    width: Float; // nullable
  end;

  Jtoolbar = class external(Jwebix.ui.baseview)
    function addView(view: Variant): Jwebix.ui.baseview; overload;
    function addView(view: Variant; index: Float): Jwebix.ui.baseview; overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clear;
    procedure clearValidation;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure focus(item: String);
    function getChildViews: array of Variant;
    function getCleanValues: Variant;
    function getDirtyValues: Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getScrollState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValues:       // property Item[key: String]: Variant;
    end;; overload;
    function getValues(details: Variant):       // property Item[key: String]: Variant;
    end;; overload;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function index(obj: Variant): Float;
    function isDirty: Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure mapEvent(map: Variant);
    procedure parse(data: Variant; &type: String);
    procedure reconstruct;
    procedure refresh;
    procedure removeView(id: String);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure resizeChildren;
    procedure scrollTo(x: Float; y: Float);
    procedure setDirty; overload;
    procedure setDirty(mark: Boolean); overload;
    procedure setValues(values: Variant); overload;
    procedure setValues(values: Variant; update: Boolean); overload;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showBatch(name: String);
    procedure unbind;
    procedure unblockEvent;
    function validate: Boolean;
    function $getSize: array of Variant;
    $height: Float;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtoolbarConfig;
    name: String;
  end;

  JtooltipConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    dx: Float; // nullable
    dy: Float; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    on: Variant; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    width: Float; // nullable
  end;

  Jtooltip = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtooltipConfig;
    name: String;
    &type:       // property Item[key: String]: Variant;
    end;;
  end;

  JtreeConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Boolean; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    filterMode: Variant; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    threeState: Boolean; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
  end;

  Jtree = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    function add(obj: Variant; index: Float; parentId: String): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure checkAll; overload;
    procedure checkAll(id: String); overload;
    procedure checkItem(id: String);
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure close(id: String);
    procedure closeAll;
    function copy(sid: String; tindex: Float): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview; details: Variant): String; overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getBranchIndex(id: String): Float; overload;
    function getBranchIndex(id: String; parent: String): Float; overload;
    function getChecked: array of Variant;
    function getChildViews: array of Variant;
    function getFirstChildId(id: String): String;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNextSiblingId(id: Variant): String;
    function getNode: Variant;
    function getOpenItems: array of Variant;
    function getParentId(id: String): String;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getPrevSiblingId(id: Variant): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getState: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure group(config: Variant; mode: Boolean);
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isBranch(id: String): Boolean;
    function isBranchOpen(id: String): Boolean;
    function isChecked(id: String): Boolean;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadBranch(id: String; callback: JWebixCallback; url: String);
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveSelection(direction: String);
    procedure open(id: String);
    procedure openAll;
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setState(state: Variant);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure uncheckAll; overload;
    procedure uncheckAll(id: String); overload;
    procedure uncheckItem(id: String);
    procedure ungroup(mode: Boolean);
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtreeConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JtreetableConfig = class external
    animate: Variant; // nullable
    autoConfig: Boolean; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    blockselect: Boolean; // nullable
    borderless: Boolean; // nullable
    checkboxRefresh: Boolean; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    columnWidth: Float; // nullable
    columns: array of Variant; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datafetch: Float; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    delimiter: Variant; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragColumn: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    editMath: Boolean; // nullable
    editValue: String; // nullable
    editable: Boolean; // nullable
    editaction: String; // nullable
    externalData: JWebixCallback; // nullable
    filterMode: Variant; // nullable
    fixedRowHeight: Boolean; // nullable
    footer: Boolean; // nullable
    form: String; // nullable
    gravity: Float; // nullable
    header: Boolean; // nullable
    headerRowHeight: Float; // nullable
    headermenu: Variant; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hover: String; // nullable
    id: String; // nullable
    leftSplit: Float; // nullable
    liveValidation: Boolean; // nullable
    loadahead: Float; // nullable
    math: Boolean; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minColumnHeight: Float; // nullable
    minColumnWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Boolean; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    prerender: Boolean; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    resizeColumn: Boolean; // nullable
    resizeRow: Boolean; // nullable
    rightSplit: Float; // nullable
    rowHeight: Float; // nullable
    rowLineHeight: Float; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Boolean; // nullable
    scrollAlignY: Boolean; // nullable
    scrollX: Boolean; // nullable
    scrollY: Boolean; // nullable
    select: Variant {Boolean or String}; // nullable
    spans: array of Variant; // nullable
    threeState: Boolean; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    url: String; // nullable
    width: Float; // nullable
    yCount: Float; // nullable
  end;

  Jtreetable = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    function add(obj: Variant; index: Float; parentId: String): String; overload;
    procedure addCellCss(id: String; name: String; css: String);
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure addRowCss(id: String; css: String);
    procedure adjust;
    procedure adjustColumn(id: Variant {String or Float}); overload;
    procedure adjustColumn(id: Variant {String or Float}; header: String); overload;
    procedure adjustRowHeight(columnId: String; silent: Boolean);
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure checkAll; overload;
    procedure checkAll(id: String); overload;
    procedure checkItem(id: String);
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure close(id: String);
    procedure closeAll;
    function collectValues(id: String): array of Variant;
    function columnId(index: Float): String;
    function copy(sid: String; tindex: Float): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview): String; overload;
    function copy(sid: String; tindex: Float; tobj: Jwebix.ui.baseview; details: Variant): String; overload;
    function count: Float;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure eachColumn(handler: JWebixCallback); overload;
    procedure eachColumn(handler: JWebixCallback; all: Boolean); overload;
    procedure eachRow(handler: JWebixCallback); overload;
    procedure eachRow(handler: JWebixCallback; all: Boolean); overload;
    procedure edit(id: Variant);
    procedure editCancel;
    procedure editCell(row: String; col: String); overload;
    procedure editCell(row: String; col: String; preserve: Boolean); overload;
    procedure editCell(row: String; col: String; preserve: Boolean; show: Boolean); overload;
    procedure editColumn(id: String);
    function editNext: Boolean;
    procedure editRow(id: String);
    procedure editStop;
    procedure enable;
    function exists(id: String): Boolean;
    procedure exportToExcel; overload;
    procedure exportToExcel(url: String); overload;
    procedure exportToPDF; overload;
    procedure exportToPDF(url: String); overload;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    procedure filterByAll;
    function find(criterion: JWebixCallback): Variant; overload;
    function find(criterion: JWebixCallback; first: Boolean): Variant; overload;
    procedure focusEditor;
    function getBranchIndex(id: String): Float; overload;
    function getBranchIndex(id: String; parent: String): Float; overload;
    function getChecked: array of Variant;
    function getChildViews: array of Variant;
    function getColumnConfig(id: String): Variant;
    function getColumnIndex(id: String): Float;
    function getEditState: Variant;
    function getEditor: Variant; overload;
    function getEditor(row: Variant): Variant; overload;
    function getEditor(row: Variant; column: Variant {String or Float}): Variant; overload;
    function getEditorValue: String;
    function getFilter(columnID: String): Variant;
    function getFirstChildId(id: String): String;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getHeaderContent(id: String):       // property Item[key: String]: Variant;
    end;;
    function getHeaderNode(columnId: String): JHTMLElement; overload;
    function getHeaderNode(columnId: String; rowIndex: Float): JHTMLElement; overload;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNextSiblingId(id: Variant): String;
    function getNode: Variant;
    function getOpenItems: array of Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentId(id: String): String;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getPrevSiblingId(id: Variant): String;
    function getScrollState: Variant;
    function getSelectedId: Variant; overload;
    function getSelectedId(asArray: Boolean): Variant; overload;
    function getSelectedId(asArray: Boolean; asString: Boolean): Variant; overload;
    procedure getSelectedItem; overload;
    procedure getSelectedItem(mode: Boolean); overload;
    function getState: Variant;
    function getText(rowid: String; colid: String): String;
    function getTopParentView: Jwebix.ui.baseview;
    function getVisibleCount: Float;
    procedure group(config: Variant; mode: Boolean);
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    procedure hideColumn(id: String);
    procedure hideOverlay;
    function isBranch(id: String): Boolean;
    function isBranchOpen(id: String): Boolean;
    function isChecked(id: String): Boolean;
    function isColumnVisible(id: String): Boolean;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadBranch(id: String; callback: JWebixCallback; url: String);
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(node: Variant {JHTMLElement or JEvent}): Variant;
    procedure mapCells(startrow: Float; startcol: String; numrows: Float; numcols: Float; callback: JWebixCallback);
    procedure mapEvent(map: Variant);
    procedure markSorting(column_id: String; dir: String);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Jwebix.ui.baseview): String; overload;
    function move(sid: String; tindex: Float; tobj: Jwebix.ui.baseview; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveColumn(id: String; index: Float);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure open(id: String);
    procedure openAll;
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure refreshColumns; overload;
    procedure refreshColumns(config: array of Variant); overload;
    procedure refreshFilter(id: String);
    procedure refreshHeaderContent;
    procedure registerFilter(node: JHTMLElement; config: Variant; obj: Variant);
    procedure remove(id: String);
    procedure removeCellCss(id: String; name: String; css_name: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure removeRowCss(id: String; css_name: String);
    procedure render(id: String; data: Variant; operation: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    function serialize: Variant;
    procedure setColumnWidth(id: String; width: Float);
    procedure setPage(page: Float);
    procedure setRowHeight(id: String; height: Float);
    procedure setState(state: Variant);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showCell(row: String; column: String);
    procedure showColumn(id: String);
    procedure showColumnBatch(batch: Variant {String or Float});
    procedure showItem(id: String);
    procedure showItemByIndex(index: Float);
    procedure showOverlay(message: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure uncheckAll; overload;
    procedure uncheckAll(id: String); overload;
    procedure uncheckItem(id: String);
    procedure ungroup(mode: Boolean);
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function validateEditor: Boolean; overload;
    function validateEditor(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JtreetableConfig;
    headerContent: Variant;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    waitData: JPromisedData;
  end;

  JunitlistConfig = class external
    animate: Variant; // nullable
    autoheight: Boolean; // nullable
    autowidth: Boolean; // nullable
    borderless: Boolean; // nullable
    click: Variant {String or JWebixCallback}; // nullable
    clipboard: Variant {Boolean or String}; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    data: Variant {String or array of Variant}; // nullable
    dataFeed: Variant {String or JWebixCallback}; // nullable
    datathrottle: Float; // nullable
    datatype: String; // nullable
    disabled: Boolean; // nullable
    drag: Variant {Boolean or String}; // nullable
    dragscroll: Variant {Boolean or String}; // nullable
    externalData: JWebixCallback; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    layout: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    mouseEventDelay: Float; // nullable
    multiselect: Variant; // nullable
    navigation: Boolean; // nullable
    on: Variant; // nullable
    onClick:       // property Item[key: String]: Variant;
    end;; // nullable
    onContext:       // property Item[key: String]: Variant;
    end;; // nullable
    onDblClick: JWebixCallback; // nullable
    onMouseMove: JWebixCallback; // nullable
    pager: Variant; // nullable
    ready: JWebixCallback; // nullable
    removeMissed: Boolean; // nullable
    rules: Variant; // nullable
    save: String; // nullable
    scheme: Variant; // nullable
    scroll: Variant {Boolean or String}; // nullable
    scrollSpeed: String; // nullable
    select: Variant {Boolean or String}; // nullable
    sort: JWebixCallback; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    templateCopy: JWebixCallback; // nullable
    tooltip: Variant; // nullable
    &type: Variant; // nullable
    uniteBy: JWebixCallback; // nullable
    url: String; // nullable
    width: Float; // nullable
    xCount: Float; // nullable
    yCount: Float; // nullable
  end;

  Junitlist = class external(Jwebix.ui.baseview)
    function add(obj: Variant): String; overload;
    function add(obj: Variant; index: Float): String; overload;
    procedure addCss(id: Variant {String or Float}; css: String); overload;
    procedure addCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure clearAll;
    procedure clearCss(css: String); overload;
    procedure clearCss(css: String; silent: Boolean); overload;
    procedure clearValidation;
    procedure copy(sid: String; tindex: Float); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant); overload;
    procedure copy(sid: String; tindex: Float; tobj: Variant; details: Variant); overload;
    function count: Float;
    procedure customize(obj: Variant);
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function exists(id: String): Boolean;
    procedure filter(text: Variant {String or JWebixTemplate or JWebixCallback}; value: String; preserve: Boolean);
    function getChildViews: array of Variant;
    function getFirstId: String;
    function getFormView: Jwebix.ui.baseview;
    function getIdByIndex(index: Float): String;
    function getIndexById(id: String): Float;
    function getItem(id: String): Variant;
    procedure getItemNode(id: String);
    function getLastId: String;
    function getNextId(id: String; step: Float): String;
    function getNode: Variant;
    function getPage: Float;
    function getPager: Variant;
    function getParentView: Variant;
    function getPrevId(id: String; step: Float): String;
    function getScrollState: Variant;
    function getSelectedId(as_array: Boolean): Variant {String or array of Variant};
    function getSelectedItem: Variant; overload;
    function getSelectedItem(as_array: Boolean): Variant; overload;
    function getTopParentView: Jwebix.ui.baseview;
    function getUnitList(name: String): array of Variant;
    function getUnits: array of Variant;
    function getVisibleCount: Float;
    function hasCss(id: String; css: String): Boolean;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isSelected(id: String): Boolean;
    function isVisible: Boolean;
    function load(url: String): JPromisedData; overload;
    function load(url: String; &type: String): JPromisedData; overload;
    function load(url: String; &type: String; callback: JWebixCallback): JPromisedData; overload;
    procedure loadNext(count: Float; start: Float; callback: JWebixCallback; url: String; now: Boolean);
    function locate(e: JEvent): String;
    procedure mapEvent(map: Variant);
    function move(sid: String; tindex: Float): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant): String; overload;
    function move(sid: String; tindex: Float; tobj: Variant; details: Variant): String; overload;
    procedure moveBottom(id: String);
    procedure moveDown(id: String; step: Float);
    procedure moveSelection(direction: String);
    procedure moveTop(id: String);
    procedure moveUp(id: String; step: Float);
    procedure parse(data: Variant; &type: String);
    procedure refresh; overload;
    procedure refresh(id: String); overload;
    procedure remove(id: String);
    procedure removeCss(id: Variant {String or Float}; css: String); overload;
    procedure removeCss(id: Variant {String or Float}; css: String; silent: Boolean); overload;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure scrollTo(x: Float; y: Float);
    procedure select(id: Variant {String or array of Variant}; preserve: Boolean);
    procedure selectAll; overload;
    procedure selectAll(from: String); overload;
    procedure selectAll(from: String; to: String); overload;
    function serialize: Variant;
    procedure setPage(page: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure showItem(id: String);
    procedure sort(by: String); overload;
    procedure sort(by: String; dir: String); overload;
    procedure sort(by: String; dir: String; as: String); overload;
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    procedure unselect; overload;
    procedure unselect(id: String); overload;
    procedure unselectAll;
    procedure updateItem(id: String; data: Variant);
    function validate: Boolean; overload;
    function validate(id: String): Boolean; overload;
    function $drag(source: JHTMLElement; ev: JEvent): String;
    $dragHTML: JWebixCallback;
    function $dragIn(source: JHTMLElement; target: JHTMLElement; ev: JEvent): JHTMLElement;
    function $dragMark(context: Variant; ev: JEvent): Boolean;
    procedure $dragOut(source: JHTMLElement; old_target: JHTMLElement; new_target: JHTMLElement; ev: JEvent);
    procedure $drop(source: JHTMLElement; target: JHTMLElement; ev: Variant);
    $dropAllow: JWebixCallback;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JunitlistConfig;
    name: String;
    on_click: JWebixCallback;
    on_context:       // property Item[key: String]: Variant;
    end;;
    on_dblclick: JWebixCallback;
    on_mouse_move: JWebixCallback;
    &type:       // property Item[key: String]: Variant;
    end;;
    types:       // property Item[key: String]: Variant;
    end;;
  end;

  JuploaderConfig = class external
    align: String; // nullable
    animate: Variant; // nullable
    apiOnly: Boolean; // nullable
    autosend: Boolean; // nullable
    borderless: Boolean; // nullable
    click: JWebixCallback; // nullable
    container: JHTMLElement; // nullable
    content: Variant {String or JHTMLElement}; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    formData:       // property Item[key: String]: Variant;
    end;; // nullable
    function getValue: String;
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    hotkey: String; // nullable
    id: String; // nullable
    inputHeight: Float; // nullable
    inputWidth: Float; // nullable
    &label: String; // nullable
    labelPosition: String; // nullable
    link: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    multiple: Boolean; // nullable
    name: String; // nullable
    on: Variant; // nullable
    placeholder: String; // nullable
    popup: Variant; // nullable
    tabFocus: Boolean; // nullable
    template: Variant {String or JWebixCallback}; // nullable
    tooltip: String; // nullable
    &type: String; // nullable
    value: String; // nullable
    width: Float; // nullable
  end;

  Juploader = class external(Jwebix.ui.baseview)
    procedure addDropZone(element: JHTMLElement);
    procedure addFile(name: String; size: Float); overload;
    procedure addFile(name: String; size: Float; &type: String); overload;
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    procedure blur;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    procedure fileDialog; overload;
    procedure fileDialog(content: Variant); overload;
    procedure focus;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getInputNode: JHTMLElement;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function getValue: String;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isUploaded: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure refresh;
    procedure render(id: String; data: Variant; &type: String);
    procedure resize;
    procedure send(id: Variant {Float or String or JWebixCallback}; details: Variant);
    procedure setValue(value: String);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure stopUpload(id: String);
    procedure sync(source: Variant; filter: JWebixCallback; silent: Boolean);
    procedure unbind;
    procedure unblockEvent;
    $cssName: String;
    function $getSize: array of Variant;
    function $getValue: String;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    procedure $setValue(value: String);
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JuploaderConfig;
    name: String;
    on_click: JWebixCallback;
    touchable: Variant;
  end;

  JvideoConfig = class external
    animate: Variant; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    controls: Boolean; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    gravity: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    src: Variant; // nullable
    width: Float; // nullable
  end;

  Jvideo = class external(Jwebix.ui.baseview)
    procedure adjust;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure disable;
    procedure enable;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    procedure getVideo;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure resize;
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JvideoConfig;
    name: String;
  end;

  JwindowConfig = class external
    animate: Variant; // nullable
    autofit: Boolean; // nullable
    autofocus: Boolean; // nullable
    body: Variant {String or Jwebix.ui.baseview}; // nullable
    borderless: Boolean; // nullable
    container: JHTMLElement; // nullable
    css: String; // nullable
    disabled: Boolean; // nullable
    fullscreen: Boolean; // nullable
    gravity: Float; // nullable
    head: Variant; // nullable
    headHeight: Float; // nullable
    height: Float; // nullable
    hidden: Boolean; // nullable
    id: String; // nullable
    left: Float; // nullable
    maxHeight: Float; // nullable
    maxWidth: Float; // nullable
    minHeight: Float; // nullable
    minWidth: Float; // nullable
    modal: Boolean; // nullable
    move: Boolean; // nullable
    on: Variant; // nullable
    padding: Variant; // nullable
    position: Variant {String or JWebixCallback}; // nullable
    relative: String; // nullable
    top: Float; // nullable
    width: Float; // nullable
    zIndex: Float; // nullable
  end;

  Jwindow = class external(Jwebix.ui.baseview)
    procedure adjust;
    function attachEvent(&type: String; functor: JWebixCallback): String; overload;
    function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
    procedure bind(target: Variant); overload;
    procedure bind(target: Variant; rule: JWebixCallback); overload;
    procedure bind(target: Variant; rule: JWebixCallback; format: String); overload;
    procedure blockEvent;
    function callEvent(name: String; params: array of Variant): Boolean;
    procedure close;
    procedure define(&property: String; value: Variant);
    procedure destructor;
    procedure detachEvent(id: String);
    procedure disable;
    procedure enable;
    function getBody: Variant;
    function getChildViews: array of Variant;
    function getFormView: Jwebix.ui.baseview;
    function getHead: Variant;
    function getNode: Variant;
    function getParentView: Variant;
    function getTopParentView: Jwebix.ui.baseview;
    function hasEvent(name: String): Boolean;
    procedure hide;
    function isEnabled: Boolean;
    function isVisible: Boolean;
    procedure mapEvent(map: Variant);
    procedure resize;
    procedure resizeChildren;
    procedure setPosition(x: Float; y: Float);
    procedure show; overload;
    procedure show(force: Boolean); overload;
    procedure show(force: Boolean; animation: Boolean); overload;
    procedure unbind;
    procedure unblockEvent;
    function $getSize: array of Variant;
    $height: Float;
    $scope: Variant;
    function $setSize(x: Float; y: Float): Boolean;
    $skin: Variant;
    $view: JHTMLElement;
    $width: Float;
    config: JwindowConfig;
    name: String;
  end;

procedure delay(config: Variant);
procedure fullScreen;
function hasMethod(name: String; method_name: String): Boolean;
procedure resize;
function zIndex: Float;

var
  scrollSize: Float;
  zIndexBase: Float;

function ajax: Jwebix._ajax;
function $$(id: Variant {String or JEvent or JHTMLElement}): Jwebix.ui.baseview;
function alert(text: String; callback: JWebixCallback): JHTMLElement;
procedure animate(html_element: JHTMLElement; animation: Variant);
function attachEvent(&type: String; functor: JWebixCallback): String; overload;
function attachEvent(&type: String; functor: JWebixCallback; id: String): String; overload;
function bind(code: JWebixCallback; master: Variant): JWebixCallback;
procedure blockEvent;
function callEvent(name: String; params: array of Variant): Boolean;
function clone(source: Variant): Variant;
function confirm(text: String; callback: JWebixCallback): JHTMLElement;
function copy(source: Variant): Variant;
function delay(code: JWebixCallback): Float; overload;
function delay(code: JWebixCallback; owner: Variant): Float; overload;
function delay(code: JWebixCallback; owner: Variant; params: array of Variant): Float; overload;
function delay(code: JWebixCallback; owner: Variant; params: array of Variant; delay: Float): Float; overload;
procedure detachEvent(id: String);
function dp(name: String): Variant;
procedure editStop;
function event(node: JHTMLElement; event: String; handler: JWebixCallback): String; overload;
function event(node: JHTMLElement; event: String; handler: JWebixCallback; master: Variant): String; overload;
procedure eventRemove(id: String);
procedure exec(code: String);
function extend(target: Variant; source: Variant; overwrite: Boolean): Variant;
function hasEvent(name: String): Boolean;
function isArray(check: Variant): Boolean;
function isDate(check: Variant): Boolean;
function isUndefined(check: Variant): Boolean;
procedure jsonp(url: String); overload;
procedure jsonp(url: String; params: Variant); overload;
procedure jsonp(url: String; params: Variant; callback: JWebixCallback); overload;
procedure jsonp(url: String; params: Variant; callback: JWebixCallback; master: Variant); overload;
procedure mapEvent(map: Variant);
procedure message(text: String);
function modalbox(text: String; callback: JWebixCallback): JHTMLElement;
procedure once(code: JWebixCallback);
function proto(target: Variant): Variant; overload;
function proto(target: Variant; mixin1: Variant): Variant; overload;
function proto(target: Variant; mixin1: Variant; mixinN: Variant): Variant; overload;
function protoUI(target: Variant; view: Variant): Variant; overload;
function protoUI(target: Variant; view: Variant; mixin1: Variant): Variant; overload;
function protoUI(target: Variant; view: Variant; mixin1: Variant; mixinN: Variant): Variant; overload;
function proxy(&type: String; source: String): Variant;
procedure ready(code: JWebixCallback);
procedure remote;
procedure require(url: String);
procedure send(url: String; values: Variant; method: String; target: String);
function single(source: JWebixCallback): JWebixCallback;
function template(template: String): JWebixCallback;
function toArray(array: array of Variant): array of Variant;
function toFunctor(name: String): JWebixCallback;
function toNode(id: String): JHTMLElement;
procedure type(config: Variant);
function ui(config: Variant): Jwebix.ui.baseview; overload;
function ui(config: Variant; parent: Variant): Jwebix.ui.baseview; overload;
function ui(config: Variant; parent: Variant; replacement: Variant): Jwebix.ui.baseview; overload;
function uid: String;
procedure unblockEvent;
function wrap(target: JWebixCallback; source: JWebixCallback): JWebixCallback;

var
  codebase: String;
  name: String;
  version: String;
  clipbuffer: Jwebix.clipbuffer;
  color: Jwebix.color;
  csv: Jwebix.csv;
  editors: Jwebix.editors;
  env: Jwebix.env;
  history: Jwebix.history;
  html: Jwebix.html;
  i18n: Jwebix.i18n;
  locale: Jwebix.locale;
  markup: Jwebix.markup;
  promise: Jwebix.promise;
  rules: Jwebix.rules;
  storage: Jwebix.storage;
  ActiveContent: JActiveContent;
  AtomDataLoader: JAtomDataLoader;
  AtomRender: JAtomRender;
  AutoTooltip: JAutoTooltip;
  BaseBind: JBaseBind;
  BindSource: JBindSource;
  Canvas: JCanvas;
  CollectionBind: JCollectionBind;
  ContextHelper: JContextHelper;
  CopyPaste: JCopyPaste;
  CustomScroll: JCustomScroll;
  DataCollection: JDataCollectionFactory;
  DataDriver: JDataDriver;
  DataLoader: JDataLoader;
  DataMarks: JDataMarks;
  DataMove: JDataMove;
  DataProcessor: JDataProcessor;
  DataRecord: JDataRecord;
  DataState: JDataState;
  DataStore: JDataStore;
  DataValue: JDataValue;
  Date: JDate;
  Destruction: JDestruction;
  DragControl: JDragControl;
  DragItem: JDragItem;
  DragOrder: JDragOrder;
  EditAbility: JEditAbility;
  EventSystem: JEventSystem;
  Group: JGroup;
  GroupMethods: JGroupMethods;
  GroupStore: JGroupStore;
  HtmlMap: JHtmlMap;
  IdSpace: JIdSpace;
  KeysNavigation: JKeysNavigation;
  MapCollection: JMapCollection;
  Modality: JModality;
  MouseEvents: JMouseEvents;
  Movable: JMovable;
  NavigationButtons: JNavigationButtons;
  Number: JNumber;
  OverlayBox: JOverlayBox;
  PagingAbility: JPagingAbility;
  PowerArray: JPowerArray;
  ProgressBar: JProgressBar;
  RecordBind: JRecordBind;
  RenderStack: JRenderStack;
  Scrollable: JScrollable;
  SelectionModel: JSelectionModel;
  Settings: JSettings;
  SingleRender: JSingleRender;
  TablePaste: JTablePaste;
  Touch: JTouch;
  TreeAPI: JTreeAPI;
  TreeClick: JTreeClick;
  TreeCollection: JTreeCollection;
  TreeDataLoader: JTreeDataLoader;
  TreeDataMove: JTreeDataMove;
  TreeRenderStack: JTreeRenderStack;
  TreeStateCheckbox: JTreeStateCheckbox;
  TreeStore: JTreeStore;
  TreeTableClick: JTreeTableClick;
  TreeTablePaste: JTreeTablePaste;
  TreeType: JTreeType;
  UIExtension: JUIExtension;
  UIManager: JUIManager;
  UploadDriver: JUploadDriver;
  ValidateCollection: JValidateCollection;
  ValidateData: JValidateData;
  ValueBind: JValueBind;
  Values: JValues;
  VirtualRenderStack: JVirtualRenderStack;

function $$(id: Variant {String or JEvent or JHTMLElement}): Jwebix.ui.baseview;
