unit Winrt;

interface

//Windows

//Foundation

//Collections

type
  JPropertySet = class external 'PropertySet'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JValueSet = class external 'ValueSet'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JIVectorChangedEventArgs = class external
    collectionChange: JWindows.Foundation.Collections.CollectionChange;
    index: Float;
  end;

  JIPropertySet = class external(JWindows.Foundation.Collections.IObservableMap {String, Variant} , JWindows.Foundation.Collections.IMap {String, Variant} , JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}} )
  end;

  JIIterable{<T>} = class external
    function first: JWindows.Foundation.Collections.IIterator{<JT>};
  end;

  JIIterator{<T>} = class external
    current: JT;
    hasCurrent: Boolean;
    function moveNext: Boolean;
    function getMany:       items: array of JT;
      returnValue: Float;
    end;;
  end;

  JIVectorView{<T>} = class external(JWindows.Foundation.Collections.IIterable {JT} )
    size: Float;
    function getAt(index: Float): JT;
    function indexOf(value: JT):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JT;
      returnValue: Float;
    end;;
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JT): array of JT;
    function join(seperator: String): String;
    function pop: JT;
    procedure push(items: array of JT);
    function reverse: array of JT;
    function shift: JT;
    function slice(start: Float): array of JT;
    function slice(start: Float; &end: Float): array of JT;
    function sort: array of JT;
    function sort(compareFn: (a: JT; b: JT): Float): array of JT;
    function splice(start: Float): array of JT;
    function splice(start: Float; deleteCount: Float; items: array of JT): array of JT;
    function unshift(items: array of JT): Float;
    function lastIndexOf(searchElement: JT): Float;
    function lastIndexOf(searchElement: JT; fromIndex: Float): Float;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JT; index: Float; array: array of JT));
    procedure forEach(callbackfn: (value: JT; index: Float; array: array of JT); thisArg: Variant);
    function map(callbackfn: (value: JT; index: Float; array: array of JT): Variant): array of Variant;
    function map(callbackfn: (value: JT; index: Float; array: array of JT): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): array of JT;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): array of JT;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JIVector{<T>} = class external(JWindows.Foundation.Collections.IIterable {JT} )
    size: Float;
    function getAt(index: Float): JT;
    function getView: JWindows.Foundation.Collections.IVectorView{<JT>};
    function indexOf(value: JT):       index: Float;
      returnValue: Boolean;
    end;;
    procedure setAt(index: Float; value: JT);
    procedure insertAt(index: Float; value: JT);
    procedure removeAt(index: Float);
    procedure append(value: JT);
    procedure removeAtEnd;
    procedure clear;
    function getMany(startIndex: Float):       items: array of JT;
      returnValue: Float;
    end;;
    procedure replaceAll(items: array of JT);
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JT): array of JT;
    function join(seperator: String): String;
    function pop: JT;
    procedure push(items: array of JT);
    function reverse: array of JT;
    function shift: JT;
    function slice(start: Float): array of JT;
    function slice(start: Float; &end: Float): array of JT;
    function sort: array of JT;
    function sort(compareFn: (a: JT; b: JT): Float): array of JT;
    function splice(start: Float): array of JT;
    function splice(start: Float; deleteCount: Float; items: array of JT): array of JT;
    function unshift(items: array of JT): Float;
    function lastIndexOf(searchElement: JT): Float;
    function lastIndexOf(searchElement: JT; fromIndex: Float): Float;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean;
    function every(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): Boolean;
    function some(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JT; index: Float; array: array of JT));
    procedure forEach(callbackfn: (value: JT; index: Float; array: array of JT); thisArg: Variant);
    function map(callbackfn: (value: JT; index: Float; array: array of JT): Variant): array of Variant;
    function map(callbackfn: (value: JT; index: Float; array: array of JT): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean): array of JT;
    function filter(callbackfn: (value: JT; index: Float; array: array of JT): Boolean; thisArg: Variant): array of JT;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JT): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JIKeyValuePair{<KV>} = class external
    key: JK;
    value: JV;
  end;

  JIMap{<KV>} = class external(JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<JKJV>}} )
    size: Float;
    function lookup(key: JK): JV;
    function hasKey(key: JK): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<JKJV>};
    function insert(key: JK; value: JV): Boolean;
    procedure remove(key: JK);
    procedure clear;
  end;

  JIMapView{<KV>} = class external(JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<JKJV>}} )
    size: Float;
    function lookup(key: JK): JV;
    function hasKey(key: JK): Boolean;
    function split:       first: JWindows.Foundation.Collections.IMapView{<JKJV>};
      second: JWindows.Foundation.Collections.IMapView{<JKJV>};
    end;;
  end;

  JVectorChangedEventHandler{<T>} = class external
(sender: JWindows.Foundation.Collections.IObservableVector{<JT>}; event: JWindows.Foundation.Collections.IVectorChangedEventArgs)  end;

  JIObservableVector{<T>} = class external(JWindows.Foundation.Collections.IVector {JT} , JWindows.Foundation.Collections.IIterable {JT} )
    onvectorchanged: Variant;
  end;

  JIMapChangedEventArgs{<K>} = class external
    collectionChange: JWindows.Foundation.Collections.CollectionChange;
    key: JK;
  end;

  JMapChangedEventHandler{<KV>} = class external
(sender: JWindows.Foundation.Collections.IObservableMap{<JKJV>}; event: JWindows.Foundation.Collections.IMapChangedEventArgs{<JK>})  end;

  JIObservableMap{<KV>} = class external(JWindows.Foundation.Collections.IMap {JK, JV} , JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<JKJV>}} )
    onmapchanged: Variant;
  end;

//Windows

//Foundation

type
  JWwwFormUrlDecoder = class external 'WwwFormUrlDecoder'
    constructor Create(query: String);
    size: Float;
    function getFirstValueByName(name: String): String;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.IWwwFormUrlDecoderEntry>};
    function getAt(index: Float): JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function indexOf(value: JWindows.Foundation.IWwwFormUrlDecoderEntry):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
      returnValue: Float;
    end;;
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Foundation.IWwwFormUrlDecoderEntry): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function join(seperator: String): String;
    function pop: JWindows.Foundation.IWwwFormUrlDecoderEntry;
    procedure push(items: array of JWindows.Foundation.IWwwFormUrlDecoderEntry);
    function reverse: array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function shift: JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function slice(start: Float): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function slice(start: Float; &end: Float): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function sort: array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function sort(compareFn: (a: JWindows.Foundation.IWwwFormUrlDecoderEntry; b: JWindows.Foundation.IWwwFormUrlDecoderEntry): Float): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function splice(start: Float): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function unshift(items: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Float;
    function lastIndexOf(searchElement: JWindows.Foundation.IWwwFormUrlDecoderEntry): Float;
    function lastIndexOf(searchElement: JWindows.Foundation.IWwwFormUrlDecoderEntry; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry));
    procedure forEach(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function filter(callbackfn: (value: JWindows.Foundation.IWwwFormUrlDecoderEntry; index: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Boolean; thisArg: Variant): array of JWindows.Foundation.IWwwFormUrlDecoderEntry;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Foundation.IWwwFormUrlDecoderEntry): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JUri = class external 'Uri'
    constructor Create(uri: String);
    constructor Create(baseUri: String; relativeUri: String);
    absoluteUri: String;
    displayUri: String;
    domain: String;
    extension: String;
    fragment: String;
    host: String;
    password: String;
    path: String;
    port: Float;
    query: String;
    queryParsed: JWindows.Foundation.WwwFormUrlDecoder;
    rawUri: String;
    schemeName: String;
    suspicious: Boolean;
    userName: String;
    absoluteCanonicalUri: String;
    displayIri: String;
    function equals(pUri: JWindows.Foundation.Uri): Boolean;
    function combineUri(relativeUri: String): JWindows.Foundation.Uri;
    function unescapeComponent(toUnescape: String): String;
    function escapeComponent(toEscape: String): String;
  end;

  JPropertyValue = class external 'PropertyValue'
    function createEmpty: Variant;
    function createUInt8(value: Float): Variant;
    function createInt16(value: Float): Variant;
    function createUInt16(value: Float): Variant;
    function createInt32(value: Float): Variant;
    function createUInt32(value: Float): Variant;
    function createInt64(value: Float): Variant;
    function createUInt64(value: Float): Variant;
    function createSingle(value: Float): Variant;
    function createDouble(value: Float): Variant;
    function createChar16(value: String): Variant;
    function createBoolean(value: Boolean): Variant;
    function createString(value: String): Variant;
    function createInspectable(value: Variant): Variant;
    function createGuid(value: String): Variant;
    function createDateTime(value: JDate): Variant;
    function createTimeSpan(value: Float): Variant;
    function createPoint(value: JWindows.Foundation.Point): Variant;
    function createSize(value: JWindows.Foundation.Size): Variant;
    function createRect(value: JWindows.Foundation.Rect): Variant;
    function createUInt8Array(value: JUint8Array): Variant;
    function createInt16Array(value: JInt16Array): Variant;
    function createUInt16Array(value: JUint16Array): Variant;
    function createInt32Array(value: JInt32Array): Variant;
    function createUInt32Array(value: JUint32Array): Variant;
    function createInt64Array(value: array of Float): Variant;
    function createUInt64Array(value: array of Float): Variant;
    function createSingleArray(value: JFloat32Array): Variant;
    function createDoubleArray(value: JFloat64Array): Variant;
    function createChar16Array(value: array of String): Variant;
    function createBooleanArray(value: array of Boolean): Variant;
    function createStringArray(value: array of String): Variant;
    function createInspectableArray(value: array of Variant): Variant;
    function createGuidArray(value: array of String): Variant;
    function createDateTimeArray(value: array of JDate): Variant;
    function createTimeSpanArray(value: array of Float): Variant;
    function createPointArray(value: array of JWindows.Foundation.Point): Variant;
    function createSizeArray(value: array of JWindows.Foundation.Size): Variant;
    function createRectArray(value: array of JWindows.Foundation.Rect): Variant;
  end;

  JIUriRuntimeClass = class external
    absoluteUri: String;
    displayUri: String;
    domain: String;
    extension: String;
    fragment: String;
    host: String;
    password: String;
    path: String;
    port: Float;
    query: String;
    queryParsed: JWindows.Foundation.WwwFormUrlDecoder;
    rawUri: String;
    schemeName: String;
    suspicious: Boolean;
    userName: String;
    function equals(pUri: JWindows.Foundation.Uri): Boolean;
    function combineUri(relativeUri: String): JWindows.Foundation.Uri;
  end;

  JIUriRuntimeClassWithAbsoluteCanonicalUri = class external
    absoluteCanonicalUri: String;
    displayIri: String;
  end;

  JIUriEscapeStatics = class external
    function unescapeComponent(toUnescape: String): String;
    function escapeComponent(toEscape: String): String;
  end;

  JIUriRuntimeClassFactory = class external
    function createUri(uri: String): JWindows.Foundation.Uri;
    function createUri(baseUri: String; relativeUri: String): JWindows.Foundation.Uri;
  end;

  JIWwwFormUrlDecoderEntry = class external
    name: String;
    value: String;
  end;

  JIWwwFormUrlDecoderRuntimeClass = class external(JWindows.Foundation.Collections.IIterable {JWindows.Foundation.IWwwFormUrlDecoderEntry} , JWindows.Foundation.Collections.IVectorView {JWindows.Foundation.IWwwFormUrlDecoderEntry} )
    function getFirstValueByName(name: String): String;
  end;

  JIWwwFormUrlDecoderRuntimeClassFactory = class external
    function createWwwFormUrlDecoder(query: String): JWindows.Foundation.WwwFormUrlDecoder;
  end;

  JIGetActivationFactory = class external
    function getActivationFactory(activatableClassId: String): Variant;
  end;

  JIClosable = class external
    procedure close;
  end;

  JPoint = class external
    x: Float;
    y: Float;
  end;

  JSize = class external
    width: Float;
    height: Float;
  end;

  JRect = class external
    x: Float;
    y: Float;
    width: Float;
    height: Float;
  end;

  JDateTime = class external
    universalTime: Float;
  end;

  JTimeSpan = class external
    duration: Float;
  end;

  JIPropertyValue = class external
    isNumericScalar: Boolean;
    &type: JWindows.Foundation.PropertyType;
    function getUInt8: Float;
    function getInt16: Float;
    function getUInt16: Float;
    function getInt32: Float;
    function getUInt32: Float;
    function getInt64: Float;
    function getUInt64: Float;
    function getSingle: Float;
    function getDouble: Float;
    function getChar16: String;
    function getBoolean: Boolean;
    function getString: String;
    function getGuid: String;
    function getDateTime: JDate;
    function getTimeSpan: Float;
    function getPoint: JWindows.Foundation.Point;
    function getSize: JWindows.Foundation.Size;
    function getRect: JWindows.Foundation.Rect;
    function getUInt8Array: JUint8Array;
    function getInt16Array: JInt16Array;
    function getUInt16Array: JUint16Array;
    function getInt32Array: JInt32Array;
    function getUInt32Array: JUint32Array;
    function getInt64Array: array of Float;
    function getUInt64Array: array of Float;
    function getSingleArray: JFloat32Array;
    function getDoubleArray: JFloat64Array;
    function getChar16Array: array of String;
    function getBooleanArray: array of Boolean;
    function getStringArray: array of String;
    function getInspectableArray: array of Variant;
    function getGuidArray: array of String;
    function getDateTimeArray: array of JDate;
    function getTimeSpanArray: array of Float;
    function getPointArray: array of JWindows.Foundation.Point;
    function getSizeArray: array of JWindows.Foundation.Size;
    function getRectArray: array of JWindows.Foundation.Rect;
  end;

  JIPropertyValueStatics = class external
    function createEmpty: Variant;
    function createUInt8(value: Float): Variant;
    function createInt16(value: Float): Variant;
    function createUInt16(value: Float): Variant;
    function createInt32(value: Float): Variant;
    function createUInt32(value: Float): Variant;
    function createInt64(value: Float): Variant;
    function createUInt64(value: Float): Variant;
    function createSingle(value: Float): Variant;
    function createDouble(value: Float): Variant;
    function createChar16(value: String): Variant;
    function createBoolean(value: Boolean): Variant;
    function createString(value: String): Variant;
    function createInspectable(value: Variant): Variant;
    function createGuid(value: String): Variant;
    function createDateTime(value: JDate): Variant;
    function createTimeSpan(value: Float): Variant;
    function createPoint(value: JWindows.Foundation.Point): Variant;
    function createSize(value: JWindows.Foundation.Size): Variant;
    function createRect(value: JWindows.Foundation.Rect): Variant;
    function createUInt8Array(value: JUint8Array): Variant;
    function createInt16Array(value: JInt16Array): Variant;
    function createUInt16Array(value: JUint16Array): Variant;
    function createInt32Array(value: JInt32Array): Variant;
    function createUInt32Array(value: JUint32Array): Variant;
    function createInt64Array(value: array of Float): Variant;
    function createUInt64Array(value: array of Float): Variant;
    function createSingleArray(value: JFloat32Array): Variant;
    function createDoubleArray(value: JFloat64Array): Variant;
    function createChar16Array(value: array of String): Variant;
    function createBooleanArray(value: array of Boolean): Variant;
    function createStringArray(value: array of String): Variant;
    function createInspectableArray(value: array of Variant): Variant;
    function createGuidArray(value: array of String): Variant;
    function createDateTimeArray(value: array of JDate): Variant;
    function createTimeSpanArray(value: array of Float): Variant;
    function createPointArray(value: array of JWindows.Foundation.Point): Variant;
    function createSizeArray(value: array of JWindows.Foundation.Size): Variant;
    function createRectArray(value: array of JWindows.Foundation.Rect): Variant;
  end;

  JAsyncActionCompletedHandler = class external
(asyncInfo: JWindows.Foundation.IAsyncAction; asyncStatus: JWindows.Foundation.AsyncStatus)  end;

  JEventRegistrationToken = class external
    value: Float;
  end;

  JHResult = class external
    value: Float;
  end;

  JIAsyncInfo = class external
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    procedure cancel;
    procedure close;
  end;

  JIAsyncAction = class external(JWindows.Foundation.IAsyncInfo)
    function then: JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}; error: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}; error: (error: Variant): JIPromise{<JU>}; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}; error: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(success: : JIPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: : JU): JIPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JIPromise{<JU>}; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: : JU): JIPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: : Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    procedure cancel;
    completed: JWindows.Foundation.AsyncActionCompletedHandler;
    procedure getResults;
  end;

  JAsyncOperationWithProgressCompletedHandler{<TResultTProgress>} = class external
(asyncInfo: JWindows.Foundation.IAsyncOperationWithProgress{<JTResultJTProgress>}; asyncStatus: JWindows.Foundation.AsyncStatus)  end;

  JIAsyncOperationWithProgress{<TResultTProgress>} = class external(JWindows.Foundation.IPromise {JTResult} )
    operation:       progress: JWindows.Foundation.AsyncOperationProgressHandler{<JTResultJTProgress>};
      completed: JWindows.Foundation.AsyncOperationWithProgressCompletedHandler{<JTResultJTProgress>};
      function getResults: JTResult;
    end;;
  end;

  JAsyncOperationCompletedHandler{<TResult>} = class external
(asyncInfo: JWindows.Foundation.IAsyncOperation{<JTResult>}; asyncStatus: JWindows.Foundation.AsyncStatus)  end;

  JIAsyncOperation{<TResult>} = class external(JWindows.Foundation.IPromise {JTResult} )
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JTResult>};
      function getResults: JTResult;
    end;;
  end;

  JAsyncActionWithProgressCompletedHandler{<TProgress>} = class external
(asyncInfo: JWindows.Foundation.IAsyncActionWithProgress{<JTProgress>}; asyncStatus: JWindows.Foundation.AsyncStatus)  end;

  JIAsyncActionWithProgress{<TProgress>} = class external(JWindows.Foundation.IAsyncInfo, JWindows.Foundation.IPromise {Variant} )
    progress: JWindows.Foundation.AsyncActionProgressHandler{<JTProgress>};
    completed: JWindows.Foundation.AsyncActionWithProgressCompletedHandler{<JTProgress>};
    procedure getResults;
  end;

  JAsyncOperationProgressHandler{<TResultTProgress>} = class external
(asyncInfo: JWindows.Foundation.IAsyncOperationWithProgress{<JTResultJTProgress>}; progressInfo: JTProgress)  end;

  JAsyncActionProgressHandler{<TProgress>} = class external
(asyncInfo: JWindows.Foundation.IAsyncActionWithProgress{<JTProgress>}; progressInfo: JTProgress)  end;

  JIReference{<T>} = class external(JWindows.Foundation.IPropertyValue)
    value: JT;
  end;

  JIReferenceArray{<T>} = class external(JWindows.Foundation.IPropertyValue)
    value: array of JT;
  end;

  JTypedEventHandler{<TSenderTResult>} = class external
(sender: JTSender; args: JTResult)  end;

  JEventHandler{<T>} = class external
(sender: Variant; args: JT)  end;

//Windows

//Foundation

//Metadata

type
  JWebHostHiddenAttribute = class external 'WebHostHiddenAttribute'
  end;

  JVariantAttribute = class external 'VariantAttribute'
  end;

  JHasVariantAttribute = class external 'HasVariantAttribute'
  end;

  JDualApiPartitionAttribute = class external 'DualApiPartitionAttribute'
  end;

  JMuseAttribute = class external 'MuseAttribute'
  end;

  JGCPressureAttribute = class external 'GCPressureAttribute'
  end;

  JActivatableAttribute = class external 'ActivatableAttribute'
    constructor Create(version: Float);
    constructor Create(&type: String; version: Float);
  end;

  JVersionAttribute = class external 'VersionAttribute'
    constructor Create(version: Float);
  end;

  JAllowMultipleAttribute = class external 'AllowMultipleAttribute'
  end;

  JAttributeUsageAttribute = class external 'AttributeUsageAttribute'
    constructor Create(targets: JWindows.Foundation.Metadata.AttributeTargets);
  end;

  JDefaultOverloadAttribute = class external 'DefaultOverloadAttribute'
  end;

  JDefaultAttribute = class external 'DefaultAttribute'
  end;

  JGuidAttribute = class external 'GuidAttribute'
    constructor Create(a: Float; b: Float; c: Float; d: Float; e: Float; f: Float; g: Float; h: Float; i: Float; j: Float; k: Float);
  end;

  JComposableAttribute = class external 'ComposableAttribute'
    constructor Create(&type: String; compositionType: JWindows.Foundation.Metadata.CompositionType; version: Float);
  end;

  JOverloadAttribute = class external 'OverloadAttribute'
    constructor Create(method: String);
  end;

  JStaticAttribute = class external 'StaticAttribute'
    constructor Create(&type: String; version: Float);
  end;

  JOverridableAttribute = class external 'OverridableAttribute'
  end;

  JProtectedAttribute = class external 'ProtectedAttribute'
  end;

  JThreadingAttribute = class external 'ThreadingAttribute'
    constructor Create(model: JWindows.Foundation.Metadata.ThreadingModel);
  end;

  JMarshalingBehaviorAttribute = class external 'MarshalingBehaviorAttribute'
    constructor Create(behavior: JWindows.Foundation.Metadata.MarshalingType);
  end;

  JExclusiveToAttribute = class external 'ExclusiveToAttribute'
    constructor Create(typeName: String);
  end;

  JLengthIsAttribute = class external 'LengthIsAttribute'
    constructor Create(indexLengthParameter: Float);
  end;

  JRangeAttribute = class external 'RangeAttribute'
    constructor Create(minValue: Float; maxValue: Float);
  end;

//Windows

//Foundation

//Diagnostics

type
  JRuntimeBrokerErrorSettings = class external 'RuntimeBrokerErrorSettings'
    procedure setErrorOptions(value: JWindows.Foundation.Diagnostics.ErrorOptions);
    function getErrorOptions: JWindows.Foundation.Diagnostics.ErrorOptions;
  end;

  JIErrorReportingSettings = class external
    procedure setErrorOptions(value: JWindows.Foundation.Diagnostics.ErrorOptions);
    function getErrorOptions: JWindows.Foundation.Diagnostics.ErrorOptions;
  end;

//Windows

//ApplicationModel

//Background

type
  JBackgroundExecutionManager = class external 'BackgroundExecutionManager'
    function requestAccessAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Background.BackgroundAccessStatus>};
    function requestAccessAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Background.BackgroundAccessStatus>};
    procedure removeAccess;
    procedure removeAccess(applicationId: String);
    function getAccessStatus: JWindows.ApplicationModel.Background.BackgroundAccessStatus;
    function getAccessStatus(applicationId: String): JWindows.ApplicationModel.Background.BackgroundAccessStatus;
  end;

  JBackgroundTaskRegistration = class external 'BackgroundTaskRegistration'
    name: String;
    taskId: String;
    onprogress: Variant;
    oncompleted: Variant;
    procedure unregister(cancelTask: Boolean);
    allTasks: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Background.IBackgroundTaskRegistration>};
  end;

  JBackgroundTaskDeferral = class external 'BackgroundTaskDeferral'
    procedure complete;
  end;

  JBackgroundTaskProgressEventArgs = class external 'BackgroundTaskProgressEventArgs'
    instanceId: String;
    progress: Float;
  end;

  JBackgroundTaskCompletedEventArgs = class external 'BackgroundTaskCompletedEventArgs'
    instanceId: String;
    procedure checkResult;
  end;

  JBackgroundTaskBuilder = class external 'BackgroundTaskBuilder'
    name: String;
    taskEntryPoint: String;
    procedure setTrigger(trigger: JWindows.ApplicationModel.Background.IBackgroundTrigger);
    procedure addCondition(condition: JWindows.ApplicationModel.Background.IBackgroundCondition);
    function register: JWindows.ApplicationModel.Background.BackgroundTaskRegistration;
  end;

  JSystemTrigger = class external 'SystemTrigger'
    constructor Create(triggerType: JWindows.ApplicationModel.Background.SystemTriggerType; oneShot: Boolean);
    oneShot: Boolean;
    triggerType: JWindows.ApplicationModel.Background.SystemTriggerType;
  end;

  JSystemCondition = class external 'SystemCondition'
    constructor Create(conditionType: JWindows.ApplicationModel.Background.SystemConditionType);
    conditionType: JWindows.ApplicationModel.Background.SystemConditionType;
  end;

  JNetworkOperatorNotificationTrigger = class external 'NetworkOperatorNotificationTrigger'
    constructor Create(networkAccountId: String);
    networkAccountId: String;
  end;

  JTimeTrigger = class external 'TimeTrigger'
    constructor Create(freshnessTime: Float; oneShot: Boolean);
    freshnessTime: Float;
    oneShot: Boolean;
  end;

  JMaintenanceTrigger = class external 'MaintenanceTrigger'
    constructor Create(freshnessTime: Float; oneShot: Boolean);
    freshnessTime: Float;
    oneShot: Boolean;
  end;

  JNetworkOperatorHotspotAuthenticationTrigger = class external 'NetworkOperatorHotspotAuthenticationTrigger'
  end;

  JPushNotificationTrigger = class external 'PushNotificationTrigger'
    constructor Create(applicationId: String);
    constructor Create;
  end;

  JIBackgroundExecutionManagerStatics = class external
    function requestAccessAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Background.BackgroundAccessStatus>};
    function requestAccessAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Background.BackgroundAccessStatus>};
    procedure removeAccess;
    procedure removeAccess(applicationId: String);
    function getAccessStatus: JWindows.ApplicationModel.Background.BackgroundAccessStatus;
    function getAccessStatus(applicationId: String): JWindows.ApplicationModel.Background.BackgroundAccessStatus;
  end;

  JBackgroundTaskCanceledEventHandler = class external
(sender: JWindows.ApplicationModel.Background.IBackgroundTaskInstance; reason: JWindows.ApplicationModel.Background.BackgroundTaskCancellationReason)  end;

  JIBackgroundTaskInstance = class external
    instanceId: String;
    progress: Float;
    suspendedCount: Float;
    task: JWindows.ApplicationModel.Background.BackgroundTaskRegistration;
    triggerDetails: Variant;
    oncanceled: Variant;
    function getDeferral: JWindows.ApplicationModel.Background.BackgroundTaskDeferral;
  end;

  JBackgroundTaskProgressEventHandler = class external
(sender: JWindows.ApplicationModel.Background.BackgroundTaskRegistration; args: JWindows.ApplicationModel.Background.BackgroundTaskProgressEventArgs)  end;

  JBackgroundTaskCompletedEventHandler = class external
(sender: JWindows.ApplicationModel.Background.BackgroundTaskRegistration; args: JWindows.ApplicationModel.Background.BackgroundTaskCompletedEventArgs)  end;

  JIBackgroundTaskDeferral = class external
    procedure complete;
  end;

  JIBackgroundTask = class external
    procedure run(taskInstance: JWindows.ApplicationModel.Background.IBackgroundTaskInstance);
  end;

  JIBackgroundTaskRegistration = class external
    name: String;
    taskId: String;
    onprogress: Variant;
    oncompleted: Variant;
    procedure unregister(cancelTask: Boolean);
  end;

  JIBackgroundTaskRegistrationStatics = class external
    allTasks: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Background.IBackgroundTaskRegistration>};
  end;

  JIBackgroundTaskBuilder = class external
    name: String;
    taskEntryPoint: String;
    procedure setTrigger(trigger: JWindows.ApplicationModel.Background.IBackgroundTrigger);
    procedure addCondition(condition: JWindows.ApplicationModel.Background.IBackgroundCondition);
    function register: JWindows.ApplicationModel.Background.BackgroundTaskRegistration;
  end;

  JIBackgroundTrigger = class external
  end;

  JIBackgroundCondition = class external
  end;

  JIBackgroundTaskCompletedEventArgs = class external
    instanceId: String;
    procedure checkResult;
  end;

  JIBackgroundTaskProgressEventArgs = class external
    instanceId: String;
    progress: Float;
  end;

  JISystemTrigger = class external(JWindows.ApplicationModel.Background.IBackgroundTrigger)
    oneShot: Boolean;
    triggerType: JWindows.ApplicationModel.Background.SystemTriggerType;
  end;

  JISystemTriggerFactory = class external
    function create(triggerType: JWindows.ApplicationModel.Background.SystemTriggerType; oneShot: Boolean): JWindows.ApplicationModel.Background.SystemTrigger;
  end;

  JISystemCondition = class external(JWindows.ApplicationModel.Background.IBackgroundCondition)
    conditionType: JWindows.ApplicationModel.Background.SystemConditionType;
  end;

  JISystemConditionFactory = class external
    function create(conditionType: JWindows.ApplicationModel.Background.SystemConditionType): JWindows.ApplicationModel.Background.SystemCondition;
  end;

  JINetworkOperatorNotificationTrigger = class external(JWindows.ApplicationModel.Background.IBackgroundTrigger)
    networkAccountId: String;
  end;

  JINetworkOperatorNotificationTriggerFactory = class external
    function create(networkAccountId: String): JWindows.ApplicationModel.Background.NetworkOperatorNotificationTrigger;
  end;

  JITimeTrigger = class external(JWindows.ApplicationModel.Background.IBackgroundTrigger)
    freshnessTime: Float;
    oneShot: Boolean;
  end;

  JITimeTriggerFactory = class external
    function create(freshnessTime: Float; oneShot: Boolean): JWindows.ApplicationModel.Background.TimeTrigger;
  end;

  JIMaintenanceTrigger = class external(JWindows.ApplicationModel.Background.IBackgroundTrigger)
    freshnessTime: Float;
    oneShot: Boolean;
  end;

  JIMaintenanceTriggerFactory = class external
    function create(freshnessTime: Float; oneShot: Boolean): JWindows.ApplicationModel.Background.MaintenanceTrigger;
  end;

  JINetworkOperatorHotspotAuthenticationTrigger = class external(JWindows.ApplicationModel.Background.IBackgroundTrigger)
  end;

  JIPushNotificationTriggerFactory = class external
    function create(applicationId: String): JWindows.ApplicationModel.Background.PushNotificationTrigger;
  end;

//Windows

//ApplicationModel

//Contacts

type
  JContactField = class external 'ContactField'
    constructor Create(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType);
    constructor Create(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory);
    constructor Create(name: String; value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory);
    category: JWindows.ApplicationModel.Contacts.ContactFieldCategory;
    name: String;
    &type: JWindows.ApplicationModel.Contacts.ContactFieldType;
    value: String;
  end;

  JContactLocationField = class external 'ContactLocationField'
    constructor Create(unstructuredAddress: String);
    constructor Create(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory);
    constructor Create(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; street: String; city: String; region: String; country: String; postalCode: String);
    city: String;
    country: String;
    postalCode: String;
    region: String;
    street: String;
    unstructuredAddress: String;
    category: JWindows.ApplicationModel.Contacts.ContactFieldCategory;
    name: String;
    &type: JWindows.ApplicationModel.Contacts.ContactFieldType;
    value: String;
  end;

  JContactInstantMessageField = class external 'ContactInstantMessageField'
    constructor Create(userName: String);
    constructor Create(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory);
    constructor Create(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; service: String; displayText: String; verb: JWindows.Foundation.Uri);
    displayText: String;
    launchUri: JWindows.Foundation.Uri;
    service: String;
    userName: String;
    category: JWindows.ApplicationModel.Contacts.ContactFieldCategory;
    name: String;
    &type: JWindows.ApplicationModel.Contacts.ContactFieldType;
    value: String;
  end;

  JKnownContactField = class external 'KnownContactField'
    email: String;
    instantMessage: String;
    location: String;
    phoneNumber: String;
    function convertNameToType(name: String): JWindows.ApplicationModel.Contacts.ContactFieldType;
    function convertTypeToName(&type: JWindows.ApplicationModel.Contacts.ContactFieldType): String;
  end;

  JContactInformation = class external 'ContactInformation'
    customFields: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    emails: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    instantMessages: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactInstantMessageField>};
    locations: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactLocationField>};
    name: String;
    phoneNumbers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
    function queryCustomFields(customName: String): JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
  end;

  JContactPicker = class external 'ContactPicker'
    commitButtonText: String;
    desiredFields: JWindows.Foundation.Collections.IVector{<String>};
    selectionMode: JWindows.ApplicationModel.Contacts.ContactSelectionMode;
    function pickSingleContactAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Contacts.ContactInformation>};
    function pickMultipleContactsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactInformation>}>};
  end;

  JContact = class external 'Contact'
    fields: JWindows.Foundation.Collections.IVector{<JWindows.ApplicationModel.Contacts.IContactField>};
    name: String;
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
  end;

  JContactFieldFactory = class external 'ContactFieldFactory'
    function createField(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType): JWindows.ApplicationModel.Contacts.ContactField;
    function createField(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactField;
    function createField(name: String; value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactField;
    function createLocation(unstructuredAddress: String): JWindows.ApplicationModel.Contacts.ContactLocationField;
    function createLocation(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactLocationField;
    function createLocation(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; street: String; city: String; region: String; country: String; postalCode: String): JWindows.ApplicationModel.Contacts.ContactLocationField;
    function createInstantMessage(userName: String): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
    function createInstantMessage(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
    function createInstantMessage(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; service: String; displayText: String; verb: JWindows.Foundation.Uri): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
  end;

  JIContactField = class external
    category: JWindows.ApplicationModel.Contacts.ContactFieldCategory;
    name: String;
    &type: JWindows.ApplicationModel.Contacts.ContactFieldType;
    value: String;
  end;

  JIContactLocationField = class external(JWindows.ApplicationModel.Contacts.IContactField)
    city: String;
    country: String;
    postalCode: String;
    region: String;
    street: String;
    unstructuredAddress: String;
  end;

  JIContactInstantMessageField = class external(JWindows.ApplicationModel.Contacts.IContactField)
    displayText: String;
    launchUri: JWindows.Foundation.Uri;
    service: String;
    userName: String;
  end;

  JIKnownContactFieldStatics = class external
    email: String;
    instantMessage: String;
    location: String;
    phoneNumber: String;
    function convertNameToType(name: String): JWindows.ApplicationModel.Contacts.ContactFieldType;
    function convertTypeToName(&type: JWindows.ApplicationModel.Contacts.ContactFieldType): String;
  end;

  JIContactInformation = class external
    customFields: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    emails: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    instantMessages: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactInstantMessageField>};
    locations: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactLocationField>};
    name: String;
    phoneNumbers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
    function queryCustomFields(customName: String): JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactField>};
  end;

  JIContactPicker = class external
    commitButtonText: String;
    desiredFields: JWindows.Foundation.Collections.IVector{<String>};
    selectionMode: JWindows.ApplicationModel.Contacts.ContactSelectionMode;
    function pickSingleContactAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Contacts.ContactInformation>};
    function pickMultipleContactsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Contacts.ContactInformation>}>};
  end;

  JIContact = class external
    fields: JWindows.Foundation.Collections.IVector{<JWindows.ApplicationModel.Contacts.IContactField>};
    name: String;
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
  end;

  JIContactFieldFactory = class external
    function createField(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType): JWindows.ApplicationModel.Contacts.ContactField;
    function createField(value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactField;
    function createField(name: String; value: String; &type: JWindows.ApplicationModel.Contacts.ContactFieldType; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactField;
  end;

  JIContactLocationFieldFactory = class external
    function createLocation(unstructuredAddress: String): JWindows.ApplicationModel.Contacts.ContactLocationField;
    function createLocation(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactLocationField;
    function createLocation(unstructuredAddress: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; street: String; city: String; region: String; country: String; postalCode: String): JWindows.ApplicationModel.Contacts.ContactLocationField;
  end;

  JIContactInstantMessageFieldFactory = class external
    function createInstantMessage(userName: String): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
    function createInstantMessage(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
    function createInstantMessage(userName: String; category: JWindows.ApplicationModel.Contacts.ContactFieldCategory; service: String; displayText: String; verb: JWindows.Foundation.Uri): JWindows.ApplicationModel.Contacts.ContactInstantMessageField;
  end;

//Windows

//ApplicationModel

//Contacts

//Provider

type
  JContactRemovedEventArgs = class external 'ContactRemovedEventArgs'
    id: String;
  end;

  JContactPickerUI = class external 'ContactPickerUI'
    desiredFields: JWindows.Foundation.Collections.IVectorView{<String>};
    selectionMode: JWindows.ApplicationModel.Contacts.ContactSelectionMode;
    function addContact(id: String; contact: JWindows.ApplicationModel.Contacts.Contact): JWindows.ApplicationModel.Contacts.Provider.AddContactResult;
    procedure removeContact(id: String);
    function containsContact(id: String): Boolean;
    oncontactremoved: Variant;
  end;

  JIContactRemovedEventArgs = class external
    id: String;
  end;

  JIContactPickerUI = class external
    desiredFields: JWindows.Foundation.Collections.IVectorView{<String>};
    selectionMode: JWindows.ApplicationModel.Contacts.ContactSelectionMode;
    function addContact(id: String; contact: JWindows.ApplicationModel.Contacts.Contact): JWindows.ApplicationModel.Contacts.Provider.AddContactResult;
    procedure removeContact(id: String);
    function containsContact(id: String): Boolean;
    oncontactremoved: Variant;
  end;

//Windows

//ApplicationModel

//DataTransfer

type
  JStandardDataFormats = class external 'StandardDataFormats'
    bitmap: String;
    html: String;
    rtf: String;
    storageItems: String;
    text: String;
    uri: String;
  end;

  JDataPackagePropertySetView = class external 'DataPackagePropertySetView'
    applicationListingUri: JWindows.Foundation.Uri;
    applicationName: String;
    description: String;
    fileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    thumbnail: JWindows.Storage.Streams.RandomAccessStreamReference;
    title: String;
    size: Float;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function split:       first: JWindows.Foundation.Collections.IMapView{<StringVariant>};
      second: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JDataPackagePropertySet = class external 'DataPackagePropertySet'
    applicationListingUri: JWindows.Foundation.Uri;
    applicationName: String;
    description: String;
    fileTypes: JWindows.Foundation.Collections.IVector{<String>};
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
    title: String;
    size: Float;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JDataProviderDeferral = class external 'DataProviderDeferral'
    procedure complete;
  end;

  JDataProviderRequest = class external 'DataProviderRequest'
    deadline: JDate;
    formatId: String;
    function getDeferral: JWindows.ApplicationModel.DataTransfer.DataProviderDeferral;
    procedure setData(value: Variant);
  end;

  JOperationCompletedEventArgs = class external 'OperationCompletedEventArgs'
    operation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
  end;

  JDataPackageView = class external 'DataPackageView'
    availableFormats: JWindows.Foundation.Collections.IVectorView{<String>};
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySetView;
    requestedOperation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
    procedure reportOperationCompleted(value: JWindows.ApplicationModel.DataTransfer.DataPackageOperation);
    function contains(formatId: String): Boolean;
    function getDataAsync(formatId: String): JWindows.Foundation.IAsyncOperation{<Variant>};
    function getTextAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getTextAsync(formatId: String): JWindows.Foundation.IAsyncOperation{<String>};
    function getUriAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Uri>};
    function getHtmlFormatAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getResourceMapAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMapView{<StringJWindows.Storage.Streams.RandomAccessStreamReference>}>};
    function getRtfAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getBitmapAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.RandomAccessStreamReference>};
    function getStorageItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
  end;

  JDataPackage = class external 'DataPackage'
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySet;
    requestedOperation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
    resourceMap: JWindows.Foundation.Collections.IMap{<StringJWindows.Storage.Streams.RandomAccessStreamReference>};
    function getView: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    onoperationcompleted: Variant;
    ondestroyed: Variant;
    procedure setData(formatId: String; value: Variant);
    procedure setDataProvider(formatId: String; delayRenderer: JWindows.ApplicationModel.DataTransfer.DataProviderHandler);
    procedure setText(value: String);
    procedure setUri(value: JWindows.Foundation.Uri);
    procedure setHtmlFormat(value: String);
    procedure setRtf(value: String);
    procedure setBitmap(value: JWindows.Storage.Streams.RandomAccessStreamReference);
    procedure setStorageItems(value: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageItem>});
    procedure setStorageItems(value: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageItem>}; readOnly: Boolean);
  end;

  JHtmlFormatHelper = class external 'HtmlFormatHelper'
    function getStaticFragment(htmlFormat: String): String;
    function createHtmlFormat(htmlFragment: String): String;
  end;

  JClipboard = class external 'Clipboard'
    function getContent: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    procedure setContent(content: JWindows.ApplicationModel.DataTransfer.DataPackage);
    procedure flush;
    procedure clear;
    oncontentchanged: Variant;
  end;

  JDataRequestDeferral = class external 'DataRequestDeferral'
    procedure complete;
  end;

  JDataRequest = class external 'DataRequest'
    data: JWindows.ApplicationModel.DataTransfer.DataPackage;
    deadline: JDate;
    procedure failWithDisplayText(value: String);
    function getDeferral: JWindows.ApplicationModel.DataTransfer.DataRequestDeferral;
  end;

  JDataRequestedEventArgs = class external 'DataRequestedEventArgs'
    request: JWindows.ApplicationModel.DataTransfer.DataRequest;
  end;

  JTargetApplicationChosenEventArgs = class external 'TargetApplicationChosenEventArgs'
    applicationName: String;
  end;

  JDataTransferManager = class external 'DataTransferManager'
    ondatarequested: Variant;
    ontargetapplicationchosen: Variant;
    procedure showShareUI;
    function getForCurrentView: JWindows.ApplicationModel.DataTransfer.DataTransferManager;
  end;

  JIStandardDataFormatsStatics = class external
    bitmap: String;
    html: String;
    rtf: String;
    storageItems: String;
    text: String;
    uri: String;
  end;

  JIDataPackagePropertySetView = class external(JWindows.Foundation.Collections.IMapView {String, Variant} , JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}} )
    applicationListingUri: JWindows.Foundation.Uri;
    applicationName: String;
    description: String;
    fileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    thumbnail: JWindows.Storage.Streams.RandomAccessStreamReference;
    title: String;
  end;

  JIDataPackagePropertySet = class external(JWindows.Foundation.Collections.IMap {String, Variant} , JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}} )
    applicationListingUri: JWindows.Foundation.Uri;
    applicationName: String;
    description: String;
    fileTypes: JWindows.Foundation.Collections.IVector{<String>};
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
    title: String;
  end;

  JIDataProviderDeferral = class external
    procedure complete;
  end;

  JIDataProviderRequest = class external
    deadline: JDate;
    formatId: String;
    function getDeferral: JWindows.ApplicationModel.DataTransfer.DataProviderDeferral;
    procedure setData(value: Variant);
  end;

  JDataProviderHandler = class external
(request: JWindows.ApplicationModel.DataTransfer.DataProviderRequest)  end;

  JIOperationCompletedEventArgs = class external
    operation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
  end;

  JIDataPackageView = class external
    availableFormats: JWindows.Foundation.Collections.IVectorView{<String>};
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySetView;
    requestedOperation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
    procedure reportOperationCompleted(value: JWindows.ApplicationModel.DataTransfer.DataPackageOperation);
    function contains(formatId: String): Boolean;
    function getDataAsync(formatId: String): JWindows.Foundation.IAsyncOperation{<Variant>};
    function getTextAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getTextAsync(formatId: String): JWindows.Foundation.IAsyncOperation{<String>};
    function getUriAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Uri>};
    function getHtmlFormatAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getResourceMapAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMapView{<StringJWindows.Storage.Streams.RandomAccessStreamReference>}>};
    function getRtfAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getBitmapAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.RandomAccessStreamReference>};
    function getStorageItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
  end;

  JIDataPackage = class external
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySet;
    requestedOperation: JWindows.ApplicationModel.DataTransfer.DataPackageOperation;
    resourceMap: JWindows.Foundation.Collections.IMap{<StringJWindows.Storage.Streams.RandomAccessStreamReference>};
    function getView: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    onoperationcompleted: Variant;
    ondestroyed: Variant;
    procedure setData(formatId: String; value: Variant);
    procedure setDataProvider(formatId: String; delayRenderer: JWindows.ApplicationModel.DataTransfer.DataProviderHandler);
    procedure setText(value: String);
    procedure setUri(value: JWindows.Foundation.Uri);
    procedure setHtmlFormat(value: String);
    procedure setRtf(value: String);
    procedure setBitmap(value: JWindows.Storage.Streams.RandomAccessStreamReference);
    procedure setStorageItems(value: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageItem>});
    procedure setStorageItems(value: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageItem>}; readOnly: Boolean);
  end;

  JIHtmlFormatHelperStatics = class external
    function getStaticFragment(htmlFormat: String): String;
    function createHtmlFormat(htmlFragment: String): String;
  end;

  JIClipboardStatics = class external
    function getContent: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    procedure setContent(content: JWindows.ApplicationModel.DataTransfer.DataPackage);
    procedure flush;
    procedure clear;
    oncontentchanged: Variant;
  end;

  JIDataRequestDeferral = class external
    procedure complete;
  end;

  JIDataRequest = class external
    data: JWindows.ApplicationModel.DataTransfer.DataPackage;
    deadline: JDate;
    procedure failWithDisplayText(value: String);
    function getDeferral: JWindows.ApplicationModel.DataTransfer.DataRequestDeferral;
  end;

  JIDataRequestedEventArgs = class external
    request: JWindows.ApplicationModel.DataTransfer.DataRequest;
  end;

  JITargetApplicationChosenEventArgs = class external
    applicationName: String;
  end;

  JIDataTransferManager = class external
    ondatarequested: Variant;
    ontargetapplicationchosen: Variant;
  end;

  JIDataTransferManagerStatics = class external
    procedure showShareUI;
    function getForCurrentView: JWindows.ApplicationModel.DataTransfer.DataTransferManager;
  end;

//Windows

//ApplicationModel

//Search

type
  JSearchPaneQueryLinguisticDetails = class external 'SearchPaneQueryLinguisticDetails'
    queryTextAlternatives: JWindows.Foundation.Collections.IVectorView{<String>};
    queryTextCompositionLength: Float;
    queryTextCompositionStart: Float;
  end;

  JSearchPaneVisibilityChangedEventArgs = class external 'SearchPaneVisibilityChangedEventArgs'
    visible: Boolean;
  end;

  JSearchPaneQueryChangedEventArgs = class external 'SearchPaneQueryChangedEventArgs'
    language: String;
    linguisticDetails: JWindows.ApplicationModel.Search.SearchPaneQueryLinguisticDetails;
    queryText: String;
  end;

  JSearchPaneQuerySubmittedEventArgs = class external 'SearchPaneQuerySubmittedEventArgs'
    language: String;
    queryText: String;
  end;

  JSearchPaneResultSuggestionChosenEventArgs = class external 'SearchPaneResultSuggestionChosenEventArgs'
    tag: String;
  end;

  JSearchSuggestionCollection = class external 'SearchSuggestionCollection'
    size: Float;
    procedure appendQuerySuggestion(text: String);
    procedure appendQuerySuggestions(suggestions: JWindows.Foundation.Collections.IIterable{<String>});
    procedure appendResultSuggestion(text: String; detailText: String; tag: String; image: JWindows.Storage.Streams.IRandomAccessStreamReference; imageAlternateText: String);
    procedure appendSearchSeparator(&label: String);
  end;

  JSearchPaneSuggestionsRequestDeferral = class external 'SearchPaneSuggestionsRequestDeferral'
    procedure complete;
  end;

  JSearchPaneSuggestionsRequest = class external 'SearchPaneSuggestionsRequest'
    isCanceled: Boolean;
    searchSuggestionCollection: JWindows.ApplicationModel.Search.SearchSuggestionCollection;
    function getDeferral: JWindows.ApplicationModel.Search.SearchPaneSuggestionsRequestDeferral;
  end;

  JSearchPaneSuggestionsRequestedEventArgs = class external 'SearchPaneSuggestionsRequestedEventArgs'
    request: JWindows.ApplicationModel.Search.SearchPaneSuggestionsRequest;
    language: String;
    linguisticDetails: JWindows.ApplicationModel.Search.SearchPaneQueryLinguisticDetails;
    queryText: String;
  end;

  JLocalContentSuggestionSettings = class external 'LocalContentSuggestionSettings'
    aqsFilter: String;
    enabled: Boolean;
    locations: JWindows.Foundation.Collections.IVector{<JWindows.Storage.StorageFolder>};
    propertiesToMatch: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JSearchPane = class external 'SearchPane'
    language: String;
    placeholderText: String;
    queryText: String;
    searchHistoryContext: String;
    searchHistoryEnabled: Boolean;
    showOnKeyboardInput: Boolean;
    visible: Boolean;
    onvisibilitychanged: Variant;
    onquerychanged: Variant;
    onsuggestionsrequested: Variant;
    onquerysubmitted: Variant;
    onresultsuggestionchosen: Variant;
    procedure setLocalContentSuggestionSettings(settings: JWindows.ApplicationModel.Search.LocalContentSuggestionSettings);
    procedure show;
    procedure show(query: String);
    function trySetQueryText(query: String): Boolean;
    function getForCurrentView: JWindows.ApplicationModel.Search.SearchPane;
  end;

  JISearchPaneQueryLinguisticDetails = class external
    queryTextAlternatives: JWindows.Foundation.Collections.IVectorView{<String>};
    queryTextCompositionLength: Float;
    queryTextCompositionStart: Float;
  end;

  JISearchPaneVisibilityChangedEventArgs = class external
    visible: Boolean;
  end;

  JISearchPaneQueryChangedEventArgs = class external
    language: String;
    linguisticDetails: JWindows.ApplicationModel.Search.SearchPaneQueryLinguisticDetails;
    queryText: String;
  end;

  JISearchPaneQuerySubmittedEventArgs = class external
    language: String;
    queryText: String;
  end;

  JISearchPaneResultSuggestionChosenEventArgs = class external
    tag: String;
  end;

  JISearchSuggestionCollection = class external
    size: Float;
    procedure appendQuerySuggestion(text: String);
    procedure appendQuerySuggestions(suggestions: JWindows.Foundation.Collections.IIterable{<String>});
    procedure appendResultSuggestion(text: String; detailText: String; tag: String; image: JWindows.Storage.Streams.IRandomAccessStreamReference; imageAlternateText: String);
    procedure appendSearchSeparator(&label: String);
  end;

  JISearchPaneSuggestionsRequestDeferral = class external
    procedure complete;
  end;

  JISearchPaneSuggestionsRequest = class external
    isCanceled: Boolean;
    searchSuggestionCollection: JWindows.ApplicationModel.Search.SearchSuggestionCollection;
    function getDeferral: JWindows.ApplicationModel.Search.SearchPaneSuggestionsRequestDeferral;
  end;

  JISearchPaneSuggestionsRequestedEventArgs = class external(JWindows.ApplicationModel.Search.ISearchPaneQueryChangedEventArgs)
    request: JWindows.ApplicationModel.Search.SearchPaneSuggestionsRequest;
  end;

  JILocalContentSuggestionSettings = class external
    aqsFilter: String;
    enabled: Boolean;
    locations: JWindows.Foundation.Collections.IVector{<JWindows.Storage.StorageFolder>};
    propertiesToMatch: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JISearchPaneStatics = class external
    function getForCurrentView: JWindows.ApplicationModel.Search.SearchPane;
  end;

  JISearchPane = class external
    language: String;
    placeholderText: String;
    queryText: String;
    searchHistoryContext: String;
    searchHistoryEnabled: Boolean;
    showOnKeyboardInput: Boolean;
    visible: Boolean;
    onvisibilitychanged: Variant;
    onquerychanged: Variant;
    onsuggestionsrequested: Variant;
    onquerysubmitted: Variant;
    onresultsuggestionchosen: Variant;
    procedure setLocalContentSuggestionSettings(settings: JWindows.ApplicationModel.Search.LocalContentSuggestionSettings);
    procedure show;
    procedure show(query: String);
    function trySetQueryText(query: String): Boolean;
  end;

//Windows

//ApplicationModel

//DataTransfer

//ShareTarget

type
  JQuickLink = class external 'QuickLink'
    id: String;
    supportedDataFormats: JWindows.Foundation.Collections.IVector{<String>};
    supportedFileTypes: JWindows.Foundation.Collections.IVector{<String>};
    thumbnail: JWindows.Storage.Streams.RandomAccessStreamReference;
    title: String;
  end;

  JShareOperation = class external 'ShareOperation'
    data: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    quickLinkId: String;
    procedure removeThisQuickLink;
    procedure reportStarted;
    procedure reportDataRetrieved;
    procedure reportSubmittedBackgroundTask;
    procedure reportCompleted(quicklink: JWindows.ApplicationModel.DataTransfer.ShareTarget.QuickLink);
    procedure reportCompleted;
    procedure reportError(value: String);
  end;

  JIQuickLink = class external
    id: String;
    supportedDataFormats: JWindows.Foundation.Collections.IVector{<String>};
    supportedFileTypes: JWindows.Foundation.Collections.IVector{<String>};
    thumbnail: JWindows.Storage.Streams.RandomAccessStreamReference;
    title: String;
  end;

  JIShareOperation = class external
    data: JWindows.ApplicationModel.DataTransfer.DataPackageView;
    quickLinkId: String;
    procedure removeThisQuickLink;
    procedure reportStarted;
    procedure reportDataRetrieved;
    procedure reportSubmittedBackgroundTask;
    procedure reportCompleted(quicklink: JWindows.ApplicationModel.DataTransfer.ShareTarget.QuickLink);
    procedure reportCompleted;
    procedure reportError(value: String);
  end;

//Windows

//ApplicationModel

//Activation

type
  JSplashScreen = class external 'SplashScreen'
    imageLocation: JWindows.Foundation.Rect;
    ondismissed: Variant;
  end;

  JLaunchActivatedEventArgs = class external 'LaunchActivatedEventArgs'
    arguments: String;
    tileId: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JSearchActivatedEventArgs = class external 'SearchActivatedEventArgs'
    language: String;
    queryText: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JShareTargetActivatedEventArgs = class external 'ShareTargetActivatedEventArgs'
    shareOperation: JWindows.ApplicationModel.DataTransfer.ShareTarget.ShareOperation;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JFileActivatedEventArgs = class external 'FileActivatedEventArgs'
    files: JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>};
    verb: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JProtocolActivatedEventArgs = class external 'ProtocolActivatedEventArgs'
    uri: JWindows.Foundation.Uri;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JFileOpenPickerActivatedEventArgs = class external 'FileOpenPickerActivatedEventArgs'
    fileOpenPickerUI: JWindows.Storage.Pickers.Provider.FileOpenPickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JFileSavePickerActivatedEventArgs = class external 'FileSavePickerActivatedEventArgs'
    fileSavePickerUI: JWindows.Storage.Pickers.Provider.FileSavePickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JCachedFileUpdaterActivatedEventArgs = class external 'CachedFileUpdaterActivatedEventArgs'
    cachedFileUpdaterUI: JWindows.Storage.Provider.CachedFileUpdaterUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JContactPickerActivatedEventArgs = class external 'ContactPickerActivatedEventArgs'
    contactPickerUI: JWindows.ApplicationModel.Contacts.Provider.ContactPickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JDeviceActivatedEventArgs = class external 'DeviceActivatedEventArgs'
    deviceInformationId: String;
    verb: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JPrintTaskSettingsActivatedEventArgs = class external 'PrintTaskSettingsActivatedEventArgs'
    configuration: JWindows.Devices.Printers.Extensions.PrintTaskConfiguration;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JCameraSettingsActivatedEventArgs = class external 'CameraSettingsActivatedEventArgs'
    videoDeviceController: Variant;
    videoDeviceExtension: Variant;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JISplashScreen = class external
    imageLocation: JWindows.Foundation.Rect;
    ondismissed: Variant;
  end;

  JIActivatedEventArgs = class external
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
  end;

  JILaunchActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    arguments: String;
    tileId: String;
  end;

  JISearchActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    language: String;
    queryText: String;
  end;

  JIShareTargetActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    shareOperation: JWindows.ApplicationModel.DataTransfer.ShareTarget.ShareOperation;
  end;

  JIFileActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    files: JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>};
    verb: String;
  end;

  JIProtocolActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    uri: JWindows.Foundation.Uri;
  end;

  JIFileOpenPickerActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    fileOpenPickerUI: JWindows.Storage.Pickers.Provider.FileOpenPickerUI;
  end;

  JIFileSavePickerActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    fileSavePickerUI: JWindows.Storage.Pickers.Provider.FileSavePickerUI;
  end;

  JICachedFileUpdaterActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    cachedFileUpdaterUI: JWindows.Storage.Provider.CachedFileUpdaterUI;
  end;

  JIContactPickerActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    contactPickerUI: JWindows.ApplicationModel.Contacts.Provider.ContactPickerUI;
  end;

  JIDeviceActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    deviceInformationId: String;
    verb: String;
  end;

  JIPrintTaskSettingsActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    configuration: JWindows.Devices.Printers.Extensions.PrintTaskConfiguration;
  end;

  JICameraSettingsActivatedEventArgs = class external(JWindows.ApplicationModel.Activation.IActivatedEventArgs)
    videoDeviceController: Variant;
    videoDeviceExtension: Variant;
  end;

//Windows

//ApplicationModel

//Core

type
  JCoreApplication = class external 'CoreApplication'
    mainView: JWindows.ApplicationModel.Core.CoreApplicationView;
    views: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Core.CoreApplicationView>};
    id: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    procedure incrementApplicationUseCount;
    procedure decrementApplicationUseCount;
    function createNewView(runtimeType: String; entryPoint: String): JWindows.ApplicationModel.Core.CoreApplicationView;
    procedure exit;
    onexiting: Variant;
    onsuspending: Variant;
    onresuming: Variant;
    function getCurrentView: JWindows.ApplicationModel.Core.CoreApplicationView;
    procedure run(viewSource: JWindows.ApplicationModel.Core.IFrameworkViewSource);
    procedure runWithActivationFactories(activationFactoryCallback: JWindows.Foundation.IGetActivationFactory);
  end;

  JCoreApplicationView = class external 'CoreApplicationView'
    coreWindow: JWindows.UI.Core.CoreWindow;
    isHosted: Boolean;
    isMain: Boolean;
    onactivated: Variant;
  end;

  JIFrameworkView = class external
    procedure initialize(applicationView: JWindows.ApplicationModel.Core.CoreApplicationView);
    procedure setWindow(window: JWindows.UI.Core.CoreWindow);
    procedure load(entryPoint: String);
    procedure run;
    procedure uninitialize;
  end;

  JIFrameworkViewSource = class external
    function createView: JWindows.ApplicationModel.Core.IFrameworkView;
  end;

  JICoreApplication = class external
    id: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    onsuspending: Variant;
    onresuming: Variant;
    function getCurrentView: JWindows.ApplicationModel.Core.CoreApplicationView;
    procedure run(viewSource: JWindows.ApplicationModel.Core.IFrameworkViewSource);
    procedure runWithActivationFactories(activationFactoryCallback: JWindows.Foundation.IGetActivationFactory);
  end;

  JICoreApplicationUseCount = class external
    procedure incrementApplicationUseCount;
    procedure decrementApplicationUseCount;
  end;

  JICoreApplicationExit = class external
    procedure exit;
    onexiting: Variant;
  end;

  JICoreImmersiveApplication = class external
    mainView: JWindows.ApplicationModel.Core.CoreApplicationView;
    views: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Core.CoreApplicationView>};
    function createNewView(runtimeType: String; entryPoint: String): JWindows.ApplicationModel.Core.CoreApplicationView;
  end;

  JICoreApplicationView = class external
    coreWindow: JWindows.UI.Core.CoreWindow;
    isHosted: Boolean;
    isMain: Boolean;
    onactivated: Variant;
  end;

//Windows

//ApplicationModel

type
  JSuspendingEventArgs = class external 'SuspendingEventArgs'
    suspendingOperation: JWindows.ApplicationModel.SuspendingOperation;
  end;

  JSuspendingDeferral = class external 'SuspendingDeferral'
    procedure complete;
  end;

  JSuspendingOperation = class external 'SuspendingOperation'
    deadline: JDate;
    function getDeferral: JWindows.ApplicationModel.SuspendingDeferral;
  end;

  JPackageId = class external 'PackageId'
    architecture: JWindows.System.ProcessorArchitecture;
    familyName: String;
    fullName: String;
    name: String;
    publisher: String;
    publisherId: String;
    resourceId: String;
    version: JWindows.ApplicationModel.PackageVersion;
  end;

  JPackage = class external 'Package'
    current: JWindows.ApplicationModel.Package;
    dependencies: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Package>};
    description: String;
    displayName: String;
    id: JWindows.ApplicationModel.PackageId;
    installedLocation: JWindows.Storage.StorageFolder;
    isBundle: Boolean;
    isDevelopmentMode: Boolean;
    isFramework: Boolean;
    isResourcePackage: Boolean;
    logo: JWindows.Foundation.Uri;
    publisherDisplayName: String;
  end;

  JDesignMode = class external 'DesignMode'
    designModeEnabled: Boolean;
  end;

  JISuspendingDeferral = class external
    procedure complete;
  end;

  JISuspendingOperation = class external
    deadline: JDate;
    function getDeferral: JWindows.ApplicationModel.SuspendingDeferral;
  end;

  JISuspendingEventArgs = class external
    suspendingOperation: JWindows.ApplicationModel.SuspendingOperation;
  end;

  JPackageVersion = class external
    major: Float;
    minor: Float;
    build: Float;
    revision: Float;
  end;

  JIPackageId = class external
    architecture: JWindows.System.ProcessorArchitecture;
    familyName: String;
    fullName: String;
    name: String;
    publisher: String;
    publisherId: String;
    resourceId: String;
    version: JWindows.ApplicationModel.PackageVersion;
  end;

  JIPackage = class external
    dependencies: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Package>};
    description: String;
    displayName: String;
    id: JWindows.ApplicationModel.PackageId;
    installedLocation: JWindows.Storage.StorageFolder;
    isBundle: Boolean;
    isDevelopmentMode: Boolean;
    isFramework: Boolean;
    isResourcePackage: Boolean;
    logo: JWindows.Foundation.Uri;
    publisherDisplayName: String;
  end;

  JIPackageStatics = class external
    current: JWindows.ApplicationModel.Package;
  end;

  JIDesignModeStatics = class external
    designModeEnabled: Boolean;
  end;

//Windows

//ApplicationModel

//Resources

type
  JResourceLoader = class external 'ResourceLoader'
    constructor Create(name: String);
    constructor Create;
    function getString(resource: String): String;
    function getStringForReference(uri: JWindows.Foundation.Uri): String;
  end;

  JIResourceLoader = class external
    function getString(resource: String): String;
  end;

  JIResourceLoaderStatics = class external
    function getStringForReference(uri: JWindows.Foundation.Uri): String;
  end;

  JIResourceLoaderFactory = class external
    function createResourceLoaderByName(name: String): JWindows.ApplicationModel.Resources.ResourceLoader;
  end;

//Windows

//ApplicationModel

//Resources

//Core

type
  JResourceMap = class external 'ResourceMap'
    uri: JWindows.Foundation.Uri;
    size: Float;
    function getValue(resource: String): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function getValue(resource: String; context: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function getSubtree(reference: String): JWindows.ApplicationModel.Resources.Core.ResourceMap;
    function lookup(key: String): JWindows.ApplicationModel.Resources.Core.NamedResource;
    function hasKey(key: String): Boolean;
    function split:       first: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>};
      second: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>};
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>}>};
  end;

  JResourceContext = class external 'ResourceContext'
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    qualifierValues: JWindows.Foundation.Collections.IObservableMap{<StringString>};
    procedure reset;
    procedure reset(qualifierNames: JWindows.Foundation.Collections.IIterable{<String>});
    procedure overrideToMatch(result: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>});
    function clone: JWindows.ApplicationModel.Resources.Core.ResourceContext;
    function createMatchingContext(result: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>}): JWindows.ApplicationModel.Resources.Core.ResourceContext;
  end;

  JResourceManager = class external 'ResourceManager'
    allResourceMaps: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
    defaultContext: JWindows.ApplicationModel.Resources.Core.ResourceContext;
    mainResourceMap: JWindows.ApplicationModel.Resources.Core.ResourceMap;
    procedure loadPriFiles(files: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageFile>});
    procedure unloadPriFiles(files: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageFile>});
    current: JWindows.ApplicationModel.Resources.Core.ResourceManager;
    function isResourceReference(resourceReference: String): Boolean;
  end;

  JResourceQualifier = class external 'ResourceQualifier'
    isDefault: Boolean;
    isMatch: Boolean;
    qualifierName: String;
    qualifierValue: String;
    score: Float;
  end;

  JResourceCandidate = class external 'ResourceCandidate'
    isDefault: Boolean;
    isMatch: Boolean;
    isMatchAsDefault: Boolean;
    qualifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>};
    valueAsString: String;
    function getValueAsFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getQualifierValue(qualifierName: String): String;
  end;

  JNamedResource = class external 'NamedResource'
    candidates: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
    uri: JWindows.Foundation.Uri;
    function resolve: JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function resolve(resourceContext: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function resolveAll: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
    function resolveAll(resourceContext: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
  end;

  JResourceMapIterator = class external 'ResourceMapIterator'
    current: JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>};
    hasCurrent: Boolean;
    function moveNext: Boolean;
    function getMany:       items: array of JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>};
      returnValue: Float;
    end;;
  end;

  JResourceMapMapView = class external 'ResourceMapMapView'
    size: Float;
    function lookup(key: String): JWindows.ApplicationModel.Resources.Core.ResourceMap;
    function hasKey(key: String): Boolean;
    function split:       first: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
      second: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>}>};
  end;

  JResourceMapMapViewIterator = class external 'ResourceMapMapViewIterator'
    current: JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
    hasCurrent: Boolean;
    function moveNext: Boolean;
    function getMany:       items: array of JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
      returnValue: Float;
    end;;
  end;

  JResourceQualifierObservableMap = class external 'ResourceQualifierObservableMap'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): String;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringString>};
    function insert(key: String; value: String): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringString>}>};
  end;

  JResourceQualifierMapView = class external 'ResourceQualifierMapView'
    size: Float;
    function lookup(key: String): String;
    function hasKey(key: String): Boolean;
    function split:       first: JWindows.Foundation.Collections.IMapView{<StringString>};
      second: JWindows.Foundation.Collections.IMapView{<StringString>};
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringString>}>};
  end;

  JResourceQualifierVectorView = class external 'ResourceQualifierVectorView'
    size: Float;
    function getAt(index: Float): JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function indexOf(value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function join(seperator: String): String;
    function pop: JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    procedure push(items: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier);
    function reverse: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function shift: JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function slice(start: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function slice(start: Float; &end: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function sort: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function sort(compareFn: (a: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; b: JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Float): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function splice(start: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function unshift(items: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Float;
    function lastIndexOf(searchElement: JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Float;
    function lastIndexOf(searchElement: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier));
    procedure forEach(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier); thisArg: Variant);
    function map(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function filter(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceQualifier; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Boolean; thisArg: Variant): array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceQualifier): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JResourceCandidateVectorView = class external 'ResourceCandidateVectorView'
    size: Float;
    function getAt(index: Float): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function indexOf(value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function join(seperator: String): String;
    function pop: JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    procedure push(items: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate);
    function reverse: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function shift: JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function slice(start: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function slice(start: Float; &end: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function sort: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function sort(compareFn: (a: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; b: JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Float): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function splice(start: Float): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function unshift(items: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Float;
    function lastIndexOf(searchElement: JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Float;
    function lastIndexOf(searchElement: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate));
    procedure forEach(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate); thisArg: Variant);
    function map(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function filter(callbackfn: (value: JWindows.ApplicationModel.Resources.Core.ResourceCandidate; index: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Boolean; thisArg: Variant): array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.ApplicationModel.Resources.Core.ResourceCandidate): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JResourceContextLanguagesVectorView = class external 'ResourceContextLanguagesVectorView'
    size: Float;
    function getAt(index: Float): String;
    function indexOf(value: String):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of String;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<String>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of String): array of String;
    function join(seperator: String): String;
    function pop: String;
    procedure push(items: array of String);
    function reverse: array of String;
    function shift: String;
    function slice(start: Float): array of String;
    function slice(start: Float; &end: Float): array of String;
    function sort: array of String;
    function sort(compareFn: (a: String; b: String): Float): array of String;
    function splice(start: Float): array of String;
    function splice(start: Float; deleteCount: Float; items: array of String): array of String;
    function unshift(items: array of String): Float;
    function lastIndexOf(searchElement: String): Float;
    function lastIndexOf(searchElement: String; fromIndex: Float): Float;
    function every(callbackfn: (value: String; index: Float; array: array of String): Boolean): Boolean;
    function every(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: String; index: Float; array: array of String): Boolean): Boolean;
    function some(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: String; index: Float; array: array of String));
    procedure forEach(callbackfn: (value: String; index: Float; array: array of String); thisArg: Variant);
    function map(callbackfn: (value: String; index: Float; array: array of String): Variant): array of Variant;
    function map(callbackfn: (value: String; index: Float; array: array of String): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: String; index: Float; array: array of String): Boolean): array of String;
    function filter(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): array of String;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JIResourceManager = class external
    allResourceMaps: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Resources.Core.ResourceMap>};
    defaultContext: JWindows.ApplicationModel.Resources.Core.ResourceContext;
    mainResourceMap: JWindows.ApplicationModel.Resources.Core.ResourceMap;
    procedure loadPriFiles(files: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageFile>});
    procedure unloadPriFiles(files: JWindows.Foundation.Collections.IIterable{<JWindows.Storage.IStorageFile>});
  end;

  JIResourceManagerStatics = class external
    current: JWindows.ApplicationModel.Resources.Core.ResourceManager;
    function isResourceReference(resourceReference: String): Boolean;
  end;

  JIResourceQualifier = class external
    isDefault: Boolean;
    isMatch: Boolean;
    qualifierName: String;
    qualifierValue: String;
    score: Float;
  end;

  JIResourceContext = class external
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    qualifierValues: JWindows.Foundation.Collections.IObservableMap{<StringString>};
    procedure reset;
    procedure reset(qualifierNames: JWindows.Foundation.Collections.IIterable{<String>});
    procedure overrideToMatch(result: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>});
    function clone: JWindows.ApplicationModel.Resources.Core.ResourceContext;
  end;

  JIResourceContextStatics = class external
    function createMatchingContext(result: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>}): JWindows.ApplicationModel.Resources.Core.ResourceContext;
  end;

  JIResourceCandidate = class external
    isDefault: Boolean;
    isMatch: Boolean;
    isMatchAsDefault: Boolean;
    qualifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceQualifier>};
    valueAsString: String;
    function getValueAsFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getQualifierValue(qualifierName: String): String;
  end;

  JINamedResource = class external
    candidates: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
    uri: JWindows.Foundation.Uri;
    function resolve: JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function resolve(resourceContext: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function resolveAll: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
    function resolveAll(resourceContext: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Core.ResourceCandidate>};
  end;

  JIResourceMap = class external(JWindows.Foundation.Collections.IMapView {String, JWindows.ApplicationModel.Resources.Core.NamedResource} , JWindows.Foundation.Collections.IIterable {JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.ApplicationModel.Resources.Core.NamedResource>}} )
    uri: JWindows.Foundation.Uri;
    function getValue(resource: String): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function getValue(resource: String; context: JWindows.ApplicationModel.Resources.Core.ResourceContext): JWindows.ApplicationModel.Resources.Core.ResourceCandidate;
    function getSubtree(reference: String): JWindows.ApplicationModel.Resources.Core.ResourceMap;
  end;

//Windows

//ApplicationModel

//Resources

//Management

type
  JIndexedResourceCandidate = class external 'IndexedResourceCandidate'
    metadata: JWindows.Foundation.Collections.IMapView{<StringString>};
    qualifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Management.IndexedResourceQualifier>};
    &type: JWindows.ApplicationModel.Resources.Management.IndexedResourceType;
    uri: JWindows.Foundation.Uri;
    valueAsString: String;
    function getQualifierValue(qualifierName: String): String;
  end;

  JResourceIndexer = class external 'ResourceIndexer'
    constructor Create(projectRoot: JWindows.Foundation.Uri);
    function indexFilePath(filePath: JWindows.Foundation.Uri): JWindows.ApplicationModel.Resources.Management.IndexedResourceCandidate;
    function indexFileContentsAsync(file: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Management.IndexedResourceCandidate>}>};
  end;

  JIndexedResourceQualifier = class external 'IndexedResourceQualifier'
    qualifierName: String;
    qualifierValue: String;
  end;

  JIResourceIndexer = class external
    function indexFilePath(filePath: JWindows.Foundation.Uri): JWindows.ApplicationModel.Resources.Management.IndexedResourceCandidate;
    function indexFileContentsAsync(file: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Management.IndexedResourceCandidate>}>};
  end;

  JIResourceIndexerFactory = class external
    function createResourceIndexer(projectRoot: JWindows.Foundation.Uri): JWindows.ApplicationModel.Resources.Management.ResourceIndexer;
  end;

  JIIndexedResourceQualifier = class external
    qualifierName: String;
    qualifierValue: String;
  end;

  JIIndexedResourceCandidate = class external
    metadata: JWindows.Foundation.Collections.IMapView{<StringString>};
    qualifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.ApplicationModel.Resources.Management.IndexedResourceQualifier>};
    &type: JWindows.ApplicationModel.Resources.Management.IndexedResourceType;
    uri: JWindows.Foundation.Uri;
    valueAsString: String;
    function getQualifierValue(qualifierName: String): String;
  end;

//Windows

//ApplicationModel

//Store

type
  JLicenseInformation = class external 'LicenseInformation'
    expirationDate: JDate;
    isActive: Boolean;
    isTrial: Boolean;
    productLicenses: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Store.ProductLicense>};
    onlicensechanged: Variant;
  end;

  JListingInformation = class external 'ListingInformation'
    ageRating: Float;
    currentMarket: String;
    description: String;
    formattedPrice: String;
    name: String;
    productListings: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Store.ProductListing>};
  end;

  JProductLicense = class external 'ProductLicense'
    expirationDate: JDate;
    isActive: Boolean;
    productId: String;
  end;

  JProductListing = class external 'ProductListing'
    formattedPrice: String;
    name: String;
    productId: String;
  end;

  JCurrentApp = class external 'CurrentApp'
    appId: String;
    licenseInformation: JWindows.ApplicationModel.Store.LicenseInformation;
    linkUri: JWindows.Foundation.Uri;
    function requestAppPurchaseAsync(includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function requestProductPurchaseAsync(productId: String; includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function loadListingInformationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Store.ListingInformation>};
    function getAppReceiptAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getProductReceiptAsync(productId: String): JWindows.Foundation.IAsyncOperation{<String>};
  end;

  JCurrentAppSimulator = class external 'CurrentAppSimulator'
    appId: String;
    licenseInformation: JWindows.ApplicationModel.Store.LicenseInformation;
    linkUri: JWindows.Foundation.Uri;
    function requestAppPurchaseAsync(includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function requestProductPurchaseAsync(productId: String; includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function loadListingInformationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Store.ListingInformation>};
    function getAppReceiptAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getProductReceiptAsync(productId: String): JWindows.Foundation.IAsyncOperation{<String>};
    function reloadSimulatorAsync(simulatorSettingsFile: JWindows.Storage.StorageFile): JWindows.Foundation.IAsyncAction;
  end;

  JLicenseChangedEventHandler = class external
  end;

  JICurrentApp = class external
    appId: String;
    licenseInformation: JWindows.ApplicationModel.Store.LicenseInformation;
    linkUri: JWindows.Foundation.Uri;
    function requestAppPurchaseAsync(includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function requestProductPurchaseAsync(productId: String; includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function loadListingInformationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Store.ListingInformation>};
    function getAppReceiptAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getProductReceiptAsync(productId: String): JWindows.Foundation.IAsyncOperation{<String>};
  end;

  JICurrentAppSimulator = class external
    appId: String;
    licenseInformation: JWindows.ApplicationModel.Store.LicenseInformation;
    linkUri: JWindows.Foundation.Uri;
    function requestAppPurchaseAsync(includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function requestProductPurchaseAsync(productId: String; includeReceipt: Boolean): JWindows.Foundation.IAsyncOperation{<String>};
    function loadListingInformationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.ApplicationModel.Store.ListingInformation>};
    function getAppReceiptAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getProductReceiptAsync(productId: String): JWindows.Foundation.IAsyncOperation{<String>};
    function reloadSimulatorAsync(simulatorSettingsFile: JWindows.Storage.StorageFile): JWindows.Foundation.IAsyncAction;
  end;

  JILicenseInformation = class external
    expirationDate: JDate;
    isActive: Boolean;
    isTrial: Boolean;
    productLicenses: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Store.ProductLicense>};
    onlicensechanged: Variant;
  end;

  JIProductLicense = class external
    expirationDate: JDate;
    isActive: Boolean;
    productId: String;
  end;

  JIListingInformation = class external
    ageRating: Float;
    currentMarket: String;
    description: String;
    formattedPrice: String;
    name: String;
    productListings: JWindows.Foundation.Collections.IMapView{<StringJWindows.ApplicationModel.Store.ProductListing>};
  end;

  JIProductListing = class external
    formattedPrice: String;
    name: String;
    productId: String;
  end;

//Windows

//Data

//Html

type
  JHtmlUtilities = class external 'HtmlUtilities'
    function convertToText(html: String): String;
  end;

  JIHtmlUtilities = class external
    function convertToText(html: String): String;
  end;

//Windows

//Data

//Json

type
  JJsonArray = class external 'JsonArray'
    valueType: JWindows.Data.Json.JsonValueType;
    size: Float;
    function getObjectAt(index: Float): JWindows.Data.Json.JsonObject;
    function getArrayAt(index: Float): JWindows.Data.Json.JsonArray;
    function getStringAt(index: Float): String;
    function getNumberAt(index: Float): Float;
    function getBooleanAt(index: Float): Boolean;
    function stringify: String;
    function getString: String;
    function getNumber: Float;
    function getBoolean: Boolean;
    function getArray: JWindows.Data.Json.JsonArray;
    function getObject: JWindows.Data.Json.JsonObject;
    function getAt(index: Float): JWindows.Data.Json.IJsonValue;
    function getView: JWindows.Foundation.Collections.IVectorView{<JWindows.Data.Json.IJsonValue>};
    function indexOf(value: JWindows.Data.Json.IJsonValue):       index: Float;
      returnValue: Boolean;
    end;;
    procedure setAt(index: Float; value: JWindows.Data.Json.IJsonValue);
    procedure insertAt(index: Float; value: JWindows.Data.Json.IJsonValue);
    procedure removeAt(index: Float);
    procedure append(value: JWindows.Data.Json.IJsonValue);
    procedure removeAtEnd;
    procedure clear;
    function getMany(startIndex: Float):       items: array of JWindows.Data.Json.IJsonValue;
      returnValue: Float;
    end;;
    procedure replaceAll(items: array of JWindows.Data.Json.IJsonValue);
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Data.Json.IJsonValue>};
    function parse(input: String): JWindows.Data.Json.JsonArray;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonArray;
      succeeded: Boolean;
    end;;
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Data.Json.IJsonValue): array of JWindows.Data.Json.IJsonValue;
    function join(seperator: String): String;
    function pop: JWindows.Data.Json.IJsonValue;
    procedure push(items: array of JWindows.Data.Json.IJsonValue);
    function reverse: array of JWindows.Data.Json.IJsonValue;
    function shift: JWindows.Data.Json.IJsonValue;
    function slice(start: Float): array of JWindows.Data.Json.IJsonValue;
    function slice(start: Float; &end: Float): array of JWindows.Data.Json.IJsonValue;
    function sort: array of JWindows.Data.Json.IJsonValue;
    function sort(compareFn: (a: JWindows.Data.Json.IJsonValue; b: JWindows.Data.Json.IJsonValue): Float): array of JWindows.Data.Json.IJsonValue;
    function splice(start: Float): array of JWindows.Data.Json.IJsonValue;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Data.Json.IJsonValue): array of JWindows.Data.Json.IJsonValue;
    function unshift(items: array of JWindows.Data.Json.IJsonValue): Float;
    function lastIndexOf(searchElement: JWindows.Data.Json.IJsonValue): Float;
    function lastIndexOf(searchElement: JWindows.Data.Json.IJsonValue; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue));
    procedure forEach(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean): array of JWindows.Data.Json.IJsonValue;
    function filter(callbackfn: (value: JWindows.Data.Json.IJsonValue; index: Float; array: array of JWindows.Data.Json.IJsonValue): Boolean; thisArg: Variant): array of JWindows.Data.Json.IJsonValue;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Json.IJsonValue): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Json.IJsonValue): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Json.IJsonValue): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Json.IJsonValue): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JJsonObject = class external 'JsonObject'
    valueType: JWindows.Data.Json.JsonValueType;
    size: Float;
    function getNamedValue(name: String): JWindows.Data.Json.JsonValue;
    procedure setNamedValue(name: String; value: JWindows.Data.Json.IJsonValue);
    function getNamedObject(name: String): JWindows.Data.Json.JsonObject;
    function getNamedArray(name: String): JWindows.Data.Json.JsonArray;
    function getNamedString(name: String): String;
    function getNamedNumber(name: String): Float;
    function getNamedBoolean(name: String): Boolean;
    function stringify: String;
    function getString: String;
    function getNumber: Float;
    function getBoolean: Boolean;
    function getArray: JWindows.Data.Json.JsonArray;
    function getObject: JWindows.Data.Json.JsonObject;
    function lookup(key: String): JWindows.Data.Json.IJsonValue;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringJWindows.Data.Json.IJsonValue>};
    function insert(key: String; value: JWindows.Data.Json.IJsonValue): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Data.Json.IJsonValue>}>};
    function parse(input: String): JWindows.Data.Json.JsonObject;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonObject;
      succeeded: Boolean;
    end;;
  end;

  JJsonValue = class external 'JsonValue'
    valueType: JWindows.Data.Json.JsonValueType;
    function stringify: String;
    function getString: String;
    function getNumber: Float;
    function getBoolean: Boolean;
    function getArray: JWindows.Data.Json.JsonArray;
    function getObject: JWindows.Data.Json.JsonObject;
    function parse(input: String): JWindows.Data.Json.JsonValue;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonValue;
      succeeded: Boolean;
    end;;
    function createBooleanValue(input: Boolean): JWindows.Data.Json.JsonValue;
    function createNumberValue(input: Float): JWindows.Data.Json.JsonValue;
    function createStringValue(input: String): JWindows.Data.Json.JsonValue;
  end;

  JJsonError = class external 'JsonError'
    function getStatus(hresult: Float): JWindows.Data.Json.JsonErrorStatus;
  end;

  JIJsonValue = class external
    valueType: JWindows.Data.Json.JsonValueType;
    function stringify: String;
    function getString: String;
    function getNumber: Float;
    function getBoolean: Boolean;
    function getArray: JWindows.Data.Json.JsonArray;
    function getObject: JWindows.Data.Json.JsonObject;
  end;

  JIJsonValueStatics = class external
    function parse(input: String): JWindows.Data.Json.JsonValue;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonValue;
      succeeded: Boolean;
    end;;
    function createBooleanValue(input: Boolean): JWindows.Data.Json.JsonValue;
    function createNumberValue(input: Float): JWindows.Data.Json.JsonValue;
    function createStringValue(input: String): JWindows.Data.Json.JsonValue;
  end;

  JIJsonObject = class external(JWindows.Data.Json.IJsonValue)
    function getNamedValue(name: String): JWindows.Data.Json.JsonValue;
    procedure setNamedValue(name: String; value: JWindows.Data.Json.IJsonValue);
    function getNamedObject(name: String): JWindows.Data.Json.JsonObject;
    function getNamedArray(name: String): JWindows.Data.Json.JsonArray;
    function getNamedString(name: String): String;
    function getNamedNumber(name: String): Float;
    function getNamedBoolean(name: String): Boolean;
  end;

  JIJsonObjectStatics = class external
    function parse(input: String): JWindows.Data.Json.JsonObject;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonObject;
      succeeded: Boolean;
    end;;
  end;

  JIJsonArray = class external(JWindows.Data.Json.IJsonValue)
    function getObjectAt(index: Float): JWindows.Data.Json.JsonObject;
    function getArrayAt(index: Float): JWindows.Data.Json.JsonArray;
    function getStringAt(index: Float): String;
    function getNumberAt(index: Float): Float;
    function getBooleanAt(index: Float): Boolean;
  end;

  JIJsonArrayStatics = class external
    function parse(input: String): JWindows.Data.Json.JsonArray;
    function tryParse(input: String):       result: JWindows.Data.Json.JsonArray;
      succeeded: Boolean;
    end;;
  end;

  JIJsonErrorStatics = class external
    function getStatus(hresult: Float): JWindows.Data.Json.JsonErrorStatus;
  end;

//Windows

//Data

//Xml

//Dom

type
  JXmlNodeList = class external 'XmlNodeList'
    _length: Float;
    size: Float;
    function item(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
    function getAt(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
    function indexOf(value: JWindows.Data.Xml.Dom.IXmlNode):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Data.Xml.Dom.IXmlNode;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Data.Xml.Dom.IXmlNode>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Data.Xml.Dom.IXmlNode): array of JWindows.Data.Xml.Dom.IXmlNode;
    function join(seperator: String): String;
    function pop: JWindows.Data.Xml.Dom.IXmlNode;
    procedure push(items: array of JWindows.Data.Xml.Dom.IXmlNode);
    function reverse: array of JWindows.Data.Xml.Dom.IXmlNode;
    function shift: JWindows.Data.Xml.Dom.IXmlNode;
    function slice(start: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function slice(start: Float; &end: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function sort: array of JWindows.Data.Xml.Dom.IXmlNode;
    function sort(compareFn: (a: JWindows.Data.Xml.Dom.IXmlNode; b: JWindows.Data.Xml.Dom.IXmlNode): Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function splice(start: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Data.Xml.Dom.IXmlNode): array of JWindows.Data.Xml.Dom.IXmlNode;
    function unshift(items: array of JWindows.Data.Xml.Dom.IXmlNode): Float;
    function lastIndexOf(searchElement: JWindows.Data.Xml.Dom.IXmlNode): Float;
    function lastIndexOf(searchElement: JWindows.Data.Xml.Dom.IXmlNode; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode));
    procedure forEach(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): array of JWindows.Data.Xml.Dom.IXmlNode;
    function filter(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): array of JWindows.Data.Xml.Dom.IXmlNode;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; initialValue: Variant): Variant;
  end;

  JXmlNamedNodeMap = class external 'XmlNamedNodeMap'
    _length: Float;
    size: Float;
    function item(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
    function getNamedItem(name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function setNamedItem(node: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeNamedItem(name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function getNamedItemNS(namespaceUri: Variant; name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function removeNamedItemNS(namespaceUri: Variant; name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function setNamedItemNS(node: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function getAt(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
    function indexOf(value: JWindows.Data.Xml.Dom.IXmlNode):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Data.Xml.Dom.IXmlNode;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Data.Xml.Dom.IXmlNode>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Data.Xml.Dom.IXmlNode): array of JWindows.Data.Xml.Dom.IXmlNode;
    function join(seperator: String): String;
    function pop: JWindows.Data.Xml.Dom.IXmlNode;
    procedure push(items: array of JWindows.Data.Xml.Dom.IXmlNode);
    function reverse: array of JWindows.Data.Xml.Dom.IXmlNode;
    function shift: JWindows.Data.Xml.Dom.IXmlNode;
    function slice(start: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function slice(start: Float; &end: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function sort: array of JWindows.Data.Xml.Dom.IXmlNode;
    function sort(compareFn: (a: JWindows.Data.Xml.Dom.IXmlNode; b: JWindows.Data.Xml.Dom.IXmlNode): Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function splice(start: Float): array of JWindows.Data.Xml.Dom.IXmlNode;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Data.Xml.Dom.IXmlNode): array of JWindows.Data.Xml.Dom.IXmlNode;
    function unshift(items: array of JWindows.Data.Xml.Dom.IXmlNode): Float;
    function lastIndexOf(searchElement: JWindows.Data.Xml.Dom.IXmlNode): Float;
    function lastIndexOf(searchElement: JWindows.Data.Xml.Dom.IXmlNode; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode));
    procedure forEach(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean): array of JWindows.Data.Xml.Dom.IXmlNode;
    function filter(callbackfn: (value: JWindows.Data.Xml.Dom.IXmlNode; index: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Boolean; thisArg: Variant): array of JWindows.Data.Xml.Dom.IXmlNode;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Data.Xml.Dom.IXmlNode): Variant; initialValue: Variant): Variant;
  end;

  JXmlDocument = class external 'XmlDocument'
    doctype: JWindows.Data.Xml.Dom.XmlDocumentType;
    documentElement: JWindows.Data.Xml.Dom.XmlElement;
    documentUri: String;
    implementation: JWindows.Data.Xml.Dom.XmlDomImplementation;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function createElement(tagName: String): JWindows.Data.Xml.Dom.XmlElement;
    function createDocumentFragment: JWindows.Data.Xml.Dom.XmlDocumentFragment;
    function createTextNode(data: String): JWindows.Data.Xml.Dom.XmlText;
    function createComment(data: String): JWindows.Data.Xml.Dom.XmlComment;
    function createProcessingInstruction(target: String; data: String): JWindows.Data.Xml.Dom.XmlProcessingInstruction;
    function createAttribute(name: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function createEntityReference(name: String): JWindows.Data.Xml.Dom.XmlEntityReference;
    function getElementsByTagName(tagName: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function createCDataSection(data: String): JWindows.Data.Xml.Dom.XmlCDataSection;
    function createAttributeNS(namespaceUri: Variant; qualifiedName: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function createElementNS(namespaceUri: Variant; qualifiedName: String): JWindows.Data.Xml.Dom.XmlElement;
    function getElementById(elementId: String): JWindows.Data.Xml.Dom.XmlElement;
    function importNode(node: JWindows.Data.Xml.Dom.IXmlNode; deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
    procedure loadXml(xml: String);
    procedure loadXml(xml: String; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings);
    function saveToFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function loadFromUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromUriAsync(uri: JWindows.Foundation.Uri; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromFileAsync(file: JWindows.Storage.IStorageFile; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
  end;

  JXmlAttribute = class external 'XmlAttribute'
    name: String;
    specified: Boolean;
    value: String;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlDocumentType = class external 'XmlDocumentType'
    entities: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    name: String;
    notations: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlDomImplementation = class external 'XmlDomImplementation'
    function hasFeature(feature: String; version: Variant): Boolean;
  end;

  JXmlElement = class external 'XmlElement'
    tagName: String;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function getAttribute(attributeName: String): String;
    procedure setAttribute(attributeName: String; attributeValue: String);
    procedure removeAttribute(attributeName: String);
    function getAttributeNode(attributeName: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function setAttributeNode(newAttribute: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function removeAttributeNode(attributeNode: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function getElementsByTagName(tagName: String): JWindows.Data.Xml.Dom.XmlNodeList;
    procedure setAttributeNS(namespaceUri: Variant; qualifiedName: String; value: String);
    function getAttributeNS(namespaceUri: Variant; localName: String): String;
    procedure removeAttributeNS(namespaceUri: Variant; localName: String);
    function setAttributeNodeNS(newAttribute: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function getAttributeNodeNS(namespaceUri: Variant; localName: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlDocumentFragment = class external 'XmlDocumentFragment'
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlText = class external 'XmlText'
    data: String;
    _length: Float;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function splitText(offset: Float): JWindows.Data.Xml.Dom.IXmlText;
    function substringData(offset: Float; count: Float): String;
    procedure appendData(data: String);
    procedure insertData(offset: Float; data: String);
    procedure deleteData(offset: Float; count: Float);
    procedure replaceData(offset: Float; count: Float; data: String);
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlComment = class external 'XmlComment'
    data: String;
    _length: Float;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function substringData(offset: Float; count: Float): String;
    procedure appendData(data: String);
    procedure insertData(offset: Float; data: String);
    procedure deleteData(offset: Float; count: Float);
    procedure replaceData(offset: Float; count: Float; data: String);
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlProcessingInstruction = class external 'XmlProcessingInstruction'
    data: String;
    target: String;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlEntityReference = class external 'XmlEntityReference'
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlCDataSection = class external 'XmlCDataSection'
    data: String;
    _length: Float;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function splitText(offset: Float): JWindows.Data.Xml.Dom.IXmlText;
    function substringData(offset: Float; count: Float): String;
    procedure appendData(data: String);
    procedure insertData(offset: Float; data: String);
    procedure deleteData(offset: Float; count: Float);
    procedure replaceData(offset: Float; count: Float; data: String);
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JXmlLoadSettings = class external 'XmlLoadSettings'
    elementContentWhiteSpace: Boolean;
    maxElementDepth: Float;
    prohibitDtd: Boolean;
    resolveExternals: Boolean;
    validateOnParse: Boolean;
  end;

  JDtdNotation = class external 'DtdNotation'
    publicId: Variant;
    systemId: Variant;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JDtdEntity = class external 'DtdEntity'
    notationName: Variant;
    publicId: Variant;
    systemId: Variant;
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    innerText: String;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
    function getXml: String;
  end;

  JIXmlNodeSelector = class external
    function selectSingleNode(xpath: String): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodes(xpath: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function selectSingleNodeNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.IXmlNode;
    function selectNodesNS(xpath: String; namespaces: Variant): JWindows.Data.Xml.Dom.XmlNodeList;
  end;

  JIXmlNodeSerializer = class external
    innerText: String;
    function getXml: String;
  end;

  JIXmlNode = class external(JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    attributes: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    childNodes: JWindows.Data.Xml.Dom.XmlNodeList;
    firstChild: JWindows.Data.Xml.Dom.IXmlNode;
    lastChild: JWindows.Data.Xml.Dom.IXmlNode;
    localName: Variant;
    namespaceUri: Variant;
    nextSibling: JWindows.Data.Xml.Dom.IXmlNode;
    nodeName: String;
    nodeType: JWindows.Data.Xml.Dom.NodeType;
    nodeValue: Variant;
    ownerDocument: JWindows.Data.Xml.Dom.XmlDocument;
    parentNode: JWindows.Data.Xml.Dom.IXmlNode;
    prefix: Variant;
    previousSibling: JWindows.Data.Xml.Dom.IXmlNode;
    function hasChildNodes: Boolean;
    function insertBefore(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function replaceChild(newChild: JWindows.Data.Xml.Dom.IXmlNode; referenceChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeChild(childNode: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function appendChild(newChild: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function cloneNode(deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
    procedure normalize;
  end;

  JIXmlDomImplementation = class external
    function hasFeature(feature: String; version: Variant): Boolean;
  end;

  JIXmlDocumentType = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    entities: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
    name: String;
    notations: JWindows.Data.Xml.Dom.XmlNamedNodeMap;
  end;

  JIXmlAttribute = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    name: String;
    specified: Boolean;
    value: String;
  end;

  JIXmlDocumentFragment = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
  end;

  JIXmlElement = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    tagName: String;
    function getAttribute(attributeName: String): String;
    procedure setAttribute(attributeName: String; attributeValue: String);
    procedure removeAttribute(attributeName: String);
    function getAttributeNode(attributeName: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function setAttributeNode(newAttribute: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function removeAttributeNode(attributeNode: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function getElementsByTagName(tagName: String): JWindows.Data.Xml.Dom.XmlNodeList;
    procedure setAttributeNS(namespaceUri: Variant; qualifiedName: String; value: String);
    function getAttributeNS(namespaceUri: Variant; localName: String): String;
    procedure removeAttributeNS(namespaceUri: Variant; localName: String);
    function setAttributeNodeNS(newAttribute: JWindows.Data.Xml.Dom.XmlAttribute): JWindows.Data.Xml.Dom.XmlAttribute;
    function getAttributeNodeNS(namespaceUri: Variant; localName: String): JWindows.Data.Xml.Dom.XmlAttribute;
  end;

  JIDtdNotation = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    publicId: Variant;
    systemId: Variant;
  end;

  JIDtdEntity = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    notationName: Variant;
    publicId: Variant;
    systemId: Variant;
  end;

  JIXmlEntityReference = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
  end;

  JIXmlProcessingInstruction = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    data: String;
    target: String;
  end;

  JIXmlCharacterData = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    data: String;
    _length: Float;
    function substringData(offset: Float; count: Float): String;
    procedure appendData(data: String);
    procedure insertData(offset: Float; data: String);
    procedure deleteData(offset: Float; count: Float);
    procedure replaceData(offset: Float; count: Float; data: String);
  end;

  JIXmlComment = class external(JWindows.Data.Xml.Dom.IXmlCharacterData, JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
  end;

  JIXmlText = class external(JWindows.Data.Xml.Dom.IXmlCharacterData, JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    function splitText(offset: Float): JWindows.Data.Xml.Dom.IXmlText;
  end;

  JIXmlCDataSection = class external(JWindows.Data.Xml.Dom.IXmlText, JWindows.Data.Xml.Dom.IXmlCharacterData, JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
  end;

  JIXmlDocument = class external(JWindows.Data.Xml.Dom.IXmlNode, JWindows.Data.Xml.Dom.IXmlNodeSelector, JWindows.Data.Xml.Dom.IXmlNodeSerializer)
    doctype: JWindows.Data.Xml.Dom.XmlDocumentType;
    documentElement: JWindows.Data.Xml.Dom.XmlElement;
    documentUri: String;
    implementation: JWindows.Data.Xml.Dom.XmlDomImplementation;
    function createElement(tagName: String): JWindows.Data.Xml.Dom.XmlElement;
    function createDocumentFragment: JWindows.Data.Xml.Dom.XmlDocumentFragment;
    function createTextNode(data: String): JWindows.Data.Xml.Dom.XmlText;
    function createComment(data: String): JWindows.Data.Xml.Dom.XmlComment;
    function createProcessingInstruction(target: String; data: String): JWindows.Data.Xml.Dom.XmlProcessingInstruction;
    function createAttribute(name: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function createEntityReference(name: String): JWindows.Data.Xml.Dom.XmlEntityReference;
    function getElementsByTagName(tagName: String): JWindows.Data.Xml.Dom.XmlNodeList;
    function createCDataSection(data: String): JWindows.Data.Xml.Dom.XmlCDataSection;
    function createAttributeNS(namespaceUri: Variant; qualifiedName: String): JWindows.Data.Xml.Dom.XmlAttribute;
    function createElementNS(namespaceUri: Variant; qualifiedName: String): JWindows.Data.Xml.Dom.XmlElement;
    function getElementById(elementId: String): JWindows.Data.Xml.Dom.XmlElement;
    function importNode(node: JWindows.Data.Xml.Dom.IXmlNode; deep: Boolean): JWindows.Data.Xml.Dom.IXmlNode;
  end;

  JIXmlNamedNodeMap = class external(JWindows.Foundation.Collections.IVectorView {JWindows.Data.Xml.Dom.IXmlNode} , JWindows.Foundation.Collections.IIterable {JWindows.Data.Xml.Dom.IXmlNode} )
    _length: Float;
    function item(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
    function getNamedItem(name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function setNamedItem(node: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
    function removeNamedItem(name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function getNamedItemNS(namespaceUri: Variant; name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function removeNamedItemNS(namespaceUri: Variant; name: String): JWindows.Data.Xml.Dom.IXmlNode;
    function setNamedItemNS(node: JWindows.Data.Xml.Dom.IXmlNode): JWindows.Data.Xml.Dom.IXmlNode;
  end;

  JIXmlNodeList = class external(JWindows.Foundation.Collections.IVectorView {JWindows.Data.Xml.Dom.IXmlNode} , JWindows.Foundation.Collections.IIterable {JWindows.Data.Xml.Dom.IXmlNode} )
    _length: Float;
    function item(index: Float): JWindows.Data.Xml.Dom.IXmlNode;
  end;

  JIXmlLoadSettings = class external
    elementContentWhiteSpace: Boolean;
    maxElementDepth: Float;
    prohibitDtd: Boolean;
    resolveExternals: Boolean;
    validateOnParse: Boolean;
  end;

  JIXmlDocumentIO = class external
    procedure loadXml(xml: String);
    procedure loadXml(xml: String; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings);
    function saveToFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
  end;

  JIXmlDocumentStatics = class external
    function loadFromUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromUriAsync(uri: JWindows.Foundation.Uri; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
    function loadFromFileAsync(file: JWindows.Storage.IStorageFile; loadSettings: JWindows.Data.Xml.Dom.XmlLoadSettings): JWindows.Foundation.IAsyncOperation{<JWindows.Data.Xml.Dom.XmlDocument>};
  end;

//Windows

//Data

//Xml

//Xsl

type
  JXsltProcessor = class external 'XsltProcessor'
    constructor Create(document: JWindows.Data.Xml.Dom.XmlDocument);
    function transformToString(inputNode: JWindows.Data.Xml.Dom.IXmlNode): String;
  end;

  JIXsltProcessor = class external
    function transformToString(inputNode: JWindows.Data.Xml.Dom.IXmlNode): String;
  end;

  JIXsltProcessorFactory = class external
    function createInstance(document: JWindows.Data.Xml.Dom.XmlDocument): JWindows.Data.Xml.Xsl.XsltProcessor;
  end;

//Windows

//Devices

//Sms

type
  JSmsBinaryMessage = class external 'SmsBinaryMessage'
    format: JWindows.Devices.Sms.SmsDataFormat;
    id: Float;
    messageClass: JWindows.Devices.Sms.SmsMessageClass;
    function getData: JUint8Array;
    procedure setData(value: JUint8Array);
  end;

  JSmsTextMessage = class external 'SmsTextMessage'
    body: String;
    encoding: JWindows.Devices.Sms.SmsEncoding;
    from: String;
    partCount: Float;
    partNumber: Float;
    partReferenceId: Float;
    timestamp: JDate;
    to: String;
    id: Float;
    messageClass: JWindows.Devices.Sms.SmsMessageClass;
    function toBinaryMessages(format: JWindows.Devices.Sms.SmsDataFormat): JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsBinaryMessage>};
    function fromBinaryMessage(binaryMessage: JWindows.Devices.Sms.SmsBinaryMessage): JWindows.Devices.Sms.SmsTextMessage;
    function fromBinaryData(format: JWindows.Devices.Sms.SmsDataFormat; value: JUint8Array): JWindows.Devices.Sms.SmsTextMessage;
  end;

  JDeleteSmsMessageOperation = class external 'DeleteSmsMessageOperation'
    completed: JWindows.Foundation.AsyncActionCompletedHandler;
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    procedure getResults;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: Variant): Variant); overload;
    procedure done(success: (value: Variant): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: Variant): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Variant>};
      function getResults: Variant;
    end;;
  end;

  JDeleteSmsMessagesOperation = class external 'DeleteSmsMessagesOperation'
    completed: JWindows.Foundation.AsyncActionCompletedHandler;
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    procedure getResults;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Variant): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: Variant): Variant); overload;
    procedure done(success: (value: Variant): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: Variant): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Variant>};
      function getResults: Variant;
    end;;
  end;

  JGetSmsMessageOperation = class external 'GetSmsMessageOperation'
    completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Devices.Sms.ISmsMessage>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: JWindows.Devices.Sms.ISmsMessage;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.ISmsMessage): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: JWindows.Devices.Sms.ISmsMessage): Variant); overload;
    procedure done(success: (value: JWindows.Devices.Sms.ISmsMessage): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: JWindows.Devices.Sms.ISmsMessage): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Devices.Sms.ISmsMessage>};
      function getResults: JWindows.Devices.Sms.ISmsMessage;
    end;;
  end;

  JGetSmsMessagesOperation = class external 'GetSmsMessagesOperation'
    completed: JWindows.Foundation.AsyncOperationWithProgressCompletedHandler{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}Float>};
    progress: JWindows.Foundation.AsyncOperationProgressHandler{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}Float>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>};
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): Variant); overload;
    procedure done(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       progress: JWindows.Foundation.AsyncOperationProgressHandler{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}Float>};
      completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}>};
      function getResults: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>};
    end;;
  end;

  JSmsDeviceMessageStore = class external 'SmsDeviceMessageStore'
    maxMessages: Float;
    function deleteMessageAsync(messageId: Float): JWindows.Foundation.IAsyncAction;
    function deleteMessagesAsync(messageFilter: JWindows.Devices.Sms.SmsMessageFilter): JWindows.Foundation.IAsyncAction;
    function getMessageAsync(messageId: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.ISmsMessage>};
    function getMessagesAsync(messageFilter: JWindows.Devices.Sms.SmsMessageFilter): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}Float>};
  end;

  JSendSmsMessageOperation = class external 'SendSmsMessageOperation'
    completed: JWindows.Foundation.AsyncActionCompletedHandler;
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    procedure getResults;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: : Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Variant>};
      function getResults: Variant;
    end;;
  end;

  JSmsMessageReceivedEventArgs = class external 'SmsMessageReceivedEventArgs'
    binaryMessage: JWindows.Devices.Sms.SmsBinaryMessage;
    textMessage: JWindows.Devices.Sms.SmsTextMessage;
  end;

  JSmsDevice = class external 'SmsDevice'
    accountPhoneNumber: String;
    cellularClass: JWindows.Devices.Sms.CellularClass;
    deviceStatus: JWindows.Devices.Sms.SmsDeviceStatus;
    messageStore: JWindows.Devices.Sms.SmsDeviceMessageStore;
    function sendMessageAsync(message: JWindows.Devices.Sms.ISmsMessage): JWindows.Devices.Sms.SendSmsMessageOperation;
    function calculateLength(message: JWindows.Devices.Sms.SmsTextMessage): JWindows.Devices.Sms.SmsEncodedLength;
    onsmsmessagereceived: Variant;
    onsmsdevicestatuschanged: Variant;
    function getDeviceSelector: String;
    function fromIdAsync(deviceInstanceId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.SmsDevice>};
    function getDefaultAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.SmsDevice>};
  end;

  JGetSmsDeviceOperation = class external 'GetSmsDeviceOperation'
    completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Devices.Sms.SmsDevice>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: JWindows.Devices.Sms.SmsDevice;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Devices.Sms.SmsDevice): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: JWindows.Devices.Sms.SmsDevice): Variant); overload;
    procedure done(success: (value: JWindows.Devices.Sms.SmsDevice): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: JWindows.Devices.Sms.SmsDevice): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Devices.Sms.SmsDevice>};
      function getResults: JWindows.Devices.Sms.SmsDevice;
    end;;
  end;

  JSmsReceivedEventDetails = class external 'SmsReceivedEventDetails'
    deviceId: String;
    messageIndex: Float;
  end;

  JISmsMessage = class external
    id: Float;
    messageClass: JWindows.Devices.Sms.SmsMessageClass;
  end;

  JISmsBinaryMessage = class external(JWindows.Devices.Sms.ISmsMessage)
    format: JWindows.Devices.Sms.SmsDataFormat;
    function getData: JUint8Array;
    procedure setData(value: JUint8Array);
  end;

  JISmsTextMessage = class external(JWindows.Devices.Sms.ISmsMessage)
    body: String;
    encoding: JWindows.Devices.Sms.SmsEncoding;
    from: String;
    partCount: Float;
    partNumber: Float;
    partReferenceId: Float;
    timestamp: JDate;
    to: String;
    function toBinaryMessages(format: JWindows.Devices.Sms.SmsDataFormat): JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsBinaryMessage>};
  end;

  JISmsTextMessageStatics = class external
    function fromBinaryMessage(binaryMessage: JWindows.Devices.Sms.SmsBinaryMessage): JWindows.Devices.Sms.SmsTextMessage;
    function fromBinaryData(format: JWindows.Devices.Sms.SmsDataFormat; value: JUint8Array): JWindows.Devices.Sms.SmsTextMessage;
  end;

  JISmsDeviceMessageStore = class external
    maxMessages: Float;
    function deleteMessageAsync(messageId: Float): JWindows.Foundation.IAsyncAction;
    function deleteMessagesAsync(messageFilter: JWindows.Devices.Sms.SmsMessageFilter): JWindows.Foundation.IAsyncAction;
    function getMessageAsync(messageId: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.ISmsMessage>};
    function getMessagesAsync(messageFilter: JWindows.Devices.Sms.SmsMessageFilter): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Sms.ISmsMessage>}Float>};
  end;

  JSmsEncodedLength = class external
    segmentCount: Float;
    characterCountLastSegment: Float;
    charactersPerSegment: Float;
    byteCountLastSegment: Float;
    bytesPerSegment: Float;
  end;

  JISmsMessageReceivedEventArgs = class external
    binaryMessage: JWindows.Devices.Sms.SmsBinaryMessage;
    textMessage: JWindows.Devices.Sms.SmsTextMessage;
  end;

  JSmsMessageReceivedEventHandler = class external
(sender: JWindows.Devices.Sms.SmsDevice; e: JWindows.Devices.Sms.SmsMessageReceivedEventArgs)  end;

  JSmsDeviceStatusChangedEventHandler = class external
(sender: JWindows.Devices.Sms.SmsDevice)  end;

  JISmsDeviceStatics = class external
    function getDeviceSelector: String;
    function fromIdAsync(deviceInstanceId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.SmsDevice>};
    function getDefaultAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Sms.SmsDevice>};
  end;

  JISmsDevice = class external
    accountPhoneNumber: String;
    cellularClass: JWindows.Devices.Sms.CellularClass;
    deviceStatus: JWindows.Devices.Sms.SmsDeviceStatus;
    messageStore: JWindows.Devices.Sms.SmsDeviceMessageStore;
    function sendMessageAsync(message: JWindows.Devices.Sms.ISmsMessage): JWindows.Devices.Sms.SendSmsMessageOperation;
    function calculateLength(message: JWindows.Devices.Sms.SmsTextMessage): JWindows.Devices.Sms.SmsEncodedLength;
    onsmsmessagereceived: Variant;
    onsmsdevicestatuschanged: Variant;
  end;

  JISmsReceivedEventDetails = class external
    deviceId: String;
    messageIndex: Float;
  end;

//Windows

//Devices

//Enumeration

type
  JDeviceThumbnail = class external 'DeviceThumbnail'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    contentType: String;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JEnclosureLocation = class external 'EnclosureLocation'
    inDock: Boolean;
    inLid: Boolean;
    panel: JWindows.Devices.Enumeration.Panel;
  end;

  JDeviceInformationUpdate = class external 'DeviceInformationUpdate'
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
  end;

  JDeviceInformationCollection = class external 'DeviceInformationCollection'
    size: Float;
    function getAt(index: Float): JWindows.Devices.Enumeration.DeviceInformation;
    function indexOf(value: JWindows.Devices.Enumeration.DeviceInformation):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Devices.Enumeration.DeviceInformation;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Devices.Enumeration.DeviceInformation>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Devices.Enumeration.DeviceInformation): array of JWindows.Devices.Enumeration.DeviceInformation;
    function join(seperator: String): String;
    function pop: JWindows.Devices.Enumeration.DeviceInformation;
    procedure push(items: array of JWindows.Devices.Enumeration.DeviceInformation);
    function reverse: array of JWindows.Devices.Enumeration.DeviceInformation;
    function shift: JWindows.Devices.Enumeration.DeviceInformation;
    function slice(start: Float): array of JWindows.Devices.Enumeration.DeviceInformation;
    function slice(start: Float; &end: Float): array of JWindows.Devices.Enumeration.DeviceInformation;
    function sort: array of JWindows.Devices.Enumeration.DeviceInformation;
    function sort(compareFn: (a: JWindows.Devices.Enumeration.DeviceInformation; b: JWindows.Devices.Enumeration.DeviceInformation): Float): array of JWindows.Devices.Enumeration.DeviceInformation;
    function splice(start: Float): array of JWindows.Devices.Enumeration.DeviceInformation;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Devices.Enumeration.DeviceInformation): array of JWindows.Devices.Enumeration.DeviceInformation;
    function unshift(items: array of JWindows.Devices.Enumeration.DeviceInformation): Float;
    function lastIndexOf(searchElement: JWindows.Devices.Enumeration.DeviceInformation): Float;
    function lastIndexOf(searchElement: JWindows.Devices.Enumeration.DeviceInformation; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation));
    procedure forEach(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean): array of JWindows.Devices.Enumeration.DeviceInformation;
    function filter(callbackfn: (value: JWindows.Devices.Enumeration.DeviceInformation; index: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Boolean; thisArg: Variant): array of JWindows.Devices.Enumeration.DeviceInformation;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.DeviceInformation): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JDeviceWatcher = class external 'DeviceWatcher'
    status: JWindows.Devices.Enumeration.DeviceWatcherStatus;
    onadded: Variant;
    onupdated: Variant;
    onremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JDeviceInformation = class external 'DeviceInformation'
    enclosureLocation: JWindows.Devices.Enumeration.EnclosureLocation;
    id: String;
    isDefault: Boolean;
    isEnabled: Boolean;
    name: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    procedure update(updateInfo: JWindows.Devices.Enumeration.DeviceInformationUpdate);
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceThumbnail>};
    function getGlyphThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceThumbnail>};
    function createFromIdAsync(id: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformation>};
    function createFromIdAsync(id: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformation>};
    function findAllAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(deviceClass: JWindows.Devices.Enumeration.DeviceClass): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(aqsFilter: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(aqsFilter: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function createWatcher: JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(deviceClass: JWindows.Devices.Enumeration.DeviceClass): JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(aqsFilter: String): JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(aqsFilter: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Devices.Enumeration.DeviceWatcher;
  end;

  JIEnclosureLocation = class external
    inDock: Boolean;
    inLid: Boolean;
    panel: JWindows.Devices.Enumeration.Panel;
  end;

  JIDeviceInformationUpdate = class external
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
  end;

  JIDeviceWatcher = class external
    status: JWindows.Devices.Enumeration.DeviceWatcherStatus;
    onadded: Variant;
    onupdated: Variant;
    onremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JIDeviceInformationStatics = class external
    function createFromIdAsync(id: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformation>};
    function createFromIdAsync(id: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformation>};
    function findAllAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(deviceClass: JWindows.Devices.Enumeration.DeviceClass): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(aqsFilter: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function findAllAsync(aqsFilter: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceInformationCollection>};
    function createWatcher: JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(deviceClass: JWindows.Devices.Enumeration.DeviceClass): JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(aqsFilter: String): JWindows.Devices.Enumeration.DeviceWatcher;
    function createWatcher(aqsFilter: String; additionalProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Devices.Enumeration.DeviceWatcher;
  end;

  JIDeviceInformation = class external
    enclosureLocation: JWindows.Devices.Enumeration.EnclosureLocation;
    id: String;
    isDefault: Boolean;
    isEnabled: Boolean;
    name: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    procedure update(updateInfo: JWindows.Devices.Enumeration.DeviceInformationUpdate);
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceThumbnail>};
    function getGlyphThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.DeviceThumbnail>};
  end;

//Windows

//Devices

//Enumeration

//Pnp

type
  JPnpObjectUpdate = class external 'PnpObjectUpdate'
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    &type: JWindows.Devices.Enumeration.Pnp.PnpObjectType;
  end;

  JPnpObjectCollection = class external 'PnpObjectCollection'
    size: Float;
    function getAt(index: Float): JWindows.Devices.Enumeration.Pnp.PnpObject;
    function indexOf(value: JWindows.Devices.Enumeration.Pnp.PnpObject):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Devices.Enumeration.Pnp.PnpObject;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Devices.Enumeration.Pnp.PnpObject>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Devices.Enumeration.Pnp.PnpObject): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function join(seperator: String): String;
    function pop: JWindows.Devices.Enumeration.Pnp.PnpObject;
    procedure push(items: array of JWindows.Devices.Enumeration.Pnp.PnpObject);
    function reverse: array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function shift: JWindows.Devices.Enumeration.Pnp.PnpObject;
    function slice(start: Float): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function slice(start: Float; &end: Float): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function sort: array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function sort(compareFn: (a: JWindows.Devices.Enumeration.Pnp.PnpObject; b: JWindows.Devices.Enumeration.Pnp.PnpObject): Float): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function splice(start: Float): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Devices.Enumeration.Pnp.PnpObject): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function unshift(items: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Float;
    function lastIndexOf(searchElement: JWindows.Devices.Enumeration.Pnp.PnpObject): Float;
    function lastIndexOf(searchElement: JWindows.Devices.Enumeration.Pnp.PnpObject; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject));
    procedure forEach(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function filter(callbackfn: (value: JWindows.Devices.Enumeration.Pnp.PnpObject; index: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Boolean; thisArg: Variant): array of JWindows.Devices.Enumeration.Pnp.PnpObject;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Devices.Enumeration.Pnp.PnpObject): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JPnpObjectWatcher = class external 'PnpObjectWatcher'
    status: JWindows.Devices.Enumeration.DeviceWatcherStatus;
    onadded: Variant;
    onupdated: Variant;
    onremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JPnpObject = class external 'PnpObject'
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    &type: JWindows.Devices.Enumeration.Pnp.PnpObjectType;
    procedure update(updateInfo: JWindows.Devices.Enumeration.Pnp.PnpObjectUpdate);
    function createFromIdAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; id: String; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObject>};
    function findAllAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObjectCollection>};
    function findAllAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}; aqsFilter: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObjectCollection>};
    function createWatcher(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Devices.Enumeration.Pnp.PnpObjectWatcher;
    function createWatcher(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}; aqsFilter: String): JWindows.Devices.Enumeration.Pnp.PnpObjectWatcher;
  end;

  JIPnpObjectUpdate = class external
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    &type: JWindows.Devices.Enumeration.Pnp.PnpObjectType;
  end;

  JIPnpObjectWatcher = class external
    status: JWindows.Devices.Enumeration.DeviceWatcherStatus;
    onadded: Variant;
    onupdated: Variant;
    onremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JIPnpObjectStatics = class external
    function createFromIdAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; id: String; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObject>};
    function findAllAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObjectCollection>};
    function findAllAsync(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}; aqsFilter: String): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Enumeration.Pnp.PnpObjectCollection>};
    function createWatcher(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Devices.Enumeration.Pnp.PnpObjectWatcher;
    function createWatcher(&type: JWindows.Devices.Enumeration.Pnp.PnpObjectType; requestedProperties: JWindows.Foundation.Collections.IIterable{<String>}; aqsFilter: String): JWindows.Devices.Enumeration.Pnp.PnpObjectWatcher;
  end;

  JIPnpObject = class external
    id: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    &type: JWindows.Devices.Enumeration.Pnp.PnpObjectType;
    procedure update(updateInfo: JWindows.Devices.Enumeration.Pnp.PnpObjectUpdate);
  end;

//Windows

//Devices

//Geolocation

type
  JGeocoordinate = class external 'Geocoordinate'
    accuracy: Float;
    altitude: Float;
    altitudeAccuracy: Float;
    heading: Float;
    latitude: Float;
    longitude: Float;
    speed: Float;
    timestamp: JDate;
  end;

  JCivicAddress = class external 'CivicAddress'
    city: String;
    country: String;
    postalCode: String;
    state: String;
    timestamp: JDate;
  end;

  JGeoposition = class external 'Geoposition'
    civicAddress: JWindows.Devices.Geolocation.CivicAddress;
    coordinate: JWindows.Devices.Geolocation.Geocoordinate;
  end;

  JPositionChangedEventArgs = class external 'PositionChangedEventArgs'
    position: JWindows.Devices.Geolocation.Geoposition;
  end;

  JStatusChangedEventArgs = class external 'StatusChangedEventArgs'
    status: JWindows.Devices.Geolocation.PositionStatus;
  end;

  JGeolocator = class external 'Geolocator'
    desiredAccuracy: JWindows.Devices.Geolocation.PositionAccuracy;
    locationStatus: JWindows.Devices.Geolocation.PositionStatus;
    movementThreshold: Float;
    reportInterval: Float;
    function getGeopositionAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Geolocation.Geoposition>};
    function getGeopositionAsync(maximumAge: Float; timeout: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Geolocation.Geoposition>};
    onpositionchanged: Variant;
    onstatuschanged: Variant;
  end;

  JIGeocoordinate = class external
    accuracy: Float;
    altitude: Float;
    altitudeAccuracy: Float;
    heading: Float;
    latitude: Float;
    longitude: Float;
    speed: Float;
    timestamp: JDate;
  end;

  JICivicAddress = class external
    city: String;
    country: String;
    postalCode: String;
    state: String;
    timestamp: JDate;
  end;

  JIGeoposition = class external
    civicAddress: JWindows.Devices.Geolocation.CivicAddress;
    coordinate: JWindows.Devices.Geolocation.Geocoordinate;
  end;

  JIPositionChangedEventArgs = class external
    position: JWindows.Devices.Geolocation.Geoposition;
  end;

  JIStatusChangedEventArgs = class external
    status: JWindows.Devices.Geolocation.PositionStatus;
  end;

  JIGeolocator = class external
    desiredAccuracy: JWindows.Devices.Geolocation.PositionAccuracy;
    locationStatus: JWindows.Devices.Geolocation.PositionStatus;
    movementThreshold: Float;
    reportInterval: Float;
    function getGeopositionAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Geolocation.Geoposition>};
    function getGeopositionAsync(maximumAge: Float; timeout: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Devices.Geolocation.Geoposition>};
    onpositionchanged: Variant;
    onstatuschanged: Variant;
  end;

//Windows

//Devices

//Input

type
  JPointerDevice = class external 'PointerDevice'
    isIntegrated: Boolean;
    maxContacts: Float;
    physicalDeviceRect: JWindows.Foundation.Rect;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    screenRect: JWindows.Foundation.Rect;
    supportedUsages: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Input.PointerDeviceUsage>};
    function getPointerDevice(pointerId: Float): JWindows.Devices.Input.PointerDevice;
    function getPointerDevices: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Input.PointerDevice>};
  end;

  JMouseDevice = class external 'MouseDevice'
    onmousemoved: Variant;
    function getForCurrentView: JWindows.Devices.Input.MouseDevice;
  end;

  JMouseEventArgs = class external 'MouseEventArgs'
    mouseDelta: JWindows.Devices.Input.MouseDelta;
  end;

  JMouseCapabilities = class external 'MouseCapabilities'
    horizontalWheelPresent: Float;
    mousePresent: Float;
    numberOfButtons: Float;
    swapButtons: Float;
    verticalWheelPresent: Float;
  end;

  JKeyboardCapabilities = class external 'KeyboardCapabilities'
    keyboardPresent: Float;
  end;

  JTouchCapabilities = class external 'TouchCapabilities'
    contacts: Float;
    touchPresent: Float;
  end;

  JPointerDeviceUsage = class external
    usagePage: Float;
    usage: Float;
    minLogical: Float;
    maxLogical: Float;
    minPhysical: Float;
    maxPhysical: Float;
    unit: Float;
    physicalMultiplier: Float;
  end;

  JMouseDelta = class external
    x: Float;
    y: Float;
  end;

  JIMouseCapabilities = class external
    horizontalWheelPresent: Float;
    mousePresent: Float;
    numberOfButtons: Float;
    swapButtons: Float;
    verticalWheelPresent: Float;
  end;

  JIKeyboardCapabilities = class external
    keyboardPresent: Float;
  end;

  JITouchCapabilities = class external
    contacts: Float;
    touchPresent: Float;
  end;

  JIPointerDeviceStatics = class external
    function getPointerDevice(pointerId: Float): JWindows.Devices.Input.PointerDevice;
    function getPointerDevices: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Input.PointerDevice>};
  end;

  JIPointerDevice = class external
    isIntegrated: Boolean;
    maxContacts: Float;
    physicalDeviceRect: JWindows.Foundation.Rect;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    screenRect: JWindows.Foundation.Rect;
    supportedUsages: JWindows.Foundation.Collections.IVectorView{<JWindows.Devices.Input.PointerDeviceUsage>};
  end;

  JIMouseEventArgs = class external
    mouseDelta: JWindows.Devices.Input.MouseDelta;
  end;

  JIMouseDevice = class external
    onmousemoved: Variant;
  end;

  JIMouseDeviceStatics = class external
    function getForCurrentView: JWindows.Devices.Input.MouseDevice;
  end;

//Windows

//Devices

//Portable

type
  JStorageDevice = class external 'StorageDevice'
    function fromId(interfaceId: String): JWindows.Storage.StorageFolder;
    function getDeviceSelector: String;
  end;

  JServiceDevice = class external 'ServiceDevice'
    function getDeviceSelector(serviceType: JWindows.Devices.Portable.ServiceDeviceType): String;
    function getDeviceSelectorFromServiceId(serviceId: String): String;
  end;

  JIStorageDeviceStatics = class external
    function fromId(interfaceId: String): JWindows.Storage.StorageFolder;
    function getDeviceSelector: String;
  end;

  JIServiceDeviceStatics = class external
    function getDeviceSelector(serviceType: JWindows.Devices.Portable.ServiceDeviceType): String;
    function getDeviceSelectorFromServiceId(serviceId: String): String;
  end;

//Windows

//Devices

//Printers

//Extensions

type
  JPrintTaskConfigurationSaveRequestedDeferral = class external 'PrintTaskConfigurationSaveRequestedDeferral'
    procedure complete;
  end;

  JPrintTaskConfigurationSaveRequest = class external 'PrintTaskConfigurationSaveRequest'
    deadline: JDate;
    procedure cancel;
    procedure save(printerExtensionContext: Variant);
    function getDeferral: JWindows.Devices.Printers.Extensions.PrintTaskConfigurationSaveRequestedDeferral;
  end;

  JPrintTaskConfigurationSaveRequestedEventArgs = class external 'PrintTaskConfigurationSaveRequestedEventArgs'
    request: JWindows.Devices.Printers.Extensions.PrintTaskConfigurationSaveRequest;
  end;

  JPrintTaskConfiguration = class external 'PrintTaskConfiguration'
    printerExtensionContext: Variant;
    onsaverequested: Variant;
  end;

  JPrintNotificationEventDetails = class external 'PrintNotificationEventDetails'
    eventData: String;
    printerName: String;
  end;

  JPrintExtensionContext = class external 'PrintExtensionContext'
    function fromDeviceId(deviceId: String): Variant;
  end;

  JIPrintTaskConfigurationSaveRequestedDeferral = class external
    procedure complete;
  end;

  JIPrintTaskConfigurationSaveRequest = class external
    deadline: JDate;
    procedure cancel;
    procedure save(printerExtensionContext: Variant);
    function getDeferral: JWindows.Devices.Printers.Extensions.PrintTaskConfigurationSaveRequestedDeferral;
  end;

  JIPrintTaskConfigurationSaveRequestedEventArgs = class external
    request: JWindows.Devices.Printers.Extensions.PrintTaskConfigurationSaveRequest;
  end;

  JIPrintTaskConfiguration = class external
    printerExtensionContext: Variant;
    onsaverequested: Variant;
  end;

  JIPrintNotificationEventDetails = class external
    eventData: String;
    printerName: String;
  end;

  JIPrintExtensionContextStatic = class external
    function fromDeviceId(deviceId: String): Variant;
  end;

//Windows

//Devices

//Sensors

type
  JAccelerometer = class external 'Accelerometer'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.AccelerometerReading;
    onreadingchanged: Variant;
    onshaken: Variant;
    function getDefault: JWindows.Devices.Sensors.Accelerometer;
  end;

  JAccelerometerReading = class external 'AccelerometerReading'
    accelerationX: Float;
    accelerationY: Float;
    accelerationZ: Float;
    timestamp: JDate;
  end;

  JAccelerometerReadingChangedEventArgs = class external 'AccelerometerReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.AccelerometerReading;
  end;

  JAccelerometerShakenEventArgs = class external 'AccelerometerShakenEventArgs'
    timestamp: JDate;
  end;

  JInclinometer = class external 'Inclinometer'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.InclinometerReading;
    onreadingchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.Inclinometer;
  end;

  JInclinometerReading = class external 'InclinometerReading'
    pitchDegrees: Float;
    rollDegrees: Float;
    timestamp: JDate;
    yawDegrees: Float;
  end;

  JInclinometerReadingChangedEventArgs = class external 'InclinometerReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.InclinometerReading;
  end;

  JGyrometer = class external 'Gyrometer'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.GyrometerReading;
    onreadingchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.Gyrometer;
  end;

  JGyrometerReading = class external 'GyrometerReading'
    angularVelocityX: Float;
    angularVelocityY: Float;
    angularVelocityZ: Float;
    timestamp: JDate;
  end;

  JGyrometerReadingChangedEventArgs = class external 'GyrometerReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.GyrometerReading;
  end;

  JCompass = class external 'Compass'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.CompassReading;
    onreadingchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.Compass;
  end;

  JCompassReading = class external 'CompassReading'
    headingMagneticNorth: Float;
    headingTrueNorth: Float;
    timestamp: JDate;
  end;

  JCompassReadingChangedEventArgs = class external 'CompassReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.CompassReading;
  end;

  JLightSensor = class external 'LightSensor'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.LightSensorReading;
    onreadingchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.LightSensor;
  end;

  JLightSensorReading = class external 'LightSensorReading'
    illuminanceInLux: Float;
    timestamp: JDate;
  end;

  JLightSensorReadingChangedEventArgs = class external 'LightSensorReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.LightSensorReading;
  end;

  JSensorRotationMatrix = class external 'SensorRotationMatrix'
    m11: Float;
    m12: Float;
    m13: Float;
    m21: Float;
    m22: Float;
    m23: Float;
    m31: Float;
    m32: Float;
    m33: Float;
  end;

  JSensorQuaternion = class external 'SensorQuaternion'
    w: Float;
    x: Float;
    y: Float;
    z: Float;
  end;

  JOrientationSensor = class external 'OrientationSensor'
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.OrientationSensorReading;
    onreadingchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.OrientationSensor;
  end;

  JOrientationSensorReading = class external 'OrientationSensorReading'
    quaternion: JWindows.Devices.Sensors.SensorQuaternion;
    rotationMatrix: JWindows.Devices.Sensors.SensorRotationMatrix;
    timestamp: JDate;
  end;

  JOrientationSensorReadingChangedEventArgs = class external 'OrientationSensorReadingChangedEventArgs'
    reading: JWindows.Devices.Sensors.OrientationSensorReading;
  end;

  JSimpleOrientationSensor = class external 'SimpleOrientationSensor'
    function getCurrentOrientation: JWindows.Devices.Sensors.SimpleOrientation;
    onorientationchanged: Variant;
    function getDefault: JWindows.Devices.Sensors.SimpleOrientationSensor;
  end;

  JSimpleOrientationSensorOrientationChangedEventArgs = class external 'SimpleOrientationSensorOrientationChangedEventArgs'
    orientation: JWindows.Devices.Sensors.SimpleOrientation;
    timestamp: JDate;
  end;

  JIAccelerometerStatics = class external
    function getDefault: JWindows.Devices.Sensors.Accelerometer;
  end;

  JIAccelerometer = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.AccelerometerReading;
    onreadingchanged: Variant;
    onshaken: Variant;
  end;

  JIAccelerometerReading = class external
    accelerationX: Float;
    accelerationY: Float;
    accelerationZ: Float;
    timestamp: JDate;
  end;

  JIAccelerometerReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.AccelerometerReading;
  end;

  JIAccelerometerShakenEventArgs = class external
    timestamp: JDate;
  end;

  JIInclinometerStatics = class external
    function getDefault: JWindows.Devices.Sensors.Inclinometer;
  end;

  JIInclinometer = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.InclinometerReading;
    onreadingchanged: Variant;
  end;

  JIInclinometerReading = class external
    pitchDegrees: Float;
    rollDegrees: Float;
    timestamp: JDate;
    yawDegrees: Float;
  end;

  JIInclinometerReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.InclinometerReading;
  end;

  JIGyrometerStatics = class external
    function getDefault: JWindows.Devices.Sensors.Gyrometer;
  end;

  JIGyrometer = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.GyrometerReading;
    onreadingchanged: Variant;
  end;

  JIGyrometerReading = class external
    angularVelocityX: Float;
    angularVelocityY: Float;
    angularVelocityZ: Float;
    timestamp: JDate;
  end;

  JIGyrometerReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.GyrometerReading;
  end;

  JICompassStatics = class external
    function getDefault: JWindows.Devices.Sensors.Compass;
  end;

  JICompass = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.CompassReading;
    onreadingchanged: Variant;
  end;

  JICompassReading = class external
    headingMagneticNorth: Float;
    headingTrueNorth: Float;
    timestamp: JDate;
  end;

  JICompassReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.CompassReading;
  end;

  JILightSensorStatics = class external
    function getDefault: JWindows.Devices.Sensors.LightSensor;
  end;

  JILightSensor = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.LightSensorReading;
    onreadingchanged: Variant;
  end;

  JILightSensorReading = class external
    illuminanceInLux: Float;
    timestamp: JDate;
  end;

  JILightSensorReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.LightSensorReading;
  end;

  JISensorRotationMatrix = class external
    m11: Float;
    m12: Float;
    m13: Float;
    m21: Float;
    m22: Float;
    m23: Float;
    m31: Float;
    m32: Float;
    m33: Float;
  end;

  JISensorQuaternion = class external
    w: Float;
    x: Float;
    y: Float;
    z: Float;
  end;

  JIOrientationSensorStatics = class external
    function getDefault: JWindows.Devices.Sensors.OrientationSensor;
  end;

  JIOrientationSensor = class external
    minimumReportInterval: Float;
    reportInterval: Float;
    function getCurrentReading: JWindows.Devices.Sensors.OrientationSensorReading;
    onreadingchanged: Variant;
  end;

  JIOrientationSensorReading = class external
    quaternion: JWindows.Devices.Sensors.SensorQuaternion;
    rotationMatrix: JWindows.Devices.Sensors.SensorRotationMatrix;
    timestamp: JDate;
  end;

  JIOrientationSensorReadingChangedEventArgs = class external
    reading: JWindows.Devices.Sensors.OrientationSensorReading;
  end;

  JISimpleOrientationSensorStatics = class external
    function getDefault: JWindows.Devices.Sensors.SimpleOrientationSensor;
  end;

  JISimpleOrientationSensor = class external
    function getCurrentOrientation: JWindows.Devices.Sensors.SimpleOrientation;
    onorientationchanged: Variant;
  end;

  JISimpleOrientationSensorOrientationChangedEventArgs = class external
    orientation: JWindows.Devices.Sensors.SimpleOrientation;
    timestamp: JDate;
  end;

//Windows

//Globalization

//Fonts

type
  JLanguageFont = class external 'LanguageFont'
    fontFamily: String;
    fontStretch: JWindows.UI.Text.FontStretch;
    fontStyle: JWindows.UI.Text.FontStyle;
    fontWeight: JWindows.UI.Text.FontWeight;
    scaleFactor: Float;
  end;

  JLanguageFontGroup = class external 'LanguageFontGroup'
    constructor Create(languageTag: String);
    documentAlternate1Font: JWindows.Globalization.Fonts.LanguageFont;
    documentAlternate2Font: JWindows.Globalization.Fonts.LanguageFont;
    documentHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    fixedWidthTextFont: JWindows.Globalization.Fonts.LanguageFont;
    modernDocumentFont: JWindows.Globalization.Fonts.LanguageFont;
    traditionalDocumentFont: JWindows.Globalization.Fonts.LanguageFont;
    uICaptionFont: JWindows.Globalization.Fonts.LanguageFont;
    uIHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    uINotificationHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    uITextFont: JWindows.Globalization.Fonts.LanguageFont;
    uITitleFont: JWindows.Globalization.Fonts.LanguageFont;
  end;

  JILanguageFontGroup = class external
    documentAlternate1Font: JWindows.Globalization.Fonts.LanguageFont;
    documentAlternate2Font: JWindows.Globalization.Fonts.LanguageFont;
    documentHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    fixedWidthTextFont: JWindows.Globalization.Fonts.LanguageFont;
    modernDocumentFont: JWindows.Globalization.Fonts.LanguageFont;
    traditionalDocumentFont: JWindows.Globalization.Fonts.LanguageFont;
    uICaptionFont: JWindows.Globalization.Fonts.LanguageFont;
    uIHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    uINotificationHeadingFont: JWindows.Globalization.Fonts.LanguageFont;
    uITextFont: JWindows.Globalization.Fonts.LanguageFont;
    uITitleFont: JWindows.Globalization.Fonts.LanguageFont;
  end;

  JILanguageFontGroupFactory = class external
    function createLanguageFontGroup(languageTag: String): JWindows.Globalization.Fonts.LanguageFontGroup;
  end;

  JILanguageFont = class external
    fontFamily: String;
    fontStretch: JWindows.UI.Text.FontStretch;
    fontStyle: JWindows.UI.Text.FontStyle;
    fontWeight: JWindows.UI.Text.FontWeight;
    scaleFactor: Float;
  end;

//Windows

//Globalization

type
  JCalendarIdentifiers = class external 'CalendarIdentifiers'
    gregorian: String;
    hebrew: String;
    hijri: String;
    japanese: String;
    julian: String;
    korean: String;
    taiwan: String;
    thai: String;
    umAlQura: String;
  end;

  JClockIdentifiers = class external 'ClockIdentifiers'
    twelveHour: String;
    twentyFourHour: String;
  end;

  JGeographicRegion = class external 'GeographicRegion'
    constructor Create(geographicRegionCode: String);
    constructor Create;
    code: String;
    codeThreeDigit: String;
    codeThreeLetter: String;
    codeTwoLetter: String;
    currenciesInUse: JWindows.Foundation.Collections.IVectorView{<String>};
    displayName: String;
    nativeName: String;
    function isSupported(geographicRegionCode: String): Boolean;
  end;

  JLanguage = class external 'Language'
    constructor Create(languageTag: String);
    displayName: String;
    languageTag: String;
    nativeName: String;
    script: String;
    currentInputMethodLanguageTag: String;
    function isWellFormed(languageTag: String): Boolean;
  end;

  JCalendar = class external 'Calendar'
    constructor Create(languages: JWindows.Foundation.Collections.IIterable{<String>});
    constructor Create(languages: JWindows.Foundation.Collections.IIterable{<String>}; calendar: String; clock: String);
    constructor Create;
    day: Float;
    dayOfWeek: JWindows.Globalization.DayOfWeek;
    era: Float;
    firstDayInThisMonth: Float;
    firstEra: Float;
    firstHourInThisPeriod: Float;
    firstMinuteInThisHour: Float;
    firstMonthInThisYear: Float;
    firstPeriodInThisDay: Float;
    firstSecondInThisMinute: Float;
    firstYearInThisEra: Float;
    hour: Float;
    isDaylightSavingTime: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    lastDayInThisMonth: Float;
    lastEra: Float;
    lastHourInThisPeriod: Float;
    lastMinuteInThisHour: Float;
    lastMonthInThisYear: Float;
    lastPeriodInThisDay: Float;
    lastSecondInThisMinute: Float;
    lastYearInThisEra: Float;
    minute: Float;
    month: Float;
    nanosecond: Float;
    numberOfDaysInThisMonth: Float;
    numberOfEras: Float;
    numberOfHoursInThisPeriod: Float;
    numberOfMinutesInThisHour: Float;
    numberOfMonthsInThisYear: Float;
    numberOfPeriodsInThisDay: Float;
    numberOfSecondsInThisMinute: Float;
    numberOfYearsInThisEra: Float;
    numeralSystem: String;
    period: Float;
    resolvedLanguage: String;
    second: Float;
    year: Float;
    function clone: JWindows.Globalization.Calendar;
    procedure setToMin;
    procedure setToMax;
    function getCalendarSystem: String;
    procedure changeCalendarSystem(value: String);
    function getClock: String;
    procedure changeClock(value: String);
    function getDateTime: JDate;
    procedure setDateTime(value: JDate);
    procedure setToNow;
    procedure addEras(eras: Float);
    function eraAsString: String;
    function eraAsString(idealLength: Float): String;
    procedure addYears(years: Float);
    function yearAsString: String;
    function yearAsTruncatedString(remainingDigits: Float): String;
    function yearAsPaddedString(minDigits: Float): String;
    procedure addMonths(months: Float);
    function monthAsString: String;
    function monthAsString(idealLength: Float): String;
    function monthAsSoloString: String;
    function monthAsSoloString(idealLength: Float): String;
    function monthAsNumericString: String;
    function monthAsPaddedNumericString(minDigits: Float): String;
    procedure addWeeks(weeks: Float);
    procedure addDays(days: Float);
    function dayAsString: String;
    function dayAsPaddedString(minDigits: Float): String;
    function dayOfWeekAsString: String;
    function dayOfWeekAsString(idealLength: Float): String;
    function dayOfWeekAsSoloString: String;
    function dayOfWeekAsSoloString(idealLength: Float): String;
    procedure addPeriods(periods: Float);
    function periodAsString: String;
    function periodAsString(idealLength: Float): String;
    procedure addHours(hours: Float);
    function hourAsString: String;
    function hourAsPaddedString(minDigits: Float): String;
    procedure addMinutes(minutes: Float);
    function minuteAsString: String;
    function minuteAsPaddedString(minDigits: Float): String;
    procedure addSeconds(seconds: Float);
    function secondAsString: String;
    function secondAsPaddedString(minDigits: Float): String;
    procedure addNanoseconds(nanoseconds: Float);
    function nanosecondAsString: String;
    function nanosecondAsPaddedString(minDigits: Float): String;
    function compare(other: JWindows.Globalization.Calendar): Float;
    function compareDateTime(other: JDate): Float;
    procedure copyTo(other: JWindows.Globalization.Calendar);
  end;

  JApplicationLanguages = class external 'ApplicationLanguages'
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    manifestLanguages: JWindows.Foundation.Collections.IVectorView{<String>};
    primaryLanguageOverride: String;
  end;

  JICalendarIdentifiersStatics = class external
    gregorian: String;
    hebrew: String;
    hijri: String;
    japanese: String;
    julian: String;
    korean: String;
    taiwan: String;
    thai: String;
    umAlQura: String;
  end;

  JIClockIdentifiersStatics = class external
    twelveHour: String;
    twentyFourHour: String;
  end;

  JIGeographicRegion = class external
    code: String;
    codeThreeDigit: String;
    codeThreeLetter: String;
    codeTwoLetter: String;
    currenciesInUse: JWindows.Foundation.Collections.IVectorView{<String>};
    displayName: String;
    nativeName: String;
  end;

  JIGeographicRegionFactory = class external
    function createGeographicRegion(geographicRegionCode: String): JWindows.Globalization.GeographicRegion;
  end;

  JIGeographicRegionStatics = class external
    function isSupported(geographicRegionCode: String): Boolean;
  end;

  JILanguage = class external
    displayName: String;
    languageTag: String;
    nativeName: String;
    script: String;
  end;

  JILanguageFactory = class external
    function createLanguage(languageTag: String): JWindows.Globalization.Language;
  end;

  JILanguageStatics = class external
    currentInputMethodLanguageTag: String;
    function isWellFormed(languageTag: String): Boolean;
  end;

  JICalendar = class external
    day: Float;
    dayOfWeek: JWindows.Globalization.DayOfWeek;
    era: Float;
    firstDayInThisMonth: Float;
    firstEra: Float;
    firstHourInThisPeriod: Float;
    firstMinuteInThisHour: Float;
    firstMonthInThisYear: Float;
    firstPeriodInThisDay: Float;
    firstSecondInThisMinute: Float;
    firstYearInThisEra: Float;
    hour: Float;
    isDaylightSavingTime: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    lastDayInThisMonth: Float;
    lastEra: Float;
    lastHourInThisPeriod: Float;
    lastMinuteInThisHour: Float;
    lastMonthInThisYear: Float;
    lastPeriodInThisDay: Float;
    lastSecondInThisMinute: Float;
    lastYearInThisEra: Float;
    minute: Float;
    month: Float;
    nanosecond: Float;
    numberOfDaysInThisMonth: Float;
    numberOfEras: Float;
    numberOfHoursInThisPeriod: Float;
    numberOfMinutesInThisHour: Float;
    numberOfMonthsInThisYear: Float;
    numberOfPeriodsInThisDay: Float;
    numberOfSecondsInThisMinute: Float;
    numberOfYearsInThisEra: Float;
    numeralSystem: String;
    period: Float;
    resolvedLanguage: String;
    second: Float;
    year: Float;
    function clone: JWindows.Globalization.Calendar;
    procedure setToMin;
    procedure setToMax;
    function getCalendarSystem: String;
    procedure changeCalendarSystem(value: String);
    function getClock: String;
    procedure changeClock(value: String);
    function getDateTime: JDate;
    procedure setDateTime(value: JDate);
    procedure setToNow;
    procedure addEras(eras: Float);
    function eraAsString: String;
    function eraAsString(idealLength: Float): String;
    procedure addYears(years: Float);
    function yearAsString: String;
    function yearAsTruncatedString(remainingDigits: Float): String;
    function yearAsPaddedString(minDigits: Float): String;
    procedure addMonths(months: Float);
    function monthAsString: String;
    function monthAsString(idealLength: Float): String;
    function monthAsSoloString: String;
    function monthAsSoloString(idealLength: Float): String;
    function monthAsNumericString: String;
    function monthAsPaddedNumericString(minDigits: Float): String;
    procedure addWeeks(weeks: Float);
    procedure addDays(days: Float);
    function dayAsString: String;
    function dayAsPaddedString(minDigits: Float): String;
    function dayOfWeekAsString: String;
    function dayOfWeekAsString(idealLength: Float): String;
    function dayOfWeekAsSoloString: String;
    function dayOfWeekAsSoloString(idealLength: Float): String;
    procedure addPeriods(periods: Float);
    function periodAsString: String;
    function periodAsString(idealLength: Float): String;
    procedure addHours(hours: Float);
    function hourAsString: String;
    function hourAsPaddedString(minDigits: Float): String;
    procedure addMinutes(minutes: Float);
    function minuteAsString: String;
    function minuteAsPaddedString(minDigits: Float): String;
    procedure addSeconds(seconds: Float);
    function secondAsString: String;
    function secondAsPaddedString(minDigits: Float): String;
    procedure addNanoseconds(nanoseconds: Float);
    function nanosecondAsString: String;
    function nanosecondAsPaddedString(minDigits: Float): String;
    function compare(other: JWindows.Globalization.Calendar): Float;
    function compareDateTime(other: JDate): Float;
    procedure copyTo(other: JWindows.Globalization.Calendar);
  end;

  JICalendarFactory = class external
    function createCalendarDefaultCalendarAndClock(languages: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Globalization.Calendar;
    function createCalendar(languages: JWindows.Foundation.Collections.IIterable{<String>}; calendar: String; clock: String): JWindows.Globalization.Calendar;
  end;

  JIApplicationLanguagesStatics = class external
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    manifestLanguages: JWindows.Foundation.Collections.IVectorView{<String>};
    primaryLanguageOverride: String;
  end;

//Windows

//Globalization

//DateTimeFormatting

type
  JDateTimeFormatter = class external 'DateTimeFormatter'
    constructor Create(formatTemplate: String);
    constructor Create(formatTemplate: String; languages: JWindows.Foundation.Collections.IIterable{<String>});
    constructor Create(formatTemplate: String; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String; calendar: String; clock: String);
    constructor Create(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat);
    constructor Create(hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat);
    constructor Create(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat; hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat; languages: JWindows.Foundation.Collections.IIterable{<String>});
    constructor Create(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat; hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String; calendar: String; clock: String);
    calendar: String;
    clock: String;
    geographicRegion: String;
    includeDay: JWindows.Globalization.DateTimeFormatting.DayFormat;
    includeDayOfWeek: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat;
    includeHour: JWindows.Globalization.DateTimeFormatting.HourFormat;
    includeMinute: JWindows.Globalization.DateTimeFormatting.MinuteFormat;
    includeMonth: JWindows.Globalization.DateTimeFormatting.MonthFormat;
    includeSecond: JWindows.Globalization.DateTimeFormatting.SecondFormat;
    includeYear: JWindows.Globalization.DateTimeFormatting.YearFormat;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    patterns: JWindows.Foundation.Collections.IVectorView{<String>};
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    template: String;
    function format(value: JDate): String;
    longDate: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    longTime: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    shortDate: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    shortTime: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
  end;

  JIDateTimeFormatter = class external
    calendar: String;
    clock: String;
    geographicRegion: String;
    includeDay: JWindows.Globalization.DateTimeFormatting.DayFormat;
    includeDayOfWeek: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat;
    includeHour: JWindows.Globalization.DateTimeFormatting.HourFormat;
    includeMinute: JWindows.Globalization.DateTimeFormatting.MinuteFormat;
    includeMonth: JWindows.Globalization.DateTimeFormatting.MonthFormat;
    includeSecond: JWindows.Globalization.DateTimeFormatting.SecondFormat;
    includeYear: JWindows.Globalization.DateTimeFormatting.YearFormat;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    patterns: JWindows.Foundation.Collections.IVectorView{<String>};
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    template: String;
    function format(value: JDate): String;
  end;

  JIDateTimeFormatterFactory = class external
    function createDateTimeFormatter(formatTemplate: String): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterLanguages(formatTemplate: String; languages: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterContext(formatTemplate: String; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String; calendar: String; clock: String): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterDate(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterTime(hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterDateTimeLanguages(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat; hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat; languages: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    function createDateTimeFormatterDateTimeContext(yearFormat: JWindows.Globalization.DateTimeFormatting.YearFormat; monthFormat: JWindows.Globalization.DateTimeFormatting.MonthFormat; dayFormat: JWindows.Globalization.DateTimeFormatting.DayFormat; dayOfWeekFormat: JWindows.Globalization.DateTimeFormatting.DayOfWeekFormat; hourFormat: JWindows.Globalization.DateTimeFormatting.HourFormat; minuteFormat: JWindows.Globalization.DateTimeFormatting.MinuteFormat; secondFormat: JWindows.Globalization.DateTimeFormatting.SecondFormat; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String; calendar: String; clock: String): JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
  end;

  JIDateTimeFormatterStatics = class external
    longDate: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    longTime: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    shortDate: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
    shortTime: JWindows.Globalization.DateTimeFormatting.DateTimeFormatter;
  end;

//Windows

//Globalization

//NumberFormatting

type
  JDecimalFormatter = class external 'DecimalFormatter'
    constructor Create(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String);
    constructor Create;
    fractionDigits: Float;
    geographicRegion: String;
    integerDigits: Float;
    isDecimalPointAlwaysDisplayed: Boolean;
    isGrouped: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    function format(value: Float): String;
    function formatInt(value: Float): String;
    function formatUInt(value: Float): String;
    function formatDouble(value: Float): String;
    function parseInt(text: String): Float;
    function parseUInt(text: String): Float;
    function parseDouble(text: String): Float;
  end;

  JPercentFormatter = class external 'PercentFormatter'
    constructor Create(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String);
    constructor Create;
    fractionDigits: Float;
    geographicRegion: String;
    integerDigits: Float;
    isDecimalPointAlwaysDisplayed: Boolean;
    isGrouped: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    function format(value: Float): String;
    function formatInt(value: Float): String;
    function formatUInt(value: Float): String;
    function formatDouble(value: Float): String;
    function parseInt(text: String): Float;
    function parseUInt(text: String): Float;
    function parseDouble(text: String): Float;
  end;

  JPermilleFormatter = class external 'PermilleFormatter'
    constructor Create(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String);
    constructor Create;
    fractionDigits: Float;
    geographicRegion: String;
    integerDigits: Float;
    isDecimalPointAlwaysDisplayed: Boolean;
    isGrouped: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    function format(value: Float): String;
    function formatInt(value: Float): String;
    function formatUInt(value: Float): String;
    function formatDouble(value: Float): String;
    function parseInt(text: String): Float;
    function parseUInt(text: String): Float;
    function parseDouble(text: String): Float;
  end;

  JCurrencyFormatter = class external 'CurrencyFormatter'
    constructor Create(currencyCode: String);
    constructor Create(currencyCode: String; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String);
    currency: String;
    fractionDigits: Float;
    geographicRegion: String;
    integerDigits: Float;
    isDecimalPointAlwaysDisplayed: Boolean;
    isGrouped: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
    function format(value: Float): String;
    function formatInt(value: Float): String;
    function formatUInt(value: Float): String;
    function formatDouble(value: Float): String;
    function parseInt(text: String): Float;
    function parseUInt(text: String): Float;
    function parseDouble(text: String): Float;
  end;

  JINumberFormatter = class external
    function format(value: Float): String;
  end;

  JINumberFormatter2 = class external
    function formatInt(value: Float): String;
    function formatUInt(value: Float): String;
    function formatDouble(value: Float): String;
  end;

  JINumberParser = class external
    function parseInt(text: String): Float;
    function parseUInt(text: String): Float;
    function parseDouble(text: String): Float;
  end;

  JINumberFormatterOptions = class external
    fractionDigits: Float;
    geographicRegion: String;
    integerDigits: Float;
    isDecimalPointAlwaysDisplayed: Boolean;
    isGrouped: Boolean;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    numeralSystem: String;
    resolvedGeographicRegion: String;
    resolvedLanguage: String;
  end;

  JIDecimalFormatterFactory = class external
    function createDecimalFormatter(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String): JWindows.Globalization.NumberFormatting.DecimalFormatter;
  end;

  JIPercentFormatterFactory = class external
    function createPercentFormatter(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String): JWindows.Globalization.NumberFormatting.PercentFormatter;
  end;

  JIPermilleFormatterFactory = class external
    function createPermilleFormatter(languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String): JWindows.Globalization.NumberFormatting.PermilleFormatter;
  end;

  JICurrencyFormatterFactory = class external
    function createCurrencyFormatterCode(currencyCode: String): JWindows.Globalization.NumberFormatting.CurrencyFormatter;
    function createCurrencyFormatterCodeContext(currencyCode: String; languages: JWindows.Foundation.Collections.IIterable{<String>}; geographicRegion: String): JWindows.Globalization.NumberFormatting.CurrencyFormatter;
  end;

  JICurrencyFormatter = class external(JWindows.Globalization.NumberFormatting.INumberFormatterOptions, JWindows.Globalization.NumberFormatting.INumberFormatter, JWindows.Globalization.NumberFormatting.INumberFormatter2, JWindows.Globalization.NumberFormatting.INumberParser)
    currency: String;
  end;

//Windows

//Globalization

//Collation

type
  JCharacterGrouping = class external 'CharacterGrouping'
    first: String;
    &label: String;
  end;

  JCharacterGroupings = class external 'CharacterGroupings'
    size: Float;
    function lookup(text: String): String;
    function getAt(index: Float): JWindows.Globalization.Collation.CharacterGrouping;
    function indexOf(value: JWindows.Globalization.Collation.CharacterGrouping):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Globalization.Collation.CharacterGrouping;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Globalization.Collation.CharacterGrouping>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Globalization.Collation.CharacterGrouping): array of JWindows.Globalization.Collation.CharacterGrouping;
    function join(seperator: String): String;
    function pop: JWindows.Globalization.Collation.CharacterGrouping;
    procedure push(items: array of JWindows.Globalization.Collation.CharacterGrouping);
    function reverse: array of JWindows.Globalization.Collation.CharacterGrouping;
    function shift: JWindows.Globalization.Collation.CharacterGrouping;
    function slice(start: Float): array of JWindows.Globalization.Collation.CharacterGrouping;
    function slice(start: Float; &end: Float): array of JWindows.Globalization.Collation.CharacterGrouping;
    function sort: array of JWindows.Globalization.Collation.CharacterGrouping;
    function sort(compareFn: (a: JWindows.Globalization.Collation.CharacterGrouping; b: JWindows.Globalization.Collation.CharacterGrouping): Float): array of JWindows.Globalization.Collation.CharacterGrouping;
    function splice(start: Float): array of JWindows.Globalization.Collation.CharacterGrouping;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Globalization.Collation.CharacterGrouping): array of JWindows.Globalization.Collation.CharacterGrouping;
    function unshift(items: array of JWindows.Globalization.Collation.CharacterGrouping): Float;
    function lastIndexOf(searchElement: JWindows.Globalization.Collation.CharacterGrouping): Float;
    function lastIndexOf(searchElement: JWindows.Globalization.Collation.CharacterGrouping; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping));
    procedure forEach(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean): array of JWindows.Globalization.Collation.CharacterGrouping;
    function filter(callbackfn: (value: JWindows.Globalization.Collation.CharacterGrouping; index: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Boolean; thisArg: Variant): array of JWindows.Globalization.Collation.CharacterGrouping;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Globalization.Collation.CharacterGrouping): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JICharacterGrouping = class external
    first: String;
    &label: String;
  end;

  JICharacterGroupings = class external(JWindows.Foundation.Collections.IVectorView {JWindows.Globalization.Collation.CharacterGrouping} , JWindows.Foundation.Collections.IIterable {JWindows.Globalization.Collation.CharacterGrouping} )
    function lookup(text: String): String;
  end;

//Windows

//Graphics

//Display

type
  JDisplayProperties = class external 'DisplayProperties'
    autoRotationPreferences: JWindows.Graphics.Display.DisplayOrientations;
    currentOrientation: JWindows.Graphics.Display.DisplayOrientations;
    logicalDpi: Float;
    nativeOrientation: JWindows.Graphics.Display.DisplayOrientations;
    resolutionScale: JWindows.Graphics.Display.ResolutionScale;
    stereoEnabled: Boolean;
    onorientationchanged: Variant;
    onlogicaldpichanged: Variant;
    onstereoenabledchanged: Variant;
    function getColorProfileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStream>};
    oncolorprofilechanged: Variant;
    ondisplaycontentsinvalidated: Variant;
  end;

  JDisplayPropertiesEventHandler = class external
(sender: Variant)  end;

  JIDisplayPropertiesStatics = class external
    autoRotationPreferences: JWindows.Graphics.Display.DisplayOrientations;
    currentOrientation: JWindows.Graphics.Display.DisplayOrientations;
    logicalDpi: Float;
    nativeOrientation: JWindows.Graphics.Display.DisplayOrientations;
    resolutionScale: JWindows.Graphics.Display.ResolutionScale;
    stereoEnabled: Boolean;
    onorientationchanged: Variant;
    onlogicaldpichanged: Variant;
    onstereoenabledchanged: Variant;
    function getColorProfileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStream>};
    oncolorprofilechanged: Variant;
    ondisplaycontentsinvalidated: Variant;
  end;

//Windows

//Graphics

//Imaging

type
  JBitmapTransform = class external 'BitmapTransform'
    bounds: JWindows.Graphics.Imaging.BitmapBounds;
    flip: JWindows.Graphics.Imaging.BitmapFlip;
    interpolationMode: JWindows.Graphics.Imaging.BitmapInterpolationMode;
    rotation: JWindows.Graphics.Imaging.BitmapRotation;
    scaledHeight: Float;
    scaledWidth: Float;
  end;

  JBitmapTypedValue = class external 'BitmapTypedValue'
    constructor Create(value: Variant; &type: JWindows.Foundation.PropertyType);
    &type: JWindows.Foundation.PropertyType;
    value: Variant;
  end;

  JBitmapPropertySet = class external 'BitmapPropertySet'
    size: Float;
    function lookup(key: String): JWindows.Graphics.Imaging.BitmapTypedValue;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringJWindows.Graphics.Imaging.BitmapTypedValue>};
    function insert(key: String; value: JWindows.Graphics.Imaging.BitmapTypedValue): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>};
  end;

  JBitmapPropertiesView = class external 'BitmapPropertiesView'
    function getPropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapPropertySet>};
  end;

  JBitmapProperties = class external 'BitmapProperties'
    function setPropertiesAsync(propertiesToSet: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncAction;
    function getPropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapPropertySet>};
  end;

  JPixelDataProvider = class external 'PixelDataProvider'
    function detachPixelData: JUint8Array;
  end;

  JImageStream = class external 'ImageStream'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    contentType: String;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JBitmapFrame = class external 'BitmapFrame'
    bitmapAlphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode;
    bitmapPixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat;
    bitmapProperties: JWindows.Graphics.Imaging.BitmapPropertiesView;
    dpiX: Float;
    dpiY: Float;
    orientedPixelHeight: Float;
    orientedPixelWidth: Float;
    pixelHeight: Float;
    pixelWidth: Float;
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.ImageStream>};
    function getPixelDataAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
    function getPixelDataAsync(pixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat; alphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode; transform: JWindows.Graphics.Imaging.BitmapTransform; exifOrientationMode: JWindows.Graphics.Imaging.ExifOrientationMode; colorManagementMode: JWindows.Graphics.Imaging.ColorManagementMode): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
  end;

  JBitmapCodecInformation = class external 'BitmapCodecInformation'
    codecId: String;
    fileExtensions: JWindows.Foundation.Collections.IVectorView{<String>};
    friendlyName: String;
    mimeTypes: JWindows.Foundation.Collections.IVectorView{<String>};
  end;

  JBitmapDecoder = class external 'BitmapDecoder'
    bitmapContainerProperties: JWindows.Graphics.Imaging.BitmapPropertiesView;
    decoderInformation: JWindows.Graphics.Imaging.BitmapCodecInformation;
    frameCount: Float;
    bitmapAlphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode;
    bitmapPixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat;
    bitmapProperties: JWindows.Graphics.Imaging.BitmapPropertiesView;
    dpiX: Float;
    dpiY: Float;
    orientedPixelHeight: Float;
    orientedPixelWidth: Float;
    pixelHeight: Float;
    pixelWidth: Float;
    function getPreviewAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.ImageStream>};
    function getFrameAsync(frameIndex: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapFrame>};
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.ImageStream>};
    function getPixelDataAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
    function getPixelDataAsync(pixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat; alphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode; transform: JWindows.Graphics.Imaging.BitmapTransform; exifOrientationMode: JWindows.Graphics.Imaging.ExifOrientationMode; colorManagementMode: JWindows.Graphics.Imaging.ColorManagementMode): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
    bmpDecoderId: String;
    gifDecoderId: String;
    icoDecoderId: String;
    jpegDecoderId: String;
    jpegXRDecoderId: String;
    pngDecoderId: String;
    tiffDecoderId: String;
    function getDecoderInformationEnumerator: JWindows.Foundation.Collections.IVectorView{<JWindows.Graphics.Imaging.BitmapCodecInformation>};
    function createAsync(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapDecoder>};
    function createAsync(decoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapDecoder>};
  end;

  JBitmapEncoder = class external 'BitmapEncoder'
    bitmapContainerProperties: JWindows.Graphics.Imaging.BitmapProperties;
    bitmapProperties: JWindows.Graphics.Imaging.BitmapProperties;
    bitmapTransform: JWindows.Graphics.Imaging.BitmapTransform;
    encoderInformation: JWindows.Graphics.Imaging.BitmapCodecInformation;
    generatedThumbnailHeight: Float;
    generatedThumbnailWidth: Float;
    isThumbnailGenerated: Boolean;
    procedure setPixelData(pixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat; alphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode; width: Float; height: Float; dpiX: Float; dpiY: Float; pixels: JUint8Array);
    function goToNextFrameAsync: JWindows.Foundation.IAsyncAction;
    function goToNextFrameAsync(encodingOptions: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncAction;
    function flushAsync: JWindows.Foundation.IAsyncAction;
    bmpEncoderId: String;
    gifEncoderId: String;
    jpegEncoderId: String;
    jpegXREncoderId: String;
    pngEncoderId: String;
    tiffEncoderId: String;
    function getEncoderInformationEnumerator: JWindows.Foundation.Collections.IVectorView{<JWindows.Graphics.Imaging.BitmapCodecInformation>};
    function createAsync(encoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createAsync(encoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream; encodingOptions: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createForTranscodingAsync(stream: JWindows.Storage.Streams.IRandomAccessStream; bitmapDecoder: JWindows.Graphics.Imaging.BitmapDecoder): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createForInPlacePropertyEncodingAsync(bitmapDecoder: JWindows.Graphics.Imaging.BitmapDecoder): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
  end;

  JBitmapBounds = class external
    x: Float;
    y: Float;
    width: Float;
    height: Float;
  end;

  JIBitmapTransform = class external
    bounds: JWindows.Graphics.Imaging.BitmapBounds;
    flip: JWindows.Graphics.Imaging.BitmapFlip;
    interpolationMode: JWindows.Graphics.Imaging.BitmapInterpolationMode;
    rotation: JWindows.Graphics.Imaging.BitmapRotation;
    scaledHeight: Float;
    scaledWidth: Float;
  end;

  JIBitmapTypedValue = class external
    &type: JWindows.Foundation.PropertyType;
    value: Variant;
  end;

  JIBitmapTypedValueFactory = class external
    function create(value: Variant; &type: JWindows.Foundation.PropertyType): JWindows.Graphics.Imaging.BitmapTypedValue;
  end;

  JIBitmapPropertiesView = class external
    function getPropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapPropertySet>};
  end;

  JIBitmapProperties = class external(JWindows.Graphics.Imaging.IBitmapPropertiesView)
    function setPropertiesAsync(propertiesToSet: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncAction;
  end;

  JIPixelDataProvider = class external
    function detachPixelData: JUint8Array;
  end;

  JIBitmapFrame = class external
    bitmapAlphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode;
    bitmapPixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat;
    bitmapProperties: JWindows.Graphics.Imaging.BitmapPropertiesView;
    dpiX: Float;
    dpiY: Float;
    orientedPixelHeight: Float;
    orientedPixelWidth: Float;
    pixelHeight: Float;
    pixelWidth: Float;
    function getThumbnailAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.ImageStream>};
    function getPixelDataAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
    function getPixelDataAsync(pixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat; alphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode; transform: JWindows.Graphics.Imaging.BitmapTransform; exifOrientationMode: JWindows.Graphics.Imaging.ExifOrientationMode; colorManagementMode: JWindows.Graphics.Imaging.ColorManagementMode): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.PixelDataProvider>};
  end;

  JIBitmapCodecInformation = class external
    codecId: String;
    fileExtensions: JWindows.Foundation.Collections.IVectorView{<String>};
    friendlyName: String;
    mimeTypes: JWindows.Foundation.Collections.IVectorView{<String>};
  end;

  JIBitmapDecoderStatics = class external
    bmpDecoderId: String;
    gifDecoderId: String;
    icoDecoderId: String;
    jpegDecoderId: String;
    jpegXRDecoderId: String;
    pngDecoderId: String;
    tiffDecoderId: String;
    function getDecoderInformationEnumerator: JWindows.Foundation.Collections.IVectorView{<JWindows.Graphics.Imaging.BitmapCodecInformation>};
    function createAsync(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapDecoder>};
    function createAsync(decoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapDecoder>};
  end;

  JIBitmapDecoder = class external
    bitmapContainerProperties: JWindows.Graphics.Imaging.BitmapPropertiesView;
    decoderInformation: JWindows.Graphics.Imaging.BitmapCodecInformation;
    frameCount: Float;
    function getPreviewAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.ImageStream>};
    function getFrameAsync(frameIndex: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapFrame>};
  end;

  JIBitmapEncoderStatics = class external
    bmpEncoderId: String;
    gifEncoderId: String;
    jpegEncoderId: String;
    jpegXREncoderId: String;
    pngEncoderId: String;
    tiffEncoderId: String;
    function getEncoderInformationEnumerator: JWindows.Foundation.Collections.IVectorView{<JWindows.Graphics.Imaging.BitmapCodecInformation>};
    function createAsync(encoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createAsync(encoderId: String; stream: JWindows.Storage.Streams.IRandomAccessStream; encodingOptions: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createForTranscodingAsync(stream: JWindows.Storage.Streams.IRandomAccessStream; bitmapDecoder: JWindows.Graphics.Imaging.BitmapDecoder): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
    function createForInPlacePropertyEncodingAsync(bitmapDecoder: JWindows.Graphics.Imaging.BitmapDecoder): JWindows.Foundation.IAsyncOperation{<JWindows.Graphics.Imaging.BitmapEncoder>};
  end;

  JIBitmapEncoder = class external
    bitmapContainerProperties: JWindows.Graphics.Imaging.BitmapProperties;
    bitmapProperties: JWindows.Graphics.Imaging.BitmapProperties;
    bitmapTransform: JWindows.Graphics.Imaging.BitmapTransform;
    encoderInformation: JWindows.Graphics.Imaging.BitmapCodecInformation;
    generatedThumbnailHeight: Float;
    generatedThumbnailWidth: Float;
    isThumbnailGenerated: Boolean;
    procedure setPixelData(pixelFormat: JWindows.Graphics.Imaging.BitmapPixelFormat; alphaMode: JWindows.Graphics.Imaging.BitmapAlphaMode; width: Float; height: Float; dpiX: Float; dpiY: Float; pixels: JUint8Array);
    function goToNextFrameAsync: JWindows.Foundation.IAsyncAction;
    function goToNextFrameAsync(encodingOptions: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Graphics.Imaging.BitmapTypedValue>}>}): JWindows.Foundation.IAsyncAction;
    function flushAsync: JWindows.Foundation.IAsyncAction;
  end;

//Windows

//Graphics

//Printing

//OptionDetails

type
  JPrintCopiesOptionDetails = class external 'PrintCopiesOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    maxValue: Float;
    minValue: Float;
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintMediaSizeOptionDetails = class external 'PrintMediaSizeOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintMediaTypeOptionDetails = class external 'PrintMediaTypeOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintOrientationOptionDetails = class external 'PrintOrientationOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintQualityOptionDetails = class external 'PrintQualityOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintColorModeOptionDetails = class external 'PrintColorModeOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintDuplexOptionDetails = class external 'PrintDuplexOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintCollationOptionDetails = class external 'PrintCollationOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintStapleOptionDetails = class external 'PrintStapleOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintHolePunchOptionDetails = class external 'PrintHolePunchOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintBindingOptionDetails = class external 'PrintBindingOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintCustomTextOptionDetails = class external 'PrintCustomTextOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    displayName: String;
    maxCharacters: Float;
    function trySetValue(value: Variant): Boolean;
  end;

  JPrintCustomItemDetails = class external 'PrintCustomItemDetails'
    itemDisplayName: String;
    itemId: String;
  end;

  JPrintCustomItemListOptionDetails = class external 'PrintCustomItemListOptionDetails'
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    displayName: String;
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
    function trySetValue(value: Variant): Boolean;
    procedure addItem(itemId: String; displayName: String);
  end;

  JPrintTaskOptionChangedEventArgs = class external 'PrintTaskOptionChangedEventArgs'
    optionId: Variant;
  end;

  JPrintTaskOptionDetails = class external 'PrintTaskOptionDetails'
    options: JWindows.Foundation.Collections.IMapView{<StringJWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails>};
    displayedOptions: JWindows.Foundation.Collections.IVector{<String>};
    function createItemListOption(optionId: String; displayName: String): JWindows.Graphics.Printing.OptionDetails.PrintCustomItemListOptionDetails;
    function createTextOption(optionId: String; displayName: String): JWindows.Graphics.Printing.OptionDetails.PrintCustomTextOptionDetails;
    onoptionchanged: Variant;
    onbeginvalidation: Variant;
    function getPageDescription(jobPageNumber: Float): JWindows.Graphics.Printing.PrintPageDescription;
    function getFromPrintTaskOptions(printTaskOptions: JWindows.Graphics.Printing.PrintTaskOptions): JWindows.Graphics.Printing.OptionDetails.PrintTaskOptionDetails;
  end;

  JIPrintOptionDetails = class external
    errorText: String;
    optionId: String;
    optionType: JWindows.Graphics.Printing.OptionDetails.PrintOptionType;
    state: JWindows.Graphics.Printing.OptionDetails.PrintOptionStates;
    value: Variant;
    function trySetValue(value: Variant): Boolean;
  end;

  JIPrintNumberOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails)
    maxValue: Float;
    minValue: Float;
  end;

  JIPrintTextOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails)
    maxCharacters: Float;
  end;

  JIPrintItemListOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails)
    items: JWindows.Foundation.Collections.IVectorView{<Variant>};
  end;

  JIPrintCustomOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails)
    displayName: String;
  end;

  JIPrintCustomTextOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintCustomOptionDetails, JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails)
    maxCharacters: Float;
  end;

  JIPrintCustomItemDetails = class external
    itemDisplayName: String;
    itemId: String;
  end;

  JIPrintCustomItemListOptionDetails = class external(JWindows.Graphics.Printing.OptionDetails.IPrintItemListOptionDetails, JWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails, JWindows.Graphics.Printing.OptionDetails.IPrintCustomOptionDetails)
    procedure addItem(itemId: String; displayName: String);
  end;

  JIPrintTaskOptionChangedEventArgs = class external
    optionId: Variant;
  end;

  JIPrintTaskOptionDetails = class external
    options: JWindows.Foundation.Collections.IMapView{<StringJWindows.Graphics.Printing.OptionDetails.IPrintOptionDetails>};
    function createItemListOption(optionId: String; displayName: String): JWindows.Graphics.Printing.OptionDetails.PrintCustomItemListOptionDetails;
    function createTextOption(optionId: String; displayName: String): JWindows.Graphics.Printing.OptionDetails.PrintCustomTextOptionDetails;
    onoptionchanged: Variant;
    onbeginvalidation: Variant;
  end;

  JIPrintTaskOptionDetailsStatic = class external
    function getFromPrintTaskOptions(printTaskOptions: JWindows.Graphics.Printing.PrintTaskOptions): JWindows.Graphics.Printing.OptionDetails.PrintTaskOptionDetails;
  end;

//Windows

//Graphics

//Printing

type
  JPrintTaskOptions = class external 'PrintTaskOptions'
    binding: JWindows.Graphics.Printing.PrintBinding;
    collation: JWindows.Graphics.Printing.PrintCollation;
    colorMode: JWindows.Graphics.Printing.PrintColorMode;
    duplex: JWindows.Graphics.Printing.PrintDuplex;
    holePunch: JWindows.Graphics.Printing.PrintHolePunch;
    maxCopies: Float;
    mediaSize: JWindows.Graphics.Printing.PrintMediaSize;
    mediaType: JWindows.Graphics.Printing.PrintMediaType;
    minCopies: Float;
    numberOfCopies: Float;
    orientation: JWindows.Graphics.Printing.PrintOrientation;
    printQuality: JWindows.Graphics.Printing.PrintQuality;
    staple: JWindows.Graphics.Printing.PrintStaple;
    displayedOptions: JWindows.Foundation.Collections.IVector{<String>};
    function getPageDescription(jobPageNumber: Float): JWindows.Graphics.Printing.PrintPageDescription;
  end;

  JStandardPrintTaskOptions = class external 'StandardPrintTaskOptions'
    binding: String;
    collation: String;
    colorMode: String;
    copies: String;
    duplex: String;
    holePunch: String;
    inputBin: String;
    mediaSize: String;
    mediaType: String;
    nUp: String;
    orientation: String;
    printQuality: String;
    staple: String;
  end;

  JPrintTaskProgressingEventArgs = class external 'PrintTaskProgressingEventArgs'
    documentPageCount: Float;
  end;

  JPrintTaskCompletedEventArgs = class external 'PrintTaskCompletedEventArgs'
    completion: JWindows.Graphics.Printing.PrintTaskCompletion;
  end;

  JPrintTask = class external 'PrintTask'
    options: JWindows.Graphics.Printing.PrintTaskOptions;
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySet;
    source: JWindows.Graphics.Printing.IPrintDocumentSource;
    onpreviewing: Variant;
    onsubmitting: Variant;
    onprogressing: Variant;
    oncompleted: Variant;
  end;

  JPrintTaskSourceRequestedDeferral = class external 'PrintTaskSourceRequestedDeferral'
    procedure complete;
  end;

  JPrintTaskSourceRequestedArgs = class external 'PrintTaskSourceRequestedArgs'
    deadline: JDate;
    procedure setSource(source: JWindows.Graphics.Printing.IPrintDocumentSource);
    function getDeferral: JWindows.Graphics.Printing.PrintTaskSourceRequestedDeferral;
  end;

  JPrintTaskRequestedDeferral = class external 'PrintTaskRequestedDeferral'
    procedure complete;
  end;

  JPrintTaskRequest = class external 'PrintTaskRequest'
    deadline: JDate;
    function createPrintTask(title: String; handler: JWindows.Graphics.Printing.PrintTaskSourceRequestedHandler): JWindows.Graphics.Printing.PrintTask;
    function getDeferral: JWindows.Graphics.Printing.PrintTaskRequestedDeferral;
  end;

  JPrintTaskRequestedEventArgs = class external 'PrintTaskRequestedEventArgs'
    request: JWindows.Graphics.Printing.PrintTaskRequest;
  end;

  JPrintManager = class external 'PrintManager'
    onprinttaskrequested: Variant;
    function getForCurrentView: JWindows.Graphics.Printing.PrintManager;
    function showPrintUIAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

  JPrintPageDescription = class external
    pageSize: JWindows.Foundation.Size;
    imageableRect: JWindows.Foundation.Rect;
    dpiX: Float;
    dpiY: Float;
  end;

  JIPrintTaskOptionsCoreProperties = class external
    binding: JWindows.Graphics.Printing.PrintBinding;
    collation: JWindows.Graphics.Printing.PrintCollation;
    colorMode: JWindows.Graphics.Printing.PrintColorMode;
    duplex: JWindows.Graphics.Printing.PrintDuplex;
    holePunch: JWindows.Graphics.Printing.PrintHolePunch;
    maxCopies: Float;
    mediaSize: JWindows.Graphics.Printing.PrintMediaSize;
    mediaType: JWindows.Graphics.Printing.PrintMediaType;
    minCopies: Float;
    numberOfCopies: Float;
    orientation: JWindows.Graphics.Printing.PrintOrientation;
    printQuality: JWindows.Graphics.Printing.PrintQuality;
    staple: JWindows.Graphics.Printing.PrintStaple;
  end;

  JIPrintTaskOptionsCoreUIConfiguration = class external
    displayedOptions: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JIPrintTaskOptionsCore = class external
    function getPageDescription(jobPageNumber: Float): JWindows.Graphics.Printing.PrintPageDescription;
  end;

  JIStandardPrintTaskOptionsStatic = class external
    binding: String;
    collation: String;
    colorMode: String;
    copies: String;
    duplex: String;
    holePunch: String;
    inputBin: String;
    mediaSize: String;
    mediaType: String;
    nUp: String;
    orientation: String;
    printQuality: String;
    staple: String;
  end;

  JIPrintDocumentSource = class external
  end;

  JIPrintTaskProgressingEventArgs = class external
    documentPageCount: Float;
  end;

  JIPrintTaskCompletedEventArgs = class external
    completion: JWindows.Graphics.Printing.PrintTaskCompletion;
  end;

  JIPrintTask = class external
    options: JWindows.Graphics.Printing.PrintTaskOptions;
    properties: JWindows.ApplicationModel.DataTransfer.DataPackagePropertySet;
    source: JWindows.Graphics.Printing.IPrintDocumentSource;
    onpreviewing: Variant;
    onsubmitting: Variant;
    onprogressing: Variant;
    oncompleted: Variant;
  end;

  JIPrintTaskSourceRequestedDeferral = class external
    procedure complete;
  end;

  JIPrintTaskSourceRequestedArgs = class external
    deadline: JDate;
    procedure setSource(source: JWindows.Graphics.Printing.IPrintDocumentSource);
    function getDeferral: JWindows.Graphics.Printing.PrintTaskSourceRequestedDeferral;
  end;

  JPrintTaskSourceRequestedHandler = class external
(args: JWindows.Graphics.Printing.PrintTaskSourceRequestedArgs)  end;

  JIPrintTaskRequestedDeferral = class external
    procedure complete;
  end;

  JIPrintTaskRequest = class external
    deadline: JDate;
    function createPrintTask(title: String; handler: JWindows.Graphics.Printing.PrintTaskSourceRequestedHandler): JWindows.Graphics.Printing.PrintTask;
    function getDeferral: JWindows.Graphics.Printing.PrintTaskRequestedDeferral;
  end;

  JIPrintTaskRequestedEventArgs = class external
    request: JWindows.Graphics.Printing.PrintTaskRequest;
  end;

  JIPrintManagerStatic = class external
    function getForCurrentView: JWindows.Graphics.Printing.PrintManager;
    function showPrintUIAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

  JIPrintManager = class external
    onprinttaskrequested: Variant;
  end;

//Windows

//Management

//Deployment

type
  JDeploymentResult = class external 'DeploymentResult'
    activityId: String;
    errorText: String;
    extendedErrorCode: Float;
  end;

  JPackageUserInformation = class external 'PackageUserInformation'
    installState: JWindows.Management.Deployment.PackageInstallState;
    userSecurityId: String;
  end;

  JPackageManager = class external 'PackageManager'
    function addPackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function updatePackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function removePackageAsync(packageFullName: String): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function stagePackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function registerPackageAsync(manifestUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function findPackages: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackages(packageName: String; packagePublisher: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String; packageName: String; packagePublisher: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findUsers(packageFullName: String): JWindows.Foundation.Collections.IIterable{<JWindows.Management.Deployment.PackageUserInformation>};
    procedure setPackageState(packageFullName: String; packageState: JWindows.Management.Deployment.PackageState);
    function findPackage(packageFullName: String): JWindows.ApplicationModel.Package;
    function cleanupPackageForUserAsync(packageName: String; userSecurityId: String): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function findPackages(packageFamilyName: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String; packageFamilyName: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackageForUser(userSecurityId: String; packageFullName: String): JWindows.ApplicationModel.Package;
  end;

  JDeploymentProgress = class external
    state: JWindows.Management.Deployment.DeploymentProgressState;
    percentage: Float;
  end;

  JIDeploymentResult = class external
    activityId: String;
    errorText: String;
    extendedErrorCode: Float;
  end;

  JIPackageUserInformation = class external
    installState: JWindows.Management.Deployment.PackageInstallState;
    userSecurityId: String;
  end;

  JIPackageManager = class external
    function addPackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function updatePackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function removePackageAsync(packageFullName: String): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function stagePackageAsync(packageUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function registerPackageAsync(manifestUri: JWindows.Foundation.Uri; dependencyPackageUris: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; deploymentOptions: JWindows.Management.Deployment.DeploymentOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function findPackages: JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackages(packageName: String; packagePublisher: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String; packageName: String; packagePublisher: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findUsers(packageFullName: String): JWindows.Foundation.Collections.IIterable{<JWindows.Management.Deployment.PackageUserInformation>};
    procedure setPackageState(packageFullName: String; packageState: JWindows.Management.Deployment.PackageState);
    function findPackage(packageFullName: String): JWindows.ApplicationModel.Package;
    function cleanupPackageForUserAsync(packageName: String; userSecurityId: String): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Management.Deployment.DeploymentResultJWindows.Management.Deployment.DeploymentProgress>};
    function findPackages(packageFamilyName: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackagesForUser(userSecurityId: String; packageFamilyName: String): JWindows.Foundation.Collections.IIterable{<JWindows.ApplicationModel.Package>};
    function findPackageForUser(userSecurityId: String; packageFullName: String): JWindows.ApplicationModel.Package;
  end;

//Windows

//Management

//Core

type
  JApplicationDataManager = class external 'ApplicationDataManager'
    function createForPackageFamily(packageFamilyName: String): JWindows.Storage.ApplicationData;
  end;

  JIApplicationDataManagerStatics = class external
    function createForPackageFamily(packageFamilyName: String): JWindows.Storage.ApplicationData;
  end;

  JIApplicationDataManager = class external
  end;

//Windows

//Media

//Capture

type
  JCameraCaptureUIPhotoCaptureSettings = class external 'CameraCaptureUIPhotoCaptureSettings'
    allowCropping: Boolean;
    croppedAspectRatio: JWindows.Foundation.Size;
    croppedSizeInPixels: JWindows.Foundation.Size;
    format: JWindows.Media.Capture.CameraCaptureUIPhotoFormat;
    maxResolution: JWindows.Media.Capture.CameraCaptureUIMaxPhotoResolution;
  end;

  JCameraCaptureUIVideoCaptureSettings = class external 'CameraCaptureUIVideoCaptureSettings'
    allowTrimming: Boolean;
    format: JWindows.Media.Capture.CameraCaptureUIVideoFormat;
    maxDurationInSeconds: Float;
    maxResolution: JWindows.Media.Capture.CameraCaptureUIMaxVideoResolution;
  end;

  JCameraCaptureUI = class external 'CameraCaptureUI'
    photoSettings: JWindows.Media.Capture.CameraCaptureUIPhotoCaptureSettings;
    videoSettings: JWindows.Media.Capture.CameraCaptureUIVideoCaptureSettings;
    function captureFileAsync(mode: JWindows.Media.Capture.CameraCaptureUIMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JCameraOptionsUI = class external 'CameraOptionsUI'
    procedure show(mediaCapture: JWindows.Media.Capture.MediaCapture);
  end;

  JMediaCaptureFailedEventArgs = class external 'MediaCaptureFailedEventArgs'
    code: Float;
    message: String;
  end;

  JMediaCapture = class external 'MediaCapture'
    audioDeviceController: JWindows.Media.Devices.AudioDeviceController;
    mediaCaptureSettings: JWindows.Media.Capture.MediaCaptureSettings;
    videoDeviceController: JWindows.Media.Devices.VideoDeviceController;
    function initializeAsync: JWindows.Foundation.IAsyncAction;
    function initializeAsync(mediaCaptureInitializationSettings: JWindows.Media.Capture.MediaCaptureInitializationSettings): JWindows.Foundation.IAsyncAction;
    function startRecordToStorageFileAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function startRecordToStreamAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
    function startRecordToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customMediaSink: JWindows.Media.IMediaExtension): JWindows.Foundation.IAsyncAction;
    function startRecordToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customSinkActivationId: String; customSinkSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function stopRecordAsync: JWindows.Foundation.IAsyncAction;
    function capturePhotoToStorageFileAsync(&type: JWindows.Media.MediaProperties.ImageEncodingProperties; file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function capturePhotoToStreamAsync(&type: JWindows.Media.MediaProperties.ImageEncodingProperties; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
    function addEffectAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType; effectActivationID: String; effectSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function clearEffectsAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Foundation.IAsyncAction;
    procedure setEncoderProperty(mediaStreamType: JWindows.Media.Capture.MediaStreamType; propertyId: String; propertyValue: Variant);
    function getEncoderProperty(mediaStreamType: JWindows.Media.Capture.MediaStreamType; propertyId: String): Variant;
    onfailed: Variant;
    onrecordlimitationexceeded: Variant;
    procedure setPreviewMirroring(value: Boolean);
    function getPreviewMirroring: Boolean;
    procedure setPreviewRotation(value: JWindows.Media.Capture.VideoRotation);
    function getPreviewRotation: JWindows.Media.Capture.VideoRotation;
    procedure setRecordRotation(value: JWindows.Media.Capture.VideoRotation);
    function getRecordRotation: JWindows.Media.Capture.VideoRotation;
    function startPreviewAsync: JWindows.Foundation.IAsyncAction;
    function startPreviewToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customMediaSink: JWindows.Media.IMediaExtension): JWindows.Foundation.IAsyncAction;
    function startPreviewToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customSinkActivationId: String; customSinkSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function stopPreviewAsync: JWindows.Foundation.IAsyncAction;
  end;

  JMediaCaptureInitializationSettings = class external 'MediaCaptureInitializationSettings'
    audioDeviceId: String;
    photoCaptureSource: JWindows.Media.Capture.PhotoCaptureSource;
    streamingCaptureMode: JWindows.Media.Capture.StreamingCaptureMode;
    videoDeviceId: String;
  end;

  JMediaCaptureSettings = class external 'MediaCaptureSettings'
    audioDeviceId: String;
    photoCaptureSource: JWindows.Media.Capture.PhotoCaptureSource;
    streamingCaptureMode: JWindows.Media.Capture.StreamingCaptureMode;
    videoDeviceCharacteristic: JWindows.Media.Capture.VideoDeviceCharacteristic;
    videoDeviceId: String;
  end;

  JICameraCaptureUIPhotoCaptureSettings = class external
    allowCropping: Boolean;
    croppedAspectRatio: JWindows.Foundation.Size;
    croppedSizeInPixels: JWindows.Foundation.Size;
    format: JWindows.Media.Capture.CameraCaptureUIPhotoFormat;
    maxResolution: JWindows.Media.Capture.CameraCaptureUIMaxPhotoResolution;
  end;

  JICameraCaptureUIVideoCaptureSettings = class external
    allowTrimming: Boolean;
    format: JWindows.Media.Capture.CameraCaptureUIVideoFormat;
    maxDurationInSeconds: Float;
    maxResolution: JWindows.Media.Capture.CameraCaptureUIMaxVideoResolution;
  end;

  JICameraCaptureUI = class external
    photoSettings: JWindows.Media.Capture.CameraCaptureUIPhotoCaptureSettings;
    videoSettings: JWindows.Media.Capture.CameraCaptureUIVideoCaptureSettings;
    function captureFileAsync(mode: JWindows.Media.Capture.CameraCaptureUIMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JICameraOptionsUIStatics = class external
    procedure show(mediaCapture: JWindows.Media.Capture.MediaCapture);
  end;

  JIMediaCaptureFailedEventArgs = class external
    code: Float;
    message: String;
  end;

  JMediaCaptureFailedEventHandler = class external
(sender: JWindows.Media.Capture.MediaCapture; errorEventArgs: JWindows.Media.Capture.MediaCaptureFailedEventArgs)  end;

  JRecordLimitationExceededEventHandler = class external
(sender: JWindows.Media.Capture.MediaCapture)  end;

  JIMediaCaptureInitializationSettings = class external
    audioDeviceId: String;
    photoCaptureSource: JWindows.Media.Capture.PhotoCaptureSource;
    streamingCaptureMode: JWindows.Media.Capture.StreamingCaptureMode;
    videoDeviceId: String;
  end;

  JIMediaCapture = class external
    audioDeviceController: JWindows.Media.Devices.AudioDeviceController;
    mediaCaptureSettings: JWindows.Media.Capture.MediaCaptureSettings;
    videoDeviceController: JWindows.Media.Devices.VideoDeviceController;
    function initializeAsync: JWindows.Foundation.IAsyncAction;
    function initializeAsync(mediaCaptureInitializationSettings: JWindows.Media.Capture.MediaCaptureInitializationSettings): JWindows.Foundation.IAsyncAction;
    function startRecordToStorageFileAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function startRecordToStreamAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
    function startRecordToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customMediaSink: JWindows.Media.IMediaExtension): JWindows.Foundation.IAsyncAction;
    function startRecordToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customSinkActivationId: String; customSinkSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function stopRecordAsync: JWindows.Foundation.IAsyncAction;
    function capturePhotoToStorageFileAsync(&type: JWindows.Media.MediaProperties.ImageEncodingProperties; file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function capturePhotoToStreamAsync(&type: JWindows.Media.MediaProperties.ImageEncodingProperties; stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
    function addEffectAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType; effectActivationID: String; effectSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function clearEffectsAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Foundation.IAsyncAction;
    procedure setEncoderProperty(mediaStreamType: JWindows.Media.Capture.MediaStreamType; propertyId: String; propertyValue: Variant);
    function getEncoderProperty(mediaStreamType: JWindows.Media.Capture.MediaStreamType; propertyId: String): Variant;
    onfailed: Variant;
    onrecordlimitationexceeded: Variant;
    procedure setPreviewMirroring(value: Boolean);
    function getPreviewMirroring: Boolean;
    procedure setPreviewRotation(value: JWindows.Media.Capture.VideoRotation);
    function getPreviewRotation: JWindows.Media.Capture.VideoRotation;
    procedure setRecordRotation(value: JWindows.Media.Capture.VideoRotation);
    function getRecordRotation: JWindows.Media.Capture.VideoRotation;
  end;

  JIMediaCaptureVideoPreview = class external
    function startPreviewAsync: JWindows.Foundation.IAsyncAction;
    function startPreviewToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customMediaSink: JWindows.Media.IMediaExtension): JWindows.Foundation.IAsyncAction;
    function startPreviewToCustomSinkAsync(encodingProfile: JWindows.Media.MediaProperties.MediaEncodingProfile; customSinkActivationId: String; customSinkSettings: JWindows.Foundation.Collections.IPropertySet): JWindows.Foundation.IAsyncAction;
    function stopPreviewAsync: JWindows.Foundation.IAsyncAction;
  end;

  JIMediaCaptureSettings = class external
    audioDeviceId: String;
    photoCaptureSource: JWindows.Media.Capture.PhotoCaptureSource;
    streamingCaptureMode: JWindows.Media.Capture.StreamingCaptureMode;
    videoDeviceCharacteristic: JWindows.Media.Capture.VideoDeviceCharacteristic;
    videoDeviceId: String;
  end;

//Windows

//Media

//Devices

type
  JDialRequestedEventArgs = class external 'DialRequestedEventArgs'
    contact: Variant;
    procedure handled;
  end;

  JRedialRequestedEventArgs = class external 'RedialRequestedEventArgs'
    procedure handled;
  end;

  JKeypadPressedEventArgs = class external 'KeypadPressedEventArgs'
    telephonyKey: JWindows.Media.Devices.TelephonyKey;
  end;

  JCallControl = class external 'CallControl'
    hasRinger: Boolean;
    function indicateNewIncomingCall(enableRinger: Boolean; callerId: String): Float;
    function indicateNewOutgoingCall: Float;
    procedure indicateActiveCall(callToken: Float);
    procedure endCall(callToken: Float);
    onanswerrequested: Variant;
    onhanguprequested: Variant;
    ondialrequested: Variant;
    onredialrequested: Variant;
    onkeypadpressed: Variant;
    onaudiotransferrequested: Variant;
    function getDefault: JWindows.Media.Devices.CallControl;
    function fromId(deviceInterfaceId: String): JWindows.Media.Devices.CallControl;
  end;

  JDefaultAudioCaptureDeviceChangedEventArgs = class external 'DefaultAudioCaptureDeviceChangedEventArgs'
    id: String;
    role: JWindows.Media.Devices.AudioDeviceRole;
  end;

  JDefaultAudioRenderDeviceChangedEventArgs = class external 'DefaultAudioRenderDeviceChangedEventArgs'
    id: String;
    role: JWindows.Media.Devices.AudioDeviceRole;
  end;

  JMediaDevice = class external 'MediaDevice'
    function getAudioCaptureSelector: String;
    function getAudioRenderSelector: String;
    function getVideoCaptureSelector: String;
    function getDefaultAudioCaptureId(role: JWindows.Media.Devices.AudioDeviceRole): String;
    function getDefaultAudioRenderId(role: JWindows.Media.Devices.AudioDeviceRole): String;
    ondefaultaudiocapturedevicechanged: Variant;
    ondefaultaudiorenderdevicechanged: Variant;
  end;

  JAudioDeviceController = class external 'AudioDeviceController'
    muted: Boolean;
    volumePercent: Float;
    function getAvailableMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Foundation.Collections.IVectorView{<JWindows.Media.MediaProperties.IMediaEncodingProperties>};
    function getMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Media.MediaProperties.IMediaEncodingProperties;
    function setMediaStreamPropertiesAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType; mediaEncodingProperties: JWindows.Media.MediaProperties.IMediaEncodingProperties): JWindows.Foundation.IAsyncAction;
  end;

  JVideoDeviceController = class external 'VideoDeviceController'
    backlightCompensation: JWindows.Media.Devices.MediaDeviceControl;
    brightness: JWindows.Media.Devices.MediaDeviceControl;
    contrast: JWindows.Media.Devices.MediaDeviceControl;
    exposure: JWindows.Media.Devices.MediaDeviceControl;
    focus: JWindows.Media.Devices.MediaDeviceControl;
    hue: JWindows.Media.Devices.MediaDeviceControl;
    pan: JWindows.Media.Devices.MediaDeviceControl;
    roll: JWindows.Media.Devices.MediaDeviceControl;
    tilt: JWindows.Media.Devices.MediaDeviceControl;
    whiteBalance: JWindows.Media.Devices.MediaDeviceControl;
    zoom: JWindows.Media.Devices.MediaDeviceControl;
    function trySetPowerlineFrequency(value: JWindows.Media.Capture.PowerlineFrequency): Boolean;
    function tryGetPowerlineFrequency:       value: JWindows.Media.Capture.PowerlineFrequency;
      succeeded: Boolean;
    end;;
    function getAvailableMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Foundation.Collections.IVectorView{<JWindows.Media.MediaProperties.IMediaEncodingProperties>};
    function getMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Media.MediaProperties.IMediaEncodingProperties;
    function setMediaStreamPropertiesAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType; mediaEncodingProperties: JWindows.Media.MediaProperties.IMediaEncodingProperties): JWindows.Foundation.IAsyncAction;
    procedure setDeviceProperty(propertyId: String; propertyValue: Variant);
    function getDeviceProperty(propertyId: String): Variant;
  end;

  JMediaDeviceControl = class external 'MediaDeviceControl'
    capabilities: JWindows.Media.Devices.MediaDeviceControlCapabilities;
    function tryGetValue:       value: Float;
      succeeded: Boolean;
    end;;
    function trySetValue(value: Float): Boolean;
    function tryGetAuto:       value: Boolean;
      succeeded: Boolean;
    end;;
    function trySetAuto(value: Boolean): Boolean;
  end;

  JMediaDeviceControlCapabilities = class external 'MediaDeviceControlCapabilities'
    autoModeSupported: Boolean;
    &default: Float;
    max: Float;
    min: Float;
    step: Float;
    supported: Boolean;
  end;

  JIDialRequestedEventArgs = class external
    contact: Variant;
    procedure handled;
  end;

  JIRedialRequestedEventArgs = class external
    procedure handled;
  end;

  JIKeypadPressedEventArgs = class external
    telephonyKey: JWindows.Media.Devices.TelephonyKey;
  end;

  JCallControlEventHandler = class external
(sender: JWindows.Media.Devices.CallControl)  end;

  JDialRequestedEventHandler = class external
(sender: JWindows.Media.Devices.CallControl; e: JWindows.Media.Devices.DialRequestedEventArgs)  end;

  JRedialRequestedEventHandler = class external
(sender: JWindows.Media.Devices.CallControl; e: JWindows.Media.Devices.RedialRequestedEventArgs)  end;

  JKeypadPressedEventHandler = class external
(sender: JWindows.Media.Devices.CallControl; e: JWindows.Media.Devices.KeypadPressedEventArgs)  end;

  JICallControl = class external
    hasRinger: Boolean;
    function indicateNewIncomingCall(enableRinger: Boolean; callerId: String): Float;
    function indicateNewOutgoingCall: Float;
    procedure indicateActiveCall(callToken: Float);
    procedure endCall(callToken: Float);
    onanswerrequested: Variant;
    onhanguprequested: Variant;
    ondialrequested: Variant;
    onredialrequested: Variant;
    onkeypadpressed: Variant;
    onaudiotransferrequested: Variant;
  end;

  JICallControlStatics = class external
    function getDefault: JWindows.Media.Devices.CallControl;
    function fromId(deviceInterfaceId: String): JWindows.Media.Devices.CallControl;
  end;

  JIDefaultAudioDeviceChangedEventArgs = class external
    id: String;
    role: JWindows.Media.Devices.AudioDeviceRole;
  end;

  JIMediaDeviceStatics = class external
    function getAudioCaptureSelector: String;
    function getAudioRenderSelector: String;
    function getVideoCaptureSelector: String;
    function getDefaultAudioCaptureId(role: JWindows.Media.Devices.AudioDeviceRole): String;
    function getDefaultAudioRenderId(role: JWindows.Media.Devices.AudioDeviceRole): String;
    ondefaultaudiocapturedevicechanged: Variant;
    ondefaultaudiorenderdevicechanged: Variant;
  end;

  JIMediaDeviceController = class external
    function getAvailableMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Foundation.Collections.IVectorView{<JWindows.Media.MediaProperties.IMediaEncodingProperties>};
    function getMediaStreamProperties(mediaStreamType: JWindows.Media.Capture.MediaStreamType): JWindows.Media.MediaProperties.IMediaEncodingProperties;
    function setMediaStreamPropertiesAsync(mediaStreamType: JWindows.Media.Capture.MediaStreamType; mediaEncodingProperties: JWindows.Media.MediaProperties.IMediaEncodingProperties): JWindows.Foundation.IAsyncAction;
  end;

  JIAudioDeviceController = class external(JWindows.Media.Devices.IMediaDeviceController)
    muted: Boolean;
    volumePercent: Float;
  end;

  JIVideoDeviceController = class external(JWindows.Media.Devices.IMediaDeviceController)
    backlightCompensation: JWindows.Media.Devices.MediaDeviceControl;
    brightness: JWindows.Media.Devices.MediaDeviceControl;
    contrast: JWindows.Media.Devices.MediaDeviceControl;
    exposure: JWindows.Media.Devices.MediaDeviceControl;
    focus: JWindows.Media.Devices.MediaDeviceControl;
    hue: JWindows.Media.Devices.MediaDeviceControl;
    pan: JWindows.Media.Devices.MediaDeviceControl;
    roll: JWindows.Media.Devices.MediaDeviceControl;
    tilt: JWindows.Media.Devices.MediaDeviceControl;
    whiteBalance: JWindows.Media.Devices.MediaDeviceControl;
    zoom: JWindows.Media.Devices.MediaDeviceControl;
    function trySetPowerlineFrequency(value: JWindows.Media.Capture.PowerlineFrequency): Boolean;
    function tryGetPowerlineFrequency:       value: JWindows.Media.Capture.PowerlineFrequency;
      succeeded: Boolean;
    end;;
  end;

  JIMediaDeviceControl = class external
    capabilities: JWindows.Media.Devices.MediaDeviceControlCapabilities;
    function tryGetValue:       value: Float;
      succeeded: Boolean;
    end;;
    function trySetValue(value: Float): Boolean;
    function tryGetAuto:       value: Boolean;
      succeeded: Boolean;
    end;;
    function trySetAuto(value: Boolean): Boolean;
  end;

  JIMediaDeviceControlCapabilities = class external
    autoModeSupported: Boolean;
    &default: Float;
    max: Float;
    min: Float;
    step: Float;
    supported: Boolean;
  end;

  JIAdvancedVideoCaptureDeviceController = class external
    procedure setDeviceProperty(propertyId: String; propertyValue: Variant);
    function getDeviceProperty(propertyId: String): Variant;
  end;

//Windows

//Media

type
  JMediaControl = class external 'MediaControl'
    albumArt: JWindows.Foundation.Uri;
    artistName: String;
    isPlaying: Boolean;
    soundLevel: JWindows.Media.SoundLevel;
    trackName: String;
    onsoundlevelchanged: Variant;
    onplaypressed: Variant;
    onpausepressed: Variant;
    onstoppressed: Variant;
    onplaypausetogglepressed: Variant;
    onrecordpressed: Variant;
    onnexttrackpressed: Variant;
    onprevioustrackpressed: Variant;
    onfastforwardpressed: Variant;
    onrewindpressed: Variant;
    onchanneluppressed: Variant;
    onchanneldownpressed: Variant;
  end;

  JMediaExtensionManager = class external 'MediaExtensionManager'
    procedure registerSchemeHandler(activatableClassId: String; scheme: String);
    procedure registerSchemeHandler(activatableClassId: String; scheme: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerByteStreamHandler(activatableClassId: String; fileExtension: String; mimeType: String);
    procedure registerByteStreamHandler(activatableClassId: String; fileExtension: String; mimeType: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerAudioDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerAudioDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerAudioEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerAudioEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerVideoDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerVideoDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerVideoEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerVideoEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
  end;

  JVideoEffects = class external 'VideoEffects'
    videoStabilization: String;
  end;

  JIMediaControl = class external
    albumArt: JWindows.Foundation.Uri;
    artistName: String;
    isPlaying: Boolean;
    soundLevel: JWindows.Media.SoundLevel;
    trackName: String;
    onsoundlevelchanged: Variant;
    onplaypressed: Variant;
    onpausepressed: Variant;
    onstoppressed: Variant;
    onplaypausetogglepressed: Variant;
    onrecordpressed: Variant;
    onnexttrackpressed: Variant;
    onprevioustrackpressed: Variant;
    onfastforwardpressed: Variant;
    onrewindpressed: Variant;
    onchanneluppressed: Variant;
    onchanneldownpressed: Variant;
  end;

  JIMediaExtension = class external
    procedure setProperties(configuration: JWindows.Foundation.Collections.IPropertySet);
  end;

  JIMediaExtensionManager = class external
    procedure registerSchemeHandler(activatableClassId: String; scheme: String);
    procedure registerSchemeHandler(activatableClassId: String; scheme: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerByteStreamHandler(activatableClassId: String; fileExtension: String; mimeType: String);
    procedure registerByteStreamHandler(activatableClassId: String; fileExtension: String; mimeType: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerAudioDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerAudioDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerAudioEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerAudioEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerVideoDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerVideoDecoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure registerVideoEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String);
    procedure registerVideoEncoder(activatableClassId: String; inputSubtype: String; outputSubtype: String; configuration: JWindows.Foundation.Collections.IPropertySet);
  end;

  JIVideoEffectsStatics = class external
    videoStabilization: String;
  end;

//Windows

//Media

//Playlists

type
  JPlaylist = class external 'Playlist'
    files: JWindows.Foundation.Collections.IVector{<JWindows.Storage.StorageFile>};
    function saveAsync: JWindows.Foundation.IAsyncAction;
    function saveAsAsync(saveLocation: JWindows.Storage.IStorageFolder; desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function saveAsAsync(saveLocation: JWindows.Storage.IStorageFolder; desiredName: String; option: JWindows.Storage.NameCollisionOption; playlistFormat: JWindows.Media.Playlists.PlaylistFormat): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function loadAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Playlists.Playlist>};
  end;

  JIPlaylist = class external
    files: JWindows.Foundation.Collections.IVector{<JWindows.Storage.StorageFile>};
    function saveAsync: JWindows.Foundation.IAsyncAction;
    function saveAsAsync(saveLocation: JWindows.Storage.IStorageFolder; desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function saveAsAsync(saveLocation: JWindows.Storage.IStorageFolder; desiredName: String; option: JWindows.Storage.NameCollisionOption; playlistFormat: JWindows.Media.Playlists.PlaylistFormat): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JIPlaylistStatics = class external
    function loadAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Playlists.Playlist>};
  end;

//Windows

//Media

//PlayTo

type
  JPlayToConnection = class external 'PlayToConnection'
    state: JWindows.Media.PlayTo.PlayToConnectionState;
    onstatechanged: Variant;
    ontransferred: Variant;
    onerror: Variant;
  end;

  JPlayToSource = class external 'PlayToSource'
    connection: JWindows.Media.PlayTo.PlayToConnection;
    next: JWindows.Media.PlayTo.PlayToSource;
    procedure playNext;
  end;

  JPlayToConnectionStateChangedEventArgs = class external 'PlayToConnectionStateChangedEventArgs'
    currentState: JWindows.Media.PlayTo.PlayToConnectionState;
    previousState: JWindows.Media.PlayTo.PlayToConnectionState;
  end;

  JPlayToConnectionTransferredEventArgs = class external 'PlayToConnectionTransferredEventArgs'
    currentSource: JWindows.Media.PlayTo.PlayToSource;
    previousSource: JWindows.Media.PlayTo.PlayToSource;
  end;

  JPlayToConnectionErrorEventArgs = class external 'PlayToConnectionErrorEventArgs'
    code: JWindows.Media.PlayTo.PlayToConnectionError;
    message: String;
  end;

  JSourceChangeRequestedEventArgs = class external 'SourceChangeRequestedEventArgs'
    album: String;
    author: String;
    date: JDate;
    description: String;
    genre: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    rating: Float;
    stream: JWindows.Storage.Streams.IRandomAccessStreamWithContentType;
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
    title: String;
  end;

  JPlaybackRateChangeRequestedEventArgs = class external 'PlaybackRateChangeRequestedEventArgs'
    rate: Float;
  end;

  JCurrentTimeChangeRequestedEventArgs = class external 'CurrentTimeChangeRequestedEventArgs'
    time: Float;
  end;

  JMuteChangeRequestedEventArgs = class external 'MuteChangeRequestedEventArgs'
    mute: Boolean;
  end;

  JVolumeChangeRequestedEventArgs = class external 'VolumeChangeRequestedEventArgs'
    volume: Float;
  end;

  JPlayToReceiver = class external 'PlayToReceiver'
    friendlyName: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    supportsAudio: Boolean;
    supportsImage: Boolean;
    supportsVideo: Boolean;
    onplayrequested: Variant;
    onpauserequested: Variant;
    onsourcechangerequested: Variant;
    onplaybackratechangerequested: Variant;
    oncurrenttimechangerequested: Variant;
    onmutechangerequested: Variant;
    onvolumechangerequested: Variant;
    ontimeupdaterequested: Variant;
    onstoprequested: Variant;
    procedure notifyVolumeChange(volume: Float; mute: Boolean);
    procedure notifyRateChange(rate: Float);
    procedure notifyLoadedMetadata;
    procedure notifyTimeUpdate(currentTime: Float);
    procedure notifyDurationChange(duration: Float);
    procedure notifySeeking;
    procedure notifySeeked;
    procedure notifyPaused;
    procedure notifyPlaying;
    procedure notifyEnded;
    procedure notifyError;
    procedure notifyStopped;
    function startAsync: JWindows.Foundation.IAsyncAction;
    function stopAsync: JWindows.Foundation.IAsyncAction;
  end;

  JPlayToSourceSelectedEventArgs = class external 'PlayToSourceSelectedEventArgs'
    friendlyName: String;
    icon: JWindows.Storage.Streams.IRandomAccessStreamWithContentType;
    supportsAudio: Boolean;
    supportsImage: Boolean;
    supportsVideo: Boolean;
  end;

  JPlayToSourceDeferral = class external 'PlayToSourceDeferral'
    procedure complete;
  end;

  JPlayToSourceRequest = class external 'PlayToSourceRequest'
    deadline: JDate;
    procedure displayErrorString(errorString: String);
    function getDeferral: JWindows.Media.PlayTo.PlayToSourceDeferral;
    procedure setSource(value: JWindows.Media.PlayTo.PlayToSource);
  end;

  JPlayToSourceRequestedEventArgs = class external 'PlayToSourceRequestedEventArgs'
    sourceRequest: JWindows.Media.PlayTo.PlayToSourceRequest;
  end;

  JPlayToManager = class external 'PlayToManager'
    defaultSourceSelection: Boolean;
    onsourcerequested: Variant;
    onsourceselected: Variant;
    function getForCurrentView: JWindows.Media.PlayTo.PlayToManager;
    procedure showPlayToUI;
  end;

  JIPlayToSource = class external
    connection: JWindows.Media.PlayTo.PlayToConnection;
    next: JWindows.Media.PlayTo.PlayToSource;
    procedure playNext;
  end;

  JIPlayToConnectionStateChangedEventArgs = class external
    currentState: JWindows.Media.PlayTo.PlayToConnectionState;
    previousState: JWindows.Media.PlayTo.PlayToConnectionState;
  end;

  JIPlayToConnectionTransferredEventArgs = class external
    currentSource: JWindows.Media.PlayTo.PlayToSource;
    previousSource: JWindows.Media.PlayTo.PlayToSource;
  end;

  JIPlayToConnectionErrorEventArgs = class external
    code: JWindows.Media.PlayTo.PlayToConnectionError;
    message: String;
  end;

  JIPlayToConnection = class external
    state: JWindows.Media.PlayTo.PlayToConnectionState;
    onstatechanged: Variant;
    ontransferred: Variant;
    onerror: Variant;
  end;

  JISourceChangeRequestedEventArgs = class external
    album: String;
    author: String;
    date: JDate;
    description: String;
    genre: String;
    properties: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    rating: Float;
    stream: JWindows.Storage.Streams.IRandomAccessStreamWithContentType;
    thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference;
    title: String;
  end;

  JIPlaybackRateChangeRequestedEventArgs = class external
    rate: Float;
  end;

  JICurrentTimeChangeRequestedEventArgs = class external
    time: Float;
  end;

  JIMuteChangeRequestedEventArgs = class external
    mute: Boolean;
  end;

  JIVolumeChangeRequestedEventArgs = class external
    volume: Float;
  end;

  JIPlayToReceiver = class external
    friendlyName: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    supportsAudio: Boolean;
    supportsImage: Boolean;
    supportsVideo: Boolean;
    onplayrequested: Variant;
    onpauserequested: Variant;
    onsourcechangerequested: Variant;
    onplaybackratechangerequested: Variant;
    oncurrenttimechangerequested: Variant;
    onmutechangerequested: Variant;
    onvolumechangerequested: Variant;
    ontimeupdaterequested: Variant;
    onstoprequested: Variant;
    procedure notifyVolumeChange(volume: Float; mute: Boolean);
    procedure notifyRateChange(rate: Float);
    procedure notifyLoadedMetadata;
    procedure notifyTimeUpdate(currentTime: Float);
    procedure notifyDurationChange(duration: Float);
    procedure notifySeeking;
    procedure notifySeeked;
    procedure notifyPaused;
    procedure notifyPlaying;
    procedure notifyEnded;
    procedure notifyError;
    procedure notifyStopped;
    function startAsync: JWindows.Foundation.IAsyncAction;
    function stopAsync: JWindows.Foundation.IAsyncAction;
  end;

  JIPlayToSourceSelectedEventArgs = class external
    friendlyName: String;
    icon: JWindows.Storage.Streams.IRandomAccessStreamWithContentType;
    supportsAudio: Boolean;
    supportsImage: Boolean;
    supportsVideo: Boolean;
  end;

  JIPlayToSourceDeferral = class external
    procedure complete;
  end;

  JIPlayToSourceRequest = class external
    deadline: JDate;
    procedure displayErrorString(errorString: String);
    function getDeferral: JWindows.Media.PlayTo.PlayToSourceDeferral;
    procedure setSource(value: JWindows.Media.PlayTo.PlayToSource);
  end;

  JIPlayToSourceRequestedEventArgs = class external
    sourceRequest: JWindows.Media.PlayTo.PlayToSourceRequest;
  end;

  JIPlayToManager = class external
    defaultSourceSelection: Boolean;
    onsourcerequested: Variant;
    onsourceselected: Variant;
  end;

  JIPlayToManagerStatics = class external
    function getForCurrentView: JWindows.Media.PlayTo.PlayToManager;
    procedure showPlayToUI;
  end;

//Windows

//Media

//MediaProperties

type
  JMediaRatio = class external 'MediaRatio'
    denominator: Float;
    numerator: Float;
  end;

  JMediaPropertySet = class external 'MediaPropertySet'
    size: Float;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JAudioEncodingProperties = class external 'AudioEncodingProperties'
    bitrate: Float;
    bitsPerSample: Float;
    channelCount: Float;
    sampleRate: Float;
    properties: JWindows.Media.MediaProperties.MediaPropertySet;
    subtype: String;
    &type: String;
  end;

  JVideoEncodingProperties = class external 'VideoEncodingProperties'
    bitrate: Float;
    frameRate: JWindows.Media.MediaProperties.MediaRatio;
    height: Float;
    pixelAspectRatio: JWindows.Media.MediaProperties.MediaRatio;
    width: Float;
    properties: JWindows.Media.MediaProperties.MediaPropertySet;
    subtype: String;
    &type: String;
  end;

  JImageEncodingProperties = class external 'ImageEncodingProperties'
    height: Float;
    width: Float;
    properties: JWindows.Media.MediaProperties.MediaPropertySet;
    subtype: String;
    &type: String;
    function createJpeg: JWindows.Media.MediaProperties.ImageEncodingProperties;
    function createPng: JWindows.Media.MediaProperties.ImageEncodingProperties;
    function createJpegXR: JWindows.Media.MediaProperties.ImageEncodingProperties;
  end;

  JContainerEncodingProperties = class external 'ContainerEncodingProperties'
    properties: JWindows.Media.MediaProperties.MediaPropertySet;
    subtype: String;
    &type: String;
  end;

  JMediaEncodingProfile = class external 'MediaEncodingProfile'
    audio: JWindows.Media.MediaProperties.AudioEncodingProperties;
    container: JWindows.Media.MediaProperties.ContainerEncodingProperties;
    video: JWindows.Media.MediaProperties.VideoEncodingProperties;
    function createM4a(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createMp3(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createWma(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createMp4(quality: JWindows.Media.MediaProperties.VideoEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createWmv(quality: JWindows.Media.MediaProperties.VideoEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createFromFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.MediaProperties.MediaEncodingProfile>};
    function createFromStreamAsync(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Media.MediaProperties.MediaEncodingProfile>};
  end;

  JIMediaRatio = class external
    denominator: Float;
    numerator: Float;
  end;

  JIMediaEncodingProperties = class external
    properties: JWindows.Media.MediaProperties.MediaPropertySet;
    subtype: String;
    &type: String;
  end;

  JIAudioEncodingProperties = class external(JWindows.Media.MediaProperties.IMediaEncodingProperties)
    bitrate: Float;
    bitsPerSample: Float;
    channelCount: Float;
    sampleRate: Float;
  end;

  JIVideoEncodingProperties = class external(JWindows.Media.MediaProperties.IMediaEncodingProperties)
    bitrate: Float;
    frameRate: JWindows.Media.MediaProperties.MediaRatio;
    height: Float;
    pixelAspectRatio: JWindows.Media.MediaProperties.MediaRatio;
    width: Float;
  end;

  JIImageEncodingProperties = class external(JWindows.Media.MediaProperties.IMediaEncodingProperties)
    height: Float;
    width: Float;
  end;

  JIImageEncodingPropertiesStatics = class external
    function createJpeg: JWindows.Media.MediaProperties.ImageEncodingProperties;
    function createPng: JWindows.Media.MediaProperties.ImageEncodingProperties;
    function createJpegXR: JWindows.Media.MediaProperties.ImageEncodingProperties;
  end;

  JIContainerEncodingProperties = class external(JWindows.Media.MediaProperties.IMediaEncodingProperties)
  end;

  JIMediaEncodingProfileStatics = class external
    function createM4a(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createMp3(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createWma(quality: JWindows.Media.MediaProperties.AudioEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createMp4(quality: JWindows.Media.MediaProperties.VideoEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createWmv(quality: JWindows.Media.MediaProperties.VideoEncodingQuality): JWindows.Media.MediaProperties.MediaEncodingProfile;
    function createFromFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.MediaProperties.MediaEncodingProfile>};
    function createFromStreamAsync(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.Media.MediaProperties.MediaEncodingProfile>};
  end;

  JIMediaEncodingProfile = class external
    audio: JWindows.Media.MediaProperties.AudioEncodingProperties;
    container: JWindows.Media.MediaProperties.ContainerEncodingProperties;
    video: JWindows.Media.MediaProperties.VideoEncodingProperties;
  end;

//Windows

//Media

//Protection

type
  JMediaProtectionManager = class external 'MediaProtectionManager'
    properties: JWindows.Foundation.Collections.IPropertySet;
    onservicerequested: Variant;
    onrebootneeded: Variant;
    oncomponentloadfailed: Variant;
  end;

  JServiceRequestedEventArgs = class external 'ServiceRequestedEventArgs'
    completion: JWindows.Media.Protection.MediaProtectionServiceCompletion;
    request: JWindows.Media.Protection.IMediaProtectionServiceRequest;
  end;

  JComponentLoadFailedEventArgs = class external 'ComponentLoadFailedEventArgs'
    completion: JWindows.Media.Protection.MediaProtectionServiceCompletion;
    information: JWindows.Media.Protection.RevocationAndRenewalInformation;
  end;

  JMediaProtectionServiceCompletion = class external 'MediaProtectionServiceCompletion'
    procedure complete(success: Boolean);
  end;

  JRevocationAndRenewalInformation = class external 'RevocationAndRenewalInformation'
    items: JWindows.Foundation.Collections.IVector{<JWindows.Media.Protection.RevocationAndRenewalItem>};
  end;

  JRevocationAndRenewalItem = class external 'RevocationAndRenewalItem'
    headerHash: String;
    name: String;
    publicKeyHash: String;
    reasons: JWindows.Media.Protection.RevocationAndRenewalReasons;
    renewalId: String;
  end;

  JComponentRenewal = class external 'ComponentRenewal'
    function renewSystemComponentsAsync(information: JWindows.Media.Protection.RevocationAndRenewalInformation): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Media.Protection.RenewalStatusFloat>};
  end;

  JServiceRequestedEventHandler = class external
(sender: JWindows.Media.Protection.MediaProtectionManager; e: JWindows.Media.Protection.ServiceRequestedEventArgs)  end;

  JRebootNeededEventHandler = class external
(sender: JWindows.Media.Protection.MediaProtectionManager)  end;

  JComponentLoadFailedEventHandler = class external
(sender: JWindows.Media.Protection.MediaProtectionManager; e: JWindows.Media.Protection.ComponentLoadFailedEventArgs)  end;

  JIMediaProtectionManager = class external
    properties: JWindows.Foundation.Collections.IPropertySet;
    onservicerequested: Variant;
    onrebootneeded: Variant;
    oncomponentloadfailed: Variant;
  end;

  JIMediaProtectionServiceCompletion = class external
    procedure complete(success: Boolean);
  end;

  JIServiceRequestedEventArgs = class external
    completion: JWindows.Media.Protection.MediaProtectionServiceCompletion;
    request: JWindows.Media.Protection.IMediaProtectionServiceRequest;
  end;

  JIMediaProtectionServiceRequest = class external
    protectionSystem: String;
    &type: String;
  end;

  JIComponentLoadFailedEventArgs = class external
    completion: JWindows.Media.Protection.MediaProtectionServiceCompletion;
    information: JWindows.Media.Protection.RevocationAndRenewalInformation;
  end;

  JIRevocationAndRenewalInformation = class external
    items: JWindows.Foundation.Collections.IVector{<JWindows.Media.Protection.RevocationAndRenewalItem>};
  end;

  JIRevocationAndRenewalItem = class external
    headerHash: String;
    name: String;
    publicKeyHash: String;
    reasons: JWindows.Media.Protection.RevocationAndRenewalReasons;
    renewalId: String;
  end;

  JIComponentRenewalStatics = class external
    function renewSystemComponentsAsync(information: JWindows.Media.Protection.RevocationAndRenewalInformation): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Media.Protection.RenewalStatusFloat>};
  end;

//Windows

//Media

//Transcoding

type
  JPrepareTranscodeResult = class external 'PrepareTranscodeResult'
    canTranscode: Boolean;
    failureReason: JWindows.Media.Transcoding.TranscodeFailureReason;
    function transcodeAsync: JWindows.Foundation.IAsyncActionWithProgress{<Float>};
  end;

  JMediaTranscoder = class external 'MediaTranscoder'
    alwaysReencode: Boolean;
    hardwareAccelerationEnabled: Boolean;
    trimStartTime: Float;
    trimStopTime: Float;
    procedure addAudioEffect(activatableClassId: String);
    procedure addAudioEffect(activatableClassId: String; effectRequired: Boolean; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure addVideoEffect(activatableClassId: String);
    procedure addVideoEffect(activatableClassId: String; effectRequired: Boolean; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure clearEffects;
    function prepareFileTranscodeAsync(source: JWindows.Storage.IStorageFile; destination: JWindows.Storage.IStorageFile; profile: JWindows.Media.MediaProperties.MediaEncodingProfile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Transcoding.PrepareTranscodeResult>};
    function prepareStreamTranscodeAsync(source: JWindows.Storage.Streams.IRandomAccessStream; destination: JWindows.Storage.Streams.IRandomAccessStream; profile: JWindows.Media.MediaProperties.MediaEncodingProfile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Transcoding.PrepareTranscodeResult>};
  end;

  JIMediaTranscoder = class external
    alwaysReencode: Boolean;
    hardwareAccelerationEnabled: Boolean;
    trimStartTime: Float;
    trimStopTime: Float;
    procedure addAudioEffect(activatableClassId: String);
    procedure addAudioEffect(activatableClassId: String; effectRequired: Boolean; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure addVideoEffect(activatableClassId: String);
    procedure addVideoEffect(activatableClassId: String; effectRequired: Boolean; configuration: JWindows.Foundation.Collections.IPropertySet);
    procedure clearEffects;
    function prepareFileTranscodeAsync(source: JWindows.Storage.IStorageFile; destination: JWindows.Storage.IStorageFile; profile: JWindows.Media.MediaProperties.MediaEncodingProfile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Transcoding.PrepareTranscodeResult>};
    function prepareStreamTranscodeAsync(source: JWindows.Storage.Streams.IRandomAccessStream; destination: JWindows.Storage.Streams.IRandomAccessStream; profile: JWindows.Media.MediaProperties.MediaEncodingProfile): JWindows.Foundation.IAsyncOperation{<JWindows.Media.Transcoding.PrepareTranscodeResult>};
  end;

  JIPrepareTranscodeResult = class external
    canTranscode: Boolean;
    failureReason: JWindows.Media.Transcoding.TranscodeFailureReason;
    function transcodeAsync: JWindows.Foundation.IAsyncActionWithProgress{<Float>};
  end;

//Windows

//Networking

//NetworkOperators

type
  JMobileBroadbandAccount = class external 'MobileBroadbandAccount'
    currentDeviceInformation: JWindows.Networking.NetworkOperators.MobileBroadbandDeviceInformation;
    currentNetwork: JWindows.Networking.NetworkOperators.MobileBroadbandNetwork;
    networkAccountId: String;
    serviceProviderGuid: String;
    serviceProviderName: String;
    availableNetworkAccountIds: JWindows.Foundation.Collections.IVectorView{<String>};
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.MobileBroadbandAccount;
  end;

  JMobileBroadbandNetwork = class external 'MobileBroadbandNetwork'
    accessPointName: String;
    activationNetworkError: Float;
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    networkRegistrationState: JWindows.Networking.NetworkOperators.NetworkRegistrationState;
    packetAttachNetworkError: Float;
    registeredDataClass: JWindows.Networking.NetworkOperators.DataClasses;
    registeredProviderId: String;
    registeredProviderName: String;
    registrationNetworkError: Float;
    procedure showConnectionUI;
  end;

  JMobileBroadbandDeviceInformation = class external 'MobileBroadbandDeviceInformation'
    cellularClass: JWindows.Devices.Sms.CellularClass;
    currentRadioState: JWindows.Networking.NetworkOperators.MobileBroadbandRadioState;
    customDataClass: String;
    dataClasses: JWindows.Networking.NetworkOperators.DataClasses;
    deviceId: String;
    deviceType: JWindows.Networking.NetworkOperators.MobileBroadbandDeviceType;
    firmwareInformation: String;
    manufacturer: String;
    mobileEquipmentId: String;
    model: String;
    networkDeviceStatus: JWindows.Networking.NetworkOperators.NetworkDeviceStatus;
    simIccId: String;
    subscriberId: String;
    telephoneNumbers: JWindows.Foundation.Collections.IVectorView{<String>};
  end;

  JNetworkOperatorNotificationEventDetails = class external 'NetworkOperatorNotificationEventDetails'
    encodingType: Float;
    message: String;
    networkAccountId: String;
    notificationType: JWindows.Networking.NetworkOperators.NetworkOperatorEventMessageType;
    ruleId: String;
    smsMessage: JWindows.Devices.Sms.ISmsMessage;
  end;

  JMobileBroadbandAccountEventArgs = class external 'MobileBroadbandAccountEventArgs'
    networkAccountId: String;
  end;

  JMobileBroadbandAccountUpdatedEventArgs = class external 'MobileBroadbandAccountUpdatedEventArgs'
    hasDeviceInformationChanged: Boolean;
    hasNetworkChanged: Boolean;
    networkAccountId: String;
  end;

  JMobileBroadbandAccountWatcher = class external 'MobileBroadbandAccountWatcher'
    status: JWindows.Networking.NetworkOperators.MobileBroadbandAccountWatcherStatus;
    onaccountadded: Variant;
    onaccountupdated: Variant;
    onaccountremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JHotspotAuthenticationEventDetails = class external 'HotspotAuthenticationEventDetails'
    eventToken: String;
  end;

  JHotspotAuthenticationContext = class external 'HotspotAuthenticationContext'
    authenticationUrl: JWindows.Foundation.Uri;
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    redirectMessageUrl: JWindows.Foundation.Uri;
    redirectMessageXml: JWindows.Data.Xml.Dom.XmlDocument;
    wirelessNetworkId: JUint8Array;
    procedure issueCredentials(userName: String; password: String; extraParameters: String; markAsManualConnectOnFailure: Boolean);
    procedure abortAuthentication(markAsManual: Boolean);
    procedure skipAuthentication;
    procedure triggerAttentionRequired(packageRelativeApplicationId: String; applicationParameters: String);
    function tryGetAuthenticationContext(evenToken: String):       context: JWindows.Networking.NetworkOperators.HotspotAuthenticationContext;
      isValid: Boolean;
    end;;
  end;

  JProvisionFromXmlDocumentResults = class external 'ProvisionFromXmlDocumentResults'
    allElementsProvisioned: Boolean;
    provisionResultsXml: String;
  end;

  JProvisionedProfile = class external 'ProvisionedProfile'
    procedure updateCost(value: JWindows.Networking.Connectivity.NetworkCostType);
    procedure updateUsage(value: JWindows.Networking.NetworkOperators.ProfileUsage);
  end;

  JProvisioningAgent = class external 'ProvisioningAgent'
    function provisionFromXmlDocumentAsync(provisioningXmlDocument: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.NetworkOperators.ProvisionFromXmlDocumentResults>};
    function getProvisionedProfile(mediaType: JWindows.Networking.NetworkOperators.ProfileMediaType; profileName: String): JWindows.Networking.NetworkOperators.ProvisionedProfile;
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.ProvisioningAgent;
  end;

  JUssdMessage = class external 'UssdMessage'
    constructor Create(messageText: String);
    dataCodingScheme: Float;
    payloadAsText: String;
    function getPayload: JUint8Array;
    procedure setPayload(value: JUint8Array);
  end;

  JUssdReply = class external 'UssdReply'
    message: JWindows.Networking.NetworkOperators.UssdMessage;
    resultCode: JWindows.Networking.NetworkOperators.UssdResultCode;
  end;

  JUssdSession = class external 'UssdSession'
    function sendMessageAndGetReplyAsync(message: JWindows.Networking.NetworkOperators.UssdMessage): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.NetworkOperators.UssdReply>};
    procedure close;
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.UssdSession;
    function createFromNetworkInterfaceId(networkInterfaceId: String): JWindows.Networking.NetworkOperators.UssdSession;
  end;

  JIMobileBroadbandAccountStatics = class external
    availableNetworkAccountIds: JWindows.Foundation.Collections.IVectorView{<String>};
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.MobileBroadbandAccount;
  end;

  JIMobileBroadbandAccount = class external
    currentDeviceInformation: JWindows.Networking.NetworkOperators.MobileBroadbandDeviceInformation;
    currentNetwork: JWindows.Networking.NetworkOperators.MobileBroadbandNetwork;
    networkAccountId: String;
    serviceProviderGuid: String;
    serviceProviderName: String;
  end;

  JIMobileBroadbandDeviceInformation = class external
    cellularClass: JWindows.Devices.Sms.CellularClass;
    currentRadioState: JWindows.Networking.NetworkOperators.MobileBroadbandRadioState;
    customDataClass: String;
    dataClasses: JWindows.Networking.NetworkOperators.DataClasses;
    deviceId: String;
    deviceType: JWindows.Networking.NetworkOperators.MobileBroadbandDeviceType;
    firmwareInformation: String;
    manufacturer: String;
    mobileEquipmentId: String;
    model: String;
    networkDeviceStatus: JWindows.Networking.NetworkOperators.NetworkDeviceStatus;
    simIccId: String;
    subscriberId: String;
    telephoneNumbers: JWindows.Foundation.Collections.IVectorView{<String>};
  end;

  JIMobileBroadbandNetwork = class external
    accessPointName: String;
    activationNetworkError: Float;
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    networkRegistrationState: JWindows.Networking.NetworkOperators.NetworkRegistrationState;
    packetAttachNetworkError: Float;
    registeredDataClass: JWindows.Networking.NetworkOperators.DataClasses;
    registeredProviderId: String;
    registeredProviderName: String;
    registrationNetworkError: Float;
    procedure showConnectionUI;
  end;

  JINetworkOperatorNotificationEventDetails = class external
    encodingType: Float;
    message: String;
    networkAccountId: String;
    notificationType: JWindows.Networking.NetworkOperators.NetworkOperatorEventMessageType;
    ruleId: String;
    smsMessage: JWindows.Devices.Sms.ISmsMessage;
  end;

  JIMobileBroadbandAccountEventArgs = class external
    networkAccountId: String;
  end;

  JIMobileBroadbandAccountUpdatedEventArgs = class external
    hasDeviceInformationChanged: Boolean;
    hasNetworkChanged: Boolean;
    networkAccountId: String;
  end;

  JIMobileBroadbandAccountWatcher = class external
    status: JWindows.Networking.NetworkOperators.MobileBroadbandAccountWatcherStatus;
    onaccountadded: Variant;
    onaccountupdated: Variant;
    onaccountremoved: Variant;
    onenumerationcompleted: Variant;
    onstopped: Variant;
    procedure start;
    procedure stop;
  end;

  JIHotspotAuthenticationEventDetails = class external
    eventToken: String;
  end;

  JIHotspotAuthenticationContextStatics = class external
    function tryGetAuthenticationContext(evenToken: String):       context: JWindows.Networking.NetworkOperators.HotspotAuthenticationContext;
      isValid: Boolean;
    end;;
  end;

  JIHotspotAuthenticationContext = class external
    authenticationUrl: JWindows.Foundation.Uri;
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    redirectMessageUrl: JWindows.Foundation.Uri;
    redirectMessageXml: JWindows.Data.Xml.Dom.XmlDocument;
    wirelessNetworkId: JUint8Array;
    procedure issueCredentials(userName: String; password: String; extraParameters: String; markAsManualConnectOnFailure: Boolean);
    procedure abortAuthentication(markAsManual: Boolean);
    procedure skipAuthentication;
    procedure triggerAttentionRequired(packageRelativeApplicationId: String; applicationParameters: String);
  end;

  JIProvisionFromXmlDocumentResults = class external
    allElementsProvisioned: Boolean;
    provisionResultsXml: String;
  end;

  JProfileUsage = class external
    usageInMegabytes: Float;
    lastSyncTime: JDate;
  end;

  JIProvisionedProfile = class external
    procedure updateCost(value: JWindows.Networking.Connectivity.NetworkCostType);
    procedure updateUsage(value: JWindows.Networking.NetworkOperators.ProfileUsage);
  end;

  JIProvisioningAgent = class external
    function provisionFromXmlDocumentAsync(provisioningXmlDocument: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.NetworkOperators.ProvisionFromXmlDocumentResults>};
    function getProvisionedProfile(mediaType: JWindows.Networking.NetworkOperators.ProfileMediaType; profileName: String): JWindows.Networking.NetworkOperators.ProvisionedProfile;
  end;

  JIProvisioningAgentStaticMethods = class external
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.ProvisioningAgent;
  end;

  JIUssdMessage = class external
    dataCodingScheme: Float;
    payloadAsText: String;
    function getPayload: JUint8Array;
    procedure setPayload(value: JUint8Array);
  end;

  JIUssdMessageFactory = class external
    function createMessage(messageText: String): JWindows.Networking.NetworkOperators.UssdMessage;
  end;

  JIUssdReply = class external
    message: JWindows.Networking.NetworkOperators.UssdMessage;
    resultCode: JWindows.Networking.NetworkOperators.UssdResultCode;
  end;

  JIUssdSession = class external
    function sendMessageAndGetReplyAsync(message: JWindows.Networking.NetworkOperators.UssdMessage): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.NetworkOperators.UssdReply>};
    procedure close;
  end;

  JIUssdSessionStatics = class external
    function createFromNetworkAccountId(networkAccountId: String): JWindows.Networking.NetworkOperators.UssdSession;
    function createFromNetworkInterfaceId(networkInterfaceId: String): JWindows.Networking.NetworkOperators.UssdSession;
  end;

//Windows

//Networking

//BackgroundTransfer

type
  JDownloadOperation = class external 'DownloadOperation'
    progress: JWindows.Networking.BackgroundTransfer.BackgroundDownloadProgress;
    resultFile: JWindows.Storage.IStorageFile;
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    guid: String;
    method: String;
    requestedUri: JWindows.Foundation.Uri;
    function startAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.DownloadOperationJWindows.Networking.BackgroundTransfer.DownloadOperation>};
    function attachAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.DownloadOperationJWindows.Networking.BackgroundTransfer.DownloadOperation>};
    procedure pause;
    procedure resume;
    function getResultStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getResponseInformation: JWindows.Networking.BackgroundTransfer.ResponseInformation;
  end;

  JUploadOperation = class external 'UploadOperation'
    progress: JWindows.Networking.BackgroundTransfer.BackgroundUploadProgress;
    sourceFile: JWindows.Storage.IStorageFile;
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    guid: String;
    method: String;
    requestedUri: JWindows.Foundation.Uri;
    function startAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.UploadOperationJWindows.Networking.BackgroundTransfer.UploadOperation>};
    function attachAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.UploadOperationJWindows.Networking.BackgroundTransfer.UploadOperation>};
    function getResultStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getResponseInformation: JWindows.Networking.BackgroundTransfer.ResponseInformation;
  end;

  JBackgroundTransferContentPart = class external 'BackgroundTransferContentPart'
    constructor Create(name: String);
    constructor Create(name: String; fileName: String);
    constructor Create;
    procedure setHeader(headerName: String; headerValue: String);
    procedure setText(value: String);
    procedure setFile(value: JWindows.Storage.IStorageFile);
  end;

  JResponseInformation = class external 'ResponseInformation'
    actualUri: JWindows.Foundation.Uri;
    headers: JWindows.Foundation.Collections.IMapView{<StringString>};
    isResumable: Boolean;
    statusCode: Float;
  end;

  JBackgroundDownloader = class external 'BackgroundDownloader'
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    method: String;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    function createDownload(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.DownloadOperation;
    function createDownload(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile; requestBodyFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.DownloadOperation;
    function createDownloadAsync(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile; requestBodyStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.DownloadOperation>};
    procedure setRequestHeader(headerName: String; headerValue: String);
    function getCurrentDownloadsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.DownloadOperation>}>};
    function getCurrentDownloadsAsync(group: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.DownloadOperation>}>};
  end;

  JBackgroundUploader = class external 'BackgroundUploader'
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    method: String;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    function createUpload(uri: JWindows.Foundation.Uri; sourceFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.UploadOperation;
    function createUploadFromStreamAsync(uri: JWindows.Foundation.Uri; sourceStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}; subType: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}; subType: String; boundary: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    procedure setRequestHeader(headerName: String; headerValue: String);
    function getCurrentUploadsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.UploadOperation>}>};
    function getCurrentUploadsAsync(group: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.UploadOperation>}>};
  end;

  JBackgroundTransferError = class external 'BackgroundTransferError'
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

  JBackgroundDownloadProgress = class external
    bytesReceived: Float;
    totalBytesToReceive: Float;
    status: JWindows.Networking.BackgroundTransfer.BackgroundTransferStatus;
    hasResponseChanged: Boolean;
    hasRestarted: Boolean;
  end;

  JBackgroundUploadProgress = class external
    bytesReceived: Float;
    bytesSent: Float;
    totalBytesToReceive: Float;
    totalBytesToSend: Float;
    status: JWindows.Networking.BackgroundTransfer.BackgroundTransferStatus;
    hasResponseChanged: Boolean;
    hasRestarted: Boolean;
  end;

  JIBackgroundTransferBase = class external
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    method: String;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    procedure setRequestHeader(headerName: String; headerValue: String);
  end;

  JIBackgroundDownloader = class external(JWindows.Networking.BackgroundTransfer.IBackgroundTransferBase)
    function createDownload(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.DownloadOperation;
    function createDownload(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile; requestBodyFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.DownloadOperation;
    function createDownloadAsync(uri: JWindows.Foundation.Uri; resultFile: JWindows.Storage.IStorageFile; requestBodyStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.DownloadOperation>};
  end;

  JIBackgroundUploader = class external(JWindows.Networking.BackgroundTransfer.IBackgroundTransferBase)
    function createUpload(uri: JWindows.Foundation.Uri; sourceFile: JWindows.Storage.IStorageFile): JWindows.Networking.BackgroundTransfer.UploadOperation;
    function createUploadFromStreamAsync(uri: JWindows.Foundation.Uri; sourceStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}; subType: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
    function createUploadAsync(uri: JWindows.Foundation.Uri; parts: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart>}; subType: String; boundary: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.BackgroundTransfer.UploadOperation>};
  end;

  JIBackgroundTransferOperation = class external
    costPolicy: JWindows.Networking.BackgroundTransfer.BackgroundTransferCostPolicy;
    group: String;
    guid: String;
    method: String;
    requestedUri: JWindows.Foundation.Uri;
    function getResultStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getResponseInformation: JWindows.Networking.BackgroundTransfer.ResponseInformation;
  end;

  JIDownloadOperation = class external(JWindows.Networking.BackgroundTransfer.IBackgroundTransferOperation)
    progress: JWindows.Networking.BackgroundTransfer.BackgroundDownloadProgress;
    resultFile: JWindows.Storage.IStorageFile;
    function startAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.DownloadOperationJWindows.Networking.BackgroundTransfer.DownloadOperation>};
    function attachAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.DownloadOperationJWindows.Networking.BackgroundTransfer.DownloadOperation>};
    procedure pause;
    procedure resume;
  end;

  JIUploadOperation = class external(JWindows.Networking.BackgroundTransfer.IBackgroundTransferOperation)
    progress: JWindows.Networking.BackgroundTransfer.BackgroundUploadProgress;
    sourceFile: JWindows.Storage.IStorageFile;
    function startAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.UploadOperationJWindows.Networking.BackgroundTransfer.UploadOperation>};
    function attachAsync: JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Networking.BackgroundTransfer.UploadOperationJWindows.Networking.BackgroundTransfer.UploadOperation>};
  end;

  JIBackgroundDownloaderStaticMethods = class external
    function getCurrentDownloadsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.DownloadOperation>}>};
    function getCurrentDownloadsAsync(group: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.DownloadOperation>}>};
  end;

  JIBackgroundUploaderStaticMethods = class external
    function getCurrentUploadsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.UploadOperation>}>};
    function getCurrentUploadsAsync(group: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.BackgroundTransfer.UploadOperation>}>};
  end;

  JIResponseInformation = class external
    actualUri: JWindows.Foundation.Uri;
    headers: JWindows.Foundation.Collections.IMapView{<StringString>};
    isResumable: Boolean;
    statusCode: Float;
  end;

  JIBackgroundTransferErrorStaticMethods = class external
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

  JIBackgroundTransferContentPart = class external
    procedure setHeader(headerName: String; headerValue: String);
    procedure setText(value: String);
    procedure setFile(value: JWindows.Storage.IStorageFile);
  end;

  JIBackgroundTransferContentPartFactory = class external
    function createWithName(name: String): JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart;
    function createWithNameAndFileName(name: String; fileName: String): JWindows.Networking.BackgroundTransfer.BackgroundTransferContentPart;
  end;

//Windows

//Networking

//Proximity

type
  JProximityMessage = class external 'ProximityMessage'
    data: JWindows.Storage.Streams.IBuffer;
    dataAsString: String;
    messageType: String;
    subscriptionId: Float;
  end;

  JProximityDevice = class external 'ProximityDevice'
    bitsPerSecond: Float;
    deviceId: String;
    maxMessageBytes: Float;
    function subscribeForMessage(messageType: String; messageReceivedHandler: JWindows.Networking.Proximity.MessageReceivedHandler): Float;
    function publishMessage(messageType: String; message: String): Float;
    function publishMessage(messageType: String; message: String; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    function publishBinaryMessage(messageType: String; message: JWindows.Storage.Streams.IBuffer): Float;
    function publishBinaryMessage(messageType: String; message: JWindows.Storage.Streams.IBuffer; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    function publishUriMessage(message: JWindows.Foundation.Uri): Float;
    function publishUriMessage(message: JWindows.Foundation.Uri; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    procedure stopSubscribingForMessage(subscriptionId: Float);
    procedure stopPublishingMessage(messageId: Float);
    ondevicearrived: Variant;
    ondevicedeparted: Variant;
    function getDeviceSelector: String;
    function getDefault: JWindows.Networking.Proximity.ProximityDevice;
    function fromId(deviceInterfaceId: String): JWindows.Networking.Proximity.ProximityDevice;
  end;

  JTriggeredConnectionStateChangedEventArgs = class external 'TriggeredConnectionStateChangedEventArgs'
    id: Float;
    socket: JWindows.Networking.Sockets.StreamSocket;
    state: JWindows.Networking.Proximity.TriggeredConnectState;
  end;

  JPeerInformation = class external 'PeerInformation'
    displayName: String;
  end;

  JConnectionRequestedEventArgs = class external 'ConnectionRequestedEventArgs'
    peerInformation: JWindows.Networking.Proximity.PeerInformation;
  end;

  JPeerFinder = class external 'PeerFinder'
    allowBluetooth: Boolean;
    allowInfrastructure: Boolean;
    allowWiFiDirect: Boolean;
    alternateIdentities: JWindows.Foundation.Collections.IMap{<StringString>};
    displayName: String;
    supportedDiscoveryTypes: JWindows.Networking.Proximity.PeerDiscoveryTypes;
    procedure start;
    procedure start(peerMessage: String);
    procedure stop;
    ontriggeredconnectionstatechanged: Variant;
    onconnectionrequested: Variant;
    function findAllPeersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Proximity.PeerInformation>}>};
    function connectAsync(peerInformation: JWindows.Networking.Proximity.PeerInformation): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Sockets.StreamSocket>};
  end;

  JIProximityMessage = class external
    data: JWindows.Storage.Streams.IBuffer;
    dataAsString: String;
    messageType: String;
    subscriptionId: Float;
  end;

  JMessageReceivedHandler = class external
(sender: JWindows.Networking.Proximity.ProximityDevice; message: JWindows.Networking.Proximity.ProximityMessage)  end;

  JMessageTransmittedHandler = class external
(sender: JWindows.Networking.Proximity.ProximityDevice; messageId: Float)  end;

  JDeviceArrivedEventHandler = class external
(sender: JWindows.Networking.Proximity.ProximityDevice)  end;

  JDeviceDepartedEventHandler = class external
(sender: JWindows.Networking.Proximity.ProximityDevice)  end;

  JIProximityDevice = class external
    bitsPerSecond: Float;
    deviceId: String;
    maxMessageBytes: Float;
    function subscribeForMessage(messageType: String; messageReceivedHandler: JWindows.Networking.Proximity.MessageReceivedHandler): Float;
    function publishMessage(messageType: String; message: String): Float;
    function publishMessage(messageType: String; message: String; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    function publishBinaryMessage(messageType: String; message: JWindows.Storage.Streams.IBuffer): Float;
    function publishBinaryMessage(messageType: String; message: JWindows.Storage.Streams.IBuffer; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    function publishUriMessage(message: JWindows.Foundation.Uri): Float;
    function publishUriMessage(message: JWindows.Foundation.Uri; messageTransmittedHandler: JWindows.Networking.Proximity.MessageTransmittedHandler): Float;
    procedure stopSubscribingForMessage(subscriptionId: Float);
    procedure stopPublishingMessage(messageId: Float);
    ondevicearrived: Variant;
    ondevicedeparted: Variant;
  end;

  JIProximityDeviceStatics = class external
    function getDeviceSelector: String;
    function getDefault: JWindows.Networking.Proximity.ProximityDevice;
    function fromId(deviceInterfaceId: String): JWindows.Networking.Proximity.ProximityDevice;
  end;

  JITriggeredConnectionStateChangedEventArgs = class external
    id: Float;
    socket: JWindows.Networking.Sockets.StreamSocket;
    state: JWindows.Networking.Proximity.TriggeredConnectState;
  end;

  JIPeerInformation = class external
    displayName: String;
  end;

  JIConnectionRequestedEventArgs = class external
    peerInformation: JWindows.Networking.Proximity.PeerInformation;
  end;

  JIPeerFinderStatics = class external
    allowBluetooth: Boolean;
    allowInfrastructure: Boolean;
    allowWiFiDirect: Boolean;
    alternateIdentities: JWindows.Foundation.Collections.IMap{<StringString>};
    displayName: String;
    supportedDiscoveryTypes: JWindows.Networking.Proximity.PeerDiscoveryTypes;
    procedure start;
    procedure start(peerMessage: String);
    procedure stop;
    ontriggeredconnectionstatechanged: Variant;
    onconnectionrequested: Variant;
    function findAllPeersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Proximity.PeerInformation>}>};
    function connectAsync(peerInformation: JWindows.Networking.Proximity.PeerInformation): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Sockets.StreamSocket>};
  end;

//Windows

//Networking

//Sockets

type
  JControlChannelTrigger = class external 'ControlChannelTrigger'
    constructor Create(channelId: String; serverKeepAliveIntervalInMinutes: Float);
    constructor Create(channelId: String; serverKeepAliveIntervalInMinutes: Float; resourceRequestType: JWindows.Networking.Sockets.ControlChannelTriggerResourceType);
    controlChannelTriggerId: String;
    currentKeepAliveIntervalInMinutes: Float;
    keepAliveTrigger: JWindows.ApplicationModel.Background.IBackgroundTrigger;
    pushNotificationTrigger: JWindows.ApplicationModel.Background.IBackgroundTrigger;
    serverKeepAliveIntervalInMinutes: Float;
    transportObject: Variant;
    procedure usingTransport(transport: Variant);
    function waitForPushEnabled: JWindows.Networking.Sockets.ControlChannelTriggerStatus;
    procedure decreaseNetworkKeepAliveInterval;
    procedure flushTransport;
    procedure dispose;
    procedure close;
  end;

  JDatagramSocketControl = class external 'DatagramSocketControl'
    outboundUnicastHopLimit: Float;
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JDatagramSocketInformation = class external 'DatagramSocketInformation'
    localAddress: JWindows.Networking.HostName;
    localPort: String;
    remoteAddress: JWindows.Networking.HostName;
    remotePort: String;
  end;

  JDatagramSocket = class external 'DatagramSocket'
    control: JWindows.Networking.Sockets.DatagramSocketControl;
    information: JWindows.Networking.Sockets.DatagramSocketInformation;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncAction;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncAction;
    function bindServiceNameAsync(localServiceName: String): JWindows.Foundation.IAsyncAction;
    function bindEndpointAsync(localHostName: JWindows.Networking.HostName; localServiceName: String): JWindows.Foundation.IAsyncAction;
    procedure joinMulticastGroup(host: JWindows.Networking.HostName);
    function getOutputStreamAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IOutputStream>};
    function getOutputStreamAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IOutputStream>};
    onmessagereceived: Variant;
    procedure dispose;
    function getEndpointPairsAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>}>};
    function getEndpointPairsAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String; sortOptions: JWindows.Networking.HostNameSortOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>}>};
    procedure close;
  end;

  JDatagramSocketMessageReceivedEventArgs = class external 'DatagramSocketMessageReceivedEventArgs'
    localAddress: JWindows.Networking.HostName;
    remoteAddress: JWindows.Networking.HostName;
    remotePort: String;
    function getDataReader: JWindows.Storage.Streams.DataReader;
    function getDataStream: JWindows.Storage.Streams.IInputStream;
  end;

  JStreamSocketControl = class external 'StreamSocketControl'
    keepAlive: Boolean;
    noDelay: Boolean;
    outboundBufferSizeInBytes: Float;
    outboundUnicastHopLimit: Float;
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JStreamSocketInformation = class external 'StreamSocketInformation'
    bandwidthStatistics: JWindows.Networking.Sockets.BandwidthStatistics;
    localAddress: JWindows.Networking.HostName;
    localPort: String;
    protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel;
    remoteAddress: JWindows.Networking.HostName;
    remoteHostName: JWindows.Networking.HostName;
    remotePort: String;
    remoteServiceName: String;
    roundTripTimeStatistics: JWindows.Networking.Sockets.RoundTripTimeStatistics;
    sessionKey: JWindows.Storage.Streams.IBuffer;
  end;

  JStreamSocket = class external 'StreamSocket'
    control: JWindows.Networking.Sockets.StreamSocketControl;
    information: JWindows.Networking.Sockets.StreamSocketInformation;
    inputStream: JWindows.Storage.Streams.IInputStream;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncAction;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncAction;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair; protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel): JWindows.Foundation.IAsyncAction;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String; protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel): JWindows.Foundation.IAsyncAction;
    function upgradeToSslAsync(protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel; validationHostName: JWindows.Networking.HostName): JWindows.Foundation.IAsyncAction;
    procedure dispose;
    procedure close;
  end;

  JStreamSocketListenerControl = class external 'StreamSocketListenerControl'
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JStreamSocketListenerInformation = class external 'StreamSocketListenerInformation'
    localPort: String;
  end;

  JStreamSocketListener = class external 'StreamSocketListener'
    control: JWindows.Networking.Sockets.StreamSocketListenerControl;
    information: JWindows.Networking.Sockets.StreamSocketListenerInformation;
    function bindServiceNameAsync(localServiceName: String): JWindows.Foundation.IAsyncAction;
    function bindEndpointAsync(localHostName: JWindows.Networking.HostName; localServiceName: String): JWindows.Foundation.IAsyncAction;
    onconnectionreceived: Variant;
    procedure dispose;
    procedure close;
  end;

  JStreamSocketListenerConnectionReceivedEventArgs = class external 'StreamSocketListenerConnectionReceivedEventArgs'
    socket: JWindows.Networking.Sockets.StreamSocket;
  end;

  JWebSocketClosedEventArgs = class external 'WebSocketClosedEventArgs'
    code: Float;
    reason: String;
  end;

  JMessageWebSocketControl = class external 'MessageWebSocketControl'
    maxMessageSize: Float;
    messageType: JWindows.Networking.Sockets.SocketMessageType;
    outboundBufferSizeInBytes: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    supportedProtocols: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JMessageWebSocketInformation = class external 'MessageWebSocketInformation'
    bandwidthStatistics: JWindows.Networking.Sockets.BandwidthStatistics;
    localAddress: JWindows.Networking.HostName;
    protocol: String;
  end;

  JMessageWebSocket = class external 'MessageWebSocket'
    control: JWindows.Networking.Sockets.MessageWebSocketControl;
    information: JWindows.Networking.Sockets.MessageWebSocketInformation;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    onmessagereceived: Variant;
    function connectAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncAction;
    procedure setRequestHeader(headerName: String; headerValue: String);
    onclosed: Variant;
    procedure close(code: Float; reason: String);
    procedure dispose;
    procedure close;
  end;

  JMessageWebSocketMessageReceivedEventArgs = class external 'MessageWebSocketMessageReceivedEventArgs'
    messageType: JWindows.Networking.Sockets.SocketMessageType;
    function getDataReader: JWindows.Storage.Streams.DataReader;
    function getDataStream: JWindows.Storage.Streams.IInputStream;
  end;

  JStreamWebSocketControl = class external 'StreamWebSocketControl'
    noDelay: Boolean;
    outboundBufferSizeInBytes: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    supportedProtocols: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JStreamWebSocketInformation = class external 'StreamWebSocketInformation'
    bandwidthStatistics: JWindows.Networking.Sockets.BandwidthStatistics;
    localAddress: JWindows.Networking.HostName;
    protocol: String;
  end;

  JStreamWebSocket = class external 'StreamWebSocket'
    control: JWindows.Networking.Sockets.StreamWebSocketControl;
    information: JWindows.Networking.Sockets.StreamWebSocketInformation;
    inputStream: JWindows.Storage.Streams.IInputStream;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncAction;
    procedure setRequestHeader(headerName: String; headerValue: String);
    onclosed: Variant;
    procedure close(code: Float; reason: String);
    procedure dispose;
    procedure close;
  end;

  JWebSocketKeepAlive = class external 'WebSocketKeepAlive'
    procedure run(taskInstance: JWindows.ApplicationModel.Background.IBackgroundTaskInstance);
  end;

  JSocketError = class external 'SocketError'
    function getStatus(hresult: Float): JWindows.Networking.Sockets.SocketErrorStatus;
  end;

  JWebSocketError = class external 'WebSocketError'
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

  JIControlChannelTrigger = class external(JWindows.Foundation.IClosable)
    controlChannelTriggerId: String;
    currentKeepAliveIntervalInMinutes: Float;
    keepAliveTrigger: JWindows.ApplicationModel.Background.IBackgroundTrigger;
    pushNotificationTrigger: JWindows.ApplicationModel.Background.IBackgroundTrigger;
    serverKeepAliveIntervalInMinutes: Float;
    transportObject: Variant;
    procedure usingTransport(transport: Variant);
    function waitForPushEnabled: JWindows.Networking.Sockets.ControlChannelTriggerStatus;
    procedure decreaseNetworkKeepAliveInterval;
    procedure flushTransport;
  end;

  JIControlChannelTriggerFactory = class external
    function createControlChannelTrigger(channelId: String; serverKeepAliveIntervalInMinutes: Float): JWindows.Networking.Sockets.ControlChannelTrigger;
    function createControlChannelTrigger(channelId: String; serverKeepAliveIntervalInMinutes: Float; resourceRequestType: JWindows.Networking.Sockets.ControlChannelTriggerResourceType): JWindows.Networking.Sockets.ControlChannelTrigger;
  end;

  JIControlChannelTriggerEventDetails = class external
    controlChannelTrigger: JWindows.Networking.Sockets.ControlChannelTrigger;
  end;

  JIControlChannelTriggerResetEventDetails = class external
    hardwareSlotReset: Boolean;
    resetReason: JWindows.Networking.Sockets.ControlChannelTriggerResetReason;
    softwareSlotReset: Boolean;
  end;

  JRoundTripTimeStatistics = class external
    variance: Float;
    max: Float;
    min: Float;
    sum: Float;
  end;

  JBandwidthStatistics = class external
    outboundBitsPerSecond: Float;
    inboundBitsPerSecond: Float;
    outboundBitsPerSecondInstability: Float;
    inboundBitsPerSecondInstability: Float;
    outboundBandwidthPeaked: Boolean;
    inboundBandwidthPeaked: Boolean;
  end;

  JIDatagramSocketMessageReceivedEventArgs = class external
    localAddress: JWindows.Networking.HostName;
    remoteAddress: JWindows.Networking.HostName;
    remotePort: String;
    function getDataReader: JWindows.Storage.Streams.DataReader;
    function getDataStream: JWindows.Storage.Streams.IInputStream;
  end;

  JIMessageWebSocketMessageReceivedEventArgs = class external
    messageType: JWindows.Networking.Sockets.SocketMessageType;
    function getDataReader: JWindows.Storage.Streams.DataReader;
    function getDataStream: JWindows.Storage.Streams.IInputStream;
  end;

  JIWebSocketClosedEventArgs = class external
    code: Float;
    reason: String;
  end;

  JIDatagramSocketInformation = class external
    localAddress: JWindows.Networking.HostName;
    localPort: String;
    remoteAddress: JWindows.Networking.HostName;
    remotePort: String;
  end;

  JIDatagramSocketControl = class external
    outboundUnicastHopLimit: Float;
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JIDatagramSocketStatics = class external
    function getEndpointPairsAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>}>};
    function getEndpointPairsAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String; sortOptions: JWindows.Networking.HostNameSortOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>}>};
  end;

  JIDatagramSocket = class external(JWindows.Foundation.IClosable)
    control: JWindows.Networking.Sockets.DatagramSocketControl;
    information: JWindows.Networking.Sockets.DatagramSocketInformation;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncAction;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncAction;
    function bindServiceNameAsync(localServiceName: String): JWindows.Foundation.IAsyncAction;
    function bindEndpointAsync(localHostName: JWindows.Networking.HostName; localServiceName: String): JWindows.Foundation.IAsyncAction;
    procedure joinMulticastGroup(host: JWindows.Networking.HostName);
    function getOutputStreamAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IOutputStream>};
    function getOutputStreamAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IOutputStream>};
    onmessagereceived: Variant;
  end;

  JIStreamSocketInformation = class external
    bandwidthStatistics: JWindows.Networking.Sockets.BandwidthStatistics;
    localAddress: JWindows.Networking.HostName;
    localPort: String;
    protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel;
    remoteAddress: JWindows.Networking.HostName;
    remoteHostName: JWindows.Networking.HostName;
    remotePort: String;
    remoteServiceName: String;
    roundTripTimeStatistics: JWindows.Networking.Sockets.RoundTripTimeStatistics;
    sessionKey: JWindows.Storage.Streams.IBuffer;
  end;

  JIStreamSocketControl = class external
    keepAlive: Boolean;
    noDelay: Boolean;
    outboundBufferSizeInBytes: Float;
    outboundUnicastHopLimit: Float;
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JIStreamSocket = class external(JWindows.Foundation.IClosable)
    control: JWindows.Networking.Sockets.StreamSocketControl;
    information: JWindows.Networking.Sockets.StreamSocketInformation;
    inputStream: JWindows.Storage.Streams.IInputStream;
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair): JWindows.Foundation.IAsyncAction;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Foundation.IAsyncAction;
    function connectAsync(endpointPair: JWindows.Networking.EndpointPair; protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel): JWindows.Foundation.IAsyncAction;
    function connectAsync(remoteHostName: JWindows.Networking.HostName; remoteServiceName: String; protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel): JWindows.Foundation.IAsyncAction;
    function upgradeToSslAsync(protectionLevel: JWindows.Networking.Sockets.SocketProtectionLevel; validationHostName: JWindows.Networking.HostName): JWindows.Foundation.IAsyncAction;
  end;

  JIStreamSocketListenerControl = class external
    qualityOfService: JWindows.Networking.Sockets.SocketQualityOfService;
  end;

  JIStreamSocketListenerInformation = class external
    localPort: String;
  end;

  JIStreamSocketListenerConnectionReceivedEventArgs = class external
    socket: JWindows.Networking.Sockets.StreamSocket;
  end;

  JIStreamSocketListener = class external(JWindows.Foundation.IClosable)
    control: JWindows.Networking.Sockets.StreamSocketListenerControl;
    information: JWindows.Networking.Sockets.StreamSocketListenerInformation;
    function bindServiceNameAsync(localServiceName: String): JWindows.Foundation.IAsyncAction;
    function bindEndpointAsync(localHostName: JWindows.Networking.HostName; localServiceName: String): JWindows.Foundation.IAsyncAction;
    onconnectionreceived: Variant;
  end;

  JIWebSocketControl = class external
    outboundBufferSizeInBytes: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    supportedProtocols: JWindows.Foundation.Collections.IVector{<String>};
  end;

  JIWebSocketInformation = class external
    bandwidthStatistics: JWindows.Networking.Sockets.BandwidthStatistics;
    localAddress: JWindows.Networking.HostName;
    protocol: String;
  end;

  JIWebSocket = class external(JWindows.Foundation.IClosable)
    outputStream: JWindows.Storage.Streams.IOutputStream;
    function connectAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncAction;
    procedure setRequestHeader(headerName: String; headerValue: String);
    onclosed: Variant;
    procedure close;
    procedure close(code: Float; reason: String);
  end;

  JIMessageWebSocketControl = class external(JWindows.Networking.Sockets.IWebSocketControl)
    maxMessageSize: Float;
    messageType: JWindows.Networking.Sockets.SocketMessageType;
  end;

  JIMessageWebSocket = class external(JWindows.Networking.Sockets.IWebSocket, JWindows.Foundation.IClosable)
    control: JWindows.Networking.Sockets.MessageWebSocketControl;
    information: JWindows.Networking.Sockets.MessageWebSocketInformation;
    onmessagereceived: Variant;
    procedure close;
    procedure close(code: Float; reason: String);
  end;

  JIStreamWebSocketControl = class external(JWindows.Networking.Sockets.IWebSocketControl)
    noDelay: Boolean;
  end;

  JIStreamWebSocket = class external(JWindows.Networking.Sockets.IWebSocket, JWindows.Foundation.IClosable)
    control: JWindows.Networking.Sockets.StreamWebSocketControl;
    information: JWindows.Networking.Sockets.StreamWebSocketInformation;
    inputStream: JWindows.Storage.Streams.IInputStream;
    procedure close;
    procedure close(code: Float; reason: String);
  end;

  JISocketErrorStatics = class external
    function getStatus(hresult: Float): JWindows.Networking.Sockets.SocketErrorStatus;
  end;

  JIWebSocketErrorStatics = class external
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

//Windows

//Networking

type
  JHostName = class external 'HostName'
    constructor Create(hostName: String);
    canonicalName: String;
    displayName: String;
    iPInformation: JWindows.Networking.Connectivity.IPInformation;
    rawName: String;
    &type: JWindows.Networking.HostNameType;
    function isEqual(hostName: JWindows.Networking.HostName): Boolean;
    function compare(value1: String; value2: String): Float;
  end;

  JEndpointPair = class external 'EndpointPair'
    constructor Create(localHostName: JWindows.Networking.HostName; localServiceName: String; remoteHostName: JWindows.Networking.HostName; remoteServiceName: String);
    localHostName: JWindows.Networking.HostName;
    localServiceName: String;
    remoteHostName: JWindows.Networking.HostName;
    remoteServiceName: String;
  end;

  JIHostNameStatics = class external
    function compare(value1: String; value2: String): Float;
  end;

  JIHostName = class external
    canonicalName: String;
    displayName: String;
    iPInformation: JWindows.Networking.Connectivity.IPInformation;
    rawName: String;
    &type: JWindows.Networking.HostNameType;
    function isEqual(hostName: JWindows.Networking.HostName): Boolean;
  end;

  JIHostNameFactory = class external
    function createHostName(hostName: String): JWindows.Networking.HostName;
  end;

  JIEndpointPair = class external
    localHostName: JWindows.Networking.HostName;
    localServiceName: String;
    remoteHostName: JWindows.Networking.HostName;
    remoteServiceName: String;
  end;

  JIEndpointPairFactory = class external
    function createEndpointPair(localHostName: JWindows.Networking.HostName; localServiceName: String; remoteHostName: JWindows.Networking.HostName; remoteServiceName: String): JWindows.Networking.EndpointPair;
  end;

//Windows

//Networking

//Connectivity

type
  JIPInformation = class external 'IPInformation'
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    prefixLength: Float;
  end;

  JDataPlanUsage = class external 'DataPlanUsage'
    lastSyncTime: JDate;
    megabytesUsed: Float;
  end;

  JConnectionCost = class external 'ConnectionCost'
    approachingDataLimit: Boolean;
    networkCostType: JWindows.Networking.Connectivity.NetworkCostType;
    overDataLimit: Boolean;
    roaming: Boolean;
  end;

  JDataPlanStatus = class external 'DataPlanStatus'
    dataLimitInMegabytes: Float;
    dataPlanUsage: JWindows.Networking.Connectivity.DataPlanUsage;
    inboundBitsPerSecond: Float;
    maxTransferSizeInMegabytes: Float;
    nextBillingCycle: JDate;
    outboundBitsPerSecond: Float;
  end;

  JNetworkAdapter = class external 'NetworkAdapter'
    ianaInterfaceType: Float;
    inboundMaxBitsPerSecond: Float;
    networkAdapterId: String;
    networkItem: JWindows.Networking.Connectivity.NetworkItem;
    outboundMaxBitsPerSecond: Float;
    function getConnectedProfileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Connectivity.ConnectionProfile>};
  end;

  JDataUsage = class external 'DataUsage'
    bytesReceived: Float;
    bytesSent: Float;
  end;

  JNetworkSecuritySettings = class external 'NetworkSecuritySettings'
    networkAuthenticationType: JWindows.Networking.Connectivity.NetworkAuthenticationType;
    networkEncryptionType: JWindows.Networking.Connectivity.NetworkEncryptionType;
  end;

  JLanIdentifierData = class external 'LanIdentifierData'
    &type: Float;
    value: JWindows.Foundation.Collections.IVectorView{<Float>};
  end;

  JConnectionProfile = class external 'ConnectionProfile'
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    networkSecuritySettings: JWindows.Networking.Connectivity.NetworkSecuritySettings;
    profileName: String;
    function getNetworkConnectivityLevel: JWindows.Networking.Connectivity.NetworkConnectivityLevel;
    function getNetworkNames: JWindows.Foundation.Collections.IVectorView{<String>};
    function getConnectionCost: JWindows.Networking.Connectivity.ConnectionCost;
    function getDataPlanStatus: JWindows.Networking.Connectivity.DataPlanStatus;
    function getLocalUsage(StartTime: JDate; EndTime: JDate): JWindows.Networking.Connectivity.DataUsage;
    function getLocalUsage(StartTime: JDate; EndTime: JDate; States: JWindows.Networking.Connectivity.RoamingStates): JWindows.Networking.Connectivity.DataUsage;
  end;

  JLanIdentifier = class external 'LanIdentifier'
    infrastructureId: JWindows.Networking.Connectivity.LanIdentifierData;
    networkAdapterId: String;
    portId: JWindows.Networking.Connectivity.LanIdentifierData;
  end;

  JProxyConfiguration = class external 'ProxyConfiguration'
    canConnectDirectly: Boolean;
    proxyUris: JWindows.Foundation.Collections.IVectorView{<JWindows.Foundation.Uri>};
  end;

  JNetworkItem = class external 'NetworkItem'
    networkId: String;
    function getNetworkTypes: JWindows.Networking.Connectivity.NetworkTypes;
  end;

  JNetworkInformation = class external 'NetworkInformation'
    function getConnectionProfiles: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Connectivity.ConnectionProfile>};
    function getInternetConnectionProfile: JWindows.Networking.Connectivity.ConnectionProfile;
    function getLanIdentifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Connectivity.LanIdentifier>};
    function getHostNames: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.HostName>};
    function getProxyConfigurationAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Connectivity.ProxyConfiguration>};
    function getSortedEndpointPairs(destinationList: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.EndpointPair>}; sortOptions: JWindows.Networking.HostNameSortOptions): JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>};
    onnetworkstatuschanged: Variant;
  end;

  JIDataUsage = class external
    bytesReceived: Float;
    bytesSent: Float;
  end;

  JIDataPlanUsage = class external
    lastSyncTime: JDate;
    megabytesUsed: Float;
  end;

  JIDataPlanStatus = class external
    dataLimitInMegabytes: Float;
    dataPlanUsage: JWindows.Networking.Connectivity.DataPlanUsage;
    inboundBitsPerSecond: Float;
    maxTransferSizeInMegabytes: Float;
    nextBillingCycle: JDate;
    outboundBitsPerSecond: Float;
  end;

  JIConnectionCost = class external
    approachingDataLimit: Boolean;
    networkCostType: JWindows.Networking.Connectivity.NetworkCostType;
    overDataLimit: Boolean;
    roaming: Boolean;
  end;

  JINetworkSecuritySettings = class external
    networkAuthenticationType: JWindows.Networking.Connectivity.NetworkAuthenticationType;
    networkEncryptionType: JWindows.Networking.Connectivity.NetworkEncryptionType;
  end;

  JIConnectionProfile = class external
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    networkSecuritySettings: JWindows.Networking.Connectivity.NetworkSecuritySettings;
    profileName: String;
    function getNetworkConnectivityLevel: JWindows.Networking.Connectivity.NetworkConnectivityLevel;
    function getNetworkNames: JWindows.Foundation.Collections.IVectorView{<String>};
    function getConnectionCost: JWindows.Networking.Connectivity.ConnectionCost;
    function getDataPlanStatus: JWindows.Networking.Connectivity.DataPlanStatus;
    function getLocalUsage(StartTime: JDate; EndTime: JDate): JWindows.Networking.Connectivity.DataUsage;
    function getLocalUsage(StartTime: JDate; EndTime: JDate; States: JWindows.Networking.Connectivity.RoamingStates): JWindows.Networking.Connectivity.DataUsage;
  end;

  JILanIdentifierData = class external
    &type: Float;
    value: JWindows.Foundation.Collections.IVectorView{<Float>};
  end;

  JILanIdentifier = class external
    infrastructureId: JWindows.Networking.Connectivity.LanIdentifierData;
    networkAdapterId: String;
    portId: JWindows.Networking.Connectivity.LanIdentifierData;
  end;

  JNetworkStatusChangedEventHandler = class external
(sender: Variant)  end;

  JINetworkInformationStatics = class external
    function getConnectionProfiles: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Connectivity.ConnectionProfile>};
    function getInternetConnectionProfile: JWindows.Networking.Connectivity.ConnectionProfile;
    function getLanIdentifiers: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.Connectivity.LanIdentifier>};
    function getHostNames: JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.HostName>};
    function getProxyConfigurationAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Connectivity.ProxyConfiguration>};
    function getSortedEndpointPairs(destinationList: JWindows.Foundation.Collections.IIterable{<JWindows.Networking.EndpointPair>}; sortOptions: JWindows.Networking.HostNameSortOptions): JWindows.Foundation.Collections.IVectorView{<JWindows.Networking.EndpointPair>};
    onnetworkstatuschanged: Variant;
  end;

  JINetworkItem = class external
    networkId: String;
    function getNetworkTypes: JWindows.Networking.Connectivity.NetworkTypes;
  end;

  JINetworkAdapter = class external
    ianaInterfaceType: Float;
    inboundMaxBitsPerSecond: Float;
    networkAdapterId: String;
    networkItem: JWindows.Networking.Connectivity.NetworkItem;
    outboundMaxBitsPerSecond: Float;
    function getConnectedProfileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Networking.Connectivity.ConnectionProfile>};
  end;

  JIIPInformation = class external
    networkAdapter: JWindows.Networking.Connectivity.NetworkAdapter;
    prefixLength: Float;
  end;

  JIProxyConfiguration = class external
    canConnectDirectly: Boolean;
    proxyUris: JWindows.Foundation.Collections.IVectorView{<JWindows.Foundation.Uri>};
  end;

//Windows

//Networking

//PushNotifications

type
  JPushNotificationChannel = class external 'PushNotificationChannel'
    expirationTime: JDate;
    uri: String;
    procedure close;
    onpushnotificationreceived: Variant;
  end;

  JPushNotificationReceivedEventArgs = class external 'PushNotificationReceivedEventArgs'
    badgeNotification: JWindows.UI.Notifications.BadgeNotification;
    cancel: Boolean;
    notificationType: JWindows.Networking.PushNotifications.PushNotificationType;
    rawNotification: JWindows.Networking.PushNotifications.RawNotification;
    tileNotification: JWindows.UI.Notifications.TileNotification;
    toastNotification: JWindows.UI.Notifications.ToastNotification;
  end;

  JRawNotification = class external 'RawNotification'
    content: String;
  end;

  JPushNotificationChannelManager = class external 'PushNotificationChannelManager'
    function createPushNotificationChannelForApplicationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
    function createPushNotificationChannelForApplicationAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
    function createPushNotificationChannelForSecondaryTileAsync(tileId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
  end;

  JIPushNotificationChannelManagerStatics = class external
    function createPushNotificationChannelForApplicationAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
    function createPushNotificationChannelForApplicationAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
    function createPushNotificationChannelForSecondaryTileAsync(tileId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Networking.PushNotifications.PushNotificationChannel>};
  end;

  JIPushNotificationChannel = class external
    expirationTime: JDate;
    uri: String;
    procedure close;
    onpushnotificationreceived: Variant;
  end;

  JIPushNotificationReceivedEventArgs = class external
    badgeNotification: JWindows.UI.Notifications.BadgeNotification;
    cancel: Boolean;
    notificationType: JWindows.Networking.PushNotifications.PushNotificationType;
    rawNotification: JWindows.Networking.PushNotifications.RawNotification;
    tileNotification: JWindows.UI.Notifications.TileNotification;
    toastNotification: JWindows.UI.Notifications.ToastNotification;
  end;

  JIRawNotification = class external
    content: String;
  end;

//Windows

//Security

//Authentication

//OnlineId

type
  JOnlineIdServiceTicketRequest = class external 'OnlineIdServiceTicketRequest'
    constructor Create(service: String; policy: String);
    constructor Create(service: String);
    policy: String;
    service: String;
  end;

  JOnlineIdServiceTicket = class external 'OnlineIdServiceTicket'
    errorCode: Float;
    request: JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest;
    value: String;
  end;

  JUserAuthenticationOperation = class external 'UserAuthenticationOperation'
    completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Security.Authentication.OnlineId.UserIdentity>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: JWindows.Security.Authentication.OnlineId.UserIdentity;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): Variant); overload;
    procedure done(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: JWindows.Security.Authentication.OnlineId.UserIdentity): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<JWindows.Security.Authentication.OnlineId.UserIdentity>};
      function getResults: JWindows.Security.Authentication.OnlineId.UserIdentity;
    end;;
  end;

  JSignOutUserOperation = class external 'SignOutUserOperation'
    completed: JWindows.Foundation.AsyncActionCompletedHandler;
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    procedure getResults;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: : JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: : Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant); overload;
    procedure done(success: : Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Variant>};
      function getResults: Variant;
    end;;
  end;

  JUserIdentity = class external 'UserIdentity'
    firstName: String;
    id: String;
    isBetaAccount: Boolean;
    isConfirmedPC: Boolean;
    lastName: String;
    safeCustomerId: String;
    signInName: String;
    tickets: JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicket>};
  end;

  JOnlineIdAuthenticator = class external 'OnlineIdAuthenticator'
    applicationId: String;
    authenticatedSafeCustomerId: String;
    canSignOut: Boolean;
    function authenticateUserAsync(request: JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest): JWindows.Security.Authentication.OnlineId.UserAuthenticationOperation;
    function authenticateUserAsync(requests: JWindows.Foundation.Collections.IIterable{<JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest>}; credentialPromptType: JWindows.Security.Authentication.OnlineId.CredentialPromptType): JWindows.Security.Authentication.OnlineId.UserAuthenticationOperation;
    function signOutUserAsync: JWindows.Security.Authentication.OnlineId.SignOutUserOperation;
  end;

  JIOnlineIdServiceTicketRequest = class external
    policy: String;
    service: String;
  end;

  JIOnlineIdServiceTicketRequestFactory = class external
    function createOnlineIdServiceTicketRequest(service: String; policy: String): JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest;
    function createOnlineIdServiceTicketRequest(service: String): JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest;
  end;

  JIOnlineIdServiceTicket = class external
    errorCode: Float;
    request: JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest;
    value: String;
  end;

  JIUserIdentity = class external
    firstName: String;
    id: String;
    isBetaAccount: Boolean;
    isConfirmedPC: Boolean;
    lastName: String;
    safeCustomerId: String;
    signInName: String;
    tickets: JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicket>};
  end;

  JIOnlineIdAuthenticator = class external
    applicationId: String;
    authenticatedSafeCustomerId: String;
    canSignOut: Boolean;
    function authenticateUserAsync(request: JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest): JWindows.Security.Authentication.OnlineId.UserAuthenticationOperation;
    function authenticateUserAsync(requests: JWindows.Foundation.Collections.IIterable{<JWindows.Security.Authentication.OnlineId.OnlineIdServiceTicketRequest>}; credentialPromptType: JWindows.Security.Authentication.OnlineId.CredentialPromptType): JWindows.Security.Authentication.OnlineId.UserAuthenticationOperation;
    function signOutUserAsync: JWindows.Security.Authentication.OnlineId.SignOutUserOperation;
  end;

//Windows

//Security

//Authentication

//Web

type
  JWebAuthenticationResult = class external 'WebAuthenticationResult'
    responseData: String;
    responseErrorDetail: Float;
    responseStatus: JWindows.Security.Authentication.Web.WebAuthenticationStatus;
  end;

  JWebAuthenticationBroker = class external 'WebAuthenticationBroker'
    function authenticateAsync(options: JWindows.Security.Authentication.Web.WebAuthenticationOptions; requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Authentication.Web.WebAuthenticationResult>};
    function authenticateAsync(options: JWindows.Security.Authentication.Web.WebAuthenticationOptions; requestUri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Authentication.Web.WebAuthenticationResult>};
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri);
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri);
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri; continuationData: JWindows.Foundation.Collections.ValueSet; options: JWindows.Security.Authentication.Web.WebAuthenticationOptions);
    function getCurrentApplicationCallbackUri: JWindows.Foundation.Uri;
  end;

  JIWebAuthenticationResult = class external
    responseData: String;
    responseErrorDetail: Float;
    responseStatus: JWindows.Security.Authentication.Web.WebAuthenticationStatus;
  end;

  JIWebAuthenticationBrokerStatics = class external
    function authenticateAsync(options: JWindows.Security.Authentication.Web.WebAuthenticationOptions; requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Authentication.Web.WebAuthenticationResult>};
    function authenticateAsync(options: JWindows.Security.Authentication.Web.WebAuthenticationOptions; requestUri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Authentication.Web.WebAuthenticationResult>};
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri);
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri);
    procedure authenticateAndContinue(requestUri: JWindows.Foundation.Uri; callbackUri: JWindows.Foundation.Uri; continuationData: JWindows.Foundation.Collections.ValueSet; options: JWindows.Security.Authentication.Web.WebAuthenticationOptions);
    function getCurrentApplicationCallbackUri: JWindows.Foundation.Uri;
  end;

//Windows

//Security

//Credentials

//UI

type
  JCredentialPickerOptions = class external 'CredentialPickerOptions'
    alwaysDisplayDialog: Boolean;
    authenticationProtocol: JWindows.Security.Credentials.UI.AuthenticationProtocol;
    callerSavesCredential: Boolean;
    caption: String;
    credentialSaveOption: JWindows.Security.Credentials.UI.CredentialSaveOption;
    customAuthenticationProtocol: String;
    errorCode: Float;
    message: String;
    previousCredential: JWindows.Storage.Streams.IBuffer;
    targetName: String;
  end;

  JCredentialPickerResults = class external 'CredentialPickerResults'
    credential: JWindows.Storage.Streams.IBuffer;
    credentialDomainName: String;
    credentialPassword: String;
    credentialSaveOption: JWindows.Security.Credentials.UI.CredentialSaveOption;
    credentialSaved: Boolean;
    credentialUserName: String;
    errorCode: Float;
  end;

  JCredentialPicker = class external 'CredentialPicker'
    function pickAsync(options: JWindows.Security.Credentials.UI.CredentialPickerOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
    function pickAsync(targetName: String; message: String): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
    function pickAsync(targetName: String; message: String; caption: String): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
  end;

  JICredentialPickerOptions = class external
    alwaysDisplayDialog: Boolean;
    authenticationProtocol: JWindows.Security.Credentials.UI.AuthenticationProtocol;
    callerSavesCredential: Boolean;
    caption: String;
    credentialSaveOption: JWindows.Security.Credentials.UI.CredentialSaveOption;
    customAuthenticationProtocol: String;
    errorCode: Float;
    message: String;
    previousCredential: JWindows.Storage.Streams.IBuffer;
    targetName: String;
  end;

  JICredentialPickerStatics = class external
    function pickAsync(options: JWindows.Security.Credentials.UI.CredentialPickerOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
    function pickAsync(targetName: String; message: String): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
    function pickAsync(targetName: String; message: String; caption: String): JWindows.Foundation.IAsyncOperation{<JWindows.Security.Credentials.UI.CredentialPickerResults>};
  end;

  JICredentialPickerResults = class external
    credential: JWindows.Storage.Streams.IBuffer;
    credentialDomainName: String;
    credentialPassword: String;
    credentialSaveOption: JWindows.Security.Credentials.UI.CredentialSaveOption;
    credentialSaved: Boolean;
    credentialUserName: String;
    errorCode: Float;
  end;

//Windows

//Security

//Credentials

type
  JPasswordCredential = class external 'PasswordCredential'
    constructor Create(resource: String; userName: String; password: String);
    constructor Create;
    password: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    resource: String;
    userName: String;
    procedure retrievePassword;
  end;

  JPasswordVault = class external 'PasswordVault'
    procedure add(credential: JWindows.Security.Credentials.PasswordCredential);
    procedure remove(credential: JWindows.Security.Credentials.PasswordCredential);
    function retrieve(resource: String; userName: String): JWindows.Security.Credentials.PasswordCredential;
    function findAllByResource(resource: String): JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
    function findAllByUserName(userName: String): JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
    function retrieveAll: JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
  end;

  JPasswordCredentialPropertyStore = class external 'PasswordCredentialPropertyStore'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JIPasswordCredential = class external
    password: String;
    properties: JWindows.Foundation.Collections.IPropertySet;
    resource: String;
    userName: String;
    procedure retrievePassword;
  end;

  JICredentialFactory = class external
    function createPasswordCredential(resource: String; userName: String; password: String): JWindows.Security.Credentials.PasswordCredential;
  end;

  JIPasswordVault = class external
    procedure add(credential: JWindows.Security.Credentials.PasswordCredential);
    procedure remove(credential: JWindows.Security.Credentials.PasswordCredential);
    function retrieve(resource: String; userName: String): JWindows.Security.Credentials.PasswordCredential;
    function findAllByResource(resource: String): JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
    function findAllByUserName(userName: String): JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
    function retrieveAll: JWindows.Foundation.Collections.IVectorView{<JWindows.Security.Credentials.PasswordCredential>};
  end;

//Windows

//Security

//Cryptography

//Certificates

type
  JCertificateRequestProperties = class external 'CertificateRequestProperties'
    exportable: JWindows.Security.Cryptography.Certificates.ExportOption;
    friendlyName: String;
    hashAlgorithmName: String;
    keyAlgorithmName: String;
    keyProtectionLevel: JWindows.Security.Cryptography.Certificates.KeyProtectionLevel;
    keySize: Float;
    keyStorageProviderName: String;
    keyUsages: JWindows.Security.Cryptography.Certificates.EnrollKeyUsages;
    subject: String;
  end;

  JCertificateEnrollmentManager = class external 'CertificateEnrollmentManager'
    function createRequestAsync(request: JWindows.Security.Cryptography.Certificates.CertificateRequestProperties): JWindows.Foundation.IAsyncOperation{<String>};
    function installCertificateAsync(certificate: String; installOption: JWindows.Security.Cryptography.Certificates.InstallOptions): JWindows.Foundation.IAsyncAction;
    function importPfxDataAsync(pfxData: String; password: String; exportable: JWindows.Security.Cryptography.Certificates.ExportOption; keyProtectionLevel: JWindows.Security.Cryptography.Certificates.KeyProtectionLevel; installOption: JWindows.Security.Cryptography.Certificates.InstallOptions; friendlyName: String): JWindows.Foundation.IAsyncAction;
  end;

  JKeyAlgorithmNames = class external 'KeyAlgorithmNames'
    dsa: String;
    ecdh256: String;
    ecdh384: String;
    ecdh521: String;
    ecdsa256: String;
    ecdsa384: String;
    ecdsa521: String;
    rsa: String;
  end;

  JKeyStorageProviderNames = class external 'KeyStorageProviderNames'
    platformKeyStorageProvider: String;
    smartcardKeyStorageProvider: String;
    softwareKeyStorageProvider: String;
  end;

  JICertificateRequestProperties = class external
    exportable: JWindows.Security.Cryptography.Certificates.ExportOption;
    friendlyName: String;
    hashAlgorithmName: String;
    keyAlgorithmName: String;
    keyProtectionLevel: JWindows.Security.Cryptography.Certificates.KeyProtectionLevel;
    keySize: Float;
    keyStorageProviderName: String;
    keyUsages: JWindows.Security.Cryptography.Certificates.EnrollKeyUsages;
    subject: String;
  end;

  JICertificateEnrollmentManagerStatics = class external
    function createRequestAsync(request: JWindows.Security.Cryptography.Certificates.CertificateRequestProperties): JWindows.Foundation.IAsyncOperation{<String>};
    function installCertificateAsync(certificate: String; installOption: JWindows.Security.Cryptography.Certificates.InstallOptions): JWindows.Foundation.IAsyncAction;
    function importPfxDataAsync(pfxData: String; password: String; exportable: JWindows.Security.Cryptography.Certificates.ExportOption; keyProtectionLevel: JWindows.Security.Cryptography.Certificates.KeyProtectionLevel; installOption: JWindows.Security.Cryptography.Certificates.InstallOptions; friendlyName: String): JWindows.Foundation.IAsyncAction;
  end;

  JIKeyAlgorithmNamesStatics = class external
    dsa: String;
    ecdh256: String;
    ecdh384: String;
    ecdh521: String;
    ecdsa256: String;
    ecdsa384: String;
    ecdsa521: String;
    rsa: String;
  end;

  JIKeyStorageProviderNamesStatics = class external
    platformKeyStorageProvider: String;
    smartcardKeyStorageProvider: String;
    softwareKeyStorageProvider: String;
  end;

//Windows

//Security

//Cryptography

//Core

type
  JKeyDerivationParameters = class external 'KeyDerivationParameters'
    iterationCount: Float;
    kdfGenericBinary: JWindows.Storage.Streams.IBuffer;
    function buildForPbkdf2(pbkdf2Salt: JWindows.Storage.Streams.IBuffer; iterationCount: Float): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
    function buildForSP800108(&label: JWindows.Storage.Streams.IBuffer; context: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
    function buildForSP80056a(algorithmId: JWindows.Storage.Streams.IBuffer; partyUInfo: JWindows.Storage.Streams.IBuffer; partyVInfo: JWindows.Storage.Streams.IBuffer; suppPubInfo: JWindows.Storage.Streams.IBuffer; suppPrivInfo: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
  end;

  JCryptographicKey = class external 'CryptographicKey'
    keySize: Float;
    function export: JWindows.Storage.Streams.IBuffer;
    function export(BlobType: JWindows.Security.Cryptography.Core.CryptographicPrivateKeyBlobType): JWindows.Storage.Streams.IBuffer;
    function exportPublicKey: JWindows.Storage.Streams.IBuffer;
    function exportPublicKey(BlobType: JWindows.Security.Cryptography.Core.CryptographicPublicKeyBlobType): JWindows.Storage.Streams.IBuffer;
  end;

  JCryptographicHash = class external 'CryptographicHash'
    procedure append(data: JWindows.Storage.Streams.IBuffer);
    function getValueAndReset: JWindows.Storage.Streams.IBuffer;
  end;

  JEncryptedAndAuthenticatedData = class external 'EncryptedAndAuthenticatedData'
    authenticationTag: JWindows.Storage.Streams.IBuffer;
    encryptedData: JWindows.Storage.Streams.IBuffer;
  end;

  JCryptographicEngine = class external 'CryptographicEngine'
    function encrypt(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; iv: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function decrypt(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; iv: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function encryptAndAuthenticate(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; nonce: JWindows.Storage.Streams.IBuffer; authenticatedData: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.EncryptedAndAuthenticatedData;
    function decryptAndAuthenticate(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; nonce: JWindows.Storage.Streams.IBuffer; authenticationTag: JWindows.Storage.Streams.IBuffer; authenticatedData: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function sign(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function verifySignature(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; signature: JWindows.Storage.Streams.IBuffer): Boolean;
    function deriveKeyMaterial(key: JWindows.Security.Cryptography.Core.CryptographicKey; parameters: JWindows.Security.Cryptography.Core.KeyDerivationParameters; desiredKeySize: Float): JWindows.Storage.Streams.IBuffer;
  end;

  JHashAlgorithmProvider = class external 'HashAlgorithmProvider'
    algorithmName: String;
    hashLength: Float;
    function hashData(data: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function createHash: JWindows.Security.Cryptography.Core.CryptographicHash;
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.HashAlgorithmProvider;
  end;

  JMacAlgorithmProvider = class external 'MacAlgorithmProvider'
    algorithmName: String;
    macLength: Float;
    function createKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.MacAlgorithmProvider;
  end;

  JKeyDerivationAlgorithmProvider = class external 'KeyDerivationAlgorithmProvider'
    algorithmName: String;
    function createKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.KeyDerivationAlgorithmProvider;
  end;

  JSymmetricKeyAlgorithmProvider = class external 'SymmetricKeyAlgorithmProvider'
    algorithmName: String;
    blockLength: Float;
    function createSymmetricKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.SymmetricKeyAlgorithmProvider;
  end;

  JAsymmetricKeyAlgorithmProvider = class external 'AsymmetricKeyAlgorithmProvider'
    algorithmName: String;
    function createKeyPair(keySize: Float): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importKeyPair(keyBlob: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importKeyPair(keyBlob: JWindows.Storage.Streams.IBuffer; BlobType: JWindows.Security.Cryptography.Core.CryptographicPrivateKeyBlobType): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importPublicKey(keyBlob: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importPublicKey(keyBlob: JWindows.Storage.Streams.IBuffer; BlobType: JWindows.Security.Cryptography.Core.CryptographicPublicKeyBlobType): JWindows.Security.Cryptography.Core.CryptographicKey;
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.AsymmetricKeyAlgorithmProvider;
  end;

  JHashAlgorithmNames = class external 'HashAlgorithmNames'
    md5: String;
    sha1: String;
    sha256: String;
    sha384: String;
    sha512: String;
  end;

  JMacAlgorithmNames = class external 'MacAlgorithmNames'
    aesCmac: String;
    hmacMd5: String;
    hmacSha1: String;
    hmacSha256: String;
    hmacSha384: String;
    hmacSha512: String;
  end;

  JSymmetricAlgorithmNames = class external 'SymmetricAlgorithmNames'
    aesCbc: String;
    aesCbcPkcs7: String;
    aesCcm: String;
    aesEcb: String;
    aesEcbPkcs7: String;
    aesGcm: String;
    desCbc: String;
    desCbcPkcs7: String;
    desEcb: String;
    desEcbPkcs7: String;
    rc2Cbc: String;
    rc2CbcPkcs7: String;
    rc2Ecb: String;
    rc2EcbPkcs7: String;
    rc4: String;
    tripleDesCbc: String;
    tripleDesCbcPkcs7: String;
    tripleDesEcb: String;
    tripleDesEcbPkcs7: String;
  end;

  JAsymmetricAlgorithmNames = class external 'AsymmetricAlgorithmNames'
    dsaSha1: String;
    dsaSha256: String;
    ecdsaP256Sha256: String;
    ecdsaP384Sha384: String;
    ecdsaP521Sha512: String;
    rsaOaepSha1: String;
    rsaOaepSha256: String;
    rsaOaepSha384: String;
    rsaOaepSha512: String;
    rsaPkcs1: String;
    rsaSignPkcs1Sha1: String;
    rsaSignPkcs1Sha256: String;
    rsaSignPkcs1Sha384: String;
    rsaSignPkcs1Sha512: String;
    rsaSignPssSha1: String;
    rsaSignPssSha256: String;
    rsaSignPssSha384: String;
    rsaSignPssSha512: String;
  end;

  JKeyDerivationAlgorithmNames = class external 'KeyDerivationAlgorithmNames'
    pbkdf2Md5: String;
    pbkdf2Sha1: String;
    pbkdf2Sha256: String;
    pbkdf2Sha384: String;
    pbkdf2Sha512: String;
    sp800108CtrHmacMd5: String;
    sp800108CtrHmacSha1: String;
    sp800108CtrHmacSha256: String;
    sp800108CtrHmacSha384: String;
    sp800108CtrHmacSha512: String;
    sp80056aConcatMd5: String;
    sp80056aConcatSha1: String;
    sp80056aConcatSha256: String;
    sp80056aConcatSha384: String;
    sp80056aConcatSha512: String;
  end;

  JIKeyDerivationParameters = class external
    iterationCount: Float;
    kdfGenericBinary: JWindows.Storage.Streams.IBuffer;
  end;

  JIKeyDerivationParametersStatics = class external
    function buildForPbkdf2(pbkdf2Salt: JWindows.Storage.Streams.IBuffer; iterationCount: Float): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
    function buildForSP800108(&label: JWindows.Storage.Streams.IBuffer; context: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
    function buildForSP80056a(algorithmId: JWindows.Storage.Streams.IBuffer; partyUInfo: JWindows.Storage.Streams.IBuffer; partyVInfo: JWindows.Storage.Streams.IBuffer; suppPubInfo: JWindows.Storage.Streams.IBuffer; suppPrivInfo: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.KeyDerivationParameters;
  end;

  JICryptographicKey = class external
    keySize: Float;
    function export: JWindows.Storage.Streams.IBuffer;
    function export(BlobType: JWindows.Security.Cryptography.Core.CryptographicPrivateKeyBlobType): JWindows.Storage.Streams.IBuffer;
    function exportPublicKey: JWindows.Storage.Streams.IBuffer;
    function exportPublicKey(BlobType: JWindows.Security.Cryptography.Core.CryptographicPublicKeyBlobType): JWindows.Storage.Streams.IBuffer;
  end;

  JIHashComputation = class external
    procedure append(data: JWindows.Storage.Streams.IBuffer);
    function getValueAndReset: JWindows.Storage.Streams.IBuffer;
  end;

  JIHashAlgorithmProvider = class external
    algorithmName: String;
    hashLength: Float;
    function hashData(data: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function createHash: JWindows.Security.Cryptography.Core.CryptographicHash;
  end;

  JIMacAlgorithmProvider = class external
    algorithmName: String;
    macLength: Float;
    function createKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
  end;

  JIKeyDerivationAlgorithmProvider = class external
    algorithmName: String;
    function createKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
  end;

  JISymmetricKeyAlgorithmProvider = class external
    algorithmName: String;
    blockLength: Float;
    function createSymmetricKey(keyMaterial: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
  end;

  JIAsymmetricKeyAlgorithmProvider = class external
    algorithmName: String;
    function createKeyPair(keySize: Float): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importKeyPair(keyBlob: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importKeyPair(keyBlob: JWindows.Storage.Streams.IBuffer; BlobType: JWindows.Security.Cryptography.Core.CryptographicPrivateKeyBlobType): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importPublicKey(keyBlob: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.CryptographicKey;
    function importPublicKey(keyBlob: JWindows.Storage.Streams.IBuffer; BlobType: JWindows.Security.Cryptography.Core.CryptographicPublicKeyBlobType): JWindows.Security.Cryptography.Core.CryptographicKey;
  end;

  JIEncryptedAndAuthenticatedData = class external
    authenticationTag: JWindows.Storage.Streams.IBuffer;
    encryptedData: JWindows.Storage.Streams.IBuffer;
  end;

  JICryptographicEngineStatics = class external
    function encrypt(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; iv: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function decrypt(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; iv: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function encryptAndAuthenticate(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; nonce: JWindows.Storage.Streams.IBuffer; authenticatedData: JWindows.Storage.Streams.IBuffer): JWindows.Security.Cryptography.Core.EncryptedAndAuthenticatedData;
    function decryptAndAuthenticate(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; nonce: JWindows.Storage.Streams.IBuffer; authenticationTag: JWindows.Storage.Streams.IBuffer; authenticatedData: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function sign(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.IBuffer;
    function verifySignature(key: JWindows.Security.Cryptography.Core.CryptographicKey; data: JWindows.Storage.Streams.IBuffer; signature: JWindows.Storage.Streams.IBuffer): Boolean;
    function deriveKeyMaterial(key: JWindows.Security.Cryptography.Core.CryptographicKey; parameters: JWindows.Security.Cryptography.Core.KeyDerivationParameters; desiredKeySize: Float): JWindows.Storage.Streams.IBuffer;
  end;

  JIHashAlgorithmProviderStatics = class external
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.HashAlgorithmProvider;
  end;

  JIMacAlgorithmProviderStatics = class external
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.MacAlgorithmProvider;
  end;

  JIKeyDerivationAlgorithmProviderStatics = class external
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.KeyDerivationAlgorithmProvider;
  end;

  JISymmetricKeyAlgorithmProviderStatics = class external
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.SymmetricKeyAlgorithmProvider;
  end;

  JIAsymmetricKeyAlgorithmProviderStatics = class external
    function openAlgorithm(algorithm: String): JWindows.Security.Cryptography.Core.AsymmetricKeyAlgorithmProvider;
  end;

  JIHashAlgorithmNamesStatics = class external
    md5: String;
    sha1: String;
    sha256: String;
    sha384: String;
    sha512: String;
  end;

  JIMacAlgorithmNamesStatics = class external
    aesCmac: String;
    hmacMd5: String;
    hmacSha1: String;
    hmacSha256: String;
    hmacSha384: String;
    hmacSha512: String;
  end;

  JISymmetricAlgorithmNamesStatics = class external
    aesCbc: String;
    aesCbcPkcs7: String;
    aesCcm: String;
    aesEcb: String;
    aesEcbPkcs7: String;
    aesGcm: String;
    desCbc: String;
    desCbcPkcs7: String;
    desEcb: String;
    desEcbPkcs7: String;
    rc2Cbc: String;
    rc2CbcPkcs7: String;
    rc2Ecb: String;
    rc2EcbPkcs7: String;
    rc4: String;
    tripleDesCbc: String;
    tripleDesCbcPkcs7: String;
    tripleDesEcb: String;
    tripleDesEcbPkcs7: String;
  end;

  JIAsymmetricAlgorithmNamesStatics = class external
    dsaSha1: String;
    dsaSha256: String;
    ecdsaP256Sha256: String;
    ecdsaP384Sha384: String;
    ecdsaP521Sha512: String;
    rsaOaepSha1: String;
    rsaOaepSha256: String;
    rsaOaepSha384: String;
    rsaOaepSha512: String;
    rsaPkcs1: String;
    rsaSignPkcs1Sha1: String;
    rsaSignPkcs1Sha256: String;
    rsaSignPkcs1Sha384: String;
    rsaSignPkcs1Sha512: String;
    rsaSignPssSha1: String;
    rsaSignPssSha256: String;
    rsaSignPssSha384: String;
    rsaSignPssSha512: String;
  end;

  JIKeyDerivationAlgorithmNamesStatics = class external
    pbkdf2Md5: String;
    pbkdf2Sha1: String;
    pbkdf2Sha256: String;
    pbkdf2Sha384: String;
    pbkdf2Sha512: String;
    sp800108CtrHmacMd5: String;
    sp800108CtrHmacSha1: String;
    sp800108CtrHmacSha256: String;
    sp800108CtrHmacSha384: String;
    sp800108CtrHmacSha512: String;
    sp80056aConcatMd5: String;
    sp80056aConcatSha1: String;
    sp80056aConcatSha256: String;
    sp80056aConcatSha384: String;
    sp80056aConcatSha512: String;
  end;

//Windows

//Security

//Cryptography

//DataProtection

type
  JDataProtectionProvider = class external 'DataProtectionProvider'
    constructor Create(protectionDescriptor: String);
    constructor Create;
    function protectAsync(data: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function unprotectAsync(data: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function protectStreamAsync(src: JWindows.Storage.Streams.IInputStream; dest: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncAction;
    function unprotectStreamAsync(src: JWindows.Storage.Streams.IInputStream; dest: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncAction;
  end;

  JIDataProtectionProvider = class external
    function protectAsync(data: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function unprotectAsync(data: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function protectStreamAsync(src: JWindows.Storage.Streams.IInputStream; dest: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncAction;
    function unprotectStreamAsync(src: JWindows.Storage.Streams.IInputStream; dest: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncAction;
  end;

  JIDataProtectionProviderFactory = class external
    function createOverloadExplicit(protectionDescriptor: String): JWindows.Security.Cryptography.DataProtection.DataProtectionProvider;
  end;

//Windows

//Security

//Cryptography

type
  JCryptographicBuffer = class external 'CryptographicBuffer'
    function compare(object1: JWindows.Storage.Streams.IBuffer; object2: JWindows.Storage.Streams.IBuffer): Boolean;
    function generateRandom(_length: Float): JWindows.Storage.Streams.IBuffer;
    function generateRandomNumber: Float;
    function createFromByteArray(value: JUint8Array): JWindows.Storage.Streams.IBuffer;
    function copyToByteArray(buffer: JWindows.Storage.Streams.IBuffer): JUint8Array;
    function decodeFromHexString(value: String): JWindows.Storage.Streams.IBuffer;
    function encodeToHexString(buffer: JWindows.Storage.Streams.IBuffer): String;
    function decodeFromBase64String(value: String): JWindows.Storage.Streams.IBuffer;
    function encodeToBase64String(buffer: JWindows.Storage.Streams.IBuffer): String;
    function convertStringToBinary(value: String; encoding: JWindows.Security.Cryptography.BinaryStringEncoding): JWindows.Storage.Streams.IBuffer;
    function convertBinaryToString(encoding: JWindows.Security.Cryptography.BinaryStringEncoding; buffer: JWindows.Storage.Streams.IBuffer): String;
  end;

  JICryptographicBufferStatics = class external
    function compare(object1: JWindows.Storage.Streams.IBuffer; object2: JWindows.Storage.Streams.IBuffer): Boolean;
    function generateRandom(_length: Float): JWindows.Storage.Streams.IBuffer;
    function generateRandomNumber: Float;
    function createFromByteArray(value: JUint8Array): JWindows.Storage.Streams.IBuffer;
    function copyToByteArray(buffer: JWindows.Storage.Streams.IBuffer): JUint8Array;
    function decodeFromHexString(value: String): JWindows.Storage.Streams.IBuffer;
    function encodeToHexString(buffer: JWindows.Storage.Streams.IBuffer): String;
    function decodeFromBase64String(value: String): JWindows.Storage.Streams.IBuffer;
    function encodeToBase64String(buffer: JWindows.Storage.Streams.IBuffer): String;
    function convertStringToBinary(value: String; encoding: JWindows.Security.Cryptography.BinaryStringEncoding): JWindows.Storage.Streams.IBuffer;
    function convertBinaryToString(encoding: JWindows.Security.Cryptography.BinaryStringEncoding; buffer: JWindows.Storage.Streams.IBuffer): String;
  end;

//Windows

//Security

//ExchangeActiveSyncProvisioning

type
  JEasComplianceResults = class external 'EasComplianceResults'
    compliant: Boolean;
    disallowConvenienceLogonResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasDisallowConvenienceLogonResult;
    maxInactivityTimeLockResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMaxInactivityTimeLockResult;
    maxPasswordFailedAttemptsResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMaxPasswordFailedAttemptsResult;
    minPasswordComplexCharactersResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMinPasswordComplexCharactersResult;
    minPasswordLengthResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMinPasswordLengthResult;
    passwordExpirationResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasPasswordExpirationResult;
    passwordHistoryResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasPasswordHistoryResult;
    requireEncryptionResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasRequireEncryptionResult;
  end;

  JEasClientSecurityPolicy = class external 'EasClientSecurityPolicy'
    disallowConvenienceLogon: Boolean;
    maxInactivityTimeLock: Float;
    maxPasswordFailedAttempts: Float;
    minPasswordComplexCharacters: Float;
    minPasswordLength: Float;
    passwordExpiration: Float;
    passwordHistory: Float;
    requireEncryption: Boolean;
    function checkCompliance: JWindows.Security.ExchangeActiveSyncProvisioning.EasComplianceResults;
    function applyAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Security.ExchangeActiveSyncProvisioning.EasComplianceResults>};
  end;

  JEasClientDeviceInformation = class external 'EasClientDeviceInformation'
    friendlyName: String;
    id: String;
    operatingSystem: String;
    systemManufacturer: String;
    systemProductName: String;
    systemSku: String;
  end;

  JIEasClientDeviceInformation = class external
    friendlyName: String;
    id: String;
    operatingSystem: String;
    systemManufacturer: String;
    systemProductName: String;
    systemSku: String;
  end;

  JIEasClientSecurityPolicy = class external
    disallowConvenienceLogon: Boolean;
    maxInactivityTimeLock: Float;
    maxPasswordFailedAttempts: Float;
    minPasswordComplexCharacters: Float;
    minPasswordLength: Float;
    passwordExpiration: Float;
    passwordHistory: Float;
    requireEncryption: Boolean;
    function checkCompliance: JWindows.Security.ExchangeActiveSyncProvisioning.EasComplianceResults;
    function applyAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Security.ExchangeActiveSyncProvisioning.EasComplianceResults>};
  end;

  JIEasComplianceResults = class external
    compliant: Boolean;
    disallowConvenienceLogonResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasDisallowConvenienceLogonResult;
    maxInactivityTimeLockResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMaxInactivityTimeLockResult;
    maxPasswordFailedAttemptsResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMaxPasswordFailedAttemptsResult;
    minPasswordComplexCharactersResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMinPasswordComplexCharactersResult;
    minPasswordLengthResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasMinPasswordLengthResult;
    passwordExpirationResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasPasswordExpirationResult;
    passwordHistoryResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasPasswordHistoryResult;
    requireEncryptionResult: JWindows.Security.ExchangeActiveSyncProvisioning.EasRequireEncryptionResult;
  end;

//Windows

//Storage

//Streams

type
  JDataReaderLoadOperation = class external 'DataReaderLoadOperation'
    completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Float>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: Float;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: Float): Variant); overload;
    procedure done(success: (value: Float): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: Float): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Float>};
      function getResults: Float;
    end;;
  end;

  JDataReader = class external 'DataReader'
    constructor Create(inputStream: JWindows.Storage.Streams.IInputStream);
    byteOrder: JWindows.Storage.Streams.ByteOrder;
    inputStreamOptions: JWindows.Storage.Streams.InputStreamOptions;
    unconsumedBufferLength: Float;
    unicodeEncoding: JWindows.Storage.Streams.UnicodeEncoding;
    function readByte: Float;
    procedure readBytes(value: array of Float);
    procedure readBytes(value: JUint8Array);
    function readBuffer(_length: Float): JWindows.Storage.Streams.IBuffer;
    function readBoolean: Boolean;
    function readGuid: String;
    function readInt16: Float;
    function readInt32: Float;
    function readInt64: Float;
    function readUInt16: Float;
    function readUInt32: Float;
    function readUInt64: Float;
    function readSingle: Float;
    function readDouble: Float;
    function readString(codeUnitCount: Float): String;
    function readDateTime: JDate;
    function readTimeSpan: Float;
    function loadAsync(count: Float): JWindows.Storage.Streams.DataReaderLoadOperation;
    function detachBuffer: JWindows.Storage.Streams.IBuffer;
    function detachStream: JWindows.Storage.Streams.IInputStream;
    procedure dispose;
    function fromBuffer(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.DataReader;
    procedure close;
  end;

  JDataWriterStoreOperation = class external 'DataWriterStoreOperation'
    completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Float>};
    errorCode: Float;
    id: Float;
    status: JWindows.Foundation.AsyncStatus;
    function getResults: Float;
    procedure cancel;
    procedure close;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JU; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    function then: JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}): JWindows.Foundation.IPromise{<JU>}; overload;
    function then(success: (value: Float): JWindows.Foundation.IPromise{<JU>}; error: (error: Variant): JWindows.Foundation.IPromise{<JU>}; progress: (progress: Variant)): JWindows.Foundation.IPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: Float): Variant); overload;
    procedure done(success: (value: Float): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: Float): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    operation:       completed: JWindows.Foundation.AsyncOperationCompletedHandler{<Float>};
      function getResults: Float;
    end;;
  end;

  JDataWriter = class external 'DataWriter'
    constructor Create(outputStream: JWindows.Storage.Streams.IOutputStream);
    constructor Create;
    byteOrder: JWindows.Storage.Streams.ByteOrder;
    unicodeEncoding: JWindows.Storage.Streams.UnicodeEncoding;
    unstoredBufferLength: Float;
    procedure writeByte(value: Float);
    procedure writeBytes(value: array of Float);
    procedure writeBytes(value: JUint8Array);
    procedure writeBuffer(buffer: JWindows.Storage.Streams.IBuffer);
    procedure writeBuffer(buffer: JWindows.Storage.Streams.IBuffer; start: Float; count: Float);
    procedure writeBoolean(value: Boolean);
    procedure writeGuid(value: String);
    procedure writeInt16(value: Float);
    procedure writeInt32(value: Float);
    procedure writeInt64(value: Float);
    procedure writeUInt16(value: Float);
    procedure writeUInt32(value: Float);
    procedure writeUInt64(value: Float);
    procedure writeSingle(value: Float);
    procedure writeDouble(value: Float);
    procedure writeDateTime(value: JDate);
    procedure writeTimeSpan(value: Float);
    function writeString(value: String): Float;
    function measureString(value: String): Float;
    function storeAsync: JWindows.Storage.Streams.DataWriterStoreOperation;
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function detachBuffer: JWindows.Storage.Streams.IBuffer;
    function detachStream: JWindows.Storage.Streams.IOutputStream;
    procedure dispose;
    procedure close;
  end;

  JRandomAccessStream = class external 'RandomAccessStream'
    function copyAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function copyAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream; bytesToCopy: Float): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function copyAndCloseAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
  end;

  JBuffer = class external 'Buffer'
    constructor Create(capacity: Float);
    capacity: Float;
    _length: Float;
  end;

  JRandomAccessStreamReference = class external 'RandomAccessStreamReference'
    function openReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
    function createFromFile(file: JWindows.Storage.IStorageFile): JWindows.Storage.Streams.RandomAccessStreamReference;
    function createFromUri(uri: JWindows.Foundation.Uri): JWindows.Storage.Streams.RandomAccessStreamReference;
    function createFromStream(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Storage.Streams.RandomAccessStreamReference;
  end;

  JFileRandomAccessStream = class external 'FileRandomAccessStream'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JFileInputStream = class external 'FileInputStream'
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    procedure dispose;
    procedure close;
  end;

  JFileOutputStream = class external 'FileOutputStream'
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure dispose;
    procedure close;
  end;

  JRandomAccessStreamOverStream = class external 'RandomAccessStreamOverStream'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JInputStreamOverStream = class external 'InputStreamOverStream'
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    procedure dispose;
    procedure close;
  end;

  JOutputStreamOverStream = class external 'OutputStreamOverStream'
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure dispose;
    procedure close;
  end;

  JInMemoryRandomAccessStream = class external 'InMemoryRandomAccessStream'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JIDataReader = class external
    byteOrder: JWindows.Storage.Streams.ByteOrder;
    inputStreamOptions: JWindows.Storage.Streams.InputStreamOptions;
    unconsumedBufferLength: Float;
    unicodeEncoding: JWindows.Storage.Streams.UnicodeEncoding;
    function readByte: Float;
    procedure readBytes(value: array of Float);
    procedure readBytes(value: JUint8Array);
    function readBuffer(_length: Float): JWindows.Storage.Streams.IBuffer;
    function readBoolean: Boolean;
    function readGuid: String;
    function readInt16: Float;
    function readInt32: Float;
    function readInt64: Float;
    function readUInt16: Float;
    function readUInt32: Float;
    function readUInt64: Float;
    function readSingle: Float;
    function readDouble: Float;
    function readString(codeUnitCount: Float): String;
    function readDateTime: JDate;
    function readTimeSpan: Float;
    function loadAsync(count: Float): JWindows.Storage.Streams.DataReaderLoadOperation;
    function detachBuffer: JWindows.Storage.Streams.IBuffer;
    function detachStream: JWindows.Storage.Streams.IInputStream;
  end;

  JIDataReaderFactory = class external
    function createDataReader(inputStream: JWindows.Storage.Streams.IInputStream): JWindows.Storage.Streams.DataReader;
  end;

  JIDataReaderStatics = class external
    function fromBuffer(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Storage.Streams.DataReader;
  end;

  JIDataWriter = class external
    byteOrder: JWindows.Storage.Streams.ByteOrder;
    unicodeEncoding: JWindows.Storage.Streams.UnicodeEncoding;
    unstoredBufferLength: Float;
    procedure writeByte(value: Float);
    procedure writeBytes(value: array of Float);
    procedure writeBytes(value: JUint8Array);
    procedure writeBuffer(buffer: JWindows.Storage.Streams.IBuffer);
    procedure writeBuffer(buffer: JWindows.Storage.Streams.IBuffer; start: Float; count: Float);
    procedure writeBoolean(value: Boolean);
    procedure writeGuid(value: String);
    procedure writeInt16(value: Float);
    procedure writeInt32(value: Float);
    procedure writeInt64(value: Float);
    procedure writeUInt16(value: Float);
    procedure writeUInt32(value: Float);
    procedure writeUInt64(value: Float);
    procedure writeSingle(value: Float);
    procedure writeDouble(value: Float);
    procedure writeDateTime(value: JDate);
    procedure writeTimeSpan(value: Float);
    function writeString(value: String): Float;
    function measureString(value: String): Float;
    function storeAsync: JWindows.Storage.Streams.DataWriterStoreOperation;
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function detachBuffer: JWindows.Storage.Streams.IBuffer;
    function detachStream: JWindows.Storage.Streams.IOutputStream;
  end;

  JIDataWriterFactory = class external
    function createDataWriter(outputStream: JWindows.Storage.Streams.IOutputStream): JWindows.Storage.Streams.DataWriter;
  end;

  JIRandomAccessStreamStatics = class external
    function copyAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function copyAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream; bytesToCopy: Float): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function copyAndCloseAsync(source: JWindows.Storage.Streams.IInputStream; destination: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
  end;

  JIBufferFactory = class external
    function create(capacity: Float): JWindows.Storage.Streams.Buffer;
  end;

  JIBuffer = class external
    capacity: Float;
    _length: Float;
  end;

  JIContentTypeProvider = class external
    contentType: String;
  end;

  JIRandomAccessStreamReference = class external
    function openReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
  end;

  JIInputStreamReference = class external
    function openSequentialReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IInputStream>};
  end;

  JIRandomAccessStreamReferenceStatics = class external
    function createFromFile(file: JWindows.Storage.IStorageFile): JWindows.Storage.Streams.RandomAccessStreamReference;
    function createFromUri(uri: JWindows.Foundation.Uri): JWindows.Storage.Streams.RandomAccessStreamReference;
    function createFromStream(stream: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Storage.Streams.RandomAccessStreamReference;
  end;

  JIInputStream = class external(JWindows.Foundation.IClosable)
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
  end;

  JIOutputStream = class external(JWindows.Foundation.IClosable)
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

  JIRandomAccessStream = class external(JWindows.Foundation.IClosable, JWindows.Storage.Streams.IInputStream, JWindows.Storage.Streams.IOutputStream)
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
  end;

  JIRandomAccessStreamWithContentType = class external(JWindows.Storage.Streams.IRandomAccessStream, JWindows.Foundation.IClosable, JWindows.Storage.Streams.IInputStream, JWindows.Storage.Streams.IOutputStream, JWindows.Storage.Streams.IContentTypeProvider)
  end;

//Windows

//Storage

//Pickers

//Provider

type
  JFileRemovedEventArgs = class external 'FileRemovedEventArgs'
    id: String;
  end;

  JFileOpenPickerUI = class external 'FileOpenPickerUI'
    allowedFileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    selectionMode: JWindows.Storage.Pickers.Provider.FileSelectionMode;
    settingsIdentifier: String;
    title: String;
    function addFile(id: String; file: JWindows.Storage.IStorageFile): JWindows.Storage.Pickers.Provider.AddFileResult;
    procedure removeFile(id: String);
    function containsFile(id: String): Boolean;
    function canAddFile(file: JWindows.Storage.IStorageFile): Boolean;
    onfileremoved: Variant;
    onclosing: Variant;
  end;

  JPickerClosingEventArgs = class external 'PickerClosingEventArgs'
    closingOperation: JWindows.Storage.Pickers.Provider.PickerClosingOperation;
    isCanceled: Boolean;
  end;

  JPickerClosingOperation = class external 'PickerClosingOperation'
    deadline: JDate;
    function getDeferral: JWindows.Storage.Pickers.Provider.PickerClosingDeferral;
  end;

  JPickerClosingDeferral = class external 'PickerClosingDeferral'
    procedure complete;
  end;

  JFileSavePickerUI = class external 'FileSavePickerUI'
    allowedFileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    fileName: String;
    settingsIdentifier: String;
    title: String;
    function trySetFileName(value: String): JWindows.Storage.Pickers.Provider.SetFileNameResult;
    onfilenamechanged: Variant;
    ontargetfilerequested: Variant;
  end;

  JTargetFileRequestedEventArgs = class external 'TargetFileRequestedEventArgs'
    request: JWindows.Storage.Pickers.Provider.TargetFileRequest;
  end;

  JTargetFileRequest = class external 'TargetFileRequest'
    targetFile: JWindows.Storage.IStorageFile;
    function getDeferral: JWindows.Storage.Pickers.Provider.TargetFileRequestDeferral;
  end;

  JTargetFileRequestDeferral = class external 'TargetFileRequestDeferral'
    procedure complete;
  end;

  JIFileRemovedEventArgs = class external
    id: String;
  end;

  JIFileOpenPickerUI = class external
    allowedFileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    selectionMode: JWindows.Storage.Pickers.Provider.FileSelectionMode;
    settingsIdentifier: String;
    title: String;
    function addFile(id: String; file: JWindows.Storage.IStorageFile): JWindows.Storage.Pickers.Provider.AddFileResult;
    procedure removeFile(id: String);
    function containsFile(id: String): Boolean;
    function canAddFile(file: JWindows.Storage.IStorageFile): Boolean;
    onfileremoved: Variant;
    onclosing: Variant;
  end;

  JIPickerClosingEventArgs = class external
    closingOperation: JWindows.Storage.Pickers.Provider.PickerClosingOperation;
    isCanceled: Boolean;
  end;

  JIPickerClosingOperation = class external
    deadline: JDate;
    function getDeferral: JWindows.Storage.Pickers.Provider.PickerClosingDeferral;
  end;

  JIPickerClosingDeferral = class external
    procedure complete;
  end;

  JIFileSavePickerUI = class external
    allowedFileTypes: JWindows.Foundation.Collections.IVectorView{<String>};
    fileName: String;
    settingsIdentifier: String;
    title: String;
    function trySetFileName(value: String): JWindows.Storage.Pickers.Provider.SetFileNameResult;
    onfilenamechanged: Variant;
    ontargetfilerequested: Variant;
  end;

  JITargetFileRequestedEventArgs = class external
    request: JWindows.Storage.Pickers.Provider.TargetFileRequest;
  end;

  JITargetFileRequest = class external
    targetFile: JWindows.Storage.IStorageFile;
    function getDeferral: JWindows.Storage.Pickers.Provider.TargetFileRequestDeferral;
  end;

  JITargetFileRequestDeferral = class external
    procedure complete;
  end;

//Windows

//Storage

//Provider

type
  JCachedFileUpdaterUI = class external 'CachedFileUpdaterUI'
    title: String;
    uIStatus: JWindows.Storage.Provider.UIStatus;
    updateTarget: JWindows.Storage.Provider.CachedFileTarget;
    onfileupdaterequested: Variant;
    onuirequested: Variant;
  end;

  JFileUpdateRequestedEventArgs = class external 'FileUpdateRequestedEventArgs'
    request: JWindows.Storage.Provider.FileUpdateRequest;
  end;

  JFileUpdateRequest = class external 'FileUpdateRequest'
    contentId: String;
    file: JWindows.Storage.StorageFile;
    status: JWindows.Storage.Provider.FileUpdateStatus;
    function getDeferral: JWindows.Storage.Provider.FileUpdateRequestDeferral;
    procedure updateLocalFile(value: JWindows.Storage.IStorageFile);
  end;

  JFileUpdateRequestDeferral = class external 'FileUpdateRequestDeferral'
    procedure complete;
  end;

  JCachedFileUpdater = class external 'CachedFileUpdater'
    procedure setUpdateInformation(file: JWindows.Storage.IStorageFile; contentId: String; readMode: JWindows.Storage.Provider.ReadActivationMode; writeMode: JWindows.Storage.Provider.WriteActivationMode; options: JWindows.Storage.Provider.CachedFileOptions);
  end;

  JICachedFileUpdaterUI = class external
    title: String;
    uIStatus: JWindows.Storage.Provider.UIStatus;
    updateTarget: JWindows.Storage.Provider.CachedFileTarget;
    onfileupdaterequested: Variant;
    onuirequested: Variant;
  end;

  JIFileUpdateRequestedEventArgs = class external
    request: JWindows.Storage.Provider.FileUpdateRequest;
  end;

  JIFileUpdateRequest = class external
    contentId: String;
    file: JWindows.Storage.StorageFile;
    status: JWindows.Storage.Provider.FileUpdateStatus;
    function getDeferral: JWindows.Storage.Provider.FileUpdateRequestDeferral;
    procedure updateLocalFile(value: JWindows.Storage.IStorageFile);
  end;

  JIFileUpdateRequestDeferral = class external
    procedure complete;
  end;

  JICachedFileUpdaterStatics = class external
    procedure setUpdateInformation(file: JWindows.Storage.IStorageFile; contentId: String; readMode: JWindows.Storage.Provider.ReadActivationMode; writeMode: JWindows.Storage.Provider.WriteActivationMode; options: JWindows.Storage.Provider.CachedFileOptions);
  end;

//Windows

//Storage

//FileProperties

type
  JStorageItemThumbnail = class external 'StorageItemThumbnail'
    canRead: Boolean;
    canWrite: Boolean;
    position: Float;
    size: Float;
    contentType: String;
    originalHeight: Float;
    originalWidth: Float;
    returnedSmallerCachedSize: Boolean;
    &type: JWindows.Storage.FileProperties.ThumbnailType;
    function getInputStreamAt(position: Float): JWindows.Storage.Streams.IInputStream;
    function getOutputStreamAt(position: Float): JWindows.Storage.Streams.IOutputStream;
    procedure seek(position: Float);
    function cloneStream: JWindows.Storage.Streams.IRandomAccessStream;
    procedure dispose;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure close;
  end;

  JMusicProperties = class external 'MusicProperties'
    album: String;
    albumArtist: String;
    artist: String;
    bitrate: Float;
    composers: JWindows.Foundation.Collections.IVector{<String>};
    conductors: JWindows.Foundation.Collections.IVector{<String>};
    duration: Float;
    genre: JWindows.Foundation.Collections.IVector{<String>};
    producers: JWindows.Foundation.Collections.IVector{<String>};
    publisher: String;
    rating: Float;
    subtitle: String;
    title: String;
    trackNumber: Float;
    writers: JWindows.Foundation.Collections.IVector{<String>};
    year: Float;
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JVideoProperties = class external 'VideoProperties'
    bitrate: Float;
    directors: JWindows.Foundation.Collections.IVector{<String>};
    duration: Float;
    height: Float;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    latitude: Float;
    longitude: Float;
    orientation: JWindows.Storage.FileProperties.VideoOrientation;
    producers: JWindows.Foundation.Collections.IVector{<String>};
    publisher: String;
    rating: Float;
    subtitle: String;
    title: String;
    width: Float;
    writers: JWindows.Foundation.Collections.IVector{<String>};
    year: Float;
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JImageProperties = class external 'ImageProperties'
    cameraManufacturer: String;
    cameraModel: String;
    dateTaken: JDate;
    height: Float;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    latitude: Float;
    longitude: Float;
    orientation: JWindows.Storage.FileProperties.PhotoOrientation;
    peopleNames: JWindows.Foundation.Collections.IVectorView{<String>};
    rating: Float;
    title: String;
    width: Float;
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JDocumentProperties = class external 'DocumentProperties'
    author: JWindows.Foundation.Collections.IVector{<String>};
    comment: String;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    title: String;
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JStorageItemContentProperties = class external 'StorageItemContentProperties'
    function getMusicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.MusicProperties>};
    function getVideoPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.VideoProperties>};
    function getImagePropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.ImageProperties>};
    function getDocumentPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.DocumentProperties>};
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JBasicProperties = class external 'BasicProperties'
    dateModified: JDate;
    itemDate: JDate;
    size: Float;
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JIThumbnailProperties = class external
    originalHeight: Float;
    originalWidth: Float;
    returnedSmallerCachedSize: Boolean;
    &type: JWindows.Storage.FileProperties.ThumbnailType;
  end;

  JIStorageItemExtraProperties = class external
    function retrievePropertiesAsync(propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IMap{<StringVariant>}>};
    function savePropertiesAsync(propertiesToSave: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>}): JWindows.Foundation.IAsyncAction;
    function savePropertiesAsync: JWindows.Foundation.IAsyncAction;
  end;

  JIStorageItemContentProperties = class external(JWindows.Storage.FileProperties.IStorageItemExtraProperties)
    function getMusicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.MusicProperties>};
    function getVideoPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.VideoProperties>};
    function getImagePropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.ImageProperties>};
    function getDocumentPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.DocumentProperties>};
  end;

  JIMusicProperties = class external(JWindows.Storage.FileProperties.IStorageItemExtraProperties)
    album: String;
    albumArtist: String;
    artist: String;
    bitrate: Float;
    composers: JWindows.Foundation.Collections.IVector{<String>};
    conductors: JWindows.Foundation.Collections.IVector{<String>};
    duration: Float;
    genre: JWindows.Foundation.Collections.IVector{<String>};
    producers: JWindows.Foundation.Collections.IVector{<String>};
    publisher: String;
    rating: Float;
    subtitle: String;
    title: String;
    trackNumber: Float;
    writers: JWindows.Foundation.Collections.IVector{<String>};
    year: Float;
  end;

  JIImageProperties = class external(JWindows.Storage.FileProperties.IStorageItemExtraProperties)
    cameraManufacturer: String;
    cameraModel: String;
    dateTaken: JDate;
    height: Float;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    latitude: Float;
    longitude: Float;
    orientation: JWindows.Storage.FileProperties.PhotoOrientation;
    peopleNames: JWindows.Foundation.Collections.IVectorView{<String>};
    rating: Float;
    title: String;
    width: Float;
  end;

  JIVideoProperties = class external(JWindows.Storage.FileProperties.IStorageItemExtraProperties)
    bitrate: Float;
    directors: JWindows.Foundation.Collections.IVector{<String>};
    duration: Float;
    height: Float;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    latitude: Float;
    longitude: Float;
    orientation: JWindows.Storage.FileProperties.VideoOrientation;
    producers: JWindows.Foundation.Collections.IVector{<String>};
    publisher: String;
    rating: Float;
    subtitle: String;
    title: String;
    width: Float;
    writers: JWindows.Foundation.Collections.IVector{<String>};
    year: Float;
  end;

  JIDocumentProperties = class external(JWindows.Storage.FileProperties.IStorageItemExtraProperties)
    author: JWindows.Foundation.Collections.IVector{<String>};
    comment: String;
    keywords: JWindows.Foundation.Collections.IVector{<String>};
    title: String;
  end;

  JIBasicProperties = class external
    dateModified: JDate;
    itemDate: JDate;
    size: Float;
  end;

//Windows

//Storage

type
  JStorageFolder = class external 'StorageFolder'
    attributes: JWindows.Storage.FileAttributes;
    dateCreated: JDate;
    name: String;
    path: String;
    displayName: String;
    displayType: String;
    folderRelativeId: String;
    properties: JWindows.Storage.FileProperties.StorageItemContentProperties;
    function createFileAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFileAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function createFolderAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getFileAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function renameAsync(desiredName: String): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function deleteAsync: JWindows.Foundation.IAsyncAction;
    function deleteAsync(option: JWindows.Storage.StorageDeleteOption): JWindows.Foundation.IAsyncAction;
    function getBasicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.BasicProperties>};
    function isOfType(&type: JWindows.Storage.StorageItemTypes): Boolean;
    function getIndexedStateAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Search.IndexedState>};
    function createFileQuery: JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQuery(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFileQueryResult;
    function createFolderQuery: JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQuery(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFolderQueryResult;
    function createItemQuery: JWindows.Storage.Search.StorageItemQueryResult;
    function createItemQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageItemQueryResult;
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function areQueryOptionsSupported(queryOptions: JWindows.Storage.Search.QueryOptions): Boolean;
    function isCommonFolderQuerySupported(query: JWindows.Storage.Search.CommonFolderQuery): Boolean;
    function isCommonFileQuerySupported(query: JWindows.Storage.Search.CommonFileQuery): Boolean;
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getFolderFromPathAsync(path: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

  JKnownFolders = class external 'KnownFolders'
    documentsLibrary: JWindows.Storage.StorageFolder;
    homeGroup: JWindows.Storage.StorageFolder;
    mediaServerDevices: JWindows.Storage.StorageFolder;
    musicLibrary: JWindows.Storage.StorageFolder;
    picturesLibrary: JWindows.Storage.StorageFolder;
    removableDevices: JWindows.Storage.StorageFolder;
    videosLibrary: JWindows.Storage.StorageFolder;
  end;

  JStorageFile = class external 'StorageFile'
    contentType: String;
    fileType: String;
    attributes: JWindows.Storage.FileAttributes;
    dateCreated: JDate;
    name: String;
    path: String;
    displayName: String;
    displayType: String;
    folderRelativeId: String;
    properties: JWindows.Storage.FileProperties.StorageItemContentProperties;
    function openAsync(accessMode: JWindows.Storage.FileAccessMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStream>};
    function openTransactedWriteAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageStreamTransaction>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function moveAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function deleteAsync: JWindows.Foundation.IAsyncAction;
    function deleteAsync(option: JWindows.Storage.StorageDeleteOption): JWindows.Foundation.IAsyncAction;
    function getBasicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.BasicProperties>};
    function isOfType(&type: JWindows.Storage.StorageItemTypes): Boolean;
    function openReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
    function openSequentialReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IInputStream>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getFileFromPathAsync(path: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFileFromApplicationUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createStreamedFileAsync(displayNameWithExtension: String; dataRequested: JWindows.Storage.StreamedFileDataRequestedHandler; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function replaceWithStreamedFileAsync(fileToReplace: JWindows.Storage.IStorageFile; dataRequested: JWindows.Storage.StreamedFileDataRequestedHandler; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createStreamedFileFromUriAsync(displayNameWithExtension: String; uri: JWindows.Foundation.Uri; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function replaceWithStreamedFileFromUriAsync(fileToReplace: JWindows.Storage.IStorageFile; uri: JWindows.Foundation.Uri; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JDownloadsFolder = class external 'DownloadsFolder'
    function createFileAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function createFileAsync(desiredName: String; option: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String; option: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

  JStreamedFileDataRequest = class external 'StreamedFileDataRequest'
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure dispose;
    procedure failAndClose(failureMode: JWindows.Storage.StreamedFileFailureMode);
    procedure close;
  end;

  JStorageStreamTransaction = class external 'StorageStreamTransaction'
    stream: JWindows.Storage.Streams.IRandomAccessStream;
    function commitAsync: JWindows.Foundation.IAsyncAction;
    procedure dispose;
    procedure close;
  end;

  JFileIO = class external 'FileIO'
    function readTextAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<String>};
    function readTextAsync(file: JWindows.Storage.IStorageFile; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<String>};
    function writeTextAsync(file: JWindows.Storage.IStorageFile; contents: String): JWindows.Foundation.IAsyncAction;
    function writeTextAsync(file: JWindows.Storage.IStorageFile; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(file: JWindows.Storage.IStorageFile; contents: String): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(file: JWindows.Storage.IStorageFile; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readLinesAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function readLinesAsync(file: JWindows.Storage.IStorageFile; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function writeLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function writeLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readBufferAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function writeBufferAsync(file: JWindows.Storage.IStorageFile; buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncAction;
    function writeBytesAsync(file: JWindows.Storage.IStorageFile; buffer: JUint8Array): JWindows.Foundation.IAsyncAction;
  end;

  JPathIO = class external 'PathIO'
    function readTextAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<String>};
    function readTextAsync(absolutePath: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<String>};
    function writeTextAsync(absolutePath: String; contents: String): JWindows.Foundation.IAsyncAction;
    function writeTextAsync(absolutePath: String; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(absolutePath: String; contents: String): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(absolutePath: String; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readLinesAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function readLinesAsync(absolutePath: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function writeLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function writeLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readBufferAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function writeBufferAsync(absolutePath: String; buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncAction;
    function writeBytesAsync(absolutePath: String; buffer: JUint8Array): JWindows.Foundation.IAsyncAction;
  end;

  JCachedFileManager = class external 'CachedFileManager'
    procedure deferUpdates(file: JWindows.Storage.IStorageFile);
    function completeUpdatesAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Provider.FileUpdateStatus>};
  end;

  JApplicationData = class external 'ApplicationData'
    localFolder: JWindows.Storage.StorageFolder;
    localSettings: JWindows.Storage.ApplicationDataContainer;
    roamingFolder: JWindows.Storage.StorageFolder;
    roamingSettings: JWindows.Storage.ApplicationDataContainer;
    roamingStorageQuota: Float;
    temporaryFolder: JWindows.Storage.StorageFolder;
    version: Float;
    function setVersionAsync(desiredVersion: Float; handler: JWindows.Storage.ApplicationDataSetVersionHandler): JWindows.Foundation.IAsyncAction;
    function clearAsync: JWindows.Foundation.IAsyncAction;
    function clearAsync(locality: JWindows.Storage.ApplicationDataLocality): JWindows.Foundation.IAsyncAction;
    ondatachanged: Variant;
    procedure signalDataChanged;
    current: JWindows.Storage.ApplicationData;
  end;

  JSetVersionRequest = class external 'SetVersionRequest'
    currentVersion: Float;
    desiredVersion: Float;
    function getDeferral: JWindows.Storage.SetVersionDeferral;
  end;

  JApplicationDataContainer = class external 'ApplicationDataContainer'
    containers: JWindows.Foundation.Collections.IMapView{<StringJWindows.Storage.ApplicationDataContainer>};
    locality: JWindows.Storage.ApplicationDataLocality;
    name: String;
    values: JWindows.Foundation.Collections.IPropertySet;
    function createContainer(name: String; disposition: JWindows.Storage.ApplicationDataCreateDisposition): JWindows.Storage.ApplicationDataContainer;
    procedure deleteContainer(name: String);
  end;

  JSetVersionDeferral = class external 'SetVersionDeferral'
    procedure complete;
  end;

  JApplicationDataContainerSettings = class external 'ApplicationDataContainerSettings'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JApplicationDataCompositeValue = class external 'ApplicationDataCompositeValue'
    size: Float;
    onmapchanged: Variant;
    function lookup(key: String): Variant;
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringVariant>};
    function insert(key: String; value: Variant): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringVariant>}>};
  end;

  JIKnownFoldersStatics = class external
    documentsLibrary: JWindows.Storage.StorageFolder;
    homeGroup: JWindows.Storage.StorageFolder;
    mediaServerDevices: JWindows.Storage.StorageFolder;
    musicLibrary: JWindows.Storage.StorageFolder;
    picturesLibrary: JWindows.Storage.StorageFolder;
    removableDevices: JWindows.Storage.StorageFolder;
    videosLibrary: JWindows.Storage.StorageFolder;
  end;

  JIDownloadsFolderStatics = class external
    function createFileAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function createFileAsync(desiredName: String; option: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String; option: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

  JIStreamedFileDataRequest = class external
    procedure failAndClose(failureMode: JWindows.Storage.StreamedFileFailureMode);
  end;

  JStreamedFileDataRequestedHandler = class external
(stream: JWindows.Storage.StreamedFileDataRequest)  end;

  JIStorageFileStatics = class external
    function getFileFromPathAsync(path: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFileFromApplicationUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createStreamedFileAsync(displayNameWithExtension: String; dataRequested: JWindows.Storage.StreamedFileDataRequestedHandler; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function replaceWithStreamedFileAsync(fileToReplace: JWindows.Storage.IStorageFile; dataRequested: JWindows.Storage.StreamedFileDataRequestedHandler; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createStreamedFileFromUriAsync(displayNameWithExtension: String; uri: JWindows.Foundation.Uri; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function replaceWithStreamedFileFromUriAsync(fileToReplace: JWindows.Storage.IStorageFile; uri: JWindows.Foundation.Uri; thumbnail: JWindows.Storage.Streams.IRandomAccessStreamReference): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JIStorageItem = class external
    attributes: JWindows.Storage.FileAttributes;
    dateCreated: JDate;
    name: String;
    path: String;
    function renameAsync(desiredName: String): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function deleteAsync: JWindows.Foundation.IAsyncAction;
    function deleteAsync(option: JWindows.Storage.StorageDeleteOption): JWindows.Foundation.IAsyncAction;
    function getBasicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.BasicProperties>};
    function isOfType(&type: JWindows.Storage.StorageItemTypes): Boolean;
  end;

  JIStorageFolder = class external(JWindows.Storage.IStorageItem)
    function createFileAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFileAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function createFolderAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getFileAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
  end;

  JIStorageFile = class external(JWindows.Storage.IStorageItem, JWindows.Storage.Streams.IRandomAccessStreamReference, JWindows.Storage.Streams.IInputStreamReference)
    contentType: String;
    fileType: String;
    function openAsync(accessMode: JWindows.Storage.FileAccessMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStream>};
    function openTransactedWriteAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageStreamTransaction>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function moveAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
  end;

  JIStorageFolderStatics = class external
    function getFolderFromPathAsync(path: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

  JIStorageItemProperties = class external
    displayName: String;
    displayType: String;
    folderRelativeId: String;
    properties: JWindows.Storage.FileProperties.StorageItemContentProperties;
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
  end;

  JIFileIOStatics = class external
    function readTextAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<String>};
    function readTextAsync(file: JWindows.Storage.IStorageFile; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<String>};
    function writeTextAsync(file: JWindows.Storage.IStorageFile; contents: String): JWindows.Foundation.IAsyncAction;
    function writeTextAsync(file: JWindows.Storage.IStorageFile; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(file: JWindows.Storage.IStorageFile; contents: String): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(file: JWindows.Storage.IStorageFile; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readLinesAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function readLinesAsync(file: JWindows.Storage.IStorageFile; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function writeLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function writeLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(file: JWindows.Storage.IStorageFile; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readBufferAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function writeBufferAsync(file: JWindows.Storage.IStorageFile; buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncAction;
    function writeBytesAsync(file: JWindows.Storage.IStorageFile; buffer: JUint8Array): JWindows.Foundation.IAsyncAction;
  end;

  JIPathIOStatics = class external
    function readTextAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<String>};
    function readTextAsync(absolutePath: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<String>};
    function writeTextAsync(absolutePath: String; contents: String): JWindows.Foundation.IAsyncAction;
    function writeTextAsync(absolutePath: String; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(absolutePath: String; contents: String): JWindows.Foundation.IAsyncAction;
    function appendTextAsync(absolutePath: String; contents: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readLinesAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function readLinesAsync(absolutePath: String; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVector{<String>}>};
    function writeLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function writeLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Foundation.IAsyncAction;
    function appendLinesAsync(absolutePath: String; lines: JWindows.Foundation.Collections.IIterable{<String>}; encoding: JWindows.Storage.Streams.UnicodeEncoding): JWindows.Foundation.IAsyncAction;
    function readBufferAsync(absolutePath: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IBuffer>};
    function writeBufferAsync(absolutePath: String; buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncAction;
    function writeBytesAsync(absolutePath: String; buffer: JUint8Array): JWindows.Foundation.IAsyncAction;
  end;

  JICachedFileManagerStatics = class external
    procedure deferUpdates(file: JWindows.Storage.IStorageFile);
    function completeUpdatesAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Provider.FileUpdateStatus>};
  end;

  JIStorageStreamTransaction = class external(JWindows.Foundation.IClosable)
    stream: JWindows.Storage.Streams.IRandomAccessStream;
    function commitAsync: JWindows.Foundation.IAsyncAction;
  end;

  JIApplicationDataStatics = class external
    current: JWindows.Storage.ApplicationData;
  end;

  JIApplicationData = class external
    localFolder: JWindows.Storage.StorageFolder;
    localSettings: JWindows.Storage.ApplicationDataContainer;
    roamingFolder: JWindows.Storage.StorageFolder;
    roamingSettings: JWindows.Storage.ApplicationDataContainer;
    roamingStorageQuota: Float;
    temporaryFolder: JWindows.Storage.StorageFolder;
    version: Float;
    function setVersionAsync(desiredVersion: Float; handler: JWindows.Storage.ApplicationDataSetVersionHandler): JWindows.Foundation.IAsyncAction;
    function clearAsync: JWindows.Foundation.IAsyncAction;
    function clearAsync(locality: JWindows.Storage.ApplicationDataLocality): JWindows.Foundation.IAsyncAction;
    ondatachanged: Variant;
    procedure signalDataChanged;
  end;

  JApplicationDataSetVersionHandler = class external
(setVersionRequest: JWindows.Storage.SetVersionRequest)  end;

  JISetVersionRequest = class external
    currentVersion: Float;
    desiredVersion: Float;
    function getDeferral: JWindows.Storage.SetVersionDeferral;
  end;

  JISetVersionDeferral = class external
    procedure complete;
  end;

  JIApplicationDataContainer = class external
    containers: JWindows.Foundation.Collections.IMapView{<StringJWindows.Storage.ApplicationDataContainer>};
    locality: JWindows.Storage.ApplicationDataLocality;
    name: String;
    values: JWindows.Foundation.Collections.IPropertySet;
    function createContainer(name: String; disposition: JWindows.Storage.ApplicationDataCreateDisposition): JWindows.Storage.ApplicationDataContainer;
    procedure deleteContainer(name: String);
  end;

//Windows

//Storage

//Search

type
  JQueryOptions = class external 'QueryOptions'
    constructor Create(query: JWindows.Storage.Search.CommonFileQuery; fileTypeFilter: JWindows.Foundation.Collections.IIterable{<String>});
    constructor Create(query: JWindows.Storage.Search.CommonFolderQuery);
    constructor Create;
    applicationSearchFilter: String;
    dateStackOption: JWindows.Storage.Search.DateStackOption;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    folderDepth: JWindows.Storage.Search.FolderDepth;
    groupPropertyName: String;
    indexerOption: JWindows.Storage.Search.IndexerOption;
    language: String;
    sortOrder: JWindows.Foundation.Collections.IVector{<JWindows.Storage.Search.SortEntry>};
    userSearchFilter: String;
    function saveToString: String;
    procedure loadFromString(value: String);
    procedure setThumbnailPrefetch(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions);
    procedure setPropertyPrefetch(options: JWindows.Storage.FileProperties.PropertyPrefetchOptions; propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>});
  end;

  JStorageFileQueryResult = class external 'StorageFileQueryResult'
    folder: JWindows.Storage.StorageFolder;
    function getFilesAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getItemCountAsync: JWindows.Foundation.IAsyncOperation{<Float>};
    oncontentschanged: Variant;
    onoptionschanged: Variant;
    function findStartIndexAsync(value: Variant): JWindows.Foundation.IAsyncOperation{<Float>};
    function getCurrentQueryOptions: JWindows.Storage.Search.QueryOptions;
    procedure applyNewQueryOptions(newQueryOptions: JWindows.Storage.Search.QueryOptions);
  end;

  JStorageFolderQueryResult = class external 'StorageFolderQueryResult'
    folder: JWindows.Storage.StorageFolder;
    function getFoldersAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemCountAsync: JWindows.Foundation.IAsyncOperation{<Float>};
    oncontentschanged: Variant;
    onoptionschanged: Variant;
    function findStartIndexAsync(value: Variant): JWindows.Foundation.IAsyncOperation{<Float>};
    function getCurrentQueryOptions: JWindows.Storage.Search.QueryOptions;
    procedure applyNewQueryOptions(newQueryOptions: JWindows.Storage.Search.QueryOptions);
  end;

  JStorageItemQueryResult = class external 'StorageItemQueryResult'
    folder: JWindows.Storage.StorageFolder;
    function getItemsAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function getItemCountAsync: JWindows.Foundation.IAsyncOperation{<Float>};
    oncontentschanged: Variant;
    onoptionschanged: Variant;
    function findStartIndexAsync(value: Variant): JWindows.Foundation.IAsyncOperation{<Float>};
    function getCurrentQueryOptions: JWindows.Storage.Search.QueryOptions;
    procedure applyNewQueryOptions(newQueryOptions: JWindows.Storage.Search.QueryOptions);
  end;

  JSortEntryVector = class external 'SortEntryVector'
    size: Float;
    function getAt(index: Float): JWindows.Storage.Search.SortEntry;
    function getView: JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.Search.SortEntry>};
    function indexOf(value: JWindows.Storage.Search.SortEntry):       index: Float;
      returnValue: Boolean;
    end;;
    procedure setAt(index: Float; value: JWindows.Storage.Search.SortEntry);
    procedure insertAt(index: Float; value: JWindows.Storage.Search.SortEntry);
    procedure removeAt(index: Float);
    procedure append(value: JWindows.Storage.Search.SortEntry);
    procedure removeAtEnd;
    procedure clear;
    function getMany(startIndex: Float):       items: array of JWindows.Storage.Search.SortEntry;
      returnValue: Float;
    end;;
    procedure replaceAll(items: array of JWindows.Storage.Search.SortEntry);
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Storage.Search.SortEntry>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Storage.Search.SortEntry): array of JWindows.Storage.Search.SortEntry;
    function join(seperator: String): String;
    function pop: JWindows.Storage.Search.SortEntry;
    procedure push(items: array of JWindows.Storage.Search.SortEntry);
    function reverse: array of JWindows.Storage.Search.SortEntry;
    function shift: JWindows.Storage.Search.SortEntry;
    function slice(start: Float): array of JWindows.Storage.Search.SortEntry;
    function slice(start: Float; &end: Float): array of JWindows.Storage.Search.SortEntry;
    function sort: array of JWindows.Storage.Search.SortEntry;
    function sort(compareFn: (a: JWindows.Storage.Search.SortEntry; b: JWindows.Storage.Search.SortEntry): Float): array of JWindows.Storage.Search.SortEntry;
    function splice(start: Float): array of JWindows.Storage.Search.SortEntry;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Storage.Search.SortEntry): array of JWindows.Storage.Search.SortEntry;
    function unshift(items: array of JWindows.Storage.Search.SortEntry): Float;
    function lastIndexOf(searchElement: JWindows.Storage.Search.SortEntry): Float;
    function lastIndexOf(searchElement: JWindows.Storage.Search.SortEntry; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry));
    procedure forEach(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean): array of JWindows.Storage.Search.SortEntry;
    function filter(callbackfn: (value: JWindows.Storage.Search.SortEntry; index: Float; array: array of JWindows.Storage.Search.SortEntry): Boolean; thisArg: Variant): array of JWindows.Storage.Search.SortEntry;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.Search.SortEntry): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.Search.SortEntry): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.Search.SortEntry): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.Search.SortEntry): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JSortEntry = class external
    propertyName: String;
    ascendingOrder: Boolean;
  end;

  JIQueryOptions = class external
    applicationSearchFilter: String;
    dateStackOption: JWindows.Storage.Search.DateStackOption;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    folderDepth: JWindows.Storage.Search.FolderDepth;
    groupPropertyName: String;
    indexerOption: JWindows.Storage.Search.IndexerOption;
    language: String;
    sortOrder: JWindows.Foundation.Collections.IVector{<JWindows.Storage.Search.SortEntry>};
    userSearchFilter: String;
    function saveToString: String;
    procedure loadFromString(value: String);
    procedure setThumbnailPrefetch(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions);
    procedure setPropertyPrefetch(options: JWindows.Storage.FileProperties.PropertyPrefetchOptions; propertiesToRetrieve: JWindows.Foundation.Collections.IIterable{<String>});
  end;

  JIQueryOptionsFactory = class external
    function createCommonFileQuery(query: JWindows.Storage.Search.CommonFileQuery; fileTypeFilter: JWindows.Foundation.Collections.IIterable{<String>}): JWindows.Storage.Search.QueryOptions;
    function createCommonFolderQuery(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Storage.Search.QueryOptions;
  end;

  JIStorageQueryResultBase = class external
    folder: JWindows.Storage.StorageFolder;
    function getItemCountAsync: JWindows.Foundation.IAsyncOperation{<Float>};
    oncontentschanged: Variant;
    onoptionschanged: Variant;
    function findStartIndexAsync(value: Variant): JWindows.Foundation.IAsyncOperation{<Float>};
    function getCurrentQueryOptions: JWindows.Storage.Search.QueryOptions;
    procedure applyNewQueryOptions(newQueryOptions: JWindows.Storage.Search.QueryOptions);
  end;

  JIStorageFileQueryResult = class external(JWindows.Storage.Search.IStorageQueryResultBase)
    function getFilesAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
  end;

  JIStorageFolderQueryResult = class external(JWindows.Storage.Search.IStorageQueryResultBase)
    function getFoldersAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
  end;

  JIStorageItemQueryResult = class external(JWindows.Storage.Search.IStorageQueryResultBase)
    function getItemsAsync(startIndex: Float; maxNumberOfItems: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
  end;

  JIStorageFolderQueryOperations = class external
    function getIndexedStateAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Search.IndexedState>};
    function createFileQuery: JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQuery(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFileQueryResult;
    function createFolderQuery: JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQuery(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFolderQueryResult;
    function createItemQuery: JWindows.Storage.Search.StorageItemQueryResult;
    function createItemQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageItemQueryResult;
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function areQueryOptionsSupported(queryOptions: JWindows.Storage.Search.QueryOptions): Boolean;
    function isCommonFolderQuerySupported(query: JWindows.Storage.Search.CommonFolderQuery): Boolean;
    function isCommonFileQuerySupported(query: JWindows.Storage.Search.CommonFileQuery): Boolean;
  end;

//Windows

//Storage

//AccessCache

type
  JAccessListEntryView = class external 'AccessListEntryView'
    size: Float;
    function getAt(index: Float): JWindows.Storage.AccessCache.AccessListEntry;
    function indexOf(value: JWindows.Storage.AccessCache.AccessListEntry):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Storage.AccessCache.AccessListEntry;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Storage.AccessCache.AccessListEntry>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Storage.AccessCache.AccessListEntry): array of JWindows.Storage.AccessCache.AccessListEntry;
    function join(seperator: String): String;
    function pop: JWindows.Storage.AccessCache.AccessListEntry;
    procedure push(items: array of JWindows.Storage.AccessCache.AccessListEntry);
    function reverse: array of JWindows.Storage.AccessCache.AccessListEntry;
    function shift: JWindows.Storage.AccessCache.AccessListEntry;
    function slice(start: Float): array of JWindows.Storage.AccessCache.AccessListEntry;
    function slice(start: Float; &end: Float): array of JWindows.Storage.AccessCache.AccessListEntry;
    function sort: array of JWindows.Storage.AccessCache.AccessListEntry;
    function sort(compareFn: (a: JWindows.Storage.AccessCache.AccessListEntry; b: JWindows.Storage.AccessCache.AccessListEntry): Float): array of JWindows.Storage.AccessCache.AccessListEntry;
    function splice(start: Float): array of JWindows.Storage.AccessCache.AccessListEntry;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Storage.AccessCache.AccessListEntry): array of JWindows.Storage.AccessCache.AccessListEntry;
    function unshift(items: array of JWindows.Storage.AccessCache.AccessListEntry): Float;
    function lastIndexOf(searchElement: JWindows.Storage.AccessCache.AccessListEntry): Float;
    function lastIndexOf(searchElement: JWindows.Storage.AccessCache.AccessListEntry; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry));
    procedure forEach(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean): array of JWindows.Storage.AccessCache.AccessListEntry;
    function filter(callbackfn: (value: JWindows.Storage.AccessCache.AccessListEntry; index: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Boolean; thisArg: Variant): array of JWindows.Storage.AccessCache.AccessListEntry;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.AccessCache.AccessListEntry): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JStorageItemMostRecentlyUsedList = class external 'StorageItemMostRecentlyUsedList'
    entries: JWindows.Storage.AccessCache.AccessListEntryView;
    maximumItemsAllowed: Float;
    onitemremoved: Variant;
    function add(file: JWindows.Storage.IStorageItem): String;
    function add(file: JWindows.Storage.IStorageItem; metadata: String): String;
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem);
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem; metadata: String);
    function getItemAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    procedure remove(token: String);
    function containsItem(token: String): Boolean;
    procedure clear;
    function checkAccess(file: JWindows.Storage.IStorageItem): Boolean;
  end;

  JItemRemovedEventArgs = class external 'ItemRemovedEventArgs'
    removedEntry: JWindows.Storage.AccessCache.AccessListEntry;
  end;

  JStorageItemAccessList = class external 'StorageItemAccessList'
    entries: JWindows.Storage.AccessCache.AccessListEntryView;
    maximumItemsAllowed: Float;
    function add(file: JWindows.Storage.IStorageItem): String;
    function add(file: JWindows.Storage.IStorageItem; metadata: String): String;
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem);
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem; metadata: String);
    function getItemAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    procedure remove(token: String);
    function containsItem(token: String): Boolean;
    procedure clear;
    function checkAccess(file: JWindows.Storage.IStorageItem): Boolean;
  end;

  JStorageApplicationPermissions = class external 'StorageApplicationPermissions'
    futureAccessList: JWindows.Storage.AccessCache.StorageItemAccessList;
    mostRecentlyUsedList: JWindows.Storage.AccessCache.StorageItemMostRecentlyUsedList;
  end;

  JAccessListEntry = class external
    token: String;
    metadata: String;
  end;

  JIItemRemovedEventArgs = class external
    removedEntry: JWindows.Storage.AccessCache.AccessListEntry;
  end;

  JIStorageItemAccessList = class external
    entries: JWindows.Storage.AccessCache.AccessListEntryView;
    maximumItemsAllowed: Float;
    function add(file: JWindows.Storage.IStorageItem): String;
    function add(file: JWindows.Storage.IStorageItem; metadata: String): String;
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem);
    procedure addOrReplace(token: String; file: JWindows.Storage.IStorageItem; metadata: String);
    function getItemAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFileAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(token: String; options: JWindows.Storage.AccessCache.AccessCacheOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    procedure remove(token: String);
    function containsItem(token: String): Boolean;
    procedure clear;
    function checkAccess(file: JWindows.Storage.IStorageItem): Boolean;
  end;

  JIStorageItemMostRecentlyUsedList = class external(JWindows.Storage.AccessCache.IStorageItemAccessList)
    onitemremoved: Variant;
  end;

  JIStorageApplicationPermissionsStatics = class external
    futureAccessList: JWindows.Storage.AccessCache.StorageItemAccessList;
    mostRecentlyUsedList: JWindows.Storage.AccessCache.StorageItemMostRecentlyUsedList;
  end;

//Windows

//Storage

//BulkAccess

type
  JFileInformationFactory = class external 'FileInformationFactory'
    constructor Create(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode);
    constructor Create(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float);
    constructor Create(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float; thumbnailOptions: JWindows.Storage.FileProperties.ThumbnailOptions);
    constructor Create(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float; thumbnailOptions: JWindows.Storage.FileProperties.ThumbnailOptions; delayLoad: Boolean);
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.IStorageItemInformation>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.IStorageItemInformation>}>};
    function getFilesAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FileInformation>}>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FileInformation>}>};
    function getFoldersAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FolderInformation>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FolderInformation>}>};
    function getVirtualizedItemsVector: Variant;
    function getVirtualizedFilesVector: Variant;
    function getVirtualizedFoldersVector: Variant;
  end;

  JFileInformation = class external 'FileInformation'
    basicProperties: JWindows.Storage.FileProperties.BasicProperties;
    documentProperties: JWindows.Storage.FileProperties.DocumentProperties;
    imageProperties: JWindows.Storage.FileProperties.ImageProperties;
    musicProperties: JWindows.Storage.FileProperties.MusicProperties;
    thumbnail: JWindows.Storage.FileProperties.StorageItemThumbnail;
    videoProperties: JWindows.Storage.FileProperties.VideoProperties;
    contentType: String;
    fileType: String;
    attributes: JWindows.Storage.FileAttributes;
    dateCreated: JDate;
    name: String;
    path: String;
    displayName: String;
    displayType: String;
    folderRelativeId: String;
    properties: JWindows.Storage.FileProperties.StorageItemContentProperties;
    onthumbnailupdated: Variant;
    onpropertiesupdated: Variant;
    function openAsync(accessMode: JWindows.Storage.FileAccessMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStream>};
    function openTransactedWriteAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageStreamTransaction>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function copyAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String): JWindows.Foundation.IAsyncAction;
    function moveAsync(destinationFolder: JWindows.Storage.IStorageFolder; desiredNewName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function moveAndReplaceAsync(fileToReplace: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function deleteAsync: JWindows.Foundation.IAsyncAction;
    function deleteAsync(option: JWindows.Storage.StorageDeleteOption): JWindows.Foundation.IAsyncAction;
    function getBasicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.BasicProperties>};
    function isOfType(&type: JWindows.Storage.StorageItemTypes): Boolean;
    function openReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IRandomAccessStreamWithContentType>};
    function openSequentialReadAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Streams.IInputStream>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
  end;

  JFolderInformation = class external 'FolderInformation'
    basicProperties: JWindows.Storage.FileProperties.BasicProperties;
    documentProperties: JWindows.Storage.FileProperties.DocumentProperties;
    imageProperties: JWindows.Storage.FileProperties.ImageProperties;
    musicProperties: JWindows.Storage.FileProperties.MusicProperties;
    thumbnail: JWindows.Storage.FileProperties.StorageItemThumbnail;
    videoProperties: JWindows.Storage.FileProperties.VideoProperties;
    attributes: JWindows.Storage.FileAttributes;
    dateCreated: JDate;
    name: String;
    path: String;
    displayName: String;
    displayType: String;
    folderRelativeId: String;
    properties: JWindows.Storage.FileProperties.StorageItemContentProperties;
    onthumbnailupdated: Variant;
    onpropertiesupdated: Variant;
    function createFileAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFileAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function createFolderAsync(desiredName: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function createFolderAsync(desiredName: String; options: JWindows.Storage.CreationCollisionOption): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getFileAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    function getFolderAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
    function getItemAsync(name: String): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.IStorageItem>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function renameAsync(desiredName: String): JWindows.Foundation.IAsyncAction;
    function renameAsync(desiredName: String; option: JWindows.Storage.NameCollisionOption): JWindows.Foundation.IAsyncAction;
    function deleteAsync: JWindows.Foundation.IAsyncAction;
    function deleteAsync(option: JWindows.Storage.StorageDeleteOption): JWindows.Foundation.IAsyncAction;
    function getBasicPropertiesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.BasicProperties>};
    function isOfType(&type: JWindows.Storage.StorageItemTypes): Boolean;
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getThumbnailAsync(mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedSize: Float; options: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Foundation.IAsyncOperation{<JWindows.Storage.FileProperties.StorageItemThumbnail>};
    function getIndexedStateAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.Search.IndexedState>};
    function createFileQuery: JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQuery(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Storage.Search.StorageFileQueryResult;
    function createFileQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFileQueryResult;
    function createFolderQuery: JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQuery(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Storage.Search.StorageFolderQueryResult;
    function createFolderQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageFolderQueryResult;
    function createItemQuery: JWindows.Storage.Search.StorageItemQueryResult;
    function createItemQueryWithOptions(queryOptions: JWindows.Storage.Search.QueryOptions): JWindows.Storage.Search.StorageItemQueryResult;
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFilesAsync(query: JWindows.Storage.Search.CommonFileQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery; startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getFoldersAsync(query: JWindows.Storage.Search.CommonFolderQuery): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFolder>}>};
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>}>};
    function areQueryOptionsSupported(queryOptions: JWindows.Storage.Search.QueryOptions): Boolean;
    function isCommonFolderQuerySupported(query: JWindows.Storage.Search.CommonFolderQuery): Boolean;
    function isCommonFileQuerySupported(query: JWindows.Storage.Search.CommonFileQuery): Boolean;
  end;

  JIStorageItemInformation = class external
    basicProperties: JWindows.Storage.FileProperties.BasicProperties;
    documentProperties: JWindows.Storage.FileProperties.DocumentProperties;
    imageProperties: JWindows.Storage.FileProperties.ImageProperties;
    musicProperties: JWindows.Storage.FileProperties.MusicProperties;
    thumbnail: JWindows.Storage.FileProperties.StorageItemThumbnail;
    videoProperties: JWindows.Storage.FileProperties.VideoProperties;
    onthumbnailupdated: Variant;
    onpropertiesupdated: Variant;
  end;

  JIFileInformationFactoryFactory = class external
    function createWithMode(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode): JWindows.Storage.BulkAccess.FileInformationFactory;
    function createWithModeAndSize(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float): JWindows.Storage.BulkAccess.FileInformationFactory;
    function createWithModeAndSizeAndOptions(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float; thumbnailOptions: JWindows.Storage.FileProperties.ThumbnailOptions): JWindows.Storage.BulkAccess.FileInformationFactory;
    function createWithModeAndSizeAndOptionsAndFlags(queryResult: JWindows.Storage.Search.IStorageQueryResultBase; mode: JWindows.Storage.FileProperties.ThumbnailMode; requestedThumbnailSize: Float; thumbnailOptions: JWindows.Storage.FileProperties.ThumbnailOptions; delayLoad: Boolean): JWindows.Storage.BulkAccess.FileInformationFactory;
  end;

  JIFileInformationFactory = class external
    function getItemsAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.IStorageItemInformation>}>};
    function getItemsAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.IStorageItemInformation>}>};
    function getFilesAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FileInformation>}>};
    function getFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FileInformation>}>};
    function getFoldersAsync(startIndex: Float; maxItemsToRetrieve: Float): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FolderInformation>}>};
    function getFoldersAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.BulkAccess.FolderInformation>}>};
    function getVirtualizedItemsVector: Variant;
    function getVirtualizedFilesVector: Variant;
    function getVirtualizedFoldersVector: Variant;
  end;

//Windows

//Storage

//Pickers

type
  JFilePickerSelectedFilesArray = class external 'FilePickerSelectedFilesArray'
    size: Float;
    function getAt(index: Float): JWindows.Storage.StorageFile;
    function indexOf(value: JWindows.Storage.StorageFile):       index: Float;
      returnValue: Boolean;
    end;;
    function getMany(startIndex: Float):       items: array of JWindows.Storage.StorageFile;
      returnValue: Float;
    end;;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Storage.StorageFile>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of JWindows.Storage.StorageFile): array of JWindows.Storage.StorageFile;
    function join(seperator: String): String;
    function pop: JWindows.Storage.StorageFile;
    procedure push(items: array of JWindows.Storage.StorageFile);
    function reverse: array of JWindows.Storage.StorageFile;
    function shift: JWindows.Storage.StorageFile;
    function slice(start: Float): array of JWindows.Storage.StorageFile;
    function slice(start: Float; &end: Float): array of JWindows.Storage.StorageFile;
    function sort: array of JWindows.Storage.StorageFile;
    function sort(compareFn: (a: JWindows.Storage.StorageFile; b: JWindows.Storage.StorageFile): Float): array of JWindows.Storage.StorageFile;
    function splice(start: Float): array of JWindows.Storage.StorageFile;
    function splice(start: Float; deleteCount: Float; items: array of JWindows.Storage.StorageFile): array of JWindows.Storage.StorageFile;
    function unshift(items: array of JWindows.Storage.StorageFile): Float;
    function lastIndexOf(searchElement: JWindows.Storage.StorageFile): Float;
    function lastIndexOf(searchElement: JWindows.Storage.StorageFile; fromIndex: Float): Float;
    function every(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean): Boolean;
    function every(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean): Boolean;
    function some(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile));
    procedure forEach(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile); thisArg: Variant);
    function map(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Variant): array of Variant;
    function map(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean): array of JWindows.Storage.StorageFile;
    function filter(callbackfn: (value: JWindows.Storage.StorageFile; index: Float; array: array of JWindows.Storage.StorageFile): Boolean; thisArg: Variant): array of JWindows.Storage.StorageFile;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.StorageFile): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.StorageFile): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.StorageFile): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of JWindows.Storage.StorageFile): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JFilePickerFileTypesOrderedMap = class external 'FilePickerFileTypesOrderedMap'
    size: Float;
    function lookup(key: String): JWindows.Foundation.Collections.IVector{<String>};
    function hasKey(key: String): Boolean;
    function getView: JWindows.Foundation.Collections.IMapView{<StringJWindows.Foundation.Collections.IVector{<String>}>};
    function insert(key: String; value: JWindows.Foundation.Collections.IVector{<String>}): Boolean;
    procedure remove(key: String);
    procedure clear;
    function first: JWindows.Foundation.Collections.IIterator{<JWindows.Foundation.Collections.IKeyValuePair{<StringJWindows.Foundation.Collections.IVector{<String>}>}>};
  end;

  JFileExtensionVector = class external 'FileExtensionVector'
    size: Float;
    function getAt(index: Float): String;
    function getView: JWindows.Foundation.Collections.IVectorView{<String>};
    function indexOf(value: String):       index: Float;
      returnValue: Boolean;
    end;;
    procedure setAt(index: Float; value: String);
    procedure insertAt(index: Float; value: String);
    procedure removeAt(index: Float);
    procedure append(value: String);
    procedure removeAtEnd;
    procedure clear;
    function getMany(startIndex: Float):       items: array of String;
      returnValue: Float;
    end;;
    procedure replaceAll(items: array of String);
    function first: JWindows.Foundation.Collections.IIterator{<String>};
    function toString: String;
    function toLocaleString: String;
    function concat(items: array of array of String): array of String;
    function join(seperator: String): String;
    function pop: String;
    procedure push(items: array of String);
    function reverse: array of String;
    function shift: String;
    function slice(start: Float): array of String;
    function slice(start: Float; &end: Float): array of String;
    function sort: array of String;
    function sort(compareFn: (a: String; b: String): Float): array of String;
    function splice(start: Float): array of String;
    function splice(start: Float; deleteCount: Float; items: array of String): array of String;
    function unshift(items: array of String): Float;
    function lastIndexOf(searchElement: String): Float;
    function lastIndexOf(searchElement: String; fromIndex: Float): Float;
    function every(callbackfn: (value: String; index: Float; array: array of String): Boolean): Boolean;
    function every(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): Boolean;
    function some(callbackfn: (value: String; index: Float; array: array of String): Boolean): Boolean;
    function some(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): Boolean;
    procedure forEach(callbackfn: (value: String; index: Float; array: array of String));
    procedure forEach(callbackfn: (value: String; index: Float; array: array of String); thisArg: Variant);
    function map(callbackfn: (value: String; index: Float; array: array of String): Variant): array of Variant;
    function map(callbackfn: (value: String; index: Float; array: array of String): Variant; thisArg: Variant): array of Variant;
    function filter(callbackfn: (value: String; index: Float; array: array of String): Boolean): array of String;
    function filter(callbackfn: (value: String; index: Float; array: array of String): Boolean; thisArg: Variant): array of String;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant): Variant;
    function reduce(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant; initialValue: Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant): Variant;
    function reduceRight(callbackfn: (previousValue: Variant; currentValue: Variant; currentIndex: Float; array: array of String): Variant; initialValue: Variant): Variant;
    _length: Float;
  end;

  JFileOpenPicker = class external 'FileOpenPicker'
    commitButtonText: String;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    settingsIdentifier: String;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    viewMode: JWindows.Storage.Pickers.PickerViewMode;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    procedure pickSingleFileAndContinue;
    function pickSingleFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
    procedure pickMultipleFilesAndContinue;
    function pickMultipleFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
  end;

  JFileSavePicker = class external 'FileSavePicker'
    commitButtonText: String;
    defaultFileExtension: String;
    fileTypeChoices: JWindows.Foundation.Collections.IMap{<StringJWindows.Foundation.Collections.IVector{<String>}>};
    settingsIdentifier: String;
    suggestedFileName: String;
    suggestedSaveFile: JWindows.Storage.StorageFile;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    procedure pickSaveFileAndContinue;
    function pickSaveFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JFolderPicker = class external 'FolderPicker'
    commitButtonText: String;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    settingsIdentifier: String;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    viewMode: JWindows.Storage.Pickers.PickerViewMode;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    procedure pickFolderAndContinue;
    function pickSingleFolderAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

  JIFileOpenPicker = class external
    commitButtonText: String;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    settingsIdentifier: String;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    viewMode: JWindows.Storage.Pickers.PickerViewMode;
    procedure pickMultipleFilesAndContinue;
    function pickMultipleFilesAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.StorageFile>}>};
    procedure pickSingleFileAndContinue;
    function pickSingleFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JIFileSavePicker = class external
    commitButtonText: String;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    defaultFileExtension: String;
    fileTypeChoices: JWindows.Foundation.Collections.IMap{<StringJWindows.Foundation.Collections.IVector{<String>}>};
    settingsIdentifier: String;
    suggestedFileName: String;
    suggestedSaveFile: JWindows.Storage.StorageFile;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    procedure pickSaveFileAndContinue;
    function pickSaveFileAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFile>};
  end;

  JIFolderPicker = class external
    commitButtonText: String;
    continuationData: JWindows.Foundation.Collections.ValueSet;
    fileTypeFilter: JWindows.Foundation.Collections.IVector{<String>};
    settingsIdentifier: String;
    suggestedStartLocation: JWindows.Storage.Pickers.PickerLocationId;
    viewMode: JWindows.Storage.Pickers.PickerViewMode;
    procedure pickFolderAndContinue;
    function pickSingleFolderAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Storage.StorageFolder>};
  end;

//Windows

//Storage

//Compression

type
  JCompressor = class external 'Compressor'
    constructor Create(underlyingStream: JWindows.Storage.Streams.IOutputStream);
    constructor Create(underlyingStream: JWindows.Storage.Streams.IOutputStream; algorithm: JWindows.Storage.Compression.CompressAlgorithm; blockSize: Float);
    function finishAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function detachStream: JWindows.Storage.Streams.IOutputStream;
    function writeAsync(buffer: JWindows.Storage.Streams.IBuffer): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    function flushAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    procedure dispose;
    procedure close;
  end;

  JDecompressor = class external 'Decompressor'
    constructor Create(underlyingStream: JWindows.Storage.Streams.IInputStream);
    function detachStream: JWindows.Storage.Streams.IInputStream;
    function readAsync(buffer: JWindows.Storage.Streams.IBuffer; count: Float; options: JWindows.Storage.Streams.InputStreamOptions): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IBufferFloat>};
    procedure dispose;
    procedure close;
  end;

  JICompressor = class external(JWindows.Storage.Streams.IOutputStream, JWindows.Foundation.IClosable)
    function finishAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function detachStream: JWindows.Storage.Streams.IOutputStream;
  end;

  JIDecompressor = class external(JWindows.Storage.Streams.IInputStream, JWindows.Foundation.IClosable)
    function detachStream: JWindows.Storage.Streams.IInputStream;
  end;

  JICompressorFactory = class external
    function createCompressor(underlyingStream: JWindows.Storage.Streams.IOutputStream): JWindows.Storage.Compression.Compressor;
    function createCompressorEx(underlyingStream: JWindows.Storage.Streams.IOutputStream; algorithm: JWindows.Storage.Compression.CompressAlgorithm; blockSize: Float): JWindows.Storage.Compression.Compressor;
  end;

  JIDecompressorFactory = class external
    function createDecompressor(underlyingStream: JWindows.Storage.Streams.IInputStream): JWindows.Storage.Compression.Decompressor;
  end;

//Windows

//System

//Profile

type
  JHardwareToken = class external 'HardwareToken'
    certificate: JWindows.Storage.Streams.IBuffer;
    id: JWindows.Storage.Streams.IBuffer;
    signature: JWindows.Storage.Streams.IBuffer;
  end;

  JHardwareIdentification = class external 'HardwareIdentification'
    function getPackageSpecificToken(nonce: JWindows.Storage.Streams.IBuffer): JWindows.System.Profile.HardwareToken;
  end;

  JIHardwareToken = class external
    certificate: JWindows.Storage.Streams.IBuffer;
    id: JWindows.Storage.Streams.IBuffer;
    signature: JWindows.Storage.Streams.IBuffer;
  end;

  JIHardwareIdentificationStatics = class external
    function getPackageSpecificToken(nonce: JWindows.Storage.Streams.IBuffer): JWindows.System.Profile.HardwareToken;
  end;

//Windows

//System

//Threading

type
  JThreadPoolTimer = class external 'ThreadPoolTimer'
    delay: Float;
    period: Float;
    procedure cancel;
    function createPeriodicTimer(handler: JWindows.System.Threading.TimerElapsedHandler; period: Float): JWindows.System.Threading.ThreadPoolTimer;
    function createTimer(handler: JWindows.System.Threading.TimerElapsedHandler; delay: Float): JWindows.System.Threading.ThreadPoolTimer;
    function createPeriodicTimer(handler: JWindows.System.Threading.TimerElapsedHandler; period: Float; destroyed: JWindows.System.Threading.TimerDestroyedHandler): JWindows.System.Threading.ThreadPoolTimer;
    function createTimer(handler: JWindows.System.Threading.TimerElapsedHandler; delay: Float; destroyed: JWindows.System.Threading.TimerDestroyedHandler): JWindows.System.Threading.ThreadPoolTimer;
  end;

  JThreadPool = class external 'ThreadPool'
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler): JWindows.Foundation.IAsyncAction;
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority): JWindows.Foundation.IAsyncAction;
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority; options: JWindows.System.Threading.WorkItemOptions): JWindows.Foundation.IAsyncAction;
  end;

  JTimerElapsedHandler = class external
(timer: JWindows.System.Threading.ThreadPoolTimer)  end;

  JTimerDestroyedHandler = class external
(timer: JWindows.System.Threading.ThreadPoolTimer)  end;

  JWorkItemHandler = class external
(operation: JWindows.Foundation.IAsyncAction)  end;

  JIThreadPoolStatics = class external
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler): JWindows.Foundation.IAsyncAction;
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority): JWindows.Foundation.IAsyncAction;
    function runAsync(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority; options: JWindows.System.Threading.WorkItemOptions): JWindows.Foundation.IAsyncAction;
  end;

  JIThreadPoolTimer = class external
    delay: Float;
    period: Float;
    procedure cancel;
  end;

  JIThreadPoolTimerStatics = class external
    function createPeriodicTimer(handler: JWindows.System.Threading.TimerElapsedHandler; period: Float): JWindows.System.Threading.ThreadPoolTimer;
    function createTimer(handler: JWindows.System.Threading.TimerElapsedHandler; delay: Float): JWindows.System.Threading.ThreadPoolTimer;
    function createPeriodicTimer(handler: JWindows.System.Threading.TimerElapsedHandler; period: Float; destroyed: JWindows.System.Threading.TimerDestroyedHandler): JWindows.System.Threading.ThreadPoolTimer;
    function createTimer(handler: JWindows.System.Threading.TimerElapsedHandler; delay: Float; destroyed: JWindows.System.Threading.TimerDestroyedHandler): JWindows.System.Threading.ThreadPoolTimer;
  end;

//Windows

//System

//Threading

//Core

type
  JSignalNotifier = class external 'SignalNotifier'
    procedure enable;
    procedure terminate;
    function attachToEvent(name: String; handler: JWindows.System.Threading.Core.SignalHandler): JWindows.System.Threading.Core.SignalNotifier;
    function attachToEvent(name: String; handler: JWindows.System.Threading.Core.SignalHandler; timeout: Float): JWindows.System.Threading.Core.SignalNotifier;
    function attachToSemaphore(name: String; handler: JWindows.System.Threading.Core.SignalHandler): JWindows.System.Threading.Core.SignalNotifier;
    function attachToSemaphore(name: String; handler: JWindows.System.Threading.Core.SignalHandler; timeout: Float): JWindows.System.Threading.Core.SignalNotifier;
  end;

  JPreallocatedWorkItem = class external 'PreallocatedWorkItem'
    constructor Create(handler: JWindows.System.Threading.WorkItemHandler);
    constructor Create(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority);
    constructor Create(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority; options: JWindows.System.Threading.WorkItemOptions);
    function runAsync: JWindows.Foundation.IAsyncAction;
  end;

  JSignalHandler = class external
(signalNotifier: JWindows.System.Threading.Core.SignalNotifier; timedOut: Boolean)  end;

  JISignalNotifierStatics = class external
    function attachToEvent(name: String; handler: JWindows.System.Threading.Core.SignalHandler): JWindows.System.Threading.Core.SignalNotifier;
    function attachToEvent(name: String; handler: JWindows.System.Threading.Core.SignalHandler; timeout: Float): JWindows.System.Threading.Core.SignalNotifier;
    function attachToSemaphore(name: String; handler: JWindows.System.Threading.Core.SignalHandler): JWindows.System.Threading.Core.SignalNotifier;
    function attachToSemaphore(name: String; handler: JWindows.System.Threading.Core.SignalHandler; timeout: Float): JWindows.System.Threading.Core.SignalNotifier;
  end;

  JIPreallocatedWorkItemFactory = class external
    function createWorkItem(handler: JWindows.System.Threading.WorkItemHandler): JWindows.System.Threading.Core.PreallocatedWorkItem;
    function createWorkItemWithPriority(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority): JWindows.System.Threading.Core.PreallocatedWorkItem;
    function createWorkItemWithPriorityAndOptions(handler: JWindows.System.Threading.WorkItemHandler; priority: JWindows.System.Threading.WorkItemPriority; options: JWindows.System.Threading.WorkItemOptions): JWindows.System.Threading.Core.PreallocatedWorkItem;
  end;

  JIPreallocatedWorkItem = class external
    function runAsync: JWindows.Foundation.IAsyncAction;
  end;

  JISignalNotifier = class external
    procedure enable;
    procedure terminate;
  end;

//Windows

//System

//UserProfile

type
  JUserInformation = class external 'UserInformation'
    accountPictureChangeEnabled: Boolean;
    nameAccessAllowed: Boolean;
    function getAccountPicture(kind: JWindows.System.UserProfile.AccountPictureKind): JWindows.Storage.IStorageFile;
    function setAccountPictureAsync(image: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPicturesAsync(smallImage: JWindows.Storage.IStorageFile; largeImage: JWindows.Storage.IStorageFile; video: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPictureFromStreamAsync(image: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPicturesFromStreamsAsync(smallImage: JWindows.Storage.Streams.IRandomAccessStream; largeImage: JWindows.Storage.Streams.IRandomAccessStream; video: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    onaccountpicturechanged: Variant;
    function getDisplayNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getFirstNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getLastNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getPrincipalNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getSessionInitiationProtocolUriAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Uri>};
    function getDomainNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
  end;

  JLockScreen = class external 'LockScreen'
    originalImageFile: JWindows.Foundation.Uri;
    function getImageStream: JWindows.Storage.Streams.IRandomAccessStream;
    function setImageFileAsync(value: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function setImageStreamAsync(value: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
  end;

  JGlobalizationPreferences = class external 'GlobalizationPreferences'
    calendars: JWindows.Foundation.Collections.IVectorView{<String>};
    clocks: JWindows.Foundation.Collections.IVectorView{<String>};
    currencies: JWindows.Foundation.Collections.IVectorView{<String>};
    homeGeographicRegion: String;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    weekStartsOn: JWindows.Globalization.DayOfWeek;
  end;

  JIUserInformationStatics = class external
    accountPictureChangeEnabled: Boolean;
    nameAccessAllowed: Boolean;
    function getAccountPicture(kind: JWindows.System.UserProfile.AccountPictureKind): JWindows.Storage.IStorageFile;
    function setAccountPictureAsync(image: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPicturesAsync(smallImage: JWindows.Storage.IStorageFile; largeImage: JWindows.Storage.IStorageFile; video: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPictureFromStreamAsync(image: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    function setAccountPicturesFromStreamsAsync(smallImage: JWindows.Storage.Streams.IRandomAccessStream; largeImage: JWindows.Storage.Streams.IRandomAccessStream; video: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncOperation{<JWindows.System.UserProfile.SetAccountPictureResult>};
    onaccountpicturechanged: Variant;
    function getDisplayNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getFirstNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getLastNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getPrincipalNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
    function getSessionInitiationProtocolUriAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Uri>};
    function getDomainNameAsync: JWindows.Foundation.IAsyncOperation{<String>};
  end;

  JILockScreenStatics = class external
    originalImageFile: JWindows.Foundation.Uri;
    function getImageStream: JWindows.Storage.Streams.IRandomAccessStream;
    function setImageFileAsync(value: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncAction;
    function setImageStreamAsync(value: JWindows.Storage.Streams.IRandomAccessStream): JWindows.Foundation.IAsyncAction;
  end;

  JIGlobalizationPreferencesStatics = class external
    calendars: JWindows.Foundation.Collections.IVectorView{<String>};
    clocks: JWindows.Foundation.Collections.IVectorView{<String>};
    currencies: JWindows.Foundation.Collections.IVectorView{<String>};
    homeGeographicRegion: String;
    languages: JWindows.Foundation.Collections.IVectorView{<String>};
    weekStartsOn: JWindows.Globalization.DayOfWeek;
  end;

//Windows

//System

type
  JLauncherUIOptions = class external 'LauncherUIOptions'
    invocationPoint: JWindows.Foundation.Point;
    preferredPlacement: JWindows.UI.Popups.Placement;
    selectionRect: JWindows.Foundation.Rect;
  end;

  JLauncherOptions = class external 'LauncherOptions'
    contentType: String;
    displayApplicationPicker: Boolean;
    fallbackUri: JWindows.Foundation.Uri;
    preferredApplicationDisplayName: String;
    preferredApplicationPackageFamilyName: String;
    treatAsUntrusted: Boolean;
    uI: JWindows.System.LauncherUIOptions;
  end;

  JLauncher = class external 'Launcher'
    function launchFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchFileAsync(file: JWindows.Storage.IStorageFile; options: JWindows.System.LauncherOptions): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchUriAsync(uri: JWindows.Foundation.Uri; options: JWindows.System.LauncherOptions): JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

  JILauncherUIOptions = class external
    invocationPoint: JWindows.Foundation.Point;
    preferredPlacement: JWindows.UI.Popups.Placement;
    selectionRect: JWindows.Foundation.Rect;
  end;

  JILauncherOptions = class external
    contentType: String;
    displayApplicationPicker: Boolean;
    fallbackUri: JWindows.Foundation.Uri;
    preferredApplicationDisplayName: String;
    preferredApplicationPackageFamilyName: String;
    treatAsUntrusted: Boolean;
    uI: JWindows.System.LauncherUIOptions;
  end;

  JILauncherStatics = class external
    function launchFileAsync(file: JWindows.Storage.IStorageFile): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchFileAsync(file: JWindows.Storage.IStorageFile; options: JWindows.System.LauncherOptions): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchUriAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function launchUriAsync(uri: JWindows.Foundation.Uri; options: JWindows.System.LauncherOptions): JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

//Windows

//System

//Display

type
  JDisplayRequest = class external 'DisplayRequest'
    procedure requestActive;
    procedure requestRelease;
  end;

  JIDisplayRequest = class external
    procedure requestActive;
    procedure requestRelease;
  end;

//Windows

//System

//RemoteDesktop

type
  JInteractiveSession = class external 'InteractiveSession'
    isRemote: Boolean;
  end;

  JIInteractiveSessionStatics = class external
    isRemote: Boolean;
  end;

//Windows

//UI

//ApplicationSettings

type
  JSettingsCommand = class external 'SettingsCommand'
    constructor Create(settingsCommandId: Variant; &label: String; handler: JWindows.UI.Popups.UICommandInvokedHandler);
    id: Variant;
    invoked: JWindows.UI.Popups.UICommandInvokedHandler;
    &label: String;
  end;

  JSettingsPaneCommandsRequest = class external 'SettingsPaneCommandsRequest'
    applicationCommands: JWindows.Foundation.Collections.IVector{<JWindows.UI.ApplicationSettings.SettingsCommand>};
  end;

  JSettingsPaneCommandsRequestedEventArgs = class external 'SettingsPaneCommandsRequestedEventArgs'
    request: JWindows.UI.ApplicationSettings.SettingsPaneCommandsRequest;
  end;

  JSettingsPane = class external 'SettingsPane'
    oncommandsrequested: Variant;
    edge: JWindows.UI.ApplicationSettings.SettingsEdgeLocation;
    function getForCurrentView: JWindows.UI.ApplicationSettings.SettingsPane;
    procedure show;
  end;

  JISettingsCommandFactory = class external
    function create(settingsCommandId: Variant; &label: String; handler: JWindows.UI.Popups.UICommandInvokedHandler): JWindows.UI.ApplicationSettings.SettingsCommand;
  end;

  JISettingsPaneCommandsRequest = class external
    applicationCommands: JWindows.Foundation.Collections.IVector{<JWindows.UI.ApplicationSettings.SettingsCommand>};
  end;

  JISettingsPaneCommandsRequestedEventArgs = class external
    request: JWindows.UI.ApplicationSettings.SettingsPaneCommandsRequest;
  end;

  JISettingsPaneStatics = class external
    edge: JWindows.UI.ApplicationSettings.SettingsEdgeLocation;
    function getForCurrentView: JWindows.UI.ApplicationSettings.SettingsPane;
    procedure show;
  end;

  JISettingsPane = class external
    oncommandsrequested: Variant;
  end;

//Windows

//UI

//ViewManagement

type
  JApplicationView = class external 'ApplicationView'
    function getForCurrentView: JApplicationView;
    function tryUnsnap: Boolean;
    value: JWindows.UI.ViewManagement.ApplicationViewState;
    terminateAppOnFinalViewClose: Boolean;
    orientation: JApplicationViewOrientation;
    title: String;
    isScreenCaptureEnabled: Boolean;
    isOnLockScreen: Boolean;
    isFullScreen: Boolean;
    id: Float;
    adjacentToRightDisplayEdge: Boolean;
    adjacentToLeftDisplayEdge: Float;
    titleBar: JApplicationViewTitleBar;
  end;

  JInputPaneVisibilityEventArgs = class external 'InputPaneVisibilityEventArgs'
    ensuredFocusedElementInView: Boolean;
    occludedRect: JWindows.Foundation.Rect;
  end;

  JInputPane = class external 'InputPane'
    occludedRect: JWindows.Foundation.Rect;
    onshowing: Variant;
    onhiding: Variant;
    function getForCurrentView: JWindows.UI.ViewManagement.InputPane;
  end;

  JAccessibilitySettings = class external 'AccessibilitySettings'
    highContrast: Boolean;
    highContrastScheme: String;
    onhighcontrastchanged: Variant;
  end;

  JUISettings = class external 'UISettings'
    animationsEnabled: Boolean;
    caretBlinkRate: Float;
    caretBrowsingEnabled: Boolean;
    caretWidth: Float;
    cursorSize: JWindows.Foundation.Size;
    doubleClickTime: Float;
    handPreference: JWindows.UI.ViewManagement.HandPreference;
    messageDuration: Float;
    mouseHoverTime: Float;
    scrollBarArrowSize: JWindows.Foundation.Size;
    scrollBarSize: JWindows.Foundation.Size;
    scrollBarThumbBoxSize: JWindows.Foundation.Size;
    function uIElementColor(desiredElement: JWindows.UI.ViewManagement.UIElementType): JWindows.UI.Color;
  end;

  JIInputPaneVisibilityEventArgs = class external
    ensuredFocusedElementInView: Boolean;
    occludedRect: JWindows.Foundation.Rect;
  end;

  JIInputPane = class external
    occludedRect: JWindows.Foundation.Rect;
    onshowing: Variant;
    onhiding: Variant;
  end;

  JIInputPaneStatics = class external
    function getForCurrentView: JWindows.UI.ViewManagement.InputPane;
  end;

  JIAccessibilitySettings = class external
    highContrast: Boolean;
    highContrastScheme: String;
    onhighcontrastchanged: Variant;
  end;

  JIUISettings = class external
    animationsEnabled: Boolean;
    caretBlinkRate: Float;
    caretBrowsingEnabled: Boolean;
    caretWidth: Float;
    cursorSize: JWindows.Foundation.Size;
    doubleClickTime: Float;
    handPreference: JWindows.UI.ViewManagement.HandPreference;
    messageDuration: Float;
    mouseHoverTime: Float;
    scrollBarArrowSize: JWindows.Foundation.Size;
    scrollBarSize: JWindows.Foundation.Size;
    scrollBarThumbBoxSize: JWindows.Foundation.Size;
    function uIElementColor(desiredElement: JWindows.UI.ViewManagement.UIElementType): JWindows.UI.Color;
  end;

//Windows

//UI

//Input

type
  JEdgeGestureEventArgs = class external 'EdgeGestureEventArgs'
    kind: JWindows.UI.Input.EdgeGestureKind;
  end;

  JEdgeGesture = class external 'EdgeGesture'
    onstarting: Variant;
    oncompleted: Variant;
    oncanceled: Variant;
    function getForCurrentView: JWindows.UI.Input.EdgeGesture;
  end;

  JMouseWheelParameters = class external 'MouseWheelParameters'
    charTranslation: JWindows.Foundation.Point;
    deltaRotationAngle: Float;
    deltaScale: Float;
    pageTranslation: JWindows.Foundation.Point;
  end;

  JGestureRecognizer = class external 'GestureRecognizer'
    autoProcessInertia: Boolean;
    crossSlideExact: Boolean;
    crossSlideHorizontally: Boolean;
    crossSlideThresholds: JWindows.UI.Input.CrossSlideThresholds;
    gestureSettings: JWindows.UI.Input.GestureSettings;
    inertiaExpansion: Float;
    inertiaExpansionDeceleration: Float;
    inertiaRotationAngle: Float;
    inertiaRotationDeceleration: Float;
    inertiaTranslationDeceleration: Float;
    inertiaTranslationDisplacement: Float;
    isActive: Boolean;
    isInertial: Boolean;
    manipulationExact: Boolean;
    mouseWheelParameters: JWindows.UI.Input.MouseWheelParameters;
    pivotCenter: JWindows.Foundation.Point;
    pivotRadius: Float;
    showGestureFeedback: Boolean;
    function canBeDoubleTap(value: JWindows.UI.Input.PointerPoint): Boolean;
    procedure processDownEvent(value: JWindows.UI.Input.PointerPoint);
    procedure processMoveEvents(value: JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>});
    procedure processUpEvent(value: JWindows.UI.Input.PointerPoint);
    procedure processMouseWheelEvent(value: JWindows.UI.Input.PointerPoint; isShiftKeyDown: Boolean; isControlKeyDown: Boolean);
    procedure processInertia;
    procedure completeGesture;
    ontapped: Variant;
    onrighttapped: Variant;
    onholding: Variant;
    ondragging: Variant;
    onmanipulationstarted: Variant;
    onmanipulationupdated: Variant;
    onmanipulationinertiastarting: Variant;
    onmanipulationcompleted: Variant;
    oncrosssliding: Variant;
  end;

  JTappedEventArgs = class external 'TappedEventArgs'
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    tapCount: Float;
  end;

  JRightTappedEventArgs = class external 'RightTappedEventArgs'
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JHoldingEventArgs = class external 'HoldingEventArgs'
    holdingState: JWindows.UI.Input.HoldingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JDraggingEventArgs = class external 'DraggingEventArgs'
    draggingState: JWindows.UI.Input.DraggingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JManipulationStartedEventArgs = class external 'ManipulationStartedEventArgs'
    cumulative: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JManipulationUpdatedEventArgs = class external 'ManipulationUpdatedEventArgs'
    cumulative: JWindows.UI.Input.ManipulationDelta;
    delta: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JManipulationInertiaStartingEventArgs = class external 'ManipulationInertiaStartingEventArgs'
    cumulative: JWindows.UI.Input.ManipulationDelta;
    delta: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JManipulationCompletedEventArgs = class external 'ManipulationCompletedEventArgs'
    cumulative: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JCrossSlidingEventArgs = class external 'CrossSlidingEventArgs'
    crossSlidingState: JWindows.UI.Input.CrossSlidingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JPointerPoint = class external 'PointerPoint'
    frameId: Float;
    isInContact: Boolean;
    pointerDevice: JWindows.Devices.Input.PointerDevice;
    pointerId: Float;
    position: JWindows.Foundation.Point;
    properties: JWindows.UI.Input.PointerPointProperties;
    rawPosition: JWindows.Foundation.Point;
    timestamp: Float;
    function getCurrentPoint(pointerId: Float): JWindows.UI.Input.PointerPoint;
    function getIntermediatePoints(pointerId: Float): JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
    function getCurrentPoint(pointerId: Float; transform: JWindows.UI.Input.IPointerPointTransform): JWindows.UI.Input.PointerPoint;
    function getIntermediatePoints(pointerId: Float; transform: JWindows.UI.Input.IPointerPointTransform): JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
  end;

  JPointerPointProperties = class external 'PointerPointProperties'
    contactRect: JWindows.Foundation.Rect;
    contactRectRaw: JWindows.Foundation.Rect;
    isBarrelButtonPressed: Boolean;
    isCanceled: Boolean;
    isEraser: Boolean;
    isHorizontalMouseWheel: Boolean;
    isInRange: Boolean;
    isInverted: Boolean;
    isLeftButtonPressed: Boolean;
    isMiddleButtonPressed: Boolean;
    isPrimary: Boolean;
    isRightButtonPressed: Boolean;
    isXButton1Pressed: Boolean;
    isXButton2Pressed: Boolean;
    mouseWheelDelta: Float;
    orientation: Float;
    pointerUpdateKind: JWindows.UI.Input.PointerUpdateKind;
    pressure: Float;
    touchConfidence: Boolean;
    twist: Float;
    xTilt: Float;
    yTilt: Float;
    function hasUsage(usagePage: Float; usageId: Float): Boolean;
    function getUsageValue(usagePage: Float; usageId: Float): Float;
  end;

  JPointerVisualizationSettings = class external 'PointerVisualizationSettings'
    isBarrelButtonFeedbackEnabled: Boolean;
    isContactFeedbackEnabled: Boolean;
    function getForCurrentView: JWindows.UI.Input.PointerVisualizationSettings;
  end;

  JIEdgeGestureEventArgs = class external
    kind: JWindows.UI.Input.EdgeGestureKind;
  end;

  JIEdgeGestureStatics = class external
    function getForCurrentView: JWindows.UI.Input.EdgeGesture;
  end;

  JIEdgeGesture = class external
    onstarting: Variant;
    oncompleted: Variant;
    oncanceled: Variant;
  end;

  JManipulationDelta = class external
    translation: JWindows.Foundation.Point;
    scale: Float;
    rotation: Float;
    expansion: Float;
  end;

  JManipulationVelocities = class external
    linear: JWindows.Foundation.Point;
    angular: Float;
    expansion: Float;
  end;

  JCrossSlideThresholds = class external
    selectionStart: Float;
    speedBumpStart: Float;
    speedBumpEnd: Float;
    rearrangeStart: Float;
  end;

  JITappedEventArgs = class external
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    tapCount: Float;
  end;

  JIRightTappedEventArgs = class external
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JIHoldingEventArgs = class external
    holdingState: JWindows.UI.Input.HoldingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JIDraggingEventArgs = class external
    draggingState: JWindows.UI.Input.DraggingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JIManipulationStartedEventArgs = class external
    cumulative: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JIManipulationUpdatedEventArgs = class external
    cumulative: JWindows.UI.Input.ManipulationDelta;
    delta: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JIManipulationInertiaStartingEventArgs = class external
    cumulative: JWindows.UI.Input.ManipulationDelta;
    delta: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JIManipulationCompletedEventArgs = class external
    cumulative: JWindows.UI.Input.ManipulationDelta;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
    velocities: JWindows.UI.Input.ManipulationVelocities;
  end;

  JICrossSlidingEventArgs = class external
    crossSlidingState: JWindows.UI.Input.CrossSlidingState;
    pointerDeviceType: JWindows.Devices.Input.PointerDeviceType;
    position: JWindows.Foundation.Point;
  end;

  JIMouseWheelParameters = class external
    charTranslation: JWindows.Foundation.Point;
    deltaRotationAngle: Float;
    deltaScale: Float;
    pageTranslation: JWindows.Foundation.Point;
  end;

  JIGestureRecognizer = class external
    autoProcessInertia: Boolean;
    crossSlideExact: Boolean;
    crossSlideHorizontally: Boolean;
    crossSlideThresholds: JWindows.UI.Input.CrossSlideThresholds;
    gestureSettings: JWindows.UI.Input.GestureSettings;
    inertiaExpansion: Float;
    inertiaExpansionDeceleration: Float;
    inertiaRotationAngle: Float;
    inertiaRotationDeceleration: Float;
    inertiaTranslationDeceleration: Float;
    inertiaTranslationDisplacement: Float;
    isActive: Boolean;
    isInertial: Boolean;
    manipulationExact: Boolean;
    mouseWheelParameters: JWindows.UI.Input.MouseWheelParameters;
    pivotCenter: JWindows.Foundation.Point;
    pivotRadius: Float;
    showGestureFeedback: Boolean;
    function canBeDoubleTap(value: JWindows.UI.Input.PointerPoint): Boolean;
    procedure processDownEvent(value: JWindows.UI.Input.PointerPoint);
    procedure processMoveEvents(value: JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>});
    procedure processUpEvent(value: JWindows.UI.Input.PointerPoint);
    procedure processMouseWheelEvent(value: JWindows.UI.Input.PointerPoint; isShiftKeyDown: Boolean; isControlKeyDown: Boolean);
    procedure processInertia;
    procedure completeGesture;
    ontapped: Variant;
    onrighttapped: Variant;
    onholding: Variant;
    ondragging: Variant;
    onmanipulationstarted: Variant;
    onmanipulationupdated: Variant;
    onmanipulationinertiastarting: Variant;
    onmanipulationcompleted: Variant;
    oncrosssliding: Variant;
  end;

  JIPointerPointStatics = class external
    function getCurrentPoint(pointerId: Float): JWindows.UI.Input.PointerPoint;
    function getIntermediatePoints(pointerId: Float): JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
    function getCurrentPoint(pointerId: Float; transform: JWindows.UI.Input.IPointerPointTransform): JWindows.UI.Input.PointerPoint;
    function getIntermediatePoints(pointerId: Float; transform: JWindows.UI.Input.IPointerPointTransform): JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
  end;

  JIPointerPointTransform = class external
    inverse: JWindows.UI.Input.IPointerPointTransform;
    function tryTransform(inPoint: JWindows.Foundation.Point):       outPoint: JWindows.Foundation.Point;
      returnValue: Boolean;
    end;;
    function transformBounds(rect: JWindows.Foundation.Rect): JWindows.Foundation.Rect;
  end;

  JIPointerPoint = class external
    frameId: Float;
    isInContact: Boolean;
    pointerDevice: JWindows.Devices.Input.PointerDevice;
    pointerId: Float;
    position: JWindows.Foundation.Point;
    properties: JWindows.UI.Input.PointerPointProperties;
    rawPosition: JWindows.Foundation.Point;
    timestamp: Float;
  end;

  JIPointerPointProperties = class external
    contactRect: JWindows.Foundation.Rect;
    contactRectRaw: JWindows.Foundation.Rect;
    isBarrelButtonPressed: Boolean;
    isCanceled: Boolean;
    isEraser: Boolean;
    isHorizontalMouseWheel: Boolean;
    isInRange: Boolean;
    isInverted: Boolean;
    isLeftButtonPressed: Boolean;
    isMiddleButtonPressed: Boolean;
    isPrimary: Boolean;
    isRightButtonPressed: Boolean;
    isXButton1Pressed: Boolean;
    isXButton2Pressed: Boolean;
    mouseWheelDelta: Float;
    orientation: Float;
    pointerUpdateKind: JWindows.UI.Input.PointerUpdateKind;
    pressure: Float;
    touchConfidence: Boolean;
    twist: Float;
    xTilt: Float;
    yTilt: Float;
    function hasUsage(usagePage: Float; usageId: Float): Boolean;
    function getUsageValue(usagePage: Float; usageId: Float): Float;
  end;

  JIPointerVisualizationSettings = class external
    isBarrelButtonFeedbackEnabled: Boolean;
    isContactFeedbackEnabled: Boolean;
  end;

  JIPointerVisualizationSettingsStatics = class external
    function getForCurrentView: JWindows.UI.Input.PointerVisualizationSettings;
  end;

//Windows

//UI

//Popups

type
  JMessageDialog = class external 'MessageDialog'
    constructor Create(content: String);
    constructor Create(content: String; title: String);
    cancelCommandIndex: Float;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    content: String;
    defaultCommandIndex: Float;
    options: JWindows.UI.Popups.MessageDialogOptions;
    title: String;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JUICommand = class external 'UICommand'
    constructor Create(&label: String);
    constructor Create(&label: String; action: JWindows.UI.Popups.UICommandInvokedHandler);
    constructor Create(&label: String; action: JWindows.UI.Popups.UICommandInvokedHandler; commandId: Variant);
    constructor Create;
    id: Variant;
    invoked: JWindows.UI.Popups.UICommandInvokedHandler;
    &label: String;
  end;

  JUICommandSeparator = class external 'UICommandSeparator'
    id: Variant;
    invoked: JWindows.UI.Popups.UICommandInvokedHandler;
    &label: String;
  end;

  JPopupMenu = class external 'PopupMenu'
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    function showAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
    function showForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
    function showForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JIMessageDialog = class external
    cancelCommandIndex: Float;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    content: String;
    defaultCommandIndex: Float;
    options: JWindows.UI.Popups.MessageDialogOptions;
    title: String;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JIMessageDialogFactory = class external
    function create(content: String): JWindows.UI.Popups.MessageDialog;
    function createWithTitle(content: String; title: String): JWindows.UI.Popups.MessageDialog;
  end;

  JUICommandInvokedHandler = class external
(command: JWindows.UI.Popups.IUICommand)  end;

  JIUICommand = class external
    id: Variant;
    invoked: JWindows.UI.Popups.UICommandInvokedHandler;
    &label: String;
  end;

  JIUICommandFactory = class external
    function create(&label: String): JWindows.UI.Popups.UICommand;
    function createWithHandler(&label: String; action: JWindows.UI.Popups.UICommandInvokedHandler): JWindows.UI.Popups.UICommand;
    function createWithHandlerAndId(&label: String; action: JWindows.UI.Popups.UICommandInvokedHandler; commandId: Variant): JWindows.UI.Popups.UICommand;
  end;

  JIPopupMenu = class external
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    function showAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
    function showForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
    function showForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

//Windows

//UI

//StartScreen

type
  JSecondaryTile = class external 'SecondaryTile'
    constructor Create(tileId: String; shortName: String; displayName: String; args: String; tileOptions: JWindows.UI.StartScreen.TileOptions; logoReference: JWindows.Foundation.Uri);
    constructor Create(tileId: String; shortName: String; displayName: String; args: String; tileOptions: JWindows.UI.StartScreen.TileOptions; logoReference: JWindows.Foundation.Uri; wideLogoReference: JWindows.Foundation.Uri);
    constructor Create(tileId: String);
    constructor Create;
    arguments: String;
    backgroundColor: JWindows.UI.Color;
    displayName: String;
    foregroundText: JWindows.UI.StartScreen.ForegroundText;
    lockScreenBadgeLogo: JWindows.Foundation.Uri;
    lockScreenDisplayBadgeAndTileText: Boolean;
    logo: JWindows.Foundation.Uri;
    shortName: String;
    smallLogo: JWindows.Foundation.Uri;
    tileId: String;
    tileOptions: JWindows.UI.StartScreen.TileOptions;
    wideLogo: JWindows.Foundation.Uri;
    function requestCreateAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function updateAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function exists(tileId: String): Boolean;
    function findAllAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
    function findAllAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
    function findAllForPackageAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
  end;

  JISecondaryTile = class external
    arguments: String;
    backgroundColor: JWindows.UI.Color;
    displayName: String;
    foregroundText: JWindows.UI.StartScreen.ForegroundText;
    lockScreenBadgeLogo: JWindows.Foundation.Uri;
    lockScreenDisplayBadgeAndTileText: Boolean;
    logo: JWindows.Foundation.Uri;
    shortName: String;
    smallLogo: JWindows.Foundation.Uri;
    tileId: String;
    tileOptions: JWindows.UI.StartScreen.TileOptions;
    wideLogo: JWindows.Foundation.Uri;
    function requestCreateAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestCreateForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteAsync(invocationPoint: JWindows.Foundation.Point): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteForSelectionAsync(selection: JWindows.Foundation.Rect): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function requestDeleteForSelectionAsync(selection: JWindows.Foundation.Rect; preferredPlacement: JWindows.UI.Popups.Placement): JWindows.Foundation.IAsyncOperation{<Boolean>};
    function updateAsync: JWindows.Foundation.IAsyncOperation{<Boolean>};
  end;

  JISecondaryTileFactory = class external
    function createTile(tileId: String; shortName: String; displayName: String; arguments: String; tileOptions: JWindows.UI.StartScreen.TileOptions; logoReference: JWindows.Foundation.Uri): JWindows.UI.StartScreen.SecondaryTile;
    function createWideTile(tileId: String; shortName: String; displayName: String; arguments: String; tileOptions: JWindows.UI.StartScreen.TileOptions; logoReference: JWindows.Foundation.Uri; wideLogoReference: JWindows.Foundation.Uri): JWindows.UI.StartScreen.SecondaryTile;
    function createWithId(tileId: String): JWindows.UI.StartScreen.SecondaryTile;
  end;

  JISecondaryTileStatics = class external
    function exists(tileId: String): Boolean;
    function findAllAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
    function findAllAsync(applicationId: String): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
    function findAllForPackageAsync: JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.StartScreen.SecondaryTile>}>};
  end;

//Windows

//UI

//Text

type
  JTextConstants = class external 'TextConstants'
    autoColor: JWindows.UI.Color;
    maxUnitCount: Float;
    minUnitCount: Float;
    undefinedColor: JWindows.UI.Color;
    undefinedFloatValue: Float;
    undefinedFontStretch: JWindows.UI.Text.FontStretch;
    undefinedFontStyle: JWindows.UI.Text.FontStyle;
    undefinedInt32Value: Float;
  end;

  JFontWeights = class external 'FontWeights'
    black: JWindows.UI.Text.FontWeight;
    bold: JWindows.UI.Text.FontWeight;
    extraBlack: JWindows.UI.Text.FontWeight;
    extraBold: JWindows.UI.Text.FontWeight;
    extraLight: JWindows.UI.Text.FontWeight;
    light: JWindows.UI.Text.FontWeight;
    medium: JWindows.UI.Text.FontWeight;
    normal: JWindows.UI.Text.FontWeight;
    semiBold: JWindows.UI.Text.FontWeight;
    semiLight: JWindows.UI.Text.FontWeight;
    thin: JWindows.UI.Text.FontWeight;
  end;

  JITextConstantsStatics = class external
    autoColor: JWindows.UI.Color;
    maxUnitCount: Float;
    minUnitCount: Float;
    undefinedColor: JWindows.UI.Color;
    undefinedFloatValue: Float;
    undefinedFontStretch: JWindows.UI.Text.FontStretch;
    undefinedFontStyle: JWindows.UI.Text.FontStyle;
    undefinedInt32Value: Float;
  end;

  JITextDocument = class external
    caretType: JWindows.UI.Text.CaretType;
    defaultTabStop: Float;
    selection: JWindows.UI.Text.ITextSelection;
    undoLimit: Float;
    function canCopy: Boolean;
    function canPaste: Boolean;
    function canRedo: Boolean;
    function canUndo: Boolean;
    function applyDisplayUpdates: Float;
    function batchDisplayUpdates: Float;
    procedure beginUndoGroup;
    procedure endUndoGroup;
    function getDefaultCharacterFormat: JWindows.UI.Text.ITextCharacterFormat;
    function getDefaultParagraphFormat: JWindows.UI.Text.ITextParagraphFormat;
    function getRange(startPosition: Float; endPosition: Float): JWindows.UI.Text.ITextRange;
    function getRangeFromPoint(point: JWindows.Foundation.Point; options: JWindows.UI.Text.PointOptions): JWindows.UI.Text.ITextRange;
    function getText(options: JWindows.UI.Text.TextGetOptions): String;
    procedure loadFromStream(options: JWindows.UI.Text.TextSetOptions; value: JWindows.Storage.Streams.IRandomAccessStream);
    procedure redo;
    procedure saveToStream(options: JWindows.UI.Text.TextGetOptions; value: JWindows.Storage.Streams.IRandomAccessStream);
    procedure setDefaultCharacterFormat(value: JWindows.UI.Text.ITextCharacterFormat);
    procedure setDefaultParagraphFormat(value: JWindows.UI.Text.ITextParagraphFormat);
    procedure setText(options: JWindows.UI.Text.TextSetOptions; value: String);
    procedure undo;
  end;

  JITextRange = class external
    character: String;
    characterFormat: JWindows.UI.Text.ITextCharacterFormat;
    endPosition: Float;
    formattedText: JWindows.UI.Text.ITextRange;
    gravity: JWindows.UI.Text.RangeGravity;
    _length: Float;
    link: String;
    paragraphFormat: JWindows.UI.Text.ITextParagraphFormat;
    startPosition: Float;
    storyLength: Float;
    text: String;
    function canPaste(format: Float): Boolean;
    procedure changeCase(value: JWindows.UI.Text.LetterCase);
    procedure collapse(value: Boolean);
    procedure copy;
    procedure cut;
    function delete_(unit: JWindows.UI.Text.TextRangeUnit; count: Float): Float;
    function endOf(unit: JWindows.UI.Text.TextRangeUnit; extend: Boolean): Float;
    function expand(unit: JWindows.UI.Text.TextRangeUnit): Float;
    function findText(value: String; scanLength: Float; options: JWindows.UI.Text.FindOptions): Float;
    function getCharacterUtf32(offset: Float): Float;
    function getClone: JWindows.UI.Text.ITextRange;
    function getIndex(unit: JWindows.UI.Text.TextRangeUnit): Float;
    function getPoint(horizontalAlign: JWindows.UI.Text.HorizontalCharacterAlignment; verticalAlign: JWindows.UI.Text.VerticalCharacterAlignment; options: JWindows.UI.Text.PointOptions): JWindows.Foundation.Point;
    function getRect(options: JWindows.UI.Text.PointOptions):       rect: JWindows.Foundation.Rect;
      hit: Float;
    end;;
    function getText(options: JWindows.UI.Text.TextGetOptions): String;
    procedure getTextViaStream(options: JWindows.UI.Text.TextGetOptions; value: JWindows.Storage.Streams.IRandomAccessStream);
    function inRange(range: JWindows.UI.Text.ITextRange): Boolean;
    procedure insertImage(width: Float; height: Float; ascent: Float; verticalAlign: JWindows.UI.Text.VerticalCharacterAlignment; alternateText: String; value: JWindows.Storage.Streams.IRandomAccessStream);
    function inStory(range: JWindows.UI.Text.ITextRange): Boolean;
    function isEqual(range: JWindows.UI.Text.ITextRange): Boolean;
    function move(unit: JWindows.UI.Text.TextRangeUnit; count: Float): Float;
    function moveEnd(unit: JWindows.UI.Text.TextRangeUnit; count: Float): Float;
    function moveStart(unit: JWindows.UI.Text.TextRangeUnit; count: Float): Float;
    procedure paste(format: Float);
    procedure scrollIntoView(value: JWindows.UI.Text.PointOptions);
    procedure matchSelection;
    procedure setIndex(unit: JWindows.UI.Text.TextRangeUnit; index: Float; extend: Boolean);
    procedure setPoint(point: JWindows.Foundation.Point; options: JWindows.UI.Text.PointOptions; extend: Boolean);
    procedure setRange(startPosition: Float; endPosition: Float);
    procedure setText(options: JWindows.UI.Text.TextSetOptions; value: String);
    procedure setTextViaStream(options: JWindows.UI.Text.TextSetOptions; value: JWindows.Storage.Streams.IRandomAccessStream);
    function startOf(unit: JWindows.UI.Text.TextRangeUnit; extend: Boolean): Float;
  end;

  JITextSelection = class external(JWindows.UI.Text.ITextRange)
    options: JWindows.UI.Text.SelectionOptions;
    &type: JWindows.UI.Text.SelectionType;
    function endKey(unit: JWindows.UI.Text.TextRangeUnit; extend: Boolean): Float;
    function homeKey(unit: JWindows.UI.Text.TextRangeUnit; extend: Boolean): Float;
    function moveDown(unit: JWindows.UI.Text.TextRangeUnit; count: Float; extend: Boolean): Float;
    function moveLeft(unit: JWindows.UI.Text.TextRangeUnit; count: Float; extend: Boolean): Float;
    function moveRight(unit: JWindows.UI.Text.TextRangeUnit; count: Float; extend: Boolean): Float;
    function moveUp(unit: JWindows.UI.Text.TextRangeUnit; count: Float; extend: Boolean): Float;
    procedure typeText(value: String);
  end;

  JITextCharacterFormat = class external
    allCaps: JWindows.UI.Text.FormatEffect;
    backgroundColor: JWindows.UI.Color;
    bold: JWindows.UI.Text.FormatEffect;
    fontStretch: JWindows.UI.Text.FontStretch;
    fontStyle: JWindows.UI.Text.FontStyle;
    foregroundColor: JWindows.UI.Color;
    hidden: JWindows.UI.Text.FormatEffect;
    italic: JWindows.UI.Text.FormatEffect;
    kerning: Float;
    languageTag: String;
    linkType: JWindows.UI.Text.LinkType;
    name: String;
    outline: JWindows.UI.Text.FormatEffect;
    position: Float;
    protectedText: JWindows.UI.Text.FormatEffect;
    size: Float;
    smallCaps: JWindows.UI.Text.FormatEffect;
    spacing: Float;
    strikethrough: JWindows.UI.Text.FormatEffect;
    subscript: JWindows.UI.Text.FormatEffect;
    superscript: JWindows.UI.Text.FormatEffect;
    textScript: JWindows.UI.Text.TextScript;
    underline: JWindows.UI.Text.UnderlineType;
    weight: Float;
    procedure setClone(value: JWindows.UI.Text.ITextCharacterFormat);
    function getClone: JWindows.UI.Text.ITextCharacterFormat;
    function isEqual(format: JWindows.UI.Text.ITextCharacterFormat): Boolean;
  end;

  JITextParagraphFormat = class external
    alignment: JWindows.UI.Text.ParagraphAlignment;
    firstLineIndent: Float;
    keepTogether: JWindows.UI.Text.FormatEffect;
    keepWithNext: JWindows.UI.Text.FormatEffect;
    leftIndent: Float;
    lineSpacing: Float;
    lineSpacingRule: JWindows.UI.Text.LineSpacingRule;
    listAlignment: JWindows.UI.Text.MarkerAlignment;
    listLevelIndex: Float;
    listStart: Float;
    listStyle: JWindows.UI.Text.MarkerStyle;
    listTab: Float;
    listType: JWindows.UI.Text.MarkerType;
    noLineNumber: JWindows.UI.Text.FormatEffect;
    pageBreakBefore: JWindows.UI.Text.FormatEffect;
    rightIndent: Float;
    rightToLeft: JWindows.UI.Text.FormatEffect;
    spaceAfter: Float;
    spaceBefore: Float;
    style: JWindows.UI.Text.ParagraphStyle;
    tabCount: Float;
    widowControl: JWindows.UI.Text.FormatEffect;
    procedure addTab(position: Float; align: JWindows.UI.Text.TabAlignment; leader: JWindows.UI.Text.TabLeader);
    procedure clearAllTabs;
    procedure deleteTab(position: Float);
    function getClone: JWindows.UI.Text.ITextParagraphFormat;
    function getTab(index: Float):       position: Float;
      align: JWindows.UI.Text.TabAlignment;
      leader: JWindows.UI.Text.TabLeader;
    end;;
    function isEqual(format: JWindows.UI.Text.ITextParagraphFormat): Boolean;
    procedure setClone(format: JWindows.UI.Text.ITextParagraphFormat);
    procedure setIndents(start: Float; left: Float; right: Float);
    procedure setLineSpacing(rule: JWindows.UI.Text.LineSpacingRule; spacing: Float);
  end;

  JFontWeight = class external
    weight: Float;
  end;

  JIFontWeights = class external
  end;

  JIFontWeightsStatics = class external
    black: JWindows.UI.Text.FontWeight;
    bold: JWindows.UI.Text.FontWeight;
    extraBlack: JWindows.UI.Text.FontWeight;
    extraBold: JWindows.UI.Text.FontWeight;
    extraLight: JWindows.UI.Text.FontWeight;
    light: JWindows.UI.Text.FontWeight;
    medium: JWindows.UI.Text.FontWeight;
    normal: JWindows.UI.Text.FontWeight;
    semiBold: JWindows.UI.Text.FontWeight;
    semiLight: JWindows.UI.Text.FontWeight;
    thin: JWindows.UI.Text.FontWeight;
  end;

//Windows

//UI

//Core

//AnimationMetrics

type
  JAnimationDescription = class external 'AnimationDescription'
    constructor Create(effect: JWindows.UI.Core.AnimationMetrics.AnimationEffect; target: JWindows.UI.Core.AnimationMetrics.AnimationEffectTarget);
    animations: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Core.AnimationMetrics.IPropertyAnimation>};
    delayLimit: Float;
    staggerDelay: Float;
    staggerDelayFactor: Float;
    zOrder: Float;
  end;

  JPropertyAnimation = class external 'PropertyAnimation'
    control1: JWindows.Foundation.Point;
    control2: JWindows.Foundation.Point;
    delay: Float;
    duration: Float;
    &type: JWindows.UI.Core.AnimationMetrics.PropertyAnimationType;
  end;

  JScaleAnimation = class external 'ScaleAnimation'
    finalScaleX: Float;
    finalScaleY: Float;
    initialScaleX: Float;
    initialScaleY: Float;
    normalizedOrigin: JWindows.Foundation.Point;
    control1: JWindows.Foundation.Point;
    control2: JWindows.Foundation.Point;
    delay: Float;
    duration: Float;
    &type: JWindows.UI.Core.AnimationMetrics.PropertyAnimationType;
  end;

  JTranslationAnimation = class external 'TranslationAnimation'
    control1: JWindows.Foundation.Point;
    control2: JWindows.Foundation.Point;
    delay: Float;
    duration: Float;
    &type: JWindows.UI.Core.AnimationMetrics.PropertyAnimationType;
  end;

  JOpacityAnimation = class external 'OpacityAnimation'
    finalOpacity: Float;
    initialOpacity: Float;
    control1: JWindows.Foundation.Point;
    control2: JWindows.Foundation.Point;
    delay: Float;
    duration: Float;
    &type: JWindows.UI.Core.AnimationMetrics.PropertyAnimationType;
  end;

  JIPropertyAnimation = class external
    control1: JWindows.Foundation.Point;
    control2: JWindows.Foundation.Point;
    delay: Float;
    duration: Float;
    &type: JWindows.UI.Core.AnimationMetrics.PropertyAnimationType;
  end;

  JIScaleAnimation = class external(JWindows.UI.Core.AnimationMetrics.IPropertyAnimation)
    finalScaleX: Float;
    finalScaleY: Float;
    initialScaleX: Float;
    initialScaleY: Float;
    normalizedOrigin: JWindows.Foundation.Point;
  end;

  JIOpacityAnimation = class external(JWindows.UI.Core.AnimationMetrics.IPropertyAnimation)
    finalOpacity: Float;
    initialOpacity: Float;
  end;

  JIAnimationDescription = class external
    animations: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Core.AnimationMetrics.IPropertyAnimation>};
    delayLimit: Float;
    staggerDelay: Float;
    staggerDelayFactor: Float;
    zOrder: Float;
  end;

  JIAnimationDescriptionFactory = class external
    function createInstance(effect: JWindows.UI.Core.AnimationMetrics.AnimationEffect; target: JWindows.UI.Core.AnimationMetrics.AnimationEffectTarget): JWindows.UI.Core.AnimationMetrics.AnimationDescription;
  end;

//Windows

//UI

//Core

type
  JCoreDispatcher = class external 'CoreDispatcher'
    hasThreadAccess: Boolean;
    procedure processEvents(options: JWindows.UI.Core.CoreProcessEventsOption);
    function runAsync(priority: JWindows.UI.Core.CoreDispatcherPriority; agileCallback: JWindows.UI.Core.DispatchedHandler): JWindows.Foundation.IAsyncAction;
    function runIdleAsync(agileCallback: JWindows.UI.Core.IdleDispatchedHandler): JWindows.Foundation.IAsyncAction;
    onacceleratorkeyactivated: Variant;
  end;

  JCoreCursor = class external 'CoreCursor'
    constructor Create(&type: JWindows.UI.Core.CoreCursorType; id: Float);
    id: Float;
    &type: JWindows.UI.Core.CoreCursorType;
  end;

  JCoreWindow = class external 'CoreWindow'
    automationHostProvider: Variant;
    bounds: JWindows.Foundation.Rect;
    customProperties: JWindows.Foundation.Collections.IPropertySet;
    dispatcher: JWindows.UI.Core.CoreDispatcher;
    flowDirection: JWindows.UI.Core.CoreWindowFlowDirection;
    isInputEnabled: Boolean;
    pointerCursor: JWindows.UI.Core.CoreCursor;
    pointerPosition: JWindows.Foundation.Point;
    visible: Boolean;
    procedure activate;
    procedure close;
    function getAsyncKeyState(virtualKey: JWindows.System.VirtualKey): JWindows.UI.Core.CoreVirtualKeyStates;
    function getKeyState(virtualKey: JWindows.System.VirtualKey): JWindows.UI.Core.CoreVirtualKeyStates;
    procedure releasePointerCapture;
    procedure setPointerCapture;
    onactivated: Variant;
    onautomationproviderrequested: Variant;
    oncharacterreceived: Variant;
    onclosed: Variant;
    oninputenabled: Variant;
    onkeydown: Variant;
    onkeyup: Variant;
    onpointercapturelost: Variant;
    onpointerentered: Variant;
    onpointerexited: Variant;
    onpointermoved: Variant;
    onpointerpressed: Variant;
    onpointerreleased: Variant;
    ontouchhittesting: Variant;
    onpointerwheelchanged: Variant;
    onsizechanged: Variant;
    onvisibilitychanged: Variant;
    function getForCurrentThread: JWindows.UI.Core.CoreWindow;
  end;

  JWindowActivatedEventArgs = class external 'WindowActivatedEventArgs'
    windowActivationState: JWindows.UI.Core.CoreWindowActivationState;
    handled: Boolean;
  end;

  JAutomationProviderRequestedEventArgs = class external 'AutomationProviderRequestedEventArgs'
    automationProvider: Variant;
    handled: Boolean;
  end;

  JCharacterReceivedEventArgs = class external 'CharacterReceivedEventArgs'
    keyCode: Float;
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
    handled: Boolean;
  end;

  JCoreWindowEventArgs = class external 'CoreWindowEventArgs'
    handled: Boolean;
  end;

  JInputEnabledEventArgs = class external 'InputEnabledEventArgs'
    inputEnabled: Boolean;
    handled: Boolean;
  end;

  JKeyEventArgs = class external 'KeyEventArgs'
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
    virtualKey: JWindows.System.VirtualKey;
    handled: Boolean;
  end;

  JPointerEventArgs = class external 'PointerEventArgs'
    currentPoint: JWindows.UI.Input.PointerPoint;
    keyModifiers: JWindows.System.VirtualKeyModifiers;
    handled: Boolean;
    function getIntermediatePoints: JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
  end;

  JTouchHitTestingEventArgs = class external 'TouchHitTestingEventArgs'
    boundingBox: JWindows.Foundation.Rect;
    point: JWindows.Foundation.Point;
    proximityEvaluation: JWindows.UI.Core.CoreProximityEvaluation;
    handled: Boolean;
    function evaluateProximity(controlBoundingBox: JWindows.Foundation.Rect): JWindows.UI.Core.CoreProximityEvaluation;
    function evaluateProximity(controlVertices: array of JWindows.Foundation.Point): JWindows.UI.Core.CoreProximityEvaluation;
  end;

  JWindowSizeChangedEventArgs = class external 'WindowSizeChangedEventArgs'
    size: JWindows.Foundation.Size;
    handled: Boolean;
  end;

  JVisibilityChangedEventArgs = class external 'VisibilityChangedEventArgs'
    visible: Boolean;
    handled: Boolean;
  end;

  JIdleDispatchedHandlerArgs = class external 'IdleDispatchedHandlerArgs'
    isDispatcherIdle: Boolean;
  end;

  JAcceleratorKeyEventArgs = class external 'AcceleratorKeyEventArgs'
    eventType: JWindows.UI.Core.CoreAcceleratorKeyEventType;
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
    virtualKey: JWindows.System.VirtualKey;
    handled: Boolean;
  end;

  JCoreAcceleratorKeys = class external 'CoreAcceleratorKeys'
    onacceleratorkeyactivated: Variant;
  end;

  JCoreWindowResizeManager = class external 'CoreWindowResizeManager'
    procedure notifyLayoutCompleted;
    function getForCurrentView: JWindows.UI.Core.CoreWindowResizeManager;
  end;

  JCoreWindowPopupShowingEventArgs = class external 'CoreWindowPopupShowingEventArgs'
    procedure setDesiredSize(value: JWindows.Foundation.Size);
  end;

  JCoreWindowDialog = class external 'CoreWindowDialog'
    constructor Create(title: String);
    constructor Create;
    backButtonCommand: JWindows.UI.Popups.UICommandInvokedHandler;
    cancelCommandIndex: Float;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    defaultCommandIndex: Float;
    isInteractionDelayed: Float;
    maxSize: JWindows.Foundation.Size;
    minSize: JWindows.Foundation.Size;
    title: String;
    onshowing: Variant;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JCoreWindowFlyout = class external 'CoreWindowFlyout'
    constructor Create(position: JWindows.Foundation.Point);
    constructor Create(position: JWindows.Foundation.Point; title: String);
    backButtonCommand: JWindows.UI.Popups.UICommandInvokedHandler;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    defaultCommandIndex: Float;
    isInteractionDelayed: Float;
    maxSize: JWindows.Foundation.Size;
    minSize: JWindows.Foundation.Size;
    title: String;
    onshowing: Variant;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JCorePhysicalKeyStatus = class external
    repeatCount: Float;
    scanCode: Float;
    isExtendedKey: Boolean;
    isMenuKeyDown: Boolean;
    wasKeyDown: Boolean;
    isKeyReleased: Boolean;
  end;

  JCoreProximityEvaluation = class external
    score: Float;
    adjustedPoint: JWindows.Foundation.Point;
  end;

  JICoreWindowEventArgs = class external
    handled: Boolean;
  end;

  JIAutomationProviderRequestedEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    automationProvider: Variant;
  end;

  JICharacterReceivedEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    keyCode: Float;
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
  end;

  JIInputEnabledEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    inputEnabled: Boolean;
  end;

  JIKeyEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
    virtualKey: JWindows.System.VirtualKey;
  end;

  JIPointerEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    currentPoint: JWindows.UI.Input.PointerPoint;
    keyModifiers: JWindows.System.VirtualKeyModifiers;
    function getIntermediatePoints: JWindows.Foundation.Collections.IVector{<JWindows.UI.Input.PointerPoint>};
  end;

  JITouchHitTestingEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    boundingBox: JWindows.Foundation.Rect;
    point: JWindows.Foundation.Point;
    proximityEvaluation: JWindows.UI.Core.CoreProximityEvaluation;
    function evaluateProximity(controlBoundingBox: JWindows.Foundation.Rect): JWindows.UI.Core.CoreProximityEvaluation;
    function evaluateProximity(controlVertices: array of JWindows.Foundation.Point): JWindows.UI.Core.CoreProximityEvaluation;
  end;

  JIWindowActivatedEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    windowActivationState: JWindows.UI.Core.CoreWindowActivationState;
  end;

  JIWindowSizeChangedEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    size: JWindows.Foundation.Size;
  end;

  JIVisibilityChangedEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    visible: Boolean;
  end;

  JICoreWindow = class external
    automationHostProvider: Variant;
    bounds: JWindows.Foundation.Rect;
    customProperties: JWindows.Foundation.Collections.IPropertySet;
    dispatcher: JWindows.UI.Core.CoreDispatcher;
    flowDirection: JWindows.UI.Core.CoreWindowFlowDirection;
    isInputEnabled: Boolean;
    pointerCursor: JWindows.UI.Core.CoreCursor;
    pointerPosition: JWindows.Foundation.Point;
    visible: Boolean;
    procedure activate;
    procedure close;
    function getAsyncKeyState(virtualKey: JWindows.System.VirtualKey): JWindows.UI.Core.CoreVirtualKeyStates;
    function getKeyState(virtualKey: JWindows.System.VirtualKey): JWindows.UI.Core.CoreVirtualKeyStates;
    procedure releasePointerCapture;
    procedure setPointerCapture;
    onactivated: Variant;
    onautomationproviderrequested: Variant;
    oncharacterreceived: Variant;
    onclosed: Variant;
    oninputenabled: Variant;
    onkeydown: Variant;
    onkeyup: Variant;
    onpointercapturelost: Variant;
    onpointerentered: Variant;
    onpointerexited: Variant;
    onpointermoved: Variant;
    onpointerpressed: Variant;
    onpointerreleased: Variant;
    ontouchhittesting: Variant;
    onpointerwheelchanged: Variant;
    onsizechanged: Variant;
    onvisibilitychanged: Variant;
  end;

  JICoreWindowStatic = class external
    function getForCurrentThread: JWindows.UI.Core.CoreWindow;
  end;

  JDispatchedHandler = class external
  end;

  JIdleDispatchedHandler = class external
(e: JWindows.UI.Core.IdleDispatchedHandlerArgs)  end;

  JIAcceleratorKeyEventArgs = class external(JWindows.UI.Core.ICoreWindowEventArgs)
    eventType: JWindows.UI.Core.CoreAcceleratorKeyEventType;
    keyStatus: JWindows.UI.Core.CorePhysicalKeyStatus;
    virtualKey: JWindows.System.VirtualKey;
  end;

  JICoreAcceleratorKeys = class external
    onacceleratorkeyactivated: Variant;
  end;

  JICoreDispatcher = class external(JWindows.UI.Core.ICoreAcceleratorKeys)
    hasThreadAccess: Boolean;
    procedure processEvents(options: JWindows.UI.Core.CoreProcessEventsOption);
    function runAsync(priority: JWindows.UI.Core.CoreDispatcherPriority; agileCallback: JWindows.UI.Core.DispatchedHandler): JWindows.Foundation.IAsyncAction;
    function runIdleAsync(agileCallback: JWindows.UI.Core.IdleDispatchedHandler): JWindows.Foundation.IAsyncAction;
  end;

  JIIdleDispatchedHandlerArgs = class external
    isDispatcherIdle: Boolean;
  end;

  JICoreCursor = class external
    id: Float;
    &type: JWindows.UI.Core.CoreCursorType;
  end;

  JICoreCursorFactory = class external
    function createCursor(&type: JWindows.UI.Core.CoreCursorType; id: Float): JWindows.UI.Core.CoreCursor;
  end;

  JIInitializeWithCoreWindow = class external
    procedure initialize(window: JWindows.UI.Core.CoreWindow);
  end;

  JICoreWindowResizeManager = class external
    procedure notifyLayoutCompleted;
  end;

  JICoreWindowResizeManagerStatics = class external
    function getForCurrentView: JWindows.UI.Core.CoreWindowResizeManager;
  end;

  JICoreWindowPopupShowingEventArgs = class external
    procedure setDesiredSize(value: JWindows.Foundation.Size);
  end;

  JICoreWindowDialog = class external
    backButtonCommand: JWindows.UI.Popups.UICommandInvokedHandler;
    cancelCommandIndex: Float;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    defaultCommandIndex: Float;
    isInteractionDelayed: Float;
    maxSize: JWindows.Foundation.Size;
    minSize: JWindows.Foundation.Size;
    title: String;
    onshowing: Variant;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JICoreWindowDialogFactory = class external
    function createWithTitle(title: String): JWindows.UI.Core.CoreWindowDialog;
  end;

  JICoreWindowFlyout = class external
    backButtonCommand: JWindows.UI.Popups.UICommandInvokedHandler;
    commands: JWindows.Foundation.Collections.IVector{<JWindows.UI.Popups.IUICommand>};
    defaultCommandIndex: Float;
    isInteractionDelayed: Float;
    maxSize: JWindows.Foundation.Size;
    minSize: JWindows.Foundation.Size;
    title: String;
    onshowing: Variant;
    function showAsync: JWindows.Foundation.IAsyncOperation{<JWindows.UI.Popups.IUICommand>};
  end;

  JICoreWindowFlyoutFactory = class external
    function create(position: JWindows.Foundation.Point): JWindows.UI.Core.CoreWindowFlyout;
    function createWithTitle(position: JWindows.Foundation.Point; title: String): JWindows.UI.Core.CoreWindowFlyout;
  end;

//Windows

//UI

//Input

//Inking

type
  JInkDrawingAttributes = class external 'InkDrawingAttributes'
    color: JWindows.UI.Color;
    fitToCurve: Boolean;
    ignorePressure: Boolean;
    penTip: JWindows.UI.Input.Inking.PenTipShape;
    size: JWindows.Foundation.Size;
  end;

  JInkStrokeRenderingSegment = class external 'InkStrokeRenderingSegment'
    bezierControlPoint1: JWindows.Foundation.Point;
    bezierControlPoint2: JWindows.Foundation.Point;
    position: JWindows.Foundation.Point;
    pressure: Float;
    tiltX: Float;
    tiltY: Float;
    twist: Float;
  end;

  JInkStroke = class external 'InkStroke'
    boundingRect: JWindows.Foundation.Rect;
    drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes;
    recognized: Boolean;
    selected: Boolean;
    function getRenderingSegments: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStrokeRenderingSegment>};
    function clone: JWindows.UI.Input.Inking.InkStroke;
  end;

  JInkStrokeBuilder = class external 'InkStrokeBuilder'
    procedure beginStroke(pointerPoint: JWindows.UI.Input.PointerPoint);
    function appendToStroke(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.UI.Input.PointerPoint;
    function endStroke(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.UI.Input.Inking.InkStroke;
    function createStroke(points: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Point>}): JWindows.UI.Input.Inking.InkStroke;
    procedure setDefaultDrawingAttributes(drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes);
  end;

  JInkRecognitionResult = class external 'InkRecognitionResult'
    boundingRect: JWindows.Foundation.Rect;
    function getTextCandidates: JWindows.Foundation.Collections.IVectorView{<String>};
    function getStrokes: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStroke>};
  end;

  JInkStrokeContainer = class external 'InkStrokeContainer'
    boundingRect: JWindows.Foundation.Rect;
    procedure addStroke(stroke: JWindows.UI.Input.Inking.InkStroke);
    function deleteSelected: JWindows.Foundation.Rect;
    function moveSelected(translation: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function selectWithPolyLine(polyline: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Point>}): JWindows.Foundation.Rect;
    function selectWithLine(from: JWindows.Foundation.Point; to: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    procedure copySelectedToClipboard;
    function pasteFromClipboard(position: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function canPasteFromClipboard: Boolean;
    function loadAsync(inputStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncActionWithProgress{<Float>};
    function saveAsync(outputStream: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    procedure updateRecognitionResults(recognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>});
    function getStrokes: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStroke>};
    function getRecognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>};
  end;

  JInkRecognizer = class external 'InkRecognizer'
    name: String;
  end;

  JInkRecognizerContainer = class external 'InkRecognizerContainer'
    procedure setDefaultRecognizer(recognizer: JWindows.UI.Input.Inking.InkRecognizer);
    function recognizeAsync(strokeCollection: JWindows.UI.Input.Inking.InkStrokeContainer; recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
    function getRecognizers: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognizer>};
  end;

  JInkManager = class external 'InkManager'
    mode: JWindows.UI.Input.Inking.InkManipulationMode;
    boundingRect: JWindows.Foundation.Rect;
    procedure processPointerDown(pointerPoint: JWindows.UI.Input.PointerPoint);
    function processPointerUpdate(pointerPoint: JWindows.UI.Input.PointerPoint): Variant;
    function processPointerUp(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.Foundation.Rect;
    procedure setDefaultDrawingAttributes(drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes);
    function recognizeAsync(recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
    procedure addStroke(stroke: JWindows.UI.Input.Inking.InkStroke);
    function deleteSelected: JWindows.Foundation.Rect;
    function moveSelected(translation: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function selectWithPolyLine(polyline: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Point>}): JWindows.Foundation.Rect;
    function selectWithLine(from: JWindows.Foundation.Point; to: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    procedure copySelectedToClipboard;
    function pasteFromClipboard(position: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function canPasteFromClipboard: Boolean;
    function loadAsync(inputStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncActionWithProgress{<Float>};
    function saveAsync(outputStream: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    procedure updateRecognitionResults(recognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>});
    function getStrokes: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStroke>};
    function getRecognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>};
    procedure setDefaultRecognizer(recognizer: JWindows.UI.Input.Inking.InkRecognizer);
    function recognizeAsync(strokeCollection: JWindows.UI.Input.Inking.InkStrokeContainer; recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
    function getRecognizers: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognizer>};
  end;

  JIInkDrawingAttributes = class external
    color: JWindows.UI.Color;
    fitToCurve: Boolean;
    ignorePressure: Boolean;
    penTip: JWindows.UI.Input.Inking.PenTipShape;
    size: JWindows.Foundation.Size;
  end;

  JIInkStrokeRenderingSegment = class external
    bezierControlPoint1: JWindows.Foundation.Point;
    bezierControlPoint2: JWindows.Foundation.Point;
    position: JWindows.Foundation.Point;
    pressure: Float;
    tiltX: Float;
    tiltY: Float;
    twist: Float;
  end;

  JIInkStroke = class external
    boundingRect: JWindows.Foundation.Rect;
    drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes;
    recognized: Boolean;
    selected: Boolean;
    function getRenderingSegments: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStrokeRenderingSegment>};
    function clone: JWindows.UI.Input.Inking.InkStroke;
  end;

  JIInkStrokeBuilder = class external
    procedure beginStroke(pointerPoint: JWindows.UI.Input.PointerPoint);
    function appendToStroke(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.UI.Input.PointerPoint;
    function endStroke(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.UI.Input.Inking.InkStroke;
    function createStroke(points: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Point>}): JWindows.UI.Input.Inking.InkStroke;
    procedure setDefaultDrawingAttributes(drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes);
  end;

  JIInkRecognitionResult = class external
    boundingRect: JWindows.Foundation.Rect;
    function getTextCandidates: JWindows.Foundation.Collections.IVectorView{<String>};
    function getStrokes: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStroke>};
  end;

  JIInkStrokeContainer = class external
    boundingRect: JWindows.Foundation.Rect;
    procedure addStroke(stroke: JWindows.UI.Input.Inking.InkStroke);
    function deleteSelected: JWindows.Foundation.Rect;
    function moveSelected(translation: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function selectWithPolyLine(polyline: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Point>}): JWindows.Foundation.Rect;
    function selectWithLine(from: JWindows.Foundation.Point; to: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    procedure copySelectedToClipboard;
    function pasteFromClipboard(position: JWindows.Foundation.Point): JWindows.Foundation.Rect;
    function canPasteFromClipboard: Boolean;
    function loadAsync(inputStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncActionWithProgress{<Float>};
    function saveAsync(outputStream: JWindows.Storage.Streams.IOutputStream): JWindows.Foundation.IAsyncOperationWithProgress{<FloatFloat>};
    procedure updateRecognitionResults(recognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>});
    function getStrokes: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkStroke>};
    function getRecognitionResults: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>};
  end;

  JIInkRecognizer = class external
    name: String;
  end;

  JIInkRecognizerContainer = class external
    procedure setDefaultRecognizer(recognizer: JWindows.UI.Input.Inking.InkRecognizer);
    function recognizeAsync(strokeCollection: JWindows.UI.Input.Inking.InkStrokeContainer; recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
    function getRecognizers: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognizer>};
  end;

  JIInkManager = class external(JWindows.UI.Input.Inking.IInkStrokeContainer, JWindows.UI.Input.Inking.IInkRecognizerContainer)
    mode: JWindows.UI.Input.Inking.InkManipulationMode;
    procedure processPointerDown(pointerPoint: JWindows.UI.Input.PointerPoint);
    function processPointerUpdate(pointerPoint: JWindows.UI.Input.PointerPoint): Variant;
    function processPointerUp(pointerPoint: JWindows.UI.Input.PointerPoint): JWindows.Foundation.Rect;
    procedure setDefaultDrawingAttributes(drawingAttributes: JWindows.UI.Input.Inking.InkDrawingAttributes);
    function recognizeAsync(strokeCollection: JWindows.UI.Input.Inking.InkStrokeContainer; recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
    function recognizeAsync(recognitionTarget: JWindows.UI.Input.Inking.InkRecognitionTarget): JWindows.Foundation.IAsyncOperation{<JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Input.Inking.InkRecognitionResult>}>};
  end;

//Windows

//UI

//WebUI

type
  JActivatedDeferral = class external 'ActivatedDeferral'
    procedure complete;
  end;

  JActivatedOperation = class external 'ActivatedOperation'
    function getDeferral: JWindows.UI.WebUI.ActivatedDeferral;
  end;

  JWebUILaunchActivatedEventArgs = class external 'WebUILaunchActivatedEventArgs'
    arguments: String;
    tileId: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUISearchActivatedEventArgs = class external 'WebUISearchActivatedEventArgs'
    language: String;
    queryText: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIShareTargetActivatedEventArgs = class external 'WebUIShareTargetActivatedEventArgs'
    shareOperation: JWindows.ApplicationModel.DataTransfer.ShareTarget.ShareOperation;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIFileActivatedEventArgs = class external 'WebUIFileActivatedEventArgs'
    files: JWindows.Foundation.Collections.IVectorView{<JWindows.Storage.IStorageItem>};
    verb: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIProtocolActivatedEventArgs = class external 'WebUIProtocolActivatedEventArgs'
    uri: JWindows.Foundation.Uri;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIFileOpenPickerActivatedEventArgs = class external 'WebUIFileOpenPickerActivatedEventArgs'
    fileOpenPickerUI: JWindows.Storage.Pickers.Provider.FileOpenPickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIFileSavePickerActivatedEventArgs = class external 'WebUIFileSavePickerActivatedEventArgs'
    fileSavePickerUI: JWindows.Storage.Pickers.Provider.FileSavePickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUICachedFileUpdaterActivatedEventArgs = class external 'WebUICachedFileUpdaterActivatedEventArgs'
    cachedFileUpdaterUI: JWindows.Storage.Provider.CachedFileUpdaterUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIContactPickerActivatedEventArgs = class external 'WebUIContactPickerActivatedEventArgs'
    contactPickerUI: JWindows.ApplicationModel.Contacts.Provider.ContactPickerUI;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIDeviceActivatedEventArgs = class external 'WebUIDeviceActivatedEventArgs'
    deviceInformationId: String;
    verb: String;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUIPrintTaskSettingsActivatedEventArgs = class external 'WebUIPrintTaskSettingsActivatedEventArgs'
    configuration: JWindows.Devices.Printers.Extensions.PrintTaskConfiguration;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUICameraSettingsActivatedEventArgs = class external 'WebUICameraSettingsActivatedEventArgs'
    videoDeviceController: Variant;
    videoDeviceExtension: Variant;
    kind: JWindows.ApplicationModel.Activation.ActivationKind;
    previousExecutionState: JWindows.ApplicationModel.Activation.ApplicationExecutionState;
    splashScreen: JWindows.ApplicationModel.Activation.SplashScreen;
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JWebUINavigatedOperation = class external 'WebUINavigatedOperation'
    function getDeferral: JWindows.UI.WebUI.WebUINavigatedDeferral;
  end;

  JSuspendingDeferral = class external 'SuspendingDeferral'
    procedure complete;
  end;

  JSuspendingOperation = class external 'SuspendingOperation'
    deadline: JDate;
    function getDeferral: JWindows.ApplicationModel.SuspendingDeferral;
  end;

  JSuspendingEventArgs = class external 'SuspendingEventArgs'
    suspendingOperation: JWindows.ApplicationModel.SuspendingOperation;
  end;

  JWebUIBackgroundTaskInstanceRuntimeClass = class external 'WebUIBackgroundTaskInstanceRuntimeClass'
    succeeded: Boolean;
    instanceId: String;
    progress: Float;
    suspendedCount: Float;
    task: JWindows.ApplicationModel.Background.BackgroundTaskRegistration;
    triggerDetails: Variant;
    oncanceled: Variant;
    function getDeferral: JWindows.ApplicationModel.Background.BackgroundTaskDeferral;
  end;

  JWebUIBackgroundTaskInstance = class external 'WebUIBackgroundTaskInstance'
    current: JWindows.UI.WebUI.IWebUIBackgroundTaskInstance;
  end;

  JWebUINavigatedDeferral = class external 'WebUINavigatedDeferral'
    procedure complete;
  end;

  JWebUINavigatedEventArgs = class external 'WebUINavigatedEventArgs'
    navigatedOperation: JWindows.UI.WebUI.WebUINavigatedOperation;
  end;

  JWebUIApplication = class external 'WebUIApplication'
    onactivated: Variant;
    onsuspending: Variant;
    onresuming: Variant;
    onnavigated: Variant;
  end;

  JIActivatedDeferral = class external
    procedure complete;
  end;

  JIActivatedOperation = class external
    function getDeferral: JWindows.UI.WebUI.ActivatedDeferral;
  end;

  JIActivatedEventArgsDeferral = class external
    activatedOperation: JWindows.UI.WebUI.ActivatedOperation;
  end;

  JActivatedEventHandler = class external
(sender: Variant; eventArgs: JWindows.ApplicationModel.Activation.IActivatedEventArgs)  end;

  JResumingEventHandler = class external
(sender: Variant)  end;

  JSuspendingEventHandler = class external
(sender: Variant; e: JWindows.ApplicationModel.ISuspendingEventArgs)  end;

  JNavigatedEventHandler = class external
(sender: Variant; e: JWindows.UI.WebUI.IWebUINavigatedEventArgs)  end;

  JIWebUINavigatedEventArgs = class external
    navigatedOperation: JWindows.UI.WebUI.WebUINavigatedOperation;
  end;

  JIWebUIBackgroundTaskInstance = class external
    succeeded: Boolean;
  end;

  JIWebUIBackgroundTaskInstanceStatics = class external
    current: JWindows.UI.WebUI.IWebUIBackgroundTaskInstance;
  end;

  JIWebUINavigatedDeferral = class external
    procedure complete;
  end;

  JIWebUINavigatedOperation = class external
    function getDeferral: JWindows.UI.WebUI.WebUINavigatedDeferral;
  end;

  JIWebUIActivationStatics = class external
    onactivated: Variant;
    onsuspending: Variant;
    onresuming: Variant;
    onnavigated: Variant;
  end;

//Windows

//UI

type
  JColors = class external 'Colors'
    aliceBlue: JWindows.UI.Color;
    antiqueWhite: JWindows.UI.Color;
    aqua: JWindows.UI.Color;
    aquamarine: JWindows.UI.Color;
    azure: JWindows.UI.Color;
    beige: JWindows.UI.Color;
    bisque: JWindows.UI.Color;
    black: JWindows.UI.Color;
    blanchedAlmond: JWindows.UI.Color;
    blue: JWindows.UI.Color;
    blueViolet: JWindows.UI.Color;
    brown: JWindows.UI.Color;
    burlyWood: JWindows.UI.Color;
    cadetBlue: JWindows.UI.Color;
    chartreuse: JWindows.UI.Color;
    chocolate: JWindows.UI.Color;
    coral: JWindows.UI.Color;
    cornflowerBlue: JWindows.UI.Color;
    cornsilk: JWindows.UI.Color;
    crimson: JWindows.UI.Color;
    cyan: JWindows.UI.Color;
    darkBlue: JWindows.UI.Color;
    darkCyan: JWindows.UI.Color;
    darkGoldenrod: JWindows.UI.Color;
    darkGray: JWindows.UI.Color;
    darkGreen: JWindows.UI.Color;
    darkKhaki: JWindows.UI.Color;
    darkMagenta: JWindows.UI.Color;
    darkOliveGreen: JWindows.UI.Color;
    darkOrange: JWindows.UI.Color;
    darkOrchid: JWindows.UI.Color;
    darkRed: JWindows.UI.Color;
    darkSalmon: JWindows.UI.Color;
    darkSeaGreen: JWindows.UI.Color;
    darkSlateBlue: JWindows.UI.Color;
    darkSlateGray: JWindows.UI.Color;
    darkTurquoise: JWindows.UI.Color;
    darkViolet: JWindows.UI.Color;
    deepPink: JWindows.UI.Color;
    deepSkyBlue: JWindows.UI.Color;
    dimGray: JWindows.UI.Color;
    dodgerBlue: JWindows.UI.Color;
    firebrick: JWindows.UI.Color;
    floralWhite: JWindows.UI.Color;
    forestGreen: JWindows.UI.Color;
    fuchsia: JWindows.UI.Color;
    gainsboro: JWindows.UI.Color;
    ghostWhite: JWindows.UI.Color;
    gold: JWindows.UI.Color;
    goldenrod: JWindows.UI.Color;
    gray: JWindows.UI.Color;
    green: JWindows.UI.Color;
    greenYellow: JWindows.UI.Color;
    honeydew: JWindows.UI.Color;
    hotPink: JWindows.UI.Color;
    indianRed: JWindows.UI.Color;
    indigo: JWindows.UI.Color;
    ivory: JWindows.UI.Color;
    khaki: JWindows.UI.Color;
    lavender: JWindows.UI.Color;
    lavenderBlush: JWindows.UI.Color;
    lawnGreen: JWindows.UI.Color;
    lemonChiffon: JWindows.UI.Color;
    lightBlue: JWindows.UI.Color;
    lightCoral: JWindows.UI.Color;
    lightCyan: JWindows.UI.Color;
    lightGoldenrodYellow: JWindows.UI.Color;
    lightGray: JWindows.UI.Color;
    lightGreen: JWindows.UI.Color;
    lightPink: JWindows.UI.Color;
    lightSalmon: JWindows.UI.Color;
    lightSeaGreen: JWindows.UI.Color;
    lightSkyBlue: JWindows.UI.Color;
    lightSlateGray: JWindows.UI.Color;
    lightSteelBlue: JWindows.UI.Color;
    lightYellow: JWindows.UI.Color;
    lime: JWindows.UI.Color;
    limeGreen: JWindows.UI.Color;
    linen: JWindows.UI.Color;
    magenta: JWindows.UI.Color;
    maroon: JWindows.UI.Color;
    mediumAquamarine: JWindows.UI.Color;
    mediumBlue: JWindows.UI.Color;
    mediumOrchid: JWindows.UI.Color;
    mediumPurple: JWindows.UI.Color;
    mediumSeaGreen: JWindows.UI.Color;
    mediumSlateBlue: JWindows.UI.Color;
    mediumSpringGreen: JWindows.UI.Color;
    mediumTurquoise: JWindows.UI.Color;
    mediumVioletRed: JWindows.UI.Color;
    midnightBlue: JWindows.UI.Color;
    mintCream: JWindows.UI.Color;
    mistyRose: JWindows.UI.Color;
    moccasin: JWindows.UI.Color;
    navajoWhite: JWindows.UI.Color;
    navy: JWindows.UI.Color;
    oldLace: JWindows.UI.Color;
    olive: JWindows.UI.Color;
    oliveDrab: JWindows.UI.Color;
    orange: JWindows.UI.Color;
    orangeRed: JWindows.UI.Color;
    orchid: JWindows.UI.Color;
    paleGoldenrod: JWindows.UI.Color;
    paleGreen: JWindows.UI.Color;
    paleTurquoise: JWindows.UI.Color;
    paleVioletRed: JWindows.UI.Color;
    papayaWhip: JWindows.UI.Color;
    peachPuff: JWindows.UI.Color;
    peru: JWindows.UI.Color;
    pink: JWindows.UI.Color;
    plum: JWindows.UI.Color;
    powderBlue: JWindows.UI.Color;
    purple: JWindows.UI.Color;
    red: JWindows.UI.Color;
    rosyBrown: JWindows.UI.Color;
    royalBlue: JWindows.UI.Color;
    saddleBrown: JWindows.UI.Color;
    salmon: JWindows.UI.Color;
    sandyBrown: JWindows.UI.Color;
    seaGreen: JWindows.UI.Color;
    seaShell: JWindows.UI.Color;
    sienna: JWindows.UI.Color;
    silver: JWindows.UI.Color;
    skyBlue: JWindows.UI.Color;
    slateBlue: JWindows.UI.Color;
    slateGray: JWindows.UI.Color;
    snow: JWindows.UI.Color;
    springGreen: JWindows.UI.Color;
    steelBlue: JWindows.UI.Color;
    tan: JWindows.UI.Color;
    teal: JWindows.UI.Color;
    thistle: JWindows.UI.Color;
    tomato: JWindows.UI.Color;
    transparent: JWindows.UI.Color;
    turquoise: JWindows.UI.Color;
    violet: JWindows.UI.Color;
    wheat: JWindows.UI.Color;
    white: JWindows.UI.Color;
    whiteSmoke: JWindows.UI.Color;
    yellow: JWindows.UI.Color;
    yellowGreen: JWindows.UI.Color;
  end;

  JColorHelper = class external 'ColorHelper'
    function fromArgb(a: Float; r: Float; g: Float; b: Float): JWindows.UI.Color;
  end;

  JIColors = class external
  end;

  JIColorsStatics = class external
    aliceBlue: JWindows.UI.Color;
    antiqueWhite: JWindows.UI.Color;
    aqua: JWindows.UI.Color;
    aquamarine: JWindows.UI.Color;
    azure: JWindows.UI.Color;
    beige: JWindows.UI.Color;
    bisque: JWindows.UI.Color;
    black: JWindows.UI.Color;
    blanchedAlmond: JWindows.UI.Color;
    blue: JWindows.UI.Color;
    blueViolet: JWindows.UI.Color;
    brown: JWindows.UI.Color;
    burlyWood: JWindows.UI.Color;
    cadetBlue: JWindows.UI.Color;
    chartreuse: JWindows.UI.Color;
    chocolate: JWindows.UI.Color;
    coral: JWindows.UI.Color;
    cornflowerBlue: JWindows.UI.Color;
    cornsilk: JWindows.UI.Color;
    crimson: JWindows.UI.Color;
    cyan: JWindows.UI.Color;
    darkBlue: JWindows.UI.Color;
    darkCyan: JWindows.UI.Color;
    darkGoldenrod: JWindows.UI.Color;
    darkGray: JWindows.UI.Color;
    darkGreen: JWindows.UI.Color;
    darkKhaki: JWindows.UI.Color;
    darkMagenta: JWindows.UI.Color;
    darkOliveGreen: JWindows.UI.Color;
    darkOrange: JWindows.UI.Color;
    darkOrchid: JWindows.UI.Color;
    darkRed: JWindows.UI.Color;
    darkSalmon: JWindows.UI.Color;
    darkSeaGreen: JWindows.UI.Color;
    darkSlateBlue: JWindows.UI.Color;
    darkSlateGray: JWindows.UI.Color;
    darkTurquoise: JWindows.UI.Color;
    darkViolet: JWindows.UI.Color;
    deepPink: JWindows.UI.Color;
    deepSkyBlue: JWindows.UI.Color;
    dimGray: JWindows.UI.Color;
    dodgerBlue: JWindows.UI.Color;
    firebrick: JWindows.UI.Color;
    floralWhite: JWindows.UI.Color;
    forestGreen: JWindows.UI.Color;
    fuchsia: JWindows.UI.Color;
    gainsboro: JWindows.UI.Color;
    ghostWhite: JWindows.UI.Color;
    gold: JWindows.UI.Color;
    goldenrod: JWindows.UI.Color;
    gray: JWindows.UI.Color;
    green: JWindows.UI.Color;
    greenYellow: JWindows.UI.Color;
    honeydew: JWindows.UI.Color;
    hotPink: JWindows.UI.Color;
    indianRed: JWindows.UI.Color;
    indigo: JWindows.UI.Color;
    ivory: JWindows.UI.Color;
    khaki: JWindows.UI.Color;
    lavender: JWindows.UI.Color;
    lavenderBlush: JWindows.UI.Color;
    lawnGreen: JWindows.UI.Color;
    lemonChiffon: JWindows.UI.Color;
    lightBlue: JWindows.UI.Color;
    lightCoral: JWindows.UI.Color;
    lightCyan: JWindows.UI.Color;
    lightGoldenrodYellow: JWindows.UI.Color;
    lightGray: JWindows.UI.Color;
    lightGreen: JWindows.UI.Color;
    lightPink: JWindows.UI.Color;
    lightSalmon: JWindows.UI.Color;
    lightSeaGreen: JWindows.UI.Color;
    lightSkyBlue: JWindows.UI.Color;
    lightSlateGray: JWindows.UI.Color;
    lightSteelBlue: JWindows.UI.Color;
    lightYellow: JWindows.UI.Color;
    lime: JWindows.UI.Color;
    limeGreen: JWindows.UI.Color;
    linen: JWindows.UI.Color;
    magenta: JWindows.UI.Color;
    maroon: JWindows.UI.Color;
    mediumAquamarine: JWindows.UI.Color;
    mediumBlue: JWindows.UI.Color;
    mediumOrchid: JWindows.UI.Color;
    mediumPurple: JWindows.UI.Color;
    mediumSeaGreen: JWindows.UI.Color;
    mediumSlateBlue: JWindows.UI.Color;
    mediumSpringGreen: JWindows.UI.Color;
    mediumTurquoise: JWindows.UI.Color;
    mediumVioletRed: JWindows.UI.Color;
    midnightBlue: JWindows.UI.Color;
    mintCream: JWindows.UI.Color;
    mistyRose: JWindows.UI.Color;
    moccasin: JWindows.UI.Color;
    navajoWhite: JWindows.UI.Color;
    navy: JWindows.UI.Color;
    oldLace: JWindows.UI.Color;
    olive: JWindows.UI.Color;
    oliveDrab: JWindows.UI.Color;
    orange: JWindows.UI.Color;
    orangeRed: JWindows.UI.Color;
    orchid: JWindows.UI.Color;
    paleGoldenrod: JWindows.UI.Color;
    paleGreen: JWindows.UI.Color;
    paleTurquoise: JWindows.UI.Color;
    paleVioletRed: JWindows.UI.Color;
    papayaWhip: JWindows.UI.Color;
    peachPuff: JWindows.UI.Color;
    peru: JWindows.UI.Color;
    pink: JWindows.UI.Color;
    plum: JWindows.UI.Color;
    powderBlue: JWindows.UI.Color;
    purple: JWindows.UI.Color;
    red: JWindows.UI.Color;
    rosyBrown: JWindows.UI.Color;
    royalBlue: JWindows.UI.Color;
    saddleBrown: JWindows.UI.Color;
    salmon: JWindows.UI.Color;
    sandyBrown: JWindows.UI.Color;
    seaGreen: JWindows.UI.Color;
    seaShell: JWindows.UI.Color;
    sienna: JWindows.UI.Color;
    silver: JWindows.UI.Color;
    skyBlue: JWindows.UI.Color;
    slateBlue: JWindows.UI.Color;
    slateGray: JWindows.UI.Color;
    snow: JWindows.UI.Color;
    springGreen: JWindows.UI.Color;
    steelBlue: JWindows.UI.Color;
    tan: JWindows.UI.Color;
    teal: JWindows.UI.Color;
    thistle: JWindows.UI.Color;
    tomato: JWindows.UI.Color;
    transparent: JWindows.UI.Color;
    turquoise: JWindows.UI.Color;
    violet: JWindows.UI.Color;
    wheat: JWindows.UI.Color;
    white: JWindows.UI.Color;
    whiteSmoke: JWindows.UI.Color;
    yellow: JWindows.UI.Color;
    yellowGreen: JWindows.UI.Color;
  end;

  JColor = class external
    a: Float;
    r: Float;
    g: Float;
    b: Float;
  end;

  JIColorHelper = class external
  end;

  JIColorHelperStatics = class external
    function fromArgb(a: Float; r: Float; g: Float; b: Float): JWindows.UI.Color;
  end;

//Windows

//UI

//Notifications

type
  JTileUpdater = class external 'TileUpdater'
    setting: JWindows.UI.Notifications.NotificationSetting;
    procedure update(notification: JWindows.UI.Notifications.TileNotification);
    procedure clear;
    procedure enableNotificationQueue(enable: Boolean);
    procedure addToSchedule(scheduledTile: JWindows.UI.Notifications.ScheduledTileNotification);
    procedure removeFromSchedule(scheduledTile: JWindows.UI.Notifications.ScheduledTileNotification);
    function getScheduledTileNotifications: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Notifications.ScheduledTileNotification>};
    procedure startPeriodicUpdate(tileContent: JWindows.Foundation.Uri; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdate(tileContent: JWindows.Foundation.Uri; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure stopPeriodicUpdate;
    procedure startPeriodicUpdateBatch(tileContents: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdateBatch(tileContents: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
  end;

  JTileNotification = class external 'TileNotification'
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument);
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
    tag: String;
  end;

  JScheduledTileNotification = class external 'ScheduledTileNotification'
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate);
    content: JWindows.Data.Xml.Dom.XmlDocument;
    deliveryTime: JDate;
    expirationTime: JDate;
    id: String;
    tag: String;
  end;

  JBadgeUpdater = class external 'BadgeUpdater'
    procedure update(notification: JWindows.UI.Notifications.BadgeNotification);
    procedure clear;
    procedure startPeriodicUpdate(badgeContent: JWindows.Foundation.Uri; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdate(badgeContent: JWindows.Foundation.Uri; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure stopPeriodicUpdate;
  end;

  JBadgeNotification = class external 'BadgeNotification'
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument);
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
  end;

  JToastNotifier = class external 'ToastNotifier'
    setting: JWindows.UI.Notifications.NotificationSetting;
    procedure show(notification: JWindows.UI.Notifications.ToastNotification);
    procedure hide(notification: JWindows.UI.Notifications.ToastNotification);
    procedure addToSchedule(scheduledToast: JWindows.UI.Notifications.ScheduledToastNotification);
    procedure removeFromSchedule(scheduledToast: JWindows.UI.Notifications.ScheduledToastNotification);
    function getScheduledToastNotifications: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Notifications.ScheduledToastNotification>};
  end;

  JToastNotification = class external 'ToastNotification'
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument);
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
    ondismissed: Variant;
    onactivated: Variant;
    onfailed: Variant;
  end;

  JScheduledToastNotification = class external 'ScheduledToastNotification'
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate);
    constructor Create(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate; snoozeInterval: Float; maximumSnoozeCount: Float);
    content: JWindows.Data.Xml.Dom.XmlDocument;
    deliveryTime: JDate;
    id: String;
    maximumSnoozeCount: Float;
    snoozeInterval: Float;
  end;

  JToastDismissedEventArgs = class external 'ToastDismissedEventArgs'
    reason: JWindows.UI.Notifications.ToastDismissalReason;
  end;

  JToastFailedEventArgs = class external 'ToastFailedEventArgs'
    errorCode: Float;
  end;

  JTileUpdateManager = class external 'TileUpdateManager'
    function createTileUpdaterForApplication: JWindows.UI.Notifications.TileUpdater;
    function createTileUpdaterForApplication(applicationId: String): JWindows.UI.Notifications.TileUpdater;
    function createTileUpdaterForSecondaryTile(tileId: String): JWindows.UI.Notifications.TileUpdater;
    function getTemplateContent(&type: JWindows.UI.Notifications.TileTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JBadgeUpdateManager = class external 'BadgeUpdateManager'
    function createBadgeUpdaterForApplication: JWindows.UI.Notifications.BadgeUpdater;
    function createBadgeUpdaterForApplication(applicationId: String): JWindows.UI.Notifications.BadgeUpdater;
    function createBadgeUpdaterForSecondaryTile(tileId: String): JWindows.UI.Notifications.BadgeUpdater;
    function getTemplateContent(&type: JWindows.UI.Notifications.BadgeTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JToastNotificationManager = class external 'ToastNotificationManager'
    function createToastNotifier: JWindows.UI.Notifications.ToastNotifier;
    function createToastNotifier(applicationId: String): JWindows.UI.Notifications.ToastNotifier;
    function getTemplateContent(&type: JWindows.UI.Notifications.ToastTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JIToastDismissedEventArgs = class external
    reason: JWindows.UI.Notifications.ToastDismissalReason;
  end;

  JIToastFailedEventArgs = class external
    errorCode: Float;
  end;

  JITileUpdateManagerStatics = class external
    function createTileUpdaterForApplication: JWindows.UI.Notifications.TileUpdater;
    function createTileUpdaterForApplication(applicationId: String): JWindows.UI.Notifications.TileUpdater;
    function createTileUpdaterForSecondaryTile(tileId: String): JWindows.UI.Notifications.TileUpdater;
    function getTemplateContent(&type: JWindows.UI.Notifications.TileTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JITileUpdater = class external
    setting: JWindows.UI.Notifications.NotificationSetting;
    procedure update(notification: JWindows.UI.Notifications.TileNotification);
    procedure clear;
    procedure enableNotificationQueue(enable: Boolean);
    procedure addToSchedule(scheduledTile: JWindows.UI.Notifications.ScheduledTileNotification);
    procedure removeFromSchedule(scheduledTile: JWindows.UI.Notifications.ScheduledTileNotification);
    function getScheduledTileNotifications: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Notifications.ScheduledTileNotification>};
    procedure startPeriodicUpdate(tileContent: JWindows.Foundation.Uri; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdate(tileContent: JWindows.Foundation.Uri; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure stopPeriodicUpdate;
    procedure startPeriodicUpdateBatch(tileContents: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdateBatch(tileContents: JWindows.Foundation.Collections.IIterable{<JWindows.Foundation.Uri>}; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
  end;

  JIBadgeUpdateManagerStatics = class external
    function createBadgeUpdaterForApplication: JWindows.UI.Notifications.BadgeUpdater;
    function createBadgeUpdaterForApplication(applicationId: String): JWindows.UI.Notifications.BadgeUpdater;
    function createBadgeUpdaterForSecondaryTile(tileId: String): JWindows.UI.Notifications.BadgeUpdater;
    function getTemplateContent(&type: JWindows.UI.Notifications.BadgeTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JIBadgeUpdater = class external
    procedure update(notification: JWindows.UI.Notifications.BadgeNotification);
    procedure clear;
    procedure startPeriodicUpdate(badgeContent: JWindows.Foundation.Uri; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure startPeriodicUpdate(badgeContent: JWindows.Foundation.Uri; startTime: JDate; requestedInterval: JWindows.UI.Notifications.PeriodicUpdateRecurrence);
    procedure stopPeriodicUpdate;
  end;

  JIToastNotificationManagerStatics = class external
    function createToastNotifier: JWindows.UI.Notifications.ToastNotifier;
    function createToastNotifier(applicationId: String): JWindows.UI.Notifications.ToastNotifier;
    function getTemplateContent(&type: JWindows.UI.Notifications.ToastTemplateType): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JIToastNotifier = class external
    setting: JWindows.UI.Notifications.NotificationSetting;
    procedure show(notification: JWindows.UI.Notifications.ToastNotification);
    procedure hide(notification: JWindows.UI.Notifications.ToastNotification);
    procedure addToSchedule(scheduledToast: JWindows.UI.Notifications.ScheduledToastNotification);
    procedure removeFromSchedule(scheduledToast: JWindows.UI.Notifications.ScheduledToastNotification);
    function getScheduledToastNotifications: JWindows.Foundation.Collections.IVectorView{<JWindows.UI.Notifications.ScheduledToastNotification>};
  end;

  JITileNotificationFactory = class external
    function createTileNotification(content: JWindows.Data.Xml.Dom.XmlDocument): JWindows.UI.Notifications.TileNotification;
  end;

  JITileNotification = class external
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
    tag: String;
  end;

  JIBadgeNotificationFactory = class external
    function createBadgeNotification(content: JWindows.Data.Xml.Dom.XmlDocument): JWindows.UI.Notifications.BadgeNotification;
  end;

  JIBadgeNotification = class external
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
  end;

  JIToastNotificationFactory = class external
    function createToastNotification(content: JWindows.Data.Xml.Dom.XmlDocument): JWindows.UI.Notifications.ToastNotification;
  end;

  JIToastNotification = class external
    content: JWindows.Data.Xml.Dom.XmlDocument;
    expirationTime: JDate;
    ondismissed: Variant;
    onactivated: Variant;
    onfailed: Variant;
  end;

  JIScheduledToastNotificationFactory = class external
    function createScheduledToastNotification(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate): JWindows.UI.Notifications.ScheduledToastNotification;
    function createScheduledToastNotification(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate; snoozeInterval: Float; maximumSnoozeCount: Float): JWindows.UI.Notifications.ScheduledToastNotification;
  end;

  JIScheduledToastNotification = class external
    content: JWindows.Data.Xml.Dom.XmlDocument;
    deliveryTime: JDate;
    id: String;
    maximumSnoozeCount: Float;
    snoozeInterval: Float;
  end;

  JIScheduledTileNotificationFactory = class external
    function createScheduledTileNotification(content: JWindows.Data.Xml.Dom.XmlDocument; deliveryTime: JDate): JWindows.UI.Notifications.ScheduledTileNotification;
  end;

  JIScheduledTileNotification = class external
    content: JWindows.Data.Xml.Dom.XmlDocument;
    deliveryTime: JDate;
    expirationTime: JDate;
    id: String;
    tag: String;
  end;

//Windows

//Web

type
  JWebError = class external 'WebError'
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

  JIWebErrorStatics = class external
    function getStatus(hresult: Float): JWindows.Web.WebErrorStatus;
  end;

//Windows

//Web

//Syndication

type
  JSyndicationAttribute = class external 'SyndicationAttribute'
    constructor Create(attributeName: String; attributeNamespace: String; attributeValue: String);
    constructor Create;
    name: String;
    namespace: String;
    value: String;
  end;

  JSyndicationNode = class external 'SyndicationNode'
    constructor Create(nodeName: String; nodeNamespace: String; nodeValue: String);
    constructor Create;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationGenerator = class external 'SyndicationGenerator'
    constructor Create(text: String);
    constructor Create;
    text: String;
    uri: JWindows.Foundation.Uri;
    version: String;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationText = class external 'SyndicationText'
    constructor Create(text: String);
    constructor Create(text: String; &type: JWindows.Web.Syndication.SyndicationTextType);
    constructor Create;
    text: String;
    &type: String;
    xml: JWindows.Data.Xml.Dom.XmlDocument;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationContent = class external 'SyndicationContent'
    constructor Create(text: String; &type: JWindows.Web.Syndication.SyndicationTextType);
    constructor Create(sourceUri: JWindows.Foundation.Uri);
    constructor Create;
    text: String;
    &type: String;
    xml: JWindows.Data.Xml.Dom.XmlDocument;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    sourceUri: JWindows.Foundation.Uri;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationLink = class external 'SyndicationLink'
    constructor Create(uri: JWindows.Foundation.Uri);
    constructor Create(uri: JWindows.Foundation.Uri; relationship: String; title: String; mediaType: String; _length: Float);
    constructor Create;
    _length: Float;
    mediaType: String;
    relationship: String;
    resourceLanguage: String;
    title: String;
    uri: JWindows.Foundation.Uri;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationPerson = class external 'SyndicationPerson'
    constructor Create(name: String);
    constructor Create(name: String; email: String; uri: JWindows.Foundation.Uri);
    constructor Create;
    email: String;
    name: String;
    uri: JWindows.Foundation.Uri;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationCategory = class external 'SyndicationCategory'
    constructor Create(term: String);
    constructor Create(term: String; scheme: String; &label: String);
    constructor Create;
    &label: String;
    scheme: String;
    term: String;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationFeed = class external 'SyndicationFeed'
    constructor Create(title: String; subtitle: String; uri: JWindows.Foundation.Uri);
    constructor Create;
    authors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    categories: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationCategory>};
    contributors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    firstUri: JWindows.Foundation.Uri;
    generator: JWindows.Web.Syndication.SyndicationGenerator;
    iconUri: JWindows.Foundation.Uri;
    id: String;
    imageUri: JWindows.Foundation.Uri;
    items: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationItem>};
    lastUpdatedTime: JDate;
    lastUri: JWindows.Foundation.Uri;
    links: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationLink>};
    nextUri: JWindows.Foundation.Uri;
    previousUri: JWindows.Foundation.Uri;
    rights: JWindows.Web.Syndication.ISyndicationText;
    sourceFormat: JWindows.Web.Syndication.SyndicationFormat;
    subtitle: JWindows.Web.Syndication.ISyndicationText;
    title: JWindows.Web.Syndication.ISyndicationText;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    procedure load(feed: String);
    procedure loadFromXml(feedDocument: JWindows.Data.Xml.Dom.XmlDocument);
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationItem = class external 'SyndicationItem'
    constructor Create(title: String; content: JWindows.Web.Syndication.SyndicationContent; uri: JWindows.Foundation.Uri);
    constructor Create;
    authors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    categories: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationCategory>};
    commentsUri: JWindows.Foundation.Uri;
    content: JWindows.Web.Syndication.SyndicationContent;
    contributors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    eTag: String;
    editMediaUri: JWindows.Foundation.Uri;
    editUri: JWindows.Foundation.Uri;
    id: String;
    itemUri: JWindows.Foundation.Uri;
    lastUpdatedTime: JDate;
    links: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationLink>};
    publishedDate: JDate;
    rights: JWindows.Web.Syndication.ISyndicationText;
    source: JWindows.Web.Syndication.SyndicationFeed;
    summary: JWindows.Web.Syndication.ISyndicationText;
    title: JWindows.Web.Syndication.ISyndicationText;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    procedure load(item: String);
    procedure loadFromXml(itemDocument: JWindows.Data.Xml.Dom.XmlDocument);
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JSyndicationClient = class external 'SyndicationClient'
    constructor Create(serverCredential: JWindows.Security.Credentials.PasswordCredential);
    constructor Create;
    bypassCacheOnRetrieve: Boolean;
    maxResponseBufferSize: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    timeout: Float;
    procedure setRequestHeader(name: String; value: String);
    function retrieveFeedAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationFeedJWindows.Web.Syndication.RetrievalProgress>};
  end;

  JSyndicationError = class external 'SyndicationError'
    function getStatus(hresult: Float): JWindows.Web.Syndication.SyndicationErrorStatus;
  end;

  JRetrievalProgress = class external
    bytesRetrieved: Float;
    totalBytesToRetrieve: Float;
  end;

  JTransferProgress = class external
    bytesSent: Float;
    totalBytesToSend: Float;
    bytesRetrieved: Float;
    totalBytesToRetrieve: Float;
  end;

  JISyndicationAttribute = class external
    name: String;
    namespace: String;
    value: String;
  end;

  JISyndicationAttributeFactory = class external
    function createSyndicationAttribute(attributeName: String; attributeNamespace: String; attributeValue: String): JWindows.Web.Syndication.SyndicationAttribute;
  end;

  JISyndicationNode = class external
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JISyndicationNodeFactory = class external
    function createSyndicationNode(nodeName: String; nodeNamespace: String; nodeValue: String): JWindows.Web.Syndication.SyndicationNode;
  end;

  JISyndicationGenerator = class external
    text: String;
    uri: JWindows.Foundation.Uri;
    version: String;
  end;

  JISyndicationGeneratorFactory = class external
    function createSyndicationGenerator(text: String): JWindows.Web.Syndication.SyndicationGenerator;
  end;

  JISyndicationText = class external(JWindows.Web.Syndication.ISyndicationNode)
    text: String;
    &type: String;
    xml: JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JISyndicationTextFactory = class external
    function createSyndicationText(text: String): JWindows.Web.Syndication.SyndicationText;
    function createSyndicationText(text: String; &type: JWindows.Web.Syndication.SyndicationTextType): JWindows.Web.Syndication.SyndicationText;
  end;

  JISyndicationContent = class external(JWindows.Web.Syndication.ISyndicationText, JWindows.Web.Syndication.ISyndicationNode)
    sourceUri: JWindows.Foundation.Uri;
  end;

  JISyndicationContentFactory = class external
    function createSyndicationContent(text: String; &type: JWindows.Web.Syndication.SyndicationTextType): JWindows.Web.Syndication.SyndicationContent;
    function createSyndicationContent(sourceUri: JWindows.Foundation.Uri): JWindows.Web.Syndication.SyndicationContent;
  end;

  JISyndicationLink = class external(JWindows.Web.Syndication.ISyndicationNode)
    _length: Float;
    mediaType: String;
    relationship: String;
    resourceLanguage: String;
    title: String;
    uri: JWindows.Foundation.Uri;
  end;

  JISyndicationLinkFactory = class external
    function createSyndicationLink(uri: JWindows.Foundation.Uri): JWindows.Web.Syndication.SyndicationLink;
    function createSyndicationLink(uri: JWindows.Foundation.Uri; relationship: String; title: String; mediaType: String; _length: Float): JWindows.Web.Syndication.SyndicationLink;
  end;

  JISyndicationPerson = class external(JWindows.Web.Syndication.ISyndicationNode)
    email: String;
    name: String;
    uri: JWindows.Foundation.Uri;
  end;

  JISyndicationPersonFactory = class external
    function createSyndicationPerson(name: String): JWindows.Web.Syndication.SyndicationPerson;
    function createSyndicationPerson(name: String; email: String; uri: JWindows.Foundation.Uri): JWindows.Web.Syndication.SyndicationPerson;
  end;

  JISyndicationCategory = class external(JWindows.Web.Syndication.ISyndicationNode)
    &label: String;
    scheme: String;
    term: String;
  end;

  JISyndicationCategoryFactory = class external
    function createSyndicationCategory(term: String): JWindows.Web.Syndication.SyndicationCategory;
    function createSyndicationCategory(term: String; scheme: String; &label: String): JWindows.Web.Syndication.SyndicationCategory;
  end;

  JISyndicationItem = class external(JWindows.Web.Syndication.ISyndicationNode)
    authors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    categories: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationCategory>};
    commentsUri: JWindows.Foundation.Uri;
    content: JWindows.Web.Syndication.SyndicationContent;
    contributors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    eTag: String;
    editMediaUri: JWindows.Foundation.Uri;
    editUri: JWindows.Foundation.Uri;
    id: String;
    itemUri: JWindows.Foundation.Uri;
    lastUpdatedTime: JDate;
    links: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationLink>};
    publishedDate: JDate;
    rights: JWindows.Web.Syndication.ISyndicationText;
    source: JWindows.Web.Syndication.SyndicationFeed;
    summary: JWindows.Web.Syndication.ISyndicationText;
    title: JWindows.Web.Syndication.ISyndicationText;
    procedure load(item: String);
    procedure loadFromXml(itemDocument: JWindows.Data.Xml.Dom.XmlDocument);
  end;

  JISyndicationItemFactory = class external
    function createSyndicationItem(title: String; content: JWindows.Web.Syndication.SyndicationContent; uri: JWindows.Foundation.Uri): JWindows.Web.Syndication.SyndicationItem;
  end;

  JISyndicationFeed = class external(JWindows.Web.Syndication.ISyndicationNode)
    authors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    categories: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationCategory>};
    contributors: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationPerson>};
    firstUri: JWindows.Foundation.Uri;
    generator: JWindows.Web.Syndication.SyndicationGenerator;
    iconUri: JWindows.Foundation.Uri;
    id: String;
    imageUri: JWindows.Foundation.Uri;
    items: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationItem>};
    lastUpdatedTime: JDate;
    lastUri: JWindows.Foundation.Uri;
    links: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationLink>};
    nextUri: JWindows.Foundation.Uri;
    previousUri: JWindows.Foundation.Uri;
    rights: JWindows.Web.Syndication.ISyndicationText;
    sourceFormat: JWindows.Web.Syndication.SyndicationFormat;
    subtitle: JWindows.Web.Syndication.ISyndicationText;
    title: JWindows.Web.Syndication.ISyndicationText;
    procedure load(feed: String);
    procedure loadFromXml(feedDocument: JWindows.Data.Xml.Dom.XmlDocument);
  end;

  JISyndicationFeedFactory = class external
    function createSyndicationFeed(title: String; subtitle: String; uri: JWindows.Foundation.Uri): JWindows.Web.Syndication.SyndicationFeed;
  end;

  JISyndicationClient = class external
    bypassCacheOnRetrieve: Boolean;
    maxResponseBufferSize: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    timeout: Float;
    procedure setRequestHeader(name: String; value: String);
    function retrieveFeedAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationFeedJWindows.Web.Syndication.RetrievalProgress>};
  end;

  JISyndicationClientFactory = class external
    function createSyndicationClient(serverCredential: JWindows.Security.Credentials.PasswordCredential): JWindows.Web.Syndication.SyndicationClient;
  end;

  JISyndicationErrorStatics = class external
    function getStatus(hresult: Float): JWindows.Web.Syndication.SyndicationErrorStatus;
  end;

//Windows

//Web

//AtomPub

type
  JResourceCollection = class external 'ResourceCollection'
    accepts: JWindows.Foundation.Collections.IVectorView{<String>};
    categories: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.Syndication.SyndicationCategory>};
    title: JWindows.Web.Syndication.ISyndicationText;
    uri: JWindows.Foundation.Uri;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JWorkspace = class external 'Workspace'
    collections: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.AtomPub.ResourceCollection>};
    title: JWindows.Web.Syndication.ISyndicationText;
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JServiceDocument = class external 'ServiceDocument'
    workspaces: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.AtomPub.Workspace>};
    attributeExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.SyndicationAttribute>};
    baseUri: JWindows.Foundation.Uri;
    elementExtensions: JWindows.Foundation.Collections.IVector{<JWindows.Web.Syndication.ISyndicationNode>};
    language: String;
    nodeName: String;
    nodeNamespace: String;
    nodeValue: String;
    function getXmlDocument(format: JWindows.Web.Syndication.SyndicationFormat): JWindows.Data.Xml.Dom.XmlDocument;
  end;

  JAtomPubClient = class external 'AtomPubClient'
    constructor Create(serverCredential: JWindows.Security.Credentials.PasswordCredential);
    constructor Create;
    bypassCacheOnRetrieve: Boolean;
    maxResponseBufferSize: Float;
    proxyCredential: JWindows.Security.Credentials.PasswordCredential;
    serverCredential: JWindows.Security.Credentials.PasswordCredential;
    timeout: Float;
    function retrieveServiceDocumentAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.AtomPub.ServiceDocumentJWindows.Web.Syndication.RetrievalProgress>};
    function retrieveMediaResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IInputStreamJWindows.Web.Syndication.RetrievalProgress>};
    function retrieveResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.RetrievalProgress>};
    function createResourceAsync(uri: JWindows.Foundation.Uri; description: String; item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.TransferProgress>};
    function createMediaResourceAsync(uri: JWindows.Foundation.Uri; mediaType: String; description: String; mediaStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.TransferProgress>};
    function updateMediaResourceAsync(uri: JWindows.Foundation.Uri; mediaType: String; mediaStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function updateResourceAsync(uri: JWindows.Foundation.Uri; item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function updateResourceItemAsync(item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function deleteResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function deleteResourceItemAsync(item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    procedure cancelAsyncOperations;
    procedure setRequestHeader(name: String; value: String);
    function retrieveFeedAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationFeedJWindows.Web.Syndication.RetrievalProgress>};
  end;

  JIResourceCollection = class external(JWindows.Web.Syndication.ISyndicationNode)
    accepts: JWindows.Foundation.Collections.IVectorView{<String>};
    categories: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.Syndication.SyndicationCategory>};
    title: JWindows.Web.Syndication.ISyndicationText;
    uri: JWindows.Foundation.Uri;
  end;

  JIWorkspace = class external(JWindows.Web.Syndication.ISyndicationNode)
    collections: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.AtomPub.ResourceCollection>};
    title: JWindows.Web.Syndication.ISyndicationText;
  end;

  JIServiceDocument = class external(JWindows.Web.Syndication.ISyndicationNode)
    workspaces: JWindows.Foundation.Collections.IVectorView{<JWindows.Web.AtomPub.Workspace>};
  end;

  JIAtomPubClient = class external(JWindows.Web.Syndication.ISyndicationClient)
    function retrieveServiceDocumentAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.AtomPub.ServiceDocumentJWindows.Web.Syndication.RetrievalProgress>};
    function retrieveMediaResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Storage.Streams.IInputStreamJWindows.Web.Syndication.RetrievalProgress>};
    function retrieveResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.RetrievalProgress>};
    function createResourceAsync(uri: JWindows.Foundation.Uri; description: String; item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.TransferProgress>};
    function createMediaResourceAsync(uri: JWindows.Foundation.Uri; mediaType: String; description: String; mediaStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncOperationWithProgress{<JWindows.Web.Syndication.SyndicationItemJWindows.Web.Syndication.TransferProgress>};
    function updateMediaResourceAsync(uri: JWindows.Foundation.Uri; mediaType: String; mediaStream: JWindows.Storage.Streams.IInputStream): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function updateResourceAsync(uri: JWindows.Foundation.Uri; item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function updateResourceItemAsync(item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function deleteResourceAsync(uri: JWindows.Foundation.Uri): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    function deleteResourceItemAsync(item: JWindows.Web.Syndication.SyndicationItem): JWindows.Foundation.IAsyncActionWithProgress{<JWindows.Web.Syndication.TransferProgress>};
    procedure cancelAsyncOperations;
  end;

  JIAtomPubClientFactory = class external
    function createAtomPubClientWithCredentials(serverCredential: JWindows.Security.Credentials.PasswordCredential): JWindows.Web.AtomPub.AtomPubClient;
  end;

//Windows.Foundation

type
  JIPromise{<T>} = class external
    function then: JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}; error: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}; error: (error: Variant): JIPromise{<JU>}; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}; error: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JIPromise{<JU>}; error: (error: Variant): JU; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU; error: (error: Variant): JIPromise{<JU>}): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU; error: (error: Variant): JIPromise{<JU>}; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    function then: JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU; error: (error: Variant): JU): JIPromise{<JU>}; overload;
    function then(success: (value: JT): JU; error: (error: Variant): JU; progress: (progress: Variant)): JIPromise{<JU>}; overload;
    procedure done; overload;
    procedure done(success: (value: JT): Variant); overload;
    procedure done(success: (value: JT): Variant; error: (error: Variant): Variant); overload;
    procedure done(success: (value: JT): Variant; error: (error: Variant): Variant; progress: (progress: Variant)); overload;
    procedure cancel;
    procedure onerror(eventInfo: JCustomEvent);
    procedure addEventListener(&type: String; listener: JFunction); overload;
    procedure addEventListener(&type: String; listener: JFunction; capture: Boolean); overload;
    function dispatchEvent(&type: String; details: Variant): Boolean;
    procedure removeEventListener(eventType: String; listener: JFunction); overload;
    procedure removeEventListener(eventType: String; listener: JFunction; capture: Boolean); overload;
  end;

//Windows.UI.ViewManagement

type
  JApplicationViewTitleBar = class external 'ApplicationViewTitleBar'
    backgroundColor: JColor;
    buttonBackgroundColor: JColor;
    buttonForegroundColor: JColor;
    buttonHoverBackgroundColor: JColor;
    buttonHoverForegroundColor: JColor;
    buttonInactiveBackgroundColor: JColor;
    buttonInactiveForegroundColor: JColor;
    buttonPressedBackgroundColor: JColor;
    buttonPressedForegroundColor: JColor;
    foregroundColor: JColor;
    inactiveBackgroundColor: JColor;
    inactiveForegroundColor: JColor;
  end;

